/* Stockfish Chess version 8 with multi-variant support for Node.js
 *
 * Copyright (C) 2004-2008 Tord Romstad (Glaurung)
 * Copyright (C) 2008-2014 Marco Costalba, Joona Kiiski, Tord Romstad (Stockfish)        // @ official-stockfish/Stockfish
 * Copyright (C) Nathan Rugg (Compilation of Stockfish to JS)                            // @ nmrugg/stockfish.js
 * Copyright (C) Daniel Dugovic (Multi-variant support for Stockfish)                    // @ ddugovic/Stockfish
 * Copyright (C) Niklas Fiekas (Compilation of the multi-variant support for Stockfish)  // @ niklasf/stockfish.js
 * Copyright (C) 2017, ecrucru (Adaptations for AntiCrux)                                // @ ecrucru/anticrux
 *
 * Released under the terms of the licence "GNU GENERAL PUBLIC LICENSE Version 3".
 */

module.exports = (function() {

//***************
// PASTE THE CONTENT OF THE FILE :
// http://raw.githubusercontent.com/niklasf/stockfish.js/ddugovic/stockfish.js

var Module={print:(function(stdout){postMessage(stdout)})};var Module;if(!Module)Module=(typeof Module!=="undefined"?Module:null)||{};var moduleOverrides={};for(var key in Module){if(Module.hasOwnProperty(key)){moduleOverrides[key]=Module[key]}}var ENVIRONMENT_IS_WEB=false;var ENVIRONMENT_IS_WORKER=false;var ENVIRONMENT_IS_NODE=false;var ENVIRONMENT_IS_SHELL=false;if(Module["ENVIRONMENT"]){if(Module["ENVIRONMENT"]==="WEB"){ENVIRONMENT_IS_WEB=true}else if(Module["ENVIRONMENT"]==="WORKER"){ENVIRONMENT_IS_WORKER=true}else if(Module["ENVIRONMENT"]==="NODE"){ENVIRONMENT_IS_NODE=true}else if(Module["ENVIRONMENT"]==="SHELL"){ENVIRONMENT_IS_SHELL=true}else{throw new Error("The provided Module['ENVIRONMENT'] value is not valid. It must be one of: WEB|WORKER|NODE|SHELL.")}}else{ENVIRONMENT_IS_WEB=typeof window==="object";ENVIRONMENT_IS_WORKER=typeof importScripts==="function";ENVIRONMENT_IS_NODE=typeof process==="object"&&typeof require==="function"&&!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_WORKER;ENVIRONMENT_IS_SHELL=!ENVIRONMENT_IS_WEB&&!ENVIRONMENT_IS_NODE&&!ENVIRONMENT_IS_WORKER}if(ENVIRONMENT_IS_NODE){if(!Module["print"])Module["print"]=console.log;if(!Module["printErr"])Module["printErr"]=console.warn;var nodeFS;var nodePath;Module["read"]=function read(filename,binary){if(!nodeFS)nodeFS=require("fs");if(!nodePath)nodePath=require("path");filename=nodePath["normalize"](filename);var ret=nodeFS["readFileSync"](filename);return binary?ret:ret.toString()};Module["readBinary"]=function readBinary(filename){var ret=Module["read"](filename,true);if(!ret.buffer){ret=new Uint8Array(ret)}assert(ret.buffer);return ret};Module["load"]=function load(f){globalEval(read(f))};if(!Module["thisProgram"]){if(process["argv"].length>1){Module["thisProgram"]=process["argv"][1].replace(/\\/g,"/")}else{Module["thisProgram"]="unknown-program"}}Module["arguments"]=process["argv"].slice(2);if(typeof module!=="undefined"){module["exports"]=Module}process["on"]("uncaughtException",(function(ex){if(!(ex instanceof ExitStatus)){throw ex}}));Module["inspect"]=(function(){return"[Emscripten Module object]"})}else if(ENVIRONMENT_IS_SHELL){if(!Module["print"])Module["print"]=print;if(typeof printErr!="undefined")Module["printErr"]=printErr;if(typeof read!="undefined"){Module["read"]=read}else{Module["read"]=function read(){throw"no read() available"}}Module["readBinary"]=function readBinary(f){if(typeof readbuffer==="function"){return new Uint8Array(readbuffer(f))}var data=read(f,"binary");assert(typeof data==="object");return data};if(typeof scriptArgs!="undefined"){Module["arguments"]=scriptArgs}else if(typeof arguments!="undefined"){Module["arguments"]=arguments}}else if(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER){Module["read"]=function read(url){var xhr=new XMLHttpRequest;xhr.open("GET",url,false);xhr.send(null);return xhr.responseText};Module["readAsync"]=function readAsync(url,onload,onerror){var xhr=new XMLHttpRequest;xhr.open("GET",url,true);xhr.responseType="arraybuffer";xhr.onload=function xhr_onload(){if(xhr.status==200||xhr.status==0&&xhr.response){onload(xhr.response)}else{onerror()}};xhr.onerror=onerror;xhr.send(null)};if(typeof arguments!="undefined"){Module["arguments"]=arguments}if(typeof console!=="undefined"){if(!Module["print"])Module["print"]=function print(x){console.log(x)};if(!Module["printErr"])Module["printErr"]=function printErr(x){console.warn(x)}}else{var TRY_USE_DUMP=false;if(!Module["print"])Module["print"]=TRY_USE_DUMP&&typeof dump!=="undefined"?(function(x){dump(x)}):(function(x){})}if(ENVIRONMENT_IS_WORKER){Module["load"]=importScripts}if(typeof Module["setWindowTitle"]==="undefined"){Module["setWindowTitle"]=(function(title){document.title=title})}}else{throw"Unknown runtime environment. Where are we?"}function globalEval(x){eval.call(null,x)}if(!Module["load"]&&Module["read"]){Module["load"]=function load(f){globalEval(Module["read"](f))}}if(!Module["print"]){Module["print"]=(function(){})}if(!Module["printErr"]){Module["printErr"]=Module["print"]}if(!Module["arguments"]){Module["arguments"]=[]}if(!Module["thisProgram"]){Module["thisProgram"]="./this.program"}Module.print=Module["print"];Module.printErr=Module["printErr"];Module["preRun"]=[];Module["postRun"]=[];for(var key in moduleOverrides){if(moduleOverrides.hasOwnProperty(key)){Module[key]=moduleOverrides[key]}}moduleOverrides=undefined;var Runtime={setTempRet0:(function(value){tempRet0=value;return value}),getTempRet0:(function(){return tempRet0}),stackSave:(function(){return STACKTOP}),stackRestore:(function(stackTop){STACKTOP=stackTop}),getNativeTypeSize:(function(type){switch(type){case"i1":case"i8":return 1;case"i16":return 2;case"i32":return 4;case"i64":return 8;case"float":return 4;case"double":return 8;default:{if(type[type.length-1]==="*"){return Runtime.QUANTUM_SIZE}else if(type[0]==="i"){var bits=parseInt(type.substr(1));assert(bits%8===0);return bits/8}else{return 0}}}}),getNativeFieldSize:(function(type){return Math.max(Runtime.getNativeTypeSize(type),Runtime.QUANTUM_SIZE)}),STACK_ALIGN:16,prepVararg:(function(ptr,type){if(type==="double"||type==="i64"){if(ptr&7){assert((ptr&7)===4);ptr+=4}}else{assert((ptr&3)===0)}return ptr}),getAlignSize:(function(type,size,vararg){if(!vararg&&(type=="i64"||type=="double"))return 8;if(!type)return Math.min(size,8);return Math.min(size||(type?Runtime.getNativeFieldSize(type):0),Runtime.QUANTUM_SIZE)}),dynCall:(function(sig,ptr,args){if(args&&args.length){return Module["dynCall_"+sig].apply(null,[ptr].concat(args))}else{return Module["dynCall_"+sig].call(null,ptr)}}),functionPointers:[],addFunction:(function(func){for(var i=0;i<Runtime.functionPointers.length;i++){if(!Runtime.functionPointers[i]){Runtime.functionPointers[i]=func;return 2*(1+i)}}throw"Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS."}),removeFunction:(function(index){Runtime.functionPointers[(index-2)/2]=null}),warnOnce:(function(text){if(!Runtime.warnOnce.shown)Runtime.warnOnce.shown={};if(!Runtime.warnOnce.shown[text]){Runtime.warnOnce.shown[text]=1;Module.printErr(text)}}),funcWrappers:{},getFuncWrapper:(function(func,sig){assert(sig);if(!Runtime.funcWrappers[sig]){Runtime.funcWrappers[sig]={}}var sigCache=Runtime.funcWrappers[sig];if(!sigCache[func]){if(sig.length===1){sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func)}}else if(sig.length===2){sigCache[func]=function dynCall_wrapper(arg){return Runtime.dynCall(sig,func,[arg])}}else{sigCache[func]=function dynCall_wrapper(){return Runtime.dynCall(sig,func,Array.prototype.slice.call(arguments))}}}return sigCache[func]}),getCompilerSetting:(function(name){throw"You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work"}),stackAlloc:(function(size){var ret=STACKTOP;STACKTOP=STACKTOP+size|0;STACKTOP=STACKTOP+15&-16;return ret}),staticAlloc:(function(size){var ret=STATICTOP;STATICTOP=STATICTOP+size|0;STATICTOP=STATICTOP+15&-16;return ret}),dynamicAlloc:(function(size){var ret=HEAP32[DYNAMICTOP_PTR>>2];var end=(ret+size+15|0)&-16;HEAP32[DYNAMICTOP_PTR>>2]=end;if(end>=TOTAL_MEMORY){var success=enlargeMemory();if(!success){HEAP32[DYNAMICTOP_PTR>>2]=ret;return 0}}return ret}),alignMemory:(function(size,quantum){var ret=size=Math.ceil(size/(quantum?quantum:16))*(quantum?quantum:16);return ret}),makeBigInt:(function(low,high,unsigned){var ret=unsigned?+(low>>>0)+ +(high>>>0)*+4294967296:+(low>>>0)+ +(high|0)*+4294967296;return ret}),GLOBAL_BASE:8,QUANTUM_SIZE:4,__dummy__:0};Module["Runtime"]=Runtime;var ABORT=0;var EXITSTATUS=0;function assert(condition,text){if(!condition){abort("Assertion failed: "+text)}}function getCFunc(ident){var func=Module["_"+ident];if(!func){try{func=eval("_"+ident)}catch(e){}}assert(func,"Cannot call unknown function "+ident+" (perhaps LLVM optimizations or closure removed it?)");return func}var cwrap,ccall;((function(){var JSfuncs={"stackSave":(function(){Runtime.stackSave()}),"stackRestore":(function(){Runtime.stackRestore()}),"arrayToC":(function(arr){var ret=Runtime.stackAlloc(arr.length);writeArrayToMemory(arr,ret);return ret}),"stringToC":(function(str){var ret=0;if(str!==null&&str!==undefined&&str!==0){var len=(str.length<<2)+1;ret=Runtime.stackAlloc(len);stringToUTF8(str,ret,len)}return ret})};var toC={"string":JSfuncs["stringToC"],"array":JSfuncs["arrayToC"]};ccall=function ccallFunc(ident,returnType,argTypes,args,opts){var func=getCFunc(ident);var cArgs=[];var stack=0;if(args){for(var i=0;i<args.length;i++){var converter=toC[argTypes[i]];if(converter){if(stack===0)stack=Runtime.stackSave();cArgs[i]=converter(args[i])}else{cArgs[i]=args[i]}}}var ret=func.apply(null,cArgs);if(returnType==="string")ret=Pointer_stringify(ret);if(stack!==0){if(opts&&opts.async){EmterpreterAsync.asyncFinalizers.push((function(){Runtime.stackRestore(stack)}));return}Runtime.stackRestore(stack)}return ret};var sourceRegex=/^function\s*[a-zA-Z$_0-9]*\s*\(([^)]*)\)\s*{\s*([^*]*?)[\s;]*(?:return\s*(.*?)[;\s]*)?}$/;function parseJSFunc(jsfunc){var parsed=jsfunc.toString().match(sourceRegex).slice(1);return{arguments:parsed[0],body:parsed[1],returnValue:parsed[2]}}var JSsource=null;function ensureJSsource(){if(!JSsource){JSsource={};for(var fun in JSfuncs){if(JSfuncs.hasOwnProperty(fun)){JSsource[fun]=parseJSFunc(JSfuncs[fun])}}}}cwrap=function cwrap(ident,returnType,argTypes){argTypes=argTypes||[];var cfunc=getCFunc(ident);var numericArgs=argTypes.every((function(type){return type==="number"}));var numericRet=returnType!=="string";if(numericRet&&numericArgs){return cfunc}var argNames=argTypes.map((function(x,i){return"$"+i}));var funcstr="(function("+argNames.join(",")+") {";var nargs=argTypes.length;if(!numericArgs){ensureJSsource();funcstr+="var stack = "+JSsource["stackSave"].body+";";for(var i=0;i<nargs;i++){var arg=argNames[i],type=argTypes[i];if(type==="number")continue;var convertCode=JSsource[type+"ToC"];funcstr+="var "+convertCode.arguments+" = "+arg+";";funcstr+=convertCode.body+";";funcstr+=arg+"=("+convertCode.returnValue+");"}}var cfuncname=parseJSFunc((function(){return cfunc})).returnValue;funcstr+="var ret = "+cfuncname+"("+argNames.join(",")+");";if(!numericRet){var strgfy=parseJSFunc((function(){return Pointer_stringify})).returnValue;funcstr+="ret = "+strgfy+"(ret);"}if(!numericArgs){ensureJSsource();funcstr+=JSsource["stackRestore"].body.replace("()","(stack)")+";"}funcstr+="return ret})";return eval(funcstr)}}))();Module["ccall"]=ccall;Module["cwrap"]=cwrap;function setValue(ptr,value,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":HEAP8[ptr>>0]=value;break;case"i8":HEAP8[ptr>>0]=value;break;case"i16":HEAP16[ptr>>1]=value;break;case"i32":HEAP32[ptr>>2]=value;break;case"i64":tempI64=[value>>>0,(tempDouble=value,+Math_abs(tempDouble)>=+1?tempDouble>+0?(Math_min(+Math_floor(tempDouble/+4294967296),+4294967295)|0)>>>0:~~+Math_ceil((tempDouble- +(~~tempDouble>>>0))/+4294967296)>>>0:0)],HEAP32[ptr>>2]=tempI64[0],HEAP32[ptr+4>>2]=tempI64[1];break;case"float":HEAPF32[ptr>>2]=value;break;case"double":HEAPF64[ptr>>3]=value;break;default:abort("invalid type for setValue: "+type)}}Module["setValue"]=setValue;function getValue(ptr,type,noSafe){type=type||"i8";if(type.charAt(type.length-1)==="*")type="i32";switch(type){case"i1":return HEAP8[ptr>>0];case"i8":return HEAP8[ptr>>0];case"i16":return HEAP16[ptr>>1];case"i32":return HEAP32[ptr>>2];case"i64":return HEAP32[ptr>>2];case"float":return HEAPF32[ptr>>2];case"double":return HEAPF64[ptr>>3];default:abort("invalid type for setValue: "+type)}return null}Module["getValue"]=getValue;var ALLOC_NORMAL=0;var ALLOC_STACK=1;var ALLOC_STATIC=2;var ALLOC_DYNAMIC=3;var ALLOC_NONE=4;Module["ALLOC_NORMAL"]=ALLOC_NORMAL;Module["ALLOC_STACK"]=ALLOC_STACK;Module["ALLOC_STATIC"]=ALLOC_STATIC;Module["ALLOC_DYNAMIC"]=ALLOC_DYNAMIC;Module["ALLOC_NONE"]=ALLOC_NONE;function allocate(slab,types,allocator,ptr){var zeroinit,size;if(typeof slab==="number"){zeroinit=true;size=slab}else{zeroinit=false;size=slab.length}var singleType=typeof types==="string"?types:null;var ret;if(allocator==ALLOC_NONE){ret=ptr}else{ret=[typeof _malloc==="function"?_malloc:Runtime.staticAlloc,Runtime.stackAlloc,Runtime.staticAlloc,Runtime.dynamicAlloc][allocator===undefined?ALLOC_STATIC:allocator](Math.max(size,singleType?1:types.length))}if(zeroinit){var ptr=ret,stop;assert((ret&3)==0);stop=ret+(size&~3);for(;ptr<stop;ptr+=4){HEAP32[ptr>>2]=0}stop=ret+size;while(ptr<stop){HEAP8[ptr++>>0]=0}return ret}if(singleType==="i8"){if(slab.subarray||slab.slice){HEAPU8.set(slab,ret)}else{HEAPU8.set(new Uint8Array(slab),ret)}return ret}var i=0,type,typeSize,previousType;while(i<size){var curr=slab[i];if(typeof curr==="function"){curr=Runtime.getFunctionIndex(curr)}type=singleType||types[i];if(type===0){i++;continue}if(type=="i64")type="i32";setValue(ret+i,curr,type);if(previousType!==type){typeSize=Runtime.getNativeTypeSize(type);previousType=type}i+=typeSize}return ret}Module["allocate"]=allocate;function getMemory(size){if(!staticSealed)return Runtime.staticAlloc(size);if(!runtimeInitialized)return Runtime.dynamicAlloc(size);return _malloc(size)}Module["getMemory"]=getMemory;function Pointer_stringify(ptr,length){if(length===0||!ptr)return"";var hasUtf=0;var t;var i=0;while(1){t=HEAPU8[ptr+i>>0];hasUtf|=t;if(t==0&&!length)break;i++;if(length&&i==length)break}if(!length)length=i;var ret="";if(hasUtf<128){var MAX_CHUNK=1024;var curr;while(length>0){curr=String.fromCharCode.apply(String,HEAPU8.subarray(ptr,ptr+Math.min(length,MAX_CHUNK)));ret=ret?ret+curr:curr;ptr+=MAX_CHUNK;length-=MAX_CHUNK}return ret}return Module["UTF8ToString"](ptr)}Module["Pointer_stringify"]=Pointer_stringify;function AsciiToString(ptr){var str="";while(1){var ch=HEAP8[ptr++>>0];if(!ch)return str;str+=String.fromCharCode(ch)}}Module["AsciiToString"]=AsciiToString;function stringToAscii(str,outPtr){return writeAsciiToMemory(str,outPtr,false)}Module["stringToAscii"]=stringToAscii;var UTF8Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf8"):undefined;function UTF8ArrayToString(u8Array,idx){var endPtr=idx;while(u8Array[endPtr])++endPtr;if(endPtr-idx>16&&u8Array.subarray&&UTF8Decoder){return UTF8Decoder.decode(u8Array.subarray(idx,endPtr))}else{var u0,u1,u2,u3,u4,u5;var str="";while(1){u0=u8Array[idx++];if(!u0)return str;if(!(u0&128)){str+=String.fromCharCode(u0);continue}u1=u8Array[idx++]&63;if((u0&224)==192){str+=String.fromCharCode((u0&31)<<6|u1);continue}u2=u8Array[idx++]&63;if((u0&240)==224){u0=(u0&15)<<12|u1<<6|u2}else{u3=u8Array[idx++]&63;if((u0&248)==240){u0=(u0&7)<<18|u1<<12|u2<<6|u3}else{u4=u8Array[idx++]&63;if((u0&252)==248){u0=(u0&3)<<24|u1<<18|u2<<12|u3<<6|u4}else{u5=u8Array[idx++]&63;u0=(u0&1)<<30|u1<<24|u2<<18|u3<<12|u4<<6|u5}}}if(u0<65536){str+=String.fromCharCode(u0)}else{var ch=u0-65536;str+=String.fromCharCode(55296|ch>>10,56320|ch&1023)}}}}Module["UTF8ArrayToString"]=UTF8ArrayToString;function UTF8ToString(ptr){return UTF8ArrayToString(HEAPU8,ptr)}Module["UTF8ToString"]=UTF8ToString;function stringToUTF8Array(str,outU8Array,outIdx,maxBytesToWrite){if(!(maxBytesToWrite>0))return 0;var startIdx=outIdx;var endIdx=outIdx+maxBytesToWrite-1;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){if(outIdx>=endIdx)break;outU8Array[outIdx++]=u}else if(u<=2047){if(outIdx+1>=endIdx)break;outU8Array[outIdx++]=192|u>>6;outU8Array[outIdx++]=128|u&63}else if(u<=65535){if(outIdx+2>=endIdx)break;outU8Array[outIdx++]=224|u>>12;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=2097151){if(outIdx+3>=endIdx)break;outU8Array[outIdx++]=240|u>>18;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else if(u<=67108863){if(outIdx+4>=endIdx)break;outU8Array[outIdx++]=248|u>>24;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}else{if(outIdx+5>=endIdx)break;outU8Array[outIdx++]=252|u>>30;outU8Array[outIdx++]=128|u>>24&63;outU8Array[outIdx++]=128|u>>18&63;outU8Array[outIdx++]=128|u>>12&63;outU8Array[outIdx++]=128|u>>6&63;outU8Array[outIdx++]=128|u&63}}outU8Array[outIdx]=0;return outIdx-startIdx}Module["stringToUTF8Array"]=stringToUTF8Array;function stringToUTF8(str,outPtr,maxBytesToWrite){return stringToUTF8Array(str,HEAPU8,outPtr,maxBytesToWrite)}Module["stringToUTF8"]=stringToUTF8;function lengthBytesUTF8(str){var len=0;for(var i=0;i<str.length;++i){var u=str.charCodeAt(i);if(u>=55296&&u<=57343)u=65536+((u&1023)<<10)|str.charCodeAt(++i)&1023;if(u<=127){++len}else if(u<=2047){len+=2}else if(u<=65535){len+=3}else if(u<=2097151){len+=4}else if(u<=67108863){len+=5}else{len+=6}}return len}Module["lengthBytesUTF8"]=lengthBytesUTF8;var UTF16Decoder=typeof TextDecoder!=="undefined"?new TextDecoder("utf-16le"):undefined;function demangle(func){var __cxa_demangle_func=Module["___cxa_demangle"]||Module["__cxa_demangle"];if(__cxa_demangle_func){try{var s=func.substr(1);var len=lengthBytesUTF8(s)+1;var buf=_malloc(len);stringToUTF8(s,buf,len);var status=_malloc(4);var ret=__cxa_demangle_func(buf,0,0,status);if(getValue(status,"i32")===0&&ret){return Pointer_stringify(ret)}}catch(e){}finally{if(buf)_free(buf);if(status)_free(status);if(ret)_free(ret)}return func}Runtime.warnOnce("warning: build with  -s DEMANGLE_SUPPORT=1  to link in libcxxabi demangling");return func}function demangleAll(text){var regex=/__Z[\w\d_]+/g;return text.replace(regex,(function(x){var y=demangle(x);return x===y?x:x+" ["+y+"]"}))}function jsStackTrace(){var err=new Error;if(!err.stack){try{throw new Error(0)}catch(e){err=e}if(!err.stack){return"(no stack trace available)"}}return err.stack.toString()}function stackTrace(){var js=jsStackTrace();if(Module["extraStackTrace"])js+="\n"+Module["extraStackTrace"]();return demangleAll(js)}Module["stackTrace"]=stackTrace;var HEAP;var buffer;var HEAP8,HEAPU8,HEAP16,HEAPU16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function updateGlobalBufferViews(){Module["HEAP8"]=HEAP8=new Int8Array(buffer);Module["HEAP16"]=HEAP16=new Int16Array(buffer);Module["HEAP32"]=HEAP32=new Int32Array(buffer);Module["HEAPU8"]=HEAPU8=new Uint8Array(buffer);Module["HEAPU16"]=HEAPU16=new Uint16Array(buffer);Module["HEAPU32"]=HEAPU32=new Uint32Array(buffer);Module["HEAPF32"]=HEAPF32=new Float32Array(buffer);Module["HEAPF64"]=HEAPF64=new Float64Array(buffer)}var STATIC_BASE,STATICTOP,staticSealed;var STACK_BASE,STACKTOP,STACK_MAX;var DYNAMIC_BASE,DYNAMICTOP_PTR;STATIC_BASE=STATICTOP=STACK_BASE=STACKTOP=STACK_MAX=DYNAMIC_BASE=DYNAMICTOP_PTR=0;staticSealed=false;function abortOnCannotGrowMemory(){abort("Cannot enlarge memory arrays. Either (1) compile with  -s TOTAL_MEMORY=X  with X higher than the current value "+TOTAL_MEMORY+", (2) compile with  -s ALLOW_MEMORY_GROWTH=1  which adjusts the size at runtime but prevents some optimizations, (3) set Module.TOTAL_MEMORY to a higher value before the program runs, or if you want malloc to return NULL (0) instead of this abort, compile with  -s ABORTING_MALLOC=0 ")}function enlargeMemory(){abortOnCannotGrowMemory()}var TOTAL_STACK=Module["TOTAL_STACK"]||5242880;var TOTAL_MEMORY=Module["TOTAL_MEMORY"]||33554432;if(TOTAL_MEMORY<TOTAL_STACK)Module.printErr("TOTAL_MEMORY should be larger than TOTAL_STACK, was "+TOTAL_MEMORY+"! (TOTAL_STACK="+TOTAL_STACK+")");if(Module["buffer"]){buffer=Module["buffer"]}else{{buffer=new ArrayBuffer(TOTAL_MEMORY)}}updateGlobalBufferViews();function getTotalMemory(){return TOTAL_MEMORY}HEAP32[0]=1668509029;HEAP16[1]=25459;if(HEAPU8[2]!==115||HEAPU8[3]!==99)throw"Runtime error: expected the system to be little-endian!";Module["HEAP"]=HEAP;Module["buffer"]=buffer;Module["HEAP8"]=HEAP8;Module["HEAP16"]=HEAP16;Module["HEAP32"]=HEAP32;Module["HEAPU8"]=HEAPU8;Module["HEAPU16"]=HEAPU16;Module["HEAPU32"]=HEAPU32;Module["HEAPF32"]=HEAPF32;Module["HEAPF64"]=HEAPF64;function callRuntimeCallbacks(callbacks){while(callbacks.length>0){var callback=callbacks.shift();if(typeof callback=="function"){callback();continue}var func=callback.func;if(typeof func==="number"){if(callback.arg===undefined){Module["dynCall_v"](func)}else{Module["dynCall_vi"](func,callback.arg)}}else{func(callback.arg===undefined?null:callback.arg)}}}var __ATPRERUN__=[];var __ATINIT__=[];var __ATMAIN__=[];var __ATEXIT__=[];var __ATPOSTRUN__=[];var runtimeInitialized=false;var runtimeExited=false;function preRun(){if(Module["preRun"]){if(typeof Module["preRun"]=="function")Module["preRun"]=[Module["preRun"]];while(Module["preRun"].length){addOnPreRun(Module["preRun"].shift())}}callRuntimeCallbacks(__ATPRERUN__)}function ensureInitRuntime(){if(runtimeInitialized)return;runtimeInitialized=true;callRuntimeCallbacks(__ATINIT__)}function preMain(){callRuntimeCallbacks(__ATMAIN__)}function exitRuntime(){callRuntimeCallbacks(__ATEXIT__);runtimeExited=true}function postRun(){if(Module["postRun"]){if(typeof Module["postRun"]=="function")Module["postRun"]=[Module["postRun"]];while(Module["postRun"].length){addOnPostRun(Module["postRun"].shift())}}callRuntimeCallbacks(__ATPOSTRUN__)}function addOnPreRun(cb){__ATPRERUN__.unshift(cb)}Module["addOnPreRun"]=addOnPreRun;function addOnInit(cb){__ATINIT__.unshift(cb)}Module["addOnInit"]=addOnInit;function addOnPreMain(cb){__ATMAIN__.unshift(cb)}Module["addOnPreMain"]=addOnPreMain;function addOnExit(cb){__ATEXIT__.unshift(cb)}Module["addOnExit"]=addOnExit;function addOnPostRun(cb){__ATPOSTRUN__.unshift(cb)}Module["addOnPostRun"]=addOnPostRun;function intArrayFromString(stringy,dontAddNull,length){var len=length>0?length:lengthBytesUTF8(stringy)+1;var u8array=new Array(len);var numBytesWritten=stringToUTF8Array(stringy,u8array,0,u8array.length);if(dontAddNull)u8array.length=numBytesWritten;return u8array}Module["intArrayFromString"]=intArrayFromString;function intArrayToString(array){var ret=[];for(var i=0;i<array.length;i++){var chr=array[i];if(chr>255){chr&=255}ret.push(String.fromCharCode(chr))}return ret.join("")}Module["intArrayToString"]=intArrayToString;function writeStringToMemory(string,buffer,dontAddNull){Runtime.warnOnce("writeStringToMemory is deprecated and should not be called! Use stringToUTF8() instead!");var lastChar,end;if(dontAddNull){end=buffer+lengthBytesUTF8(string);lastChar=HEAP8[end]}stringToUTF8(string,buffer,Infinity);if(dontAddNull)HEAP8[end]=lastChar}Module["writeStringToMemory"]=writeStringToMemory;function writeArrayToMemory(array,buffer){HEAP8.set(array,buffer)}Module["writeArrayToMemory"]=writeArrayToMemory;function writeAsciiToMemory(str,buffer,dontAddNull){for(var i=0;i<str.length;++i){HEAP8[buffer++>>0]=str.charCodeAt(i)}if(!dontAddNull)HEAP8[buffer>>0]=0}Module["writeAsciiToMemory"]=writeAsciiToMemory;if(!Math["imul"]||Math["imul"](4294967295,5)!==-5)Math["imul"]=function imul(a,b){var ah=a>>>16;var al=a&65535;var bh=b>>>16;var bl=b&65535;return al*bl+(ah*bl+al*bh<<16)|0};Math.imul=Math["imul"];if(!Math["clz32"])Math["clz32"]=(function(x){x=x>>>0;for(var i=0;i<32;i++){if(x&1<<31-i)return i}return 32});Math.clz32=Math["clz32"];if(!Math["trunc"])Math["trunc"]=(function(x){return x<0?Math.ceil(x):Math.floor(x)});Math.trunc=Math["trunc"];var Math_abs=Math.abs;var Math_cos=Math.cos;var Math_sin=Math.sin;var Math_tan=Math.tan;var Math_acos=Math.acos;var Math_asin=Math.asin;var Math_atan=Math.atan;var Math_atan2=Math.atan2;var Math_exp=Math.exp;var Math_log=Math.log;var Math_sqrt=Math.sqrt;var Math_ceil=Math.ceil;var Math_floor=Math.floor;var Math_pow=Math.pow;var Math_imul=Math.imul;var Math_fround=Math.fround;var Math_round=Math.round;var Math_min=Math.min;var Math_clz32=Math.clz32;var Math_trunc=Math.trunc;var runDependencies=0;var runDependencyWatcher=null;var dependenciesFulfilled=null;function getUniqueRunDependency(id){return id}function addRunDependency(id){runDependencies++;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}}Module["addRunDependency"]=addRunDependency;function removeRunDependency(id){runDependencies--;if(Module["monitorRunDependencies"]){Module["monitorRunDependencies"](runDependencies)}if(runDependencies==0){if(runDependencyWatcher!==null){clearInterval(runDependencyWatcher);runDependencyWatcher=null}if(dependenciesFulfilled){var callback=dependenciesFulfilled;dependenciesFulfilled=null;callback()}}}Module["removeRunDependency"]=removeRunDependency;Module["preloadedImages"]={};Module["preloadedAudios"]={};var ASM_CONSTS=[];STATIC_BASE=8;STATICTOP=STATIC_BASE+1235168;__ATINIT__.push({func:(function(){__GLOBAL__I_000101()})},{func:(function(){__GLOBAL__sub_I_position_cpp()})},{func:(function(){__GLOBAL__sub_I_iostream_cpp()})},{func:(function(){__GLOBAL__sub_I_ucioption_cpp()})},{func:(function(){__GLOBAL__sub_I_uci_cpp()})},{func:(function(){__GLOBAL__sub_I_tt_cpp()})},{func:(function(){__GLOBAL__sub_I_timeman_cpp()})},{func:(function(){__GLOBAL__sub_I_thread_cpp()})},{func:(function(){__GLOBAL__sub_I_search_cpp()})},{func:(function(){__GLOBAL__sub_I_psqt_cpp()})},{func:(function(){__GLOBAL__sub_I_bitbase_cpp()})},{func:(function(){__GLOBAL__sub_I_pawns_cpp()})},{func:(function(){__GLOBAL__sub_I_movepick_cpp()})},{func:(function(){__GLOBAL__sub_I_movegen_cpp()})},{func:(function(){__GLOBAL__sub_I_misc_cpp()})},{func:(function(){__GLOBAL__sub_I_material_cpp()})},{func:(function(){__GLOBAL__sub_I_main_cpp()})},{func:(function(){__GLOBAL__sub_I_evaluate_cpp()})},{func:(function(){__GLOBAL__sub_I_endgame_cpp()})},{func:(function(){__GLOBAL__sub_I_bitboard_cpp()})});allocate([15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,240,76,77,0,0,154,97,0,0,88,0,0,0,0,0,0,0,36,77,0,0,136,97,0,0,76,77,0,0,196,97,0,0,88,0,0,0,0,0,0,0,36,77,0,0,238,97,0,0,36,77,0,0,31,98,0,0,116,77,0,0,80,98,0,0,0,0,0,0,1,0,0,0,72,0,0,0,3,244,255,255,116,77,0,0,127,98,0,0,0,0,0,0,1,0,0,0,96,0,0,0,3,244,255,255,116,77,0,0,174,98,0,0,0,0,0,0,1,0,0,0,72,0,0,0,3,244,255,255,116,77,0,0,221,98,0,0,0,0,0,0,1,0,0,0,96,0,0,0,3,244,255,255,76,77,0,0,12,99,0,0,120,0,0,0,0,0,0,0,76,77,0,0,37,99,0,0,112,0,0,0,0,0,0,0,76,77,0,0,100,99,0,0,120,0,0,0,0,0,0,0,76,77,0,0,124,99,0,0,112,0,0,0,0,0,0,0,76,77,0,0,148,99,0,0,48,1,0,0,0,0,0,0,76,77,0,0,168,99,0,0,128,5,0,0,0,0,0,0,76,77,0,0,190,99,0,0,48,1,0,0,0,0,0,0,116,77,0,0,248,99,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,112,1,0,0,0,0,0,0,116,77,0,0,60,100,0,0,0,0,0,0,1,0,0,0,136,1,0,0,0,0,0,0,36,77,0,0,82,100,0,0,116,77,0,0,107,100,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,176,1,0,0,0,0,0,0,116,77,0,0,175,100,0,0,0,0,0,0,1,0,0,0,136,1,0,0,0,0,0,0,116,77,0,0,216,100,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,232,1,0,0,0,0,0,0,116,77,0,0,28,101,0,0,0,0,0,0,1,0,0,0,0,2,0,0,0,0,0,0,36,77,0,0,50,101,0,0,116,77,0,0,75,101,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,40,2,0,0,0,0,0,0,116,77,0,0,143,101,0,0,0,0,0,0,1,0,0,0,0,2,0,0,0,0,0,0,116,77,0,0,229,102,0,0,0,0,0,0,3,0,0,0,48,1,0,0,2,0,0,0,104,2,0,0,2,0,0,0,112,2,0,0,0,8,0,0,36,77,0,0,76,103,0,0,36,77,0,0,42,103,0,0,116,77,0,0,95,103,0,0,0,0,0,0,3,0,0,0,48,1,0,0,2,0,0,0,104,2,0,0,2,0,0,0,160,2,0,0,0,8,0,0,36,77,0,0,164,103,0,0,116,77,0,0,198,103,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,200,2,0,0,0,8,0,0,36,77,0,0,11,104,0,0,116,77,0,0,32,104,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,200,2,0,0,0,8,0,0,116,77,0,0,101,104,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,16,3,0,0,2,0,0,0,36,77,0,0,129,104,0,0,116,77,0,0,150,104,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,16,3,0,0,2,0,0,0,116,77,0,0,178,104,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,16,3,0,0,2,0,0,0,116,77,0,0,206,104,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,16,3,0,0,2,0,0,0,116,77,0,0,249,104,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,152,3,0,0,0,0,0,0,36,77,0,0,63,105,0,0,116,77,0,0,99,105,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,192,3,0,0,0,0,0,0,36,77,0,0,169,105,0,0,116,77,0,0,200,105,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,232,3,0,0,0,0,0,0,36,77,0,0,14,106,0,0,116,77,0,0,39,106,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,16,4,0,0,0,0,0,0,36,77,0,0,109,106,0,0,116,77,0,0,134,106,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,56,4,0,0,2,0,0,0,36,77,0,0,155,106,0,0,116,77,0,0,50,107,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,56,4,0,0,2,0,0,0,76,77,0,0,179,106,0,0,112,4,0,0,0,0,0,0,116,77,0,0,214,106,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,144,4,0,0,2,0,0,0,36,77,0,0,249,106,0,0,76,77,0,0,16,107,0,0,112,4,0,0,0,0,0,0,116,77,0,0,71,107,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,144,4,0,0,2,0,0,0,116,77,0,0,105,107,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,144,4,0,0,2,0,0,0,116,77,0,0,139,107,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,144,4,0,0,2,0,0,0,76,77,0,0,174,107,0,0,48,1,0,0,0,0,0,0,116,77,0,0,196,107,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,56,5,0,0,2,0,0,0,36,77,0,0,214,107,0,0,116,77,0,0,235,107,0,0,0,0,0,0,2,0,0,0,48,1,0,0,2,0,0,0,56,5,0,0,2,0,0,0,76,77,0,0,8,108,0,0,48,1,0,0,0,0,0,0,76,77,0,0,29,108,0,0,48,1,0,0,0,0,0,0,36,77,0,0,182,108,0,0,76,77,0,0,1,111,0,0,152,5,0,0,0,0,0,0,76,77,0,0,174,110,0,0,168,5,0,0,0,0,0,0,36,77,0,0,207,110,0,0,76,77,0,0,220,110,0,0,136,5,0,0,0,0,0,0,76,77,0,0,35,111,0,0,136,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,17,0,0,0,15,0,0,0,10,0,0,0,6,0,0,0,250,255,255,255,246,255,255,255,241,255,255,255,239,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,7,0,0,0,249,255,255,255,247,255,255,255,8,0,0,0,1,0,0,0,255,255,255,255,248,255,255,255,0,0,0,0,8,0,0,0,1,0,0,0,248,255,255,255,255,255,255,255,9,0,0,0,249,255,255,255,247,255,255,255,7,0,0,0,17,35,0,0,16,174,0,0,71,212,0,0,86,152,0,0,99,22,0,0,229,115,1,0,208,153,1,0,124,66,0,0,216,2,0,0,76,40,0,0,229,214,0,0,35,128,0,0,249,47,0,0,252,58,0,0,5,65,0,0,255,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,3,0,0,0,2,0,0,0,2,0,0,0,100,0,0,0,90,0,0,0,80,0,0,0,70,0,0,0,70,0,0,0,80,0,0,0,90,0,0,0,100,0,0,0,90,0,0,0,70,0,0,0,60,0,0,0,50,0,0,0,50,0,0,0,60,0,0,0,70,0,0,0,90,0,0,0,80,0,0,0,60,0,0,0,40,0,0,0,30,0,0,0,30,0,0,0,40,0,0,0,60,0,0,0,80,0,0,0,70,0,0,0,50,0,0,0,30,0,0,0,20,0,0,0,20,0,0,0,30,0,0,0,50,0,0,0,70,0,0,0,70,0,0,0,50,0,0,0,30,0,0,0,20,0,0,0,20,0,0,0,30,0,0,0,50,0,0,0,70,0,0,0,80,0,0,0,60,0,0,0,40,0,0,0,30,0,0,0,30,0,0,0,40,0,0,0,60,0,0,0,80,0,0,0,90,0,0,0,70,0,0,0,60,0,0,0,50,0,0,0,50,0,0,0,60,0,0,0,70,0,0,0,90,0,0,0,100,0,0,0,90,0,0,0,80,0,0,0,70,0,0,0,70,0,0,0,80,0,0,0,90,0,0,0,100,0,0,0,0,0,0,0,5,0,0,0,20,0,0,0,40,0,0,0,60,0,0,0,80,0,0,0,90,0,0,0,100,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,0,0,0,3,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,5,0,0,0,4,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,80,0,0,0,60,0,0,0,40,0,0,0,20,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,6,0,0,0,5,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,7,0,0,0,6,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,9,0,0,0,7,0,0,0,7,0,0,0,0,0,0,0,9,0,0,0,10,0,0,0,14,0,0,0,21,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,10,0,0,0,8,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,11,0,0,0,9,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,12,0,0,0,10,0,0,0,10,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,13,0,0,0,11,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,14,0,0,0,12,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,15,0,0,0,13,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,16,0,0,0,14,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,17,0,0,0,15,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,18,0,0,0,16,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,19,0,0,0,17,0,0,0,17,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,20,0,0,0,18,0,0,0,18,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,21,0,0,0,19,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,22,0,0,0,20,0,0,0,20,0,0,0,200,0,0,0,190,0,0,0,180,0,0,0,170,0,0,0,160,0,0,0,150,0,0,0,140,0,0,0,130,0,0,0,190,0,0,0,180,0,0,0,170,0,0,0,160,0,0,0,150,0,0,0,140,0,0,0,130,0,0,0,140,0,0,0,180,0,0,0,170,0,0,0,155,0,0,0,140,0,0,0,140,0,0,0,125,0,0,0,140,0,0,0,150,0,0,0,170,0,0,0,160,0,0,0,140,0,0,0,120,0,0,0,110,0,0,0,140,0,0,0,150,0,0,0,160,0,0,0,160,0,0,0,150,0,0,0,140,0,0,0,110,0,0,0,120,0,0,0,140,0,0,0,160,0,0,0,170,0,0,0,150,0,0,0,140,0,0,0,125,0,0,0,140,0,0,0,140,0,0,0,155,0,0,0,170,0,0,0,180,0,0,0,140,0,0,0,130,0,0,0,140,0,0,0,150,0,0,0,160,0,0,0,170,0,0,0,180,0,0,0,190,0,0,0,130,0,0,0,140,0,0,0,150,0,0,0,160,0,0,0,170,0,0,0,180,0,0,0,190,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,23,0,0,0,21,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,24,0,0,0,22,0,0,0,22,0,0,0,92,6,0,0,92,6,0,0,92,6,0,0,157,6,0,0,92,6,0,0,92,6,0,0,92,6,0,0,92,6,0,0,184,12,0,0,28,0,0,0,27,0,0,0,35,0,0,0,36,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,85,0,0,0,120,0,0,0,85,0,0,0,138,0,0,0,184,0,0,0,207,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,49,0,0,0,55,0,0,0,77,0,0,0,156,0,0,0,241,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,23,0,0,0,13,0,0,0,88,0,0,0,177,0,0,0,229,0,0,0,0,0,0,0,0,0,0,0,27,0,0,0,13,0,0,0,19,0,0,0,111,0,0,0,140,0,0,0,203,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,5,0,0,0,31,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,14,0,0,0,38,0,0,0,73,0,0,0,166,0,0,0,252,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,25,0,0,0,26,0,0,0,56,0,0,0,248,255,255,255,0,0,0,0,27,0,0,0,28,0,0,0,192,255,255,255,192,255,255,255,0,0,0,0,29,0,0,0,30,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,32,0,0,0,192,255,255,255,192,255,255,255,0,0,0,0,33,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,35,0,0,0,36,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,1,0,0,0,23,0,0,0,24,0,0,0,2,0,0,0,25,0,0,0,26,0,0,0,23,0,0,0,3,0,0,0,24,0,0,0,28,14,0,0,232,14,0,0,88,14,0,0,108,14,0,0,200,42,0,0,220,42,0,0,16,15,0,0,252,14,0,0,68,14,0,0,48,14,0,0,64,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,38,0,0,0,56,0,0,0,248,255,255,255,0,0,0,0,39,0,0,0,40,0,0,0,192,255,255,255,192,255,255,255,0,0,0,0,41,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,43,0,0,0,27,0,0,0,25,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,44,0,0,0,28,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,45,0,0,0,29,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,46,0,0,0,30,0,0,0,28,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,47,0,0,0,31,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,48,0,0,0,32,0,0,0,30,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,255,0,0,0,253,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,230,255,255,255,254,255,255,255,47,0,0,0,105,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,71,255,255,255,24,0,0,0,122,0,0,0,137,0,0,0,122,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,194,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,255,255,255,59,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,206,255,255,255,178,0,0,0,209,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,126,255,255,255,69,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,255,255,255,195,254,255,255,60,0,0,0,38,255,255,255,224,254,255,255,0,0,0,0,0,0,0,0,0,0,0,0,89,0,0,0,253,254,255,255,196,255,255,255,77,255,255,255,224,255,255,255,180,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,238,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,38,0,0,0,5,1,0,0,246,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,0,0,0,254,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,237,255,255,255,238,255,255,255,28,0,0,0,90,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,81,255,255,255,18,0,0,0,109,0,0,0,149,0,0,0,132,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,255,0,0,0,253,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,230,255,255,255,254,255,255,255,47,0,0,0,105,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,71,255,255,255,24,0,0,0,122,0,0,0,137,0,0,0,122,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,255,0,0,0,253,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,230,255,255,255,254,255,255,255,47,0,0,0,105,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,71,255,255,255,24,0,0,0,122,0,0,0,137,0,0,0,122,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,255,0,0,0,253,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,230,255,255,255,254,255,255,255,47,0,0,0,105,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,71,255,255,255,24,0,0,0,122,0,0,0,137,0,0,0,122,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,255,0,0,0,253,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,230,255,255,255,254,255,255,255,47,0,0,0,105,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,71,255,255,255,24,0,0,0,122,0,0,0,137,0,0,0,122,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,131,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,255,0,0,0,253,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,230,255,255,255,254,255,255,255,47,0,0,0,105,0,0,0,107,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,71,255,255,255,24,0,0,0,122,0,0,0,137,0,0,0,122,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,65,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,39,0,0,0,24,0,0,0,232,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,0,0,0,100,0,0,0,219,255,255,255,141,0,0,0,12,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,203,255,255,255,113,255,255,255,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,0,0,0,214,254,255,255,3,0,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,255,255,255,142,254,255,255,56,0,0,0,45,0,0,0,177,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,62,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,54,0,0,0,17,0,0,0,238,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,105,0,0,0,97,0,0,0,222,255,255,255,151,0,0,0,22,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,65,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,39,0,0,0,24,0,0,0,232,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,0,0,0,100,0,0,0,219,255,255,255,141,0,0,0,12,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,235,252,255,255,152,252,255,255,237,255,255,255,96,254,255,255,174,253,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,65,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,39,0,0,0,24,0,0,0,232,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,0,0,0,100,0,0,0,219,255,255,255,141,0,0,0,12,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,65,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,39,0,0,0,24,0,0,0,232,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,0,0,0,100,0,0,0,219,255,255,255,141,0,0,0,12,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,65,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,39,0,0,0,24,0,0,0,232,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,0,0,0,100,0,0,0,219,255,255,255,141,0,0,0,12,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,59,0,0,0,65,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,46,0,0,0,39,0,0,0,24,0,0,0,232,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,0,0,0,100,0,0,0,219,255,255,255,141,0,0,0,12,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,0,0,0,0,0,0,0,0,0,0,0,49,0,0,0,50,0,0,0,152,255,255,255,152,255,255,255,0,0,0,0,51,0,0,0,52,0,0,0,104,0,0,0,0,0,0,0,0,0,0,0,53,0,0,0,54,0,0,0,152,255,255,255,152,255,255,255,0,0,0,0,55,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,57,0,0,0,58,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,33,0,0,0,24,0,0,0,2,0,0,0,34,0,0,0,35,0,0,0,31,0,0,0,3,0,0,0,32,0,0,0,220,33,0,0,180,33,0,0,200,33,0,0,240,33,0,0,0,0,0,0,0,0,0,0,59,0,0,0,60,0,0,0,2,0,0,0,4,0,0,0,3,0,0,0,3,0,0,0,36,0,0,0,24,0,0,0,2,0,0,0,37,0,0,0,26,0,0,0,33,0,0,0,3,0,0,0,34,0,0,0,10,0,0,0,100,0,0,0,20,0,0,0,10,0,0,0,46,0,0,0,82,0,0,0,86,0,0,0,98,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,28,0,0,0,87,0,0,0,94,0,0,0,108,0,0,0,104,0,0,0,0,0,0,0,109,0,0,0,1,0,0,0,59,0,0,0,87,0,0,0,62,0,0,0,91,0,0,0,116,0,0,0,0,0,0,0,75,0,0,0,12,0,0,0,43,0,0,0,59,0,0,0,90,0,0,0,84,0,0,0,112,0,0,0,0,0,0,0,100,0,0,0,20,0,0,0,10,0,0,0,46,0,0,0,82,0,0,0,86,0,0,0,98,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,28,0,0,0,87,0,0,0,94,0,0,0,108,0,0,0,104,0,0,0,0,0,0,0,109,0,0,0,1,0,0,0,59,0,0,0,87,0,0,0,62,0,0,0,91,0,0,0,116,0,0,0,0,0,0,0,75,0,0,0,12,0,0,0,43,0,0,0,59,0,0,0,90,0,0,0,84,0,0,0,112,0,0,0,0,0,0,0,100,0,0,0,50,0,0,0,10,0,0,0,46,0,0,0,82,0,0,0,86,0,0,0,98,0,0,0,0,0,0,0,116,0,0,0,50,0,0,0,10,0,0,0,87,0,0,0,94,0,0,0,108,0,0,0,104,0,0,0,0,0,0,0,109,0,0,0,50,0,0,0,10,0,0,0,87,0,0,0,62,0,0,0,91,0,0,0,116,0,0,0,0,0,0,0,75,0,0,0,50,0,0,0,10,0,0,0,59,0,0,0,90,0,0,0,84,0,0,0,112,0,0,0,0,0,0,0,238,0,0,0,6,0,0,0,82,0,0,0,130,0,0,0,120,0,0,0,166,0,0,0,232,0,0,0,0,0,0,0,74,1,0,0,0,0,0,0,120,0,0,0,184,0,0,0,186,0,0,0,184,0,0,0,192,0,0,0,0,0,0,0,196,0,0,0,0,0,0,0,156,0,0,0,136,0,0,0,216,0,0,0,196,0,0,0,242,0,0,0,0,0,0,0,176,0,0,0,34,0,0,0,112,0,0,0,170,0,0,0,182,0,0,0,194,0,0,0,20,1,0,0,0,0,0,0,100,0,0,0,20,0,0,0,10,0,0,0,46,0,0,0,82,0,0,0,86,0,0,0,98,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,28,0,0,0,87,0,0,0,94,0,0,0,108,0,0,0,104,0,0,0,0,0,0,0,109,0,0,0,1,0,0,0,59,0,0,0,87,0,0,0,62,0,0,0,91,0,0,0,116,0,0,0,0,0,0,0,75,0,0,0,12,0,0,0,43,0,0,0,59,0,0,0,90,0,0,0,84,0,0,0,112,0,0,0,0,0,0,0,100,0,0,0,20,0,0,0,10,0,0,0,46,0,0,0,82,0,0,0,86,0,0,0,98,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,28,0,0,0,87,0,0,0,94,0,0,0,108,0,0,0,104,0,0,0,0,0,0,0,109,0,0,0,1,0,0,0,59,0,0,0,87,0,0,0,62,0,0,0,91,0,0,0,116,0,0,0,0,0,0,0,75,0,0,0,12,0,0,0,43,0,0,0,59,0,0,0,90,0,0,0,84,0,0,0,112,0,0,0,0,0,0,0,100,0,0,0,20,0,0,0,10,0,0,0,46,0,0,0,82,0,0,0,86,0,0,0,98,0,0,0,0,0,0,0,116,0,0,0,4,0,0,0,28,0,0,0,87,0,0,0,94,0,0,0,108,0,0,0,104,0,0,0,0,0,0,0,109,0,0,0,1,0,0,0,59,0,0,0,87,0,0,0,62,0,0,0,91,0,0,0,116,0,0,0,0,0,0,0,75,0,0,0,12,0,0,0,43,0,0,0,59,0,0,0,90,0,0,0,84,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,21,0,0,0,54,0,0,0,87,0,0,0,89,0,0,0,100,0,0,0,0,0,0,0,112,0,0,0,3,0,0,0,54,0,0,0,105,0,0,0,85,0,0,0,105,0,0,0,100,0,0,0,0,0,0,0,118,0,0,0,22,0,0,0,68,0,0,0,93,0,0,0,60,0,0,0,88,0,0,0,119,0,0,0,0,0,0,0,92,0,0,0,11,0,0,0,51,0,0,0,66,0,0,0,93,0,0,0,86,0,0,0,118,0,0,0,0,0,0,0,0,0,0,0,222,254,255,255,238,254,255,255,57,0,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,0,0,144,0,0,0,39,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,141,0,0,0,41,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,53,0,0,0,127,0,0,0,56,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4,0,0,0,73,0,0,0,132,0,0,0,46,0,0,0,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,64,0,0,0,143,0,0,0,26,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,47,0,0,0,110,0,0,0,44,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,0,0,0,127,0,0,0,50,0,0,0,31],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE);allocate([79,0,0,0,23,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,148,0,0,0,27,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,161,0,0,0,16,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,171,0,0,0,22,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,22,0,0,0,45,0,0,0,104,0,0,0,62,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,30,0,0,0,99,0,0,0,39,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,23,0,0,0,29,0,0,0,96,0,0,0,41,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,0,0,0,23,0,0,0,116,0,0,0,41,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,36,0,0,0,28,0,0,0,3,0,0,0,1,0,0,0,115,0,0,0,107,0,0,0,65,1,0,0,76,1,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,19,0,0,0,13,0,0,0,71,0,0,0,94,0,0,0,169,0,0,0,68,1,0,0,60,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,32,0,0,0,196,255,255,255,196,255,255,255,0,0,0,0,33,0,0,0,34,0,0,0,60,0,0,0,0,0,0,0,0,0,0,0,61,0,0,0,62,0,0,0,196,255,255,255,196,255,255,255,0,0,0,0,63,0,0,0,64,0,0,0,96,42,0,0,56,42,0,0,76,42,0,0,116,42,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,49,0,0,0,50,0,0,0,200,255,255,255,200,255,255,255,0,0,0,0,51,0,0,0,52,0,0,0,56,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,66,0,0,0,200,255,255,255,200,255,255,255,0,0,0,0,67,0,0,0,68,0,0,0,240,42,0,0,200,42,0,0,220,42,0,0,4,43,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,154,59,0,0,75,15,0,0,0,0,0,0,188,0,0,0,241,2,0,0,46,3,0,0,5,5,0,0,209,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,0,0,0,64,3,0,0,122,3,0,0,91,5,0,0,88,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,255,255,95,255,255,255,161,254,255,255,227,253,255,255,135,255,255,255,233,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,193,0,0,0,118,0,0,0,58,0,0,0,32,255,255,255,231,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,58,1,0,0,218,1,0,0,140,2,0,0,131,3,0,0,126,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,191,1,0,0,243,2,0,0,250,2,0,0,175,4,0,0,61,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,157,0,0,0,179,1,0,0,237,1,0,0,136,2,0,0,98,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,246,0,0,0,109,2,0,0,99,2,0,0,15,3,0,0,223,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,61,1,0,0,117,3,0,0,233,2,0,0,36,4,0,0,35,12,0,0,248,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,1,0,0,217,3,0,0,196,3,0,0,163,4,0,0,194,12,0,0,227,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,178,0,0,0,222,2,0,0,91,3,0,0,135,4,0,0,92,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,50,3,0,0,115,3,0,0,9,5,0,0,50,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,215,255,255,255,234,255,255,255,37,255,255,255,55,254,255,255,134,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,233,255,255,255,73,1,0,0,231,0,0,0,77,0,0,0,43,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,218,2,0,0,238,3,0,0,250,4,0,0,227,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,71,3,0,0,251,3,0,0,50,7,0,0,42,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,181,0,0,0,179,2,0,0,61,3,0,0,198,4,0,0,226,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,245,0,0,0,82,3,0,0,77,3,0,0,106,5,0,0,13,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,20,0,0,0,20,0,0,0,20,0,0,0,100,0,0,0,20,0,0,0,20,0,0,0,20,0,0,0,100,0,0,0,20,0,0,0,150,0,0,0,88,2,0,0,48,2,0,0,125,0,0,0,150,0,0,0,150,0,0,0,81,2,0,0,80,1,0,0,44,1,0,0,0,1,0,0,200,0,0,0,0,1,0,0,200,0,0,0,0,2,0,0,144,1,0,0,0,1,0,0,200,0,0,0,0,1,0,0,200,0,0,0,0,1,0,0,200,0,0,0,43,1,0,0,25,1,0,0,49,1,0,0,55,1,0,0,0,1,0,0,200,0,0,0,227,1,0,0,58,2,0,0,91,2,0,0,42,2,0,0,140,7,0,0,232,8,0,0,108,9,0,0,168,8,0,0,75,7,0,0,37,9,0,0,197,9,0,0,170,8,0,0,219,1,0,0,78,2,0,0,139,2,0,0,110,2,0,0,227,1,0,0,58,2,0,0,91,2,0,0,42,2,0,0,227,1,0,0,58,2,0,0,91,2,0,0,42,2,0,0,189,7,0,0,31,9,0,0,47,9,0,0,94,8,0,0,19,4,0,0,248,3,0,0,236,3,0,0,244,3,0,0,208,7,0,0,208,7,0,0,208,7,0,0,208,7,0,0,200,0,0,0,200,0,0,0,200,0,0,0,200,0,0,0,200,0,0,0,200,0,0,0,200,0,0,0,235,0,0,0,200,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,72,0,0,0,73,0,0,0,84,49,0,0,5,0,0,0,0,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,6,0,0,0,204,208,18,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,49,0,0,5,0,0,0,0,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,0,0,0,6,0,0,0,212,208,18,0,0,4,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,49,0,0,64,50,0,0,9,0,0,0,0,0,0,0,0,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,6,0,0,0,220,212,18,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5,95,112,137,0,255,9,47,15,148,78,0,0,28,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,97,0,0,0,98,0,0,0,99,0,0,0,100,0,0,0,101,0,0,0,102,0,0,0,103,0,0,0,104,0,0,0,105,0,0,0,106,0,0,0,107,0,0,0,108,0,0,0,109,0,0,0,110,0,0,0,111,0,0,0,112,0,0,0,113,0,0,0,114,0,0,0,115,0,0,0,116,0,0,0,117,0,0,0,118,0,0,0,119,0,0,0,120,0,0,0,121,0,0,0,122,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,42,0,0,0,43,0,0,0,44,0,0,0,45,0,0,0,46,0,0,0,47,0,0,0,48,0,0,0,49,0,0,0,50,0,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,91,0,0,0,92,0,0,0,93,0,0,0,94,0,0,0,95,0,0,0,96,0,0,0,65,0,0,0,66,0,0,0,67,0,0,0,68,0,0,0,69,0,0,0,70,0,0,0,71,0,0,0,72,0,0,0,73,0,0,0,74,0,0,0,75,0,0,0,76,0,0,0,77,0,0,0,78,0,0,0,79,0,0,0,80,0,0,0,81,0,0,0,82,0,0,0,83,0,0,0,84,0,0,0,85,0,0,0,86,0,0,0,87,0,0,0,88,0,0,0,89,0,0,0,90,0,0,0,123,0,0,0,124,0,0,0,125,0,0,0,126,0,0,0,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,0,0,0,74,0,0,0,75,0,0,0,0,0,0,0,112,0,0,0,57,0,0,0,76,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,23,0,0,0,24,0,0,0,2,0,0,0,39,0,0,0,26,0,0,0,31,0,0,0,3,0,0,0,35,0,0,0,0,0,0,0,120,0,0,0,77,0,0,0,78,0,0,0,3,0,0,0,10,0,0,0,4,0,0,0,4,0,0,0,40,0,0,0,41,0,0,0,11,0,0,0,42,0,0,0,43,0,0,0,36,0,0,0,12,0,0,0,37,0,0,0,8,0,0,0,0,0,0,0,128,0,0,0,31,0,0,0,32,0,0,0,248,255,255,255,248,255,255,255,128,0,0,0,33,0,0,0,34,0,0,0,8,0,0,0,0,0,0,0,152,0,0,0,79,0,0,0,80,0,0,0,248,255,255,255,248,255,255,255,152,0,0,0,81,0,0,0,82,0,0,0,4,0,0,0,0,0,0,0,176,0,0,0,49,0,0,0,50,0,0,0,252,255,255,255,252,255,255,255,176,0,0,0,51,0,0,0,52,0,0,0,4,0,0,0,0,0,0,0,200,0,0,0,83,0,0,0,84,0,0,0,252,255,255,255,252,255,255,255,200,0,0,0,85,0,0,0,86,0,0,0,0,0,0,0,224,0,0,0,77,0,0,0,87,0,0,0,4,0,0,0,10,0,0,0,4,0,0,0,4,0,0,0,44,0,0,0,41,0,0,0,11,0,0,0,42,0,0,0,43,0,0,0,36,0,0,0,13,0,0,0,38,0,0,0,0,0,0,0,240,0,0,0,57,0,0,0,88,0,0,0,5,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,45,0,0,0,24,0,0,0,2,0,0,0,39,0,0,0,26,0,0,0,31,0,0,0,14,0,0,0,39,0,0,0,0,0,0,0,0,1,0,0,77,0,0,0,89,0,0,0,6,0,0,0,10,0,0,0,4,0,0,0,4,0,0,0,40,0,0,0,41,0,0,0,11,0,0,0,46,0,0,0,47,0,0,0,40,0,0,0,12,0,0,0,37,0,0,0,0,0,0,0,16,1,0,0,57,0,0,0,90,0,0,0,7,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,23,0,0,0,24,0,0,0,2,0,0,0,48,0,0,0,49,0,0,0,41,0,0,0,3,0,0,0,35,0,0,0,0,0,0,0,32,1,0,0,91,0,0,0,92,0,0,0,93,0,0,0,1,0,0,0,5,0,0,0,15,0,0,0,0,0,0,0,64,1,0,0,94,0,0,0,95,0,0,0,93,0,0,0,2,0,0,0,6,0,0,0,16,0,0,0,0,0,0,0,80,1,0,0,96,0,0,0,97,0,0,0,93,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,144,1,0,0,98,0,0,0,99,0,0,0,93,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,200,1,0,0,100,0,0,0,101,0,0,0,93,0,0,0,3,0,0,0,4,0,0,0,23,0,0,0,5,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,6,0,0,0,0,0,0,0,8,2,0,0,102,0,0,0,103,0,0,0,93,0,0,0,7,0,0,0,8,0,0,0,25,0,0,0,9,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,10,0,0,0,0,0,0,0,64,2,0,0,104,0,0,0,105,0,0,0,93,0,0,0,50,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,64,2,0,0,51,0,0,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,0,0,0,0,120,2,0,0,106,0,0,0,107,0,0,0,93,0,0,0,58,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,120,2,0,0,59,0,0,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,168,2,0,0,108,0,0,0,109,0,0,0,93,0,0,0,1,0,0,0,0,0,0,0,208,2,0,0,110,0,0,0,111,0,0,0,93,0,0,0,2,0,0,0,0,0,0,0,240,2,0,0,112,0,0,0,113,0,0,0,93,0,0,0,66,0,0,0,67,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,68,0,0,0,12,0,0,0,13,0,0,0,0,0,0,0,24,3,0,0,114,0,0,0,115,0,0,0,93,0,0,0,69,0,0,0,70,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,71,0,0,0,18,0,0,0,19,0,0,0,0,0,0,0,56,3,0,0,116,0,0,0,117,0,0,0,93,0,0,0,72,0,0,0,73,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,74,0,0,0,24,0,0,0,25,0,0,0,0,0,0,0,88,3,0,0,118,0,0,0,119,0,0,0,93,0,0,0,75,0,0,0,76,0,0,0,26,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,77,0,0,0,30,0,0,0,31,0,0,0,0,0,0,0,120,3,0,0,120,0,0,0,121,0,0,0,93,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,160,3,0,0,122,0,0,0,123,0,0,0,93,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,200,3,0,0,124,0,0,0,125,0,0,0,93,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,240,3,0,0,126,0,0,0,127,0,0,0,93,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,24,4,0,0,128,0,0,0,129,0,0,0,93,0,0,0,17,0,0,0,5,0,0,0,32,0,0,0,0,0,0,0,64,4,0,0,130,0,0,0,131,0,0,0,93,0,0,0,18,0,0,0,6,0,0,0,33,0,0,0,0,0,0,0,152,4,0,0,132,0,0,0,133,0,0,0,93,0,0,0,3,0,0,0,4,0,0,0,11,0,0,0,78,0,0,0,79,0,0,0,12,0,0,0,80,0,0,0,0,0,0,0,96,4,0,0,132,0,0,0,134,0,0,0,93,0,0,0,3,0,0,0,4,0,0,0,11,0,0,0,78,0,0,0,79,0,0,0,12,0,0,0,80,0,0,0,0,0,0,0,200,4,0,0,135,0,0,0,136,0,0,0,93,0,0,0,5,0,0,0,6,0,0,0,13,0,0,0,81,0,0,0,82,0,0,0,14,0,0,0,83,0,0,0,0,0,0,0,8,5,0,0,137,0,0,0,138,0,0,0,93,0,0,0,0,0,0,0,24,5,0,0,139,0,0,0,140,0,0,0,93,0,0,0,42,0,0,0,19,0,0,0,43,0,0,0,20,0,0,0,44,0,0,0,1,0,0,0,21,0,0,0,15,0,0,0,0,0,0,0,96,5,0,0,141,0,0,0,142,0,0,0,93,0,0,0,84,0,0,0,85,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,0,0,0,0,112,5,0,0,143,0,0,0,144,0,0,0,93,0,0,0,86,0,0,0,87,0,0,0,37,0,0,0,38,0,0,0,39,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,48,1,0,0,132,0,0,0,145,0,0,0,93,0,0,0,0,0,0,0,64,5,0,0,132,0,0,0,146,0,0,0,93,0,0,0,22,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,45,0,0,0,23,0,0,0,46,0,0,0,24,0,0,0,47,0,0,0,5,0,0,0,25,0,0,0,16,0,0,0,0,0,0,0,168,4,0,0,132,0,0,0,147,0,0,0,93,0,0,0,7,0,0,0,8,0,0,0,17,0,0,0,88,0,0,0,89,0,0,0,18,0,0,0,90,0,0,0,0,0,0,0,232,4,0,0,132,0,0,0,148,0,0,0,93,0,0,0,9,0,0,0,10,0,0,0,19,0,0,0,91,0,0,0,92,0,0,0,20,0,0,0,93,0,0,0,0,0,0,0,112,4,0,0,132,0,0,0,149,0,0,0,93,0,0,0,3,0,0,0,4,0,0,0,11,0,0,0,78,0,0,0,79,0,0,0,12,0,0,0,80,0,0,0,0,0,0,0,136,5,0,0,150,0,0,0,151,0,0,0,152,0,0,0,153,0,0,0,26,0,0,0,7,0,0,0,1,0,0,0,7,0,0,0,0,0,0,0,176,5,0,0,150,0,0,0,154,0,0,0,152,0,0,0,153,0,0,0,26,0,0,0,8,0,0,0,2,0,0,0,8,0,0,0,0,0,0,0,192,5,0,0,150,0,0,0,155,0,0,0,152,0,0,0,153,0,0,0,26,0,0,0,9,0,0,0,3,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,3,32,2,32,2,32,2,32,2,32,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,96,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,8,216,4,192,4,192,4,192,4,192,4,192,4,192,4,192,8,213,8,213,8,213,8,213,8,213,8,213,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,8,197,4,192,4,192,4,192,4,192,4,192,4,192,8,214,8,214,8,214,8,214,8,214,8,214,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,8,198,4,192,4,192,4,192,4,192,2],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+10252);allocate([75,80,118,75,0,75,78,78,118,75,0,75,66,78,118,75,0,75,82,118,75,80,0,75,82,118,75,66,0,75,82,118,75,78,0,75,81,118,75,80,0,75,81,118,75,82,0,75,78,80,118,75,0,75,78,80,118,75,66,0,75,82,80,118,75,82,0,75,82,80,118,75,66,0,75,66,80,118,75,66,0,75,66,80,118,75,78,0,75,66,80,80,118,75,66,0,75,82,80,80,118,75,82,80,0,82,118,75,0,75,118,78,0,78,118,78,0,75,81,118,75,0,74,97,110,32,70,101,98,32,77,97,114,32,65,112,114,32,77,97,121,32,74,117,110,32,74,117,108,32,65,117,103,32,83,101,112,32,79,99,116,32,78,111,118,32,68,101,99,0,77,97,114,32,32,56,32,50,48,49,55,0,83,116,111,99,107,102,105,115,104,32,0,10,105,100,32,97,117,116,104,111,114,32,0,32,98,121,32,0,84,46,32,82,111,109,115,116,97,100,44,32,77,46,32,67,111,115,116,97,108,98,97,44,32,74,46,32,75,105,105,115,107,105,44,32,71,46,32,76,105,110,115,99,111,116,116,0,119,0,60,60,32,0,62,62,32,0,32,80,78,66,82,81,75,32,32,112,110,98,114,113,107,0,126,0,32,119,32,0,32,98,32,0,32,45,32,0,43,0,47,56,47,56,47,56,47,56,47,56,47,56,47,0,32,119,32,45,32,45,32,48,32,49,48,0,105,110,102,111,32,100,101,112,116,104,32,48,32,115,99,111,114,101,32,0,98,101,115,116,109,111,118,101,32,0,32,112,111,110,100,101,114,32,0,105,110,102,111,0,32,100,101,112,116,104,32,0,32,115,101,108,100,101,112,116,104,32,0,32,109,117,108,116,105,112,118,32,0,32,115,99,111,114,101,32,0,32,117,112,112,101,114,98,111,117,110,100,0,32,108,111,119,101,114,98,111,117,110,100,0,32,110,111,100,101,115,32,0,32,110,112,115,32,0,32,104,97,115,104,102,117,108,108,32,0,32,116,98,104,105,116,115,32,0,32,116,105,109,101,32,0,32,112,118,0,70,97,105,108,101,100,32,116,111,32,97,108,108,111,99,97,116,101,32,0,77,66,32,102,111,114,32,116,114,97,110,115,112,111,115,105,116,105,111,110,32,116,97,98,108,101,46,0,114,110,98,113,107,98,110,114,47,112,112,112,112,112,112,112,112,47,56,47,56,47,56,47,56,47,80,80,80,80,80,80,80,80,47,82,78,66,81,75,66,78,82,32,119,32,75,81,107,113,32,45,32,48,32,49,0,114,110,98,113,107,98,110,114,47,112,112,112,112,112,112,112,112,47,56,47,56,47,56,47,56,47,80,80,80,80,80,80,80,80,47,82,78,66,81,75,66,78,82,91,93,32,119,32,75,81,107,113,32,45,32,48,32,49,0,114,110,98,113,107,98,110,114,47,112,112,112,112,112,112,112,112,47,56,47,49,80,80,50,80,80,49,47,80,80,80,80,80,80,80,80,47,80,80,80,80,80,80,80,80,47,80,80,80,80,80,80,80,80,47,80,80,80,80,80,80,80,80,32,119,32,107,113,32,45,32,48,32,49,0,56,47,56,47,56,47,56,47,56,47,56,47,107,114,98,110,78,66,82,75,47,113,114,98,110,78,66,82,81,32,119,32,45,32,45,32,48,32,49,0,114,110,98,113,107,98,110,114,47,112,112,112,112,112,112,112,112,47,56,47,56,47,56,47,56,47,80,80,80,80,80,80,80,80,47,82,78,66,81,75,66,78,82,32,119,32,75,81,107,113,32,45,32,51,43,51,32,48,32,49,0,114,110,98,113,107,98,110,114,47,112,112,112,112,112,112,112,112,47,56,47,56,47,56,47,56,47,80,80,80,80,80,80,80,80,47,82,78,66,81,75,66,78,82,32,119,32,45,32,45,32,48,32,49,0,113,117,105,116,0,115,116,111,112,0,112,111,110,100,101,114,104,105,116,0,117,99,105,0,105,100,32,110,97,109,101,32,0,10,0,10,117,99,105,111,107,0,117,99,105,110,101,119,103,97,109,101,0,105,115,114,101,97,100,121,0,114,101,97,100,121,111,107,0,103,111,0,115,101,97,114,99,104,109,111,118,101,115,0,119,116,105,109,101,0,98,116,105,109,101,0,119,105,110,99,0,98,105,110,99,0,109,111,118,101,115,116,111,103,111,0,100,101,112,116,104,0,110,111,100,101,115,0,109,111,118,101,116,105,109,101,0,109,97,116,101,0,105,110,102,105,110,105,116,101,0,112,111,110,100,101,114,0,112,111,115,105,116,105,111,110,0,115,116,97,114,116,112,111,115,0,102,101,110,0,109,111,118,101,115,0,32,0,115,101,116,111,112,116,105,111,110,0,118,97,108,117,101,0,105,110,102,111,32,115,116,114,105,110,103,32,118,97,114,105,97,110,116,32,0,32,115,116,97,114,116,112,111,115,32,0,78,111,32,115,117,99,104,32,111,112,116,105,111,110,58,32,0,85,110,107,110,111,119,110,32,99,111,109,109,97,110,100,58,32,0,40,110,111,110,101,41,0,48,48,48,48,0,32,80,78,66,82,81,75,32,32,80,78,66,82,81,75,32,0,32,112,110,98,114,113,107,0,99,112,32,0,109,97,116,101,32,0,99,104,101,115,115,0,103,105,118,101,97,119,97,121,0,97,116,111,109,105,99,0,99,114,97,122,121,104,111,117,115,101,0,104,111,114,100,101,0,107,105,110,103,111,102,116,104,101,104,105,108,108,0,108,111,115,101,114,115,0,114,97,99,105,110,103,107,105,110,103,115,0,116,104,114,101,101,99,104,101,99,107,0,115,117,105,99,105,100,101,0,98,117,103,104,111,117,115,101,0,108,111,111,112,0,115,112,105,110,0,68,101,98,117,103,32,76,111,103,32,70,105,108,101,0,115,116,114,105,110,103,0,67,111,110,116,101,109,112,116,0,84,104,114,101,97,100,115,0,72,97,115,104,0,67,108,101,97,114,32,72,97,115,104,0,98,117,116,116,111,110,0,80,111,110,100,101,114,0,99,104,101,99,107,0,77,117,108,116,105,80,86,0,77,111,118,101,32,79,118,101,114,104,101,97,100,0,77,105,110,105,109,117,109,32,84,104,105,110,107,105,110,103,32,84,105,109,101,0,83,108,111,119,32,77,111,118,101,114,0,110,111,100,101,115,116,105,109,101,0,85,67,73,95,67,104,101,115,115,57,54,48,0,85,67,73,95,86,97,114,105,97,110,116,0,99,111,109,98,111,0,10,111,112,116,105,111,110,32,110,97,109,101,32,0,32,116,121,112,101,32,0,32,100,101,102,97,117,108,116,32,0,32,118,97,114,32,0,32,109,105,110,32,0,32,109,97,120,32,0,17,0,10,0,17,17,17,0,0,0,0,5,0,0,0,0,0,0,9,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,15,10,17,17,17,3,10,7,0,1,19,9,11,11,0,0,9,6,11,0,0,11,0,6,17,0,0,0,17,17,17,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,17,0,10,10,17,17,17,0,10,0,0,2,0,9,11,0,0,0,9,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,0,0,0,0,0,0,0,0,0,0,0,13,0,0,0,4,13,0,0,0,0,9,14,0,0,0,0,0,14,0,0,14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,15,0,0,0,0,9,16,0,0,0,0,0,16,0,0,16,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,18,0,0,0,18,18,18,0,0,0,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,0,10,0,0,0,0,9,11,0,0,0,0,0,11,0,0,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,0,0,0,0,12,0,0,0,0,12,0,0,0,0,9,12,0,0,0,0,0,12,0,0,12,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,45,43,32,32,32,48,88,48,120,0,40,110,117,108,108,41,0,45,48,88,43,48,88,32,48,88,45,48,120,43,48,120,32,48,120,0,105,110,102,0,73,78,70,0,78,65,78,0,46,0,84,33,34,25,13,1,2,3,17,75,28,12,16,4,11,29,18,30,39,104,110,111,112,113,98,32,5,6,15,19,20,21,26,8,22,7,40,36,23,24,9,10,14,27,31,37,35,131,130,125,38,42,43,60,61,62,63,67,71,74,77,88,89,90,91,92,93,94,95,96,97,99,100,101,102,103,105,106,107,108,114,115,116,121,122,123,124,0,73,108,108,101,103,97,108,32,98,121,116,101,32,115,101,113,117,101,110,99,101,0,68,111,109,97,105,110,32,101,114,114,111,114,0,82,101,115,117,108,116,32,110,111,116,32,114,101,112,114,101,115,101,110,116,97,98,108,101,0,78,111,116,32,97,32,116,116,121,0,80,101,114,109,105,115,115,105,111,110,32,100,101,110,105,101,100,0,79,112,101,114,97,116,105,111,110,32,110,111,116,32,112,101,114,109,105,116,116,101,100,0,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,0,78,111,32,115,117,99,104,32,112,114,111,99,101,115,115,0,70,105,108,101,32,101,120,105,115,116,115,0,86,97,108,117,101,32,116,111,111,32,108,97,114,103,101,32,102,111,114,32,100,97,116,97,32,116,121,112,101,0,78,111,32,115,112,97,99,101,32,108,101,102,116,32,111,110,32,100,101,118,105,99,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,115,111,117,114,99,101,32,98,117,115,121,0,73,110,116,101,114,114,117,112,116,101,100,32,115,121,115,116,101,109,32,99,97,108,108,0,82,101,115,111,117,114,99,101,32,116,101,109,112,111,114,97,114,105,108,121,32,117,110,97,118,97,105,108,97,98,108,101,0,73,110,118,97,108,105,100,32,115,101,101,107,0,67,114,111,115,115,45,100,101,118,105,99,101,32,108,105,110,107,0,82,101,97,100,45,111,110,108,121,32,102,105,108,101,32,115,121,115,116,101,109,0,68,105,114,101,99,116,111,114,121,32,110,111,116,32,101,109,112,116,121,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,112,101,101,114,0,79,112,101,114,97,116,105,111,110,32,116,105,109,101,100,32,111,117,116,0,67,111,110,110,101,99,116,105,111,110,32,114,101,102,117,115,101,100,0,72,111,115,116,32,105,115,32,100,111,119,110,0,72,111,115,116,32,105,115,32,117,110,114,101,97,99,104,97,98,108,101,0,65,100,100,114,101,115,115,32,105,110,32,117,115,101,0,66,114,111,107,101,110,32,112,105,112,101,0,73,47,79,32,101,114,114,111,114,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,32,111,114,32,97,100,100,114,101,115,115,0,66,108,111,99,107,32,100,101,118,105,99,101,32,114,101,113,117,105,114,101,100,0,78,111,32,115,117,99,104,32,100,101,118,105,99,101,0,78,111,116,32,97,32,100,105,114,101,99,116,111,114,121,0,73,115,32,97,32,100,105,114,101,99,116,111,114,121,0,84,101,120,116,32,102,105,108,101,32,98,117,115,121,0,69,120,101,99,32,102,111,114,109,97,116,32,101,114,114,111,114,0,73,110,118,97,108,105,100,32,97,114,103,117,109,101,110,116,0,65,114,103,117,109,101,110,116,32,108,105,115,116,32,116,111,111,32,108,111,110,103,0,83,121,109,98,111,108,105,99,32,108,105,110,107,32,108,111,111,112,0,70,105,108,101,110,97,109,101,32,116,111,111,32,108,111,110,103,0,84,111,111,32,109,97,110,121,32,111,112,101,110,32,102,105,108,101,115,32,105,110,32,115,121,115,116,101,109,0,78,111,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,115,32,97,118,97,105,108,97,98,108,101,0,66,97,100,32,102,105,108,101,32,100,101,115,99,114,105,112,116,111,114,0,78,111,32,99,104,105,108,100,32,112,114,111,99,101,115,115,0,66,97,100,32,97,100,100,114,101,115,115,0,70,105,108,101,32,116,111,111,32,108,97,114,103,101,0,84,111,111,32,109,97,110,121,32,108,105,110,107,115,0,78,111,32,108,111,99,107,115,32,97,118,97,105,108,97,98,108,101,0,82,101,115,111,117,114,99,101,32,100,101,97,100,108,111,99,107,32,119,111,117,108,100,32,111,99,99,117,114,0,83,116,97,116,101,32,110,111,116,32,114,101,99,111,118,101,114,97,98,108,101,0,80,114,101,118,105,111,117,115,32,111,119,110,101,114,32,100,105,101,100,0,79,112,101,114,97,116,105,111,110,32,99,97,110,99,101,108,101,100,0,70,117,110,99,116,105,111,110,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,0,78,111,32,109,101,115,115,97,103,101,32,111,102,32,100,101,115,105,114,101,100,32,116,121,112,101,0,73,100,101,110,116,105,102,105,101,114,32,114,101,109,111,118,101,100,0,68,101,118,105,99,101,32,110,111,116,32,97,32,115,116,114,101,97,109,0,78,111,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,0,68,101,118,105,99,101,32,116,105,109,101,111,117,116,0,79,117,116,32,111,102,32,115,116,114,101,97,109,115,32,114,101,115,111,117,114,99,101,115,0,76,105,110,107,32,104,97,115,32,98,101,101,110,32,115,101,118,101,114,101,100,0,80,114,111,116,111,99,111,108,32,101,114,114,111,114,0,66,97,100,32,109,101,115,115,97,103,101,0,70,105,108,101,32,100,101,115,99,114,105,112,116,111,114,32,105,110,32,98,97,100,32,115,116,97,116,101,0,78,111,116,32,97,32,115,111,99,107,101,116,0,68,101,115,116,105,110,97,116,105,111,110,32,97,100,100,114,101,115,115,32,114,101,113,117,105,114,101,100,0,77,101,115,115,97,103,101,32,116,111,111,32,108,97,114,103,101,0,80,114,111,116,111,99,111,108,32,119,114,111,110,103,32,116,121,112,101,32,102,111,114,32,115,111,99,107,101,116,0,80,114,111,116,111,99,111,108,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,80,114,111,116,111,99,111,108,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,83,111,99,107,101,116,32,116,121,112,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,78,111,116,32,115,117,112,112,111,114,116,101,100,0,80,114,111,116,111,99,111,108,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,65,100,100,114,101,115,115,32,102,97,109,105,108,121,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,98,121,32,112,114,111,116,111,99,111,108,0,65,100,100,114,101,115,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,0,78,101,116,119,111,114,107,32,105,115,32,100,111,119,110,0,78,101,116,119,111,114,107,32,117,110,114,101,97,99,104,97,98,108,101,0,67,111,110,110,101,99,116,105,111,110,32,114,101,115,101,116,32,98,121,32,110,101,116,119,111,114,107,0,67,111,110,110,101,99,116,105,111,110,32,97,98,111,114,116,101,100,0,78,111,32,98,117,102,102,101,114,32,115,112,97,99,101,32,97,118,97,105,108,97,98,108,101,0,83,111,99,107,101,116,32,105,115,32,99,111,110,110,101,99,116,101,100,0,83,111,99,107,101,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,67,97,110,110,111,116,32,115,101,110,100,32,97,102,116,101,114,32,115,111,99,107,101,116,32,115,104,117,116,100,111,119,110,0,79,112,101,114,97,116,105,111,110,32,97,108,114,101,97,100,121,32,105,110,32,112,114,111,103,114,101,115,115,0,79,112,101,114,97,116,105,111,110,32,105,110,32,112,114,111,103,114,101,115,115,0,83,116,97,108,101,32,102,105,108,101,32,104,97,110,100,108,101,0,82,101,109,111,116,101,32,73,47,79,32,101,114,114,111,114,0,81,117,111,116,97,32,101,120,99,101,101,100,101,100,0,78,111,32,109,101,100,105,117,109,32,102,111,117,110,100,0,87,114,111,110,103,32,109,101,100,105,117,109,32,116,121,112,101,0,78,111,32,101,114,114,111,114,32,105,110,102,111,114,109,97,116,105,111,110,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,3,4,5,6,7,8,9,255,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,1,2,4,7,3,6,5,0,105,110,102,105,110,105,116,121,0,110,97,110,0,114,119,97,0,80,79,83,73,88,0,99,108,111,99,107,95,103,101,116,116,105,109,101,40,67,76,79,67,75,95,82,69,65,76,84,73,77,69,41,32,102,97,105,108,101,100,0,99,111,110,100,105,116,105,111,110,95,118,97,114,105,97,98,108,101,58,58,119,97,105,116,58,32,109,117,116,101,120,32,110,111,116,32,108,111,99,107,101,100,0,99,111,110,100,105,116,105,111,110,95,118,97,114,105,97,98,108,101,32,119,97,105,116,32,102,97,105,108,101,100,0,78,83,116,51,95,95,50,56,105,111,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,78,83,116,51,95,95,50,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,78,83,116,51,95,95,50,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,99,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,78,83,116,51,95,95,50,55,99,111,108,108,97,116,101,73,119,69,69,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,37,112,0,67,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,37,112,0,0,0,0,76,0,108,108,0,37,0,0,0,0,0,108,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,37,72,58,37,77,58,37,83,0,37,109,47,37,100,47,37,121,0,37,73,58,37,77,58,37,83,32,37,112,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,65,77,0,80,77,0,74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,77,97,114,99,104,0,65,112,114,105,108,0,77,97,121,0,74,117,110,101,0,74,117,108,121,0,65,117,103,117,115,116,0,83,101,112,116,101,109,98,101,114,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,68,101,99,101,109,98,101,114,0,74,97,110,0,70,101,98,0,77,97,114,0,65,112,114,0,74,117,110,0,74,117,108,0,65,117,103,0,83,101,112,0,79,99,116,0,78,111,118,0,68,101,99,0,83,117,110,100,97,121,0,77,111,110,100,97,121,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,84,104,117,114,115,100,97,121,0,70,114,105,100,97,121,0,83,97,116,117,114,100,97,121,0,83,117,110,0,77,111,110,0,84,117,101,0,87,101,100,0,84,104,117,0,70,114,105,0,83,97,116,0,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,37,72,58,37,77,37,72,58,37,77,58,37,83,37,72,58,37,77,58,37,83,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,78,83,116,51,95,95,50,57,116,105,109,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,95,95,116,105,109,101,95,112,117,116,69,0,78,83,116,51,95,95,50,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,78,83,116,51,95,95,50,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,48,49,50,51,52,53,54,55,56,57,0,37,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,48,49,50,51,52,53,54,55,56,57,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,37,46,48,76,102,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,78,83,116,51,95,95,50,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,78,83,116,51,95,95,50,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,99,69,69,0,78,83,116,51,95,95,50,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,78,83,116,51,95,95,50,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,78,83,116,51,95,95,50,56,109,101,115,115,97,103,101,115,73,119,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,78,83,116,51,95,95,50,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,99,69,69,0,78,83,116,51,95,95,50,49,48,99,116,121,112,101,95,98,97,115,101,69,0,78,83,116,51,95,95,50,53,99,116,121,112,101,73,119,69,69,0,102,97,108,115,101,0,116,114,117,101,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,99,69,69,0,78,83,116,51,95,95,50,56,110,117,109,112,117,110,99,116,73,119,69,69,0,33,34,118,101,99,116,111,114,32,108,101,110,103,116,104,95,101,114,114,111,114,34,0,47,104,111,109,101,47,110,105,107,108,97,115,47,80,97,99,107,97,103,101,115,47,101,109,115,100,107,95,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,105,110,99,111,109,105,110,103,47,115,121,115,116,101,109,47,105,110,99,108,117,100,101,47,108,105,98,99,120,120,47,118,101,99,116,111,114,0,33,34,118,101,99,116,111,114,32,111,117,116,95,111,102,95,114,97,110,103,101,34,0,78,83,116,51,95,95,50,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,109,117,116,101,120,32,108,111,99,107,32,102,97,105,108,101,100,0,101,99,32,61,61,32,48,0,47,104,111,109,101,47,110,105,107,108,97,115,47,80,97,99,107,97,103,101,115,47,101,109,115,100,107,95,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,105,110,99,111,109,105,110,103,47,115,121,115,116,101,109,47,108,105,98,47,108,105,98,99,120,120,47,109,117,116,101,120,46,99,112,112,0,117,110,108,111,99,107,0,33,34,98,97,115,105,99,95,115,116,114,105,110,103,32,108,101,110,103,116,104,95,101,114,114,111,114,34,0,47,104,111,109,101,47,110,105,107,108,97,115,47,80,97,99,107,97,103,101,115,47,101,109,115,100,107,95,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,105,110,99,111,109,105,110,103,47,115,121,115,116,101,109,47,105,110,99,108,117,100,101,47,108,105,98,99,120,120,47,115,116,114,105,110,103,0,95,95,116,104,114,111,119,95,108,101,110,103,116,104,95,101,114,114,111,114,0,33,34,98,97,115,105,99,95,115,116,114,105,110,103,32,111,117,116,95,111,102,95,114,97,110,103,101,34,0,95,95,116,104,114,111,119,95,111,117,116,95,111,102,95,114,97,110,103,101,0,33,34,97,108,108,111,99,97,116,111,114,60,84,62,58,58,97,108,108,111,99,97,116,101,58,58,98,97,100,95,97,108,108,111,99,34,0,47,104,111,109,101,47,110,105,107,108,97,115,47,80,97,99,107,97,103,101,115,47,101,109,115,100,107,95,112,111,114,116,97,98,108,101,47,101,109,115,99,114,105,112,116,101,110,47,105,110,99,111,109,105,110,103,47,115,121,115,116,101,109,47,105,110,99,108,117,100,101,47,108,105,98,99,120,120,47,109,101,109,111,114,121,0,97,108,108,111,99,97,116,101,0,115,116,111,105,0,58,32,110,111,32,99,111,110,118,101,114,115,105,111,110,0,37,115,10,0,58,32,111,117,116,32,111,102,32,114,97,110,103,101,0,37,100,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,83,116,57,116,121,112,101,95,105,110,102,111,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0],"i8",ALLOC_NONE,Runtime.GLOBAL_BASE+20620);var tempDoublePtr=STATICTOP;STATICTOP+=16;function _emscripten_get_now(){abort()}function _emscripten_get_now_is_monotonic(){return ENVIRONMENT_IS_NODE||typeof dateNow!=="undefined"||(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)&&self["performance"]&&self["performance"]["now"]}var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};function ___setErrNo(value){if(Module["___errno_location"])HEAP32[Module["___errno_location"]()>>2]=value;return value}function _clock_gettime(clk_id,tp){var now;if(clk_id===0){now=Date.now()}else if(clk_id===1&&_emscripten_get_now_is_monotonic()){now=_emscripten_get_now()}else{___setErrNo(ERRNO_CODES.EINVAL);return-1}HEAP32[tp>>2]=now/1e3|0;HEAP32[tp+4>>2]=now%1e3*1e3*1e3|0;return 0}Module["_i64Subtract"]=_i64Subtract;function ___assert_fail(condition,filename,line,func){ABORT=true;throw"Assertion failed: "+Pointer_stringify(condition)+", at: "+[filename?Pointer_stringify(filename):"unknown filename",line,func?Pointer_stringify(func):"unknown function"]+" at "+stackTrace()}Module["_memset"]=_memset;Module["_pthread_mutex_lock"]=_pthread_mutex_lock;function _pthread_cond_signal(){return 0}function _abort(){Module["abort"]()}function _pthread_cond_destroy(){return 0}function _pthread_mutex_destroy(){}Module["_i64Add"]=_i64Add;var cttz_i8=allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0],"i8",ALLOC_STATIC);Module["_llvm_cttz_i32"]=_llvm_cttz_i32;Module["___udivmoddi4"]=___udivmoddi4;Module["___divdi3"]=___divdi3;function ___lock(){}function ___unlock(){}var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};var PATH={splitPath:(function(filename){var splitPathRe=/^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;return splitPathRe.exec(filename).slice(1)}),normalizeArray:(function(parts,allowAboveRoot){var up=0;for(var i=parts.length-1;i>=0;i--){var last=parts[i];if(last==="."){parts.splice(i,1)}else if(last===".."){parts.splice(i,1);up++}else if(up){parts.splice(i,1);up--}}if(allowAboveRoot){for(;up--;up){parts.unshift("..")}}return parts}),normalize:(function(path){var isAbsolute=path.charAt(0)==="/",trailingSlash=path.substr(-1)==="/";path=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),!isAbsolute).join("/");if(!path&&!isAbsolute){path="."}if(path&&trailingSlash){path+="/"}return(isAbsolute?"/":"")+path}),dirname:(function(path){var result=PATH.splitPath(path),root=result[0],dir=result[1];if(!root&&!dir){return"."}if(dir){dir=dir.substr(0,dir.length-1)}return root+dir}),basename:(function(path){if(path==="/")return"/";var lastSlash=path.lastIndexOf("/");if(lastSlash===-1)return path;return path.substr(lastSlash+1)}),extname:(function(path){return PATH.splitPath(path)[3]}),join:(function(){var paths=Array.prototype.slice.call(arguments,0);return PATH.normalize(paths.join("/"))}),join2:(function(l,r){return PATH.normalize(l+"/"+r)}),resolve:(function(){var resolvedPath="",resolvedAbsolute=false;for(var i=arguments.length-1;i>=-1&&!resolvedAbsolute;i--){var path=i>=0?arguments[i]:FS.cwd();if(typeof path!=="string"){throw new TypeError("Arguments to path.resolve must be strings")}else if(!path){return""}resolvedPath=path+"/"+resolvedPath;resolvedAbsolute=path.charAt(0)==="/"}resolvedPath=PATH.normalizeArray(resolvedPath.split("/").filter((function(p){return!!p})),!resolvedAbsolute).join("/");return(resolvedAbsolute?"/":"")+resolvedPath||"."}),relative:(function(from,to){from=PATH.resolve(from).substr(1);to=PATH.resolve(to).substr(1);function trim(arr){var start=0;for(;start<arr.length;start++){if(arr[start]!=="")break}var end=arr.length-1;for(;end>=0;end--){if(arr[end]!=="")break}if(start>end)return[];return arr.slice(start,end-start+1)}var fromParts=trim(from.split("/"));var toParts=trim(to.split("/"));var length=Math.min(fromParts.length,toParts.length);var samePartsLength=length;for(var i=0;i<length;i++){if(fromParts[i]!==toParts[i]){samePartsLength=i;break}}var outputParts=[];for(var i=samePartsLength;i<fromParts.length;i++){outputParts.push("..")}outputParts=outputParts.concat(toParts.slice(samePartsLength));return outputParts.join("/")})};var TTY={ttys:[],init:(function(){}),shutdown:(function(){}),register:(function(dev,ops){TTY.ttys[dev]={input:[],output:[],ops:ops};FS.registerDevice(dev,TTY.stream_ops)}),stream_ops:{open:(function(stream){var tty=TTY.ttys[stream.node.rdev];if(!tty){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}stream.tty=tty;stream.seekable=false}),close:(function(stream){stream.tty.ops.flush(stream.tty)}),flush:(function(stream){stream.tty.ops.flush(stream.tty)}),read:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.get_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=stream.tty.ops.get_char(stream.tty)}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){if(!stream.tty||!stream.tty.ops.put_char){throw new FS.ErrnoError(ERRNO_CODES.ENXIO)}for(var i=0;i<length;i++){try{stream.tty.ops.put_char(stream.tty,buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})},default_tty_ops:{get_char:(function(tty){if(!tty.input.length){var result=null;if(ENVIRONMENT_IS_NODE){var BUFSIZE=256;var buf=new Buffer(BUFSIZE);var bytesRead=0;var isPosixPlatform=process.platform!="win32";var fd=process.stdin.fd;if(isPosixPlatform){var usingDevice=false;try{fd=fs.openSync("/dev/stdin","r");usingDevice=true}catch(e){}}try{bytesRead=fs.readSync(fd,buf,0,BUFSIZE,null)}catch(e){if(e.toString().indexOf("EOF")!=-1)bytesRead=0;else throw e}if(usingDevice){fs.closeSync(fd)}if(bytesRead>0){result=buf.slice(0,bytesRead).toString("utf-8")}else{result=null}}else if(typeof window!="undefined"&&typeof window.prompt=="function"){result=window.prompt("Input: ");if(result!==null){result+="\n"}}else if(typeof readline=="function"){result=readline();if(result!==null){result+="\n"}}if(!result){return null}tty.input=intArrayFromString(result,true)}return tty.input.shift()}),put_char:(function(tty,val){if(val===null||val===10){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["print"](UTF8ArrayToString(tty.output,0));tty.output=[]}})},default_tty1_ops:{put_char:(function(tty,val){if(val===null||val===10){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}else{if(val!=0)tty.output.push(val)}}),flush:(function(tty){if(tty.output&&tty.output.length>0){Module["printErr"](UTF8ArrayToString(tty.output,0));tty.output=[]}})}};var MEMFS={ops_table:null,mount:(function(mount){return MEMFS.createNode(null,"/",16384|511,0)}),createNode:(function(parent,name,mode,dev){if(FS.isBlkdev(mode)||FS.isFIFO(mode)){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(!MEMFS.ops_table){MEMFS.ops_table={dir:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,lookup:MEMFS.node_ops.lookup,mknod:MEMFS.node_ops.mknod,rename:MEMFS.node_ops.rename,unlink:MEMFS.node_ops.unlink,rmdir:MEMFS.node_ops.rmdir,readdir:MEMFS.node_ops.readdir,symlink:MEMFS.node_ops.symlink},stream:{llseek:MEMFS.stream_ops.llseek}},file:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:{llseek:MEMFS.stream_ops.llseek,read:MEMFS.stream_ops.read,write:MEMFS.stream_ops.write,allocate:MEMFS.stream_ops.allocate,mmap:MEMFS.stream_ops.mmap,msync:MEMFS.stream_ops.msync}},link:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr,readlink:MEMFS.node_ops.readlink},stream:{}},chrdev:{node:{getattr:MEMFS.node_ops.getattr,setattr:MEMFS.node_ops.setattr},stream:FS.chrdev_stream_ops}}}var node=FS.createNode(parent,name,mode,dev);if(FS.isDir(node.mode)){node.node_ops=MEMFS.ops_table.dir.node;node.stream_ops=MEMFS.ops_table.dir.stream;node.contents={}}else if(FS.isFile(node.mode)){node.node_ops=MEMFS.ops_table.file.node;node.stream_ops=MEMFS.ops_table.file.stream;node.usedBytes=0;node.contents=null}else if(FS.isLink(node.mode)){node.node_ops=MEMFS.ops_table.link.node;node.stream_ops=MEMFS.ops_table.link.stream}else if(FS.isChrdev(node.mode)){node.node_ops=MEMFS.ops_table.chrdev.node;node.stream_ops=MEMFS.ops_table.chrdev.stream}node.timestamp=Date.now();if(parent){parent.contents[name]=node}return node}),getFileDataAsRegularArray:(function(node){if(node.contents&&node.contents.subarray){var arr=[];for(var i=0;i<node.usedBytes;++i)arr.push(node.contents[i]);return arr}return node.contents}),getFileDataAsTypedArray:(function(node){if(!node.contents)return new Uint8Array;if(node.contents.subarray)return node.contents.subarray(0,node.usedBytes);return new Uint8Array(node.contents)}),expandFileStorage:(function(node,newCapacity){if(node.contents&&node.contents.subarray&&newCapacity>node.contents.length){node.contents=MEMFS.getFileDataAsRegularArray(node);node.usedBytes=node.contents.length}if(!node.contents||node.contents.subarray){var prevCapacity=node.contents?node.contents.length:0;if(prevCapacity>=newCapacity)return;var CAPACITY_DOUBLING_MAX=1024*1024;newCapacity=Math.max(newCapacity,prevCapacity*(prevCapacity<CAPACITY_DOUBLING_MAX?2:1.125)|0);if(prevCapacity!=0)newCapacity=Math.max(newCapacity,256);var oldContents=node.contents;node.contents=new Uint8Array(newCapacity);if(node.usedBytes>0)node.contents.set(oldContents.subarray(0,node.usedBytes),0);return}if(!node.contents&&newCapacity>0)node.contents=[];while(node.contents.length<newCapacity)node.contents.push(0)}),resizeFileStorage:(function(node,newSize){if(node.usedBytes==newSize)return;if(newSize==0){node.contents=null;node.usedBytes=0;return}if(!node.contents||node.contents.subarray){var oldContents=node.contents;node.contents=new Uint8Array(new ArrayBuffer(newSize));if(oldContents){node.contents.set(oldContents.subarray(0,Math.min(newSize,node.usedBytes)))}node.usedBytes=newSize;return}if(!node.contents)node.contents=[];if(node.contents.length>newSize)node.contents.length=newSize;else while(node.contents.length<newSize)node.contents.push(0);node.usedBytes=newSize}),node_ops:{getattr:(function(node){var attr={};attr.dev=FS.isChrdev(node.mode)?node.id:1;attr.ino=node.id;attr.mode=node.mode;attr.nlink=1;attr.uid=0;attr.gid=0;attr.rdev=node.rdev;if(FS.isDir(node.mode)){attr.size=4096}else if(FS.isFile(node.mode)){attr.size=node.usedBytes}else if(FS.isLink(node.mode)){attr.size=node.link.length}else{attr.size=0}attr.atime=new Date(node.timestamp);attr.mtime=new Date(node.timestamp);attr.ctime=new Date(node.timestamp);attr.blksize=4096;attr.blocks=Math.ceil(attr.size/attr.blksize);return attr}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}if(attr.size!==undefined){MEMFS.resizeFileStorage(node,attr.size)}}),lookup:(function(parent,name){throw FS.genericErrors[ERRNO_CODES.ENOENT]}),mknod:(function(parent,name,mode,dev){return MEMFS.createNode(parent,name,mode,dev)}),rename:(function(old_node,new_dir,new_name){if(FS.isDir(old_node.mode)){var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(new_node){for(var i in new_node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}}}delete old_node.parent.contents[old_node.name];old_node.name=new_name;new_dir.contents[new_name]=old_node;old_node.parent=new_dir}),unlink:(function(parent,name){delete parent.contents[name]}),rmdir:(function(parent,name){var node=FS.lookupNode(parent,name);for(var i in node.contents){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}delete parent.contents[name]}),readdir:(function(node){var entries=[".",".."];for(var key in node.contents){if(!node.contents.hasOwnProperty(key)){continue}entries.push(key)}return entries}),symlink:(function(parent,newname,oldpath){var node=MEMFS.createNode(parent,newname,511|40960,0);node.link=oldpath;return node}),readlink:(function(node){if(!FS.isLink(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return node.link})},stream_ops:{read:(function(stream,buffer,offset,length,position){var contents=stream.node.contents;if(position>=stream.node.usedBytes)return 0;var size=Math.min(stream.node.usedBytes-position,length);assert(size>=0);if(size>8&&contents.subarray){buffer.set(contents.subarray(position,position+size),offset)}else{for(var i=0;i<size;i++)buffer[offset+i]=contents[position+i]}return size}),write:(function(stream,buffer,offset,length,position,canOwn){if(!length)return 0;var node=stream.node;node.timestamp=Date.now();if(buffer.subarray&&(!node.contents||node.contents.subarray)){if(canOwn){node.contents=buffer.subarray(offset,offset+length);node.usedBytes=length;return length}else if(node.usedBytes===0&&position===0){node.contents=new Uint8Array(buffer.subarray(offset,offset+length));node.usedBytes=length;return length}else if(position+length<=node.usedBytes){node.contents.set(buffer.subarray(offset,offset+length),position);return length}}MEMFS.expandFileStorage(node,position+length);if(node.contents.subarray&&buffer.subarray)node.contents.set(buffer.subarray(offset,offset+length),position);else{for(var i=0;i<length;i++){node.contents[position+i]=buffer[offset+i]}}node.usedBytes=Math.max(node.usedBytes,position+length);return length}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.usedBytes}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position}),allocate:(function(stream,offset,length){MEMFS.expandFileStorage(stream.node,offset+length);stream.node.usedBytes=Math.max(stream.node.usedBytes,offset+length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}var ptr;var allocated;var contents=stream.node.contents;if(!(flags&2)&&(contents.buffer===buffer||contents.buffer===buffer.buffer)){allocated=false;ptr=contents.byteOffset}else{if(position>0||position+length<stream.node.usedBytes){if(contents.subarray){contents=contents.subarray(position,position+length)}else{contents=Array.prototype.slice.call(contents,position,position+length)}}allocated=true;ptr=_malloc(length);if(!ptr){throw new FS.ErrnoError(ERRNO_CODES.ENOMEM)}buffer.set(contents,ptr)}return{ptr:ptr,allocated:allocated}}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!FS.isFile(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(mmapFlags&2){return 0}var bytesWritten=MEMFS.stream_ops.write(stream,buffer,0,length,offset,false);return 0})}};var IDBFS={dbs:{},indexedDB:(function(){if(typeof indexedDB!=="undefined")return indexedDB;var ret=null;if(typeof window==="object")ret=window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB;assert(ret,"IDBFS used, but indexedDB not supported");return ret}),DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:(function(mount){return MEMFS.mount.apply(null,arguments)}),syncfs:(function(mount,populate,callback){IDBFS.getLocalSet(mount,(function(err,local){if(err)return callback(err);IDBFS.getRemoteSet(mount,(function(err,remote){if(err)return callback(err);var src=populate?remote:local;var dst=populate?local:remote;IDBFS.reconcile(src,dst,callback)}))}))}),getDB:(function(name,callback){var db=IDBFS.dbs[name];if(db){return callback(null,db)}var req;try{req=IDBFS.indexedDB().open(name,IDBFS.DB_VERSION)}catch(e){return callback(e)}if(!req){return callback("Unable to connect to IndexedDB")}req.onupgradeneeded=(function(e){var db=e.target.result;var transaction=e.target.transaction;var fileStore;if(db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)){fileStore=transaction.objectStore(IDBFS.DB_STORE_NAME)}else{fileStore=db.createObjectStore(IDBFS.DB_STORE_NAME)}if(!fileStore.indexNames.contains("timestamp")){fileStore.createIndex("timestamp","timestamp",{unique:false})}});req.onsuccess=(function(){db=req.result;IDBFS.dbs[name]=db;callback(null,db)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),getLocalSet:(function(mount,callback){var entries={};function isRealDir(p){return p!=="."&&p!==".."}function toAbsolute(root){return(function(p){return PATH.join2(root,p)})}var check=FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));while(check.length){var path=check.pop();var stat;try{stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){check.push.apply(check,FS.readdir(path).filter(isRealDir).map(toAbsolute(path)))}entries[path]={timestamp:stat.mtime}}return callback(null,{type:"local",entries:entries})}),getRemoteSet:(function(mount,callback){var entries={};IDBFS.getDB(mount.mountpoint,(function(err,db){if(err)return callback(err);var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readonly");transaction.onerror=(function(e){callback(this.error);e.preventDefault()});var store=transaction.objectStore(IDBFS.DB_STORE_NAME);var index=store.index("timestamp");index.openKeyCursor().onsuccess=(function(event){var cursor=event.target.result;if(!cursor){return callback(null,{type:"remote",db:db,entries:entries})}entries[cursor.primaryKey]={timestamp:cursor.key};cursor.continue()})}))}),loadLocalEntry:(function(path,callback){var stat,node;try{var lookup=FS.lookupPath(path);node=lookup.node;stat=FS.stat(path)}catch(e){return callback(e)}if(FS.isDir(stat.mode)){return callback(null,{timestamp:stat.mtime,mode:stat.mode})}else if(FS.isFile(stat.mode)){node.contents=MEMFS.getFileDataAsTypedArray(node);return callback(null,{timestamp:stat.mtime,mode:stat.mode,contents:node.contents})}else{return callback(new Error("node type not supported"))}}),storeLocalEntry:(function(path,entry,callback){try{if(FS.isDir(entry.mode)){FS.mkdir(path,entry.mode)}else if(FS.isFile(entry.mode)){FS.writeFile(path,entry.contents,{encoding:"binary",canOwn:true})}else{return callback(new Error("node type not supported"))}FS.chmod(path,entry.mode);FS.utime(path,entry.timestamp,entry.timestamp)}catch(e){return callback(e)}callback(null)}),removeLocalEntry:(function(path,callback){try{var lookup=FS.lookupPath(path);var stat=FS.stat(path);if(FS.isDir(stat.mode)){FS.rmdir(path)}else if(FS.isFile(stat.mode)){FS.unlink(path)}}catch(e){return callback(e)}callback(null)}),loadRemoteEntry:(function(store,path,callback){var req=store.get(path);req.onsuccess=(function(event){callback(null,event.target.result)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),storeRemoteEntry:(function(store,path,entry,callback){var req=store.put(entry,path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),removeRemoteEntry:(function(store,path,callback){var req=store.delete(path);req.onsuccess=(function(){callback(null)});req.onerror=(function(e){callback(this.error);e.preventDefault()})}),reconcile:(function(src,dst,callback){var total=0;var create=[];Object.keys(src.entries).forEach((function(key){var e=src.entries[key];var e2=dst.entries[key];if(!e2||e.timestamp>e2.timestamp){create.push(key);total++}}));var remove=[];Object.keys(dst.entries).forEach((function(key){var e=dst.entries[key];var e2=src.entries[key];if(!e2){remove.push(key);total++}}));if(!total){return callback(null)}var completed=0;var db=src.type==="remote"?src.db:dst.db;var transaction=db.transaction([IDBFS.DB_STORE_NAME],"readwrite");var store=transaction.objectStore(IDBFS.DB_STORE_NAME);function done(err){if(err){if(!done.errored){done.errored=true;return callback(err)}return}if(++completed>=total){return callback(null)}}transaction.onerror=(function(e){done(this.error);e.preventDefault()});create.sort().forEach((function(path){if(dst.type==="local"){IDBFS.loadRemoteEntry(store,path,(function(err,entry){if(err)return done(err);IDBFS.storeLocalEntry(path,entry,done)}))}else{IDBFS.loadLocalEntry(path,(function(err,entry){if(err)return done(err);IDBFS.storeRemoteEntry(store,path,entry,done)}))}}));remove.sort().reverse().forEach((function(path){if(dst.type==="local"){IDBFS.removeLocalEntry(path,done)}else{IDBFS.removeRemoteEntry(store,path,done)}}))})};var NODEFS={isWindows:false,staticInit:(function(){NODEFS.isWindows=!!process.platform.match(/^win/)}),mount:(function(mount){assert(ENVIRONMENT_IS_NODE);return NODEFS.createNode(null,"/",NODEFS.getMode(mount.opts.root),0)}),createNode:(function(parent,name,mode,dev){if(!FS.isDir(mode)&&!FS.isFile(mode)&&!FS.isLink(mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=FS.createNode(parent,name,mode);node.node_ops=NODEFS.node_ops;node.stream_ops=NODEFS.stream_ops;return node}),getMode:(function(path){var stat;try{stat=fs.lstatSync(path);if(NODEFS.isWindows){stat.mode=stat.mode|(stat.mode&146)>>1}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return stat.mode}),realPath:(function(node){var parts=[];while(node.parent!==node){parts.push(node.name);node=node.parent}parts.push(node.mount.opts.root);parts.reverse();return PATH.join.apply(null,parts)}),flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:(function(flags){flags&=~2097152;flags&=~2048;flags&=~32768;flags&=~524288;if(flags in NODEFS.flagsToPermissionStringMap){return NODEFS.flagsToPermissionStringMap[flags]}else{throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}}),node_ops:{getattr:(function(node){var path=NODEFS.realPath(node);var stat;try{stat=fs.lstatSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(NODEFS.isWindows&&!stat.blksize){stat.blksize=4096}if(NODEFS.isWindows&&!stat.blocks){stat.blocks=(stat.size+stat.blksize-1)/stat.blksize|0}return{dev:stat.dev,ino:stat.ino,mode:stat.mode,nlink:stat.nlink,uid:stat.uid,gid:stat.gid,rdev:stat.rdev,size:stat.size,atime:stat.atime,mtime:stat.mtime,ctime:stat.ctime,blksize:stat.blksize,blocks:stat.blocks}}),setattr:(function(node,attr){var path=NODEFS.realPath(node);try{if(attr.mode!==undefined){fs.chmodSync(path,attr.mode);node.mode=attr.mode}if(attr.timestamp!==undefined){var date=new Date(attr.timestamp);fs.utimesSync(path,date,date)}if(attr.size!==undefined){fs.truncateSync(path,attr.size)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),lookup:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);var mode=NODEFS.getMode(path);return NODEFS.createNode(parent,name,mode)}),mknod:(function(parent,name,mode,dev){var node=NODEFS.createNode(parent,name,mode,dev);var path=NODEFS.realPath(node);try{if(FS.isDir(node.mode)){fs.mkdirSync(path,node.mode)}else{fs.writeFileSync(path,"",{mode:node.mode})}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}return node}),rename:(function(oldNode,newDir,newName){var oldPath=NODEFS.realPath(oldNode);var newPath=PATH.join2(NODEFS.realPath(newDir),newName);try{fs.renameSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),unlink:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.unlinkSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),rmdir:(function(parent,name){var path=PATH.join2(NODEFS.realPath(parent),name);try{fs.rmdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readdir:(function(node){var path=NODEFS.realPath(node);try{return fs.readdirSync(path)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),symlink:(function(parent,newName,oldPath){var newPath=PATH.join2(NODEFS.realPath(parent),newName);try{fs.symlinkSync(oldPath,newPath)}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),readlink:(function(node){var path=NODEFS.realPath(node);try{path=fs.readlinkSync(path);path=NODEJS_PATH.relative(NODEJS_PATH.resolve(node.mount.opts.root),path);return path}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}})},stream_ops:{open:(function(stream){var path=NODEFS.realPath(stream.node);try{if(FS.isFile(stream.node.mode)){stream.nfd=fs.openSync(path,NODEFS.flagsToPermissionString(stream.flags))}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),close:(function(stream){try{if(FS.isFile(stream.node.mode)&&stream.nfd){fs.closeSync(stream.nfd)}}catch(e){if(!e.code)throw e;throw new FS.ErrnoError(ERRNO_CODES[e.code])}}),read:(function(stream,buffer,offset,length,position){if(length===0)return 0;var nbuffer=new Buffer(length);var res;try{res=fs.readSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}if(res>0){for(var i=0;i<res;i++){buffer[offset+i]=nbuffer[i]}}return res}),write:(function(stream,buffer,offset,length,position){var nbuffer=new Buffer(buffer.subarray(offset,offset+length));var res;try{res=fs.writeSync(stream.nfd,nbuffer,0,length,position)}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}return res}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){try{var stat=fs.fstatSync(stream.nfd);position+=stat.size}catch(e){throw new FS.ErrnoError(ERRNO_CODES[e.code])}}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};var WORKERFS={DIR_MODE:16895,FILE_MODE:33279,reader:null,mount:(function(mount){assert(ENVIRONMENT_IS_WORKER);if(!WORKERFS.reader)WORKERFS.reader=new FileReaderSync;var root=WORKERFS.createNode(null,"/",WORKERFS.DIR_MODE,0);var createdParents={};function ensureParent(path){var parts=path.split("/");var parent=root;for(var i=0;i<parts.length-1;i++){var curr=parts.slice(0,i+1).join("/");if(!createdParents[curr]){createdParents[curr]=WORKERFS.createNode(parent,parts[i],WORKERFS.DIR_MODE,0)}parent=createdParents[curr]}return parent}function base(path){var parts=path.split("/");return parts[parts.length-1]}Array.prototype.forEach.call(mount.opts["files"]||[],(function(file){WORKERFS.createNode(ensureParent(file.name),base(file.name),WORKERFS.FILE_MODE,0,file,file.lastModifiedDate)}));(mount.opts["blobs"]||[]).forEach((function(obj){WORKERFS.createNode(ensureParent(obj["name"]),base(obj["name"]),WORKERFS.FILE_MODE,0,obj["data"])}));(mount.opts["packages"]||[]).forEach((function(pack){pack["metadata"].files.forEach((function(file){var name=file.filename.substr(1);WORKERFS.createNode(ensureParent(name),base(name),WORKERFS.FILE_MODE,0,pack["blob"].slice(file.start,file.end))}))}));return root}),createNode:(function(parent,name,mode,dev,contents,mtime){var node=FS.createNode(parent,name,mode);node.mode=mode;node.node_ops=WORKERFS.node_ops;node.stream_ops=WORKERFS.stream_ops;node.timestamp=(mtime||new Date).getTime();assert(WORKERFS.FILE_MODE!==WORKERFS.DIR_MODE);if(mode===WORKERFS.FILE_MODE){node.size=contents.size;node.contents=contents}else{node.size=4096;node.contents={}}if(parent){parent.contents[name]=node}return node}),node_ops:{getattr:(function(node){return{dev:1,ino:undefined,mode:node.mode,nlink:1,uid:0,gid:0,rdev:undefined,size:node.size,atime:new Date(node.timestamp),mtime:new Date(node.timestamp),ctime:new Date(node.timestamp),blksize:4096,blocks:Math.ceil(node.size/4096)}}),setattr:(function(node,attr){if(attr.mode!==undefined){node.mode=attr.mode}if(attr.timestamp!==undefined){node.timestamp=attr.timestamp}}),lookup:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}),mknod:(function(parent,name,mode,dev){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rename:(function(oldNode,newDir,newName){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),unlink:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),rmdir:(function(parent,name){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readdir:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),symlink:(function(parent,newName,oldPath){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}),readlink:(function(node){throw new FS.ErrnoError(ERRNO_CODES.EPERM)})},stream_ops:{read:(function(stream,buffer,offset,length,position){if(position>=stream.node.size)return 0;var chunk=stream.node.contents.slice(position,position+length);var ab=WORKERFS.reader.readAsArrayBuffer(chunk);buffer.set(new Uint8Array(ab),offset);return chunk.size}),write:(function(stream,buffer,offset,length,position){throw new FS.ErrnoError(ERRNO_CODES.EIO)}),llseek:(function(stream,offset,whence){var position=offset;if(whence===1){position+=stream.position}else if(whence===2){if(FS.isFile(stream.node.mode)){position+=stream.node.size}}if(position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return position})}};STATICTOP+=16;STATICTOP+=16;STATICTOP+=16;var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,trackingDelegate:{},tracking:{openFlags:{READ:1,WRITE:2}},ErrnoError:null,genericErrors:{},filesystems:null,syncFSRequests:0,handleFSError:(function(e){if(!(e instanceof FS.ErrnoError))throw e+" : "+stackTrace();return ___setErrNo(e.errno)}),lookupPath:(function(path,opts){path=PATH.resolve(FS.cwd(),path);opts=opts||{};if(!path)return{path:"",node:null};var defaults={follow_mount:true,recurse_count:0};for(var key in defaults){if(opts[key]===undefined){opts[key]=defaults[key]}}if(opts.recurse_count>8){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}var parts=PATH.normalizeArray(path.split("/").filter((function(p){return!!p})),false);var current=FS.root;var current_path="/";for(var i=0;i<parts.length;i++){var islast=i===parts.length-1;if(islast&&opts.parent){break}current=FS.lookupNode(current,parts[i]);current_path=PATH.join2(current_path,parts[i]);if(FS.isMountpoint(current)){if(!islast||islast&&opts.follow_mount){current=current.mounted.root}}if(!islast||opts.follow){var count=0;while(FS.isLink(current.mode)){var link=FS.readlink(current_path);current_path=PATH.resolve(PATH.dirname(current_path),link);var lookup=FS.lookupPath(current_path,{recurse_count:opts.recurse_count});current=lookup.node;if(count++>40){throw new FS.ErrnoError(ERRNO_CODES.ELOOP)}}}}return{path:current_path,node:current}}),getPath:(function(node){var path;while(true){if(FS.isRoot(node)){var mount=node.mount.mountpoint;if(!path)return mount;return mount[mount.length-1]!=="/"?mount+"/"+path:mount+path}path=path?node.name+"/"+path:node.name;node=node.parent}}),hashName:(function(parentid,name){var hash=0;for(var i=0;i<name.length;i++){hash=(hash<<5)-hash+name.charCodeAt(i)|0}return(parentid+hash>>>0)%FS.nameTable.length}),hashAddNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);node.name_next=FS.nameTable[hash];FS.nameTable[hash]=node}),hashRemoveNode:(function(node){var hash=FS.hashName(node.parent.id,node.name);if(FS.nameTable[hash]===node){FS.nameTable[hash]=node.name_next}else{var current=FS.nameTable[hash];while(current){if(current.name_next===node){current.name_next=node.name_next;break}current=current.name_next}}}),lookupNode:(function(parent,name){var err=FS.mayLookup(parent);if(err){throw new FS.ErrnoError(err,parent)}var hash=FS.hashName(parent.id,name);for(var node=FS.nameTable[hash];node;node=node.name_next){var nodeName=node.name;if(node.parent.id===parent.id&&nodeName===name){return node}}return FS.lookup(parent,name)}),createNode:(function(parent,name,mode,rdev){if(!FS.FSNode){FS.FSNode=(function(parent,name,mode,rdev){if(!parent){parent=this}this.parent=parent;this.mount=parent.mount;this.mounted=null;this.id=FS.nextInode++;this.name=name;this.mode=mode;this.node_ops={};this.stream_ops={};this.rdev=rdev});FS.FSNode.prototype={};var readMode=292|73;var writeMode=146;Object.defineProperties(FS.FSNode.prototype,{read:{get:(function(){return(this.mode&readMode)===readMode}),set:(function(val){val?this.mode|=readMode:this.mode&=~readMode})},write:{get:(function(){return(this.mode&writeMode)===writeMode}),set:(function(val){val?this.mode|=writeMode:this.mode&=~writeMode})},isFolder:{get:(function(){return FS.isDir(this.mode)})},isDevice:{get:(function(){return FS.isChrdev(this.mode)})}})}var node=new FS.FSNode(parent,name,mode,rdev);FS.hashAddNode(node);return node}),destroyNode:(function(node){FS.hashRemoveNode(node)}),isRoot:(function(node){return node===node.parent}),isMountpoint:(function(node){return!!node.mounted}),isFile:(function(mode){return(mode&61440)===32768}),isDir:(function(mode){return(mode&61440)===16384}),isLink:(function(mode){return(mode&61440)===40960}),isChrdev:(function(mode){return(mode&61440)===8192}),isBlkdev:(function(mode){return(mode&61440)===24576}),isFIFO:(function(mode){return(mode&61440)===4096}),isSocket:(function(mode){return(mode&49152)===49152}),flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:(function(str){var flags=FS.flagModes[str];if(typeof flags==="undefined"){throw new Error("Unknown file open mode: "+str)}return flags}),flagsToPermissionString:(function(flag){var perms=["r","w","rw"][flag&3];if(flag&512){perms+="w"}return perms}),nodePermissions:(function(node,perms){if(FS.ignorePermissions){return 0}if(perms.indexOf("r")!==-1&&!(node.mode&292)){return ERRNO_CODES.EACCES}else if(perms.indexOf("w")!==-1&&!(node.mode&146)){return ERRNO_CODES.EACCES}else if(perms.indexOf("x")!==-1&&!(node.mode&73)){return ERRNO_CODES.EACCES}return 0}),mayLookup:(function(dir){var err=FS.nodePermissions(dir,"x");if(err)return err;if(!dir.node_ops.lookup)return ERRNO_CODES.EACCES;return 0}),mayCreate:(function(dir,name){try{var node=FS.lookupNode(dir,name);return ERRNO_CODES.EEXIST}catch(e){}return FS.nodePermissions(dir,"wx")}),mayDelete:(function(dir,name,isdir){var node;try{node=FS.lookupNode(dir,name)}catch(e){return e.errno}var err=FS.nodePermissions(dir,"wx");if(err){return err}if(isdir){if(!FS.isDir(node.mode)){return ERRNO_CODES.ENOTDIR}if(FS.isRoot(node)||FS.getPath(node)===FS.cwd()){return ERRNO_CODES.EBUSY}}else{if(FS.isDir(node.mode)){return ERRNO_CODES.EISDIR}}return 0}),mayOpen:(function(node,flags){if(!node){return ERRNO_CODES.ENOENT}if(FS.isLink(node.mode)){return ERRNO_CODES.ELOOP}else if(FS.isDir(node.mode)){if(FS.flagsToPermissionString(flags)!=="r"||flags&512){return ERRNO_CODES.EISDIR}}return FS.nodePermissions(node,FS.flagsToPermissionString(flags))}),MAX_OPEN_FDS:4096,nextfd:(function(fd_start,fd_end){fd_start=fd_start||0;fd_end=fd_end||FS.MAX_OPEN_FDS;for(var fd=fd_start;fd<=fd_end;fd++){if(!FS.streams[fd]){return fd}}throw new FS.ErrnoError(ERRNO_CODES.EMFILE)}),getStream:(function(fd){return FS.streams[fd]}),createStream:(function(stream,fd_start,fd_end){if(!FS.FSStream){FS.FSStream=(function(){});FS.FSStream.prototype={};Object.defineProperties(FS.FSStream.prototype,{object:{get:(function(){return this.node}),set:(function(val){this.node=val})},isRead:{get:(function(){return(this.flags&2097155)!==1})},isWrite:{get:(function(){return(this.flags&2097155)!==0})},isAppend:{get:(function(){return this.flags&1024})}})}var newStream=new FS.FSStream;for(var p in stream){newStream[p]=stream[p]}stream=newStream;var fd=FS.nextfd(fd_start,fd_end);stream.fd=fd;FS.streams[fd]=stream;return stream}),closeStream:(function(fd){FS.streams[fd]=null}),chrdev_stream_ops:{open:(function(stream){var device=FS.getDevice(stream.node.rdev);stream.stream_ops=device.stream_ops;if(stream.stream_ops.open){stream.stream_ops.open(stream)}}),llseek:(function(){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)})},major:(function(dev){return dev>>8}),minor:(function(dev){return dev&255}),makedev:(function(ma,mi){return ma<<8|mi}),registerDevice:(function(dev,ops){FS.devices[dev]={stream_ops:ops}}),getDevice:(function(dev){return FS.devices[dev]}),getMounts:(function(mount){var mounts=[];var check=[mount];while(check.length){var m=check.pop();mounts.push(m);check.push.apply(check,m.mounts)}return mounts}),syncfs:(function(populate,callback){if(typeof populate==="function"){callback=populate;populate=false}FS.syncFSRequests++;if(FS.syncFSRequests>1){console.log("warning: "+FS.syncFSRequests+" FS.syncfs operations in flight at once, probably just doing extra work")}var mounts=FS.getMounts(FS.root.mount);var completed=0;function doCallback(err){assert(FS.syncFSRequests>0);FS.syncFSRequests--;return callback(err)}function done(err){if(err){if(!done.errored){done.errored=true;return doCallback(err)}return}if(++completed>=mounts.length){doCallback(null)}}mounts.forEach((function(mount){if(!mount.type.syncfs){return done(null)}mount.type.syncfs(mount,populate,done)}))}),mount:(function(type,opts,mountpoint){var root=mountpoint==="/";var pseudo=!mountpoint;var node;if(root&&FS.root){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}else if(!root&&!pseudo){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});mountpoint=lookup.path;node=lookup.node;if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}}var mount={type:type,opts:opts,mountpoint:mountpoint,mounts:[]};var mountRoot=type.mount(mount);mountRoot.mount=mount;mount.root=mountRoot;if(root){FS.root=mountRoot}else if(node){node.mounted=mount;if(node.mount){node.mount.mounts.push(mount)}}return mountRoot}),unmount:(function(mountpoint){var lookup=FS.lookupPath(mountpoint,{follow_mount:false});if(!FS.isMountpoint(lookup.node)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node=lookup.node;var mount=node.mounted;var mounts=FS.getMounts(mount);Object.keys(FS.nameTable).forEach((function(hash){var current=FS.nameTable[hash];while(current){var next=current.name_next;if(mounts.indexOf(current.mount)!==-1){FS.destroyNode(current)}current=next}}));node.mounted=null;var idx=node.mount.mounts.indexOf(mount);assert(idx!==-1);node.mount.mounts.splice(idx,1)}),lookup:(function(parent,name){return parent.node_ops.lookup(parent,name)}),mknod:(function(path,mode,dev){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);if(!name||name==="."||name===".."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.mayCreate(parent,name);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.mknod){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.mknod(parent,name,mode,dev)}),create:(function(path,mode){mode=mode!==undefined?mode:438;mode&=4095;mode|=32768;return FS.mknod(path,mode,0)}),mkdir:(function(path,mode){mode=mode!==undefined?mode:511;mode&=511|512;mode|=16384;return FS.mknod(path,mode,0)}),mkdirTree:(function(path,mode){var dirs=path.split("/");var d="";for(var i=0;i<dirs.length;++i){if(!dirs[i])continue;d+="/"+dirs[i];try{FS.mkdir(d,mode)}catch(e){if(e.errno!=ERRNO_CODES.EEXIST)throw e}}}),mkdev:(function(path,mode,dev){if(typeof dev==="undefined"){dev=mode;mode=438}mode|=8192;return FS.mknod(path,mode,dev)}),symlink:(function(oldpath,newpath){if(!PATH.resolve(oldpath)){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var lookup=FS.lookupPath(newpath,{parent:true});var parent=lookup.node;if(!parent){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}var newname=PATH.basename(newpath);var err=FS.mayCreate(parent,newname);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.symlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return parent.node_ops.symlink(parent,newname,oldpath)}),rename:(function(old_path,new_path){var old_dirname=PATH.dirname(old_path);var new_dirname=PATH.dirname(new_path);var old_name=PATH.basename(old_path);var new_name=PATH.basename(new_path);var lookup,old_dir,new_dir;try{lookup=FS.lookupPath(old_path,{parent:true});old_dir=lookup.node;lookup=FS.lookupPath(new_path,{parent:true});new_dir=lookup.node}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(!old_dir||!new_dir)throw new FS.ErrnoError(ERRNO_CODES.ENOENT);if(old_dir.mount!==new_dir.mount){throw new FS.ErrnoError(ERRNO_CODES.EXDEV)}var old_node=FS.lookupNode(old_dir,old_name);var relative=PATH.relative(old_path,new_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}relative=PATH.relative(new_path,old_dirname);if(relative.charAt(0)!=="."){throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY)}var new_node;try{new_node=FS.lookupNode(new_dir,new_name)}catch(e){}if(old_node===new_node){return}var isdir=FS.isDir(old_node.mode);var err=FS.mayDelete(old_dir,old_name,isdir);if(err){throw new FS.ErrnoError(err)}err=new_node?FS.mayDelete(new_dir,new_name,isdir):FS.mayCreate(new_dir,new_name);if(err){throw new FS.ErrnoError(err)}if(!old_dir.node_ops.rename){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(old_node)||new_node&&FS.isMountpoint(new_node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}if(new_dir!==old_dir){err=FS.nodePermissions(old_dir,"w");if(err){throw new FS.ErrnoError(err)}}try{if(FS.trackingDelegate["willMovePath"]){FS.trackingDelegate["willMovePath"](old_path,new_path)}}catch(e){console.log("FS.trackingDelegate['willMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}FS.hashRemoveNode(old_node);try{old_dir.node_ops.rename(old_node,new_dir,new_name)}catch(e){throw e}finally{FS.hashAddNode(old_node)}try{if(FS.trackingDelegate["onMovePath"])FS.trackingDelegate["onMovePath"](old_path,new_path)}catch(e){console.log("FS.trackingDelegate['onMovePath']('"+old_path+"', '"+new_path+"') threw an exception: "+e.message)}}),rmdir:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,true);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.rmdir){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.rmdir(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;if(!node.node_ops.readdir){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}return node.node_ops.readdir(node)}),unlink:(function(path){var lookup=FS.lookupPath(path,{parent:true});var parent=lookup.node;var name=PATH.basename(path);var node=FS.lookupNode(parent,name);var err=FS.mayDelete(parent,name,false);if(err){throw new FS.ErrnoError(err)}if(!parent.node_ops.unlink){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isMountpoint(node)){throw new FS.ErrnoError(ERRNO_CODES.EBUSY)}try{if(FS.trackingDelegate["willDeletePath"]){FS.trackingDelegate["willDeletePath"](path)}}catch(e){console.log("FS.trackingDelegate['willDeletePath']('"+path+"') threw an exception: "+e.message)}parent.node_ops.unlink(parent,name);FS.destroyNode(node);try{if(FS.trackingDelegate["onDeletePath"])FS.trackingDelegate["onDeletePath"](path)}catch(e){console.log("FS.trackingDelegate['onDeletePath']('"+path+"') threw an exception: "+e.message)}}),readlink:(function(path){var lookup=FS.lookupPath(path);var link=lookup.node;if(!link){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!link.node_ops.readlink){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}return PATH.resolve(FS.getPath(link.parent),link.node_ops.readlink(link))}),stat:(function(path,dontFollow){var lookup=FS.lookupPath(path,{follow:!dontFollow});var node=lookup.node;if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!node.node_ops.getattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}return node.node_ops.getattr(node)}),lstat:(function(path){return FS.stat(path,true)}),chmod:(function(path,mode,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{mode:mode&4095|node.mode&~4095,timestamp:Date.now()})}),lchmod:(function(path,mode){FS.chmod(path,mode,true)}),fchmod:(function(fd,mode){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chmod(stream.node,mode)}),chown:(function(path,uid,gid,dontFollow){var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:!dontFollow});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}node.node_ops.setattr(node,{timestamp:Date.now()})}),lchown:(function(path,uid,gid){FS.chown(path,uid,gid,true)}),fchown:(function(fd,uid,gid){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}FS.chown(stream.node,uid,gid)}),truncate:(function(path,len){if(len<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var node;if(typeof path==="string"){var lookup=FS.lookupPath(path,{follow:true});node=lookup.node}else{node=path}if(!node.node_ops.setattr){throw new FS.ErrnoError(ERRNO_CODES.EPERM)}if(FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!FS.isFile(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var err=FS.nodePermissions(node,"w");if(err){throw new FS.ErrnoError(err)}node.node_ops.setattr(node,{size:len,timestamp:Date.now()})}),ftruncate:(function(fd,len){var stream=FS.getStream(fd);if(!stream){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}FS.truncate(stream.node,len)}),utime:(function(path,atime,mtime){var lookup=FS.lookupPath(path,{follow:true});var node=lookup.node;node.node_ops.setattr(node,{timestamp:Math.max(atime,mtime)})}),open:(function(path,flags,mode,fd_start,fd_end){if(path===""){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}flags=typeof flags==="string"?FS.modeStringToFlags(flags):flags;mode=typeof mode==="undefined"?438:mode;if(flags&64){mode=mode&4095|32768}else{mode=0}var node;if(typeof path==="object"){node=path}else{path=PATH.normalize(path);try{var lookup=FS.lookupPath(path,{follow:!(flags&131072)});node=lookup.node}catch(e){}}var created=false;if(flags&64){if(node){if(flags&128){throw new FS.ErrnoError(ERRNO_CODES.EEXIST)}}else{node=FS.mknod(path,mode,0);created=true}}if(!node){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(FS.isChrdev(node.mode)){flags&=~512}if(flags&65536&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}if(!created){var err=FS.mayOpen(node,flags);if(err){throw new FS.ErrnoError(err)}}if(flags&512){FS.truncate(node,0)}flags&=~(128|512);var stream=FS.createStream({node:node,path:FS.getPath(node),flags:flags,seekable:true,position:0,stream_ops:node.stream_ops,ungotten:[],error:false},fd_start,fd_end);if(stream.stream_ops.open){stream.stream_ops.open(stream)}if(Module["logReadFiles"]&&!(flags&1)){if(!FS.readFiles)FS.readFiles={};if(!(path in FS.readFiles)){FS.readFiles[path]=1;Module["printErr"]("read file: "+path)}}try{if(FS.trackingDelegate["onOpenFile"]){var trackingFlags=0;if((flags&2097155)!==1){trackingFlags|=FS.tracking.openFlags.READ}if((flags&2097155)!==0){trackingFlags|=FS.tracking.openFlags.WRITE}FS.trackingDelegate["onOpenFile"](path,trackingFlags)}}catch(e){console.log("FS.trackingDelegate['onOpenFile']('"+path+"', flags) threw an exception: "+e.message)}return stream}),close:(function(stream){if(stream.getdents)stream.getdents=null;try{if(stream.stream_ops.close){stream.stream_ops.close(stream)}}catch(e){throw e}finally{FS.closeStream(stream.fd)}}),llseek:(function(stream,offset,whence){if(!stream.seekable||!stream.stream_ops.llseek){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}stream.position=stream.stream_ops.llseek(stream,offset,whence);stream.ungotten=[];return stream.position}),read:(function(stream,buffer,offset,length,position){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.read){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesRead=stream.stream_ops.read(stream,buffer,offset,length,position);if(!seeking)stream.position+=bytesRead;return bytesRead}),write:(function(stream,buffer,offset,length,position,canOwn){if(length<0||position<0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(FS.isDir(stream.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.EISDIR)}if(!stream.stream_ops.write){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if(stream.flags&1024){FS.llseek(stream,0,2)}var seeking=true;if(typeof position==="undefined"){position=stream.position;seeking=false}else if(!stream.seekable){throw new FS.ErrnoError(ERRNO_CODES.ESPIPE)}var bytesWritten=stream.stream_ops.write(stream,buffer,offset,length,position,canOwn);if(!seeking)stream.position+=bytesWritten;try{if(stream.path&&FS.trackingDelegate["onWriteToFile"])FS.trackingDelegate["onWriteToFile"](stream.path)}catch(e){console.log("FS.trackingDelegate['onWriteToFile']('"+path+"') threw an exception: "+e.message)}return bytesWritten}),allocate:(function(stream,offset,length){if(offset<0||length<=0){throw new FS.ErrnoError(ERRNO_CODES.EINVAL)}if((stream.flags&2097155)===0){throw new FS.ErrnoError(ERRNO_CODES.EBADF)}if(!FS.isFile(stream.node.mode)&&!FS.isDir(node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}if(!stream.stream_ops.allocate){throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP)}stream.stream_ops.allocate(stream,offset,length)}),mmap:(function(stream,buffer,offset,length,position,prot,flags){if((stream.flags&2097155)===1){throw new FS.ErrnoError(ERRNO_CODES.EACCES)}if(!stream.stream_ops.mmap){throw new FS.ErrnoError(ERRNO_CODES.ENODEV)}return stream.stream_ops.mmap(stream,buffer,offset,length,position,prot,flags)}),msync:(function(stream,buffer,offset,length,mmapFlags){if(!stream||!stream.stream_ops.msync){return 0}return stream.stream_ops.msync(stream,buffer,offset,length,mmapFlags)}),munmap:(function(stream){return 0}),ioctl:(function(stream,cmd,arg){if(!stream.stream_ops.ioctl){throw new FS.ErrnoError(ERRNO_CODES.ENOTTY)}return stream.stream_ops.ioctl(stream,cmd,arg)}),readFile:(function(path,opts){opts=opts||{};opts.flags=opts.flags||"r";opts.encoding=opts.encoding||"binary";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var ret;var stream=FS.open(path,opts.flags);var stat=FS.stat(path);var length=stat.size;var buf=new Uint8Array(length);FS.read(stream,buf,0,length,0);if(opts.encoding==="utf8"){ret=UTF8ArrayToString(buf,0)}else if(opts.encoding==="binary"){ret=buf}FS.close(stream);return ret}),writeFile:(function(path,data,opts){opts=opts||{};opts.flags=opts.flags||"w";opts.encoding=opts.encoding||"utf8";if(opts.encoding!=="utf8"&&opts.encoding!=="binary"){throw new Error('Invalid encoding type "'+opts.encoding+'"')}var stream=FS.open(path,opts.flags,opts.mode);if(opts.encoding==="utf8"){var buf=new Uint8Array(lengthBytesUTF8(data)+1);var actualNumBytes=stringToUTF8Array(data,buf,0,buf.length);FS.write(stream,buf,0,actualNumBytes,0,opts.canOwn)}else if(opts.encoding==="binary"){FS.write(stream,data,0,data.length,0,opts.canOwn)}FS.close(stream)}),cwd:(function(){return FS.currentPath}),chdir:(function(path){var lookup=FS.lookupPath(path,{follow:true});if(lookup.node===null){throw new FS.ErrnoError(ERRNO_CODES.ENOENT)}if(!FS.isDir(lookup.node.mode)){throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR)}var err=FS.nodePermissions(lookup.node,"x");if(err){throw new FS.ErrnoError(err)}FS.currentPath=lookup.path}),createDefaultDirectories:(function(){FS.mkdir("/tmp");FS.mkdir("/home");FS.mkdir("/home/web_user")}),createDefaultDevices:(function(){FS.mkdir("/dev");FS.registerDevice(FS.makedev(1,3),{read:(function(){return 0}),write:(function(stream,buffer,offset,length,pos){return length})});FS.mkdev("/dev/null",FS.makedev(1,3));TTY.register(FS.makedev(5,0),TTY.default_tty_ops);TTY.register(FS.makedev(6,0),TTY.default_tty1_ops);FS.mkdev("/dev/tty",FS.makedev(5,0));FS.mkdev("/dev/tty1",FS.makedev(6,0));var random_device;if(typeof crypto!=="undefined"){var randomBuffer=new Uint8Array(1);random_device=(function(){crypto.getRandomValues(randomBuffer);return randomBuffer[0]})}else if(ENVIRONMENT_IS_NODE){random_device=(function(){return require("crypto").randomBytes(1)[0]})}else{random_device=(function(){return Math.random()*256|0})}FS.createDevice("/dev","random",random_device);FS.createDevice("/dev","urandom",random_device);FS.mkdir("/dev/shm");FS.mkdir("/dev/shm/tmp")}),createSpecialDirectories:(function(){FS.mkdir("/proc");FS.mkdir("/proc/self");FS.mkdir("/proc/self/fd");FS.mount({mount:(function(){var node=FS.createNode("/proc/self","fd",16384|511,73);node.node_ops={lookup:(function(parent,name){var fd=+name;var stream=FS.getStream(fd);if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);var ret={parent:null,mount:{mountpoint:"fake"},node_ops:{readlink:(function(){return stream.path})}};ret.parent=ret;return ret})};return node})},{},"/proc/self/fd")}),createStandardStreams:(function(){if(Module["stdin"]){FS.createDevice("/dev","stdin",Module["stdin"])}else{FS.symlink("/dev/tty","/dev/stdin")}if(Module["stdout"]){FS.createDevice("/dev","stdout",null,Module["stdout"])}else{FS.symlink("/dev/tty","/dev/stdout")}if(Module["stderr"]){FS.createDevice("/dev","stderr",null,Module["stderr"])}else{FS.symlink("/dev/tty1","/dev/stderr")}var stdin=FS.open("/dev/stdin","r");assert(stdin.fd===0,"invalid handle for stdin ("+stdin.fd+")");var stdout=FS.open("/dev/stdout","w");assert(stdout.fd===1,"invalid handle for stdout ("+stdout.fd+")");var stderr=FS.open("/dev/stderr","w");assert(stderr.fd===2,"invalid handle for stderr ("+stderr.fd+")")}),ensureErrnoError:(function(){if(FS.ErrnoError)return;FS.ErrnoError=function ErrnoError(errno,node){this.node=node;this.setErrno=(function(errno){this.errno=errno;for(var key in ERRNO_CODES){if(ERRNO_CODES[key]===errno){this.code=key;break}}});this.setErrno(errno);this.message=ERRNO_MESSAGES[errno]};FS.ErrnoError.prototype=new Error;FS.ErrnoError.prototype.constructor=FS.ErrnoError;[ERRNO_CODES.ENOENT].forEach((function(code){FS.genericErrors[code]=new FS.ErrnoError(code);FS.genericErrors[code].stack="<generic error, no stack>"}))}),staticInit:(function(){FS.ensureErrnoError();FS.nameTable=new Array(4096);FS.mount(MEMFS,{},"/");FS.createDefaultDirectories();FS.createDefaultDevices();FS.createSpecialDirectories();FS.filesystems={"MEMFS":MEMFS,"IDBFS":IDBFS,"NODEFS":NODEFS,"WORKERFS":WORKERFS}}),init:(function(input,output,error){assert(!FS.init.initialized,"FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)");FS.init.initialized=true;FS.ensureErrnoError();Module["stdin"]=input||Module["stdin"];Module["stdout"]=output||Module["stdout"];Module["stderr"]=error||Module["stderr"];FS.createStandardStreams()}),quit:(function(){FS.init.initialized=false;var fflush=Module["_fflush"];if(fflush)fflush(0);for(var i=0;i<FS.streams.length;i++){var stream=FS.streams[i];if(!stream){continue}FS.close(stream)}}),getMode:(function(canRead,canWrite){var mode=0;if(canRead)mode|=292|73;if(canWrite)mode|=146;return mode}),joinPath:(function(parts,forceRelative){var path=PATH.join.apply(null,parts);if(forceRelative&&path[0]=="/")path=path.substr(1);return path}),absolutePath:(function(relative,base){return PATH.resolve(base,relative)}),standardizePath:(function(path){return PATH.normalize(path)}),findObject:(function(path,dontResolveLastLink){var ret=FS.analyzePath(path,dontResolveLastLink);if(ret.exists){return ret.object}else{___setErrNo(ret.error);return null}}),analyzePath:(function(path,dontResolveLastLink){try{var lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});path=lookup.path}catch(e){}var ret={isRoot:false,exists:false,error:0,name:null,path:null,object:null,parentExists:false,parentPath:null,parentObject:null};try{var lookup=FS.lookupPath(path,{parent:true});ret.parentExists=true;ret.parentPath=lookup.path;ret.parentObject=lookup.node;ret.name=PATH.basename(path);lookup=FS.lookupPath(path,{follow:!dontResolveLastLink});ret.exists=true;ret.path=lookup.path;ret.object=lookup.node;ret.name=lookup.node.name;ret.isRoot=lookup.path==="/"}catch(e){ret.error=e.errno}return ret}),createFolder:(function(parent,name,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.mkdir(path,mode)}),createPath:(function(parent,path,canRead,canWrite){parent=typeof parent==="string"?parent:FS.getPath(parent);var parts=path.split("/").reverse();while(parts.length){var part=parts.pop();if(!part)continue;var current=PATH.join2(parent,part);try{FS.mkdir(current)}catch(e){}parent=current}return current}),createFile:(function(parent,name,properties,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(canRead,canWrite);return FS.create(path,mode)}),createDataFile:(function(parent,name,data,canRead,canWrite,canOwn){var path=name?PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name):parent;var mode=FS.getMode(canRead,canWrite);var node=FS.create(path,mode);if(data){if(typeof data==="string"){var arr=new Array(data.length);for(var i=0,len=data.length;i<len;++i)arr[i]=data.charCodeAt(i);data=arr}FS.chmod(node,mode|146);var stream=FS.open(node,"w");FS.write(stream,data,0,data.length,0,canOwn);FS.close(stream);FS.chmod(node,mode)}return node}),createDevice:(function(parent,name,input,output){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);var mode=FS.getMode(!!input,!!output);if(!FS.createDevice.major)FS.createDevice.major=64;var dev=FS.makedev(FS.createDevice.major++,0);FS.registerDevice(dev,{open:(function(stream){stream.seekable=false}),close:(function(stream){if(output&&output.buffer&&output.buffer.length){output(10)}}),read:(function(stream,buffer,offset,length,pos){var bytesRead=0;for(var i=0;i<length;i++){var result;try{result=input()}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}if(result===undefined&&bytesRead===0){throw new FS.ErrnoError(ERRNO_CODES.EAGAIN)}if(result===null||result===undefined)break;bytesRead++;buffer[offset+i]=result}if(bytesRead){stream.node.timestamp=Date.now()}return bytesRead}),write:(function(stream,buffer,offset,length,pos){for(var i=0;i<length;i++){try{output(buffer[offset+i])}catch(e){throw new FS.ErrnoError(ERRNO_CODES.EIO)}}if(length){stream.node.timestamp=Date.now()}return i})});return FS.mkdev(path,mode,dev)}),createLink:(function(parent,name,target,canRead,canWrite){var path=PATH.join2(typeof parent==="string"?parent:FS.getPath(parent),name);return FS.symlink(target,path)}),forceLoadFile:(function(obj){if(obj.isDevice||obj.isFolder||obj.link||obj.contents)return true;var success=true;if(typeof XMLHttpRequest!=="undefined"){throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.")}else if(Module["read"]){try{obj.contents=intArrayFromString(Module["read"](obj.url),true);obj.usedBytes=obj.contents.length}catch(e){success=false}}else{throw new Error("Cannot load without read() or XMLHttpRequest.")}if(!success)___setErrNo(ERRNO_CODES.EIO);return success}),createLazyFile:(function(parent,name,url,canRead,canWrite){function LazyUint8Array(){this.lengthKnown=false;this.chunks=[]}LazyUint8Array.prototype.get=function LazyUint8Array_get(idx){if(idx>this.length-1||idx<0){return undefined}var chunkOffset=idx%this.chunkSize;var chunkNum=idx/this.chunkSize|0;return this.getter(chunkNum)[chunkOffset]};LazyUint8Array.prototype.setDataGetter=function LazyUint8Array_setDataGetter(getter){this.getter=getter};LazyUint8Array.prototype.cacheLength=function LazyUint8Array_cacheLength(){var xhr=new XMLHttpRequest;xhr.open("HEAD",url,false);xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);var datalength=Number(xhr.getResponseHeader("Content-length"));var header;var hasByteServing=(header=xhr.getResponseHeader("Accept-Ranges"))&&header==="bytes";var usesGzip=(header=xhr.getResponseHeader("Content-Encoding"))&&header==="gzip";var chunkSize=1024*1024;if(!hasByteServing)chunkSize=datalength;var doXHR=(function(from,to){if(from>to)throw new Error("invalid range ("+from+", "+to+") or no bytes requested!");if(to>datalength-1)throw new Error("only "+datalength+" bytes available! programmer error!");var xhr=new XMLHttpRequest;xhr.open("GET",url,false);if(datalength!==chunkSize)xhr.setRequestHeader("Range","bytes="+from+"-"+to);if(typeof Uint8Array!="undefined")xhr.responseType="arraybuffer";if(xhr.overrideMimeType){xhr.overrideMimeType("text/plain; charset=x-user-defined")}xhr.send(null);if(!(xhr.status>=200&&xhr.status<300||xhr.status===304))throw new Error("Couldn't load "+url+". Status: "+xhr.status);if(xhr.response!==undefined){return new Uint8Array(xhr.response||[])}else{return intArrayFromString(xhr.responseText||"",true)}});var lazyArray=this;lazyArray.setDataGetter((function(chunkNum){var start=chunkNum*chunkSize;var end=(chunkNum+1)*chunkSize-1;end=Math.min(end,datalength-1);if(typeof lazyArray.chunks[chunkNum]==="undefined"){lazyArray.chunks[chunkNum]=doXHR(start,end)}if(typeof lazyArray.chunks[chunkNum]==="undefined")throw new Error("doXHR failed!");return lazyArray.chunks[chunkNum]}));if(usesGzip||!datalength){chunkSize=datalength=1;datalength=this.getter(0).length;chunkSize=datalength;console.log("LazyFiles on gzip forces download of the whole file when length is accessed")}this._length=datalength;this._chunkSize=chunkSize;this.lengthKnown=true};if(typeof XMLHttpRequest!=="undefined"){if(!ENVIRONMENT_IS_WORKER)throw"Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc";var lazyArray=new LazyUint8Array;Object.defineProperties(lazyArray,{length:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._length})},chunkSize:{get:(function(){if(!this.lengthKnown){this.cacheLength()}return this._chunkSize})}});var properties={isDevice:false,contents:lazyArray}}else{var properties={isDevice:false,url:url}}var node=FS.createFile(parent,name,properties,canRead,canWrite);if(properties.contents){node.contents=properties.contents}else if(properties.url){node.contents=null;node.url=properties.url}Object.defineProperties(node,{usedBytes:{get:(function(){return this.contents.length})}});var stream_ops={};var keys=Object.keys(node.stream_ops);keys.forEach((function(key){var fn=node.stream_ops[key];stream_ops[key]=function forceLoadLazyFile(){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}return fn.apply(null,arguments)}}));stream_ops.read=function stream_ops_read(stream,buffer,offset,length,position){if(!FS.forceLoadFile(node)){throw new FS.ErrnoError(ERRNO_CODES.EIO)}var contents=stream.node.contents;if(position>=contents.length)return 0;var size=Math.min(contents.length-position,length);assert(size>=0);if(contents.slice){for(var i=0;i<size;i++){buffer[offset+i]=contents[position+i]}}else{for(var i=0;i<size;i++){buffer[offset+i]=contents.get(position+i)}}return size};node.stream_ops=stream_ops;return node}),createPreloadedFile:(function(parent,name,url,canRead,canWrite,onload,onerror,dontCreateFile,canOwn,preFinish){Browser.init();var fullname=name?PATH.resolve(PATH.join2(parent,name)):parent;var dep=getUniqueRunDependency("cp "+fullname);function processData(byteArray){function finish(byteArray){if(preFinish)preFinish();if(!dontCreateFile){FS.createDataFile(parent,name,byteArray,canRead,canWrite,canOwn)}if(onload)onload();removeRunDependency(dep)}var handled=false;Module["preloadPlugins"].forEach((function(plugin){if(handled)return;if(plugin["canHandle"](fullname)){plugin["handle"](byteArray,fullname,finish,(function(){if(onerror)onerror();removeRunDependency(dep)}));handled=true}}));if(!handled)finish(byteArray)}addRunDependency(dep);if(typeof url=="string"){Browser.asyncLoad(url,(function(byteArray){processData(byteArray)}),onerror)}else{processData(url)}}),indexedDB:(function(){return window.indexedDB||window.mozIndexedDB||window.webkitIndexedDB||window.msIndexedDB}),DB_NAME:(function(){return"EM_FS_"+window.location.pathname}),DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=function openRequest_onupgradeneeded(){console.log("creating db");var db=openRequest.result;db.createObjectStore(FS.DB_STORE_NAME)};openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;var transaction=db.transaction([FS.DB_STORE_NAME],"readwrite");var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var putRequest=files.put(FS.analyzePath(path).object.contents,path);putRequest.onsuccess=function putRequest_onsuccess(){ok++;if(ok+fail==total)finish()};putRequest.onerror=function putRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror}),loadFilesFromDB:(function(paths,onload,onerror){onload=onload||(function(){});onerror=onerror||(function(){});var indexedDB=FS.indexedDB();try{var openRequest=indexedDB.open(FS.DB_NAME(),FS.DB_VERSION)}catch(e){return onerror(e)}openRequest.onupgradeneeded=onerror;openRequest.onsuccess=function openRequest_onsuccess(){var db=openRequest.result;try{var transaction=db.transaction([FS.DB_STORE_NAME],"readonly")}catch(e){onerror(e);return}var files=transaction.objectStore(FS.DB_STORE_NAME);var ok=0,fail=0,total=paths.length;function finish(){if(fail==0)onload();else onerror()}paths.forEach((function(path){var getRequest=files.get(path);getRequest.onsuccess=function getRequest_onsuccess(){if(FS.analyzePath(path).exists){FS.unlink(path)}FS.createDataFile(PATH.dirname(path),PATH.basename(path),getRequest.result,true,true,true);ok++;if(ok+fail==total)finish()};getRequest.onerror=function getRequest_onerror(){fail++;if(ok+fail==total)finish()}}));transaction.onerror=onerror};openRequest.onerror=onerror})};var SYSCALLS={DEFAULT_POLLMASK:5,mappings:{},umask:511,calculateAt:(function(dirfd,path){if(path[0]!=="/"){var dir;if(dirfd===-100){dir=FS.cwd()}else{var dirstream=FS.getStream(dirfd);if(!dirstream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);dir=dirstream.path}path=PATH.join2(dir,path)}return path}),doStat:(function(func,path,buf){try{var stat=func(path)}catch(e){if(e&&e.node&&PATH.normalize(path)!==PATH.normalize(FS.getPath(e.node))){return-ERRNO_CODES.ENOTDIR}throw e}HEAP32[buf>>2]=stat.dev;HEAP32[buf+4>>2]=0;HEAP32[buf+8>>2]=stat.ino;HEAP32[buf+12>>2]=stat.mode;HEAP32[buf+16>>2]=stat.nlink;HEAP32[buf+20>>2]=stat.uid;HEAP32[buf+24>>2]=stat.gid;HEAP32[buf+28>>2]=stat.rdev;HEAP32[buf+32>>2]=0;HEAP32[buf+36>>2]=stat.size;HEAP32[buf+40>>2]=4096;HEAP32[buf+44>>2]=stat.blocks;HEAP32[buf+48>>2]=stat.atime.getTime()/1e3|0;HEAP32[buf+52>>2]=0;HEAP32[buf+56>>2]=stat.mtime.getTime()/1e3|0;HEAP32[buf+60>>2]=0;HEAP32[buf+64>>2]=stat.ctime.getTime()/1e3|0;HEAP32[buf+68>>2]=0;HEAP32[buf+72>>2]=stat.ino;return 0}),doMsync:(function(addr,stream,len,flags){var buffer=new Uint8Array(HEAPU8.subarray(addr,addr+len));FS.msync(stream,buffer,0,len,flags)}),doMkdir:(function(path,mode){path=PATH.normalize(path);if(path[path.length-1]==="/")path=path.substr(0,path.length-1);FS.mkdir(path,mode,0);return 0}),doMknod:(function(path,mode,dev){switch(mode&61440){case 32768:case 8192:case 24576:case 4096:case 49152:break;default:return-ERRNO_CODES.EINVAL}FS.mknod(path,mode,dev);return 0}),doReadlink:(function(path,buf,bufsize){if(bufsize<=0)return-ERRNO_CODES.EINVAL;var ret=FS.readlink(path);var len=Math.min(bufsize,lengthBytesUTF8(ret));var endChar=HEAP8[buf+len];stringToUTF8(ret,buf,bufsize+1);HEAP8[buf+len]=endChar;return len}),doAccess:(function(path,amode){if(amode&~7){return-ERRNO_CODES.EINVAL}var node;var lookup=FS.lookupPath(path,{follow:true});node=lookup.node;var perms="";if(amode&4)perms+="r";if(amode&2)perms+="w";if(amode&1)perms+="x";if(perms&&FS.nodePermissions(node,perms)){return-ERRNO_CODES.EACCES}return 0}),doDup:(function(path,flags,suggestFD){var suggest=FS.getStream(suggestFD);if(suggest)FS.close(suggest);return FS.open(path,flags,0,suggestFD,suggestFD).fd}),doReadv:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.read(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr;if(curr<len)break}return ret}),doWritev:(function(stream,iov,iovcnt,offset){var ret=0;for(var i=0;i<iovcnt;i++){var ptr=HEAP32[iov+i*8>>2];var len=HEAP32[iov+(i*8+4)>>2];var curr=FS.write(stream,HEAP8,ptr,len,offset);if(curr<0)return-1;ret+=curr}return ret}),varargs:0,get:(function(varargs){SYSCALLS.varargs+=4;var ret=HEAP32[SYSCALLS.varargs-4>>2];return ret}),getStr:(function(){var ret=Pointer_stringify(SYSCALLS.get());return ret}),getStreamFromFD:(function(){var stream=FS.getStream(SYSCALLS.get());if(!stream)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return stream}),getSocketFromFD:(function(){var socket=SOCKFS.getSocket(SYSCALLS.get());if(!socket)throw new FS.ErrnoError(ERRNO_CODES.EBADF);return socket}),getSocketAddress:(function(allowNull){var addrp=SYSCALLS.get(),addrlen=SYSCALLS.get();if(allowNull&&addrp===0)return null;var info=__read_sockaddr(addrp,addrlen);if(info.errno)throw new FS.ErrnoError(info.errno);info.addr=DNS.lookup_addr(info.addr)||info.addr;return info}),get64:(function(){var low=SYSCALLS.get(),high=SYSCALLS.get();if(low>=0)assert(high===0);else assert(high===-1);return low}),getZero:(function(){assert(SYSCALLS.get()===0)})};function ___syscall221(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),cmd=SYSCALLS.get();switch(cmd){case 0:{var arg=SYSCALLS.get();if(arg<0){return-ERRNO_CODES.EINVAL}var newStream;newStream=FS.open(stream.path,stream.flags,0,arg);return newStream.fd};case 1:case 2:return 0;case 3:return stream.flags;case 4:{var arg=SYSCALLS.get();stream.flags|=arg;return 0};case 12:case 12:{var arg=SYSCALLS.get();var offset=0;HEAP16[arg+offset>>1]=2;return 0};case 13:case 14:case 13:case 14:return 0;case 16:case 8:return-ERRNO_CODES.EINVAL;case 9:___setErrNo(ERRNO_CODES.EINVAL);return-1;default:{return-ERRNO_CODES.EINVAL}}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function __exit(status){Module["exit"](status)}function _exit(status){__exit(status)}function ___syscall54(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),op=SYSCALLS.get();switch(op){case 21505:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21506:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return 0};case 21519:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;var argp=SYSCALLS.get();HEAP32[argp>>2]=0;return 0};case 21520:{if(!stream.tty)return-ERRNO_CODES.ENOTTY;return-ERRNO_CODES.EINVAL};case 21531:{var argp=SYSCALLS.get();return FS.ioctl(stream,op,argp)};default:abort("bad ioctl syscall "+op)}}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["_bitshift64Lshr"]=_bitshift64Lshr;function __ZSt18uncaught_exceptionv(){return!!__ZSt18uncaught_exceptionv.uncaught_exception}function _pthread_cleanup_push(routine,arg){__ATEXIT__.push((function(){Module["dynCall_vi"](routine,arg)}));_pthread_cleanup_push.level=__ATEXIT__.length}Module["_pthread_cond_broadcast"]=_pthread_cond_broadcast;function __isLeapYear(year){return year%4===0&&(year%100!==0||year%400===0)}function __arraySum(array,index){var sum=0;for(var i=0;i<=index;sum+=array[i++]);return sum}var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date,days){var newDate=new Date(date.getTime());while(days>0){var leap=__isLeapYear(newDate.getFullYear());var currentMonth=newDate.getMonth();var daysInCurrentMonth=(leap?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR)[currentMonth];if(days>daysInCurrentMonth-newDate.getDate()){days-=daysInCurrentMonth-newDate.getDate()+1;newDate.setDate(1);if(currentMonth<11){newDate.setMonth(currentMonth+1)}else{newDate.setMonth(0);newDate.setFullYear(newDate.getFullYear()+1)}}else{newDate.setDate(newDate.getDate()+days);return newDate}}return newDate}function _strftime(s,maxsize,format,tm){var tm_zone=HEAP32[tm+40>>2];var date={tm_sec:HEAP32[tm>>2],tm_min:HEAP32[tm+4>>2],tm_hour:HEAP32[tm+8>>2],tm_mday:HEAP32[tm+12>>2],tm_mon:HEAP32[tm+16>>2],tm_year:HEAP32[tm+20>>2],tm_wday:HEAP32[tm+24>>2],tm_yday:HEAP32[tm+28>>2],tm_isdst:HEAP32[tm+32>>2],tm_gmtoff:HEAP32[tm+36>>2],tm_zone:tm_zone?Pointer_stringify(tm_zone):""};var pattern=Pointer_stringify(format);var EXPANSION_RULES_1={"%c":"%a %b %d %H:%M:%S %Y","%D":"%m/%d/%y","%F":"%Y-%m-%d","%h":"%b","%r":"%I:%M:%S %p","%R":"%H:%M","%T":"%H:%M:%S","%x":"%m/%d/%y","%X":"%H:%M:%S"};for(var rule in EXPANSION_RULES_1){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_1[rule])}var WEEKDAYS=["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"];var MONTHS=["January","February","March","April","May","June","July","August","September","October","November","December"];function leadingSomething(value,digits,character){var str=typeof value==="number"?value.toString():value||"";while(str.length<digits){str=character[0]+str}return str}function leadingNulls(value,digits){return leadingSomething(value,digits,"0")}function compareByDay(date1,date2){function sgn(value){return value<0?-1:value>0?1:0}var compare;if((compare=sgn(date1.getFullYear()-date2.getFullYear()))===0){if((compare=sgn(date1.getMonth()-date2.getMonth()))===0){compare=sgn(date1.getDate()-date2.getDate())}}return compare}function getFirstWeekStartDate(janFourth){switch(janFourth.getDay()){case 0:return new Date(janFourth.getFullYear()-1,11,29);case 1:return janFourth;case 2:return new Date(janFourth.getFullYear(),0,3);case 3:return new Date(janFourth.getFullYear(),0,2);case 4:return new Date(janFourth.getFullYear(),0,1);case 5:return new Date(janFourth.getFullYear()-1,11,31);case 6:return new Date(janFourth.getFullYear()-1,11,30)}}function getWeekBasedYear(date){var thisDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);var janFourthThisYear=new Date(thisDate.getFullYear(),0,4);var janFourthNextYear=new Date(thisDate.getFullYear()+1,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);if(compareByDay(firstWeekStartThisYear,thisDate)<=0){if(compareByDay(firstWeekStartNextYear,thisDate)<=0){return thisDate.getFullYear()+1}else{return thisDate.getFullYear()}}else{return thisDate.getFullYear()-1}}var EXPANSION_RULES_2={"%a":(function(date){return WEEKDAYS[date.tm_wday].substring(0,3)}),"%A":(function(date){return WEEKDAYS[date.tm_wday]}),"%b":(function(date){return MONTHS[date.tm_mon].substring(0,3)}),"%B":(function(date){return MONTHS[date.tm_mon]}),"%C":(function(date){var year=date.tm_year+1900;return leadingNulls(year/100|0,2)}),"%d":(function(date){return leadingNulls(date.tm_mday,2)}),"%e":(function(date){return leadingSomething(date.tm_mday,2," ")}),"%g":(function(date){return getWeekBasedYear(date).toString().substring(2)}),"%G":(function(date){return getWeekBasedYear(date)}),"%H":(function(date){return leadingNulls(date.tm_hour,2)}),"%I":(function(date){var twelveHour=date.tm_hour;if(twelveHour==0)twelveHour=12;else if(twelveHour>12)twelveHour-=12;return leadingNulls(twelveHour,2)}),"%j":(function(date){return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900)?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,date.tm_mon-1),3)}),"%m":(function(date){return leadingNulls(date.tm_mon+1,2)}),"%M":(function(date){return leadingNulls(date.tm_min,2)}),"%n":(function(){return"\n"}),"%p":(function(date){if(date.tm_hour>=0&&date.tm_hour<12){return"AM"}else{return"PM"}}),"%S":(function(date){return leadingNulls(date.tm_sec,2)}),"%t":(function(){return"\t"}),"%u":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()||7}),"%U":(function(date){var janFirst=new Date(date.tm_year+1900,0,1);var firstSunday=janFirst.getDay()===0?janFirst:__addDays(janFirst,7-janFirst.getDay());var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstSunday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstSundayUntilEndJanuary=31-firstSunday.getDate();var days=firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstSunday,janFirst)===0?"01":"00"}),"%V":(function(date){var janFourthThisYear=new Date(date.tm_year+1900,0,4);var janFourthNextYear=new Date(date.tm_year+1901,0,4);var firstWeekStartThisYear=getFirstWeekStartDate(janFourthThisYear);var firstWeekStartNextYear=getFirstWeekStartDate(janFourthNextYear);var endDate=__addDays(new Date(date.tm_year+1900,0,1),date.tm_yday);if(compareByDay(endDate,firstWeekStartThisYear)<0){return"53"}if(compareByDay(firstWeekStartNextYear,endDate)<=0){return"01"}var daysDifference;if(firstWeekStartThisYear.getFullYear()<date.tm_year+1900){daysDifference=date.tm_yday+32-firstWeekStartThisYear.getDate()}else{daysDifference=date.tm_yday+1-firstWeekStartThisYear.getDate()}return leadingNulls(Math.ceil(daysDifference/7),2)}),"%w":(function(date){var day=new Date(date.tm_year+1900,date.tm_mon+1,date.tm_mday,0,0,0,0);return day.getDay()}),"%W":(function(date){var janFirst=new Date(date.tm_year,0,1);var firstMonday=janFirst.getDay()===1?janFirst:__addDays(janFirst,janFirst.getDay()===0?1:7-janFirst.getDay()+1);var endDate=new Date(date.tm_year+1900,date.tm_mon,date.tm_mday);if(compareByDay(firstMonday,endDate)<0){var februaryFirstUntilEndMonth=__arraySum(__isLeapYear(endDate.getFullYear())?__MONTH_DAYS_LEAP:__MONTH_DAYS_REGULAR,endDate.getMonth()-1)-31;var firstMondayUntilEndJanuary=31-firstMonday.getDate();var days=firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();return leadingNulls(Math.ceil(days/7),2)}return compareByDay(firstMonday,janFirst)===0?"01":"00"}),"%y":(function(date){return(date.tm_year+1900).toString().substring(2)}),"%Y":(function(date){return date.tm_year+1900}),"%z":(function(date){var off=date.tm_gmtoff;var ahead=off>=0;off=Math.abs(off)/60;off=off/60*100+off%60;return(ahead?"+":"-")+String("0000"+off).slice(-4)}),"%Z":(function(date){return date.tm_zone}),"%%":(function(){return"%"})};for(var rule in EXPANSION_RULES_2){if(pattern.indexOf(rule)>=0){pattern=pattern.replace(new RegExp(rule,"g"),EXPANSION_RULES_2[rule](date))}}var bytes=intArrayFromString(pattern,false);if(bytes.length>maxsize){return 0}writeArrayToMemory(bytes,s);return bytes.length-1}function _strftime_l(s,maxsize,format,tm){return _strftime(s,maxsize,format,tm)}function _pthread_cleanup_pop(){assert(_pthread_cleanup_push.level==__ATEXIT__.length,"cannot pop if something else added meanwhile!");__ATEXIT__.pop();_pthread_cleanup_push.level=__ATEXIT__.length}function _pthread_join(){}function ___syscall5(which,varargs){SYSCALLS.varargs=varargs;try{var pathname=SYSCALLS.getStr(),flags=SYSCALLS.get(),mode=SYSCALLS.get();var stream=FS.open(pathname,flags,mode);return stream.fd}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function _emscripten_memcpy_big(dest,src,num){HEAPU8.set(HEAPU8.subarray(src,src+num),dest);return dest}Module["_memcpy"]=_memcpy;function ___syscall6(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD();FS.close(stream);return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["___udivdi3"]=___udivdi3;Module["___muldsi3"]=___muldsi3;Module["___muldi3"]=___muldi3;var _llvm_pow_f64=Math_pow;function _llvm_cttz_i64(l,h){var ret=_llvm_cttz_i32(l);if(ret==32)ret+=_llvm_cttz_i32(h);return(Runtime.setTempRet0(0),ret)|0}Module["_bitshift64Shl"]=_bitshift64Shl;Module["_memmove"]=_memmove;Module["___uremdi3"]=___uremdi3;function _pthread_cond_wait(){return 0}Module["_pthread_mutex_unlock"]=_pthread_mutex_unlock;Module["_sbrk"]=_sbrk;Module["_pthread_self"]=_pthread_self;function ___syscall140(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),offset_high=SYSCALLS.get(),offset_low=SYSCALLS.get(),result=SYSCALLS.get(),whence=SYSCALLS.get();var offset=offset_low;assert(offset_high===0);FS.llseek(stream,offset,whence);HEAP32[result>>2]=stream.position;if(stream.getdents&&offset===0&&whence===0)stream.getdents=null;return 0}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall145(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doReadv(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}function ___syscall146(which,varargs){SYSCALLS.varargs=varargs;try{var stream=SYSCALLS.getStreamFromFD(),iov=SYSCALLS.get(),iovcnt=SYSCALLS.get();return SYSCALLS.doWritev(stream,iov,iovcnt)}catch(e){if(typeof FS==="undefined"||!(e instanceof FS.ErrnoError))abort(e);return-e.errno}}Module["_round"]=_round;Module["_llvm_ctlz_i64"]=_llvm_ctlz_i64;function _emscripten_set_main_loop_timing(mode,value){Browser.mainLoop.timingMode=mode;Browser.mainLoop.timingValue=value;if(!Browser.mainLoop.func){return 1}if(mode==0){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setTimeout(){var timeUntilNextTick=Math.max(0,Browser.mainLoop.tickStartTime+value-_emscripten_get_now())|0;setTimeout(Browser.mainLoop.runner,timeUntilNextTick)};Browser.mainLoop.method="timeout"}else if(mode==1){Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_rAF(){Browser.requestAnimationFrame(Browser.mainLoop.runner)};Browser.mainLoop.method="rAF"}else if(mode==2){if(!window["setImmediate"]){var setImmediates=[];var emscriptenMainLoopMessageId="setimmediate";function Browser_setImmediate_messageHandler(event){if(event.source===window&&event.data===emscriptenMainLoopMessageId){event.stopPropagation();setImmediates.shift()()}}window.addEventListener("message",Browser_setImmediate_messageHandler,true);window["setImmediate"]=function Browser_emulated_setImmediate(func){setImmediates.push(func);if(ENVIRONMENT_IS_WORKER){if(Module["setImmediates"]===undefined)Module["setImmediates"]=[];Module["setImmediates"].push(func);window.postMessage({target:emscriptenMainLoopMessageId})}else window.postMessage(emscriptenMainLoopMessageId,"*")}}Browser.mainLoop.scheduler=function Browser_mainLoop_scheduler_setImmediate(){window["setImmediate"](Browser.mainLoop.runner)};Browser.mainLoop.method="immediate"}return 0}function _emscripten_set_main_loop(func,fps,simulateInfiniteLoop,arg,noSetTiming){Module["noExitRuntime"]=true;assert(!Browser.mainLoop.func,"emscripten_set_main_loop: there can only be one main loop function at once: call emscripten_cancel_main_loop to cancel the previous one before setting a new one with different parameters.");Browser.mainLoop.func=func;Browser.mainLoop.arg=arg;var browserIterationFunc;if(typeof arg!=="undefined"){browserIterationFunc=(function(){Module["dynCall_vi"](func,arg)})}else{browserIterationFunc=(function(){Module["dynCall_v"](func)})}var thisMainLoopId=Browser.mainLoop.currentlyRunningMainloop;Browser.mainLoop.runner=function Browser_mainLoop_runner(){if(ABORT)return;if(Browser.mainLoop.queue.length>0){var start=Date.now();var blocker=Browser.mainLoop.queue.shift();blocker.func(blocker.arg);if(Browser.mainLoop.remainingBlockers){var remaining=Browser.mainLoop.remainingBlockers;var next=remaining%1==0?remaining-1:Math.floor(remaining);if(blocker.counted){Browser.mainLoop.remainingBlockers=next}else{next=next+.5;Browser.mainLoop.remainingBlockers=(8*remaining+next)/9}}console.log('main loop blocker "'+blocker.name+'" took '+(Date.now()-start)+" ms");Browser.mainLoop.updateStatus();if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;setTimeout(Browser.mainLoop.runner,0);return}if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;Browser.mainLoop.currentFrameNumber=Browser.mainLoop.currentFrameNumber+1|0;if(Browser.mainLoop.timingMode==1&&Browser.mainLoop.timingValue>1&&Browser.mainLoop.currentFrameNumber%Browser.mainLoop.timingValue!=0){Browser.mainLoop.scheduler();return}else if(Browser.mainLoop.timingMode==0){Browser.mainLoop.tickStartTime=_emscripten_get_now()}if(Browser.mainLoop.method==="timeout"&&Module.ctx){Module.printErr("Looks like you are rendering without using requestAnimationFrame for the main loop. You should use 0 for the frame rate in emscripten_set_main_loop in order to use requestAnimationFrame, as that can greatly improve your frame rates!");Browser.mainLoop.method=""}Browser.mainLoop.runIter(browserIterationFunc);if(thisMainLoopId<Browser.mainLoop.currentlyRunningMainloop)return;if(typeof SDL==="object"&&SDL.audio&&SDL.audio.queueNewAudioData)SDL.audio.queueNewAudioData();Browser.mainLoop.scheduler()};if(!noSetTiming){if(fps&&fps>0)_emscripten_set_main_loop_timing(0,1e3/fps);else _emscripten_set_main_loop_timing(1,1);Browser.mainLoop.scheduler()}if(simulateInfiniteLoop){throw"SimulateInfiniteLoop"}}var Browser={mainLoop:{scheduler:null,method:"",currentlyRunningMainloop:0,func:null,arg:0,timingMode:0,timingValue:0,currentFrameNumber:0,queue:[],pause:(function(){Browser.mainLoop.scheduler=null;Browser.mainLoop.currentlyRunningMainloop++}),resume:(function(){Browser.mainLoop.currentlyRunningMainloop++;var timingMode=Browser.mainLoop.timingMode;var timingValue=Browser.mainLoop.timingValue;var func=Browser.mainLoop.func;Browser.mainLoop.func=null;_emscripten_set_main_loop(func,0,false,Browser.mainLoop.arg,true);_emscripten_set_main_loop_timing(timingMode,timingValue);Browser.mainLoop.scheduler()}),updateStatus:(function(){if(Module["setStatus"]){var message=Module["statusMessage"]||"Please wait...";var remaining=Browser.mainLoop.remainingBlockers;var expected=Browser.mainLoop.expectedBlockers;if(remaining){if(remaining<expected){Module["setStatus"](message+" ("+(expected-remaining)+"/"+expected+")")}else{Module["setStatus"](message)}}else{Module["setStatus"]("")}}}),runIter:(function(func){if(ABORT)return;if(Module["preMainLoop"]){var preRet=Module["preMainLoop"]();if(preRet===false){return}}try{func()}catch(e){if(e instanceof ExitStatus){return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}if(Module["postMainLoop"])Module["postMainLoop"]()})},isFullscreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:(function(){if(!Module["preloadPlugins"])Module["preloadPlugins"]=[];if(Browser.initted)return;Browser.initted=true;try{new Blob;Browser.hasBlobConstructor=true}catch(e){Browser.hasBlobConstructor=false;console.log("warning: no blob constructor, cannot create blobs with mimetypes")}Browser.BlobBuilder=typeof MozBlobBuilder!="undefined"?MozBlobBuilder:typeof WebKitBlobBuilder!="undefined"?WebKitBlobBuilder:!Browser.hasBlobConstructor?console.log("warning: no BlobBuilder"):null;Browser.URLObject=typeof window!="undefined"?window.URL?window.URL:window.webkitURL:undefined;if(!Module.noImageDecoding&&typeof Browser.URLObject==="undefined"){console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");Module.noImageDecoding=true}var imagePlugin={};imagePlugin["canHandle"]=function imagePlugin_canHandle(name){return!Module.noImageDecoding&&/\.(jpg|jpeg|png|bmp)$/i.test(name)};imagePlugin["handle"]=function imagePlugin_handle(byteArray,name,onload,onerror){var b=null;if(Browser.hasBlobConstructor){try{b=new Blob([byteArray],{type:Browser.getMimetype(name)});if(b.size!==byteArray.length){b=new Blob([(new Uint8Array(byteArray)).buffer],{type:Browser.getMimetype(name)})}}catch(e){Runtime.warnOnce("Blob constructor present but fails: "+e+"; falling back to blob builder")}}if(!b){var bb=new Browser.BlobBuilder;bb.append((new Uint8Array(byteArray)).buffer);b=bb.getBlob()}var url=Browser.URLObject.createObjectURL(b);var img=new Image;img.onload=function img_onload(){assert(img.complete,"Image "+name+" could not be decoded");var canvas=document.createElement("canvas");canvas.width=img.width;canvas.height=img.height;var ctx=canvas.getContext("2d");ctx.drawImage(img,0,0);Module["preloadedImages"][name]=canvas;Browser.URLObject.revokeObjectURL(url);if(onload)onload(byteArray)};img.onerror=function img_onerror(event){console.log("Image "+url+" could not be decoded");if(onerror)onerror()};img.src=url};Module["preloadPlugins"].push(imagePlugin);var audioPlugin={};audioPlugin["canHandle"]=function audioPlugin_canHandle(name){return!Module.noAudioDecoding&&name.substr(-4)in{".ogg":1,".wav":1,".mp3":1}};audioPlugin["handle"]=function audioPlugin_handle(byteArray,name,onload,onerror){var done=false;function finish(audio){if(done)return;done=true;Module["preloadedAudios"][name]=audio;if(onload)onload(byteArray)}function fail(){if(done)return;done=true;Module["preloadedAudios"][name]=new Audio;if(onerror)onerror()}if(Browser.hasBlobConstructor){try{var b=new Blob([byteArray],{type:Browser.getMimetype(name)})}catch(e){return fail()}var url=Browser.URLObject.createObjectURL(b);var audio=new Audio;audio.addEventListener("canplaythrough",(function(){finish(audio)}),false);audio.onerror=function audio_onerror(event){if(done)return;console.log("warning: browser could not fully decode audio "+name+", trying slower base64 approach");function encode64(data){var BASE="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";var PAD="=";var ret="";var leftchar=0;var leftbits=0;for(var i=0;i<data.length;i++){leftchar=leftchar<<8|data[i];leftbits+=8;while(leftbits>=6){var curr=leftchar>>leftbits-6&63;leftbits-=6;ret+=BASE[curr]}}if(leftbits==2){ret+=BASE[(leftchar&3)<<4];ret+=PAD+PAD}else if(leftbits==4){ret+=BASE[(leftchar&15)<<2];ret+=PAD}return ret}audio.src="data:audio/x-"+name.substr(-3)+";base64,"+encode64(byteArray);finish(audio)};audio.src=url;Browser.safeSetTimeout((function(){finish(audio)}),1e4)}else{return fail()}};Module["preloadPlugins"].push(audioPlugin);function pointerLockChange(){Browser.pointerLock=document["pointerLockElement"]===Module["canvas"]||document["mozPointerLockElement"]===Module["canvas"]||document["webkitPointerLockElement"]===Module["canvas"]||document["msPointerLockElement"]===Module["canvas"]}var canvas=Module["canvas"];if(canvas){canvas.requestPointerLock=canvas["requestPointerLock"]||canvas["mozRequestPointerLock"]||canvas["webkitRequestPointerLock"]||canvas["msRequestPointerLock"]||(function(){});canvas.exitPointerLock=document["exitPointerLock"]||document["mozExitPointerLock"]||document["webkitExitPointerLock"]||document["msExitPointerLock"]||(function(){});canvas.exitPointerLock=canvas.exitPointerLock.bind(document);document.addEventListener("pointerlockchange",pointerLockChange,false);document.addEventListener("mozpointerlockchange",pointerLockChange,false);document.addEventListener("webkitpointerlockchange",pointerLockChange,false);document.addEventListener("mspointerlockchange",pointerLockChange,false);if(Module["elementPointerLock"]){canvas.addEventListener("click",(function(ev){if(!Browser.pointerLock&&Module["canvas"].requestPointerLock){Module["canvas"].requestPointerLock();ev.preventDefault()}}),false)}}}),createContext:(function(canvas,useWebGL,setInModule,webGLContextAttributes){if(useWebGL&&Module.ctx&&canvas==Module.canvas)return Module.ctx;var ctx;var contextHandle;if(useWebGL){var contextAttributes={antialias:false,alpha:false};if(webGLContextAttributes){for(var attribute in webGLContextAttributes){contextAttributes[attribute]=webGLContextAttributes[attribute]}}contextHandle=GL.createContext(canvas,contextAttributes);if(contextHandle){ctx=GL.getContext(contextHandle).GLctx}}else{ctx=canvas.getContext("2d")}if(!ctx)return null;if(setInModule){if(!useWebGL)assert(typeof GLctx==="undefined","cannot set in module if GLctx is used, but we are a non-GL context that would replace it");Module.ctx=ctx;if(useWebGL)GL.makeContextCurrent(contextHandle);Module.useWebGL=useWebGL;Browser.moduleContextCreatedCallbacks.forEach((function(callback){callback()}));Browser.init()}return ctx}),destroyContext:(function(canvas,useWebGL,setInModule){}),fullscreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullscreen:(function(lockPointer,resizeCanvas,vrDevice){Browser.lockPointer=lockPointer;Browser.resizeCanvas=resizeCanvas;Browser.vrDevice=vrDevice;if(typeof Browser.lockPointer==="undefined")Browser.lockPointer=true;if(typeof Browser.resizeCanvas==="undefined")Browser.resizeCanvas=false;if(typeof Browser.vrDevice==="undefined")Browser.vrDevice=null;var canvas=Module["canvas"];function fullscreenChange(){Browser.isFullscreen=false;var canvasContainer=canvas.parentNode;if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvasContainer){canvas.exitFullscreen=document["exitFullscreen"]||document["cancelFullScreen"]||document["mozCancelFullScreen"]||document["msExitFullscreen"]||document["webkitCancelFullScreen"]||(function(){});canvas.exitFullscreen=canvas.exitFullscreen.bind(document);if(Browser.lockPointer)canvas.requestPointerLock();Browser.isFullscreen=true;if(Browser.resizeCanvas)Browser.setFullscreenCanvasSize()}else{canvasContainer.parentNode.insertBefore(canvas,canvasContainer);canvasContainer.parentNode.removeChild(canvasContainer);if(Browser.resizeCanvas)Browser.setWindowedCanvasSize()}if(Module["onFullScreen"])Module["onFullScreen"](Browser.isFullscreen);if(Module["onFullscreen"])Module["onFullscreen"](Browser.isFullscreen);Browser.updateCanvasDimensions(canvas)}if(!Browser.fullscreenHandlersInstalled){Browser.fullscreenHandlersInstalled=true;document.addEventListener("fullscreenchange",fullscreenChange,false);document.addEventListener("mozfullscreenchange",fullscreenChange,false);document.addEventListener("webkitfullscreenchange",fullscreenChange,false);document.addEventListener("MSFullscreenChange",fullscreenChange,false)}var canvasContainer=document.createElement("div");canvas.parentNode.insertBefore(canvasContainer,canvas);canvasContainer.appendChild(canvas);canvasContainer.requestFullscreen=canvasContainer["requestFullscreen"]||canvasContainer["mozRequestFullScreen"]||canvasContainer["msRequestFullscreen"]||(canvasContainer["webkitRequestFullscreen"]?(function(){canvasContainer["webkitRequestFullscreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null)||(canvasContainer["webkitRequestFullScreen"]?(function(){canvasContainer["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"])}):null);if(vrDevice){canvasContainer.requestFullscreen({vrDisplay:vrDevice})}else{canvasContainer.requestFullscreen()}}),requestFullScreen:(function(lockPointer,resizeCanvas,vrDevice){Module.printErr("Browser.requestFullScreen() is deprecated. Please call Browser.requestFullscreen instead.");Browser.requestFullScreen=(function(lockPointer,resizeCanvas,vrDevice){return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)});return Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)}),nextRAF:0,fakeRequestAnimationFrame:(function(func){var now=Date.now();if(Browser.nextRAF===0){Browser.nextRAF=now+1e3/60}else{while(now+2>=Browser.nextRAF){Browser.nextRAF+=1e3/60}}var delay=Math.max(Browser.nextRAF-now,0);setTimeout(func,delay)}),requestAnimationFrame:function requestAnimationFrame(func){if(typeof window==="undefined"){Browser.fakeRequestAnimationFrame(func)}else{if(!window.requestAnimationFrame){window.requestAnimationFrame=window["requestAnimationFrame"]||window["mozRequestAnimationFrame"]||window["webkitRequestAnimationFrame"]||window["msRequestAnimationFrame"]||window["oRequestAnimationFrame"]||Browser.fakeRequestAnimationFrame}window.requestAnimationFrame(func)}},safeCallback:(function(func){return(function(){if(!ABORT)return func.apply(null,arguments)})}),allowAsyncCallbacks:true,queuedAsyncCallbacks:[],pauseAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=false}),resumeAsyncCallbacks:(function(){Browser.allowAsyncCallbacks=true;if(Browser.queuedAsyncCallbacks.length>0){var callbacks=Browser.queuedAsyncCallbacks;Browser.queuedAsyncCallbacks=[];callbacks.forEach((function(func){func()}))}}),safeRequestAnimationFrame:(function(func){return Browser.requestAnimationFrame((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}))}),safeSetTimeout:(function(func,timeout){Module["noExitRuntime"]=true;return setTimeout((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}else{Browser.queuedAsyncCallbacks.push(func)}}),timeout)}),safeSetInterval:(function(func,timeout){Module["noExitRuntime"]=true;return setInterval((function(){if(ABORT)return;if(Browser.allowAsyncCallbacks){func()}}),timeout)}),getMimetype:(function(name){return{"jpg":"image/jpeg","jpeg":"image/jpeg","png":"image/png","bmp":"image/bmp","ogg":"audio/ogg","wav":"audio/wav","mp3":"audio/mpeg"}[name.substr(name.lastIndexOf(".")+1)]}),getUserMedia:(function(func){if(!window.getUserMedia){window.getUserMedia=navigator["getUserMedia"]||navigator["mozGetUserMedia"]}window.getUserMedia(func)}),getMovementX:(function(event){return event["movementX"]||event["mozMovementX"]||event["webkitMovementX"]||0}),getMovementY:(function(event){return event["movementY"]||event["mozMovementY"]||event["webkitMovementY"]||0}),getMouseWheelDelta:(function(event){var delta=0;switch(event.type){case"DOMMouseScroll":delta=event.detail;break;case"mousewheel":delta=event.wheelDelta;break;case"wheel":delta=event["deltaY"];break;default:throw"unrecognized mouse wheel event: "+event.type}return delta}),mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,touches:{},lastTouches:{},calculateMouseEvent:(function(event){if(Browser.pointerLock){if(event.type!="mousemove"&&"mozMovementX"in event){Browser.mouseMovementX=Browser.mouseMovementY=0}else{Browser.mouseMovementX=Browser.getMovementX(event);Browser.mouseMovementY=Browser.getMovementY(event)}if(typeof SDL!="undefined"){Browser.mouseX=SDL.mouseX+Browser.mouseMovementX;Browser.mouseY=SDL.mouseY+Browser.mouseMovementY}else{Browser.mouseX+=Browser.mouseMovementX;Browser.mouseY+=Browser.mouseMovementY}}else{var rect=Module["canvas"].getBoundingClientRect();var cw=Module["canvas"].width;var ch=Module["canvas"].height;var scrollX=typeof window.scrollX!=="undefined"?window.scrollX:window.pageXOffset;var scrollY=typeof window.scrollY!=="undefined"?window.scrollY:window.pageYOffset;if(event.type==="touchstart"||event.type==="touchend"||event.type==="touchmove"){var touch=event.touch;if(touch===undefined){return}var adjustedX=touch.pageX-(scrollX+rect.left);var adjustedY=touch.pageY-(scrollY+rect.top);adjustedX=adjustedX*(cw/rect.width);adjustedY=adjustedY*(ch/rect.height);var coords={x:adjustedX,y:adjustedY};if(event.type==="touchstart"){Browser.lastTouches[touch.identifier]=coords;Browser.touches[touch.identifier]=coords}else if(event.type==="touchend"||event.type==="touchmove"){var last=Browser.touches[touch.identifier];if(!last)last=coords;Browser.lastTouches[touch.identifier]=last;Browser.touches[touch.identifier]=coords}return}var x=event.pageX-(scrollX+rect.left);var y=event.pageY-(scrollY+rect.top);x=x*(cw/rect.width);y=y*(ch/rect.height);Browser.mouseMovementX=x-Browser.mouseX;Browser.mouseMovementY=y-Browser.mouseY;Browser.mouseX=x;Browser.mouseY=y}}),asyncLoad:(function(url,onload,onerror,noRunDep){var dep=!noRunDep?getUniqueRunDependency("al "+url):"";Module["readAsync"](url,(function(arrayBuffer){assert(arrayBuffer,'Loading data file "'+url+'" failed (no arrayBuffer).');onload(new Uint8Array(arrayBuffer));if(dep)removeRunDependency(dep)}),(function(event){if(onerror){onerror()}else{throw'Loading data file "'+url+'" failed.'}}));if(dep)addRunDependency(dep)}),resizeListeners:[],updateResizeListeners:(function(){var canvas=Module["canvas"];Browser.resizeListeners.forEach((function(listener){listener(canvas.width,canvas.height)}))}),setCanvasSize:(function(width,height,noUpdates){var canvas=Module["canvas"];Browser.updateCanvasDimensions(canvas,width,height);if(!noUpdates)Browser.updateResizeListeners()}),windowedWidth:0,windowedHeight:0,setFullscreenCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags|8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),setWindowedCanvasSize:(function(){if(typeof SDL!="undefined"){var flags=HEAPU32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2];flags=flags&~8388608;HEAP32[SDL.screen+Runtime.QUANTUM_SIZE*0>>2]=flags}Browser.updateResizeListeners()}),updateCanvasDimensions:(function(canvas,wNative,hNative){if(wNative&&hNative){canvas.widthNative=wNative;canvas.heightNative=hNative}else{wNative=canvas.widthNative;hNative=canvas.heightNative}var w=wNative;var h=hNative;if(Module["forcedAspectRatio"]&&Module["forcedAspectRatio"]>0){if(w/h<Module["forcedAspectRatio"]){w=Math.round(h*Module["forcedAspectRatio"])}else{h=Math.round(w/Module["forcedAspectRatio"])}}if((document["fullscreenElement"]||document["mozFullScreenElement"]||document["msFullscreenElement"]||document["webkitFullscreenElement"]||document["webkitCurrentFullScreenElement"])===canvas.parentNode&&typeof screen!="undefined"){var factor=Math.min(screen.width/w,screen.height/h);w=Math.round(w*factor);h=Math.round(h*factor)}if(Browser.resizeCanvas){if(canvas.width!=w)canvas.width=w;if(canvas.height!=h)canvas.height=h;if(typeof canvas.style!="undefined"){canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}else{if(canvas.width!=wNative)canvas.width=wNative;if(canvas.height!=hNative)canvas.height=hNative;if(typeof canvas.style!="undefined"){if(w!=wNative||h!=hNative){canvas.style.setProperty("width",w+"px","important");canvas.style.setProperty("height",h+"px","important")}else{canvas.style.removeProperty("width");canvas.style.removeProperty("height")}}}}),wgetRequests:{},nextWgetRequestHandle:0,getNextWgetRequestHandle:(function(){var handle=Browser.nextWgetRequestHandle;Browser.nextWgetRequestHandle++;return handle})};function _emscripten_async_call(func,arg,millis){Module["noExitRuntime"]=true;function wrapper(){Runtime.getFuncWrapper(func,"vi")(arg)}if(millis>=0){Browser.safeSetTimeout(wrapper,millis)}else{Browser.safeRequestAnimationFrame(wrapper)}}if(ENVIRONMENT_IS_NODE){_emscripten_get_now=function _emscripten_get_now_actual(){var t=process["hrtime"]();return t[0]*1e3+t[1]/1e6}}else if(typeof dateNow!=="undefined"){_emscripten_get_now=dateNow}else if(typeof self==="object"&&self["performance"]&&typeof self["performance"]["now"]==="function"){_emscripten_get_now=(function(){return self["performance"]["now"]()})}else if(typeof performance==="object"&&typeof performance["now"]==="function"){_emscripten_get_now=(function(){return performance["now"]()})}else{_emscripten_get_now=Date.now}FS.staticInit();__ATINIT__.unshift((function(){if(!Module["noFSInit"]&&!FS.init.initialized)FS.init()}));__ATMAIN__.push((function(){FS.ignorePermissions=false}));__ATEXIT__.push((function(){FS.quit()}));Module["FS_createFolder"]=FS.createFolder;Module["FS_createPath"]=FS.createPath;Module["FS_createDataFile"]=FS.createDataFile;Module["FS_createPreloadedFile"]=FS.createPreloadedFile;Module["FS_createLazyFile"]=FS.createLazyFile;Module["FS_createLink"]=FS.createLink;Module["FS_createDevice"]=FS.createDevice;Module["FS_unlink"]=FS.unlink;__ATINIT__.unshift((function(){TTY.init()}));__ATEXIT__.push((function(){TTY.shutdown()}));if(ENVIRONMENT_IS_NODE){var fs=require("fs");var NODEJS_PATH=require("path");NODEFS.staticInit()}Module["requestFullScreen"]=function Module_requestFullScreen(lockPointer,resizeCanvas,vrDevice){Module.printErr("Module.requestFullScreen is deprecated. Please call Module.requestFullscreen instead.");Module["requestFullScreen"]=Module["requestFullscreen"];Browser.requestFullScreen(lockPointer,resizeCanvas,vrDevice)};Module["requestFullscreen"]=function Module_requestFullscreen(lockPointer,resizeCanvas,vrDevice){Browser.requestFullscreen(lockPointer,resizeCanvas,vrDevice)};Module["requestAnimationFrame"]=function Module_requestAnimationFrame(func){Browser.requestAnimationFrame(func)};Module["setCanvasSize"]=function Module_setCanvasSize(width,height,noUpdates){Browser.setCanvasSize(width,height,noUpdates)};Module["pauseMainLoop"]=function Module_pauseMainLoop(){Browser.mainLoop.pause()};Module["resumeMainLoop"]=function Module_resumeMainLoop(){Browser.mainLoop.resume()};Module["getUserMedia"]=function Module_getUserMedia(){Browser.getUserMedia()};Module["createContext"]=function Module_createContext(canvas,useWebGL,setInModule,webGLContextAttributes){return Browser.createContext(canvas,useWebGL,setInModule,webGLContextAttributes)};DYNAMICTOP_PTR=allocate(1,"i32",ALLOC_STATIC);STACK_BASE=STACKTOP=Runtime.alignMemory(STATICTOP);STACK_MAX=STACK_BASE+TOTAL_STACK;DYNAMIC_BASE=Runtime.alignMemory(STACK_MAX);HEAP32[DYNAMICTOP_PTR>>2]=DYNAMIC_BASE;staticSealed=true;function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7){try{return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiii(index,a1,a2,a3){try{return Module["dynCall_iiii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiii(index,a1,a2,a3,a4,a5){try{Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiid(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiid"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vi(index,a1){try{Module["dynCall_vi"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_vii(index,a1,a2){try{Module["dynCall_vii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiii(index,a1,a2,a3,a4,a5,a6){try{return Module["dynCall_iiiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiid(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiid"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_ii(index,a1){try{return Module["dynCall_ii"](index,a1)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viii(index,a1,a2,a3){try{Module["dynCall_viii"](index,a1,a2,a3)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_v(index){try{Module["dynCall_v"](index)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8){try{return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiii(index,a1,a2,a3,a4){try{return Module["dynCall_iiiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6){try{Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iii(index,a1,a2){try{return Module["dynCall_iii"](index,a1,a2)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_iiiiii(index,a1,a2,a3,a4,a5){try{return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}function invoke_viiii(index,a1,a2,a3,a4){try{Module["dynCall_viiii"](index,a1,a2,a3,a4)}catch(e){if(typeof e!=="number"&&e!=="longjmp")throw e;Module["setThrew"](1,0)}}Module.asmGlobalArg={"Math":Math,"Int8Array":Int8Array,"Int16Array":Int16Array,"Int32Array":Int32Array,"Uint8Array":Uint8Array,"Uint16Array":Uint16Array,"Uint32Array":Uint32Array,"Float32Array":Float32Array,"Float64Array":Float64Array,"NaN":NaN,"Infinity":Infinity};Module.asmLibraryArg={"abort":abort,"assert":assert,"enlargeMemory":enlargeMemory,"getTotalMemory":getTotalMemory,"abortOnCannotGrowMemory":abortOnCannotGrowMemory,"invoke_iiiiiiii":invoke_iiiiiiii,"invoke_iiii":invoke_iiii,"invoke_viiiii":invoke_viiiii,"invoke_iiiiiid":invoke_iiiiiid,"invoke_vi":invoke_vi,"invoke_vii":invoke_vii,"invoke_iiiiiii":invoke_iiiiiii,"invoke_iiiiid":invoke_iiiiid,"invoke_ii":invoke_ii,"invoke_viii":invoke_viii,"invoke_v":invoke_v,"invoke_iiiiiiiii":invoke_iiiiiiiii,"invoke_iiiii":invoke_iiiii,"invoke_viiiiii":invoke_viiiiii,"invoke_iii":invoke_iii,"invoke_iiiiii":invoke_iiiiii,"invoke_viiii":invoke_viiii,"___syscall221":___syscall221,"_pthread_cleanup_pop":_pthread_cleanup_pop,"_pthread_cond_wait":_pthread_cond_wait,"___lock":___lock,"_pthread_join":_pthread_join,"_emscripten_get_now_is_monotonic":_emscripten_get_now_is_monotonic,"_llvm_pow_f64":_llvm_pow_f64,"_pthread_cleanup_push":_pthread_cleanup_push,"_abort":_abort,"___setErrNo":___setErrNo,"___assert_fail":___assert_fail,"__ZSt18uncaught_exceptionv":__ZSt18uncaught_exceptionv,"_clock_gettime":_clock_gettime,"_strftime_l":_strftime_l,"_emscripten_set_main_loop_timing":_emscripten_set_main_loop_timing,"_emscripten_memcpy_big":_emscripten_memcpy_big,"__exit":__exit,"_strftime":_strftime,"__arraySum":__arraySum,"_pthread_cond_signal":_pthread_cond_signal,"_pthread_mutex_destroy":_pthread_mutex_destroy,"___syscall54":___syscall54,"___unlock":___unlock,"__isLeapYear":__isLeapYear,"_emscripten_set_main_loop":_emscripten_set_main_loop,"_emscripten_get_now":_emscripten_get_now,"_llvm_cttz_i64":_llvm_cttz_i64,"__addDays":__addDays,"___syscall6":___syscall6,"___syscall5":___syscall5,"___syscall145":___syscall145,"_pthread_cond_destroy":_pthread_cond_destroy,"___syscall140":___syscall140,"_exit":_exit,"_emscripten_async_call":_emscripten_async_call,"___syscall146":___syscall146,"DYNAMICTOP_PTR":DYNAMICTOP_PTR,"tempDoublePtr":tempDoublePtr,"ABORT":ABORT,"STACKTOP":STACKTOP,"STACK_MAX":STACK_MAX,"cttz_i8":cttz_i8};// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer) {
"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.DYNAMICTOP_PTR|0;var j=env.tempDoublePtr|0;var k=env.ABORT|0;var l=env.STACKTOP|0;var m=env.STACK_MAX|0;var n=env.cttz_i8|0;var o=0;var p=0;var q=0;var r=0;var s=global.NaN,t=global.Infinity;var u=0,v=0,w=0,x=0,y=0.0,z=0,A=0,B=0,C=0.0;var D=0;var E=global.Math.floor;var F=global.Math.abs;var G=global.Math.sqrt;var H=global.Math.pow;var I=global.Math.cos;var J=global.Math.sin;var K=global.Math.tan;var L=global.Math.acos;var M=global.Math.asin;var N=global.Math.atan;var O=global.Math.atan2;var P=global.Math.exp;var Q=global.Math.log;var R=global.Math.ceil;var S=global.Math.imul;var T=global.Math.min;var U=global.Math.max;var V=global.Math.clz32;var W=env.abort;var X=env.assert;var Y=env.enlargeMemory;var Z=env.getTotalMemory;var _=env.abortOnCannotGrowMemory;var $=env.invoke_iiiiiiii;var aa=env.invoke_iiii;var ba=env.invoke_viiiii;var ca=env.invoke_iiiiiid;var da=env.invoke_vi;var ea=env.invoke_vii;var fa=env.invoke_iiiiiii;var ga=env.invoke_iiiiid;var ha=env.invoke_ii;var ia=env.invoke_viii;var ja=env.invoke_v;var ka=env.invoke_iiiiiiiii;var la=env.invoke_iiiii;var ma=env.invoke_viiiiii;var na=env.invoke_iii;var oa=env.invoke_iiiiii;var pa=env.invoke_viiii;var qa=env.___syscall221;var ra=env._pthread_cleanup_pop;var sa=env._pthread_cond_wait;var ta=env.___lock;var ua=env._pthread_join;var va=env._emscripten_get_now_is_monotonic;var wa=env._llvm_pow_f64;var xa=env._pthread_cleanup_push;var ya=env._abort;var za=env.___setErrNo;var Aa=env.___assert_fail;var Ba=env.__ZSt18uncaught_exceptionv;var Ca=env._clock_gettime;var Da=env._strftime_l;var Ea=env._emscripten_set_main_loop_timing;var Fa=env._emscripten_memcpy_big;var Ga=env.__exit;var Ha=env._strftime;var Ia=env.__arraySum;var Ja=env._pthread_cond_signal;var Ka=env._pthread_mutex_destroy;var La=env.___syscall54;var Ma=env.___unlock;var Na=env.__isLeapYear;var Oa=env._emscripten_set_main_loop;var Pa=env._emscripten_get_now;var Qa=env._llvm_cttz_i64;var Ra=env.__addDays;var Sa=env.___syscall6;var Ta=env.___syscall5;var Ua=env.___syscall145;var Va=env._pthread_cond_destroy;var Wa=env.___syscall140;var Xa=env._exit;var Ya=env._emscripten_async_call;var Za=env.___syscall146;var _a=0.0;

// EMSCRIPTEN_START_FUNCS
function Ln(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+224|0;i=a+8|0;o=a;n=a+200|0;h=a+28|0;m=a+24|0;k=a+16|0;j=a+20|0;p=o;c[p>>2]=37;c[p+4>>2]=0;Fn(o+1|0,25805,1,c[d+4>>2]|0);p=nm()|0;q=i;c[q>>2]=f;c[q+4>>2]=g;f=n+(An(n,23,p,o,i)|0)|0;g=Bn(n,f,d)|0;c[i>>2]=Sk(d)|0;Tn(n,g,f,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[b>>2];f=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Rn(i,h,f,g,d,e)|0;l=a;return g|0}function Mn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+128|0;i=b;n=b+112|0;o=b+100|0;h=b+16|0;m=b+12|0;k=b+4|0;j=b+8|0;a[n>>0]=a[25808]|0;a[n+1>>0]=a[25809]|0;a[n+2>>0]=a[25810]|0;a[n+3>>0]=a[25811]|0;a[n+4>>0]=a[25812]|0;a[n+5>>0]=a[25813]|0;Fn(n+1|0,25814,0,c[e+4>>2]|0);p=nm()|0;c[i>>2]=g;g=o+(An(o,12,p,n,i)|0)|0;n=Bn(o,g,e)|0;c[i>>2]=Sk(e)|0;Tn(o,n,g,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[d>>2];d=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Rn(i,h,d,g,e,f)|0;l=b;return g|0}function Nn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+224|0;i=a+8|0;o=a;n=a+200|0;h=a+28|0;m=a+24|0;k=a+16|0;j=a+20|0;p=o;c[p>>2]=37;c[p+4>>2]=0;Fn(o+1|0,25805,0,c[d+4>>2]|0);p=nm()|0;q=i;c[q>>2]=f;c[q+4>>2]=g;f=n+(An(n,23,p,o,i)|0)|0;g=Bn(n,f,d)|0;c[i>>2]=Sk(d)|0;Tn(n,g,f,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[b>>2];f=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Rn(i,h,f,g,d,e)|0;l=a;return g|0}function On(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+336|0;r=v+300|0;n=v+48|0;m=v+32|0;i=v+24|0;g=v+8|0;k=v;p=v+304|0;q=v+296|0;o=v+68|0;u=v+64|0;s=v+60|0;t=v+56|0;j=k;c[j>>2]=37;c[j+4>>2]=0;j=Cn(k+1|0,1235164,c[d+4>>2]|0)|0;c[q>>2]=p;a=nm()|0;if(j){c[g>>2]=c[d+8>>2];h[g+8>>3]=f;a=An(p,30,a,k,g)|0}else{h[i>>3]=f;a=An(p,30,a,k,i)|0}if((a|0)>29){a=nm()|0;if(j){c[m>>2]=c[d+8>>2];h[m+8>>3]=f;a=Dn(q,a,k,m)|0}else{h[n>>3]=f;a=Dn(q,a,k,n)|0}g=c[q>>2]|0;if(!g){j=c[q>>2]|0;n=j}else{n=g;j=g}}else{n=0;j=c[q>>2]|0}k=j+a|0;m=Bn(j,k,d)|0;if((j|0)!=(p|0)){a=Fj(a<<3)|0;if(!a){g=a;i=a;a=c[q>>2]|0}else{g=a;i=a;a=j}}else{g=o;i=0;a=p}c[r>>2]=Sk(d)|0;Sn(a,m,k,g,u,s,r);vt(c[r>>2]|0)|0;c[t>>2]=c[b>>2];u=c[u>>2]|0;a=c[s>>2]|0;c[r>>2]=c[t>>2];a=Rn(r,g,u,a,d,e)|0;c[b>>2]=a;if(i|0)Gj(i);Gj(n);l=v;return a|0}function Pn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+336|0;r=v+300|0;n=v+48|0;m=v+32|0;i=v+24|0;g=v+8|0;k=v;p=v+304|0;q=v+296|0;o=v+68|0;u=v+64|0;s=v+60|0;t=v+56|0;j=k;c[j>>2]=37;c[j+4>>2]=0;j=Cn(k+1|0,25803,c[d+4>>2]|0)|0;c[q>>2]=p;a=nm()|0;if(j){c[g>>2]=c[d+8>>2];h[g+8>>3]=f;a=An(p,30,a,k,g)|0}else{h[i>>3]=f;a=An(p,30,a,k,i)|0}if((a|0)>29){a=nm()|0;if(j){c[m>>2]=c[d+8>>2];h[m+8>>3]=f;a=Dn(q,a,k,m)|0}else{h[n>>3]=f;a=Dn(q,a,k,n)|0}g=c[q>>2]|0;if(!g){j=c[q>>2]|0;n=j}else{n=g;j=g}}else{n=0;j=c[q>>2]|0}k=j+a|0;m=Bn(j,k,d)|0;if((j|0)!=(p|0)){a=Fj(a<<3)|0;if(!a){g=a;i=a;a=c[q>>2]|0}else{g=a;i=a;a=j}}else{g=o;i=0;a=p}c[r>>2]=Sk(d)|0;Sn(a,m,k,g,u,s,r);vt(c[r>>2]|0)|0;c[t>>2]=c[b>>2];u=c[u>>2]|0;a=c[s>>2]|0;c[r>>2]=c[t>>2];a=Rn(r,g,u,a,d,e)|0;c[b>>2]=a;if(i|0)Gj(i);Gj(n);l=v;return a|0}function Qn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+192|0;m=b;k=b+176|0;h=b+156|0;j=b+4|0;n=b+152|0;a[k>>0]=a[25797]|0;a[k+1>>0]=a[25798]|0;a[k+2>>0]=a[25799]|0;a[k+3>>0]=a[25800]|0;a[k+4>>0]=a[25801]|0;a[k+5>>0]=a[25802]|0;i=nm()|0;c[m>>2]=g;g=An(h,20,i,k,m)|0;k=h+g|0;i=Bn(h,k,e)|0;p=Sk(e)|0;c[m>>2]=p;o=lm(m,1165660)|0;vt(p)|0;lb[c[(c[o>>2]|0)+48>>2]&7](o,h,k,j)|0;g=j+(g<<2)|0;c[n>>2]=c[d>>2];c[m>>2]=c[n>>2];g=Rn(m,j,(i|0)==(k|0)?g:j+(i-h<<2)|0,g,e,f)|0;l=b;return g|0}function Rn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+16|0;n=o;i=c[b>>2]|0;a:do if(!i)i=0;else{p=d;j=f-p>>2;m=g+12|0;g=c[m>>2]|0;g=(g|0)>(j|0)?g-j|0:0;j=e;p=j-p|0;k=p>>2;if((p|0)>0?(ab[c[(c[i>>2]|0)+48>>2]&31](i,d,k)|0)!=(k|0):0){c[b>>2]=0;i=0;break}do if((g|0)>0){c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;du(n,g,h);if((ab[c[(c[i>>2]|0)+48>>2]&31](i,(a[n+8+3>>0]|0)<0?c[n>>2]|0:n,g)|0)==(g|0)){fu(n);break}else{c[b>>2]=0;fu(n);i=0;break a}}while(0);p=f-j|0;f=p>>2;if((p|0)>0?(ab[c[(c[i>>2]|0)+48>>2]&31](i,e,f)|0)!=(f|0):0){c[b>>2]=0;i=0;break}c[m>>2]=0}while(0);l=o;return i|0}function Sn(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=l;l=l+16|0;v=y;w=lm(i,1165660)|0;t=lm(i,1165668)|0;eb[c[(c[t>>2]|0)+20>>2]&63](v,t);c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{u=nb[c[(c[w>>2]|0)+44>>2]&63](w,i)|0;i=c[h>>2]|0;c[h>>2]=i+4;c[i>>2]=u;i=b+1|0;break}default:i=b}u=e;a:do if((u-i|0)>1?(a[i>>0]|0)==48:0){j=i+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:{j=i;x=10;break a}}r=nb[c[(c[w>>2]|0)+44>>2]&63](w,48)|0;s=c[h>>2]|0;c[h>>2]=s+4;c[s>>2]=r;i=i+2|0;s=nb[c[(c[w>>2]|0)+44>>2]&63](w,a[j>>0]|0)|0;j=c[h>>2]|0;c[h>>2]=j+4;c[j>>2]=s;j=i;while(1){if(j>>>0>=e>>>0)break a;s=a[j>>0]|0;if(!(lj(s,nm()|0)|0))break a;j=j+1|0}}else{j=i;x=10}while(0);b:do if((x|0)==10)while(1){x=0;if(j>>>0>=e>>>0)break b;s=a[j>>0]|0;if(!(sj(s,nm()|0)|0))break b;j=j+1|0;x=10}while(0);r=v+11|0;q=a[r>>0]|0;s=v+4|0;c:do if((q<<24>>24<0?c[s>>2]|0:q&255)|0){d:do if((i|0)!=(j|0)){k=j;m=i;while(1){k=k+-1|0;if(m>>>0>=k>>>0)break d;q=a[m>>0]|0;a[m>>0]=a[k>>0]|0;a[k>>0]=q;m=m+1|0}}while(0);q=hb[c[(c[t>>2]|0)+16>>2]&127](t)|0;p=i;k=0;m=0;while(1){if(p>>>0>=j>>>0)break;n=a[r>>0]|0;o=n<<24>>24<0;z=a[(o?c[v>>2]|0:v)+k>>0]|0;if(z<<24>>24>0&(m|0)==(z<<24>>24|0)){m=c[h>>2]|0;c[h>>2]=m+4;c[m>>2]=q;k=(k>>>0<((o?c[s>>2]|0:n&255)+-1|0)>>>0&1)+k|0;m=0}o=nb[c[(c[w>>2]|0)+44>>2]&63](w,a[p>>0]|0)|0;z=c[h>>2]|0;c[h>>2]=z+4;c[z>>2]=o;p=p+1|0;m=m+1|0}i=f+(i-b<<2)|0;m=c[h>>2]|0;if((i|0)==(m|0))k=w;else{k=m;while(1){k=k+-4|0;if(i>>>0>=k>>>0){k=w;i=m;break c}z=c[i>>2]|0;c[i>>2]=c[k>>2];c[k>>2]=z;i=i+4|0}}}else{lb[c[(c[w>>2]|0)+48>>2]&7](w,i,j,c[h>>2]|0)|0;i=(c[h>>2]|0)+(j-i<<2)|0;c[h>>2]=i;k=w}while(0);while(1){if(j>>>0>=e>>>0)break;i=a[j>>0]|0;if(i<<24>>24==46){x=29;break}s=nb[c[(c[k>>2]|0)+44>>2]&63](w,i)|0;z=c[h>>2]|0;i=z+4|0;c[h>>2]=i;c[z>>2]=s;j=j+1|0}if((x|0)==29){x=hb[c[(c[t>>2]|0)+12>>2]&127](t)|0;z=c[h>>2]|0;i=z+4|0;c[h>>2]=i;c[z>>2]=x;j=j+1|0}lb[c[(c[w>>2]|0)+48>>2]&7](w,j,e,i)|0;z=(c[h>>2]|0)+(u-j<<2)|0;c[h>>2]=z;c[g>>2]=(d|0)==(e|0)?z:f+(d-b<<2)|0;Mt(v);l=y;return}function Tn(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;u=l;l=l+16|0;t=u;s=lm(i,1165660)|0;m=lm(i,1165668)|0;eb[c[(c[m>>2]|0)+20>>2]&63](t,m);q=t+11|0;p=a[q>>0]|0;r=t+4|0;a:do if((p<<24>>24<0?c[r>>2]|0:p&255)|0){c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{p=nb[c[(c[s>>2]|0)+44>>2]&63](s,i)|0;i=c[h>>2]|0;c[h>>2]=i+4;c[i>>2]=p;i=b+1|0;break}default:i=b}b:do if((e-i|0)>1?(a[i>>0]|0)==48:0){j=i+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:break b}p=nb[c[(c[s>>2]|0)+44>>2]&63](s,48)|0;o=c[h>>2]|0;c[h>>2]=o+4;c[o>>2]=p;o=nb[c[(c[s>>2]|0)+44>>2]&63](s,a[j>>0]|0)|0;p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=o;i=i+2|0}while(0);c:do if((i|0)!=(e|0)){j=e;k=i;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break c;p=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=p;k=k+1|0}}while(0);p=hb[c[(c[m>>2]|0)+16>>2]&127](m)|0;o=i;j=0;k=0;while(1){if(o>>>0>=e>>>0)break;m=a[q>>0]|0;n=m<<24>>24<0;v=a[(n?c[t>>2]|0:t)+j>>0]|0;if(v<<24>>24!=0&(k|0)==(v<<24>>24|0)){k=c[h>>2]|0;c[h>>2]=k+4;c[k>>2]=p;j=(j>>>0<((n?c[r>>2]|0:m&255)+-1|0)>>>0&1)+j|0;k=0}n=nb[c[(c[s>>2]|0)+44>>2]&63](s,a[o>>0]|0)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=n;o=o+1|0;k=k+1|0}i=f+(i-b<<2)|0;k=c[h>>2]|0;if((i|0)!=(k|0)){j=k;while(1){j=j+-4|0;if(i>>>0>=j>>>0){i=k;break a}v=c[i>>2]|0;c[i>>2]=c[j>>2];c[j>>2]=v;i=i+4|0}}}else{lb[c[(c[s>>2]|0)+48>>2]&7](s,b,e,f)|0;i=f+(e-b<<2)|0;c[h>>2]=i}while(0);c[g>>2]=(d|0)==(e|0)?i:f+(d-b<<2)|0;Mt(t);l=u;return}function Un(a){a=a|0;return}function Vn(a){a=a|0;Dt(a);return}function Wn(a){a=a|0;return 2}function Xn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=lo(a,j,i,e,f,g,26333,26341)|0;l=h;return g|0}function Yn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;i=l;l=l+16|0;j=i+12|0;k=i+8|0;n=i+4|0;m=i;o=b+8|0;o=hb[c[(c[o>>2]|0)+20>>2]&127](o)|0;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];e=a[o+11>>0]|0;p=e<<24>>24<0;d=p?c[o>>2]|0:o;e=d+(p?c[o+4>>2]|0:e&255)|0;c[k>>2]=c[n>>2];c[j>>2]=c[m>>2];h=lo(b,k,j,f,g,h,d,e)|0;l=i;return h|0}function Zn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;h=l;l=l+16|0;i=h+4|0;j=h;k=Sk(e)|0;c[i>>2]=k;e=lm(i,1165628)|0;vt(k)|0;c[j>>2]=c[d>>2];c[i>>2]=c[j>>2];jo(a,g+24|0,b,i,f,e);l=h;return c[b>>2]|0}function _n(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;h=l;l=l+16|0;i=h+4|0;j=h;k=Sk(e)|0;c[i>>2]=k;e=lm(i,1165628)|0;vt(k)|0;c[j>>2]=c[d>>2];c[i>>2]=c[j>>2];ko(a,g+16|0,b,i,f,e);l=h;return c[b>>2]|0}function $n(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;h=l;l=l+16|0;i=h+4|0;j=h;k=Sk(e)|0;c[i>>2]=k;e=lm(i,1165628)|0;vt(k)|0;c[j>>2]=c[d>>2];c[i>>2]=c[j>>2];wo(a,g+20|0,b,i,f,e);l=h;return c[b>>2]|0}function ao(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;S=l;l=l+144|0;k=S+128|0;j=S+112|0;Q=S+124|0;R=S+120|0;m=S+116|0;n=S+108|0;o=S+104|0;p=S+100|0;q=S+96|0;r=S+92|0;s=S+88|0;t=S+84|0;u=S+80|0;v=S+76|0;w=S+72|0;x=S+68|0;y=S+64|0;z=S+60|0;A=S+56|0;B=S+52|0;C=S+48|0;D=S+44|0;E=S+40|0;F=S+36|0;G=S+32|0;H=S+28|0;I=S+24|0;J=S+20|0;K=S+16|0;L=S+12|0;M=S+8|0;N=S+4|0;O=S;c[g>>2]=0;U=Sk(f)|0;c[k>>2]=U;P=lm(k,1165628)|0;vt(U)|0;do switch(i<<24>>24|0){case 65:case 97:{c[Q>>2]=c[e>>2];c[k>>2]=c[Q>>2];jo(b,h+24|0,d,k,g,P);T=26;break}case 104:case 66:case 98:{c[R>>2]=c[e>>2];c[k>>2]=c[R>>2];ko(b,h+16|0,d,k,g,P);T=26;break}case 99:{i=b+8|0;i=hb[c[(c[i>>2]|0)+12>>2]&127](i)|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];T=a[i+11>>0]|0;e=T<<24>>24<0;U=e?c[i>>2]|0:i;T=U+(e?c[i+4>>2]|0:T&255)|0;c[j>>2]=c[m>>2];c[k>>2]=c[n>>2];c[d>>2]=lo(b,j,k,f,g,h,U,T)|0;T=26;break}case 101:case 100:{c[o>>2]=c[e>>2];c[k>>2]=c[o>>2];mo(b,h+12|0,d,k,g,P);T=26;break}case 68:{c[p>>2]=c[d>>2];c[q>>2]=c[e>>2];c[j>>2]=c[p>>2];c[k>>2]=c[q>>2];c[d>>2]=lo(b,j,k,f,g,h,26293,26301)|0;T=26;break}case 70:{c[r>>2]=c[d>>2];c[s>>2]=c[e>>2];c[j>>2]=c[r>>2];c[k>>2]=c[s>>2];c[d>>2]=lo(b,j,k,f,g,h,26301,26309)|0;T=26;break}case 72:{c[t>>2]=c[e>>2];c[k>>2]=c[t>>2];no(b,h+8|0,d,k,g,P);T=26;break}case 73:{c[u>>2]=c[e>>2];c[k>>2]=c[u>>2];oo(b,h+8|0,d,k,g,P);T=26;break}case 106:{c[v>>2]=c[e>>2];c[k>>2]=c[v>>2];po(b,h+28|0,d,k,g,P);T=26;break}case 109:{c[w>>2]=c[e>>2];c[k>>2]=c[w>>2];qo(b,h+16|0,d,k,g,P);T=26;break}case 77:{c[x>>2]=c[e>>2];c[k>>2]=c[x>>2];ro(b,h+4|0,d,k,g,P);T=26;break}case 116:case 110:{c[y>>2]=c[e>>2];c[k>>2]=c[y>>2];so(b,d,k,g,P);T=26;break}case 112:{c[z>>2]=c[e>>2];c[k>>2]=c[z>>2];to(b,h+8|0,d,k,g,P);T=26;break}case 114:{c[A>>2]=c[d>>2];c[B>>2]=c[e>>2];c[j>>2]=c[A>>2];c[k>>2]=c[B>>2];c[d>>2]=lo(b,j,k,f,g,h,26309,26320)|0;T=26;break}case 82:{c[C>>2]=c[d>>2];c[D>>2]=c[e>>2];c[j>>2]=c[C>>2];c[k>>2]=c[D>>2];c[d>>2]=lo(b,j,k,f,g,h,26320,26325)|0;T=26;break}case 83:{c[E>>2]=c[e>>2];c[k>>2]=c[E>>2];uo(b,h,d,k,g,P);T=26;break}case 84:{c[F>>2]=c[d>>2];c[G>>2]=c[e>>2];c[j>>2]=c[F>>2];c[k>>2]=c[G>>2];c[d>>2]=lo(b,j,k,f,g,h,26325,26333)|0;T=26;break}case 119:{c[H>>2]=c[e>>2];c[k>>2]=c[H>>2];vo(b,h+24|0,d,k,g,P);T=26;break}case 120:{U=c[(c[b>>2]|0)+20>>2]|0;c[I>>2]=c[d>>2];c[J>>2]=c[e>>2];c[j>>2]=c[I>>2];c[k>>2]=c[J>>2];j=fb[U&63](b,j,k,f,g,h)|0;break}case 88:{i=b+8|0;i=hb[c[(c[i>>2]|0)+24>>2]&127](i)|0;c[K>>2]=c[d>>2];c[L>>2]=c[e>>2];T=a[i+11>>0]|0;e=T<<24>>24<0;U=e?c[i>>2]|0:i;T=U+(e?c[i+4>>2]|0:T&255)|0;c[j>>2]=c[K>>2];c[k>>2]=c[L>>2];c[d>>2]=lo(b,j,k,f,g,h,U,T)|0;T=26;break}case 121:{c[M>>2]=c[e>>2];c[k>>2]=c[M>>2];wo(b,h+20|0,d,k,g,P);T=26;break}case 89:{c[N>>2]=c[e>>2];c[k>>2]=c[N>>2];xo(b,h+20|0,d,k,g,P);T=26;break}case 37:{c[O>>2]=c[e>>2];c[k>>2]=c[O>>2];yo(b,d,k,g,P);T=26;break}default:{c[g>>2]=c[g>>2]|4;T=26}}while(0);if((T|0)==26)j=c[d>>2]|0;l=S;return j|0}function bo(b){b=b|0;var d=0;if((a[993872]|0)==0?Ru(993872)|0:0){if((a[993880]|0)==0?Ru(993880)|0:0){d=1166332;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=1166500)}Rt(1166332,26208)|0;Rt(1166344,26215)|0;Rt(1166356,26222)|0;Rt(1166368,26230)|0;Rt(1166380,26240)|0;Rt(1166392,26249)|0;Rt(1166404,26256)|0;Rt(1166416,26265)|0;Rt(1166428,26269)|0;Rt(1166440,26273)|0;Rt(1166452,26277)|0;Rt(1166464,26281)|0;Rt(1166476,26285)|0;Rt(1166488,26289)|0;c[291625]=1166332}return c[291625]|0}function co(b){b=b|0;var d=0;if((a[993856]|0)==0?Ru(993856)|0:0){if((a[993864]|0)==0?Ru(993864)|0:0){d=1166040;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=1166328)}Rt(1166040,26078)|0;Rt(1166052,26086)|0;Rt(1166064,26095)|0;Rt(1166076,26101)|0;Rt(1166088,26107)|0;Rt(1166100,26111)|0;Rt(1166112,26116)|0;Rt(1166124,26121)|0;Rt(1166136,26128)|0;Rt(1166148,26138)|0;Rt(1166160,26146)|0;Rt(1166172,26155)|0;Rt(1166184,26164)|0;Rt(1166196,26168)|0;Rt(1166208,26172)|0;Rt(1166220,26176)|0;Rt(1166232,26107)|0;Rt(1166244,26180)|0;Rt(1166256,26184)|0;Rt(1166268,26188)|0;Rt(1166280,26192)|0;Rt(1166292,26196)|0;Rt(1166304,26200)|0;Rt(1166316,26204)|0;c[291582]=1166040}return c[291582]|0}function eo(b){b=b|0;var d=0;if((a[993840]|0)==0?Ru(993840)|0:0){if((a[993848]|0)==0?Ru(993848)|0:0){d=1165748;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=1166036)}Rt(1165748,26072)|0;Rt(1165760,26075)|0;c[291509]=1165748}return c[291509]|0}function fo(b){b=b|0;if((a[993832]|0)==0?Ru(993832)|0:0){c[291434]=0;c[291435]=0;c[291436]=0;Jt(1165736,26051,20)}return 1165736}function go(b){b=b|0;if((a[993824]|0)==0?Ru(993824)|0:0){c[291431]=0;c[291432]=0;c[291433]=0;Jt(1165724,26039,11)}return 1165724}function ho(b){b=b|0;if((a[993816]|0)==0?Ru(993816)|0:0){c[291428]=0;c[291429]=0;c[291430]=0;Jt(1165712,26030,8)}return 1165712}function io(b){b=b|0;if((a[993808]|0)==0?Ru(993808)|0:0){c[291425]=0;c[291426]=0;c[291427]=0;Jt(1165700,26021,8)}return 1165700}function jo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=l;l=l+16|0;i=h+4|0;j=h;a=a+8|0;a=hb[c[c[a>>2]>>2]&127](a)|0;c[j>>2]=c[e>>2];c[i>>2]=c[j>>2];a=(Pm(d,i,a,a+168|0,g,f,0)|0)-a|0;if((a|0)<168)c[b>>2]=((a|0)/12|0|0)%7|0;l=h;return}function ko(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=l;l=l+16|0;i=h+4|0;j=h;a=a+8|0;a=hb[c[(c[a>>2]|0)+4>>2]&127](a)|0;c[j>>2]=c[e>>2];c[i>>2]=c[j>>2];a=(Pm(d,i,a,a+288|0,g,f,0)|0)-a|0;if((a|0)<288)c[b>>2]=((a|0)/12|0|0)%12|0;l=h;return}function lo(e,f,g,h,i,j,k,m){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;B=l;l=l+16|0;u=B+12|0;t=B+8|0;y=B+4|0;z=B;w=Sk(h)|0;c[u>>2]=w;v=lm(u,1165628)|0;vt(w)|0;c[i>>2]=0;w=v+8|0;n=k;k=0;a:while(1){s=(n|0)!=(m|0);o=k;while(1){k=c[f>>2]|0;if(!(s&(o|0)==0))break a;o=k;if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[f>>2]=0;k=0;o=0}}else k=0;r=(k|0)==0;q=c[g>>2]|0;p=q;do if(q){if((c[q+12>>2]|0)==(c[q+16>>2]|0)?(hb[c[(c[q>>2]|0)+36>>2]&127](q)|0)==-1:0){c[g>>2]=0;p=0;A=13;break}if(!r){A=14;break a}}else A=13;while(0);if((A|0)==13){A=0;if(r){A=14;break a}else q=0}if((ab[c[(c[v>>2]|0)+36>>2]&31](v,a[n>>0]|0,0)|0)<<24>>24==37){A=16;break}o=a[n>>0]|0;if(o<<24>>24>-1?(x=c[w>>2]|0,b[x+(o<<24>>24<<1)>>1]&8192):0){A=25;break}p=k+12|0;o=c[p>>2]|0;q=k+16|0;if((o|0)==(c[q>>2]|0))o=hb[c[(c[k>>2]|0)+36>>2]&127](k)|0;else o=d[o>>0]|0;r=nb[c[(c[v>>2]|0)+12>>2]&63](v,o&255)|0;if(r<<24>>24==(nb[c[(c[v>>2]|0)+12>>2]&63](v,a[n>>0]|0)|0)<<24>>24){A=52;break}c[i>>2]=4;o=4}b:do if((A|0)==16){A=0;s=n+1|0;if((s|0)==(m|0)){A=17;break a}q=ab[c[(c[v>>2]|0)+36>>2]&31](v,a[s>>0]|0,0)|0;switch(q<<24>>24){case 48:case 69:{n=n+2|0;if((n|0)==(m|0)){A=22;break a}r=q;k=ab[c[(c[v>>2]|0)+36>>2]&31](v,a[n>>0]|0,0)|0;n=s;break}default:{r=0;k=q}}s=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=o;c[z>>2]=p;c[t>>2]=c[y>>2];c[u>>2]=c[z>>2];c[f>>2]=kb[s&15](e,t,u,h,i,j,k,r)|0;k=n+2|0}else if((A|0)==25){while(1){A=0;n=n+1|0;if((n|0)==(m|0)){n=m;break}o=a[n>>0]|0;if(o<<24>>24<=-1)break;if(!(b[x+(o<<24>>24<<1)>>1]&8192))break;else A=25}o=q;while(1){if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[f>>2]=0;k=0}}else k=0;p=(k|0)==0;do if(q){if((c[q+12>>2]|0)!=(c[q+16>>2]|0))if(p){s=o;break}else{k=n;break b}if((hb[c[(c[q>>2]|0)+36>>2]&127](q)|0)!=-1)if(p^(o|0)==0){s=o;q=o;break}else{k=n;break b}else{c[g>>2]=0;o=0;A=38;break}}else A=38;while(0);if((A|0)==38){A=0;if(p){k=n;break b}else{s=o;q=0}}p=k+12|0;o=c[p>>2]|0;r=k+16|0;if((o|0)==(c[r>>2]|0))o=hb[c[(c[k>>2]|0)+36>>2]&127](k)|0;else o=d[o>>0]|0;if((o&255)<<24>>24<=-1){k=n;break b}if(!(b[(c[w>>2]|0)+(o<<24>>24<<1)>>1]&8192)){k=n;break b}o=c[p>>2]|0;if((o|0)==(c[r>>2]|0)){hb[c[(c[k>>2]|0)+40>>2]&127](k)|0;o=s;continue}else{c[p>>2]=o+1;o=s;continue}}}else if((A|0)==52){A=0;o=c[p>>2]|0;if((o|0)==(c[q>>2]|0))hb[c[(c[k>>2]|0)+40>>2]&127](k)|0;else c[p>>2]=o+1;k=n+1|0}while(0);n=k;k=c[i>>2]|0}if((A|0)==14)c[i>>2]=4;else if((A|0)==17)c[i>>2]=4;else if((A|0)==22)c[i>>2]=4;if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[f>>2]=0;k=0}}else k=0;n=(k|0)==0;o=c[g>>2]|0;do if(o){if((c[o+12>>2]|0)==(c[o+16>>2]|0)?(hb[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1:0){c[g>>2]=0;A=67;break}if(!n)A=68}else A=67;while(0);if((A|0)==67?n:0)A=68;if((A|0)==68)c[i>>2]=c[i>>2]|2;l=B;return k|0}function mo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,2)|0;d=c[f>>2]|0;if((a+-1|0)>>>0<31&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function no(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<24&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function oo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,2)|0;d=c[f>>2]|0;if((a+-1|0)>>>0<12&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function po(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,3)|0;d=c[f>>2]|0;if((a|0)<366&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function qo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<13&(d&4|0)==0)c[b>>2]=a+-1;else c[f>>2]=d|4;l=h;return}function ro(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<60&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function so(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0;j=h+8|0;a:while(1){a=c[e>>2]|0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0))if((hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){c[e>>2]=0;a=0;break}else{a=c[e>>2]|0;break}}else a=0;while(0);a=(a|0)==0;h=c[f>>2]|0;do if(h){if((c[h+12>>2]|0)!=(c[h+16>>2]|0))if(a)break;else break a;if((hb[c[(c[h>>2]|0)+36>>2]&127](h)|0)!=-1)if(a)break;else break a;else{c[f>>2]=0;k=12;break}}else k=12;while(0);if((k|0)==12){k=0;if(a){h=0;break}else h=0}a=c[e>>2]|0;i=c[a+12>>2]|0;if((i|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=d[i>>0]|0;if((a&255)<<24>>24<=-1)break;if(!(b[(c[j>>2]|0)+(a<<24>>24<<1)>>1]&8192))break;a=c[e>>2]|0;h=a+12|0;i=c[h>>2]|0;if((i|0)==(c[a+16>>2]|0)){hb[c[(c[a>>2]|0)+40>>2]&127](a)|0;continue}else{c[h>>2]=i+1;continue}}a=c[e>>2]|0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0))if((hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){c[e>>2]=0;a=0;break}else{a=c[e>>2]|0;break}}else a=0;while(0);a=(a|0)==0;do if(h){if((c[h+12>>2]|0)==(c[h+16>>2]|0)?(hb[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1:0){c[f>>2]=0;k=32;break}if(!a)k=33}else k=32;while(0);if((k|0)==32?a:0)k=33;if((k|0)==33)c[g>>2]=c[g>>2]|2;return}function to(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;k=n+4|0;m=n;j=b+8|0;j=hb[c[(c[j>>2]|0)+8>>2]&127](j)|0;b=a[j+11>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+12+11>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){c[m>>2]=c[f>>2];c[k>>2]=c[m>>2];b=(Pm(e,k,j,j+24|0,h,g,0)|0)-j|0;i=c[d>>2]|0;if((i|0)==12&(b|0)==0){c[d>>2]=0;break}if((i|0)<12&(b|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);l=n;return}function uo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<61&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function vo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,1)|0;d=c[f>>2]|0;if((a|0)<7&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function wo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,4)|0;if(!(c[f>>2]&4)){if((a|0)<69)a=a+2e3|0;else a=(a|0)<100?a+1900|0:a;c[b>>2]=a+-1900}l=h;return}function xo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=zo(d,a,f,g,4)|0;if(!(c[f>>2]&4))c[b>>2]=a+-1900;l=h;return}function yo(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;a=c[b>>2]|0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0))if((hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){c[b>>2]=0;a=0;break}else{a=c[b>>2]|0;break}}else a=0;while(0);h=(a|0)==0;a=c[e>>2]|0;do if(a){if((c[a+12>>2]|0)==(c[a+16>>2]|0)?(hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1:0){c[e>>2]=0;j=11;break}if(h){i=a;j=13}else j=12}else j=11;while(0);if((j|0)==11)if(h)j=12;else{i=0;j=13}a:do if((j|0)==12)c[f>>2]=c[f>>2]|6;else if((j|0)==13){a=c[b>>2]|0;h=c[a+12>>2]|0;if((h|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=d[h>>0]|0;if((ab[c[(c[g>>2]|0)+36>>2]&31](g,a&255,0)|0)<<24>>24!=37){c[f>>2]=c[f>>2]|4;break}a=c[b>>2]|0;h=a+12|0;g=c[h>>2]|0;if((g|0)==(c[a+16>>2]|0)){hb[c[(c[a>>2]|0)+40>>2]&127](a)|0;a=c[b>>2]|0;if(!a)a=0;else j=21}else{c[h>>2]=g+1;j=21}do if((j|0)==21)if((c[a+12>>2]|0)==(c[a+16>>2]|0))if((hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){c[b>>2]=0;a=0;break}else{a=c[b>>2]|0;break}while(0);a=(a|0)==0;do if(i){if((c[i+12>>2]|0)==(c[i+16>>2]|0)?(hb[c[(c[i>>2]|0)+36>>2]&127](i)|0)==-1:0){c[e>>2]=0;j=30;break}if(a)break a}else j=30;while(0);if((j|0)==30?!a:0)break;c[f>>2]=c[f>>2]|2}while(0);return}function zo(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;i=c[a>>2]|0;do if(i){if((c[i+12>>2]|0)==(c[i+16>>2]|0))if((hb[c[(c[i>>2]|0)+36>>2]&127](i)|0)==-1){c[a>>2]=0;i=0;break}else{i=c[a>>2]|0;break}}else i=0;while(0);j=(i|0)==0;i=c[e>>2]|0;do if(i){if((c[i+12>>2]|0)==(c[i+16>>2]|0)?(hb[c[(c[i>>2]|0)+36>>2]&127](i)|0)==-1:0){c[e>>2]=0;r=11;break}if(j)r=13;else r=12}else r=11;while(0);if((r|0)==11)if(j)r=12;else{i=0;r=13}a:do if((r|0)==12){c[f>>2]=c[f>>2]|6;i=0}else if((r|0)==13){j=c[a>>2]|0;k=c[j+12>>2]|0;if((k|0)==(c[j+16>>2]|0))j=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[k>>0]|0;k=j&255;if(k<<24>>24>-1?(q=g+8|0,b[(c[q>>2]|0)+(j<<24>>24<<1)>>1]&2048):0){j=(ab[c[(c[g>>2]|0)+36>>2]&31](g,k,0)|0)<<24>>24;k=c[a>>2]|0;l=k+12|0;m=c[l>>2]|0;if((m|0)==(c[k+16>>2]|0)){hb[c[(c[k>>2]|0)+40>>2]&127](k)|0;m=i;l=i}else{c[l>>2]=m+1;m=i;l=i}while(1){i=j+-48|0;o=h+-1|0;j=c[a>>2]|0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[a>>2]=0;j=0;break}else{j=c[a>>2]|0;break}}else j=0;while(0);k=(j|0)==0;if(l)if((c[l+12>>2]|0)==(c[l+16>>2]|0))if((hb[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;p=0;n=0}else{p=m;n=m}else{p=m;n=l}else{p=m;n=0}j=c[a>>2]|0;if(!((h|0)>1&(k^(n|0)==0)))break;k=c[j+12>>2]|0;if((k|0)==(c[j+16>>2]|0))j=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else j=d[k>>0]|0;k=j&255;if(k<<24>>24<=-1)break a;if(!(b[(c[q>>2]|0)+(j<<24>>24<<1)>>1]&2048))break a;j=((ab[c[(c[g>>2]|0)+36>>2]&31](g,k,0)|0)<<24>>24)+(i*10|0)|0;i=c[a>>2]|0;k=i+12|0;l=c[k>>2]|0;if((l|0)==(c[i+16>>2]|0)){hb[c[(c[i>>2]|0)+40>>2]&127](i)|0;h=o;m=p;l=n;continue}else{c[k>>2]=l+1;h=o;m=p;l=n;continue}}do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0))if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1){c[a>>2]=0;j=0;break}else{j=c[a>>2]|0;break}}else j=0;while(0);j=(j|0)==0;do if(p){if((c[p+12>>2]|0)==(c[p+16>>2]|0)?(hb[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1:0){c[e>>2]=0;r=50;break}if(j)break a}else r=50;while(0);if((r|0)==50?!j:0)break;c[f>>2]=c[f>>2]|2;break}c[f>>2]=c[f>>2]|4;i=0}while(0);return i|0}function Ao(a){a=a|0;return}function Bo(a){a=a|0;Dt(a);return}function Co(a){a=a|0;return 2}function Do(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=So(a,j,i,e,f,g,18688,18720)|0;l=h;return g|0}function Eo(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;i=l;l=l+16|0;j=i+12|0;k=i+8|0;n=i+4|0;m=i;o=b+8|0;o=hb[c[(c[o>>2]|0)+20>>2]&127](o)|0;c[n>>2]=c[d>>2];c[m>>2]=c[e>>2];e=a[o+8+3>>0]|0;p=e<<24>>24<0;d=p?c[o>>2]|0:o;e=d+((p?c[o+4>>2]|0:e&255)<<2)|0;c[k>>2]=c[n>>2];c[j>>2]=c[m>>2];h=So(b,k,j,f,g,h,d,e)|0;l=i;return h|0}function Fo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;h=l;l=l+16|0;i=h+4|0;j=h;k=Sk(e)|0;c[i>>2]=k;e=lm(i,1165660)|0;vt(k)|0;c[j>>2]=c[d>>2];c[i>>2]=c[j>>2];Qo(a,g+24|0,b,i,f,e);l=h;return c[b>>2]|0}function Go(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;h=l;l=l+16|0;i=h+4|0;j=h;k=Sk(e)|0;c[i>>2]=k;e=lm(i,1165660)|0;vt(k)|0;c[j>>2]=c[d>>2];c[i>>2]=c[j>>2];Ro(a,g+16|0,b,i,f,e);l=h;return c[b>>2]|0}function Ho(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;h=l;l=l+16|0;i=h+4|0;j=h;k=Sk(e)|0;c[i>>2]=k;e=lm(i,1165660)|0;vt(k)|0;c[j>>2]=c[d>>2];c[i>>2]=c[j>>2];bp(a,g+20|0,b,i,f,e);l=h;return c[b>>2]|0}function Io(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;S=l;l=l+144|0;k=S+128|0;j=S+112|0;Q=S+124|0;R=S+120|0;m=S+116|0;n=S+108|0;o=S+104|0;p=S+100|0;q=S+96|0;r=S+92|0;s=S+88|0;t=S+84|0;u=S+80|0;v=S+76|0;w=S+72|0;x=S+68|0;y=S+64|0;z=S+60|0;A=S+56|0;B=S+52|0;C=S+48|0;D=S+44|0;E=S+40|0;F=S+36|0;G=S+32|0;H=S+28|0;I=S+24|0;J=S+20|0;K=S+16|0;L=S+12|0;M=S+8|0;N=S+4|0;O=S;c[g>>2]=0;U=Sk(f)|0;c[k>>2]=U;P=lm(k,1165660)|0;vt(U)|0;do switch(i<<24>>24|0){case 65:case 97:{c[Q>>2]=c[e>>2];c[k>>2]=c[Q>>2];Qo(b,h+24|0,d,k,g,P);T=26;break}case 104:case 66:case 98:{c[R>>2]=c[e>>2];c[k>>2]=c[R>>2];Ro(b,h+16|0,d,k,g,P);T=26;break}case 99:{i=b+8|0;i=hb[c[(c[i>>2]|0)+12>>2]&127](i)|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];T=a[i+8+3>>0]|0;e=T<<24>>24<0;U=e?c[i>>2]|0:i;T=U+((e?c[i+4>>2]|0:T&255)<<2)|0;c[j>>2]=c[m>>2];c[k>>2]=c[n>>2];c[d>>2]=So(b,j,k,f,g,h,U,T)|0;T=26;break}case 101:case 100:{c[o>>2]=c[e>>2];c[k>>2]=c[o>>2];To(b,h+12|0,d,k,g,P);T=26;break}case 68:{c[p>>2]=c[d>>2];c[q>>2]=c[e>>2];c[j>>2]=c[p>>2];c[k>>2]=c[q>>2];c[d>>2]=So(b,j,k,f,g,h,18528,18560)|0;T=26;break}case 70:{c[r>>2]=c[d>>2];c[s>>2]=c[e>>2];c[j>>2]=c[r>>2];c[k>>2]=c[s>>2];c[d>>2]=So(b,j,k,f,g,h,18560,18592)|0;T=26;break}case 72:{c[t>>2]=c[e>>2];c[k>>2]=c[t>>2];Uo(b,h+8|0,d,k,g,P);T=26;break}case 73:{c[u>>2]=c[e>>2];c[k>>2]=c[u>>2];Vo(b,h+8|0,d,k,g,P);T=26;break}case 106:{c[v>>2]=c[e>>2];c[k>>2]=c[v>>2];Wo(b,h+28|0,d,k,g,P);T=26;break}case 109:{c[w>>2]=c[e>>2];c[k>>2]=c[w>>2];Xo(b,h+16|0,d,k,g,P);T=26;break}case 77:{c[x>>2]=c[e>>2];c[k>>2]=c[x>>2];Yo(b,h+4|0,d,k,g,P);T=26;break}case 116:case 110:{c[y>>2]=c[e>>2];c[k>>2]=c[y>>2];Zo(b,d,k,g,P);T=26;break}case 112:{c[z>>2]=c[e>>2];c[k>>2]=c[z>>2];_o(b,h+8|0,d,k,g,P);T=26;break}case 114:{c[A>>2]=c[d>>2];c[B>>2]=c[e>>2];c[j>>2]=c[A>>2];c[k>>2]=c[B>>2];c[d>>2]=So(b,j,k,f,g,h,18592,18636)|0;T=26;break}case 82:{c[C>>2]=c[d>>2];c[D>>2]=c[e>>2];c[j>>2]=c[C>>2];c[k>>2]=c[D>>2];c[d>>2]=So(b,j,k,f,g,h,18636,18656)|0;T=26;break}case 83:{c[E>>2]=c[e>>2];c[k>>2]=c[E>>2];$o(b,h,d,k,g,P);T=26;break}case 84:{c[F>>2]=c[d>>2];c[G>>2]=c[e>>2];c[j>>2]=c[F>>2];c[k>>2]=c[G>>2];c[d>>2]=So(b,j,k,f,g,h,18656,18688)|0;T=26;break}case 119:{c[H>>2]=c[e>>2];c[k>>2]=c[H>>2];ap(b,h+24|0,d,k,g,P);T=26;break}case 120:{U=c[(c[b>>2]|0)+20>>2]|0;c[I>>2]=c[d>>2];c[J>>2]=c[e>>2];c[j>>2]=c[I>>2];c[k>>2]=c[J>>2];j=fb[U&63](b,j,k,f,g,h)|0;break}case 88:{i=b+8|0;i=hb[c[(c[i>>2]|0)+24>>2]&127](i)|0;c[K>>2]=c[d>>2];c[L>>2]=c[e>>2];T=a[i+8+3>>0]|0;e=T<<24>>24<0;U=e?c[i>>2]|0:i;T=U+((e?c[i+4>>2]|0:T&255)<<2)|0;c[j>>2]=c[K>>2];c[k>>2]=c[L>>2];c[d>>2]=So(b,j,k,f,g,h,U,T)|0;T=26;break}case 121:{c[M>>2]=c[e>>2];c[k>>2]=c[M>>2];bp(b,h+20|0,d,k,g,P);T=26;break}case 89:{c[N>>2]=c[e>>2];c[k>>2]=c[N>>2];cp(b,h+20|0,d,k,g,P);T=26;break}case 37:{c[O>>2]=c[e>>2];c[k>>2]=c[O>>2];dp(b,d,k,g,P);T=26;break}default:{c[g>>2]=c[g>>2]|4;T=26}}while(0);if((T|0)==26)j=c[d>>2]|0;l=S;return j|0}function Jo(b){b=b|0;var d=0;if((a[993952]|0)==0?Ru(993952)|0:0){if((a[993960]|0)==0?Ru(993960)|0:0){d=1167144;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=1167312)}ku(1167144,18188)|0;ku(1167156,18216)|0;ku(1167168,18244)|0;ku(1167180,18276)|0;ku(1167192,18316)|0;ku(1167204,18352)|0;ku(1167216,18380)|0;ku(1167228,18416)|0;ku(1167240,18432)|0;ku(1167252,18448)|0;ku(1167264,18464)|0;ku(1167276,18480)|0;ku(1167288,18496)|0;ku(1167300,18512)|0;c[291828]=1167144}return c[291828]|0}function Ko(b){b=b|0;var d=0;if((a[993936]|0)==0?Ru(993936)|0:0){if((a[993944]|0)==0?Ru(993944)|0:0){d=1166852;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=1167140)}ku(1166852,17668)|0;ku(1166864,17700)|0;ku(1166876,17736)|0;ku(1166888,17760)|0;ku(1166900,17784)|0;ku(1166912,17800)|0;ku(1166924,17820)|0;ku(1166936,17840)|0;ku(1166948,17868)|0;ku(1166960,17908)|0;ku(1166972,17940)|0;ku(1166984,17976)|0;ku(1166996,18012)|0;ku(1167008,18028)|0;ku(1167020,18044)|0;ku(1167032,18060)|0;ku(1167044,17784)|0;ku(1167056,18076)|0;ku(1167068,18092)|0;ku(1167080,18108)|0;ku(1167092,18124)|0;ku(1167104,18140)|0;ku(1167116,18156)|0;ku(1167128,18172)|0;c[291785]=1166852}return c[291785]|0}function Lo(b){b=b|0;var d=0;if((a[993920]|0)==0?Ru(993920)|0:0){if((a[993928]|0)==0?Ru(993928)|0:0){d=1166560;do{c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}d=d+12|0}while((d|0)!=1166848)}ku(1166560,17644)|0;ku(1166572,17656)|0;c[291712]=1166560}return c[291712]|0}function Mo(b){b=b|0;if((a[993912]|0)==0?Ru(993912)|0:0){c[291637]=0;c[291638]=0;c[291639]=0;cu(1166548,17560,oi(17560)|0)}return 1166548}function No(b){b=b|0;if((a[993904]|0)==0?Ru(993904)|0:0){c[291634]=0;c[291635]=0;c[291636]=0;cu(1166536,17512,oi(17512)|0)}return 1166536}function Oo(b){b=b|0;if((a[993896]|0)==0?Ru(993896)|0:0){c[291631]=0;c[291632]=0;c[291633]=0;cu(1166524,17476,oi(17476)|0)}return 1166524}function Po(b){b=b|0;if((a[993888]|0)==0?Ru(993888)|0:0){c[291628]=0;c[291629]=0;c[291630]=0;cu(1166512,17440,oi(17440)|0)}return 1166512}function Qo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=l;l=l+16|0;i=h+4|0;j=h;a=a+8|0;a=hb[c[c[a>>2]>>2]&127](a)|0;c[j>>2]=c[e>>2];c[i>>2]=c[j>>2];a=(pn(d,i,a,a+168|0,g,f,0)|0)-a|0;if((a|0)<168)c[b>>2]=((a|0)/12|0|0)%7|0;l=h;return}function Ro(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=l;l=l+16|0;i=h+4|0;j=h;a=a+8|0;a=hb[c[(c[a>>2]|0)+4>>2]&127](a)|0;c[j>>2]=c[e>>2];c[i>>2]=c[j>>2];a=(pn(d,i,a,a+288|0,g,f,0)|0)-a|0;if((a|0)<288)c[b>>2]=((a|0)/12|0|0)%12|0;l=h;return}function So(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+16|0;s=x+12|0;r=x+8|0;u=x+4|0;v=x;j=Sk(e)|0;c[s>>2]=j;t=lm(s,1165660)|0;vt(j)|0;c[f>>2]=0;j=0;a:while(1){q=(h|0)!=(i|0);k=j;while(1){j=c[b>>2]|0;if(!(q&(k|0)==0))break a;m=j;if(j){k=c[j+12>>2]|0;if((k|0)==(c[j+16>>2]|0))k=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else k=c[k>>2]|0;if((k|0)==-1){c[b>>2]=0;j=0;o=1;p=0}else{o=0;p=m}}else{j=0;o=1;p=m}n=c[d>>2]|0;k=n;do if(n){m=c[n+12>>2]|0;if((m|0)==(c[n+16>>2]|0))m=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else m=c[m>>2]|0;if((m|0)!=-1)if(o)break;else{w=18;break a}else{c[d>>2]=0;k=0;w=16;break}}else w=16;while(0);if((w|0)==16){w=0;if(o){w=18;break a}else n=0}if((ab[c[(c[t>>2]|0)+52>>2]&31](t,c[h>>2]|0,0)|0)<<24>>24==37){w=20;break}if(ab[c[(c[t>>2]|0)+12>>2]&31](t,8192,c[h>>2]|0)|0){w=28;break}m=j+12|0;k=c[m>>2]|0;n=j+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else k=c[k>>2]|0;p=nb[c[(c[t>>2]|0)+28>>2]&63](t,k)|0;if((p|0)==(nb[c[(c[t>>2]|0)+28>>2]&63](t,c[h>>2]|0)|0)){w=56;break}c[f>>2]=4;k=4}b:do if((w|0)==20){w=0;o=h+4|0;if((o|0)==(i|0)){w=21;break a}m=ab[c[(c[t>>2]|0)+52>>2]&31](t,c[o>>2]|0,0)|0;switch(m<<24>>24){case 48:case 69:{h=h+8|0;if((h|0)==(i|0)){w=26;break a}n=m;j=ab[c[(c[t>>2]|0)+52>>2]&31](t,c[h>>2]|0,0)|0;h=o;break}default:{n=0;j=m}}q=c[(c[a>>2]|0)+36>>2]|0;c[u>>2]=p;c[v>>2]=k;c[r>>2]=c[u>>2];c[s>>2]=c[v>>2];c[b>>2]=kb[q&15](a,r,s,e,f,g,j,n)|0;h=h+8|0}else if((w|0)==28){while(1){w=0;h=h+4|0;if((h|0)==(i|0)){h=i;break}if(ab[c[(c[t>>2]|0)+12>>2]&31](t,8192,c[h>>2]|0)|0)w=28;else break}k=n;o=n;while(1){if(j){m=c[j+12>>2]|0;if((m|0)==(c[j+16>>2]|0))m=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else m=c[m>>2]|0;if((m|0)==-1){c[b>>2]=0;n=1;j=0}else n=0}else{n=1;j=0}do if(o){m=c[o+12>>2]|0;if((m|0)==(c[o+16>>2]|0))m=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else m=c[m>>2]|0;if((m|0)!=-1)if(n^(k|0)==0){p=k;o=k;break}else break b;else{c[d>>2]=0;k=0;w=43;break}}else w=43;while(0);if((w|0)==43){w=0;if(n)break b;else{p=k;o=0}}m=j+12|0;k=c[m>>2]|0;n=j+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else k=c[k>>2]|0;if(!(ab[c[(c[t>>2]|0)+12>>2]&31](t,8192,k)|0))break b;k=c[m>>2]|0;if((k|0)==(c[n>>2]|0)){hb[c[(c[j>>2]|0)+40>>2]&127](j)|0;k=p;continue}else{c[m>>2]=k+4;k=p;continue}}}else if((w|0)==56){w=0;k=c[m>>2]|0;if((k|0)==(c[n>>2]|0))hb[c[(c[j>>2]|0)+40>>2]&127](j)|0;else c[m>>2]=k+4;h=h+4|0}while(0);j=c[f>>2]|0}if((w|0)==18)c[f>>2]=4;else if((w|0)==21)c[f>>2]=4;else if((w|0)==26)c[f>>2]=4;if(j){h=c[j+12>>2]|0;if((h|0)==(c[j+16>>2]|0))h=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else h=c[h>>2]|0;if((h|0)==-1){c[b>>2]=0;j=0;m=1}else m=0}else{j=0;m=1}h=c[d>>2]|0;do if(h){k=c[h+12>>2]|0;if((k|0)==(c[h+16>>2]|0))h=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else h=c[k>>2]|0;if((h|0)!=-1)if(m)break;else{w=76;break}else{c[d>>2]=0;w=74;break}}else w=74;while(0);if((w|0)==74?m:0)w=76;if((w|0)==76)c[f>>2]=c[f>>2]|2;l=x;return j|0}function To(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,2)|0;d=c[f>>2]|0;if((a+-1|0)>>>0<31&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function Uo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<24&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function Vo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,2)|0;d=c[f>>2]|0;if((a+-1|0)>>>0<12&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function Wo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,3)|0;d=c[f>>2]|0;if((a|0)<366&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function Xo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<13&(d&4|0)==0)c[b>>2]=a+-1;else c[f>>2]=d|4;l=h;return}function Yo(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<60&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function Zo(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;a:while(1){a=c[b>>2]|0;do if(a){g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((a|0)==-1){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}else h=1;while(0);g=c[d>>2]|0;do if(g){a=c[g+12>>2]|0;if((a|0)==(c[g+16>>2]|0))a=hb[c[(c[g>>2]|0)+36>>2]&127](g)|0;else a=c[a>>2]|0;if((a|0)!=-1)if(h){h=g;break}else{h=g;break a}else{c[d>>2]=0;i=15;break}}else i=15;while(0);if((i|0)==15){i=0;if(h){h=0;break}else h=0}a=c[b>>2]|0;g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if(!(ab[c[(c[f>>2]|0)+12>>2]&31](f,8192,a)|0))break;a=c[b>>2]|0;g=a+12|0;h=c[g>>2]|0;if((h|0)==(c[a+16>>2]|0)){hb[c[(c[a>>2]|0)+40>>2]&127](a)|0;continue}else{c[g>>2]=h+4;continue}}a=c[b>>2]|0;do if(a){g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((a|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(h){a=c[h+12>>2]|0;if((a|0)==(c[h+16>>2]|0))a=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else a=c[a>>2]|0;if((a|0)!=-1)if(g)break;else{i=39;break}else{c[d>>2]=0;i=37;break}}else i=37;while(0);if((i|0)==37?g:0)i=39;if((i|0)==39)c[e>>2]=c[e>>2]|2;return}function _o(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;k=n+4|0;m=n;j=b+8|0;j=hb[c[(c[j>>2]|0)+8>>2]&127](j)|0;b=a[j+8+3>>0]|0;if(b<<24>>24<0)i=c[j+4>>2]|0;else i=b&255;b=a[j+20+3>>0]|0;if(b<<24>>24<0)b=c[j+16>>2]|0;else b=b&255;do if((i|0)!=(0-b|0)){c[m>>2]=c[f>>2];c[k>>2]=c[m>>2];b=(pn(e,k,j,j+24|0,h,g,0)|0)-j|0;i=c[d>>2]|0;if((i|0)==12&(b|0)==0){c[d>>2]=0;break}if((i|0)<12&(b|0)==12)c[d>>2]=i+12}else c[g>>2]=c[g>>2]|4;while(0);l=n;return}function $o(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,2)|0;d=c[f>>2]|0;if((a|0)<61&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function ap(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,1)|0;d=c[f>>2]|0;if((a|0)<7&(d&4|0)==0)c[b>>2]=a;else c[f>>2]=d|4;l=h;return}function bp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,4)|0;if(!(c[f>>2]&4)){if((a|0)<69)a=a+2e3|0;else a=(a|0)<100?a+1900|0:a;c[b>>2]=a+-1900}l=h;return}function cp(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=l;l=l+16|0;a=h+4|0;i=h;c[i>>2]=c[e>>2];c[a>>2]=c[i>>2];a=ep(d,a,f,g,4)|0;if(!(c[f>>2]&4))c[b>>2]=a+-1900;l=h;return}function dp(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;a=c[b>>2]|0;do if(a){g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((a|0)==-1){c[b>>2]=0;h=1;break}else{h=(c[b>>2]|0)==0;break}}else h=1;while(0);g=c[d>>2]|0;do if(g){a=c[g+12>>2]|0;if((a|0)==(c[g+16>>2]|0))a=hb[c[(c[g>>2]|0)+36>>2]&127](g)|0;else a=c[a>>2]|0;if((a|0)!=-1)if(h){i=g;j=17;break}else{j=16;break}else{c[d>>2]=0;j=14;break}}else j=14;while(0);if((j|0)==14)if(h)j=16;else{i=0;j=17}a:do if((j|0)==16)c[e>>2]=c[e>>2]|6;else if((j|0)==17){a=c[b>>2]|0;g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((ab[c[(c[f>>2]|0)+52>>2]&31](f,a,0)|0)<<24>>24!=37){c[e>>2]=c[e>>2]|4;break}a=c[b>>2]|0;g=a+12|0;h=c[g>>2]|0;if((h|0)==(c[a+16>>2]|0)){hb[c[(c[a>>2]|0)+40>>2]&127](a)|0;a=c[b>>2]|0;if(!a)g=1;else j=25}else{c[g>>2]=h+4;j=25}do if((j|0)==25){g=c[a+12>>2]|0;if((g|0)==(c[a+16>>2]|0))a=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;else a=c[g>>2]|0;if((a|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}while(0);do if(i){a=c[i+12>>2]|0;if((a|0)==(c[i+16>>2]|0))a=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else a=c[a>>2]|0;if((a|0)!=-1)if(g)break a;else break;else{c[d>>2]=0;j=37;break}}else j=37;while(0);if((j|0)==37?!g:0)break;c[e>>2]=c[e>>2]|2}while(0);return}function ep(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=c[a>>2]|0;do if(g){h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=hb[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[h>>2]|0;if((g|0)==-1){c[a>>2]=0;i=1;break}else{i=(c[a>>2]|0)==0;break}}else i=1;while(0);h=c[b>>2]|0;do if(h){g=c[h+12>>2]|0;if((g|0)==(c[h+16>>2]|0))g=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(i){p=17;break}else{p=16;break}else{c[b>>2]=0;p=14;break}}else p=14;while(0);if((p|0)==14)if(i)p=16;else{h=0;p=17}a:do if((p|0)==16){c[d>>2]=c[d>>2]|6;g=0}else if((p|0)==17){g=c[a>>2]|0;i=c[g+12>>2]|0;if((i|0)==(c[g+16>>2]|0))g=hb[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=c[i>>2]|0;if(!(ab[c[(c[e>>2]|0)+12>>2]&31](e,2048,g)|0)){c[d>>2]=c[d>>2]|4;g=0;break}g=(ab[c[(c[e>>2]|0)+52>>2]&31](e,g,0)|0)<<24>>24;i=c[a>>2]|0;j=i+12|0;k=c[j>>2]|0;if((k|0)==(c[i+16>>2]|0)){hb[c[(c[i>>2]|0)+40>>2]&127](i)|0;l=h;j=h}else{c[j>>2]=k+4;l=h;j=h}while(1){g=g+-48|0;o=f+-1|0;h=c[a>>2]|0;do if(h){i=c[h+12>>2]|0;if((i|0)==(c[h+16>>2]|0))h=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else h=c[i>>2]|0;if((h|0)==-1){c[a>>2]=0;k=1;break}else{k=(c[a>>2]|0)==0;break}}else k=1;while(0);do if(j){h=c[j+12>>2]|0;if((h|0)==(c[j+16>>2]|0))h=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else h=c[h>>2]|0;if((h|0)==-1){c[b>>2]=0;n=0;m=0;h=1;break}else{n=l;m=l;h=(l|0)==0;break}}else{n=l;m=0;h=1}while(0);i=c[a>>2]|0;if(!((f|0)>1&(k^h)))break;h=c[i+12>>2]|0;if((h|0)==(c[i+16>>2]|0))h=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else h=c[h>>2]|0;if(!(ab[c[(c[e>>2]|0)+12>>2]&31](e,2048,h)|0))break a;g=((ab[c[(c[e>>2]|0)+52>>2]&31](e,h,0)|0)<<24>>24)+(g*10|0)|0;h=c[a>>2]|0;i=h+12|0;j=c[i>>2]|0;if((j|0)==(c[h+16>>2]|0)){hb[c[(c[h>>2]|0)+40>>2]&127](h)|0;f=o;l=n;j=m;continue}else{c[i>>2]=j+4;f=o;l=n;j=m;continue}}do if(i){h=c[i+12>>2]|0;if((h|0)==(c[i+16>>2]|0))h=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else h=c[h>>2]|0;if((h|0)==-1){c[a>>2]=0;i=1;break}else{i=(c[a>>2]|0)==0;break}}else i=1;while(0);do if(n){h=c[n+12>>2]|0;if((h|0)==(c[n+16>>2]|0))h=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else h=c[h>>2]|0;if((h|0)!=-1)if(i)break a;else break;else{c[b>>2]=0;p=60;break}}else p=60;while(0);if((p|0)==60?!i:0)break;c[d>>2]=c[d>>2]|2}while(0);return g|0}function fp(a){a=a|0;jp(a+8|0);return}function gp(a){a=a|0;jp(a+8|0);Dt(a);return}function hp(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;j=l;l=l+112|0;e=j+4|0;f=j;c[f>>2]=e+100;ip(b+8|0,e,f,g,h,i);i=c[f>>2]|0;h=e;e=c[d>>2]|0;while(1){if((h|0)==(i|0))break;f=a[h>>0]|0;do if(e){b=e+24|0;g=c[b>>2]|0;if((g|0)==(c[e+28>>2]|0)){d=(nb[c[(c[e>>2]|0)+52>>2]&63](e,f&255)|0)==-1;e=d?0:e;break}else{c[b>>2]=g+1;a[g>>0]=f;break}}else e=0;while(0);h=h+1|0}l=j;return e|0}function ip(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0;m=l;l=l+16|0;i=m;a[i>>0]=37;j=i+1|0;a[j>>0]=g;k=i+2|0;a[k>>0]=h;a[i+3>>0]=0;if(h<<24>>24){a[j>>0]=h;a[k>>0]=g}c[e>>2]=d+(Da(d|0,(c[e>>2]|0)-d|0,i|0,f|0,c[b>>2]|0)|0);l=m;return}function jp(a){a=a|0;var b=0;b=c[a>>2]|0;if((b|0)!=(nm()|0))qj(c[a>>2]|0);return}function kp(a){a=a|0;jp(a+8|0);return}function lp(a){a=a|0;jp(a+8|0);Dt(a);return}function mp(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0;i=l;l=l+416|0;d=i+8|0;e=i;c[e>>2]=d+400;np(a+8|0,d,e,f,g,h);h=c[e>>2]|0;g=d;d=c[b>>2]|0;while(1){if((g|0)==(h|0))break;e=c[g>>2]|0;if(!d)d=0;else{a=d+24|0;f=c[a>>2]|0;if((f|0)==(c[d+28>>2]|0))e=nb[c[(c[d>>2]|0)+52>>2]&63](d,e)|0;else{c[a>>2]=f+4;c[f>>2]=e}d=(e|0)==-1?0:d}g=g+4|0}l=i;return d|0}function np(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+128|0;k=h+16|0;m=h+12|0;i=h;j=h+8|0;c[m>>2]=k+100;ip(a,k,m,e,f,g);e=i;c[e>>2]=0;c[e+4>>2]=0;c[j>>2]=k;e=(c[d>>2]|0)-b>>2;a=nj(c[a>>2]|0)|0;e=bj(b,j,e,i)|0;if(a|0)nj(a)|0;c[d>>2]=b+(e<<2);l=h;return}function op(a){a=a|0;return}function pp(a){a=a|0;Dt(a);return}function qp(a){a=a|0;return 127}function rp(a){a=a|0;return 127}function sp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function tp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function up(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function vp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Kt(a,1,45);return}function wp(a){a=a|0;return 0}function xp(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function yp(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function zp(a){a=a|0;return}function Ap(a){a=a|0;Dt(a);return}function Bp(a){a=a|0;return 127}function Cp(a){a=a|0;return 127}function Dp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function Ep(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function Fp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function Gp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Kt(a,1,45);return}function Hp(a){a=a|0;return 0}function Ip(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Jp(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Kp(a){a=a|0;return}function Lp(a){a=a|0;Dt(a);return}function Mp(a){a=a|0;return 2147483647}function Np(a){a=a|0;return 2147483647}function Op(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function Pp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function Qp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function Rp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;du(a,1,45);return}function Sp(a){a=a|0;return 0}function Tp(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Up(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function Vp(a){a=a|0;return}function Wp(a){a=a|0;Dt(a);return}function Xp(a){a=a|0;return 2147483647}function Yp(a){a=a|0;return 2147483647}function Zp(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function _p(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function $p(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[a+(b<<2)>>2]=0;b=b+1|0}return}function aq(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;du(a,1,45);return}function bq(a){a=a|0;return 0}function cq(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function dq(b,c){b=b|0;c=c|0;a[b>>0]=2;a[b+1>>0]=3;a[b+2>>0]=0;a[b+3>>0]=4;return}function eq(a){a=a|0;return}function fq(a){a=a|0;Dt(a);return}function gq(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+240|0;o=w+24|0;r=w;n=w+140|0;v=w+16|0;q=w+12|0;s=w+8|0;j=w+136|0;k=w+4|0;p=w+36|0;c[v>>2]=n;u=v+4|0;c[u>>2]=166;c[s>>2]=Sk(g)|0;b=lm(s,1165628)|0;a[j>>0]=0;c[k>>2]=c[e>>2];m=c[g+4>>2]|0;c[o>>2]=c[k>>2];if(jq(d,o,f,s,m,h,j,b,v,q,n+100|0)|0){lb[c[(c[b>>2]|0)+32>>2]&7](b,26858,26868,o)|0;b=(c[q>>2]|0)-(c[v>>2]|0)|0;if((b|0)>98){b=Fj(b+2|0)|0;f=b;if(!b)b=0}else{b=p;f=0}if(a[j>>0]|0){a[b>>0]=45;b=b+1|0}m=o+10|0;n=o;k=c[v>>2]|0;while(1){if(k>>>0>=(c[q>>2]|0)>>>0)break;j=a[k>>0]|0;g=o;while(1){if((g|0)==(m|0)){g=m;break}if((a[g>>0]|0)==j<<24>>24)break;g=g+1|0}a[b>>0]=a[26858+(g-n)>>0]|0;k=k+1|0;b=b+1|0}a[b>>0]=0;c[r>>2]=i;Wi(p,26869,r)|0;if(f|0)Gj(f)}b=c[d>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0))if((hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1){c[d>>2]=0;b=0;break}else{b=c[d>>2]|0;break}}else b=0;while(0);b=(b|0)==0;f=c[e>>2]|0;do if(f){if((c[f+12>>2]|0)==(c[f+16>>2]|0)?(hb[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1:0){c[e>>2]=0;t=27;break}if(!b)t=28}else t=27;while(0);if((t|0)==27?b:0)t=28;if((t|0)==28)c[h>>2]=c[h>>2]|2;f=c[d>>2]|0;vt(c[s>>2]|0)|0;b=c[v>>2]|0;c[v>>2]=0;if(b|0)db[c[u>>2]&255](b);l=w;return f|0}function hq(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=l;l=l+144|0;u=t+24|0;b=t+32|0;s=t+16|0;m=t+8|0;p=t+4|0;j=t+28|0;n=t;c[s>>2]=b;r=s+4|0;c[r>>2]=166;c[p>>2]=Sk(g)|0;k=lm(p,1165628)|0;a[j>>0]=0;o=c[e>>2]|0;c[n>>2]=o;g=c[g+4>>2]|0;c[u>>2]=c[n>>2];n=o;if(jq(d,u,f,p,g,h,j,k,s,m,b+100|0)|0){b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0}else{a[i>>0]=0;a[b>>0]=0}if(a[j>>0]|0)Xt(i,nb[c[(c[k>>2]|0)+28>>2]&63](k,45)|0);k=nb[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;g=c[m>>2]|0;j=g+-1|0;b=c[s>>2]|0;while(1){if(b>>>0>=j>>>0)break;if((a[b>>0]|0)!=k<<24>>24)break;b=b+1|0}kq(i,b,g)|0}b=c[d>>2]|0;do if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0))if((hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1){c[d>>2]=0;b=0;break}else{b=c[d>>2]|0;break}}else b=0;while(0);b=(b|0)==0;do if(o){if((c[n+12>>2]|0)==(c[n+16>>2]|0)?(hb[c[(c[o>>2]|0)+36>>2]&127](n)|0)==-1:0){c[e>>2]=0;q=22;break}if(!b)q=23}else q=22;while(0);if((q|0)==22?b:0)q=23;if((q|0)==23)c[h>>2]=c[h>>2]|2;g=c[d>>2]|0;vt(c[p>>2]|0)|0;b=c[s>>2]|0;c[s>>2]=0;if(b|0)db[c[r>>2]&255](b);l=t;return g|0}function iq(a){a=a|0;return}function jq(e,f,g,h,i,j,k,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;_=l;l=l+512|0;J=_+88|0;P=_+96|0;Z=_+80|0;R=_+72|0;K=_+68|0;L=_+500|0;M=_+497|0;N=_+496|0;T=_+56|0;U=_+44|0;V=_+32|0;W=_+20|0;X=_+8|0;O=_+4|0;S=_;c[J>>2]=p;c[Z>>2]=P;Y=Z+4|0;c[Y>>2]=166;c[R>>2]=P;c[K>>2]=P+400;c[T>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[T+(p<<2)>>2]=0;p=p+1|0}c[U>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[U+(p<<2)>>2]=0;p=p+1|0}c[V>>2]=0;c[V+4>>2]=0;c[V+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[V+(p<<2)>>2]=0;p=p+1|0}c[W>>2]=0;c[W+4>>2]=0;c[W+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[W+(p<<2)>>2]=0;p=p+1|0}c[X>>2]=0;c[X+4>>2]=0;c[X+8>>2]=0;p=0;while(1){if((p|0)==3)break;c[X+(p<<2)>>2]=0;p=p+1|0}lq(g,h,L,M,N,T,U,V,W,O);c[o>>2]=c[n>>2];E=m+8|0;F=V+11|0;G=V+4|0;H=W+11|0;I=W+4|0;w=(i&512|0)!=0;x=U+11|0;y=U+4|0;z=X+11|0;A=X+4|0;B=L+3|0;C=T+11|0;D=T+4|0;P=0;v=0;a:while(1){if(v>>>0>=4){Q=217;break}p=c[e>>2]|0;do if(p){if((c[p+12>>2]|0)==(c[p+16>>2]|0))if((hb[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1){c[e>>2]=0;p=0;break}else{p=c[e>>2]|0;break}}else p=0;while(0);p=(p|0)==0;g=c[f>>2]|0;do if(g){if((c[g+12>>2]|0)!=(c[g+16>>2]|0))if(p)break;else{Q=217;break a}if((hb[c[(c[g>>2]|0)+36>>2]&127](g)|0)!=-1)if(p)break;else{Q=217;break a}else{c[f>>2]=0;Q=28;break}}else Q=28;while(0);if((Q|0)==28){Q=0;if(p){Q=217;break}else g=0}b:do switch(a[L+v>>0]|0){case 1:{if((v|0)==3)p=P;else{p=c[e>>2]|0;h=c[p+12>>2]|0;if((h|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[h>>0]|0;if((p&255)<<24>>24<=-1){Q=41;break a}if(!(b[(c[E>>2]|0)+(p<<24>>24<<1)>>1]&8192)){Q=41;break a}p=c[e>>2]|0;h=p+12|0;m=c[h>>2]|0;if((m|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+40>>2]&127](p)|0;else{c[h>>2]=m+1;p=d[m>>0]|0}Xt(X,p&255);p=g;h=g;Q=43}break}case 0:{if((v|0)==3)p=P;else{p=g;h=g;Q=43}break}case 3:{p=a[F>>0]|0;g=p<<24>>24<0?c[G>>2]|0:p&255;m=a[H>>0]|0;m=m<<24>>24<0?c[I>>2]|0:m&255;if((g|0)==(0-m|0))p=P;else{i=(g|0)==0;q=c[e>>2]|0;r=c[q+12>>2]|0;g=c[q+16>>2]|0;h=(r|0)==(g|0);if(i|(m|0)==0){if(h)p=hb[c[(c[q>>2]|0)+36>>2]&127](q)|0;else p=d[r>>0]|0;g=p&255;if(i){p=a[H>>0]|0;if(g<<24>>24!=(a[(p<<24>>24<0?c[W>>2]|0:W)>>0]|0)){p=P;break b}g=c[e>>2]|0;h=g+12|0;m=c[h>>2]|0;if((m|0)==(c[g+16>>2]|0)){hb[c[(c[g>>2]|0)+40>>2]&127](g)|0;p=a[H>>0]|0}else c[h>>2]=m+1;a[k>>0]=1;p=(p<<24>>24<0?c[I>>2]|0:p&255)>>>0>1?W:P;break b}p=a[F>>0]|0;if(g<<24>>24!=(a[(p<<24>>24<0?c[V>>2]|0:V)>>0]|0)){a[k>>0]=1;p=P;break b}g=c[e>>2]|0;h=g+12|0;m=c[h>>2]|0;if((m|0)==(c[g+16>>2]|0)){hb[c[(c[g>>2]|0)+40>>2]&127](g)|0;p=a[F>>0]|0}else c[h>>2]=m+1;p=(p<<24>>24<0?c[G>>2]|0:p&255)>>>0>1?V:P;break b}if(h){i=hb[c[(c[q>>2]|0)+36>>2]&127](q)|0;g=c[e>>2]|0;p=a[F>>0]|0;q=g;m=c[g+12>>2]|0;g=c[g+16>>2]|0}else{i=d[r>>0]|0;m=r}h=q+12|0;g=(m|0)==(g|0);if((i&255)<<24>>24==(a[(p<<24>>24<0?c[V>>2]|0:V)>>0]|0)){if(g){hb[c[(c[q>>2]|0)+40>>2]&127](q)|0;p=a[F>>0]|0}else c[h>>2]=m+1;p=(p<<24>>24<0?c[G>>2]|0:p&255)>>>0>1?V:P;break b}if(g)g=hb[c[(c[q>>2]|0)+36>>2]&127](q)|0;else g=d[m>>0]|0;p=a[H>>0]|0;if((g&255)<<24>>24!=(a[(p<<24>>24<0?c[W>>2]|0:W)>>0]|0)){Q=97;break a}g=c[e>>2]|0;h=g+12|0;m=c[h>>2]|0;if((m|0)==(c[g+16>>2]|0)){hb[c[(c[g>>2]|0)+40>>2]&127](g)|0;p=a[H>>0]|0}else c[h>>2]=m+1;a[k>>0]=1;p=(p<<24>>24<0?c[I>>2]|0:p&255)>>>0>1?W:P}break}case 2:{if(!(v>>>0<2|(P|0)!=0)?!(w|(v|0)==2&(a[B>>0]|0)!=0):0){p=0;break b}h=a[x>>0]|0;p=h<<24>>24<0;u=c[U>>2]|0;m=p?u:U;t=m;c:do if((v|0)!=0?(d[L+(v+-1)>>0]|0)<2:0){p=m+(p?c[y>>2]|0:h&255)|0;r=t;while(1){i=r;if((i|0)==(p|0))break;q=a[i>>0]|0;if(q<<24>>24<=-1)break;if(!(b[(c[E>>2]|0)+(q<<24>>24<<1)>>1]&8192))break;r=i+1|0}q=r-t|0;i=a[z>>0]|0;p=i<<24>>24<0;i=p?c[A>>2]|0:i&255;if(q>>>0<=i>>>0){i=(p?c[X>>2]|0:X)+i|0;p=i+(0-q)|0;while(1){if((p|0)==(i|0)){s=g;m=r;p=u;i=g;break c}if((a[p>>0]|0)!=(a[m>>0]|0)){s=g;m=t;p=u;i=g;break c}m=m+1|0;p=p+1|0}}else{s=g;m=t;p=u;i=g}}else{s=g;m=t;p=u;i=g}while(0);d:while(1){q=h<<24>>24<0;p=(q?p:U)+(q?c[y>>2]|0:h&255)|0;q=m;if((q|0)==(p|0))break;p=c[e>>2]|0;do if(p){if((c[p+12>>2]|0)==(c[p+16>>2]|0))if((hb[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1){c[e>>2]=0;p=0;break}else{p=c[e>>2]|0;break}}else p=0;while(0);g=(p|0)==0;do if(i){if((c[i+12>>2]|0)!=(c[i+16>>2]|0))if(g){p=s;break}else{p=q;break d}if((hb[c[(c[i>>2]|0)+36>>2]&127](i)|0)!=-1)if(g^(s|0)==0){p=s;i=s;break}else{p=q;break d}else{c[f>>2]=0;p=0;Q=123;break}}else{p=s;Q=123}while(0);if((Q|0)==123){Q=0;if(g){p=q;break}else i=0}g=c[e>>2]|0;h=c[g+12>>2]|0;if((h|0)==(c[g+16>>2]|0))g=hb[c[(c[g>>2]|0)+36>>2]&127](g)|0;else g=d[h>>0]|0;if((g&255)<<24>>24!=(a[q>>0]|0)){p=q;break}g=c[e>>2]|0;h=g+12|0;m=c[h>>2]|0;if((m|0)==(c[g+16>>2]|0))hb[c[(c[g>>2]|0)+40>>2]&127](g)|0;else c[h>>2]=m+1;s=p;m=q+1|0;h=a[x>>0]|0;p=c[U>>2]|0}if(w?(u=a[x>>0]|0,t=u<<24>>24<0,(p|0)!=((t?c[U>>2]|0:U)+(t?c[y>>2]|0:u&255)|0)):0){Q=135;break a}else p=P;break}case 4:{m=0;p=g;h=g;e:while(1){g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0))if((hb[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}else g=0;while(0);g=(g|0)==0;do if(h){if((c[h+12>>2]|0)!=(c[h+16>>2]|0))if(g){q=p;i=h;break}else{g=p;break e}if((hb[c[(c[h>>2]|0)+36>>2]&127](h)|0)!=-1)if(g^(p|0)==0){q=p;i=p;break}else{g=p;break e}else{c[f>>2]=0;p=0;Q=146;break}}else Q=146;while(0);if((Q|0)==146){Q=0;if(g){g=p;break}else{q=p;i=0}}p=c[e>>2]|0;g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[g>>0]|0;g=p&255;if(g<<24>>24>-1?(b[(c[E>>2]|0)+(p<<24>>24<<1)>>1]&2048)!=0:0){p=c[o>>2]|0;if((p|0)==(c[J>>2]|0)){mq(n,o,J);p=c[o>>2]|0}c[o>>2]=p+1;a[p>>0]=g;p=m+1|0}else{u=a[C>>0]|0;if(!(g<<24>>24==(a[N>>0]|0)&(m|0?((u<<24>>24<0?c[D>>2]|0:u&255)|0)!=0:0))){g=q;break}p=c[R>>2]|0;if((p|0)==(c[K>>2]|0)){nq(Z,R,K);p=c[R>>2]|0}c[R>>2]=p+4;c[p>>2]=m;p=0}g=c[e>>2]|0;h=g+12|0;m=c[h>>2]|0;if((m|0)==(c[g+16>>2]|0)){hb[c[(c[g>>2]|0)+40>>2]&127](g)|0;m=p;p=q;h=i;continue}else{c[h>>2]=m+1;m=p;p=q;h=i;continue}}p=c[R>>2]|0;if(m|0?(c[Z>>2]|0)!=(p|0):0){if((p|0)==(c[K>>2]|0)){nq(Z,R,K);p=c[R>>2]|0}c[R>>2]=p+4;c[p>>2]=m}f:do if((c[O>>2]|0)>0){p=c[e>>2]|0;do if(p){if((c[p+12>>2]|0)==(c[p+16>>2]|0))if((hb[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1){c[e>>2]=0;p=0;break}else{p=c[e>>2]|0;break}}else p=0;while(0);p=(p|0)==0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)?(hb[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1:0){c[f>>2]=0;Q=178;break}if(p)m=g;else{Q=183;break a}}else Q=178;while(0);if((Q|0)==178){Q=0;if(p){Q=183;break a}else m=0}p=c[e>>2]|0;g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[g>>0]|0;if((p&255)<<24>>24!=(a[M>>0]|0)){Q=183;break a}p=c[e>>2]|0;g=p+12|0;h=c[g>>2]|0;if((h|0)==(c[p+16>>2]|0)){hb[c[(c[p>>2]|0)+40>>2]&127](p)|0;p=m;h=m}else{c[g>>2]=h+1;p=m;h=m}while(1){if((c[O>>2]|0)<=0)break f;g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0))if((hb[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}else g=0;while(0);g=(g|0)==0;do if(h){if((c[h+12>>2]|0)!=(c[h+16>>2]|0))if(g){i=p;m=h;break}else{Q=205;break a}if((hb[c[(c[h>>2]|0)+36>>2]&127](h)|0)!=-1)if(g^(p|0)==0){i=p;m=p;break}else{Q=205;break a}else{c[f>>2]=0;p=0;Q=198;break}}else Q=198;while(0);if((Q|0)==198){Q=0;if(g){Q=205;break a}else{i=p;m=0}}p=c[e>>2]|0;g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[g>>0]|0;if((p&255)<<24>>24<=-1){Q=205;break a}if(!(b[(c[E>>2]|0)+(p<<24>>24<<1)>>1]&2048)){Q=205;break a}if((c[o>>2]|0)==(c[J>>2]|0))mq(n,o,J);p=c[e>>2]|0;g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[g>>0]|0;g=c[o>>2]|0;c[o>>2]=g+1;a[g>>0]=p;c[O>>2]=(c[O>>2]|0)+-1;p=c[e>>2]|0;g=p+12|0;h=c[g>>2]|0;if((h|0)==(c[p+16>>2]|0)){hb[c[(c[p>>2]|0)+40>>2]&127](p)|0;p=i;h=m;continue}else{c[g>>2]=h+1;p=i;h=m;continue}}}while(0);if((c[o>>2]|0)==(c[n>>2]|0)){Q=215;break a}else p=P;break}default:p=P}while(0);g:do if((Q|0)==43)while(1){Q=0;g=c[e>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0))if((hb[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1){c[e>>2]=0;g=0;break}else{g=c[e>>2]|0;break}}else g=0;while(0);g=(g|0)==0;do if(h){if((c[h+12>>2]|0)!=(c[h+16>>2]|0))if(g){i=p;m=h;break}else{p=P;break g}if((hb[c[(c[h>>2]|0)+36>>2]&127](h)|0)!=-1)if(g^(p|0)==0){i=p;m=p;break}else{p=P;break g}else{c[f>>2]=0;p=0;Q=53;break}}else Q=53;while(0);if((Q|0)==53){Q=0;if(g){p=P;break g}else{i=p;m=0}}p=c[e>>2]|0;g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[g>>0]|0;if((p&255)<<24>>24<=-1){p=P;break g}if(!(b[(c[E>>2]|0)+(p<<24>>24<<1)>>1]&8192)){p=P;break g}p=c[e>>2]|0;g=p+12|0;h=c[g>>2]|0;if((h|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+40>>2]&127](p)|0;else{c[g>>2]=h+1;p=d[h>>0]|0}Xt(X,p&255);p=i;h=m;Q=43}while(0);P=p;v=v+1|0}h:do if((Q|0)==41){c[j>>2]=c[j>>2]|4;g=0}else if((Q|0)==97){c[j>>2]=c[j>>2]|4;g=0}else if((Q|0)==135){c[j>>2]=c[j>>2]|4;g=0}else if((Q|0)==183){c[j>>2]=c[j>>2]|4;g=0}else if((Q|0)==205){c[j>>2]=c[j>>2]|4;g=0}else if((Q|0)==215){c[j>>2]=c[j>>2]|4;g=0}else if((Q|0)==217){i:do if(P|0){i=P+11|0;q=P+4|0;h=1;j:while(1){p=a[i>>0]|0;if(p<<24>>24<0)p=c[q>>2]|0;else p=p&255;if(h>>>0>=p>>>0)break i;p=c[e>>2]|0;do if(p){if((c[p+12>>2]|0)==(c[p+16>>2]|0))if((hb[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1){c[e>>2]=0;p=0;break}else{p=c[e>>2]|0;break}}else p=0;while(0);p=(p|0)==0;g=c[f>>2]|0;do if(g){if((c[g+12>>2]|0)==(c[g+16>>2]|0)?(hb[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1:0){c[f>>2]=0;Q=233;break}if(!p)break j}else Q=233;while(0);if((Q|0)==233?(Q=0,p):0)break;p=c[e>>2]|0;g=c[p+12>>2]|0;if((g|0)==(c[p+16>>2]|0))p=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else p=d[g>>0]|0;if((a[i>>0]|0)<0)g=c[P>>2]|0;else g=P;if((p&255)<<24>>24!=(a[g+h>>0]|0))break;p=h+1|0;g=c[e>>2]|0;h=g+12|0;m=c[h>>2]|0;if((m|0)==(c[g+16>>2]|0)){hb[c[(c[g>>2]|0)+40>>2]&127](g)|0;h=p;continue}else{c[h>>2]=m+1;h=p;continue}}c[j>>2]=c[j>>2]|4;g=0;break h}while(0);g=c[Z>>2]|0;p=c[R>>2]|0;if((g|0)!=(p|0)){c[S>>2]=0;wm(T,g,p,S);if(!(c[S>>2]|0)){g=1;break}else{c[j>>2]=c[j>>2]|4;g=0;break}}else g=1}while(0);Mt(X);Mt(W);Mt(V);Mt(U);Mt(T);p=c[Z>>2]|0;c[Z>>2]=0;if(p|0)db[c[Y>>2]&255](p);l=_;return g|0}function kq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;h=d;l=b+11|0;f=a[l>>0]|0;if(f<<24>>24<0){k=c[b+4>>2]|0;g=(c[b+8>>2]&2147483647)+-1|0}else{k=f&255;g=10}j=e-h|0;do if(j|0){if((g-k|0)>>>0<j>>>0){Ut(b,g,k+j-g|0,k,k,0,0);f=a[l>>0]|0}if(f<<24>>24<0)i=c[b>>2]|0;else i=b;h=e+(k-h)|0;g=i+k|0;f=d;while(1){if((f|0)==(e|0))break;a[g>>0]=a[f>>0]|0;g=g+1|0;f=f+1|0}a[i+h>>0]=0;f=k+j|0;if((a[l>>0]|0)<0){c[b+4>>2]=f;break}else{a[l>>0]=f;break}}while(0);return b|0}function lq(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0;o=l;l=l+16|0;n=o;if(b){d=lm(d,1167348)|0;eb[c[(c[d>>2]|0)+44>>2]&63](n,d);b=c[n>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;eb[c[(c[d>>2]|0)+32>>2]&63](n,d);b=k+11|0;if((a[b>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0;b=k}else{a[k>>0]=0;a[b>>0]=0;b=k}Qt(k,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[d>>2]|0)+28>>2]&63](n,d);b=j+11|0;if((a[b>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0;b=j}else{a[j>>0]=0;a[b>>0]=0;b=j}Qt(j,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);a[f>>0]=hb[c[(c[d>>2]|0)+12>>2]&127](d)|0;a[g>>0]=hb[c[(c[d>>2]|0)+16>>2]&127](d)|0;eb[c[(c[d>>2]|0)+20>>2]&63](n,d);b=h+11|0;if((a[b>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0;b=h}else{a[h>>0]=0;a[b>>0]=0;b=h}Qt(h,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[d>>2]|0)+24>>2]&63](n,d);b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0;b=i}else{a[i>>0]=0;a[b>>0]=0;b=i}Qt(i,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);b=hb[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{d=lm(d,1167340)|0;eb[c[(c[d>>2]|0)+44>>2]&63](n,d);b=c[n>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;eb[c[(c[d>>2]|0)+32>>2]&63](n,d);b=k+11|0;if((a[b>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0;b=k}else{a[k>>0]=0;a[b>>0]=0;b=k}Qt(k,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[d>>2]|0)+28>>2]&63](n,d);b=j+11|0;if((a[b>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0;b=j}else{a[j>>0]=0;a[b>>0]=0;b=j}Qt(j,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);a[f>>0]=hb[c[(c[d>>2]|0)+12>>2]&127](d)|0;a[g>>0]=hb[c[(c[d>>2]|0)+16>>2]&127](d)|0;eb[c[(c[d>>2]|0)+20>>2]&63](n,d);b=h+11|0;if((a[b>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0;b=h}else{a[h>>0]=0;a[b>>0]=0;b=h}Qt(h,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[d>>2]|0)+24>>2]&63](n,d);b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0;b=i}else{a[i>>0]=0;a[b>>0]=0;b=i}Qt(i,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);b=hb[c[(c[d>>2]|0)+36>>2]&127](d)|0}c[m>>2]=b;l=o;return}function mq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=a+4|0;f=(c[i>>2]|0)!=166;e=c[a>>2]|0;g=(c[d>>2]|0)-e|0;g=g>>>0<2147483647?g<<1:-1;g=(g|0)==0?1:g;h=(c[b>>2]|0)-e|0;e=Ij(f?e:0,g)|0;if(!f){f=c[a>>2]|0;c[a>>2]=e;if(f){db[c[i>>2]&255](f);e=c[a>>2]|0}}else c[a>>2]=e;c[i>>2]=167;c[b>>2]=e+h;c[d>>2]=(c[a>>2]|0)+g;return}function nq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=a+4|0;f=(c[i>>2]|0)!=166;e=c[a>>2]|0;g=(c[d>>2]|0)-e|0;g=g>>>0<2147483647?g<<1:-1;g=(g|0)==0?4:g;h=(c[b>>2]|0)-e>>2;e=Ij(f?e:0,g)|0;if(!f){f=c[a>>2]|0;c[a>>2]=e;if(f){db[c[i>>2]&255](f);e=c[a>>2]|0}}else c[a>>2]=e;c[i>>2]=167;c[b>>2]=e+(h<<2);c[d>>2]=(c[a>>2]|0)+(g>>>2<<2);return}function oq(a){a=a|0;return}function pq(a){a=a|0;Dt(a);return}function qq(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;w=l;l=l+576|0;o=w+424|0;r=w;n=w+24|0;v=w+16|0;q=w+12|0;s=w+8|0;j=w+564|0;k=w+4|0;p=w+464|0;c[v>>2]=n;u=v+4|0;c[u>>2]=166;c[s>>2]=Sk(g)|0;b=lm(s,1165660)|0;a[j>>0]=0;c[k>>2]=c[e>>2];m=c[g+4>>2]|0;c[o>>2]=c[k>>2];if(sq(d,o,f,s,m,h,j,b,v,q,n+400|0)|0){lb[c[(c[b>>2]|0)+48>>2]&7](b,26968,26978,o)|0;b=(c[q>>2]|0)-(c[v>>2]|0)|0;if((b|0)>392){b=Fj((b>>2)+2|0)|0;f=b;if(!b)b=0}else{b=p;f=0}if(a[j>>0]|0){a[b>>0]=45;b=b+1|0}m=o+40|0;n=o;k=c[v>>2]|0;while(1){if(k>>>0>=(c[q>>2]|0)>>>0)break;j=c[k>>2]|0;g=o;while(1){if((g|0)==(m|0)){g=m;break}if((c[g>>2]|0)==(j|0))break;g=g+4|0}a[b>>0]=a[26968+(g-n>>2)>>0]|0;k=k+4|0;b=b+1|0}a[b>>0]=0;c[r>>2]=i;Wi(p,26869,r)|0;if(f|0)Gj(f)}b=c[d>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else b=c[f>>2]|0;if((b|0)==-1){c[d>>2]=0;g=1;break}else{g=(c[d>>2]|0)==0;break}}else g=1;while(0);b=c[e>>2]|0;do if(b){f=c[b+12>>2]|0;if((f|0)==(c[b+16>>2]|0))b=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else b=c[f>>2]|0;if((b|0)!=-1)if(g)break;else{t=32;break}else{c[e>>2]=0;t=30;break}}else t=30;while(0);if((t|0)==30?g:0)t=32;if((t|0)==32)c[h>>2]=c[h>>2]|2;f=c[d>>2]|0;vt(c[s>>2]|0)|0;b=c[v>>2]|0;c[v>>2]=0;if(b|0)db[c[u>>2]&255](b);l=w;return f|0}function rq(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;t=l;l=l+432|0;u=t+424|0;b=t+24|0;s=t+16|0;m=t+8|0;p=t+4|0;j=t+428|0;n=t;c[s>>2]=b;r=s+4|0;c[r>>2]=166;c[p>>2]=Sk(g)|0;k=lm(p,1165660)|0;a[j>>0]=0;o=c[e>>2]|0;c[n>>2]=o;g=c[g+4>>2]|0;c[u>>2]=c[n>>2];n=o;if(sq(d,u,f,p,g,h,j,k,s,m,b+400|0)|0){b=i+8+3|0;if((a[b>>0]|0)<0){c[c[i>>2]>>2]=0;c[i+4>>2]=0}else{c[i>>2]=0;a[b>>0]=0}if(a[j>>0]|0)mu(i,nb[c[(c[k>>2]|0)+44>>2]&63](k,45)|0);k=nb[c[(c[k>>2]|0)+44>>2]&63](k,48)|0;g=c[m>>2]|0;j=g+-4|0;b=c[s>>2]|0;while(1){if(b>>>0>=j>>>0)break;if((c[b>>2]|0)!=(k|0))break;b=b+4|0}tq(i,b,g)|0}b=c[d>>2]|0;do if(b){g=c[b+12>>2]|0;if((g|0)==(c[b+16>>2]|0))b=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else b=c[g>>2]|0;if((b|0)==-1){c[d>>2]=0;g=1;break}else{g=(c[d>>2]|0)==0;break}}else g=1;while(0);do if(o){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))b=hb[c[(c[o>>2]|0)+36>>2]&127](n)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(g)break;else{q=27;break}else{c[e>>2]=0;q=25;break}}else q=25;while(0);if((q|0)==25?g:0)q=27;if((q|0)==27)c[h>>2]=c[h>>2]|2;g=c[d>>2]|0;vt(c[p>>2]|0)|0;b=c[s>>2]|0;c[s>>2]=0;if(b|0)db[c[r>>2]&255](b);l=t;return g|0}function sq(b,e,f,g,h,i,j,k,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;Y=l;l=l+512|0;H=Y+96|0;N=Y+104|0;X=Y+88|0;P=Y+80|0;I=Y+76|0;J=Y+504|0;K=Y+72|0;L=Y+68|0;R=Y+56|0;S=Y+44|0;T=Y+32|0;U=Y+20|0;V=Y+8|0;M=Y+4|0;Q=Y;c[H>>2]=o;c[X>>2]=N;W=X+4|0;c[W>>2]=166;c[P>>2]=N;c[I>>2]=N+400;c[R>>2]=0;c[R+4>>2]=0;c[R+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[R+(o<<2)>>2]=0;o=o+1|0}c[S>>2]=0;c[S+4>>2]=0;c[S+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[S+(o<<2)>>2]=0;o=o+1|0}c[T>>2]=0;c[T+4>>2]=0;c[T+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[T+(o<<2)>>2]=0;o=o+1|0}c[U>>2]=0;c[U+4>>2]=0;c[U+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[U+(o<<2)>>2]=0;o=o+1|0}c[V>>2]=0;c[V+4>>2]=0;c[V+8>>2]=0;o=0;while(1){if((o|0)==3)break;c[V+(o<<2)>>2]=0;o=o+1|0}uq(f,g,J,K,L,R,S,T,U,M);c[n>>2]=c[m>>2];D=T+8+3|0;E=T+4|0;F=U+8+3|0;G=U+4|0;v=(h&512|0)!=0;w=S+8+3|0;x=S+4|0;y=V+8+3|0;z=V+4|0;A=J+3|0;B=R+11|0;C=R+4|0;N=0;u=0;a:while(1){if(u>>>0>=4){O=231;break}o=c[b>>2]|0;do if(o){f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((o|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);f=c[e>>2]|0;do if(f){o=c[f+12>>2]|0;if((o|0)==(c[f+16>>2]|0))o=hb[c[(c[f>>2]|0)+36>>2]&127](f)|0;else o=c[o>>2]|0;if((o|0)!=-1)if(g){t=f;break}else{O=231;break a}else{c[e>>2]=0;O=31;break}}else O=31;while(0);if((O|0)==31){O=0;if(g){O=231;break}else t=0}b:do switch(a[J+u>>0]|0){case 1:{if((u|0)==3)o=N;else{o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if(!(ab[c[(c[k>>2]|0)+12>>2]&31](k,8192,o)|0)){O=43;break a}o=c[b>>2]|0;f=o+12|0;g=c[f>>2]|0;if((g|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+40>>2]&127](o)|0;else{c[f>>2]=g+4;o=c[g>>2]|0}mu(V,o);o=t;h=t;O=45}break}case 0:{if((u|0)==3)o=N;else{o=t;h=t;O=45}break}case 3:{o=a[D>>0]|0;f=o<<24>>24<0?c[E>>2]|0:o&255;h=a[F>>0]|0;h=h<<24>>24<0?c[G>>2]|0:h&255;if((f|0)==(0-h|0))o=N;else{p=(f|0)==0;q=c[b>>2]|0;r=c[q+12>>2]|0;f=c[q+16>>2]|0;g=(r|0)==(f|0);if(p|(h|0)==0){if(g)f=hb[c[(c[q>>2]|0)+36>>2]&127](q)|0;else f=c[r>>2]|0;if(p){o=a[F>>0]|0;if((f|0)!=(c[(o<<24>>24<0?c[U>>2]|0:U)>>2]|0)){o=N;break b}f=c[b>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0)){hb[c[(c[f>>2]|0)+40>>2]&127](f)|0;o=a[F>>0]|0}else c[g>>2]=h+4;a[j>>0]=1;o=(o<<24>>24<0?c[G>>2]|0:o&255)>>>0>1?U:N;break b}o=a[D>>0]|0;if((f|0)!=(c[(o<<24>>24<0?c[T>>2]|0:T)>>2]|0)){a[j>>0]=1;o=N;break b}f=c[b>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0)){hb[c[(c[f>>2]|0)+40>>2]&127](f)|0;o=a[D>>0]|0}else c[g>>2]=h+4;o=(o<<24>>24<0?c[E>>2]|0:o&255)>>>0>1?T:N;break b}if(g){p=hb[c[(c[q>>2]|0)+36>>2]&127](q)|0;f=c[b>>2]|0;o=a[D>>0]|0;q=f;h=c[f+12>>2]|0;f=c[f+16>>2]|0}else{p=c[r>>2]|0;h=r}g=q+12|0;f=(h|0)==(f|0);if((p|0)==(c[(o<<24>>24<0?c[T>>2]|0:T)>>2]|0)){if(f){hb[c[(c[q>>2]|0)+40>>2]&127](q)|0;o=a[D>>0]|0}else c[g>>2]=h+4;o=(o<<24>>24<0?c[E>>2]|0:o&255)>>>0>1?T:N;break b}if(f)f=hb[c[(c[q>>2]|0)+36>>2]&127](q)|0;else f=c[h>>2]|0;o=a[F>>0]|0;if((f|0)!=(c[(o<<24>>24<0?c[U>>2]|0:U)>>2]|0)){O=101;break a}f=c[b>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0)){hb[c[(c[f>>2]|0)+40>>2]&127](f)|0;o=a[F>>0]|0}else c[g>>2]=h+4;a[j>>0]=1;o=(o<<24>>24<0?c[G>>2]|0:o&255)>>>0>1?U:N}break}case 2:{if(!(u>>>0<2|(N|0)!=0)?!(v|(u|0)==2&(a[A>>0]|0)!=0):0){o=0;break b}g=a[w>>0]|0;h=c[S>>2]|0;o=g<<24>>24<0?h:S;c:do if((u|0)!=0?(d[J+(u+-1)>>0]|0)<2:0){while(1){s=g<<24>>24<0;f=o;if((f|0)==((s?h:S)+((s?c[x>>2]|0:g&255)<<2)|0))break;if(!(ab[c[(c[k>>2]|0)+12>>2]&31](k,8192,c[f>>2]|0)|0)){O=108;break}o=f+4|0;g=a[w>>0]|0;h=c[S>>2]|0}if((O|0)==108){O=0;g=a[w>>0]|0;h=c[S>>2]|0}p=g<<24>>24<0?h:S;s=p;r=o-s>>2;q=a[y>>0]|0;f=q<<24>>24<0;q=f?c[z>>2]|0:q&255;if(r>>>0>q>>>0){r=t;f=s;p=t}else{q=(f?c[V>>2]|0:V)+(q<<2)|0;f=q+(0-r<<2)|0;while(1){if((f|0)==(q|0)){r=t;f=o;p=t;break c}if((c[f>>2]|0)!=(c[p>>2]|0)){r=t;f=s;p=t;break c}p=p+4|0;f=f+4|0}}}else{r=t;f=o;p=t}while(0);d:while(1){o=g<<24>>24<0;o=(o?h:S)+((o?c[x>>2]|0:g&255)<<2)|0;q=f;if((q|0)==(o|0))break;o=c[b>>2]|0;do if(o){f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((o|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);do if(p){o=c[p+12>>2]|0;if((o|0)==(c[p+16>>2]|0))o=hb[c[(c[p>>2]|0)+36>>2]&127](p)|0;else o=c[o>>2]|0;if((o|0)!=-1)if(f^(r|0)==0){o=r;p=r;break}else{o=q;break d}else{c[e>>2]=0;o=0;O=129;break}}else{o=r;O=129}while(0);if((O|0)==129){O=0;if(f){o=q;break}else p=0}f=c[b>>2]|0;g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=hb[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)!=(c[q>>2]|0)){o=q;break}f=c[b>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0))hb[c[(c[f>>2]|0)+40>>2]&127](f)|0;else c[g>>2]=h+4;r=o;f=q+4|0;g=a[w>>0]|0;h=c[S>>2]|0}if(v?(t=a[w>>0]|0,s=t<<24>>24<0,(o|0)!=((s?c[S>>2]|0:S)+((s?c[x>>2]|0:t&255)<<2)|0)):0){O=141;break a}else o=N;break}case 4:{r=0;o=t;h=t;e:while(1){f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=hb[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(h){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(g^(o|0)==0){p=o;q=o;break}else{h=o;break e}else{c[e>>2]=0;o=0;O=155;break}}else O=155;while(0);if((O|0)==155){O=0;if(g){h=o;break}else{p=o;q=0}}o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))f=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else f=c[f>>2]|0;if(ab[c[(c[k>>2]|0)+12>>2]&31](k,2048,f)|0){o=c[n>>2]|0;if((o|0)==(c[H>>2]|0)){vq(m,n,H);o=c[n>>2]|0}c[n>>2]=o+4;c[o>>2]=f;o=r+1|0}else{t=a[B>>0]|0;if(!((f|0)==(c[L>>2]|0)&(r|0?((t<<24>>24<0?c[C>>2]|0:t&255)|0)!=0:0))){h=p;break}o=c[P>>2]|0;if((o|0)==(c[I>>2]|0)){nq(X,P,I);o=c[P>>2]|0}c[P>>2]=o+4;c[o>>2]=r;o=0}f=c[b>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0)){hb[c[(c[f>>2]|0)+40>>2]&127](f)|0;r=o;o=p;h=q;continue}else{c[g>>2]=h+4;r=o;o=p;h=q;continue}}o=c[P>>2]|0;if(r|0?(c[X>>2]|0)!=(o|0):0){if((o|0)==(c[I>>2]|0)){nq(X,P,I);o=c[P>>2]|0}c[P>>2]=o+4;c[o>>2]=r}f:do if((c[M>>2]|0)>0){o=c[b>>2]|0;do if(o){f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((o|0)==-1){c[b>>2]=0;f=1;break}else{f=(c[b>>2]|0)==0;break}}else f=1;while(0);do if(h){o=c[h+12>>2]|0;if((o|0)==(c[h+16>>2]|0))o=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else o=c[o>>2]|0;if((o|0)!=-1)if(f)break;else{O=195;break a}else{c[e>>2]=0;O=189;break}}else O=189;while(0);if((O|0)==189){O=0;if(f){O=195;break a}else h=0}o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((o|0)!=(c[K>>2]|0)){O=195;break a}o=c[b>>2]|0;f=o+12|0;g=c[f>>2]|0;if((g|0)==(c[o+16>>2]|0)){hb[c[(c[o>>2]|0)+40>>2]&127](o)|0;o=h}else{c[f>>2]=g+4;o=h}while(1){if((c[M>>2]|0)<=0)break f;f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=hb[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(h){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(g^(o|0)==0){p=o;h=o;break}else{O=219;break a}else{c[e>>2]=0;o=0;O=213;break}}else O=213;while(0);if((O|0)==213){O=0;if(g){O=219;break a}else{p=o;h=0}}o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if(!(ab[c[(c[k>>2]|0)+12>>2]&31](k,2048,o)|0)){O=219;break a}if((c[n>>2]|0)==(c[H>>2]|0))vq(m,n,H);o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;f=c[n>>2]|0;c[n>>2]=f+4;c[f>>2]=o;c[M>>2]=(c[M>>2]|0)+-1;o=c[b>>2]|0;f=o+12|0;g=c[f>>2]|0;if((g|0)==(c[o+16>>2]|0)){hb[c[(c[o>>2]|0)+40>>2]&127](o)|0;o=p;continue}else{c[f>>2]=g+4;o=p;continue}}}while(0);if((c[n>>2]|0)==(c[m>>2]|0)){O=229;break a}else o=N;break}default:o=N}while(0);g:do if((O|0)==45)while(1){O=0;f=c[b>>2]|0;do if(f){g=c[f+12>>2]|0;if((g|0)==(c[f+16>>2]|0))f=hb[c[(c[f>>2]|0)+36>>2]&127](f)|0;else f=c[g>>2]|0;if((f|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);do if(h){f=c[h+12>>2]|0;if((f|0)==(c[h+16>>2]|0))f=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(g^(o|0)==0){p=o;h=o;break}else{o=N;break g}else{c[e>>2]=0;o=0;O=58;break}}else O=58;while(0);if((O|0)==58){O=0;if(g){o=N;break g}else{p=o;h=0}}o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if(!(ab[c[(c[k>>2]|0)+12>>2]&31](k,8192,o)|0)){o=N;break g}o=c[b>>2]|0;f=o+12|0;g=c[f>>2]|0;if((g|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+40>>2]&127](o)|0;else{c[f>>2]=g+4;o=c[g>>2]|0}mu(V,o);o=p;O=45}while(0);N=o;u=u+1|0}h:do if((O|0)==43){c[i>>2]=c[i>>2]|4;f=0}else if((O|0)==101){c[i>>2]=c[i>>2]|4;f=0}else if((O|0)==141){c[i>>2]=c[i>>2]|4;f=0}else if((O|0)==195){c[i>>2]=c[i>>2]|4;f=0}else if((O|0)==219){c[i>>2]=c[i>>2]|4;f=0}else if((O|0)==229){c[i>>2]=c[i>>2]|4;f=0}else if((O|0)==231){i:do if(N|0){p=N+8+3|0;q=N+4|0;h=1;j:while(1){o=a[p>>0]|0;if(o<<24>>24<0)o=c[q>>2]|0;else o=o&255;if(h>>>0>=o>>>0)break i;o=c[b>>2]|0;do if(o){f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((o|0)==-1){c[b>>2]=0;g=1;break}else{g=(c[b>>2]|0)==0;break}}else g=1;while(0);o=c[e>>2]|0;do if(o){f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((o|0)!=-1)if(g)break;else break j;else{c[e>>2]=0;O=250;break}}else O=250;while(0);if((O|0)==250?(O=0,g):0)break;o=c[b>>2]|0;f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0))o=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else o=c[f>>2]|0;if((a[p>>0]|0)<0)f=c[N>>2]|0;else f=N;if((o|0)!=(c[f+(h<<2)>>2]|0))break;o=h+1|0;f=c[b>>2]|0;g=f+12|0;h=c[g>>2]|0;if((h|0)==(c[f+16>>2]|0)){hb[c[(c[f>>2]|0)+40>>2]&127](f)|0;h=o;continue}else{c[g>>2]=h+4;h=o;continue}}c[i>>2]=c[i>>2]|4;f=0;break h}while(0);f=c[X>>2]|0;o=c[P>>2]|0;if((f|0)!=(o|0)){c[Q>>2]=0;wm(R,f,o,Q);if(!(c[Q>>2]|0)){f=1;break}else{c[i>>2]=c[i>>2]|4;f=0;break}}else f=1}while(0);fu(V);fu(U);fu(T);fu(S);Mt(R);o=c[X>>2]|0;c[X>>2]=0;if(o|0)db[c[W>>2]&255](o);l=Y;return f|0}function tq(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;h=d;g=b+8|0;m=g+3|0;f=a[m>>0]|0;if(f<<24>>24<0){l=c[b+4>>2]|0;g=(c[g>>2]&2147483647)+-1|0}else{l=f&255;g=1}k=e-h>>2;do if(k|0){if((g-l|0)>>>0<k>>>0){lu(b,g,l+k-g|0,l,l,0,0);f=a[m>>0]|0}j=f<<24>>24<0;if(j)i=c[b>>2]|0;else i=b;h=l+((e-h|0)>>>2)|0;g=i+(l<<2)|0;f=d;while(1){if((f|0)==(e|0))break;c[g>>2]=c[f>>2];g=g+4|0;f=f+4|0}c[i+(h<<2)>>2]=0;f=l+k|0;if(j){c[b+4>>2]=f;break}else{a[m>>0]=f;break}}while(0);return b|0}function uq(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0;o=l;l=l+16|0;n=o;if(b){d=lm(d,1167364)|0;eb[c[(c[d>>2]|0)+44>>2]&63](n,d);b=c[n>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;eb[c[(c[d>>2]|0)+32>>2]&63](n,d);b=k+8+3|0;if((a[b>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[b>>0]=0}ju(k,0);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);eb[c[(c[d>>2]|0)+28>>2]&63](n,d);b=j+8+3|0;if((a[b>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[b>>0]=0}ju(j,0);c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);c[f>>2]=hb[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[g>>2]=hb[c[(c[d>>2]|0)+16>>2]&127](d)|0;eb[c[(c[d>>2]|0)+20>>2]&63](n,d);b=h+11|0;if((a[b>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0;b=h}else{a[h>>0]=0;a[b>>0]=0;b=h}Qt(h,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[d>>2]|0)+24>>2]&63](n,d);b=i+8+3|0;if((a[b>>0]|0)<0){c[c[i>>2]>>2]=0;c[i+4>>2]=0}else{c[i>>2]=0;a[b>>0]=0}ju(i,0);c[i>>2]=c[n>>2];c[i+4>>2]=c[n+4>>2];c[i+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);b=hb[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{d=lm(d,1167356)|0;eb[c[(c[d>>2]|0)+44>>2]&63](n,d);b=c[n>>2]|0;a[e>>0]=b;a[e+1>>0]=b>>8;a[e+2>>0]=b>>16;a[e+3>>0]=b>>24;eb[c[(c[d>>2]|0)+32>>2]&63](n,d);b=k+8+3|0;if((a[b>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[b>>0]=0}ju(k,0);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);eb[c[(c[d>>2]|0)+28>>2]&63](n,d);b=j+8+3|0;if((a[b>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[b>>0]=0}ju(j,0);c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);c[f>>2]=hb[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[g>>2]=hb[c[(c[d>>2]|0)+16>>2]&127](d)|0;eb[c[(c[d>>2]|0)+20>>2]&63](n,d);b=h+11|0;if((a[b>>0]|0)<0){a[c[h>>2]>>0]=0;c[h+4>>2]=0;b=h}else{a[h>>0]=0;a[b>>0]=0;b=h}Qt(h,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[d>>2]|0)+24>>2]&63](n,d);b=i+8+3|0;if((a[b>>0]|0)<0){c[c[i>>2]>>2]=0;c[i+4>>2]=0}else{c[i>>2]=0;a[b>>0]=0}ju(i,0);c[i>>2]=c[n>>2];c[i+4>>2]=c[n+4>>2];c[i+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);b=hb[c[(c[d>>2]|0)+36>>2]&127](d)|0}c[m>>2]=b;l=o;return}function vq(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=a+4|0;f=(c[i>>2]|0)!=166;e=c[a>>2]|0;g=(c[d>>2]|0)-e|0;g=g>>>0<2147483647?g<<1:-1;g=(g|0)==0?4:g;h=(c[b>>2]|0)-e>>2;e=Ij(f?e:0,g)|0;if(!f){f=c[a>>2]|0;c[a>>2]=e;if(f){db[c[i>>2]&255](f);e=c[a>>2]|0}}else c[a>>2]=e;c[i>>2]=167;c[b>>2]=e+(h<<2);c[d>>2]=(c[a>>2]|0)+(g>>>2<<2);return}function wq(a){a=a|0;return}function xq(a){a=a|0;Dt(a);return}function yq(b,d,e,f,g,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;i=+i;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+384|0;u=F+8|0;b=F;k=F+284|0;n=F+72|0;j=F+184|0;E=F+68|0;v=F+180|0;w=F+177|0;x=F+176|0;B=F+56|0;C=F+44|0;D=F+32|0;t=F+28|0;s=F+76|0;y=F+24|0;z=F+16|0;A=F+20|0;c[n>>2]=k;h[u>>3]=i;k=Wh(k,100,27074,u)|0;if(k>>>0>99){k=nm()|0;h[b>>3]=i;k=Dn(n,k,27074,b)|0;b=c[n>>2]|0;if(!b)b=c[n>>2]|0;j=Fj(k)|0;m=j;if(!j){j=0;r=m;q=b}else{r=m;q=b}}else{r=0;q=0}c[E>>2]=Sk(f)|0;p=lm(E,1165628)|0;o=c[n>>2]|0;lb[c[(c[p>>2]|0)+32>>2]&7](p,o,o+k|0,j)|0;if(!k)o=0;else o=(a[c[n>>2]>>0]|0)==45;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[C+(b<<2)>>2]=0;b=b+1|0}c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[D+(b<<2)>>2]=0;b=b+1|0}Aq(e,o,E,v,w,x,B,C,D,t);b=c[t>>2]|0;if((k|0)>(b|0)){e=a[D+11>>0]|0;m=a[C+11>>0]|0;m=(e<<24>>24<0?c[D+4>>2]|0:e&255)+(k-b<<1|1)+(m<<24>>24<0?c[C+4>>2]|0:m&255)|0}else{e=a[D+11>>0]|0;m=a[C+11>>0]|0;m=(e<<24>>24<0?c[D+4>>2]|0:e&255)+2+(m<<24>>24<0?c[C+4>>2]|0:m&255)|0}m=m+b|0;if(m>>>0>100){m=Fj(m)|0;n=m;if(!m){m=0;b=c[t>>2]|0}}else{m=s;n=0}Bq(m,y,z,c[f+4>>2]|0,j,j+k|0,p,o,v,a[w>>0]|0,a[x>>0]|0,B,C,D,b);c[A>>2]=c[d>>2];d=c[y>>2]|0;b=c[z>>2]|0;c[u>>2]=c[A>>2];b=Md(u,m,d,b,f,g)|0;if(n|0)Gj(n);Mt(D);Mt(C);Mt(B);vt(c[E>>2]|0)|0;if(r|0)Gj(r);if(q|0)Gj(q);l=F;return b|0}function zq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;C=l;l=l+176|0;q=C+56|0;B=C+52|0;v=C+164|0;w=C+161|0;x=C+160|0;y=C+40|0;z=C+28|0;A=C+16|0;m=C+12|0;k=C+60|0;r=C+8|0;s=C+4|0;t=C;c[B>>2]=Sk(f)|0;u=lm(B,1165628)|0;n=h+11|0;p=a[n>>0]|0;b=p<<24>>24<0;o=h+4|0;if(!((b?c[o>>2]|0:p&255)|0))p=0;else{p=a[(b?c[h>>2]|0:h)>>0]|0;p=p<<24>>24==(nb[c[(c[u>>2]|0)+28>>2]&63](u,45)|0)<<24>>24};c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}Aq(e,p,B,v,w,x,y,z,A,m);e=a[n>>0]|0;b=c[o>>2]|0;i=e<<24>>24<0?b:e&255;j=c[m>>2]|0;if((i|0)>(j|0)){E=a[A+11>>0]|0;D=a[z+11>>0]|0;i=(E<<24>>24<0?c[A+4>>2]|0:E&255)+(i-j<<1|1)+(D<<24>>24<0?c[z+4>>2]|0:D&255)|0}else{E=a[A+11>>0]|0;i=a[z+11>>0]|0;i=(E<<24>>24<0?c[A+4>>2]|0:E&255)+2+(i<<24>>24<0?c[z+4>>2]|0:i&255)|0}i=i+j|0;if(i>>>0>100){i=Fj(i)|0;k=i;if(!i){i=0;j=c[m>>2]|0;e=a[n>>0]|0;b=c[o>>2]|0}}else{i=k;k=0}E=e<<24>>24<0;D=E?c[h>>2]|0:h;Bq(i,r,s,c[f+4>>2]|0,D,D+(E?b:e&255)|0,u,p,v,a[w>>0]|0,a[x>>0]|0,y,z,A,j);c[t>>2]=c[d>>2];E=c[r>>2]|0;b=c[s>>2]|0;c[q>>2]=c[t>>2];b=Md(q,i,E,b,f,g)|0;if(k|0)Gj(k);Mt(A);Mt(z);Mt(y);vt(c[B>>2]|0)|0;l=C;return b|0}function Aq(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0;p=l;l=l+16|0;o=p;if(b){n=lm(e,1167348)|0;if(d){eb[c[(c[n>>2]|0)+44>>2]&63](o,n);b=c[o>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[n>>2]|0)+32>>2]&63](o,n);b=k+11|0;if((a[b>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0;b=k}else{a[k>>0]=0;a[b>>0]=0;b=k}Qt(k,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);e=n}else{eb[c[(c[n>>2]|0)+40>>2]&63](o,n);b=c[o>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[n>>2]|0)+28>>2]&63](o,n);b=k+11|0;if((a[b>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0;b=k}else{a[k>>0]=0;a[b>>0]=0;b=k}Qt(k,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);e=n}a[g>>0]=hb[c[(c[n>>2]|0)+12>>2]&127](n)|0;a[h>>0]=hb[c[(c[n>>2]|0)+16>>2]&127](n)|0;eb[c[(c[e>>2]|0)+20>>2]&63](o,n);b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0;b=i}else{a[i>>0]=0;a[b>>0]=0;b=i}Qt(i,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);eb[c[(c[e>>2]|0)+24>>2]&63](o,n);b=j+11|0;if((a[b>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0;b=j}else{a[j>>0]=0;a[b>>0]=0;b=j}Qt(j,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);b=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{n=lm(e,1167340)|0;if(d){eb[c[(c[n>>2]|0)+44>>2]&63](o,n);b=c[o>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[n>>2]|0)+32>>2]&63](o,n);b=k+11|0;if((a[b>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0;b=k}else{a[k>>0]=0;a[b>>0]=0;b=k}Qt(k,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);e=n}else{eb[c[(c[n>>2]|0)+40>>2]&63](o,n);b=c[o>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[n>>2]|0)+28>>2]&63](o,n);b=k+11|0;if((a[b>>0]|0)<0){a[c[k>>2]>>0]=0;c[k+4>>2]=0;b=k}else{a[k>>0]=0;a[b>>0]=0;b=k}Qt(k,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);e=n}a[g>>0]=hb[c[(c[n>>2]|0)+12>>2]&127](n)|0;a[h>>0]=hb[c[(c[n>>2]|0)+16>>2]&127](n)|0;eb[c[(c[e>>2]|0)+20>>2]&63](o,n);b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0;b=i}else{a[i>>0]=0;a[b>>0]=0;b=i}Qt(i,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);eb[c[(c[e>>2]|0)+24>>2]&63](o,n);b=j+11|0;if((a[b>>0]|0)<0){a[c[j>>2]>>0]=0;c[j+4>>2]=0;b=j}else{a[j>>0]=0;a[b>>0]=0;b=j}Qt(j,0);c[b>>2]=c[o>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];b=0;while(1){if((b|0)==3)break;c[o+(b<<2)>>2]=0;b=b+1|0}Mt(o);b=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0}c[m>>2]=b;l=p;return}function Bq(d,e,f,g,h,i,j,k,l,m,n,o,p,q,r){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c[f>>2]=d;z=q+11|0;H=q+4|0;A=p+11|0;B=p+4|0;C=(g&512|0)==0;D=j+8|0;E=(r|0)>0;F=o+11|0;G=o+4|0;y=0;while(1){if((y|0)==4)break;a:do switch(a[l+y>>0]|0){case 0:{c[e>>2]=c[f>>2];break}case 1:{c[e>>2]=c[f>>2];w=nb[c[(c[j>>2]|0)+28>>2]&63](j,32)|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=w;break}case 3:{x=a[z>>0]|0;s=x<<24>>24<0;if((s?c[H>>2]|0:x&255)|0){w=a[(s?c[q>>2]|0:q)>>0]|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=w}break}case 2:{t=a[A>>0]|0;s=t<<24>>24<0;t=s?c[B>>2]|0:t&255;if(!(C|(t|0)==0)){x=s?c[p>>2]|0:p;u=x+t|0;s=c[f>>2]|0;t=x;while(1){if((t|0)==(u|0))break;a[s>>0]=a[t>>0]|0;s=s+1|0;t=t+1|0}c[f>>2]=s}break}case 4:{t=c[f>>2]|0;h=k?h+1|0:h;u=h;while(1){if(u>>>0>=i>>>0)break;s=a[u>>0]|0;if(s<<24>>24<=-1)break;if(!(b[(c[D>>2]|0)+(s<<24>>24<<1)>>1]&2048))break;u=u+1|0}if(E){v=r;while(1){s=(v|0)>0;if(!(u>>>0>h>>>0&s))break;x=u+-1|0;s=a[x>>0]|0;w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=s;v=v+-1|0;u=x}if(s)w=nb[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;else w=0;s=v;while(1){v=c[f>>2]|0;c[f>>2]=v+1;if((s|0)<=0)break;a[v>>0]=w;s=s+-1|0}a[v>>0]=m}b:do if((u|0)==(h|0)){w=nb[c[(c[j>>2]|0)+28>>2]&63](j,48)|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=w}else{x=a[F>>0]|0;s=x<<24>>24<0;if(!((s?c[G>>2]|0:x&255)|0)){w=-1;v=0;x=0}else{w=a[(s?c[o>>2]|0:o)>>0]|0;v=0;x=0}while(1){if((u|0)==(h|0))break b;if((x|0)==(w|0)){w=c[f>>2]|0;c[f>>2]=w+1;a[w>>0]=n;v=v+1|0;w=a[F>>0]|0;s=w<<24>>24<0;if(v>>>0<(s?c[G>>2]|0:w&255)>>>0){w=a[(s?c[o>>2]|0:o)+v>>0]|0;w=w<<24>>24==127?-1:w<<24>>24;s=0}else{w=x;s=0}}else s=x;I=u+-1|0;J=a[I>>0]|0;x=c[f>>2]|0;c[f>>2]=x+1;a[x>>0]=J;x=s+1|0;u=I}}while(0);s=c[f>>2]|0;if((t|0)!=(s|0))while(1){s=s+-1|0;if(t>>>0>=s>>>0)break a;J=a[t>>0]|0;a[t>>0]=a[s>>0]|0;a[s>>0]=J;t=t+1|0}break}default:{}}while(0);y=y+1|0}h=a[z>>0]|0;s=h<<24>>24<0;h=s?c[H>>2]|0:h&255;if(h>>>0>1){J=s?c[q>>2]|0:q;t=J+h|0;s=c[f>>2]|0;h=J;while(1){h=h+1|0;if((h|0)==(t|0))break;a[s>>0]=a[h>>0]|0;s=s+1|0}c[f>>2]=s}switch((g&176)<<24>>24){case 32:{c[e>>2]=c[f>>2];break}case 16:break;default:c[e>>2]=d}return}function Cq(a){a=a|0;return}function Dq(a){a=a|0;Dt(a);return}function Eq(b,d,e,f,g,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;i=+i;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+1008|0;u=F+8|0;b=F;k=F+896|0;n=F+888|0;j=F+488|0;E=F+480|0;v=F+892|0;w=F+476|0;x=F+472|0;B=F+460|0;C=F+448|0;D=F+436|0;t=F+432|0;s=F+32|0;y=F+24|0;z=F+16|0;A=F+20|0;c[n>>2]=k;h[u>>3]=i;k=Wh(k,100,27074,u)|0;if(k>>>0>99){k=nm()|0;h[b>>3]=i;k=Dn(n,k,27074,b)|0;b=c[n>>2]|0;if(!b)b=c[n>>2]|0;j=Fj(k<<2)|0;m=j;if(!j){j=0;r=m;q=b}else{r=m;q=b}}else{r=0;q=0}c[E>>2]=Sk(f)|0;p=lm(E,1165660)|0;o=c[n>>2]|0;lb[c[(c[p>>2]|0)+48>>2]&7](p,o,o+k|0,j)|0;if(!k)o=0;else o=(a[c[n>>2]>>0]|0)==45;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[C+(b<<2)>>2]=0;b=b+1|0}c[D>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[D+(b<<2)>>2]=0;b=b+1|0}Gq(e,o,E,v,w,x,B,C,D,t);b=c[t>>2]|0;if((k|0)>(b|0)){e=a[D+8+3>>0]|0;m=a[C+8+3>>0]|0;m=(e<<24>>24<0?c[D+4>>2]|0:e&255)+(k-b<<1|1)+(m<<24>>24<0?c[C+4>>2]|0:m&255)|0}else{e=a[D+8+3>>0]|0;m=a[C+8+3>>0]|0;m=(e<<24>>24<0?c[D+4>>2]|0:e&255)+2+(m<<24>>24<0?c[C+4>>2]|0:m&255)|0}m=m+b|0;if(m>>>0>100){m=Fj(m<<2)|0;n=m;if(!m){m=0;b=c[t>>2]|0}}else{m=s;n=0}Hq(m,y,z,c[f+4>>2]|0,j,j+(k<<2)|0,p,o,v,c[w>>2]|0,c[x>>2]|0,B,C,D,b);c[A>>2]=c[d>>2];d=c[y>>2]|0;b=c[z>>2]|0;c[u>>2]=c[A>>2];b=Rn(u,m,d,b,f,g)|0;if(n|0)Gj(n);fu(D);fu(C);Mt(B);vt(c[E>>2]|0)|0;if(r|0)Gj(r);if(q|0)Gj(q);l=F;return b|0}function Fq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;C=l;l=l+480|0;q=C+468|0;B=C+464|0;v=C+472|0;w=C+460|0;x=C+456|0;y=C+444|0;z=C+432|0;A=C+420|0;n=C+416|0;k=C+16|0;r=C+8|0;s=C+4|0;t=C;c[B>>2]=Sk(f)|0;u=lm(B,1165660)|0;o=h+8+3|0;p=a[o>>0]|0;b=p<<24>>24<0;m=h+4|0;if(!((b?c[m>>2]|0:p&255)|0))p=0;else{p=c[(b?c[h>>2]|0:h)>>2]|0;p=(p|0)==(nb[c[(c[u>>2]|0)+44>>2]&63](u,45)|0)};c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}Gq(e,p,B,v,w,x,y,z,A,n);b=a[o>>0]|0;j=c[m>>2]|0;i=b<<24>>24<0?j:b&255;e=c[n>>2]|0;if((i|0)>(e|0)){E=a[A+8+3>>0]|0;D=a[z+8+3>>0]|0;i=(E<<24>>24<0?c[A+4>>2]|0:E&255)+(i-e<<1|1)+(D<<24>>24<0?c[z+4>>2]|0:D&255)|0}else{E=a[A+8+3>>0]|0;i=a[z+8+3>>0]|0;i=(E<<24>>24<0?c[A+4>>2]|0:E&255)+2+(i<<24>>24<0?c[z+4>>2]|0:i&255)|0}i=i+e|0;if(i>>>0>100){i=Fj(i<<2)|0;k=i;if(!i){i=0;j=c[m>>2]|0;e=c[n>>2]|0;b=a[o>>0]|0}}else{i=k;k=0}E=b<<24>>24<0;D=E?c[h>>2]|0:h;Hq(i,r,s,c[f+4>>2]|0,D,D+((E?j:b&255)<<2)|0,u,p,v,c[w>>2]|0,c[x>>2]|0,y,z,A,e);c[t>>2]=c[d>>2];E=c[r>>2]|0;b=c[s>>2]|0;c[q>>2]=c[t>>2];b=Rn(q,i,E,b,f,g)|0;if(k|0)Gj(k);fu(A);fu(z);Mt(y);vt(c[B>>2]|0)|0;l=C;return b|0}function Gq(b,d,e,f,g,h,i,j,k,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0;o=l;l=l+16|0;n=o;if(b){e=lm(e,1167364)|0;if(d){eb[c[(c[e>>2]|0)+44>>2]&63](n,e);b=c[n>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[e>>2]|0)+32>>2]&63](n,e);b=k+8+3|0;if((a[b>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[b>>0]=0}ju(k,0);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n)}else{eb[c[(c[e>>2]|0)+40>>2]&63](n,e);b=c[n>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[e>>2]|0)+28>>2]&63](n,e);b=k+8+3|0;if((a[b>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[b>>0]=0}ju(k,0);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n)}c[g>>2]=hb[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=hb[c[(c[e>>2]|0)+16>>2]&127](e)|0;eb[c[(c[e>>2]|0)+20>>2]&63](n,e);b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0;b=i}else{a[i>>0]=0;a[b>>0]=0;b=i}Qt(i,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[e>>2]|0)+24>>2]&63](n,e);b=j+8+3|0;if((a[b>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[b>>0]=0}ju(j,0);c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);b=hb[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{e=lm(e,1167356)|0;if(d){eb[c[(c[e>>2]|0)+44>>2]&63](n,e);b=c[n>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[e>>2]|0)+32>>2]&63](n,e);b=k+8+3|0;if((a[b>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[b>>0]=0}ju(k,0);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n)}else{eb[c[(c[e>>2]|0)+40>>2]&63](n,e);b=c[n>>2]|0;a[f>>0]=b;a[f+1>>0]=b>>8;a[f+2>>0]=b>>16;a[f+3>>0]=b>>24;eb[c[(c[e>>2]|0)+28>>2]&63](n,e);b=k+8+3|0;if((a[b>>0]|0)<0){c[c[k>>2]>>2]=0;c[k+4>>2]=0}else{c[k>>2]=0;a[b>>0]=0}ju(k,0);c[k>>2]=c[n>>2];c[k+4>>2]=c[n+4>>2];c[k+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n)}c[g>>2]=hb[c[(c[e>>2]|0)+12>>2]&127](e)|0;c[h>>2]=hb[c[(c[e>>2]|0)+16>>2]&127](e)|0;eb[c[(c[e>>2]|0)+20>>2]&63](n,e);b=i+11|0;if((a[b>>0]|0)<0){a[c[i>>2]>>0]=0;c[i+4>>2]=0;b=i}else{a[i>>0]=0;a[b>>0]=0;b=i}Qt(i,0);c[b>>2]=c[n>>2];c[b+4>>2]=c[n+4>>2];c[b+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}Mt(n);eb[c[(c[e>>2]|0)+24>>2]&63](n,e);b=j+8+3|0;if((a[b>>0]|0)<0){c[c[j>>2]>>2]=0;c[j+4>>2]=0}else{c[j>>2]=0;a[b>>0]=0}ju(j,0);c[j>>2]=c[n>>2];c[j+4>>2]=c[n+4>>2];c[j+8>>2]=c[n+8>>2];b=0;while(1){if((b|0)==3)break;c[n+(b<<2)>>2]=0;b=b+1|0}fu(n);b=hb[c[(c[e>>2]|0)+36>>2]&127](e)|0}c[m>>2]=b;l=o;return}function Hq(b,d,e,f,g,h,i,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;c[e>>2]=b;B=p+8+3|0;I=p+4|0;C=o+8+3|0;D=o+4|0;E=(f&512|0)==0;F=(q|0)>0;G=n+11|0;H=n+4|0;A=0;while(1){if((A|0)==4)break;a:do switch(a[k+A>>0]|0){case 0:{c[d>>2]=c[e>>2];break}case 1:{c[d>>2]=c[e>>2];y=nb[c[(c[i>>2]|0)+44>>2]&63](i,32)|0;z=c[e>>2]|0;c[e>>2]=z+4;c[z>>2]=y;break}case 3:{z=a[B>>0]|0;r=z<<24>>24<0;if((r?c[I>>2]|0:z&255)|0){y=c[(r?c[p>>2]|0:p)>>2]|0;z=c[e>>2]|0;c[e>>2]=z+4;c[z>>2]=y}break}case 2:{v=a[C>>0]|0;r=v<<24>>24<0;v=r?c[D>>2]|0:v&255;if(!(E|(v|0)==0)){u=r?c[o>>2]|0:o;s=u+(v<<2)|0;t=c[e>>2]|0;r=t;while(1){if((u|0)==(s|0))break;c[r>>2]=c[u>>2];r=r+4|0;u=u+4|0}c[e>>2]=t+(v<<2)}break}case 4:{s=c[e>>2]|0;g=j?g+4|0:g;r=g;while(1){if(r>>>0>=h>>>0)break;if(!(ab[c[(c[i>>2]|0)+12>>2]&31](i,2048,c[r>>2]|0)|0))break;r=r+4|0}if(F){u=q;while(1){t=(u|0)>0;if(!(r>>>0>g>>>0&t))break;z=r+-4|0;x=c[z>>2]|0;y=c[e>>2]|0;c[e>>2]=y+4;c[y>>2]=x;u=u+-1|0;r=z}if(t)w=nb[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;else w=0;v=c[e>>2]|0;while(1){t=v+4|0;if((u|0)<=0)break;c[v>>2]=w;u=u+-1|0;v=t}c[e>>2]=t;c[v>>2]=l}if((r|0)==(g|0)){y=nb[c[(c[i>>2]|0)+44>>2]&63](i,48)|0;z=c[e>>2]|0;r=z+4|0;c[e>>2]=r;c[z>>2]=y}else{z=a[G>>0]|0;y=z<<24>>24<0;z=y?c[H>>2]|0:z&255;if(!z){v=-1;t=0;w=0}else{v=a[(y?c[n>>2]|0:n)>>0]|0;t=0;w=0}while(1){if((r|0)==(g|0))break;u=c[e>>2]|0;if((w|0)==(v|0)){x=u+4|0;c[e>>2]=x;c[u>>2]=m;t=t+1|0;if(t>>>0<z>>>0){v=a[(y?c[n>>2]|0:n)+t>>0]|0;v=v<<24>>24==127?-1:v<<24>>24;w=0;u=x}else{v=w;w=0;u=x}}x=r+-4|0;J=c[x>>2]|0;c[e>>2]=u+4;c[u>>2]=J;w=w+1|0;r=x}r=c[e>>2]|0}if((s|0)!=(r|0))while(1){r=r+-4|0;if(s>>>0>=r>>>0)break a;J=c[s>>2]|0;c[s>>2]=c[r>>2];c[r>>2]=J;s=s+4|0}break}default:{}}while(0);A=A+1|0}g=a[B>>0]|0;r=g<<24>>24<0;g=r?c[I>>2]|0:g&255;if(g>>>0>1){r=r?c[p>>2]|0:p;u=r+4|0;r=r+(g<<2)|0;s=c[e>>2]|0;t=r-u|0;g=s;while(1){if((u|0)==(r|0))break;c[g>>2]=c[u>>2];g=g+4|0;u=u+4|0}c[e>>2]=s+(t>>>2<<2)}switch((f&176)<<24>>24){case 32:{c[d>>2]=c[e>>2];break}case 16:break;default:c[d>>2]=b}return}function Iq(a){a=a|0;return}function Jq(a){a=a|0;Dt(a);return}function Kq(b,d,e){b=b|0;d=d|0;e=e|0;e=oj((a[d+11>>0]|0)<0?c[d>>2]|0:d,1)|0;return e>>>((e|0)!=(-1|0)&1)|0}function Lq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0;j=l;l=l+16|0;i=j;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[i+(d<<2)>>2]=0;d=d+1|0}k=a[h+11>>0]|0;m=k<<24>>24<0;d=m?c[h>>2]|0:h;h=d+(m?c[h+4>>2]|0:k&255)|0;while(1){if(d>>>0>=h>>>0)break;Xt(i,a[d>>0]|0);d=d+1|0}d=pj((e|0)==-1?-1:e<<1,f,g,(a[i+11>>0]|0)<0?c[i>>2]|0:i)|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;h=0;while(1){if((h|0)==3)break;c[b+(h<<2)>>2]=0;h=h+1|0}h=d+(Vh(d)|0)|0;while(1){if(d>>>0>=h>>>0)break;Xt(b,a[d>>0]|0);d=d+1|0}Mt(i);l=j;return}function Mq(a,b){a=a|0;b=b|0;return}function Nq(a){a=a|0;return}function Oq(a){a=a|0;Dt(a);return}function Pq(b,d,e){b=b|0;d=d|0;e=e|0;e=oj((a[d+11>>0]|0)<0?c[d>>2]|0:d,1)|0;return e>>>((e|0)!=(-1|0)&1)|0}function Qq(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=l;l=l+176|0;p=t+168|0;q=t+40|0;r=t+36|0;s=t+32|0;n=t;m=t+24|0;o=t+16|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[n+(d<<2)>>2]=0;d=d+1|0}c[m+4>>2]=0;c[m>>2]=19176;j=a[h+8+3>>0]|0;k=j<<24>>24<0;d=k?c[h>>2]|0:h;j=d+((k?c[h+4>>2]|0:j&255)<<2)|0;k=q+32|0;h=d;d=0;while(1){if(!((d|0)!=2&h>>>0<j>>>0))break;c[s>>2]=h;i=kb[c[(c[m>>2]|0)+12>>2]&15](m,p,h,j,s,q,k,r)|0;d=q;while(1){if(d>>>0>=(c[r>>2]|0)>>>0)break;Xt(n,a[d>>0]|0);d=d+1|0}h=c[s>>2]|0;d=i}h=pj((e|0)==-1?-1:e<<1,f,g,(a[n+11>>0]|0)<0?c[n>>2]|0:n)|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[b+(d<<2)>>2]=0;d=d+1|0}c[o+4>>2]=0;c[o>>2]=19224;j=h+(Vh(h)|0)|0;k=j;m=q+128|0;d=0;while(1){if(!((d|0)!=2&h>>>0<j>>>0))break;c[s>>2]=h;i=kb[c[(c[o>>2]|0)+16>>2]&15](o,p,h,(k-h|0)>32?h+32|0:j,s,q,m,r)|0;d=q;while(1){if(d>>>0>=(c[r>>2]|0)>>>0)break;mu(b,c[d>>2]|0);d=d+4|0}h=c[s>>2]|0;d=i}Mt(n);l=t;return}function Rq(a,b){a=a|0;b=b|0;return}function Sq(a){a=a|0;return}function Tq(a){a=a|0;Dt(a);return}function Uq(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=br(d,e,j,g,h,a,1114111,0)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function Vq(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=ar(d,e,j,g,h,a,1114111,0)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function Wq(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function Xq(a){a=a|0;return 0}function Yq(a){a=a|0;return 0}function Zq(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return $q(c,d,e,1114111,0)|0}function _q(a){a=a|0;return 4}function $q(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=c;if((((g&4|0)!=0?(o-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0){n=0;g=(a[b+2>>0]|0)==-65?b+3|0:b}else{n=0;g=b}a:while(1){if(!(n>>>0<e>>>0&g>>>0<c>>>0)){h=40;break}l=a[g>>0]|0;m=l&255;do if(l<<24>>24<=-1){if((l&255)<194){h=40;break a}if((l&255)<224){if((o-g|0)<2){h=40;break a}h=d[g+1>>0]|0;if((h&192|0)!=128){h=40;break a}if((h&63|m<<6&1984)>>>0>f>>>0){h=40;break a}g=g+2|0;break}if((l&255)<240){i=g;if((o-i|0)<3){h=40;break a}j=a[g+1>>0]|0;h=a[g+2>>0]|0;switch(l<<24>>24){case -32:{if((j&-32)<<24>>24!=-96){h=20;break a}break}case -19:{if((j&-32)<<24>>24!=-128){h=22;break a}break}default:if((j&-64)<<24>>24!=-128){h=24;break a}}h=h&255;if((h&192|0)!=128){h=40;break a}if(((j&255)<<6&4032|m<<12&61440|h&63)>>>0>f>>>0){h=40;break a}else{g=g+3|0;break}}if((l&255)>=245){h=40;break a}i=g;if((o-i|0)<4){h=40;break a}k=a[g+1>>0]|0;h=a[g+2>>0]|0;j=a[g+3>>0]|0;switch(l<<24>>24){case -16:{if((k+112&255)>=48){h=31;break a}break}case -12:{if((k&-16)<<24>>24!=-128){h=33;break a}break}default:if((k&-64)<<24>>24!=-128){h=35;break a}}i=h&255;if((i&192|0)!=128){h=40;break a}h=j&255;if((h&192|0)!=128){h=40;break a}if(((k&255)<<12&258048|m<<18&1835008|i<<6&4032|h&63)>>>0>f>>>0){h=40;break a}else g=g+4|0}else{if(m>>>0>f>>>0){h=40;break a}g=g+1|0}while(0);n=n+1|0}if((h|0)==20)g=i-b|0;else if((h|0)==22)g=i-b|0;else if((h|0)==24)g=i-b|0;else if((h|0)==31)g=i-b|0;else if((h|0)==33)g=i-b|0;else if((h|0)==35)g=i-b|0;else if((h|0)==40)g=g-b|0;return g|0}function ar(b,e,f,g,h,i,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;c[f>>2]=b;c[i>>2]=g;if(k&4){b=c[f>>2]|0;g=e;if((((g-b|0)>2?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0)?(a[b+2>>0]|0)==-65:0)c[f>>2]=b+3}else g=e;a:while(1){p=c[f>>2]|0;b=p>>>0<e>>>0;if(!b){r=40;break}q=c[i>>2]|0;if(q>>>0>=h>>>0){r=40;break}m=a[p>>0]|0;o=m&255;do if(m<<24>>24>-1){if(o>>>0>j>>>0){b=2;break a}c[q>>2]=o;c[f>>2]=p+1}else{if((m&255)<194){b=2;break a}if((m&255)<224){if((g-p|0)<2){b=1;break a}b=d[p+1>>0]|0;if((b&192|0)!=128){b=2;break a}b=b&63|o<<6&1984;if(b>>>0>j>>>0){b=2;break a}c[q>>2]=b;c[f>>2]=p+2;break}if((m&255)<240){if((g-p|0)<3){b=1;break a}k=a[p+1>>0]|0;b=a[p+2>>0]|0;switch(m<<24>>24){case -32:{if((k&-32)<<24>>24!=-96){b=2;break a}break}case -19:{if((k&-32)<<24>>24!=-128){b=2;break a}break}default:if((k&-64)<<24>>24!=-128){b=2;break a}}b=b&255;if((b&192|0)!=128){b=2;break a}b=(k&255)<<6&4032|o<<12&61440|b&63;if(b>>>0>j>>>0){b=2;break a}c[q>>2]=b;c[f>>2]=p+3;break}if((m&255)>=245){b=2;break a}if((g-p|0)<4){b=1;break a}n=a[p+1>>0]|0;b=a[p+2>>0]|0;l=a[p+3>>0]|0;switch(m<<24>>24){case -16:{if((n+112&255)>=48){b=2;break a}break}case -12:{if((n&-16)<<24>>24!=-128){b=2;break a}break}default:if((n&-64)<<24>>24!=-128){b=2;break a}}k=b&255;if((k&192|0)!=128){b=2;break a}b=l&255;if((b&192|0)!=128){b=2;break a}b=(n&255)<<12&258048|o<<18&1835008|k<<6&4032|b&63;if(b>>>0>j>>>0){b=2;break a}c[q>>2]=b;c[f>>2]=p+4}while(0);c[i>>2]=(c[i>>2]|0)+4}if((r|0)==40)b=b&1;return b|0}function br(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0;c[e>>2]=b;c[h>>2]=f;l=g;if(j&2)if((l-f|0)<3)b=1;else{c[h>>2]=f+1;a[f>>0]=-17;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-69;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=-65;k=4}else k=4;a:do if((k|0)==4){b=c[e>>2]|0;while(1){if(b>>>0>=d>>>0){b=0;break a}f=c[b>>2]|0;if(f>>>0>i>>>0|(f&-2048|0)==55296){b=2;break a}do if(f>>>0>=128){if(f>>>0<2048){b=c[h>>2]|0;if((l-b|0)<2){b=1;break a}c[h>>2]=b+1;a[b>>0]=f>>>6|192;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=f&63|128;break}b=c[h>>2]|0;g=l-b|0;if(f>>>0<65536){if((g|0)<3){b=1;break a}c[h>>2]=b+1;a[b>>0]=f>>>12|224;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=f>>>6&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=f&63|128;break}else{if((g|0)<4){b=1;break a}c[h>>2]=b+1;a[b>>0]=f>>>18|240;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=f>>>12&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=f>>>6&63|128;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=f&63|128;break}}else{b=c[h>>2]|0;if((l-b|0)<1){b=1;break a}c[h>>2]=b+1;a[b>>0]=f}while(0);b=(c[e>>2]|0)+4|0;c[e>>2]=b}}while(0);return b|0}function cr(a){a=a|0;Dt(a);return}function dr(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function er(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;c[f>>2]=d;c[i>>2]=g;return 3}function fr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function gr(a){a=a|0;return 1}function hr(a){a=a|0;return 1}function ir(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;d=d-c|0;return (d>>>0<e>>>0?d:e)|0}function jr(a){a=a|0;return 1}function kr(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;r=l;l=l+16|0;q=r;o=r+8|0;k=e;while(1){if((k|0)==(f|0)){k=f;break}if(!(c[k>>2]|0))break;k=k+4|0}c[j>>2]=h;c[g>>2]=e;n=i;p=b+8|0;a:while(1){if((h|0)==(i|0)|(e|0)==(f|0)){k=35;break}s=d;m=c[s+4>>2]|0;b=q;c[b>>2]=c[s>>2];c[b+4>>2]=m;b=nj(c[p>>2]|0)|0;m=ej(h,g,k-e>>2,n-h|0,d)|0;if(b|0)nj(b)|0;switch(m|0){case -1:{k=10;break a}case 0:{e=1;k=32;break a}default:{}}h=(c[j>>2]|0)+m|0;c[j>>2]=h;if((h|0)==(i|0)){k=33;break}if((k|0)==(f|0)){k=f;e=c[g>>2]|0}else{h=nj(c[p>>2]|0)|0;e=ii(o,0,d)|0;if(h|0)nj(h)|0;if((e|0)==-1){e=2;k=31;break}if(e>>>0>(n-(c[j>>2]|0)|0)>>>0){e=1;k=31;break}else h=o;while(1){if(!e)break;m=a[h>>0]|0;s=c[j>>2]|0;c[j>>2]=s+1;a[s>>0]=m;h=h+1|0;e=e+-1|0}e=(c[g>>2]|0)+4|0;c[g>>2]=e;k=e;while(1){if((k|0)==(f|0)){k=f;break}if(!(c[k>>2]|0))break;k=k+4|0}h=c[j>>2]|0}}if((k|0)==10){c[j>>2]=h;while(1){if((e|0)==(c[g>>2]|0))break;s=c[e>>2]|0;k=nj(c[p>>2]|0)|0;h=ii(h,s,q)|0;if(k|0)nj(k)|0;if((h|0)==-1)break;h=(c[j>>2]|0)+h|0;c[j>>2]=h;e=e+4|0}c[g>>2]=e;e=2;k=32}else if((k|0)==31)k=32;else if((k|0)==33){e=c[g>>2]|0;k=35}if((k|0)!=32)if((k|0)==35)e=(e|0)!=(f|0)&1;l=r;return e|0}function lr(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+16|0;q=r;k=e;while(1){if((k|0)==(f|0)){k=f;break}if(!(a[k>>0]|0))break;k=k+1|0}c[j>>2]=h;c[g>>2]=e;o=i;p=b+8|0;b=h;while(1){if((b|0)==(i|0)|(e|0)==(f|0)){b=33;break}m=d;h=c[m+4>>2]|0;n=q;c[n>>2]=c[m>>2];c[n+4>>2]=h;n=k;h=nj(c[p>>2]|0)|0;m=aj(b,g,n-e|0,o-b>>2,d)|0;if(h|0)nj(h)|0;if((m|0)==-1){k=b;b=10;break}b=(c[j>>2]|0)+(m<<2)|0;c[j>>2]=b;if((b|0)==(i|0)){b=30;break}e=c[g>>2]|0;if((k|0)==(f|0))k=f;else{k=nj(c[p>>2]|0)|0;e=yi(b,e,1,d)|0;if(k|0)nj(k)|0;if(e|0){e=2;b=29;break}c[j>>2]=(c[j>>2]|0)+4;e=(c[g>>2]|0)+1|0;c[g>>2]=e;k=e;while(1){if((k|0)==(f|0)){k=f;break}if(!(a[k>>0]|0))break;k=k+1|0}b=c[j>>2]|0}}do if((b|0)==10){a:while(1){c[j>>2]=k;if((e|0)==(c[g>>2]|0)){b=19;break}b=nj(c[p>>2]|0)|0;k=yi(k,e,n-e|0,q)|0;if(b|0)nj(b)|0;switch(k|0){case -1:{b=15;break a}case -2:{b=16;break a}case 0:{e=e+1|0;break}default:e=e+k|0}k=(c[j>>2]|0)+4|0;b=10}if((b|0)==15){c[g>>2]=e;e=2;b=29;break}else if((b|0)==16){c[g>>2]=e;e=1;b=29;break}else if((b|0)==19){c[g>>2]=e;e=(e|0)!=(f|0)&1;b=29;break}}else if((b|0)==30){e=c[g>>2]|0;b=33}while(0);if((b|0)!=29)if((b|0)==33)e=(e|0)!=(f|0)&1;l=r;return e|0}function mr(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;i=l;l=l+16|0;h=i;c[g>>2]=e;e=nj(c[b+8>>2]|0)|0;b=ii(h,0,d)|0;if(e|0)nj(e)|0;a:do switch(b|0){case 0:case -1:{b=2;break}default:{b=b+-1|0;if(b>>>0>(f-(c[g>>2]|0)|0)>>>0)b=1;else while(1){if(!b){b=0;break a}d=a[h>>0]|0;f=c[g>>2]|0;c[g>>2]=f+1;a[f>>0]=d;h=h+1|0;b=b+-1|0}}}while(0);l=i;return b|0}function nr(a){a=a|0;var b=0,d=0;a=a+8|0;b=nj(c[a>>2]|0)|0;d=ni(0,0,4)|0;if(b|0)nj(b)|0;if(!d){a=c[a>>2]|0;if(a){a=nj(a)|0;if(!a)a=0;else{nj(a)|0;a=0}}else a=1}else a=-1;return a|0}function or(a){a=a|0;return 0}function pr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=e;j=a+8|0;h=0;i=0;a:while(1){if((d|0)==(e|0)|h>>>0>=f>>>0)break;g=nj(c[j>>2]|0)|0;a=dj(d,k-d|0,b)|0;if(g|0)nj(g)|0;switch(a|0){case -2:case -1:break a;case 0:{d=d+1|0;a=1;break}default:d=d+a|0}h=h+1|0;i=a+i|0}return i|0}function qr(a){a=a|0;a=c[a+8>>2]|0;if(a){a=nj(a)|0;if(!a)a=4;else{nj(a)|0;a=4}}else a=1;return a|0}function rr(a){a=a|0;var b=0;c[a>>2]=19272;a=a+8|0;b=c[a>>2]|0;if((b|0)!=(nm()|0))qj(c[a>>2]|0);return}function sr(a){a=a|0;rr(a);Dt(a);return}function tr(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=Cr(d,e,j,g,h,a,1114111,0)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function ur(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0;b=l;l=l+16|0;j=b+4|0;a=b;c[j>>2]=d;c[a>>2]=g;h=Br(d,e,j,g,h,a,1114111,0)|0;c[f>>2]=c[j>>2];c[i>>2]=c[a>>2];l=b;return h|0}function vr(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;return 3}function wr(a){a=a|0;return 0}function xr(a){a=a|0;return 0}function yr(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ar(c,d,e,1114111,0)|0}function zr(a){a=a|0;return 4}function Ar(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=c;if((((g&4|0)!=0?(o-b|0)>2:0)?(a[b>>0]|0)==-17:0)?(a[b+1>>0]|0)==-69:0){g=0;n=(a[b+2>>0]|0)==-65?b+3|0:b}else{g=0;n=b}a:while(1){if(!(g>>>0<e>>>0&n>>>0<c>>>0)){h=39;break}l=a[n>>0]|0;m=l&255;if(m>>>0>f>>>0){h=39;break}do if(l<<24>>24<=-1){if((l&255)<194){h=39;break a}if((l&255)<224){if((o-n|0)<2){h=39;break a}h=d[n+1>>0]|0;if((h&192|0)!=128){h=39;break a}if((h&63|m<<6&1984)>>>0>f>>>0){h=39;break a}else{h=n+2|0;break}}if((l&255)<240){i=n;if((o-i|0)<3){h=39;break a}j=a[n+1>>0]|0;h=a[n+2>>0]|0;switch(l<<24>>24){case -32:{if((j&-32)<<24>>24!=-96){h=19;break a}break}case -19:{if((j&-32)<<24>>24!=-128){h=21;break a}break}default:if((j&-64)<<24>>24!=-128){h=23;break a}}h=h&255;if((h&192|0)!=128){h=39;break a}if(((j&255)<<6&4032|m<<12&61440|h&63)>>>0>f>>>0){h=39;break a}else{h=n+3|0;break}}if((l&255)>=245){h=39;break a}i=n;if((e-g|0)>>>0<2|(o-i|0)<4){h=39;break a}k=a[n+1>>0]|0;h=a[n+2>>0]|0;j=a[n+3>>0]|0;switch(l<<24>>24){case -16:{if((k+112&255)>=48){h=30;break a}break}case -12:{if((k&-16)<<24>>24!=-128){h=32;break a}break}default:if((k&-64)<<24>>24!=-128){h=34;break a}}i=h&255;if((i&192|0)!=128){h=39;break a}h=j&255;if((h&192|0)!=128){h=39;break a}if(((k&255)<<12&258048|m<<18&1835008|i<<6&4032|h&63)>>>0>f>>>0){h=39;break a}else{g=g+1|0;h=n+4|0}}else h=n+1|0;while(0);g=g+1|0;n=h}if((h|0)==19)g=i-b|0;else if((h|0)==21)g=i-b|0;else if((h|0)==23)g=i-b|0;else if((h|0)==30)g=i-b|0;else if((h|0)==32)g=i-b|0;else if((h|0)==34)g=i-b|0;else if((h|0)==39)g=n-b|0;return g|0}function Br(e,f,g,h,i,j,k,l){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c[g>>2]=e;c[j>>2]=h;if(l&4){e=c[g>>2]|0;h=f;if((((h-e|0)>2?(a[e>>0]|0)==-17:0)?(a[e+1>>0]|0)==-69:0)?(a[e+2>>0]|0)==-65:0)c[g>>2]=e+3}else h=f;r=i;a:while(1){n=c[g>>2]|0;e=n>>>0<f>>>0;if(!e){t=41;break}s=c[j>>2]|0;if(s>>>0>=i>>>0){t=41;break}m=a[n>>0]|0;q=m&255;if(q>>>0>k>>>0){e=2;break}do if(m<<24>>24>-1){b[s>>1]=m&255;c[g>>2]=n+1}else{if((m&255)<194){e=2;break a}if((m&255)<224){if((h-n|0)<2){e=1;break a}e=d[n+1>>0]|0;if((e&192|0)!=128){e=2;break a}e=e&63|q<<6&1984;if(e>>>0>k>>>0){e=2;break a}b[s>>1]=e;c[g>>2]=n+2;break}if((m&255)<240){if((h-n|0)<3){e=1;break a}l=a[n+1>>0]|0;e=a[n+2>>0]|0;switch(m<<24>>24){case -32:{if((l&-32)<<24>>24!=-96){e=2;break a}break}case -19:{if((l&-32)<<24>>24!=-128){e=2;break a}break}default:if((l&-64)<<24>>24!=-128){e=2;break a}}e=e&255;if((e&192|0)!=128){e=2;break a}e=(l&255)<<6&4032|q<<12|e&63;if((e&65535)>>>0>k>>>0){e=2;break a}b[s>>1]=e;c[g>>2]=n+3;break}if((m&255)>=245){e=2;break a}if((h-n|0)<4){e=1;break a}o=a[n+1>>0]|0;e=a[n+2>>0]|0;l=a[n+3>>0]|0;switch(m<<24>>24){case -16:{if((o+112&255)>=48){e=2;break a}break}case -12:{if((o&-16)<<24>>24!=-128){e=2;break a}break}default:if((o&-64)<<24>>24!=-128){e=2;break a}}p=e&255;if((p&192|0)!=128){e=2;break a}e=l&255;if((e&192|0)!=128){e=2;break a}if((r-s|0)<4){e=1;break a}n=q&7;l=o&255;m=p<<6;e=e&63;if((l<<12&258048|n<<18|m&4032|e)>>>0>k>>>0){e=2;break a}b[s>>1]=l<<2&60|p>>>4&3|((l>>>4&3|n<<2)<<6)+16320|55296;s=s+2|0;c[j>>2]=s;b[s>>1]=e|m&960|56320;c[g>>2]=(c[g>>2]|0)+4}while(0);c[j>>2]=(c[j>>2]|0)+2}if((t|0)==41)e=e&1;return e|0}function Cr(d,f,g,h,i,j,k,l){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0;c[g>>2]=d;c[j>>2]=h;if(l&2)if((i-h|0)<3)d=1;else{c[j>>2]=h+1;a[h>>0]=-17;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-69;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=-65;m=4}else m=4;a:do if((m|0)==4){n=f;d=c[g>>2]|0;while(1){if(d>>>0>=f>>>0){d=0;break a}h=b[d>>1]|0;m=h&65535;if(m>>>0>k>>>0){d=2;break a}do if((h&65535)<128){d=c[j>>2]|0;if((i-d|0)<1){d=1;break a}c[j>>2]=d+1;a[d>>0]=h}else{if((h&65535)<2048){d=c[j>>2]|0;if((i-d|0)<2){d=1;break a}c[j>>2]=d+1;a[d>>0]=m>>>6|192;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m&63|128;break}if((h&65535)<55296){d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=m>>>12|224;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m>>>6&63|128;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m&63|128;break}if((h&65535)>=56320){if((h&65535)<57344){d=2;break a}d=c[j>>2]|0;if((i-d|0)<3){d=1;break a}c[j>>2]=d+1;a[d>>0]=m>>>12|224;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m>>>6&63|128;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m&63|128;break}if((n-d|0)<4){d=1;break a}d=d+2|0;h=e[d>>1]|0;if((h&64512|0)!=56320){d=2;break a}if((i-(c[j>>2]|0)|0)<4){d=1;break a}l=m&960;if(((l<<10)+65536|m<<10&64512|h&1023)>>>0>k>>>0){d=2;break a}c[g>>2]=d;d=(l>>>6)+1|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=d>>>2|240;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m>>>2&15|d<<4&48|128;l=c[j>>2]|0;c[j>>2]=l+1;a[l>>0]=m<<4&48|h>>>6&15|128;m=c[j>>2]|0;c[j>>2]=m+1;a[m>>0]=h&63|128}while(0);d=(c[g>>2]|0)+2|0;c[g>>2]=d}}while(0);return d|0}function Dr(a){a=a|0;var b=0,d=0,e=0,f=0;c[a>>2]=19320;e=a+8|0;f=a+12|0;d=0;while(1){b=c[e>>2]|0;if(d>>>0>=(c[f>>2]|0)-b>>2>>>0)break;b=c[b+(d<<2)>>2]|0;if(b|0)vt(b)|0;d=d+1|0}Mt(a+144|0);Fr(e);return}function Er(a){a=a|0;Dr(a);Dt(a);return}function Fr(b){b=b|0;var d=0,e=0,f=0,g=0;d=c[b>>2]|0;do if(d|0){e=b+4|0;f=c[e>>2]|0;while(1){if((f|0)==(d|0))break;g=f+-4|0;c[e>>2]=g;f=g}if((b+16|0)==(d|0)){a[b+128>>0]=0;break}else{Dt(d);break}}while(0);return}function Gr(b){b=b|0;var d=0;c[b>>2]=19340;d=c[b+8>>2]|0;if(d|0?a[b+12>>0]|0:0)Et(d);return}function Hr(a){a=a|0;Gr(a);Dt(a);return}function Ir(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[(c[(Cj()|0)>>2]|0)+((b&255)<<2)>>2]&255;return b|0}function Jr(b,d,e){b=b|0;d=d|0;e=e|0;while(1){if((d|0)==(e|0))break;b=a[d>>0]|0;if(b<<24>>24>-1)b=c[(c[(Cj()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;a[d>>0]=b;d=d+1|0}return e|0}function Kr(a,b){a=a|0;b=b|0;if(b<<24>>24>-1)b=c[(c[(Bj()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;return b|0}function Lr(b,d,e){b=b|0;d=d|0;e=e|0;while(1){if((d|0)==(e|0))break;b=a[d>>0]|0;if(b<<24>>24>-1)b=c[(c[(Bj()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;a[d>>0]=b;d=d+1|0}return e|0}function Mr(a,b){a=a|0;b=b|0;return b|0}function Nr(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;while(1){if((c|0)==(d|0))break;a[e>>0]=a[c>>0]|0;e=e+1|0;c=c+1|0}return d|0}function Or(a,b,c){a=a|0;b=b|0;c=c|0;return (b<<24>>24>-1?b:c)|0}function Pr(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;while(1){if((c|0)==(d|0))break;b=a[c>>0]|0;a[f>>0]=b<<24>>24>-1?b:e;f=f+1|0;c=c+1|0}return d|0}function Qr(a){a=a|0;c[a>>2]=19392;Mt(a+12|0);return}function Rr(a){a=a|0;Qr(a);Dt(a);return}function Sr(b){b=b|0;return a[b+8>>0]|0}function Tr(b){b=b|0;return a[b+9>>0]|0}function Ur(a,b){a=a|0;b=b|0;It(a,b+12|0);return}function Vr(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Jt(a,27651,4);return}function Wr(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Jt(a,27645,5);return}function Xr(a){a=a|0;c[a>>2]=19432;Mt(a+16|0);return}function Yr(a){a=a|0;Xr(a);Dt(a);return}function Zr(a){a=a|0;return c[a+8>>2]|0}function _r(a){a=a|0;return c[a+12>>2]|0}function $r(a,b){a=a|0;b=b|0;It(a,b+16|0);return}function as(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;cu(a,19488,oi(19488)|0);return}function bs(a,b){a=a|0;b=b|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;cu(a,19464,oi(19464)|0);return}function cs(a){a=a|0;Dt(a);return}function ds(a){a=a|0;Dt(a);return}function es(a,d,e){a=a|0;d=d|0;e=e|0;if(e>>>0<128)a=(b[(c[(Aj()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;else a=0;return a|0}function fs(a,d,f,g){a=a|0;d=d|0;f=f|0;g=g|0;while(1){if((d|0)==(f|0))break;a=c[d>>2]|0;if(a>>>0<128)a=e[(c[(Aj()|0)>>2]|0)+(a<<1)>>1]|0;else a=0;b[g>>1]=a;g=g+2|0;d=d+4|0}return f|0}function gs(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0<128?(b[(c[(Aj()|0)>>2]|0)+(a<<1)>>1]&d)<<16>>16:0)break;e=e+4|0}return e|0}function hs(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;while(1){if((e|0)==(f|0)){e=f;break}a=c[e>>2]|0;if(a>>>0>=128)break;if(!((b[(c[(Aj()|0)>>2]|0)+(a<<1)>>1]&d)<<16>>16))break;e=e+4|0}return e|0}function is(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[(c[(Cj()|0)>>2]|0)+(b<<2)>>2]|0;return b|0}function js(a,b,d){a=a|0;b=b|0;d=d|0;while(1){if((b|0)==(d|0))break;a=c[b>>2]|0;if(a>>>0<128)a=c[(c[(Cj()|0)>>2]|0)+(a<<2)>>2]|0;c[b>>2]=a;b=b+4|0}return d|0}function ks(a,b){a=a|0;b=b|0;if(b>>>0<128)b=c[(c[(Bj()|0)>>2]|0)+(b<<2)>>2]|0;return b|0}function ls(a,b,d){a=a|0;b=b|0;d=d|0;while(1){if((b|0)==(d|0))break;a=c[b>>2]|0;if(a>>>0<128)a=c[(c[(Bj()|0)>>2]|0)+(a<<2)>>2]|0;c[b>>2]=a;b=b+4|0}return d|0}function ms(a,b){a=a|0;b=b|0;return b<<24>>24|0}function ns(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;while(1){if((d|0)==(e|0))break;c[f>>2]=a[d>>0];f=f+4|0;d=d+1|0}return e|0}function os(a,b,c){a=a|0;b=b|0;c=c|0;return (b>>>0<128?b&255:c)|0}function ps(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=(e-d|0)>>>2;b=g;g=d;while(1){if((g|0)==(e|0))break;i=c[g>>2]|0;a[b>>0]=i>>>0<128?i&255:f;b=b+1|0;g=g+4|0}return d+(h<<2)|0}function qs(a){a=a|0;Dt(a);return}function rs(a){a=a|0;Dt(a);return}function ss(a){a=a|0;Dt(a);return}function ts(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;c[b+4>>2]=f+-1;c[b>>2]=19340;f=b+8|0;c[f>>2]=d;a[b+12>>0]=e&1;if(!d)c[f>>2]=c[(Aj()|0)>>2];return}function us(a){a=a|0;return}function vs(a){a=a|0;Aa(27698,27721,304,28088)}function ws(a){a=a|0;Aa(27807,27721,315,28138)}function xs(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a+4>>2]=b+-1;c[a>>2]=19320;b=a+8|0;ys(b,28);d=a+144|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,25590,1);b=c[b>>2]|0;d=a+12|0;e=c[d>>2]|0;while(1){if((e|0)==(b|0))break;f=e+-4|0;c[d>>2]=f;e=f}c[248493]=0;c[248492]=16984;zs(a,993968);c[248495]=0;c[248494]=17016;As(a,993976);ts(993984,0,0,1);Bs(a,993984);c[248501]=0;c[248500]=19536;Cs(a,994e3);c[248503]=0;c[248502]=19604;Ds(a,994008);c[248505]=0;c[248504]=19272;c[248506]=nm()|0;Es(a,994016);c[248509]=0;c[248508]=19652;Fs(a,994032);c[248511]=0;c[248510]=19700;Gs(a,994040);Hs(994048,1);Is(a,994048);Js(994072,1);Ks(a,994072);c[248527]=0;c[248526]=17048;Ls(a,994104);c[248529]=0;c[248528]=17112;Ms(a,994112);c[248531]=0;c[248530]=17176;Ns(a,994120);c[248533]=0;c[248532]=17228;Os(a,994128);c[248535]=0;c[248534]=18776;Ps(a,994136);c[248537]=0;c[248536]=18832;Qs(a,994144);c[248539]=0;c[248538]=18888;Rs(a,994152);c[248541]=0;c[248540]=18944;Ss(a,994160);c[248543]=0;c[248542]=19e3;Ts(a,994168);c[248545]=0;c[248544]=19028;Us(a,994176);c[248547]=0;c[248546]=19056;Vs(a,994184);c[248549]=0;c[248548]=19084;Ws(a,994192);c[248551]=0;c[248550]=17280;c[248552]=17328;Xs(a,994200);c[248555]=0;c[248554]=17364;c[248556]=17412;Ys(a,994216);c[248559]=0;c[248558]=19516;c[248560]=nm()|0;c[248558]=18728;Zs(a,994232);c[248563]=0;c[248562]=19516;c[248564]=nm()|0;c[248562]=18752;_s(a,994248);c[248567]=0;c[248566]=19112;$s(a,994264);c[248569]=0;c[248568]=19144;at(a,994272);return}function ys(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+128>>0]=0;if(d|0){it(b,d);et(b,d)}return}function zs(a,b){a=a|0;b=b|0;bt(a,b,pm(1165612)|0);return}function As(a,b){a=a|0;b=b|0;bt(a,b,pm(1165620)|0);return}function Bs(a,b){a=a|0;b=b|0;bt(a,b,pm(1165628)|0);return}function Cs(a,b){a=a|0;b=b|0;bt(a,b,pm(1165660)|0);return}function Ds(a,b){a=a|0;b=b|0;bt(a,b,pm(1167420)|0);return}function Es(a,b){a=a|0;b=b|0;bt(a,b,pm(1167428)|0);return}function Fs(a,b){a=a|0;b=b|0;bt(a,b,pm(1167436)|0);return}function Gs(a,b){a=a|0;b=b|0;bt(a,b,pm(1167444)|0);return}function Hs(b,d){b=b|0;d=d|0;c[b+4>>2]=d+-1;c[b>>2]=19392;a[b+8>>0]=46;a[b+9>>0]=44;d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[d+(b<<2)>>2]=0;b=b+1|0}return}function Is(a,b){a=a|0;b=b|0;bt(a,b,pm(1165644)|0);return}function Js(a,b){a=a|0;b=b|0;c[a+4>>2]=b+-1;c[a>>2]=19432;c[a+8>>2]=46;c[a+12>>2]=44;b=a+16|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a=0;while(1){if((a|0)==3)break;c[b+(a<<2)>>2]=0;a=a+1|0}return}function Ks(a,b){a=a|0;b=b|0;bt(a,b,pm(1165668)|0);return}function Ls(a,b){a=a|0;b=b|0;bt(a,b,pm(1165652)|0);return}function Ms(a,b){a=a|0;b=b|0;bt(a,b,pm(1165676)|0);return}function Ns(a,b){a=a|0;b=b|0;bt(a,b,pm(1165684)|0);return}function Os(a,b){a=a|0;b=b|0;bt(a,b,pm(1165692)|0);return}function Ps(a,b){a=a|0;b=b|0;bt(a,b,pm(1167340)|0);return}function Qs(a,b){a=a|0;b=b|0;bt(a,b,pm(1167348)|0);return}function Rs(a,b){a=a|0;b=b|0;bt(a,b,pm(1167356)|0);return}function Ss(a,b){a=a|0;b=b|0;bt(a,b,pm(1167364)|0);return}function Ts(a,b){a=a|0;b=b|0;bt(a,b,pm(1167372)|0);return}function Us(a,b){a=a|0;b=b|0;bt(a,b,pm(1167380)|0);return}function Vs(a,b){a=a|0;b=b|0;bt(a,b,pm(1167388)|0);return}function Ws(a,b){a=a|0;b=b|0;bt(a,b,pm(1167396)|0);return}function Xs(a,b){a=a|0;b=b|0;bt(a,b,pm(1166504)|0);return}function Ys(a,b){a=a|0;b=b|0;bt(a,b,pm(1167316)|0);return}function Zs(a,b){a=a|0;b=b|0;bt(a,b,pm(1167324)|0);return}function _s(a,b){a=a|0;b=b|0;bt(a,b,pm(1167332)|0);return}function $s(a,b){a=a|0;b=b|0;bt(a,b,pm(1167404)|0);return}function at(a,b){a=a|0;b=b|0;bt(a,b,pm(1167412)|0);return}function bt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;ut(b);f=a+8|0;e=c[f>>2]|0;if((c[a+12>>2]|0)-e>>2>>>0>d>>>0)a=f;else{ct(f,d+1|0);a=f;e=c[f>>2]|0}e=c[e+(d<<2)>>2]|0;if(e|0)vt(e)|0;c[(c[a>>2]|0)+(d<<2)>>2]=b;return}
function Fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;L=l;l=l+16|0;p=L;do if(a>>>0<245){o=a>>>0<11?16:a+11&-8;a=o>>>3;t=c[291021]|0;d=t>>>a;if(d&3|0){a=(d&1^1)+a|0;d=1164124+(a<<1<<2)|0;e=d+8|0;f=c[e>>2]|0;g=f+8|0;h=c[g>>2]|0;do if((d|0)!=(h|0)){if(h>>>0<(c[291025]|0)>>>0)ya();b=h+12|0;if((c[b>>2]|0)==(f|0)){c[b>>2]=d;c[e>>2]=h;break}else ya()}else c[291021]=t&~(1<<a);while(0);K=a<<3;c[f+4>>2]=K|3;K=f+K+4|0;c[K>>2]=c[K>>2]|1;K=g;l=L;return K|0}s=c[291023]|0;if(o>>>0>s>>>0){if(d|0){i=2<<a;a=d<<a&(i|0-i);a=(a&0-a)+-1|0;i=a>>>12&16;a=a>>>i;e=a>>>5&8;a=a>>>e;g=a>>>2&4;a=a>>>g;d=a>>>1&2;a=a>>>d;b=a>>>1&1;b=(e|i|g|d|b)+(a>>>b)|0;a=1164124+(b<<1<<2)|0;d=a+8|0;g=c[d>>2]|0;i=g+8|0;e=c[i>>2]|0;do if((a|0)!=(e|0)){if(e>>>0<(c[291025]|0)>>>0)ya();f=e+12|0;if((c[f>>2]|0)==(g|0)){c[f>>2]=a;c[d>>2]=e;j=t;break}else ya()}else{j=t&~(1<<b);c[291021]=j}while(0);h=(b<<3)-o|0;c[g+4>>2]=o|3;e=g+o|0;c[e+4>>2]=h|1;c[e+h>>2]=h;if(s|0){f=c[291026]|0;b=s>>>3;d=1164124+(b<<1<<2)|0;b=1<<b;if(j&b){b=d+8|0;a=c[b>>2]|0;if(a>>>0<(c[291025]|0)>>>0)ya();else{k=a;m=b}}else{c[291021]=j|b;k=d;m=d+8|0}c[m>>2]=f;c[k+12>>2]=f;c[f+8>>2]=k;c[f+12>>2]=d}c[291023]=h;c[291026]=e;K=i;l=L;return K|0}k=c[291022]|0;if(k){a=(k&0-k)+-1|0;J=a>>>12&16;a=a>>>J;I=a>>>5&8;a=a>>>I;K=a>>>2&4;a=a>>>K;i=a>>>1&2;a=a>>>i;j=a>>>1&1;j=c[1164388+((I|J|K|i|j)+(a>>>j)<<2)>>2]|0;a=j;i=j;j=(c[j+4>>2]&-8)-o|0;while(1){b=c[a+16>>2]|0;if(!b){b=c[a+20>>2]|0;if(!b)break}K=(c[b+4>>2]&-8)-o|0;J=K>>>0<j>>>0;a=b;i=J?b:i;j=J?K:j}f=c[291025]|0;if(i>>>0<f>>>0)ya();h=i+o|0;if(i>>>0>=h>>>0)ya();g=c[i+24>>2]|0;d=c[i+12>>2]|0;do if((d|0)==(i|0)){a=i+20|0;b=c[a>>2]|0;if(!b){a=i+16|0;b=c[a>>2]|0;if(!b){n=0;break}}while(1){d=b+20|0;e=c[d>>2]|0;if(e|0){b=e;a=d;continue}d=b+16|0;e=c[d>>2]|0;if(!e)break;else{b=e;a=d}}if(a>>>0<f>>>0)ya();else{c[a>>2]=0;n=b;break}}else{e=c[i+8>>2]|0;if(e>>>0<f>>>0)ya();b=e+12|0;if((c[b>>2]|0)!=(i|0))ya();a=d+8|0;if((c[a>>2]|0)==(i|0)){c[b>>2]=d;c[a>>2]=e;n=d;break}else ya()}while(0);do if(g|0){b=c[i+28>>2]|0;a=1164388+(b<<2)|0;if((i|0)==(c[a>>2]|0)){c[a>>2]=n;if(!n){c[291022]=k&~(1<<b);break}}else{if(g>>>0<(c[291025]|0)>>>0)ya();b=g+16|0;if((c[b>>2]|0)==(i|0))c[b>>2]=n;else c[g+20>>2]=n;if(!n)break}a=c[291025]|0;if(n>>>0<a>>>0)ya();c[n+24>>2]=g;b=c[i+16>>2]|0;do if(b|0)if(b>>>0<a>>>0)ya();else{c[n+16>>2]=b;c[b+24>>2]=n;break}while(0);b=c[i+20>>2]|0;if(b|0)if(b>>>0<(c[291025]|0)>>>0)ya();else{c[n+20>>2]=b;c[b+24>>2]=n;break}}while(0);if(j>>>0<16){K=j+o|0;c[i+4>>2]=K|3;K=i+K+4|0;c[K>>2]=c[K>>2]|1}else{c[i+4>>2]=o|3;c[h+4>>2]=j|1;c[h+j>>2]=j;if(s|0){e=c[291026]|0;b=s>>>3;d=1164124+(b<<1<<2)|0;b=1<<b;if(t&b){b=d+8|0;a=c[b>>2]|0;if(a>>>0<(c[291025]|0)>>>0)ya();else{q=a;r=b}}else{c[291021]=t|b;q=d;r=d+8|0}c[r>>2]=e;c[q+12>>2]=e;c[e+8>>2]=q;c[e+12>>2]=d}c[291023]=j;c[291026]=h}K=i+8|0;l=L;return K|0}}}else if(a>>>0<=4294967231){a=a+11|0;o=a&-8;k=c[291022]|0;if(k){e=0-o|0;a=a>>>8;if(a)if(o>>>0>16777215)j=31;else{r=(a+1048320|0)>>>16&8;D=a<<r;q=(D+520192|0)>>>16&4;D=D<<q;j=(D+245760|0)>>>16&2;j=14-(q|r|j)+(D<<j>>>15)|0;j=o>>>(j+7|0)&1|j<<1}else j=0;a=c[1164388+(j<<2)>>2]|0;a:do if(!a){d=0;f=0;D=86}else{f=0;i=a;h=o<<((j|0)==31?0:25-(j>>>1)|0);d=0;while(1){a=(c[i+4>>2]&-8)-o|0;if(a>>>0<e>>>0)if(!a){a=i;e=0;d=i;D=90;break a}else{f=i;e=a}a=c[i+20>>2]|0;i=c[i+16+(h>>>31<<2)>>2]|0;d=(a|0)==0|(a|0)==(i|0)?d:a;a=(i|0)==0;if(a){D=86;break}else h=h<<(a&1^1)}}while(0);if((D|0)==86){if((d|0)==0&(f|0)==0){a=2<<j;a=k&(a|0-a);if(!a)break;r=(a&0-a)+-1|0;m=r>>>12&16;r=r>>>m;j=r>>>5&8;r=r>>>j;n=r>>>2&4;r=r>>>n;q=r>>>1&2;r=r>>>q;d=r>>>1&1;d=c[1164388+((j|m|n|q|d)+(r>>>d)<<2)>>2]|0}if(!d){j=f;i=e}else{a=f;D=90}}if((D|0)==90)while(1){D=0;r=(c[d+4>>2]&-8)-o|0;f=r>>>0<e>>>0;e=f?r:e;a=f?d:a;f=c[d+16>>2]|0;if(f|0){d=f;D=90;continue}d=c[d+20>>2]|0;if(!d){j=a;i=e;break}else D=90}if((j|0)!=0?i>>>0<((c[291023]|0)-o|0)>>>0:0){f=c[291025]|0;if(j>>>0<f>>>0)ya();h=j+o|0;if(j>>>0>=h>>>0)ya();g=c[j+24>>2]|0;d=c[j+12>>2]|0;do if((d|0)==(j|0)){a=j+20|0;b=c[a>>2]|0;if(!b){a=j+16|0;b=c[a>>2]|0;if(!b){s=0;break}}while(1){d=b+20|0;e=c[d>>2]|0;if(e|0){b=e;a=d;continue}d=b+16|0;e=c[d>>2]|0;if(!e)break;else{b=e;a=d}}if(a>>>0<f>>>0)ya();else{c[a>>2]=0;s=b;break}}else{e=c[j+8>>2]|0;if(e>>>0<f>>>0)ya();b=e+12|0;if((c[b>>2]|0)!=(j|0))ya();a=d+8|0;if((c[a>>2]|0)==(j|0)){c[b>>2]=d;c[a>>2]=e;s=d;break}else ya()}while(0);do if(g){b=c[j+28>>2]|0;a=1164388+(b<<2)|0;if((j|0)==(c[a>>2]|0)){c[a>>2]=s;if(!s){t=k&~(1<<b);c[291022]=t;break}}else{if(g>>>0<(c[291025]|0)>>>0)ya();b=g+16|0;if((c[b>>2]|0)==(j|0))c[b>>2]=s;else c[g+20>>2]=s;if(!s){t=k;break}}a=c[291025]|0;if(s>>>0<a>>>0)ya();c[s+24>>2]=g;b=c[j+16>>2]|0;do if(b|0)if(b>>>0<a>>>0)ya();else{c[s+16>>2]=b;c[b+24>>2]=s;break}while(0);b=c[j+20>>2]|0;if(b)if(b>>>0<(c[291025]|0)>>>0)ya();else{c[s+20>>2]=b;c[b+24>>2]=s;t=k;break}else t=k}else t=k;while(0);do if(i>>>0>=16){c[j+4>>2]=o|3;c[h+4>>2]=i|1;c[h+i>>2]=i;b=i>>>3;if(i>>>0<256){d=1164124+(b<<1<<2)|0;a=c[291021]|0;b=1<<b;if(a&b){b=d+8|0;a=c[b>>2]|0;if(a>>>0<(c[291025]|0)>>>0)ya();else{B=a;C=b}}else{c[291021]=a|b;B=d;C=d+8|0}c[C>>2]=h;c[B+12>>2]=h;c[h+8>>2]=B;c[h+12>>2]=d;break}b=i>>>8;if(b)if(i>>>0>16777215)b=31;else{J=(b+1048320|0)>>>16&8;K=b<<J;I=(K+520192|0)>>>16&4;K=K<<I;b=(K+245760|0)>>>16&2;b=14-(I|J|b)+(K<<b>>>15)|0;b=i>>>(b+7|0)&1|b<<1}else b=0;d=1164388+(b<<2)|0;c[h+28>>2]=b;a=h+16|0;c[a+4>>2]=0;c[a>>2]=0;a=1<<b;if(!(t&a)){c[291022]=t|a;c[d>>2]=h;c[h+24>>2]=d;c[h+12>>2]=h;c[h+8>>2]=h;break}a=i<<((b|0)==31?0:25-(b>>>1)|0);e=c[d>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(i|0)){D=148;break}d=e+16+(a>>>31<<2)|0;b=c[d>>2]|0;if(!b){D=145;break}else{a=a<<1;e=b}}if((D|0)==145)if(d>>>0<(c[291025]|0)>>>0)ya();else{c[d>>2]=h;c[h+24>>2]=e;c[h+12>>2]=h;c[h+8>>2]=h;break}else if((D|0)==148){b=e+8|0;a=c[b>>2]|0;K=c[291025]|0;if(a>>>0>=K>>>0&e>>>0>=K>>>0){c[a+12>>2]=h;c[b>>2]=h;c[h+8>>2]=a;c[h+12>>2]=e;c[h+24>>2]=0;break}else ya()}}else{K=i+o|0;c[j+4>>2]=K|3;K=j+K+4|0;c[K>>2]=c[K>>2]|1}while(0);K=j+8|0;l=L;return K|0}}}else o=-1;while(0);d=c[291023]|0;if(d>>>0>=o>>>0){b=d-o|0;a=c[291026]|0;if(b>>>0>15){K=a+o|0;c[291026]=K;c[291023]=b;c[K+4>>2]=b|1;c[K+b>>2]=b;c[a+4>>2]=o|3}else{c[291023]=0;c[291026]=0;c[a+4>>2]=d|3;K=a+d+4|0;c[K>>2]=c[K>>2]|1}K=a+8|0;l=L;return K|0}i=c[291024]|0;if(i>>>0>o>>>0){I=i-o|0;c[291024]=I;K=c[291027]|0;J=K+o|0;c[291027]=J;c[J+4>>2]=I|1;c[K+4>>2]=o|3;K=K+8|0;l=L;return K|0}if(!(c[291139]|0)){c[291141]=4096;c[291140]=4096;c[291142]=-1;c[291143]=-1;c[291144]=0;c[291132]=0;a=p&-16^1431655768;c[p>>2]=a;c[291139]=a;a=4096}else a=c[291141]|0;j=o+48|0;k=o+47|0;h=a+k|0;f=0-a|0;m=h&f;if(m>>>0<=o>>>0){K=0;l=L;return K|0}a=c[291131]|0;if(a|0?(B=c[291129]|0,C=B+m|0,C>>>0<=B>>>0|C>>>0>a>>>0):0){K=0;l=L;return K|0}b:do if(!(c[291132]&4)){d=c[291027]|0;c:do if(d){e=1164532;while(1){a=c[e>>2]|0;if(a>>>0<=d>>>0?(u=e+4|0,(a+(c[u>>2]|0)|0)>>>0>d>>>0):0)break;a=c[e+8>>2]|0;if(!a){D=172;break c}else e=a}d=h-i&f;if(d>>>0<2147483647){a=kv(d|0)|0;if((a|0)==((c[e>>2]|0)+(c[u>>2]|0)|0)){if((a|0)!=(-1|0)){h=d;g=a;D=190;break b}}else{b=d;D=180}}}else D=172;while(0);do if(((D|0)==172?(g=kv(0)|0,(g|0)!=(-1|0)):0)?(b=g,v=c[291140]|0,w=v+-1|0,b=((w&b|0)==0?0:(w+b&0-v)-b|0)+m|0,v=c[291129]|0,w=b+v|0,b>>>0>o>>>0&b>>>0<2147483647):0){C=c[291131]|0;if(C|0?w>>>0<=v>>>0|w>>>0>C>>>0:0)break;a=kv(b|0)|0;if((a|0)==(g|0)){h=b;D=190;break b}else D=180}while(0);d:do if((D|0)==180){d=0-b|0;do if(j>>>0>b>>>0&(b>>>0<2147483647&(a|0)!=(-1|0))?(x=c[291141]|0,x=k-b+x&0-x,x>>>0<2147483647):0)if((kv(x|0)|0)==(-1|0)){kv(d|0)|0;break d}else{b=x+b|0;break}while(0);if((a|0)!=(-1|0)){h=b;g=a;D=190;break b}}while(0);c[291132]=c[291132]|4;D=187}else D=187;while(0);if((((D|0)==187?m>>>0<2147483647:0)?(A=kv(m|0)|0,y=kv(0)|0,A>>>0<y>>>0&((A|0)!=(-1|0)&(y|0)!=(-1|0))):0)?(z=y-A|0,z>>>0>(o+40|0)>>>0):0){h=z;g=A;D=190}if((D|0)==190){b=(c[291129]|0)+h|0;c[291129]=b;if(b>>>0>(c[291130]|0)>>>0)c[291130]=b;k=c[291027]|0;do if(k){b=1164532;while(1){a=c[b>>2]|0;d=b+4|0;e=c[d>>2]|0;if((g|0)==(a+e|0)){D=200;break}f=c[b+8>>2]|0;if(!f)break;else b=f}if(((D|0)==200?(c[b+12>>2]&8|0)==0:0)?k>>>0<g>>>0&k>>>0>=a>>>0:0){c[d>>2]=e+h;K=k+8|0;K=(K&7|0)==0?0:0-K&7;J=k+K|0;K=h-K+(c[291024]|0)|0;c[291027]=J;c[291024]=K;c[J+4>>2]=K|1;c[J+K+4>>2]=40;c[291028]=c[291143];break}b=c[291025]|0;if(g>>>0<b>>>0){c[291025]=g;i=g}else i=b;a=g+h|0;b=1164532;while(1){if((c[b>>2]|0)==(a|0)){D=208;break}b=c[b+8>>2]|0;if(!b){a=1164532;break}}if((D|0)==208)if(!(c[b+12>>2]&8)){c[b>>2]=g;n=b+4|0;c[n>>2]=(c[n>>2]|0)+h;n=g+8|0;n=g+((n&7|0)==0?0:0-n&7)|0;b=a+8|0;b=a+((b&7|0)==0?0:0-b&7)|0;m=n+o|0;j=b-n-o|0;c[n+4>>2]=o|3;do if((b|0)!=(k|0)){if((b|0)==(c[291026]|0)){K=(c[291023]|0)+j|0;c[291023]=K;c[291026]=m;c[m+4>>2]=K|1;c[m+K>>2]=K;break}a=c[b+4>>2]|0;if((a&3|0)==1){h=a&-8;f=a>>>3;e:do if(a>>>0>=256){g=c[b+24>>2]|0;e=c[b+12>>2]|0;do if((e|0)==(b|0)){e=b+16|0;d=e+4|0;a=c[d>>2]|0;if(!a){a=c[e>>2]|0;if(!a){I=0;break}else d=e}while(1){e=a+20|0;f=c[e>>2]|0;if(f|0){a=f;d=e;continue}e=a+16|0;f=c[e>>2]|0;if(!f)break;else{a=f;d=e}}if(d>>>0<i>>>0)ya();else{c[d>>2]=0;I=a;break}}else{f=c[b+8>>2]|0;if(f>>>0<i>>>0)ya();a=f+12|0;if((c[a>>2]|0)!=(b|0))ya();d=e+8|0;if((c[d>>2]|0)==(b|0)){c[a>>2]=e;c[d>>2]=f;I=e;break}else ya()}while(0);if(!g)break;a=c[b+28>>2]|0;d=1164388+(a<<2)|0;do if((b|0)!=(c[d>>2]|0)){if(g>>>0<(c[291025]|0)>>>0)ya();a=g+16|0;if((c[a>>2]|0)==(b|0))c[a>>2]=I;else c[g+20>>2]=I;if(!I)break e}else{c[d>>2]=I;if(I|0)break;c[291022]=c[291022]&~(1<<a);break e}while(0);e=c[291025]|0;if(I>>>0<e>>>0)ya();c[I+24>>2]=g;a=b+16|0;d=c[a>>2]|0;do if(d|0)if(d>>>0<e>>>0)ya();else{c[I+16>>2]=d;c[d+24>>2]=I;break}while(0);a=c[a+4>>2]|0;if(!a)break;if(a>>>0<(c[291025]|0)>>>0)ya();else{c[I+20>>2]=a;c[a+24>>2]=I;break}}else{d=c[b+8>>2]|0;e=c[b+12>>2]|0;a=1164124+(f<<1<<2)|0;do if((d|0)!=(a|0)){if(d>>>0<i>>>0)ya();if((c[d+12>>2]|0)==(b|0))break;ya()}while(0);if((e|0)==(d|0)){c[291021]=c[291021]&~(1<<f);break}do if((e|0)==(a|0))F=e+8|0;else{if(e>>>0<i>>>0)ya();a=e+8|0;if((c[a>>2]|0)==(b|0)){F=a;break}ya()}while(0);c[d+12>>2]=e;c[F>>2]=d}while(0);b=b+h|0;f=h+j|0}else f=j;b=b+4|0;c[b>>2]=c[b>>2]&-2;c[m+4>>2]=f|1;c[m+f>>2]=f;b=f>>>3;if(f>>>0<256){d=1164124+(b<<1<<2)|0;a=c[291021]|0;b=1<<b;do if(!(a&b)){c[291021]=a|b;J=d;K=d+8|0}else{b=d+8|0;a=c[b>>2]|0;if(a>>>0>=(c[291025]|0)>>>0){J=a;K=b;break}ya()}while(0);c[K>>2]=m;c[J+12>>2]=m;c[m+8>>2]=J;c[m+12>>2]=d;break}b=f>>>8;do if(!b)b=0;else{if(f>>>0>16777215){b=31;break}J=(b+1048320|0)>>>16&8;K=b<<J;I=(K+520192|0)>>>16&4;K=K<<I;b=(K+245760|0)>>>16&2;b=14-(I|J|b)+(K<<b>>>15)|0;b=f>>>(b+7|0)&1|b<<1}while(0);e=1164388+(b<<2)|0;c[m+28>>2]=b;a=m+16|0;c[a+4>>2]=0;c[a>>2]=0;a=c[291022]|0;d=1<<b;if(!(a&d)){c[291022]=a|d;c[e>>2]=m;c[m+24>>2]=e;c[m+12>>2]=m;c[m+8>>2]=m;break}a=f<<((b|0)==31?0:25-(b>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){D=278;break}d=e+16+(a>>>31<<2)|0;b=c[d>>2]|0;if(!b){D=275;break}else{a=a<<1;e=b}}if((D|0)==275)if(d>>>0<(c[291025]|0)>>>0)ya();else{c[d>>2]=m;c[m+24>>2]=e;c[m+12>>2]=m;c[m+8>>2]=m;break}else if((D|0)==278){b=e+8|0;a=c[b>>2]|0;K=c[291025]|0;if(a>>>0>=K>>>0&e>>>0>=K>>>0){c[a+12>>2]=m;c[b>>2]=m;c[m+8>>2]=a;c[m+12>>2]=e;c[m+24>>2]=0;break}else ya()}}else{K=(c[291024]|0)+j|0;c[291024]=K;c[291027]=m;c[m+4>>2]=K|1}while(0);K=n+8|0;l=L;return K|0}else a=1164532;while(1){b=c[a>>2]|0;if(b>>>0<=k>>>0?(E=b+(c[a+4>>2]|0)|0,E>>>0>k>>>0):0)break;a=c[a+8>>2]|0}f=E+-47|0;a=f+8|0;a=f+((a&7|0)==0?0:0-a&7)|0;f=k+16|0;a=a>>>0<f>>>0?k:a;b=a+8|0;d=g+8|0;d=(d&7|0)==0?0:0-d&7;K=g+d|0;d=h+-40-d|0;c[291027]=K;c[291024]=d;c[K+4>>2]=d|1;c[K+d+4>>2]=40;c[291028]=c[291143];d=a+4|0;c[d>>2]=27;c[b>>2]=c[291133];c[b+4>>2]=c[291134];c[b+8>>2]=c[291135];c[b+12>>2]=c[291136];c[291133]=g;c[291134]=h;c[291136]=0;c[291135]=b;b=a+24|0;do{b=b+4|0;c[b>>2]=7}while((b+4|0)>>>0<E>>>0);if((a|0)!=(k|0)){g=a-k|0;c[d>>2]=c[d>>2]&-2;c[k+4>>2]=g|1;c[a>>2]=g;b=g>>>3;if(g>>>0<256){d=1164124+(b<<1<<2)|0;a=c[291021]|0;b=1<<b;if(a&b){b=d+8|0;a=c[b>>2]|0;if(a>>>0<(c[291025]|0)>>>0)ya();else{G=a;H=b}}else{c[291021]=a|b;G=d;H=d+8|0}c[H>>2]=k;c[G+12>>2]=k;c[k+8>>2]=G;c[k+12>>2]=d;break}b=g>>>8;if(b)if(g>>>0>16777215)d=31;else{J=(b+1048320|0)>>>16&8;K=b<<J;I=(K+520192|0)>>>16&4;K=K<<I;d=(K+245760|0)>>>16&2;d=14-(I|J|d)+(K<<d>>>15)|0;d=g>>>(d+7|0)&1|d<<1}else d=0;e=1164388+(d<<2)|0;c[k+28>>2]=d;c[k+20>>2]=0;c[f>>2]=0;b=c[291022]|0;a=1<<d;if(!(b&a)){c[291022]=b|a;c[e>>2]=k;c[k+24>>2]=e;c[k+12>>2]=k;c[k+8>>2]=k;break}a=g<<((d|0)==31?0:25-(d>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(g|0)){D=304;break}d=e+16+(a>>>31<<2)|0;b=c[d>>2]|0;if(!b){D=301;break}else{a=a<<1;e=b}}if((D|0)==301)if(d>>>0<(c[291025]|0)>>>0)ya();else{c[d>>2]=k;c[k+24>>2]=e;c[k+12>>2]=k;c[k+8>>2]=k;break}else if((D|0)==304){b=e+8|0;a=c[b>>2]|0;K=c[291025]|0;if(a>>>0>=K>>>0&e>>>0>=K>>>0){c[a+12>>2]=k;c[b>>2]=k;c[k+8>>2]=a;c[k+12>>2]=e;c[k+24>>2]=0;break}else ya()}}}else{K=c[291025]|0;if((K|0)==0|g>>>0<K>>>0)c[291025]=g;c[291133]=g;c[291134]=h;c[291136]=0;c[291030]=c[291139];c[291029]=-1;b=0;do{K=1164124+(b<<1<<2)|0;c[K+12>>2]=K;c[K+8>>2]=K;b=b+1|0}while((b|0)!=32);K=g+8|0;K=(K&7|0)==0?0:0-K&7;J=g+K|0;K=h+-40-K|0;c[291027]=J;c[291024]=K;c[J+4>>2]=K|1;c[J+K+4>>2]=40;c[291028]=c[291143]}while(0);b=c[291024]|0;if(b>>>0>o>>>0){I=b-o|0;c[291024]=I;K=c[291027]|0;J=K+o|0;c[291027]=J;c[J+4>>2]=I|1;c[K+4>>2]=o|3;K=K+8|0;l=L;return K|0}}c[(Oh()|0)>>2]=12;K=0;l=L;return K|0}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;if(!a)return;d=a+-8|0;h=c[291025]|0;if(d>>>0<h>>>0)ya();a=c[a+-4>>2]|0;b=a&3;if((b|0)==1)ya();e=a&-8;n=d+e|0;do if(!(a&1)){a=c[d>>2]|0;if(!b)return;k=d+(0-a)|0;j=a+e|0;if(k>>>0<h>>>0)ya();if((k|0)==(c[291026]|0)){a=n+4|0;b=c[a>>2]|0;if((b&3|0)!=3){q=k;f=j;break}c[291023]=j;c[a>>2]=b&-2;c[k+4>>2]=j|1;c[k+j>>2]=j;return}e=a>>>3;if(a>>>0<256){b=c[k+8>>2]|0;d=c[k+12>>2]|0;a=1164124+(e<<1<<2)|0;if((b|0)!=(a|0)){if(b>>>0<h>>>0)ya();if((c[b+12>>2]|0)!=(k|0))ya()}if((d|0)==(b|0)){c[291021]=c[291021]&~(1<<e);q=k;f=j;break}if((d|0)!=(a|0)){if(d>>>0<h>>>0)ya();a=d+8|0;if((c[a>>2]|0)==(k|0))g=a;else ya()}else g=d+8|0;c[b+12>>2]=d;c[g>>2]=b;q=k;f=j;break}g=c[k+24>>2]|0;d=c[k+12>>2]|0;do if((d|0)==(k|0)){d=k+16|0;b=d+4|0;a=c[b>>2]|0;if(!a){a=c[d>>2]|0;if(!a){i=0;break}else b=d}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}if(b>>>0<h>>>0)ya();else{c[b>>2]=0;i=a;break}}else{e=c[k+8>>2]|0;if(e>>>0<h>>>0)ya();a=e+12|0;if((c[a>>2]|0)!=(k|0))ya();b=d+8|0;if((c[b>>2]|0)==(k|0)){c[a>>2]=d;c[b>>2]=e;i=d;break}else ya()}while(0);if(g){a=c[k+28>>2]|0;b=1164388+(a<<2)|0;if((k|0)==(c[b>>2]|0)){c[b>>2]=i;if(!i){c[291022]=c[291022]&~(1<<a);q=k;f=j;break}}else{if(g>>>0<(c[291025]|0)>>>0)ya();a=g+16|0;if((c[a>>2]|0)==(k|0))c[a>>2]=i;else c[g+20>>2]=i;if(!i){q=k;f=j;break}}d=c[291025]|0;if(i>>>0<d>>>0)ya();c[i+24>>2]=g;a=k+16|0;b=c[a>>2]|0;do if(b|0)if(b>>>0<d>>>0)ya();else{c[i+16>>2]=b;c[b+24>>2]=i;break}while(0);a=c[a+4>>2]|0;if(a)if(a>>>0<(c[291025]|0)>>>0)ya();else{c[i+20>>2]=a;c[a+24>>2]=i;q=k;f=j;break}else{q=k;f=j}}else{q=k;f=j}}else{q=d;f=e}while(0);if(q>>>0>=n>>>0)ya();a=n+4|0;b=c[a>>2]|0;if(!(b&1))ya();if(!(b&2)){if((n|0)==(c[291027]|0)){p=(c[291024]|0)+f|0;c[291024]=p;c[291027]=q;c[q+4>>2]=p|1;if((q|0)!=(c[291026]|0))return;c[291026]=0;c[291023]=0;return}if((n|0)==(c[291026]|0)){p=(c[291023]|0)+f|0;c[291023]=p;c[291026]=q;c[q+4>>2]=p|1;c[q+p>>2]=p;return}f=(b&-8)+f|0;e=b>>>3;do if(b>>>0>=256){g=c[n+24>>2]|0;a=c[n+12>>2]|0;do if((a|0)==(n|0)){d=n+16|0;b=d+4|0;a=c[b>>2]|0;if(!a){a=c[d>>2]|0;if(!a){m=0;break}else b=d}while(1){d=a+20|0;e=c[d>>2]|0;if(e|0){a=e;b=d;continue}d=a+16|0;e=c[d>>2]|0;if(!e)break;else{a=e;b=d}}if(b>>>0<(c[291025]|0)>>>0)ya();else{c[b>>2]=0;m=a;break}}else{b=c[n+8>>2]|0;if(b>>>0<(c[291025]|0)>>>0)ya();d=b+12|0;if((c[d>>2]|0)!=(n|0))ya();e=a+8|0;if((c[e>>2]|0)==(n|0)){c[d>>2]=a;c[e>>2]=b;m=a;break}else ya()}while(0);if(g|0){a=c[n+28>>2]|0;b=1164388+(a<<2)|0;if((n|0)==(c[b>>2]|0)){c[b>>2]=m;if(!m){c[291022]=c[291022]&~(1<<a);break}}else{if(g>>>0<(c[291025]|0)>>>0)ya();a=g+16|0;if((c[a>>2]|0)==(n|0))c[a>>2]=m;else c[g+20>>2]=m;if(!m)break}d=c[291025]|0;if(m>>>0<d>>>0)ya();c[m+24>>2]=g;a=n+16|0;b=c[a>>2]|0;do if(b|0)if(b>>>0<d>>>0)ya();else{c[m+16>>2]=b;c[b+24>>2]=m;break}while(0);a=c[a+4>>2]|0;if(a|0)if(a>>>0<(c[291025]|0)>>>0)ya();else{c[m+20>>2]=a;c[a+24>>2]=m;break}}}else{b=c[n+8>>2]|0;d=c[n+12>>2]|0;a=1164124+(e<<1<<2)|0;if((b|0)!=(a|0)){if(b>>>0<(c[291025]|0)>>>0)ya();if((c[b+12>>2]|0)!=(n|0))ya()}if((d|0)==(b|0)){c[291021]=c[291021]&~(1<<e);break}if((d|0)!=(a|0)){if(d>>>0<(c[291025]|0)>>>0)ya();a=d+8|0;if((c[a>>2]|0)==(n|0))l=a;else ya()}else l=d+8|0;c[b+12>>2]=d;c[l>>2]=b}while(0);c[q+4>>2]=f|1;c[q+f>>2]=f;if((q|0)==(c[291026]|0)){c[291023]=f;return}}else{c[a>>2]=b&-2;c[q+4>>2]=f|1;c[q+f>>2]=f}a=f>>>3;if(f>>>0<256){d=1164124+(a<<1<<2)|0;b=c[291021]|0;a=1<<a;if(b&a){a=d+8|0;b=c[a>>2]|0;if(b>>>0<(c[291025]|0)>>>0)ya();else{o=b;p=a}}else{c[291021]=b|a;o=d;p=d+8|0}c[p>>2]=q;c[o+12>>2]=q;c[q+8>>2]=o;c[q+12>>2]=d;return}a=f>>>8;if(a)if(f>>>0>16777215)a=31;else{o=(a+1048320|0)>>>16&8;p=a<<o;n=(p+520192|0)>>>16&4;p=p<<n;a=(p+245760|0)>>>16&2;a=14-(n|o|a)+(p<<a>>>15)|0;a=f>>>(a+7|0)&1|a<<1}else a=0;e=1164388+(a<<2)|0;c[q+28>>2]=a;c[q+20>>2]=0;c[q+16>>2]=0;b=c[291022]|0;d=1<<a;do if(b&d){b=f<<((a|0)==31?0:25-(a>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){a=130;break}d=e+16+(b>>>31<<2)|0;a=c[d>>2]|0;if(!a){a=127;break}else{b=b<<1;e=a}}if((a|0)==127)if(d>>>0<(c[291025]|0)>>>0)ya();else{c[d>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q;break}else if((a|0)==130){a=e+8|0;b=c[a>>2]|0;p=c[291025]|0;if(b>>>0>=p>>>0&e>>>0>=p>>>0){c[b+12>>2]=q;c[a>>2]=q;c[q+8>>2]=b;c[q+12>>2]=e;c[q+24>>2]=0;break}else ya()}}else{c[291022]=b|d;c[e>>2]=q;c[q+24>>2]=e;c[q+12>>2]=q;c[q+8>>2]=q}while(0);q=(c[291029]|0)+-1|0;c[291029]=q;if(!q)a=1164540;else return;while(1){a=c[a>>2]|0;if(!a)break;else a=a+8|0}c[291029]=-1;return}function Hj(a,b){a=a|0;b=b|0;var d=0;if(a){d=S(b,a)|0;if((b|a)>>>0>65535)d=((d>>>0)/(a>>>0)|0|0)==(b|0)?d:-1}else d=0;a=Fj(d)|0;if(!a)return a|0;if(!(c[a+-4>>2]&3))return a|0;Wu(a|0,0,d|0)|0;return a|0}function Ij(a,b){a=a|0;b=b|0;var d=0,e=0;if(!a){b=Fj(b)|0;return b|0}if(b>>>0>4294967231){c[(Oh()|0)>>2]=12;b=0;return b|0}d=Jj(a+-8|0,b>>>0<11?16:b+11&-8)|0;if(d|0){b=d+8|0;return b|0}d=Fj(b)|0;if(!d){b=0;return b|0}e=c[a+-4>>2]|0;e=(e&-8)-((e&3|0)==0?8:4)|0;cv(d|0,a|0,(e>>>0<b>>>0?e:b)|0)|0;Gj(a);b=d;return b|0}function Jj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;n=a+4|0;o=c[n>>2]|0;d=o&-8;k=a+d|0;i=c[291025]|0;e=o&3;if(!((e|0)!=1&a>>>0>=i>>>0&a>>>0<k>>>0))ya();f=c[k+4>>2]|0;if(!(f&1))ya();if(!e){if(b>>>0<256){a=0;return a|0}if(d>>>0>=(b+4|0)>>>0?(d-b|0)>>>0<=c[291141]<<1>>>0:0)return a|0;a=0;return a|0}if(d>>>0>=b>>>0){d=d-b|0;if(d>>>0<=15)return a|0;m=a+b|0;c[n>>2]=o&1|b|2;c[m+4>>2]=d|3;o=m+d+4|0;c[o>>2]=c[o>>2]|1;Kj(m,d);return a|0}if((k|0)==(c[291027]|0)){d=(c[291024]|0)+d|0;if(d>>>0<=b>>>0){a=0;return a|0}m=d-b|0;l=a+b|0;c[n>>2]=o&1|b|2;c[l+4>>2]=m|1;c[291027]=l;c[291024]=m;return a|0}if((k|0)==(c[291026]|0)){e=(c[291023]|0)+d|0;if(e>>>0<b>>>0){a=0;return a|0}d=e-b|0;if(d>>>0>15){e=a+b|0;m=e+d|0;c[n>>2]=o&1|b|2;c[e+4>>2]=d|1;c[m>>2]=d;o=m+4|0;c[o>>2]=c[o>>2]&-2}else{c[n>>2]=o&1|e|2;e=a+e+4|0;c[e>>2]=c[e>>2]|1;e=0;d=0}c[291023]=d;c[291026]=e;return a|0}if(f&2|0){a=0;return a|0}l=(f&-8)+d|0;if(l>>>0<b>>>0){a=0;return a|0}m=l-b|0;g=f>>>3;do if(f>>>0>=256){h=c[k+24>>2]|0;f=c[k+12>>2]|0;do if((f|0)==(k|0)){f=k+16|0;e=f+4|0;d=c[e>>2]|0;if(!d){d=c[f>>2]|0;if(!d){j=0;break}else e=f}while(1){f=d+20|0;g=c[f>>2]|0;if(g|0){d=g;e=f;continue}f=d+16|0;g=c[f>>2]|0;if(!g)break;else{d=g;e=f}}if(e>>>0<i>>>0)ya();else{c[e>>2]=0;j=d;break}}else{g=c[k+8>>2]|0;if(g>>>0<i>>>0)ya();d=g+12|0;if((c[d>>2]|0)!=(k|0))ya();e=f+8|0;if((c[e>>2]|0)==(k|0)){c[d>>2]=f;c[e>>2]=g;j=f;break}else ya()}while(0);if(h|0){d=c[k+28>>2]|0;e=1164388+(d<<2)|0;if((k|0)==(c[e>>2]|0)){c[e>>2]=j;if(!j){c[291022]=c[291022]&~(1<<d);break}}else{if(h>>>0<(c[291025]|0)>>>0)ya();d=h+16|0;if((c[d>>2]|0)==(k|0))c[d>>2]=j;else c[h+20>>2]=j;if(!j)break}f=c[291025]|0;if(j>>>0<f>>>0)ya();c[j+24>>2]=h;d=k+16|0;e=c[d>>2]|0;do if(e|0)if(e>>>0<f>>>0)ya();else{c[j+16>>2]=e;c[e+24>>2]=j;break}while(0);d=c[d+4>>2]|0;if(d|0)if(d>>>0<(c[291025]|0)>>>0)ya();else{c[j+20>>2]=d;c[d+24>>2]=j;break}}}else{e=c[k+8>>2]|0;f=c[k+12>>2]|0;d=1164124+(g<<1<<2)|0;if((e|0)!=(d|0)){if(e>>>0<i>>>0)ya();if((c[e+12>>2]|0)!=(k|0))ya()}if((f|0)==(e|0)){c[291021]=c[291021]&~(1<<g);break}if((f|0)!=(d|0)){if(f>>>0<i>>>0)ya();d=f+8|0;if((c[d>>2]|0)==(k|0))h=d;else ya()}else h=f+8|0;c[e+12>>2]=f;c[h>>2]=e}while(0);if(m>>>0<16){c[n>>2]=l|o&1|2;o=a+l+4|0;c[o>>2]=c[o>>2]|1;return a|0}else{l=a+b|0;c[n>>2]=o&1|b|2;c[l+4>>2]=m|3;o=l+m+4|0;c[o>>2]=c[o>>2]|1;Kj(l,m);return a|0}return 0}function Kj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;o=a+b|0;d=c[a+4>>2]|0;do if(!(d&1)){g=c[a>>2]|0;if(!(d&3))return;l=a+(0-g)|0;k=g+b|0;i=c[291025]|0;if(l>>>0<i>>>0)ya();if((l|0)==(c[291026]|0)){a=o+4|0;d=c[a>>2]|0;if((d&3|0)!=3){r=l;f=k;break}c[291023]=k;c[a>>2]=d&-2;c[l+4>>2]=k|1;c[l+k>>2]=k;return}e=g>>>3;if(g>>>0<256){d=c[l+8>>2]|0;b=c[l+12>>2]|0;a=1164124+(e<<1<<2)|0;if((d|0)!=(a|0)){if(d>>>0<i>>>0)ya();if((c[d+12>>2]|0)!=(l|0))ya()}if((b|0)==(d|0)){c[291021]=c[291021]&~(1<<e);r=l;f=k;break}if((b|0)!=(a|0)){if(b>>>0<i>>>0)ya();a=b+8|0;if((c[a>>2]|0)==(l|0))h=a;else ya()}else h=b+8|0;c[d+12>>2]=b;c[h>>2]=d;r=l;f=k;break}g=c[l+24>>2]|0;b=c[l+12>>2]|0;do if((b|0)==(l|0)){b=l+16|0;d=b+4|0;a=c[d>>2]|0;if(!a){a=c[b>>2]|0;if(!a){j=0;break}else d=b}while(1){b=a+20|0;e=c[b>>2]|0;if(e|0){a=e;d=b;continue}b=a+16|0;e=c[b>>2]|0;if(!e)break;else{a=e;d=b}}if(d>>>0<i>>>0)ya();else{c[d>>2]=0;j=a;break}}else{e=c[l+8>>2]|0;if(e>>>0<i>>>0)ya();a=e+12|0;if((c[a>>2]|0)!=(l|0))ya();d=b+8|0;if((c[d>>2]|0)==(l|0)){c[a>>2]=b;c[d>>2]=e;j=b;break}else ya()}while(0);if(g){a=c[l+28>>2]|0;d=1164388+(a<<2)|0;if((l|0)==(c[d>>2]|0)){c[d>>2]=j;if(!j){c[291022]=c[291022]&~(1<<a);r=l;f=k;break}}else{if(g>>>0<(c[291025]|0)>>>0)ya();a=g+16|0;if((c[a>>2]|0)==(l|0))c[a>>2]=j;else c[g+20>>2]=j;if(!j){r=l;f=k;break}}b=c[291025]|0;if(j>>>0<b>>>0)ya();c[j+24>>2]=g;a=l+16|0;d=c[a>>2]|0;do if(d|0)if(d>>>0<b>>>0)ya();else{c[j+16>>2]=d;c[d+24>>2]=j;break}while(0);a=c[a+4>>2]|0;if(a)if(a>>>0<(c[291025]|0)>>>0)ya();else{c[j+20>>2]=a;c[a+24>>2]=j;r=l;f=k;break}else{r=l;f=k}}else{r=l;f=k}}else{r=a;f=b}while(0);h=c[291025]|0;if(o>>>0<h>>>0)ya();a=o+4|0;d=c[a>>2]|0;if(!(d&2)){if((o|0)==(c[291027]|0)){q=(c[291024]|0)+f|0;c[291024]=q;c[291027]=r;c[r+4>>2]=q|1;if((r|0)!=(c[291026]|0))return;c[291026]=0;c[291023]=0;return}if((o|0)==(c[291026]|0)){q=(c[291023]|0)+f|0;c[291023]=q;c[291026]=r;c[r+4>>2]=q|1;c[r+q>>2]=q;return}f=(d&-8)+f|0;e=d>>>3;do if(d>>>0>=256){g=c[o+24>>2]|0;b=c[o+12>>2]|0;do if((b|0)==(o|0)){b=o+16|0;d=b+4|0;a=c[d>>2]|0;if(!a){a=c[b>>2]|0;if(!a){n=0;break}else d=b}while(1){b=a+20|0;e=c[b>>2]|0;if(e|0){a=e;d=b;continue}b=a+16|0;e=c[b>>2]|0;if(!e)break;else{a=e;d=b}}if(d>>>0<h>>>0)ya();else{c[d>>2]=0;n=a;break}}else{e=c[o+8>>2]|0;if(e>>>0<h>>>0)ya();a=e+12|0;if((c[a>>2]|0)!=(o|0))ya();d=b+8|0;if((c[d>>2]|0)==(o|0)){c[a>>2]=b;c[d>>2]=e;n=b;break}else ya()}while(0);if(g|0){a=c[o+28>>2]|0;d=1164388+(a<<2)|0;if((o|0)==(c[d>>2]|0)){c[d>>2]=n;if(!n){c[291022]=c[291022]&~(1<<a);break}}else{if(g>>>0<(c[291025]|0)>>>0)ya();a=g+16|0;if((c[a>>2]|0)==(o|0))c[a>>2]=n;else c[g+20>>2]=n;if(!n)break}b=c[291025]|0;if(n>>>0<b>>>0)ya();c[n+24>>2]=g;a=o+16|0;d=c[a>>2]|0;do if(d|0)if(d>>>0<b>>>0)ya();else{c[n+16>>2]=d;c[d+24>>2]=n;break}while(0);a=c[a+4>>2]|0;if(a|0)if(a>>>0<(c[291025]|0)>>>0)ya();else{c[n+20>>2]=a;c[a+24>>2]=n;break}}}else{d=c[o+8>>2]|0;b=c[o+12>>2]|0;a=1164124+(e<<1<<2)|0;if((d|0)!=(a|0)){if(d>>>0<h>>>0)ya();if((c[d+12>>2]|0)!=(o|0))ya()}if((b|0)==(d|0)){c[291021]=c[291021]&~(1<<e);break}if((b|0)!=(a|0)){if(b>>>0<h>>>0)ya();a=b+8|0;if((c[a>>2]|0)==(o|0))m=a;else ya()}else m=b+8|0;c[d+12>>2]=b;c[m>>2]=d}while(0);c[r+4>>2]=f|1;c[r+f>>2]=f;if((r|0)==(c[291026]|0)){c[291023]=f;return}}else{c[a>>2]=d&-2;c[r+4>>2]=f|1;c[r+f>>2]=f}a=f>>>3;if(f>>>0<256){b=1164124+(a<<1<<2)|0;d=c[291021]|0;a=1<<a;if(d&a){a=b+8|0;d=c[a>>2]|0;if(d>>>0<(c[291025]|0)>>>0)ya();else{p=d;q=a}}else{c[291021]=d|a;p=b;q=b+8|0}c[q>>2]=r;c[p+12>>2]=r;c[r+8>>2]=p;c[r+12>>2]=b;return}a=f>>>8;if(a)if(f>>>0>16777215)a=31;else{p=(a+1048320|0)>>>16&8;q=a<<p;o=(q+520192|0)>>>16&4;q=q<<o;a=(q+245760|0)>>>16&2;a=14-(o|p|a)+(q<<a>>>15)|0;a=f>>>(a+7|0)&1|a<<1}else a=0;e=1164388+(a<<2)|0;c[r+28>>2]=a;c[r+20>>2]=0;c[r+16>>2]=0;d=c[291022]|0;b=1<<a;if(!(d&b)){c[291022]=d|b;c[e>>2]=r;c[r+24>>2]=e;c[r+12>>2]=r;c[r+8>>2]=r;return}d=f<<((a|0)==31?0:25-(a>>>1)|0);e=c[e>>2]|0;while(1){if((c[e+4>>2]&-8|0)==(f|0)){a=127;break}b=e+16+(d>>>31<<2)|0;a=c[b>>2]|0;if(!a){a=124;break}else{d=d<<1;e=a}}if((a|0)==124){if(b>>>0<(c[291025]|0)>>>0)ya();c[b>>2]=r;c[r+24>>2]=e;c[r+12>>2]=r;c[r+8>>2]=r;return}else if((a|0)==127){a=e+8|0;d=c[a>>2]|0;q=c[291025]|0;if(!(d>>>0>=q>>>0&e>>>0>=q>>>0))ya();c[d+12>>2]=r;c[a>>2]=r;c[r+8>>2]=d;c[r+12>>2]=e;c[r+24>>2]=0;return}}function Lj(){var a=0,b=0,d=0,e=0;b=l;l=l+16|0;a=b;Ca(0,a|0)|0;e=c[a>>2]|0;d=(c[a+4>>2]|0)/1e3|0;a=fv(e|0,((e|0)<0)<<31>>31|0,1e6,0)|0;a=Yu(d|0,((d|0)<0)<<31>>31|0,a|0,D|0)|0;l=b;return a|0}function Mj(a){a=a|0;Va(a|0)|0;return}function Nj(a){a=a|0;Ja(a|0)|0;return}function Oj(a,b){a=a|0;b=b|0;sa(a|0,c[b>>2]|0)|0;return}function Pj(a){a=a|0;Qj(a);return}function Qj(a){a=a|0;c[a>>2]=16424;Rj(a,0);pt(a+28|0);Gj(c[a+32>>2]|0);Gj(c[a+36>>2]|0);Gj(c[a+48>>2]|0);Gj(c[a+60>>2]|0);return}function Rj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;e=a+32|0;f=a+36|0;d=c[a+40>>2]|0;while(1){if(!d)break;g=d+-1|0;ib[c[(c[e>>2]|0)+(g<<2)>>2]&0](b,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);d=g}return}function Sj(a){a=a|0;Qj(a);Dt(a);return}function Tj(a){a=a|0;c[a>>2]=16440;pt(a+4|0);return}function Uj(a){a=a|0;c[a>>2]=16440;pt(a+4|0);Dt(a);return}function Vj(a,b){a=a|0;b=b|0;return}function Wj(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function Xj(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function Yj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}function Zj(a){a=a|0;return 0}function _j(a){a=a|0;return 0}function $j(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=b+12|0;i=b+16|0;g=0;while(1){if((g|0)>=(e|0))break;f=c[h>>2]|0;if(f>>>0<(c[i>>2]|0)>>>0){c[h>>2]=f+1;f=a[f>>0]|0}else{f=hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((f|0)==-1)break;f=f&255}a[d>>0]=f;g=g+1|0;d=d+1|0}return g|0}function ak(a){a=a|0;return -1}function bk(a){a=a|0;var b=0;if((hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=a+12|0;a=c[b>>2]|0;c[b>>2]=a+1;a=d[a>>0]|0}return a|0}function ck(a,b){a=a|0;b=b|0;return -1}function dk(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;i=a+24|0;j=a+28|0;h=0;while(1){if((h|0)>=(e|0))break;f=c[i>>2]|0;g=c[j>>2]|0;if(f>>>0>=g>>>0){if((nb[c[(c[a>>2]|0)+52>>2]&63](a,d[b>>0]|0)|0)==-1)break;b=b+1|0;h=h+1|0;continue}g=g-f|0;k=e-h|0;g=(k|0)<(g|0)?k:g;if(g){cv(f|0,b|0,g|0)|0;f=c[i>>2]|0}c[i>>2]=f+g;b=b+g|0;h=g+h|0}return h|0}function ek(a,b){a=a|0;b=b|0;return -1}function fk(a){a=a|0;c[a>>2]=16504;pt(a+4|0);return}function gk(a){a=a|0;c[a>>2]=16504;pt(a+4|0);Dt(a);return}function hk(a,b){a=a|0;b=b|0;return}function ik(a,b,c){a=a|0;b=b|0;c=c|0;return a|0}function jk(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;return}function kk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;return}function lk(a){a=a|0;return 0}function mk(a){a=a|0;return 0}function nk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=a+12|0;h=a+16|0;f=0;while(1){if((f|0)>=(d|0))break;e=c[g>>2]|0;if(e>>>0>=(c[h>>2]|0)>>>0){e=hb[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((e|0)==-1)break}else{c[g>>2]=e+4;e=c[e>>2]|0}c[b>>2]=e;f=f+1|0;b=b+4|0}return f|0}function ok(a){a=a|0;return -1}function pk(a){a=a|0;var b=0;if((hb[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1)a=-1;else{b=a+12|0;a=c[b>>2]|0;c[b>>2]=a+4;a=c[a>>2]|0}return a|0}function qk(a,b){a=a|0;b=b|0;return -1}function rk(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;h=a+24|0;i=a+28|0;e=0;while(1){if((e|0)>=(d|0))break;f=c[h>>2]|0;g=c[i>>2]|0;if(f>>>0<g>>>0){g=g-f>>2;j=d-e|0;g=(j|0)<(g|0)?j:g;tk(f,b,g)|0;c[h>>2]=(c[h>>2]|0)+(g<<2);b=b+(g<<2)|0;e=g+e|0;continue}if((nb[c[(c[a>>2]|0)+52>>2]&63](a,c[b>>2]|0)|0)==-1)break;b=b+4|0;e=e+1|0}return e|0}function sk(a,b){a=a|0;b=b|0;return -1}function tk(a,b,c){a=a|0;b=b|0;c=c|0;if(c)a=rj(a,b,c)|0;return a|0}function uk(a){a=a|0;Qj(a+8|0);return}function vk(a){a=a|0;Qj(a+8|0);Dt(a);return}function wk(a){a=a|0;Qj(a+(c[(c[a>>2]|0)+-12>>2]|0)+8|0);return}function xk(a){a=a|0;vk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function yk(a){a=a|0;Qj(a+8|0);return}function zk(a){a=a|0;Qj(a+8|0);Dt(a);return}function Ak(a){a=a|0;Qj(a+(c[(c[a>>2]|0)+-12>>2]|0)+8|0);return}function Bk(a){a=a|0;zk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Ck(a){a=a|0;Qj(a+4|0);return}function Dk(a){a=a|0;Qj(a+4|0);Dt(a);return}function Ek(a){a=a|0;Qj(a+(c[(c[a>>2]|0)+-12>>2]|0)+4|0);return}function Fk(a){a=a|0;Dk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Gk(a){a=a|0;Qj(a+4|0);return}function Hk(a){a=a|0;Qj(a+4|0);Dt(a);return}function Ik(a){a=a|0;Qj(a+(c[(c[a>>2]|0)+-12>>2]|0)+4|0);return}function Jk(a){a=a|0;Hk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Kk(a){a=a|0;Qj(a+12|0);return}function Lk(a){a=a|0;Qj(a+12|0);Dt(a);return}function Mk(a){a=a|0;Qj(a+-8+12|0);return}function Nk(a){a=a|0;Lk(a+-8|0);return}function Ok(a){a=a|0;Qj(a+(c[(c[a>>2]|0)+-12>>2]|0)+12|0);return}function Pk(a){a=a|0;Lk(a+(c[(c[a>>2]|0)+-12>>2]|0)|0);return}function Qk(a,b){a=a|0;b=b|0;c[a+16>>2]=(c[a+24>>2]|0)==0|b;return}function Rk(a,b){a=a|0;b=b|0;var d=0;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0&1;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;d=a+28|0;b=a+32|0;a=b+40|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(a|0));nt(d);return}function Sk(a){a=a|0;var b=0,d=0;d=l;l=l+16|0;b=d;ot(b,a+28|0);l=d;return c[b>>2]|0}function Tk(a){a=a|0;c[a>>2]=16440;nt(a+4|0);a=a+8|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function Uk(a){a=a|0;c[a>>2]=16504;nt(a+4|0);a=a+8|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0;c[a+16>>2]=0;c[a+20>>2]=0;return}function Vk(a,b){a=a|0;b=b|0;return}function Wk(e,f,g){e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;m=u;a[e>>0]=0;h=f+(c[(c[f>>2]|0)+-12>>2]|0)|0;i=h+16|0;j=c[i>>2]|0;if(!j){h=c[h+72>>2]|0;if(h|0)Xk(h)|0;do if(!g?(k=f+(c[(c[f>>2]|0)+-12>>2]|0)|0,c[k+4>>2]&4096|0):0){c[m>>2]=Sk(k)|0;k=lm(m,1165628)|0;pt(m);h=c[f+(c[(c[f>>2]|0)+-12>>2]|0)+24>>2]|0;k=k+8|0;g=h;m=(h|0)==0;n=g+12|0;o=g+16|0;p=h;i=h;q=i+12|0;r=i+16|0;s=h;t=h;while(1){if(m){i=0;h=0;break}if((c[n>>2]|0)==(c[o>>2]|0)?(hb[c[(c[p>>2]|0)+36>>2]&127](g)|0)==-1:0){i=0;h=0;break}j=c[q>>2]|0;if((j|0)==(c[r>>2]|0))j=hb[c[(c[s>>2]|0)+36>>2]&127](i)|0;else j=d[j>>0]|0;if((j&255)<<24>>24<=-1)break;if(!(b[(c[k>>2]|0)+(j<<24>>24<<1)>>1]&8192))break;j=c[q>>2]|0;if((j|0)==(c[r>>2]|0)){hb[c[(c[t>>2]|0)+40>>2]&127](i)|0;continue}else{c[q>>2]=j+1;continue}}if(h|0){if((c[i+12>>2]|0)!=(c[i+16>>2]|0))break;if((hb[c[(c[h>>2]|0)+36>>2]&127](i)|0)!=-1)break}s=f+(c[(c[f>>2]|0)+-12>>2]|0)|0;t=s+16|0;c[t>>2]=c[t>>2]|(c[s+24>>2]|0)==0|6}while(0);a[e>>0]=(c[f+(c[(c[f>>2]|0)+-12>>2]|0)+16>>2]|0)==0&1}else c[i>>2]=j|(c[h+24>>2]|0)==0|4;l=u;return}function Xk(b){b=b|0;var d=0,e=0,f=0;e=l;l=l+16|0;d=e;if(c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0){Yk(d,b);if(a[d>>0]|0?(f=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,(hb[c[(c[f>>2]|0)+24>>2]&127](f)|0)==-1):0){f=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[f>>2]=c[f>>2]|1}Zk(d)}l=e;return b|0}function Yk(b,d){b=b|0;d=d|0;a[b>>0]=0;c[b+4>>2]=d;d=d+(c[(c[d>>2]|0)+-12>>2]|0)|0;if(!(c[d+16>>2]|0)){d=c[d+72>>2]|0;if(d|0)Xk(d)|0;a[b>>0]=1}return}function Zk(a){a=a|0;var b=0;a=a+4|0;b=c[a>>2]|0;b=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;if((((c[b+24>>2]|0?(c[b+16>>2]|0)==0:0)?c[b+4>>2]&8192|0:0)?!(Ba()|0):0)?(b=c[a>>2]|0,b=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0,(hb[c[(c[b>>2]|0)+24>>2]&127](b)|0)==-1):0){b=c[a>>2]|0;b=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[b>>2]=c[b>>2]|1}return}function _k(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;m=l;l=l+32|0;f=m+24|0;e=m+20|0;g=m+16|0;h=m+12|0;n=m+28|0;i=m+8|0;j=m+4|0;k=m;Wk(n,b,0);if(a[n>>0]|0){c[i>>2]=0;c[k>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;o=lm(k,1165652)|0;n=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;p=c[(c[o>>2]|0)+16>>2]|0;c[g>>2]=c[n+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];fb[p&63](o,e,f,n,i,j)|0;pt(k);c[d>>2]=c[j>>2];k=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;n=k+16|0;c[n>>2]=c[n>>2]|c[i>>2]|(c[k+24>>2]|0)==0}l=m;return b|0}function $k(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;k=l;l=l+32|0;f=k+20|0;e=k+16|0;g=k+12|0;h=k+8|0;m=k+24|0;i=k+4|0;j=k;Wk(m,b,0);if(a[m>>0]|0){c[i>>2]=0;c[j>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;n=lm(j,1165652)|0;m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;o=c[(c[n>>2]|0)+20>>2]|0;c[g>>2]=c[m+24>>2];c[h>>2]=0;c[e>>2]=c[g>>2];c[f>>2]=c[h>>2];fb[o&63](n,e,f,m,i,d)|0;pt(j);j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;m=j+16|0;c[m>>2]=c[m>>2]|c[i>>2]|(c[j+24>>2]|0)==0}l=k;return b|0}function al(b){b=b|0;var e=0,f=0,g=0;g=l;l=l+16|0;f=g;c[b+4>>2]=0;Wk(f,b,1);do if(a[f>>0]|0){e=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;f=c[e+12>>2]|0;if((f|0)!=(c[e+16>>2]|0)){e=d[f>>0]|0;break}e=hb[c[(c[e>>2]|0)+36>>2]&127](e)|0;if((e|0)==-1){b=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;e=b+16|0;c[e>>2]=c[e>>2]|(c[b+24>>2]|0)==0|2;e=-1}}else e=-1;while(0);l=g;return e|0}function bl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;g=i;c[b+4>>2]=0;f=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;e=f+16|0;c[e>>2]=(c[f+24>>2]|0)==0|c[e>>2]&-3;Wk(g,b,1);e=c[(c[b>>2]|0)+-12>>2]|0;f=b+e|0;do if(!(a[g>>0]|0)){h=f+16|0;c[h>>2]=c[h>>2]|(c[f+24>>2]|0)==0|4}else{g=c[f+24>>2]|0;if(g){e=g+12|0;f=c[e>>2]|0;if((c[g+8>>2]|0)!=(f|0)?(h=f+-1|0,(a[h>>0]|0)==d<<24>>24):0){c[e>>2]=h;break}if((nb[c[(c[g>>2]|0)+44>>2]&63](g,d&255)|0)!=-1)break;e=c[(c[b>>2]|0)+-12>>2]|0}h=b+e+16|0;c[h>>2]=c[h>>2]|1}while(0);l=i;return b|0}function cl(a,b){a=a|0;b=b|0;return}function dl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;Yk(m,b);if(a[m>>0]|0){c[g>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;h=lm(g,1165684)|0;pt(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if((e|0)==-1){c[g>>2]=Sk(i)|0;e=lm(g,1165628)|0;e=nb[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;pt(g);e=e<<24>>24;c[f>>2]=e}f=c[(c[h>>2]|0)+16>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(ob[f&31](h,g,i,e&255,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[k>>2]=c[k>>2]|5}}Zk(m);l=n;return b|0}function el(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;Yk(m,b);if(a[m>>0]|0){c[g>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;h=lm(g,1165684)|0;pt(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if((e|0)==-1){c[g>>2]=Sk(i)|0;e=lm(g,1165628)|0;e=nb[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;pt(g);e=e<<24>>24;c[f>>2]=e}f=c[(c[h>>2]|0)+24>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(ob[f&31](h,g,i,e&255,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[k>>2]=c[k>>2]|5}}Zk(m);l=n;return b|0}function fl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;h=o+12|0;m=o+8|0;n=o;Yk(n,b);if(a[n>>0]|0){c[h>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;i=lm(h,1165684)|0;pt(h);j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;k=c[j+24>>2]|0;g=j+76|0;f=c[g>>2]|0;if((f|0)==-1){c[h>>2]=Sk(j)|0;f=lm(h,1165628)|0;f=nb[c[(c[f>>2]|0)+28>>2]&63](f,32)|0;pt(h);f=f<<24>>24;c[g>>2]=f}g=c[(c[i>>2]|0)+20>>2]|0;c[m>>2]=k;c[h>>2]=c[m>>2];if(!(fb[g&63](i,h,j,f&255,d,e)|0)){m=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[m>>2]=c[m>>2]|5}}Zk(n);l=o;return b|0}function gl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;h=o+12|0;m=o+8|0;n=o;Yk(n,b);if(a[n>>0]|0){c[h>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;i=lm(h,1165684)|0;pt(h);j=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;k=c[j+24>>2]|0;g=j+76|0;f=c[g>>2]|0;if((f|0)==-1){c[h>>2]=Sk(j)|0;f=lm(h,1165628)|0;f=nb[c[(c[f>>2]|0)+28>>2]&63](f,32)|0;pt(h);f=f<<24>>24;c[g>>2]=f}g=c[(c[i>>2]|0)+28>>2]|0;c[m>>2]=k;c[h>>2]=c[m>>2];if(!(fb[g&63](i,h,j,f&255,d,e)|0)){m=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[m>>2]=c[m>>2]|5}}Zk(n);l=o;return b|0}function hl(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;g=n+12|0;k=n+8|0;m=n;Yk(m,b);if(a[m>>0]|0){c[g>>2]=Sk(b+(c[(c[b>>2]|0)+-12>>2]|0)|0)|0;h=lm(g,1165684)|0;pt(g);i=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;j=c[i+24>>2]|0;f=i+76|0;e=c[f>>2]|0;if((e|0)==-1){c[g>>2]=Sk(i)|0;e=lm(g,1165628)|0;e=nb[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;pt(g);e=e<<24>>24;c[f>>2]=e}f=c[(c[h>>2]|0)+32>>2]|0;c[k>>2]=j;c[g>>2]=c[k>>2];if(!(gb[f&7](h,g,i,e&255,d)|0)){k=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[k>>2]=c[k>>2]|5}}Zk(m);l=n;return b|0}function il(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j;Yk(i,b);a:do if(a[i>>0]|0){e=c[b+(c[(c[b>>2]|0)+-12>>2]|0)+24>>2]|0;f=e;do if(e|0){g=f+24|0;h=c[g>>2]|0;if((h|0)==(c[f+28>>2]|0))if((nb[c[(c[e>>2]|0)+52>>2]&63](f,d&255)|0)==-1)break;else break a;else{c[g>>2]=h+1;a[h>>0]=d;break a}}while(0);h=b+(c[(c[b>>2]|0)+-12>>2]|0)+16|0;c[h>>2]=c[h>>2]|1}while(0);Zk(i);l=j;return b|0}function jl(a,b){a=a|0;b=b|0;return}function kl(){ml(0);return}function ll(){return}function ml(a){a=a|0;var b=0;a=c[3215]|0;nl(1165260,a,1165316);c[291145]=16572;c[291147]=16592;c[291146]=0;Rk(1164588,1165260);c[291165]=0;c[291166]=-1;ol(1165324,a,1165380);c[291167]=16612;c[291169]=16632;c[291168]=0;Rk(1164676,1165324);c[291187]=0;c[291188]=-1;a=c[3185]|0;pl(1165388,a,1165436);c[291189]=16652;c[291190]=16672;Rk(1164760,1165388);c[291208]=0;c[291209]=-1;ql(1165444,a,1165492);c[291210]=16692;c[291211]=16712;Rk(1164844,1165444);c[291229]=0;c[291230]=-1;a=c[3156]|0;pl(1165500,a,1165548);c[291231]=16652;c[291232]=16672;Rk(1164928,1165500);c[291250]=0;c[291251]=-1;b=c[1164924+(c[(c[291231]|0)+-12>>2]|0)+24>>2]|0;c[291273]=16652;c[291274]=16672;Rk(1165096,b);c[291292]=0;c[291293]=-1;ql(1165556,a,1165604);c[291252]=16692;c[291253]=16712;Rk(1165012,1165556);c[291271]=0;c[291272]=-1;a=c[1165008+(c[(c[291252]|0)+-12>>2]|0)+24>>2]|0;c[291294]=16692;c[291295]=16712;Rk(1165180,a);c[291313]=0;c[291314]=-1;c[1164580+(c[(c[291145]|0)+-12>>2]|0)+72>>2]=1164756;c[1164668+(c[(c[291167]|0)+-12>>2]|0)+72>>2]=1164840;a=1164924+(c[(c[291231]|0)+-12>>2]|0)+4|0;c[a>>2]=c[a>>2]|8192;a=1165008+(c[(c[291252]|0)+-12>>2]|0)+4|0;c[a>>2]=c[a>>2]|8192;c[1164924+(c[(c[291231]|0)+-12>>2]|0)+72>>2]=1164756;c[1165008+(c[(c[291252]|0)+-12>>2]|0)+72>>2]=1164840;return}function nl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;h=f+4|0;g=f;Tk(b);c[b>>2]=16920;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52>>0]=0;ot(h,b+4|0);c[g>>2]=c[h>>2];Hl(b,g);pt(g);l=f;return}function ol(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;h=f+4|0;g=f;Uk(b);c[b>>2]=16856;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52>>0]=0;ot(h,b+4|0);c[g>>2]=c[h>>2];Bl(b,g);pt(g);l=f;return}function pl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;h=f+4|0;g=f;Tk(b);c[b>>2]=16792;c[b+32>>2]=d;ot(h,b+4|0);c[g>>2]=c[h>>2];d=lm(g,1167420)|0;pt(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(hb[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;l=f;return}function ql(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;h=f+4|0;g=f;Uk(b);c[b>>2]=16728;c[b+32>>2]=d;ot(h,b+4|0);c[g>>2]=c[h>>2];d=lm(g,1167428)|0;pt(g);c[b+36>>2]=d;c[b+40>>2]=e;a[b+44>>0]=(hb[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;l=f;return}function rl(a){a=a|0;fk(a);Dt(a);return}function sl(b,d){b=b|0;d=d|0;hb[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=lm(d,1167428)|0;c[b+36>>2]=d;a[b+44>>0]=(hb[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function tl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;d=k+8|0;e=k;f=a+36|0;g=a+40|0;h=d+8|0;i=d;b=a+32|0;a:while(1){a=c[f>>2]|0;a=ob[c[(c[a>>2]|0)+20>>2]&31](a,c[g>>2]|0,d,h,e)|0;m=(c[e>>2]|0)-i|0;if((Ni(d,1,m,c[b>>2]|0)|0)!=(m|0)){a=-1;break}switch(a|0){case 1:break;case 2:{a=-1;break a}default:{j=4;break a}}}if((j|0)==4)a=((Li(c[b>>2]|0)|0)!=0)<<31>>31;l=k;return a|0}function ul(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;a:do if(!(a[b+44>>0]|0)){f=0;while(1){if((f|0)>=(e|0))break a;if((nb[c[(c[b>>2]|0)+52>>2]&63](b,c[d>>2]|0)|0)==-1)break a;f=f+1|0;d=d+4|0}}else f=Ni(d,4,e,c[b+32>>2]|0)|0;while(0);return f|0}function vl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+32|0;m=q+16|0;f=q+8|0;n=q+4|0;o=q;p=(d|0)==-1;do if(!p){c[f>>2]=d;if(a[b+44>>0]|0)if((Ni(f,4,1,c[b+32>>2]|0)|0)==1){e=14;break}else{b=-1;break}c[n>>2]=m;e=f+4|0;g=b+36|0;h=b+40|0;i=m+8|0;j=m;k=b+32|0;while(1){b=c[g>>2]|0;b=kb[c[(c[b>>2]|0)+12>>2]&15](b,c[h>>2]|0,f,e,o,m,i,n)|0;if((c[o>>2]|0)==(f|0)){e=13;break}if((b|0)==3){e=7;break}if((b|1|0)!=1){e=13;break}f=(c[n>>2]|0)-j|0;if((Ni(m,1,f,c[k>>2]|0)|0)!=(f|0)){e=13;break}if((b|0)==1)f=c[o>>2]|0;else{e=12;break}}if((e|0)==7)if((Ni(f,1,1,c[k>>2]|0)|0)==1)e=12;else e=13;if((e|0)==12){e=14;break}else if((e|0)==13){b=-1;break}}else e=14;while(0);if((e|0)==14)b=p?0:d;l=q;return b|0}function wl(a){a=a|0;Tj(a);Dt(a);return}function xl(b,d){b=b|0;d=d|0;hb[c[(c[b>>2]|0)+24>>2]&127](b)|0;d=lm(d,1167420)|0;c[b+36>>2]=d;a[b+44>>0]=(hb[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;return}function yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;d=k+8|0;e=k;f=a+36|0;g=a+40|0;h=d+8|0;i=d;b=a+32|0;a:while(1){a=c[f>>2]|0;a=ob[c[(c[a>>2]|0)+20>>2]&31](a,c[g>>2]|0,d,h,e)|0;m=(c[e>>2]|0)-i|0;if((Ni(d,1,m,c[b>>2]|0)|0)!=(m|0)){a=-1;break}switch(a|0){case 1:break;case 2:{a=-1;break a}default:{j=4;break a}}}if((j|0)==4)a=((Li(c[b>>2]|0)|0)!=0)<<31>>31;l=k;return a|0}function zl(b,e,f){b=b|0;e=e|0;f=f|0;var g=0;a:do if(!(a[b+44>>0]|0)){g=0;while(1){if((g|0)>=(f|0))break a;if((nb[c[(c[b>>2]|0)+52>>2]&63](b,d[e>>0]|0)|0)==-1)break a;g=g+1|0;e=e+1|0}}else g=Ni(e,1,f,c[b+32>>2]|0)|0;while(0);return g|0}function Al(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+32|0;m=q+16|0;f=q+8|0;n=q+4|0;o=q;p=(d|0)==-1;do if(!p){a[f>>0]=d;if(a[b+44>>0]|0)if((Ni(f,1,1,c[b+32>>2]|0)|0)==1){e=14;break}else{b=-1;break}c[n>>2]=m;e=f+1|0;g=b+36|0;h=b+40|0;i=m+8|0;j=m;k=b+32|0;while(1){b=c[g>>2]|0;b=kb[c[(c[b>>2]|0)+12>>2]&15](b,c[h>>2]|0,f,e,o,m,i,n)|0;if((c[o>>2]|0)==(f|0)){e=13;break}if((b|0)==3){e=7;break}if((b|1|0)!=1){e=13;break}f=(c[n>>2]|0)-j|0;if((Ni(m,1,f,c[k>>2]|0)|0)!=(f|0)){e=13;break}if((b|0)==1)f=c[o>>2]|0;else{e=12;break}}if((e|0)==7)if((Ni(f,1,1,c[k>>2]|0)|0)==1)e=12;else e=13;if((e|0)==12){e=14;break}else if((e|0)==13){b=-1;break}}else e=14;while(0);if((e|0)==14)b=p?0:d;l=q;return b|0}function Bl(b,d){b=b|0;d=d|0;var e=0,f=0;f=lm(d,1167428)|0;e=b+36|0;c[e>>2]=f;d=b+44|0;c[d>>2]=hb[c[(c[f>>2]|0)+24>>2]&127](f)|0;e=c[e>>2]|0;a[b+53>>0]=(hb[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;return}function Cl(a){a=a|0;fk(a);Dt(a);return}function Dl(a){a=a|0;return Gl(a,0)|0}function El(a){a=a|0;return Gl(a,1)|0}function Fl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;i=m+16|0;j=m+8|0;f=m+4|0;g=m;k=b+52|0;e=(a[k>>0]|0)!=0;a:do if((d|0)==-1)if(e)d=-1;else{d=c[b+48>>2]|0;a[k>>0]=(d|0)!=-1&1}else{b:do if(e){e=b+48|0;c[f>>2]=c[e>>2];n=c[b+36>>2]|0;switch(kb[c[(c[n>>2]|0)+12>>2]&15](n,c[b+40>>2]|0,f,f+4|0,g,i,i+8|0,j)|0){case 1:case 2:break;case 3:{a[i>>0]=c[e>>2];c[j>>2]=i+1;h=8;break}default:h=8}c:do if((h|0)==8){b=b+32|0;while(1){f=c[j>>2]|0;if(f>>>0<=i>>>0)break;n=f+-1|0;c[j>>2]=n;if((Oi(a[n>>0]|0,c[b>>2]|0)|0)==-1)break c}break b}while(0);d=-1;break a}else e=b+48|0;while(0);c[e>>2]=d;a[k>>0]=1}while(0);l=m;return d|0}function Gl(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;s=l;l=l+32|0;p=s+16|0;q=s+8|0;m=s+4|0;n=s;g=b+52|0;if(a[g>>0]|0){f=b+48|0;e=c[f>>2]|0;if(d){c[f>>2]=-1;a[g>>0]=0}}else{e=c[b+44>>2]|0;e=(e|0)>1?e:1;o=b+32|0;f=0;while(1){if((f|0)>=(e|0)){r=8;break}g=cj(c[o>>2]|0)|0;if((g|0)==-1){e=-1;break}a[p+f>>0]=g;f=f+1|0}if((r|0)==8){do if(!(a[b+53>>0]|0)){i=b+40|0;j=b+36|0;k=q+4|0;a:while(1){t=c[i>>2]|0;g=t;f=c[g>>2]|0;g=c[g+4>>2]|0;u=c[j>>2]|0;h=p+e|0;switch(kb[c[(c[u>>2]|0)+16>>2]&15](u,t,p,h,m,q,k,n)|0){case 3:{r=15;break a}case 2:{r=17;break a}case 1:break;default:break a}u=c[i>>2]|0;c[u>>2]=f;c[u+4>>2]=g;if((e|0)==8){r=17;break}f=cj(c[o>>2]|0)|0;if((f|0)==-1){r=17;break}a[h>>0]=f;e=e+1|0}if((r|0)==15)c[q>>2]=a[p>>0];else if((r|0)==17){e=-1;break}r=18}else{c[q>>2]=a[p>>0];r=18}while(0);b:do if((r|0)==18){if(d){e=c[q>>2]|0;c[b+48>>2]=e;break}while(1){if((e|0)<=0)break;e=e+-1|0;if((Oi(a[p+e>>0]|0,c[o>>2]|0)|0)==-1){e=-1;break b}}e=c[q>>2]|0}while(0)}}l=s;return e|0}function Hl(b,d){b=b|0;d=d|0;var e=0,f=0;f=lm(d,1167420)|0;e=b+36|0;c[e>>2]=f;d=b+44|0;c[d>>2]=hb[c[(c[f>>2]|0)+24>>2]&127](f)|0;e=c[e>>2]|0;a[b+53>>0]=(hb[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;return}function Il(a){a=a|0;Tj(a);Dt(a);return}function Jl(a){a=a|0;return Ml(a,0)|0}function Kl(a){a=a|0;return Ml(a,1)|0}function Ll(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;i=m+16|0;j=m+4|0;f=m+8|0;g=m;k=b+52|0;e=(a[k>>0]|0)!=0;a:do if((d|0)==-1)if(e)d=-1;else{d=c[b+48>>2]|0;a[k>>0]=(d|0)!=-1&1}else{b:do if(e){e=b+48|0;a[f>>0]=c[e>>2];n=c[b+36>>2]|0;switch(kb[c[(c[n>>2]|0)+12>>2]&15](n,c[b+40>>2]|0,f,f+1|0,g,i,i+8|0,j)|0){case 1:case 2:break;case 3:{a[i>>0]=c[e>>2];c[j>>2]=i+1;h=8;break}default:h=8}c:do if((h|0)==8){b=b+32|0;while(1){f=c[j>>2]|0;if(f>>>0<=i>>>0)break;n=f+-1|0;c[j>>2]=n;if((Oi(a[n>>0]|0,c[b>>2]|0)|0)==-1)break c}break b}while(0);d=-1;break a}else e=b+48|0;while(0);c[e>>2]=d;a[k>>0]=1}while(0);l=m;return d|0}function Ml(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=l;l=l+32|0;q=t+16|0;r=t+8|0;n=t+4|0;o=t;h=b+52|0;if(a[h>>0]|0){g=b+48|0;f=c[g>>2]|0;if(e){c[g>>2]=-1;a[h>>0]=0}}else{f=c[b+44>>2]|0;f=(f|0)>1?f:1;p=b+32|0;g=0;while(1){if((g|0)>=(f|0)){s=8;break}h=cj(c[p>>2]|0)|0;if((h|0)==-1){f=-1;break}a[q+g>>0]=h;g=g+1|0}if((s|0)==8){do if(!(a[b+53>>0]|0)){j=b+40|0;k=b+36|0;m=r+1|0;a:while(1){u=c[j>>2]|0;h=u;g=c[h>>2]|0;h=c[h+4>>2]|0;v=c[k>>2]|0;i=q+f|0;switch(kb[c[(c[v>>2]|0)+16>>2]&15](v,u,q,i,n,r,m,o)|0){case 3:{s=15;break a}case 2:{s=17;break a}case 1:break;default:break a}v=c[j>>2]|0;c[v>>2]=g;c[v+4>>2]=h;if((f|0)==8){s=17;break}g=cj(c[p>>2]|0)|0;if((g|0)==-1){s=17;break}a[i>>0]=g;f=f+1|0}if((s|0)==15)a[r>>0]=a[q>>0]|0;else if((s|0)==17){f=-1;break}s=18}else{a[r>>0]=a[q>>0]|0;s=18}while(0);b:do if((s|0)==18){if(e){f=a[r>>0]|0;c[b+48>>2]=f&255}else{while(1){if((f|0)<=0)break;f=f+-1|0;if((Oi(d[q+f>>0]|0,c[p>>2]|0)|0)==-1){f=-1;break b}}f=a[r>>0]|0}f=f&255}while(0)}}l=t;return f|0}function Nl(a){a=a|0;return}function Ol(a){a=a|0;Dt(a);return}function Pl(a){a=a|0;if(a|0)db[c[(c[a>>2]|0)+4>>2]&255](a);return}function Ql(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;b=c;while(1){if((e|0)==(f|0)){h=7;break}if((b|0)==(d|0)){b=-1;break}c=a[b>>0]|0;g=a[e>>0]|0;if(c<<24>>24<g<<24>>24){b=-1;break}if(g<<24>>24<c<<24>>24){b=1;break}e=e+1|0;b=b+1|0}if((h|0)==7)b=(b|0)!=(d|0)&1;return b|0}function Rl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Tl(a,d,e);return}function Sl(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;b=0;while(1){if((c|0)==(d|0))break;e=(a[c>>0]|0)+(b<<4)|0;f=e&-268435456;b=(f>>>24|f)^e;c=c+1|0}return b|0}function Tl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=d;f=e-g|0;if(f>>>0>4294967279)Gt(b);if(f>>>0<11){a[b+11>>0]=f;h=b}else{i=f+16&-16;h=At(i)|0;c[b>>2]=h;c[b+8>>2]=i|-2147483648;c[b+4>>2]=f}f=e-g|0;b=h;while(1){if((d|0)==(e|0))break;a[b>>0]=a[d>>0]|0;d=d+1|0;b=b+1|0}a[h+f>>0]=0;return}function Ul(a){a=a|0;return}function Vl(a){a=a|0;Dt(a);return}function Wl(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a=b;while(1){if((e|0)==(f|0)){h=7;break}if((a|0)==(d|0)){a=-1;break}b=c[a>>2]|0;g=c[e>>2]|0;if((b|0)<(g|0)){a=-1;break}if((g|0)<(b|0)){a=1;break}e=e+4|0;a=a+4|0}if((h|0)==7)a=(a|0)!=(d|0)&1;return a|0}function Xl(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Zl(a,d,e);return}function Yl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;a=0;while(1){if((b|0)==(d|0))break;e=(c[b>>2]|0)+(a<<4)|0;f=e&-268435456;a=(f>>>24|f)^e;b=b+4|0}return a|0}function Zl(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;g=d;h=e-g>>2;if(h>>>0>1073741807)Gt(b);do if(h>>>0>=2){f=h+4&-4;if(f>>>0>1073741823)Aa(28159,28196,1734,28282);else{i=At(f<<2)|0;c[b>>2]=i;c[b+8>>2]=f|-2147483648;c[b+4>>2]=h;break}}else{a[b+8+3>>0]=h;i=b}while(0);f=(e-g|0)>>>2;b=i;while(1){if((d|0)==(e|0))break;c[b>>2]=c[d>>2];d=d+4|0;b=b+4|0}c[i+(f<<2)>>2]=0;return}function _l(a){a=a|0;return}function $l(a){a=a|0;Dt(a);return}function am(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+48|0;i=p+40|0;o=p+16|0;j=p+8|0;k=p+12|0;m=p+4|0;n=p;if(!(c[f+4>>2]&1)){c[j>>2]=-1;n=c[(c[b>>2]|0)+16>>2]|0;c[k>>2]=c[d>>2];c[m>>2]=c[e>>2];c[o>>2]=c[k>>2];c[i>>2]=c[m>>2];c[d>>2]=fb[n&63](b,o,i,f,g,j)|0;switch(c[j>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}i=c[d>>2]|0}else{k=Sk(f)|0;c[i>>2]=k;m=lm(i,1165628)|0;vt(k)|0;k=Sk(f)|0;c[i>>2]=k;b=lm(i,1165644)|0;vt(k)|0;eb[c[(c[b>>2]|0)+24>>2]&63](o,b);eb[c[(c[b>>2]|0)+28>>2]&63](o+12|0,b);c[n>>2]=c[e>>2];b=o+24|0;c[i>>2]=c[n>>2];a[h>>0]=(Pm(d,i,o,b,m,g,1)|0)==(o|0)&1;i=c[d>>2]|0;do{b=b+-12|0;Mt(b)}while((b|0)!=(o|0))}l=p;return i|0}function bm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=Nm(a,j,i,e,f,g)|0;l=h;return g|0}function cm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=Lm(a,j,i,e,f,g)|0;l=h;return g|0}function dm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=Jm(a,j,i,e,f,g)|0;l=h;return g|0}function em(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=Hm(a,j,i,e,f,g)|0;l=h;return g|0}function fm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=Fm(a,j,i,e,f,g)|0;l=h;return g|0}function gm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=Bm(a,j,i,e,f,g)|0;l=h;return g|0}function hm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=zm(a,j,i,e,f,g)|0;l=h;return g|0}function im(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=xm(a,j,i,e,f,g)|0;l=h;return g|0}function jm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=sm(a,j,i,e,f,g)|0;l=h;return g|0}function km(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;z=l;l=l+240|0;w=z;u=z+204|0;x=z+192|0;y=z+180|0;v=z+176|0;r=z+16|0;s=z+8|0;t=z+4|0;c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[x+(b<<2)>>2]=0;b=b+1|0}b=Sk(g)|0;c[y>>2]=b;q=lm(y,1165628)|0;lb[c[(c[q>>2]|0)+32>>2]&7](q,25554,25580,u)|0;vt(b)|0;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[y+(b<<2)>>2]=0;b=b+1|0}q=y+11|0;p=y+8|0;if((a[q>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(y,b,0);g=(a[q>>0]|0)<0?c[y>>2]|0:y;c[v>>2]=g;c[s>>2]=r;c[t>>2]=0;o=y+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;k=(b|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(k)break;else break a;if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;A=19;break}}else A=19;while(0);if((A|0)==19){A=0;if(k){j=0;break}else j=0}k=a[q>>0]|0;k=k<<24>>24<0?c[o>>2]|0:k&255;if((c[v>>2]|0)==(g+k|0)){St(y,k<<1,0);if((a[q>>0]|0)<0)g=(c[p>>2]&2147483647)+-1|0;else g=10;St(y,g,0);g=(a[q>>0]|0)<0?c[y>>2]|0:y;c[v>>2]=g+k}m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=d[k>>0]|0;if(mm(k&255,16,g,v,t,0,x,r,s,u)|0)break;j=c[m>>2]|0;if((j|0)==(c[n>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[m>>2]=j+1;continue}}St(y,(c[v>>2]|0)-g|0,0);u=(a[q>>0]|0)<0?c[y>>2]|0:y;v=nm()|0;c[w>>2]=i;if((om(u,v,25587,w)|0)!=1)c[h>>2]=4;if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[f>>2]=0;A=43;break}if(!b)A=44}else A=43;while(0);if((A|0)==43?b:0)A=44;if((A|0)==44)c[h>>2]=c[h>>2]|2;A=c[e>>2]|0;Mt(y);Mt(x);l=z;return A|0}function lm(a,b){a=a|0;b=b|0;a=c[a>>2]|0;b=pm(b)|0;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function mm(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){m=(a[l+24>>0]|0)==b<<24>>24;if(!m?(a[l+25>>0]|0)!=b<<24>>24:0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if(b<<24>>24==h<<24>>24?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}f=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=f;c[g>>2]=0;m=0;break}i=l+26|0;h=0;while(1){m=l+h|0;if((h|0)==26){m=i;break}if((a[m>>0]|0)==b<<24>>24)break;else h=h+1|0}m=m-l|0;if((m|0)>23)m=-1;else{switch(d|0){case 10:case 8:{if((m|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=22){if(p){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[25554+m>>0]|0;c[f>>2]=o+1;a[o>>0]=m;m=0;break a}break}default:{}}m=a[25554+m>>0]|0;c[f>>2]=o+1;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function nm(){if((a[993800]|0)==0?Ru(993800)|0:0)c[291409]=fj(2147483647,25590,0)|0;return c[291409]|0}function om(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;c[g>>2]=e;e=nj(b)|0;b=Xi(a,d,g)|0;if(e|0)nj(e)|0;l=f;return b|0}function pm(a){a=a|0;var b=0,d=0,e=0,f=0;f=l;l=l+32|0;b=f+16|0;d=f+12|0;e=f;c[e>>2]=a;c[e+4>>2]=164;c[e+8>>2]=0;if((c[a>>2]|0)!=-1){c[b>>2]=e;c[d>>2]=b;zt(a,d,165)}l=f;return (c[a+4>>2]|0)+-1|0}function qm(a){a=a|0;var b=0;b=c[291410]|0;c[291410]=b+1;c[a+4>>2]=b+1;return}function rm(a){a=a|0;var b=0,d=0;b=c[c[a>>2]>>2]|0;a=c[b+4>>2]|0;d=c[b+8>>2]|0;b=(c[b>>2]|0)+(d>>1)|0;if(d&1)a=c[(c[b>>2]|0)+a>>2]|0;db[a&255](b);return}function sm(b,e,f,g,i,j){b=b|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=l;l=l+240|0;t=E+200|0;u=E+199|0;v=E+198|0;D=E+184|0;C=E+172|0;w=E+168|0;x=E+8|0;y=E+4|0;z=E;A=E+197|0;s=E+196|0;tm(D,g,t,u,v);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[C+(b<<2)>>2]=0;b=b+1|0}q=C+11|0;r=C+8|0;if((a[q>>0]|0)<0)b=(c[r>>2]&2147483647)+-1|0;else b=10;St(C,b,0);g=(a[q>>0]|0)<0?c[C>>2]|0:C;c[w>>2]=g;c[y>>2]=x;c[z>>2]=0;a[A>>0]=1;a[s>>0]=69;p=C+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;m=(b|0)==0;k=c[f>>2]|0;do if(k){if((c[k+12>>2]|0)!=(c[k+16>>2]|0))if(m)break;else break a;if((hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)!=-1)if(m)break;else break a;else{c[f>>2]=0;F=16;break}}else F=16;while(0);if((F|0)==16){F=0;if(m){k=0;break}else k=0}m=a[q>>0]|0;m=m<<24>>24<0?c[p>>2]|0:m&255;if((c[w>>2]|0)==(g+m|0)){St(C,m<<1,0);if((a[q>>0]|0)<0)g=(c[r>>2]&2147483647)+-1|0;else g=10;St(C,g,0);g=(a[q>>0]|0)<0?c[C>>2]|0:C;c[w>>2]=g+m}n=b+12|0;m=c[n>>2]|0;o=b+16|0;if((m|0)==(c[o>>2]|0))m=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else m=d[m>>0]|0;if(um(m&255,A,s,g,w,a[u>>0]|0,a[v>>0]|0,D,x,y,z,t)|0)break;k=c[n>>2]|0;if((k|0)==(c[o>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[n>>2]=k+1;continue}}v=a[D+11>>0]|0;if(!((a[A>>0]|0)==0?1:((v<<24>>24<0?c[D+4>>2]|0:v&255)|0)==0)?(B=c[y>>2]|0,(B-x|0)<160):0){A=c[z>>2]|0;c[y>>2]=B+4;c[B>>2]=A}h[j>>3]=+vm(g,c[w>>2]|0,i);wm(D,x,c[y>>2]|0,i);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[f>>2]=0;F=41;break}if(!b)F=42}else F=41;while(0);if((F|0)==41?b:0)F=42;if((F|0)==42)c[i>>2]=c[i>>2]|2;F=c[e>>2]|0;Mt(C);Mt(D);l=E;return F|0}function tm(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;h=l;l=l+16|0;i=h;d=Sk(d)|0;c[i>>2]=d;j=lm(i,1165628)|0;lb[c[(c[j>>2]|0)+32>>2]&7](j,25554,25586,e)|0;e=lm(i,1165644)|0;a[f>>0]=hb[c[(c[e>>2]|0)+12>>2]&127](e)|0;a[g>>0]=hb[c[(c[e>>2]|0)+16>>2]&127](e)|0;eb[c[(c[e>>2]|0)+20>>2]&63](b,e);vt(d)|0;l=h;return}function um(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if(b<<24>>24==i<<24>>24)if(a[e>>0]|0){a[e>>0]=0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=46;h=a[k+11>>0]|0;if(((h<<24>>24<0?c[k+4>>2]|0:h&255)|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;p=0}else p=0}else p=-1;else{if(b<<24>>24==j<<24>>24?(j=a[k+11>>0]|0,(j<<24>>24<0?c[k+4>>2]|0:j&255)|0):0){if(!(a[e>>0]|0)){p=-1;break}p=c[m>>2]|0;if((p-l|0)>=160){p=0;break}l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;c[n>>2]=0;p=0;break}j=o+32|0;i=0;while(1){p=o+i|0;if((i|0)==32){p=j;break}if((a[p>>0]|0)==b<<24>>24)break;else i=i+1|0}i=p-o|0;if((i|0)>31)p=-1;else{j=a[25554+i>>0]|0;switch(i|0){case 24:case 25:{p=c[h>>2]|0;if((p|0)!=(g|0)?(d[p+-1>>0]&95|0)!=(d[f>>0]&127|0):0){p=-1;break a}c[h>>2]=p+1;a[p>>0]=j;p=0;break a}case 23:case 22:{a[f>>0]=80;p=c[h>>2]|0;c[h>>2]=p+1;a[p>>0]=j;p=0;break a}default:{p=j&95;if((((p|0)==(a[f>>0]|0)?(a[f>>0]=p|128,a[e>>0]|0):0)?(a[e>>0]=0,f=a[k+11>>0]|0,(f<<24>>24<0?c[k+4>>2]|0:f&255)|0):0)?(q=c[m>>2]|0,(q-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=l}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=j;if((i|0)>21){p=0;break a}c[n>>2]=(c[n>>2]|0)+1;p=0;break a}}}}while(0);return p|0}function vm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{g=Oh()|0;h=c[g>>2]|0;c[g>>2]=0;e=+uj(a,f,nm()|0);a=c[g>>2]|0;if(!a)c[g>>2]=h;if((c[f>>2]|0)==(b|0)){if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}}l=i;return +e}function wm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=a[b+11>>0]|0;j=k<<24>>24<0;i=b+4|0;g=c[i>>2]|0;k=k&255;do if((j?g:k)|0){if((d|0)!=(e|0)){g=e;h=d;while(1){g=g+-4|0;if(h>>>0>=g>>>0)break;m=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=m;h=h+4|0}g=c[i>>2]|0}m=j?c[b>>2]|0:b;e=e+-4|0;b=m+(j?g:k)|0;g=m;while(1){h=a[g>>0]|0;i=h<<24>>24>0&h<<24>>24!=127;if(d>>>0>=e>>>0)break;if(i?(h<<24>>24|0)!=(c[d>>2]|0):0){l=10;break}d=d+4|0;g=(b-g|0)>1?g+1|0:g}if((l|0)==10){c[f>>2]=4;break}if(i?((c[e>>2]|0)+-1|0)>>>0>=h<<24>>24>>>0:0)c[f>>2]=4}while(0);return}function xm(b,e,f,g,i,j){b=b|0;e=e|0;f=f|0;g=g|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=l;l=l+240|0;t=E+200|0;u=E+199|0;v=E+198|0;D=E+184|0;C=E+172|0;w=E+168|0;x=E+8|0;y=E+4|0;z=E;A=E+197|0;s=E+196|0;tm(D,g,t,u,v);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[C+(b<<2)>>2]=0;b=b+1|0}q=C+11|0;r=C+8|0;if((a[q>>0]|0)<0)b=(c[r>>2]&2147483647)+-1|0;else b=10;St(C,b,0);g=(a[q>>0]|0)<0?c[C>>2]|0:C;c[w>>2]=g;c[y>>2]=x;c[z>>2]=0;a[A>>0]=1;a[s>>0]=69;p=C+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;m=(b|0)==0;k=c[f>>2]|0;do if(k){if((c[k+12>>2]|0)!=(c[k+16>>2]|0))if(m)break;else break a;if((hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)!=-1)if(m)break;else break a;else{c[f>>2]=0;F=16;break}}else F=16;while(0);if((F|0)==16){F=0;if(m){k=0;break}else k=0}m=a[q>>0]|0;m=m<<24>>24<0?c[p>>2]|0:m&255;if((c[w>>2]|0)==(g+m|0)){St(C,m<<1,0);if((a[q>>0]|0)<0)g=(c[r>>2]&2147483647)+-1|0;else g=10;St(C,g,0);g=(a[q>>0]|0)<0?c[C>>2]|0:C;c[w>>2]=g+m}n=b+12|0;m=c[n>>2]|0;o=b+16|0;if((m|0)==(c[o>>2]|0))m=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else m=d[m>>0]|0;if(um(m&255,A,s,g,w,a[u>>0]|0,a[v>>0]|0,D,x,y,z,t)|0)break;k=c[n>>2]|0;if((k|0)==(c[o>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[n>>2]=k+1;continue}}v=a[D+11>>0]|0;if(!((a[A>>0]|0)==0?1:((v<<24>>24<0?c[D+4>>2]|0:v&255)|0)==0)?(B=c[y>>2]|0,(B-x|0)<160):0){A=c[z>>2]|0;c[y>>2]=B+4;c[B>>2]=A}h[j>>3]=+ym(g,c[w>>2]|0,i);wm(D,x,c[y>>2]|0,i);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[f>>2]=0;F=41;break}if(!b)F=42}else F=41;while(0);if((F|0)==41?b:0)F=42;if((F|0)==42)c[i>>2]=c[i>>2]|2;F=c[e>>2]|0;Mt(C);Mt(D);l=E;return F|0}function ym(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{g=Oh()|0;h=c[g>>2]|0;c[g>>2]=0;e=+uj(a,f,nm()|0);a=c[g>>2]|0;if(!a)c[g>>2]=h;if((c[f>>2]|0)==(b|0)){if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}}l=i;return +e}function zm(b,e,f,h,i,j){b=b|0;e=e|0;f=f|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;E=l;l=l+240|0;t=E+200|0;u=E+199|0;v=E+198|0;D=E+184|0;C=E+172|0;w=E+168|0;x=E+8|0;y=E+4|0;z=E;A=E+197|0;s=E+196|0;tm(D,h,t,u,v);c[C>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[C+(b<<2)>>2]=0;b=b+1|0}q=C+11|0;r=C+8|0;if((a[q>>0]|0)<0)b=(c[r>>2]&2147483647)+-1|0;else b=10;St(C,b,0);h=(a[q>>0]|0)<0?c[C>>2]|0:C;c[w>>2]=h;c[y>>2]=x;c[z>>2]=0;a[A>>0]=1;a[s>>0]=69;p=C+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;m=(b|0)==0;k=c[f>>2]|0;do if(k){if((c[k+12>>2]|0)!=(c[k+16>>2]|0))if(m)break;else break a;if((hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)!=-1)if(m)break;else break a;else{c[f>>2]=0;F=16;break}}else F=16;while(0);if((F|0)==16){F=0;if(m){k=0;break}else k=0}m=a[q>>0]|0;m=m<<24>>24<0?c[p>>2]|0:m&255;if((c[w>>2]|0)==(h+m|0)){St(C,m<<1,0);if((a[q>>0]|0)<0)h=(c[r>>2]&2147483647)+-1|0;else h=10;St(C,h,0);h=(a[q>>0]|0)<0?c[C>>2]|0:C;c[w>>2]=h+m}n=b+12|0;m=c[n>>2]|0;o=b+16|0;if((m|0)==(c[o>>2]|0))m=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else m=d[m>>0]|0;if(um(m&255,A,s,h,w,a[u>>0]|0,a[v>>0]|0,D,x,y,z,t)|0)break;k=c[n>>2]|0;if((k|0)==(c[o>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[n>>2]=k+1;continue}}v=a[D+11>>0]|0;if(!((a[A>>0]|0)==0?1:((v<<24>>24<0?c[D+4>>2]|0:v&255)|0)==0)?(B=c[y>>2]|0,(B-x|0)<160):0){A=c[z>>2]|0;c[y>>2]=B+4;c[B>>2]=A}g[j>>2]=+Am(h,c[w>>2]|0,i);wm(D,x,c[y>>2]|0,i);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[f>>2]=0;F=41;break}if(!b)F=42}else F=41;while(0);if((F|0)==41?b:0)F=42;if((F|0)==42)c[i>>2]=c[i>>2]|2;F=c[e>>2]|0;Mt(C);Mt(D);l=E;return F|0}function Am(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;if((a|0)==(b|0)){c[d>>2]=4;e=0.0}else{g=Oh()|0;h=c[g>>2]|0;c[g>>2]=0;e=+uj(a,f,nm()|0);a=c[g>>2]|0;if(!a)c[g>>2]=h;if((c[f>>2]|0)==(b|0)){if((a|0)==34)c[d>>2]=4}else{c[d>>2]=4;e=0.0}}l=i;return +e}function Bm(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+224|0;r=B+198|0;s=B+196|0;z=B+184|0;A=B+172|0;t=B+168|0;u=B+8|0;v=B+4|0;w=B;x=Cm(g)|0;Dm(z,g,r,s);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}p=A+11|0;q=A+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(A,b,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g;c[v>>2]=u;c[w>>2]=0;o=A+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;k=(b|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(k)break;else break a;if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;C=16;break}}else C=16;while(0);if((C|0)==16){C=0;if(k){j=0;break}else j=0}k=a[p>>0]|0;k=k<<24>>24<0?c[o>>2]|0:k&255;if((c[t>>2]|0)==(g+k|0)){St(A,k<<1,0);if((a[p>>0]|0)<0)g=(c[q>>2]&2147483647)+-1|0;else g=10;St(A,g,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g+k}m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=d[k>>0]|0;if(mm(k&255,x,g,t,w,a[s>>0]|0,z,u,v,r)|0)break;j=c[m>>2]|0;if((j|0)==(c[n>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[m>>2]=j+1;continue}}s=a[z+11>>0]|0;if((s<<24>>24<0?c[z+4>>2]|0:s&255)|0?(y=c[v>>2]|0,(y-u|0)<160):0){w=c[w>>2]|0;c[v>>2]=y+4;c[y>>2]=w}y=Em(g,c[t>>2]|0,h,x)|0;c[i>>2]=y;c[i+4>>2]=D;wm(z,u,c[v>>2]|0,h);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[f>>2]=0;C=41;break}if(!b)C=42}else C=41;while(0);if((C|0)==41?b:0)C=42;if((C|0)==42)c[h>>2]=c[h>>2]|2;C=c[e>>2]|0;Mt(A);Mt(z);l=B;return C|0}function Cm(a){a=a|0;switch(c[a+4>>2]&74){case 64:{a=8;break}case 8:{a=16;break}case 0:{a=0;break}default:a=10}return a|0}function Dm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=l;l=l+16|0;h=g;d=Sk(d)|0;c[h>>2]=d;i=lm(h,1165628)|0;lb[c[(c[i>>2]|0)+32>>2]&7](i,25554,25580,e)|0;e=lm(h,1165644)|0;a[f>>0]=hb[c[(c[e>>2]|0)+16>>2]&127](e)|0;eb[c[(c[e>>2]|0)+20>>2]&63](b,e);vt(d)|0;l=g;return}function Em(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;h=k;do if((b|0)==(d|0)){c[e>>2]=4;f=0;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;f=0;b=0;break}i=Oh()|0;j=c[i>>2]|0;c[i>>2]=0;b=yj(b,h,f,nm()|0)|0;f=D;g=c[i>>2]|0;if(!g)c[i>>2]=j;if((c[h>>2]|0)==(d|0)){if((g|0)==34){c[e>>2]=4;b=-1;f=-1}}else{c[e>>2]=4;b=0;f=0}}while(0);D=f;l=k;return b|0}function Fm(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+224|0;r=B+198|0;s=B+196|0;z=B+184|0;A=B+172|0;t=B+168|0;u=B+8|0;v=B+4|0;w=B;x=Cm(g)|0;Dm(z,g,r,s);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}p=A+11|0;q=A+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(A,b,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g;c[v>>2]=u;c[w>>2]=0;o=A+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;k=(b|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(k)break;else break a;if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;C=16;break}}else C=16;while(0);if((C|0)==16){C=0;if(k){j=0;break}else j=0}k=a[p>>0]|0;k=k<<24>>24<0?c[o>>2]|0:k&255;if((c[t>>2]|0)==(g+k|0)){St(A,k<<1,0);if((a[p>>0]|0)<0)g=(c[q>>2]&2147483647)+-1|0;else g=10;St(A,g,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g+k}m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=d[k>>0]|0;if(mm(k&255,x,g,t,w,a[s>>0]|0,z,u,v,r)|0)break;j=c[m>>2]|0;if((j|0)==(c[n>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[m>>2]=j+1;continue}}s=a[z+11>>0]|0;if((s<<24>>24<0?c[z+4>>2]|0:s&255)|0?(y=c[v>>2]|0,(y-u|0)<160):0){w=c[w>>2]|0;c[v>>2]=y+4;c[y>>2]=w}c[i>>2]=Gm(g,c[t>>2]|0,h,x)|0;wm(z,u,c[v>>2]|0,h);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[f>>2]=0;C=41;break}if(!b)C=42}else C=41;while(0);if((C|0)==41?b:0)C=42;if((C|0)==42)c[h>>2]=c[h>>2]|2;C=c[e>>2]|0;Mt(A);Mt(z);l=B;return C|0}function Gm(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;h=k;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}i=Oh()|0;j=c[i>>2]|0;c[i>>2]=0;b=yj(b,h,f,nm()|0)|0;f=D;g=c[i>>2]|0;if(!g)c[i>>2]=j;do if((c[h>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>4294967295|(g|0)==34){c[e>>2]=4;b=-1;break}else break;else{c[e>>2]=4;b=0}while(0)}while(0);l=k;return b|0}function Hm(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+224|0;r=B+198|0;s=B+196|0;z=B+184|0;A=B+172|0;t=B+168|0;u=B+8|0;v=B+4|0;w=B;x=Cm(g)|0;Dm(z,g,r,s);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}p=A+11|0;q=A+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(A,b,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g;c[v>>2]=u;c[w>>2]=0;o=A+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;k=(b|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(k)break;else break a;if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;C=16;break}}else C=16;while(0);if((C|0)==16){C=0;if(k){j=0;break}else j=0}k=a[p>>0]|0;k=k<<24>>24<0?c[o>>2]|0:k&255;if((c[t>>2]|0)==(g+k|0)){St(A,k<<1,0);if((a[p>>0]|0)<0)g=(c[q>>2]&2147483647)+-1|0;else g=10;St(A,g,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g+k}m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=d[k>>0]|0;if(mm(k&255,x,g,t,w,a[s>>0]|0,z,u,v,r)|0)break;j=c[m>>2]|0;if((j|0)==(c[n>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[m>>2]=j+1;continue}}s=a[z+11>>0]|0;if((s<<24>>24<0?c[z+4>>2]|0:s&255)|0?(y=c[v>>2]|0,(y-u|0)<160):0){w=c[w>>2]|0;c[v>>2]=y+4;c[y>>2]=w}c[i>>2]=Im(g,c[t>>2]|0,h,x)|0;wm(z,u,c[v>>2]|0,h);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[f>>2]=0;C=41;break}if(!b)C=42}else C=41;while(0);if((C|0)==41?b:0)C=42;if((C|0)==42)c[h>>2]=c[h>>2]|2;C=c[e>>2]|0;Mt(A);Mt(z);l=B;return C|0}function Im(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;h=k;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}i=Oh()|0;j=c[i>>2]|0;c[i>>2]=0;b=yj(b,h,f,nm()|0)|0;f=D;g=c[i>>2]|0;if(!g)c[i>>2]=j;do if((c[h>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>4294967295|(g|0)==34){c[e>>2]=4;b=-1;break}else break;else{c[e>>2]=4;b=0}while(0)}while(0);l=k;return b|0}function Jm(e,f,g,h,i,j){e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;C=l;l=l+224|0;s=C+198|0;t=C+196|0;A=C+184|0;B=C+172|0;u=C+168|0;v=C+8|0;w=C+4|0;x=C;y=Cm(h)|0;Dm(A,h,s,t);c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[B+(e<<2)>>2]=0;e=e+1|0}q=B+11|0;r=B+8|0;if((a[q>>0]|0)<0)e=(c[r>>2]&2147483647)+-1|0;else e=10;St(B,e,0);h=(a[q>>0]|0)<0?c[B>>2]|0:B;c[u>>2]=h;c[w>>2]=v;c[x>>2]=0;p=B+4|0;e=c[f>>2]|0;a:while(1){if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(hb[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;m=(e|0)==0;k=c[g>>2]|0;do if(k){if((c[k+12>>2]|0)!=(c[k+16>>2]|0))if(m)break;else break a;if((hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)!=-1)if(m)break;else break a;else{c[g>>2]=0;D=16;break}}else D=16;while(0);if((D|0)==16){D=0;if(m){k=0;break}else k=0}m=a[q>>0]|0;m=m<<24>>24<0?c[p>>2]|0:m&255;if((c[u>>2]|0)==(h+m|0)){St(B,m<<1,0);if((a[q>>0]|0)<0)h=(c[r>>2]&2147483647)+-1|0;else h=10;St(B,h,0);h=(a[q>>0]|0)<0?c[B>>2]|0:B;c[u>>2]=h+m}n=e+12|0;m=c[n>>2]|0;o=e+16|0;if((m|0)==(c[o>>2]|0))m=hb[c[(c[e>>2]|0)+36>>2]&127](e)|0;else m=d[m>>0]|0;if(mm(m&255,y,h,u,x,a[t>>0]|0,A,v,w,s)|0)break;k=c[n>>2]|0;if((k|0)==(c[o>>2]|0)){hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;continue}else{c[n>>2]=k+1;continue}}t=a[A+11>>0]|0;if((t<<24>>24<0?c[A+4>>2]|0:t&255)|0?(z=c[w>>2]|0,(z-v|0)<160):0){x=c[x>>2]|0;c[w>>2]=z+4;c[z>>2]=x}b[j>>1]=Km(h,c[u>>2]|0,i,y)|0;wm(A,v,c[w>>2]|0,i);if(e){if((c[e+12>>2]|0)==(c[e+16>>2]|0)?(hb[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1:0){c[f>>2]=0;e=0}}else e=0;e=(e|0)==0;do if(k){if((c[k+12>>2]|0)==(c[k+16>>2]|0)?(hb[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1:0){c[g>>2]=0;D=41;break}if(!e)D=42}else D=41;while(0);if((D|0)==41?e:0)D=42;if((D|0)==42)c[i>>2]=c[i>>2]|2;D=c[f>>2]|0;Mt(B);Mt(A);l=C;return D|0}function Km(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;h=k;do if((b|0)==(d|0)){c[e>>2]=4;b=0}else{if((a[b>>0]|0)==45){c[e>>2]=4;b=0;break}i=Oh()|0;j=c[i>>2]|0;c[i>>2]=0;b=yj(b,h,f,nm()|0)|0;f=D;g=c[i>>2]|0;if(!g)c[i>>2]=j;do if((c[h>>2]|0)==(d|0))if(f>>>0>0|(f|0)==0&b>>>0>65535|(g|0)==34){c[e>>2]=4;b=-1;break}else{b=b&65535;break}else{c[e>>2]=4;b=0}while(0)}while(0);l=k;return b|0}function Lm(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+224|0;r=B+198|0;s=B+196|0;z=B+184|0;A=B+172|0;t=B+168|0;u=B+8|0;v=B+4|0;w=B;x=Cm(g)|0;Dm(z,g,r,s);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}p=A+11|0;q=A+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(A,b,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g;c[v>>2]=u;c[w>>2]=0;o=A+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;k=(b|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(k)break;else break a;if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;C=16;break}}else C=16;while(0);if((C|0)==16){C=0;if(k){j=0;break}else j=0}k=a[p>>0]|0;k=k<<24>>24<0?c[o>>2]|0:k&255;if((c[t>>2]|0)==(g+k|0)){St(A,k<<1,0);if((a[p>>0]|0)<0)g=(c[q>>2]&2147483647)+-1|0;else g=10;St(A,g,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g+k}m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=d[k>>0]|0;if(mm(k&255,x,g,t,w,a[s>>0]|0,z,u,v,r)|0)break;j=c[m>>2]|0;if((j|0)==(c[n>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[m>>2]=j+1;continue}}s=a[z+11>>0]|0;if((s<<24>>24<0?c[z+4>>2]|0:s&255)|0?(y=c[v>>2]|0,(y-u|0)<160):0){w=c[w>>2]|0;c[v>>2]=y+4;c[y>>2]=w}y=Mm(g,c[t>>2]|0,h,x)|0;c[i>>2]=y;c[i+4>>2]=D;wm(z,u,c[v>>2]|0,h);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[f>>2]=0;C=41;break}if(!b)C=42}else C=41;while(0);if((C|0)==41?b:0)C=42;if((C|0)==42)c[h>>2]=c[h>>2]|2;C=c[e>>2]|0;Mt(A);Mt(z);l=B;return C|0}function Mm(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;if((a|0)==(b|0)){c[d>>2]=4;e=0;a=0}else{h=Oh()|0;i=c[h>>2]|0;c[h>>2]=0;a=zj(a,g,e,nm()|0)|0;e=D;f=c[h>>2]|0;if(!f)c[h>>2]=i;if((c[g>>2]|0)==(b|0)){if((f|0)==34){c[d>>2]=4;e=(e|0)>0|(e|0)==0&a>>>0>0;a=e?-1:0;e=e?2147483647:-2147483648}}else{c[d>>2]=4;a=0;e=0}}D=e;l=j;return a|0}function Nm(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+224|0;r=B+198|0;s=B+196|0;z=B+184|0;A=B+172|0;t=B+168|0;u=B+8|0;v=B+4|0;w=B;x=Cm(g)|0;Dm(z,g,r,s);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[A+(b<<2)>>2]=0;b=b+1|0}p=A+11|0;q=A+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(A,b,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g;c[v>>2]=u;c[w>>2]=0;o=A+4|0;b=c[e>>2]|0;a:while(1){if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;k=(b|0)==0;j=c[f>>2]|0;do if(j){if((c[j+12>>2]|0)!=(c[j+16>>2]|0))if(k)break;else break a;if((hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;C=16;break}}else C=16;while(0);if((C|0)==16){C=0;if(k){j=0;break}else j=0}k=a[p>>0]|0;k=k<<24>>24<0?c[o>>2]|0:k&255;if((c[t>>2]|0)==(g+k|0)){St(A,k<<1,0);if((a[p>>0]|0)<0)g=(c[q>>2]&2147483647)+-1|0;else g=10;St(A,g,0);g=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=g+k}m=b+12|0;k=c[m>>2]|0;n=b+16|0;if((k|0)==(c[n>>2]|0))k=hb[c[(c[b>>2]|0)+36>>2]&127](b)|0;else k=d[k>>0]|0;if(mm(k&255,x,g,t,w,a[s>>0]|0,z,u,v,r)|0)break;j=c[m>>2]|0;if((j|0)==(c[n>>2]|0)){hb[c[(c[b>>2]|0)+40>>2]&127](b)|0;continue}else{c[m>>2]=j+1;continue}}s=a[z+11>>0]|0;if((s<<24>>24<0?c[z+4>>2]|0:s&255)|0?(y=c[v>>2]|0,(y-u|0)<160):0){w=c[w>>2]|0;c[v>>2]=y+4;c[y>>2]=w}c[i>>2]=Om(g,c[t>>2]|0,h,x)|0;wm(z,u,c[v>>2]|0,h);if(b){if((c[b+12>>2]|0)==(c[b+16>>2]|0)?(hb[c[(c[b>>2]|0)+36>>2]&127](b)|0)==-1:0){c[e>>2]=0;b=0}}else b=0;b=(b|0)==0;do if(j){if((c[j+12>>2]|0)==(c[j+16>>2]|0)?(hb[c[(c[j>>2]|0)+36>>2]&127](j)|0)==-1:0){c[f>>2]=0;C=41;break}if(!b)C=42}else C=41;while(0);if((C|0)==41?b:0)C=42;if((C|0)==42)c[h>>2]=c[h>>2]|2;C=c[e>>2]|0;Mt(A);Mt(z);l=B;return C|0}function Om(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;if((a|0)==(b|0)){c[d>>2]=4;a=0}else{h=Oh()|0;i=c[h>>2]|0;c[h>>2]=0;a=zj(a,g,e,nm()|0)|0;e=D;f=c[h>>2]|0;if(!f)c[h>>2]=i;a:do if((c[g>>2]|0)==(b|0)){do if((f|0)==34){c[d>>2]=4;if((e|0)>0|(e|0)==0&a>>>0>0){a=2147483647;break a}}else{if((e|0)<-1|(e|0)==-1&a>>>0<2147483648){c[d>>2]=4;break}if((e|0)>0|(e|0)==0&a>>>0>2147483647){c[d>>2]=4;a=2147483647;break a}else break a}while(0);a=-2147483648}else{c[d>>2]=4;a=0}while(0)}l=j;return a|0}function Pm(b,e,f,g,h,i,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;y=l;l=l+112|0;k=y;n=(g-f|0)/12|0;if(n>>>0>100){m=Fj(n)|0;if(!m){k=0;w=0}else{k=m;w=m}}else w=0;p=f;q=k;m=0;while(1){if((p|0)==(g|0))break;o=a[p+11>>0]|0;if(o<<24>>24<0)o=c[p+4>>2]|0;else o=o&255;if(!o){a[q>>0]=2;n=n+-1|0;m=m+1|0}else a[q>>0]=1;p=p+12|0;q=q+1|0}v=0;r=m;a:while(1){m=c[b>>2]|0;do if(m){if((c[m+12>>2]|0)==(c[m+16>>2]|0))if((hb[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1){c[b>>2]=0;m=0;break}else{m=c[b>>2]|0;break}}else m=0;while(0);o=(m|0)==0;m=c[e>>2]|0;if(m)if((c[m+12>>2]|0)==(c[m+16>>2]|0)?(hb[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1:0){c[e>>2]=0;p=0}else p=m;else p=0;q=(p|0)==0;m=c[b>>2]|0;if(!((n|0)!=0&(o^q)))break;o=c[m+12>>2]|0;if((o|0)==(c[m+16>>2]|0))m=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else m=d[o>>0]|0;m=m&255;if(!j)m=nb[c[(c[h>>2]|0)+12>>2]&63](h,m)|0;u=v+1|0;s=f;q=0;t=k;while(1){if((s|0)==(g|0))break;do if((a[t>>0]|0)==1){p=s+11|0;if((a[p>>0]|0)<0)o=c[s>>2]|0;else o=s;o=a[o+v>>0]|0;if(!j)o=nb[c[(c[h>>2]|0)+12>>2]&63](h,o)|0;if(m<<24>>24!=o<<24>>24){a[t>>0]=0;o=q;p=r;n=n+-1|0;break}o=a[p>>0]|0;if(o<<24>>24<0)o=c[s+4>>2]|0;else o=o&255;if((o|0)==(u|0)){a[t>>0]=2;o=1;p=r+1|0;n=n+-1|0}else{o=1;p=r}}else{o=q;p=r}while(0);s=s+12|0;q=o;t=t+1|0;r=p}if(!q){v=u;continue}m=c[b>>2]|0;o=m+12|0;p=c[o>>2]|0;if((p|0)==(c[m+16>>2]|0))hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;else c[o>>2]=p+1;if((r+n|0)>>>0>1){p=f;q=k;m=r}else{v=u;continue}while(1){if((p|0)==(g|0)){v=u;r=m;continue a}if((a[q>>0]|0)==2){o=a[p+11>>0]|0;if(o<<24>>24<0)o=c[p+4>>2]|0;else o=o&255;if((o|0)!=(u|0)){a[q>>0]=0;m=m+-1|0}}p=p+12|0;q=q+1|0}}do if(m){if((c[m+12>>2]|0)==(c[m+16>>2]|0))if((hb[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1){c[b>>2]=0;m=0;break}else{m=c[b>>2]|0;break}}else m=0;while(0);m=(m|0)==0;do if(!q){if((c[p+12>>2]|0)==(c[p+16>>2]|0)?(hb[c[(c[p>>2]|0)+36>>2]&127](p)|0)==-1:0){c[e>>2]=0;x=34;break}if(!m)x=69}else x=34;while(0);if((x|0)==34)if(m)x=69;if((x|0)==69)c[i>>2]=c[i>>2]|2;while(1){if((f|0)==(g|0)){x=73;break}if((a[k>>0]|0)==2)break;f=f+12|0;k=k+1|0}if((x|0)==73){c[i>>2]=c[i>>2]|4;f=g}Gj(w);l=y;return f|0}function Qm(a){a=a|0;return}function Rm(a){a=a|0;Dt(a);return}function Sm(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+48|0;i=p+40|0;o=p+16|0;j=p+8|0;k=p+12|0;m=p+4|0;n=p;if(!(c[f+4>>2]&1)){c[j>>2]=-1;n=c[(c[b>>2]|0)+16>>2]|0;c[k>>2]=c[d>>2];c[m>>2]=c[e>>2];c[o>>2]=c[k>>2];c[i>>2]=c[m>>2];c[d>>2]=fb[n&63](b,o,i,f,g,j)|0;switch(c[j>>2]|0){case 0:{a[h>>0]=0;break}case 1:{a[h>>0]=1;break}default:{a[h>>0]=1;c[g>>2]=4}}i=c[d>>2]|0}else{k=Sk(f)|0;c[i>>2]=k;m=lm(i,1165660)|0;vt(k)|0;k=Sk(f)|0;c[i>>2]=k;b=lm(i,1165668)|0;vt(k)|0;eb[c[(c[b>>2]|0)+24>>2]&63](o,b);eb[c[(c[b>>2]|0)+28>>2]&63](o+12|0,b);c[n>>2]=c[e>>2];b=o+24|0;c[i>>2]=c[n>>2];a[h>>0]=(pn(d,i,o,b,m,g,1)|0)==(o|0)&1;i=c[d>>2]|0;do{b=b+-12|0;fu(b)}while((b|0)!=(o|0))}l=p;return i|0}function Tm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=on(a,j,i,e,f,g)|0;l=h;return g|0}function Um(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=nn(a,j,i,e,f,g)|0;l=h;return g|0}function Vm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=mn(a,j,i,e,f,g)|0;l=h;return g|0}function Wm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=ln(a,j,i,e,f,g)|0;l=h;return g|0}function Xm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=kn(a,j,i,e,f,g)|0;l=h;return g|0}function Ym(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=hn(a,j,i,e,f,g)|0;l=h;return g|0}function Zm(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=gn(a,j,i,e,f,g)|0;l=h;return g|0}function _m(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=fn(a,j,i,e,f,g)|0;l=h;return g|0}function $m(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;h=l;l=l+16|0;i=h+12|0;j=h+8|0;m=h+4|0;k=h;c[m>>2]=c[b>>2];c[k>>2]=c[d>>2];c[j>>2]=c[m>>2];c[i>>2]=c[k>>2];g=cn(a,j,i,e,f,g)|0;l=h;return g|0}function an(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;y=l;l=l+320|0;v=y;t=y+208|0;w=y+192|0;x=y+180|0;u=y+176|0;q=y+16|0;r=y+8|0;s=y+4|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[w+(b<<2)>>2]=0;b=b+1|0}b=Sk(f)|0;c[x>>2]=b;p=lm(x,1165660)|0;lb[c[(c[p>>2]|0)+48>>2]&7](p,25554,25580,t)|0;vt(b)|0;c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[x+(b<<2)>>2]=0;b=b+1|0}p=x+11|0;o=x+8|0;if((a[p>>0]|0)<0)b=(c[o>>2]&2147483647)+-1|0;else b=10;St(x,b,0);b=(a[p>>0]|0)<0?c[x>>2]|0:x;c[u>>2]=b;c[r>>2]=q;c[s>>2]=0;n=x+4|0;i=c[d>>2]|0;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;m=0;j=1}else{m=i;j=0}}else{m=0;j=1}i=c[e>>2]|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(j)break;else break a;else{c[e>>2]=0;z=22;break}}else z=22;while(0);if((z|0)==22){z=0;if(j){i=0;break}else i=0}f=a[p>>0]|0;f=f<<24>>24<0?c[n>>2]|0:f&255;if((c[u>>2]|0)==(b+f|0)){St(x,f<<1,0);if((a[p>>0]|0)<0)b=(c[o>>2]&2147483647)+-1|0;else b=10;St(x,b,0);b=(a[p>>0]|0)<0?c[x>>2]|0:x;c[u>>2]=b+f}j=m+12|0;f=c[j>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0))f=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else f=c[f>>2]|0;if(bn(f,16,b,u,s,0,w,q,r,t)|0)break;f=c[j>>2]|0;if((f|0)==(c[k>>2]|0)){hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;i=m;continue}else{c[j>>2]=f+4;i=m;continue}}St(x,(c[u>>2]|0)-b|0,0);t=(a[p>>0]|0)<0?c[x>>2]|0:x;u=nm()|0;c[v>>2]=h;if((om(t,u,25587,v)|0)!=1)c[g>>2]=4;if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))b=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{z=51;break}else{c[e>>2]=0;z=49;break}}else z=49;while(0);if((z|0)==49?f:0)z=51;if((z|0)==51)c[g>>2]=c[g>>2]|2;z=c[d>>2]|0;Mt(x);Mt(w);l=y;return z|0}function bn(b,d,e,f,g,h,i,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0;o=c[f>>2]|0;p=(o|0)==(e|0);do if(p){m=(c[l+96>>2]|0)==(b|0);if(!m?(c[l+100>>2]|0)!=(b|0):0){n=5;break}c[f>>2]=e+1;a[e>>0]=m?43:45;c[g>>2]=0;m=0}else n=5;while(0);a:do if((n|0)==5){n=a[i+11>>0]|0;if((b|0)==(h|0)?((n<<24>>24<0?c[i+4>>2]|0:n&255)|0)!=0:0){m=c[k>>2]|0;if((m-j|0)>=160){m=0;break}f=c[g>>2]|0;c[k>>2]=m+4;c[m>>2]=f;c[g>>2]=0;m=0;break}i=l+104|0;h=0;while(1){m=l+(h<<2)|0;if((h|0)==26){m=i;break}if((c[m>>2]|0)==(b|0))break;else h=h+1|0}m=m-l|0;h=m>>2;if((m|0)>92)m=-1;else{switch(d|0){case 10:case 8:{if((h|0)>=(d|0)){m=-1;break a}break}case 16:{if((m|0)>=88){if(p){m=-1;break a}if((o-e|0)>=3){m=-1;break a}if((a[o+-1>>0]|0)!=48){m=-1;break a}c[g>>2]=0;m=a[25554+h>>0]|0;c[f>>2]=o+1;a[o>>0]=m;m=0;break a}break}default:{}}m=a[25554+h>>0]|0;c[f>>2]=o+1;a[o>>0]=m;c[g>>2]=(c[g>>2]|0)+1;m=0}}while(0);return m|0}function cn(b,d,e,f,g,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=l;l=l+352|0;s=D+208|0;t=D+200|0;u=D+196|0;C=D+184|0;B=D+172|0;v=D+168|0;w=D+8|0;x=D+4|0;y=D;z=D+337|0;r=D+336|0;dn(C,f,s,t,u);c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}p=B+11|0;q=B+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(B,b,0);b=(a[p>>0]|0)<0?c[B>>2]|0:B;c[v>>2]=b;c[x>>2]=w;c[y>>2]=0;a[z>>0]=1;a[r>>0]=69;o=B+4|0;j=c[d>>2]|0;a:while(1){if(j){f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;n=0;k=1}else{n=j;k=0}}else{n=0;k=1}j=c[e>>2]|0;do if(j){f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(k)break;else break a;else{c[e>>2]=0;E=19;break}}else E=19;while(0);if((E|0)==19){E=0;if(k){j=0;break}else j=0}f=a[p>>0]|0;f=f<<24>>24<0?c[o>>2]|0:f&255;if((c[v>>2]|0)==(b+f|0)){St(B,f<<1,0);if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(B,b,0);b=(a[p>>0]|0)<0?c[B>>2]|0:B;c[v>>2]=b+f}k=n+12|0;f=c[k>>2]|0;m=n+16|0;if((f|0)==(c[m>>2]|0))f=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else f=c[f>>2]|0;if(en(f,z,r,b,v,c[t>>2]|0,c[u>>2]|0,C,w,x,y,s)|0)break;f=c[k>>2]|0;if((f|0)==(c[m>>2]|0)){hb[c[(c[n>>2]|0)+40>>2]&127](n)|0;j=n;continue}else{c[k>>2]=f+4;j=n;continue}}u=a[C+11>>0]|0;if(!((a[z>>0]|0)==0?1:((u<<24>>24<0?c[C+4>>2]|0:u&255)|0)==0)?(A=c[x>>2]|0,(A-w|0)<160):0){z=c[y>>2]|0;c[x>>2]=A+4;c[A>>2]=z}h[i>>3]=+vm(b,c[v>>2]|0,g);wm(C,w,c[x>>2]|0,g);if(n){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))b=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0))b=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{E=49;break}else{c[e>>2]=0;E=47;break}}else E=47;while(0);if((E|0)==47?f:0)E=49;if((E|0)==49)c[g>>2]=c[g>>2]|2;E=c[d>>2]|0;Mt(B);Mt(C);l=D;return E|0}function dn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;g=l;l=l+16|0;h=g;b=Sk(b)|0;c[h>>2]=b;i=lm(h,1165660)|0;lb[c[(c[i>>2]|0)+48>>2]&7](i,25554,25586,d)|0;d=lm(h,1165668)|0;c[e>>2]=hb[c[(c[d>>2]|0)+12>>2]&127](d)|0;c[f>>2]=hb[c[(c[d>>2]|0)+16>>2]&127](d)|0;eb[c[(c[d>>2]|0)+20>>2]&63](a,d);vt(b)|0;l=g;return}function en(b,e,f,g,h,i,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0;a:do if((b|0)==(i|0))if(a[e>>0]|0){a[e>>0]=0;f=c[h>>2]|0;c[h>>2]=f+1;a[f>>0]=46;h=a[k+11>>0]|0;if(((h<<24>>24<0?c[k+4>>2]|0:h&255)|0)!=0?(p=c[m>>2]|0,(p-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;p=0}else p=0}else p=-1;else{if((b|0)==(j|0)?(j=a[k+11>>0]|0,(j<<24>>24<0?c[k+4>>2]|0:j&255)|0):0){if(!(a[e>>0]|0)){p=-1;break}p=c[m>>2]|0;if((p-l|0)>=160){p=0;break}l=c[n>>2]|0;c[m>>2]=p+4;c[p>>2]=l;c[n>>2]=0;p=0;break}j=o+128|0;i=0;while(1){p=o+(i<<2)|0;if((i|0)==32){p=j;break}if((c[p>>2]|0)==(b|0))break;else i=i+1|0}i=p-o|0;p=i>>2;if((i|0)<=124){j=a[25554+p>>0]|0;switch(p|0){case 24:case 25:{p=c[h>>2]|0;if((p|0)!=(g|0)?(d[p+-1>>0]&95|0)!=(d[f>>0]&127|0):0){p=-1;break a}c[h>>2]=p+1;a[p>>0]=j;p=0;break a}case 23:case 22:{a[f>>0]=80;break}default:{p=j&95;if((((p|0)==(a[f>>0]|0)?(a[f>>0]=p|128,a[e>>0]|0):0)?(a[e>>0]=0,f=a[k+11>>0]|0,(f<<24>>24<0?c[k+4>>2]|0:f&255)|0):0)?(q=c[m>>2]|0,(q-l|0)<160):0){l=c[n>>2]|0;c[m>>2]=q+4;c[q>>2]=l}}}m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=j;if((i|0)>84)p=0;else{c[n>>2]=(c[n>>2]|0)+1;p=0}}else p=-1}while(0);return p|0}function fn(b,d,e,f,g,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=l;l=l+352|0;s=D+208|0;t=D+200|0;u=D+196|0;C=D+184|0;B=D+172|0;v=D+168|0;w=D+8|0;x=D+4|0;y=D;z=D+337|0;r=D+336|0;dn(C,f,s,t,u);c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}p=B+11|0;q=B+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(B,b,0);b=(a[p>>0]|0)<0?c[B>>2]|0:B;c[v>>2]=b;c[x>>2]=w;c[y>>2]=0;a[z>>0]=1;a[r>>0]=69;o=B+4|0;j=c[d>>2]|0;a:while(1){if(j){f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;n=0;k=1}else{n=j;k=0}}else{n=0;k=1}j=c[e>>2]|0;do if(j){f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(k)break;else break a;else{c[e>>2]=0;E=19;break}}else E=19;while(0);if((E|0)==19){E=0;if(k){j=0;break}else j=0}f=a[p>>0]|0;f=f<<24>>24<0?c[o>>2]|0:f&255;if((c[v>>2]|0)==(b+f|0)){St(B,f<<1,0);if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(B,b,0);b=(a[p>>0]|0)<0?c[B>>2]|0:B;c[v>>2]=b+f}k=n+12|0;f=c[k>>2]|0;m=n+16|0;if((f|0)==(c[m>>2]|0))f=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else f=c[f>>2]|0;if(en(f,z,r,b,v,c[t>>2]|0,c[u>>2]|0,C,w,x,y,s)|0)break;f=c[k>>2]|0;if((f|0)==(c[m>>2]|0)){hb[c[(c[n>>2]|0)+40>>2]&127](n)|0;j=n;continue}else{c[k>>2]=f+4;j=n;continue}}u=a[C+11>>0]|0;if(!((a[z>>0]|0)==0?1:((u<<24>>24<0?c[C+4>>2]|0:u&255)|0)==0)?(A=c[x>>2]|0,(A-w|0)<160):0){z=c[y>>2]|0;c[x>>2]=A+4;c[A>>2]=z}h[i>>3]=+ym(b,c[v>>2]|0,g);wm(C,w,c[x>>2]|0,g);if(n){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))b=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0))b=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{E=49;break}else{c[e>>2]=0;E=47;break}}else E=47;while(0);if((E|0)==47?f:0)E=49;if((E|0)==49)c[g>>2]=c[g>>2]|2;E=c[d>>2]|0;Mt(B);Mt(C);l=D;return E|0}function gn(b,d,e,f,h,i){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;D=l;l=l+352|0;s=D+208|0;t=D+200|0;u=D+196|0;C=D+184|0;B=D+172|0;v=D+168|0;w=D+8|0;x=D+4|0;y=D;z=D+337|0;r=D+336|0;dn(C,f,s,t,u);c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[B+(b<<2)>>2]=0;b=b+1|0}p=B+11|0;q=B+8|0;if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(B,b,0);b=(a[p>>0]|0)<0?c[B>>2]|0:B;c[v>>2]=b;c[x>>2]=w;c[y>>2]=0;a[z>>0]=1;a[r>>0]=69;o=B+4|0;j=c[d>>2]|0;a:while(1){if(j){f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;n=0;k=1}else{n=j;k=0}}else{n=0;k=1}j=c[e>>2]|0;do if(j){f=c[j+12>>2]|0;if((f|0)==(c[j+16>>2]|0))f=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(k)break;else break a;else{c[e>>2]=0;E=19;break}}else E=19;while(0);if((E|0)==19){E=0;if(k){j=0;break}else j=0}f=a[p>>0]|0;f=f<<24>>24<0?c[o>>2]|0:f&255;if((c[v>>2]|0)==(b+f|0)){St(B,f<<1,0);if((a[p>>0]|0)<0)b=(c[q>>2]&2147483647)+-1|0;else b=10;St(B,b,0);b=(a[p>>0]|0)<0?c[B>>2]|0:B;c[v>>2]=b+f}k=n+12|0;f=c[k>>2]|0;m=n+16|0;if((f|0)==(c[m>>2]|0))f=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else f=c[f>>2]|0;if(en(f,z,r,b,v,c[t>>2]|0,c[u>>2]|0,C,w,x,y,s)|0)break;f=c[k>>2]|0;if((f|0)==(c[m>>2]|0)){hb[c[(c[n>>2]|0)+40>>2]&127](n)|0;j=n;continue}else{c[k>>2]=f+4;j=n;continue}}u=a[C+11>>0]|0;if(!((a[z>>0]|0)==0?1:((u<<24>>24<0?c[C+4>>2]|0:u&255)|0)==0)?(A=c[x>>2]|0,(A-w|0)<160):0){z=c[y>>2]|0;c[x>>2]=A+4;c[A>>2]=z}g[i>>2]=+Am(b,c[v>>2]|0,h);wm(C,w,c[x>>2]|0,h);if(n){b=c[n+12>>2]|0;if((b|0)==(c[n+16>>2]|0))b=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(j){b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0))b=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{E=49;break}else{c[e>>2]=0;E=47;break}}else E=47;while(0);if((E|0)==47?f:0)E=49;if((E|0)==49)c[h>>2]=c[h>>2]|2;E=c[d>>2]|0;Mt(B);Mt(C);l=D;return E|0}function hn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+304|0;q=A+200|0;r=A+196|0;y=A+184|0;z=A+172|0;s=A+168|0;t=A+8|0;u=A+4|0;v=A;w=Cm(f)|0;jn(y,f,q,r);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}o=z+11|0;p=z+8|0;if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b;c[u>>2]=t;c[v>>2]=0;n=z+4|0;i=c[d>>2]|0;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;m=0;j=1}else{m=i;j=0}}else{m=0;j=1}i=c[e>>2]|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(j)break;else break a;else{c[e>>2]=0;B=19;break}}else B=19;while(0);if((B|0)==19){B=0;if(j){i=0;break}else i=0}f=a[o>>0]|0;f=f<<24>>24<0?c[n>>2]|0:f&255;if((c[s>>2]|0)==(b+f|0)){St(z,f<<1,0);if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b+f}j=m+12|0;f=c[j>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0))f=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else f=c[f>>2]|0;if(bn(f,w,b,s,v,c[r>>2]|0,y,t,u,q)|0)break;f=c[j>>2]|0;if((f|0)==(c[k>>2]|0)){hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;i=m;continue}else{c[j>>2]=f+4;i=m;continue}}r=a[y+11>>0]|0;if((r<<24>>24<0?c[y+4>>2]|0:r&255)|0?(x=c[u>>2]|0,(x-t|0)<160):0){v=c[v>>2]|0;c[u>>2]=x+4;c[x>>2]=v}x=Em(b,c[s>>2]|0,g,w)|0;c[h>>2]=x;c[h+4>>2]=D;wm(y,t,c[u>>2]|0,g);if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))b=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{B=49;break}else{c[e>>2]=0;B=47;break}}else B=47;while(0);if((B|0)==47?f:0)B=49;if((B|0)==49)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;Mt(z);Mt(y);l=A;return B|0}function jn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=l;l=l+16|0;g=f;b=Sk(b)|0;c[g>>2]=b;h=lm(g,1165660)|0;lb[c[(c[h>>2]|0)+48>>2]&7](h,25554,25580,d)|0;d=lm(g,1165668)|0;c[e>>2]=hb[c[(c[d>>2]|0)+16>>2]&127](d)|0;eb[c[(c[d>>2]|0)+20>>2]&63](a,d);vt(b)|0;l=f;return}function kn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+304|0;q=A+200|0;r=A+196|0;y=A+184|0;z=A+172|0;s=A+168|0;t=A+8|0;u=A+4|0;v=A;w=Cm(f)|0;jn(y,f,q,r);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}o=z+11|0;p=z+8|0;if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b;c[u>>2]=t;c[v>>2]=0;n=z+4|0;i=c[d>>2]|0;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;m=0;j=1}else{m=i;j=0}}else{m=0;j=1}i=c[e>>2]|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(j)break;else break a;else{c[e>>2]=0;B=19;break}}else B=19;while(0);if((B|0)==19){B=0;if(j){i=0;break}else i=0}f=a[o>>0]|0;f=f<<24>>24<0?c[n>>2]|0:f&255;if((c[s>>2]|0)==(b+f|0)){St(z,f<<1,0);if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b+f}j=m+12|0;f=c[j>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0))f=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else f=c[f>>2]|0;if(bn(f,w,b,s,v,c[r>>2]|0,y,t,u,q)|0)break;f=c[j>>2]|0;if((f|0)==(c[k>>2]|0)){hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;i=m;continue}else{c[j>>2]=f+4;i=m;continue}}r=a[y+11>>0]|0;if((r<<24>>24<0?c[y+4>>2]|0:r&255)|0?(x=c[u>>2]|0,(x-t|0)<160):0){v=c[v>>2]|0;c[u>>2]=x+4;c[x>>2]=v}c[h>>2]=Gm(b,c[s>>2]|0,g,w)|0;wm(y,t,c[u>>2]|0,g);if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))b=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{B=49;break}else{c[e>>2]=0;B=47;break}}else B=47;while(0);if((B|0)==47?f:0)B=49;if((B|0)==49)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;Mt(z);Mt(y);l=A;return B|0}function ln(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+304|0;q=A+200|0;r=A+196|0;y=A+184|0;z=A+172|0;s=A+168|0;t=A+8|0;u=A+4|0;v=A;w=Cm(f)|0;jn(y,f,q,r);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}o=z+11|0;p=z+8|0;if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b;c[u>>2]=t;c[v>>2]=0;n=z+4|0;i=c[d>>2]|0;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;m=0;j=1}else{m=i;j=0}}else{m=0;j=1}i=c[e>>2]|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(j)break;else break a;else{c[e>>2]=0;B=19;break}}else B=19;while(0);if((B|0)==19){B=0;if(j){i=0;break}else i=0}f=a[o>>0]|0;f=f<<24>>24<0?c[n>>2]|0:f&255;if((c[s>>2]|0)==(b+f|0)){St(z,f<<1,0);if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b+f}j=m+12|0;f=c[j>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0))f=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else f=c[f>>2]|0;if(bn(f,w,b,s,v,c[r>>2]|0,y,t,u,q)|0)break;f=c[j>>2]|0;if((f|0)==(c[k>>2]|0)){hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;i=m;continue}else{c[j>>2]=f+4;i=m;continue}}r=a[y+11>>0]|0;if((r<<24>>24<0?c[y+4>>2]|0:r&255)|0?(x=c[u>>2]|0,(x-t|0)<160):0){v=c[v>>2]|0;c[u>>2]=x+4;c[x>>2]=v}c[h>>2]=Im(b,c[s>>2]|0,g,w)|0;wm(y,t,c[u>>2]|0,g);if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))b=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{B=49;break}else{c[e>>2]=0;B=47;break}}else B=47;while(0);if((B|0)==47?f:0)B=49;if((B|0)==49)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;Mt(z);Mt(y);l=A;return B|0}function mn(d,e,f,g,h,i){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;B=l;l=l+304|0;r=B+200|0;s=B+196|0;z=B+184|0;A=B+172|0;t=B+168|0;u=B+8|0;v=B+4|0;w=B;x=Cm(g)|0;jn(z,g,r,s);c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;d=0;while(1){if((d|0)==3)break;c[A+(d<<2)>>2]=0;d=d+1|0}p=A+11|0;q=A+8|0;if((a[p>>0]|0)<0)d=(c[q>>2]&2147483647)+-1|0;else d=10;St(A,d,0);d=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=d;c[v>>2]=u;c[w>>2]=0;o=A+4|0;j=c[e>>2]|0;a:while(1){if(j){g=c[j+12>>2]|0;if((g|0)==(c[j+16>>2]|0))g=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else g=c[g>>2]|0;if((g|0)==-1){c[e>>2]=0;n=0;k=1}else{n=j;k=0}}else{n=0;k=1}j=c[f>>2]|0;do if(j){g=c[j+12>>2]|0;if((g|0)==(c[j+16>>2]|0))g=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else g=c[g>>2]|0;if((g|0)!=-1)if(k)break;else break a;else{c[f>>2]=0;C=19;break}}else C=19;while(0);if((C|0)==19){C=0;if(k){j=0;break}else j=0}g=a[p>>0]|0;g=g<<24>>24<0?c[o>>2]|0:g&255;if((c[t>>2]|0)==(d+g|0)){St(A,g<<1,0);if((a[p>>0]|0)<0)d=(c[q>>2]&2147483647)+-1|0;else d=10;St(A,d,0);d=(a[p>>0]|0)<0?c[A>>2]|0:A;c[t>>2]=d+g}k=n+12|0;g=c[k>>2]|0;m=n+16|0;if((g|0)==(c[m>>2]|0))g=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else g=c[g>>2]|0;if(bn(g,x,d,t,w,c[s>>2]|0,z,u,v,r)|0)break;g=c[k>>2]|0;if((g|0)==(c[m>>2]|0)){hb[c[(c[n>>2]|0)+40>>2]&127](n)|0;j=n;continue}else{c[k>>2]=g+4;j=n;continue}}s=a[z+11>>0]|0;if((s<<24>>24<0?c[z+4>>2]|0:s&255)|0?(y=c[v>>2]|0,(y-u|0)<160):0){w=c[w>>2]|0;c[v>>2]=y+4;c[y>>2]=w}b[i>>1]=Km(d,c[t>>2]|0,h,x)|0;wm(z,u,c[v>>2]|0,h);if(n){d=c[n+12>>2]|0;if((d|0)==(c[n+16>>2]|0))d=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else d=c[d>>2]|0;if((d|0)==-1){c[e>>2]=0;g=1}else g=0}else g=1;do if(j){d=c[j+12>>2]|0;if((d|0)==(c[j+16>>2]|0))d=hb[c[(c[j>>2]|0)+36>>2]&127](j)|0;else d=c[d>>2]|0;if((d|0)!=-1)if(g)break;else{C=49;break}else{c[f>>2]=0;C=47;break}}else C=47;while(0);if((C|0)==47?g:0)C=49;if((C|0)==49)c[h>>2]=c[h>>2]|2;C=c[e>>2]|0;Mt(A);Mt(z);l=B;return C|0}function nn(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+304|0;q=A+200|0;r=A+196|0;y=A+184|0;z=A+172|0;s=A+168|0;t=A+8|0;u=A+4|0;v=A;w=Cm(f)|0;jn(y,f,q,r);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}o=z+11|0;p=z+8|0;if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b;c[u>>2]=t;c[v>>2]=0;n=z+4|0;i=c[d>>2]|0;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;m=0;j=1}else{m=i;j=0}}else{m=0;j=1}i=c[e>>2]|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(j)break;else break a;else{c[e>>2]=0;B=19;break}}else B=19;while(0);if((B|0)==19){B=0;if(j){i=0;break}else i=0}f=a[o>>0]|0;f=f<<24>>24<0?c[n>>2]|0:f&255;if((c[s>>2]|0)==(b+f|0)){St(z,f<<1,0);if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b+f}j=m+12|0;f=c[j>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0))f=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else f=c[f>>2]|0;if(bn(f,w,b,s,v,c[r>>2]|0,y,t,u,q)|0)break;f=c[j>>2]|0;if((f|0)==(c[k>>2]|0)){hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;i=m;continue}else{c[j>>2]=f+4;i=m;continue}}r=a[y+11>>0]|0;if((r<<24>>24<0?c[y+4>>2]|0:r&255)|0?(x=c[u>>2]|0,(x-t|0)<160):0){v=c[v>>2]|0;c[u>>2]=x+4;c[x>>2]=v}x=Mm(b,c[s>>2]|0,g,w)|0;c[h>>2]=x;c[h+4>>2]=D;wm(y,t,c[u>>2]|0,g);if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))b=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{B=49;break}else{c[e>>2]=0;B=47;break}}else B=47;while(0);if((B|0)==47?f:0)B=49;if((B|0)==49)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;Mt(z);Mt(y);l=A;return B|0}function on(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;A=l;l=l+304|0;q=A+200|0;r=A+196|0;y=A+184|0;z=A+172|0;s=A+168|0;t=A+8|0;u=A+4|0;v=A;w=Cm(f)|0;jn(y,f,q,r);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;b=0;while(1){if((b|0)==3)break;c[z+(b<<2)>>2]=0;b=b+1|0}o=z+11|0;p=z+8|0;if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b;c[u>>2]=t;c[v>>2]=0;n=z+4|0;i=c[d>>2]|0;a:while(1){if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)==-1){c[d>>2]=0;m=0;j=1}else{m=i;j=0}}else{m=0;j=1}i=c[e>>2]|0;do if(i){f=c[i+12>>2]|0;if((f|0)==(c[i+16>>2]|0))f=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else f=c[f>>2]|0;if((f|0)!=-1)if(j)break;else break a;else{c[e>>2]=0;B=19;break}}else B=19;while(0);if((B|0)==19){B=0;if(j){i=0;break}else i=0}f=a[o>>0]|0;f=f<<24>>24<0?c[n>>2]|0:f&255;if((c[s>>2]|0)==(b+f|0)){St(z,f<<1,0);if((a[o>>0]|0)<0)b=(c[p>>2]&2147483647)+-1|0;else b=10;St(z,b,0);b=(a[o>>0]|0)<0?c[z>>2]|0:z;c[s>>2]=b+f}j=m+12|0;f=c[j>>2]|0;k=m+16|0;if((f|0)==(c[k>>2]|0))f=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else f=c[f>>2]|0;if(bn(f,w,b,s,v,c[r>>2]|0,y,t,u,q)|0)break;f=c[j>>2]|0;if((f|0)==(c[k>>2]|0)){hb[c[(c[m>>2]|0)+40>>2]&127](m)|0;i=m;continue}else{c[j>>2]=f+4;i=m;continue}}r=a[y+11>>0]|0;if((r<<24>>24<0?c[y+4>>2]|0:r&255)|0?(x=c[u>>2]|0,(x-t|0)<160):0){v=c[v>>2]|0;c[u>>2]=x+4;c[x>>2]=v}c[h>>2]=Om(b,c[s>>2]|0,g,w)|0;wm(y,t,c[u>>2]|0,g);if(m){b=c[m+12>>2]|0;if((b|0)==(c[m+16>>2]|0))b=hb[c[(c[m>>2]|0)+36>>2]&127](m)|0;else b=c[b>>2]|0;if((b|0)==-1){c[d>>2]=0;f=1}else f=0}else f=1;do if(i){b=c[i+12>>2]|0;if((b|0)==(c[i+16>>2]|0))b=hb[c[(c[i>>2]|0)+36>>2]&127](i)|0;else b=c[b>>2]|0;if((b|0)!=-1)if(f)break;else{B=49;break}else{c[e>>2]=0;B=47;break}}else B=47;while(0);if((B|0)==47?f:0)B=49;if((B|0)==49)c[g>>2]=c[g>>2]|2;B=c[d>>2]|0;Mt(z);Mt(y);l=A;return B|0}function pn(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+112|0;j=x;m=(f-e|0)/12|0;if(m>>>0>100){k=Fj(m)|0;if(!k){j=0;v=0}else{j=k;v=k}}else v=0;k=0;o=e;p=j;while(1){if((o|0)==(f|0))break;n=a[o+8+3>>0]|0;if(n<<24>>24<0)n=c[o+4>>2]|0;else n=n&255;if(!n){a[p>>0]=2;k=k+1|0;m=m+-1|0}else a[p>>0]=1;o=o+12|0;p=p+1|0}u=0;s=k;a:while(1){k=c[b>>2]|0;do if(k){n=c[k+12>>2]|0;if((n|0)==(c[k+16>>2]|0))k=hb[c[(c[k>>2]|0)+36>>2]&127](k)|0;else k=c[n>>2]|0;if((k|0)==-1){c[b>>2]=0;p=1;break}else{p=(c[b>>2]|0)==0;break}}else p=1;while(0);n=c[d>>2]|0;if(n){k=c[n+12>>2]|0;if((k|0)==(c[n+16>>2]|0))k=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else k=c[k>>2]|0;if((k|0)==-1){c[d>>2]=0;n=0;k=1}else k=0}else{n=0;k=1}o=c[b>>2]|0;if(!((m|0)!=0&(p^k)))break;k=c[o+12>>2]|0;if((k|0)==(c[o+16>>2]|0))k=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else k=c[k>>2]|0;if(!i)k=nb[c[(c[g>>2]|0)+28>>2]&63](g,k)|0;t=u+1|0;q=e;p=0;r=j;while(1){if((q|0)==(f|0))break;do if((a[r>>0]|0)==1){o=q+8+3|0;if((a[o>>0]|0)<0)n=c[q>>2]|0;else n=q;n=c[n+(u<<2)>>2]|0;if(!i)n=nb[c[(c[g>>2]|0)+28>>2]&63](g,n)|0;if((k|0)!=(n|0)){a[r>>0]=0;n=p;o=s;m=m+-1|0;break}n=a[o>>0]|0;if(n<<24>>24<0)n=c[q+4>>2]|0;else n=n&255;if((n|0)==(t|0)){a[r>>0]=2;n=1;o=s+1|0;m=m+-1|0}else{n=1;o=s}}else{n=p;o=s}while(0);q=q+12|0;p=n;r=r+1|0;s=o}if(!p){u=t;continue}k=c[b>>2]|0;n=k+12|0;o=c[n>>2]|0;if((o|0)==(c[k+16>>2]|0))hb[c[(c[k>>2]|0)+40>>2]&127](k)|0;else c[n>>2]=o+4;if((s+m|0)>>>0>1){o=e;p=j;k=s}else{u=t;continue}while(1){if((o|0)==(f|0)){u=t;s=k;continue a}if((a[p>>0]|0)==2){n=a[o+8+3>>0]|0;if(n<<24>>24<0)n=c[o+4>>2]|0;else n=n&255;if((n|0)!=(t|0)){a[p>>0]=0;k=k+-1|0}}o=o+12|0;p=p+1|0}}do if(o){k=c[o+12>>2]|0;if((k|0)==(c[o+16>>2]|0))k=hb[c[(c[o>>2]|0)+36>>2]&127](o)|0;else k=c[k>>2]|0;if((k|0)==-1){c[b>>2]=0;m=1;break}else{m=(c[b>>2]|0)==0;break}}else m=1;while(0);do if(n){k=c[n+12>>2]|0;if((k|0)==(c[n+16>>2]|0))k=hb[c[(c[n>>2]|0)+36>>2]&127](n)|0;else k=c[k>>2]|0;if((k|0)!=-1)if(m)break;else{w=77;break}else{c[d>>2]=0;w=41;break}}else w=41;while(0);if((w|0)==41)if(m)w=77;if((w|0)==77)c[h>>2]=c[h>>2]|2;while(1){if((e|0)==(f|0)){w=81;break}if((a[j>>0]|0)==2)break;e=e+12|0;j=j+1|0}if((w|0)==81){c[h>>2]=c[h>>2]|4;e=f}Gj(v);l=x;return e|0}function qn(a){a=a|0;return}function rn(a){a=a|0;Dt(a);return}function sn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;k=m+4|0;h=m;if(!(c[e+4>>2]&1)){j=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[k>>2]=c[h>>2];b=ob[j&31](b,k,e,f,g&1)|0}else{e=Sk(e)|0;c[k>>2]=e;b=lm(k,1165644)|0;vt(e)|0;e=c[b>>2]|0;if(g)eb[c[e+24>>2]&63](k,b);else eb[c[e+28>>2]&63](k,b);i=k+11|0;e=a[i>>0]|0;if(e<<24>>24<0){b=c[k>>2]|0;j=8}else b=k;while(1){j=e<<24>>24<0;if((b|0)==((j?c[k>>2]|0:k)+(j?c[k+4>>2]|0:e&255)|0))break;e=a[b>>0]|0;f=c[d>>2]|0;do if(f|0){h=f+24|0;g=c[h>>2]|0;if((g|0)!=(c[f+28>>2]|0)){c[h>>2]=g+1;a[g>>0]=e;break}if((nb[c[(c[f>>2]|0)+52>>2]&63](f,e&255)|0)==-1)c[d>>2]=0}while(0);e=a[i>>0]|0;b=b+1|0;j=8}b=c[d>>2]|0;Mt(k)}l=m;return b|0}function tn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+64|0;i=b;n=b+52|0;o=b+39|0;h=b+16|0;m=b+12|0;k=b+4|0;j=b+8|0;a[n>>0]=a[25808]|0;a[n+1>>0]=a[25809]|0;a[n+2>>0]=a[25810]|0;a[n+3>>0]=a[25811]|0;a[n+4>>0]=a[25812]|0;a[n+5>>0]=a[25813]|0;Fn(n+1|0,25814,1,c[e+4>>2]|0);p=nm()|0;c[i>>2]=g;g=o+(An(o,13,p,n,i)|0)|0;n=Bn(o,g,e)|0;c[i>>2]=Sk(e)|0;Gn(o,n,g,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[d>>2];d=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Md(i,h,d,g,e,f)|0;l=b;return g|0}function un(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+96|0;i=a+8|0;o=a;n=a+71|0;h=a+28|0;m=a+24|0;k=a+16|0;j=a+20|0;p=o;c[p>>2]=37;c[p+4>>2]=0;Fn(o+1|0,25805,1,c[d+4>>2]|0);p=nm()|0;q=i;c[q>>2]=f;c[q+4>>2]=g;f=n+(An(n,23,p,o,i)|0)|0;g=Bn(n,f,d)|0;c[i>>2]=Sk(d)|0;Gn(n,g,f,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[b>>2];f=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Md(i,h,f,g,d,e)|0;l=a;return g|0}function vn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+64|0;i=b;n=b+52|0;o=b+40|0;h=b+16|0;m=b+12|0;k=b+4|0;j=b+8|0;a[n>>0]=a[25808]|0;a[n+1>>0]=a[25809]|0;a[n+2>>0]=a[25810]|0;a[n+3>>0]=a[25811]|0;a[n+4>>0]=a[25812]|0;a[n+5>>0]=a[25813]|0;Fn(n+1|0,25814,0,c[e+4>>2]|0);p=nm()|0;c[i>>2]=g;g=o+(An(o,12,p,n,i)|0)|0;n=Bn(o,g,e)|0;c[i>>2]=Sk(e)|0;Gn(o,n,g,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[d>>2];d=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Md(i,h,d,g,e,f)|0;l=b;return g|0}function wn(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;a=l;l=l+96|0;i=a+8|0;o=a;n=a+71|0;h=a+28|0;m=a+24|0;k=a+16|0;j=a+20|0;p=o;c[p>>2]=37;c[p+4>>2]=0;Fn(o+1|0,25805,0,c[d+4>>2]|0);p=nm()|0;q=i;c[q>>2]=f;c[q+4>>2]=g;f=n+(An(n,23,p,o,i)|0)|0;g=Bn(n,f,d)|0;c[i>>2]=Sk(d)|0;Gn(n,g,f,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[b>>2];f=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Md(i,h,f,g,d,e)|0;l=a;return g|0}function xn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+176|0;r=v+72|0;o=v+48|0;n=v+32|0;j=v+24|0;g=v+8|0;m=v;p=v+134|0;q=v+68|0;i=v+76|0;u=v+64|0;s=v+60|0;t=v+56|0;k=m;c[k>>2]=37;c[k+4>>2]=0;k=Cn(m+1|0,1235164,c[d+4>>2]|0)|0;c[q>>2]=p;a=nm()|0;if(k){c[g>>2]=c[d+8>>2];h[g+8>>3]=f;a=An(p,30,a,m,g)|0}else{h[j>>3]=f;a=An(p,30,a,m,j)|0}if((a|0)>29){a=nm()|0;if(k){c[n>>2]=c[d+8>>2];h[n+8>>3]=f;a=Dn(q,a,m,n)|0}else{h[o>>3]=f;a=Dn(q,a,m,o)|0}g=c[q>>2]|0;if(!g){j=c[q>>2]|0;n=j}else{n=g;j=g}}else{n=0;j=c[q>>2]|0}k=j+a|0;m=Bn(j,k,d)|0;if((j|0)!=(p|0)){a=Fj(a<<1)|0;if(!a){i=0;g=0;a=c[q>>2]|0}else{i=a;g=a;a=j}}else{g=0;a=p}c[r>>2]=Sk(d)|0;En(a,m,k,i,u,s,r);vt(c[r>>2]|0)|0;c[t>>2]=c[b>>2];u=c[u>>2]|0;b=c[s>>2]|0;c[r>>2]=c[t>>2];e=Md(r,i,u,b,d,e)|0;Gj(g);Gj(n);l=v;return e|0}function yn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;var g=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+176|0;r=v+72|0;o=v+48|0;n=v+32|0;j=v+24|0;g=v+8|0;m=v;p=v+134|0;q=v+68|0;i=v+76|0;u=v+64|0;s=v+60|0;t=v+56|0;k=m;c[k>>2]=37;c[k+4>>2]=0;k=Cn(m+1|0,25803,c[d+4>>2]|0)|0;c[q>>2]=p;a=nm()|0;if(k){c[g>>2]=c[d+8>>2];h[g+8>>3]=f;a=An(p,30,a,m,g)|0}else{h[j>>3]=f;a=An(p,30,a,m,j)|0}if((a|0)>29){a=nm()|0;if(k){c[n>>2]=c[d+8>>2];h[n+8>>3]=f;a=Dn(q,a,m,n)|0}else{h[o>>3]=f;a=Dn(q,a,m,o)|0}g=c[q>>2]|0;if(!g){j=c[q>>2]|0;n=j}else{n=g;j=g}}else{n=0;j=c[q>>2]|0}k=j+a|0;m=Bn(j,k,d)|0;if((j|0)!=(p|0)){a=Fj(a<<1)|0;if(!a){i=0;g=0;a=c[q>>2]|0}else{i=a;g=a;a=j}}else{g=0;a=p}c[r>>2]=Sk(d)|0;En(a,m,k,i,u,s,r);vt(c[r>>2]|0)|0;c[t>>2]=c[b>>2];u=c[u>>2]|0;b=c[s>>2]|0;c[r>>2]=c[t>>2];e=Md(r,i,u,b,d,e)|0;Gj(g);Gj(n);l=v;return e|0}function zn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+80|0;m=b;k=b+68|0;h=b+48|0;j=b+8|0;n=b+4|0;a[k>>0]=a[25797]|0;a[k+1>>0]=a[25798]|0;a[k+2>>0]=a[25799]|0;a[k+3>>0]=a[25800]|0;a[k+4>>0]=a[25801]|0;a[k+5>>0]=a[25802]|0;i=nm()|0;c[m>>2]=g;g=An(h,20,i,k,m)|0;k=h+g|0;i=Bn(h,k,e)|0;p=Sk(e)|0;c[m>>2]=p;o=lm(m,1165628)|0;vt(p)|0;lb[c[(c[o>>2]|0)+32>>2]&7](o,h,k,j)|0;g=j+g|0;c[n>>2]=c[d>>2];c[m>>2]=c[n>>2];g=Md(m,j,(i|0)==(k|0)?g:j+(i-h)|0,g,e,f)|0;l=b;return g|0}function An(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=l;l=l+16|0;h=g;c[h>>2]=f;f=nj(d)|0;d=Xh(a,b,e,h)|0;if(f|0)nj(f)|0;l=g;return d|0}function Bn(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;a:do switch((c[e+4>>2]&176)<<24>>24){case 16:{e=a[b>>0]|0;switch(e<<24>>24){case 43:case 45:{b=b+1|0;break a}default:{}}if((d-b|0)>1&e<<24>>24==48){switch(a[b+1>>0]|0){case 88:case 120:break;default:{f=7;break a}}b=b+2|0}else f=7;break}case 32:{b=d;break}default:f=7}while(0);return b|0}function Cn(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;if(d&2048){a[b>>0]=43;b=b+1|0}if(d&1024){a[b>>0]=35;b=b+1|0}h=d&260;e=d>>>14;g=(h|0)==260;if(g)f=0;else{a[b>>0]=46;a[b+1>>0]=42;f=1;b=b+2|0}while(1){d=a[c>>0]|0;if(!(d<<24>>24))break;a[b>>0]=d;c=c+1|0;b=b+1|0}a:do switch(h&511){case 4:if(!(e&1)){a[b>>0]=102;break a}else{a[b>>0]=70;break a}case 256:if(!(e&1)){a[b>>0]=101;break a}else{a[b>>0]=69;break a}default:{d=(e&1|0)!=0;if(g)if(d){a[b>>0]=65;break a}else{a[b>>0]=97;break a}else if(d){a[b>>0]=71;break a}else{a[b>>0]=103;break a}}}while(0);return f|0}function Dn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;c[g>>2]=e;e=nj(b)|0;b=Vi(a,d,g)|0;if(e|0)nj(e)|0;l=f;return b|0}function En(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;w=l;l=l+16|0;t=w;u=lm(i,1165628)|0;s=lm(i,1165644)|0;eb[c[(c[s>>2]|0)+20>>2]&63](t,s);c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{r=nb[c[(c[u>>2]|0)+28>>2]&63](u,i)|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j>>0]=r;j=b+1|0;break}default:j=b}r=e;a:do if((r-j|0)>1?(a[j>>0]|0)==48:0){i=j+1|0;switch(a[i>>0]|0){case 88:case 120:break;default:{i=j;v=10;break a}}p=nb[c[(c[u>>2]|0)+28>>2]&63](u,48)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q>>0]=p;j=j+2|0;q=nb[c[(c[u>>2]|0)+28>>2]&63](u,a[i>>0]|0)|0;i=c[h>>2]|0;c[h>>2]=i+1;a[i>>0]=q;i=j;while(1){if(i>>>0>=e>>>0)break a;q=a[i>>0]|0;if(!(lj(q,nm()|0)|0))break a;i=i+1|0}}else{i=j;v=10}while(0);b:do if((v|0)==10)while(1){v=0;if(i>>>0>=e>>>0)break b;q=a[i>>0]|0;if(!(sj(q,nm()|0)|0))break b;i=i+1|0;v=10}while(0);p=t+11|0;o=a[p>>0]|0;q=t+4|0;c:do if((o<<24>>24<0?c[q>>2]|0:o&255)|0){d:do if((j|0)!=(i|0)){k=i;m=j;while(1){k=k+-1|0;if(m>>>0>=k>>>0)break d;o=a[m>>0]|0;a[m>>0]=a[k>>0]|0;a[k>>0]=o;m=m+1|0}}while(0);o=hb[c[(c[s>>2]|0)+16>>2]&127](s)|0;n=j;m=0;k=0;while(1){if(n>>>0>=i>>>0)break;x=a[((a[p>>0]|0)<0?c[t>>2]|0:t)+k>>0]|0;if(x<<24>>24>0&(m|0)==(x<<24>>24|0)){m=c[h>>2]|0;c[h>>2]=m+1;a[m>>0]=o;m=a[p>>0]|0;k=(k>>>0<((m<<24>>24<0?c[q>>2]|0:m&255)+-1|0)>>>0&1)+k|0;m=0}y=nb[c[(c[u>>2]|0)+28>>2]&63](u,a[n>>0]|0)|0;x=c[h>>2]|0;c[h>>2]=x+1;a[x>>0]=y;n=n+1|0;m=m+1|0}k=f+(j-b)|0;j=c[h>>2]|0;if((k|0)==(j|0))k=u;else while(1){j=j+-1|0;if(k>>>0>=j>>>0){k=u;break c}y=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=y;k=k+1|0}}else{lb[c[(c[u>>2]|0)+32>>2]&7](u,j,i,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(i-j);k=u}while(0);while(1){if(i>>>0>=e>>>0)break;j=a[i>>0]|0;if(j<<24>>24==46){v=29;break}x=nb[c[(c[k>>2]|0)+28>>2]&63](u,j)|0;y=c[h>>2]|0;c[h>>2]=y+1;a[y>>0]=x;i=i+1|0}if((v|0)==29){x=hb[c[(c[s>>2]|0)+12>>2]&127](s)|0;y=c[h>>2]|0;c[h>>2]=y+1;a[y>>0]=x;i=i+1|0}lb[c[(c[u>>2]|0)+32>>2]&7](u,i,e,c[h>>2]|0)|0;y=(c[h>>2]|0)+(r-i)|0;c[h>>2]=y;c[g>>2]=(d|0)==(e|0)?y:f+(d-b)|0;Mt(t);l=w;return}function Fn(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0;if(e&2048){a[b>>0]=43;b=b+1|0}if(e&512){a[b>>0]=35;b=b+1|0}while(1){f=a[c>>0]|0;if(!(f<<24>>24))break;a[b>>0]=f;c=c+1|0;b=b+1|0}a:do switch(e&74){case 64:{a[b>>0]=111;break}case 8:if(!(e&16384)){a[b>>0]=120;break a}else{a[b>>0]=88;break a}default:if(d){a[b>>0]=100;break a}else{a[b>>0]=117;break a}}while(0);return}function Gn(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;s=l;l=l+16|0;r=s;q=lm(i,1165628)|0;m=lm(i,1165644)|0;eb[c[(c[m>>2]|0)+20>>2]&63](r,m);o=r+11|0;n=a[o>>0]|0;p=r+4|0;if((n<<24>>24<0?c[p>>2]|0:n&255)|0){c[h>>2]=f;i=a[b>>0]|0;switch(i<<24>>24){case 43:case 45:{n=nb[c[(c[q>>2]|0)+28>>2]&63](q,i)|0;i=c[h>>2]|0;c[h>>2]=i+1;a[i>>0]=n;i=b+1|0;break}default:i=b}a:do if((e-i|0)>1?(a[i>>0]|0)==48:0){j=i+1|0;switch(a[j>>0]|0){case 88:case 120:break;default:break a}n=nb[c[(c[q>>2]|0)+28>>2]&63](q,48)|0;k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=n;k=nb[c[(c[q>>2]|0)+28>>2]&63](q,a[j>>0]|0)|0;n=c[h>>2]|0;c[h>>2]=n+1;a[n>>0]=k;i=i+2|0}while(0);b:do if((i|0)!=(e|0)){j=e;k=i;while(1){j=j+-1|0;if(k>>>0>=j>>>0)break b;n=a[k>>0]|0;a[k>>0]=a[j>>0]|0;a[j>>0]=n;k=k+1|0}}while(0);n=hb[c[(c[m>>2]|0)+16>>2]&127](m)|0;m=i;j=0;k=0;while(1){if(m>>>0>=e>>>0)break;t=a[((a[o>>0]|0)<0?c[r>>2]|0:r)+j>>0]|0;if(t<<24>>24!=0&(k|0)==(t<<24>>24|0)){k=c[h>>2]|0;c[h>>2]=k+1;a[k>>0]=n;k=a[o>>0]|0;j=(j>>>0<((k<<24>>24<0?c[p>>2]|0:k&255)+-1|0)>>>0&1)+j|0;k=0}u=nb[c[(c[q>>2]|0)+28>>2]&63](q,a[m>>0]|0)|0;t=c[h>>2]|0;c[h>>2]=t+1;a[t>>0]=u;m=m+1|0;k=k+1|0}i=f+(i-b)|0;j=c[h>>2]|0;if((i|0)!=(j|0)){while(1){j=j+-1|0;if(i>>>0>=j>>>0)break;u=a[i>>0]|0;a[i>>0]=a[j>>0]|0;a[j>>0]=u;i=i+1|0}i=c[h>>2]|0}}else{lb[c[(c[q>>2]|0)+32>>2]&7](q,b,e,f)|0;i=f+(e-b)|0;c[h>>2]=i}c[g>>2]=(d|0)==(e|0)?i:f+(d-b)|0;Mt(r);l=s;return}function Hn(a){a=a|0;return}function In(a){a=a|0;Dt(a);return}function Jn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0;m=l;l=l+16|0;k=m+4|0;h=m;if(!(c[e+4>>2]&1)){j=c[(c[b>>2]|0)+24>>2]|0;c[h>>2]=c[d>>2];c[k>>2]=c[h>>2];b=ob[j&31](b,k,e,f,g&1)|0}else{e=Sk(e)|0;c[k>>2]=e;b=lm(k,1165668)|0;vt(e)|0;e=c[b>>2]|0;if(g)eb[c[e+24>>2]&63](k,b);else eb[c[e+28>>2]&63](k,b);i=k+8+3|0;b=a[i>>0]|0;e=c[k>>2]|0;j=k+4|0;g=b<<24>>24<0?e:k;while(1){h=b<<24>>24<0;if((g|0)==((h?e:k)+((h?c[j>>2]|0:b&255)<<2)|0))break;b=c[g>>2]|0;e=c[d>>2]|0;if(e|0){f=e+24|0;h=c[f>>2]|0;if((h|0)==(c[e+28>>2]|0))b=nb[c[(c[e>>2]|0)+52>>2]&63](e,b)|0;else{c[f>>2]=h+4;c[h>>2]=b}if((b|0)==-1)c[d>>2]=0}g=g+4|0;b=a[i>>0]|0;e=c[k>>2]|0}b=c[d>>2]|0;fu(k)}l=m;return b|0}function Kn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+128|0;i=b;n=b+122|0;o=b+108|0;h=b+16|0;m=b+12|0;k=b+4|0;j=b+8|0;a[n>>0]=a[25808]|0;a[n+1>>0]=a[25809]|0;a[n+2>>0]=a[25810]|0;a[n+3>>0]=a[25811]|0;a[n+4>>0]=a[25812]|0;a[n+5>>0]=a[25813]|0;Fn(n+1|0,25814,1,c[e+4>>2]|0);p=nm()|0;c[i>>2]=g;g=o+(An(o,13,p,n,i)|0)|0;n=Bn(o,g,e)|0;c[i>>2]=Sk(e)|0;Tn(o,n,g,h,m,k,i);vt(c[i>>2]|0)|0;c[j>>2]=c[d>>2];d=c[m>>2]|0;g=c[k>>2]|0;c[i>>2]=c[j>>2];g=Rn(i,h,d,g,e,f)|0;l=b;return g|0}
function Cf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;s=c[a+5364>>2]|0;a:do if((s|0)==1){a=b+344|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;c[a+12>>2]=0}else{e=a+328|0;d=c[e>>2]|0;e=c[e+4>>2]|0;switch(s|0){case 4:{if(!(c[a+360>>2]|0))k=64;else q=6;break}case 2:{if(!(c[a+360>>2]|0))k=64;else q=6;break}default:q=6}if((q|0)==6)k=c[a+1936>>2]|0;n=b+360|0;r=n;c[r>>2]=0;c[r+4>>2]=0;r=(s|0)==4|(s|0)==2;b:do if((k|0)==64&r){e=0;d=0}else{f=114320+(k<<3)|0;j=a+296|0;g=c[j>>2]|0;j=c[j+4>>2]|0;i=a+288|0;h=113808+(k<<3)|0;t=a+280|0;o=a+256|0;p=a+(k<<2)|0;l=0;m=0;g=((c[t>>2]|g)&c[h>>2]|(c[i>>2]|g)&c[f>>2])&d;f=((c[t+4>>2]|j)&c[h+4>>2]|(c[i+4>>2]|j)&c[f+4>>2])&e;e=0;d=0;while(1){do{do{if((g|0)==0&(f|0)==0)break b;j=Qa(g|0,f|0,0)|0;i=Yu(g|0,f|0,-1,-1)|0;g=i&g;f=D&f;i=39568+(k<<9)+(j<<3)|0;t=o;h=c[t>>2]&c[i>>2];i=c[t+4>>2]&c[i+4>>2];t=Yu(h|0,i|0,-1,-1)|0}while(!((t&h|0)==0&(D&i|0)==0));e=h|e;d=i|d;t=a+320+(c[p>>2]>>3<<3)|0}while((c[t>>2]&h|0)==0?(c[t+4>>2]&i|0)==0:0);t=30544+(j<<3)|0;j=c[t>>2]|l;t=c[t+4>>2]|m;i=n;c[i>>2]=j;c[i+4>>2]=t;l=j;m=t}}while(0);t=b+344|0;c[t>>2]=e;c[t+4>>2]=d;e=a+320|0;d=c[e>>2]|0;e=c[e+4>>2]|0;switch(s|0){case 4:{if(!(c[a+392>>2]|0))p=64;else q=19;break}case 2:{if(!(c[a+392>>2]|0))p=64;else q=19;break}case 1:{if(!(c[a+392>>2]|0))p=64;else q=19;break}default:q=19}if((q|0)==19)p=c[a+3984>>2]|0;o=b+368|0;t=o;c[t>>2]=0;c[t+4>>2]=0;c:do if((p|0)==64&r){e=0;d=0}else{f=114320+(p<<3)|0;t=a+296|0;g=c[t>>2]|0;t=c[t+4>>2]|0;r=a+288|0;q=113808+(p<<3)|0;j=a+280|0;k=a+256|0;l=a+(p<<2)|0;m=0;n=0;g=((c[j>>2]|g)&c[q>>2]|(c[r>>2]|g)&c[f>>2])&d;f=((c[j+4>>2]|t)&c[q+4>>2]|(c[r+4>>2]|t)&c[f+4>>2])&e;e=0;d=0;while(1){do{do{if((g|0)==0&(f|0)==0)break c;h=Qa(g|0,f|0,0)|0;j=Yu(g|0,f|0,-1,-1)|0;g=j&g;f=D&f;j=39568+(p<<9)+(h<<3)|0;t=k;i=c[t>>2]&c[j>>2];j=c[t+4>>2]&c[j+4>>2];t=Yu(i|0,j|0,-1,-1)|0}while(!((t&i|0)==0&(D&j|0)==0));e=i|e;d=j|d;t=a+320+(c[l>>2]>>3<<3)|0}while((c[t>>2]&i|0)==0?(c[t+4>>2]&j|0)==0:0);t=30544+(h<<3)|0;r=c[t>>2]|m;t=c[t+4>>2]|n;q=o;c[q>>2]=r;c[q+4>>2]=t;m=r;n=t}}while(0);t=b+352|0;c[t>>2]=e;c[t+4>>2]=d;e=c[a+5348>>2]|0;d=e^1;switch(s|0){case 1:break a;case 4:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;if(!(c[a+336+((e<<3^14)<<2)>>2]|0)){d=b+384|0;e=d+48|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}break}case 2:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;if((d|0)==64){d=b+384|0;e=d+48|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}break}default:d=c[a+400+((d<<3|6)<<8)>>2]|0}r=31376+((e<<3^9)<<9)+(d<<3)|0;q=c[r+4>>2]|0;t=b+384|0;c[t>>2]=c[r>>2];c[t+4>>2]=q;t=32400+(d<<3)|0;q=c[t+4>>2]|0;r=b+392|0;c[r>>2]=c[t>>2];c[r+4>>2]=q;r=a+256|0;q=r;t=29520+(d<<3)|0;s=30032+(d<<3)|0;s=(S(c[t+4>>2]&c[q+4>>2],c[s+4>>2]|0)|0)^(S(c[t>>2]&c[q>>2],c[s>>2]|0)|0);s=(c[1035940+(d<<2)>>2]|0)+(s>>>(c[1036196+(d<<2)>>2]|0)<<3)|0;q=c[s>>2]|0;s=c[s+4>>2]|0;t=b+400|0;c[t>>2]=q;c[t+4>>2]=s;t=28496+(d<<3)|0;a=29008+(d<<3)|0;a=(S(c[t+4>>2]&c[r+4>>2],c[a+4>>2]|0)|0)^(S(c[t>>2]&c[r>>2],c[a>>2]|0)|0);a=(c[1035428+(d<<2)>>2]|0)+(a>>>(c[1035684+(d<<2)>>2]|0)<<3)|0;r=c[a>>2]|0;a=c[a+4>>2]|0;t=b+408|0;c[t>>2]=r;c[t+4>>2]=a;t=b+416|0;c[t>>2]=q|r;c[t+4>>2]=s|a;t=b+424|0;c[t>>2]=0;c[t+4>>2]=0;return}while(0);d=b+384|0;e=d+48|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(e|0));return}function Df(a){a=a|0;var b=0,d=0;c[a>>2]=10848;b=a+60|0;c[b>>2]=10868;d=a+8|0;c[d>>2]=3708;Mt(a+40|0);Tj(d);Vk(a,10880);Pj(b);return}function Ef(a){a=a|0;var b=0,d=0;c[a>>2]=10848;b=a+60|0;c[b>>2]=10868;d=a+8|0;c[d>>2]=3708;Mt(a+40|0);Tj(d);Vk(a,10880);Pj(b);Dt(a);return}function Ff(a){a=a|0;var b=0,d=0;b=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[b>>2]=10848;a=b+60|0;c[a>>2]=10868;d=b+8|0;c[d>>2]=3708;Mt(b+40|0);Tj(d);Vk(b,10880);Pj(a);return}function Gf(a){a=a|0;var b=0,d=0;a=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[a>>2]=10848;b=a+60|0;c[b>>2]=10868;d=a+8|0;c[d>>2]=3708;Mt(a+40|0);Tj(d);Vk(a,10880);Pj(b);Dt(a);return}function Hf(a){a=a|0;var b=0,d=0;c[a>>2]=10992;b=a+56|0;c[b>>2]=11012;d=a+4|0;c[d>>2]=3708;Mt(a+36|0);Tj(d);cl(a,11024);Pj(b);return}function If(a){a=a|0;var b=0,d=0;c[a>>2]=10992;b=a+56|0;c[b>>2]=11012;d=a+4|0;c[d>>2]=3708;Mt(a+36|0);Tj(d);cl(a,11024);Pj(b);Dt(a);return}function Jf(a){a=a|0;var b=0,d=0;b=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[b>>2]=10992;a=b+56|0;c[a>>2]=11012;d=b+4|0;c[d>>2]=3708;Mt(b+36|0);Tj(d);cl(b,11024);Pj(a);return}function Kf(a){a=a|0;var b=0,d=0;a=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[a>>2]=10992;b=a+56|0;c[b>>2]=11012;d=a+4|0;c[d>>2]=3708;Mt(a+36|0);Tj(d);cl(a,11024);Pj(b);Dt(a);return}function Lf(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;d=10892;a=1070372;b=0;do{f=c[d>>2]|0;e=0;do{i=av(a|0,b|0,12)|0;i=i^a;h=D^b;g=gv(i|0,h|0,25)|0;i=g^i;h=D^h;g=av(i|0,h|0,27)|0;a=g^i;b=D^h;h=fv(a|0,b|0,1332534557,625341585)|0;i=977568+(f<<9)+(e<<3)|0;c[i>>2]=h;c[i+4>>2]=D;e=e+1|0}while((e|0)!=64);d=d+4|0}while((d|0)!=10940);d=av(a|0,b|0,12)|0;a=d^a;d=D^b;b=gv(a|0,d|0,25)|0;b=b^a;d=D^d;a=av(b|0,d|0,27)|0;b=a^b;d=D^d;a=fv(b|0,d|0,1332534557,625341585)|0;i=985760;c[i>>2]=a;c[i+4>>2]=D;i=av(b|0,d|0,12)|0;b=i^b;d=D^d;i=gv(b|0,d|0,25)|0;b=i^b;d=D^d;i=av(b|0,d|0,27)|0;b=i^b;d=D^d;i=fv(b|0,d|0,1332534557,625341585)|0;a=985768;c[a>>2]=i;c[a+4>>2]=D;a=av(b|0,d|0,12)|0;b=a^b;d=D^d;a=gv(b|0,d|0,25)|0;b=a^b;d=D^d;a=av(b|0,d|0,27)|0;b=a^b;d=D^d;a=fv(b|0,d|0,1332534557,625341585)|0;i=985776;c[i>>2]=a;c[i+4>>2]=D;i=av(b|0,d|0,12)|0;b=i^b;d=D^d;i=gv(b|0,d|0,25)|0;b=i^b;d=D^d;i=av(b|0,d|0,27)|0;b=i^b;d=D^d;i=fv(b|0,d|0,1332534557,625341585)|0;a=985784;c[a>>2]=i;c[a+4>>2]=D;a=av(b|0,d|0,12)|0;b=a^b;d=D^d;a=gv(b|0,d|0,25)|0;b=a^b;d=D^d;a=av(b|0,d|0,27)|0;b=a^b;d=D^d;a=fv(b|0,d|0,1332534557,625341585)|0;i=985792;c[i>>2]=a;c[i+4>>2]=D;i=av(b|0,d|0,12)|0;b=i^b;d=D^d;i=gv(b|0,d|0,25)|0;b=i^b;d=D^d;i=av(b|0,d|0,27)|0;b=i^b;d=D^d;i=fv(b|0,d|0,1332534557,625341585)|0;a=985800;c[a>>2]=i;c[a+4>>2]=D;a=av(b|0,d|0,12)|0;b=a^b;d=D^d;a=gv(b|0,d|0,25)|0;b=a^b;d=D^d;a=av(b|0,d|0,27)|0;b=a^b;d=D^d;a=fv(b|0,d|0,1332534557,625341585)|0;i=985808;c[i>>2]=a;c[i+4>>2]=D;i=av(b|0,d|0,12)|0;b=i^b;d=D^d;i=gv(b|0,d|0,25)|0;b=i^b;d=D^d;i=av(b|0,d|0,27)|0;b=i^b;d=D^d;i=fv(b|0,d|0,1332534557,625341585)|0;a=985816;c[a>>2]=i;c[a+4>>2]=D;a=0;while(1){while(1){e=985824+(a<<3)|0;i=e;c[i>>2]=0;c[i+4>>2]=0;if(!a)a=1;else break}f=a;g=((a|0)<0)<<31>>31;h=b;i=d;b=0;d=0;do{j=Qa(f|0,g|0,0)|0;l=Yu(f|0,g|0,-1,-1)|0;f=l&f;g=D&g;j=gv(1,0,j|0)|0;j=985824+(j<<3)|0;l=c[j>>2]|0;j=c[j+4>>2]|0;k=(l|0)==0&(j|0)==0;o=av(h|0,i|0,12)|0;o=o^h;n=D^i;m=gv(o|0,n|0,25)|0;o=m^o;n=D^n;m=av(o|0,n|0,27)|0;o=m^o;n=D^n;m=fv(o|0,n|0,1332534557,625341585)|0;h=k?o:h;i=k?n:i;b=(k?m:l)^b;d=(k?D:j)^d;j=e;c[j>>2]=b;c[j+4>>2]=d}while(!((f|0)==0&(g|0)==0));a=a+1|0;if((a|0)==16)break;else{b=h;d=i}}a=av(h|0,i|0,12)|0;a=a^h;b=D^i;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=985952;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=985960;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=985968;c[o>>2]=0;c[o+4>>2]=0;o=985976;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=985984;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=985992;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=986e3;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=986008;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=986016;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=986024;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=986032;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=988216;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=988224;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=988232;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=988240;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=988248;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=988256;c[d>>2]=o;c[d+4>>2]=D;d=av(a|0,b|0,12)|0;a=d^a;b=D^b;d=gv(a|0,b|0,25)|0;a=d^a;b=D^b;d=av(a|0,b|0,27)|0;a=d^a;b=D^b;d=fv(a|0,b|0,1332534557,625341585)|0;o=988264;c[o>>2]=d;c[o+4>>2]=D;o=av(a|0,b|0,12)|0;a=o^a;b=D^b;o=gv(a|0,b|0,25)|0;a=o^a;b=D^b;o=av(a|0,b|0,27)|0;a=o^a;b=D^b;o=fv(a|0,b|0,1332534557,625341585)|0;d=988272;c[d>>2]=o;c[d+4>>2]=D;d=10892;do{f=c[d>>2]|0;e=0;do{o=av(a|0,b|0,12)|0;o=o^a;n=D^b;m=gv(o|0,n|0,25)|0;o=m^o;n=D^n;m=av(o|0,n|0,27)|0;a=m^o;b=D^n;n=fv(a|0,b|0,1332534557,625341585)|0;o=986040+(f*136|0)+(e<<3)|0;c[o>>2]=n;c[o+4>>2]=D;e=e+1|0}while((e|0)!=17);d=d+4|0}while((d|0)!=10940);return}function Mf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=f;c[o>>2]=0;c[o+4>>2]=0;o=c[a+5364>>2]|0;if((e|0)==64&((o|0)==4|(o|0)==2)){n=0;o=0;D=n;return o|0}g=114320+(e<<3)|0;k=a+296|0;h=c[k>>2]|0;k=c[k+4>>2]|0;j=a+288|0;i=113808+(e<<3)|0;p=a+280|0;n=a+256|0;o=a+(e<<2)|0;l=0;m=0;h=((c[p>>2]|h)&c[i>>2]|(c[j>>2]|h)&c[g>>2])&b;g=((c[p+4>>2]|k)&c[i+4>>2]|(c[j+4>>2]|k)&c[g+4>>2])&d;b=0;d=0;a:while(1){while(1){k=h;do{if((k|0)==0&(g|0)==0)break a;h=Qa(k|0,g|0,0)|0;j=Yu(k|0,g|0,-1,-1)|0;k=j&k;g=D&g;j=39568+(e<<9)+(h<<3)|0;p=n;i=c[p>>2]&c[j>>2];j=c[p+4>>2]&c[j+4>>2];p=Yu(i|0,j|0,-1,-1)|0}while(!((p&i|0)==0&(D&j|0)==0));b=i|b;d=j|d;p=a+320+(c[o>>2]>>3<<3)|0;if(!((c[p>>2]&i|0)==0?(c[p+4>>2]&j|0)==0:0))break;else h=k}h=30544+(h<<3)|0;p=l|c[h>>2];h=m|c[h+4>>2];j=f;c[j>>2]=p;c[j+4>>2]=h;l=p;m=h;h=k}D=d;return b|0}function Nf(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+96|0;m=r+64|0;n=r+48|0;o=r+36|0;p=r+24|0;q=r+12|0;j=r;Lt(m,d,(_t(d,118,0)|0)+1|0,-1,d);k=m+12|0;Lt(k,d,0,_t(d,118,0)|0,d);i=m+(e*12|0)|0;d=a[i+11>>0]|0;if(d<<24>>24<0){d=c[i>>2]|0;h=d;e=d+(c[m+(e*12|0)+4>>2]|0)|0}else{h=i;e=i+(d&255)|0;d=i}if((h|0)!=(e|0))while(1){a[d>>0]=gj(a[h>>0]|0)|0;h=h+1|0;if((h|0)==(e|0))break;else d=d+1|0}i=a[m+11>>0]|0;h=i<<24>>24<0;i=h?c[m+4>>2]|0:i&255;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;bu(j,h?c[m>>2]|0:m,i,i+1|0);Xt(j,56-i&255);i=Wt(j,20928)|0;c[q>>2]=c[i>>2];c[q+4>>2]=c[i+4>>2];c[q+8>>2]=c[i+8>>2];c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;i=k+11|0;h=a[i>>0]|0;d=h<<24>>24<0;e=m+16|0;k=Vt(q,d?c[k>>2]|0:k,d?c[e>>2]|0:h&255)|0;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[p+8>>2]=c[k+8>>2];c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[i>>0]|0;Xt(p,56-(k<<24>>24<0?c[e>>2]|0:k&255)&255);c[o>>2]=c[p>>2];c[o+4>>2]=c[p+4>>2];c[o+8>>2]=c[p+8>>2];c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;k=Wt(o,20942)|0;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[n+8>>2]=c[k+8>>2];c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Mt(o);Mt(p);Mt(q);Mt(j);q=zf(b,n,0,f,g,0)|0;Mt(n);Mt(m+12|0);Mt(m);l=r;return q|0}function Of(a){a=a|0;var b=0,d=0;b=c[a+5356>>2]|0;b=(c[b+20>>2]|0)+(c[b+16>>2]|0)|0;d=c[a+5364>>2]|0;if((d|0)==4){d=(c[a+336+((((c[a+360>>2]|0)!=0&1)<<3|1)<<2)>>2]<<7|0)/36|0;return d|0}else{a=c[11036+(d<<3)>>2]|0;d=c[11036+(d<<3)+4>>2]|0;b=(a|0)<(b|0)?a:b;d=(((d|0)<(b|0)?b:d)-d<<7|0)/(a-d|0)|0;return d|0}return 0}function Pf(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;n=35984+(b<<3)|0;o=a+320|0;s=a+264|0;m=c[s>>2]|0;s=c[s+4>>2]|0;q=31888+(b<<3)|0;p=a+328|0;k=32400+(b<<3)|0;l=a+272|0;j=28496+(b<<3)|0;i=29008+(b<<3)|0;i=(S(c[j+4>>2]&e,c[i+4>>2]|0)|0)^(S(c[j>>2]&d,c[i>>2]|0)|0);i=(c[1035428+(b<<2)>>2]|0)+(i>>>(c[1035684+(b<<2)>>2]|0)<<3)|0;j=a+288|0;r=a+296|0;g=c[r>>2]|0;r=c[r+4>>2]|0;h=29520+(b<<3)|0;f=30032+(b<<3)|0;f=(S(c[h+4>>2]&e,c[f+4>>2]|0)|0)^(S(c[h>>2]&d,c[f>>2]|0)|0);f=(c[1035940+(b<<2)>>2]|0)+(f>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;h=a+280|0;e=34448+(b<<3)|0;d=a+304|0;D=c[q+4>>2]&s&c[p+4>>2]|c[o+4>>2]&c[n+4>>2]&s|c[l+4>>2]&c[k+4>>2]|(r|c[j+4>>2])&c[i+4>>2]|(c[h+4>>2]|r)&c[f+4>>2]|c[d+4>>2]&c[e+4>>2];return c[q>>2]&m&c[p>>2]|c[o>>2]&c[n>>2]&m|c[l>>2]&c[k>>2]|(g|c[j>>2])&c[i>>2]|(c[h>>2]|g)&c[f>>2]|c[d>>2]&c[e>>2]|0}function Qf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;n=c[a+5348>>2]|0;m=b&49152;i=(m|0)==32768;if(i)p=(b&12288|0)==4096?64:b>>>6&63;else p=b>>>6&63;d=a+5364|0;e=c[d>>2]|0;switch(e|0){case 7:{o=5;break}case 1:{a=1;return a|0}default:{}}do if((o|0)==5)if(Rf(a,b)|0){a=0;return a|0}else{e=c[d>>2]|0;break}while(0);a:do if((e|0)==4)if(!(c[a+336+((n<<3|6)<<2)>>2]|0)){a=1;return a|0}else{d=0;o=34}else{f=(e|0)==2;if(f){d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))l=64;else l=c[a+400+(d<<8)>>2]|0;j=b&63;h=(m|0)==49152?1:(c[a+(j<<2)>>2]|0)==0;b:do if(h){if(i){d=b&12288;if(d<<16>>16<8192)switch(d<<16>>16){case 4096:break b;default:{o=15;break b}}else switch(d<<16>>16){case 8192:break b;default:{o=15;break b}}}}else o=15;while(0);if((o|0)==15?(A=34448+(j<<3)|0,z=30544+(l<<3)|0,!((c[z>>2]&c[A>>2]|0)==0?(c[z+4>>2]&c[A+4>>2]|0)==0:0)):0){a=0;return a|0}k=n^1;d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;g=34448+(d<<3)|0;d=c[g>>2]|0;g=c[g+4>>2]|0;if((c[a+(p<<2)>>2]&7|0)==6){A=30544+(j<<3)|0;if((c[A>>2]&d|0)==0?(c[A+4>>2]&g|0)==0:0){d=f;o=34;break}else d=1;return d|0}A=30544+(l<<3)|0;if(!((c[A>>2]&d|0)==0?(c[A+4>>2]&g|0)==0:0)){a=1;return a|0}c:do if(h){if(!i){d=f;break a}g=b&12288;d=g&65535;h=d&16383;if(h<<16>>16<8192)switch(h<<16>>16){case 4096:{o=36;break a}default:{o=25;break c}}else switch(h<<16>>16){case 8192:{o=36;break a}default:{o=25;break c}}}else if(i){d=b&12288;o=25}else i=j;while(0);d:do if((o|0)==25){d=d&16383;if(d<<16>>16<8192)switch(d<<16>>16){case 4096:{i=j;break d}default:{}}else switch(d<<16>>16){case 8192:{i=j;break d}default:{}}i=p&-8|b&7}while(0);h=34448+(j<<3)|0;g=a+256|0;f=c[g>>2]|0;g=c[g+4>>2]|0;d=a+264|0;e=(c[d>>2]^f)&c[h>>2];h=(c[d+4>>2]^g)&c[h+4>>2];d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;C=30544+(d<<3)|0;if(!((c[C>>2]&e|0)==0?(c[C+4>>2]&h|0)==0:0)){a=1;return a|0}B=30544+(i<<3)|0;C=30544+(p<<3)|0;i=(c[B>>2]|e|c[C>>2])^f;h=(c[B+4>>2]|h|c[C+4>>2])^g;C=(c[a+5356>>2]|0)+64|0;if(!((c[C>>2]&i|0)==0?(c[C+4>>2]&h|0)==0:0)){a=0;return a|0}e=28496+(l<<3)|0;B=29008+(l<<3)|0;B=(S(c[e+4>>2]&h,c[B+4>>2]|0)|0)^(S(c[e>>2]&i,c[B>>2]|0)|0);B=(c[1035428+(l<<2)>>2]|0)+(B>>>(c[1035684+(l<<2)>>2]|0)<<3)|0;e=a+320+(k<<3)|0;d=c[e>>2]|0;e=c[e+4>>2]|0;g=a+296|0;f=c[g>>2]|0;g=c[g+4>>2]|0;C=a+288|0;if(!((c[B>>2]&i&d&(c[C>>2]|f)|0)==0?(c[B+4>>2]&h&e&(c[C+4>>2]|g)|0)==0:0)){a=0;return a|0}B=29520+(l<<3)|0;C=30032+(l<<3)|0;C=(S(c[B+4>>2]&h,c[C+4>>2]|0)|0)^(S(c[B>>2]&i,c[C>>2]|0)|0);C=(c[1035940+(l<<2)>>2]|0)+(C>>>(c[1036196+(l<<2)>>2]|0)<<3)|0;a=a+280|0;a=(d&i&c[C>>2]&(c[a>>2]|f)|0)==0?(e&h&c[C+4>>2]&(c[a+4>>2]|g)|0)==0:0;return a|0}else{d=0;o=34}}while(0);if((o|0)==34)if(i){o=b&12288;g=o;f=d;d=o&65535;o=36}do if((o|0)==36){d=d&16383;if(d<<16>>16<8192)switch(d<<16>>16){case 4096:{o=45;break}default:{}}else switch(d<<16>>16){case 8192:{o=45;break}default:{}}if((o|0)==45){if((g|0)!=4096){d=f;break}d=b>>>6;if((b&61440|0)==36864)d=d&15;else d=c[a+((d&63)<<2)>>2]|0;if(!(c[a+4496+(n<<5)+((d&7)<<2)>>2]|0)){a=0;return a|0}a=(c[a+((b&63)<<2)>>2]|0)==0;return a|0}switch(e|0){case 4:{d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))j=64;else o=42;break}case 2:{d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))j=64;else o=42;break}case 1:{d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))j=64;else o=42;break}default:{d=n<<3|6;o=42}}if((o|0)==42)j=c[a+400+(d<<8)>>2]|0;d=b&63;e=a+256|0;B=30544+(p<<3)|0;i=30544+(d-((n|0)==0?8:-8)<<3)|0;d=30544+(d<<3)|0;h=c[d>>2]|c[B>>2]^c[e>>2]^c[i>>2];i=c[d+4>>2]|c[B+4>>2]^c[e+4>>2]^c[i+4>>2];e=28496+(j<<3)|0;B=29008+(j<<3)|0;B=(S(c[e+4>>2]&i,c[B+4>>2]|0)|0)^(S(c[e>>2]&h,c[B>>2]|0)|0);B=(c[1035428+(j<<2)>>2]|0)+(B>>>(c[1035684+(j<<2)>>2]|0)<<3)|0;e=a+320+((n^1)<<3)|0;d=c[e>>2]|0;e=c[e+4>>2]|0;g=a+296|0;f=c[g>>2]|0;g=c[g+4>>2]|0;C=a+288|0;if(!((d&c[B>>2]&(c[C>>2]|f)|0)==0?(e&c[B+4>>2]&(c[C+4>>2]|g)|0)==0:0)){a=0;return a|0}B=29520+(j<<3)|0;C=30032+(j<<3)|0;C=(S(c[B+4>>2]&i,c[C+4>>2]|0)|0)^(S(c[B>>2]&h,c[C>>2]|0)|0);C=(c[1035940+(j<<2)>>2]|0)+(C>>>(c[1036196+(j<<2)>>2]|0)<<3)|0;a=a+280|0;a=(c[C>>2]&d&(c[a>>2]|f)|0)==0?(c[C+4>>2]&e&(c[a+4>>2]|g)|0)==0:0;return a|0}while(0);g=c[a+(p<<2)>>2]|0;if(d?!((m|0)==49152|(g&7|0)!=6):0){y=n^1;d=y<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;x=b&63;f=34448+(d<<3)|0;d=c[f>>2]|0;f=c[f+4>>2]|0;A=30544+(p<<3)|0;z=c[A>>2]|0;A=c[A+4>>2]|0;if(!((z&d|0)==0&(A&f|0)==0)?(C=30544+(x<<3)|0,B=c[C>>2]|0,C=c[C+4>>2]|0,(B&d|0)==0&(C&f|0)==0):0){h=a+256|0;d=c[h>>2]|0;h=c[h+4>>2]|0;I=35984+(x<<3)|0;J=a+320|0;H=a+264|0;N=c[H>>2]|0;H=c[H+4>>2]|0;L=31888+(x<<3)|0;K=a+328|0;F=32400+(x<<3)|0;G=a+272|0;M=c[G>>2]|0;G=c[G+4>>2]|0;j=28496+(x<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;l=29008+(x<<3)|0;k=c[l>>2]|0;l=c[l+4>>2]|0;E=(S(j&h,l)|0)^(S(i&d,k)|0);m=c[1035684+(x<<2)>>2]|0;b=c[1035428+(x<<2)>>2]|0;E=b+(E>>>m<<3)|0;o=a+288|0;w=a+296|0;v=c[w>>2]|0;w=c[w+4>>2]|0;n=v|c[o>>2];o=w|c[o+4>>2];q=29520+(x<<3)|0;p=c[q>>2]|0;q=c[q+4>>2]|0;s=30032+(x<<3)|0;r=c[s>>2]|0;s=c[s+4>>2]|0;D=(S(q&h,s)|0)^(S(p&d,r)|0);t=c[1036196+(x<<2)>>2]|0;u=c[1035940+(x<<2)>>2]|0;D=u+(D>>>t<<3)|0;e=a+280|0;v=c[e>>2]|v;w=c[e+4>>2]|w;x=34448+(x<<3)|0;e=a+304|0;g=a+320+(y<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f&(M|N)&(c[L>>2]&N&c[K>>2]|c[J>>2]&c[I>>2]&N|M&c[F>>2]|n&c[E>>2]|v&c[D>>2]|c[e>>2]&c[x>>2])|0)==0?(g&(G|H)&(c[L+4>>2]&H&c[K+4>>2]|c[J+4>>2]&c[I+4>>2]&H|G&c[F+4>>2]|o&c[E+4>>2]|w&c[D+4>>2]|c[e+4>>2]&c[x+4>>2])|0)==0:0)){N=0;return N|0}e=d^z|B;d=h^A|C;N=b+(((S(j&d,l)|0)^(S(i&e,k)|0))>>>m<<3)|0;if(!((f&n&c[N>>2]|0)==0?(g&o&c[N+4>>2]|0)==0:0)){N=0;return N|0}N=u+(((S(q&d,s)|0)^(S(p&e,r)|0))>>>t<<3)|0;N=(f&v&c[N>>2]|0)==0?(g&w&c[N+4>>2]|0)==0:0;return N|0}}if((g&7|0)==6){if((m|0)==49152){N=1;return N|0}M=b&63;N=a+256|0;I=c[N>>2]|0;N=c[N+4>>2]|0;C=35984+(M<<3)|0;B=a+320|0;D=a+264|0;x=c[D>>2]|0;D=c[D+4>>2]|0;z=31888+(M<<3)|0;A=a+328|0;F=32400+(M<<3)|0;E=a+272|0;G=28496+(M<<3)|0;H=29008+(M<<3)|0;H=(S(c[G+4>>2]&N,c[H+4>>2]|0)|0)^(S(c[G>>2]&I,c[H>>2]|0)|0);H=(c[1035428+(M<<2)>>2]|0)+(H>>>(c[1035684+(M<<2)>>2]|0)<<3)|0;G=a+288|0;J=a+296|0;y=c[J>>2]|0;J=c[J+4>>2]|0;L=29520+(M<<3)|0;K=30032+(M<<3)|0;K=(S(c[L+4>>2]&N,c[K+4>>2]|0)|0)^(S(c[L>>2]&I,c[K>>2]|0)|0);K=(c[1035940+(M<<2)>>2]|0)+(K>>>(c[1036196+(M<<2)>>2]|0)<<3)|0;I=a+280|0;M=34448+(M<<3)|0;L=a+304|0;N=a+320+((n^1)<<3)|0;N=((c[z>>2]&x&c[A>>2]|c[B>>2]&c[C>>2]&x|c[E>>2]&c[F>>2]|(y|c[G>>2])&c[H>>2]|(c[I>>2]|y)&c[K>>2]|c[L>>2]&c[M>>2])&c[N>>2]|0)==0?((c[z+4>>2]&D&c[A+4>>2]|c[B+4>>2]&c[C+4>>2]&D|c[E+4>>2]&c[F+4>>2]|(J|c[G+4>>2])&c[H+4>>2]|(c[I+4>>2]|J)&c[K+4>>2]|c[L+4>>2]&c[M+4>>2])&c[N+4>>2]|0)==0:0;return N|0}M=(c[a+5356>>2]|0)+344+(n<<3)|0;L=a+320+(n<<3)|0;N=30544+(p<<3)|0;if((c[L>>2]&c[M>>2]&c[N>>2]|0)==0?(c[L+4>>2]&c[M+4>>2]&c[N+4>>2]|0)==0:0){N=1;return N|0}f=b&63;switch(e|0){case 4:{d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else o=69;break}case 2:{d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else o=69;break}case 1:{d=n<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else o=69;break}default:{d=n<<3|6;o=69}}if((o|0)==69)d=c[a+400+(d<<8)>>2]|0;N=72336+(p<<9)+(f<<3)|0;M=30544+(d<<3)|0;N=c[M>>2]&c[N>>2]|0?1:(c[M+4>>2]&c[N+4>>2]|0)!=0;return N|0}function Rf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=b&49152;o=(n|0)==32768;if(o){e=b>>>6;d=b&63;if((b&12288|0)==4096){a=(c[a+5356>>2]|0)+376+((e&7)<<3)|0;C=30544+(d<<3)|0;a=c[C>>2]&c[a>>2]|0?1:(c[C+4>>2]&c[a+4>>2]|0)!=0;return a|0}else p=e}else{d=b&63;p=b>>>6}r=p&63;q=a+5364|0;s=c[q>>2]|0;a:do switch(s|0){case 4:{if(!(c[a+336+((c[a+5348>>2]<<3^14)<<2)>>2]|0)){a=0;return a|0}else t=28;break}case 2:{C=c[a+5348>>2]|0;e=C<<3^14;if(!(c[a+336+(e<<2)>>2]|0)){a=0;return a|0}j=c[a+400+(e<<8)>>2]|0;if((j|0)==64){a=0;return a|0}h=c[a+(r<<2)>>2]|0;B=34448+(j<<3)|0;A=c[B>>2]|0;B=c[B+4>>2]|0;if((h&7|0)==6){y=30544+(d<<3)|0;e=c[y>>2]|0;y=c[y+4>>2]|0;if(!((e&A|0)==0&(y&B|0)==0)){a=0;return a|0}z=30544+(r<<3)|0;x=c[z>>2]|0;z=c[z+4>>2]|0;if(!((x&A|0)==0&(z&B|0)==0)){k=a+256|0;d=c[k>>2]|0;k=c[k+4>>2]|0;K=35984+(j<<3)|0;L=a+320|0;J=a+264|0;P=c[J>>2]|0;J=c[J+4>>2]|0;N=31888+(j<<3)|0;M=a+328|0;H=32400+(j<<3)|0;I=a+272|0;O=c[I>>2]|0;I=c[I+4>>2]|0;m=28496+(j<<3)|0;l=c[m>>2]|0;m=c[m+4>>2]|0;o=29008+(j<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;G=(S(m&k,o)|0)^(S(l&d,n)|0);p=c[1035684+(j<<2)>>2]|0;b=c[1035428+(j<<2)>>2]|0;G=b+(G>>>p<<3)|0;r=a+288|0;E=a+296|0;i=c[E>>2]|0;E=c[E+4>>2]|0;q=i|c[r>>2];r=E|c[r+4>>2];t=29520+(j<<3)|0;s=c[t>>2]|0;t=c[t+4>>2]|0;v=30032+(j<<3)|0;u=c[v>>2]|0;v=c[v+4>>2]|0;F=(S(t&k,v)|0)^(S(s&d,u)|0);w=c[1036196+(j<<2)>>2]|0;h=c[1035940+(j<<2)>>2]|0;F=h+(F>>>w<<3)|0;j=a+280|0;i=c[j>>2]|i;j=c[j+4>>2]|E;E=a+304|0;g=a+320+(C<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if(!((f&(O|P)&(c[N>>2]&P&c[M>>2]|c[L>>2]&c[K>>2]&P|O&c[H>>2]|q&c[G>>2]|i&c[F>>2]|c[E>>2]&A)|0)==0?(g&(I|J)&(c[N+4>>2]&J&c[M+4>>2]|c[L+4>>2]&c[K+4>>2]&J|I&c[H+4>>2]|r&c[G+4>>2]|j&c[F+4>>2]|c[E+4>>2]&B)|0)==0:0)){P=1;return P|0}e=d^x|e;d=k^z|y;P=b+(((S(m&d,o)|0)^(S(l&e,n)|0))>>>p<<3)|0;if(!((f&q&c[P>>2]|0)==0?(g&r&c[P+4>>2]|0)==0:0)){P=1;return P|0}P=h+(((S(t&d,v)|0)^(S(s&e,u)|0))>>>w<<3)|0;P=f&i&c[P>>2]|0?1:(g&j&c[P+4>>2]|0)!=0;return P|0}}else{e=C<<3|6;if(!(c[a+336+(e<<2)>>2]|0))e=64;else e=c[a+400+(e<<8)>>2]|0;P=30544+(e<<3)|0;if(!((c[P>>2]&A|0)==0?(c[P+4>>2]&B|0)==0:0)){P=0;return P|0}}b:do if((n|0)==49152?1:(c[a+(d<<2)>>2]|0)==0){if(!o){e=h;break a}f=b&12288;e=f&65535;g=e&16383;if(g<<16>>16<8192)switch(g<<16>>16){case 4096:break;default:{t=23;break b}}else switch(g<<16>>16){case 8192:break;default:{t=23;break b}}if((f|0)==4096){t=31;break a}else{e=h;break a}}else if(o){e=b&12288;t=23}else h=d;while(0);c:do if((t|0)==23){e=e&16383;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:{h=d;break c}default:{}}else switch(e<<16>>16){case 8192:{h=d;break c}default:{}}h=p&56|d&7}while(0);g=34448+(d<<3)|0;f=a+256|0;d=c[f>>2]|0;f=c[f+4>>2]|0;P=a+264|0;e=(c[P>>2]^d)&c[g>>2];g=(c[P+4>>2]^f)&c[g+4>>2];P=30544+(j<<3)|0;if(!((e&c[P>>2]|0)==0?(g&c[P+4>>2]|0)==0:0)){P=0;return P|0}O=30544+(h<<3)|0;h=30544+(r<<3)|0;i=(c[O>>2]|e|c[h>>2])^d;h=(c[O+4>>2]|g|c[h+4>>2])^f;e=28496+(j<<3)|0;O=29008+(j<<3)|0;O=(S(h&c[e+4>>2],c[O+4>>2]|0)|0)^(S(i&c[e>>2],c[O>>2]|0)|0);O=(c[1035428+(j<<2)>>2]|0)+(O>>>(c[1035684+(j<<2)>>2]|0)<<3)|0;e=a+320+(C<<3)|0;d=c[e>>2]|0;e=c[e+4>>2]|0;g=a+296|0;f=c[g>>2]|0;g=c[g+4>>2]|0;P=a+288|0;if(!((c[O>>2]&i&d&(c[P>>2]|f)|0)==0?(c[O+4>>2]&h&e&(c[P+4>>2]|g)|0)==0:0)){P=1;return P|0}P=29520+(j<<3)|0;O=30032+(j<<3)|0;O=(S(c[P+4>>2]&h,c[O+4>>2]|0)|0)^(S(c[P>>2]&i,c[O>>2]|0)|0);O=(c[1035940+(j<<2)>>2]|0)+(O>>>(c[1036196+(j<<2)>>2]|0)<<3)|0;P=a+280|0;P=d&i&c[O>>2]&(c[P>>2]|f)|0?1:(e&h&c[O+4>>2]&(c[P+4>>2]|g)|0)!=0;return P|0}case 1:{P=0;return P|0}default:t=28}while(0);if((t|0)==28)if((b&61440|0)==36864)t=31;else e=c[a+(r<<2)>>2]|0;if((t|0)==31)e=b>>>6&15;f=c[a+5356>>2]|0;P=f+376+((e&7)<<3)|0;l=30544+(d<<3)|0;k=c[l>>2]|0;l=c[l+4>>2]|0;if(!((k&c[P>>2]|0)==0?(l&c[P+4>>2]|0)==0:0)){P=1;return P|0}j=b&61440;d:do if((j|0)!=36864){g=a+5348|0;i=c[g>>2]|0;m=i^1;P=f+344+(m<<3)|0;O=a+320+(i<<3)|0;e=30544+(r<<3)|0;f=c[e>>2]|0;e=c[e+4>>2]|0;if(!((c[O>>2]&c[P>>2]&f|0)==0?(c[O+4>>2]&c[P+4>>2]&e|0)==0:0)){switch(s|0){case 4:{h=m<<3|6;if(!(c[a+336+(h<<2)>>2]|0))h=64;else t=40;break}case 2:{h=m<<3|6;if(!(c[a+336+(h<<2)>>2]|0))h=64;else t=40;break}case 1:{h=m<<3|6;if(!(c[a+336+(h<<2)>>2]|0))h=64;else t=40;break}default:{h=m<<3|6;t=40}}if((t|0)==40)h=c[a+400+(h<<8)>>2]|0;P=72336+(r<<9)+(d<<3)|0;O=30544+(h<<3)|0;if((c[O>>2]&c[P>>2]|0)==0?(c[O+4>>2]&c[P+4>>2]|0)==0:0){P=1;return P|0}}if(!o){h=n&65535;if(h<<16>>16>=16384){switch(h<<16>>16){case 16384:break d;default:d=0}return d|0}switch(h<<16>>16){case -16384:break;default:{P=0;return P|0}}h=d>>>0>r>>>0;j=i*56|0;g=j|(h?6:2);h=j|(h?5:3);j=114320+(h<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;switch(s|0){case 4:{d=m<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=71;break}case 2:{d=m<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=71;break}case 1:{d=m<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=71;break}default:{d=m<<3|6;t=71}}if((t|0)==71)d=c[a+400+(d<<8)>>2]|0;P=30544+(d<<3)|0;if((c[P>>2]&i|0)==0?(c[P+4>>2]&j|0)==0:0){P=0;return P|0}N=a+256|0;M=30544+(h<<3)|0;O=30544+(g<<3)|0;L=28496+(h<<3)|0;P=29008+(h<<3)|0;f=(S(c[L+4>>2]&(c[M+4>>2]|e^c[N+4>>2]^l|c[O+4>>2]),c[P+4>>2]|0)|0)^(S(c[L>>2]&(c[M>>2]|f^c[N>>2]^k|c[O>>2]),c[P>>2]|0)|0);f=(c[1035428+(h<<2)>>2]|0)+(f>>>(c[1035684+(h<<2)>>2]|0)<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;switch(s|0){case 4:{d=m<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=78;break}case 2:{d=m<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=78;break}case 1:{d=m<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=78;break}default:{d=m<<3|6;t=78}}if((t|0)==78)d=c[a+400+(d<<8)>>2]|0;P=30544+(d<<3)|0;P=c[P>>2]&e|0?1:(c[P+4>>2]&f|0)!=0;return P|0}else t=43}else t=43;while(0);e:do if((t|0)==43){e=b&12288;f:do if(e<<16>>16<8192){switch(e<<16>>16){case 4096:{d=0;break}default:break f}return d|0}else{switch(e<<16>>16){case 8192:break;default:break f}e=30544+(r<<3)|0;g=a+5348|0;f=c[e>>2]|0;e=c[e+4>>2]|0;break e}while(0);P=a+256|0;O=30544+(r<<3)|0;e=30544+((p&56|d&7)<<3)|0;m=k|c[O>>2]^c[P>>2]^c[e>>2];l=l|c[O+4>>2]^c[P+4>>2]^c[e+4>>2];e=c[a+5348>>2]|0;k=e^1;switch(s|0){case 4:{d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=58;break}case 2:{d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=58;break}case 1:{d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=58;break}default:{d=k<<3|6;t=58}}if((t|0)==58)d=c[a+400+(d<<8)>>2]|0;f=28496+(d<<3)|0;P=29008+(d<<3)|0;P=(S(c[f+4>>2]&l,c[P+4>>2]|0)|0)^(S(c[f>>2]&m,c[P>>2]|0)|0);P=(c[1035428+(d<<2)>>2]|0)+(P>>>(c[1035684+(d<<2)>>2]|0)<<3)|0;f=a+320+(e<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;h=a+296|0;g=c[h>>2]|0;h=c[h+4>>2]|0;j=a+288|0;i=e&c[P>>2]&(c[j>>2]|g);j=f&c[P+4>>2]&(c[j+4>>2]|h);switch(s|0){case 4:{d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=64;break}case 2:{d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=64;break}case 1:{d=k<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=64;break}default:{d=k<<3|6;t=64}}if((t|0)==64)d=c[a+400+(d<<8)>>2]|0;P=29520+(d<<3)|0;O=30032+(d<<3)|0;O=(S(c[P+4>>2]&l,c[O+4>>2]|0)|0)^(S(c[P>>2]&m,c[O>>2]|0)|0);O=(c[1035940+(d<<2)>>2]|0)+(O>>>(c[1036196+(d<<2)>>2]|0)<<3)|0;P=a+280|0;P=e&c[O>>2]&(c[P>>2]|g)|i|0?1:(f&c[O+4>>2]&(c[P+4>>2]|h)|j|0)!=0;return P|0}while(0);P=a+256|0;e=Cb((j|0)==40960?6:(b>>>12&3)+2|0,d,f^c[P>>2],e^c[P+4>>2])|0;f=D;d=c[g>>2]^1;switch(c[q>>2]|0){case 4:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=51;break}case 2:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=51;break}case 1:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else t=51;break}default:{d=d<<3|6;t=51}}if((t|0)==51)d=c[a+400+(d<<8)>>2]|0;P=30544+(d<<3)|0;P=c[P>>2]&e|0?1:(c[P+4>>2]&f|0)!=0;return P|0}function Sf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;F=l;l=l+4112|0;d=F;q=a+5348|0;B=c[q>>2]|0;u=b&49152;v=(u|0)==32768;if(v){A=b>>>6;e=A;A=(b&12288|0)==4096?64:A&63}else{A=b>>>6;e=A;A=A&63}z=b&63;t=b&61440;w=(t|0)==36864;if(w)y=e&15;else y=c[a+((e&63)<<2)>>2]|0;if(zd(a)|0){a=0;l=F;return a|0}x=a+5364|0;o=c[x>>2]|0;a:do switch(o|0){case 2:{if(!((y|0)!=0&(y>>3|0)==(B|0))){a=0;l=F;return a|0}b:do if((u|0)==49152?1:(c[a+(z<<2)>>2]|0)==0){if(!v){k=50;break a}e=b&12288;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:{k=49;break a}default:break b}else switch(e<<16>>16){case 8192:{k=49;break a}default:break b}}while(0);g=y&7;if((g|0)==6){a=0;l=F;return a|0}e=B<<3|6;if(!(c[a+336+(e<<2)>>2]|0))n=64;else n=c[a+400+(e<<8)>>2]|0;m=a+320+(B<<3)|0;f=30544+(z<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e&c[m>>2]|0)==0?(f&c[m+4>>2]|0)==0:0)){a=0;l=F;return a|0}m=34448+(n<<3)|0;if(!((c[m>>2]&e|0)==0?(c[m+4>>2]&f|0)==0:0)){a=0;l=F;return a|0}m=B^1;e=m<<3|6;if(!(c[a+336+(e<<2)>>2]|0))e=64;else e=c[a+400+(e<<8)>>2]|0;k=34448+(e<<3)|0;j=30544+(n<<3)|0;if((c[j>>2]&c[k>>2]|0)==0?(c[j+4>>2]&c[k+4>>2]|0)==0:0){if((g|0)==1?((A^b)&7|0)==0:0){a=0;l=F;return a|0}c:do if(v){e=b&12288;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:{h=z;break c}default:{}}else switch(e<<16>>16){case 8192:{h=z;break c}default:{}}h=A&-8|b&7}else h=z;while(0);j=34448+(z<<3)|0;i=a+256|0;f=c[i>>2]|0;i=c[i+4>>2]|0;e=a+264|0;g=(c[e>>2]^f)&c[j>>2];j=(c[e+4>>2]^i)&c[j+4>>2];e=m<<3|6;if(!(c[a+336+(e<<2)>>2]|0))e=64;else e=c[a+400+(e<<8)>>2]|0;k=30544+(e<<3)|0;if(!((c[k>>2]&g|0)==0?(c[k+4>>2]&j|0)==0:0)){a=1;l=F;return a|0}e=30544+(h<<3)|0;h=30544+(A<<3)|0;k=(c[e>>2]|g|c[h>>2])^f;i=(c[e+4>>2]|j|c[h+4>>2])^i;j=(c[a+5356>>2]|0)+64|0;if(!((c[j>>2]&k|0)==0?(c[j+4>>2]&i|0)==0:0)){a=0;l=F;return a|0}f=28496+(n<<3)|0;j=29008+(n<<3)|0;j=(S(c[f+4>>2]&i,c[j+4>>2]|0)|0)^(S(c[f>>2]&k,c[j>>2]|0)|0);j=(c[1035428+(n<<2)>>2]|0)+(j>>>(c[1035684+(n<<2)>>2]|0)<<3)|0;f=a+320+(m<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;h=a+296|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+288|0;if(!((c[j>>2]&k&e&(c[m>>2]|g)|0)==0?(c[j+4>>2]&i&f&(c[m+4>>2]|h)|0)==0:0)){a=0;l=F;return a|0}j=29520+(n<<3)|0;m=30032+(n<<3)|0;m=(S(c[j+4>>2]&i,c[m+4>>2]|0)|0)^(S(c[j>>2]&k,c[m>>2]|0)|0);m=(c[1035940+(n<<2)>>2]|0)+(m>>>(c[1036196+(n<<2)>>2]|0)<<3)|0;n=a+280|0;if(!((e&k&c[m>>2]&(c[n>>2]|g)|0)==0?(f&i&c[m+4>>2]&(c[n+4>>2]|h)|0)==0:0)){a=0;l=F;return a|0}}if((o|0)==1)k=33;else{r=o;k=43}break}case 1:{k=33;break}default:{r=o;k=43}}while(0);d:do if((k|0)==33)if((u|0)==49152?1:(c[a+(z<<2)>>2]|0)==0){e:do if(v){e=b&12288;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:break e;default:{k=49;break d}}else switch(e<<16>>16){case 8192:break e;default:{k=49;break d}}}while(0);e=c[(c[a+5356>>2]|0)+48>>2]|0;if((e|0)!=64){f=a+256|0;m=f;i=c[m>>2]|0;m=c[m+4>>2]|0;J=35984+(e<<3)|0;K=a+320|0;o=a+264|0;N=c[o>>2]|0;o=c[o+4>>2]|0;M=31888+(e<<3)|0;L=a+328|0;H=32400+(e<<3)|0;I=a+272|0;G=28496+(e<<3)|0;h=29008+(e<<3)|0;h=(S(c[G+4>>2]&m,c[h+4>>2]|0)|0)^(S(c[G>>2]&i,c[h>>2]|0)|0);h=(c[1035428+(e<<2)>>2]|0)+(h>>>(c[1035684+(e<<2)>>2]|0)<<3)|0;G=a+288|0;j=a+296|0;O=c[j>>2]|0;j=c[j+4>>2]|0;n=29520+(e<<3)|0;k=30032+(e<<3)|0;k=(S(c[n+4>>2]&m,c[k+4>>2]|0)|0)^(S(c[n>>2]&i,c[k>>2]|0)|0);k=(c[1035940+(e<<2)>>2]|0)+(k>>>(c[1036196+(e<<2)>>2]|0)<<3)|0;i=a+280|0;n=34448+(e<<3)|0;m=a+304|0;g=a+320+(c[q>>2]<<3)|0;e=c[g>>2]|0;g=c[g+4>>2]|0;if(!(((c[M>>2]&N&c[L>>2]|c[K>>2]&c[J>>2]&N|c[I>>2]&c[H>>2]|(O|c[G>>2])&c[h>>2]|(c[i>>2]|O)&c[k>>2]|c[m>>2]&c[n>>2])&N&e|0)==0?((c[M+4>>2]&o&c[L+4>>2]|c[K+4>>2]&c[J+4>>2]&o|c[I+4>>2]&c[H+4>>2]|(j|c[G+4>>2])&c[h+4>>2]|(c[i+4>>2]|j)&c[k+4>>2]|c[m+4>>2]&c[n+4>>2])&o&g|0)==0:0)){O=0;l=F;return O|0}}else{g=a+320+(c[q>>2]<<3)|0;f=a+256|0;e=c[g>>2]|0;g=c[g+4>>2]|0}while(1){if((e|0)==0&(g|0)==0){k=42;break}O=Qa(e|0,g|0,0)|0;h=Yu(e|0,g|0,-1,-1)|0;g=D&g;N=f;N=Cb(c[a+(O<<2)>>2]|0,O,c[N>>2]|0,c[N+4>>2]|0)|0;O=a+320+((c[q>>2]^1)<<3)|0;if(!((c[O>>2]&N|0)==0?(c[O+4>>2]&D|0)==0:0)){p=0;k=91;break}else e=h&e}if((k|0)==42){r=c[x>>2]|0;k=43;break}else if((k|0)==91){l=F;return p|0}}else k=48;while(0);f:do if((k|0)==43)if((r|0)==6?((u|0)==49152?1:(c[a+(z<<2)>>2]|0)==0):0){g:do if(v){e=b&12288;f=e&16383;if(f<<16>>16<8192)switch(f<<16>>16){case 4096:break g;default:{s=e;k=51;break f}}else switch(f<<16>>16){case 8192:break g;default:{s=e;k=51;break f}}}while(0);if(Te(a)|0){O=0;l=F;return O|0}else k=48}else k=48;while(0);if((k|0)==48)if(v)k=49;else k=50;if((k|0)==49){s=b&12288;k=51}else if((k|0)==50)if(!u){if(!((y>>3|0)==(B|0)&(((t|0)==40960|(b&12288|0)!=0|(y|0)==0)^1))){O=0;l=F;return O|0}}else k=52;if((k|0)==51)if((s|0)==4096){if(!((y|0)!=0&(y>>3|0)==(B|0))){O=0;l=F;return O|0}}else k=52;if((k|0)==52){e=kf(a,d)|0;c[d+4096>>2]=e;if((d|0)==(e|0)){O=0;l=F;return O|0}while(1){if((c[d>>2]|0)==(b|0)){p=1;k=91;break}d=d+8|0;if((d|0)==(e|0)){p=0;k=91;break}}if((k|0)==91){l=F;return p|0}}if(w){if(!(c[a+4496+(B<<5)+((y&7)<<2)>>2]|0)){O=0;l=F;return O|0}if(c[a+(z<<2)>>2]|0){O=0;l=F;return O|0}}O=a+320+(B<<3)|0;d=30544+(z<<3)|0;e=d;g=c[e>>2]|0;e=c[e+4>>2]|0;if(!((g&c[O>>2]|0)==0?(e&c[O+4>>2]|0)==0:0)){O=0;l=F;return O|0}do if(!w){if((y&7|0)!=1){O=a+256|0;O=Cb(y,A,c[O>>2]|0,c[O+4>>2]|0)|0;e=d;d=c[e>>2]|0;e=c[e+4>>2]|0;if((d&O|0)==0&(e&D|0)==0)p=0;else{g=d;break}l=F;return p|0}d=B*7|0;if((z>>>3|0)==(d^7|0)){O=0;l=F;return O|0}O=31376+((B<<3|1)<<9)+(A<<3)|0;N=a+320+((B^1)<<3)|0;if((c[N>>2]&c[O>>2]&g|0)==0?(c[N+4>>2]&c[O+4>>2]&e|0)==0:0){f=(B|0)==0?8:-8;if((A+f|0)==(z|0)?(c[a+(z<<2)>>2]|0)==0:0)break;if((A+(f<<1)|0)!=(z|0)){O=0;l=F;return O|0}if((A>>3|0)!=(d^1|0)){O=0;l=F;return O|0}if(c[a+(z<<2)>>2]|0){O=0;l=F;return O|0}if(c[a+(z-f<<2)>>2]|0){O=0;l=F;return O|0}}}while(0);j=c[x>>2]|0;if((j|0)==2){f=B<<3;d=f^14;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;i=34448+(d<<3)|0;h=c[i>>2]|0;i=c[i+4>>2]|0;if((y&7|0)!=6){d=f|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0}else d=z;O=30544+(d<<3)|0;if(!((c[O>>2]&h|0)==0?(c[O+4>>2]&i|0)==0:0)){O=1;l=F;return O|0}}i=(c[a+5356>>2]|0)+64|0;h=c[i>>2]|0;i=c[i+4>>2]|0;do if(!((h|0)==0&(i|0)==0)){if((y&7|0)==6){M=a+256|0;A=30544+(A<<3)|0;J=c[A>>2]^c[M>>2];M=c[A+4>>2]^c[M+4>>2];A=35984+(z<<3)|0;y=a+320|0;C=a+264|0;v=c[C>>2]|0;C=c[C+4>>2]|0;w=31888+(z<<3)|0;x=a+328|0;G=32400+(z<<3)|0;E=a+272|0;H=28496+(z<<3)|0;I=29008+(z<<3)|0;I=(S(c[H+4>>2]&M,c[I+4>>2]|0)|0)^(S(c[H>>2]&J,c[I>>2]|0)|0);I=(c[1035428+(z<<2)>>2]|0)+(I>>>(c[1035684+(z<<2)>>2]|0)<<3)|0;H=a+288|0;K=a+296|0;b=c[K>>2]|0;K=c[K+4>>2]|0;N=29520+(z<<3)|0;L=30032+(z<<3)|0;L=(S(c[N+4>>2]&M,c[L+4>>2]|0)|0)^(S(c[N>>2]&J,c[L>>2]|0)|0);L=(c[1035940+(z<<2)>>2]|0)+(L>>>(c[1036196+(z<<2)>>2]|0)<<3)|0;J=a+280|0;N=34448+(z<<3)|0;M=a+304|0;O=a+320+((B^1)<<3)|0;if(((c[w>>2]&v&c[x>>2]|c[y>>2]&c[A>>2]&v|c[E>>2]&c[G>>2]|(b|c[H>>2])&c[I>>2]|(c[J>>2]|b)&c[L>>2]|c[M>>2]&c[N>>2])&c[O>>2]|0)==0?((c[w+4>>2]&C&c[x+4>>2]|c[y+4>>2]&c[A+4>>2]&C|c[E+4>>2]&c[G+4>>2]|(K|c[H+4>>2])&c[I+4>>2]|(c[J+4>>2]|K)&c[L+4>>2]|c[M+4>>2]&c[N+4>>2])&c[O+4>>2]|0)==0:0)break;else p=0;l=F;return p|0}O=Yu(h|0,i|0,-1,-1)|0;if(!((O&h|0)==0&(D&i|0)==0)){O=0;l=F;return O|0}f=Qa(h|0,i|0,0)|0;switch(j|0){case 4:{d=B<<3|6;if(!(c[a+336+(d<<2)>>2]|0))C=64;else{E=d;k=87}break}case 2:{d=B<<3|6;if(!(c[a+336+(d<<2)>>2]|0))C=64;else{E=d;k=87}break}case 1:{d=B<<3|6;if(!(c[a+336+(d<<2)>>2]|0))C=64;else{E=d;k=87}break}default:{E=B<<3|6;k=87}}if((k|0)==87)C=c[a+400+(E<<8)>>2]|0;O=39568+(f<<9)+(C<<3)|0;if((g&(h|c[O>>2])|0)==0?(e&(i|c[O+4>>2])|0)==0:0){O=0;l=F;return O|0}}while(0);O=1;l=F;return O|0}function Tf(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;P=l;l=l+16|0;O=P+8|0;j=P+4|0;k=P;K=b+5336|0;h=K;h=Yu(c[h>>2]|0,c[h+4>>2]|0,1,0)|0;c[K>>2]=h;c[K+4>>2]=D;K=b+5356|0;h=c[K>>2]|0;v=h+56|0;g=985952;n=c[g>>2]^c[v>>2];v=c[g+4>>2]^c[v+4>>2];g=e;i=g+56|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(i|0));c[e+336>>2]=c[K>>2];c[K>>2]=e;N=b+5344|0;c[N>>2]=(c[N>>2]|0)+1;N=e+28|0;c[N>>2]=(c[N>>2]|0)+1;N=e+32|0;c[N>>2]=(c[N>>2]|0)+1;N=b+5348|0;M=c[N>>2]|0;L=M^1;I=d&49152;J=(I|0)==32768;do if(J){h=d&12288;g=d>>>6;m=(h|0)==4096?64:g&63;j=d&63;c[O>>2]=j;h=h&16383;a:do if(h<<16>>16<8192){switch(h<<16>>16){case 4096:break;default:{H=5;break a}}i=g&15;H=6}else{switch(h<<16>>16){case 8192:break;default:{H=5;break a}}i=c[b+(m<<2)>>2]|0;H=6}while(0);if((H|0)==5){g=L<<3|1;x=O;A=m;i=c[b+(m<<2)>>2]|0;H=11;break}else if((H|0)==6){g=c[b+(j<<2)>>2]|0;h=j;k=O;H=9;break}}else{m=d>>>6&63;h=d&63;c[O>>2]=h;i=c[b+(m<<2)>>2]|0;g=c[b+(h<<2)>>2]|0;if((I|0)==49152){Uf(b,M,m,O,j,k);H=c[K>>2]|0;p=H+44|0;o=c[k>>2]|0;r=b+5364|0;s=c[r>>2]|0;k=c[j>>2]|0;c[p>>2]=(c[1045948+(s*4160|0)+(g*260|0)+(o<<2)>>2]|0)-(c[1045948+(s*4160|0)+(g*260|0)+(k<<2)>>2]|0)+(c[p>>2]|0);k=977568+(g<<9)+(k<<3)|0;o=977568+(g<<9)+(o<<3)|0;p=0;s=0;q=i;n=c[k>>2]^n^c[o>>2];o=c[k+4>>2]^v^c[o+4>>2];k=H;H=40}else{k=O;H=9}}while(0);if((H|0)==9)if(!g){p=0;r=b+5364|0;s=0;q=i;o=v;k=e;H=40}else{j=h;x=k;A=m;H=11}if((H|0)==11){m=g&7;if((m|0)==1){b:do if(J){h=d&12288;if(h<<16>>16<8192)switch(h<<16>>16){case 4096:{k=j;h=e;break b}default:{}}else switch(h<<16>>16){case 8192:{k=j;h=e;break b}default:{}}k=j-((M|0)==0?8:-8)|0;c[b+(k<<2)>>2]=0;h=c[K>>2]|0}else{k=j;h=e}while(0);t=977568+(g<<9)+(k<<3)|0;e=h;u=c[e+4>>2]^c[t+4>>2];z=h;c[z>>2]=c[e>>2]^c[t>>2];c[z+4>>2]=u}else{k=e+16+(L<<2)|0;c[k>>2]=(c[k>>2]|0)-(c[11108+(g<<2)>>2]|0);k=j}u=b+256|0;e=30544+(k<<3)|0;t=e;z=u;s=c[z+4>>2]^c[t+4>>2];h=u;c[h>>2]=c[z>>2]^c[t>>2];c[h+4>>2]=s;h=b+256+(m<<3)|0;s=e;t=h;z=c[t+4>>2]^c[s+4>>2];c[h>>2]=c[t>>2]^c[s>>2];c[h+4>>2]=z;h=g>>3;z=b+320+(h<<3)|0;s=z;t=c[s+4>>2]^c[e+4>>2];c[z>>2]=c[s>>2]^c[e>>2];c[z+4>>2]=t;z=b+5364|0;if((c[z>>2]|0)==2)c[b+(k<<2)>>2]=0;t=b+336+(g<<2)|0;o=(c[t>>2]|0)+-1|0;c[t>>2]=o;o=c[b+400+(g<<8)+(o<<2)>>2]|0;p=c[b+4568+(k<<2)>>2]|0;c[b+4568+(o<<2)>>2]=p;c[b+400+(g<<8)+(p<<2)>>2]=o;c[b+400+(g<<8)+(c[t>>2]<<2)>>2]=64;p=h<<3;o=b+336+(p<<2)|0;c[o>>2]=(c[o>>2]|0)+-1;o=c[z>>2]|0;if((o|0)==3){r=b+4560|0;m=r;e=30544+(j<<3)|0;s=c[e>>2]|0;e=c[e+4>>2]|0;h=s&c[m>>2];m=e&c[m+4>>2];q=c[K>>2]|0;a[q+332>>0]=((h|0)!=0|(m|0)!=0)&1;if((c[b+5368>>2]|0)==10){o=3;h=v}else{h=(h|0)==0&(m|0)==0?g:p|1;m=h^8;q=m>>3;h=b+4496+(q<<5)+((h&7)<<2)|0;c[h>>2]=(c[h>>2]|0)+1;q=b+4496+(q<<5)|0;c[q>>2]=(c[q>>2]|0)+1;q=c[K>>2]|0;p=q+44|0;o=c[z>>2]|0;c[p>>2]=(c[p>>2]|0)+(c[1045948+(o*4160|0)+(m*260|0)+256>>2]|0);h=c[h>>2]|0;p=986040+(m*136|0)+(h+-1<<3)|0;h=986040+(m*136|0)+(h<<3)|0;n=c[p>>2]^n^c[h>>2];h=c[p+4>>2]^v^c[h+4>>2]}p=r;v=c[p+4>>2]&~e;m=r;c[m>>2]=c[p>>2]&~s;c[m+4>>2]=v;m=h}else{m=v;q=c[K>>2]|0}e=977568+(g<<9)+(k<<3)|0;h=c[e>>2]^n;m=c[e+4>>2]^m;e=977568+(g<<9)+(c[t>>2]<<3)|0;v=q+8|0;s=v;t=c[s+4>>2]^c[e+4>>2];c[v>>2]=c[s>>2]^c[e>>2];c[v+4>>2]=t;c:do if((o|0)==2?(v=34448+(j<<3)|0,y=30544+(A<<3)|0,w=c[v>>2]&~c[y>>2],y=c[v+4>>2]&~c[y+4>>2],!((w|0)==0&(y|0)==0)):0){o=w;n=y;while(1){s=o;e=n;while(1){r=Qa(s|0,e|0,0)|0;n=Yu(s|0,e|0,-1,-1)|0;s=n&s;e=D&e;n=b+(r<<2)|0;p=c[n>>2]|0;c[q+76+(r<<2)>>2]=p;if(p|0?(B=p&7,(B|0)!=1):0)break;if((s|0)==0&(e|0)==0){n=h;break c}}o=p>>3;v=q+16+(o<<2)|0;c[v>>2]=(c[v>>2]|0)-(c[11108+(B<<2)>>2]|0);v=30544+(r<<3)|0;q=v;t=u;w=c[t+4>>2]^c[q+4>>2];y=u;c[y>>2]=c[t>>2]^c[q>>2];c[y+4>>2]=w;y=b+256+(B<<3)|0;w=v;q=y;t=c[q+4>>2]^c[w+4>>2];c[y>>2]=c[q>>2]^c[w>>2];c[y+4>>2]=t;y=b+320+(o<<3)|0;t=y;w=c[t+4>>2]^c[v+4>>2];c[y>>2]=c[t>>2]^c[v>>2];c[y+4>>2]=w;if((c[z>>2]|0)==2)c[n>>2]=0;y=b+336+(p<<2)|0;n=(c[y>>2]|0)+-1|0;c[y>>2]=n;n=c[b+400+(p<<8)+(n<<2)>>2]|0;q=c[b+4568+(r<<2)>>2]|0;c[b+4568+(n<<2)>>2]=q;c[b+400+(p<<8)+(q<<2)>>2]=n;c[b+400+(p<<8)+(c[y>>2]<<2)>>2]=64;q=b+336+(o<<3<<2)|0;c[q>>2]=(c[q>>2]|0)+-1;q=977568+(p<<9)+(r<<3)|0;h=c[q>>2]^h;m=c[q+4>>2]^m;y=977568+(p<<9)+(c[y>>2]<<3)|0;q=c[K>>2]|0;n=q+8|0;w=n;o=c[w+4>>2]^c[y+4>>2];c[n>>2]=c[w>>2]^c[y>>2];c[n+4>>2]=o;n=q+44|0;c[n>>2]=(c[n>>2]|0)-(c[1045948+((c[z>>2]|0)*4160|0)+(p*260|0)+(r<<2)>>2]|0);n=q+24|0;o=c[n>>2]|0;if((o|0)!=0?(C=c[b+4824+(r<<2)>>2]|0,(C|0)!=0):0){y=985824+((C&o)<<3)|0;h=c[y>>2]^h;m=c[y+4>>2]^m;c[n>>2]=o&~C}if((s|0)==0&(e|0)==0)break;else{o=s;n=e}}n=h}else n=h;while(0);h=c[K>>2]|0;B=h+44|0;C=c[z>>2]|0;c[B>>2]=(c[B>>2]|0)-(c[1045948+(C*4160|0)+(g*260|0)+(k<<2)>>2]|0);c[h+28>>2]=0;if((C|0)==2){y=977568+(i<<9)+(A<<3)|0;x=g;p=h;g=c[y>>2]^n;h=c[y+4>>2]^m;y=A;e=j;t=z;v=1;u=i}else{p=g;r=z;s=1;q=i;o=m;k=h;m=A;H=40}}do if((H|0)==40){if((d&61440|0)!=36864){y=977568+(q<<9)+(m<<3)|0;e=c[O>>2]|0;h=977568+(q<<9)+(e<<3)|0;x=p;p=k;g=c[y>>2]^n^c[h>>2];h=c[y+4>>2]^o^c[h+4>>2];y=m;t=r;v=s;u=q;break}j=c[O>>2]|0;C=977568+(q<<9)+(j<<3)|0;i=q&7;h=c[b+4496+(q>>3<<5)+(i<<2)>>2]|0;H=986040+(q*136|0)+(h+-1<<3)|0;h=986040+(q*136|0)+(h<<3)|0;g=c[C>>2]^n^c[H>>2]^c[h>>2];h=c[C+4>>2]^o^c[H+4>>2]^c[h+4>>2];if((i|0)==1){x=p;p=k;y=m;e=j;t=r;v=s;u=q}else{x=k+16+(M<<2)|0;c[x>>2]=(c[x>>2]|0)+(c[11108+(i<<2)>>2]|0);x=p;p=k;y=m;e=j;t=r;v=s;u=q}}while(0);i=p+48|0;j=c[i>>2]|0;if((j|0)!=64){H=985760+((j&7)<<3)|0;g=c[H>>2]^g;h=c[H+4>>2]^h;c[i>>2]=64}m=d&61440;w=(m|0)==36864;if((!w?(E=p+24|0,F=c[E>>2]|0,(F|0)!=0):0)?(G=c[b+4824+(e<<2)>>2]|c[b+4824+(y<<2)>>2],(G|0)!=0):0){H=985824+((G&F)<<3)|0;g=c[H>>2]^g;h=c[H+4>>2]^h;c[E>>2]=F&~G}s=c[t>>2]|0;if(!((s|0)!=8|f^1)){G=p+36+(M<<2)|0;F=c[G>>2]|0;H=988216+(M<<5)+(F<<3)|0;g=c[H>>2]^g;H=c[H+4>>2]^h;h=F+1|0;c[G>>2]=h;h=988216+(M<<5)+(h<<3)|0;g=g^c[h>>2];h=H^c[h+4>>2]}r=(s|0)==2;k=v&r;do if(k){F=b+(y<<2)|0;c[p+76+(y<<2)>>2]=c[F>>2];i=b+256|0;G=30544+(y<<3)|0;C=G;H=i;j=c[H+4>>2]^c[C+4>>2];c[i>>2]=c[H>>2]^c[C>>2];c[i+4>>2]=j;i=u&7;j=b+256+(i<<3)|0;C=G;H=j;E=c[H+4>>2]^c[C+4>>2];c[j>>2]=c[H>>2]^c[C>>2];c[j+4>>2]=E;j=u>>3;E=b+320+(j<<3)|0;C=E;H=c[C+4>>2]^c[G+4>>2];c[E>>2]=c[C>>2]^c[G>>2];c[E+4>>2]=H;c[F>>2]=0;F=b+336+(u<<2)|0;E=(c[F>>2]|0)+-1|0;c[F>>2]=E;E=c[b+400+(u<<8)+(E<<2)>>2]|0;H=c[b+4568+(y<<2)>>2]|0;c[b+4568+(E<<2)>>2]=H;c[b+400+(u<<8)+(H<<2)>>2]=E;c[b+400+(u<<8)+(c[F>>2]<<2)>>2]=64;j=b+336+(j<<3<<2)|0;c[j>>2]=(c[j>>2]|0)+-1;F=977568+(u<<9)+(c[F>>2]<<3)|0;j=c[K>>2]|0;H=j+8|0;E=H;G=c[E+4>>2]^c[F+4>>2];c[H>>2]=c[E>>2]^c[F>>2];c[H+4>>2]=G;if((i|0)==1)H=63;else{H=j+16+(M<<2)|0;c[H>>2]=(c[H>>2]|0)-(c[11108+(i<<2)>>2]|0);H=61}}else{if(J){if((d&12288|0)==4096){c[b+(e<<2)>>2]=u;i=b+256|0;E=30544+(e<<3)|0;C=E;G=i;H=c[G+4>>2]|c[C+4>>2];c[i>>2]=c[G>>2]|c[C>>2];c[i+4>>2]=H;i=u&7;H=b+256+(i<<3)|0;C=E;G=H;F=c[G+4>>2]|c[C+4>>2];c[H>>2]=c[G>>2]|c[C>>2];c[H+4>>2]=F;H=u>>3;F=b+320+(H<<3)|0;C=F;G=c[C+4>>2]|c[E+4>>2];c[F>>2]=c[C>>2]|c[E>>2];c[F+4>>2]=G;F=b+336+(u<<2)|0;G=c[F>>2]|0;c[F>>2]=G+1;c[b+4568+(e<<2)>>2]=G;c[b+400+(u<<8)+(G<<2)>>2]=e;G=b+336+(H<<3<<2)|0;c[G>>2]=(c[G>>2]|0)+1;G=b+4496+(H<<5)+(i<<2)|0;c[G>>2]=(c[G>>2]|0)+-1;H=b+4496+(H<<5)|0;c[H>>2]=(c[H>>2]|0)+-1;H=61;break}}else if((I|0)==49152){i=u&7;H=61;break}G=30544+(y<<3)|0;i=30544+(e<<3)|0;F=c[i>>2]^c[G>>2];G=c[i+4>>2]^c[G+4>>2];i=b+256|0;C=i;H=c[C+4>>2]^G;c[i>>2]=c[C>>2]^F;c[i+4>>2]=H;i=u&7;H=b+256+(i<<3)|0;C=H;E=c[C+4>>2]^G;c[H>>2]=c[C>>2]^F;c[H+4>>2]=E;H=b+320+(u>>3<<3)|0;E=H;G=c[E+4>>2]^G;c[H>>2]=c[E>>2]^F;c[H+4>>2]=G;c[b+(y<<2)>>2]=0;c[b+(e<<2)>>2]=u;H=c[b+4568+(y<<2)>>2]|0;c[b+4568+(e<<2)>>2]=H;c[b+400+(u<<8)+(H<<2)>>2]=e;H=61}while(0);if((H|0)==61)if((i|0)==1)H=63;else{m=s;n=c[K>>2]|0}if((H|0)==63){if((s|0)==4?(y>>3|0)==(M*7|0):0)if(k)H=79;else H=80;else H=65;do if((H|0)==65)if(k)H=79;else{if((e^y|0)==16?(G=31376+((M<<3|1)<<9)+(e-((M|0)==0?8:-8)<<3)|0,F=b+320+(L<<3)|0,H=b+264|0,!((c[F>>2]&c[G>>2]&c[H>>2]|0)==0?(c[F+4>>2]&c[G+4>>2]&c[H+4>>2]|0)==0:0)):0){H=(e+y|0)/2|0;c[(c[K>>2]|0)+48>>2]=H;H=985760+((H&7)<<3)|0;g=c[H>>2]^g;h=c[H+4>>2]^h;H=80;break}if(J){if((d&12288|0)!=8192){H=80;break}}else if((I|0)!=16384){H=80;break}i=(m|0)==40960?6:(d>>>12&3)+2|0;o=M<<3;p=o|i;n=b+256|0;q=30544+(e<<3)|0;I=q;k=n;J=c[k+4>>2]^c[I+4>>2];j=n;c[j>>2]=c[k>>2]^c[I>>2];c[j+4>>2]=J;j=b+264|0;J=q;I=j;k=c[I+4>>2]^c[J+4>>2];c[j>>2]=c[I>>2]^c[J>>2];c[j+4>>2]=k;j=u>>3;k=b+320+(j<<3)|0;J=q;I=k;d=c[I+4>>2]^c[J+4>>2];c[k>>2]=c[I>>2]^c[J>>2];c[k+4>>2]=d;k=b+(e<<2)|0;if(r)c[k>>2]=0;m=b+336+(u<<2)|0;G=(c[m>>2]|0)+-1|0;c[m>>2]=G;G=c[b+400+(u<<8)+(G<<2)>>2]|0;J=b+4568+(e<<2)|0;I=c[J>>2]|0;c[b+4568+(G<<2)>>2]=I;c[b+400+(u<<8)+(I<<2)>>2]=G;c[b+400+(u<<8)+(c[m>>2]<<2)>>2]=64;I=b+336+(j<<3<<2)|0;c[I>>2]=(c[I>>2]|0)+-1;c[k>>2]=p;I=q;G=n;d=c[G+4>>2]|c[I+4>>2];H=n;c[H>>2]=c[G>>2]|c[I>>2];c[H+4>>2]=d;i=b+256+(i<<3)|0;H=q;d=i;I=c[d+4>>2]|c[H+4>>2];c[i>>2]=c[d>>2]|c[H>>2];c[i+4>>2]=I;i=b+320+(o>>3<<3)|0;I=q;H=i;d=c[H+4>>2]|c[I+4>>2];c[i>>2]=c[H>>2]|c[I>>2];c[i+4>>2]=d;i=b+336+(p<<2)|0;d=c[i>>2]|0;c[i>>2]=d+1;c[J>>2]=d;c[b+400+(p<<8)+(d<<2)>>2]=e;d=b+336+(o<<2)|0;c[d>>2]=(c[d>>2]|0)+1;if((s|0)==3?(c[b+5368>>2]|0)!=11:0){d=b+4560|0;I=d;H=q;J=c[H+4>>2]|c[I+4>>2];c[d>>2]=c[H>>2]|c[I>>2];c[d+4>>2]=J}F=977568+(u<<9)+(e<<3)|0;d=c[F>>2]|0;F=c[F+4>>2]|0;H=977568+(p<<9)+(e<<3)|0;g=d^g^c[H>>2];h=F^h^c[H+4>>2];H=c[K>>2]|0;I=H;F=c[I+4>>2]^F;G=H;c[G>>2]=c[I>>2]^d;c[G+4>>2]=F;G=977568+(p<<9)+((c[i>>2]|0)+-1<<3)|0;F=977568+(u<<9)+(c[m>>2]<<3)|0;d=H+8|0;I=d;J=c[F+4>>2]^c[G+4>>2]^c[I+4>>2];c[d>>2]=c[F>>2]^c[G>>2]^c[I>>2];c[d+4>>2]=J;d=H+44|0;c[d>>2]=(c[1045948+(s*4160|0)+(p*260|0)+(e<<2)>>2]|0)-(c[1045948+(s*4160|0)+(u*260|0)+(e<<2)>>2]|0)+(c[d>>2]|0);H=H+16+(M<<2)|0;c[H>>2]=(c[H>>2]|0)+(c[11108+(p<<2)>>2]|0);H=80}while(0);do if((H|0)==79){I=977568+((M<<3|1)<<9)+(y<<3)|0;d=c[K>>2]|0;G=d;J=c[G+4>>2]^c[I+4>>2];c[d>>2]=c[G>>2]^c[I>>2];c[d+4>>2]=J}else if((H|0)==80)if(w){I=977568+(u<<9)+(e<<3)|0;d=c[K>>2]|0;G=d;J=c[G+4>>2]^c[I+4>>2];c[d>>2]=c[G>>2]^c[I>>2];c[d+4>>2]=J;break}else{G=977568+(u<<9)+(y<<3)|0;F=977568+(u<<9)+(e<<3)|0;d=c[K>>2]|0;I=d;J=c[F+4>>2]^c[G+4>>2]^c[I+4>>2];c[d>>2]=c[F>>2]^c[G>>2]^c[I>>2];c[d+4>>2]=J;break}while(0);n=c[K>>2]|0;c[n+28>>2]=0;m=c[t>>2]|0}k=v&(m|0)==2;j=n+44|0;i=c[1045948+(m*4160|0)+(u*260|0)+(y<<2)>>2]|0;if(k)i=(c[j>>2]|0)-i|0;else i=(c[1045948+(m*4160|0)+(u*260|0)+(c[O>>2]<<2)>>2]|0)-i+(c[j>>2]|0)|0;c[j>>2]=i;c[n+72>>2]=x;if(!(v|(m|0)!=3))a[n+332>>0]=0;K=n+56|0;c[K>>2]=g;c[K+4>>2]=h;if(k)f=(c[b+336+((c[N>>2]<<3^14)<<2)>>2]|0)!=0&f;switch(m|0){case 7:{M=c[30544+(c[b+400+((M<<3|6)<<8)>>2]<<3)+4>>2]&-16777216;O=n+64|0;c[O>>2]=0;c[O+4>>2]=M;O=c[N>>2]|0;O=O^1;c[N>>2]=O;Cf(b,n);l=P;return}case 1:{O=n+64|0;c[O>>2]=0;c[O+4>>2]=0;O=c[N>>2]|0;O=O^1;c[N>>2]=O;Cf(b,n);l=P;return}default:{if(f){switch(m|0){case 4:{f=L<<3|6;if(!(c[b+336+(f<<2)>>2]|0))f=64;else H=99;break}case 2:{f=L<<3|6;if(!(c[b+336+(f<<2)>>2]|0))f=64;else H=99;break}default:{f=L<<3|6;H=99}}if((H|0)==99)f=c[b+400+(f<<8)>>2]|0;K=b+256|0;I=c[K>>2]|0;K=c[K+4>>2]|0;B=35984+(f<<3)|0;A=b+320|0;C=b+264|0;u=c[C>>2]|0;C=c[C+4>>2]|0;x=31888+(f<<3)|0;z=b+328|0;F=32400+(f<<3)|0;E=b+272|0;G=28496+(f<<3)|0;H=29008+(f<<3)|0;H=(S(c[G+4>>2]&K,c[H+4>>2]|0)|0)^(S(c[G>>2]&I,c[H>>2]|0)|0);H=(c[1035428+(f<<2)>>2]|0)+(H>>>(c[1035684+(f<<2)>>2]|0)<<3)|0;G=b+288|0;J=b+296|0;v=c[J>>2]|0;J=c[J+4>>2]|0;L=29520+(f<<3)|0;d=30032+(f<<3)|0;d=(S(c[L+4>>2]&K,c[d+4>>2]|0)|0)^(S(c[L>>2]&I,c[d>>2]|0)|0);d=(c[1035940+(f<<2)>>2]|0)+(d>>>(c[1036196+(f<<2)>>2]|0)<<3)|0;I=b+280|0;L=34448+(f<<3)|0;K=b+304|0;g=b+320+(M<<3)|0;f=(c[x>>2]&u&c[z>>2]|c[A>>2]&c[B>>2]&u|c[E>>2]&c[F>>2]|(v|c[G>>2])&c[H>>2]|(c[I>>2]|v)&c[d>>2]|c[K>>2]&c[L>>2])&c[g>>2];g=(c[x+4>>2]&C&c[z+4>>2]|c[A+4>>2]&c[B+4>>2]&C|c[E+4>>2]&c[F+4>>2]|(J|c[G+4>>2])&c[H+4>>2]|(c[I+4>>2]|J)&c[d+4>>2]|c[K+4>>2]&c[L+4>>2])&c[g+4>>2]}else{f=0;g=0}M=n+64|0;c[M>>2]=f;c[M+4>>2]=g;if((m|0)!=3|w){O=c[N>>2]|0;O=O^1;c[N>>2]=O;Cf(b,n);l=P;return}h=b+4560|0;j=h;i=c[j>>2]|0;j=c[j+4>>2]|0;g=30544+(y<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0;if((f&i|0)==0&(g&j|0)==0){O=c[N>>2]|0;O=O^1;c[N>>2]=O;Cf(b,n);l=P;return}L=30544+(c[O>>2]<<3)|0;M=c[L+4>>2]|j&~g;O=h;c[O>>2]=c[L>>2]|i&~f;c[O+4>>2]=M;O=c[N>>2]|0;O=O^1;c[N>>2]=O;Cf(b,n);l=P;return}}}function Uf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=c[e>>2]|0;k=(j|0)>(d|0);c[f>>2]=j;j=b*56|0;c[g>>2]=(k?5:3)|j;c[e>>2]=(k?6:2)|j;b=b<<3;j=b|6;k=a+256|0;o=30544+(d<<3)|0;n=o;i=k;p=c[i+4>>2]^c[n+4>>2];l=k;c[l>>2]=c[i>>2]^c[n>>2];c[l+4>>2]=p;l=a+304|0;p=o;n=l;i=c[n+4>>2]^c[p+4>>2];m=l;c[m>>2]=c[n>>2]^c[p>>2];c[m+4>>2]=i;m=a+320+(b>>3<<3)|0;i=m;p=c[i+4>>2]^c[o+4>>2];n=m;c[n>>2]=c[i>>2]^c[o>>2];c[n+4>>2]=p;n=a+5364|0;if((c[n>>2]|0)==2)c[a+(d<<2)>>2]=0;o=a+336+(j<<2)|0;h=(c[o>>2]|0)+-1|0;c[o>>2]=h;h=c[a+400+(j<<8)+(h<<2)>>2]|0;p=c[a+4568+(d<<2)>>2]|0;c[a+4568+(h<<2)>>2]=p;c[a+400+(j<<8)+(p<<2)>>2]=h;c[a+400+(j<<8)+(c[o>>2]<<2)>>2]=64;p=a+336+(b<<2)|0;c[p>>2]=(c[p>>2]|0)+-1;h=b|4;i=c[f>>2]|0;s=30544+(i<<3)|0;u=s;r=k;q=c[r+4>>2]^c[u+4>>2];b=k;c[b>>2]=c[r>>2]^c[u>>2];c[b+4>>2]=q;b=a+288|0;q=s;u=b;r=c[u+4>>2]^c[q+4>>2];t=b;c[t>>2]=c[u>>2]^c[q>>2];c[t+4>>2]=r;t=m;r=c[t+4>>2]^c[s+4>>2];q=m;c[q>>2]=c[t>>2]^c[s>>2];c[q+4>>2]=r;if((c[n>>2]|0)==2)c[a+(i<<2)>>2]=0;s=a+336+(h<<2)|0;r=(c[s>>2]|0)+-1|0;c[s>>2]=r;r=c[a+400+(h<<8)+(r<<2)>>2]|0;q=c[a+4568+(i<<2)>>2]|0;c[a+4568+(r<<2)>>2]=q;c[a+400+(h<<8)+(q<<2)>>2]=r;c[a+400+(h<<8)+(c[s>>2]<<2)>>2]=64;c[p>>2]=(c[p>>2]|0)+-1;c[a+(c[f>>2]<<2)>>2]=0;c[a+(d<<2)>>2]=0;q=c[e>>2]|0;c[a+(q<<2)>>2]=j;f=30544+(q<<3)|0;r=f;u=k;e=c[u+4>>2]|c[r+4>>2];t=k;c[t>>2]=c[u>>2]|c[r>>2];c[t+4>>2]=e;t=f;e=l;r=c[e+4>>2]|c[t+4>>2];u=l;c[u>>2]=c[e>>2]|c[t>>2];c[u+4>>2]=r;u=m;r=c[u+4>>2]|c[f+4>>2];t=m;c[t>>2]=c[u>>2]|c[f>>2];c[t+4>>2]=r;t=c[o>>2]|0;c[o>>2]=t+1;c[a+4568+(q<<2)>>2]=t;c[a+400+(j<<8)+(t<<2)>>2]=q;c[p>>2]=(c[p>>2]|0)+1;t=c[g>>2]|0;c[a+(t<<2)>>2]=h;q=30544+(t<<3)|0;r=q;g=k;f=c[g+4>>2]|c[r+4>>2];u=k;c[u>>2]=c[g>>2]|c[r>>2];c[u+4>>2]=f;u=q;f=b;r=c[f+4>>2]|c[u+4>>2];g=b;c[g>>2]=c[f>>2]|c[u>>2];c[g+4>>2]=r;g=m;r=c[g+4>>2]|c[q+4>>2];u=m;c[u>>2]=c[g>>2]|c[q>>2];c[u+4>>2]=r;u=c[s>>2]|0;c[s>>2]=u+1;c[a+4568+(t<<2)>>2]=u;c[a+400+(h<<8)+(u<<2)>>2]=t;c[p>>2]=(c[p>>2]|0)+1;return}function Vf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0;E=l;l=l+16|0;j=E+8|0;k=E+4|0;m=E;n=b+5348|0;w=c[n>>2]^1;c[n>>2]=w;n=d&49152;v=(n|0)==32768;if(v)y=(d&12288|0)==4096?64:d>>>6&63;else y=d>>>6&63;B=d&63;c[j>>2]=B;p=b+(B<<2)|0;f=c[p>>2]|0;C=b+5364|0;e=c[C>>2]|0;i=(e|0)==2;if(i?(h=c[b+5356>>2]|0,(c[h+72>>2]|0)!=0):0)f=c[h+76+(y<<2)>>2]|0;if(v)if((d&12288|0)==8192)o=10;else h=f;else if((n|0)==16384)o=10;else o=17;if((o|0)==10){if(i?(c[(c[b+5356>>2]|0)+72>>2]|0)!=0:0)e=2;else{h=b+256|0;i=30544+(B<<3)|0;I=i;F=h;H=c[F+4>>2]^c[I+4>>2];e=h;c[e>>2]=c[F>>2]^c[I>>2];c[e+4>>2]=H;e=b+256+((f&7)<<3)|0;H=i;I=e;F=c[I+4>>2]^c[H+4>>2];c[e>>2]=c[I>>2]^c[H>>2];c[e+4>>2]=F;e=f>>3;F=b+320+(e<<3)|0;H=i;I=F;G=c[I+4>>2]^c[H+4>>2];c[F>>2]=c[I>>2]^c[H>>2];c[F+4>>2]=G;if((c[C>>2]|0)==2)c[p>>2]=0;F=b+336+(f<<2)|0;I=(c[F>>2]|0)+-1|0;c[F>>2]=I;I=c[b+400+(f<<8)+(I<<2)>>2]|0;H=b+4568+(B<<2)|0;J=c[H>>2]|0;c[b+4568+(I<<2)>>2]=J;c[b+400+(f<<8)+(J<<2)>>2]=I;c[b+400+(f<<8)+(c[F>>2]<<2)>>2]=64;e=b+336+(e<<3<<2)|0;c[e>>2]=(c[e>>2]|0)+-1;e=w<<3;f=e|1;c[p>>2]=f;F=i;J=h;I=c[J+4>>2]|c[F+4>>2];G=h;c[G>>2]=c[J>>2]|c[F>>2];c[G+4>>2]=I;G=b+264|0;h=i;I=G;F=c[I+4>>2]|c[h+4>>2];c[G>>2]=c[I>>2]|c[h>>2];c[G+4>>2]=F;G=b+320+(e>>3<<3)|0;F=i;h=G;I=c[h+4>>2]|c[F+4>>2];c[G>>2]=c[h>>2]|c[F>>2];c[G+4>>2]=I;G=b+336+(f<<2)|0;I=c[G>>2]|0;c[G>>2]=I+1;c[H>>2]=I;c[b+400+(f<<8)+(I<<2)>>2]=B;e=b+336+(e<<2)|0;c[e>>2]=(c[e>>2]|0)+1;e=c[C>>2]|0;if((e|0)==3){e=b+4560|0;I=i;H=e;J=c[H+4>>2]&~c[I+4>>2];c[e>>2]=c[H>>2]&~c[I>>2];c[e+4>>2]=J;e=3}}if(v)h=f;else o=17}if((o|0)==17)if((n|0)==49152){Wf(b,w,y,j,k,m);J=b+5356|0;I=c[J>>2]|0;I=I+336|0;I=c[I>>2]|0;c[J>>2]=I;J=b+5344|0;I=c[J>>2]|0;I=I+-1|0;c[J>>2]=I;l=E;return}else h=f;if((e|0)==2?(c[(c[b+5356>>2]|0)+72>>2]|0)!=0:0){c[b+(y<<2)>>2]=h;J=b+256|0;G=30544+(y<<3)|0;I=G;H=J;F=c[H+4>>2]|c[I+4>>2];c[J>>2]=c[H>>2]|c[I>>2];c[J+4>>2]=F;J=b+256+((h&7)<<3)|0;F=G;I=J;H=c[I+4>>2]|c[F+4>>2];c[J>>2]=c[I>>2]|c[F>>2];c[J+4>>2]=H;J=h>>3;H=b+320+(J<<3)|0;F=H;I=c[F+4>>2]|c[G+4>>2];c[H>>2]=c[F>>2]|c[G>>2];c[H+4>>2]=I;H=b+336+(h<<2)|0;I=c[H>>2]|0;c[H>>2]=I+1;c[b+4568+(y<<2)>>2]=I;c[b+400+(h<<8)+(I<<2)>>2]=y;J=b+336+(J<<3<<2)|0;c[J>>2]=(c[J>>2]|0)+1}else o=22;do if((o|0)==22){if((d&61440|0)!=36864){I=30544+(B<<3)|0;J=30544+(y<<3)|0;H=c[J>>2]^c[I>>2];I=c[J+4>>2]^c[I+4>>2];J=b+256|0;G=J;F=c[G+4>>2]^I;c[J>>2]=c[G>>2]^H;c[J+4>>2]=F;J=b+256+((h&7)<<3)|0;F=J;G=c[F+4>>2]^I;c[J>>2]=c[F>>2]^H;c[J+4>>2]=G;J=b+320+(h>>3<<3)|0;G=J;I=c[G+4>>2]^I;c[J>>2]=c[G>>2]^H;c[J+4>>2]=I;c[p>>2]=0;c[b+(y<<2)>>2]=h;J=c[b+4568+(B<<2)>>2]|0;c[b+4568+(y<<2)>>2]=J;c[b+400+(h<<8)+(J<<2)>>2]=y;break}e=b+256|0;H=30544+(B<<3)|0;G=H;I=e;f=c[I+4>>2]^c[G+4>>2];c[e>>2]=c[I>>2]^c[G>>2];c[e+4>>2]=f;e=h&7;f=b+256+(e<<3)|0;G=H;I=f;J=c[I+4>>2]^c[G+4>>2];c[f>>2]=c[I>>2]^c[G>>2];c[f+4>>2]=J;f=h>>3;J=b+320+(f<<3)|0;G=J;I=c[G+4>>2]^c[H+4>>2];c[J>>2]=c[G>>2]^c[H>>2];c[J+4>>2]=I;if((c[C>>2]|0)==2)c[p>>2]=0;J=b+336+(h<<2)|0;H=(c[J>>2]|0)+-1|0;c[J>>2]=H;H=c[b+400+(h<<8)+(H<<2)>>2]|0;I=c[b+4568+(B<<2)>>2]|0;c[b+4568+(H<<2)>>2]=I;c[b+400+(h<<8)+(I<<2)>>2]=H;c[b+400+(h<<8)+(c[J>>2]<<2)>>2]=64;J=b+336+(f<<3<<2)|0;c[J>>2]=(c[J>>2]|0)+-1;c[p>>2]=0;J=b+4496+(f<<5)+(e<<2)|0;c[J>>2]=(c[J>>2]|0)+1;J=b+4496+(f<<5)|0;c[J>>2]=(c[J>>2]|0)+1}while(0);h=c[C>>2]|0;if((h|0)==3?(q=b+4560|0,s=q,r=c[s>>2]|0,s=c[s+4>>2]|0,u=30544+(B<<3)|0,t=c[u>>2]|0,u=c[u+4>>2]|0,!((t&r|0)==0&(u&s|0)==0)):0){H=30544+(y<<3)|0;I=c[H+4>>2]|s&~u;J=q;c[J>>2]=c[H>>2]|r&~t;c[J+4>>2]=I}j=b+5356|0;e=c[(c[j>>2]|0)+72>>2]|0;if(!e){J=j;I=c[J>>2]|0;I=I+336|0;I=c[I>>2]|0;c[J>>2]=I;J=b+5344|0;I=c[J>>2]|0;I=I+-1|0;c[J>>2]=I;l=E;return}a:do if(v){f=d&12288;if(f<<16>>16<8192)switch(f<<16>>16){case 4096:{i=B;break a}default:{}}else switch(f<<16>>16){case 8192:{i=B;break a}default:{}}i=B-((w|0)==0?8:-8)|0}else i=B;while(0);if((h|0)==2?(x=34448+(B<<3)|0,g=c[x>>2]|0,x=c[x+4>>2]|0,!((g|0)==0&(x|0)==0)):0){h=b+256|0;e=x;do{f=Qa(g|0,e|0,0)|0;J=Yu(g|0,e|0,-1,-1)|0;g=J&g;e=D&e;if(((f|0)!=(y|0)?(z=c[(c[j>>2]|0)+76+(f<<2)>>2]|0,z|0):0)?(A=z&7,(A|0)!=1):0){c[b+(f<<2)>>2]=z;G=30544+(f<<3)|0;I=G;H=h;F=c[H+4>>2]|c[I+4>>2];J=h;c[J>>2]=c[H>>2]|c[I>>2];c[J+4>>2]=F;J=b+256+(A<<3)|0;F=G;I=J;H=c[I+4>>2]|c[F+4>>2];c[J>>2]=c[I>>2]|c[F>>2];c[J+4>>2]=H;J=z>>3;H=b+320+(J<<3)|0;F=H;I=c[F+4>>2]|c[G+4>>2];c[H>>2]=c[F>>2]|c[G>>2];c[H+4>>2]=I;H=b+336+(z<<2)|0;I=c[H>>2]|0;c[H>>2]=I+1;c[b+4568+(f<<2)>>2]=I;c[b+400+(z<<8)+(I<<2)>>2]=f;J=b+336+(J<<3<<2)|0;c[J>>2]=(c[J>>2]|0)+1}}while(!((g|0)==0&(e|0)==0));e=c[(c[j>>2]|0)+72>>2]|0}c[b+(i<<2)>>2]=e;J=b+256|0;G=30544+(i<<3)|0;I=G;H=J;F=c[H+4>>2]|c[I+4>>2];c[J>>2]=c[H>>2]|c[I>>2];c[J+4>>2]=F;J=b+256+((e&7)<<3)|0;F=G;I=J;H=c[I+4>>2]|c[F+4>>2];c[J>>2]=c[I>>2]|c[F>>2];c[J+4>>2]=H;J=e>>3;H=b+320+(J<<3)|0;F=H;I=c[F+4>>2]|c[G+4>>2];c[H>>2]=c[F>>2]|c[G>>2];c[H+4>>2]=I;H=b+336+(e<<2)|0;I=c[H>>2]|0;c[H>>2]=I+1;c[b+4568+(i<<2)>>2]=I;c[b+400+(e<<8)+(I<<2)>>2]=i;J=b+336+(J<<3<<2)|0;c[J>>2]=(c[J>>2]|0)+1;if((c[C>>2]|0)!=3){J=j;I=c[J>>2]|0;I=I+336|0;I=c[I>>2]|0;c[J>>2]=I;J=b+5344|0;I=c[J>>2]|0;I=I+-1|0;c[J>>2]=I;l=E;return}if((c[b+5368>>2]|0)!=10){H=c[j>>2]|0;I=c[H+72>>2]|0;J=I>>3^1;I=b+4496+(J<<5)+(((a[H+332>>0]|0)==0?I&7:1)<<2)|0;c[I>>2]=(c[I>>2]|0)+-1;J=b+4496+(J<<5)|0;c[J>>2]=(c[J>>2]|0)+-1}if(!(a[(c[j>>2]|0)+332>>0]|0)){J=j;I=c[J>>2]|0;I=I+336|0;I=c[I>>2]|0;c[J>>2]=I;J=b+5344|0;I=c[J>>2]|0;I=I+-1|0;c[J>>2]=I;l=E;return}J=b+4560|0;H=30544+(B<<3)|0;G=J;I=c[G+4>>2]|c[H+4>>2];c[J>>2]=c[G>>2]|c[H>>2];c[J+4>>2]=I;J=j;I=c[J>>2]|0;I=I+336|0;I=c[I>>2]|0;c[J>>2]=I;J=b+5344|0;I=c[J>>2]|0;I=I+-1|0;c[J>>2]=I;l=E;return}function Wf(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=c[e>>2]|0;k=(h|0)>(d|0);c[f>>2]=h;h=b*56|0;c[g>>2]=(k?5:3)|h;h=(k?6:2)|h;c[e>>2]=h;b=b<<3;k=b|6;l=a+256|0;j=30544+(h<<3)|0;o=j;i=l;p=c[i+4>>2]^c[o+4>>2];m=l;c[m>>2]=c[i>>2]^c[o>>2];c[m+4>>2]=p;m=a+304|0;p=j;o=m;i=c[o+4>>2]^c[p+4>>2];n=m;c[n>>2]=c[o>>2]^c[p>>2];c[n+4>>2]=i;n=a+320+(b>>3<<3)|0;i=n;p=c[i+4>>2]^c[j+4>>2];o=n;c[o>>2]=c[i>>2]^c[j>>2];c[o+4>>2]=p;o=a+5364|0;if((c[o>>2]|0)==2)c[a+(h<<2)>>2]=0;p=a+336+(k<<2)|0;i=(c[p>>2]|0)+-1|0;c[p>>2]=i;i=c[a+400+(k<<8)+(i<<2)>>2]|0;j=c[a+4568+(h<<2)>>2]|0;c[a+4568+(i<<2)>>2]=j;c[a+400+(k<<8)+(j<<2)>>2]=i;c[a+400+(k<<8)+(c[p>>2]<<2)>>2]=64;j=a+336+(b<<2)|0;c[j>>2]=(c[j>>2]|0)+-1;h=b|4;i=c[g>>2]|0;s=30544+(i<<3)|0;u=s;r=l;q=c[r+4>>2]^c[u+4>>2];b=l;c[b>>2]=c[r>>2]^c[u>>2];c[b+4>>2]=q;b=a+288|0;q=s;u=b;r=c[u+4>>2]^c[q+4>>2];t=b;c[t>>2]=c[u>>2]^c[q>>2];c[t+4>>2]=r;t=n;r=c[t+4>>2]^c[s+4>>2];q=n;c[q>>2]=c[t>>2]^c[s>>2];c[q+4>>2]=r;if((c[o>>2]|0)==2)c[a+(i<<2)>>2]=0;s=a+336+(h<<2)|0;q=(c[s>>2]|0)+-1|0;c[s>>2]=q;q=c[a+400+(h<<8)+(q<<2)>>2]|0;r=c[a+4568+(i<<2)>>2]|0;c[a+4568+(q<<2)>>2]=r;c[a+400+(h<<8)+(r<<2)>>2]=q;c[a+400+(h<<8)+(c[s>>2]<<2)>>2]=64;c[j>>2]=(c[j>>2]|0)+-1;c[a+(c[g>>2]<<2)>>2]=0;c[a+(c[e>>2]<<2)>>2]=0;c[a+(d<<2)>>2]=k;r=30544+(d<<3)|0;q=r;g=l;u=c[g+4>>2]|c[q+4>>2];t=l;c[t>>2]=c[g>>2]|c[q>>2];c[t+4>>2]=u;t=r;u=m;q=c[u+4>>2]|c[t+4>>2];g=m;c[g>>2]=c[u>>2]|c[t>>2];c[g+4>>2]=q;g=n;q=c[g+4>>2]|c[r+4>>2];t=n;c[t>>2]=c[g>>2]|c[r>>2];c[t+4>>2]=q;t=c[p>>2]|0;c[p>>2]=t+1;c[a+4568+(d<<2)>>2]=t;c[a+400+(k<<8)+(t<<2)>>2]=d;c[j>>2]=(c[j>>2]|0)+1;t=c[f>>2]|0;c[a+(t<<2)>>2]=h;q=30544+(t<<3)|0;r=q;g=l;f=c[g+4>>2]|c[r+4>>2];u=l;c[u>>2]=c[g>>2]|c[r>>2];c[u+4>>2]=f;u=q;f=b;r=c[f+4>>2]|c[u+4>>2];g=b;c[g>>2]=c[f>>2]|c[u>>2];c[g+4>>2]=r;g=n;r=c[g+4>>2]|c[q+4>>2];u=n;c[u>>2]=c[g>>2]|c[q>>2];c[u+4>>2]=r;u=c[s>>2]|0;c[s>>2]=u+1;c[a+4568+(t<<2)>>2]=u;c[a+400+(h<<8)+(u<<2)>>2]=t;c[j>>2]=(c[j>>2]|0)+1;return}function Xf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;f=a+5356|0;cv(b|0,c[f>>2]|0,440)|0;c[b+336>>2]=c[f>>2];c[f>>2]=b;d=b+48|0;e=c[d>>2]|0;if((e|0)==64){b=b+56|0;e=b;d=c[e>>2]|0;e=c[e+4>>2]|0}else{e=985760+((e&7)<<3)|0;b=b+56|0;h=b;g=c[h>>2]^c[e>>2];e=c[h+4>>2]^c[e+4>>2];h=b;c[h>>2]=g;c[h+4>>2]=e;c[d>>2]=64;d=g}i=985952;g=e^c[i+4>>2];h=b;c[h>>2]=d^c[i>>2];c[h+4>>2]=g;h=c[f>>2]|0;g=h+28|0;c[g>>2]=(c[g>>2]|0)+1;c[h+32>>2]=0;g=a+5348|0;c[g>>2]=c[g>>2]^1;Cf(a,h);return}function Yf(a){a=a|0;var b=0;b=a+5356|0;c[b>>2]=c[(c[b>>2]|0)+336>>2];a=a+5348|0;c[a>>2]=c[a>>2]^1;return}function Zf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if((b&49152|0)==32768){d=b>>>6;e=b&63;if((b&12288|0)==4096){i=d&15;g=e;h=64}else f=5}else{e=b&63;d=b>>>6;f=5}if((f|0)==5){h=d&63;i=c[a+(h<<2)>>2]|0;g=e}f=c[a+(g<<2)>>2]|0;d=(c[a+5356>>2]|0)+56|0;j=985952;e=c[j>>2]^c[d>>2];d=c[j+4>>2]^c[d+4>>2];a:do if(f){j=977568+(f<<9)+(g<<3)|0;e=c[j>>2]^e;d=c[j+4>>2]^d;switch(c[a+5364>>2]|0){case 2:break;case 3:{j=a+4560|0;k=30544+(g<<3)|0;j=((c[k>>2]&c[j>>2]|0)==0?(c[k+4>>2]&c[j+4>>2]|0)==0:0)?f:f&-8|1;k=j^8;j=c[a+4496+(k>>3<<5)+((j&7)<<2)>>2]|0;f=986040+(k*136|0)+(j+1<<3)|0;j=986040+(k*136|0)+(j<<3)|0;e=c[f>>2]^e^c[j>>2];d=c[f+4>>2]^d^c[j+4>>2];break a}default:break a}k=34448+(g<<3)|0;j=a+256|0;b=a+264|0;g=30544+(h<<3)|0;f=(c[b>>2]^c[j>>2])&c[k>>2]&~c[g>>2];g=(c[b+4>>2]^c[j+4>>2])&c[k+4>>2]&~c[g+4>>2];if(!((f|0)==0&(g|0)==0))do{k=Qa(f|0,g|0,0)|0;j=Yu(f|0,g|0,-1,-1)|0;f=j&f;g=D&g;k=977568+(c[a+(k<<2)>>2]<<9)+(k<<3)|0;e=c[k>>2]^e;d=c[k+4>>2]^d}while(!((f|0)==0&(g|0)==0));k=977568+(i<<9)+(h<<3)|0;j=c[k+4>>2]^d;k=c[k>>2]^e;D=j;return k|0}while(0);k=977568+(i<<9)+(g<<3)|0;e=c[k>>2]^e;d=c[k+4>>2]^d;if((b&61440|0)==36864){k=c[a+4496+(i>>3<<5)+((i&7)<<2)>>2]|0;a=986040+(i*136|0)+(k<<3)|0;k=986040+(i*136|0)+(k+-1<<3)|0;j=c[a+4>>2]^d^c[k+4>>2];k=c[a>>2]^e^c[k>>2];D=j;return k|0}else{k=977568+(i<<9)+(h<<3)|0;j=c[k+4>>2]^d;k=c[k>>2]^e;D=j;return k|0}return 0}function _f(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;if((b&49152|0)==32768)e=(b&12288|0)==4096?64:b>>>6&63;else e=b>>>6&63;C=b&63;B=c[a+(e<<2)>>2]>>3;A=34448+(C<<3)|0;z=a+256|0;y=a+264|0;j=30544+(e<<3)|0;i=(c[y>>2]^c[z>>2])&c[A>>2]&~c[j>>2];j=(c[y+4>>2]^c[z+4>>2])&c[A+4>>2]&~c[j+4>>2];A=a+320+((B^1)<<3)|0;z=a+304|0;if(!((c[z>>2]&c[A>>2]&i|0)==0?(c[z+4>>2]&c[A+4>>2]&j|0)==0:0)){C=32e3;return C|0}k=a+5364|0;A=c[k>>2]|0;l=a+272|0;m=11108+(A<<7)+8|0;n=a+280|0;o=11108+(A<<7)+12|0;p=a+288|0;q=11108+(A<<7)+16|0;r=a+296|0;s=11108+(A<<7)+20|0;t=a+272|0;u=11108+(A<<7)+8|0;v=a+280|0;w=11108+(A<<7)+12|0;x=a+288|0;y=11108+(A<<7)+16|0;z=a+296|0;A=11108+(A<<7)+20|0;h=0;e=0;while(1){g=a+320+(h<<3)|0;f=c[g>>2]&i;g=c[g+4>>2]&j;if((h|0)==(B|0)){D=l;F=f&c[D>>2];D=g&c[D+4>>2];G=av(F|0,D|0,16)|0;E=av(F|0,D|0,48)|0;E=e-(S(c[m>>2]|0,(d[1167548+(G&65535)>>0]|0)+(d[1167548+(F&65535)>>0]|0)+(d[1167548+(D&65535)>>0]|0)+(d[1167548+E>>0]|0)|0)|0)|0;D=n;e=f&c[D>>2];D=g&c[D+4>>2];F=av(e|0,D|0,16)|0;G=av(e|0,D|0,48)|0;G=E-(S(c[o>>2]|0,(d[1167548+(F&65535)>>0]|0)+(d[1167548+(e&65535)>>0]|0)+(d[1167548+(D&65535)>>0]|0)+(d[1167548+G>>0]|0)|0)|0)|0;D=p;e=f&c[D>>2];D=g&c[D+4>>2];F=av(e|0,D|0,16)|0;E=av(e|0,D|0,48)|0;E=G-(S(c[q>>2]|0,(d[1167548+(F&65535)>>0]|0)+(d[1167548+(e&65535)>>0]|0)+(d[1167548+(D&65535)>>0]|0)+(d[1167548+E>>0]|0)|0)|0)|0;D=r;e=f&c[D>>2];f=g&c[D+4>>2];D=av(e|0,f|0,16)|0;g=av(e|0,f|0,48)|0;g=E-(S(c[s>>2]|0,(d[1167548+(D&65535)>>0]|0)+(d[1167548+(e&65535)>>0]|0)+(d[1167548+(f&65535)>>0]|0)+(d[1167548+g>>0]|0)|0)|0)|0}else{D=t;F=f&c[D>>2];D=g&c[D+4>>2];E=av(F|0,D|0,16)|0;G=av(F|0,D|0,48)|0;G=(S(c[u>>2]|0,(d[1167548+(E&65535)>>0]|0)+(d[1167548+(F&65535)>>0]|0)+(d[1167548+(D&65535)>>0]|0)+(d[1167548+G>>0]|0)|0)|0)+e|0;D=v;e=f&c[D>>2];D=g&c[D+4>>2];F=av(e|0,D|0,16)|0;E=av(e|0,D|0,48)|0;G=(S(c[w>>2]|0,(d[1167548+(F&65535)>>0]|0)+(d[1167548+(e&65535)>>0]|0)+(d[1167548+(D&65535)>>0]|0)+(d[1167548+E>>0]|0)|0)|0)+G|0;E=x;D=f&c[E>>2];E=g&c[E+4>>2];e=av(D|0,E|0,16)|0;F=av(D|0,E|0,48)|0;G=(S(c[y>>2]|0,(d[1167548+(e&65535)>>0]|0)+(d[1167548+(D&65535)>>0]|0)+(d[1167548+(E&65535)>>0]|0)+(d[1167548+F>>0]|0)|0)|0)+G|0;F=z;E=f&c[F>>2];F=g&c[F+4>>2];D=av(E|0,F|0,16)|0;g=av(E|0,F|0,48)|0;g=(S(c[A>>2]|0,(d[1167548+(D&65535)>>0]|0)+(d[1167548+(E&65535)>>0]|0)+(d[1167548+(F&65535)>>0]|0)+(d[1167548+g>>0]|0)|0)|0)+G|0}h=h+1|0;if((h|0)==2)break;else e=g}f=c[k>>2]|0;e=b>>>6;if((b&61440|0)==36864)e=e&15;else e=c[a+((e&63)<<2)>>2]|0;G=(c[11108+(f<<7)+(c[a+(C<<2)>>2]<<2)>>2]|0)+g-(c[11108+(f<<7)+(e<<2)>>2]|0)|0;return G|0}function $f(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;X=l;l=l+16|0;O=X+8|0;L=X;W=a+5364|0;switch(c[W>>2]|0){case 3:{V=(e|0)/2|0;break}case 8:{if(Rf(a,b)|0){W=1;l=X;return W|0}else V=e;break}default:V=e}e=b&49152;m=(e|0)==32768;do if(m){e=b&12288;h=(e|0)==4096;g=b>>>6;i=g&63;f=h?64:i;k=b&63;e=e&16383;a:do if(e<<16>>16<8192)switch(e<<16>>16){case 4096:{e=g;break}default:N=9}else{switch(e<<16>>16){case 8192:break;default:{N=9;break a}}e=c[a+(f<<2)>>2]|0}while(0);if((N|0)==9)e=c[a+(f<<2)>>2]|0;j=e&7;if(h){e=g&15;i=64;break}else{e=c[a+(f<<2)>>2]|0;break}}else{if((e|0)!=49152){i=b>>>6&63;j=c[a+(i<<2)>>2]|0;e=j;k=b&63;j=j&7;break}W=(V|0)<1;l=X;return W|0}while(0);o=e>>3;p=c[W>>2]|0;b:do if((p|0)!=2){c:do if(m){e=b&12288;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:{N=36;break c}default:{}}else switch(e<<16>>16){case 8192:{N=36;break c}default:{}}n=30544+(k-((o|0)==0?8:-8)<<3)|0;m=c[n>>2]|0;n=c[n+4>>2]|0;e=O;c[e>>2]=m;c[e+4>>2]=n;e=c[11108+(p<<7)+4>>2]|0}else N=36;while(0);if((N|0)==36){e=c[11108+(p<<7)+(c[a+(k<<2)>>2]<<2)>>2]|0;m=O;c[m>>2]=0;c[m+4>>2]=0;m=0;n=0}if((e|0)>=(V|0))if(!((j|0)==6&(p|0)!=1)?(q=e-(c[11108+(p<<7)+(j<<2)>>2]|0)|0,(q|0)<(V|0)):0){K=a+256|0;g=K;e=c[g>>2]|0;g=c[g+4>>2]|0;h=30544+(k<<3)|0;f=c[h>>2]|0;h=c[h+4>>2]|0;if((b&61440|0)==36864){f=f^e;e=h^g}else{U=30544+(i<<3)|0;f=c[U>>2]^e^f;e=c[U+4>>2]^g^h}t=f^m;u=e^n;s=O;c[s>>2]=t;c[s+4>>2]=u;s=35984+(k<<3)|0;r=a+320|0;w=a+264|0;v=w;i=c[v>>2]|0;v=c[v+4>>2]|0;m=31888+(k<<3)|0;n=a+328|0;Q=32400+(k<<3)|0;b=a+272|0;P=b;x=28496+(k<<3)|0;z=x;y=29008+(k<<3)|0;T=y;T=(S(c[z+4>>2]&u,c[T+4>>2]|0)|0)^(S(c[z>>2]&t,c[T>>2]|0)|0);z=1035684+(k<<2)|0;A=1035428+(k<<2)|0;T=(c[A>>2]|0)+(T>>>(c[z>>2]|0)<<3)|0;B=a+288|0;R=B;C=a+296|0;h=C;j=c[h>>2]|0;h=c[h+4>>2]|0;E=29520+(k<<3)|0;G=E;F=30032+(k<<3)|0;f=F;f=(S(c[G+4>>2]&u,c[f+4>>2]|0)|0)^(S(c[G>>2]&t,c[f>>2]|0)|0);G=1036196+(k<<2)|0;H=1035940+(k<<2)|0;f=(c[H>>2]|0)+(f>>>(c[G>>2]|0)<<3)|0;I=a+280|0;U=I;J=34448+(k<<3)|0;e=a+304|0;t=(c[m>>2]&i&c[n>>2]|c[r>>2]&c[s>>2]&i|c[P>>2]&c[Q>>2]|(j|c[R>>2])&c[T>>2]|(c[U>>2]|j)&c[f>>2]|c[e>>2]&c[J>>2])&t;u=(c[m+4>>2]&v&c[n+4>>2]|c[r+4>>2]&c[s+4>>2]&v|c[P+4>>2]&c[Q+4>>2]|(h|c[R+4>>2])&c[T+4>>2]|(c[U+4>>2]|h)&c[f+4>>2]|c[e+4>>2]&c[J+4>>2])&u;J=L;c[J>>2]=t;c[J+4>>2]=u;J=a+5356|0;e=1;f=q;h=p;while(1){v=o^1;i=a+320+(v<<3)|0;g=c[i>>2]&t;i=c[i+4>>2]&u;j=(h|0)==1;if(!j?(M=c[J>>2]|0,T=M+360+(v<<3)|0,U=O,(c[T>>2]&~c[U>>2]|0)==0?(c[T+4>>2]&~c[U+4>>2]|0)==0:0):0){U=M+344+(v<<3)|0;g=g&~c[U>>2];i=i&~c[U+4>>2]}if((g|0)==0&(i|0)==0)break;do if(!j){m=w;j=c[m>>2]&g;m=c[m+4>>2]&i;if(!((j|0)==0&(m|0)==0)){T=Vu(0,0,j|0,m|0)|0;U=O;T=c[U>>2]^j&T;U=c[U+4>>2]^m&D;Q=O;c[Q>>2]=T;c[Q+4>>2]=U;Q=E;R=F;R=(S(c[Q+4>>2]&U,c[R+4>>2]|0)|0)^(S(c[Q>>2]&T,c[R>>2]|0)|0);R=(c[H>>2]|0)+(R>>>(c[G>>2]|0)<<3)|0;Q=I;P=C;U=((c[P+4>>2]|c[Q+4>>2])&c[R+4>>2]|u)&U;g=L;c[g>>2]=((c[P>>2]|c[Q>>2])&c[R>>2]|t)&T;c[g+4>>2]=U;g=1;break}m=b;j=c[m>>2]&g;m=c[m+4>>2]&i;if(!((j|0)==0&(m|0)==0)){T=Vu(0,0,j|0,m|0)|0;U=O;T=c[U>>2]^j&T;U=c[U+4>>2]^m&D;g=O;c[g>>2]=T;c[g+4>>2]=U;g=L;c[g>>2]=t&T;c[g+4>>2]=u&U;g=2;break}s=I;r=c[s>>2]|0;s=c[s+4>>2]|0;j=r&g;m=s&i;if(!((j|0)==0&(m|0)==0)){T=Vu(0,0,j|0,m|0)|0;U=O;T=c[U>>2]^j&T;U=c[U+4>>2]^m&D;Q=O;c[Q>>2]=T;c[Q+4>>2]=U;Q=E;R=F;R=(S(c[Q+4>>2]&U,c[R+4>>2]|0)|0)^(S(c[Q>>2]&T,c[R>>2]|0)|0);R=(c[H>>2]|0)+(R>>>(c[G>>2]|0)<<3)|0;Q=C;U=((c[Q+4>>2]|s)&c[R+4>>2]|u)&U;g=L;c[g>>2]=((c[Q>>2]|r)&c[R>>2]|t)&T;c[g+4>>2]=U;g=3;break}q=B;p=c[q>>2]|0;q=c[q+4>>2]|0;j=p&g;m=q&i;if(!((j|0)==0&(m|0)==0)){T=Vu(0,0,j|0,m|0)|0;U=O;T=c[U>>2]^j&T;U=c[U+4>>2]^m&D;Q=O;c[Q>>2]=T;c[Q+4>>2]=U;Q=x;R=y;R=(S(c[Q+4>>2]&U,c[R+4>>2]|0)|0)^(S(c[Q>>2]&T,c[R>>2]|0)|0);R=(c[A>>2]|0)+(R>>>(c[z>>2]|0)<<3)|0;Q=C;U=((c[Q+4>>2]|q)&c[R+4>>2]|u)&U;g=L;c[g>>2]=((c[Q>>2]|p)&c[R>>2]|t)&T;c[g+4>>2]=U;g=4;break}n=C;m=c[n>>2]|0;n=c[n+4>>2]|0;j=m&g;g=n&i;if((j|0)==0&(g|0)==0){g=6;N=60}else{T=Vu(0,0,j|0,g|0)|0;U=O;T=c[U>>2]^j&T;U=c[U+4>>2]^g&D;g=O;c[g>>2]=T;c[g+4>>2]=U;g=E;R=F;R=(S(c[g+4>>2]&U,c[R+4>>2]|0)|0)^(S(c[g>>2]&T,c[R>>2]|0)|0);R=(c[H>>2]|0)+(R>>>(c[G>>2]|0)<<3)|0;g=x;Q=y;Q=(S(c[g+4>>2]&U,c[Q+4>>2]|0)|0)^(S(c[g>>2]&T,c[Q>>2]|0)|0);Q=(c[A>>2]|0)+(Q>>>(c[z>>2]|0)<<3)|0;U=((n|q)&c[Q+4>>2]|((n|s)&c[R+4>>2]|u))&U;g=L;c[g>>2]=((m|p)&c[Q>>2]|((m|r)&c[R>>2]|t))&T;c[g+4>>2]=U;g=5}}else{g=ag(K,k,g,i,O,L)|0;h=c[W>>2]|0;N=60}while(0);if((N|0)==60){N=0;if((g|0)==6&(h|0)!=1){N=61;break}}g=c[11108+(h<<7)+(g<<2)>>2]|0;if(e){f=g+f|0;if((f|0)<(V|0)){e=0;break}else e=0}else{f=f-g|0;if((f|0)<(V|0))e=1;else{e=1;break}}u=L;o=v;t=c[u>>2]|0;u=c[u+4>>2]|0}if((N|0)==61){W=L;a=a+320+(o<<3)|0;e=e^(c[a>>2]&c[W>>2]|0?1:(c[a+4>>2]&c[W+4>>2]|0)!=0)^1}}else e=1;else e=0}else{U=c[a+(i<<2)>>2]>>3;d:do if(!(c[a+(k<<2)>>2]|0)){e:do if(m){e=b&12288;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:break e;default:break d}else switch(e<<16>>16){case 8192:break e;default:break d}}while(0);if((V|0)>0){e=0;break b}o=a+256|0;m=c[o>>2]|0;o=c[o+4>>2]|0;n=30544+(i<<3)|0;i=c[n>>2]|0;n=c[n+4>>2]|0;v=i^m;F=n^o;J=O;c[J>>2]=v;c[J+4>>2]=F;J=35984+(k<<3)|0;I=a+320|0;j=a+264|0;g=c[j>>2]|0;j=c[j+4>>2]|0;G=31888+(k<<3)|0;H=a+328|0;L=32400+(k<<3)|0;P=a+272|0;K=P;Q=28496+(k<<3)|0;O=29008+(k<<3)|0;O=(S(c[Q+4>>2]&F,c[O+4>>2]|0)|0)^(S(c[Q>>2]&v,c[O>>2]|0)|0);O=(c[1035428+(k<<2)>>2]|0)+(O>>>(c[1035684+(k<<2)>>2]|0)<<3)|0;Q=a+288|0;s=Q;r=c[s>>2]|0;s=c[s+4>>2]|0;R=a+296|0;q=R;p=c[q>>2]|0;q=c[q+4>>2]|0;T=29520+(k<<3)|0;w=30032+(k<<3)|0;w=(S(c[T+4>>2]&F,c[w+4>>2]|0)|0)^(S(c[T>>2]&v,c[w>>2]|0)|0);w=(c[1035940+(k<<2)>>2]|0)+(w>>>(c[1036196+(k<<2)>>2]|0)<<3)|0;T=a+280|0;u=T;t=c[u>>2]|0;u=c[u+4>>2]|0;f=34448+(k<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;N=a+304|0;M=c[N>>2]|0;N=c[N+4>>2]|0;k=a+320+((U^1)<<3)|0;h=c[k>>2]|0;k=c[k+4>>2]|0;v=v&~M&h&(c[G>>2]&g&c[H>>2]|c[I>>2]&c[J>>2]&g|c[K>>2]&c[L>>2]|(p|r)&c[O>>2]|(t|p)&c[w>>2]|M&e);w=F&~N&k&(c[G+4>>2]&j&c[H+4>>2]|c[I+4>>2]&c[J+4>>2]&j|c[K+4>>2]&c[L+4>>2]|(q|s)&c[O+4>>2]|(u|q)&c[w+4>>2]|N&f);O=a+320+(U<<3)|0;if((v|0)==0&(w|0)==0){e=1;break b}L=(g^m)&e&~i;K=(j^o)&f&~n;J=M&h;H=N&k;I=(b&61440|0)==36864;G=b>>>6;F=G&15;G=a+((G&63)<<2)|0;k=q;j=r;h=s;g=t;f=u;e=2;while(1){E=Qa(v|0,w|0,0)|0;u=Yu(v|0,w|0,-1,-1)|0;v=u&v;w=D&w;u=30544+(E<<3)|0;t=L&~c[u>>2];u=K&~c[u+4>>2];if((J&t|0)==0&(H&u|0)==0){C=O;if(!((t&M&c[C>>2]|0)==0?(u&N&c[C+4>>2]|0)==0:0)){e=0;break b}b=11108+(e<<7)+8|0;x=11108+(e<<7)+12|0;y=11108+(e<<7)+16|0;z=11108+(e<<7)+20|0;A=11108+(e<<7)+8|0;B=11108+(e<<7)+12|0;C=11108+(e<<7)+16|0;q=11108+(e<<7)+20|0;s=P;r=c[s>>2]|0;s=c[s+4>>2]|0;o=0;n=0;while(1){i=a+320+(o<<3)|0;e=c[i>>2]&t;i=c[i+4>>2]&u;Z=e&r;Y=i&s;_=av(Z|0,Y|0,16)|0;m=av(Z|0,Y|0,48)|0;m=(d[1167548+(_&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+(Y&65535)>>0]|0)+(d[1167548+m>>0]|0)|0;if((o|0)==(U|0)){k=n-(S(c[b>>2]|0,m)|0)|0;f=T;g=c[f>>2]|0;f=c[f+4>>2]|0;j=e&g;h=i&f;p=av(j|0,h|0,16)|0;_=av(j|0,h|0,48)|0;_=k-(S(c[x>>2]|0,(d[1167548+(p&65535)>>0]|0)+(d[1167548+(j&65535)>>0]|0)+(d[1167548+(h&65535)>>0]|0)+(d[1167548+_>>0]|0)|0)|0)|0;h=Q;j=c[h>>2]|0;h=c[h+4>>2]|0;p=e&j;k=i&h;Z=av(p|0,k|0,16)|0;n=av(p|0,k|0,48)|0;n=_-(S(c[y>>2]|0,(d[1167548+(Z&65535)>>0]|0)+(d[1167548+(p&65535)>>0]|0)+(d[1167548+(k&65535)>>0]|0)+(d[1167548+n>>0]|0)|0)|0)|0;k=R;p=c[k>>2]|0;k=c[k+4>>2]|0;Z=e&p;_=i&k;Y=av(Z|0,_|0,16)|0;m=av(Z|0,_|0,48)|0;m=n-(S(c[z>>2]|0,(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+(_&65535)>>0]|0)+(d[1167548+m>>0]|0)|0)|0)|0}else{m=(S(c[A>>2]|0,m)|0)+n|0;_=e&g;Z=i&f;Y=av(_|0,Z|0,16)|0;n=av(_|0,Z|0,48)|0;m=(S(c[B>>2]|0,(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(_&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+n>>0]|0)|0)|0)+m|0;n=e&j;Z=i&h;_=av(n|0,Z|0,16)|0;Y=av(n|0,Z|0,48)|0;m=(S(c[C>>2]|0,(d[1167548+(_&65535)>>0]|0)+(d[1167548+(n&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+Y>>0]|0)|0)|0)+m|0;Y=e&p;Z=i&k;n=av(Y|0,Z|0,16)|0;_=av(Y|0,Z|0,48)|0;m=(S(c[q>>2]|0,(d[1167548+(n&65535)>>0]|0)+(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+_>>0]|0)|0)|0)+m|0}o=o+1|0;if((o|0)==2)break;else n=m}i=c[W>>2]|0;if(I)e=F;else e=c[G>>2]|0;if(((c[11108+(i<<7)+(c[a+(E<<2)>>2]<<2)>>2]|0)+m-(c[11108+(i<<7)+(e<<2)>>2]|0)|0)<(V|0)){e=0;break b}else e=i}if((v|0)==0&(w|0)==0){e=1;break b}}}while(0);e=(_f(a,b)|0)>(V|0)}while(0);_=e;l=X;return _|0}function ag(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;k=a+40|0;i=k;h=c[i>>2]&d;i=c[i+4>>2]&e;if(!((h|0)==0&(i|0)==0)){j=Vu(0,0,h|0,i|0)|0;e=f;h=c[e>>2]^h&j;e=c[e+4>>2]^i&D;j=f;c[j>>2]=h;c[j+4>>2]=e;j=29520+(b<<3)|0;i=30032+(b<<3)|0;i=(S(c[j+4>>2]&e,c[i+4>>2]|0)|0)^(S(c[j>>2]&h,c[i>>2]|0)|0);i=(c[1035940+(b<<2)>>2]|0)+(i>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;h=a+24|0;j=k;e=g;d=(c[j>>2]|c[h>>2])&c[i>>2]|c[e>>2];e=(c[j+4>>2]|c[h+4>>2])&c[i+4>>2]|c[e+4>>2];i=g;c[i>>2]=d;c[i+4>>2]=e;i=f;h=28496+(b<<3)|0;j=29008+(b<<3)|0;j=(S(c[h+4>>2]&c[i+4>>2],c[j+4>>2]|0)|0)^(S(c[h>>2]&c[i>>2],c[j>>2]|0)|0);b=(c[1035428+(b<<2)>>2]|0)+(j>>>(c[1035684+(b<<2)>>2]|0)<<3)|0;a=a+32|0;d=(c[k>>2]|c[a>>2])&c[b>>2]|d;k=(c[k+4>>2]|c[a+4>>2])&c[b+4>>2]|e;e=g;c[e>>2]=d;c[e+4>>2]=k;e=f;f=k&c[e+4>>2];k=g;c[k>>2]=d&c[e>>2];c[k+4>>2]=f;k=5;return k|0}h=a+32|0;j=h;i=c[j>>2]&d;j=c[j+4>>2]&e;if(!((i|0)==0&(j|0)==0)){a=Vu(0,0,i|0,j|0)|0;d=f;a=c[d>>2]^i&a;j=c[d+4>>2]^j&D;d=f;c[d>>2]=a;c[d+4>>2]=j;d=28496+(b<<3)|0;e=29008+(b<<3)|0;e=(S(c[d+4>>2]&j,c[e+4>>2]|0)|0)^(S(c[d>>2]&a,c[e>>2]|0)|0);e=(c[1035428+(b<<2)>>2]|0)+(e>>>(c[1035684+(b<<2)>>2]|0)<<3)|0;b=h;a=k;k=g;d=(c[a>>2]|c[b>>2])&c[e>>2]|c[k>>2];k=(c[a+4>>2]|c[b+4>>2])&c[e+4>>2]|c[k+4>>2];e=g;c[e>>2]=d;c[e+4>>2]=k;e=f;f=k&c[e+4>>2];k=g;c[k>>2]=d&c[e>>2];c[k+4>>2]=f;k=4;return k|0}j=a+24|0;i=j;h=c[i>>2]&d;i=c[i+4>>2]&e;if(!((h|0)==0&(i|0)==0)){a=Vu(0,0,h|0,i|0)|0;d=f;a=c[d>>2]^h&a;i=c[d+4>>2]^i&D;d=f;c[d>>2]=a;c[d+4>>2]=i;d=29520+(b<<3)|0;e=30032+(b<<3)|0;e=(S(c[d+4>>2]&i,c[e+4>>2]|0)|0)^(S(c[d>>2]&a,c[e>>2]|0)|0);e=(c[1035940+(b<<2)>>2]|0)+(e>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;b=j;a=k;k=g;d=(c[a>>2]|c[b>>2])&c[e>>2]|c[k>>2];k=(c[a+4>>2]|c[b+4>>2])&c[e+4>>2]|c[k+4>>2];e=g;c[e>>2]=d;c[e+4>>2]=k;e=f;f=k&c[e+4>>2];k=g;c[k>>2]=d&c[e>>2];c[k+4>>2]=f;k=3;return k|0}i=a+16|0;h=c[i>>2]&d;i=c[i+4>>2]&e;if(!((h|0)==0&(i|0)==0)){e=Vu(0,0,h|0,i|0)|0;k=f;e=c[k>>2]^h&e;k=c[k+4>>2]^i&D;d=f;c[d>>2]=e;c[d+4>>2]=k;d=g;f=c[d+4>>2]&k;k=g;c[k>>2]=c[d>>2]&e;c[k+4>>2]=f;k=2;return k|0}i=a+8|0;h=c[i>>2]&d;i=c[i+4>>2]&e;if(!((h|0)==0&(i|0)==0)){a=Vu(0,0,h|0,i|0)|0;d=f;a=c[d>>2]^h&a;i=c[d+4>>2]^i&D;d=f;c[d>>2]=a;c[d+4>>2]=i;d=29520+(b<<3)|0;e=30032+(b<<3)|0;e=(S(c[d+4>>2]&i,c[e+4>>2]|0)|0)^(S(c[d>>2]&a,c[e>>2]|0)|0);e=(c[1035940+(b<<2)>>2]|0)+(e>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;b=j;a=k;k=g;d=(c[a>>2]|c[b>>2])&c[e>>2]|c[k>>2];k=(c[a+4>>2]|c[b+4>>2])&c[e+4>>2]|c[k+4>>2];e=g;c[e>>2]=d;c[e+4>>2]=k;e=f;f=k&c[e+4>>2];k=g;c[k>>2]=d&c[e>>2];c[k+4>>2]=f;k=1;return k|0}k=a+48|0;if((c[k>>2]&d|0)==0?(c[k+4>>2]&e|0)==0:0){k=0;return k|0}k=bg(a,b,d,e,f,g)|0;return k|0}function bg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0;i=a+48|0;h=c[i>>2]&d;i=c[i+4>>2]&e;if((h|0)==0&(i|0)==0){g=ag(a,b,d,e,f,g)|0;return g|0}else{k=Vu(0,0,h|0,i|0)|0;e=f;k=c[e>>2]^h&k;e=c[e+4>>2]^i&D;j=f;c[j>>2]=k;c[j+4>>2]=e;j=29520+(b<<3)|0;h=30032+(b<<3)|0;h=(S(c[j+4>>2]&e,c[h+4>>2]|0)|0)^(S(c[j>>2]&k,c[h>>2]|0)|0);h=(c[1035940+(b<<2)>>2]|0)+(h>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;k=a+24|0;j=a+40|0;e=j;i=g;d=(c[e>>2]|c[k>>2])&c[h>>2]|c[i>>2];i=(c[e+4>>2]|c[k+4>>2])&c[h+4>>2]|c[i+4>>2];h=g;c[h>>2]=d;c[h+4>>2]=i;h=f;k=28496+(b<<3)|0;e=29008+(b<<3)|0;e=(S(c[k+4>>2]&c[h+4>>2],c[e+4>>2]|0)|0)^(S(c[k>>2]&c[h>>2],c[e>>2]|0)|0);e=(c[1035428+(b<<2)>>2]|0)+(e>>>(c[1035684+(b<<2)>>2]|0)<<3)|0;h=a+32|0;b=j;d=(c[b>>2]|c[h>>2])&c[e>>2]|d;i=(c[b+4>>2]|c[h+4>>2])&c[e+4>>2]|i;e=g;c[e>>2]=d;c[e+4>>2]=i;e=f;f=i&c[e+4>>2];c[g>>2]=d&c[e>>2];c[g+4>>2]=f;g=6;return g|0}return 0}function cg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+4112|0;d=i;e=a+5356|0;f=c[e>>2]|0;do if((c[f+28>>2]|0)>99){h=f+64|0;if((c[h>>2]|0)==0&(c[h+4>>2]|0)==0){b=1;l=i;return b|0}h=kf(a,d)|0;c[d+4096>>2]=h;if((h|0)==(d|0)){f=c[e>>2]|0;break}else{b=1;l=i;return b|0}}while(0);if((c[a+5364>>2]|0)==3)d=f+32|0;else{d=f+28|0;h=f+32|0;d=(c[h>>2]|0)<(c[d>>2]|0)?h:d}a=c[d>>2]|0;if((a|0)<4){b=0;l=i;return b|0}h=f+56|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=0;e=c[(c[f+336>>2]|0)+336>>2]|0;f=4;while(1){e=c[(c[e+336>>2]|0)+336>>2]|0;j=e+56|0;if((c[j>>2]|0)==(g|0)?(c[j+4>>2]|0)==(h|0):0){d=d+1|0;if((((f|0)<(b|0)&1)+d|0)==2){d=1;e=13;break}}f=f+2|0;if((f|0)>(a|0)){d=0;e=13;break}}if((e|0)==13){l=i;return d|0}return 0}function dg(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+144|0;a=b;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Jt(a,21816,5);d=a+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=a+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=a+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=a+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=a+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=a+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=a+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=a+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=a+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=a+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=a+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[270848]=p;c[270847]=p;c[270849]=p+144;It(p,a);p=(c[270848]|0)+12|0;c[270848]=p;It(p,d);p=(c[270848]|0)+12|0;c[270848]=p;It(p,e);p=(c[270848]|0)+12|0;c[270848]=p;It(p,f);p=(c[270848]|0)+12|0;c[270848]=p;It(p,g);p=(c[270848]|0)+12|0;c[270848]=p;It(p,h);p=(c[270848]|0)+12|0;c[270848]=p;It(p,i);p=(c[270848]|0)+12|0;c[270848]=p;It(p,j);p=(c[270848]|0)+12|0;c[270848]=p;It(p,k);p=(c[270848]|0)+12|0;c[270848]=p;It(p,m);p=(c[270848]|0)+12|0;c[270848]=p;It(p,n);p=(c[270848]|0)+12|0;c[270848]=p;It(p,o);c[270848]=(c[270848]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(a);Wu(1083400,0,144)|0;c[270886]=458741;c[270887]=-262138;c[270888]=524295;c[270889]=-131069;c[270890]=-262162;c[270891]=-327682;c[270892]=327699;c[270893]=262168;c[270894]=196591;c[270895]=196599;c[270896]=-524268;c[270897]=-196573;c[270898]=524282;c[270899]=589829;c[270900]=458755;c[270901]=-393195;c[270902]=524282;c[270903]=-327688;c[270904]=131066;c[270905]=262142;c[270906]=196604;c[270907]=-589804;c[270908]=65528;c[270909]=1179644;c[270910]=0;c[270911]=0;c[270912]=0;c[270913]=0;c[270914]=-6422672;c[270915]=-5374048;c[270916]=-3014736;c[270917]=-917577;c[270918]=-4522067;c[270919]=-3538987;c[270920]=-1114133;c[270921]=589814;c[270922]=-3276871;c[270923]=-2555926;c[270924]=-458752;c[270925]=1835017;c[270926]=-2687001;c[270927]=-1638382;c[270928]=393259;c[270929]=2490415;c[270930]=-3014682;c[270931]=-1638384;c[270932]=196646;c[270933]=2621490;c[270934]=-3538955;c[270935]=-2490331;c[270936]=-458696;c[270937]=1769537;c[270938]=-4259902;c[270939]=-3276817;c[270940]=-1572859;c[270941]=851982;c[270942]=-7143618;c[270943]=-5832770;c[270944]=-3276842;c[270945]=-851997;c[270946]=-3801132;c[270947]=-2031629;c[270948]=-2424857;c[270949]=-1245218;c[270950]=-2228244;c[270951]=-589804;c[270952]=-917492;c[270953]=262145;c[270954]=-1507337;c[270955]=27;c[270956]=-196587;c[270957]=1048587;c[270958]=-1703947;c[270959]=-196580;c[270960]=-327659;c[270961]=1048586;c[270962]=-1703947;c[270963]=-262120;c[270964]=-458736;c[270965]=917513;c[270966]=-1572881;c[270967]=-131056;c[270968]=12;c[270969]=851970;c[270970]=-2228247;c[270971]=-655343;c[270972]=-786426;c[270973]=393214;c[270974]=-3604515;c[270975]=-2097163;c[270976]=-2359315;c[270977]=-1114141;c[270978]=-25;c[270979]=-16;c[270980]=-16;c[270981]=-9;c[270982]=-21;c[270983]=-8;c[270984]=-3;c[270985]=0;c[270986]=-21;c[270987]=-9;c[270988]=-4;c[270989]=2;c[270990]=-22;c[270991]=-6;c[270992]=-1;c[270993]=2;c[270994]=-22;c[270995]=-7;c[270996]=0;c[270997]=1;c[270998]=-21;c[270999]=-7;c[271e3]=0;c[271001]=2;c[271002]=-12;c[271003]=4;c[271004]=8;c[271005]=12;c[271006]=-23;c[271007]=-15;c[271008]=-11;c[271009]=-5;c[271010]=-4653056;c[271011]=-3670020;c[271012]=-2752515;c[271013]=-1900545;c[271014]=-3670020;c[271015]=-1966074;c[271016]=-1376247;c[271017]=-327672;c[271018]=-2555906;c[271019]=-1114106;c[271020]=-524279;c[271021]=327689;c[271022]=-1900545;c[271023]=-327672;c[271024]=589834;c[271025]=1245191;c[271026]=-1769475;c[271027]=-327671;c[271028]=655368;c[271029]=1376263;c[271030]=-2621442;c[271031]=-1048570;c[271032]=-655352;c[271033]=196618;c[271034]=-3604482;c[271035]=-1966073;c[271036]=-1376249;c[271037]=-393210;c[271038]=-4849665;c[271039]=-3604484;c[271040]=-2818049;c[271041]=-1966080;c[271042]=267;c[271043]=3146048;c[271044]=4915470;c[271045]=5505219;c[271046]=2818312;c[271047]=6029616;c[271048]=9371886;c[271049]=8650932;c[271050]=5439688;c[271051]=9044213;c[271052]=10944688;c[271053]=10813550;c[271054]=6946993;c[271055]=11075769;c[271056]=11075732;c[271057]=11731054;c[271058]=7078037;c[271059]=10682545;c[271060]=13107315;c[271061]=13303874;c[271062]=6226038;c[271063]=10158239;c[271064]=11534420;c[271065]=11403305;c[271066]=3276886;c[271067]=6488192;c[271068]=7995455;c[271069]=9109522;c[271070]=589887;c[271071]=3604569;c[271072]=5242927;c[271073]=5898240;Wu(1084296,0,272)|0;c[271142]=458741;c[271143]=-262138;c[271144]=524295;c[271145]=-131069;c[271146]=-262162;c[271147]=-327682;c[271148]=327699;c[271149]=262168;c[271150]=196591;c[271151]=196599;c[271152]=-524268;c[271153]=-196573;c[271154]=524282;c[271155]=589829;c[271156]=458755;c[271157]=-393195;c[271158]=524282;c[271159]=-327688;c[271160]=131066;c[271161]=262142;c[271162]=196604;c[271163]=-589804;c[271164]=65528;c[271165]=1179644;c[271166]=0;c[271167]=0;c[271168]=0;c[271169]=0;c[271170]=-6357135;c[271171]=-5374048;c[271172]=-3014736;c[271173]=-917577;c[271174]=-4522067;c[271175]=-3604523;c[271176]=-1114133;c[271177]=589814;c[271178]=-3276871;c[271179]=-2555926;c[271180]=-524288;c[271181]=1835017;c[271182]=-2687001;c[271183]=-1638382;c[271184]=458795;c[271185]=2490415;c[271186]=-3014682;c[271187]=-1638384;c[271188]=131110;c[271189]=2687026;c[271190]=-3604491;c[271191]=-2490331;c[271192]=-524232;c[271193]=1769543;c[271194]=-4194366;c[271195]=-3276817;c[271196]=-1572859;c[271197]=851982;c[271198]=-7209155;c[271199]=-5898306;c[271200]=-3276842;c[271201]=-851997;c[271202]=-4456502;c[271203]=-2621463;c[271204]=-3014691;c[271205]=-1835052;c[271206]=-2818078;c[271207]=-1114102;c[271208]=-1507326;c[271209]=-327689;c[271210]=-2097171;c[271211]=-589807;c[271212]=-851957;c[271213]=524289;c[271214]=-2359317;c[271215]=-851950;c[271216]=-983029;c[271217]=458752;c[271218]=-2359317;c[271219]=-917490;c[271220]=-1114106;c[271221]=196607;c[271222]=-2293787;c[271223]=-851962;c[271224]=-655358;c[271225]=65528;c[271226]=-2883617;c[271227]=-1376249;c[271228]=-1441796;c[271229]=-262156;c[271230]=-4259885;c[271231]=-2752533;c[271232]=-3014685;c[271233]=-1769511;c[271234]=-25;c[271235]=-16;c[271236]=-16;c[271237]=-9;c[271238]=-21;c[271239]=-8;c[271240]=-3;c[271241]=0;c[271242]=-21;c[271243]=-9;c[271244]=-4;c[271245]=2;c[271246]=-22;c[271247]=-6;c[271248]=-1;c[271249]=2;c[271250]=-22;c[271251]=-7;c[271252]=0;c[271253]=1;c[271254]=-21;c[271255]=-7;c[271256]=0;c[271257]=2;c[271258]=-12;c[271259]=4;c[271260]=8;c[271261]=12;c[271262]=-23;c[271263]=-15;c[271264]=-11;c[271265]=-5;c[271266]=-4587520;c[271267]=-3735555;c[271268]=-2686980;c[271269]=-1900545;c[271270]=-3801092;c[271271]=-1966074;c[271272]=-1376247;c[271273]=-262136;c[271274]=-2555906;c[271275]=-1114106;c[271276]=-458743;c[271277]=327689;c[271278]=-1900545;c[271279]=-327672;c[271280]=589834;c[271281]=1114119;c[271282]=-1769475;c[271283]=-327671;c[271284]=655368;c[271285]=1507335;c[271286]=-2621442;c[271287]=-1048570;c[271288]=-720888;c[271289]=196618;c[271290]=-3538946;c[271291]=-1966073;c[271292]=-1376249;c[271293]=-458746;c[271294]=-4915201;c[271295]=-3538948;c[271296]=-2883585;c[271297]=-1966080;c[271298]=1835299;c[271299]=4981080;c[271300]=6750502;c[271301]=7340251;c[271302]=4587809;c[271303]=7799113;c[271304]=11141383;c[271305]=10420429;c[271306]=7143650;c[271307]=10748175;c[271308]=12779722;c[271309]=12517512;c[271310]=8585420;c[271311]=12714196;c[271312]=12714159;c[271313]=13369481;c[271314]=8650929;c[271315]=12255437;c[271316]=14680207;c[271317]=14876766;c[271318]=7733395;c[271319]=11665596;c[271320]=13041777;c[271321]=12910662;c[271322]=4718708;c[271323]=7930014;c[271324]=9306205;c[271325]=10551344;c[271326]=1966174;c[271327]=4980856;c[271328]=6619214;c[271329]=7274527;Wu(1085320,0,272)|0;c[271398]=458741;c[271399]=-262138;c[271400]=524295;c[271401]=-131069;c[271402]=-262162;c[271403]=-327682;c[271404]=327699;c[271405]=262168;c[271406]=196591;c[271407]=196599;c[271408]=-524268;c[271409]=-196573;c[271410]=524282;c[271411]=589829;c[271412]=458755;c[271413]=-393195;c[271414]=524282;c[271415]=-327688;c[271416]=131066;c[271417]=262142;c[271418]=196604;c[271419]=-589804;c[271420]=65528;c[271421]=1179644;c[271422]=0;c[271423]=0;c[271424]=0;c[271425]=0;c[271426]=-6357135;c[271427]=-5374048;c[271428]=-3014736;c[271429]=-917577;c[271430]=-4522067;c[271431]=-3604523;c[271432]=-1114133;c[271433]=589814;c[271434]=-3276871;c[271435]=-2555926;c[271436]=-524288;c[271437]=1835017;c[271438]=-2687001;c[271439]=-1638382;c[271440]=458795;c[271441]=2490415;c[271442]=-3014682;c[271443]=-1638384;c[271444]=131110;c[271445]=2687026;c[271446]=-3604491;c[271447]=-2490331;c[271448]=-524232;c[271449]=1769543;c[271450]=-4194366;c[271451]=-3276817;c[271452]=-1572859;c[271453]=851982;c[271454]=-7209155;c[271455]=-5898306;c[271456]=-3276842;c[271457]=-851997;c[271458]=-4456502;c[271459]=-2621463;c[271460]=-3014691;c[271461]=-1835052;c[271462]=-2818078;c[271463]=-1114102;c[271464]=-1507326;c[271465]=-327689;c[271466]=-2097171;c[271467]=-589807;c[271468]=-851957;c[271469]=524289;c[271470]=-2359317;c[271471]=-851950;c[271472]=-983029;c[271473]=458752;c[271474]=-2359317;c[271475]=-917490;c[271476]=-1114106;c[271477]=196607;c[271478]=-2293787;c[271479]=-851962;c[271480]=-655358;c[271481]=65528;c[271482]=-2883617;c[271483]=-1376249;c[271484]=-1441796;c[271485]=-262156;c[271486]=-4259885;c[271487]=-2752533;c[271488]=-3014685;c[271489]=-1769511;c[271490]=-25;c[271491]=-16;c[271492]=-16;c[271493]=-9;c[271494]=-21;c[271495]=-8;c[271496]=-3;c[271497]=0;c[271498]=-21;c[271499]=-9;c[271500]=-4;c[271501]=2;c[271502]=-22;c[271503]=-6;c[271504]=-1;c[271505]=2;c[271506]=-22;c[271507]=-7;c[271508]=0;c[271509]=1;c[271510]=-21;c[271511]=-7;c[271512]=0;c[271513]=2;c[271514]=-12;c[271515]=4;c[271516]=8;c[271517]=12;c[271518]=-23;c[271519]=-15;c[271520]=-11;c[271521]=-5;c[271522]=-4587520;c[271523]=-3735555;c[271524]=-2686980;c[271525]=-1900545;c[271526]=-3801092;c[271527]=-1966074;c[271528]=-1376247;c[271529]=-262136;c[271530]=-2555906;c[271531]=-1114106;c[271532]=-458743;c[271533]=327689;c[271534]=-1900545;c[271535]=-327672;c[271536]=589834;c[271537]=1114119;c[271538]=-1769475;c[271539]=-327671;c[271540]=655368;c[271541]=1507335;c[271542]=-2621442;c[271543]=-1048570;c[271544]=-720888;c[271545]=196618;c[271546]=-3538946;c[271547]=-1966073;c[271548]=-1376249;c[271549]=-458746;c[271550]=-4915201;c[271551]=-3538948;c[271552]=-2883585;c[271553]=-1966080;c[271554]=260;c[271555]=3146041;c[271556]=4915463;c[271557]=5505212;c[271558]=2752770;c[271559]=5964074;c[271560]=9306344;c[271561]=8585390;c[271562]=5308611;c[271563]=8913136;c[271564]=10944683;c[271565]=10682473;c[271566]=6750381;c[271567]=10879157;c[271568]=10879120;c[271569]=11534442;c[271570]=6815890;c[271571]=10420398;c[271572]=12845168;c[271573]=13041727;c[271574]=5898356;c[271575]=9830557;c[271576]=11206738;c[271577]=11075623;c[271578]=2883669;c[271579]=6094975;c[271580]=7471166;c[271581]=8716305;c[271582]=131135;c[271583]=3145817;c[271584]=4784175;c[271585]=5439488;Wu(1086344,0,272)|0;c[271654]=458741;c[271655]=-262138;c[271656]=524295;c[271657]=-131069;c[271658]=-262162;c[271659]=-327682;c[271660]=327699;c[271661]=262168;c[271662]=196591;c[271663]=196599;c[271664]=-524268;c[271665]=-196573;c[271666]=524282;c[271667]=589829;c[271668]=458755;c[271669]=-393195;c[271670]=524282;c[271671]=-327688;c[271672]=131066;c[271673]=262142;c[271674]=196604;c[271675]=-589804;c[271676]=65528;c[271677]=1179644;c[271678]=0;c[271679]=0;c[271680]=0;c[271681]=0;c[271682]=-6357135;c[271683]=-5374048;c[271684]=-3014736;c[271685]=-917577;c[271686]=-4522067;c[271687]=-3604523;c[271688]=-1114133;c[271689]=589814;c[271690]=-3276871;c[271691]=-2555926;c[271692]=-524288;c[271693]=1835017;c[271694]=-2687001;c[271695]=-1638382;c[271696]=458795;c[271697]=2490415;c[271698]=-3014682;c[271699]=-1638384;c[271700]=131110;c[271701]=2687026;c[271702]=-3604491;c[271703]=-2490331;c[271704]=-524232;c[271705]=1769543;c[271706]=-4194366;c[271707]=-3276817;c[271708]=-1572859;c[271709]=851982;c[271710]=-7209155;c[271711]=-5898306;c[271712]=-3276842;c[271713]=-851997;c[271714]=-4456502;c[271715]=-2621463;c[271716]=-3014691;c[271717]=-1835052;c[271718]=-2818078;c[271719]=-1114102;c[271720]=-1507326;c[271721]=-327689;c[271722]=-2097171;c[271723]=-589807;c[271724]=-851957;c[271725]=524289;c[271726]=-2359317;c[271727]=-851950;c[271728]=-983029;c[271729]=458752;c[271730]=-2359317;c[271731]=-917490;c[271732]=-1114106;c[271733]=196607;c[271734]=-2293787;c[271735]=-851962;c[271736]=-655358;c[271737]=65528;c[271738]=-2883617;c[271739]=-1376249;c[271740]=-1441796;c[271741]=-262156;c[271742]=-4259885;c[271743]=-2752533;c[271744]=-3014685;c[271745]=-1769511;c[271746]=-25;c[271747]=-16;c[271748]=-16;c[271749]=-9;c[271750]=-21;c[271751]=-8;c[271752]=-3;c[271753]=0;c[271754]=-21;c[271755]=-9;c[271756]=-4;c[271757]=2;c[271758]=-22;c[271759]=-6;c[271760]=-1;c[271761]=2;c[271762]=-22;c[271763]=-7;c[271764]=0;c[271765]=1;c[271766]=-21;c[271767]=-7;c[271768]=0;c[271769]=2;c[271770]=-12;c[271771]=4;c[271772]=8;c[271773]=12;c[271774]=-23;c[271775]=-15;c[271776]=-11;c[271777]=-5;c[271778]=-4587520;c[271779]=-3735555;c[271780]=-2686980;c[271781]=-1900545;c[271782]=-3801092;c[271783]=-1966074;c[271784]=-1376247;c[271785]=-262136;c[271786]=-2555906;c[271787]=-1114106;c[271788]=-458743;c[271789]=327689;c[271790]=-1900545;c[271791]=-327672;c[271792]=589834;c[271793]=1114119;c[271794]=-1769475;c[271795]=-327671;c[271796]=655368;c[271797]=1507335;c[271798]=-2621442;c[271799]=-1048570;c[271800]=-720888;c[271801]=196618;c[271802]=-3538946;c[271803]=-1966073;c[271804]=-1376249;c[271805]=-458746;c[271806]=-4915201;c[271807]=-3538948;c[271808]=-2883585;c[271809]=-1966080;c[271810]=13893952;c[271811]=26870234;c[271812]=4194541;c[271813]=4259973;c[271814]=7012599;c[271815]=5046593;c[271816]=3277092;c[271817]=-261953;c[271818]=1245382;c[271819]=5177625;c[271820]=5964007;c[271821]=5701773;c[271822]=5964039;c[271823]=12452063;c[271824]=13107357;c[271825]=9502962;c[271826]=8650929;c[271827]=12255437;c[271828]=14680207;c[271829]=14876766;c[271830]=7733395;c[271831]=11665596;c[271832]=13041777;c[271833]=12910662;c[271834]=4718708;c[271835]=7930014;c[271836]=9306205;c[271837]=10551344;c[271838]=1966174;c[271839]=4980856;c[271840]=6619214;c[271841]=7274527;Wu(1087368,0,256)|0;c[271906]=-2949152;c[271907]=-3014686;c[271908]=-1310743;c[271909]=-458759;c[271910]=-1769499;c[271911]=-983046;c[271912]=-655368;c[271913]=-786439;c[271914]=-1376315;c[271915]=-589829;c[271916]=393205;c[271917]=262148;c[271918]=-458755;c[271919]=851986;c[271920]=655365;c[271921]=131104;c[271922]=11;c[271923]=1179663;c[271924]=1376267;c[271925]=2490398;c[271926]=851989;c[271927]=1310732;c[271928]=2293792;c[271929]=2162724;c[271930]=2162709;c[271931]=2162720;c[271932]=2490412;c[271933]=3604530;c[271934]=0;c[271935]=0;c[271936]=0;c[271937]=0;c[271938]=-6357135;c[271939]=-5374048;c[271940]=-3014736;c[271941]=-917577;c[271942]=-4522067;c[271943]=-3604523;c[271944]=-1114133;c[271945]=589814;c[271946]=-3276871;c[271947]=-2555926;c[271948]=-524288;c[271949]=1835017;c[271950]=-2687001;c[271951]=-1638382;c[271952]=458795;c[271953]=2490415;c[271954]=-3014682;c[271955]=-1638384;c[271956]=131110;c[271957]=2687026;c[271958]=-3604491;c[271959]=-2490331;c[271960]=-524232;c[271961]=1769543;c[271962]=-4194366;c[271963]=-3276817;c[271964]=-1572859;c[271965]=851982;c[271966]=-7209155;c[271967]=-5898306;c[271968]=-3276842;c[271969]=-851997;c[271970]=-4456502;c[271971]=-2621463;c[271972]=-3014691;c[271973]=-1835052;c[271974]=-2818078;c[271975]=-1114102;c[271976]=-1507326;c[271977]=-327689;c[271978]=-2097171;c[271979]=-589807;c[271980]=-851957;c[271981]=524289;c[271982]=-2359317;c[271983]=-851950;c[271984]=-983029;c[271985]=458752;c[271986]=-2359317;c[271987]=-917490;c[271988]=-1114106;c[271989]=196607;c[271990]=-2293787;c[271991]=-851962;c[271992]=-655358;c[271993]=65528;c[271994]=-2883617;c[271995]=-1376249;c[271996]=-1441796;c[271997]=-262156;c[271998]=-4259885;c[271999]=-2752533;c[272e3]=-3014685;c[272001]=-1769511;c[272002]=-25;c[272003]=-16;c[272004]=-16;c[272005]=-9;c[272006]=-21;c[272007]=-8;c[272008]=-3;c[272009]=0;c[272010]=-21;c[272011]=-9;c[272012]=-4;c[272013]=2;c[272014]=-22;c[272015]=-6;c[272016]=-1;c[272017]=2;c[272018]=-22;c[272019]=-7;c[272020]=0;c[272021]=1;c[272022]=-21;c[272023]=-7;c[272024]=0;c[272025]=2;c[272026]=-12;c[272027]=4;c[272028]=8;c[272029]=12;c[272030]=-23;c[272031]=-15;c[272032]=-11;c[272033]=-5;c[272034]=-4587520;c[272035]=-3735555;c[272036]=-2686980;c[272037]=-1900545;c[272038]=-3801092;c[272039]=-1966074;c[272040]=-1376247;c[272041]=-262136;c[272042]=-2555906;c[272043]=-1114106;c[272044]=-458743;c[272045]=327689;c[272046]=-1900545;c[272047]=-327672;c[272048]=589834;c[272049]=1114119;c[272050]=-1769475;c[272051]=-327671;c[272052]=655368;c[272053]=1507335;c[272054]=-2621442;c[272055]=-1048570;c[272056]=-720888;c[272057]=196618;c[272058]=-3538946;c[272059]=-1966073;c[272060]=-1376249;c[272061]=-458746;c[272062]=-4915201;c[272063]=-3538948;c[272064]=-2883585;c[272065]=-1966080;c[272066]=1835238;c[272067]=-2293370;c[272068]=9568653;c[272069]=5439840;c[272070]=2425075;c[272071]=4849938;c[272072]=15008092;c[272073]=25755944;c[272074]=1638636;c[272075]=6881585;c[272076]=6226175;c[272077]=12321022;c[272078]=11469046;c[272079]=16056587;c[272080]=16318644;c[272081]=0;c[272082]=7864471;c[272083]=13566151;c[272084]=15138972;c[272085]=0;c[272086]=7012529;c[272087]=15073469;c[272088]=11272333;c[272089]=16449747;c[272090]=2359322;c[272091]=9502884;c[272092]=9109606;c[272093]=8716246;c[272094]=131219;c[272095]=458938;c[272096]=5177393;c[272097]=3276848;Wu(1088392,0,272)|0;c[272166]=458741;c[272167]=-262138;c[272168]=524295;c[272169]=-131069;c[272170]=-262162;c[272171]=-327682;c[272172]=327699;c[272173]=262168;c[272174]=196591;c[272175]=196599;c[272176]=-524268;c[272177]=-196573;c[272178]=524282;c[272179]=589829;c[272180]=458755;c[272181]=-393195;c[272182]=524282;c[272183]=-327688;c[272184]=131066;c[272185]=262142;c[272186]=196604;c[272187]=-589804;c[272188]=65528;c[272189]=1179644;c[272190]=0;c[272191]=0;c[272192]=0;c[272193]=0;c[272194]=-6357135;c[272195]=-5374048;c[272196]=-3014736;c[272197]=-917577;c[272198]=-4522067;c[272199]=-3604523;c[272200]=-1114133;c[272201]=589814;c[272202]=-3276871;c[272203]=-2555926;c[272204]=-524288;c[272205]=1835017;c[272206]=-2687001;c[272207]=-1638382;c[272208]=458795;c[272209]=2490415;c[272210]=-3014682;c[272211]=-1638384;c[272212]=131110;c[272213]=2687026;c[272214]=-3604491;c[272215]=-2490331;c[272216]=-524232;c[272217]=1769543;c[272218]=-4194366;c[272219]=-3276817;c[272220]=-1572859;c[272221]=851982;c[272222]=-7209155;c[272223]=-5898306;c[272224]=-3276842;c[272225]=-851997;c[272226]=-4456502;c[272227]=-2621463;c[272228]=-3014691;c[272229]=-1835052;c[272230]=-2818078;c[272231]=-1114102;c[272232]=-1507326;c[272233]=-327689;c[272234]=-2097171;c[272235]=-589807;c[272236]=-851957;c[272237]=524289;c[272238]=-2359317;c[272239]=-851950;c[272240]=-983029;c[272241]=458752;c[272242]=-2359317;c[272243]=-917490;c[272244]=-1114106;c[272245]=196607;c[272246]=-2293787;c[272247]=-851962;c[272248]=-655358;c[272249]=65528;c[272250]=-2883617;c[272251]=-1376249;c[272252]=-1441796;c[272253]=-262156;c[272254]=-4259885;c[272255]=-2752533;c[272256]=-3014685;c[272257]=-1769511;c[272258]=-25;c[272259]=-16;c[272260]=-16;c[272261]=-9;c[272262]=-21;c[272263]=-8;c[272264]=-3;c[272265]=0;c[272266]=-21;c[272267]=-9;c[272268]=-4;c[272269]=2;c[272270]=-22;c[272271]=-6;c[272272]=-1;c[272273]=2;c[272274]=-22;c[272275]=-7;c[272276]=0;c[272277]=1;c[272278]=-21;c[272279]=-7;c[272280]=0;c[272281]=2;c[272282]=-12;c[272283]=4;c[272284]=8;c[272285]=12;c[272286]=-23;c[272287]=-15;c[272288]=-11;c[272289]=-5;c[272290]=-4587520;c[272291]=-3735555;c[272292]=-2686980;c[272293]=-1900545;c[272294]=-3801092;c[272295]=-1966074;c[272296]=-1376247;c[272297]=-262136;c[272298]=-2555906;c[272299]=-1114106;c[272300]=-458743;c[272301]=327689;c[272302]=-1900545;c[272303]=-327672;c[272304]=589834;c[272305]=1114119;c[272306]=-1769475;c[272307]=-327671;c[272308]=655368;c[272309]=1507335;c[272310]=-2621442;c[272311]=-1048570;c[272312]=-720888;c[272313]=196618;c[272314]=-3538946;c[272315]=-1966073;c[272316]=-1376249;c[272317]=-458746;c[272318]=-4915201;c[272319]=-3538948;c[272320]=-2883585;c[272321]=-1966080;c[272322]=1835238;c[272323]=-2293370;c[272324]=9568653;c[272325]=5439840;c[272326]=2425075;c[272327]=4849938;c[272328]=15008092;c[272329]=25755944;c[272330]=1638636;c[272331]=6881585;c[272332]=6226175;c[272333]=12321022;c[272334]=11469046;c[272335]=16056587;c[272336]=16318644;c[272337]=0;c[272338]=7864471;c[272339]=13566151;c[272340]=15138972;c[272341]=0;c[272342]=7012529;c[272343]=15073469;c[272344]=11272333;c[272345]=16449747;c[272346]=2359322;c[272347]=9502884;c[272348]=9109606;c[272349]=8716246;c[272350]=131219;c[272351]=458938;c[272352]=5177393;c[272353]=3276848;Wu(1089416,0,272)|0;c[272422]=458741;c[272423]=-262138;c[272424]=524295;c[272425]=-131069;c[272426]=-262162;c[272427]=-327682;c[272428]=327699;c[272429]=262168;c[272430]=196591;c[272431]=196599;c[272432]=-524268;c[272433]=-196573;c[272434]=524282;c[272435]=589829;c[272436]=458755;c[272437]=-393195;c[272438]=524282;c[272439]=-327688;c[272440]=131066;c[272441]=262142;c[272442]=196604;c[272443]=-589804;c[272444]=65528;c[272445]=1179644;c[272446]=0;c[272447]=0;c[272448]=0;c[272449]=0;c[272450]=-6357135;c[272451]=-5374048;c[272452]=-3014736;c[272453]=-917577;c[272454]=-4522067;c[272455]=-3604523;c[272456]=-1114133;c[272457]=589814;c[272458]=-3276871;c[272459]=-2555926;c[272460]=-524288;c[272461]=1835017;c[272462]=-2687001;c[272463]=-1638382;c[272464]=458795;c[272465]=2490415;c[272466]=-3014682;c[272467]=-1638384;c[272468]=131110;c[272469]=2687026;c[272470]=-3604491;c[272471]=-2490331;c[272472]=-524232;c[272473]=1769543;c[272474]=-4194366;c[272475]=-3276817;c[272476]=-1572859;c[272477]=851982;c[272478]=-7209155;c[272479]=-5898306;c[272480]=-3276842;c[272481]=-851997;c[272482]=-4456502;c[272483]=-2621463;c[272484]=-3014691;c[272485]=-1835052;c[272486]=-2818078;c[272487]=-1114102;c[272488]=-1507326;c[272489]=-327689;c[272490]=-2097171;c[272491]=-589807;c[272492]=-851957;c[272493]=524289;c[272494]=-2359317;c[272495]=-851950;c[272496]=-983029;c[272497]=458752;c[272498]=-2359317;c[272499]=-917490;c[272500]=-1114106;c[272501]=196607;c[272502]=-2293787;c[272503]=-851962;c[272504]=-655358;c[272505]=65528;c[272506]=-2883617;c[272507]=-1376249;c[272508]=-1441796;c[272509]=-262156;c[272510]=-4259885;c[272511]=-2752533;c[272512]=-3014685;c[272513]=-1769511;c[272514]=-25;c[272515]=-16;c[272516]=-16;c[272517]=-9;c[272518]=-21;c[272519]=-8;c[272520]=-3;c[272521]=0;c[272522]=-21;c[272523]=-9;c[272524]=-4;c[272525]=2;c[272526]=-22;c[272527]=-6;c[272528]=-1;c[272529]=2;c[272530]=-22;c[272531]=-7;c[272532]=0;c[272533]=1;c[272534]=-21;c[272535]=-7;c[272536]=0;c[272537]=2;c[272538]=-12;c[272539]=4;c[272540]=8;c[272541]=12;c[272542]=-23;c[272543]=-15;c[272544]=-11;c[272545]=-5;c[272546]=-4587520;c[272547]=-3735555;c[272548]=-2686980;c[272549]=-1900545;c[272550]=-3801092;c[272551]=-1966074;c[272552]=-1376247;c[272553]=-262136;c[272554]=-2555906;c[272555]=-1114106;c[272556]=-458743;c[272557]=327689;c[272558]=-1900545;c[272559]=-327672;c[272560]=589834;c[272561]=1114119;c[272562]=-1769475;c[272563]=-327671;c[272564]=655368;c[272565]=1507335;c[272566]=-2621442;c[272567]=-1048570;c[272568]=-720888;c[272569]=196618;c[272570]=-3538946;c[272571]=-1966073;c[272572]=-1376249;c[272573]=-458746;c[272574]=-4915201;c[272575]=-3538948;c[272576]=-2883585;c[272577]=-1966080;c[272578]=260;c[272579]=3146041;c[272580]=4915463;c[272581]=5505212;c[272582]=2752770;c[272583]=5964074;c[272584]=9306344;c[272585]=8585390;c[272586]=5308611;c[272587]=8913136;c[272588]=10944683;c[272589]=10682473;c[272590]=6750381;c[272591]=10879157;c[272592]=10879120;c[272593]=11534442;c[272594]=6815890;c[272595]=10420398;c[272596]=12845168;c[272597]=13041727;c[272598]=5898356;c[272599]=9830557;c[272600]=11206738;c[272601]=11075623;c[272602]=2883669;c[272603]=6094975;c[272604]=7471166;c[272605]=8716305;c[272606]=131135;c[272607]=3145817;c[272608]=4784175;c[272609]=5439488;Wu(1090440,0,384)|0;c[272706]=-7864557;c[272707]=-10092600;c[272708]=-10616970;c[272709]=-5963876;c[272710]=-4784232;c[272711]=-4522011;c[272712]=-1769453;c[272713]=-3538974;c[272714]=-2949069;c[272715]=-65507;c[272716]=-1638342;c[272717]=2293865;c[272718]=1769492;c[272719]=-1769418;c[272720]=3866701;c[272721]=8650877;c[272722]=1900576;c[272723]=-130997;c[272724]=8061023;c[272725]=8650882;c[272726]=1376272;c[272727]=5636127;c[272728]=4849772;c[272729]=9306247;c[272730]=-17;c[272731]=3342376;c[272732]=7602217;c[272733]=4849672;c[272734]=-2752534;c[272735]=-1441803;c[272736]=3080158;c[272737]=6357004;c[272738]=-4259885;c[272739]=-2752533;c[272740]=-3014685;c[272741]=-1769511;c[272742]=-2228247;c[272743]=-720879;c[272744]=-786426;c[272745]=393214;c[272746]=-983047;c[272747]=458778;c[272748]=655382;c[272749]=1376268;c[272750]=-393207;c[272751]=1048620;c[272752]=852004;c[272753]=2162717;c[272754]=262163;c[272755]=1769530;c[272756]=1638451;c[272757]=3080232;c[272758]=1179679;c[272759]=2687043;c[272760]=2424893;c[272761]=3801139;c[272762]=1114142;c[272763]=2818118;c[272764]=2424894;c[272765]=3604531;c[272766]=131088;c[272767]=1966127;c[272768]=1572899;c[272769]=2752538;c[272770]=-23;c[272771]=-15;c[272772]=-11;c[272773]=-5;c[272774]=655358;c[272775]=655374;c[272776]=655378;c[272777]=655382;c[272778]=1310719;c[272779]=1310733;c[272780]=1310740;c[272781]=1310742;c[272782]=1966088;c[272783]=1966103;c[272784]=1966110;c[272785]=1966111;c[272786]=2621458;c[272787]=2621474;c[272788]=2621479;c[272789]=2621482;c[272790]=3276829;c[272791]=3276841;c[272792]=3276846;c[272793]=3276852;c[272794]=3932199;c[272795]=3932212;c[272796]=3932217;c[272797]=3932220;c[272798]=4587565;c[272799]=4587574;c[272800]=4587574;c[272801]=4587581;c[272802]=-4915201;c[272803]=-3538948;c[272804]=-2883585;c[272805]=-1966080;c[272806]=-2883576;c[272807]=-1310703;c[272808]=-720879;c[272809]=196624;c[272810]=-1310702;c[272811]=262170;c[272812]=589852;c[272813]=1507358;c[272814]=196635;c[272815]=1638439;c[272816]=2621478;c[272817]=3473445;c[272818]=720935;c[272819]=2293808;c[272820]=3211314;c[272821]=3735599;c[272822]=720944;c[272823]=2162744;c[272824]=2818107;c[272825]=3604539;c[272826]=131128;c[272827]=1966146;c[272828]=2555973;c[272829]=3670084;c[272830]=70;c[272831]=852035;c[272832]=1900610;c[272833]=2687045;c[272834]=131135;c[272835]=3145817;c[272836]=4784175;c[272837]=5439488;c[272838]=3539039;c[272839]=6750345;c[272840]=8126536;c[272841]=9371675;c[272842]=7209096;c[272843]=11141297;c[272844]=12517478;c[272845]=12386363;c[272846]=8782e3;c[272847]=12386508;c[272848]=14811278;c[272849]=15007837;c[272850]=9371861;c[272851]=13500637;c[272852]=13500600;c[272853]=14155922;c[272854]=8585461;c[272855]=12189986;c[272856]=14221533;c[272857]=13959323;c[272858]=6684990;c[272859]=9896294;c[272860]=13238564;c[272861]=12517610;c[272862]=4587850;c[272863]=7733631;c[272864]=9503053;c[272865]=10092802;Wu(1091464,0,272)|0;c[272934]=458741;c[272935]=-262138;c[272936]=524295;c[272937]=-131069;c[272938]=-262162;c[272939]=-327682;c[272940]=327699;c[272941]=262168;c[272942]=196591;c[272943]=196599;c[272944]=-524268;c[272945]=-196573;c[272946]=524282;c[272947]=589829;c[272948]=458755;c[272949]=-393195;c[272950]=524282;c[272951]=-327688;c[272952]=131066;c[272953]=262142;c[272954]=196604;c[272955]=-589804;c[272956]=65528;c[272957]=1179644;c[272958]=0;c[272959]=0;c[272960]=0;c[272961]=0;c[272962]=-6357135;c[272963]=-5374048;c[272964]=-3014736;c[272965]=-917577;c[272966]=-4522067;c[272967]=-3604523;c[272968]=-1114133;c[272969]=589814;c[272970]=-3276871;c[272971]=-2555926;c[272972]=-524288;c[272973]=1835017;c[272974]=-2687001;c[272975]=-1638382;c[272976]=458795;c[272977]=2490415;c[272978]=-3014682;c[272979]=-1638384;c[272980]=131110;c[272981]=2687026;c[272982]=-3604491;c[272983]=-2490331;c[272984]=-524232;c[272985]=1769543;c[272986]=-4194366;c[272987]=-3276817;c[272988]=-1572859;c[272989]=851982;c[272990]=-7209155;c[272991]=-5898306;c[272992]=-3276842;c[272993]=-851997;c[272994]=-4456502;c[272995]=-2621463;c[272996]=-3014691;c[272997]=-1835052;c[272998]=-2818078;c[272999]=-1114102;c[273e3]=-1507326;c[273001]=-327689;c[273002]=-2097171;c[273003]=-589807;c[273004]=-851957;c[273005]=524289;c[273006]=-2359317;c[273007]=-851950;c[273008]=-983029;c[273009]=458752;c[273010]=-2359317;c[273011]=-917490;c[273012]=-1114106;c[273013]=196607;c[273014]=-2293787;c[273015]=-851962;c[273016]=-655358;c[273017]=65528;c[273018]=-2883617;c[273019]=-1376249;c[273020]=-1441796;c[273021]=-262156;c[273022]=-4259885;c[273023]=-2752533;c[273024]=-3014685;c[273025]=-1769511;c[273026]=-25;c[273027]=-16;c[273028]=-16;c[273029]=-9;c[273030]=-21;c[273031]=-8;c[273032]=-3;c[273033]=0;c[273034]=-21;c[273035]=-9;c[273036]=-4;c[273037]=2;c[273038]=-22;c[273039]=-6;c[273040]=-1;c[273041]=2;c[273042]=-22;c[273043]=-7;c[273044]=0;c[273045]=1;c[273046]=-21;c[273047]=-7;c[273048]=0;c[273049]=2;c[273050]=-12;c[273051]=4;c[273052]=8;c[273053]=12;c[273054]=-23;c[273055]=-15;c[273056]=-11;c[273057]=-5;c[273058]=-4587520;c[273059]=-3735555;c[273060]=-2686980;c[273061]=-1900545;c[273062]=-3801092;c[273063]=-1966074;c[273064]=-1376247;c[273065]=-262136;c[273066]=-2555906;c[273067]=-1114106;c[273068]=-458743;c[273069]=327689;c[273070]=-1900545;c[273071]=-327672;c[273072]=589834;c[273073]=1114119;c[273074]=-1769475;c[273075]=-327671;c[273076]=655368;c[273077]=1507335;c[273078]=-2621442;c[273079]=-1048570;c[273080]=-720888;c[273081]=196618;c[273082]=-3538946;c[273083]=-1966073;c[273084]=-1376249;c[273085]=-458746;c[273086]=-4915201;c[273087]=-3538948;c[273088]=-2883585;c[273089]=-1966080;c[273090]=260;c[273091]=3146041;c[273092]=4915463;c[273093]=5505212;c[273094]=2752770;c[273095]=5964074;c[273096]=9306344;c[273097]=8585390;c[273098]=5308611;c[273099]=8913136;c[273100]=10944683;c[273101]=10682473;c[273102]=6750381;c[273103]=10879157;c[273104]=10879120;c[273105]=11534442;c[273106]=6815890;c[273107]=10420398;c[273108]=12845168;c[273109]=13041727;c[273110]=5898356;c[273111]=9830557;c[273112]=11206738;c[273113]=11075623;c[273114]=2883669;c[273115]=6094975;c[273116]=7471166;c[273117]=8716305;c[273118]=131135;c[273119]=3145817;c[273120]=4784175;c[273121]=5439488;a=1092488;d=a+128|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[273154]=0;c[273155]=786484;c[273156]=2097208;c[273157]=262148;c[273158]=196621;c[273159]=655385;p=1092640;c[p>>2]=0;c[p+4>>2]=0;l=b;return}function eg(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0;f=0;do{if((f|0)==7){a=1;do{d=12004+(a<<2)|0;e=a^8;c[12004+(e<<2)>>2]=c[d>>2];b=12068+(a<<2)|0;c[12068+(e<<2)>>2]=c[b>>2];d=(c[b>>2]<<16)+(c[d>>2]|0)|0;b=0;do{g=b&7;h=g^7;g=(c[1090568+(a<<7)+(b>>3<<4)+((h>>>0<g>>>0?h:g)<<2)>>2]|0)+d|0;c[1075068+(a*260|0)+(b<<2)>>2]=g;c[1075068+(e*260|0)+((b^7)<<2)>>2]=0-g;b=b+1|0}while((b|0)!=64);h=(c[1092616+(a<<2)>>2]|0)+d|0;c[1075068+(a*260|0)+256>>2]=h;c[1075068+(e*260|0)+256>>2]=0-h;a=a+1|0}while((a|0)!=7)}else{a=1;do{e=11108+(f<<7)+(a<<2)|0;d=a^8;c[11108+(f<<7)+(d<<2)>>2]=c[e>>2];b=11108+(f<<7)+64+(a<<2)|0;c[11108+(f<<7)+64+(d<<2)>>2]=c[b>>2];e=(c[b>>2]<<16)+(c[e>>2]|0)|0;b=0;do{h=b&7;g=h^7;h=(c[1083400+(f<<10)+(a<<7)+(b>>3<<4)+((g>>>0<h>>>0?g:h)<<2)>>2]|0)+e|0;c[1045948+(f*4160|0)+(a*260|0)+(b<<2)>>2]=h;c[1045948+(f*4160|0)+(d*260|0)+((b^56)<<2)>>2]=0-h;b=b+1|0}while((b|0)!=64);h=(c[1092616+(a<<2)>>2]|0)+e|0;c[1045948+(f*4160|0)+(a*260|0)+256>>2]=h;c[1045948+(f*4160|0)+(d*260|0)+256>>2]=0-h;a=a+1|0}while((a|0)!=7)}f=f+1|0}while((f|0)!=9);return}function fg(a){a=a|0;Mg(a);Dt(a);return}function gg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;o=l;l=l+64|0;m=o;n=o+40|0;e=o+32|0;d=o+20|0;j=b+160|0;k=b+5508|0;f=c[k>>2]|0;c[273162]=f;bh(988400,988280,f,c[b+5504>>2]|0);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21948,8);c[m>>2]=d;ae(e,1163992,d,1233087,m,n);e=((xh((c[e>>2]|0)+28|0)|0)*248|0)/100|0;Mt(d);d=c[273162]|0;c[1098080+(d<<2)>>2]=0-e;c[1098080+((d^1)<<2)>>2]=e;d=b+5536|0;e=c[d>>2]|0;f=b+5540|0;if((e|0)!=(c[f>>2]|0)){d=c[290941]|0;f=c[290942]|0;if((d|0)!=(f|0))do{e=c[d>>2]|0;if((e|0)!=(b|0))Tg(e,0);d=d+4|0}while((d|0)!=(f|0));ig(b);l=o;return}c[m>>2]=-32001;c[m+4>>2]=-32001;g=m+8|0;i=m+12|0;q=At(4)|0;c[g>>2]=q;p=q+4|0;h=m+16|0;c[h>>2]=p;c[q>>2]=0;c[i>>2]=p;if(e>>>0>=(c[b+5544>>2]|0)>>>0){hg(d,m);d=c[m+8>>2]|0;e=d;if(d|0){f=c[i>>2]|0;if((f|0)!=(d|0))c[i>>2]=f+(~((f+-4-e|0)>>>2)<<2);Dt(d)}}else{d=m;q=c[d+4>>2]|0;p=e;c[p>>2]=c[d>>2];c[p+4>>2]=q;p=e+8|0;c[p>>2]=0;q=e+12|0;c[q>>2]=0;c[e+16>>2]=0;c[p>>2]=c[g>>2];c[q>>2]=c[i>>2];c[e+16>>2]=c[h>>2];c[h>>2]=0;c[i>>2]=0;c[g>>2]=0;c[f>>2]=(c[f>>2]|0)+20}do if(!(zd(j)|0)){q=(c[b+5516>>2]|0)+64|0;d=c[b+5524>>2]|0;if(!((c[q>>2]|0)==0&(c[q+4>>2]|0)==0)){d=(d|0)==6?32e3:-32e3;break}if((d|0)!=1){d=(d|0)==6?32e3:0;break}if((c[b+5528>>2]|0)==9){d=c[k>>2]<<3;d=(c[b+496+(d<<2)>>2]|0)-(c[b+496+((d^8)<<2)>>2]|0)|0;if((d|0)>0)d=-32e3;else d=d|0?32e3:0}else d=32e3}else d=Ad(j,0,0)|0;while(0);b=Kd(te(1164756,0)|0,20954,19)|0;sh(n,d);q=a[n+11>>0]|0;p=q<<24>>24<0;q=Kd(b,p?c[n>>2]|0:n,p?c[n+4>>2]|0:q&255)|0;c[m>>2]=Sk(q+(c[(c[q>>2]|0)+-12>>2]|0)|0)|0;p=lm(m,1165628)|0;p=nb[c[(c[p>>2]|0)+28>>2]&63](p,10)|0;pt(m);il(q,p)|0;Xk(q)|0;te(q,1)|0;Mt(n);l=o;return}function hg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;k=a+4|0;e=c[k>>2]|0;f=c[a>>2]|0;d=((e-f|0)/20|0)+1|0;if(d>>>0>214748364)vs(a);l=a+8|0;j=((c[l>>2]|0)-f|0)/20|0;h=j<<1;h=j>>>0<107374182?(h>>>0<d>>>0?d:h):214748364;d=(e-f|0)/20|0;if(!h)g=0;else g=At(h*20|0)|0;e=g+(d*20|0)|0;f=e;j=g+(h*20|0)|0;m=b;i=c[m+4>>2]|0;h=e;c[h>>2]=c[m>>2];c[h+4>>2]=i;h=b+8|0;c[g+(d*20|0)+16>>2]=0;c[g+(d*20|0)+8>>2]=c[h>>2];i=b+12|0;c[g+(d*20|0)+12>>2]=c[i>>2];b=b+16|0;c[g+(d*20|0)+16>>2]=c[b>>2];c[b>>2]=0;c[i>>2]=0;c[h>>2]=0;h=e+20|0;g=c[a>>2]|0;d=c[k>>2]|0;if((d|0)==(g|0)){e=f;i=g;d=g}else{do{b=d;d=d+-20|0;n=d;m=c[n+4>>2]|0;i=e+-20|0;c[i>>2]=c[n>>2];c[i+4>>2]=m;i=e+-12|0;m=b+-12|0;c[i>>2]=0;n=e+-8|0;c[n>>2]=0;c[e+-4>>2]=0;c[i>>2]=c[m>>2];i=b+-8|0;c[n>>2]=c[i>>2];b=b+-4|0;c[e+-4>>2]=c[b>>2];c[b>>2]=0;c[i>>2]=0;c[m>>2]=0;e=f+-20|0;f=e}while((d|0)!=(g|0));e=f;i=c[a>>2]|0;d=c[k>>2]|0}c[a>>2]=e;c[k>>2]=h;c[l>>2]=j;b=i;if((d|0)!=(b|0))do{e=c[d+-12>>2]|0;f=e;if(e|0){g=d+-8|0;h=c[g>>2]|0;if((h|0)!=(e|0))c[g>>2]=h+(~((h+-4-f|0)>>>2)<<2);Dt(e)}d=d+-20|0}while((d|0)!=(b|0));if(!i)return;Dt(i);return}function ig(b){b=b|0;var e=0,f=0,g=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+32|0;e=m+24|0;g=m+28|0;i=m+16|0;j=m;c[274517]=0;k=c[290941]|0;if((c[290942]|0)==(k|0))ws(1163764);do if((c[k>>2]|0)==(b|0))if((c[290942]|0)==(k|0))ws(1163764);else{f=c[k>>2]|0;break}else f=0;while(0);c[274518]=f;Wu(1092812+-160|0,0,280)|0;c[274514]=-32001;c[274516]=-32001;c[274513]=-32001;c[274515]=32001;c[b+5552>>2]=0;if(f|0){k=(c[b+5516>>2]|0)+56|0;n=988360;c[274517]=((c[n>>2]|0)==(c[k>>2]|0)?(c[n+4>>2]|0)==(c[k+4>>2]|0):0)?c[247094]|0:0;c[247088]=0;c[247090]=0;c[247091]=0;c[247092]=0;c[247093]=0;c[247094]=0;a[f+4237241>>0]=0;a[f+4237240>>0]=0;h[f+4237248>>3]=0.0;a[1163816]=(d[1163816]|0)+4};c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,22001,7);c[e>>2]=j;ae(i,1163992,j,1233087,e,g);c[274519]=xh((c[i>>2]|0)+28|0)|0;Mt(j);k=((c[b+5540>>2]|0)-(c[b+5536>>2]|0)|0)/20|0;n=c[274519]|0;c[274519]=k>>>0<n>>>0?k:n;Ya(156,b|0,30);l=m;return}function jg(a){a=a|0;kg(a);return}
function kg(b){b=b|0;var e=0,f=0,g=0,i=0,j=0,k=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;A=l;l=l+912|0;z=A+8|0;t=A+896|0;u=A+892|0;v=A+888|0;w=A;x=b+5548|0;y=(c[x>>2]|0)+1|0;c[x>>2]=y;a:do if((y|0)<128?(a[1233085]&1)==0:0){f=c[247079]|0;do if(f|0){e=c[290941]|0;if((c[290942]|0)!=(e|0))if((c[(c[e>>2]|0)+5548>>2]|0)>(f|0))break a;else break;else ws(1163764)}while(0);e=c[b+136>>2]|0;if(e|0){i=c[x>>2]|0;j=c[b+5504>>2]|0;f=(e+-1|0)%20|0;e=1;while(1){g=e+1|0;if((S(g,e)|0)>(f|0))break;else e=g}if(!(((i+f+j|0)/(e|0)|0)-e&1))Ya(156,b|0,30)}e=c[274518]|0;if(e|0){y=e+4237248|0;h[y>>3]=+h[y>>3]*.505;a[e+4237241>>0]=0}y=b+5536|0;e=c[y>>2]|0;s=b+5540|0;f=c[s>>2]|0;if((e|0)!=(f|0))do{c[e+4>>2]=c[e>>2];e=e+20|0}while((e|0)!=(f|0));k=b+140|0;c[k>>2]=0;b:do if(c[274519]|0){n=b+160|0;o=t+11|0;p=t+4|0;q=t+11|0;r=t+4|0;do{if(a[1233085]&1)break b;e=c[x>>2]|0;if((e|0)>=5){c[274516]=18;j=c[(c[y>>2]|0)+((c[k>>2]|0)*20|0)+4>>2]|0;i=j+-18|0;c[274514]=(i|0)<-32001?-32001:i;j=j+18|0;c[274515]=(j|0)>32001?32001:j}while(1){c[274513]=lg(n,1092812,c[274514]|0,c[274515]|0,e,0)|0;g=c[s>>2]|0;i=(c[y>>2]|0)+((c[k>>2]|0)*20|0)|0;f=g-i|0;j=(f|0)/20|0;if((f|0)>0){e=j;while(1){f=Bt(e*20|0,1235165)|0;if(f|0)break;e=e>>>1;if(!e){f=0;e=0;break}}}else{f=0;e=0}c[u>>2]=i;c[v>>2]=g;c[t>>2]=c[u>>2];c[z>>2]=c[v>>2];mg(t,z,w,j,f,e);if(f|0)Dt(f);if(a[1233085]&1)break;do if((c[274518]|0)!=0&(c[274519]|0)==1?(j=c[274513]|0,!((j|0)>(c[274514]|0)&(j|0)<(c[274515]|0))):0){if(!(c[247077]|0)){j=Lj()|0;j=$u(j|0,D|0,1e3,0)|0;e=988408;e=Vu(j|0,D|0,c[e>>2]|0,c[e+4>>2]|0)|0}else e=Xg(1163764)|0;if((e|0)<=3e3)break;g=te(1164756,0)|0;ng(t,n,c[x>>2]|0,c[274514]|0,c[274515]|0);j=a[o>>0]|0;i=j<<24>>24<0;j=Kd(g,i?c[t>>2]|0:t,i?c[p>>2]|0:j&255)|0;c[z>>2]=Sk(j+(c[(c[j>>2]|0)+-12>>2]|0)|0)|0;i=lm(z,1165628)|0;i=nb[c[(c[i>>2]|0)+28>>2]&63](i,10)|0;pt(z);il(j,i)|0;Xk(j)|0;te(j,1)|0;Mt(t)}while(0);g=c[274513]|0;e=c[274514]|0;f=c[274515]|0;if((g|0)<=(e|0)){c[274515]=(f+e|0)/2|0;e=c[274516]|0;f=g-e|0;c[274514]=(f|0)<-32001?-32001:f;f=c[274518]|0;if(f){a[f+4237241>>0]=1;a[1233086]=0;e=c[274516]|0}}else{if((g|0)<(f|0))break;c[274514]=(f+e|0)/2|0;e=c[274516]|0;j=e+g|0;c[274515]=(j|0)>32001?32001:j}c[274516]=e+5+((e|0)/4|0);e=c[x>>2]|0}i=c[y>>2]|0;g=i+((c[k>>2]|0)*20|0)+20|0;f=g-i|0;j=(f|0)/20|0;if((f|0)>0){e=j;while(1){f=Bt(e*20|0,1235165)|0;if(f|0)break;e=e>>>1;if(!e){f=0;e=0;break}}}else{f=0;e=0}c[u>>2]=i;c[v>>2]=g;c[t>>2]=c[u>>2];c[z>>2]=c[v>>2];mg(t,z,w,j,f,e);if(f|0)Dt(f);do if(c[274518]|0){if((a[1233085]&1)==0?((c[k>>2]|0)+1|0)!=(c[274519]|0):0){if(!(c[247077]|0)){j=Lj()|0;j=$u(j|0,D|0,1e3,0)|0;e=988408;e=Vu(j|0,D|0,c[e>>2]|0,c[e+4>>2]|0)|0}else e=Xg(1163764)|0;if((e|0)<=3e3)break}g=te(1164756,0)|0;ng(t,n,c[x>>2]|0,c[274514]|0,c[274515]|0);j=a[q>>0]|0;i=j<<24>>24<0;j=Kd(g,i?c[t>>2]|0:t,i?c[r>>2]|0:j&255)|0;c[z>>2]=Sk(j+(c[(c[j>>2]|0)+-12>>2]|0)|0)|0;i=lm(z,1165628)|0;i=nb[c[(c[i>>2]|0)+28>>2]&63](i,10)|0;pt(z);il(j,i)|0;Xk(j)|0;te(j,1)|0;Mt(t)}while(0);j=(c[k>>2]|0)+1|0;c[k>>2]=j}while(j>>>0<(c[274519]|0)>>>0)}while(0);if(!(a[1233085]&1))c[b+5552>>2]=c[x>>2];if(!(c[274518]|0)){Ya(156,b|0,30);l=A;return}e=c[247081]|0;x=c[274513]|0;if((e|0)!=0&(x|0)>31743?(32e3-x|0)<=(e<<1|0):0){a[1233085]=1;e=c[247081]|0}v=c[247080]|e|c[247079];w=988336;x=c[247082]|0;do if((v|c[w>>2]|x|0)==0?(((v|0)<0)<<31>>31|c[w+4>>2]|((x|0)<0)<<31>>31|0)==0:0){c:do if((a[1233085]&1)==0?(a[1233086]&1)==0:0){e=c[274518]|0;g=(0-(d[e+4237241>>0]|0)&119)+357+(S((c[274513]|0)-(c[e+4237256>>2]|0)|0,-6)|0)|0;g=(g|0)<715?g:715;g=(g|0)>229?g:229;B=+h[e+4237248>>3];m=B+1.0;e=c[y>>2]|0;if(B<.03?(c[c[e+8>>2]>>2]|0)==(c[274517]|0):0){if(!(c[247077]|0)){x=Lj()|0;x=$u(x|0,D|0,1e3,0)|0;f=988408;f=Vu(x|0,D|0,c[f>>2]|0,c[f+4>>2]|0)|0}else f=Xg(1163764)|0;e=c[y>>2]|0;f=(f|0)>(((c[247104]|0)*5|0)/44|0|0)}else f=0;do if(((c[s>>2]|0)-e|0)!=20){if(!(c[247077]|0)){x=Lj()|0;x=$u(x|0,D|0,1e3,0)|0;e=988408;e=Vu(x|0,D|0,c[e>>2]|0,c[e+4>>2]|0)|0}else e=Xg(1163764)|0;if(+(e|0)>+(g|0)*(m*+(c[247104]|0))/628.0)break;a[(c[274518]|0)+4237240>>0]=f&1;if(!f)break c}while(0);if(!(c[247083]|0)){a[1233085]=1;break}else{a[1233086]=1;break}}while(0);x=c[y>>2]|0;f=x+8|0;y=c[f>>2]|0;g=y;if((c[x+12>>2]|0)-y>>2>>>0<=2){c[247088]=0;c[247090]=0;c[247091]=0;c[247092]=0;c[247093]=0;c[247094]=0;break}i=b+160|0;j=g+8|0;y=(c[j>>2]|0)==(c[247094]|0);c[247088]=y?(c[247088]|0)+1|0:0;k=c[g>>2]|0;e=g+4|0;if((k|0)==(c[247092]|0)?!((c[e>>2]|0)!=(c[247093]|0)|y^1):0)break;c[247092]=k;c[247093]=c[e>>2];c[247094]=c[j>>2];x=c[g>>2]|0;Tf(i,x,z,Rf(i,x)|0);x=c[(c[f>>2]|0)+4>>2]|0;Tf(i,x,z+440|0,Rf(i,x)|0);x=(c[b+5516>>2]|0)+56|0;y=c[x+4>>2]|0;z=988360;c[z>>2]=c[x>>2];c[z+4>>2]=y;Vf(i,c[(c[f>>2]|0)+4>>2]|0);Vf(i,c[c[f>>2]>>2]|0)}while(0);Ya(156,b|0,30);l=A;return}while(0);e=c[274518]|0;if(!e){l=A;return}if(!((c[247088]|0)>=6?!(a[e+4237240>>0]|0):0)){c[247088]=0;c[247090]=0;c[247091]=0;c[247092]=0;c[247093]=0;c[247094]=0}Ya(157,e|0,30);l=A;return}function lg(f,g,i,j,k,m){f=f|0;g=g|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0;_a=l;l=l+9456|0;Ia=_a+8936|0;La=_a+8680|0;Ja=_a;z=_a+9452|0;Ba=_a+4540|0;Ca=_a+440|0;n=c[g+-32>>2]|0;Da=(n|0)==0;Ea=c[f+5352>>2]|0;Na=f+5356|0;Ka=(c[Na>>2]|0)+64|0;Ka=(c[Ka>>2]|0)!=0|(c[Ka+4>>2]|0)!=0;Fa=g+36|0;c[Fa>>2]=0;Ga=g+32|0;c[Ga>>2]=0;Za=g+8|0;c[Za>>2]=n+1;n=Ea+5556|0;do if(a[n>>0]&1){a[n>>0]=0;o=988336;n=c[o>>2]|0;o=c[o+4>>2]|0;if((n|0)==0&(o|0)==0){c[Ea+148>>2]=4095;break}else{r=$u(n|0,o|0,1024,0)|0;p=D;Ya=(p|0)<0|(p|0)==0&r>>>0<4096;r=Ya?r:4096;p=Ea+148|0;c[p>>2]=r;Ya=6;break}}else{r=Ea+148|0;p=r;r=c[r>>2]|0;Ya=6}while(0);if((Ya|0)==6?(c[p>>2]=r+-1,(r|0)<2):0){n=c[290941]|0;o=c[290942]|0;if((n|0)!=(o|0))do{a[(c[n>>2]|0)+5556>>0]=1;n=n+4|0}while((n|0)!=(o|0));Bg()}n=Ea+144|0;o=c[Za>>2]|0;if((c[n>>2]|0)<(o|0))c[n>>2]=o;do if(!Da){if(zd(f)|0){k=Ad(f,c[Za>>2]|0,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;l=_a;return k|0}if(((a[1233085]&1)==0?!(cg(f,c[Za>>2]|0)|0):0)?(s=c[Za>>2]|0,(s|0)<=127):0){n=s+-32e3|0;i=(n|0)<(i|0)?i:n;n=31999-s|0;n=(n|0)>(j|0)?j:n;if((i|0)<(n|0)){j=n;break}l=_a;return i|0}if(Ka|(c[Za>>2]|0)<128){k=c[1098080+(c[f+5348>>2]<<2)>>2]|0;l=_a;return k|0}else{k=Id(f)|0;l=_a;return k|0}}while(0);ua=g+40|0;c[g+56>>2]=0;va=g+12|0;c[va>>2]=0;wa=g+4|0;c[wa>>2]=0;c[g+104>>2]=0;c[g+100>>2]=0;xa=g+-28|0;Oa=c[xa>>2]&63;ta=g+16|0;ya=c[ta>>2]|0;Wa=(c[Na>>2]|0)+56|0;Va=c[Wa>>2]^ya;Wa=c[Wa+4>>2]^((ya|0)<0)<<31>>31;w=gh(1163804,Va,Wa,z)|0;n=(a[z>>0]|0)==0;do if(!n?(t=b[w+4>>1]|0,u=t<<16>>16,v=c[Za>>2]|0,t<<16>>16!=32002):0)if(t<<16>>16>31743){y=u-v|0;break}else{y=(t<<16>>16<-31743?v:0)+u|0;break}else y=32002;while(0);if(!Da)if(n)v=0;else v=e[w+2>>1]|0;else v=c[c[(c[Ea+5536>>2]|0)+((c[Ea+140>>2]|0)*20|0)+8>>2]>>2]|0;a:do if(!Ka){do if(!n){sa=b[w+6>>1]|0;n=sa<<16>>16;o=g+28|0;c[o>>2]=n;if(sa<<16>>16==32002){n=Id(f)|0;c[o>>2]=n}if((y|0)!=32002)n=(d[w+8>>0]&((y|0)>(n|0)?2:1)|0)==0?n:y}else{if((c[xa>>2]|0)==65)n=(c[12280+(c[f+5364>>2]<<2)>>2]<<1)-(c[g+-12>>2]|0)|0;else n=Id(f)|0;c[g+28>>2]=n;p=a[1163816]|0;r=av(Va|0,Wa|0,48)|0;if((D|0)==0?(r|0)==(e[w>>1]|0):0){o=w+9|0;if(((a[o>>0]|0)+-4|0)>=-6)break}else{b[w+2>>1]=0;o=w+9|0}b[w>>1]=r;b[w+4>>1]=32002;b[w+6>>1]=n;a[w+8>>0]=p;a[o>>0]=-6}while(0);u=f+5364|0;o=c[u>>2]|0;if((o|0)==1){o=c[(c[Na>>2]|0)+48>>2]|0;if((o|0)!=64){s=f+256|0;ra=s;ra=Pf(f,o,c[ra>>2]|0,c[ra+4>>2]|0)|0;o=f+5348|0;p=f+320+(c[o>>2]<<3)|0;r=c[p>>2]|0;p=c[p+4>>2]|0;sa=f+264|0;if(!((r&ra&c[sa>>2]|0)==0?(p&D&c[sa+4>>2]|0)==0:0))break}else{o=f+5348|0;p=f+320+(c[o>>2]<<3)|0;s=f+256|0;r=c[p>>2]|0;p=c[p+4>>2]|0}t=r;while(1){if((t|0)==0&(p|0)==0)break;sa=Qa(t|0,p|0,0)|0;r=Yu(t|0,p|0,-1,-1)|0;p=D&p;ra=s;ra=Cb(c[f+(sa<<2)>>2]|0,sa,c[ra>>2]|0,c[ra+4>>2]|0)|0;sa=f+320+((c[o>>2]^1)<<3)|0;if(!((c[sa>>2]&ra|0)==0?(c[sa+4>>2]&D|0)==0:0))break a;else t=r&t}o=c[u>>2]|0}if((o|0)==6){if(Te(f)|0|m)break}else if(m)break;if(((k|0)<7&(Da^1)?(x=c[u>>2]|0,(n|0)<1e4?(n-(S(c[12316+(x<<2)>>2]|0,k)|0)|0)>=(j|0):0):0)?((x|0)==4?1:(c[(c[Na>>2]|0)+16+(c[f+5348>>2]<<2)>>2]|0)!=0):0){k=n;l=_a;return k|0}if(!((k|0)<6|(v|0)!=0)){lg(f,g,i,j,((k*3|0)/4|0)+-2|0,1)|0;n=gh(1163804,Va,Wa,z)|0;if(!(a[z>>0]|0)){w=n;v=0}else{w=n;v=e[n+2>>1]|0}}}else c[g+28>>2]=32002;while(0);oa=c[g+-36>>2]|0;ra=g+-76|0;pa=c[ra>>2]|0;qa=c[g+-156>>2]|0;mf(Ba,f,v,k,g);sa=g+28|0;n=c[g+-52>>2]|0;n=(n|0)==32002?1:(c[sa>>2]|0)>=(n|0);if((!Da?!((ya|0)!=0|(y|0)!=32002&((k|0)>7&(v|0)!=0)^1):0)?(A=b[w+8>>1]|0,(A&2)!=0):0)na=(((A&65535)>>>8&65535)<<24>>24|0)>=(k+-3|0);else na=0;p=rf(Ba)|0;b:do if(p){ha=Ea+5536|0;ia=Ea+140|0;ja=Ea+5540|0;ka=f+5364|0;la=f+5348|0;ma=(k|0)<16;fa=n&1;ga=1098088+(fa<<6)+(k<<2)|0;N=y-(k<<1)|0;N=(N|0)<-32e3?-32e3:N;O=(k|0)/2|0;P=N+-1|0;Q=k+-1|0;R=(k|0)>2;M=(k|0)>63?63:k;T=(oa|0)==0;U=(pa|0)==0;V=(qa|0)==0;W=g+-8|0;X=0-j|0;Y=Ea+4237248|0;L=Da^1;Z=(k|0)>6;_=S(k,-248)|0;$=f+256|0;aa=(oa|0)!=0;ba=(pa|0)!=0;ea=aa&ba;ca=Ca+4096|0;da=Ca;I=0;o=-32001;t=-32001;G=0;K=0;c:while(1){d:do if((p|0)==(ya|0)){n=I;r=G;s=K}else{if(Da){n=(c[ha>>2]|0)+((c[ia>>2]|0)*20|0)|0;s=c[ja>>2]|0;if((n|0)==(s|0)){n=I;r=G;s=K;break}else r=0;do{r=((c[c[n+8>>2]>>2]|0)==(p|0)&1)+r|0;n=n+20|0}while((n|0)!=(s|0));if(!r){n=I;r=G;s=K;break}}J=G+1|0;c[Fa>>2]=J;c[ua>>2]=0;s=c[ka>>2]|0;u=p&49152;B=(u|0)==32768;e:do if((s|0)==7){if(B)r=(p&12288|0)==4096?64:p>>>6&63;else r=p>>>6&63;n=p&63;if((c[f+(r<<2)>>2]&7|0)==6?(n>>>3|0)>=(r>>3|0):0){H=1;break}H=(c[f+(n<<2)>>2]|0)!=0}else{f:do if(B){n=p&12288;if((n|0)==4096){H=0;break e}n=n&16383;if(n<<16>>16<8192)switch(n<<16>>16){case 4096:{H=1;break e}default:break f}else switch(n<<16>>16){case 8192:{H=1;break e}default:break f}}else if(!u){H=(c[f+((p&63)<<2)>>2]|0)!=0;break e}while(0);H=(u|0)!=49152}while(0);x=(p&61440|0)==36864;A=p>>>6;if(x)z=A&15;else z=c[f+((A&63)<<2)>>2]|0;y=(u|0)==0;if(y?(E=c[la>>2]|0,Ha=c[Na>>2]|0,F=Ha+344+((E^1)<<3)|0,E=f+320+(E<<3)|0,!((c[E>>2]&c[F>>2]|0?1:(c[E+4>>2]&c[F+4>>2]|0)!=0)|(s+-1|0)>>>0<2)):0){r=Ha+376+((c[f+((A&63)<<2)>>2]&7)<<3)|0;F=30544+((p&63)<<3)|0;n=c[F>>2]&c[r>>2];r=c[F+4>>2]&c[r+4>>2]}else{n=(Rf(f,p)|0)&1;r=0}F=(n|0)!=0|(r|0)!=0;if(ma)m=(J|0)>=(c[ga>>2]|0);else m=0;if(m|F^1)n=0;else n=($f(f,p,0)|0)&1;g:do if(!(m|(c[ka>>2]|0)!=1)){h:do if((u|0)==49152?1:(c[f+((p&63)<<2)>>2]|0)==0){if(!B)break g;r=p&12288;if(r<<16>>16<8192)switch(r<<16>>16){case 4096:break g;default:break h}else switch(r<<16>>16){case 8192:break g;default:break h}}while(0);E=kf(f,Ca)|0;c[ca>>2]=E;n=(E-da|0)==8?1:n}while(0);do if(na){if((p|0)!=(v|0)|(n|0)!=0)break;if(!(Qf(f,v)|0)){n=0;break}c[ta>>2]=v;n=Cg(f,g,P,N,O,0,1)|0;c[ta>>2]=0;t=n;n=(n|0)<(N|0)&1}while(0);C=Q+n|0;r=c[ka>>2]|0;if((z&7|0)==6&(r|0)==7){if(B)s=(p&12288|0)==4096?64:A&63;else s=A&63;if((p>>>3&7|0)<=(s>>3|0)&((o|0)>-31744&L))Ya=112}else if((o|0)>-31744&L)Ya=112;i:do if((Ya|0)==112){Ya=0;j:do if(!(H|F)){if((r|0)==1){u=$;u=Pf(f,p&63,c[u>>2]|0,c[u+4>>2]|0)|0;E=f+320+((c[la>>2]^1)<<3)|0;if(!((c[E>>2]&u|0)==0?(c[E+4>>2]&D|0)==0:0))break;s=c[ka>>2]|0}else s=r;do if((s|0)!=4){if(x)r=A&15;else r=c[f+((A&63)<<2)>>2]|0;r=r&7;do if((s|0)==7){if((r|0)!=6)break;if(B)r=(p&12288|0)==4096?64:A&63;else r=A&63;if((r>>3|0)>3)break j}else{if((r|0)!=1)break;if(B)r=(p&12288|0)==4096?64:A&63;else r=A&63;if((r>>3^(c[la>>2]|0)*7|0)>3)break j}while(0);if(x)r=A&15;else r=c[f+((A&63)<<2)>>2]|0;r=r&7;if((s|0)==7){if((r|0)!=6)break;if(B)r=(p&12288|0)==4096?64:A&63;else r=A&63;if((r>>3|0)<=3)break}else{if((r|0)!=1)break;if(B)r=(p&12288|0)==4096?64:A&63;else r=A&63;if((r>>3^(c[la>>2]|0)*7|0)<=3)break}E=c[Na>>2]|0;if(((c[E+20>>2]|0)+(c[E+16>>2]|0)|0)<=4999)break j}while(0);if(m){n=I;r=J;s=K;break d}n=C-(c[1098216+(fa<<14)+(M<<8)+(((J|0)>63?63:J)<<2)>>2]|0)|0;n=(n|0)<0?0:n;do if((n|0)<3){if(aa?(c[oa+(z<<8)+((p&63)<<2)>>2]|0)>=0:0)break;if(ba?(c[pa+(z<<8)+((p&63)<<2)>>2]|0)>=0:0)break;if(V){n=I;r=J;s=K;break d}if(ea|(c[qa+(z<<8)+((p&63)<<2)>>2]|0)<0){n=I;r=J;s=K;break d}}while(0);if(!(Ka|(n|0)>6)?((c[12352+(s<<3)>>2]|0)+(c[sa>>2]|0)+(S(c[12352+(s<<3)+4>>2]|0,n)|0)|0)<=(i|0):0){n=I;r=J;s=K;break d}if((s|0)==1)break i;if(!((n|0)<8&(s|0)!=7))break i;if($f(f,p,S(S(n,-35)|0,n)|0)|0)break i;else{n=I;r=J;s=K;break d}}while(0);if(Z|(n|0)!=0)break;if(!($f(f,p,_)|0)){n=I;r=J;s=K;break d}}while(0);do if(!Da){if(Qf(f,p)|0)break;c[Fa>>2]=G;n=I;r=G;s=K;break d}while(0);c[va>>2]=p;x=p&63;c[wa>>2]=Ea+42936+(z<<18)+(x<<12);Tf(f,p,Ja,F);E=(G|0)>0;do if(R&E&(m|H^1)){n=c[1098216+(fa<<14)+(M<<8)+(((J|0)>63?63:J)<<2)>>2]|0;if(H)n=n-((n|0)!=0&1)|0;else{if(y){y=$f(f,x<<6|A&63,0)|0;n=y?n:n+-2|0}if(T)t=0;else t=c[oa+(z<<8)+(x<<2)>>2]|0;if(U)u=0;else u=c[pa+(z<<8)+(x<<2)>>2]|0;if(V)s=0;else s=c[qa+(z<<8)+(x<<2)>>2]|0;if(B)r=(p&12288|0)==4096?64:A&63;else r=A&63;r=u+t+s+(c[Ea+9656+((c[la>>2]^1)*16640|0)+(r<<8)+(x<<2)>>2]|0)|0;s=r+-4e3|0;c[Ga>>2]=s;do if((r|0)>4e3)n=n+(c[W>>2]>>31)|0;else{if((r|0)==4e3)break;n=((c[W>>2]|0)>0&1)+n|0}while(0);n=n-((s|0)/2e4|0)|0;n=(n|0)>0?n:0}B=C-n|0;B=(B|0)<1?1:B;r=~i;s=0-i|0;n=0-(Cg(f,ua,r,s,B,1,0)|0)|0;if((i|0)<(n|0)&(B|0)!=(C|0)){n=s;Ya=187}}else{if(!E){n=t;break}r=~i;n=0-i|0;Ya=187}while(0);do if((Ya|0)==187){Ya=0;if((C|0)>=1){n=0-(Cg(f,ua,r,n,C,1,0)|0)|0;break}if(F){n=0-(Dg(f,ua,r,n,0)|0)|0;break}else{n=0-(Eg(f,ua,r,n,0)|0)|0;break}}while(0);s=(G|0)==0;if(!s?!((n|0)>(i|0)&(Da|(n|0)<(j|0))):0)t=n;else Ya=194;do if((Ya|0)==194){Ya=0;c[ua>>2]=Ia;c[Ia>>2]=0;n=0-i|0;if((C|0)>=1){t=0-(lg(f,ua,X,n,C,0)|0)|0;break}if(F){t=0-(Fg(f,ua,X,n,0)|0)|0;break}else{t=0-(Gg(f,ua,X,n,0)|0)|0;break}}while(0);Vf(f,p);if(a[1233085]&1){i=0;break b}do if(Da){n=c[ha>>2]|0;r=c[ja>>2]|0;k:do if((n|0)!=(r|0))while(1){if((c[c[n+8>>2]>>2]|0)==(p|0))break k;n=n+20|0;if((n|0)==(r|0)){n=r;break}}while(0);if(!(s|(t|0)>(i|0))){c[n>>2]=-32001;break}c[n>>2]=t;x=n+8|0;m=n+12|0;G=c[m>>2]|0;r=c[x>>2]|0;s=G;l:do switch(G-r>>2|0){case 0:{Hg(x,1);break}case 1:break;default:{r=r+4|0;if((s|0)==(r|0))break l;c[m>>2]=s+(~((s+-4-r|0)>>>2)<<2)}}while(0);r=c[ua>>2]|0;s=c[r>>2]|0;if(s|0){u=n+16|0;do{n=c[m>>2]|0;if((n|0)==(c[u>>2]|0))rg(x,r);else{c[n>>2]=s;c[m>>2]=n+4}r=r+4|0;s=c[r>>2]|0}while((s|0)!=0)}if(!E)break;n=c[290941]|0;if((c[290942]|0)==(n|0)){Ya=218;break c}if((Ea|0)!=(c[n>>2]|0))break;h[Y>>3]=+h[Y>>3]+1.0}while(0);do if((t|0)>(o|0)){if((t|0)<=(i|0)){n=I;o=t;break}if(!Da){n=c[g>>2]|0;o=c[ua>>2]|0;c[n>>2]=p;n=n+4|0;do if(o){r=c[o>>2]|0;if(!r)break;do{o=o+4|0;c[n>>2]=r;n=n+4|0;r=c[o>>2]|0}while((r|0)!=0)}while(0);c[n>>2]=0}if((t|0)<(j|0)){n=p;o=t;i=t}else{Ma=K;za=i;Aa=J;q=p;Xa=t;break c}}else n=I;while(0);if(H){r=J;s=K;break}if(!((K|0)<64&(p|0)!=(n|0))){r=J;s=K;break}c[La+(K<<2)>>2]=p;r=J;s=K+1|0}while(0);p=rf(Ba)|0;if(!p){Ma=s;za=i;Aa=r;q=n;Xa=o;break}else{I=n;G=r;K=s}}if((Ya|0)==218)ws(1163764);if(Aa){if(!q){if((k|0)<3){r=0;i=Xa;Ya=286;break}if(c[(c[Na>>2]|0)+72>>2]|0){r=0;i=Xa;Ya=286;break}i=c[xa>>2]|0;if((i&49152|0)==32768)n=(i&12288|0)==4096?64:i>>>6&63;else n=i>>>6&63;if((n|0)==(i&63|0)){r=q;i=Xa;Ya=286;break}r=c[f+(Oa<<2)>>2]|0;o=S(k+2|0,k)|0;s=o+-2|0;p=c[g+-196>>2]|0;n=c[g+-116>>2]|0;i=c[ra>>2]|0;if(i|0?(Pa=(s|0)>-1?s:2-o|0,(Pa|0)<=323):0){Ya=i+(r<<8)+(Oa<<2)|0;g=c[Ya>>2]|0;c[Ya>>2]=g+(s<<5)+((S(g,Pa)|0)/-936|0)}if(n|0?(Ra=(s|0)>-1?s:2-o|0,(Ra|0)<=323):0){Ya=n+(r<<8)+(Oa<<2)|0;g=c[Ya>>2]|0;c[Ya>>2]=g+(s<<5)+((S(g,Ra)|0)/-936|0)}if(!p){r=q;i=Xa;Ya=286;break}i=(s|0)>-1?s:2-o|0;if((i|0)>323){r=q;i=Xa;Ya=286;break}r=p+(r<<8)+(Oa<<2)|0;Ya=c[r>>2]|0;c[r>>2]=Ya+(s<<5)+((S(Ya,i)|0)/-936|0);r=q;i=Xa;Ya=286;break}i=q&49152;n=(i|0)==32768;do if((c[f+5364>>2]|0)==7){if(n)n=(q&12288|0)==4096?64:q>>>6&63;else n=q>>>6&63;i=q&63;if((c[f+(n<<2)>>2]&7|0)==6?(i>>>3|0)>=(n>>3|0):0)break;if(!(c[f+(i<<2)>>2]|0)){i=La;Ya=259}}else{if(n){if((q&12288|0)!=4096)break;i=La;Ya=259;break}if(!i)if(!(c[f+((q&63)<<2)>>2]|0)){i=La;Ya=259;break}else break;else if((i|0)==49152){i=La;Ya=259;break}else break}while(0);if((Ya|0)==259)Ig(f,g,q,i,Ma,(S(k+2|0,k)|0)+-2|0);if((c[g+-4>>2]|0)==1?(c[(c[Na>>2]|0)+72>>2]|0)==0:0){p=c[f+(Oa<<2)>>2]|0;s=S(k+3|0,k+1|0)|0;r=s+-2|0;s=2-s|0;o=c[g+-196>>2]|0;n=c[g+-116>>2]|0;i=c[ra>>2]|0;if(i|0?(Sa=(s|0)>-1?s:r,(Sa|0)<=323):0){Ya=i+(p<<8)+(Oa<<2)|0;g=c[Ya>>2]|0;c[Ya>>2]=g+(s<<5)+((S(g,Sa)|0)/-936|0)}if(n|0?(Ta=(s|0)>-1?s:r,(Ta|0)<=323):0){Ya=n+(p<<8)+(Oa<<2)|0;g=c[Ya>>2]|0;c[Ya>>2]=g+(s<<5)+((S(g,Ta)|0)/-936|0)}if((o|0)!=0?(Ua=(s|0)>-1?s:r,(Ua|0)<=323):0){r=o+(p<<8)+(Oa<<2)|0;i=c[r>>2]|0;c[r>>2]=i+(s<<5)+((S(i,Ua)|0)/-936|0);r=q;i=Xa;Ya=286}else{r=q;i=Xa;Ya=286}}else{r=q;i=Xa;Ya=286}}else{i=za;Ya=233}}else{q=0;Ya=233}while(0);do if((Ya|0)==233)if(!ya){Ya=zd(f)|0;p=c[Za>>2]|0;if(Ya){r=q;i=Ad(f,p,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;Ya=286;break}if(Ka){r=q;i=(c[f+5364>>2]|0)==6?32e3-p|0:p+-32e3|0;Ya=286;break}i=c[f+5348>>2]|0;o=c[1098080+(i<<2)>>2]|0;n=c[f+5364>>2]|0;if((n|0)!=1){r=q;i=(n|0)==6?32e3-p|0:o;Ya=286;break}if((c[f+5368>>2]|0)!=9){r=q;i=32e3-p|0;Ya=286;break}i=i<<3;i=(c[f+336+(i<<2)>>2]|0)-(c[f+336+((i^8)<<2)>>2]|0)|0;if((i|0)>0){r=q;i=p+-32e3|0;Ya=286;break}else{r=q;i=i|0?32e3-p|0:o;Ya=286;break}}else{r=q;Ya=286}while(0);do if((Ya|0)==286){n=c[Za>>2]|0;if((i|0)>31743)u=n+i|0;else u=i-((i|0)<-31743?n:0)|0;t=(i|0)<(j|0)?(r|0?3:1):2;s=c[sa>>2]|0;j=a[1163816]|0;if(!r){p=av(Va|0,Wa|0,48)|0;o=D;n=b[w>>1]|0;if((p|0)==(n&65535|0)&(o|0)==0){q=w;r=n}else{q=w;Ya=292}}else{n=b[w>>1]|0;p=av(Va|0,Wa|0,48)|0;q=w;o=D;Ya=292}if((Ya|0)==292){b[w+2>>1]=r;r=n}n=w+9|0;if((p|0)==(r&65535|0)&(o|0)==0?!((t|0)==3?1:((a[n>>0]|0)+-4|0)<(k|0)):0)break;b[q>>1]=p;b[w+4>>1]=u;b[w+6>>1]=s;a[w+8>>0]=j&255|t;a[n>>0]=k}while(0);k=i;l=_a;return k|0}function mg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=l;l=l+80|0;n=A+64|0;m=A+60|0;k=A+56|0;h=A+52|0;i=A+48|0;y=A+44|0;z=A+40|0;o=A+36|0;p=A+32|0;q=A+28|0;r=A+24|0;s=A+20|0;t=A+16|0;u=A+12|0;v=A+8|0;w=A+4|0;x=A;switch(e|0){case 2:{h=c[b>>2]|0;i=h+-20|0;c[b>>2]=i;f=c[a>>2]|0;if((c[f>>2]|0)>=(c[i>>2]|0)){l=A;return}w=f;v=c[w>>2]|0;w=c[w+4>>2]|0;z=f+8|0;d=c[z>>2]|0;e=f+12|0;y=c[e>>2]|0;x=f+16|0;b=c[x>>2]|0;c[x>>2]=0;c[e>>2]=0;c[z>>2]=0;t=i;u=c[t+4>>2]|0;g=f;c[g>>2]=c[t>>2];c[g+4>>2]=u;g=h+-12|0;c[z>>2]=c[g>>2];z=h+-8|0;c[e>>2]=c[z>>2];e=h+-4|0;c[x>>2]=c[e>>2];x=i;c[x>>2]=v;c[x+4>>2]=w;c[g>>2]=d;c[z>>2]=y;c[e>>2]=b;l=A;return}case 1:case 0:{l=A;return}default:{if((e|0)<1){c[h>>2]=c[a>>2];c[i>>2]=c[b>>2];c[m>>2]=c[h>>2];c[n>>2]=c[i>>2];sg(m,n,d);l=A;return}j=e>>>1;h=c[a>>2]|0;i=h+(j*20|0)|0;if((e|0)>(g|0)){c[r>>2]=h;c[s>>2]=i;c[m>>2]=c[r>>2];c[n>>2]=c[s>>2];mg(m,n,d,j,f,g);c[t>>2]=i;b=c[b>>2]|0;c[u>>2]=b;e=e-j|0;c[m>>2]=c[t>>2];c[n>>2]=c[u>>2];mg(m,n,d,e,f,g);c[v>>2]=h;c[w>>2]=i;c[x>>2]=b;c[k>>2]=c[v>>2];c[m>>2]=c[w>>2];c[n>>2]=c[x>>2];vg(k,m,n,d,j,e,f,g);l=A;return}c[y>>2]=h;c[z>>2]=i;c[m>>2]=c[y>>2];c[n>>2]=c[z>>2];tg(m,n,d,j,f);c[o>>2]=i;c[p>>2]=c[b>>2];b=f+(j*20|0)|0;c[m>>2]=c[o>>2];c[n>>2]=c[p>>2];tg(m,n,d,e-j|0,b);c[q>>2]=h;c[n>>2]=c[q>>2];ug(f,b,b,f+(e*20|0)|0,n,d);if(!f){l=A;return}else h=0;while(1){i=c[f+8>>2]|0;j=i;if(i|0){k=f+12|0;m=c[k>>2]|0;if((m|0)!=(i|0))c[k>>2]=m+(~((m+-4-j|0)>>>2)<<2);Dt(i)}h=h+1|0;if((h|0)==(e|0))break;else f=f+20|0}l=A;return}}}function ng(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;P=l;l=l+192|0;K=P+168|0;h=P+160|0;O=P+16|0;i=P;N=O+8|0;c[N>>2]=3632;L=O+12|0;c[O>>2]=3672;M=O+64|0;c[M>>2]=3692;c[O+4>>2]=0;Rk(O+64|0,L);c[O+136>>2]=0;c[O+140>>2]=-1;c[O>>2]=3612;c[O+64>>2]=3652;c[N>>2]=3632;Tk(L);c[L>>2]=3708;N=O+44|0;c[N>>2]=0;c[N+4>>2]=0;c[N+8>>2]=0;c[N+12>>2]=0;c[O+60>>2]=24;c[K>>2]=0;c[K+4>>2]=0;c[K+8>>2]=0;Jd(L,K);Mt(K);if(!(c[247077]|0)){J=Lj()|0;J=$u(J|0,D|0,1e3,0)|0;k=988408;k=Vu(J|0,D|0,c[k>>2]|0,c[k+4>>2]|0)|0}else k=Xg(1163764)|0;G=k+1|0;H=d+5352|0;C=c[H>>2]|0;I=C+5536|0;J=c[C+140>>2]|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,22001,7);c[K>>2]=i;ae(h,1163992,i,1233087,K,P+180|0);F=xh((c[h>>2]|0)+28|0)|0;h=C+5540|0;C=((c[h>>2]|0)-(c[I>>2]|0)|0)/20|0;F=C>>>0<F>>>0?C:F;Mt(i);C=Xg(1163764)|0;E=D;j=Yg(1163764)|0;if(!0){h=0;i=0}else{h=((c[h>>2]|0)-(c[I>>2]|0)|0)/20|0;i=0}t=Yu(h|0,i|0,j|0,D|0)|0;u=D;if(!F){K=O+8|0;Ld(b,L);c[O>>2]=3612;c[M>>2]=3652;c[K>>2]=3632;c[L>>2]=3708;Mt(N);Tj(L);jl(O,3768);Pj(M);l=P;return}s=(e|0)!=1;v=O+24|0;w=O+28|0;h=O+8|0;x=K+11|0;y=K+4|0;z=fv(C|0,E|0,1e3,0)|0;A=D;B=((G|0)<0)<<31>>31;r=(k|0)>999;o=d+5360|0;p=K+11|0;q=K+4|0;i=0;do{d=i>>>0<=J>>>0;if(s|d){j=c[I>>2]|0;j=d?c[j+(i*20|0)>>2]|0:c[j+(i*20|0)+4>>2]|0;if(!0)n=0;else n=(((j|0)>-1?j:0-j|0)|0)<31872;m=n?0:j;j=c[v>>2]|0;k=c[w>>2]|0;if(j>>>0<k>>>0)j=k-j|0;else j=hb[c[(c[L>>2]|0)+28>>2]&127](L)|0;if(j|0)Kd(h,21531,1)|0;Q=Kd(dl(Kd(Kd(h,20993,4)|0,20998,7)|0,((d^1)<<31>>31)+e|0)|0,21006,10)|0;d=i+1|0;Q=Kd(el(Kd(dl(Q,c[(c[H>>2]|0)+144>>2]|0)|0,21017,9)|0,d)|0,21027,7)|0;sh(K,m);k=a[x>>0]|0;j=k<<24>>24<0;Kd(Q,j?c[K>>2]|0:K,j?c[y>>2]|0:k&255)|0;Mt(K);if((i|0)==(J|0)&(n^1)){Q=(m|0)<(g|0)?((m|0)<=(f|0)?21035:1235164):21047;Kd(h,Q,Vh(Q)|0)|0}n=Kd(gl(Kd(h,21059,7)|0,C,E)|0,21067,5)|0;Q=dv(z|0,A|0,G|0,B|0)|0;gl(n,Q,D)|0;if(r){Q=Kd(h,21073,10)|0;dl(Q,hh(1163804)|0)|0}Kd(dl(Kd(gl(Kd(h,21084,8)|0,t,u)|0,21093,6)|0,G)|0,21100,3)|0;k=c[I>>2]|0;j=c[k+(i*20|0)+8>>2]|0;k=c[k+(i*20|0)+12>>2]|0;if((j|0)==(k|0))i=d;else{i=j;do{Q=c[i>>2]|0;m=Kd(h,21684,1)|0;rh(K,Q,(a[o>>0]|0)!=0);Q=a[p>>0]|0;n=Q<<24>>24<0;Kd(m,n?c[K>>2]|0:K,n?c[q>>2]|0:Q&255)|0;Mt(K);i=i+4|0}while((i|0)!=(k|0));i=d}}else i=i+1|0}while(i>>>0<F>>>0);Ld(b,L);c[O>>2]=3612;c[M>>2]=3652;c[h>>2]=3632;c[L>>2]=3708;Mt(N);Tj(L);jl(O,3768);Pj(M);l=P;return}function og(a){a=a|0;pg(a);return}function pg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=l;l=l+48|0;y=z+36|0;x=z+24|0;f=z+16|0;h=z;if(c[247077]|0){u=c[988300+(c[273162]<<2)>>2]|0;v=Xg(1163764)|0;v=Vu(u|0,((u|0)<0)<<31>>31|0,v|0,D|0)|0;u=988400;u=Yu(v|0,D|0,c[u>>2]|0,c[u+4>>2]|0)|0;v=988400;c[v>>2]=u;c[v+4>>2]=D}if((a[1233085]&1)==0?c[247082]|c[247083]|0:0){a[1233086]=1;Sg(b,1233085)}a[1233085]=1;d=c[290941]|0;g=c[290942]|0;if((d|0)!=(g|0))do{e=c[d>>2]|0;if((e|0)!=(b|0))Rg(e);d=d+4|0}while((d|0)!=(g|0));do if(!(a[b+4237240>>0]|0)){c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,22001,7);c[y>>2]=h;ae(f,1163992,h,1233087,y,x);v=(xh((c[f>>2]|0)+28|0)|0)!=1;if(v|(c[247079]|0)!=0){Mt(h);e=b;d=b;break}v=(c[c[(c[b+5536>>2]|0)+8>>2]>>2]|0)==0;Mt(h);if(!v){h=c[290941]|0;v=c[290942]|0;g=(h|0)==(v|0);if(g){u=b;e=0}else{e=0;d=b;f=h;do{t=c[f>>2]|0;u=c[t+5536>>2]|0;d=((c[t+5552>>2]|0)>=(c[d+5552>>2]|0)?(c[u>>2]|0)>(c[c[d+5536>>2]>>2]|0):0)?t:d;u=(c[u+12>>2]|0)-(c[u+8>>2]|0)>>2;e=u>>>0<e>>>0?e:u;f=f+4|0}while((f|0)!=(v|0));u=d}r=c[u+5536>>2]|0;q=c[r+12>>2]|0;s=c[r+8>>2]|0;t=q-s|0;o=e>>>0<6?e:6;p=s;if(t>>2>>>0>=o>>>0|g){e=u;d=u}else{m=u+5552|0;n=(p|0)==(q|0);d=u;while(1){j=c[h>>2]|0;k=c[j+5536>>2]|0;e=c[k+8>>2]|0;i=(c[k+12>>2]|0)-e|0;do if(i>>>0>t>>>0){a:do if(n)e=s;else{g=p;f=e;e=s;while(1){if((c[g>>2]|0)!=(c[f>>2]|0))break a;g=g+4|0;e=g;if((g|0)==(q|0))break;else f=f+4|0}}while(0);if((e|0)==(q|0)){f=c[d+5536>>2]|0;g=(c[f+12>>2]|0)-(c[f+8>>2]|0)>>2;e=i>>2;if(g>>>0<o>>>0){if(e>>>0<g>>>0)break;k=(c[r>>2]|0)-(c[k>>2]|0)|0;if((((k|0)>-1?k:0-k|0)|0)>=20)break;d=((c[m>>2]|0)-(c[j+5552>>2]|0)|0)<2?j:d;break}if(e>>>0>=o>>>0?(w=c[k>>2]|0,k=(c[r>>2]|0)-w|0,(((k|0)>-1?k:0-k|0)|0)<20):0){if((w|0)<(c[f>>2]|0)?(c[j+5552>>2]|0)<(c[d+5552>>2]|0):0)break;d=j}}}while(0);h=h+4|0;if((h|0)==(v|0)){e=u;break}}}}else{e=b;d=b}}else{e=b;d=b}while(0);f=e+5536|0;c[b+4237256>>2]=c[c[f>>2]>>2];if((d|0)!=(b|0)){u=te(1164756,0)|0;ng(x,d+160|0,c[d+5552>>2]|0,-32001,32001);w=a[x+11>>0]|0;v=w<<24>>24<0;w=Kd(u,v?c[x>>2]|0:x,v?c[x+4>>2]|0:w&255)|0;c[y>>2]=Sk(w+(c[(c[w>>2]|0)+-12>>2]|0)|0)|0;v=lm(y,1165628)|0;v=nb[c[(c[v>>2]|0)+28>>2]&63](v,10)|0;pt(y);il(w,v)|0;Xk(w)|0;te(w,1)|0;Mt(x)}w=Kd(te(1164756,0)|0,20974,9)|0;d=b+5520|0;rh(y,c[c[(c[f>>2]|0)+8>>2]>>2]|0,(a[d>>0]|0)!=0);e=a[y+11>>0]|0;x=e<<24>>24<0;Kd(w,x?c[y>>2]|0:y,x?c[y+4>>2]|0:e&255)|0;Mt(y);e=c[f>>2]|0;if((c[e+12>>2]|0)-(c[e+8>>2]|0)>>2>>>0<=1?!(qg(e,b+160|0)|0):0){b=c[291189]|0;b=b+-12|0;b=c[b>>2]|0;b=1164756+b|0;b=Sk(b)|0;c[y>>2]=b;b=lm(y,1165628)|0;x=c[b>>2]|0;x=x+28|0;x=c[x>>2]|0;b=nb[x&63](b,10)|0;pt(y);il(1164756,b)|0;Xk(1164756)|0;te(1164756,1)|0;l=z;return}w=Kd(1164756,20984,8)|0;rh(y,c[(c[(c[f>>2]|0)+8>>2]|0)+4>>2]|0,(a[d>>0]|0)!=0);b=a[y+11>>0]|0;x=b<<24>>24<0;Kd(w,x?c[y>>2]|0:y,x?c[y+4>>2]|0:b&255)|0;Mt(y);b=c[291189]|0;b=b+-12|0;b=c[b>>2]|0;b=1164756+b|0;b=Sk(b)|0;c[y>>2]=b;b=lm(y,1165628)|0;x=c[b>>2]|0;x=x+28|0;x=c[x>>2]|0;b=nb[x&63](b,10)|0;pt(y);il(1164756,b)|0;Xk(1164756)|0;te(1164756,1)|0;l=z;return}function qg(b,d){b=b|0;d=d|0;var f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+4560|0;h=k+4544|0;i=k+4540|0;f=k+440|0;j=b+8|0;g=c[c[j>>2]>>2]|0;if(!g){j=0;l=k;return j|0}Tf(d,g,k,Rf(d,g)|0);g=(c[d+5356>>2]|0)+56|0;g=gh(1163804,c[g>>2]|0,c[g+4>>2]|0,h)|0;if(a[h>>0]|0){h=e[g+2>>1]|0;c[i>>2]=h;g=kf(d,f)|0;c[f+4096>>2]=g;a:do if((f|0)!=(g|0)){while(1){if((c[f>>2]|0)==(h|0))break;f=f+8|0;if((f|0)==(g|0))break a}f=b+12|0;g=c[f>>2]|0;if((g|0)==(c[b+16>>2]|0)){rg(j,i);break}else{c[g>>2]=h;c[f>>2]=g+4;break}}while(0)}Vf(d,c[c[j>>2]>>2]|0);j=(c[b+12>>2]|0)-(c[j>>2]|0)>>2>>>0>1;l=k;return j|0}function rg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=a+4|0;e=c[i>>2]|0;j=c[a>>2]|0;d=(e-j>>2)+1|0;if(d>>>0>1073741823)vs(a);k=a+8|0;h=(c[k>>2]|0)-j|0;f=h>>1;f=h>>2>>>0<536870911?(f>>>0<d>>>0?d:f):1073741823;if(!f)h=0;else h=At(f<<2)|0;g=h+(e-j>>2<<2)|0;c[g>>2]=c[b>>2];d=e-j|0;b=g+(0-(d>>2)<<2)|0;if((d|0)>0)cv(b|0,j|0,d|0)|0;c[a>>2]=b;c[i>>2]=g+4;c[k>>2]=h+(f<<2);if(!j)return;Dt(j);return}function sg(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=c[a>>2]|0;e=c[b>>2]|0;if((d|0)==(e|0))return;f=d+20|0;if((f|0)==(e|0))return;while(1){e=f;o=f;n=c[o>>2]|0;o=c[o+4>>2]|0;m=d+28|0;q=c[m>>2]|0;l=d+32|0;r=c[l>>2]|0;k=d+36|0;p=c[k>>2]|0;c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;a:do if((f|0)==(c[a>>2]|0))d=e;else{d=e;m=f;do{k=m;m=m+-20|0;if((c[m>>2]|0)>=(n|0))break a;l=d;e=m;j=c[e+4>>2]|0;i=d;c[i>>2]=c[e>>2];c[i+4>>2]=j;i=l+8|0;j=k+-12|0;d=c[i>>2]|0;e=d;h=l+12|0;if(!d)d=l+16|0;else{g=c[h>>2]|0;if((g|0)!=(d|0))c[h>>2]=g+(~((g+-4-e|0)>>>2)<<2);Dt(d);d=l+16|0;c[d>>2]=0;c[h>>2]=0;c[i>>2]=0}c[i>>2]=c[j>>2];i=k+-8|0;c[h>>2]=c[i>>2];k=k+-4|0;c[d>>2]=c[k>>2];c[k>>2]=0;c[i>>2]=0;c[j>>2]=0;d=l+-20|0}while((m|0)!=(c[a>>2]|0))}while(0);j=d;i=d;c[i>>2]=n;c[i+4>>2]=o;i=j+8|0;d=c[i>>2]|0;e=d;h=j+12|0;if(!d)d=j+16|0;else{g=c[h>>2]|0;if((g|0)!=(d|0))c[h>>2]=g+(~((g+-4-e|0)>>>2)<<2);Dt(d);d=j+16|0;c[d>>2]=0;c[h>>2]=0;c[i>>2]=0}c[i>>2]=q;c[h>>2]=r;c[d>>2]=p;d=f+20|0;if((d|0)==(c[b>>2]|0))break;else{r=f;f=d;d=r}}return}function tg(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;v=l;l=l+64|0;j=v+52|0;i=v+48|0;h=v+44|0;g=v+40|0;q=v+36|0;r=v+32|0;s=v+28|0;t=v+24|0;u=v+20|0;k=v+16|0;m=v+12|0;n=v+8|0;o=v+4|0;p=v;switch(e|0){case 1:{u=c[a>>2]|0;t=u;b=c[t+4>>2]|0;a=f;c[a>>2]=c[t>>2];c[a+4>>2]=b;a=f+8|0;b=u+8|0;c[a>>2]=0;t=f+12|0;c[t>>2]=0;c[f+16>>2]=0;c[a>>2]=c[b>>2];a=u+12|0;c[t>>2]=c[a>>2];u=u+16|0;c[f+16>>2]=c[u>>2];c[u>>2]=0;c[a>>2]=0;c[b>>2]=0;l=v;return}case 2:{h=c[b>>2]|0;i=h+-20|0;c[b>>2]=i;g=c[a>>2]|0;if((c[g>>2]|0)<(c[i>>2]|0)){a=i;u=c[a+4>>2]|0;b=f;c[b>>2]=c[a>>2];c[b+4>>2]=u;b=f+8|0;u=h+-12|0;c[b>>2]=0;a=f+12|0;c[a>>2]=0;c[f+16>>2]=0;c[b>>2]=c[u>>2];b=h+-8|0;c[a>>2]=c[b>>2];a=h+-4|0;c[f+16>>2]=c[a>>2];c[a>>2]=0;c[b>>2]=0;c[u>>2]=0;u=g;b=c[u+4>>2]|0;a=f+20|0;c[a>>2]=c[u>>2];c[a+4>>2]=b;a=f+28|0;b=g+8|0;c[a>>2]=0;u=f+32|0;c[u>>2]=0;c[f+36>>2]=0;c[a>>2]=c[b>>2];a=g+12|0;c[u>>2]=c[a>>2];u=g+16|0;c[f+36>>2]=c[u>>2];c[u>>2]=0;c[a>>2]=0;c[b>>2]=0;l=v;return}else{a=g;u=c[a+4>>2]|0;b=f;c[b>>2]=c[a>>2];c[b+4>>2]=u;b=f+8|0;u=g+8|0;c[b>>2]=0;a=f+12|0;c[a>>2]=0;c[f+16>>2]=0;c[b>>2]=c[u>>2];b=g+12|0;c[a>>2]=c[b>>2];a=g+16|0;c[f+16>>2]=c[a>>2];c[a>>2]=0;c[b>>2]=0;c[u>>2]=0;u=i;b=c[u+4>>2]|0;a=f+20|0;c[a>>2]=c[u>>2];c[a+4>>2]=b;a=f+28|0;b=h+-12|0;c[a>>2]=0;u=f+32|0;c[u>>2]=0;c[f+36>>2]=0;c[a>>2]=c[b>>2];a=h+-8|0;c[u>>2]=c[a>>2];u=h+-4|0;c[f+36>>2]=c[u>>2];c[u>>2]=0;c[a>>2]=0;c[b>>2]=0;l=v;return}}case 0:{l=v;return}default:if((e|0)<9){c[q>>2]=c[a>>2];c[r>>2]=c[b>>2];c[i>>2]=c[q>>2];c[j>>2]=c[r>>2];zg(i,j,f,d);l=v;return}else{q=e>>>1;r=c[a>>2]|0;a=r+(q*20|0)|0;c[s>>2]=r;c[t>>2]=a;c[i>>2]=c[s>>2];c[j>>2]=c[t>>2];mg(i,j,d,q,f,q);c[u>>2]=a;b=c[b>>2]|0;c[k>>2]=b;t=e-q|0;c[i>>2]=c[u>>2];c[j>>2]=c[k>>2];mg(i,j,d,t,f+(q*20|0)|0,t);c[m>>2]=r;c[n>>2]=a;c[o>>2]=a;c[p>>2]=b;c[g>>2]=c[m>>2];c[h>>2]=c[n>>2];c[i>>2]=c[o>>2];c[j>>2]=c[p>>2];Ag(g,h,i,j,f,d);l=v;return}}}function ug(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0;a:do if((a|0)!=(b|0)){while(1){if((d|0)==(e|0))break;m=c[f>>2]|0;if((c[a>>2]|0)<(c[d>>2]|0)){g=d;l=c[g+4>>2]|0;k=m;c[k>>2]=c[g>>2];c[k+4>>2]=l;k=m+8|0;l=d+8|0;g=c[k>>2]|0;h=g;j=m+12|0;if(!g)g=m+16|0;else{i=c[j>>2]|0;if((i|0)!=(g|0))c[j>>2]=i+(~((i+-4-h|0)>>>2)<<2);Dt(g);g=m+16|0;c[g>>2]=0;c[j>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];m=d+12|0;c[j>>2]=c[m>>2];k=d+16|0;c[g>>2]=c[k>>2];c[k>>2]=0;c[m>>2]=0;c[l>>2]=0;d=d+20|0}else{g=a;l=c[g+4>>2]|0;k=m;c[k>>2]=c[g>>2];c[k+4>>2]=l;k=m+8|0;l=a+8|0;g=c[k>>2]|0;h=g;j=m+12|0;if(!g)g=m+16|0;else{i=c[j>>2]|0;if((i|0)!=(g|0))c[j>>2]=i+(~((i+-4-h|0)>>>2)<<2);Dt(g);g=m+16|0;c[g>>2]=0;c[j>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];m=a+12|0;c[j>>2]=c[m>>2];k=a+16|0;c[g>>2]=c[k>>2];c[k>>2]=0;c[m>>2]=0;c[l>>2]=0;a=a+20|0}c[f>>2]=(c[f>>2]|0)+20;if((a|0)==(b|0))break a}if((a|0)==(b|0))return;d=c[f>>2]|0;do{g=a;l=c[g+4>>2]|0;k=d;c[k>>2]=c[g>>2];c[k+4>>2]=l;k=d+8|0;l=a+8|0;g=c[k>>2]|0;h=g;j=d+12|0;if(!g)d=d+16|0;else{i=c[j>>2]|0;if((i|0)!=(g|0))c[j>>2]=i+(~((i+-4-h|0)>>>2)<<2);Dt(g);d=d+16|0;c[d>>2]=0;c[j>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];e=a+12|0;c[j>>2]=c[e>>2];m=a+16|0;c[d>>2]=c[m>>2];c[m>>2]=0;c[e>>2]=0;c[l>>2]=0;a=a+20|0;d=(c[f>>2]|0)+20|0;c[f>>2]=d}while((a|0)!=(b|0));return}while(0);if((d|0)==(e|0))return;a=c[f>>2]|0;do{g=d;l=c[g+4>>2]|0;k=a;c[k>>2]=c[g>>2];c[k+4>>2]=l;k=a+8|0;l=d+8|0;g=c[k>>2]|0;h=g;j=a+12|0;if(!g)a=a+16|0;else{i=c[j>>2]|0;if((i|0)!=(g|0))c[j>>2]=i+(~((i+-4-h|0)>>>2)<<2);Dt(g);a=a+16|0;c[a>>2]=0;c[j>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];b=d+12|0;c[j>>2]=c[b>>2];m=d+16|0;c[a>>2]=c[m>>2];c[m>>2]=0;c[b>>2]=0;c[l>>2]=0;d=d+20|0;a=(c[f>>2]|0)+20|0;c[f>>2]=a}while((d|0)!=(e|0));return}function vg(a,b,d,e,f,g,h,i){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;K=l;l=l+48|0;G=K+44|0;F=K+40|0;E=K+36|0;I=K+32|0;J=K+28|0;H=K+24|0;y=K+20|0;z=K+16|0;A=K+12|0;B=K+8|0;C=K+4|0;D=K;if(!g){l=K;return}j=f;a:while(1){if(!((g|0)>(i|0)&(j|0)>(i|0))){f=6;break}if(!j){f=33;break}w=c[b>>2]|0;m=c[w>>2]|0;x=w;k=c[a>>2]|0;while(1){if((c[k>>2]|0)<(m|0))break;f=k+20|0;c[a>>2]=f;j=j+-1|0;if(!j){f=33;break a}else k=f}s=k;if((j|0)<(g|0)){t=(g|0)/2|0;m=w+(t*20|0)|0;f=m;n=x-s|0;if(n){r=c[m>>2]|0;q=(n|0)/20|0;m=k;n=k;while(1){v=(q|0)/2|0;p=n+(v*20|0)|0;o=(c[p>>2]|0)<(r|0);p=p+20|0;k=o?m:p;q=o?v:q+-1-v|0;if(!q)break;else{m=k;n=o?n:p}}}v=k;q=(v-s|0)/20|0}else{if((j|0)==1){f=15;break}q=(j|0)/2|0;f=k+(q*20|0)|0;r=f;k=(c[d>>2]|0)-x|0;if(!k)f=w;else{p=c[f>>2]|0;k=(k|0)/20|0;f=w;m=w;while(1){v=(k|0)/2|0;o=m+(v*20|0)|0;n=(p|0)<(c[o>>2]|0);o=o+20|0;f=n?o:f;k=n?k+-1-v|0:v;if(!k)break;else m=n?o:m}}t=(f-x|0)/20|0;v=r}j=j-q|0;g=g-t|0;k=v;u=f;b:do if((k|0)!=(w|0)){if((w|0)!=(u|0)){p=x;o=v;r=x;while(1){x=p;M=k;N=c[M>>2]|0;M=c[M+4>>2]|0;n=k+8|0;L=c[n>>2]|0;P=k+12|0;w=c[P>>2]|0;O=k+16|0;m=c[O>>2]|0;c[O>>2]=0;c[P>>2]=0;c[n>>2]=0;R=p;Q=c[R+4>>2]|0;s=k;c[s>>2]=c[R>>2];c[s+4>>2]=Q;s=x+8|0;c[n>>2]=c[s>>2];n=x+12|0;c[P>>2]=c[n>>2];k=x+16|0;c[O>>2]=c[k>>2];c[p>>2]=N;c[p+4>>2]=M;c[s>>2]=L;c[n>>2]=w;c[k>>2]=m;k=o+20|0;o=k;x=x+20|0;m=x;n=(k|0)==(r|0);if((x|0)==(u|0))break;p=m;r=n?m:r}if(!n){n=k;m=r;while(1){s=r;while(1){p=m;L=n;x=c[L>>2]|0;L=c[L+4>>2]|0;Q=n+8|0;N=c[Q>>2]|0;S=n+12|0;P=c[S>>2]|0;w=n+16|0;R=c[w>>2]|0;c[w>>2]=0;c[S>>2]=0;c[Q>>2]=0;M=m;T=M;m=c[T+4>>2]|0;O=n;c[O>>2]=c[T>>2];c[O+4>>2]=m;O=p+8|0;c[Q>>2]=c[O>>2];Q=p+12|0;c[S>>2]=c[Q>>2];m=p+16|0;c[w>>2]=c[m>>2];c[M>>2]=x;c[M+4>>2]=L;c[O>>2]=N;c[Q>>2]=P;c[m>>2]=R;n=o+20|0;o=n;m=p+20|0;p=(n|0)==(s|0);if((m|0)!=(u|0))break;if(p)break b;else m=r}T=m;m=T;r=p?T:r}}}}else k=u;while(0);c[b>>2]=k;if((q+t|0)<(j+g|0)){c[y>>2]=c[a>>2];c[z>>2]=v;c[A>>2]=k;c[E>>2]=c[y>>2];c[F>>2]=c[z>>2];c[G>>2]=c[A>>2];vg(E,F,G,e,q,t,h,i);c[a>>2]=k}else{c[B>>2]=k;c[C>>2]=f;c[D>>2]=c[d>>2];c[E>>2]=c[B>>2];c[F>>2]=c[C>>2];c[G>>2]=c[D>>2];vg(E,F,G,e,j,g,h,i);c[d>>2]=k;g=t;j=q;f=v}c[b>>2]=f;if(!g){f=33;break}}if((f|0)==6){c[I>>2]=c[a>>2];c[J>>2]=c[b>>2];c[H>>2]=c[d>>2];c[E>>2]=c[I>>2];c[F>>2]=c[J>>2];c[G>>2]=c[H>>2];wg(E,F,G,e,j,g,h);l=K;return}else if((f|0)==15){M=k;L=c[M>>2]|0;M=c[M+4>>2]|0;R=k+8|0;O=c[R>>2]|0;T=k+12|0;Q=c[T>>2]|0;N=k+16|0;S=c[N>>2]|0;c[N>>2]=0;c[T>>2]=0;c[R>>2]=0;I=w;J=c[I+4>>2]|0;P=k;c[P>>2]=c[I>>2];c[P+4>>2]=J;P=w+8|0;c[R>>2]=c[P>>2];R=w+12|0;c[T>>2]=c[R>>2];T=w+16|0;c[N>>2]=c[T>>2];N=w;c[N>>2]=L;c[N+4>>2]=M;c[P>>2]=O;c[R>>2]=Q;c[T>>2]=S;l=K;return}else if((f|0)==33){l=K;return}}function wg(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;D=l;l=l+112|0;C=D+104|0;B=D+96|0;A=D+88|0;z=D+80|0;o=D+72|0;m=D+64|0;w=D+56|0;x=D+52|0;y=D+48|0;p=D+108|0;q=D+40|0;r=D+32|0;s=D+24|0;t=D+16|0;u=D+8|0;v=D;if((g|0)>(h|0)){g=c[d>>2]|0;j=g;h=c[e>>2]|0;if((j|0)==(h|0)){j=i;n=0}else{k=i;n=0;h=j;while(1){y=g;j=c[y+4>>2]|0;g=k;c[g>>2]=c[y>>2];c[g+4>>2]=j;g=k+8|0;j=h+8|0;c[g>>2]=0;y=k+12|0;c[y>>2]=0;c[k+16>>2]=0;c[g>>2]=c[j>>2];g=h+12|0;c[y>>2]=c[g>>2];y=h+16|0;c[k+16>>2]=c[y>>2];c[y>>2]=0;c[g>>2]=0;c[j>>2]=0;n=n+1|0;j=h+20|0;g=k+20|0;h=c[e>>2]|0;if((j|0)==(h|0))break;else{k=g;g=j;h=j}}j=g;g=c[d>>2]|0}e=h;c[q>>2]=j;c[q+4>>2]=j;c[r>>2]=i;c[r+4>>2]=i;c[s>>2]=g;c[s+4>>2]=g;b=c[b>>2]|0;c[t>>2]=b;c[t+4>>2]=b;c[u>>2]=e;c[u+4>>2]=e;c[v>>2]=f;c[m>>2]=c[q>>2];c[m+4>>2]=c[q+4>>2];c[o>>2]=c[r>>2];c[o+4>>2]=c[r+4>>2];c[z>>2]=c[s>>2];c[z+4>>2]=c[s+4>>2];c[A>>2]=c[t>>2];c[A+4>>2]=c[t+4>>2];c[B>>2]=c[u>>2];c[B+4>>2]=c[u+4>>2];c[C>>2]=c[v>>2];yg(m,o,z,A,B,C)}else{g=c[b>>2]|0;j=g;h=c[d>>2]|0;if((j|0)==(h|0)){j=i;n=0}else{k=i;n=0;h=j;while(1){f=g;j=c[f+4>>2]|0;g=k;c[g>>2]=c[f>>2];c[g+4>>2]=j;g=k+8|0;j=h+8|0;c[g>>2]=0;f=k+12|0;c[f>>2]=0;c[k+16>>2]=0;c[g>>2]=c[j>>2];g=h+12|0;c[f>>2]=c[g>>2];f=h+16|0;c[k+16>>2]=c[f>>2];c[f>>2]=0;c[g>>2]=0;c[j>>2]=0;n=n+1|0;j=h+20|0;g=k+20|0;h=c[d>>2]|0;if((j|0)==(h|0))break;else{k=g;g=j;h=j}}j=g;g=c[b>>2]|0}c[w>>2]=h;c[x>>2]=c[e>>2];c[y>>2]=g;c[z>>2]=c[w>>2];c[A>>2]=c[x>>2];c[B>>2]=c[y>>2];a[C>>0]=a[p>>0]|0;xg(i,j,z,A,B,C)}if((i|0)==0|(n|0)==0){l=D;return}else{m=0;g=n}while(1){j=c[i+8>>2]|0;k=j;if(j){h=i+12|0;g=c[h>>2]|0;if((g|0)!=(j|0))c[h>>2]=g+(~((g+-4-k|0)>>>2)<<2);Dt(j);g=n}m=m+1|0;if(m>>>0>=g>>>0)break;else i=i+20|0}l=D;return}function xg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;if((a|0)==(b|0))return;while(1){n=c[d>>2]|0;if((n|0)==(c[e>>2]|0))break;g=c[f>>2]|0;if((c[a>>2]|0)<(c[n>>2]|0)){h=n;m=c[h+4>>2]|0;l=g;c[l>>2]=c[h>>2];c[l+4>>2]=m;l=g+8|0;m=n+8|0;h=c[l>>2]|0;i=h;k=g+12|0;if(!h)h=g+16|0;else{j=c[k>>2]|0;if((j|0)!=(h|0))c[k>>2]=j+(~((j+-4-i|0)>>>2)<<2);Dt(h);h=g+16|0;c[h>>2]=0;c[k>>2]=0;c[l>>2]=0}c[l>>2]=c[m>>2];l=n+12|0;c[k>>2]=c[l>>2];k=n+16|0;c[h>>2]=c[k>>2];c[k>>2]=0;c[l>>2]=0;c[m>>2]=0;c[d>>2]=n+20}else{h=a;m=c[h+4>>2]|0;l=g;c[l>>2]=c[h>>2];c[l+4>>2]=m;l=g+8|0;m=a+8|0;h=c[l>>2]|0;i=h;k=g+12|0;if(!h)g=g+16|0;else{j=c[k>>2]|0;if((j|0)!=(h|0))c[k>>2]=j+(~((j+-4-i|0)>>>2)<<2);Dt(h);g=g+16|0;c[g>>2]=0;c[k>>2]=0;c[l>>2]=0}c[l>>2]=c[m>>2];n=a+12|0;c[k>>2]=c[n>>2];l=a+16|0;c[g>>2]=c[l>>2];c[l>>2]=0;c[n>>2]=0;c[m>>2]=0;a=a+20|0;g=c[f>>2]|0}c[f>>2]=g+20;if((a|0)==(b|0)){o=25;break}}if((o|0)==25)return;m=a;j=c[f>>2]|0;while(1){a=m;l=c[a+4>>2]|0;k=j;c[k>>2]=c[a>>2];c[k+4>>2]=l;k=j+8|0;l=m+8|0;a=c[k>>2]|0;g=a;i=j+12|0;if(!a)a=j+16|0;else{h=c[i>>2]|0;if((h|0)!=(a|0))c[i>>2]=h+(~((h+-4-g|0)>>>2)<<2);Dt(a);a=j+16|0;c[a>>2]=0;c[i>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];f=m+12|0;c[i>>2]=c[f>>2];o=m+16|0;c[a>>2]=c[o>>2];c[o>>2]=0;c[f>>2]=0;c[l>>2]=0;m=m+20|0;if((m|0)==(b|0))break;else j=j+20|0}return}function yg(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;r=a+4|0;g=c[r>>2]|0;s=b+4|0;if((g|0)==(c[s>>2]|0))return;q=d+4|0;o=c[e+4>>2]|0;p=f+4|0;e=c[q>>2]|0;n=g;while(1){if((e|0)==(o|0))break;h=e+-20|0;d=n+-20|0;g=c[p>>2]|0;i=g+-20|0;if((c[d>>2]|0)<(c[h>>2]|0)){h=d;m=c[h+4>>2]|0;l=i;c[l>>2]=c[h>>2];c[l+4>>2]=m;l=g+-12|0;m=n+-12|0;h=c[l>>2]|0;i=h;k=g+-8|0;if(!h)h=g+-4|0;else{j=c[k>>2]|0;if((j|0)!=(h|0))c[k>>2]=j+(~((j+-4-i|0)>>>2)<<2);Dt(h);h=g+-4|0;c[h>>2]=0;c[k>>2]=0;c[l>>2]=0}c[l>>2]=c[m>>2];l=n+-8|0;c[k>>2]=c[l>>2];n=n+-4|0;c[h>>2]=c[n>>2];c[n>>2]=0;c[l>>2]=0;c[m>>2]=0;c[r>>2]=d}else{d=h;l=c[d+4>>2]|0;k=i;c[k>>2]=c[d>>2];c[k+4>>2]=l;k=g+-12|0;l=e+-12|0;d=c[k>>2]|0;h=d;j=g+-8|0;if(!d)g=g+-4|0;else{i=c[j>>2]|0;if((i|0)!=(d|0))c[j>>2]=i+(~((i+-4-h|0)>>>2)<<2);Dt(d);g=g+-4|0;c[g>>2]=0;c[j>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];d=e+-8|0;c[j>>2]=c[d>>2];e=e+-4|0;c[g>>2]=c[e>>2];c[e>>2]=0;c[d>>2]=0;c[l>>2]=0;e=(c[q>>2]|0)+-20|0;c[q>>2]=e;g=c[p>>2]|0;d=c[r>>2]|0}c[p>>2]=g+-20;if((d|0)==(c[s>>2]|0)){t=26;break}else n=d}if((t|0)==26)return;d=c[f+4>>2]|0;g=c[a+4>>2]|0;o=c[b+4>>2]|0;if((g|0)==(o|0))return;n=d;k=d;while(1){m=g;l=g+-20|0;g=l;j=c[g+4>>2]|0;i=k+-20|0;c[i>>2]=c[g>>2];c[i+4>>2]=j;i=k+-12|0;j=m+-12|0;g=c[i>>2]|0;d=g;h=k+-8|0;if(!g)g=k+-4|0;else{e=c[h>>2]|0;if((e|0)!=(g|0))c[h>>2]=e+(~((e+-4-d|0)>>>2)<<2);Dt(g);g=k+-4|0;c[g>>2]=0;c[h>>2]=0;c[i>>2]=0}c[i>>2]=c[j>>2];b=m+-8|0;c[h>>2]=c[b>>2];a=m+-4|0;c[g>>2]=c[a>>2];c[a>>2]=0;c[b>>2]=0;c[j>>2]=0;g=n+-20|0;if((l|0)==(o|0))break;else{n=g;k=g;g=l}}return}function zg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;g=c[a>>2]|0;e=c[b>>2]|0;if((g|0)==(e|0))return;l=g;f=c[l+4>>2]|0;m=d;c[m>>2]=c[l>>2];c[m+4>>2]=f;m=d+8|0;f=g+8|0;c[m>>2]=0;l=d+12|0;c[l>>2]=0;c[d+16>>2]=0;c[m>>2]=c[f>>2];m=g+12|0;c[l>>2]=c[m>>2];l=g+16|0;c[d+16>>2]=c[l>>2];c[l>>2]=0;c[m>>2]=0;c[f>>2]=0;f=g+20|0;c[a>>2]=f;if((f|0)==(e|0))return;else m=d;do{e=m;m=m+20|0;if((c[e>>2]|0)<(c[f>>2]|0)){j=e;k=c[j+4>>2]|0;l=m;c[l>>2]=c[j>>2];c[l+4>>2]=k;l=e+8|0;c[e+28>>2]=c[l>>2];k=e+12|0;c[e+32>>2]=c[k>>2];j=e+16|0;c[e+36>>2]=c[j>>2];c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;a:do if((e|0)==(d|0))e=d;else while(1){i=e;e=e+-20|0;if((c[e>>2]|0)>=(c[c[a>>2]>>2]|0)){e=i;break a}f=e;l=c[f+4>>2]|0;k=i;c[k>>2]=c[f>>2];c[k+4>>2]=l;k=i+8|0;l=i+-12|0;f=c[k>>2]|0;g=f;j=i+12|0;if(!f)f=i+16|0;else{h=c[j>>2]|0;if((h|0)!=(f|0))c[j>>2]=h+(~((h+-4-g|0)>>>2)<<2);Dt(f);f=i+16|0;c[f>>2]=0;c[j>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];k=i+-8|0;c[j>>2]=c[k>>2];j=i+-4|0;c[f>>2]=c[j>>2];c[j>>2]=0;c[k>>2]=0;c[l>>2]=0;if((e|0)==(d|0)){e=d;break}}while(0);j=c[a>>2]|0;h=j;l=c[h+4>>2]|0;k=e;c[k>>2]=c[h>>2];c[k+4>>2]=l;k=e+8|0;l=j+8|0;h=c[k>>2]|0;f=h;i=e+12|0;if(!h)e=e+16|0;else{g=c[i>>2]|0;if((g|0)!=(h|0))c[i>>2]=g+(~((g+-4-f|0)>>>2)<<2);Dt(h);e=e+16|0;c[e>>2]=0;c[i>>2]=0;c[k>>2]=0}c[k>>2]=c[l>>2];k=j+12|0;c[i>>2]=c[k>>2];j=j+16|0;c[e>>2]=c[j>>2];c[j>>2]=0;c[k>>2]=0;c[l>>2]=0}else{j=f;l=c[j+4>>2]|0;k=m;c[k>>2]=c[j>>2];c[k+4>>2]=l;k=e+28|0;l=g+28|0;c[k>>2]=0;j=e+32|0;c[j>>2]=0;c[e+36>>2]=0;c[k>>2]=c[l>>2];k=g+32|0;c[j>>2]=c[k>>2];j=g+36|0;c[e+36>>2]=c[j>>2];c[j>>2]=0;c[k>>2]=0;c[l>>2]=0}g=c[a>>2]|0;f=g+20|0;c[a>>2]=f}while((f|0)!=(c[b>>2]|0));return}function Ag(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;g=c[a>>2]|0;i=c[b>>2]|0;a:do if((g|0)!=(i|0)){while(1){h=c[d>>2]|0;if((h|0)==(c[e>>2]|0))break;if((c[g>>2]|0)<(c[h>>2]|0)){j=h;g=c[j+4>>2]|0;i=f;c[i>>2]=c[j>>2];c[i+4>>2]=g;i=f+8|0;g=h+8|0;c[i>>2]=0;j=f+12|0;c[j>>2]=0;c[f+16>>2]=0;c[i>>2]=c[g>>2];i=h+12|0;c[j>>2]=c[i>>2];h=h+16|0;c[f+16>>2]=c[h>>2];c[h>>2]=0;c[i>>2]=0;c[g>>2]=0;c[d>>2]=(c[d>>2]|0)+20;g=c[a>>2]|0}else{h=g;j=c[h+4>>2]|0;i=f;c[i>>2]=c[h>>2];c[i+4>>2]=j;i=f+8|0;j=g+8|0;c[i>>2]=0;h=f+12|0;c[h>>2]=0;c[f+16>>2]=0;c[i>>2]=c[j>>2];i=g+12|0;c[h>>2]=c[i>>2];g=g+16|0;c[f+16>>2]=c[g>>2];c[g>>2]=0;c[i>>2]=0;c[j>>2]=0;g=(c[a>>2]|0)+20|0;c[a>>2]=g}f=f+20|0;i=c[b>>2]|0;if((g|0)==(i|0))break a}if((g|0)==(i|0))return;while(1){d=g;j=c[d+4>>2]|0;e=f;c[e>>2]=c[d>>2];c[e+4>>2]=j;e=f+8|0;j=g+8|0;c[e>>2]=0;d=f+12|0;c[d>>2]=0;c[f+16>>2]=0;c[e>>2]=c[j>>2];e=g+12|0;c[d>>2]=c[e>>2];d=g+16|0;c[f+16>>2]=c[d>>2];c[d>>2]=0;c[e>>2]=0;c[j>>2]=0;g=(c[a>>2]|0)+20|0;c[a>>2]=g;if((g|0)==(c[b>>2]|0))break;else f=f+20|0}return}while(0);g=c[d>>2]|0;if((g|0)==(c[e>>2]|0))return;while(1){a=g;j=c[a+4>>2]|0;b=f;c[b>>2]=c[a>>2];c[b+4>>2]=j;b=f+8|0;j=g+8|0;c[b>>2]=0;a=f+12|0;c[a>>2]=0;c[f+16>>2]=0;c[b>>2]=c[j>>2];b=g+12|0;c[a>>2]=c[b>>2];a=g+16|0;c[f+16>>2]=c[a>>2];c[a>>2]=0;c[b>>2]=0;c[j>>2]=0;g=(c[d>>2]|0)+20|0;c[d>>2]=g;if((g|0)==(c[e>>2]|0))break;else f=f+20|0}return}function Bg(){var b=0,d=0,e=0,f=0,g=0,h=0,i=0;if((a[988384]|0)==0?Ru(988384)|0:0){e=Lj()|0;e=$u(e|0,D|0,1e3,0)|0;f=988392;c[f>>2]=e;c[f+4>>2]=D}if(!(c[247077]|0)){e=Lj()|0;e=$u(e|0,D|0,1e3,0)|0;f=988408;f=Vu(e|0,D|0,c[f>>2]|0,c[f+4>>2]|0)|0}else f=Xg(1163764)|0;b=988344;b=Yu(f|0,((f|0)<0)<<31>>31|0,c[b>>2]|0,c[b+4>>2]|0)|0;d=D;e=988392;e=Vu(b|0,d|0,c[e>>2]|0,c[e+4>>2]|0)|0;h=D;if((h|0)>0|(h|0)==0&e>>>0>999){h=988392;c[h>>2]=b;c[h+4>>2]=d;se()}if(c[247083]|0)return;b=c[247080]|0;i=b|c[247081]|c[247079];e=988336;d=c[e>>2]|0;e=c[e+4>>2]|0;h=c[247082]|0;if(!(((i|d|h|0)==0?(((i|0)<0)<<31>>31|e|((h|0)<0)<<31>>31|0)==0:0)?(f|0)>((c[247105]|0)+-10|0):0))g=12;if((g|0)==12?(b|0)==0|(f|0)<(b|0):0){if((d|0)==0&(e|0)==0)return;h=Xg(1163764)|0;f=D;i=988336;g=c[i+4>>2]|0;if(f>>>0<g>>>0|((f|0)==(g|0)?h>>>0<(c[i>>2]|0)>>>0:0))return}a[1233085]=1;return}function Cg(f,g,h,i,j,k,m){f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0;Ka=l;l=l+8944|0;o=Ka+8680|0;za=Ka;w=Ka+8936|0;ua=Ka+4540|0;va=Ka+440|0;Ba=c[f+5352>>2]|0;Da=f+5356|0;Aa=(c[Da>>2]|0)+64|0;Aa=(c[Aa>>2]|0)!=0|(c[Aa+4>>2]|0)!=0;wa=g+36|0;c[wa>>2]=0;xa=g+32|0;c[xa>>2]=0;Ja=g+8|0;c[Ja>>2]=(c[g+-32>>2]|0)+1;n=Ba+5556|0;do if(a[n>>0]&1){a[n>>0]=0;p=988336;n=c[p>>2]|0;p=c[p+4>>2]|0;if((n|0)==0&(p|0)==0){c[Ba+148>>2]=4095;break}else{r=$u(n|0,p|0,1024,0)|0;q=D;Fa=(q|0)<0|(q|0)==0&r>>>0<4096;r=Fa?r:4096;q=Ba+148|0;c[q>>2]=r;Fa=6;break}}else{r=Ba+148|0;q=r;r=c[r>>2]|0;Fa=6}while(0);if((Fa|0)==6?(c[q>>2]=r+-1,(r|0)<2):0){n=c[290941]|0;p=c[290942]|0;if((n|0)!=(p|0))do{a[(c[n>>2]|0)+5556>>0]=1;n=n+4|0}while((n|0)!=(p|0));Bg()}if(zd(f)|0){j=Ad(f,c[Ja>>2]|0,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;l=Ka;return j|0}if(((a[1233085]&1)==0?!(cg(f,c[Ja>>2]|0)|0):0)?(s=c[Ja>>2]|0,(s|0)<=127):0){ta=s+-32e3|0;ta=(ta|0)<(h|0)?h:ta;Ea=31999-s|0;Ea=(Ea|0)>(i|0)?i:Ea;if((ta|0)>=(Ea|0)){j=ta;l=Ka;return j|0}na=g+40|0;c[g+56>>2]=0;oa=g+12|0;c[oa>>2]=0;pa=g+4|0;c[pa>>2]=0;c[g+104>>2]=0;c[g+100>>2]=0;sa=g+-28|0;Ia=c[sa>>2]&63;qa=g+16|0;ra=c[qa>>2]|0;Ha=(c[Da>>2]|0)+56|0;Ga=c[Ha>>2]^ra;Ha=c[Ha+4>>2]^((ra|0)<0)<<31>>31;v=gh(1163804,Ga,Ha,w)|0;r=(a[w>>0]|0)==0;if(!r){n=b[v+4>>1]|0;p=n<<16>>16;q=c[Ja>>2]|0;do if(n<<16>>16!=32002)if(n<<16>>16>31743){u=p-q|0;break}else{u=(n<<16>>16<-31743?q:0)+p|0;break}else u=32002;while(0);n=b[v+2>>1]|0;t=n&65535;if(((u|0)!=32002?(a[v+9>>0]|0)>=(j|0):0)?(d[v+8>>0]&((u|0)>=(Ea|0)?2:1)|0)!=0:0){if(!(n<<16>>16)){j=u;l=Ka;return j|0}p=(u|0)<(Ea|0);o=t&49152;q=(o|0)==32768;a:do if((c[f+5364>>2]|0)==7){if(q)o=(t&12288|0)==4096?64:t>>>6&63;else o=t>>>6&63;n=t&63;if((c[f+(o<<2)>>2]&7|0)==6?(n>>>3|0)>=(o>>3|0):0){n=1;break}n=(c[f+(n<<2)>>2]|0)!=0}else{b:do if(q){n=t&12288;if((n|0)==4096){n=0;break a}n=n&16383;if(n<<16>>16<8192)switch(n<<16>>16){case 4096:{n=1;break a}default:break b}else switch(n<<16>>16){case 8192:{n=1;break a}default:break b}}else if(!o){n=(c[f+((t&63)<<2)>>2]|0)!=0;break a}while(0);n=(o|0)!=49152}while(0);if(p){if(n){j=u;l=Ka;return j|0}i=S(j+3|0,j+1|0)|0;h=2-i|0;o=c[f+5348>>2]|0;i=(h|0)>-1?h:i+-2|0;s=(i|0)>323;if(!s){if(q)n=(t&12288|0)==4096?64:t>>>6&63;else n=t>>>6&63;j=Ba+9656+(o*16640|0)+(n<<8)+((t&63)<<2)|0;Ja=c[j>>2]|0;c[j>>2]=Ja+(h<<5)+((S(Ja,i)|0)/-324|0)}n=t>>>6;if((t&61440|0)==36864)r=n&15;else r=c[f+((n&63)<<2)>>2]|0;q=t&63;o=c[g+-156>>2]|0;p=c[g+-76>>2]|0;n=c[g+-36>>2]|0;if(!(s|(n|0)==0)){j=n+(r<<8)+(q<<2)|0;g=c[j>>2]|0;c[j>>2]=g+(h<<5)+((S(g,i)|0)/-936|0)}if(!(s|(p|0)==0)){j=p+(r<<8)+(q<<2)|0;g=c[j>>2]|0;c[j>>2]=g+(h<<5)+((S(g,i)|0)/-936|0)}if(s|(o|0)==0){j=u;l=Ka;return j|0}j=o+(r<<8)+(q<<2)|0;g=c[j>>2]|0;c[j>>2]=g+(h<<5)+((S(g,i)|0)/-936|0);j=u;l=Ka;return j|0}else{if(!n)Ig(f,g,t,0,0,(S(j+2|0,j)|0)+-2|0);if((c[g+-4>>2]|0)!=1){j=u;l=Ka;return j|0}if(c[(c[Da>>2]|0)+72>>2]|0){j=u;l=Ka;return j|0}i=c[f+(Ia<<2)>>2]|0;h=S(j+3|0,j+1|0)|0;q=h+-2|0;h=2-h|0;r=c[g+-196>>2]|0;p=c[g+-116>>2]|0;n=c[g+-76>>2]|0;do if(n|0){o=(h|0)>-1?h:q;if((o|0)>323)break;j=n+(i<<8)+(Ia<<2)|0;g=c[j>>2]|0;c[j>>2]=g+(h<<5)+((S(g,o)|0)/-936|0)}while(0);do if(p|0){n=(h|0)>-1?h:q;if((n|0)>323)break;j=p+(i<<8)+(Ia<<2)|0;g=c[j>>2]|0;c[j>>2]=g+(h<<5)+((S(g,n)|0)/-936|0)}while(0);if(!r){j=u;l=Ka;return j|0}n=(h|0)>-1?h:q;if((n|0)>323){j=u;l=Ka;return j|0}j=r+(i<<8)+(Ia<<2)|0;g=c[j>>2]|0;c[j>>2]=g+(h<<5)+((S(g,n)|0)/-936|0);j=u;l=Ka;return j|0}}}else{u=32002;t=0}c:do if(!Aa){do if(!r){ma=b[v+6>>1]|0;n=ma<<16>>16;p=g+28|0;c[p>>2]=n;if(ma<<16>>16==32002){n=Id(f)|0;c[p>>2]=n}if((u|0)==32002)p=n;else p=(d[v+8>>0]&((u|0)>(n|0)?2:1)|0)==0?n:u}else{if((c[sa>>2]|0)==65)p=(c[12280+(c[f+5364>>2]<<2)>>2]<<1)-(c[g+-12>>2]|0)|0;else p=Id(f)|0;c[g+28>>2]=p;q=a[1163816]|0;r=av(Ga|0,Ha|0,48)|0;if((D|0)==0?(r|0)==(e[v>>1]|0):0){n=v+9|0;if(((a[n>>0]|0)+-4|0)>=-6)break}else{b[v+2>>1]=0;n=v+9|0}b[v>>1]=r;b[v+4>>1]=32002;b[v+6>>1]=p;a[v+8>>0]=q;a[n>>0]=-6}while(0);s=f+5364|0;n=c[s>>2]|0;if((n|0)==1){n=c[(c[Da>>2]|0)+48>>2]|0;if((n|0)!=64){h=f+256|0;la=h;la=Pf(f,n,c[la>>2]|0,c[la+4>>2]|0)|0;n=f+5348|0;r=f+320+(c[n>>2]<<3)|0;q=c[r>>2]|0;r=c[r+4>>2]|0;ma=f+264|0;if((q&la&c[ma>>2]|0)==0?(r&D&c[ma+4>>2]|0)==0:0)i=h;else break}else{n=f+5348|0;r=f+320+(c[n>>2]<<3)|0;i=f+256|0;q=c[r>>2]|0;r=c[r+4>>2]|0}while(1){if((q|0)==0&(r|0)==0)break;ma=Qa(q|0,r|0,0)|0;h=Yu(q|0,r|0,-1,-1)|0;r=D&r;la=i;la=Cb(c[f+(ma<<2)>>2]|0,ma,c[la>>2]|0,c[la+4>>2]|0)|0;ma=f+320+((c[n>>2]^1)<<3)|0;if(!((c[ma>>2]&la|0)==0?(c[ma+4>>2]&D|0)==0:0))break c;else q=h&q}n=c[s>>2]|0}if((n|0)==6){if(Te(f)|0|m)break}else if(m)break;do if((j|0)<4){n=c[12424+(c[s>>2]<<4)+(j<<2)>>2]|0;if((n+p|0)<=(ta|0))if((j|0)<2){j=Eg(f,g,ta,ta+1|0,0)|0;l=Ka;return j|0}else{Fa=ta-n|0;n=Eg(f,g,Fa,Fa+1|0,0)|0;if((n|0)>(Fa|0)){Fa=101;break}l=Ka;return n|0}else Fa=101}else if((j|0)<7)Fa=101;else n=c[s>>2]|0;while(0);if((Fa|0)==101){n=c[s>>2]|0;if(((p|0)<1e4?(p-(S(c[12316+(n<<2)>>2]|0,j)|0)|0)>=(Ea|0):0)?((n|0)==4?1:(c[(c[Da>>2]|0)+16+(c[f+5348>>2]<<2)>>2]|0)!=0):0){j=p;l=Ka;return j|0}}if((n|0)!=4){d:do if((p|0)>=(Ea|0)?!((j|0)<13?(c[g+28>>2]|0)<((S(j,-35)|0)+210+Ea|0):0):0){do if((n|0)==3){if((p|0)>=2e4)break d;if((j|0)<=4)break;if(c[f+4496+((c[f+5348>>2]^1)<<5)>>2]|0)break d}while(0);if(!(c[(c[Da>>2]|0)+16+(c[f+5348>>2]<<2)>>2]|0))break;c[oa>>2]=65;c[pa>>2]=0;r=(p-Ea|0)/188|0;Xf(f,za);r=(((j*67|0)+823|0)/-256|0)+j-((r|0)>3?3:r)|0;h=(r|0)<1;q=0-Ea|0;n=1-Ea|0;if(h)n=Eg(f,na,q,n,0)|0;else n=Cg(f,na,q,n,r,k^1,1)|0;p=0-n|0;Yf(f);if((Ea|0)>(p|0))break;n=(n|0)<-31743?Ea:p;do if((j|0)<12){if((((Ea|0)>-1?Ea:q)|0)>=1e4)break;l=Ka;return n|0}while(0);p=Ea+-1|0;if(h)p=Eg(f,g,p,Ea,0)|0;else p=Cg(f,g,p,Ea,r,0,1)|0;if((p|0)<(Ea|0))break;l=Ka;return n|0}while(0);n=c[s>>2]|0;if((n|0)!=1)Fa=122}else{n=4;Fa=122}if((Fa|0)==122){if((j|0)<5)break;if((((Ea|0)>-1?Ea:0-Ea|0)|0)<31744){q=(c[12568+(n<<2)>>2]|0)+Ea|0;q=(q|0)>32001?32001:q;r=j+-4|0;of(ua,f,t,q-(c[g+28>>2]|0)|0);n=rf(ua)|0;e:do if(n|0){h=0-q|0;i=1-q|0;s=k^1;while(1){if(Qf(f,n)|0){c[oa>>2]=n;p=n>>>6;if((n&61440|0)==36864)p=p&15;else p=c[f+((p&63)<<2)>>2]|0;c[pa>>2]=Ba+42936+(p<<18)+((n&63)<<12);Tf(f,n,za,Rf(f,n)|0);p=0-(Cg(f,na,h,i,r,s,0)|0)|0;Vf(f,n);if((q|0)<=(p|0))break}n=rf(ua)|0;if(!n)break e}j=p;l=Ka;return j|0}while(0)}}if(!((j|0)<6|(t|0)!=0))if(((c[g+28>>2]|0)+256|0)>=(Ea|0)){Cg(f,g,ta,Ea,((j*3|0)/4|0)+-2|0,k,1)|0;n=gh(1163804,Ga,Ha,w)|0;if(!(a[w>>0]|0)){v=n;t=0}else{v=n;t=e[n+2>>1]|0}}else t=0}else c[g+28>>2]=32002;while(0);ha=c[g+-36>>2]|0;la=g+-76|0;ia=c[la>>2]|0;ja=c[g+-156>>2]|0;mf(ua,f,t,j,g);ma=g+28|0;n=c[g+-52>>2]|0;n=(n|0)==32002?1:(c[ma>>2]|0)>=(n|0);ka=(ra|0)!=0;if(!(ka|(u|0)!=32002&((j|0)>7&(t|0)!=0)^1)?(x=b[v+8>>1]|0,(x&2)!=0):0)da=(((x&65535)>>>8&65535)<<24>>24|0)>=(j+-3|0);else da=0;r=rf(ua)|0;f:do if(r){ea=f+5364|0;fa=f+5348|0;ga=(j|0)<16;ba=n&1;ca=1098088+(ba<<6)+(j<<2)|0;I=u-(j<<1)|0;I=(I|0)<-32e3?-32e3:I;J=(j|0)/2|0;K=I+-1|0;L=j+-1|0;M=(j|0)>6;N=S(j,-248)|0;O=f+256|0;H=(j|0)>63?63:j;P=(ha|0)!=0;Q=(ia|0)!=0;R=(ja|0)==0;aa=P&Q;T=(j|0)>2;U=~ta;V=0-ta|0;W=(ha|0)==0;X=(ia|0)==0;Y=g+-8|0;Z=k^1;_=va+4096|0;$=va;n=-32001;p=0;h=0;g:while(1){h:do if((r|0)!=(ra|0)){G=p+1|0;c[wa>>2]=G;s=c[ea>>2]|0;u=r&49152;F=(u|0)==32768;i:do if((s|0)==7){if(F)i=(r&12288|0)==4096?64:r>>>6&63;else i=r>>>6&63;q=r&63;if((c[f+(i<<2)>>2]&7|0)==6?(q>>>3|0)>=(i>>3|0):0){y=1;break}y=(c[f+(q<<2)>>2]|0)!=0}else{j:do if(F){q=r&12288;if((q|0)==4096){y=0;break i}q=q&16383;if(q<<16>>16<8192)switch(q<<16>>16){case 4096:{y=1;break i}default:break j}else switch(q<<16>>16){case 8192:{y=1;break i}default:break j}}else if(!u){y=(c[f+((r&63)<<2)>>2]|0)!=0;break i}while(0);y=(u|0)!=49152}while(0);m=(r&61440|0)==36864;C=r>>>6;if(m)A=C&15;else A=c[f+((C&63)<<2)>>2]|0;z=(u|0)==0;if(z?(B=c[fa>>2]|0,ya=c[Da>>2]|0,E=ya+344+((B^1)<<3)|0,B=f+320+(B<<3)|0,!((c[B>>2]&c[E>>2]|0?1:(c[B+4>>2]&c[E+4>>2]|0)!=0)|(s+-1|0)>>>0<2)):0){i=ya+376+((c[f+((C&63)<<2)>>2]&7)<<3)|0;E=30544+((r&63)<<3)|0;q=c[E>>2]&c[i>>2];i=c[E+4>>2]&c[i+4>>2]}else{q=(Rf(f,r)|0)&1;i=0}E=(q|0)!=0|(i|0)!=0;if(ga)x=(G|0)>=(c[ca>>2]|0);else x=0;if(x|E^1)q=0;else q=($f(f,r,0)|0)&1;k:do if(!(x|(c[ea>>2]|0)!=1)){l:do if((u|0)==49152?1:(c[f+((r&63)<<2)>>2]|0)==0){if(!F)break k;i=r&12288;if(i<<16>>16<8192)switch(i<<16>>16){case 4096:break k;default:break l}else switch(i<<16>>16){case 8192:break k;default:break l}}while(0);B=kf(f,va)|0;c[_>>2]=B;q=(B-$|0)==8?1:q}while(0);do if(da){if((r|0)!=(t|0)|(q|0)!=0)break;if(!(Qf(f,t)|0)){q=0;break}c[qa>>2]=t;q=Cg(f,g,K,I,J,k,1)|0;c[qa>>2]=0;q=(q|0)<(I|0)&1}while(0);B=L+q|0;i=c[ea>>2]|0;if((A&7|0)==6&(i|0)==7){if(F)s=(r&12288|0)==4096?64:C&63;else s=C&63;if((n|0)>-31744&(r>>>3&7|0)<=(s>>3|0))Fa=183}else if((n|0)>-31744)Fa=183;m:do if((Fa|0)==183){Fa=0;n:do if(!(y|E)){if((i|0)==1){u=O;u=Pf(f,r&63,c[u>>2]|0,c[u+4>>2]|0)|0;w=f+320+((c[fa>>2]^1)<<3)|0;if(!((c[w>>2]&u|0)==0?(c[w+4>>2]&D|0)==0:0))break;s=c[ea>>2]|0}else s=i;do if((s|0)!=4){if(m)i=C&15;else i=c[f+((C&63)<<2)>>2]|0;i=i&7;do if((s|0)==7){if((i|0)!=6)break;if(F)i=(r&12288|0)==4096?64:C&63;else i=C&63;if((i>>3|0)>3)break n}else{if((i|0)!=1)break;if(F)i=(r&12288|0)==4096?64:C&63;else i=C&63;if((i>>3^(c[fa>>2]|0)*7|0)>3)break n}while(0);if(m)i=C&15;else i=c[f+((C&63)<<2)>>2]|0;i=i&7;if((s|0)==7){if((i|0)!=6)break;if(F)i=(r&12288|0)==4096?64:C&63;else i=C&63;if((i>>3|0)<=3)break}else{if((i|0)!=1)break;if(F)i=(r&12288|0)==4096?64:C&63;else i=C&63;if((i>>3^(c[fa>>2]|0)*7|0)<=3)break}w=c[Da>>2]|0;if(((c[w+20>>2]|0)+(c[w+16>>2]|0)|0)<=4999)break n}while(0);if(x){p=G;break h}q=B-(c[1130984+(ba<<14)+(H<<8)+(((G|0)>63?63:G)<<2)>>2]|0)|0;q=(q|0)<0?0:q;do if((q|0)<3){if(P?(c[ha+(A<<8)+((r&63)<<2)>>2]|0)>=0:0)break;if(Q?(c[ia+(A<<8)+((r&63)<<2)>>2]|0)>=0:0)break;if(R){p=G;break h}if(aa|(c[ja+(A<<8)+((r&63)<<2)>>2]|0)<0){p=G;break h}}while(0);if(!(Aa|(q|0)>6)?((c[12352+(s<<3)>>2]|0)+(c[ma>>2]|0)+(S(c[12352+(s<<3)+4>>2]|0,q)|0)|0)<=(ta|0):0){p=G;break h}if((s|0)==1)break m;if(!((q|0)<8&(s|0)!=7))break m;if($f(f,r,S(S(q,-35)|0,q)|0)|0)break m;else{p=G;break h}}while(0);if(M|(q|0)!=0)break;if(!($f(f,r,N)|0)){p=G;break h}}while(0);if(!(Qf(f,r)|0)){c[wa>>2]=p;break}c[oa>>2]=r;m=r&63;c[pa>>2]=Ba+42936+(A<<18)+(m<<12);Tf(f,r,za,E);w=y^1;if(T&(p|0)>0&(x|w)){p=c[1130984+(ba<<14)+(H<<8)+(((G|0)>63?63:G)<<2)>>2]|0;if(y)p=p-((p|0)!=0&1)|0;else{do if(k)p=p+2|0;else{if(!z)break;z=$f(f,m<<6|C&63,0)|0;p=z?p:p+-2|0}while(0);if(W)s=0;else s=c[ha+(A<<8)+(m<<2)>>2]|0;if(X)u=0;else u=c[ia+(A<<8)+(m<<2)>>2]|0;if(R)i=0;else i=c[ja+(A<<8)+(m<<2)>>2]|0;if(F)q=(r&12288|0)==4096?64:C&63;else q=C&63;q=u+s+i+(c[Ba+9656+((c[fa>>2]^1)*16640|0)+(q<<8)+(m<<2)>>2]|0)|0;i=q+-4e3|0;c[xa>>2]=i;do if((q|0)>4e3)p=p+(c[Y>>2]>>31)|0;else{if((q|0)==4e3)break;p=((c[Y>>2]|0)>0&1)+p|0}while(0);p=p-((i|0)/2e4|0)|0;p=(p|0)>0?p:0}F=B-p|0;F=(F|0)<1?1:F;p=0-(Cg(f,na,U,V,F,1,0)|0)|0;if(!((ta|0)<(p|0)&(F|0)!=(B|0)))q=p;else Fa=257}else Fa=257;do if((Fa|0)==257){Fa=0;if((B|0)>=1){q=0-(Cg(f,na,U,V,B,Z,0)|0)|0;break}if(E){q=0-(Dg(f,na,U,V,0)|0)|0;break}else{q=0-(Eg(f,na,U,V,0)|0)|0;break}}while(0);Vf(f,r);if(a[1233085]&1){n=0;break f}if((q|0)>(n|0))if((q|0)>(ta|0)){p=G;n=q;break g}else n=q;if(!((h|0)<64&w)){p=G;break}c[o+(h<<2)>>2]=r;p=G;h=h+1|0}while(0);r=rf(ua)|0;if(!r){r=0;break}}if(p){if(!r){if((j|0)<3){h=0;Fa=321;break}if(c[(c[Da>>2]|0)+72>>2]|0){h=0;Fa=321;break}o=c[sa>>2]|0;if((o&49152|0)==32768)p=(o&12288|0)==4096?64:o>>>6&63;else p=o>>>6&63;if((p|0)==(o&63|0)){h=r;Fa=321;break}t=c[f+(Ia<<2)>>2]|0;h=S(j+2|0,j)|0;s=h+-2|0;i=c[g+-196>>2]|0;q=c[g+-116>>2]|0;o=c[la>>2]|0;do if(o|0){p=(s|0)>-1?s:2-h|0;if((p|0)>323)break;g=o+(t<<8)+(Ia<<2)|0;f=c[g>>2]|0;c[g>>2]=f+(s<<5)+((S(f,p)|0)/-936|0)}while(0);do if(q|0){o=(s|0)>-1?s:2-h|0;if((o|0)>323)break;g=q+(t<<8)+(Ia<<2)|0;f=c[g>>2]|0;c[g>>2]=f+(s<<5)+((S(f,o)|0)/-936|0)}while(0);if(!i){h=r;Fa=321;break}o=(s|0)>-1?s:2-h|0;if((o|0)>323){h=r;Fa=321;break}h=i+(t<<8)+(Ia<<2)|0;Fa=c[h>>2]|0;c[h>>2]=Fa+(s<<5)+((S(Fa,o)|0)/-936|0);h=r;Fa=321;break}p=r&49152;q=(p|0)==32768;do if((c[f+5364>>2]|0)==7){if(q)q=(r&12288|0)==4096?64:r>>>6&63;else q=r>>>6&63;p=r&63;if((c[f+(q<<2)>>2]&7|0)==6?(p>>>3|0)>=(q>>3|0):0)break;if(!(c[f+(p<<2)>>2]|0))Fa=294}else{if(q){if((r&12288|0)!=4096)break;Fa=294;break}if(!p)if(!(c[f+((r&63)<<2)>>2]|0)){Fa=294;break}else break;else if((p|0)==49152){Fa=294;break}else break}while(0);if((Fa|0)==294)Ig(f,g,r,o,h,(S(j+2|0,j)|0)+-2|0);if((c[g+-4>>2]|0)==1?(c[(c[Da>>2]|0)+72>>2]|0)==0:0){i=c[f+(Ia<<2)>>2]|0;s=S(j+3|0,j+1|0)|0;q=s+-2|0;s=2-s|0;h=c[g+-196>>2]|0;p=c[g+-116>>2]|0;o=c[la>>2]|0;if(o|0?(Ca=(s|0)>-1?s:q,(Ca|0)<=323):0){g=o+(i<<8)+(Ia<<2)|0;f=c[g>>2]|0;c[g>>2]=f+(s<<5)+((S(f,Ca)|0)/-936|0)}do if(p|0){o=(s|0)>-1?s:q;if((o|0)>323)break;g=p+(i<<8)+(Ia<<2)|0;f=c[g>>2]|0;c[g>>2]=f+(s<<5)+((S(f,o)|0)/-936|0)}while(0);if(h){o=(s|0)>-1?s:q;if((o|0)>323){h=r;Fa=321;break}h=h+(i<<8)+(Ia<<2)|0;Fa=c[h>>2]|0;c[h>>2]=Fa+(s<<5)+((S(Fa,o)|0)/-936|0);h=r;Fa=321}else{h=r;Fa=321}}else{h=r;Fa=321}}else Fa=268}else{r=0;Fa=268}while(0);do if((Fa|0)==268)if(!ka){g=zd(f)|0;q=c[Ja>>2]|0;if(g){h=r;n=Ad(f,q,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;Fa=321;break}if(Aa){h=r;n=(c[f+5364>>2]|0)==6?32e3-q|0:q+-32e3|0;Fa=321;break}n=c[f+5348>>2]|0;p=c[1098080+(n<<2)>>2]|0;o=c[f+5364>>2]|0;if((o|0)!=1){h=r;n=(o|0)==6?32e3-q|0:p;Fa=321;break}if((c[f+5368>>2]|0)!=9){h=r;n=32e3-q|0;Fa=321;break}n=n<<3;n=(c[f+336+(n<<2)>>2]|0)-(c[f+336+((n^8)<<2)>>2]|0)|0;if((n|0)>0){h=r;n=q+-32e3|0;Fa=321;break}else{h=r;n=n|0?32e3-q|0:p;Fa=321;break}}else{h=r;n=ta;Fa=321}while(0);do if((Fa|0)==321){o=c[Ja>>2]|0;if((n|0)>31743)u=o+n|0;else u=n-((n|0)<-31743?o:0)|0;t=(n|0)>=(Ea|0)?2:1;i=c[ma>>2]|0;s=a[1163816]|0;if(!h){q=av(Ga|0,Ha|0,48)|0;p=D;o=b[v>>1]|0;if((q|0)==(o&65535|0)&(p|0)==0){r=v;h=o}else{r=v;Fa=327}}else{o=b[v>>1]|0;q=av(Ga|0,Ha|0,48)|0;r=v;p=D;Fa=327}if((Fa|0)==327){b[v+2>>1]=h;h=o}o=v+9|0;if((q|0)==(h&65535|0)&(p|0)==0?((a[o>>0]|0)+-4|0)>=(j|0):0)break;b[r>>1]=q;b[v+4>>1]=u;b[v+6>>1]=i;a[v+8>>0]=s&255|t;a[o>>0]=j}while(0);j=n;l=Ka;return j|0}if(Aa|(c[Ja>>2]|0)<128){j=c[1098080+(c[f+5348>>2]<<2)>>2]|0;l=Ka;return j|0}else{j=Id(f)|0;l=Ka;return j|0}return 0}function Dg(f,g,h,i,j){f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0;I=l;l=l+4592|0;z=I;m=I+4580|0;A=I+440|0;B=g+12|0;c[B>>2]=0;y=g+8|0;c[y>>2]=(c[g+-32>>2]|0)+1;H=zd(f)|0;k=c[y>>2]|0;if(H){H=Ad(f,k,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;l=I;return H|0}if(!(cg(f,k)|0)?(c[y>>2]|0)<=127:0){x=f+5356|0;G=(c[x>>2]|0)+56|0;F=c[G>>2]|0;G=c[G+4>>2]|0;H=gh(1163804,F,G,m)|0;if(a[m>>0]|0){o=e[H+2>>1]|0;k=b[H+4>>1]|0;m=k<<16>>16;n=c[y>>2]|0;if(k<<16>>16!=32002){if(k<<16>>16>31743)k=m-n|0;else k=(k<<16>>16<-31743?n:0)+m|0;if((k|0)!=32002&(a[H+9>>0]|0)>-1?(d[H+8>>0]&((k|0)>=(i|0)?2:1)|0)!=0:0){H=k;l=I;return H|0}else k=o}else k=o}else k=0;w=g+28|0;c[w>>2]=32002;nf(A,f,k,j,c[g+-28>>2]&63);v=f+5364|0;t=g+40|0;r=0-i|0;s=0-h|0;j=j+-1|0;p=f+5348|0;k=-32001;a:while(1){m=rf(A)|0;if(!m){E=46;break}q=(k|0)>-31744;u=m;while(1){m=c[v>>2]|0;g=u&49152;if((m|0)==7){if((g|0)==32768)m=(u&12288|0)==4096?64:u>>>6&63;else m=u>>>6&63;if((c[f+(m<<2)>>2]&7|0)==6)o=(u&56|0)==56;else o=0}else{if((g|0)==0?(o=c[p>>2]|0,C=c[x>>2]|0,i=C+344+((o^1)<<3)|0,o=f+320+(o<<3)|0,!((c[o>>2]&c[i>>2]|0?1:(c[o+4>>2]&c[i+4>>2]|0)!=0)|(m+-1|0)>>>0<2)):0){n=C+376+((c[f+((u>>>6&63)<<2)>>2]&7)<<3)|0;i=30544+((u&63)<<3)|0;m=c[i>>2]&c[n>>2];n=c[i+4>>2]&c[n+4>>2]}else{m=(Rf(f,u)|0)&1;n=0}o=(m|0)!=0|(n|0)!=0}b:do if(q?((g|0)==49152?1:(c[f+((u&63)<<2)>>2]|0)==0):0){m=g&65535;c:do if(m<<16>>16<16384){switch(m<<16>>16){case -32768:break;default:break c}m=u&12288;n=m&16383;if(n<<16>>16<8192)switch(n<<16>>16){case 4096:break;default:{E=34;break b}}else switch(n<<16>>16){case 8192:break;default:{E=34;break b}}if((m|0)==8192){E=34;break b}}else switch(m<<16>>16){case 16384:{E=34;break b}default:{}}while(0);if($f(f,u,0)|0)E=34}else E=34;while(0);if((E|0)==34?(E=0,Qf(f,u)|0):0){c[B>>2]=u;Tf(f,u,z,o);if(o)m=Dg(f,t,r,s,j)|0;else m=Eg(f,t,r,s,j)|0;i=0-m|0;Vf(f,u);if((k|0)<(i|0))break}m=rf(A)|0;if(!m){E=46;break a}else u=m}if((i|0)>(h|0)){E=40;break}else k=i}do if((E|0)==40){k=c[y>>2]|0;if((m|0)<-31743)g=k-m|0;else g=i-((m|0)>31743?k:0)|0;n=c[w>>2]|0;o=a[1163816]|0;E=b[H>>1]|0;m=av(F|0,G|0,48)|0;b[H+2>>1]=u;k=H+9|0;if((m|0)==(E&65535|0)&(D|0)==0?(a[k>>0]|0)>=4:0){k=i;break}b[H>>1]=m;b[H+4>>1]=g;b[H+6>>1]=n;a[H+8>>0]=o&255|2;a[k>>0]=0;k=i}else if((E|0)==46){m=c[y>>2]|0;if((k|0)==-32001){k=(c[v>>2]|0)==6?32e3-m|0:m+-32e3|0;break}if((k|0)>31743)i=m+k|0;else i=k-((k|0)<-31743?m:0)|0;o=c[w>>2]|0;g=a[1163816]|0;n=av(F|0,G|0,48)|0;if((D|0)==0?(n|0)==(e[H>>1]|0):0){m=H+9|0;if((a[m>>0]|0)>=4)break}else{b[H+2>>1]=0;m=H+9|0}b[H>>1]=n;b[H+4>>1]=i;b[H+6>>1]=o;a[H+8>>0]=g&255|1;a[m>>0]=0}while(0);H=k;l=I;return H|0}H=c[1098080+(c[f+5348>>2]<<2)>>2]|0;l=I;return H|0}function Eg(f,g,h,i,j){f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=l;l=l+4592|0;C=M;p=M+4580|0;E=M+440|0;F=g+12|0;c[F>>2]=0;G=g+8|0;c[G>>2]=(c[g+-32>>2]|0)+1;L=zd(f)|0;k=c[G>>2]|0;if(L){L=Ad(f,k,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;l=M;return L|0}L=cg(f,k)|0;k=(c[G>>2]|0)>127;if(L){if(!k){L=c[1098080+(c[f+5348>>2]<<2)>>2]|0;l=M;return L|0}}else if(!k){K=j>>31;A=f+5356|0;J=(c[A>>2]|0)+56|0;I=c[J>>2]|0;J=c[J+4>>2]|0;L=gh(1163804,I,J,p)|0;if(a[p>>0]|0){o=e[L+2>>1]|0;k=b[L+4>>1]|0;m=k<<16>>16;n=c[G>>2]|0;if(k<<16>>16!=32002){if(k<<16>>16>31743)k=m-n|0;else k=(k<<16>>16<-31743?n:0)+m|0;if(((k|0)!=32002?(a[L+9>>0]|0)>=(K|0):0)?(d[L+8>>0]&((k|0)>=(i|0)?2:1)|0)!=0:0){L=k;l=M;return L|0}}else k=32002;z=b[L+6>>1]|0;m=z<<16>>16;n=g+28|0;c[n>>2]=m;if(z<<16>>16==32002){m=Id(f)|0;c[n>>2]=m}if((k|0)==32002){k=m;q=m;m=o}else{k=(d[L+8>>0]&((k|0)>(m|0)?2:1)|0)==0?m:k;q=m;m=o}}else{if((c[g+-28>>2]|0)==65)m=(c[12280+(c[f+5364>>2]<<2)>>2]<<1)-(c[g+-12>>2]|0)|0;else m=Id(f)|0;c[g+28>>2]=m;k=m;q=m;m=0}if((k|0)>=(i|0)){if(a[p>>0]|0){L=k;l=M;return L|0}n=(c[A>>2]|0)+56|0;m=c[G>>2]|0;if((k|0)>31743)p=m+k|0;else p=k-((k|0)<-31743?m:0)|0;o=a[1163816]|0;n=av(c[n>>2]|0,c[n+4>>2]|0,48)|0;if((D|0)==0?(n|0)==(e[L>>1]|0):0){m=L+9|0;if(((a[m>>0]|0)+-4|0)>=-6){L=k;l=M;return L|0}}else{b[L+2>>1]=0;m=L+9|0}b[L>>1]=n;b[L+4>>1]=p;b[L+6>>1]=q;a[L+8>>0]=o&255|2;a[m>>0]=-6;L=k;l=M;return L|0}z=k+128|0;nf(E,f,m,j,c[g+-28>>2]&63);m=rf(E)|0;a:do if(!m)H=85;else{x=f+5364|0;y=g+40|0;v=0-i|0;w=0-h|0;r=j+-1|0;i=(z|0)>-1e4;s=(z|0)>(h|0);t=f+5348|0;j=i^1;i=i^1;while(1){u=m;b:while(1){m=c[x>>2]|0;p=u&49152;if((m|0)==7){if((p|0)==32768)m=(u&12288|0)==4096?64:u>>>6&63;else m=u>>>6&63;m=(u&56|0)==56?(c[f+(m<<2)>>2]&7|0)==6:0;if(m|j)n=m;else{o=7;H=46}}else{if((p|0)==0?(o=c[t>>2]|0,B=c[A>>2]|0,q=B+344+((o^1)<<3)|0,o=f+320+(o<<3)|0,!((c[o>>2]&c[q>>2]|0?1:(c[o+4>>2]&c[q+4>>2]|0)!=0)|(m+-1|0)>>>0<2)):0){n=B+376+((c[f+((u>>>6&63)<<2)>>2]&7)<<3)|0;q=30544+((u&63)<<3)|0;m=c[q>>2]&c[n>>2];n=c[q+4>>2]&c[n+4>>2]}else{m=(Rf(f,u)|0)&1;n=0}m=(m|0)!=0|(n|0)!=0;if(m|i)n=m;else{o=c[x>>2]|0;H=46}}do if((H|0)==46){H=0;n=u>>>6;if((u&61440|0)==36864)m=n&15;else m=c[f+((n&63)<<2)>>2]|0;m=m&7;if((o|0)==7)if((m|0)==6){if((p|0)==32768)m=(u&12288|0)==4096?64:n&63;else m=n&63;if((m>>3|0)>3){n=0;break}else H=62}else H=62;else{if((m|0)==1){if((p|0)==32768)m=(u&12288|0)==4096?64:n&63;else m=n&63;if((m>>3^(c[t>>2]|0)*7|0)>3){n=0;break}}if((o|0)==2)m=_f(f,u)|0;else H=62}if((H|0)==62)m=c[11108+(o<<7)+64+(c[f+((u&63)<<2)>>2]<<2)>>2]<<((o|0)==3&1);m=m+z|0;if((m|0)<=(h|0)){H=64;break b}if(!s?!($f(f,u,1)|0):0){H=67;break b}else n=0}while(0);m=p&65535;c:do if(m<<16>>16<16384){switch(m<<16>>16){case -32768:break;default:{H=70;break c}}if((u&12288|0)==8192)H=72;else H=70}else switch(m<<16>>16){case 16384:{H=72;break}default:H=70}while(0);if((H|0)==70?(H=0,$f(f,u,0)|0):0)H=72;if((H|0)==72?(H=0,Qf(f,u)|0):0){c[F>>2]=u;Tf(f,u,C,n);if(n)m=Dg(f,y,v,w,r)|0;else m=Eg(f,y,v,w,r)|0;q=0-m|0;Vf(f,u);if((k|0)<(q|0)){H=77;break}}m=rf(E)|0;if(!m){H=85;break a}else u=m}if((H|0)==64){H=0;k=(k|0)<(m|0)?m:k}else if((H|0)==67){H=0;k=(k|0)<(z|0)?z:k}else if((H|0)==77){H=0;if((q|0)>(h|0))break;else k=q}m=rf(E)|0;if(!m){H=85;break a}}k=c[G>>2]|0;if((m|0)<-31743)p=k-m|0;else p=q-((m|0)>31743?k:0)|0;n=c[g+28>>2]|0;o=a[1163816]|0;g=b[L>>1]|0;m=av(I|0,J|0,48)|0;b[L+2>>1]=u;k=L+9|0;if((m|0)==(g&65535|0)&(D|0)==0?((a[k>>0]|0)+-4|0)>=(K|0):0){k=q;break}b[L>>1]=m;b[L+4>>1]=p;b[L+6>>1]=n;a[L+8>>0]=o&255|2;a[k>>0]=K;k=q}while(0);do if((H|0)==85){m=c[G>>2]|0;if((k|0)>31743)q=m+k|0;else q=k-((k|0)<-31743?m:0)|0;o=c[g+28>>2]|0;p=a[1163816]|0;n=av(I|0,J|0,48)|0;if((D|0)==0?(n|0)==(e[L>>1]|0):0){m=L+9|0;if(((a[m>>0]|0)+-4|0)>=(K|0))break}else{b[L+2>>1]=0;m=L+9|0}b[L>>1]=n;b[L+4>>1]=q;b[L+6>>1]=o;a[L+8>>0]=p&255|1;a[m>>0]=K}while(0);L=k;l=M;return L|0}L=Id(f)|0;l=M;return L|0}function Fg(d,f,g,h,i){d=d|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;M=l;l=l+5104|0;B=M;k=M+5096|0;E=M+440|0;F=f+40|0;c[F>>2]=M+4580;c[c[f>>2]>>2]=0;y=f+12|0;c[y>>2]=0;A=f+8|0;c[A>>2]=(c[f+-32>>2]|0)+1;L=zd(d)|0;j=c[A>>2]|0;if(L){L=Ad(d,j,c[1098080+(c[d+5348>>2]<<2)>>2]|0)|0;l=M;return L|0}if(!(cg(d,j)|0)?(c[A>>2]|0)<=127:0){x=d+5356|0;J=(c[x>>2]|0)+56|0;I=c[J>>2]|0;J=c[J+4>>2]|0;L=gh(1163804,I,J,k)|0;if(!(a[k>>0]|0))j=0;else j=e[L+2>>1]|0;H=f+28|0;c[H>>2]=32002;nf(E,d,j,i,c[f+-28>>2]&63);v=d+5364|0;u=0-h|0;s=i+-1|0;t=d+5348|0;p=g;G=0;j=-32001;a:while(1){q=0-p|0;while(1){k=rf(E)|0;if(!k){K=46;break a}o=(j|0)>-31744;w=k;while(1){k=c[v>>2]|0;n=w&49152;if((k|0)==7){if((n|0)==32768)k=(w&12288|0)==4096?64:w>>>6&63;else k=w>>>6&63;if((c[d+(k<<2)>>2]&7|0)==6)m=(w&56|0)==56;else m=0}else{if((n|0)==0?(m=c[t>>2]|0,C=c[x>>2]|0,r=C+344+((m^1)<<3)|0,m=d+320+(m<<3)|0,!((c[m>>2]&c[r>>2]|0?1:(c[m+4>>2]&c[r+4>>2]|0)!=0)|(k+-1|0)>>>0<2)):0){i=C+376+((c[d+((w>>>6&63)<<2)>>2]&7)<<3)|0;r=30544+((w&63)<<3)|0;k=c[r>>2]&c[i>>2];i=c[r+4>>2]&c[i+4>>2]}else{k=(Rf(d,w)|0)&1;i=0}m=(k|0)!=0|(i|0)!=0}b:do if(o?((n|0)==49152?1:(c[d+((w&63)<<2)>>2]|0)==0):0){k=n&65535;c:do if(k<<16>>16<16384){switch(k<<16>>16){case -32768:break;default:break c}k=w&12288;i=k&16383;if(i<<16>>16<8192)switch(i<<16>>16){case 4096:break;default:{K=30;break b}}else switch(i<<16>>16){case 8192:break;default:{K=30;break b}}if((k|0)==8192){K=30;break b}}else switch(k<<16>>16){case 16384:{K=30;break b}default:{}}while(0);if($f(d,w,0)|0)K=30}else K=30;while(0);if((K|0)==30?(K=0,Qf(d,w)|0):0){c[y>>2]=w;Tf(d,w,B,m);if(m)m=Fg(d,F,u,q,s)|0;else m=Gg(d,F,u,q,s)|0;r=0-m|0;Vf(d,w);if((j|0)<(r|0))break}k=rf(E)|0;if(!k){K=46;break a}else w=k}if((p|0)<(r|0))break;else j=r}j=c[f>>2]|0;k=c[F>>2]|0;c[j>>2]=w;j=j+4|0;if((k|0)!=0?(z=c[k>>2]|0,(z|0)!=0):0){i=z;do{k=k+4|0;c[j>>2]=i;j=j+4|0;i=c[k>>2]|0}while((i|0)!=0)}c[j>>2]=0;if((r|0)<(h|0)){p=r;G=w;j=r}else{K=40;break}}do if((K|0)==40){j=c[A>>2]|0;if((m|0)<-31743)n=j-m|0;else n=r-((m|0)>31743?j:0)|0;i=c[H>>2]|0;m=a[1163816]|0;K=b[L>>1]|0;k=av(I|0,J|0,48)|0;b[L+2>>1]=w;j=L+9|0;if((k|0)==(K&65535|0)&(D|0)==0?(a[j>>0]|0)>=4:0){j=r;break}b[L>>1]=k;b[L+4>>1]=n;b[L+6>>1]=i;a[L+8>>0]=m&255|2;a[j>>0]=0;j=r}else if((K|0)==46){k=c[A>>2]|0;if((j|0)==-32001){j=(c[v>>2]|0)==6?32e3-k|0:k+-32e3|0;break}if((j|0)>31743)t=k+j|0;else t=j-((j|0)<-31743?k:0)|0;r=(j|0)>(g|0);s=r?3:1;p=c[H>>2]|0;q=a[1163816]|0;if(!G){m=av(I|0,J|0,48)|0;i=D;k=b[L>>1]|0;if((m|0)==(k&65535|0)&(i|0)==0){n=L;o=k}else{n=L;K=54}}else{k=b[L>>1]|0;m=av(I|0,J|0,48)|0;n=L;i=D;K=54}if((K|0)==54){b[L+2>>1]=G;o=k}k=L+9|0;if((m|0)==(o&65535|0)&(i|0)==0?!(r|(a[k>>0]|0)<4):0)break;b[n>>1]=m;b[L+4>>1]=t;b[L+6>>1]=p;a[L+8>>0]=q&255|s;a[k>>0]=0}while(0);L=j;l=M;return L|0}L=c[1098080+(c[d+5348>>2]<<2)>>2]|0;l=M;return L|0}function Gg(f,g,h,i,j){f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;Q=l;l=l+5104|0;H=Q;p=Q+5096|0;I=Q+440|0;J=g+40|0;c[J>>2]=Q+4580;c[c[g>>2]>>2]=0;E=g+12|0;c[E>>2]=0;K=g+8|0;c[K>>2]=(c[g+-32>>2]|0)+1;P=zd(f)|0;k=c[K>>2]|0;if(P){P=Ad(f,k,c[1098080+(c[f+5348>>2]<<2)>>2]|0)|0;l=Q;return P|0}P=cg(f,k)|0;k=(c[K>>2]|0)>127;if(P){if(!k){P=c[1098080+(c[f+5348>>2]<<2)>>2]|0;l=Q;return P|0}}else if(!k){O=j>>31;C=f+5356|0;M=(c[C>>2]|0)+56|0;L=c[M>>2]|0;M=c[M+4>>2]|0;P=gh(1163804,L,M,p)|0;if(a[p>>0]|0){o=e[P+2>>1]|0;k=b[P+4>>1]|0;m=k<<16>>16;n=c[K>>2]|0;do if(k<<16>>16!=32002)if(k<<16>>16>31743){n=m-n|0;break}else{n=(k<<16>>16<-31743?n:0)+m|0;break}else n=32002;while(0);B=b[P+6>>1]|0;m=B<<16>>16;k=g+28|0;c[k>>2]=m;if(B<<16>>16==32002){m=Id(f)|0;c[k>>2]=m}if((n|0)==32002){k=m;q=m;m=o}else{k=(d[P+8>>0]&((n|0)>(m|0)?2:1)|0)==0?m:n;q=m;m=o}}else{if((c[g+-28>>2]|0)==65)m=(c[12280+(c[f+5364>>2]<<2)>>2]<<1)-(c[g+-12>>2]|0)|0;else m=Id(f)|0;c[g+28>>2]=m;k=m;q=m;m=0}if((k|0)>=(i|0)){if(a[p>>0]|0){P=k;l=Q;return P|0}n=(c[C>>2]|0)+56|0;m=c[K>>2]|0;if((k|0)>31743)o=m+k|0;else o=k-((k|0)<-31743?m:0)|0;p=a[1163816]|0;n=av(c[n>>2]|0,c[n+4>>2]|0,48)|0;if((D|0)==0?(n|0)==(e[P>>1]|0):0){m=P+9|0;if(((a[m>>0]|0)+-4|0)>=-6){P=k;l=Q;return P|0}}else{b[P+2>>1]=0;m=P+9|0}b[P>>1]=n;b[P+4>>1]=o;b[P+6>>1]=q;a[P+8>>0]=p&255|2;a[m>>0]=-6;P=k;l=Q;return P|0}A=k+128|0;nf(I,f,m,j,c[g+-28>>2]&63);y=f+5364|0;z=0-i|0;w=j+-1|0;u=(A|0)>-1e4;x=f+5348|0;v=u^1;u=u^1;B=0;s=(k|0)>(h|0)?k:h;a:while(1){m=rf(I)|0;if(!m){N=88;break}j=0-s|0;r=(A|0)>(s|0);while(1){t=m;b:while(1){m=c[y>>2]|0;p=t&49152;if((m|0)==7){if((p|0)==32768)m=(t&12288|0)==4096?64:t>>>6&63;else m=t>>>6&63;m=(t&56|0)==56?(c[f+(m<<2)>>2]&7|0)==6:0;if(m|v)n=m;else{o=7;N=45}}else{if((p|0)==0?(o=c[x>>2]|0,F=c[C>>2]|0,q=F+344+((o^1)<<3)|0,o=f+320+(o<<3)|0,!((c[o>>2]&c[q>>2]|0?1:(c[o+4>>2]&c[q+4>>2]|0)!=0)|(m+-1|0)>>>0<2)):0){n=F+376+((c[f+((t>>>6&63)<<2)>>2]&7)<<3)|0;q=30544+((t&63)<<3)|0;m=c[q>>2]&c[n>>2];n=c[q+4>>2]&c[n+4>>2]}else{m=(Rf(f,t)|0)&1;n=0}m=(m|0)!=0|(n|0)!=0;if(m|u)n=m;else{o=c[y>>2]|0;N=45}}do if((N|0)==45){N=0;n=t>>>6;if((t&61440|0)==36864)m=n&15;else m=c[f+((n&63)<<2)>>2]|0;m=m&7;if((o|0)==7)if((m|0)==6){if((p|0)==32768)m=(t&12288|0)==4096?64:n&63;else m=n&63;if((m>>3|0)>3){n=0;break}else N=61}else N=61;else{if((m|0)==1){if((p|0)==32768)m=(t&12288|0)==4096?64:n&63;else m=n&63;if((m>>3^(c[x>>2]|0)*7|0)>3){n=0;break}}if((o|0)==2)m=_f(f,t)|0;else N=61}if((N|0)==61)m=c[11108+(o<<7)+64+(c[f+((t&63)<<2)>>2]<<2)>>2]<<((o|0)==3&1);m=m+A|0;if((m|0)<=(s|0)){N=63;break b}if(!r?!($f(f,t,1)|0):0){N=66;break b}else n=0}while(0);m=p&65535;c:do if(m<<16>>16<16384){switch(m<<16>>16){case -32768:break;default:{N=69;break c}}if((t&12288|0)==8192)N=71;else N=69}else switch(m<<16>>16){case 16384:{N=71;break}default:N=69}while(0);if((N|0)==69?(N=0,$f(f,t,0)|0):0)N=71;if((N|0)==71?(N=0,Qf(f,t)|0):0){c[E>>2]=t;Tf(f,t,H,n);if(n)o=Fg(f,J,z,j,w)|0;else o=Gg(f,J,z,j,w)|0;q=0-o|0;Vf(f,t);if((k|0)<(q|0)){N=76;break}}m=rf(I)|0;if(!m){N=88;break a}else t=m}if((N|0)==63){N=0;k=(k|0)<(m|0)?m:k}else if((N|0)==66){N=0;k=(k|0)<(A|0)?A:k}else if((N|0)==76){N=0;if((s|0)<(q|0))break;else k=q}m=rf(I)|0;if(!m){N=88;break a}}k=c[g>>2]|0;m=c[J>>2]|0;c[k>>2]=t;k=k+4|0;if((m|0)!=0?(G=c[m>>2]|0,(G|0)!=0):0){n=G;do{m=m+4|0;c[k>>2]=n;k=k+4|0;n=c[m>>2]|0}while((n|0)!=0)}c[k>>2]=0;if((q|0)<(i|0)){B=t;s=q;k=q}else{N=82;break}}do if((N|0)==82){k=c[K>>2]|0;if((o|0)<-31743)p=k-o|0;else p=q-((o|0)>31743?k:0)|0;n=c[g+28>>2]|0;o=a[1163816]|0;N=b[P>>1]|0;m=av(L|0,M|0,48)|0;b[P+2>>1]=t;k=P+9|0;if((m|0)==(N&65535|0)&(D|0)==0?((a[k>>0]|0)+-4|0)>=(O|0):0){k=q;break}b[P>>1]=m;b[P+4>>1]=p;b[P+6>>1]=n;a[P+8>>0]=o&255|2;a[k>>0]=O;k=q}else if((N|0)==88){m=c[K>>2]|0;if((k|0)>31743)u=m+k|0;else u=k-((k|0)<-31743?m:0)|0;s=(k|0)>(h|0);t=s?3:1;j=c[g+28>>2]|0;r=a[1163816]|0;if(!B){o=av(L|0,M|0,48)|0;n=D;m=b[P>>1]|0;if((o|0)==(m&65535|0)&(n|0)==0){p=P;q=m}else{p=P;N=94}}else{m=b[P>>1]|0;o=av(L|0,M|0,48)|0;p=P;n=D;N=94}if((N|0)==94){b[P+2>>1]=B;q=m}m=P+9|0;if((o|0)==(q&65535|0)&(n|0)==0?!(s|((a[m>>0]|0)+-4|0)<(O|0)):0)break;b[p>>1]=o;b[P+4>>1]=u;b[P+6>>1]=j;a[P+8>>0]=r&255|t;a[m>>0]=O}while(0);P=k;l=Q;return P|0}P=Id(f)|0;l=Q;return P|0}function Hg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=a+8|0;e=c[k>>2]|0;l=a+4|0;i=c[l>>2]|0;if(e-i>>2>>>0>=b>>>0){Wu(i|0,0,b<<2|0)|0;c[l>>2]=i+(b<<2);return}j=c[a>>2]|0;d=(i-j>>2)+b|0;if(d>>>0>1073741823)vs(a);h=e-j|0;f=h>>1;f=h>>2>>>0<536870911?(f>>>0<d>>>0?d:f):1073741823;if(!f)h=0;else h=At(f<<2)|0;g=h+(i-j>>2<<2)|0;Wu(g|0,0,b<<2|0)|0;d=i-j|0;e=g+(0-(d>>2)<<2)|0;if((d|0)>0)cv(e|0,j|0,d|0)|0;c[a>>2]=e;c[l>>2]=g+(b<<2);c[k>>2]=h+(f<<2);if(!j)return;Dt(j);return}function Ig(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=b+20|0;i=c[h>>2]|0;if((i|0)!=(d|0)){c[b+24>>2]=i;c[h>>2]=d}p=c[a+5348>>2]|0;q=c[a+5352>>2]|0;o=0-g|0;k=(g|0)>-1?g:o;l=(k|0)>323;if(!l){if((d&49152|0)==32768)h=(d&12288|0)==4096?64:d>>>6&63;else h=d>>>6&63;t=q+9656+(p*16640|0)+(h<<8)+((d&63)<<2)|0;s=c[t>>2]|0;c[t>>2]=s+(g<<5)+((S(s,k)|0)/-324|0)}h=d>>>6;if((d&61440|0)==36864)h=h&15;else h=c[a+((h&63)<<2)>>2]|0;i=d&63;r=c[b+-156>>2]|0;s=c[b+-76>>2]|0;t=c[b+-36>>2]|0;j=(t|0)==0;if(!(l|j)){n=t+(h<<8)+(i<<2)|0;m=c[n>>2]|0;c[n>>2]=m+(g<<5)+((S(m,k)|0)/-936|0)}m=(s|0)==0;if(!(l|m)){n=s+(h<<8)+(i<<2)|0;u=c[n>>2]|0;c[n>>2]=u+(g<<5)+((S(u,k)|0)/-936|0)}n=(r|0)==0;if(!(l|n)){u=r+(h<<8)+(i<<2)|0;l=c[u>>2]|0;c[u>>2]=l+(g<<5)+((S(l,k)|0)/-936|0)}if(!j){u=c[b+-28>>2]&63;c[q+5560+(c[a+(u<<2)>>2]<<8)+(u<<2)>>2]=d}if((f|0)<=0)return;g=(o|0)>-1?o:g;u=(g|0)>323;d=u|j;b=u|m;n=u|n;m=o<<5;if(u){k=0;do{j=c[e+(k<<2)>>2]|0;h=j>>>6;if((j&61440|0)==36864)i=h&15;else i=c[a+((h&63)<<2)>>2]|0;h=j&63;if(!d){u=t+(i<<8)+(h<<2)|0;q=c[u>>2]|0;c[u>>2]=q+m+((S(q,g)|0)/-936|0)}if(!b){u=s+(i<<8)+(h<<2)|0;q=c[u>>2]|0;c[u>>2]=q+m+((S(q,g)|0)/-936|0)}if(!n){u=r+(i<<8)+(h<<2)|0;q=c[u>>2]|0;c[u>>2]=q+m+((S(q,g)|0)/-936|0)}k=k+1|0}while((k|0)!=(f|0));return}else k=0;do{j=c[e+(k<<2)>>2]|0;if((j&49152|0)==32768){i=j>>>6;h=i;i=(j&12288|0)==4096?64:i&63}else{i=j>>>6;h=i;i=i&63}l=j&63;u=q+9656+(p*16640|0)+(i<<8)+(l<<2)|0;o=c[u>>2]|0;c[u>>2]=o+m+((S(o,g)|0)/-324|0);if((j&61440|0)==36864)h=h&15;else h=c[a+((h&63)<<2)>>2]|0;if(!d){u=t+(h<<8)+(l<<2)|0;o=c[u>>2]|0;c[u>>2]=o+m+((S(o,g)|0)/-936|0)}if(!b){u=s+(h<<8)+(l<<2)|0;o=c[u>>2]|0;c[u>>2]=o+m+((S(o,g)|0)/-936|0)}if(!n){u=r+(h<<8)+(l<<2)|0;o=c[u>>2]|0;c[u>>2]=o+m+((S(o,g)|0)/-936|0)}k=k+1|0}while((k|0)!=(f|0));return}function Jg(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+144|0;a=b;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Jt(a,21816,5);d=a+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=a+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=a+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=a+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=a+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=a+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=a+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=a+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=a+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=a+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=a+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[290939]=p;c[290938]=p;c[290940]=p+144;It(p,a);p=(c[290939]|0)+12|0;c[290939]=p;It(p,d);p=(c[290939]|0)+12|0;c[290939]=p;It(p,e);p=(c[290939]|0)+12|0;c[290939]=p;It(p,f);p=(c[290939]|0)+12|0;c[290939]=p;It(p,g);p=(c[290939]|0)+12|0;c[290939]=p;It(p,h);p=(c[290939]|0)+12|0;c[290939]=p;It(p,i);p=(c[290939]|0)+12|0;c[290939]=p;It(p,j);p=(c[290939]|0)+12|0;c[290939]=p;It(p,k);p=(c[290939]|0)+12|0;c[290939]=p;It(p,m);p=(c[290939]|0)+12|0;c[290939]=p;It(p,n);p=(c[290939]|0)+12|0;c[290939]=p;It(p,o);c[290939]=(c[290939]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(a);a=988280;d=a+64|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));l=b;return}function Kg(){var a=0,b=0,d=0.0,e=0,f=0,g=0;b=1;do{d=+Q(+(+(b|0)));a=1;do{e=~~+mv(+(d*+Q(+(+(a|0)))*.5));f=1130984+(b<<8)+(a<<2)|0;c[f>>2]=e;g=e+-1|0;c[1098216+(b<<8)+(a<<2)>>2]=(g|0)<0?0:g;if((e|0)>1)c[f>>2]=e+1;a=a+1|0}while((a|0)!=64);b=b+1|0}while((b|0)!=64);b=1;do{d=+Q(+(+(b|0)));a=1;do{g=~~+mv(+(d*+Q(+(+(a|0)))*.5));c[1147368+(b<<8)+(a<<2)>>2]=g;g=g+-1|0;c[1114600+(b<<8)+(a<<2)>>2]=(g|0)<0?0:g;a=a+1|0}while((a|0)!=64);b=b+1|0}while((b|0)!=64);a=0;do{d=+(a|0);c[1098088+(a<<2)>>2]=~~(+H(+d,1.8)*.773+2.4);c[1098152+(a<<2)>>2]=~~(+H(+(d+.49),1.8)*1.045+2.9);a=a+1|0}while((a|0)!=16);return}function Lg(){var b=0,d=0,e=0;fh(1163804);b=c[290941]|0;d=c[290942]|0;if((b|0)!=(d|0)){do{e=c[b>>2]|0;Wu(e+5560|0,0,4231680)|0;a[e+5556>>0]=1;b=b+4|0}while((b|0)!=(d|0));d=c[290942]|0;b=c[290941]|0}if((d|0)==(b|0))ws(1163764);else{c[(c[b>>2]|0)+4237256>>2]=32001;return}}function Mg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;c[b>>2]=12612;k=b+8|0;xt(k);a[b+84>>0]=1;l=b+36|0;Nj(l);yt(k);ua(c[b+4>>2]|0,0)|0;i=b+5536|0;d=c[i>>2]|0;if(d|0){j=b+5540|0;e=c[j>>2]|0;if((e|0)!=(d|0)){do{f=e+-20|0;c[j>>2]=f;g=c[e+-12>>2]|0;h=g;if(!g)e=f;else{e=e+-8|0;f=c[e>>2]|0;if((f|0)!=(g|0))c[e>>2]=f+(~((f+-4-h|0)>>>2)<<2);Dt(g);e=c[j>>2]|0}}while((e|0)!=(d|0));d=c[i>>2]|0}Dt(d)}Og(b+124|0,c[b+128>>2]|0);Pg(b+112|0,c[b+116>>2]|0);d=c[b+100>>2]|0;e=d;if(d|0){f=b+104|0;g=c[f>>2]|0;if((g|0)!=(d|0))c[f>>2]=g+(~((g+-32-e|0)>>>5)<<5);Dt(d)}f=c[b+88>>2]|0;if(!f){Mj(l);wt(k);return}d=b+92|0;e=c[d>>2]|0;if((e|0)!=(f|0))c[d>>2]=e+(~(((e+-120-f|0)>>>0)/120|0)*120|0);Dt(f);Mj(l);wt(k);return}function Ng(a){a=a|0;Mg(a);Dt(a);return}function Og(a,b){a=a|0;b=b|0;var d=0;if(!b)return;Og(a,c[b>>2]|0);Og(a,c[b+4>>2]|0);d=b+24|0;a=c[d>>2]|0;c[d>>2]=0;if(a|0)db[c[(c[a>>2]|0)+4>>2]&255](a);Dt(b);return}function Pg(a,b){a=a|0;b=b|0;var d=0;if(!b)return;Pg(a,c[b>>2]|0);Pg(a,c[b+4>>2]|0);d=b+24|0;a=c[d>>2]|0;c[d>>2]=0;if(a|0)db[c[(c[a>>2]|0)+4>>2]&255](a);Dt(b);return}function Qg(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[290946]=p;c[290945]=p;c[290947]=p+144;It(p,b);p=(c[290946]|0)+12|0;c[290946]=p;It(p,d);p=(c[290946]|0)+12|0;c[290946]=p;It(p,e);p=(c[290946]|0)+12|0;c[290946]=p;It(p,f);p=(c[290946]|0)+12|0;c[290946]=p;It(p,g);p=(c[290946]|0)+12|0;c[290946]=p;It(p,h);p=(c[290946]|0)+12|0;c[290946]=p;It(p,i);p=(c[290946]|0)+12|0;c[290946]=p;It(p,j);p=(c[290946]|0)+12|0;c[290946]=p;It(p,k);p=(c[290946]|0)+12|0;c[290946]=p;It(p,m);p=(c[290946]|0)+12|0;c[290946]=p;It(p,n);p=(c[290946]|0)+12|0;c[290946]=p;It(p,o);c[290946]=(c[290946]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);c[290941]=0;c[290942]=0;c[290943]=0;c[290944]=0;l=a;return}function Rg(b){b=b|0;var d=0,e=0,f=0,g=0;g=l;l=l+16|0;d=g;f=b+8|0;c[d>>2]=f;e=d+4|0;a[e>>0]=1;xt(f);f=b+36|0;b=b+85|0;if(a[b>>0]|0){do Oj(f,d);while((a[b>>0]|0)!=0);if(!(a[e>>0]|0)){l=g;return}}yt(c[d>>2]|0);l=g;return}function Sg(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=l;l=l+16|0;e=g;h=b+8|0;c[e>>2]=h;f=e+4|0;a[f>>0]=1;xt(h);b=b+36|0;if(!(a[d>>0]&1))do Oj(b,e);while(!(a[d>>0]&1));if(!(a[f>>0]|0)){l=g;return}yt(c[e>>2]|0);l=g;return}function Tg(b,c){b=b|0;c=c|0;var d=0;d=b+8|0;xt(d);if(!c)a[b+85>>0]=1;Nj(b+36|0);yt(d);return}function Ug(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;i=At(4237264)|0;Wu(i|0,0,4237264)|0;c[i>>2]=12612;e=i+88|0;g=i+92|0;d=i+8|0;f=d+76|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));d=At(1966080)|0;c[g>>2]=d;c[e>>2]=d;c[i+96>>2]=d+1966080;e=16384;do{f=d+120|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));d=(c[g>>2]|0)+120|0;c[g>>2]=d;e=e+-1|0}while((e|0)!=0);e=i+104|0;f=At(262144)|0;c[e>>2]=f;c[i+100>>2]=f;c[i+108>>2]=f+262144;d=8192;do{c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;f=(c[e>>2]|0)+32|0;c[e>>2]=f;d=d+-1|0}while((d|0)!=0);Ib(i+112|0);c[i+5536>>2]=0;c[i+5540>>2]=0;c[i+5544>>2]=0;a[i+84>>0]=0;a[i+5556>>0]=0;d=i+144|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[i+136>>2]=(c[290942]|0)-(c[290941]|0)>>2;a[i+85>>0]=0;c[i>>2]=12268;c[h>>2]=i;d=b+4|0;e=c[d>>2]|0;if(e>>>0<(c[b+8>>2]|0)>>>0){c[e>>2]=i;c[d>>2]=(c[d>>2]|0)+4;Wg(b);l=j;return}else{Vg(b,h);Wg(b);l=j;return}}function Vg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=a+4|0;e=c[i>>2]|0;j=c[a>>2]|0;d=(e-j>>2)+1|0;if(d>>>0>1073741823)vs(a);k=a+8|0;h=(c[k>>2]|0)-j|0;f=h>>1;f=h>>2>>>0<536870911?(f>>>0<d>>>0?d:f):1073741823;if(!f)h=0;else h=At(f<<2)|0;g=h+(e-j>>2<<2)|0;c[g>>2]=c[b>>2];d=e-j|0;b=g+(0-(d>>2)<<2)|0;if((d|0)>0)cv(b|0,j|0,d|0)|0;c[a>>2]=b;c[i>>2]=g+4;c[k>>2]=h+(f<<2);if(!j)return;Dt(j);return}function Wg(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+32|0;j=n+24|0;k=n+16|0;m=n;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21957,7);c[j>>2]=m;ae(k,1163992,m,1233088,j,n+28|0);k=xh((c[k>>2]|0)+28|0)|0;Mt(m);m=b+4|0;f=c[m>>2]|0;e=c[b>>2]|0;d=f;if(f-e>>2>>>0<k>>>0){i=b+8|0;do{h=At(4237240)|0;c[h>>2]=12612;e=h+88|0;g=h+92|0;d=h+8|0;f=d+76|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));d=At(1966080)|0;c[g>>2]=d;c[e>>2]=d;c[h+96>>2]=d+1966080;e=16384;do{f=d+120|0;do{c[d>>2]=0;d=d+4|0}while((d|0)<(f|0));d=(c[g>>2]|0)+120|0;c[g>>2]=d;e=e+-1|0}while((e|0)!=0);e=h+104|0;f=At(262144)|0;c[e>>2]=f;c[h+100>>2]=f;c[h+108>>2]=f+262144;d=8192;do{c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=0;c[f+28>>2]=0;f=(c[e>>2]|0)+32|0;c[e>>2]=f;d=d+-1|0}while((d|0)!=0);Ib(h+112|0);c[h+5536>>2]=0;c[h+5540>>2]=0;c[h+5544>>2]=0;a[h+84>>0]=0;a[h+5556>>0]=0;d=h+144|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[h+136>>2]=(c[290942]|0)-(c[290941]|0)>>2;a[h+85>>0]=0;c[j>>2]=h;d=c[m>>2]|0;if(d>>>0<(c[i>>2]|0)>>>0){c[d>>2]=h;d=(c[m>>2]|0)+4|0;c[m>>2]=d;f=d}else{Vg(b,j);d=c[m>>2]|0;f=d}e=c[b>>2]|0}while(f-e>>2>>>0<k>>>0)}if(f-e>>2>>>0>k>>>0)f=d;else{l=n;return}do{d=c[f+-4>>2]|0;if(!d)d=f;else{db[c[(c[d>>2]|0)+4>>2]&255](d);d=c[m>>2]|0;e=c[b>>2]|0}f=d+-4|0;c[m>>2]=f}while(f-e>>2>>>0>k>>>0);l=n;return}function Xg(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;e=c[a+4>>2]|0;if((b|0)==(e|0)){d=0;e=0;D=d;return e|0}else{a=0;d=0}do{f=(c[b>>2]|0)+5496|0;a=Yu(c[f>>2]|0,c[f+4>>2]|0,a|0,d|0)|0;d=D;b=b+4|0}while((b|0)!=(e|0));b=d;D=b;return a|0}function Yg(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a>>2]|0;e=c[a+4>>2]|0;if((b|0)==(e|0)){d=0;e=0;D=d;return e|0}else{a=0;d=0}do{f=(c[b>>2]|0)+152|0;a=Yu(c[f>>2]|0,c[f+4>>2]|0,a|0,d|0)|0;d=D;b=b+4|0}while((b|0)!=(e|0));b=d;D=b;return a|0}function Zg(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;A=l;l=l+4144|0;z=A+4124|0;x=A+24|0;w=A;a[1233085]=0;a[1233086]=0;if((f|0)!=988280)_g(988280,c[f>>2]|0,c[f+4>>2]|0);g=988292;h=f+12|0;i=g+60|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(i|0));c[z>>2]=0;y=z+4|0;c[y>>2]=0;c[z+8>>2]=0;m=kf(d,x)|0;c[x+4096>>2]=m;if((x|0)!=(m|0)){n=f+4|0;o=w+4|0;p=w+8|0;q=w+12|0;r=w+16|0;s=z+8|0;t=w+8|0;k=x;do{g=c[f>>2]|0;j=c[n>>2]|0;i=c[k>>2]|0;if((g|0)!=(j|0)){h=0;do{h=((c[g>>2]|0)==(i|0)&1)+h|0;g=g+4|0}while((g|0)!=(j|0));if(h|0)u=9}else u=9;if((u|0)==9){u=0;c[w>>2]=-32001;c[o>>2]=-32001;j=At(4)|0;c[p>>2]=j;g=j+4|0;c[r>>2]=g;c[j>>2]=i;c[q>>2]=g;g=c[y>>2]|0;if(g>>>0>=(c[s>>2]|0)>>>0){hg(z,w);g=c[t>>2]|0;h=g;if(g|0){i=c[q>>2]|0;if((i|0)!=(g|0))c[q>>2]=i+(~((i+-4-h|0)>>>2)<<2);Dt(g)}}else{h=w;j=c[h+4>>2]|0;i=g;c[i>>2]=c[h>>2];c[i+4>>2]=j;i=g+8|0;c[i>>2]=0;j=g+12|0;c[j>>2]=0;c[g+16>>2]=0;c[i>>2]=c[p>>2];c[j>>2]=c[q>>2];c[g+16>>2]=c[r>>2];c[r>>2]=0;c[q>>2]=0;c[p>>2]=0;c[y>>2]=(c[y>>2]|0)+20}}k=k+8|0}while((k|0)!=(m|0))}g=c[e>>2]|0;if(g|0?(u=b+12|0,c[e>>2]=0,v=c[u>>2]|0,c[u>>2]=g,v|0):0){p=v+4|0;h=c[p>>2]|0;o=v+16|0;g=c[o>>2]|0;i=h+(g>>>4<<2)|0;q=v+8|0;e=c[q>>2]|0;m=e;n=h;if((e|0)==(h|0)){k=v+20|0;g=0;j=0}else{k=v+20|0;j=(c[k>>2]|0)+g|0;g=(c[i>>2]|0)+((g&15)*440|0)|0;j=(c[h+(j>>>4<<2)>>2]|0)+((j&15)*440|0)|0}a:while(1){do{if((g|0)==(j|0))break a;g=g+440|0}while((g-(c[i>>2]|0)|0)!=7040);g=i+4|0;i=g;g=c[g>>2]|0}c[k>>2]=0;g=m-n>>2;if(g>>>0>2)do{Dt(c[h>>2]|0);h=(c[p>>2]|0)+4|0;c[p>>2]=h;g=(c[q>>2]|0)-h>>2}while(g>>>0>2);switch(g|0){case 1:{c[o>>2]=8;break}case 2:{c[o>>2]=16;break}default:{}}g=c[p>>2]|0;h=c[q>>2]|0;if((g|0)!=(h|0)){do{Dt(c[g>>2]|0);g=g+4|0}while((g|0)!=(h|0));g=c[p>>2]|0;h=c[q>>2]|0;if((h|0)!=(g|0))c[q>>2]=h+(~((h+-4-g|0)>>>2)<<2)}g=c[v>>2]|0;if(g|0)Dt(g);Dt(v)}n=b+12|0;g=c[n>>2]|0;i=c[g+20>>2]|0;h=c[g+16>>2]|0;j=i+-1+h|0;g=c[g+4>>2]|0;cv(x|0,(c[g+(j>>>4<<2)>>2]|0)+((j&15)*440|0)|0,440)|0;j=c[290941]|0;o=c[290942]|0;if((j|0)!=(o|0)){k=d+5360|0;m=d+5368|0;g=j;do{h=c[g>>2]|0;c[h+144>>2]=0;i=h+152|0;c[i>>2]=0;c[i+4>>2]=0;c[h+5548>>2]=0;i=h+5536|0;if((i|0)!=(z|0))$g(i,c[z>>2]|0,c[y>>2]|0);yf(w,d);e=c[n>>2]|0;v=(c[e+20>>2]|0)+-1+(c[e+16>>2]|0)|0;zf(h+160|0,w,(a[k>>0]|0)!=0,c[m>>2]|0,(c[(c[e+4>>2]|0)+(v>>>4<<2)>>2]|0)+((v&15)*440|0)|0,h)|0;Mt(w);g=g+4|0}while((g|0)!=(o|0));g=c[n>>2]|0;i=c[g+20>>2]|0;h=c[g+16>>2]|0;g=c[g+4>>2]|0}w=i+-1+h|0;cv((c[g+(w>>>4<<2)>>2]|0)+((w&15)*440|0)|0,x|0,440)|0;g=c[b>>2]|0;if((c[b+4>>2]|0)==(g|0))ws(b);g=c[g>>2]|0;db[c[(c[g>>2]|0)+8>>2]&255](g);g=c[z>>2]|0;if(!g){l=A;return}h=c[y>>2]|0;if((h|0)!=(g|0)){do{i=h+-20|0;c[y>>2]=i;j=c[h+-12>>2]|0;k=j;if(!j)h=i;else{h=h+-8|0;i=c[h>>2]|0;if((i|0)!=(j|0))c[h>>2]=i+(~((i+-4-k|0)>>>2)<<2);Dt(j);h=c[y>>2]|0}}while((h|0)!=(g|0));g=c[z>>2]|0}Dt(g);l=A;return}function _g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;j=d;h=b;g=j-h|0;k=g>>2;i=a+8|0;e=c[i>>2]|0;m=c[a>>2]|0;l=m;if(k>>>0<=e-m>>2>>>0){i=a+4|0;a=(c[i>>2]|0)-m>>2;g=k>>>0>a>>>0;a=g?b+(a<<2)|0:d;f=a;e=f-h|0;d=e>>2;if(d|0)hv(m|0,b|0,e|0)|0;d=l+(d<<2)|0;if(g){e=j-f|0;if((e|0)<=0)return;cv(c[i>>2]|0,a|0,e|0)|0;c[i>>2]=(c[i>>2]|0)+(e>>2<<2);return}else{e=c[i>>2]|0;if((e|0)==(d|0))return;c[i>>2]=e+(~((e+-4-d|0)>>>2)<<2);return}}f=m;if(m){e=a+4|0;d=c[e>>2]|0;if((d|0)!=(l|0))c[e>>2]=d+(~((d+-4-m|0)>>>2)<<2);Dt(f);c[i>>2]=0;c[e>>2]=0;c[a>>2]=0;e=0}if(k>>>0>1073741823)vs(a);m=e-0|0;e=m>>1;e=m>>2>>>0<536870911?(e>>>0<k>>>0?k:e):1073741823;if(e>>>0>1073741823)vs(a);d=At(e<<2)|0;f=a+4|0;c[f>>2]=d;c[a>>2]=d;c[i>>2]=d+(e<<2);if((g|0)<=0)return;cv(d|0,b|0,g|0)|0;c[f>>2]=d+(k<<2);return}function $g(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;k=(d-b|0)/20|0;m=a+8|0;e=c[m>>2]|0;f=c[a>>2]|0;j=f;if(k>>>0>((e-f|0)/20|0)>>>0){if(f){i=a+4|0;e=c[i>>2]|0;if((e|0)==(j|0))e=f;else{do{f=e+-20|0;c[i>>2]=f;g=c[e+-12>>2]|0;h=g;if(!g)e=f;else{e=e+-8|0;f=c[e>>2]|0;if((f|0)!=(g|0))c[e>>2]=f+(~((f+-4-h|0)>>>2)<<2);Dt(g);e=c[i>>2]|0}}while((e|0)!=(j|0));e=c[a>>2]|0}Dt(e);c[m>>2]=0;c[i>>2]=0;c[a>>2]=0;e=0}if(k>>>0>214748364)vs(a);l=(e-0|0)/20|0;e=l<<1;e=l>>>0<107374182?(e>>>0<k>>>0?k:e):214748364;if(e>>>0>214748364)vs(a);f=At(e*20|0)|0;l=a+4|0;c[l>>2]=f;c[a>>2]=f;c[m>>2]=f+(e*20|0);if((b|0)==(d|0))return;while(1){k=b;g=c[k+4>>2]|0;a=f;c[a>>2]=c[k>>2];c[a+4>>2]=g;a=f+8|0;g=b+8|0;c[a>>2]=0;k=f+12|0;c[k>>2]=0;c[f+16>>2]=0;i=b+12|0;e=(c[i>>2]|0)-(c[g>>2]|0)|0;h=e>>2;if(h|0){if(h>>>0>1073741823){e=38;break}j=At(e)|0;c[k>>2]=j;c[a>>2]=j;c[f+16>>2]=j+(h<<2);f=c[g>>2]|0;e=(c[i>>2]|0)-f|0;if((e|0)>0){cv(j|0,f|0,e|0)|0;c[k>>2]=j+(e>>2<<2)}}b=b+20|0;f=(c[l>>2]|0)+20|0;c[l>>2]=f;if((b|0)==(d|0)){e=42;break}}if((e|0)==38)vs(a);else if((e|0)==42)return}else{l=a+4|0;i=((c[l>>2]|0)-f|0)/20|0;h=k>>>0>i>>>0;i=b+(i*20|0)|0;g=h?i:d;if((g|0)!=(b|0)){f=b;e=j;do{b=f;a=c[b+4>>2]|0;m=e;c[m>>2]=c[b>>2];c[m+4>>2]=a;if((e|0)!=(f|0))_g(e+8|0,c[f+8>>2]|0,c[f+12>>2]|0);f=f+20|0;e=e+20|0}while((f|0)!=(g|0));j=e}if(!h){e=c[l>>2]|0;if((e|0)==(j|0))return;do{f=e+-20|0;c[l>>2]=f;g=c[e+-12>>2]|0;h=g;if(!g)e=f;else{e=e+-8|0;f=c[e>>2]|0;if((f|0)!=(g|0))c[e>>2]=f+(~((f+-4-h|0)>>>2)<<2);Dt(g);e=c[l>>2]|0}}while((e|0)!=(j|0));return}if((g|0)==(d|0))return;f=c[l>>2]|0;while(1){b=i;g=c[b+4>>2]|0;a=f;c[a>>2]=c[b>>2];c[a+4>>2]=g;a=f+8|0;g=i+8|0;c[a>>2]=0;b=f+12|0;c[b>>2]=0;c[f+16>>2]=0;j=i+12|0;e=(c[j>>2]|0)-(c[g>>2]|0)|0;h=e>>2;if(h|0){if(h>>>0>1073741823){e=11;break}k=At(e)|0;c[b>>2]=k;c[a>>2]=k;c[f+16>>2]=k+(h<<2);f=c[g>>2]|0;e=(c[j>>2]|0)-f|0;if((e|0)>0){cv(k|0,f|0,e|0)|0;c[b>>2]=k+(e>>2<<2)}}i=i+20|0;f=(c[l>>2]|0)+20|0;c[l>>2]=f;if((i|0)==(d|0)){e=42;break}}if((e|0)==11)vs(a);else if((e|0)==42)return}}function ah(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[290949]=p;c[290948]=p;c[290950]=p+144;It(p,b);p=(c[290949]|0)+12|0;c[290949]=p;It(p,d);p=(c[290949]|0)+12|0;c[290949]=p;It(p,e);p=(c[290949]|0)+12|0;c[290949]=p;It(p,f);p=(c[290949]|0)+12|0;c[290949]=p;It(p,g);p=(c[290949]|0)+12|0;c[290949]=p;It(p,h);p=(c[290949]|0)+12|0;c[290949]=p;It(p,i);p=(c[290949]|0)+12|0;c[290949]=p;It(p,j);p=(c[290949]|0)+12|0;c[290949]=p;It(p,k);p=(c[290949]|0)+12|0;c[290949]=p;It(p,m);p=(c[290949]|0)+12|0;c[290949]=p;It(p,n);p=(c[290949]|0)+12|0;c[290949]=p;It(p,o);c[290949]=(c[290949]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function bh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0.0,j=0,k=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;y=l;l=l+32|0;u=y+24|0;v=y+28|0;w=y+16|0;x=y;c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Jt(x,22023,21);c[u>>2]=x;ae(w,1163992,x,1233089,u,v);s=xh((c[w>>2]|0)+28|0)|0;Mt(x);c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Jt(x,22009,13);c[u>>2]=x;ae(w,1163992,x,1233089,u,v);t=xh((c[w>>2]|0)+28|0)|0;Mt(x);c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Jt(x,22045,10);c[u>>2]=x;ae(w,1163992,x,1233089,u,v);k=xh((c[w>>2]|0)+28|0)|0;Mt(x);c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Jt(x,22056,9);c[u>>2]=x;ae(w,1163992,x,1233089,u,v);g=xh((c[w>>2]|0)+28|0)|0;Mt(x);if(!g)h=b+12+(d<<2)|0;else{r=a;f=c[r>>2]|0;h=b+12+(d<<2)|0;if((f|0)==0&(c[r+4>>2]|0)==0){f=S(c[h>>2]|0,g)|0;r=a;c[r>>2]=f;c[r+4>>2]=((f|0)<0)<<31>>31}c[h>>2]=f;r=b+20+(d<<2)|0;c[r>>2]=S(c[r>>2]|0,g)|0;c[b+28>>2]=g}q=b+64|0;r=c[q+4>>2]|0;g=a+8|0;c[g>>2]=c[q>>2];c[g+4>>2]=r;g=c[h>>2]|0;g=(g|0)<(s|0)?s:g;r=a+20|0;c[r>>2]=g;q=a+16|0;c[q>>2]=g;f=c[b+32>>2]|0;if(!((f|0)==0|(f|0)>50)){if((f|0)>=1)j=9}else{f=50;j=9}if((j|0)==9){p=b+20+(d<<2)|0;n=+(k|0)*(+H(+(+P(+((+(e|0)+-58.4)/7.64))+1.0),-.183)+2.2250738585072014e-308)/100.0;o=n*7.09;k=g;d=g;j=1;while(1){a=S(c[p>>2]|0,j+-1|0)|0;a=(c[h>>2]|0)-(S(((j|0)>40?40:j)+2|0,t)|0)+a|0;a=(a|0)<0?0:a;b=(j|0)>1;if(b){i=0.0;g=1;do{i=i+(+H(+(+P(+((+((g<<1)+e|0)+-58.4)/7.64))+1.0),-.183)+2.2250738585072014e-308);g=g+1|0}while((g|0)!=(j|0))}else i=0.0;m=n+i;z=n/m;i=(n+i*0.0)/m;m=+(a|0);a=~~(m*(i<z?i:z))+s|0;if(b){i=0.0;g=1;do{i=i+(+H(+(+P(+((+((g<<1)+e|0)+-58.4)/7.64))+1.0),-.183)+2.2250738585072014e-308);g=g+1|0}while((g|0)!=(j|0))}else i=0.0;z=o/(o+i);i=(n+i*.35)/(n+i);b=~~(m*(i<z?i:z))+s|0;k=(k|0)<(a|0)?k:a;c[q>>2]=k;d=(d|0)<(b|0)?d:b;c[r>>2]=d;if((j|0)==(f|0))break;else j=j+1|0}};c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;Jt(x,21988,6);c[u>>2]=x;ae(w,1163992,x,1233089,u,v);w=(xh((c[w>>2]|0)+28|0)|0)==0;Mt(x);if(w){l=y;return}x=c[q>>2]|0;c[q>>2]=((x|0)/4|0)+x;l=y;return}function ch(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[290956]=p;c[290955]=p;c[290957]=p+144;It(p,b);p=(c[290956]|0)+12|0;c[290956]=p;It(p,d);p=(c[290956]|0)+12|0;c[290956]=p;It(p,e);p=(c[290956]|0)+12|0;c[290956]=p;It(p,f);p=(c[290956]|0)+12|0;c[290956]=p;It(p,g);p=(c[290956]|0)+12|0;c[290956]=p;It(p,h);p=(c[290956]|0)+12|0;c[290956]=p;It(p,i);p=(c[290956]|0)+12|0;c[290956]=p;It(p,j);p=(c[290956]|0)+12|0;c[290956]=p;It(p,k);p=(c[290956]|0)+12|0;c[290956]=p;It(p,m);p=(c[290956]|0)+12|0;c[290956]=p;It(p,n);p=(c[290956]|0)+12|0;c[290956]=p;It(p,o);c[290956]=(c[290956]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function dh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;f=l;l=l+16|0;e=f;d=nv(b<<15&134184960|0,0,0)|0;d=1<<(d^63);if((d|0)==(c[a>>2]|0)){l=f;return}c[a>>2]=d;g=a+8|0;Gj(c[g>>2]|0);d=Hj((c[a>>2]<<5)+63|0,1)|0;c[g>>2]=d;if(!d){g=eh(el(eh(1164924,21104)|0,b)|0,21124)|0;c[e>>2]=Sk(g+(c[(c[g>>2]|0)+-12>>2]|0)|0)|0;b=lm(e,1165628)|0;b=nb[c[(c[b>>2]|0)+28>>2]&63](b,10)|0;pt(e);il(g,b)|0;Xk(g)|0;Xa(1)}c[a+4>>2]=d+63&-64;l=f;return}function eh(a,b){a=a|0;b=b|0;return Kd(a,b,Vh(b)|0)|0}function fh(a){a=a|0;Wu(c[a+4>>2]|0,0,c[a>>2]<<5|0)|0;return}function gh(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;o=(c[e>>2]|0)+-1&f;p=c[e+4>>2]|0;n=p+(o<<5)|0;j=av(f|0,g|0,48)|0;f=b[n>>1]|0;g=f<<16>>16==0;if(!(g|(f&65535|0)==(j|0))){k=p+(o<<5)+10|0;f=b[k>>1]|0;g=f<<16>>16==0;if(!(g|(f&65535|0)==(j|0))){i=p+(o<<5)+20|0;f=b[i>>1]|0;g=f<<16>>16==0;if(g|(f&65535|0)==(j|0)){j=2;l=g;m=i;k=i}else{m=(d[e+12>>0]|0)+259|0;e=((a[p+(o<<5)+9>>0]|0)-(m-(d[p+(o<<5)+8>>0]|0)<<1&504)|0)>((a[p+(o<<5)+19>>0]|0)-(m-(d[p+(o<<5)+18>>0]|0)<<1&504)|0)?k:n;e=((a[e+9>>0]|0)-(m-(d[e+8>>0]|0)<<1&504)|0)>((a[p+(o<<5)+29>>0]|0)-(m-(d[p+(o<<5)+28>>0]|0)<<1&504)|0)?i:e;p=0;a[h>>0]=p;return e|0}}else{j=1;l=g;m=k}}else{j=0;l=g;m=n;k=n}i=p+(o<<5)+(j*10|0)+8|0;j=d[i>>0]|0;g=d[e+12>>0]|0;if(!(l|(j&252|0)==(g|0))){a[i>>0]=j&3|g;f=b[m>>1]|0}e=k;p=f<<16>>16!=0&1;a[h>>0]=p;return e|0}function hh(a){a=a|0;var b=0,e=0,f=0;f=c[a+4>>2]|0;e=d[a+12>>0]|0;a=0;b=0;do{a=(((d[f+(b<<5)+28>>0]|0)&252|0)==(e|0)&1)+((((d[f+(b<<5)+18>>0]|0)&252|0)==(e|0)&1)+((((d[f+(b<<5)+8>>0]|0)&252|0)==(e|0)&1)+a))|0;b=b+1|0}while((b|0)!=333);return a|0}function ih(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;g=l;l=l+144|0;d=g;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21816,5);e=d+12|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21822,8);a=d+24|0;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Jt(a,21831,6);b=d+36|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21838,10);f=d+48|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21849,5);h=d+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=d+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=d+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=d+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=d+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=d+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=d+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[290959]=p;c[290958]=p;c[290960]=p+144;It(p,d);p=(c[290959]|0)+12|0;c[290959]=p;It(p,e);p=(c[290959]|0)+12|0;c[290959]=p;It(p,a);p=(c[290959]|0)+12|0;c[290959]=p;It(p,b);p=(c[290959]|0)+12|0;c[290959]=p;It(p,f);p=(c[290959]|0)+12|0;c[290959]=p;It(p,h);p=(c[290959]|0)+12|0;c[290959]=p;It(p,i);p=(c[290959]|0)+12|0;c[290959]=p;It(p,j);p=(c[290959]|0)+12|0;c[290959]=p;It(p,k);p=(c[290959]|0)+12|0;c[290959]=p;It(p,m);p=(c[290959]|0)+12|0;c[290959]=p;It(p,n);p=(c[290959]|0)+12|0;c[290959]=p;It(p,o);c[290959]=(c[290959]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(f);Mt(b);Mt(a);Mt(e);Mt(d);c[290961]=0;c[290962]=0;c[290963]=0;Jt(1163844,21152,56);c[290964]=0;c[290965]=0;c[290966]=0;Jt(1163856,21152,56);c[290967]=0;c[290968]=0;c[290969]=0;Jt(1163868,21152,56);c[290970]=0;c[290971]=0;c[290972]=0;Jt(1163880,21209,58);c[290973]=0;c[290974]=0;c[290975]=0;Jt(1163892,21268,74);c[290976]=0;c[290977]=0;c[290978]=0;Jt(1163904,21152,56);c[290979]=0;c[290980]=0;c[290981]=0;Jt(1163916,21152,56);c[290982]=0;c[290983]=0;c[290984]=0;Jt(1163928,21343,39);c[290985]=0;c[290986]=0;c[290987]=0;Jt(1163940,21383,60);c[290988]=0;c[290989]=0;c[290990]=0;Jt(1163952,21444,53);c[290991]=0;c[290992]=0;c[290993]=0;Jt(1163964,21209,58);c[290994]=0;c[290995]=0;c[290996]=0;Jt(1163976,21209,58);d=At(24)|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;e=d+20|0;jh(d,1);a=c[e>>2]|0;b=c[d+4>>2]|0;f=(c[d+16>>2]|0)+a|0;if((c[d+8>>2]|0)==(b|0)){p=0;Wu(p|0,0,440)|0;p=a+1|0;c[e>>2]=p;p=d;c[290997]=p;l=g;return}p=(c[b+(f>>>4<<2)>>2]|0)+((f&15)*440|0)|0;Wu(p|0,0,440)|0;p=a+1|0;c[e>>2]=p;p=d;c[290997]=p;l=g;return}function jh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=l;l=l+16|0;k=t;r=a+8|0;g=c[r>>2]|0;s=a+4|0;e=c[s>>2]|0;d=((g|0)==(e|0)&1)+b|0;d=((d&15|0)!=0&1)+(d>>>4)|0;p=a+16|0;f=c[p>>2]|0;b=f>>>4;b=d>>>0<b>>>0?d:b;d=d-b|0;h=g;if(!d){c[p>>2]=f-(b<<4);if(!b){l=t;return}n=a+12|0;while(1){m=c[e>>2]|0;k=e+4|0;c[s>>2]=k;q=c[n>>2]|0;d=q;h=g;do if((g|0)==(q|0)){e=c[a>>2]|0;f=e;if(k>>>0>e>>>0){d=k;f=((d-f>>2)+1|0)/-2|0;g=k+(f<<2)|0;d=h-d|0;e=d>>2;if(!e)d=k;else{hv(g|0,k|0,d|0)|0;d=c[s>>2]|0}q=g+(e<<2)|0;c[r>>2]=q;c[s>>2]=d+(f<<2);d=q;break}j=d-f>>1;j=(j|0)==0?1:j;q=At(j<<2)|0;h=q;d=q+(j>>>2<<2)|0;i=d;j=q+(j<<2)|0;if((k|0)==(g|0))d=i;else{f=d;d=i;e=k;do{c[f>>2]=c[e>>2];f=d+4|0;d=f;e=e+4|0}while((e|0)!=(g|0));e=c[a>>2]|0}c[a>>2]=h;c[s>>2]=i;c[r>>2]=d;c[n>>2]=j;if(e){Dt(e);d=c[r>>2]|0}}else d=g;while(0);c[d>>2]=m;d=(c[r>>2]|0)+4|0;c[r>>2]=d;b=b+-1|0;if(!b)break;e=c[s>>2]|0;g=d}l=t;return}q=a+12|0;f=c[q>>2]|0;g=f-(c[a>>2]|0)|0;i=h-e>>2;if(d>>>0<=((g>>2)-i|0)>>>0){a:do if((f|0)==(h|0))j=19;else{while(1){c[k>>2]=At(7040)|0;kh(a,k);d=d+-1|0;if(!d)break;if((c[q>>2]|0)==(c[r>>2]|0)){j=19;break a}}d=c[p>>2]|0}while(0);if((j|0)==19){e=d;do{c[k>>2]=At(7040)|0;lh(a,k);e=e+-1|0;b=b+1|0;d=(c[p>>2]|0)+16+((((c[r>>2]|0)-(c[s>>2]|0)|0)==4)<<31>>31)|0;c[p>>2]=d}while((e|0)!=0)}c[p>>2]=d-(b<<4);if(!b){l=t;return}j=c[r>>2]|0;do{k=c[s>>2]|0;m=c[k>>2]|0;k=k+4|0;c[s>>2]=k;p=c[q>>2]|0;d=p;h=j;do if((j|0)==(p|0)){e=c[a>>2]|0;f=e;if(k>>>0>e>>>0){d=k;f=((d-f>>2)+1|0)/-2|0;g=k+(f<<2)|0;d=h-d|0;e=d>>2;if(!e)d=k;else{hv(g|0,k|0,d|0)|0;d=c[s>>2]|0}p=g+(e<<2)|0;c[r>>2]=p;c[s>>2]=d+(f<<2);d=p;break}i=d-f>>1;i=(i|0)==0?1:i;p=At(i<<2)|0;g=p;d=p+(i>>>2<<2)|0;h=d;i=p+(i<<2)|0;if((k|0)==(j|0))d=h;else{f=d;d=h;e=k;do{c[f>>2]=c[e>>2];f=d+4|0;d=f;e=e+4|0}while((e|0)!=(j|0));e=c[a>>2]|0}c[a>>2]=g;c[s>>2]=h;c[r>>2]=d;c[q>>2]=i;if(e){Dt(e);d=c[r>>2]|0}}else d=j;while(0);c[d>>2]=m;j=(c[r>>2]|0)+4|0;c[r>>2]=j;b=b+-1|0}while((b|0)!=0);l=t;return}o=b<<4;e=g>>1;n=i+d|0;e=e>>>0<n>>>0?n:e;if(!e)g=0;else g=At(e<<2)|0;k=g+(i-b<<2)|0;h=g;f=k;j=g+(e<<2)|0;do{n=At(7040)|0;m=k;e=k;do if((m|0)==(j|0)){i=f;if(i>>>0>h>>>0){i=i+((((f-h>>2)+1|0)/-2|0)<<2)|0;e=k-f|0;g=e>>2;if(g|0)hv(i|0,f|0,e|0)|0;e=i+(g<<2)|0;f=i;g=e;break}j=j-h>>1;j=(j|0)==0?1:j;g=At(j<<2)|0;k=g;e=g+(j>>>2<<2)|0;f=e;j=g+(j<<2)|0;if((i|0)==(m|0))g=f;else{g=f;do{c[e>>2]=c[i>>2];e=g+4|0;g=e;i=i+4|0}while((i|0)!=(m|0))}e=g;if(!h)h=k;else{Dt(h);h=k}}else g=k;while(0);c[e>>2]=n;k=g+4|0;d=d+-1|0}while((d|0)!=0);if(!b){g=k;b=j;e=c[s>>2]|0}else{n=h;m=f;g=k;e=c[s>>2]|0;while(1){k=g;d=g;do if((k|0)==(j|0)){h=m;if(h>>>0>n>>>0){h=h+((((m-n>>2)+1|0)/-2|0)<<2)|0;d=g-m|0;f=d>>2;if(f|0)hv(h|0,m|0,d|0)|0;d=h+(f<<2)|0;i=n;f=h;g=d;break}j=j-n>>1;j=(j|0)==0?1:j;m=At(j<<2)|0;i=m;d=m+(j>>>2<<2)|0;f=d;j=m+(j<<2)|0;if((h|0)==(k|0))g=f;else{g=f;do{c[d>>2]=c[h>>2];d=g+4|0;g=d;h=h+4|0}while((h|0)!=(k|0))}d=g;if(n)Dt(n)}else{i=n;f=m}while(0);c[d>>2]=c[e>>2];g=g+4|0;e=(c[s>>2]|0)+4|0;c[s>>2]=e;b=b+-1|0;if(!b){h=i;b=j;break}else{n=i;m=f}}}d=c[r>>2]|0;if((d|0)==(e|0))e=g;else{j=f;while(1){d=d+-4|0;e=j;do if((e|0)==(h|0)){k=g;if(k>>>0<b>>>0){i=k+((((b-g>>2)+1|0)/2|0)<<2)|0;e=g-j|0;n=e>>2;f=i+(0-n<<2)|0;if(!n)f=i;else hv(f|0,j|0,e|0)|0;j=f;g=i;e=f;break}b=b-h>>1;b=(b|0)==0?1:b;n=At(b<<2)|0;h=n;m=n+((b+3|0)>>>2<<2)|0;i=m;b=n+(b<<2)|0;if((e|0)==(k|0))e=i;else{g=m;f=i;do{c[g>>2]=c[e>>2];g=f+4|0;f=g;e=e+4|0}while((e|0)!=(k|0));e=f}if(!j){j=i;g=e;e=m}else{Dt(j);j=i;g=e;e=m}}while(0);c[e+-4>>2]=c[d>>2];e=j+-4|0;if((d|0)==(c[s>>2]|0)){f=e;e=g;break}else j=e}}d=c[a>>2]|0;c[a>>2]=h;c[s>>2]=f;c[r>>2]=e;c[q>>2]=b;c[p>>2]=(c[p>>2]|0)-o;if(!d){l=t;return}Dt(d);l=t;return}function kh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;n=a+8|0;j=c[n>>2]|0;k=a+12|0;m=c[k>>2]|0;f=m;h=j;do if((j|0)==(m|0)){m=a+4|0;l=c[m>>2]|0;e=c[a>>2]|0;d=e;if(l>>>0>e>>>0){e=l;f=((e-d>>2)+1|0)/-2|0;g=l+(f<<2)|0;d=h-e|0;e=d>>2;if(!e)d=l;else{hv(g|0,l|0,d|0)|0;d=c[m>>2]|0}l=g+(e<<2)|0;c[n>>2]=l;c[m>>2]=d+(f<<2);d=l;break}i=f-d>>1;i=(i|0)==0?1:i;f=At(i<<2)|0;g=f;d=f+(i>>>2<<2)|0;h=d;i=f+(i<<2)|0;if((l|0)==(j|0))d=h;else{f=d;d=h;e=l;do{c[f>>2]=c[e>>2];f=d+4|0;d=f;e=e+4|0}while((e|0)!=(j|0));e=c[a>>2]|0}c[a>>2]=g;c[m>>2]=h;c[n>>2]=d;c[k>>2]=i;if(e){Dt(e);d=c[n>>2]|0}}else d=j;while(0);c[d>>2]=c[b>>2];c[n>>2]=(c[n>>2]|0)+4;return}function lh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=a+4|0;m=c[o>>2]|0;n=c[a>>2]|0;f=n;do if((m|0)==(n|0)){n=a+8|0;e=c[n>>2]|0;l=a+12|0;k=c[l>>2]|0;d=k;if(e>>>0<k>>>0){f=e;h=((d-f>>2)+1|0)/2|0;d=e+(h<<2)|0;f=f-m|0;l=f>>2;g=d+(0-l<<2)|0;if(l){hv(g|0,m|0,f|0)|0;d=g;e=c[n>>2]|0}c[o>>2]=d;c[n>>2]=e+(h<<2);break}k=d-f>>1;k=(k|0)==0?1:k;h=At(k<<2)|0;i=h;d=h+((k+3|0)>>>2<<2)|0;j=d;k=h+(k<<2)|0;if((m|0)==(e|0)){f=j;e=m}else{h=d;f=j;g=m;do{c[h>>2]=c[g>>2];h=f+4|0;f=h;g=g+4|0}while((g|0)!=(e|0));e=c[a>>2]|0}c[a>>2]=i;c[o>>2]=j;c[n>>2]=f;c[l>>2]=k;if(e){Dt(e);d=c[o>>2]|0}}else d=m;while(0);c[d+-4>>2]=c[b>>2];c[o>>2]=(c[o>>2]|0)+-4;return}
function qb(a){a=a|0;var b=0;b=l;l=l+a|0;l=l+15&-16;return b|0}function rb(){return l|0}function sb(a){a=a|0;l=a}function tb(a,b){a=a|0;b=b|0;l=a;m=b}function ub(a,b){a=a|0;b=b|0;if(!o){o=a;p=b}}function vb(a){a=a|0;D=a}function wb(){return D|0}function xb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;return (c[994468+((d<<6|a|b<<13&57344|e<<12|6-(b>>>3)<<15)>>>5<<2)>>2]&1<<(a&31)|0)!=0|0}function yb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;n=At(3932160)|0;Wu(n|0,0,3932160)|0;f=0;do{g=f&63;i=f>>>6&63;k=f>>>12&1;a=6-(f>>>15&7)<<3;h=a|f>>>13&3;do if((i|0)==(h|0)|((g|0)==(h|0)?1:(c[1019044+(g<<8)+(i<<2)>>2]|0)<2))a=0;else{if(!k){e=31888+(h<<3)|0;d=30544+(i<<3)|0;if(!((c[d>>2]&c[e>>2]|0)==0?(c[d+4>>2]&c[e+4>>2]|0)==0:0)){a=0;break}if((a|0)==48?(j=h+8|0,(g|0)!=(j|0)):0){if((c[1019044+(i<<8)+(j<<2)>>2]|0)>1){a=4;break}e=34448+(g<<3)|0;d=30544+(j<<3)|0;if(!((c[d>>2]&c[e>>2]|0)==0?(c[d+4>>2]&c[e+4>>2]|0)==0:0)){a=4;break}}}else{b=34448+(i<<3)|0;a=c[b>>2]|0;b=c[b+4>>2]|0;e=34448+(g<<3)|0;d=c[e>>2]|0;e=c[e+4>>2]|0;o=31888+(h<<3)|0;if((a&~(c[o>>2]|d)|0)==0?(b&~(c[o+4>>2]|e)|0)==0:0){a=2;break}o=30544+(h<<3)|0;if(!((a&~d&c[o>>2]|0)==0?(b&~e&c[o+4>>2]|0)==0:0)){a=2;break}}a=1}while(0);c[n+(f*20|0)>>2]=k;c[n+(f*20|0)+4>>2]=g;c[n+(f*20|0)+8>>2]=i;c[n+(f*20|0)+12>>2]=h;c[n+(f*20|0)+16>>2]=a;f=f+1|0}while((f|0)!=196608);do{i=0;j=0;do{h=n+(i*20|0)+16|0;if((c[h>>2]|0)==1){if(!(c[n+(i*20|0)>>2]|0)){g=c[n+(i*20|0)+4>>2]|0;e=34448+(g<<3)|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if((d|0)==0&(e|0)==0){a=0;b=c[n+(i*20|0)+12>>2]|0}else{b=c[n+(i*20|0)+12>>2]|0;f=c[n+(i*20|0)+8>>2]<<6|b<<13&57344|6-(b>>>3)<<15;a=0;do{o=Qa(d|0,e|0,0)|0;k=Yu(d|0,e|0,-1,-1)|0;d=k&d;e=D&e;a=c[n+((f|o|4096)*20|0)+16>>2]|a}while(!((d|0)==0&(e|0)==0))}if((b>>3|0)<6){o=b+8|0;a=c[n+((g|o<<13&57344|6-(o>>>3)<<15|c[n+(i*20|0)+8>>2]<<6|4096)*20|0)+16>>2]|a}if(((b&-8|0)==8?(l=b+8|0,(l|0)!=(g|0)):0)?(m=c[n+(i*20|0)+8>>2]|0,(l|0)!=(m|0)):0){o=b+16|0;a=c[n+((g|o<<13&57344|6-(o>>>3)<<15|m<<6|4096)*20|0)+16>>2]|a}a=(a&4|0)==0?2-(a&1)|0:4}else{d=34448+(c[n+(i*20|0)+8>>2]<<3)|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if((b|0)==0&(d|0)==0)a=0;else{e=c[n+(i*20|0)+12>>2]|0;e=e<<13&57344|c[n+(i*20|0)+4>>2]|6-(e>>>3)<<15;a=0;do{o=Qa(b|0,d|0,0)|0;k=Yu(b|0,d|0,-1,-1)|0;b=k&b;d=D&d;a=c[n+((e|o<<6)*20|0)+16>>2]|a}while(!((b|0)==0&(d|0)==0))}a=(a&2|0)==0?(a&1|0?1:4):2}c[h>>2]=a;a=(a|0)!=1}else a=0;j=a&1|j;i=i+1|0}while((i|0)!=196608)}while((j|0)!=0);a=0;do{b=994468+(a>>>5<<2)|0;if((c[n+(a*20|0)+16>>2]|0)==4)c[b>>2]=c[b>>2]|1<<(a&31);a=a+1|0}while((a|0)!=196608);Dt(n);return}function zb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[248615]=p;c[248614]=p;c[248616]=p+144;It(p,b);p=(c[248615]|0)+12|0;c[248615]=p;It(p,d);p=(c[248615]|0)+12|0;c[248615]=p;It(p,e);p=(c[248615]|0)+12|0;c[248615]=p;It(p,f);p=(c[248615]|0)+12|0;c[248615]=p;It(p,g);p=(c[248615]|0)+12|0;c[248615]=p;It(p,h);p=(c[248615]|0)+12|0;c[248615]=p;It(p,i);p=(c[248615]|0)+12|0;c[248615]=p;It(p,j);p=(c[248615]|0)+12|0;c[248615]=p;It(p,k);p=(c[248615]|0)+12|0;c[248615]=p;It(p,m);p=(c[248615]|0)+12|0;c[248615]=p;It(p,n);p=(c[248615]|0)+12|0;c[248615]=p;It(p,o);c[248615]=(c[248615]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function Ab(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[259114]=p;c[259113]=p;c[259115]=p+144;It(p,b);p=(c[259114]|0)+12|0;c[259114]=p;It(p,d);p=(c[259114]|0)+12|0;c[259114]=p;It(p,e);p=(c[259114]|0)+12|0;c[259114]=p;It(p,f);p=(c[259114]|0)+12|0;c[259114]=p;It(p,g);p=(c[259114]|0)+12|0;c[259114]=p;It(p,h);p=(c[259114]|0)+12|0;c[259114]=p;It(p,i);p=(c[259114]|0)+12|0;c[259114]=p;It(p,j);p=(c[259114]|0)+12|0;c[259114]=p;It(p,k);p=(c[259114]|0)+12|0;c[259114]=p;It(p,m);p=(c[259114]|0)+12|0;c[259114]=p;It(p,n);p=(c[259114]|0)+12|0;c[259114]=p;It(p,o);c[259114]=(c[259114]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function Bb(){var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;s=l;l=l+32|0;j=s+16|0;k=s;b=0;do{r=b-(b>>>1&21845)|0;r=(r>>>2&13107)+(r&13107)|0;a[1167548+b>>0]=(((r>>>4)+r&3855)*257|0)>>>8;b=b+1|0}while((b|0)!=65536);b=0;do{q=gv(1,0,b|0)|0;r=30544+(b<<3)|0;c[r>>2]=q;c[r+4>>2]=D;b=b+1|0}while((b|0)!=64);b=2;d=0;e=c[259117]|0;do{r=Yu(b|0,d|0,-1,-1)|0;e=e+((r&b|0)==0&(D&d|0)==0&1)|0;c[1036464+(b<<2)>>2]=e;b=Yu(b|0,d|0,1,0)|0;d=D}while(d>>>0<0|(d|0)==0&b>>>0<256);r=31056;c[r>>2]=16843009;c[r+4>>2]=16843009;r=31064;c[r>>2]=33686018;c[r+4>>2]=33686018;r=31072;c[r>>2]=67372036;c[r+4>>2]=67372036;r=31080;c[r>>2]=134744072;c[r+4>>2]=134744072;r=31088;c[r>>2]=269488144;c[r+4>>2]=269488144;r=31096;c[r>>2]=538976288;c[r+4>>2]=538976288;r=31104;c[r>>2]=1077952576;c[r+4>>2]=1077952576;r=31112;c[r>>2]=-2139062144;c[r+4>>2]=-2139062144;r=31120;c[r>>2]=255;c[r+4>>2]=0;r=31128;c[r>>2]=65280;c[r+4>>2]=0;r=31136;c[r>>2]=16711680;c[r+4>>2]=0;r=31144;c[r>>2]=-16777216;c[r+4>>2]=0;r=31152;c[r>>2]=0;c[r+4>>2]=255;r=31160;c[r>>2]=0;c[r+4>>2]=65280;r=31168;c[r>>2]=0;c[r+4>>2]=16711680;r=31176;c[r>>2]=0;c[r+4>>2]=-16777216;r=31184;c[r>>2]=33686018;c[r+4>>2]=33686018;r=31192;c[r>>2]=84215045;c[r+4>>2]=84215045;r=31200;c[r>>2]=168430090;c[r+4>>2]=168430090;r=31208;c[r>>2]=336860180;c[r+4>>2]=336860180;r=31216;c[r>>2]=673720360;c[r+4>>2]=673720360;r=31224;c[r>>2]=1347440720;c[r+4>>2]=1347440720;r=31232;c[r>>2]=-1600085856;c[r+4>>2]=-1600085856;r=31240;c[r>>2]=1077952576;c[r+4>>2]=1077952576;r=31312;q=c[r>>2]|0;r=c[r+4>>2]|0;b=31320;c[b>>2]=q|255;c[b+4>>2]=r;b=31248;c[b>>2]=q&-256^-256;c[b+4>>2]=~r;b=31328;c[b>>2]=q|65535;c[b+4>>2]=r;b=31256;c[b>>2]=q&-65536^-65536;c[b+4>>2]=~r;b=31336;c[b>>2]=q|16777215;c[b+4>>2]=r;b=31264;c[b>>2]=q&-16777216^-16777216;c[b+4>>2]=~r;b=31344;c[b>>2]=-1;c[b+4>>2]=r;b=31272;c[b>>2]=0;c[b+4>>2]=~r;b=31352;c[b>>2]=-1;c[b+4>>2]=r|255;b=31280;c[b>>2]=0;c[b+4>>2]=r&-256^-256;b=31360;c[b>>2]=-1;c[b+4>>2]=r|65535;b=31288;c[b>>2]=0;c[b+4>>2]=r&-65536^-65536;b=31368;c[b>>2]=-1;c[b+4>>2]=r|16777215;b=31296;c[b>>2]=0;c[b+4>>2]=r&-16777216^-16777216;b=0;do{q=31248+(b>>3<<3)|0;o=c[q>>2]|0;q=c[q+4>>2]|0;r=b&7;p=31056+(r<<3)|0;n=c[p>>2]&o;p=c[p+4>>2]&q;m=109200+(b<<3)|0;c[m>>2]=n;c[m+4>>2]=p;r=31184+(r<<3)|0;o=c[r>>2]&o;q=c[r+4>>2]&q;r=111248+(b<<3)|0;c[r>>2]=o;c[r+4>>2]=q;r=110224+(b<<3)|0;c[r>>2]=n|o;c[r+4>>2]=p|q;b=b+1|0}while((b|0)!=64);b=0;do{q=31312+(b>>3<<3)|0;o=c[q>>2]|0;q=c[q+4>>2]|0;r=b&7;p=31056+(r<<3)|0;n=c[p>>2]&o;p=c[p+4>>2]&q;m=109712+(b<<3)|0;c[m>>2]=n;c[m+4>>2]=p;r=31184+(r<<3)|0;o=c[r>>2]&o;q=c[r+4>>2]&q;r=111760+(b<<3)|0;c[r>>2]=o;c[r+4>>2]=q;r=110736+(b<<3)|0;c[r>>2]=n|o;c[r+4>>2]=p|q;b=b+1|0}while((b|0)!=64);d=0;do{e=d&7;f=d>>3;b=0;do{if((d|0)!=(b|0)){r=b&7;r=e>>>0<r>>>0?r-e|0:e-r|0;p=b>>3;p=(f|0)<(p|0)?p-f|0:f-p|0;r=(r|0)<(p|0)?p:r;c[1019044+(d<<8)+(b<<2)>>2]=r;r=105104+(d<<6)+(r+-1<<3)|0;p=30544+(b<<3)|0;o=r;q=c[o+4>>2]|c[p+4>>2];c[r>>2]=c[o>>2]|c[p>>2];c[r+4>>2]=q}b=b+1|0}while((b|0)!=64);d=d+1|0}while((d|0)!=64);e=1;do{g=c[1488+(e*36|0)>>2]|0;if(!(57>>>e&1)){d=0;do{h=31376+(e<<9)+(d<<3)|0;f=0;b=g;do{b=b+d|0;if(b>>>0<64?(c[1019044+(d<<8)+(b<<2)>>2]|0)<3:0){p=30544+(b<<3)|0;o=h;q=c[o+4>>2]|c[p+4>>2];r=h;c[r>>2]=c[o>>2]|c[p>>2];c[r+4>>2]=q}f=f+1|0;b=c[1488+(e*36|0)+(f<<2)>>2]|0}while((b|0)!=0);d=d+1|0}while((d|0)!=64)}e=e+1|0}while((e|0)!=7);e=1;do{g=c[1488+(e*36|0)>>2]|0;h=e+8|0;if(!(57>>>e&1)){d=0;do{i=31376+(h<<9)+(d<<3)|0;f=0;b=g;do{b=d-b|0;if(b>>>0<64?(c[1019044+(d<<8)+(b<<2)>>2]|0)<3:0){p=30544+(b<<3)|0;o=i;q=c[o+4>>2]|c[p+4>>2];r=i;c[r>>2]=c[o>>2]|c[p>>2];c[r+4>>2]=q}f=f+1|0;b=c[1488+(e*36|0)+(f<<2)>>2]|0}while((b|0)!=0);d=d+1|0}while((d|0)!=64)}e=e+1|0}while((e|0)!=7);c[j>>2]=c[435];c[j+4>>2]=c[436];c[j+8>>2]=c[437];c[j+12>>2]=c[438];c[k>>2]=c[439];c[k+4>>2]=c[440];c[k+8>>2]=c[441];c[k+12>>2]=c[442];Eb(116368,1035428,29008,28496,1035684,j,27);Eb(935568,1035940,30032,29520,1036196,k,28);n=0;do{o=1035940+(n<<2)|0;m=c[o>>2]|0;k=c[m>>2]|0;m=c[m+4>>2]|0;q=113808+(n<<3)|0;c[q>>2]=k;c[q+4>>2]=m;q=114832+(n<<3)|0;p=q;c[p>>2]=k;c[p+4>>2]=m;p=1035428+(n<<2)|0;r=c[p>>2]|0;j=c[r>>2]|0;r=c[r+4>>2]|0;i=114320+(n<<3)|0;c[i>>2]=j;c[i+4>>2]=r;c[q>>2]=j|k;c[q+4>>2]=r|m;q=30544+(n<<3)|0;m=3;do{r=112272+(m<<9)+(n<<3)|0;k=m&255;d=31376+(m<<9)+(n<<3)|0;if((k&7)==3){b=0;do{k=r;e=30544+(b<<3)|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d&c[k>>2]|0)==0?(e&c[k+4>>2]|0)==0:0)){h=c[o>>2]|0;k=c[1035940+(b<<2)>>2]|0;g=q;j=c[g+4>>2]|c[k+4>>2]&c[h+4>>2]|e;i=72336+(n<<9)+(b<<3)|0;c[i>>2]=c[g>>2]|c[k>>2]&c[h>>2]|d;c[i+4>>2]=j;i=Cb(m,n,d,e)|0;j=D;h=q;h=Cb(m,b,c[h>>2]|0,c[h+4>>2]|0)|0;k=39568+(n<<9)+(b<<3)|0;c[k>>2]=h&i;c[k+4>>2]=D&j}b=b+1|0}while((b|0)!=64)}else{b=0;do{j=r;f=30544+(b<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(!((e&c[j>>2]|0)==0?(f&c[j+4>>2]|0)==0:0)){switch(k&7){case 5:{i=c[o>>2]|0;u=c[p>>2]|0;j=c[1035940+(b<<2)>>2]|0;t=c[1035428+(b<<2)>>2]|0;g=c[u>>2]|c[i>>2];h=c[t>>2]|c[j>>2];i=c[u+4>>2]|c[i+4>>2];j=c[t+4>>2]|c[j+4>>2];break}case 4:{i=c[p>>2]|0;j=c[1035428+(b<<2)>>2]|0;g=c[i>>2]|0;h=c[j>>2]|0;i=c[i+4>>2]|0;j=c[j+4>>2]|0;break}default:{i=d;j=31376+(m<<9)+(b<<3)|0;g=c[i>>2]|0;h=c[j>>2]|0;i=c[i+4>>2]|0;j=c[j+4>>2]|0}}u=q;t=c[u+4>>2]|j&i|f;j=72336+(n<<9)+(b<<3)|0;c[j>>2]=c[u>>2]|h&g|e;c[j+4>>2]=t;j=Cb(m,n,e,f)|0;t=D;i=q;i=Cb(m,b,c[i>>2]|0,c[i+4>>2]|0)|0;u=39568+(n<<9)+(b<<3)|0;c[u>>2]=i&j;c[u+4>>2]=D&t}b=b+1|0}while((b|0)!=64)}m=m+1|0}while((m|0)!=5);n=n+1|0}while((n|0)!=64);l=s;return}function Cb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;switch(a&7){case 3:{f=29520+(b<<3)|0;a=30032+(b<<3)|0;e=(S(c[f+4>>2]&e,c[a+4>>2]|0)|0)^(S(c[f>>2]&d,c[a>>2]|0)|0);e=(c[1035940+(b<<2)>>2]|0)+(e>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;d=c[e+4>>2]|0;e=c[e>>2]|0;D=d;return e|0}case 4:{a=28496+(b<<3)|0;f=29008+(b<<3)|0;f=(S(c[a+4>>2]&e,c[f+4>>2]|0)|0)^(S(c[a>>2]&d,c[f>>2]|0)|0);f=(c[1035428+(b<<2)>>2]|0)+(f>>>(c[1035684+(b<<2)>>2]|0)<<3)|0;e=c[f+4>>2]|0;f=c[f>>2]|0;D=e;return f|0}case 5:{g=29520+(b<<3)|0;f=30032+(b<<3)|0;f=(S(c[g+4>>2]&e,c[f+4>>2]|0)|0)^(S(c[g>>2]&d,c[f>>2]|0)|0);f=(c[1035940+(b<<2)>>2]|0)+(f>>>(c[1036196+(b<<2)>>2]|0)<<3)|0;g=28496+(b<<3)|0;a=29008+(b<<3)|0;d=(S(c[g+4>>2]&e,c[a+4>>2]|0)|0)^(S(c[g>>2]&d,c[a>>2]|0)|0);d=(c[1035428+(b<<2)>>2]|0)+(d>>>(c[1035684+(b<<2)>>2]|0)<<3)|0;e=c[d+4>>2]|c[f+4>>2];f=c[d>>2]|c[f>>2];D=e;return f|0}default:{g=31376+(a<<9)+(b<<3)|0;f=c[g+4>>2]|0;g=c[g>>2]|0;D=f;return g|0}}return 0}function Db(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=28496+(a<<3)|0;e=29008+(a<<3)|0;d=(S(c[f+4>>2]&d,c[e+4>>2]|0)|0)^(S(c[f>>2]&b,c[e>>2]|0)|0);return d>>>(c[1035684+(a<<2)>>2]|0)|0}function Eb(a,b,e,f,g,h,i){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;y=l;l=l+81920|0;v=y+32768|0;w=y;x=y+65536|0;Wu(x|0,0,16384)|0;c[b>>2]=a;a=0;u=0;while(1){p=u>>3;k=31120+(p<<3)|0;t=31056+((u&7)<<3)|0;j=c[t>>2]&-2122219135^-2122219135|c[k>>2]&255^255;k=c[t+4>>2]&-2122219135^-2122219135|c[k+4>>2]&-16777216^-16777216;t=Gb(h,u,0,0)|0;j=t&~j;k=D&~k;t=f+(u<<3)|0;m=t;c[m>>2]=j;c[m+4>>2]=k;m=av(j|0,k|0,16)|0;s=av(j|0,k|0,48)|0;c[g+(u<<2)>>2]=32-(d[1167548+(j&65535)>>0]|0)-(d[1167548+(m&65535)>>0]|0)-(d[1167548+(k&65535)>>0]|0)-(d[1167548+s>>0]|0);s=0;m=0;n=0;while(1){r=v+(s<<3)|0;c[r>>2]=m;c[r+4>>2]=n;r=Gb(h,u,m,n)|0;o=w+(s<<3)|0;c[o>>2]=r;c[o+4>>2]=D;o=s+1|0;r=Vu(m|0,n|0,j|0,k|0)|0;m=r&j;n=D&k;if((m|0)==0&(n|0)==0)break;else s=o}if((u|0)<63){q=b+(u<<2)|0;c[b+(u+1<<2)>>2]=(c[q>>2]|0)+(o<<3)}else q=b+(u<<2)|0;k=c[1772+(p<<2)>>2]|0;j=((k|0)<0)<<31>>31;r=e+(u<<3)|0;a:do if((s|0)<0){do{n=av(k|0,j|0,12)|0;n=n^k;p=D^j;s=gv(n|0,p|0,25)|0;n=s^n;p=D^p;s=av(n|0,p|0,27)|0;n=s^n;p=D^p;s=fv(n|0,p|0,1332534557,625341585)|0;q=D;o=av(n|0,p|0,12)|0;n=o^n;p=D^p;o=gv(n|0,p|0,25)|0;n=o^n;p=D^p;o=av(n|0,p|0,27)|0;n=o^n;p=D^p;o=fv(n|0,p|0,1332534557,625341585)|0;q=D&q;m=av(n|0,p|0,12)|0;n=m^n;p=D^p;m=gv(n|0,p|0,25)|0;n=m^n;p=D^p;m=av(n|0,p|0,27)|0;k=m^n;j=D^p;p=fv(k|0,j|0,1332534557,625341585)|0;p=o&s&p;q=q&D;s=r;c[s>>2]=p;c[s+4>>2]=q;s=t;s=fv(p|0,q|0,c[s>>2]|0,c[s+4>>2]|0)|0;s=av(s|0,D|0,56)|0}while((((d[1167548]|0)*3|0)+(d[1167548+s>>0]|0)|0)>>>0<6);a=a+1|0}else b:while(1){do{z=av(k|0,j|0,12)|0;z=z^k;n=D^j;p=gv(z|0,n|0,25)|0;z=p^z;n=D^n;p=av(z|0,n|0,27)|0;z=p^z;n=D^n;p=fv(z|0,n|0,1332534557,625341585)|0;o=D;m=av(z|0,n|0,12)|0;z=m^z;n=D^n;m=gv(z|0,n|0,25)|0;z=m^z;n=D^n;m=av(z|0,n|0,27)|0;z=m^z;n=D^n;m=fv(z|0,n|0,1332534557,625341585)|0;o=D&o;A=av(z|0,n|0,12)|0;z=A^z;n=D^n;A=gv(z|0,n|0,25)|0;z=A^z;n=D^n;A=av(z|0,n|0,27)|0;k=A^z;j=D^n;n=fv(k|0,j|0,1332534557,625341585)|0;n=m&p&n;o=o&D;p=r;c[p>>2]=n;c[p+4>>2]=o;p=t;p=fv(n|0,o|0,c[p>>2]|0,c[p+4>>2]|0)|0;p=av(p|0,D|0,56)|0}while((((d[1167548]|0)*3|0)+(d[1167548+p>>0]|0)|0)>>>0<6);n=a+1|0;m=0;while(1){o=v+(m<<3)|0;o=ab[i&31](u,c[o>>2]|0,c[o+4>>2]|0)|0;p=x+(o<<2)|0;if((c[p>>2]|0)>(a|0)){z=(c[q>>2]|0)+(o<<3)|0;A=w+(m<<3)|0;if(!((c[z>>2]|0)==(c[A>>2]|0)?(c[z+4>>2]|0)==(c[A+4>>2]|0):0)){a=n;continue b}}else{c[p>>2]=n;p=w+(m<<3)|0;z=c[p+4>>2]|0;A=(c[q>>2]|0)+(o<<3)|0;c[A>>2]=c[p>>2];c[A+4>>2]=z}if((m|0)<(s|0))m=m+1|0;else{a=n;break a}}}while(0);u=u+1|0;if((u|0)==64)break}l=y;return}function Fb(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;f=29520+(a<<3)|0;e=30032+(a<<3)|0;d=(S(c[f+4>>2]&d,c[e+4>>2]|0)|0)^(S(c[f>>2]&b,c[e>>2]|0)|0);return d>>>(c[1036196+(a<<2)>>2]|0)|0}function Gb(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;i=c[a>>2]|0;f=i+b|0;a:do if(f>>>0<64){g=f;f=0;h=0;do{if((c[1019044+(g<<8)+(g-i<<2)>>2]|0)!=1)break a;j=30544+(g<<3)|0;k=c[j>>2]|0;j=c[j+4>>2]|0;f=k|f;h=j|h;g=i+g|0}while((k&d|0)==0&(j&e|0)==0&g>>>0<64)}else{f=0;h=0}while(0);i=c[a+4>>2]|0;g=i+b|0;b:do if(g>>>0<64)do{if((c[1019044+(g<<8)+(g-i<<2)>>2]|0)!=1)break b;k=30544+(g<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;f=j|f;h=k|h;g=i+g|0}while((j&d|0)==0&(k&e|0)==0&g>>>0<64);while(0);i=c[a+8>>2]|0;g=i+b|0;c:do if(g>>>0<64)do{if((c[1019044+(g<<8)+(g-i<<2)>>2]|0)!=1)break c;k=30544+(g<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;f=j|f;h=k|h;g=i+g|0}while((j&d|0)==0&(k&e|0)==0&g>>>0<64);while(0);i=c[a+12>>2]|0;g=i+b|0;if(g>>>0>=64){j=h;k=f;D=j;return k|0}while(1){if((c[1019044+(g<<8)+(g-i<<2)>>2]|0)!=1){g=13;break}k=30544+(g<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;f=j|f;h=k|h;g=i+g|0;if(!((j&d|0)==0&(k&e|0)==0&g>>>0<64)){g=13;break}}if((g|0)==13){D=h;return f|0}return 0}function Hb(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[259373]=p;c[259372]=p;c[259374]=p+144;It(p,b);p=(c[259373]|0)+12|0;c[259373]=p;It(p,d);p=(c[259373]|0)+12|0;c[259373]=p;It(p,e);p=(c[259373]|0)+12|0;c[259373]=p;It(p,f);p=(c[259373]|0)+12|0;c[259373]=p;It(p,g);p=(c[259373]|0)+12|0;c[259373]=p;It(p,h);p=(c[259373]|0)+12|0;c[259373]=p;It(p,i);p=(c[259373]|0)+12|0;c[259373]=p;It(p,j);p=(c[259373]|0)+12|0;c[259373]=p;It(p,k);p=(c[259373]|0)+12|0;c[259373]=p;It(p,m);p=(c[259373]|0)+12|0;c[259373]=p;It(p,n);p=(c[259373]|0)+12|0;c[259373]=p;It(p,o);c[259373]=(c[259373]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function Ib(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;c[a+4>>2]=0;c[a+8>>2]=0;c[a>>2]=a+4;c[a+16>>2]=0;c[a+20>>2]=0;c[a+12>>2]=a+16;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20628,4);Jb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20633,5);Kb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20639,5);Lb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20645,5);Mb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20651,5);Nb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20657,5);Ob(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20663,5);Pb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20669,5);Qb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20675,5);Rb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20681,6);Sb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20688,6);Tb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20695,6);Ub(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20702,6);Vb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20709,6);Wb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20716,7);Xb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20724,8);Yb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20733,3);Zb(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20737,3);_b(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20741,3);$b(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20628,4);ac(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20745,4);bc(a,d);Mt(d);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,20633,5);cc(a,d);Mt(d);l=b;return}function Jb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2956;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2956;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Kb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2932;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2932;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Lb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2652;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2652;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Mb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2628;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2628;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Nb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2604;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2604;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Ob(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2580;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2580;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Pb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2556;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2556;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Qb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2532;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2532;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function Rb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2508;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2508;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Sb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2484;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2484;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Tb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2460;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2460;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Ub(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2436;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2436;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Vb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2412;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2412;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Wb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2388;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2388;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Xb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2364;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2364;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Yb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;p=l;l=l+11200|0;n=p+11192|0;j=p+5376|0;h=p+5816|0;k=p;o=a+12|0;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+16|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);i=a+20|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2308;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,0,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[o>>2]>>2]|0;if(!e)e=d;else{c[o>>2]=e;e=c[f>>2]|0}dc(c[a+16>>2]|0,e);a=a+20|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;o=At(12)|0;c[o>>2]=2308;c[o+4>>2]=1;c[o+8>>2]=0;d=c[a>>2]|0;c[a>>2]=o;if(!d){l=p;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=p;return}function Zb(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,1,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2284;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,1,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2284;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function _b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,1,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2260;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,1,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2260;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function $b(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,1,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2204;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,1,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2204;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function ac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,2,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=2180;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,2,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=2180;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function bc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,2,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=1868;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,2,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=1868;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function cc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+11200|0;n=o+11192|0;j=o+5376|0;h=o+5816|0;k=o;Wu(h|0,0,5376)|0;h=(c[(Nf(h,b,0,2,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;m=a+4|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=4;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=9;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=8;break}else d=e}}if((i|0)==4){c[n>>2]=d;e=d;f=d;break}else if((i|0)==8){c[n>>2]=d;e=d;break}else if((i|0)==9){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;i=d+16|0;c[i>>2]=g;c[i+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);i=a+8|0;c[i>>2]=(c[i>>2]|0)+1}i=d+24|0;h=At(12)|0;c[h>>2]=1844;c[h+4>>2]=0;c[h+8>>2]=1;d=c[i>>2]|0;c[i>>2]=h;if(d|0)db[c[(c[d>>2]|0)+4>>2]&255](d);Wu(k|0,0,5376)|0;h=(c[(Nf(k,b,1,2,j)|0)+5356>>2]|0)+8|0;g=c[h>>2]|0;h=c[h+4>>2]|0;d=c[m>>2]|0;do if(d){while(1){f=d+16|0;e=c[f>>2]|0;f=c[f+4>>2]|0;if(h>>>0<f>>>0|(h|0)==(f|0)&g>>>0<e>>>0){e=c[d>>2]|0;if(!e){i=20;break}else d=e}else{if(!(f>>>0<h>>>0|(f|0)==(h|0)&e>>>0<g>>>0)){i=25;break}f=d+4|0;e=c[f>>2]|0;if(!e){i=24;break}else d=e}}if((i|0)==20){c[n>>2]=d;e=d;f=d;break}else if((i|0)==24){c[n>>2]=d;e=d;break}else if((i|0)==25){c[n>>2]=d;e=d;f=n;break}}else{c[n>>2]=m;e=m;f=m}while(0);d=c[f>>2]|0;if(!d){d=At(32)|0;n=d+16|0;c[n>>2]=g;c[n+4>>2]=h;c[d+24>>2]=0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=e;c[f>>2]=d;e=c[c[a>>2]>>2]|0;if(!e)e=d;else{c[a>>2]=e;e=c[f>>2]|0}dc(c[a+4>>2]|0,e);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1}a=d+24|0;n=At(12)|0;c[n>>2]=1844;c[n+4>>2]=1;c[n+8>>2]=0;d=c[a>>2]|0;c[a>>2]=n;if(!d){l=o;return}db[c[(c[d>>2]|0)+4>>2]&255](d);l=o;return}function dc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=(d|0)==(b|0);a[d+12>>0]=i&1;if(i)return;while(1){i=c[d+8>>2]|0;f=i+12|0;if(a[f>>0]|0){e=37;break}h=i+8|0;g=c[h>>2]|0;e=c[g>>2]|0;if((e|0)==(i|0)){e=c[g+4>>2]|0;if(!e){e=8;break}e=e+12|0;if(a[e>>0]|0){e=8;break}a[f>>0]=1;a[g+12>>0]=(g|0)==(b|0)&1;a[e>>0]=1}else{if(!e){e=24;break}e=e+12|0;if(a[e>>0]|0){e=24;break}a[f>>0]=1;a[g+12>>0]=(g|0)==(b|0)&1;a[e>>0]=1}if((g|0)==(b|0)){e=37;break}else d=g}if((e|0)==8){if((c[i>>2]|0)==(d|0)){d=i;b=g}else{b=i+4|0;d=c[b>>2]|0;e=c[d>>2]|0;c[b>>2]=e;if(!e)e=g;else{c[e+8>>2]=i;e=c[h>>2]|0}f=d+8|0;c[f>>2]=e;e=c[h>>2]|0;if((c[e>>2]|0)==(i|0))c[e>>2]=d;else c[e+4>>2]=d;c[d>>2]=i;c[h>>2]=d;b=c[f>>2]|0}a[d+12>>0]=1;a[b+12>>0]=0;f=c[b>>2]|0;g=f+4|0;d=c[g>>2]|0;c[b>>2]=d;if(d|0)c[d+8>>2]=b;d=b+8|0;c[f+8>>2]=c[d>>2];e=c[d>>2]|0;if((c[e>>2]|0)==(b|0))c[e>>2]=f;else c[e+4>>2]=f;c[g>>2]=b;c[d>>2]=f;return}else if((e|0)==24){if((c[i>>2]|0)==(d|0)){d=c[i>>2]|0;b=d+4|0;e=c[b>>2]|0;c[i>>2]=e;if(!e)e=g;else{c[e+8>>2]=i;e=c[h>>2]|0}f=d+8|0;c[f>>2]=e;e=c[h>>2]|0;if((c[e>>2]|0)==(i|0))c[e>>2]=d;else c[e+4>>2]=d;c[b>>2]=i;c[h>>2]=d;g=c[f>>2]|0}else d=i;a[d+12>>0]=1;a[g+12>>0]=0;i=g+4|0;f=c[i>>2]|0;d=c[f>>2]|0;c[i>>2]=d;if(d|0)c[d+8>>2]=g;d=g+8|0;c[f+8>>2]=c[d>>2];e=c[d>>2]|0;if((c[e>>2]|0)==(g|0))c[e>>2]=f;else c[e+4>>2]=f;c[f>>2]=g;c[d>>2]=f;return}else if((e|0)==37)return}function ec(a){a=a|0;return}function fc(a){a=a|0;Dt(a);return}function gc(a){a=a|0;return c[a+4>>2]|0}function hc(a,b){a=a|0;b=b|0;return 0}function ic(a){a=a|0;Dt(a);return}function jc(a){a=a|0;return c[a+4>>2]|0}function kc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+4112|0;d=i;h=b+5348|0;e=a+8|0;if((c[h>>2]|0)==(c[e>>2]|0)?(f=kf(b,d)|0,c[d+4096>>2]=f,(f|0)==(d|0)):0){l=i;return 0}f=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{a=f<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else a=c[b+400+(a<<8)>>2]|0;d=c[e>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else g=14;break}case 2:{a=f<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else a=c[b+400+(a<<8)>>2]|0;d=c[e>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else g=14;break}case 1:{a=f<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else a=c[b+400+(a<<8)>>2]|0;d=c[e>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else g=14;break}default:{a=c[b+400+((f<<3|6)<<8)>>2]|0;d=c[e>>2]<<3|6;g=14}}if((g|0)==14)e=c[b+400+(d<<8)>>2]|0;d=c[1019044+(a<<8)+(e<<2)>>2]|0;a=(f|0)==(c[h>>2]|0);if((d|0)>((a?1:2)|0)){b=(c[1884+(e<<2)>>2]|0)+(c[(c[b+5356>>2]|0)+16+(f<<2)>>2]|0)+(c[2140+(d<<2)>>2]|0)|0;b=(d|0)<((a?3:4)|0)?b:b+1e4|0;l=i;return (a?b:0-b|0)|0}else{l=i;return 0}return 0}function lc(a){a=a|0;Dt(a);return}function mc(a){a=a|0;return c[a+4>>2]|0}function nc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;g=c[a+4>>2]|0;f=c[b+5364>>2]|0;switch(f|0){case 4:{d=g<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else h=12;break}case 2:{d=g<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else h=12;break}case 1:{d=g<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else h=12;break}default:{d=c[b+400+((g<<3|6)<<8)>>2]|0;a=c[a+8>>2]<<3|6;h=12}}if((h|0)==12)a=c[b+400+(a<<8)>>2]|0;a=c[1019044+(d<<8)+(a<<2)>>2]|0;e=(g|0)==(c[b+5348>>2]|0);if((a|0)<=((e?1:2)|0))return 0;switch(f|0){case 4:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=8;else h=19;break}case 2:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=8;else h=19;break}case 1:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=8;else h=19;break}default:{d=g<<3|1;h=19}}if((h|0)==19)d=c[b+400+(d<<8)>>2]>>3;h=(c[2140+((d^g*7)<<2)>>2]|0)+447+(c[2140+(a<<2)>>2]|0)|0;return (e?h:0-h|0)|0}function oc(a){a=a|0;Dt(a);return}function pc(a){a=a|0;return c[a+4>>2]|0}function qc(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[b+5348>>2]|0;switch(c[b+5364>>2]|0){case 4:{a=d<<3|2;if(!(c[b+336+(a<<2)>>2]|0))a=64;else a=c[b+400+(a<<8)>>2]|0;d=d<<3^10;if(!(c[b+336+(d<<2)>>2]|0))d=64;else e=12;break}case 2:{a=d<<3|2;if(!(c[b+336+(a<<2)>>2]|0))a=64;else a=c[b+400+(a<<8)>>2]|0;d=d<<3^10;if(!(c[b+336+(d<<2)>>2]|0))d=64;else e=12;break}case 1:{a=d<<3|2;if(!(c[b+336+(a<<2)>>2]|0))a=64;else a=c[b+400+(a<<8)>>2]|0;d=d<<3^10;if(!(c[b+336+(d<<2)>>2]|0))d=64;else e=12;break}default:{a=c[b+400+((d<<3|2)<<8)>>2]|0;d=d<<3^10;e=12}}if((e|0)==12)d=c[b+400+(d<<8)>>2]|0;e=c[2220+(c[1019044+(a<<8)+(d<<2)>>2]<<2)>>2]|0;b=d^a;return ((b>>>3^b)&1|0?-1e4-e|0:e+1e4|0)|0}function rc(a){a=a|0;Dt(a);return}function sc(a){a=a|0;return c[a+4>>2]|0}function tc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|2;if(!(c[b+336+(d<<2)>>2]|0)){g=64;f=e}else h=12;break}case 2:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|2;if(!(c[b+336+(d<<2)>>2]|0)){g=64;f=e}else h=12;break}case 1:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|2;if(!(c[b+336+(d<<2)>>2]|0)){g=64;f=e}else h=12;break}default:{a=c[a+8>>2]|0;e=c[b+400+((i<<3|6)<<8)>>2]|0;d=a<<3|2;h=12}}if((h|0)==12){g=c[b+400+(d<<8)>>2]|0;f=e}e=c[b+5348>>2]|0;d=(e|0)==(i|0);if(d?(i=32400+(g<<3)|0,h=30544+(f<<3)|0,!((c[h>>2]&c[i>>2]|0)==0?(c[h+4>>2]&c[i+4>>2]|0)==0:0)):0){i=-1e4;return i|0}if((e|0)!=(a|0)){i=1884+(g<<2)|0;i=c[i>>2]|0;i=i+1e4|0;h=1884+(f<<2)|0;h=c[h>>2]|0;h=i-h|0;i=0-h|0;i=d?h:i;return i|0}i=32400+(g<<3)|0;h=34448+(f<<3)|0;if((c[h>>2]&c[i>>2]|0)==0?(c[h+4>>2]&c[i+4>>2]|0)==0:0){i=1884+(g<<2)|0;i=c[i>>2]|0;i=i+1e4|0;h=1884+(f<<2)|0;h=c[h>>2]|0;h=i-h|0;i=0-h|0;i=d?h:i;return i|0}else{i=1e4;return i|0}return 0}function uc(a){a=a|0;Dt(a);return}function vc(a){a=a|0;return c[a+4>>2]|0}function wc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=h<<3|4;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0)){f=64;d=e}else g=12;break}case 2:{d=h<<3|4;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0)){f=64;d=e}else g=12;break}case 1:{d=h<<3|4;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0)){f=64;d=e}else g=12;break}default:{a=c[a+8>>2]|0;e=c[b+400+((h<<3|4)<<8)>>2]|0;d=a<<3|6;g=12}}if((g|0)==12){f=c[b+400+(d<<8)>>2]|0;d=e}e=(c[2220+(c[1019044+(d<<8)+(f<<2)>>2]<<2)>>2]|0)+(c[1884+(f<<2)>>2]|0)|0;i=d>>3;g=f>>3;g=(i|0)<(g|0)?g-i|0:i-g|0;d=d&7;f=f&7;f=d>>>0<f>>>0?f-d|0:d-f|0;d=(g|0)<(f|0)?f:g;switch(((f|0)<(g|0)?f:g)|0){case 0:{i=c[b+5348>>2]|0;b=((d|0)>1|(h|0)==(i|0)?-1e4:1e4)+e|0;h=(h|0)==(i|0);i=0-b|0;i=h?b:i;return i|0}case 1:{i=c[b+5348>>2]|0;b=((d|0)>1&(a|0)==(i|0)?-1e4:1e4)+e|0;h=(h|0)==(i|0);i=0-b|0;i=h?b:i;return i|0}default:{g=e+1e4|0;i=c[b+5348>>2]|0;h=(h|0)==(i|0);i=0-g|0;i=h?g:i;return i|0}}return 0}function xc(a){a=a|0;return}function yc(a){a=a|0;Dt(a);return}function zc(a){a=a|0;return c[a+4>>2]|0}function Ac(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=c[a+4>>2]|0;h=i<<3;k=h|1;j=c[b+400+(k<<8)>>2]|0;k=c[b+400+(k<<8)+4>>2]|0;a=c[a+8>>2]|0;e=c[b+5364>>2]|0;switch(e|0){case 4:{a=a<<3|6;if(!(c[b+336+(a<<2)>>2]|0))f=64;else f=c[b+400+(a<<8)>>2]|0;if(!(c[b+336+((h|6)<<2)>>2]|0)){e=b+320+((i^1)<<3)|0;a=b+264|0;d=c[a>>2]|0;a=c[a+4>>2]|0;g=109200+(i<<9)+(j<<3)|0;if((d&c[e>>2]&c[g>>2]|0)==0?(a&c[e+4>>2]&c[g+4>>2]|0)==0:0){k=255;return k|0}else g=12}else g=10;break}case 2:{a=a<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){f=64;g=10}else g=6;break}case 1:{a=a<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){f=64;g=10}else g=6;break}default:if((e|0)==7){k=255;return k|0}else{f=c[b+400+((a<<3|6)<<8)>>2]|0;g=10}}if((g|0)==6){f=c[b+400+(a<<8)>>2]|0;g=10}a:do if((g|0)==10){l=b+320+((i^1)<<3)|0;a=b+264|0;d=c[a>>2]|0;a=c[a+4>>2]|0;g=110224+(i<<9)+(j<<3)|0;if((d&c[l>>2]&c[g>>2]|0)==0?(a&c[l+4>>2]&c[g+4>>2]|0)==0:0){l=255;return l|0}switch(e|0){case 4:{g=12;break a}case 7:{a=255;break}default:{g=14;break a}}return a|0}while(0);if((g|0)==12)if(!(c[b+336+((h|6)<<2)>>2]|0)){b=b+320+((i^1)<<3)|0;l=109200+(i<<9)+(k<<3)|0;if((d&c[b>>2]&c[l>>2]|0)==0?(a&c[b+4>>2]&c[l+4>>2]|0)==0:0){l=255;return l|0}}else g=14;if((g|0)==14){b=b+320+((i^1)<<3)|0;l=110224+(i<<9)+(k<<3)|0;if((d&c[b>>2]&c[l>>2]|0)==0?(a&c[b+4>>2]&c[l+4>>2]|0)==0:0){l=255;return l|0}}d=i*7|0;a=d^j>>3;e=d^k>>3;a=(a|0)<(e|0)?e:a;e=f&7;l=j&7;if(((e>>>0<l>>>0?l-e|0:e-l|0)|0)>=2){l=255;return l|0}l=k&7;if(((e>>>0<l>>>0?l-e|0:e-l|0)|0)>=2){l=255;return l|0}if((d^f>>3|0)<=(a|0)){l=255;return l|0}l=c[2324+(a<<2)>>2]|0;return l|0}function Bc(a){a=a|0;Dt(a);return}function Cc(a){a=a|0;return c[a+4>>2]|0}function Dc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;o=c[a+4>>2]|0;f=c[b+5364>>2]|0;switch(f|0){case 4:{d=o<<3|3;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|3;if(!(c[b+336+(d<<2)>>2]|0))n=64;else g=12;break}case 2:{d=o<<3|3;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|3;if(!(c[b+336+(d<<2)>>2]|0))n=64;else g=12;break}case 1:{d=o<<3|3;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|3;if(!(c[b+336+(d<<2)>>2]|0))n=64;else g=12;break}default:{a=c[a+8>>2]|0;e=c[b+400+((o<<3|3)<<8)>>2]|0;d=a<<3|3;g=12}}if((g|0)==12)n=c[b+400+(d<<8)>>2]|0;m=n^e;if(!((m>>>3^m)&1)){b=255;return b|0}switch(f|0){case 4:{d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))m=64;else g=19;break}case 2:{d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))m=64;else g=19;break}case 1:{d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))m=64;else g=19;break}default:{d=a<<3|6;g=19}}if((g|0)==19)m=c[b+400+(d<<8)>>2]|0;d=o<<3|1;f=c[b+400+(d<<8)>>2]|0;d=c[b+400+(d<<8)+4>>2]|0;j=f>>3;k=d>>3;l=o*7|0;if((j^l|0)>(k^l|0)){h=d&7;i=j<<3|h;g=f;f=f&7}else{f=f&7;i=k<<3|f;g=d;h=d&7}d=g+((o|0)==0?8:-8)|0;switch((f>>>0<h>>>0?h-f|0:f-h|0)|0){case 0:{if((((d^m)&7|0)==0?(l^m>>3|0)>=(l^d>>3|0):0)?(b=m^e,(b>>>3^b)&1|0):0){b=0;return b|0}b=255;return b|0}case 1:{if((m|0)==(d|0)?(o=m^e,(o>>>3^o)&1|0):0){if((n|0)==(i|0)){b=0;return b|0}h=b+256|0;o=29520+(i<<3)|0;l=30032+(i<<3)|0;l=(S(c[o+4>>2]&c[h+4>>2],c[l+4>>2]|0)|0)^(S(c[o>>2]&c[h>>2],c[l>>2]|0)|0);l=(c[1035940+(i<<2)>>2]|0)+(l>>>(c[1036196+(i<<2)>>2]|0)<<3)|0;h=b+320+(a<<3)|0;o=b+280|0;if(!((c[h>>2]&c[l>>2]&c[o>>2]|0)==0?(c[h+4>>2]&c[l+4>>2]&c[o+4>>2]|0)==0:0)){b=0;return b|0}if((((j|0)<(k|0)?k-j|0:j-k|0)|0)>1){b=0;return b|0}}if((m|0)==(i|0)?(o=m^e,(o>>>3^o)&1|0):0){if((n|0)==(d|0)){b=0;return b|0}n=b+256|0;m=29520+(d<<3)|0;o=30032+(d<<3)|0;o=(S(c[m+4>>2]&c[n+4>>2],c[o+4>>2]|0)|0)^(S(c[m>>2]&c[n>>2],c[o>>2]|0)|0);o=(c[1035940+(d<<2)>>2]|0)+(o>>>(c[1036196+(d<<2)>>2]|0)<<3)|0;n=b+320+(a<<3)|0;b=b+280|0;if(!((c[n>>2]&c[o>>2]&c[b>>2]|0)==0?(c[n+4>>2]&c[o+4>>2]&c[b+4>>2]|0)==0:0)){b=0;return b|0}}b=255;return b|0}default:{b=255;return b|0}}return 0}function Ec(a){a=a|0;Dt(a);return}function Fc(a){a=a|0;return c[a+4>>2]|0}function Gc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;g=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=g<<3|3;if(!(c[b+336+(e<<2)>>2]|0))f=64;else f=c[b+400+(e<<8)>>2]|0;e=c[a+8>>2]<<3|6;if(!(c[b+336+(e<<2)>>2]|0))e=64;else i=18;break}case 2:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=g<<3|3;if(!(c[b+336+(e<<2)>>2]|0))f=64;else f=c[b+400+(e<<8)>>2]|0;e=c[a+8>>2]<<3|6;if(!(c[b+336+(e<<2)>>2]|0))e=64;else i=18;break}case 1:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=g<<3|3;if(!(c[b+336+(e<<2)>>2]|0))f=64;else f=c[b+400+(e<<8)>>2]|0;e=c[a+8>>2]<<3|6;if(!(c[b+336+(e<<2)>>2]|0))e=64;else i=18;break}default:{f=c[b+400+((g<<3|3)<<8)>>2]|0;d=c[b+400+((g<<3|1)<<8)>>2]|0;e=c[a+8>>2]<<3|6;i=18}}if((i|0)==18)e=c[b+400+(e<<8)>>2]|0;if((((e^d)&7|0)==0?(i=g*7|0,h=i^e>>3,(i^d>>3|0)<(h|0)):0)?(i=e^f,((i>>>3^i)&1|0)!=0|(h|0)<6):0){i=0;return i|0}i=255;return i|0}function Hc(a){a=a|0;Dt(a);return}function Ic(a){a=a|0;return c[a+4>>2]|0}function Jc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;j=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0))g=64;else g=c[b+400+(d<<8)>>2]|0;d=j<<3|3;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;e=c[a+8>>2]|0;d=e<<3|3;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=e<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){a=64;h=d}else k=24;break}case 2:{d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0))g=64;else g=c[b+400+(d<<8)>>2]|0;d=j<<3|3;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;e=c[a+8>>2]|0;d=e<<3|3;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=e<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){a=64;h=d}else k=24;break}case 1:{d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0))g=64;else g=c[b+400+(d<<8)>>2]|0;d=j<<3|3;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;e=c[a+8>>2]|0;d=e<<3|3;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=e<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){a=64;h=d}else k=24;break}default:{e=c[a+8>>2]|0;d=c[b+400+((e<<3|3)<<8)>>2]|0;f=c[b+400+((j<<3|3)<<8)>>2]|0;g=c[b+400+((j<<3|1)<<8)>>2]|0;a=e<<3|6;k=24}}if((k|0)==24){a=c[b+400+(a<<8)>>2]|0;h=d}if((((a^g)&7|0)==0?(k=j*7|0,i=k^a>>3,(k^g>>3|0)<(i|0)):0)?(k=a^f,((k>>>3^k)&1|0)!=0|(i|0)<6):0){b=0;return b|0}k=h^f;if(!((k>>>3^k)&1)){b=255;return b|0}if((j*7^g>>3|0)<5){b=0;return b|0}a=109200+(j<<9)+(g<<3)|0;d=c[a>>2]|0;a=c[a+4>>2]|0;j=b+320+(e<<3)|0;k=b+304|0;if(!((c[j>>2]&d&c[k>>2]|0)==0?(c[j+4>>2]&a&c[k+4>>2]|0)==0:0)){b=0;return b|0}k=b+256|0;j=29520+(h<<3)|0;b=30032+(h<<3)|0;b=(S(c[j+4>>2]&c[k+4>>2],c[b+4>>2]|0)|0)^(S(c[j>>2]&c[k>>2],c[b>>2]|0)|0);b=(c[1035940+(h<<2)>>2]|0)+(b>>>(c[1036196+(h<<2)>>2]|0)<<3)|0;if(!((c[b>>2]&d|0)==0?(c[b+4>>2]&a|0)==0:0)?(c[1019044+(h<<8)+(g<<2)>>2]|0)>2:0){b=0;return b|0}b=255;return b|0}function Kc(a){a=a|0;Dt(a);return}function Lc(a){a=a|0;return c[a+4>>2]|0}function Mc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=b+264|0;if((c[h>>2]&-2122219135|0)==0?(c[h+4>>2]&-2122219135|0)==0:0){i=255;return i|0}e=c[a+8>>2]|0;h=c[b+5364>>2]|0;switch(h|0){case 4:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;d=e<<3|3;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+4>>2]|0;e=a<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){g=64;e=a}else i=19;break}case 2:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;d=e<<3|3;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+4>>2]|0;e=a<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){g=64;e=a}else i=19;break}case 1:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;d=e<<3|3;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+4>>2]|0;e=a<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){g=64;e=a}else i=19;break}default:{a=c[a+4>>2]|0;d=c[b+400+((e<<3|3)<<8)>>2]|0;f=c[b+400+((e<<3|6)<<8)>>2]|0;e=a<<3|1;i=19}}if((i|0)==19){g=c[b+400+(e<<8)>>2]|0;e=a}a=(e|0)==0?8:-8;a:do switch(e*7^g>>3|0){case 4:{d=g^d;if((d>>>3^d)&1|0){i=255;return i|0}d=c[1019044+((a*3|0)+g<<8)+(f<<2)>>2]|0;if((d|0)<3){if(d|0){d=24;break a}switch(h|0){case 4:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else i=29;break}case 2:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else i=29;break}case 1:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else i=29;break}default:{d=e<<3|6;i=29}}if((i|0)==29)d=c[b+400+(d<<8)>>2]|0;if((f|0)!=(d+(a<<1)|0)){d=24;break a}}d=48;break}case 5:{if((c[1019044+((a<<1)+g<<8)+(f<<2)>>2]|0)>=2){i=255;return i|0}i=113808+(d<<3)|0;b=30544+(a+g<<3)|0;if((c[b>>2]&c[i>>2]|0)==0?(c[b+4>>2]&c[i+4>>2]|0)==0:0){i=255;return i|0}b=d&7;i=g&7;if(((b>>>0<i>>>0?i-b|0:b-i|0)|0)>1)d=8;else{i=255;return i|0}break}default:{i=255;return i|0}}while(0);i=d;return i|0}function Nc(a){a=a|0;Dt(a);return}function Oc(a){a=a|0;return c[a+4>>2]|0}function Pc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;n=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=n<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){j=(n|0)==1;h=j?d^56:d}else{h=c[b+400+(e<<8)>>2]&4|0?d^7:d;j=(n|0)==1;h=j?h^56:h}a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))g=j?d^56:d;else{g=c[b+400+(e<<8)>>2]&4|0?d^7:d;g=j?g^56:g}d=n<<3|4;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))f=j?d^56:d;else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;f=j?f^56:f}d=n<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=j?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=j?e^56:e}d=a<<3|4;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=n<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){m=f;l=g;k=h;d=j}else{i=g;g=d;d=j;s=72}break}case 2:{d=n<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){j=(n|0)==1;h=j?d^56:d}else{h=c[b+400+(e<<8)>>2]&4|0?d^7:d;j=(n|0)==1;h=j?h^56:h}a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))g=j?d^56:d;else{g=c[b+400+(e<<8)>>2]&4|0?d^7:d;g=j?g^56:g}d=n<<3|4;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))f=j?d^56:d;else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;f=j?f^56:f}d=n<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=j?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=j?e^56:e}d=a<<3|4;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=n<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){m=f;l=g;k=h;d=j}else{i=g;g=d;d=j;s=72}break}case 1:{d=n<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){j=(n|0)==1;h=j?d^56:d}else{h=c[b+400+(e<<8)>>2]&4|0?d^7:d;j=(n|0)==1;h=j?h^56:h}a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))g=j?d^56:d;else{g=c[b+400+(e<<8)>>2]&4|0?d^7:d;g=j?g^56:g}d=n<<3|4;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))f=j?d^56:d;else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;f=j?f^56:f}d=n<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=n<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=j?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=j?e^56:e}d=a<<3|4;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=n<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){m=f;l=g;k=h;d=j}else{i=g;g=d;d=j;s=72}break}default:{h=c[b+400+((n<<3|6)<<8)>>2]|0;h=c[b+400+((n<<3|1)<<8)>>2]&4|0?h^7:h;d=(n|0)==1;a=c[a+8>>2]|0;i=c[b+400+((a<<3|6)<<8)>>2]|0;i=c[b+400+((n<<3|1)<<8)>>2]&4|0?i^7:i;f=c[b+400+((n<<3|4)<<8)>>2]|0;f=c[b+400+((n<<3|1)<<8)>>2]&4|0?f^7:f;e=c[b+400+((n<<3|1)<<8)>>2]|0;e=c[b+400+((n<<3|1)<<8)>>2]&4|0?e^7:e;e=d?e^56:e;f=d?f^56:f;i=d?i^56:i;h=d?h^56:h;a=c[b+400+((a<<3|4)<<8)>>2]|0;g=n<<3|1;s=72}}if((s|0)==72){m=f;l=i;k=h;a=c[b+400+(g<<8)>>2]&4|0?a^7:a}g=d?a^56:a;j=e&7;h=e>>3;i=j|56;a=(c[b+5348>>2]|0)==(n|0);f=a&1;d=(h|0)<5;do if(d){if((k|0)<40?(c[1019044+(l<<8)+(i<<2)>>2]|0)<2:0){if((g&-8|0)==40){s=0;return s|0}if(!((m&-8|0)==40|(h|0)>2)){s=0;return s|0}}}else{if(((h|0)==5?(c[1019044+(l<<8)+(i<<2)>>2]|0)<2:0)?(f+(k>>3)|0)<6:0){if(g>>>0<8){s=0;return s|0}if(a)break;n=g&7;if(((n>>>0<j>>>0?j-n|0:n-j|0)|0)>2)d=0;else break;return d|0}if((l|0)==(i|0)&g>>>0<8){if(!a){s=0;return s|0}if((c[1019044+(k<<8)+(e<<2)>>2]|0)>1){s=0;return s|0}}}while(0);if((l|1|0)==55&((m|0)==56&(e|0)==48)&(g&7|0)==0?(k>>3|0)<5|((k&7)>>>0>2|(g>>3|0)<3):0){s=0;return s|0}if(d){if(((l|0)==(e+8|0)?((c[1019044+(k<<8)+(e<<2)>>2]|0)-f|0)>1:0)?((c[1019044+(k<<8)+(g<<2)>>2]|0)-f|0)>1:0){s=0;return s|0}if(j|0)s=99}else{d=(j|0)!=0;if((((h|0)==6&d?!((m&7|0)!=(j|0)|(m|0)==(i|0)):0)?(o=c[1019044+(k<<8)+(i<<2)>>2]|0,(o|0)<((a?-1:-2)+(c[1019044+(l<<8)+(i<<2)>>2]|0)|0)):0)?(o|0)<((c[1019044+(l<<8)+(m<<2)>>2]|0)+f|0):0){s=128-(o<<1)|0;return s|0}if(d)s=99}do if((((s|0)==99?(m|0)<(e|0)&(m&7|0)==(j|0):0)?(p=c[1019044+(k<<8)+(i<<2)>>2]|0,q=a?-1:-2,(p|0)<(q+(c[1019044+(l<<8)+(i<<2)>>2]|0)|0)):0)?(s=e+8|0,r=c[1019044+(k<<8)+(s<<2)>>2]|0,(r|0)<(q+(c[1019044+(l<<8)+(s<<2)>>2]|0)|0)):0){s=(c[1019044+(l<<8)+(m<<2)>>2]|0)+f|0;if((s|0)<=2?!((p|0)<(s|0)&(r|0)<(s|0)):0)break;s=128-(c[1019044+(e<<8)+(i<<2)>>2]<<3)-(p<<1)|0;return s|0}while(0);if(!((l|0)>(e|0)&(h|0)<4)){s=255;return s|0}d=l&7;if((d|0)==(j|0)){s=10;return s|0}if(((d>>>0<j>>>0?j-d|0:d-j|0)|0)==1){s=c[1019044+(k<<8)+(l<<2)>>2]|0;return ((s|0)>2?24-(s<<1)|0:255)|0}else{s=255;return s|0}return 0}function Qc(a){a=a|0;Dt(a);return}function Rc(a){a=a|0;return c[a+4>>2]|0}function Sc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;g=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=c[a+8>>2]|0;a=e<<3|3;if(!(c[b+336+(a<<2)>>2]|0))f=64;else f=c[b+400+(a<<8)>>2]|0;a=e<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else h=18;break}case 2:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=c[a+8>>2]|0;a=e<<3|3;if(!(c[b+336+(a<<2)>>2]|0))f=64;else f=c[b+400+(a<<8)>>2]|0;a=e<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else h=18;break}case 1:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=c[a+8>>2]|0;a=e<<3|3;if(!(c[b+336+(a<<2)>>2]|0))f=64;else f=c[b+400+(a<<8)>>2]|0;a=e<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else h=18;break}default:{a=c[a+8>>2]|0;f=c[b+400+((a<<3|3)<<8)>>2]|0;d=c[b+400+((g<<3|1)<<8)>>2]|0;a=a<<3|6;h=18}}if((h|0)==18)a=c[b+400+(a<<8)>>2]|0;h=109200+(g<<9)+(d<<3)|0;b=b+256|0;e=29520+(f<<3)|0;g=30032+(f<<3)|0;g=(S(c[e+4>>2]&c[b+4>>2],c[g+4>>2]|0)|0)^(S(c[e>>2]&c[b>>2],c[g>>2]|0)|0);g=(c[1035940+(f<<2)>>2]|0)+(g>>>(c[1036196+(f<<2)>>2]|0)<<3)|0;if((c[g>>2]&c[h>>2]|0)==0?(c[g+4>>2]&c[h+4>>2]|0)==0:0){h=255;return h|0}h=c[1019044+(a<<8)+(d<<2)>>2]|0;return h|0}function Tc(a){a=a|0;Dt(a);return}function Uc(a){a=a|0;return c[a+4>>2]|0}function Vc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;g=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=g<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){e=(g|0)==1;f=e?d^56:d;d=e}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;d=(g|0)==1;f=d?f^56:f}e=c[a+8>>2]<<3|6;if(!(c[b+336+(e<<2)>>2]|0))a=64;else a=c[b+400+(e<<8)>>2]|0;e=g<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=a;else h=27;break}case 2:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=g<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){e=(g|0)==1;f=e?d^56:d;d=e}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;d=(g|0)==1;f=d?f^56:f}e=c[a+8>>2]<<3|6;if(!(c[b+336+(e<<2)>>2]|0))a=64;else a=c[b+400+(e<<8)>>2]|0;e=g<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=a;else h=27;break}case 1:{d=g<<3|1;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=g<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){e=(g|0)==1;f=e?d^56:d;d=e}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;d=(g|0)==1;f=d?f^56:f}e=c[a+8>>2]<<3|6;if(!(c[b+336+(e<<2)>>2]|0))a=64;else a=c[b+400+(e<<8)>>2]|0;e=g<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=a;else h=27;break}default:{f=c[b+400+((g<<3|1)<<8)>>2]|0;f=c[b+400+((g<<3|1)<<8)>>2]&4|0?f^7:f;d=(g|0)==1;f=d?f^56:f;a=c[b+400+((c[a+8>>2]<<3|6)<<8)>>2]|0;e=g<<3|1;h=27}}if((h|0)==27)e=c[b+400+(e<<8)>>2]&4|0?a^7:a;if((f|0)==48?(c[1033380+((d?e^56:e)<<2)>>2]|0)<2:0){h=0;return h|0}h=255;return h|0}function Wc(a){a=a|0;Dt(a);return}function Xc(a){a=a|0;return c[a+4>>2]|0}function Yc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else f=12;break}case 2:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else f=12;break}case 1:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0))a=64;else f=12;break}default:{d=c[b+400+((e<<3|6)<<8)>>2]|0;a=c[a+8>>2]<<3|6;f=12}}if((f|0)==12)a=c[b+400+(a<<8)>>2]|0;f=(c[1884+(a<<2)>>2]|0)+1277+(c[2220+(c[1019044+(d<<8)+(a<<2)>>2]<<2)>>2]|0)|0;return ((e|0)==(c[b+5348>>2]|0)?f:0-f|0)|0}function Zc(a){a=a|0;Dt(a);return}function _c(a){a=a|0;return c[a+4>>2]|0}function $c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=a<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){g=64;e=d;d=f}else h=18;break}case 2:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=a<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){g=64;e=d;d=f}else h=18;break}case 1:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;a=c[a+8>>2]|0;d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=a<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){g=64;e=d;d=f}else h=18;break}default:{a=c[a+8>>2]|0;d=c[b+400+((a<<3|6)<<8)>>2]|0;f=c[b+400+((i<<3|6)<<8)>>2]|0;e=a<<3|1;h=18}}if((h|0)==18){g=c[b+400+(e<<8)>>2]|0;e=d;d=f}d=c[2220+(c[1019044+(d<<8)+(e<<2)>>2]<<2)>>2]|0;if(((a*7^g>>3|0)==6?(c[1019044+(e<<8)+(g<<2)>>2]|0)==1:0)?(h=30544+(g<<3)|0,!((c[h>>2]&-1515870811|0)==0?(c[h+4>>2]&-1515870811|0)==0:0)):0){h=d;b=b+5348|0;b=c[b>>2]|0;b=(i|0)==(b|0);i=0-h|0;i=b?h:i;return i|0}h=d+2400|0;b=b+5348|0;b=c[b>>2]|0;b=(i|0)==(b|0);i=0-h|0;i=b?h:i;return i|0}function ad(a){a=a|0;Dt(a);return}function bd(a){a=a|0;return c[a+4>>2]|0}function cd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;e=c[a+8>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=e<<3|2;if(!(c[b+336+(e<<2)>>2]|0))e=64;else f=12;break}case 2:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=e<<3|2;if(!(c[b+336+(e<<2)>>2]|0))e=64;else f=12;break}case 1:{d=e<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=e<<3|2;if(!(c[b+336+(e<<2)>>2]|0))e=64;else f=12;break}default:{d=c[b+400+((e<<3|6)<<8)>>2]|0;e=e<<3|2;f=12}}if((f|0)==12)e=c[b+400+(e<<8)>>2]|0;f=(c[2140+(c[1019044+(d<<8)+(e<<2)>>2]<<2)>>2]|0)+(c[1884+(d<<2)>>2]|0)|0;return ((c[a+4>>2]|0)==(c[b+5348>>2]|0)?f:0-f|0)|0}function dd(a){a=a|0;Dt(a);return}function ed(a){a=a|0;return c[a+4>>2]|0}function fd(a,b){a=a|0;b=b|0;var d=0,e=0;d=c[a+8>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=d<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else e=6;break}case 2:{d=d<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else e=6;break}case 1:{d=d<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else e=6;break}default:{d=d<<3|6;e=6}}if((e|0)==6)d=c[b+400+(d<<8)>>2]|0;e=c[1884+(d<<2)>>2]|0;return ((c[a+4>>2]|0)==(c[b+5348>>2]|0)?e:0-e|0)|0}function gd(a){a=a|0;Dt(a);return}function hd(a){a=a|0;return c[a+4>>2]|0}function id(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;n=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=n<<3|6;if(!(c[b+336+(d<<2)>>2]|0)){e=n*56|0;f=64;i=e^64}else{i=c[b+400+(d<<8)>>2]|0;e=n*56|0;f=i;i=i^e}h=c[a+8>>2]|0;d=h<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=d^e;d=n<<3|4;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;g=d^e;d=h<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){k=64;d=f;j=a}else l=27;break}case 2:{d=n<<3|6;if(!(c[b+336+(d<<2)>>2]|0)){e=n*56|0;f=64;i=e^64}else{i=c[b+400+(d<<8)>>2]|0;e=n*56|0;f=i;i=i^e}h=c[a+8>>2]|0;d=h<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=d^e;d=n<<3|4;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;g=d^e;d=h<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){k=64;d=f;j=a}else l=27;break}case 1:{d=n<<3|6;if(!(c[b+336+(d<<2)>>2]|0)){e=n*56|0;f=64;i=e^64}else{i=c[b+400+(d<<8)>>2]|0;e=n*56|0;f=i;i=i^e}h=c[a+8>>2]|0;d=h<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=d^e;d=n<<3|4;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;g=d^e;d=h<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){k=64;d=f;j=a}else l=27;break}default:{i=c[b+400+((n<<3|6)<<8)>>2]|0;l=n*56|0;a=c[a+8>>2]|0;f=i;d=a<<3|1;g=c[b+400+((n<<3|4)<<8)>>2]^l;h=a;i=i^l;e=l;a=c[b+400+((a<<3|6)<<8)>>2]^l;l=27}}if((l|0)==27){k=c[b+400+(d<<8)>>2]|0;d=f;j=a}f=k^e;e=k&7;if((i|0)<(f|0)&(d&7|0)==(e|0)){m=1371-(c[1019044+(i<<8)+(f<<2)>>2]|0)|0;b=c[b+5348>>2]|0;b=(n|0)==(b|0);n=0-m|0;n=b?m:n;return n|0}a=c[1019044+(j<<8)+(f<<2)>>2]|0;d=c[b+5348>>2]|0;if((a|0)>=(((d|0)==(h|0)?4:3)|0)?(c[1019044+(j<<8)+(g<<2)>>2]|0)>2:0){m=1371-(c[1019044+(i<<8)+(f<<2)>>2]|0)|0;b=d;b=(n|0)==(b|0);n=0-m|0;n=b?m:n;return n|0}if(((j>>3|0)<3?(i>>3|0)>2&(a|0)==1:0)?(m=c[1019044+(i<<8)+(f<<2)>>2]|0,(m|0)>(((d|0)==(n|0)?3:2)|0)):0){m=80-(m<<3)|0;b=d;b=(n|0)==(b|0);n=0-m|0;n=b?m:n;return n|0}m=f+-8|0;m=200-((c[1019044+(i<<8)+(m<<2)>>2]|0)-(c[1019044+(j<<8)+(m<<2)>>2]|0)-(c[1019044+(f<<8)+(e<<2)>>2]|0)<<3)|0;b=d;b=(n|0)==(b|0);n=0-m|0;n=b?m:n;return n|0}function jd(a){a=a|0;Dt(a);return}function kd(a){a=a|0;return c[a+4>>2]|0}function ld(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;h=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=h<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=h<<3|3;if(!(c[b+336+(a<<2)>>2]|0)){g=64;a=d;d=e}else{f=d;d=e;i=18}break}case 2:{d=h<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=h<<3|3;if(!(c[b+336+(a<<2)>>2]|0)){g=64;a=d;d=e}else{f=d;d=e;i=18}break}case 1:{d=h<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;a=h<<3|3;if(!(c[b+336+(a<<2)>>2]|0)){g=64;a=d;d=e}else{f=d;d=e;i=18}break}default:{f=c[b+400+((c[a+8>>2]<<3|6)<<8)>>2]|0;d=c[b+400+((h<<3|6)<<8)>>2]|0;a=h<<3|3;i=18}}if((i|0)==18){g=c[b+400+(a<<8)>>2]|0;a=f}g=((g>>>3^g)&1|0)!=0;i=g?a^56:a;i=(c[2220+(c[1019044+((g?d^56:d)<<8)+(i<<2)>>2]<<2)>>2]|0)+1e4+(c[2668+(i<<2)>>2]|0)|0;return ((h|0)==(c[b+5348>>2]|0)?i:0-i|0)|0}function md(a){a=a|0;Dt(a);return}function nd(a){a=a|0;return c[a+4>>2]|0}function od(a,b){a=a|0;b=b|0;return 0}function pd(a){a=a|0;Dt(a);return}function qd(a){a=a|0;return c[a+4>>2]|0}function rd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0;k=a+4|0;l=c[k>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=l<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=l<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){h=(l|0)==1;f=h?d^56:d}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;h=(l|0)==1;f=h?f^56:f}d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=l<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=h?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=h?e^56:e}d=l<<3|1;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=l<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){i=e;g=f;e=a;d=h}else{g=f;f=d;d=h;j=42}break}case 2:{d=l<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=l<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){h=(l|0)==1;f=h?d^56:d}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;h=(l|0)==1;f=h?f^56:f}d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=l<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=h?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=h?e^56:e}d=l<<3|1;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=l<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){i=e;g=f;e=a;d=h}else{g=f;f=d;d=h;j=42}break}case 1:{d=l<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=l<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){h=(l|0)==1;f=h?d^56:d}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;h=(l|0)==1;f=h?f^56:f}d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=l<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=h?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=h?e^56:e}d=l<<3|1;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=l<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){i=e;g=f;e=a;d=h}else{g=f;f=d;d=h;j=42}break}default:{g=c[b+400+((l<<3|6)<<8)>>2]|0;g=c[b+400+((l<<3|1)<<8)>>2]&4|0?g^7:g;d=(l|0)==1;e=c[b+400+((c[a+8>>2]<<3|6)<<8)>>2]|0;e=c[b+400+((l<<3|1)<<8)>>2]&4|0?e^7:e;e=d?e^56:e;g=d?g^56:g;a=c[b+400+((l<<3|1)<<8)>>2]|0;f=l<<3|1;j=42}}if((j|0)==42){i=e;e=c[b+400+(f<<8)>>2]&4|0?a^7:a}e=d?e^56:e;d=b+5348|0;if(xb(g,e,i,(l|0)!=(c[d>>2]|0)&1)|0){l=e>>3;return ((c[k>>2]|0)==(c[d>>2]|0)?l+10248|0:-10248-l|0)|0}else return 0;return 0}function sd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+4112|0;d=i;h=b+5348|0;e=a+8|0;if((c[h>>2]|0)==(c[e>>2]|0)?(g=kf(b,d)|0,c[d+4096>>2]=g,(g|0)==(d|0)):0){l=i;return 0}g=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{a=g<<3|6;if(!(c[b+336+(a<<2)>>2]|0))d=64;else d=c[b+400+(a<<8)>>2]|0;a=c[e>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){e=64;a=d}else f=14;break}case 2:{a=g<<3|6;if(!(c[b+336+(a<<2)>>2]|0))d=64;else d=c[b+400+(a<<8)>>2]|0;a=c[e>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){e=64;a=d}else f=14;break}case 1:{a=g<<3|6;if(!(c[b+336+(a<<2)>>2]|0))d=64;else d=c[b+400+(a<<8)>>2]|0;a=c[e>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){e=64;a=d}else f=14;break}default:{d=c[b+400+((g<<3|6)<<8)>>2]|0;a=c[e>>2]<<3|6;f=14}}if((f|0)==14){e=c[b+400+(a<<8)>>2]|0;a=d}f=g<<3;a=((c[b+336+((f|1)<<2)>>2]|0)*248|0)+(c[(c[b+5356>>2]|0)+16+(g<<2)>>2]|0)+(c[1884+(e<<2)>>2]|0)+(c[2220+(c[1019044+(a<<8)+(e<<2)>>2]<<2)>>2]|0)|0;if((c[b+336+((f|5)<<2)>>2]|0)==0?(c[b+336+((f|4)<<2)>>2]|0)==0:0){d=f|3;e=c[b+336+(d<<2)>>2]|0;if(!e){b=a;h=c[h>>2]|0;g=(g|0)==(h|0);h=0-b|0;h=g?b:h;l=i;return h|0}if(!(c[b+336+((f|2)<<2)>>2]|0)){if((e|0)<=1){b=a;h=c[h>>2]|0;g=(g|0)==(h|0);h=0-b|0;h=g?b:h;l=i;return h|0}b=c[b+400+(d<<8)+4>>2]^c[b+400+(d<<8)>>2];if(!((b>>>3^b)&1)){b=a;h=c[h>>2]|0;g=(g|0)==(h|0);h=0-b|0;h=g?b:h;l=i;return h|0}}}b=a+1e4|0;b=(b|0)>31743?31743:b;h=c[h>>2]|0;g=(g|0)==(h|0);h=0-b|0;h=g?b:h;l=i;return h|0}function td(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;p=c[a+4>>2]|0;o=b+320+(p<<3)|0;i=b+264|0;h=c[i>>2]|0;i=c[i+4>>2]|0;n=h&c[o>>2];o=i&c[o+4>>2];k=Qa(n|0,o|0,0)|0;j=k&7;k=k&255;switch(k&7){case 0:case 7:{f=31056+(j<<3)|0;if((n&~c[f>>2]|0)==0?(o&~c[f+4>>2]|0)==0:0){switch(c[b+5364>>2]|0){case 4:{d=p<<3|3;if(!(c[b+336+(d<<2)>>2]|0)){e=64;d=p*56^(j|56)}else{e=c[b+400+(d<<8)>>2]|0;d=p*56^(j|56)}f=c[a+8>>2]<<3|6;if(!(c[b+336+(f<<2)>>2]|0))f=64;else m=17;break}case 2:{d=p<<3|3;if(!(c[b+336+(d<<2)>>2]|0)){e=64;d=p*56^(j|56)}else{e=c[b+400+(d<<8)>>2]|0;d=p*56^(j|56)}f=c[a+8>>2]<<3|6;if(!(c[b+336+(f<<2)>>2]|0))f=64;else m=17;break}case 1:{d=p<<3|3;if(!(c[b+336+(d<<2)>>2]|0)){e=64;d=p*56^(j|56)}else{e=c[b+400+(d<<8)>>2]|0;d=p*56^(j|56)}f=c[a+8>>2]<<3|6;if(!(c[b+336+(f<<2)>>2]|0))f=64;else m=17;break}default:{e=c[b+400+((p<<3|3)<<8)>>2]|0;f=c[a+8>>2]<<3|6;d=p*56^(j|56);m=17}}if((m|0)==17)f=c[b+400+(f<<8)>>2]|0;e=d^e;if((e>>>3^e)&1|0?(c[1019044+(d<<8)+(f<<2)>>2]|0)<2:0){p=0;return p|0}}switch(k&7){case 1:case 6:{m=21;break}default:{}}break}case 1:case 6:{m=21;break}default:{}}do if((((m|0)==21?(k=31056+(j<<3)|0,(h&~c[k>>2]|0)==0?(i&~c[k+4>>2]|0)==0:0):0)?(g=c[a+8>>2]|0,(c[(c[b+5356>>2]|0)+16+(g<<2)>>2]|0)==0):0)?(l=g<<3,(c[b+336+((l|1)<<2)>>2]|0)>0):0){k=b+320+(g<<3)|0;j=c[k>>2]&h;h=c[k+4>>2]&i;g=(g|0)==0;k=Qa(j|0,h|0,0)|0;h=nv(j|0,h|0,0)|0;h=g?k:h^63;switch(c[b+5364>>2]|0){case 4:{d=p<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;d=l|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=p<<3|3;if(!(c[b+336+(d<<2)>>2]|0))a=64;else m=41;break}case 2:{d=p<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;d=l|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=p<<3|3;if(!(c[b+336+(d<<2)>>2]|0))a=64;else m=41;break}case 1:{d=p<<3|6;if(!(c[b+336+(d<<2)>>2]|0))f=64;else f=c[b+400+(d<<8)>>2]|0;d=l|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=p<<3|3;if(!(c[b+336+(d<<2)>>2]|0))a=64;else m=41;break}default:{e=c[b+400+((l|6)<<8)>>2]|0;f=c[b+400+((p<<3|6)<<8)>>2]|0;d=p<<3|3;m=41}}if((m|0)==41)a=c[b+400+(d<<8)>>2]|0;d=p*7|0;if((d^h>>3|0)==6?(m=30544+((g?8:-8)+h<<3)|0,!((n&c[m>>2]|0)==0?(o&c[m+4>>2]|0)==0:0)):0){o=a^h;if(((o>>>3^o)&1|0)==0?(c[b+336+((p<<3|1)<<2)>>2]|0)!=1:0)break;p=c[1019044+(h<<8)+(e<<2)>>2]|0;if(!((p|0)>(c[1019044+(h<<8)+(f<<2)>>2]|0)|((p|0)>2|(d^e>>3|0)<6))){p=0;return p|0}}}while(0);p=255;return p|0}function ud(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=c[a+8>>2]|0;h=c[b+5364>>2]|0;switch(h|0){case 4:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=i<<3|4;if(!(c[b+336+(d<<2)>>2]|0))g=64;else j=12;break}case 2:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=i<<3|4;if(!(c[b+336+(d<<2)>>2]|0))g=64;else j=12;break}case 1:{d=i<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else e=c[b+400+(d<<8)>>2]|0;d=i<<3|4;if(!(c[b+336+(d<<2)>>2]|0))g=64;else j=12;break}default:{e=c[b+400+((i<<3|6)<<8)>>2]|0;d=i<<3|4;j=12}}if((j|0)==12)g=c[b+400+(d<<8)>>2]|0;f=i*7|0;if((f^e>>3|0)<2){a=c[a+4>>2]|0;switch(h|0){case 4:{d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=8;else j=19;break}case 2:{d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=8;else j=19;break}case 1:{d=a<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=8;else j=19;break}default:{d=a<<3|6;j=19}}if((j|0)==19)d=c[b+400+(d<<8)>>2]>>3;if(((d^f|0)>2?(f^g>>3|0)==2:0)?(h=b+320+(i<<3)|0,b=b+264|0,i=34448+(e<<3)|0,j=31376+((a<<3|1)<<9)+(g<<3)|0,!((c[b>>2]&c[h>>2]&c[i>>2]&c[j>>2]|0)==0?(c[b+4>>2]&c[h+4>>2]&c[i+4>>2]&c[j+4>>2]|0)==0:0)):0){j=0;return j|0}}j=255;return j|0}function vd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=c[a+8>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=g<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else f=6;break}case 2:{d=g<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else f=6;break}case 1:{d=g<<3|6;if(!(c[b+336+(d<<2)>>2]|0))e=64;else f=6;break}default:{d=g<<3|6;f=6}}if((f|0)==6)e=c[b+400+(d<<8)>>2]|0;a=b+320+(c[a+4>>2]<<3)|0;f=b+264|0;d=c[f>>2]&c[a>>2];a=c[f+4>>2]&c[a+4>>2];g=31248+(g<<6)+(e>>3<<3)|0;if((((d&~c[g>>2]|0)==0?(a&~c[g+4>>2]|0)==0:0)?(d&-16843010|0)==0&(a&-16843010|0)==0|(d&2139062143|0)==0&(a&2139062143|0)==0:0)?(g=Qa(d|0,a|0,0)|0,f=e&7,g=g&7,((f>>>0<g>>>0?g-f|0:f-g|0)|0)<2):0){g=0;return g|0}g=255;return g|0}function wd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{d=j<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=j<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){h=(j|0)==1;f=h?d^56:d}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;h=(j|0)==1;f=h?f^56:f}d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=j<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=h?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=h?e^56:e}d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){g=f;d=h}else{g=f;f=d;d=h;i=42}break}case 2:{d=j<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=j<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){h=(j|0)==1;f=h?d^56:d}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;h=(j|0)==1;f=h?f^56:f}d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=j<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=h?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=h?e^56:e}d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){g=f;d=h}else{g=f;f=d;d=h;i=42}break}case 1:{d=j<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=j<<3|1;if(!(c[b+336+(e<<2)>>2]|0)){h=(j|0)==1;f=h?d^56:d}else{f=c[b+400+(e<<8)>>2]&4|0?d^7:d;h=(j|0)==1;f=h?f^56:f}d=c[a+8>>2]<<3|6;if(!(c[b+336+(d<<2)>>2]|0))d=64;else d=c[b+400+(d<<8)>>2]|0;e=j<<3|1;if(!(c[b+336+(e<<2)>>2]|0))e=h?d^56:d;else{e=c[b+400+(e<<8)>>2]&4|0?d^7:d;e=h?e^56:e}d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0))a=64;else a=c[b+400+(d<<8)>>2]|0;d=j<<3|1;if(!(c[b+336+(d<<2)>>2]|0)){g=f;d=h}else{g=f;f=d;d=h;i=42}break}default:{g=c[b+400+((j<<3|6)<<8)>>2]|0;g=c[b+400+((j<<3|1)<<8)>>2]&4|0?g^7:g;d=(j|0)==1;e=c[b+400+((c[a+8>>2]<<3|6)<<8)>>2]|0;e=c[b+400+((j<<3|1)<<8)>>2]&4|0?e^7:e;e=d?e^56:e;g=d?g^56:g;a=c[b+400+((j<<3|1)<<8)>>2]|0;f=j<<3|1;i=42}}if((i|0)==42)a=c[b+400+(f<<8)>>2]&4|0?a^7:a;d=d?a^56:a;if(!((d>>3|0)<4|(d&7|0)==0)){j=255;return j|0}j=xb(g,d,e,(j|0)!=(c[b+5348>>2]|0)&1)|0;j=j?255:0;return j|0}function xd(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+4112|0;d=j;i=b+5348|0;e=a+8|0;if((c[i>>2]|0)==(c[e>>2]|0)?(g=kf(b,d)|0,c[d+4096>>2]=g,(g|0)==(d|0)):0){l=j;return 0}g=c[a+4>>2]|0;switch(c[b+5364>>2]|0){case 4:{a=g<<3|6;if(!(c[b+336+(a<<2)>>2]|0))d=64;else d=c[b+400+(a<<8)>>2]|0;a=c[e>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){f=64;a=d}else h=14;break}case 2:{a=g<<3|6;if(!(c[b+336+(a<<2)>>2]|0))d=64;else d=c[b+400+(a<<8)>>2]|0;a=c[e>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){f=64;a=d}else h=14;break}case 1:{a=g<<3|6;if(!(c[b+336+(a<<2)>>2]|0))d=64;else d=c[b+400+(a<<8)>>2]|0;a=c[e>>2]<<3|6;if(!(c[b+336+(a<<2)>>2]|0)){f=64;a=d}else h=14;break}default:{d=c[b+400+((g<<3|6)<<8)>>2]|0;a=c[e>>2]<<3|6;h=14}}if((h|0)==14){f=c[b+400+(a<<8)>>2]|0;a=d}e=g<<3;d=((c[b+336+((e|1)<<2)>>2]|0)*248|0)+(c[(c[b+5356>>2]|0)+16+(g<<2)>>2]|0)+(c[2668+(f<<2)>>2]|0)+(c[2140+(c[1019044+(a<<8)+(f<<2)>>2]<<2)>>2]|0)|0;if((c[b+336+((e|5)<<2)>>2]|0)==0?(c[b+336+((e|4)<<2)>>2]|0)==0:0)h=18;else h=17;if((h|0)==17?(c[b+336+(e<<2)>>2]|0)<=2:0)h=18;if((h|0)==18){a=c[b+336+((e|2)<<2)>>2]|0;if((a+(c[b+336+((e|3)<<2)>>2]|0)|0)<=2){b=d;h=c[i>>2]|0;h=(g|0)==(h|0);i=0-b|0;i=h?b:i;l=j;return i|0}if((a|0)<=1?(f=b+320+(g<<3)|0,b=b+280|0,h=c[b>>2]&c[f>>2],b=c[b+4>>2]&c[f+4>>2],(h&-1437226411|0)==0&(b&-1437226411|0)==0|(h&1437226410|0)==0&(b&1437226410|0)==0):0){b=d;h=c[i>>2]|0;h=(g|0)==(h|0);i=0-b|0;i=h?b:i;l=j;return i|0}}b=d+1e4|0;b=(b|0)>31743?31743:b;h=c[i>>2]|0;h=(g|0)==(h|0);i=0-b|0;i=h?b:i;l=j;return i|0}
function mh(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0;F=l;l=l+688|0;x=F;v=F+672|0;w=F+664|0;q=F+652|0;r=F+640|0;p=F+628|0;m=F+616|0;k=F+604|0;E=F+592|0;B=F+580|0;C=F+440|0;do if(!(a[1233090]|0)){e=c[290997]|0;d=(c[e+20>>2]|0)+-1+(c[e+16>>2]|0)|0;d=(c[(c[e+4>>2]|0)+(d>>>4<<2)>>2]|0)+((d&15)*440|0)|0;e=c[290941]|0;if((c[290942]|0)==(e|0))ws(1163764);else{zf(988424,1163844,0,0,d,c[e>>2]|0)|0;a[1233090]=1;break}}while(0);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;Jt(B,b,Vh(b)|0);y=C+8|0;c[C>>2]=10808;z=C+60|0;c[z>>2]=10828;c[C+4>>2]=0;Rk(C+60|0,y);c[C+132>>2]=0;c[C+136>>2]=-1;c[C>>2]=10848;c[C+60>>2]=10868;Tk(y);c[y>>2]=3708;A=C+40|0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[A+12>>2]=0;c[C+56>>2]=8;Jd(y,B);e=E+11|0;if((a[e>>0]|0)<0){a[c[E>>2]>>0]=0;f=E+4|0;c[f>>2]=0}else{a[E>>0]=0;a[e>>0]=0;f=E+4|0}b=C+(c[(c[C>>2]|0)+-12>>2]|0)+4|0;c[b>>2]=c[b>>2]|4096;re(C,E)|0;b=a[e>>0]|0;d=c[f>>2]|0;if(((b<<24>>24<0?d:b&255)|0)==4){if(au(E,0,-1,21498,4)|0){b=a[e>>0]|0;d=c[f>>2]|0;u=11}}else u=11;do if((u|0)==11){if(((b<<24>>24<0?d:b&255)|0)==4){if(!(au(E,0,-1,21503,4)|0))break;b=a[e>>0]|0;d=c[f>>2]|0}if((((b<<24>>24<0?d:b&255)|0)==9?(au(E,0,-1,21508,9)|0)==0:0)?a[1233086]&1:0)break;d=a[e>>0]|0;b=c[f>>2]|0;do if(((d<<24>>24<0?b:d&255)|0)==9){if(au(E,0,-1,21508,9)|0){d=a[e>>0]|0;b=c[f>>2]|0;break}c[247083]=0;c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);do if(((d<<24>>24<0?b:d&255)|0)==3){if(au(E,0,-1,21518,3)|0){d=a[e>>0]|0;b=c[f>>2]|0;break}t=Kd(te(1164756,0)|0,21522,8)|0;qe(v,1);w=a[v+11>>0]|0;u=w<<24>>24<0;w=Kd(Hh(Kd(Kd(t,u?c[v>>2]|0:v,u?c[v+4>>2]|0:w&255)|0,21531,1)|0,1163992)|0,21533,6)|0;c[x>>2]=Sk(w+(c[(c[w>>2]|0)+-12>>2]|0)|0)|0;u=lm(x,1165628)|0;u=nb[c[(c[u>>2]|0)+28>>2]&63](u,10)|0;pt(x);il(w,u)|0;Xk(w)|0;te(w,1)|0;Mt(v);c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);do if(((d<<24>>24<0?b:d&255)|0)==10){if(au(E,0,-1,21540,10)|0){d=a[e>>0]|0;b=c[f>>2]|0;break}Lg();x=988400;c[x>>2]=0;c[x+4>>2]=0;c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);do if(((d<<24>>24<0?b:d&255)|0)==7){if(au(E,0,-1,21551,7)|0){d=a[e>>0]|0;b=c[f>>2]|0;break}w=Kd(te(1164756,0)|0,21559,7)|0;c[x>>2]=Sk(w+(c[(c[w>>2]|0)+-12>>2]|0)|0)|0;v=lm(x,1165628)|0;v=nb[c[(c[v>>2]|0)+28>>2]&63](v,10)|0;pt(x);il(w,v)|0;Xk(w)|0;te(w,1)|0;c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);do if(((d<<24>>24<0?b:d&255)|0)==2){if(au(E,0,-1,21567,2)|0){d=a[e>>0]|0;b=c[f>>2]|0;break}b=x;d=b+64|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;s=Lj()|0;s=$u(s|0,D|0,1e3,0)|0;t=x+64|0;c[t>>2]=s;c[t+4>>2]=D;t=re(C,v)|0;if(!(c[t+(c[(c[t>>2]|0)+-12>>2]|0)+16>>2]&5)){e=v+11|0;f=v+4|0;g=x+4|0;h=x+8|0;i=x+12|0;j=x+16|0;k=x+20|0;m=x+24|0;n=x+32|0;o=x+36|0;p=x+56|0;q=x+40|0;r=x+44|0;s=x+48|0;t=x+52|0;do{b=a[e>>0]|0;d=c[f>>2]|0;do if(((b<<24>>24<0?d:b&255)|0)==11){if(au(v,0,-1,21570,11)|0){b=a[e>>0]|0;d=c[f>>2]|0;u=49;break}d=re(C,v)|0;if(!(c[d+(c[(c[d>>2]|0)+-12>>2]|0)+16>>2]&5))do{b=nh(988424,v)|0;c[w>>2]=b;d=c[g>>2]|0;if(d>>>0<(c[h>>2]|0)>>>0){c[d>>2]=b;c[g>>2]=d+4}else oh(x,w);d=re(C,v)|0}while(!(c[d+(c[(c[d>>2]|0)+-12>>2]|0)+16>>2]&5|0))}else u=49;while(0);a:do if((u|0)==49){u=0;do if(((b<<24>>24<0?d:b&255)|0)==5)if(!(au(v,0,-1,21582,5)|0)){_k(C,i)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==5)if(!(au(v,0,-1,21588,5)|0)){_k(C,j)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==4)if(!(au(v,0,-1,21594,4)|0)){_k(C,k)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==4)if(!(au(v,0,-1,21599,4)|0)){_k(C,m)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==9)if(!(au(v,0,-1,21604,9)|0)){_k(C,n)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==5)if(!(au(v,0,-1,21614,5)|0)){_k(C,o)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==5)if(!(au(v,0,-1,21620,5)|0)){$k(C,p)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==8)if(!(au(v,0,-1,21626,8)|0)){_k(C,q)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==4)if(!(au(v,0,-1,21635,4)|0)){_k(C,r)|0;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);do if(((b<<24>>24<0?d:b&255)|0)==8)if(!(au(v,0,-1,21640,8)|0)){c[s>>2]=1;break a}else{b=a[e>>0]|0;d=c[f>>2]|0;break}while(0);if(((b<<24>>24<0?d:b&255)|0)!=6)break;if(au(v,0,-1,21649,6)|0)break;c[t>>2]=1}while(0);d=re(C,v)|0}while(!(c[d+(c[(c[d>>2]|0)+-12>>2]|0)+16>>2]&5|0))}Zg(1163764,988424,1163988,x);Mt(v);e=c[x>>2]|0;f=e;if(e|0){b=x+4|0;d=c[b>>2]|0;if((d|0)!=(e|0))c[b>>2]=d+(~((d+-4-f|0)>>>2)<<2);Dt(e)}c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);do if(((d<<24>>24<0?b:d&255)|0)==8){if(au(E,0,-1,21656,8)|0){d=a[e>>0]|0;b=c[f>>2]|0;break};c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,22079,11);c[x>>2]=m;ae(w,1163992,m,1233091,x,v);zh(p,(c[w>>2]|0)+28|0);h=c[290958]|0;i=a[p+11>>0]|0;j=i<<24>>24<0;i=j?c[p+4>>2]|0:i&255;j=j?c[p>>2]|0:p;b:do if(!i){u=a[h+11>>0]|0;do if((u<<24>>24<0?c[h+4>>2]|0:u&255)|0){u=a[h+12+11>>0]|0;if((u<<24>>24<0?c[h+16>>2]|0:u&255)|0){u=a[h+24+11>>0]|0;if((u<<24>>24<0?c[h+28>>2]|0:u&255)|0){u=a[h+36+11>>0]|0;if(!((u<<24>>24<0?c[h+40>>2]|0:u&255)|0)){b=3;break}u=a[h+48+11>>0]|0;if(!((u<<24>>24<0?c[h+52>>2]|0:u&255)|0)){b=4;break}u=a[h+60+11>>0]|0;if(!((u<<24>>24<0?c[h+64>>2]|0:u&255)|0)){b=5;break}u=a[h+72+11>>0]|0;if(!((u<<24>>24<0?c[h+76>>2]|0:u&255)|0)){b=6;break}u=a[h+84+11>>0]|0;if(!((u<<24>>24<0?c[h+88>>2]|0:u&255)|0)){b=7;break}u=a[h+96+11>>0]|0;if(!((u<<24>>24<0?c[h+100>>2]|0:u&255)|0)){b=8;break}u=a[h+108+11>>0]|0;if(!((u<<24>>24<0?c[h+112>>2]|0:u&255)|0)){b=9;break}u=a[h+120+11>>0]|0;if(!((u<<24>>24<0?c[h+124>>2]|0:u&255)|0)){b=10;break}u=a[h+132+11>>0]|0;if(!((u<<24>>24<0?c[h+136>>2]|0:u&255)|0))b=11;else{b=0;break b}}else b=2}else b=1}else b=0;while(0)}else{b=0;while(1){f=h+(b*12|0)|0;d=a[f+11>>0]|0;e=d<<24>>24<0;d=d&255;do if(((e?c[h+(b*12|0)+4>>2]|0:d)|0)==(i|0)){g=c[f>>2]|0;if(e)if(!(xj(g,j,i)|0))break b;else break;if((g&255)<<24>>24!=(a[j>>0]|0))break;e=j;do{d=d+-1|0;f=f+1|0;if(!d)break b;e=e+1|0}while((a[f>>0]|0)==(a[e>>0]|0))}while(0);b=b+1|0;if((b|0)>=12){b=0;break}}}while(0);Mt(p);Mt(m);re(C,q)|0;h=q+11|0;d=a[h>>0]|0;i=q+4|0;e=c[i>>2]|0;do if(((d<<24>>24<0?e:d&255)|0)==8)if(!(au(q,0,-1,21665,8)|0)){Nt(r,1163844+(b*12|0)|0)|0;re(C,q)|0;u=125;break}else{d=a[h>>0]|0;e=c[i>>2]|0;u=117;break}else u=117;while(0);c:do if(((u|0)==117?((d<<24>>24<0?e:d&255)|0)==3:0)?(au(q,0,-1,21674,3)|0)==0:0){u=re(C,q)|0;if(!(c[u+(c[(c[u>>2]|0)+-12>>2]|0)+16>>2]&5)){f=x+11|0;g=x+4|0;while(1){d=a[h>>0]|0;e=c[i>>2]|0;if(((d<<24>>24<0?e:d&255)|0)==5){if(!(au(q,0,-1,21678,5)|0)){u=125;break c}d=a[h>>0]|0;e=c[i>>2]|0};c[x>>2]=0;c[x+4>>2]=0;c[x+8>>2]=0;t=d<<24>>24<0;u=t?e:d&255;bu(x,t?c[q>>2]|0:q,u,u+1|0);Vt(x,21684,1)|0;u=a[f>>0]|0;t=u<<24>>24<0;Vt(r,t?c[x>>2]|0:x,t?c[g>>2]|0:u&255)|0;Mt(x);u=re(C,q)|0;if(c[u+(c[(c[u>>2]|0)+-12>>2]|0)+16>>2]&5|0){u=125;break}}}else u=125}while(0);d:do if((u|0)==125){h=At(24)|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;g=h+20|0;jh(h,1);f=c[g>>2]|0;d=c[h+4>>2]|0;e=(c[h+16>>2]|0)+f|0;if((c[h+8>>2]|0)==(d|0))d=0;else d=(c[d+(e>>>4<<2)>>2]|0)+((e&15)*440|0)|0;Wu(d|0,0,440)|0;c[g>>2]=f+1;o=c[290997]|0;c[290997]=h;if(o|0){m=o+4|0;e=c[m>>2]|0;k=o+16|0;d=c[k>>2]|0;f=e+(d>>>4<<2)|0;n=o+8|0;u=c[n>>2]|0;i=u;j=e;if((u|0)==(e|0)){d=0;g=0;h=o+20|0}else{h=o+20|0;g=(c[h>>2]|0)+d|0;d=(c[f>>2]|0)+((d&15)*440|0)|0;g=(c[e+(g>>>4<<2)>>2]|0)+((g&15)*440|0)|0}e:while(1){do{if((d|0)==(g|0))break e;d=d+440|0}while((d-(c[f>>2]|0)|0)!=7040);d=f+4|0;f=d;d=c[d>>2]|0}c[h>>2]=0;d=i-j>>2;if(d>>>0>2)do{Dt(c[e>>2]|0);e=(c[m>>2]|0)+4|0;c[m>>2]=e;d=(c[n>>2]|0)-e>>2}while(d>>>0>2);switch(d|0){case 1:{c[k>>2]=8;break}case 2:{c[k>>2]=16;break}default:{}}d=c[m>>2]|0;e=c[n>>2]|0;do if((d|0)!=(e|0)){do{Dt(c[d>>2]|0);d=d+4|0}while((d|0)!=(e|0));d=c[m>>2]|0;e=c[n>>2]|0;if((e|0)==(d|0))break;c[n>>2]=e+(~((e+-4-d|0)>>>2)<<2)}while(0);d=c[o>>2]|0;if(d|0)Dt(d);Dt(o)};c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;Jt(p,22066,12);c[x>>2]=p;ae(w,1163992,p,1233091,x,v);d=(xh((c[w>>2]|0)+28|0)|0)!=0;f=c[290997]|0;e=(c[f+20>>2]|0)+-1+(c[f+16>>2]|0)|0;e=(c[(c[f+4>>2]|0)+(e>>>4<<2)>>2]|0)+((e&15)*440|0)|0;f=c[290941]|0;if((c[290942]|0)==(f|0))ws(1163764);zf(988424,r,d,b,e,c[f>>2]|0)|0;Mt(p);w=re(C,q)|0;if(c[w+(c[(c[w>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;do{k=nh(988424,q)|0;if(!k)break d;b=c[290997]|0;Wu(x|0,0,440)|0;i=b+8|0;e=c[i>>2]|0;j=b+4|0;d=c[j>>2]|0;w=e-d|0;f=b+16|0;g=c[f>>2]|0;m=b+20|0;h=c[m>>2]|0;if((((w|0)==0?0:(w<<2)+-1|0)|0)==(h+g|0)){ph(b);g=c[f>>2]|0;b=c[m>>2]|0;e=c[i>>2]|0;d=c[j>>2]|0}else b=h;b=b+g|0;if((e|0)==(d|0))b=0;else b=(c[d+(b>>>4<<2)>>2]|0)+((b&15)*440|0)|0;cv(b|0,x|0,440)|0;c[m>>2]=(c[m>>2]|0)+1;v=c[290997]|0;w=(c[v+20>>2]|0)+-1+(c[v+16>>2]|0)|0;w=(c[(c[v+4>>2]|0)+(w>>>4<<2)>>2]|0)+((w&15)*440|0)|0;Tf(988424,k,w,Rf(988424,k)|0);w=re(C,q)|0}while(!(c[w+(c[(c[w>>2]|0)+-12>>2]|0)+16>>2]&5|0))}while(0);Mt(r);Mt(q);c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);if(((d<<24>>24<0?b:d&255)|0)==9?(au(E,0,-1,21686,9)|0)==0:0){c[q>>2]=0;c[q+4>>2]=0;c[q+8>>2]=0;c[r>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;re(C,q)|0;t=re(C,q)|0;f:do if(!(c[t+(c[(c[t>>2]|0)+-12>>2]|0)+16>>2]&5)){b=q+11|0;d=q+4|0;e=r+11|0;f=r+4|0;g=x+11|0;h=x+4|0;do{t=a[b>>0]|0;if(((t<<24>>24<0?c[d>>2]|0:t&255)|0)==5?(au(q,0,-1,21696,5)|0)==0:0)break f;t=a[e>>0]|0;t=((t<<24>>24<0?c[f>>2]|0:t&255)|0)!=0&1;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Jt(v,21684,t);t=a[b>>0]|0;s=t<<24>>24<0;t=Vt(v,s?c[q>>2]|0:q,s?c[d>>2]|0:t&255)|0;c[x>>2]=c[t>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;t=a[g>>0]|0;s=t<<24>>24<0;Vt(r,s?c[x>>2]|0:x,s?c[h>>2]|0:t&255)|0;Mt(x);Mt(v);t=re(C,q)|0}while(!(c[t+(c[(c[t>>2]|0)+-12>>2]|0)+16>>2]&5|0))}while(0);t=re(C,q)|0;if(!(c[t+(c[(c[t>>2]|0)+-12>>2]|0)+16>>2]&5)){b=p+11|0;d=p+4|0;e=q+11|0;f=q+4|0;g=x+11|0;h=x+4|0;do{t=a[b>>0]|0;t=((t<<24>>24<0?c[d>>2]|0:t&255)|0)!=0&1;c[v>>2]=0;c[v+4>>2]=0;c[v+8>>2]=0;Jt(v,21684,t);t=a[e>>0]|0;s=t<<24>>24<0;t=Vt(v,s?c[q>>2]|0:q,s?c[f>>2]|0:t&255)|0;c[x>>2]=c[t>>2];c[x+4>>2]=c[t+4>>2];c[x+8>>2]=c[t+8>>2];c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;t=a[g>>0]|0;s=t<<24>>24<0;Vt(p,s?c[x>>2]|0:x,s?c[h>>2]|0:t&255)|0;Mt(x);Mt(v);t=re(C,q)|0}while(!(c[t+(c[(c[t>>2]|0)+-12>>2]|0)+16>>2]&5|0))}b=c[290999]|0;g:do if(b){while(1){d=b+16|0;if(!(Bh(1164e3,r,d)|0)){if(!(Bh(1164e3,d,r)|0))break;b=b+4|0}b=c[b>>2]|0;if(!b){u=200;break g}}c[x>>2]=r;qh(w,1163992,r,1233091,x,v);Jh((c[w>>2]|0)+28|0,p)|0;t=a[r+11>>0]|0;if(((t<<24>>24<0?c[r+4>>2]|0:t&255)|0)==11){if(au(r,0,-1,22079,11)|0)break;h=c[290958]|0;i=a[p+11>>0]|0;j=i<<24>>24<0;i=j?c[p+4>>2]|0:i&255;j=j?c[p>>2]|0:p;h:do if(!i){t=a[h+11>>0]|0;do if((t<<24>>24<0?c[h+4>>2]|0:t&255)|0){t=a[h+12+11>>0]|0;if(!((t<<24>>24<0?c[h+16>>2]|0:t&255)|0)){b=1;break}t=a[h+24+11>>0]|0;if(!((t<<24>>24<0?c[h+28>>2]|0:t&255)|0)){b=2;break}t=a[h+36+11>>0]|0;if(!((t<<24>>24<0?c[h+40>>2]|0:t&255)|0)){b=3;break}t=a[h+48+11>>0]|0;if(!((t<<24>>24<0?c[h+52>>2]|0:t&255)|0)){b=4;break}t=a[h+60+11>>0]|0;if(!((t<<24>>24<0?c[h+64>>2]|0:t&255)|0)){b=5;break}t=a[h+72+11>>0]|0;if(!((t<<24>>24<0?c[h+76>>2]|0:t&255)|0)){b=6;break}t=a[h+84+11>>0]|0;if(!((t<<24>>24<0?c[h+88>>2]|0:t&255)|0)){b=7;break}t=a[h+96+11>>0]|0;if(!((t<<24>>24<0?c[h+100>>2]|0:t&255)|0)){b=8;break}t=a[h+108+11>>0]|0;if(!((t<<24>>24<0?c[h+112>>2]|0:t&255)|0)){b=9;break}t=a[h+120+11>>0]|0;if(!((t<<24>>24<0?c[h+124>>2]|0:t&255)|0)){b=10;break}t=a[h+132+11>>0]|0;if(!((t<<24>>24<0?c[h+136>>2]|0:t&255)|0))b=11;else{b=0;break h}}else b=0;while(0)}else{b=0;while(1){f=h+(b*12|0)|0;d=a[f+11>>0]|0;e=d<<24>>24<0;d=d&255;do if(((e?c[h+(b*12|0)+4>>2]|0:d)|0)==(i|0)){g=c[f>>2]|0;if(e)if(!(xj(g,j,i)|0))break h;else break;if((g&255)<<24>>24!=(a[j>>0]|0))break;e=j;do{d=d+-1|0;f=f+1|0;if(!d)break h;e=e+1|0}while((a[f>>0]|0)==(a[e>>0]|0))}while(0);b=b+1|0;if((b|0)>=12){b=0;break}}}while(0);o=Kd(te(1164756,0)|0,21702,20)|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,22079,11);c[x>>2]=k;ae(w,1163992,k,1233091,x,v);zh(m,(c[w>>2]|0)+28|0);s=a[m+11>>0]|0;t=s<<24>>24<0;s=Kd(Kd(o,t?c[m>>2]|0:m,t?c[m+4>>2]|0:s&255)|0,21723,10)|0;t=1163844+(b*12|0)|0;w=a[t+11>>0]|0;v=w<<24>>24<0;w=Kd(s,v?c[t>>2]|0:t,v?c[1163844+(b*12|0)+4>>2]|0:w&255)|0;c[x>>2]=Sk(w+(c[(c[w>>2]|0)+-12>>2]|0)|0)|0;v=lm(x,1165628)|0;v=nb[c[(c[v>>2]|0)+28>>2]&63](v,10)|0;pt(x);il(w,v)|0;Xk(w)|0;te(w,1)|0;Mt(m);Mt(k)}}else u=200;while(0);if((u|0)==200){u=Kd(te(1164756,0)|0,21734,16)|0;w=a[r+11>>0]|0;v=w<<24>>24<0;w=Kd(u,v?c[r>>2]|0:r,v?c[r+4>>2]|0:w&255)|0;c[x>>2]=Sk(w+(c[(c[w>>2]|0)+-12>>2]|0)|0)|0;v=lm(x,1165628)|0;v=nb[c[(c[v>>2]|0)+28>>2]&63](v,10)|0;pt(x);il(w,v)|0;Xk(w)|0;te(w,1)|0}Mt(p);Mt(r);Mt(q);c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}u=Kd(te(1164756,0)|0,21751,17)|0;w=a[B+11>>0]|0;v=w<<24>>24<0;w=Kd(u,v?c[B>>2]|0:B,v?c[B+4>>2]|0:w&255)|0;c[x>>2]=Sk(w+(c[(c[w>>2]|0)+-12>>2]|0)|0)|0;v=lm(x,1165628)|0;v=nb[c[(c[v>>2]|0)+28>>2]&63](v,10)|0;pt(x);il(w,v)|0;Xk(w)|0;te(w,1)|0;c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}while(0);a[1233085]=1;b=c[290941]|0;if((c[290942]|0)==(b|0))ws(1163764);Tg(c[b>>2]|0,1);c[C>>2]=10848;c[z>>2]=10868;c[y>>2]=3708;Mt(A);Tj(y);Vk(C,10880);Pj(z);Mt(B);Mt(E);l=F;return}function nh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+4112|0;f=u+12|0;r=u;s=d+11|0;q=a[s>>0]|0;e=q<<24>>24<0;t=d+4|0;if(((e?c[t>>2]|0:q&255)|0)==5){q=(e?c[d>>2]|0:d)+4|0;a[q>>0]=gj(a[q>>0]|0)|0}q=kf(b,f)|0;c[f+4096>>2]=q;if((f|0)==(q|0)){t=0;l=u;return t|0}m=b+5360|0;n=r+11|0;o=r+4|0;e=f;a:while(1){rh(r,c[e>>2]|0,(a[m>>0]|0)!=0);f=a[s>>0]|0;h=f<<24>>24<0;f=f&255;i=h?c[t>>2]|0:f;k=a[n>>0]|0;b=k<<24>>24<0;do if((i|0)==((b?c[o>>2]|0:k&255)|0)){j=c[d>>2]|0;k=h?j:d;b=b?c[r>>2]|0:r;g=(i|0)==0;if(h){if(g){p=12;break a}k=(xj(k,b,i)|0)==0;Mt(r);if(k)break a;else break}if(g){p=12;break a}if((j&255)<<24>>24==(a[b>>0]|0)){g=d;while(1){f=f+-1|0;g=g+1|0;if(!f){p=12;break a}b=b+1|0;if((a[g>>0]|0)!=(a[b>>0]|0)){p=13;break}}}else p=13}else p=13;while(0);if((p|0)==13){p=0;Mt(r)}e=e+8|0;if((e|0)==(q|0)){e=0;p=17;break}}if((p|0)==12)Mt(r);else if((p|0)==17){l=u;return e|0}t=c[e>>2]|0;l=u;return t|0}function oh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;i=a+4|0;e=c[i>>2]|0;j=c[a>>2]|0;d=(e-j>>2)+1|0;if(d>>>0>1073741823)vs(a);k=a+8|0;h=(c[k>>2]|0)-j|0;f=h>>1;f=h>>2>>>0<536870911?(f>>>0<d>>>0?d:f):1073741823;if(!f)h=0;else h=At(f<<2)|0;g=h+(e-j>>2<<2)|0;c[g>>2]=c[b>>2];d=e-j|0;b=g+(0-(d>>2)<<2)|0;if((d|0)>0)cv(b|0,j|0,d|0)|0;c[a>>2]=b;c[i>>2]=g+4;c[k>>2]=h+(f<<2);if(!j)return;Dt(j);return}function ph(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+16|0;h=q;b=a+16|0;d=c[b>>2]|0;if(d>>>0>15){c[b>>2]=d+-16;m=a+4|0;k=c[m>>2]|0;o=c[k>>2]|0;k=k+4|0;c[m>>2]=k;n=a+8|0;i=c[n>>2]|0;j=a+12|0;p=c[j>>2]|0;b=p;g=i;do if((i|0)==(p|0)){d=c[a>>2]|0;e=d;if(k>>>0>d>>>0){b=k;e=((b-e>>2)+1|0)/-2|0;f=k+(e<<2)|0;b=g-b|0;d=b>>2;if(!d)b=k;else{hv(f|0,k|0,b|0)|0;b=c[m>>2]|0}a=f+(d<<2)|0;c[n>>2]=a;c[m>>2]=b+(e<<2);b=a;break}h=b-e>>1;h=(h|0)==0?1:h;p=At(h<<2)|0;f=p;b=p+(h>>>2<<2)|0;g=b;h=p+(h<<2)|0;if((k|0)==(i|0))b=g;else{e=b;b=g;d=k;do{c[e>>2]=c[d>>2];e=b+4|0;b=e;d=d+4|0}while((d|0)!=(i|0));d=c[a>>2]|0}c[a>>2]=f;c[m>>2]=g;c[n>>2]=b;c[j>>2]=h;if(d){Dt(d);b=c[n>>2]|0}}else b=i;while(0);c[b>>2]=o;c[n>>2]=(c[n>>2]|0)+4;l=q;return}p=a+8|0;b=c[p>>2]|0;o=a+4|0;d=c[o>>2]|0;i=b-d|0;j=i>>2;n=a+12|0;e=c[n>>2]|0;f=e-(c[a>>2]|0)|0;g=b;if(j>>>0<f>>2>>>0){if((e|0)!=(b|0)){c[h>>2]=At(7040)|0;kh(a,h);l=q;return}c[h>>2]=At(7040)|0;lh(a,h);j=c[o>>2]|0;k=c[j>>2]|0;j=j+4|0;c[o>>2]=j;i=c[p>>2]|0;m=c[n>>2]|0;b=m;g=i;do if((i|0)==(m|0)){d=c[a>>2]|0;e=d;if(j>>>0>d>>>0){b=j;e=((b-e>>2)+1|0)/-2|0;f=j+(e<<2)|0;b=g-b|0;d=b>>2;if(!d)b=j;else{hv(f|0,j|0,b|0)|0;b=c[o>>2]|0}a=f+(d<<2)|0;c[p>>2]=a;c[o>>2]=b+(e<<2);b=a;break}h=b-e>>1;h=(h|0)==0?1:h;m=At(h<<2)|0;f=m;b=m+(h>>>2<<2)|0;g=b;h=m+(h<<2)|0;if((j|0)==(i|0))b=g;else{e=b;b=g;d=j;do{c[e>>2]=c[d>>2];e=b+4|0;b=e;d=d+4|0}while((d|0)!=(i|0));d=c[a>>2]|0}c[a>>2]=f;c[o>>2]=g;c[p>>2]=b;c[n>>2]=h;if(d){Dt(d);b=c[p>>2]|0}}else b=i;while(0);c[b>>2]=k;c[p>>2]=(c[p>>2]|0)+4;l=q;return}m=f>>1;m=(m|0)==0?1:m;e=At(m<<2)|0;f=e;h=e+(j<<2)|0;b=e+(m<<2)|0;k=At(7040)|0;do if((j|0)==(m|0))if((i|0)>0){i=f;e=h+(((j+1|0)/-2|0)<<2)|0;break}else{b=i>>1;b=(b|0)==0?1:b;g=At(b<<2)|0;Dt(e);i=g;e=g+(b>>>2<<2)|0;b=g+(b<<2)|0;g=c[p>>2]|0;d=c[o>>2]|0;break}else{i=f;e=h}while(0);f=e;c[e>>2]=k;e=e+4|0;if((g|0)==(d|0))g=i;else while(1){g=g+-4|0;d=f;do if((d|0)==(i|0)){k=e;if(k>>>0<b>>>0){h=k+((((b-e>>2)+1|0)/2|0)<<2)|0;d=e-f|0;m=d>>2;e=h+(0-m<<2)|0;if(!m)d=h;else{hv(e|0,f|0,d|0)|0;d=e}f=d;e=h;break}b=b-i>>1;b=(b|0)==0?1:b;h=At(b<<2)|0;i=h;m=h+((b+3|0)>>>2<<2)|0;j=m;b=h+(b<<2)|0;if((d|0)==(k|0))e=j;else{h=m;e=j;do{c[h>>2]=c[d>>2];h=e+4|0;e=h;d=d+4|0}while((d|0)!=(k|0))}if(!f){f=j;d=m}else{Dt(f);f=j;d=m}}while(0);c[d+-4>>2]=c[g>>2];d=f+-4|0;if((g|0)==(c[o>>2]|0)){g=i;f=d;break}else f=d}d=c[a>>2]|0;c[a>>2]=g;c[o>>2]=f;c[p>>2]=e;c[n>>2]=b;if(!d){l=q;return}Dt(d);l=q;return}function qh(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0;m=l;l=l+16|0;k=m;h=d+4|0;f=c[h>>2]|0;do if(f){j=d+8|0;while(1){h=f+16|0;if(Bh(j,e,h)|0){h=c[f>>2]|0;if(!h){h=5;break}else f=h}else{if(!(Bh(j,h,e)|0)){h=10;break}i=f+4|0;h=c[i>>2]|0;if(!h){h=9;break}else f=h}}if((h|0)==5){c[k>>2]=f;j=f;i=f;break}else if((h|0)==9){c[k>>2]=f;j=f;break}else if((h|0)==10){c[k>>2]=f;j=f;i=k;break}}else{c[k>>2]=h;j=h;i=h}while(0);f=c[i>>2]|0;if(f|0){d=f;g=0;c[b>>2]=d;d=b+4|0;a[d>>0]=g;l=m;return}h=At(92)|0;It(h+16|0,c[g>>2]|0);Ih(h+28|0,0);c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=j;c[i>>2]=h;f=c[c[d>>2]>>2]|0;if(!f)f=h;else{c[d>>2]=f;f=c[i>>2]|0}dc(c[d+4>>2]|0,f);d=d+8|0;c[d>>2]=(c[d>>2]|0)+1;d=h;g=1;c[b>>2]=d;d=b+4|0;a[d>>0]=g;l=m;return}function rh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+48|0;n=o+24|0;h=o+12|0;i=o;j=d&49152;k=(j|0)==32768;if(k)g=(d&12288|0)==4096?64:d>>>6&63;else g=d>>>6&63;f=d&63;switch(d|0){case 0:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21769,6);l=o;return}case 65:{c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21776,4);l=o;return}default:{if(k)if((d&12288|0)==4096){m=a[21781+(d>>>6&15)>>0]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;a[h+11>>0]=2;a[h>>0]=m;a[h+1>>0]=64;a[h+2>>0]=0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;a[i+11>>0]=2;a[i>>0]=(d&7)+97;a[i+1>>0]=(f>>>3)+49;a[i+2>>0]=0;f=Vt(h,i,2)|0;c[n>>2]=c[f>>2];c[n+4>>2]=c[f+4>>2];c[n+8>>2]=c[f+8>>2];c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Mt(i);Mt(h);f=n;m=14}else{e=f;f=n;m=13}else{if(!((j|0)!=49152|e))f=((f|0)>(g|0)?6:2)|g&-8;e=f;f=n;m=13}if((m|0)==13){c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;a[h+11>>0]=2;a[h>>0]=(g&7)+97;a[h+1>>0]=(g>>>3)+49;a[h+2>>0]=0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;a[i+11>>0]=2;a[i>>0]=(e&7)+97;a[i+1>>0]=(e>>>3)+49;a[i+2>>0]=0;g=Vt(h,i,2)|0;c[f>>2]=c[g>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Mt(i);Mt(h);if(!k){if((j|0)==16384)m=16}else m=14}if((m|0)==14)if((d&12288|0)==8192)m=16;if((m|0)==16)Xt(n,a[21798+((d&61440|0)==40960?6:(d>>>12&3)+2|0)>>0]|0);c[b>>2]=c[f>>2];c[b+4>>2]=c[f+4>>2];c[b+8>>2]=c[f+8>>2];c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Mt(n);l=o;return}}}function sh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0;i=l;l=l+160|0;e=i+144|0;f=i;d=f+8|0;c[d>>2]=3632;g=f+12|0;c[f>>2]=3672;h=f+64|0;c[h>>2]=3692;c[f+4>>2]=0;Rk(f+64|0,g);c[f+136>>2]=0;c[f+140>>2]=-1;c[f>>2]=3612;c[f+64>>2]=3652;c[d>>2]=3632;Tk(g);c[g>>2]=3708;d=f+44|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[f+60>>2]=24;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jd(g,e);Mt(e);e=f+8|0;if((((b|0)>-1?b:0-b|0)|0)<31872)dl(Kd(e,21806,3)|0,(b*100|0)/248|0)|0;else{j=Kd(e,21810,5)|0;dl(j,(((b|0)>0?32001:-32e3)-b|0)/2|0)|0}Ld(a,g);c[f>>2]=3612;c[h>>2]=3652;c[e>>2]=3632;c[g>>2]=3708;Mt(d);Tj(g);jl(f,3768);Pj(h);l=i;return}function th(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;a[b+11>>0]=2;a[b>>0]=(d&7)+97;a[b+1>>0]=(d>>>3)+49;a[b+2>>0]=0;return}function uh(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[291002]=p;c[291001]=p;c[291003]=p+144;It(p,b);p=(c[291002]|0)+12|0;c[291002]=p;It(p,d);p=(c[291002]|0)+12|0;c[291002]=p;It(p,e);p=(c[291002]|0)+12|0;c[291002]=p;It(p,f);p=(c[291002]|0)+12|0;c[291002]=p;It(p,g);p=(c[291002]|0)+12|0;c[291002]=p;It(p,h);p=(c[291002]|0)+12|0;c[291002]=p;It(p,i);p=(c[291002]|0)+12|0;c[291002]=p;It(p,j);p=(c[291002]|0)+12|0;c[291002]=p;It(p,k);p=(c[291002]|0)+12|0;c[291002]=p;It(p,m);p=(c[291002]|0)+12|0;c[291002]=p;It(p,n);p=(c[291002]|0)+12|0;c[291002]=p;It(p,o);c[291002]=(c[291002]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);c[290999]=0;c[291e3]=0;c[290998]=1163996;l=a;return}function vh(a){a=a|0;Lg();return}function wh(b){b=b|0;var d=0,e=0;e=b+24|0;d=a[e+11>>0]|0;if(((d<<24>>24<0?c[b+28>>2]|0:d&255)|0)==4){d=b+12|0;if(!(au(e,0,-1,21921,4)|0)){b=nu(d,0,10)|0;dh(1163804,b);return}}else d=b+12|0;e=a[d+11>>0]|0;if(((e<<24>>24<0?c[b+16>>2]|0:e&255)|0)==4)d=(au(d,0,-1,27651,4)|0)==0;else d=0;b=d&1;dh(1163804,b);return}function xh(b){b=b|0;var d=0,e=0;e=b+24|0;d=a[e+11>>0]|0;if(((d<<24>>24<0?c[b+28>>2]|0:d&255)|0)==4){d=b+12|0;if(!(au(e,0,-1,21921,4)|0)){b=nu(d,0,10)|0;return b|0}}else d=b+12|0;e=a[d+11>>0]|0;if(((e<<24>>24<0?c[b+16>>2]|0:e&255)|0)==4)d=(au(d,0,-1,27651,4)|0)==0;else d=0;b=d&1;return b|0}function yh(a){a=a|0;var b=0,c=0;b=l;l=l+16|0;c=b;It(c,a+12|0);ue(c);Mt(c);l=b;return}function zh(a,b){a=a|0;b=b|0;It(a,b+12|0);return}function Ah(a){a=a|0;Wg(1163764);return}function Bh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=a[d+11>>0]|0;g=h<<24>>24<0;f=g?c[d>>2]|0:d;h=f+(g?c[d+4>>2]|0:h&255)|0;g=a[e+11>>0]|0;d=g<<24>>24<0;b=d?c[e>>2]|0:e;e=d?c[e+4>>2]|0:g&255;g=b+e|0;if(!e){h=0;return h|0}while(1){if((f|0)==(h|0)){b=1;d=6;break}e=a[b>>0]|0;d=gj(a[f>>0]|0)|0;e=gj(e<<24>>24)|0;if((d|0)<(e|0)){b=1;d=6;break}if((e|0)<(d|0)){b=0;d=6;break}b=b+1|0;if((b|0)==(g|0)){b=0;d=6;break}else f=f+1|0}if((d|0)==6)return b|0;return 0}function Ch(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;o=l;l=l+144|0;m=o+128|0;n=o+64|0;k=o;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21926,14);d=Dh(b,m)|0;h=n+12|0;i=n+24|0;e=n;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(i,21941,6);f=n+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[n+60>>2]=158;Nt(n,Rt(h,1235164)|0)|0;Nt(d,n)|0;Nt(d+12|0,h)|0;Nt(d+24|0,i)|0;g=c[f+4>>2]|0;j=d+36|0;c[j>>2]=c[f>>2];c[j+4>>2]=g;if((d|0)!=(n|0))Eh(d+44|0,c[n+44>>2]|0,c[n+48>>2]|0);f=d+56|0;g=n+56|0;j=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=j;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=n+44|0;d=c[f>>2]|0;if(d|0){g=n+48|0;e=c[g>>2]|0;if((e|0)!=(d|0)){do{j=e+-12|0;c[g>>2]=j;Mt(j);e=c[g>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(i);Mt(h);Mt(n);Mt(m);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21948,8);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=-100;c[k+40>>2]=100;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=0;su(m,0);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;p=d;d=c[p+4>>2]|0;f=g+36|0;c[f>>2]=c[p>>2];c[f+4>>2]=d;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21957,7);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=1;c[k+40>>2]=1;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=159;su(m,1);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21965,4);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=1;c[k+40>>2]=2048;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=160;su(m,16);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21970,10);d=Dh(b,m)|0;i=n+24|0;e=n;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(i,21981,6);g=n+36|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[n+60>>2]=161;Nt(d,n)|0;h=n+12|0;Nt(d+12|0,h)|0;Nt(d+24|0,i)|0;j=c[g+4>>2]|0;p=d+36|0;c[p>>2]=c[g>>2];c[p+4>>2]=j;if((d|0)!=(n|0))Eh(d+44|0,c[n+44>>2]|0,c[n+48>>2]|0);f=d+56|0;j=n+56|0;p=c[j+4>>2]|0;d=f;c[d>>2]=c[j>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=n+44|0;d=c[f>>2]|0;if(d|0){g=n+48|0;e=c[g>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[g>>2]=p;Mt(p);e=c[g>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(i);Mt(h);Mt(n);Mt(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21988,6);d=Dh(b,m)|0;h=n+12|0;i=n+24|0;e=n;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(i,21995,5);g=n+36|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;c[g+12>>2]=0;c[g+16>>2]=0;c[n+60>>2]=0;Nt(n,Rt(h,27645)|0)|0;Nt(d,n)|0;Nt(d+12|0,h)|0;Nt(d+24|0,i)|0;j=c[g+4>>2]|0;p=d+36|0;c[p>>2]=c[g>>2];c[p+4>>2]=j;if((d|0)!=(n|0))Eh(d+44|0,c[n+44>>2]|0,c[n+48>>2]|0);f=d+56|0;j=n+56|0;p=c[j+4>>2]|0;d=f;c[d>>2]=c[j>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=n+44|0;d=c[f>>2]|0;if(d|0){g=n+48|0;e=c[g>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[g>>2]=p;Mt(p);e=c[g>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(i);Mt(h);Mt(n);Mt(m);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,22001,7);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=1;c[k+40>>2]=500;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=0;su(m,1);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,22009,13);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=0;c[k+40>>2]=5e3;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=0;su(m,30);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,22023,21);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=0;c[k+40>>2]=5e3;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=0;su(m,20);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,22045,10);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=10;c[k+40>>2]=1e3;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=0;su(m,89);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,22056,9);g=Dh(b,n)|0;i=k+12|0;j=k+24|0;e=k;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(j,21921,4);d=k+36|0;c[d>>2]=0;c[k+40>>2]=1e4;e=k+44|0;c[e>>2]=0;h=k+48|0;c[h>>2]=0;c[k+52>>2]=0;c[k+60>>2]=0;su(m,0);f=i+11|0;if((a[f>>0]|0)<0){a[c[i>>2]>>0]=0;c[k+16>>2]=0}else{a[i>>0]=0;a[f>>0]=0}Qt(i,0);c[i>>2]=c[m>>2];c[i+4>>2]=c[m+4>>2];c[i+8>>2]=c[m+8>>2];c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Nt(k,i)|0;Mt(m);Nt(g,k)|0;Nt(g+12|0,i)|0;Nt(g+24|0,j)|0;f=c[d+4>>2]|0;p=g+36|0;c[p>>2]=c[d>>2];c[p+4>>2]=f;if((g|0)!=(k|0))Eh(g+44|0,c[e>>2]|0,c[h>>2]|0);f=g+56|0;g=k+56|0;p=c[g+4>>2]|0;d=f;c[d>>2]=c[g>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=k+44|0;d=c[f>>2]|0;if(d|0){e=c[h>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[h>>2]=p;Mt(p);e=c[h>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(j);Mt(i);Mt(k);Mt(n);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,22066,12);d=Dh(b,m)|0;h=n+12|0;i=n+24|0;e=n;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(i,21995,5);j=n+36|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[n+60>>2]=0;Nt(n,Rt(h,27645)|0)|0;Nt(d,n)|0;Nt(d+12|0,h)|0;Nt(d+24|0,i)|0;k=c[j+4>>2]|0;p=d+36|0;c[p>>2]=c[j>>2];c[p+4>>2]=k;if((d|0)!=(n|0))Eh(d+44|0,c[n+44>>2]|0,c[n+48>>2]|0);f=d+56|0;k=n+56|0;p=c[k+4>>2]|0;d=f;c[d>>2]=c[k>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=n+44|0;d=c[f>>2]|0;if(d|0){g=n+48|0;e=c[g>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[g>>2]=p;Mt(p);e=c[g>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d)}Mt(i);Mt(h);Mt(n);Mt(m);c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,22079,11);e=Dh(b,m)|0;d=c[291001]|0;if((a[d+11>>0]|0)<0)d=c[d>>2]|0;Fh(n,d,1164004,0);Nt(e,n)|0;h=n+12|0;Nt(e+12|0,h)|0;i=n+24|0;Nt(e+24|0,i)|0;k=n+36|0;b=c[k+4>>2]|0;p=e+36|0;c[p>>2]=c[k>>2];c[p+4>>2]=b;if((e|0)!=(n|0))Eh(e+44|0,c[n+44>>2]|0,c[n+48>>2]|0);f=e+56|0;b=n+56|0;p=c[b+4>>2]|0;d=f;c[d>>2]=c[b>>2];c[d+4>>2]=p;d=c[291004]|0;c[291004]=d+1;c[f>>2]=d;f=n+44|0;d=c[f>>2]|0;if(!d){Mt(i);Mt(h);Mt(n);Mt(m);l=o;return}g=n+48|0;e=c[g>>2]|0;if((e|0)!=(d|0)){do{p=e+-12|0;c[g>>2]=p;Mt(p);e=c[g>>2]|0}while((e|0)!=(d|0));d=c[f>>2]|0}Dt(d);Mt(i);Mt(h);Mt(n);Mt(m);l=o;return}function Dh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;f=i;g=Gh(a,f,b)|0;d=c[g>>2]|0;if(d|0){a=d;a=a+28|0;l=i;return a|0}h=At(92)|0;d=h+16|0;c[d>>2]=c[b>>2];c[d+4>>2]=c[b+4>>2];c[d+8>>2]=c[b+8>>2];c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=h+52|0;b=h+28|0;e=b+36|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));Jt(d,21981,6);d=h+64|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[h+88>>2]=0;d=c[f>>2]|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=d;c[g>>2]=h;d=c[c[a>>2]>>2]|0;if(!d)d=h;else{c[a>>2]=d;d=c[g>>2]|0}dc(c[a+4>>2]|0,d);a=a+8|0;c[a>>2]=(c[a>>2]|0)+1;a=h;a=a+28|0;l=i;return a|0}function Eh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=(d-b|0)/12|0;j=a+8|0;e=c[j>>2]|0;h=c[a>>2]|0;f=h;if(i>>>0<=((e-h|0)/12|0)>>>0){a=a+4|0;e=((c[a>>2]|0)-h|0)/12|0;h=i>>>0>e>>>0;e=b+(e*12|0)|0;g=h?e:d;if((g|0)!=(b|0))do{Nt(f,b)|0;b=b+12|0;f=f+12|0}while((b|0)!=(g|0));if(!h){e=c[a>>2]|0;if((e|0)==(f|0))return;do{d=e+-12|0;c[a>>2]=d;Mt(d);e=c[a>>2]|0}while((e|0)!=(f|0));return}if((g|0)==(d|0))return;b=c[a>>2]|0;do{It(b,e);e=e+12|0;b=(c[a>>2]|0)+12|0;c[a>>2]=b}while((e|0)!=(d|0));return}if(h){g=a+4|0;e=c[g>>2]|0;if((e|0)==(f|0))e=h;else{do{h=e+-12|0;c[g>>2]=h;Mt(h);e=c[g>>2]|0}while((e|0)!=(f|0));e=c[a>>2]|0}Dt(e);c[j>>2]=0;c[g>>2]=0;c[a>>2]=0;e=0}if(i>>>0>357913941)vs(a);h=(e-0|0)/12|0;f=h<<1;f=h>>>0<178956970?(f>>>0<i>>>0?i:f):357913941;if(f>>>0>357913941)vs(a);e=At(f*12|0)|0;g=a+4|0;c[g>>2]=e;c[a>>2]=e;c[j>>2]=e+(f*12|0);if((b|0)==(d|0))return;do{It(e,b);b=b+12|0;e=(c[g>>2]|0)+12|0;c[g>>2]=e}while((b|0)!=(d|0));return}function Fh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;k=a+12|0;f=a+24|0;g=a;h=g+36|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(h|0));Jt(f,22091,5);f=a+36|0;h=a+44|0;j=a+48|0;i=d+4|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;f=(c[i>>2]|0)-(c[d>>2]|0)|0;g=(f|0)/12|0;if(f|0){if(g>>>0>357913941)vs(h);f=At(f)|0;c[j>>2]=f;c[h>>2]=f;c[a+52>>2]=f+(g*12|0);g=c[d>>2]|0;h=c[i>>2]|0;if((g|0)!=(h|0))do{It(f,g);g=g+12|0;f=(c[j>>2]|0)+12|0;c[j>>2]=f}while((g|0)!=(h|0))}c[a+60>>2]=e;Nt(a,Rt(k,b)|0)|0;return}function Gh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;f=b+4|0;b=c[f>>2]|0;if(!b){c[d>>2]=f;d=f;return d|0}j=a[e+11>>0]|0;l=j<<24>>24<0;m=l?c[e>>2]|0:e;j=l?c[e+4>>2]|0:j&255;l=m+j|0;a:do if(!j){e=b+16|0;f=a[e+11>>0]|0;k=f<<24>>24<0;e=k?c[e>>2]|0:e;f=k?c[b+20>>2]|0:f&255;if(!f)k=26;else{i=e+f|0;f=e;while(1){h=m;while(1){if((h|0)==(l|0))break;g=a[f>>0]|0;e=gj(a[h>>0]|0)|0;g=gj(g<<24>>24)|0;if((e|0)<(g|0))break;if((g|0)<(e|0)){k=26;break a}f=f+1|0;if((f|0)==(i|0)){k=26;break a}else h=h+1|0}f=c[b>>2]|0;if(!f){f=b;k=18;break a}g=f+16|0;e=a[g+11>>0]|0;k=e<<24>>24<0;g=k?c[g>>2]|0:g;e=k?c[f+20>>2]|0:e&255;if(!e){b=f;k=26;break}else{b=f;i=g+e|0;f=g}}}}else{while(1){f=b+16|0;i=a[f+11>>0]|0;j=i<<24>>24<0;f=j?c[f>>2]|0:f;i=j?c[b+20>>2]|0:i&255;j=f+i|0;b:do if(i){e=m;g=f;while(1){if((e|0)==(l|0))break;i=a[g>>0]|0;h=gj(a[e>>0]|0)|0;i=gj(i<<24>>24)|0;if((h|0)<(i|0))break;if((i|0)<(h|0)){e=m;k=19;break b}g=g+1|0;if((g|0)==(j|0)){e=m;k=19;break b}else e=e+1|0}f=c[b>>2]|0;if(!f){f=b;k=18;break a}else b=f}else{e=m;k=19}while(0);if((k|0)==19){while(1){k=0;if((f|0)==(j|0))break;h=a[e>>0]|0;g=gj(a[f>>0]|0)|0;h=gj(h<<24>>24)|0;if((g|0)<(h|0))break;if((h|0)<(g|0)){k=26;break a}e=e+1|0;if((e|0)==(l|0)){k=26;break a}else{f=f+1|0;k=19}}f=b+4|0;e=c[f>>2]|0;if(!e)break;else b=e}}c[d>>2]=b;d=f;return d|0}while(0);if((k|0)==18){c[d>>2]=f;d=b;return d|0}else if((k|0)==26){c[d>>2]=b;return d|0}return 0}function Hh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;s=l;l=l+16|0;k=s;m=d+8|0;if(!(c[m>>2]|0)){l=s;return b|0}n=d+4|0;q=k+11|0;r=k+4|0;j=0;do{e=c[d>>2]|0;a:do if((e|0)!=(n|0)){f=e;while(1){if((c[f+84>>2]|0)==(j|0))break;e=c[f+4>>2]|0;if(!e)while(1){e=c[f+8>>2]|0;if((c[e>>2]|0)==(f|0))break;else f=e}else while(1){f=c[e>>2]|0;if(!f)break;else e=f}if((e|0)==(n|0))break a;else f=e}h=f+16|0;e=Kd(b,22097,13)|0;u=a[h+11>>0]|0;g=u<<24>>24<0;u=Kd(Kd(e,g?c[h>>2]|0:h,g?c[f+20>>2]|0:u&255)|0,22111,6)|0;g=f+52|0;h=g+11|0;e=a[h>>0]|0;t=e<<24>>24<0;i=f+56|0;Kd(u,t?c[g>>2]|0:g,t?c[i>>2]|0:e&255)|0;e=a[h>>0]|0;if(!(((e<<24>>24<0?c[i>>2]|0:e&255)|0)==6?!(au(g,0,-1,21981,6)|0):0)){v=Kd(b,22118,9)|0;e=f+28|0;u=a[e+11>>0]|0;t=u<<24>>24<0;Kd(v,t?c[e>>2]|0:e,t?c[f+32>>2]|0:u&255)|0}v=a[h>>0]|0;if((((v<<24>>24<0?c[i>>2]|0:v&255)|0)==5?(au(g,0,-1,22091,5)|0)==0:0)?(o=c[f+72>>2]|0,p=c[f+76>>2]|0,(o|0)!=(p|0)):0){e=o;do{It(k,e);t=Kd(b,22128,5)|0;v=a[q>>0]|0;u=v<<24>>24<0;Kd(t,u?c[k>>2]|0:k,u?c[r>>2]|0:v&255)|0;Mt(k);e=e+12|0}while((e|0)!=(p|0))}v=a[h>>0]|0;if(((v<<24>>24<0?c[i>>2]|0:v&255)|0)==4?(au(g,0,-1,21921,4)|0)==0:0){v=Kd(b,22134,5)|0;v=Kd(dl(v,c[f+64>>2]|0)|0,22140,5)|0;dl(v,c[f+68>>2]|0)|0}}while(0);j=j+1|0}while(j>>>0<(c[m>>2]|0)>>>0);l=s;return b|0}function Ih(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=a+24|0;e=a;f=e+36|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(f|0));Jt(d,21981,6);f=a+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f+16>>2]=0;c[a+60>>2]=b;return}function Jh(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;n=b+24|0;o=n+11|0;m=a[o>>0]|0;p=b+28|0;if(!(((m<<24>>24<0?c[p>>2]|0:m&255)|0)==6?!(au(n,0,-1,21981,6)|0):0))e=3;if((e|0)==3?(m=a[d+11>>0]|0,((m<<24>>24<0?c[d+4>>2]|0:m&255)|0)==0):0)return b|0;m=a[o>>0]|0;do if(((m<<24>>24<0?c[p>>2]|0:m&255)|0)==5?(au(n,0,-1,21995,5)|0)==0:0){f=d+11|0;g=a[f>>0]|0;h=d+4|0;e=c[h>>2]|0;if(((g<<24>>24<0?e:g&255)|0)==4){if(!(au(d,0,-1,27651,4)|0))break;g=a[f>>0]|0;e=c[h>>2]|0}if(((g<<24>>24<0?e:g&255)|0)!=5)return b|0;if(au(d,0,-1,27645,5)|0)return b|0}while(0);m=a[o>>0]|0;if(((m<<24>>24<0?c[p>>2]|0:m&255)|0)==5?(au(n,0,-1,22091,5)|0)==0:0){e=c[b+44>>2]|0;m=c[b+48>>2]|0;a:do if((e|0)!=(m|0)){j=a[d+11>>0]|0;k=j<<24>>24<0;j=k?c[d+4>>2]|0:j&255;k=k?c[d>>2]|0:d;l=(j|0)==0;do{f=a[e+11>>0]|0;g=f<<24>>24<0;f=f&255;do if(((g?c[e+4>>2]|0:f)|0)==(j|0)){h=c[e>>2]|0;i=g?h:e;if(g){if(l)break a;if(!(xj(i,k,j)|0))break a;else break}if(l)break a;if((h&255)<<24>>24==(a[k>>0]|0)){h=e;g=k;do{f=f+-1|0;h=h+1|0;if(!f)break a;g=g+1|0}while((a[h>>0]|0)==(a[g>>0]|0))}}while(0);e=e+12|0}while((e|0)!=(m|0));return b|0}while(0);if((e|0)==(m|0))return b|0}m=a[o>>0]|0;if(((m<<24>>24<0?c[p>>2]|0:m&255)|0)==4?(au(n,0,-1,21921,4)|0)==0:0){m=nu(d,0,10)|0;if((m|0)<(c[b+36>>2]|0))return b|0;m=nu(d,0,10)|0;if((m|0)>(c[b+40>>2]|0))return b|0}o=a[o>>0]|0;if(!(((o<<24>>24<0?c[p>>2]|0:o&255)|0)==6?!(au(n,0,-1,21981,6)|0):0))Nt(b+12|0,d)|0;e=c[b+60>>2]|0;if(!e)return b|0;db[e&255](b);return b|0}function Kh(a){a=a|0;var b=0,d=0;b=l;l=l+16|0;d=b;c[d>>2]=c[a+60>>2];a=Nh(Sa(6,d|0)|0)|0;l=b;return a|0}function Lh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0;q=l;l=l+48|0;n=q+16|0;m=q;i=q+32|0;o=a+28|0;h=c[o>>2]|0;c[i>>2]=h;p=a+20|0;h=(c[p>>2]|0)-h|0;c[i+4>>2]=h;c[i+8>>2]=b;c[i+12>>2]=d;j=a+60|0;k=a+44|0;g=2;b=h+d|0;while(1){if(!(c[291005]|0)){c[n>>2]=c[j>>2];c[n+4>>2]=i;c[n+8>>2]=g;f=Nh(Za(146,n|0)|0)|0}else{xa(162,a|0);c[m>>2]=c[j>>2];c[m+4>>2]=i;c[m+8>>2]=g;f=Nh(Za(146,m|0)|0)|0;ra(0)}if((b|0)==(f|0)){b=6;break}if((f|0)<0){b=8;break}b=b-f|0;e=c[i+4>>2]|0;if(f>>>0<=e>>>0)if((g|0)==2){c[o>>2]=(c[o>>2]|0)+f;g=2;h=i}else h=i;else{h=c[k>>2]|0;c[o>>2]=h;c[p>>2]=h;f=f-e|0;g=g+-1|0;h=i+8|0;e=c[i+12>>2]|0}c[h>>2]=(c[h>>2]|0)+f;c[h+4>>2]=e-f;i=h}if((b|0)==6){n=c[k>>2]|0;c[a+16>>2]=n+(c[a+48>>2]|0);a=n;c[o>>2]=a;c[p>>2]=a}else if((b|0)==8){c[a+16>>2]=0;c[o>>2]=0;c[p>>2]=0;c[a>>2]=c[a>>2]|32;if((g|0)==2)d=0;else d=d-(c[i+4>>2]|0)|0}l=q;return d|0}function Mh(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;f=l;l=l+32|0;g=f;e=f+20|0;c[g>>2]=c[a+60>>2];c[g+4>>2]=0;c[g+8>>2]=b;c[g+12>>2]=e;c[g+16>>2]=d;if((Nh(Wa(140,g|0)|0)|0)<0){c[e>>2]=-1;a=-1}else a=c[e>>2]|0;l=f;return a|0}function Nh(a){a=a|0;if(a>>>0>4294963200){c[(Oh()|0)>>2]=0-a;a=-1}return a|0}function Oh(){var a=0;if(!(c[291005]|0))a=1164064;else a=c[(lv()|0)+64>>2]|0;return a|0}function Ph(a){a=a|0;if(!(c[a+68>>2]|0))Qh(a);return}function Qh(a){a=a|0;return}function Rh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+80|0;f=g;c[b+36>>2]=5;if((c[b>>2]&64|0)==0?(c[f>>2]=c[b+60>>2],c[f+4>>2]=21505,c[f+8>>2]=g+12,La(54,f|0)|0):0)a[b+75>>0]=-1;f=Lh(b,d,e)|0;l=g;return f|0}function Sh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;m=l;l=l+48|0;h=m+16|0;g=m;f=m+32|0;c[f>>2]=d;i=f+4|0;k=b+48|0;n=c[k>>2]|0;c[i>>2]=e-((n|0)!=0&1);j=b+44|0;c[f+8>>2]=c[j>>2];c[f+12>>2]=n;if(!(c[291005]|0)){c[h>>2]=c[b+60>>2];c[h+4>>2]=f;c[h+8>>2]=2;f=Nh(Ua(145,h|0)|0)|0}else{xa(163,b|0);c[g>>2]=c[b+60>>2];c[g+4>>2]=f;c[g+8>>2]=2;f=Nh(Ua(145,g|0)|0)|0;ra(0)}if((f|0)>=1){i=c[i>>2]|0;if(f>>>0>i>>>0){g=c[j>>2]|0;h=b+4|0;c[h>>2]=g;c[b+8>>2]=g+(f-i);if(!(c[k>>2]|0))f=e;else{c[h>>2]=g+1;a[d+(e+-1)>>0]=a[g>>0]|0;f=e}}}else{c[b>>2]=c[b>>2]|f&48^16;c[b+8>>2]=0;c[b+4>>2]=0}l=m;return f|0}function Th(a){a=a|0;if(!(c[a+68>>2]|0))Qh(a);return}function Uh(a,b){a=+a;b=+b;var d=0,e=0;h[j>>3]=a;e=c[j>>2]|0;d=c[j+4>>2]|0;h[j>>3]=b;d=c[j+4>>2]&-2147483648|d&2147483647;c[j>>2]=e;c[j+4>>2]=d;return +(+h[j>>3])}function Vh(b){b=b|0;var d=0,e=0,f=0;f=b;a:do if(!(f&3))e=4;else{d=f;while(1){if(!(a[b>>0]|0)){b=d;break a}b=b+1|0;d=b;if(!(d&3)){e=4;break}}}while(0);if((e|0)==4){while(1){d=c[b>>2]|0;if(!((d&-2139062144^-2139062144)&d+-16843009))b=b+4|0;else break}if((d&255)<<24>>24)do b=b+1|0;while((a[b>>0]|0)!=0)}return b-f|0}function Wh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=l;l=l+16|0;g=f;c[g>>2]=e;e=Xh(a,b,d,g)|0;l=f;return e|0}function Xh(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+128|0;g=n+112|0;m=n;h=m;i=13180;j=h+112|0;do{c[h>>2]=c[i>>2];h=h+4|0;i=i+4|0}while((h|0)<(j|0));if((d+-1|0)>>>0>2147483646)if(!d){b=g;d=1;k=4}else{c[(Oh()|0)>>2]=75;d=-1}else k=4;if((k|0)==4){k=-2-b|0;k=d>>>0>k>>>0?k:d;c[m+48>>2]=k;g=m+20|0;c[g>>2]=b;c[m+44>>2]=b;d=b+k|0;b=m+16|0;c[b>>2]=d;c[m+28>>2]=d;d=Yh(m,e,f)|0;if(k){m=c[g>>2]|0;a[m+(((m|0)==(c[b>>2]|0))<<31>>31)>>0]=0}}l=n;return d|0}function Yh(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;s=l;l=l+224|0;n=s+120|0;p=s+80|0;q=s;r=s+136|0;f=p;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c[n>>2]=c[e>>2];if((Zh(0,d,n,q,p)|0)<0)e=-1;else{if((c[b+76>>2]|0)>-1)o=_h(b)|0;else o=0;e=c[b>>2]|0;m=e&32;if((a[b+74>>0]|0)<1)c[b>>2]=e&-33;f=b+48|0;if(!(c[f>>2]|0)){g=b+44|0;h=c[g>>2]|0;c[g>>2]=r;i=b+28|0;c[i>>2]=r;j=b+20|0;c[j>>2]=r;c[f>>2]=80;k=b+16|0;c[k>>2]=r+80;e=Zh(b,d,n,q,p)|0;if(h){ab[c[b+36>>2]&31](b,0,0)|0;e=(c[j>>2]|0)==0?-1:e;c[g>>2]=h;c[f>>2]=0;c[k>>2]=0;c[i>>2]=0;c[j>>2]=0}}else e=Zh(b,d,n,q,p)|0;f=c[b>>2]|0;c[b>>2]=f|m;if(o|0)Qh(b);e=(f&32|0)==0?e:-1}l=s;return e|0}function Zh(e,f,g,i,k){e=e|0;f=f|0;g=g|0;i=i|0;k=k|0;var m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;ja=l;l=l+624|0;fa=ja+24|0;ga=ja+16|0;ha=ja+588|0;Y=ja+576|0;ia=ja;T=ja+536|0;N=ja+8|0;O=ja+528|0;P=(e|0)!=0;Q=T+40|0;R=Q;T=T+39|0;U=N+4|0;V=ha;W=0-V|0;X=Y+12|0;Y=Y+11|0;Z=X;_=Z-V|0;$=-2-V|0;aa=Z+2|0;ba=fa+288|0;ca=ha+9|0;da=ca;ea=ha+8|0;n=0;m=0;s=0;a:while(1){do if((m|0)>-1)if((n|0)>(2147483647-m|0)){c[(Oh()|0)>>2]=75;m=-1;break}else{m=n+m|0;break}while(0);n=a[f>>0]|0;if(!(n<<24>>24)){M=243;break}else o=f;b:while(1){switch(n<<24>>24){case 37:{n=o;M=9;break b}case 0:{n=o;break b}default:{}}n=o+1|0;o=n;n=a[n>>0]|0}c:do if((M|0)==9)while(1){M=0;if((a[o+1>>0]|0)!=37)break c;n=n+1|0;o=o+2|0;if((a[o>>0]|0)==37)M=9;else break}while(0);n=n-f|0;if(P?(c[e>>2]&32|0)==0:0)$h(f,n,e)|0;if(n|0){f=o;continue}r=o+1|0;p=a[r>>0]|0;n=(p<<24>>24)+-48|0;if(n>>>0<10){u=(a[o+2>>0]|0)==36;r=u?o+3|0:r;w=u?n:-1;u=u?1:s;n=a[r>>0]|0}else{w=-1;u=s;n=p}o=(n<<24>>24)+-32|0;d:do if(o>>>0<32){p=0;do{if(!(1<<o&75913))break d;p=1<<(n<<24>>24)+-32|p;r=r+1|0;n=a[r>>0]|0;o=(n<<24>>24)+-32|0}while(o>>>0<32)}else p=0;while(0);do if(n<<24>>24!=42){o=(n<<24>>24)+-48|0;if(o>>>0<10){s=0;do{s=(s*10|0)+o|0;r=r+1|0;n=a[r>>0]|0;o=(n<<24>>24)+-48|0}while(o>>>0<10);if((s|0)<0){m=-1;break a}else L=u}else{s=0;L=u}}else{t=r+1|0;n=a[t>>0]|0;o=(n<<24>>24)+-48|0;if(o>>>0<10?(a[r+2>>0]|0)==36:0){c[k+(o<<2)>>2]=10;n=c[i+((a[t>>0]|0)+-48<<3)>>2]|0;o=1;t=r+3|0}else{if(u|0){m=-1;break a}if(!P){s=0;L=0;r=t;break}o=(c[g>>2]|0)+(4-1)&~(4-1);n=c[o>>2]|0;c[g>>2]=o+4;o=0}L=(n|0)<0;s=L?0-n|0:n;p=L?p|8192:p;L=o;r=t;n=a[t>>0]|0}while(0);e:do if(n<<24>>24==46){n=r+1|0;o=a[n>>0]|0;if(o<<24>>24!=42){r=(o<<24>>24)+-48|0;if(r>>>0<10)o=0;else{x=0;break}while(1){o=(o*10|0)+r|0;n=n+1|0;r=(a[n>>0]|0)+-48|0;if(r>>>0>=10){x=o;break e}}}n=r+2|0;o=(a[n>>0]|0)+-48|0;if(o>>>0<10?(a[r+3>>0]|0)==36:0){c[k+(o<<2)>>2]=10;x=c[i+((a[n>>0]|0)+-48<<3)>>2]|0;n=r+4|0;break}if(L|0){m=-1;break a}if(P){K=(c[g>>2]|0)+(4-1)&~(4-1);x=c[K>>2]|0;c[g>>2]=K+4}else x=0}else{x=-1;n=r}while(0);u=0;while(1){o=(a[n>>0]|0)+-65|0;if(o>>>0>57){m=-1;break a}K=n+1|0;o=a[22146+(u*58|0)+o>>0]|0;r=o&255;if((r+-1|0)>>>0<8){u=r;n=K}else break}if(!(o<<24>>24)){m=-1;break}t=(w|0)>-1;do if(o<<24>>24==19)if(t){m=-1;break a}else M=51;else{if(t){c[k+(w<<2)>>2]=r;I=i+(w<<3)|0;J=c[I+4>>2]|0;M=ia;c[M>>2]=c[I>>2];c[M+4>>2]=J;M=51;break}if(!P){m=0;break a}ai(ia,r,g)}while(0);if((M|0)==51?(M=0,!P):0){n=0;s=L;f=K;continue}F=a[n>>0]|0;F=(u|0)!=0&(F&15|0)==3?F&-33:F;t=p&-65537;J=(p&8192|0)==0?p:t;f:do switch(F|0){case 110:switch((u&255)<<24>>24){case 0:{c[c[ia>>2]>>2]=m;n=0;s=L;f=K;continue a}case 1:{c[c[ia>>2]>>2]=m;n=0;s=L;f=K;continue a}case 2:{n=c[ia>>2]|0;c[n>>2]=m;c[n+4>>2]=((m|0)<0)<<31>>31;n=0;s=L;f=K;continue a}case 3:{b[c[ia>>2]>>1]=m;n=0;s=L;f=K;continue a}case 4:{a[c[ia>>2]>>0]=m;n=0;s=L;f=K;continue a}case 6:{c[c[ia>>2]>>2]=m;n=0;s=L;f=K;continue a}case 7:{n=c[ia>>2]|0;c[n>>2]=m;c[n+4>>2]=((m|0)<0)<<31>>31;n=0;s=L;f=K;continue a}default:{n=0;s=L;f=K;continue a}}case 112:{t=120;u=x>>>0>8?x:8;n=J|8;M=63;break}case 88:case 120:{t=F;u=x;n=J;M=63;break}case 111:{o=ia;n=c[o>>2]|0;o=c[o+4>>2]|0;if((n|0)==0&(o|0)==0)f=Q;else{f=Q;do{f=f+-1|0;a[f>>0]=n&7|48;n=av(n|0,o|0,3)|0;o=D}while(!((n|0)==0&(o|0)==0))}if(!(J&8)){o=0;p=22626;r=x;n=J;M=76}else{r=R-f|0;o=0;p=22626;r=(x|0)>(r|0)?x:r+1|0;n=J;M=76}break}case 105:case 100:{f=ia;n=c[f>>2]|0;f=c[f+4>>2]|0;if((f|0)<0){n=Vu(0,0,n|0,f|0)|0;f=D;o=ia;c[o>>2]=n;c[o+4>>2]=f;o=1;p=22626;M=75;break f}if(!(J&2048)){p=J&1;o=p;p=(p|0)==0?22626:22628;M=75}else{o=1;p=22627;M=75}break}case 117:{f=ia;o=0;p=22626;n=c[f>>2]|0;f=c[f+4>>2]|0;M=75;break}case 99:{a[T>>0]=c[ia>>2];f=T;w=0;u=22626;o=Q;n=1;break}case 109:{n=ci(c[(Oh()|0)>>2]|0)|0;M=81;break}case 115:{n=c[ia>>2]|0;n=n|0?n:22636;M=81;break}case 67:{c[N>>2]=c[ia>>2];c[U>>2]=0;c[ia>>2]=N;t=-1;o=N;M=85;break}case 83:{n=c[ia>>2]|0;if(!x){ei(e,32,s,0,J);n=0;M=96}else{t=x;o=n;M=85}break}case 65:case 71:case 70:case 69:case 97:case 103:case 102:case 101:{q=+h[ia>>3];c[ga>>2]=0;h[j>>3]=q;if((c[j+4>>2]|0)>=0){n=J&1;if(!(J&2048)){H=n;I=(n|0)==0?22644:22649}else{H=1;I=22646}}else{q=-q;H=1;I=22643}h[j>>3]=q;G=c[j+4>>2]&2146435072;do if(G>>>0<2146435072|(G|0)==2146435072&0<0){v=+gi(q,ga)*2.0;f=v!=0.0;if(f)c[ga>>2]=(c[ga>>2]|0)+-1;z=F|32;if((z|0)==97){r=F&32;w=(r|0)==0?I:I+9|0;u=H|2;n=12-x|0;do if(!(x>>>0>11|(n|0)==0)){q=8.0;do{n=n+-1|0;q=q*16.0}while((n|0)!=0);if((a[w>>0]|0)==45){q=-(q+(-v-q));break}else{q=v+q-q;break}}else q=v;while(0);f=c[ga>>2]|0;n=(f|0)<0?0-f|0:f;n=bi(n,((n|0)<0)<<31>>31,X)|0;if((n|0)==(X|0)){a[Y>>0]=48;n=Y}a[n+-1>>0]=(f>>31&2)+43;t=n+-2|0;a[t>>0]=F+15;p=(x|0)<1;o=(J&8|0)==0;n=ha;do{I=~~q;f=n+1|0;a[n>>0]=d[22610+I>>0]|r;q=(q-+(I|0))*16.0;do if((f-V|0)==1){if(o&(p&q==0.0)){n=f;break}a[f>>0]=46;n=n+2|0}else n=f;while(0)}while(q!=0.0);p=t;o=(x|0)!=0&($+n|0)<(x|0)?aa+x-p|0:_-p+n|0;r=o+u|0;ei(e,32,s,r,J);if(!(c[e>>2]&32))$h(w,u,e)|0;ei(e,48,s,r,J^65536);f=n-V|0;if(!(c[e>>2]&32))$h(ha,f,e)|0;n=Z-p|0;ei(e,48,o-(f+n)|0,0,0);if(!(c[e>>2]&32))$h(t,n,e)|0;ei(e,32,s,r,J^8192);n=(r|0)<(s|0)?s:r;break}n=(x|0)<0?6:x;if(f){f=(c[ga>>2]|0)+-28|0;c[ga>>2]=f;q=v*268435456.0}else{q=v;f=c[ga>>2]|0}G=(f|0)<0?fa:ba;o=G;do{E=~~q>>>0;c[o>>2]=E;o=o+4|0;q=(q-+(E>>>0))*1.0e9}while(q!=0.0);if((f|0)>0){p=G;t=o;while(1){r=(f|0)>29?29:f;f=t+-4|0;do if(f>>>0>=p>>>0){o=0;do{C=gv(c[f>>2]|0,0,r|0)|0;C=Yu(C|0,D|0,o|0,0)|0;E=D;B=iv(C|0,E|0,1e9,0)|0;c[f>>2]=B;o=dv(C|0,E|0,1e9,0)|0;f=f+-4|0}while(f>>>0>=p>>>0);if(!o)break;p=p+-4|0;c[p>>2]=o}while(0);o=t;while(1){if(o>>>0<=p>>>0)break;f=o+-4|0;if(!(c[f>>2]|0))o=f;else break}f=(c[ga>>2]|0)-r|0;c[ga>>2]=f;if((f|0)>0)t=o;else break}}else p=G;if((f|0)<0){x=((n+25|0)/9|0)+1|0;y=(z|0)==102;do{w=0-f|0;w=(w|0)>9?9:w;do if(p>>>0<o>>>0){r=(1<<w)+-1|0;t=1e9>>>w;u=0;f=p;do{E=c[f>>2]|0;c[f>>2]=(E>>>w)+u;u=S(E&r,t)|0;f=f+4|0}while(f>>>0<o>>>0);f=(c[p>>2]|0)==0?p+4|0:p;if(!u){p=f;f=o;break}c[o>>2]=u;p=f;f=o+4|0}else{p=(c[p>>2]|0)==0?p+4|0:p;f=o}while(0);o=y?G:p;o=(f-o>>2|0)>(x|0)?o+(x<<2)|0:f;f=(c[ga>>2]|0)+w|0;c[ga>>2]=f}while((f|0)<0)}E=G;do if(p>>>0<o>>>0){f=(E-p>>2)*9|0;t=c[p>>2]|0;if(t>>>0<10)break;else r=10;do{r=r*10|0;f=f+1|0}while(t>>>0>=r>>>0)}else f=0;while(0);A=(z|0)==103;B=(n|0)!=0;r=n-((z|0)!=102?f:0)+((B&A)<<31>>31)|0;if((r|0)<(((o-E>>2)*9|0)+-9|0)){r=r+9216|0;u=G+4+(((r|0)/9|0)+-1024<<2)|0;r=((r|0)%9|0)+1|0;if((r|0)<9){t=10;do{t=t*10|0;r=r+1|0}while((r|0)!=9)}else t=10;x=c[u>>2]|0;y=(x>>>0)%(t>>>0)|0;r=(u+4|0)==(o|0);do if(r&(y|0)==0)r=u;else{v=(((x>>>0)/(t>>>0)|0)&1|0)==0?9007199254740992.0:9007199254740994.0;w=(t|0)/2|0;if(y>>>0<w>>>0)q=.5;else q=r&(y|0)==(w|0)?1.0:1.5;do if(H){if((a[I>>0]|0)!=45)break;q=-q;v=-v}while(0);r=x-y|0;c[u>>2]=r;if(!(v+q!=v)){r=u;break}C=r+t|0;c[u>>2]=C;if(C>>>0>999999999){r=u;while(1){f=r+-4|0;c[r>>2]=0;if(f>>>0<p>>>0){p=p+-4|0;c[p>>2]=0}C=(c[f>>2]|0)+1|0;c[f>>2]=C;if(C>>>0>999999999)r=f;else{u=f;break}}}f=(E-p>>2)*9|0;t=c[p>>2]|0;if(t>>>0<10){r=u;break}else r=10;do{r=r*10|0;f=f+1|0}while(t>>>0>=r>>>0);r=u}while(0);C=r+4|0;o=o>>>0>C>>>0?C:o}y=0-f|0;C=o;while(1){if(C>>>0<=p>>>0){z=0;break}o=C+-4|0;if(!(c[o>>2]|0))C=o;else{z=1;break}}do if(A){n=(B&1^1)+n|0;if((n|0)>(f|0)&(f|0)>-5){u=F+-1|0;n=n+-1-f|0}else{u=F+-2|0;n=n+-1|0}o=J&8;if(o|0){w=o;break}do if(z){t=c[C+-4>>2]|0;if(!t){r=9;break}if(!((t>>>0)%10|0)){r=0;o=10}else{r=0;break}do{o=o*10|0;r=r+1|0}while(!((t>>>0)%(o>>>0)|0|0))}else r=9;while(0);o=((C-E>>2)*9|0)+-9|0;if((u|32|0)==102){w=o-r|0;w=(w|0)<0?0:w;n=(n|0)<(w|0)?n:w;w=0;break}else{w=o+f-r|0;w=(w|0)<0?0:w;n=(n|0)<(w|0)?n:w;w=0;break}}else{u=F;w=J&8}while(0);x=n|w;r=(x|0)!=0&1;t=(u|32|0)==102;if(t){y=0;f=(f|0)>0?f:0}else{o=(f|0)<0?y:f;o=bi(o,((o|0)<0)<<31>>31,X)|0;if((Z-o|0)<2)do{o=o+-1|0;a[o>>0]=48}while((Z-o|0)<2);a[o+-1>>0]=(f>>31&2)+43;f=o+-2|0;a[f>>0]=u;y=f;f=Z-f|0}A=H+1+n+r+f|0;ei(e,32,s,A,J);if(!(c[e>>2]&32))$h(I,H,e)|0;ei(e,48,s,A,J^65536);do if(t){p=p>>>0>G>>>0?G:p;o=p;do{f=bi(c[o>>2]|0,0,ca)|0;do if((o|0)==(p|0)){if((f|0)!=(ca|0))break;a[ea>>0]=48;f=ea}else{if(f>>>0<=ha>>>0)break;Wu(ha|0,48,f-V|0)|0;do f=f+-1|0;while(f>>>0>ha>>>0)}while(0);if(!(c[e>>2]&32))$h(f,da-f|0,e)|0;o=o+4|0}while(o>>>0<=G>>>0);do if(x|0){if(c[e>>2]&32|0)break;$h(22674,1,e)|0}while(0);if((n|0)>0&o>>>0<C>>>0)while(1){f=bi(c[o>>2]|0,0,ca)|0;if(f>>>0>ha>>>0){Wu(ha|0,48,f-V|0)|0;do f=f+-1|0;while(f>>>0>ha>>>0)}if(!(c[e>>2]&32))$h(f,(n|0)>9?9:n,e)|0;o=o+4|0;f=n+-9|0;if(!((n|0)>9&o>>>0<C>>>0)){n=f;break}else n=f}ei(e,48,n+9|0,9,0)}else{u=z?C:p+4|0;if((n|0)>-1){t=(w|0)==0;r=p;do{f=bi(c[r>>2]|0,0,ca)|0;if((f|0)==(ca|0)){a[ea>>0]=48;f=ea}do if((r|0)==(p|0)){o=f+1|0;if(!(c[e>>2]&32))$h(f,1,e)|0;if(t&(n|0)<1){f=o;break}if(c[e>>2]&32|0){f=o;break}$h(22674,1,e)|0;f=o}else{if(f>>>0<=ha>>>0)break;Wu(ha|0,48,f+W|0)|0;do f=f+-1|0;while(f>>>0>ha>>>0)}while(0);o=da-f|0;if(!(c[e>>2]&32))$h(f,(n|0)>(o|0)?o:n,e)|0;n=n-o|0;r=r+4|0}while(r>>>0<u>>>0&(n|0)>-1)}ei(e,48,n+18|0,18,0);if(c[e>>2]&32|0)break;$h(y,Z-y|0,e)|0}while(0);ei(e,32,s,A,J^8192);n=(A|0)<(s|0)?s:A}else{r=(F&32|0)!=0;p=q!=q|0.0!=0.0;f=p?0:H;o=f+3|0;ei(e,32,s,o,t);n=c[e>>2]|0;if(!(n&32)){$h(I,f,e)|0;n=c[e>>2]|0}if(!(n&32))$h(p?(r?24843:22670):r?22662:22666,3,e)|0;ei(e,32,s,o,J^8192);n=(o|0)<(s|0)?s:o}while(0);s=L;f=K;continue a}default:{w=0;u=22626;o=Q;n=x;t=J}}while(0);g:do if((M|0)==63){p=ia;o=c[p>>2]|0;p=c[p+4>>2]|0;r=t&32;if((o|0)==0&(p|0)==0){f=Q;o=0;p=0}else{f=Q;do{f=f+-1|0;a[f>>0]=d[22610+(o&15)>>0]|r;o=av(o|0,p|0,4)|0;p=D}while(!((o|0)==0&(p|0)==0));p=ia;o=c[p>>2]|0;p=c[p+4>>2]|0}p=(n&8|0)==0|(o|0)==0&(p|0)==0;o=p?0:2;p=p?22626:22626+(t>>4)|0;r=u;M=76}else if((M|0)==75){f=bi(n,f,Q)|0;r=x;n=J;M=76}else if((M|0)==81){M=0;J=di(n,0,x)|0;I=(J|0)==0;f=n;w=0;u=22626;o=I?n+x|0:J;n=I?x:J-n|0}else if((M|0)==85){M=0;r=o;n=0;f=0;while(1){p=c[r>>2]|0;if(!p)break;f=fi(O,p)|0;if((f|0)<0|f>>>0>(t-n|0)>>>0)break;n=f+n|0;if(t>>>0>n>>>0)r=r+4|0;else break}if((f|0)<0){m=-1;break a}ei(e,32,s,n,J);if(!n){n=0;M=96}else{p=0;while(1){f=c[o>>2]|0;if(!f){M=96;break g}f=fi(O,f)|0;p=f+p|0;if((p|0)>(n|0)){M=96;break g}if(!(c[e>>2]&32))$h(O,f,e)|0;if(p>>>0>=n>>>0){M=96;break}else o=o+4|0}}}while(0);if((M|0)==96){M=0;ei(e,32,s,n,J^8192);n=(s|0)>(n|0)?s:n;s=L;f=K;continue}if((M|0)==76){M=0;t=(r|0)>-1?n&-65537:n;n=ia;n=(c[n>>2]|0)!=0|(c[n+4>>2]|0)!=0;if((r|0)!=0|n){n=(n&1^1)+(R-f)|0;w=o;u=p;o=Q;n=(r|0)>(n|0)?r:n}else{f=Q;w=o;u=p;o=Q;n=0}}r=o-f|0;o=(n|0)<(r|0)?r:n;p=o+w|0;n=(s|0)<(p|0)?p:s;ei(e,32,n,p,t);if(!(c[e>>2]&32))$h(u,w,e)|0;ei(e,48,n,p,t^65536);ei(e,48,o,r,0);if(!(c[e>>2]&32))$h(f,r,e)|0;ei(e,32,n,p,t^8192);s=L;f=K}h:do if((M|0)==243)if(!e)if(!s)m=0;else{m=1;while(1){n=c[k+(m<<2)>>2]|0;if(!n)break;ai(i+(m<<3)|0,n,g);m=m+1|0;if((m|0)>=10){m=1;break h}}while(1){if(c[k+(m<<2)>>2]|0){m=-1;break h}m=m+1|0;if((m|0)>=10){m=1;break}}}while(0);l=ja;return m|0}function _h(a){a=a|0;return 0}function $h(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=e+16|0;g=c[f>>2]|0;if(!g)if(!(ji(e)|0)){f=c[f>>2]|0;h=5}else f=0;else{f=g;h=5}a:do if((h|0)==5){i=e+20|0;h=c[i>>2]|0;g=h;if((f-h|0)>>>0<d>>>0){f=ab[c[e+36>>2]&31](e,b,d)|0;break}b:do if((a[e+75>>0]|0)>-1){f=d;while(1){if(!f){h=d;f=0;break b}h=f+-1|0;if((a[b+h>>0]|0)==10)break;else f=h}if((ab[c[e+36>>2]&31](e,b,f)|0)>>>0<f>>>0)break a;h=d-f|0;b=b+f|0;g=c[i>>2]|0}else{h=d;f=0}while(0);cv(g|0,b|0,h|0)|0;c[i>>2]=(c[i>>2]|0)+h;f=f+h|0}while(0);return f|0}function ai(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0;a:do if(b>>>0<=20)do switch(b|0){case 9:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;c[a>>2]=b;break a}case 10:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;e=a;c[e>>2]=b;c[e+4>>2]=((b|0)<0)<<31>>31;break a}case 11:{e=(c[d>>2]|0)+(4-1)&~(4-1);b=c[e>>2]|0;c[d>>2]=e+4;e=a;c[e>>2]=b;c[e+4>>2]=0;break a}case 12:{e=(c[d>>2]|0)+(8-1)&~(8-1);b=e;f=c[b>>2]|0;b=c[b+4>>2]|0;c[d>>2]=e+8;e=a;c[e>>2]=f;c[e+4>>2]=b;break a}case 13:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;e=(e&65535)<<16>>16;f=a;c[f>>2]=e;c[f+4>>2]=((e|0)<0)<<31>>31;break a}case 14:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;f=a;c[f>>2]=e&65535;c[f+4>>2]=0;break a}case 15:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;e=(e&255)<<24>>24;f=a;c[f>>2]=e;c[f+4>>2]=((e|0)<0)<<31>>31;break a}case 16:{f=(c[d>>2]|0)+(4-1)&~(4-1);e=c[f>>2]|0;c[d>>2]=f+4;f=a;c[f>>2]=e&255;c[f+4>>2]=0;break a}case 17:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}case 18:{f=(c[d>>2]|0)+(8-1)&~(8-1);g=+h[f>>3];c[d>>2]=f+8;h[a>>3]=g;break a}default:break a}while(0);while(0);return}function bi(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if(c>>>0>0|(c|0)==0&b>>>0>4294967295){while(1){e=iv(b|0,c|0,10,0)|0;d=d+-1|0;a[d>>0]=e|48;e=b;b=dv(b|0,c|0,10,0)|0;if(!(c>>>0>9|(c|0)==9&e>>>0>4294967295))break;else c=D}c=b}else c=b;if(c)while(1){d=d+-1|0;a[d>>0]=(c>>>0)%10|0|48;if(c>>>0<10)break;else c=(c>>>0)/10|0}return d|0}function ci(b){b=b|0;var c=0,e=0;e=0;while(1){if((d[22676+e>>0]|0)==(b|0)){b=2;break}c=e+1|0;if((c|0)==87){c=22764;e=87;b=5;break}else e=c}if((b|0)==2)if(!e)c=22764;else{c=22764;b=5}if((b|0)==5)while(1){do{b=c;c=c+1|0}while((a[b>>0]|0)!=0);e=e+-1|0;if(!e)break;else b=5}return c|0}function di(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=d&255;f=(e|0)!=0;a:do if(f&(b&3|0)!=0){g=d&255;while(1){if((a[b>>0]|0)==g<<24>>24){i=6;break a}b=b+1|0;e=e+-1|0;f=(e|0)!=0;if(!(f&(b&3|0)!=0)){i=5;break}}}else i=5;while(0);if((i|0)==5)if(f)i=6;else e=0;b:do if((i|0)==6){g=d&255;if((a[b>>0]|0)!=g<<24>>24){f=S(h,16843009)|0;c:do if(e>>>0>3)while(1){h=c[b>>2]^f;if((h&-2139062144^-2139062144)&h+-16843009|0)break;b=b+4|0;e=e+-4|0;if(e>>>0<=3){i=11;break c}}else i=11;while(0);if((i|0)==11)if(!e){e=0;break}while(1){if((a[b>>0]|0)==g<<24>>24)break b;b=b+1|0;e=e+-1|0;if(!e){e=0;break}}}}while(0);return (e|0?b:0)|0}function ei(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0;i=l;l=l+256|0;h=i;do if((d|0)>(e|0)&(f&73728|0)==0){f=d-e|0;Wu(h|0,b|0,(f>>>0>256?256:f)|0)|0;b=c[a>>2]|0;g=(b&32|0)==0;if(f>>>0>255){d=d-e|0;do{if(g){$h(h,256,a)|0;b=c[a>>2]|0}f=f+-256|0;g=(b&32|0)==0}while(f>>>0>255);if(g)f=d&255;else break}else if(!g)break;$h(h,f,a)|0}while(0);l=i;return}function fi(a,b){a=a|0;b=b|0;if(!a)a=0;else a=ii(a,b,0)|0;return a|0}function gi(a,b){a=+a;b=b|0;return +(+hi(a,b))}function hi(a,b){a=+a;b=b|0;var d=0,e=0,f=0;h[j>>3]=a;d=c[j>>2]|0;e=c[j+4>>2]|0;f=av(d|0,e|0,52)|0;switch(f&2047){case 0:{if(a!=0.0){a=+hi(a*18446744073709551616.0,b);d=(c[b>>2]|0)+-64|0}else d=0;c[b>>2]=d;break}case 2047:break;default:{c[b>>2]=(f&2047)+-1022;c[j>>2]=d;c[j+4>>2]=e&-2146435073|1071644672;a=+h[j>>3]}}return +a}function ii(b,d,e){b=b|0;d=d|0;e=e|0;do if(b){if(d>>>0<128){a[b>>0]=d;b=1;break}if(d>>>0<2048){a[b>>0]=d>>>6|192;a[b+1>>0]=d&63|128;b=2;break}if(d>>>0<55296|(d&-8192|0)==57344){a[b>>0]=d>>>12|224;a[b+1>>0]=d>>>6&63|128;a[b+2>>0]=d&63|128;b=3;break}if((d+-65536|0)>>>0<1048576){a[b>>0]=d>>>18|240;a[b+1>>0]=d>>>12&63|128;a[b+2>>0]=d>>>6&63|128;a[b+3>>0]=d&63|128;b=4;break}else{c[(Oh()|0)>>2]=84;b=-1;break}}else b=1;while(0);return b|0}function ji(b){b=b|0;var d=0,e=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;d=c[b>>2]|0;if(!(d&8)){c[b+8>>2]=0;c[b+4>>2]=0;e=c[b+44>>2]|0;c[b+28>>2]=e;c[b+20>>2]=e;c[b+16>>2]=e+(c[b+48>>2]|0);b=0}else{c[b>>2]=d|32;b=-1}return b|0}function ki(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=a+20|0;f=c[e>>2]|0;a=(c[a+16>>2]|0)-f|0;a=a>>>0>d>>>0?d:a;cv(f|0,b|0,a|0)|0;c[e>>2]=(c[e>>2]|0)+a;return d|0}function li(b,c){b=b|0;c=c|0;var d=0,e=0;d=a[b>>0]|0;e=a[c>>0]|0;if(d<<24>>24==0?1:d<<24>>24!=e<<24>>24)b=e;else{do{b=b+1|0;c=c+1|0;d=a[b>>0]|0;e=a[c>>0]|0}while(!(d<<24>>24==0?1:d<<24>>24!=e<<24>>24));b=e}return (d&255)-(b&255)|0}function mi(b,c){b=b|0;c=c|0;b=pi(b,c)|0;return ((a[b>>0]|0)==(c&255)<<24>>24?b:0)|0}function ni(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;g=j;a:do if(!e)b=0;else{do if(f|0){i=(b|0)==0?g:b;b=a[e>>0]|0;g=b&255;if(b<<24>>24>-1){c[i>>2]=g;b=b<<24>>24!=0&1;break a}b=g+-194|0;if(b>>>0<=50){g=e+1|0;h=c[12976+(b<<2)>>2]|0;if(f>>>0<4?h&-2147483648>>>((f*6|0)+-6|0)|0:0)break;b=d[g>>0]|0;f=b>>>3;if((f+-16|f+(h>>26))>>>0<=7){b=b+-128|h<<6;if((b|0)>=0){c[i>>2]=b;b=2;break a}g=(d[e+2>>0]|0)+-128|0;if(g>>>0<=63){g=g|b<<6;if((g|0)>=0){c[i>>2]=g;b=3;break a}b=(d[e+3>>0]|0)+-128|0;if(b>>>0<=63){c[i>>2]=b|g<<6;b=4;break a}}}}}while(0);c[(Oh()|0)>>2]=84;b=-1}while(0);l=j;return b|0}function oi(a){a=a|0;var b=0;b=a;while(1)if(!(c[b>>2]|0))break;else b=b+4|0;return b-a>>2|0}function pi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;f=d&255;a:do if(!f)b=b+(Vh(b)|0)|0;else{if(b&3){e=d&255;do{g=a[b>>0]|0;if(g<<24>>24==0?1:g<<24>>24==e<<24>>24)break a;b=b+1|0}while((b&3|0)!=0)}f=S(f,16843009)|0;e=c[b>>2]|0;b:do if(!((e&-2139062144^-2139062144)&e+-16843009))do{g=e^f;if((g&-2139062144^-2139062144)&g+-16843009|0)break b;b=b+4|0;e=c[b>>2]|0}while(!((e&-2139062144^-2139062144)&e+-16843009|0));while(0);e=d&255;while(1){g=a[b>>0]|0;if(g<<24>>24==0?1:g<<24>>24==e<<24>>24)break;else b=b+1|0}}while(0);return b|0}function qi(a,b,c){a=a|0;b=b|0;c=c|0;c=ri(a,b,c,-2147483648,0)|0;return c|0}function ri(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+112|0;h=j;c[h>>2]=0;i=h+4|0;c[i>>2]=a;c[h+44>>2]=a;g=h+8|0;c[g>>2]=(a|0)<0?-1:a+2147483647|0;c[h+76>>2]=-1;si(h,0);d=ti(h,d,1,e,f)|0;if(b|0)c[b>>2]=a+((c[i>>2]|0)+(c[h+108>>2]|0)-(c[g>>2]|0));l=j;return d|0}function si(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;c[a+104>>2]=b;d=c[a+8>>2]|0;e=c[a+4>>2]|0;f=d-e|0;c[a+108>>2]=f;if((b|0)!=0&(f|0)>(b|0))c[a+100>>2]=e+b;else c[a+100>>2]=d;return}function ti(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a:do if(e>>>0>36){c[(Oh()|0)>>2]=22;h=0;g=0}else{r=b+4|0;q=b+100|0;do{i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=ui(b)|0}while((vi(i)|0)!=0);b:do switch(i|0){case 43:case 45:{i=((i|0)==45)<<31>>31;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;p=i;i=d[j>>0]|0;break b}else{p=i;i=ui(b)|0;break b}}default:p=0}while(0);j=(e|0)==0;do if((e|16|0)==16&(i|0)==48){i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=ui(b)|0;if((i|32|0)!=120)if(j){e=8;n=46;break}else{n=32;break}i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=ui(b)|0;if((d[24569+i>>0]|0)>15){g=(c[q>>2]|0)==0;if(!g)c[r>>2]=(c[r>>2]|0)+-1;if(!f){si(b,0);h=0;g=0;break a}if(g){h=0;g=0;break a}c[r>>2]=(c[r>>2]|0)+-1;h=0;g=0;break a}else{e=16;n=46}}else{e=j?10:e;if((d[24569+i>>0]|0)>>>0<e>>>0)n=32;else{if(c[q>>2]|0)c[r>>2]=(c[r>>2]|0)+-1;si(b,0);c[(Oh()|0)>>2]=22;h=0;g=0;break a}}while(0);if((n|0)==32)if((e|0)==10){e=i+-48|0;if(e>>>0<10){i=0;j=e;do{i=(i*10|0)+j|0;e=c[r>>2]|0;if(e>>>0<(c[q>>2]|0)>>>0){c[r>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;j=e+-48|0}while(j>>>0<10&i>>>0<429496729);f=0}else{e=i;i=0;f=0}j=e+-48|0;if(j>>>0<10){m=j;while(1){j=fv(i|0,f|0,10,0)|0;k=D;l=((m|0)<0)<<31>>31;o=~l;if(k>>>0>o>>>0|(k|0)==(o|0)&j>>>0>~m>>>0){j=e;e=m;break}i=Yu(j|0,k|0,m|0,l|0)|0;f=D;e=c[r>>2]|0;if(e>>>0<(c[q>>2]|0)>>>0){c[r>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;k=e+-48|0;if(k>>>0<10&(f>>>0<429496729|(f|0)==429496729&i>>>0<2576980378))m=k;else{j=e;e=k;break}}if(e>>>0>9){j=p;e=f}else{e=10;n=72}}else{j=p;e=f}}else n=46;c:do if((n|0)==46){if(!(e+-1&e)){n=a[24825+((e*23|0)>>>5&7)>>0]|0;f=a[24569+i>>0]|0;j=f&255;if(j>>>0<e>>>0){i=0;k=j;do{i=k|i<<n;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=ui(b)|0;f=a[24569+j>>0]|0;k=f&255}while(i>>>0<134217728&k>>>0<e>>>0);k=0}else{j=i;k=0;i=0}l=av(-1,-1,n|0)|0;m=D;if((f&255)>>>0>=e>>>0|(k>>>0>m>>>0|(k|0)==(m|0)&i>>>0>l>>>0)){f=k;n=72;break}else j=k;while(1){i=gv(i|0,j|0,n|0)|0;k=D;i=f&255|i;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=ui(b)|0;f=a[24569+j>>0]|0;if((f&255)>>>0>=e>>>0|(k>>>0>m>>>0|(k|0)==(m|0)&i>>>0>l>>>0)){f=k;n=72;break c}else j=k}}f=a[24569+i>>0]|0;j=f&255;if(j>>>0<e>>>0){i=0;k=j;do{i=k+(S(i,e)|0)|0;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=ui(b)|0;f=a[24569+j>>0]|0;k=f&255}while(i>>>0<119304647&k>>>0<e>>>0);k=0}else{j=i;i=0;k=0}if((f&255)>>>0<e>>>0){n=dv(-1,-1,e|0,0)|0;o=D;m=k;while(1){if(m>>>0>o>>>0|(m|0)==(o|0)&i>>>0>n>>>0){f=m;n=72;break c}k=fv(i|0,m|0,e|0,0)|0;l=D;f=f&255;if(l>>>0>4294967295|(l|0)==-1&k>>>0>~f>>>0){f=m;n=72;break c}i=Yu(f|0,0,k|0,l|0)|0;k=D;j=c[r>>2]|0;if(j>>>0<(c[q>>2]|0)>>>0){c[r>>2]=j+1;j=d[j>>0]|0}else j=ui(b)|0;f=a[24569+j>>0]|0;if((f&255)>>>0>=e>>>0){f=k;n=72;break}else m=k}}else{f=k;n=72}}while(0);if((n|0)==72)if((d[24569+j>>0]|0)>>>0<e>>>0){do{i=c[r>>2]|0;if(i>>>0<(c[q>>2]|0)>>>0){c[r>>2]=i+1;i=d[i>>0]|0}else i=ui(b)|0}while((d[24569+i>>0]|0)>>>0<e>>>0);c[(Oh()|0)>>2]=34;j=(g&1|0)==0&0==0?p:0;e=h;i=g}else{j=p;e=f}if(c[q>>2]|0)c[r>>2]=(c[r>>2]|0)+-1;if(!(e>>>0<h>>>0|(e|0)==(h|0)&i>>>0<g>>>0)){if(!((g&1|0)!=0|0!=0|(j|0)!=0)){c[(Oh()|0)>>2]=34;g=Yu(g|0,h|0,-1,-1)|0;h=D;break}if(e>>>0>h>>>0|(e|0)==(h|0)&i>>>0>g>>>0){c[(Oh()|0)>>2]=34;break}}g=((j|0)<0)<<31>>31;g=Vu(i^j|0,e^g|0,j|0,g|0)|0;h=D}while(0);D=h;return g|0}function ui(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0;f=b+104|0;i=c[f>>2]|0;if((i|0)!=0?(c[b+108>>2]|0)>=(i|0):0)j=4;else{e=wi(b)|0;if((e|0)>=0){f=c[f>>2]|0;i=c[b+8>>2]|0;if(f){h=c[b+4>>2]|0;f=f-(c[b+108>>2]|0)|0;g=i;if((i-h|0)<(f|0))j=9;else c[b+100>>2]=h+(f+-1)}else{g=i;j=9}if((j|0)==9)c[b+100>>2]=i;f=b+4|0;if(!g)f=c[f>>2]|0;else{f=c[f>>2]|0;b=b+108|0;c[b>>2]=g+1-f+(c[b>>2]|0)}f=f+-1|0;if((d[f>>0]|0|0)!=(e|0))a[f>>0]=e}else j=4}if((j|0)==4){c[b+100>>2]=0;e=-1}return e|0}function vi(a){a=a|0;return ((a|0)==32|(a+-9|0)>>>0<5)&1|0}function wi(a){a=a|0;var b=0,e=0;e=l;l=l+16|0;b=e;if((c[a+8>>2]|0)==0?(xi(a)|0)!=0:0)a=-1;else if((ab[c[a+32>>2]&31](a,b,1)|0)==1)a=d[b>>0]|0;else a=-1;l=e;return a|0}function xi(b){b=b|0;var d=0,e=0;d=b+74|0;e=a[d>>0]|0;a[d>>0]=e+255|e;d=b+20|0;e=b+44|0;if((c[d>>2]|0)>>>0>(c[e>>2]|0)>>>0)ab[c[b+36>>2]&31](b,0,0)|0;c[b+16>>2]=0;c[b+28>>2]=0;c[d>>2]=0;d=c[b>>2]|0;if(d&20)if(!(d&4))d=-1;else{c[b>>2]=d|32;d=-1}else{d=c[e>>2]|0;c[b+8>>2]=d;c[b+4>>2]=d;d=0}return d|0}function yi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;k=l;l=l+16|0;g=k;i=(f|0)==0?1164068:f;f=c[i>>2]|0;a:do if(!d)if(!f)f=0;else j=15;else{h=(b|0)==0?g:b;if(!e)f=-2;else{if(!f){f=a[d>>0]|0;b=f&255;if(f<<24>>24>-1){c[h>>2]=b;f=f<<24>>24!=0&1;break}f=b+-194|0;if(f>>>0>50){j=15;break}f=c[12976+(f<<2)>>2]|0;g=e+-1|0;if(g){d=d+1|0;j=9}}else{g=e;j=9}b:do if((j|0)==9){b=a[d>>0]|0;m=(b&255)>>>3;if((m+-16|m+(f>>26))>>>0>7){j=15;break a}while(1){d=d+1|0;f=(b&255)+-128|f<<6;g=g+-1|0;if((f|0)>=0)break;if(!g)break b;b=a[d>>0]|0;if((b&-64)<<24>>24!=-128){j=15;break a}}c[i>>2]=0;c[h>>2]=f;f=e-g|0;break a}while(0);c[i>>2]=f;f=-2}}while(0);if((j|0)==15){c[i>>2]=0;c[(Oh()|0)>>2]=84;f=-1}l=k;return f|0}function zi(a){a=a|0;if(!a)a=1;else a=(c[a>>2]|0)==0;return a&1|0}function Ai(e,f,i){e=e|0;f=f|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=l;l=l+304|0;K=R+16|0;L=R+8|0;M=R+33|0;N=R;O=R+32|0;if((c[e+76>>2]|0)>-1)Q=_h(e)|0;else Q=0;m=a[f>>0]|0;a:do if(m<<24>>24){z=e+4|0;A=e+100|0;B=e+108|0;C=e+8|0;E=M+10|0;F=M+33|0;y=L+4|0;G=M+46|0;H=M+94|0;I=M+1|0;J=M+1|0;q=f;v=0;f=0;k=0;j=0;b:while(1){c:do if(!(vi(m&255)|0)){m=m<<24>>24==37;d:do if(m){n=q+1|0;o=a[n>>0]|0;e:do switch(o<<24>>24){case 37:break d;case 42:{x=0;n=q+2|0;break}default:{m=(o&255)+-48|0;if(m>>>0<10?(a[q+2>>0]|0)==36:0){c[K>>2]=c[i>>2];while(1){x=(c[K>>2]|0)+(4-1)&~(4-1);n=c[x>>2]|0;c[K>>2]=x+4;if(m>>>0>1)m=m+-1|0;else break}x=n;n=q+3|0;break e}w=(c[i>>2]|0)+(4-1)&~(4-1);x=c[w>>2]|0;c[i>>2]=w+4}}while(0);q=a[n>>0]|0;m=q&255;if((m+-48|0)>>>0<10){o=0;do{o=(o*10|0)+-48+m|0;n=n+1|0;q=a[n>>0]|0;m=q&255}while((m+-48|0)>>>0<10)}else o=0;if(q<<24>>24==109){q=n+1|0;m=(x|0)!=0&1;k=0;j=0;n=q;q=a[q>>0]|0}else m=0;r=n+1|0;switch(q<<24>>24){case 104:{w=(a[r>>0]|0)==104;q=w?-2:-1;n=w?n+2|0:r;break}case 108:{w=(a[r>>0]|0)==108;q=w?3:1;n=w?n+2|0:r;break}case 106:{q=3;n=r;break}case 116:case 122:{q=1;n=r;break}case 76:{q=2;n=r;break}case 110:case 112:case 67:case 83:case 91:case 99:case 115:case 88:case 71:case 70:case 69:case 65:case 103:case 102:case 101:case 97:case 120:case 117:case 111:case 105:case 100:{q=0;break}default:{P=154;break b}}t=d[n>>0]|0;u=(t&47|0)==3;t=u?t|32:t;u=u?1:q;s=t&255;switch(s<<24>>24){case 99:{o=(o|0)<1?1:o;break}case 91:break;case 110:{if(!x){o=v;break c}switch(u|0){case -2:{a[x>>0]=v;o=v;break c}case -1:{b[x>>1]=v;o=v;break c}case 0:{c[x>>2]=v;o=v;break c}case 1:{c[x>>2]=v;o=v;break c}case 3:{o=x;c[o>>2]=v;c[o+4>>2]=((v|0)<0)<<31>>31;o=v;break c}default:{o=v;break c}}}default:{si(e,0);do{q=c[z>>2]|0;if(q>>>0<(c[A>>2]|0)>>>0){c[z>>2]=q+1;q=d[q>>0]|0}else q=ui(e)|0}while((vi(q)|0)!=0);if(!(c[A>>2]|0))q=c[z>>2]|0;else{q=(c[z>>2]|0)+-1|0;c[z>>2]=q}v=(c[B>>2]|0)+v+q-(c[C>>2]|0)|0}}si(e,o);q=c[z>>2]|0;r=c[A>>2]|0;if(q>>>0<r>>>0)c[z>>2]=q+1;else{if((ui(e)|0)<0){P=154;break b}r=c[A>>2]|0}if(r|0)c[z>>2]=(c[z>>2]|0)+-1;f:do switch(s<<24>>24){case 91:case 99:case 115:{w=(t|0)==99;g:do if((t|16|0)==115){Wu(I|0,-1,256)|0;a[M>>0]=0;if((t|0)==115){a[F>>0]=0;a[E>>0]=0;a[E+1>>0]=0;a[E+2>>0]=0;a[E+3>>0]=0;a[E+4>>0]=0}}else{s=n+1|0;t=(a[s>>0]|0)==94;q=t&1;n=t?n+2|0:s;Wu(J|0,t&1|0,256)|0;a[M>>0]=0;switch(a[n>>0]|0){case 45:{t=(q^1)&255;a[G>>0]=t;n=n+1|0;break}case 93:{t=(q^1)&255;a[H>>0]=t;n=n+1|0;break}default:t=(q^1)&255}while(1){q=a[n>>0]|0;h:do switch(q<<24>>24){case 0:{P=154;break b}case 93:break g;case 45:{s=n+1|0;q=a[s>>0]|0;switch(q<<24>>24){case 93:case 0:{q=45;break h}default:{}}n=a[n+-1>>0]|0;if((n&255)<(q&255)){n=n&255;do{n=n+1|0;a[M+n>>0]=t;q=a[s>>0]|0}while((n|0)<(q&255|0));n=s}else n=s;break}default:{}}while(0);a[M+((q&255)+1)>>0]=t;n=n+1|0}}while(0);q=w?o+1|0:31;t=(u|0)==1;u=(m|0)!=0;i:do if(t){if(u){k=Fj(q<<2)|0;if(!k){j=0;P=154;break b}}else k=x;c[L>>2]=0;c[y>>2]=0;s=q;j=0;j:while(1){r=(k|0)==0;do{k:while(1){q=c[z>>2]|0;if(q>>>0<(c[A>>2]|0)>>>0){c[z>>2]=q+1;q=d[q>>0]|0}else q=ui(e)|0;if(!(a[M+(q+1)>>0]|0))break j;a[O>>0]=q;switch(yi(N,O,1,L)|0){case -1:{j=0;P=154;break b}case -2:break;default:break k}}if(!r){c[k+(j<<2)>>2]=c[N>>2];j=j+1|0}}while(!(u&(j|0)==(s|0)));j=s<<1|1;q=Ij(k,j<<2)|0;if(!q){j=0;P=154;break b}else{r=s;s=j;k=q;j=r}}if(!(zi(L)|0)){j=0;P=154;break b}else{r=j;j=0}}else{if(u){j=Fj(q)|0;if(!j){j=0;k=0;P=154;break b}else{r=q;k=0}while(1){do{q=c[z>>2]|0;if(q>>>0<(c[A>>2]|0)>>>0){c[z>>2]=q+1;q=d[q>>0]|0}else q=ui(e)|0;if(!(a[M+(q+1)>>0]|0)){r=k;k=0;break i}a[j+k>>0]=q;k=k+1|0}while((k|0)!=(r|0));k=r<<1|1;q=Ij(j,k)|0;if(!q){k=0;P=154;break b}else{s=r;r=k;j=q;k=s}}}if(!x){k=r;while(1){j=c[z>>2]|0;if(j>>>0<k>>>0){c[z>>2]=j+1;j=d[j>>0]|0}else j=ui(e)|0;if(!(a[M+(j+1)>>0]|0)){r=0;j=0;k=0;break i}k=c[A>>2]|0}}else{q=0;k=r;while(1){j=c[z>>2]|0;if(j>>>0<k>>>0){c[z>>2]=j+1;j=d[j>>0]|0}else j=ui(e)|0;if(!(a[M+(j+1)>>0]|0)){r=q;j=x;k=0;break i}a[x+q>>0]=j;q=q+1|0;k=c[A>>2]|0}}}while(0);if(!(c[A>>2]|0))q=c[z>>2]|0;else{q=(c[z>>2]|0)+-1|0;c[z>>2]=q}q=q-(c[C>>2]|0)+(c[B>>2]|0)|0;if(!q)break b;if(!((q|0)==(o|0)|w^1))break b;do if(u)if(t){c[x>>2]=k;break}else{c[x>>2]=j;break}while(0);if(!w){if(k|0)c[k+(r<<2)>>2]=0;if(!j){j=0;break f}a[j+r>>0]=0}break}case 120:case 88:case 112:{o=16;P=136;break}case 111:{o=8;P=136;break}case 117:case 100:{o=10;P=136;break}case 105:{o=0;P=136;break}case 71:case 103:case 70:case 102:case 69:case 101:case 65:case 97:{p=+Bi(e,u,0);if((c[B>>2]|0)==((c[C>>2]|0)-(c[z>>2]|0)|0))break b;if(x)switch(u|0){case 0:{g[x>>2]=p;break f}case 1:{h[x>>3]=p;break f}case 2:{h[x>>3]=p;break f}default:break f}break}default:{}}while(0);l:do if((P|0)==136){P=0;o=ti(e,o,0,-1,-1)|0;if((c[B>>2]|0)==((c[C>>2]|0)-(c[z>>2]|0)|0))break b;if((x|0)!=0&(t|0)==112){c[x>>2]=o;break}if(x)switch(u|0){case -2:{a[x>>0]=o;break l}case -1:{b[x>>1]=o;break l}case 0:{c[x>>2]=o;break l}case 1:{c[x>>2]=o;break l}case 3:{w=x;c[w>>2]=o;c[w+4>>2]=D;break l}default:break l}}while(0);f=((x|0)!=0&1)+f|0;o=(c[B>>2]|0)+v+(c[z>>2]|0)-(c[C>>2]|0)|0;break c}while(0);n=q+(m&1)|0;si(e,0);m=c[z>>2]|0;if(m>>>0<(c[A>>2]|0)>>>0){c[z>>2]=m+1;m=d[m>>0]|0}else m=ui(e)|0;if((m|0)!=(d[n>>0]|0)){P=22;break b}o=v+1|0}else{n=q;while(1){m=n+1|0;if(!(vi(d[m>>0]|0)|0))break;else n=m}si(e,0);do{m=c[z>>2]|0;if(m>>>0<(c[A>>2]|0)>>>0){c[z>>2]=m+1;m=d[m>>0]|0}else m=ui(e)|0}while((vi(m)|0)!=0);if(!(c[A>>2]|0))m=c[z>>2]|0;else{m=(c[z>>2]|0)+-1|0;c[z>>2]=m}o=(c[B>>2]|0)+v+m-(c[C>>2]|0)|0}while(0);q=n+1|0;m=a[q>>0]|0;if(!(m<<24>>24))break a;else v=o}if((P|0)==22){if(c[A>>2]|0)c[z>>2]=(c[z>>2]|0)+-1;if((f|0)!=0|(m|0)>-1)break;else{m=0;f=k;P=155}}else if((P|0)==154)if(!f){f=k;P=155}if((P|0)==155){k=f;f=-1}if(m){Gj(j);Gj(k)}}else f=0;while(0);if(Q|0)Qh(e);l=R;return f|0}function Bi(b,e,f){b=b|0;e=e|0;f=f|0;var g=0.0,h=0,i=0.0,j=0,k=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0;M=l;l=l+512|0;I=M;switch(e|0){case 0:{J=-149;L=24;A=4;break}case 1:{J=-1074;L=53;A=4;break}case 2:{J=-1074;L=53;A=4;break}default:g=0.0}a:do if((A|0)==4){C=b+4|0;B=b+100|0;do{e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0}while((vi(e)|0)!=0);b:do switch(e|0){case 43:case 45:{h=1-(((e|0)==45&1)<<1)|0;e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;j=d[e>>0]|0;K=h;break b}else{j=ui(b)|0;K=h;break b}}default:{j=e;K=1}}while(0);e=0;do{if((j|32|0)!=(a[24834+e>>0]|0))break;do if(e>>>0<7){h=c[C>>2]|0;if(h>>>0<(c[B>>2]|0)>>>0){c[C>>2]=h+1;j=d[h>>0]|0;break}else{j=ui(b)|0;break}}while(0);e=e+1|0}while(e>>>0<8);c:do switch(e|0){case 8:break;case 3:{A=23;break}default:{k=(f|0)!=0;if(k&e>>>0>3)if((e|0)==8)break c;else{A=23;break c}d:do if(!e){e=0;do{if((j|32|0)!=(a[24843+e>>0]|0))break d;do if(e>>>0<2){h=c[C>>2]|0;if(h>>>0<(c[B>>2]|0)>>>0){c[C>>2]=h+1;j=d[h>>0]|0;break}else{j=ui(b)|0;break}}while(0);e=e+1|0}while(e>>>0<3)}while(0);switch(e|0){case 3:{e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;if((e|0)==40)e=1;else{if(!(c[B>>2]|0)){g=s;break a}c[C>>2]=(c[C>>2]|0)+-1;g=s;break a}while(1){h=c[C>>2]|0;if(h>>>0<(c[B>>2]|0)>>>0){c[C>>2]=h+1;h=d[h>>0]|0}else h=ui(b)|0;if(!((h+-48|0)>>>0<10|(h+-65|0)>>>0<26)?!((h|0)==95|(h+-97|0)>>>0<26):0)break;e=e+1|0}if((h|0)==41){g=s;break a}h=(c[B>>2]|0)==0;if(!h)c[C>>2]=(c[C>>2]|0)+-1;if(!k){c[(Oh()|0)>>2]=22;si(b,0);g=0.0;break a}if(!e){g=s;break a}while(1){e=e+-1|0;if(!h)c[C>>2]=(c[C>>2]|0)+-1;if(!e){g=s;break a}}}case 0:{do if((j|0)==48){e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;if((e|32|0)!=120){if(!(c[B>>2]|0)){e=48;break}c[C>>2]=(c[C>>2]|0)+-1;e=48;break}e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;h=d[e>>0]|0;j=0}else{h=ui(b)|0;j=0}e:while(1){switch(h|0){case 46:{A=74;break e}case 48:break;default:{v=0;m=0;p=1.0;g=0.0;e=0;k=h;w=j;y=0;x=0;j=0;h=0;break e}}e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;h=d[e>>0]|0;j=1;continue}else{h=ui(b)|0;j=1;continue}}if((A|0)==74){e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;h=d[e>>0]|0}else h=ui(b)|0;if((h|0)==48){j=0;h=0;do{e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;k=d[e>>0]|0}else k=ui(b)|0;j=Yu(j|0,h|0,-1,-1)|0;h=D}while((k|0)==48);v=1;m=0;p=1.0;g=0.0;e=0;w=1;y=0;x=0}else{v=1;m=0;p=1.0;g=0.0;e=0;k=h;w=j;y=0;x=0;j=0;h=0}}while(1){o=k+-48|0;n=k|32;if(o>>>0>=10){r=(k|0)==46;if(!(r|(n+-97|0)>>>0<6)){n=k;break}if(r)if(!v){v=1;i=p;r=w;j=x;h=y;o=x;n=y}else{n=46;break}else A=86}else A=86;if((A|0)==86){A=0;k=(k|0)>57?n+-87|0:o;do if(!((y|0)<0|(y|0)==0&x>>>0<8)){if((y|0)<0|(y|0)==0&x>>>0<14){u=p*.0625;i=u;g=g+u*+(k|0);break}if((m|0)!=0|(k|0)==0)i=p;else{m=1;i=p;g=g+p*.5}}else{i=p;e=k+(e<<4)|0}while(0);o=Yu(x|0,y|0,1,0)|0;r=1;n=D}k=c[C>>2]|0;if(k>>>0<(c[B>>2]|0)>>>0){c[C>>2]=k+1;p=i;k=d[k>>0]|0;w=r;y=n;x=o;continue}else{p=i;k=ui(b)|0;w=r;y=n;x=o;continue}}if(!w){e=(c[B>>2]|0)==0;if(!e)c[C>>2]=(c[C>>2]|0)+-1;if(f){if(!e?(z=c[C>>2]|0,c[C>>2]=z+-1,v|0):0)c[C>>2]=z+-2}else si(b,0);g=+(K|0)*0.0;break a}m=(v|0)==0;o=m?x:j;m=m?y:h;if((y|0)<0|(y|0)==0&x>>>0<8){j=x;h=y;do{e=e<<4;j=Yu(j|0,h|0,1,0)|0;h=D}while((h|0)<0|(h|0)==0&j>>>0<8);k=e}else k=e;if((n|32|0)==112){h=Ci(b,f)|0;e=D;if((h|0)==0&(e|0)==-2147483648){if(!f){si(b,0);g=0.0;break a}if(!(c[B>>2]|0)){h=0;e=0}else{c[C>>2]=(c[C>>2]|0)+-1;h=0;e=0}}}else if(!(c[B>>2]|0)){h=0;e=0}else{c[C>>2]=(c[C>>2]|0)+-1;h=0;e=0}j=gv(o|0,m|0,2)|0;j=Yu(j|0,D|0,-32,-1)|0;j=Yu(j|0,D|0,h|0,e|0)|0;e=D;if(!k){g=+(K|0)*0.0;break a}if((e|0)>0|(e|0)==0&j>>>0>(0-J|0)>>>0){c[(Oh()|0)>>2]=34;g=+(K|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break a}I=J+-106|0;H=((I|0)<0)<<31>>31;if((e|0)<(H|0)|(e|0)==(H|0)&j>>>0<I>>>0){c[(Oh()|0)>>2]=34;g=+(K|0)*2.2250738585072014e-308*2.2250738585072014e-308;break a}if((k|0)>-1){h=k;do{H=!(g>=.5);I=H&1|h<<1;h=I^1;g=g+(H?g:g+-1.0);j=Yu(j|0,e|0,-1,-1)|0;e=D}while((I|0)>-1);p=g;k=h}else p=g;J=Vu(32,0,J|0,((J|0)<0)<<31>>31|0)|0;e=Yu(j|0,e|0,J|0,D|0)|0;J=D;if(0>(J|0)|0==(J|0)&L>>>0>e>>>0)if((e|0)<0){h=0;e=84;A=127}else A=125;else{e=L;A=125}if((A|0)==125)if((e|0)<53){h=e;e=84-e|0;A=127}else{i=0.0;g=+(K|0)}if((A|0)==127){g=+(K|0);i=+Ei(+Di(1.0,e),g);e=h}L=(k&1|0)==0&(p!=0.0&(e|0)<32);g=g*(L?0.0:p)+(i+g*+(((L&1)+k|0)>>>0))-i;if(!(g!=0.0))c[(Oh()|0)>>2]=34;g=+Fi(g,j);break a}else e=j;while(0);E=J+L|0;H=0-E|0;h=0;f:while(1){switch(e|0){case 46:{A=138;break f}case 48:break;default:{n=0;k=h;o=0;m=0;break f}}e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0;h=1;continue}else{e=ui(b)|0;h=1;continue}}if((A|0)==138){e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;if((e|0)==48){h=0;e=0;while(1){h=Yu(h|0,e|0,-1,-1)|0;m=D;e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;if((e|0)==48)e=m;else{n=1;k=1;o=h;break}}}else{n=1;k=h;o=0;m=0}}c[I>>2]=0;r=e+-48|0;j=(e|0)==46;g:do if(j|r>>>0<10){A=I+496|0;w=0;h=0;z=0;x=n;y=k;n=0;k=0;h:while(1){do if(j)if(!x){x=1;v=z;o=n;m=k}else break h;else{n=Yu(n|0,k|0,1,0)|0;k=D;v=(e|0)!=48;if((h|0)>=125){if(!v){v=z;break}c[A>>2]=c[A>>2]|1;v=z;break}j=I+(h<<2)|0;if(!w)e=r;else e=e+-48+((c[j>>2]|0)*10|0)|0;c[j>>2]=e;w=w+1|0;y=(w|0)==9;w=y?0:w;h=(y&1)+h|0;v=v?n:z;y=1}while(0);e=c[C>>2]|0;if(e>>>0<(c[B>>2]|0)>>>0){c[C>>2]=e+1;e=d[e>>0]|0}else e=ui(b)|0;r=e+-48|0;j=(e|0)==46;if(!(j|r>>>0<10)){r=v;v=x;j=y;A=161;break g}else z=v}e=w;r=z;j=(y|0)!=0;A=169}else{w=0;h=0;r=0;v=n;j=k;n=0;k=0;A=161}while(0);do if((A|0)==161){z=(v|0)==0;o=z?n:o;m=z?k:m;j=(j|0)!=0;if(!(j&(e|32|0)==101))if((e|0)>-1){e=w;A=169;break}else{e=w;A=171;break}j=Ci(b,f)|0;e=D;if((j|0)==0&(e|0)==-2147483648){if(!f){si(b,0);g=0.0;break}if(!(c[B>>2]|0)){j=0;e=0}else{c[C>>2]=(c[C>>2]|0)+-1;j=0;e=0}}y=Yu(j|0,e|0,o|0,m|0)|0;e=w;m=D;A=173}while(0);if((A|0)==169)if(c[B>>2]|0){c[C>>2]=(c[C>>2]|0)+-1;if(j){y=o;A=173}else A=172}else A=171;if((A|0)==171)if(j){y=o;A=173}else A=172;do if((A|0)==172){c[(Oh()|0)>>2]=22;si(b,0);g=0.0}else if((A|0)==173){j=c[I>>2]|0;if(!j){g=+(K|0)*0.0;break}if(((k|0)<0|(k|0)==0&n>>>0<10)&((y|0)==(n|0)&(m|0)==(k|0))?L>>>0>30|(j>>>L|0)==0:0){g=+(K|0)*+(j>>>0);break}b=(J|0)/-2|0;C=((b|0)<0)<<31>>31;if((m|0)>(C|0)|(m|0)==(C|0)&y>>>0>b>>>0){c[(Oh()|0)>>2]=34;g=+(K|0)*1797693134862315708145274.0e284*1797693134862315708145274.0e284;break}b=J+-106|0;C=((b|0)<0)<<31>>31;if((m|0)<(C|0)|(m|0)==(C|0)&y>>>0<b>>>0){c[(Oh()|0)>>2]=34;g=+(K|0)*2.2250738585072014e-308*2.2250738585072014e-308;break}if(e){if((e|0)<9){k=I+(h<<2)|0;j=c[k>>2]|0;do{j=j*10|0;e=e+1|0}while((e|0)!=9);c[k>>2]=j}h=h+1|0}if((r|0)<9?(r|0)<=(y|0)&(y|0)<18:0){if((y|0)==9){g=+(K|0)*+((c[I>>2]|0)>>>0);break}if((y|0)<9){g=+(K|0)*+((c[I>>2]|0)>>>0)/+(c[13292+(8-y<<2)>>2]|0);break}b=L+27+(S(y,-3)|0)|0;e=c[I>>2]|0;if((b|0)>30|(e>>>b|0)==0){g=+(K|0)*+(e>>>0)*+(c[13292+(y+-10<<2)>>2]|0);break}}e=(y|0)%9|0;if(!e){e=0;k=0}else{r=(y|0)>-1?e:e+9|0;n=c[13292+(8-r<<2)>>2]|0;if(h){o=1e9/(n|0)|0;k=0;m=0;j=y;e=0;do{B=I+(e<<2)|0;C=c[B>>2]|0;b=((C>>>0)/(n>>>0)|0)+k|0;c[B>>2]=b;k=S((C>>>0)%(n>>>0)|0,o)|0;b=(e|0)==(m|0)&(b|0)==0;j=b?j+-9|0:j;m=b?m+1&127:m;e=e+1|0}while((e|0)!=(h|0));if(!k)k=m;else{c[I+(h<<2)>>2]=k;k=m;h=h+1|0}}else{k=0;h=0;j=y}e=0;y=9-r+j|0}i:while(1){r=(y|0)<18;v=(y|0)==18;w=I+(k<<2)|0;while(1){if(!r){if(!v){j=y;break i}if((c[w>>2]|0)>>>0>=9007199){j=18;break i}}j=0;x=h;h=h+127|0;while(1){m=h&127;n=I+(m<<2)|0;h=gv(c[n>>2]|0,0,29)|0;h=Yu(h|0,D|0,j|0,0)|0;j=D;if(j>>>0>0|(j|0)==0&h>>>0>1e9){o=dv(h|0,j|0,1e9,0)|0;h=iv(h|0,j|0,1e9,0)|0}else o=0;c[n>>2]=h;b=(m|0)==(k|0);x=(m|0)!=(x+127&127|0)|b?x:(h|0)==0?m:x;if(b)break;else{j=o;h=m+-1|0}}e=e+-29|0;if(o|0)break;else h=x}k=k+127&127;h=x+127&127;j=I+((x+126&127)<<2)|0;if((k|0)==(x|0))c[j>>2]=c[j>>2]|c[I+(h<<2)>>2];else h=x;c[I+(k<<2)>>2]=o;y=y+9|0}j:while(1){w=h+1&127;x=I+((h+127&127)<<2)|0;while(1){o=(j|0)==18;v=(j|0)>27?9:1;y=k;while(1){k=0;while(1){m=k+y&127;if((m|0)==(h|0)){G=2;A=220;break}m=c[I+(m<<2)>>2]|0;n=c[13324+(k<<2)>>2]|0;if(m>>>0<n>>>0){G=2;A=220;break}if(m>>>0>n>>>0)break;k=k+1|0;if((k|0)>=2){G=k;A=220;break}}if((A|0)==220?(A=0,o&(G|0)==2):0){g=0.0;m=0;break j}e=e+v|0;if((y|0)==(h|0))y=h;else break}o=(1<<v)+-1|0;r=1e9>>>v;n=0;k=y;m=y;do{B=I+(m<<2)|0;C=c[B>>2]|0;b=(C>>>v)+n|0;c[B>>2]=b;n=S(C&o,r)|0;b=(m|0)==(k|0)&(b|0)==0;j=b?j+-9|0:j;k=b?k+1&127:k;m=m+1&127}while((m|0)!=(h|0));if(!n)continue;if((w|0)!=(k|0))break;c[x>>2]=c[x>>2]|1}c[I+(h<<2)>>2]=n;h=w}while(1){k=m+y&127;j=h+1&127;if((k|0)==(h|0))c[I+(j+-1<<2)>>2]=0;else j=h;g=g*1.0e9+ +((c[I+(k<<2)>>2]|0)>>>0);m=m+1|0;if((m|0)==2)break;else h=j}u=+(K|0);i=u*g;n=e+53|0;o=n-J|0;r=(o|0)<(L|0);h=r&1;m=r?((o|0)<0?0:o):L;if((m|0)<53){N=+Ei(+Di(1.0,105-m|0),i);p=+Gi(i,+Di(1.0,53-m|0));q=N;g=p;p=N+(i-p)}else{q=0.0;g=0.0;p=i}k=y+2&127;do if((k|0)!=(j|0)){k=c[I+(k<<2)>>2]|0;do if(k>>>0>=5e8){if((k|0)!=5e8){g=u*.75+g;break}if((y+3&127|0)==(j|0)){g=u*.5+g;break}else{g=u*.75+g;break}}else{if((k|0)==0?(y+3&127|0)==(j|0):0)break;g=u*.25+g}while(0);if((53-m|0)>1){if(+Gi(g,1.0)!=0.0){i=g;break}i=g+1.0}else i=g}else i=g;while(0);g=p+i-q;do if((n&2147483647|0)>(-2-E|0)){if(+F(+g)>=9007199254740992.0){g=g*.5;h=r&(m|0)==(o|0)?0:h;e=e+1|0}if((e+50|0)<=(H|0)?!(i!=0.0&(h|0)!=0):0)break;c[(Oh()|0)>>2]=34}while(0);g=+Fi(g,e)}while(0);break a}default:{if(c[B>>2]|0)c[C>>2]=(c[C>>2]|0)+-1;c[(Oh()|0)>>2]=22;si(b,0);g=0.0;break a}}}}while(0);if((A|0)==23){h=(c[B>>2]|0)==0;if(!h)c[C>>2]=(c[C>>2]|0)+-1;if((f|0)!=0&e>>>0>3)do{if(!h)c[C>>2]=(c[C>>2]|0)+-1;e=e+-1|0}while(e>>>0>3)}g=+(K|0)*t}while(0);l=M;return +g}function Ci(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0;h=a+4|0;e=c[h>>2]|0;i=a+100|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=ui(a)|0;switch(e|0){case 43:case 45:{f=(e|0)==45&1;e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=ui(a)|0;if((b|0)!=0&(e+-48|0)>>>0>9?(c[i>>2]|0)!=0:0)c[h>>2]=(c[h>>2]|0)+-1;break}default:f=0}if((e+-48|0)>>>0>9)if(!(c[i>>2]|0)){f=-2147483648;e=0}else{c[h>>2]=(c[h>>2]|0)+-1;f=-2147483648;e=0}else{g=0;do{g=e+-48+(g*10|0)|0;e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=ui(a)|0}while((e+-48|0)>>>0<10&(g|0)<214748364);b=((g|0)<0)<<31>>31;if((e+-48|0)>>>0<10)do{b=fv(g|0,b|0,10,0)|0;g=D;e=Yu(e|0,((e|0)<0)<<31>>31|0,-48,-1)|0;g=Yu(e|0,D|0,b|0,g|0)|0;b=D;e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=ui(a)|0}while((e+-48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&g>>>0<2061584302));if((e+-48|0)>>>0<10)do{e=c[h>>2]|0;if(e>>>0<(c[i>>2]|0)>>>0){c[h>>2]=e+1;e=d[e>>0]|0}else e=ui(a)|0}while((e+-48|0)>>>0<10);if(c[i>>2]|0)c[h>>2]=(c[h>>2]|0)+-1;i=(f|0)!=0;e=Vu(0,0,g|0,b|0)|0;f=i?D:b;e=i?e:g}D=f;return e|0}function Di(a,b){a=+a;b=b|0;var d=0;if((b|0)>1023){a=a*8988465674311579538646525.0e283;d=b+-1023|0;b=b+-2046|0;if((d|0)>1023){a=a*8988465674311579538646525.0e283;b=(b|0)>1023?1023:b}else b=d}else if((b|0)<-1022){a=a*2.2250738585072014e-308;d=b+1022|0;b=b+2044|0;if((d|0)<-1022){a=a*2.2250738585072014e-308;b=(b|0)<-1022?-1022:b}else b=d}b=gv(b+1023|0,0,52)|0;d=D;c[j>>2]=b;c[j+4>>2]=d;return +(a*+h[j>>3])}function Ei(a,b){a=+a;b=+b;return +(+Uh(a,b))}function Fi(a,b){a=+a;b=b|0;return +(+Di(a,b))}function Gi(a,b){a=+a;b=+b;return +(+Hi(a,b))}function Hi(a,b){a=+a;b=+b;var d=0,e=0,f=0,g=0,i=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h[j>>3]=a;i=c[j>>2]|0;l=c[j+4>>2]|0;h[j>>3]=b;n=c[j>>2]|0;o=c[j+4>>2]|0;e=av(i|0,l|0,52)|0;e=e&2047;m=av(n|0,o|0,52)|0;m=m&2047;p=l&-2147483648;g=gv(n|0,o|0,1)|0;k=D;a:do if(!((g|0)==0&(k|0)==0)?(f=o&2147483647,!(f>>>0>2146435072|(f|0)==2146435072&n>>>0>0|(e|0)==2047)):0){d=gv(i|0,l|0,1)|0;f=D;if(!(f>>>0>k>>>0|(f|0)==(k|0)&d>>>0>g>>>0))return +((d|0)==(g|0)&(f|0)==(k|0)?a*0.0:a);if(!e){d=gv(i|0,l|0,12)|0;f=D;if((f|0)>-1|(f|0)==-1&d>>>0>4294967295){e=0;do{e=e+-1|0;d=gv(d|0,f|0,1)|0;f=D}while((f|0)>-1|(f|0)==-1&d>>>0>4294967295)}else e=0;i=gv(i|0,l|0,1-e|0)|0;g=D}else g=l&1048575|1048576;if(!m){f=gv(n|0,o|0,12)|0;k=D;if((k|0)>-1|(k|0)==-1&f>>>0>4294967295){d=0;do{d=d+-1|0;f=gv(f|0,k|0,1)|0;k=D}while((k|0)>-1|(k|0)==-1&f>>>0>4294967295)}else d=0;n=gv(n|0,o|0,1-d|0)|0;m=d;l=D}else l=o&1048575|1048576;f=Vu(i|0,g|0,n|0,l|0)|0;d=D;k=(d|0)>-1|(d|0)==-1&f>>>0>4294967295;b:do if((e|0)>(m|0)){while(1){if(k){if((f|0)==0&(d|0)==0)break}else{f=i;d=g}i=gv(f|0,d|0,1)|0;g=D;e=e+-1|0;f=Vu(i|0,g|0,n|0,l|0)|0;d=D;k=(d|0)>-1|(d|0)==-1&f>>>0>4294967295;if((e|0)<=(m|0))break b}b=a*0.0;break a}while(0);if(k){if((f|0)==0&(d|0)==0){b=a*0.0;break}}else{d=g;f=i}if(d>>>0<1048576|(d|0)==1048576&f>>>0<0)do{f=gv(f|0,d|0,1)|0;d=D;e=e+-1|0}while(d>>>0<1048576|(d|0)==1048576&f>>>0<0);if((e|0)>0){o=Yu(f|0,d|0,0,-1048576)|0;d=D;e=gv(e|0,0,52)|0;d=d|D;e=o|e}else{e=av(f|0,d|0,1-e|0)|0;d=D}c[j>>2]=e;c[j+4>>2]=d|p;b=+h[j>>3]}else q=3;while(0);if((q|0)==3){b=a*b;b=b/b}return +b}function Ii(a){a=a|0;var b=0;if(!(c[a>>2]&128))b=1;else b=(c[a+20>>2]|0)>>>0>(c[a+28>>2]|0)>>>0?2:1;b=ab[c[a+40>>2]&31](a,0,b)|0;if((b|0)>=0)b=b-(c[a+8>>2]|0)+(c[a+4>>2]|0)+(c[a+20>>2]|0)-(c[a+28>>2]|0)|0;return b|0}function Ji(a){a=a|0;var b=0,d=0;if((c[a+76>>2]|0)>-1){d=(_h(a)|0)==0;b=Ii(a)|0;if(!d)Qh(a)}else b=Ii(a)|0;return b|0}function Ki(a){a=a|0;var b=0,d=0,e=0;if((c[a+76>>2]|0)>-1)_h(a)|0;e=(c[a>>2]&1|0)!=0;if(!e){ta(1164048);d=c[a+52>>2]|0;b=a+56|0;if(d|0)c[d+56>>2]=c[b>>2];b=c[b>>2]|0;if(b|0)c[b+52>>2]=d;if((c[291011]|0)==(a|0))c[291011]=b;Ma(1164048)}b=Li(a)|0;b=hb[c[a+12>>2]&127](a)|0|b;d=c[a+92>>2]|0;if(d|0)Gj(d);if(!e)Gj(a);return b|0}function Li(a){a=a|0;var b=0,d=0;do if(a){if((c[a+76>>2]|0)<=-1){b=Mi(a)|0;break}d=(_h(a)|0)==0;b=Mi(a)|0;if(!d)Qh(a)}else{if(!(c[3214]|0))b=0;else b=Li(c[3214]|0)|0;ta(1164048);a=c[291011]|0;if(a)do{if((c[a+76>>2]|0)>-1)d=_h(a)|0;else d=0;if((c[a+20>>2]|0)>>>0>(c[a+28>>2]|0)>>>0)b=Mi(a)|0|b;if(d|0)Qh(a);a=c[a+56>>2]|0}while((a|0)!=0);Ma(1164048)}while(0);return b|0}function Mi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=a+20|0;h=a+28|0;if((c[b>>2]|0)>>>0>(c[h>>2]|0)>>>0?(ab[c[a+36>>2]&31](a,0,0)|0,(c[b>>2]|0)==0):0)a=-1;else{d=a+4|0;e=c[d>>2]|0;f=a+8|0;g=c[f>>2]|0;if(e>>>0<g>>>0)ab[c[a+40>>2]&31](a,e-g|0,1)|0;c[a+16>>2]=0;c[h>>2]=0;c[b>>2]=0;c[f>>2]=0;c[d>>2]=0;a=0}return a|0}function Ni(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=S(d,b)|0;if((c[e+76>>2]|0)>-1){g=(_h(e)|0)==0;a=$h(a,f,e)|0;if(!g)Qh(e)}else a=$h(a,f,e)|0;if((a|0)!=(f|0))d=(a>>>0)/(b>>>0)|0;return d|0}function Oi(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;do if((b|0)!=-1){if((c[d+76>>2]|0)>-1)g=_h(d)|0;else g=0;if(!((c[d+8>>2]|0)==0?(xi(d)|0)!=0:0))h=6;if((h|0)==6?(e=d+4|0,f=c[e>>2]|0,f>>>0>((c[d+44>>2]|0)+-8|0)>>>0):0){h=f+-1|0;c[e>>2]=h;a[h>>0]=b;c[d>>2]=c[d>>2]&-17;if(!g)break;Qh(d);break}if(g){Qh(d);b=-1}else b=-1}else b=-1;while(0);return b|0}function Pi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0;k=S(e,d)|0;if((c[f+76>>2]|0)>-1)j=_h(f)|0;else j=0;g=f+74|0;i=a[g>>0]|0;a[g>>0]=i+255|i;g=f+4|0;i=c[g>>2]|0;h=(c[f+8>>2]|0)-i|0;if((h|0)>0){h=h>>>0<k>>>0?h:k;cv(b|0,i|0,h|0)|0;c[g>>2]=i+h;g=k-h|0;b=b+h|0}else g=k;a:do if(!g)l=13;else{i=f+32|0;while(1){if(xi(f)|0)break;h=ab[c[i>>2]&31](f,b,g)|0;if((h+1|0)>>>0<2)break;g=g-h|0;if(!g){l=13;break a}else b=b+h|0}if(j|0)Qh(f);e=((k-g|0)>>>0)/(d>>>0)|0}while(0);if((l|0)==13)if(j)Qh(f);return e|0}function Qi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;c[f>>2]=d;d=Yh(a,b,f)|0;l=e;return d|0}function Ri(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0;j=l;l=l+16|0;i=j;a:do if(!b){e=c[d>>2]|0;f=c[e>>2]|0;if(!f)e=0;else{b=e;e=0;do{if(f>>>0>127){f=ii(i,f,0)|0;if((f|0)==-1){e=-1;break a}}else f=1;e=f+e|0;b=b+4|0;f=c[b>>2]|0}while((f|0)!=0)}}else{b:do if(e>>>0>3){f=e;g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h)break;h=ii(b,h,0)|0;if((h|0)==-1){e=-1;break a}b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(f>>>0<=3)break b}a[b>>0]=0;c[d>>2]=0;e=e-f|0;break a}else f=e;while(0);if(f){g=c[d>>2]|0;while(1){h=c[g>>2]|0;if((h+-1|0)>>>0>126){if(!h){g=19;break}h=ii(i,h,0)|0;if((h|0)==-1){e=-1;break a}if(f>>>0<h>>>0){g=22;break}ii(b,c[g>>2]|0,0)|0;b=b+h|0;f=f-h|0}else{a[b>>0]=h;b=b+1|0;f=f+-1|0;g=c[d>>2]|0}g=g+4|0;c[d>>2]=g;if(!f)break a}if((g|0)==19){a[b>>0]=0;c[d>>2]=0;e=e-f|0;break}else if((g|0)==22){e=e-f|0;break}}}while(0);l=j;return e|0}function Si(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+112|0;n=o+40|0;k=o+24|0;j=o+16|0;g=o;m=o+52|0;f=a[d>>0]|0;if(di(24847,f<<24>>24,4)|0){e=Fj(1144)|0;if(!e)e=0;else{h=e;i=h+112|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(i|0));if(!(mi(d,43)|0))c[e>>2]=f<<24>>24==114?8:4;if(mi(d,101)|0){c[g>>2]=b;c[g+4>>2]=2;c[g+8>>2]=1;qa(221,g|0)|0;f=a[d>>0]|0}if(f<<24>>24==97){c[j>>2]=b;c[j+4>>2]=3;f=qa(221,j|0)|0;if(!(f&1024)){c[k>>2]=b;c[k+4>>2]=4;c[k+8>>2]=f|1024;qa(221,k|0)|0}d=c[e>>2]|128;c[e>>2]=d}else d=c[e>>2]|0;c[e+60>>2]=b;c[e+44>>2]=e+120;c[e+48>>2]=1024;f=e+75|0;a[f>>0]=-1;if((d&8|0)==0?(c[n>>2]=b,c[n+4>>2]=21505,c[n+8>>2]=m,(La(54,n|0)|0)==0):0)a[f>>0]=10;c[e+32>>2]=8;c[e+36>>2]=5;c[e+40>>2]=6;c[e+12>>2]=38;if(!(c[291006]|0))c[e+76>>2]=-1;ta(1164048);f=c[291011]|0;c[e+56>>2]=f;if(f|0)c[f+52>>2]=e;c[291011]=e;Ma(1164048)}}else{c[(Oh()|0)>>2]=22;e=0}l=o;return e|0}function Ti(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=l;l=l+32|0;f=g+16|0;e=g;if(di(24847,a[d>>0]|0,4)|0){h=Ui(d)|0|32768;c[e>>2]=b;c[e+4>>2]=h;c[e+8>>2]=438;e=Nh(Ta(5,e|0)|0)|0;if((e|0)>=0){b=Si(e,d)|0;if(!b){c[f>>2]=e;Sa(6,f|0)|0;b=0}}else b=0}else{c[(Oh()|0)>>2]=22;b=0}l=g;return b|0}function Ui(b){b=b|0;var c=0,d=0,e=0;d=(mi(b,43)|0)==0;c=a[b>>0]|0;d=d?c<<24>>24!=114&1:2;e=(mi(b,120)|0)==0;d=e?d:d|128;b=(mi(b,101)|0)==0;b=b?d:d|524288;b=c<<24>>24==114?b:b|64;b=c<<24>>24==119?b|512:b;return (c<<24>>24==97?b|1024:b)|0}function Vi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=l;l=l+16|0;e=i;h=Fj(240)|0;do if(h){c[e>>2]=c[d>>2];e=Xh(h,240,b,e)|0;if(e>>>0<240){d=Ij(h,e+1|0)|0;c[a>>2]=d|0?d:h;break}Gj(h);if((e|0)>=0?(f=e+1|0,g=Fj(f)|0,c[a>>2]=g,(g|0)!=0):0)e=Xh(g,f,b,d)|0;else e=-1}else e=-1;while(0);l=i;return e|0}function Wi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;c[f>>2]=d;d=Xi(a,b,f)|0;l=e;return d|0}function Xi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;g=l;l=l+112|0;e=g;f=e;h=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(h|0));c[e+32>>2]=29;c[e+44>>2]=a;c[e+76>>2]=-1;c[e+84>>2]=a;h=Ai(e,b,d)|0;l=g;return h|0}function Yi(a,b,c){a=a|0;b=b|0;c=c|0;return Zi(a,b,c)|0}function Zi(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=a+84|0;g=c[e>>2]|0;h=d+256|0;f=di(g,0,h)|0;f=(f|0)==0?h:f-g|0;d=f>>>0<d>>>0?f:d;cv(b|0,g|0,d|0)|0;c[a+4>>2]=g+d;b=g+f|0;c[a+8>>2]=b;c[e>>2]=b;return d|0}function _i(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if((c[a+76>>2]|0)>-1){e=(_h(a)|0)==0;b=$i(a,b,d)|0;if(!e)Qh(a)}else b=$i(a,b,d)|0;return b|0}function $i(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;if((d|0)==1)b=b-(c[a+8>>2]|0)+(c[a+4>>2]|0)|0;e=a+20|0;f=a+28|0;if((c[e>>2]|0)>>>0>(c[f>>2]|0)>>>0?(ab[c[a+36>>2]&31](a,0,0)|0,(c[e>>2]|0)==0):0)b=-1;else{c[a+16>>2]=0;c[f>>2]=0;c[e>>2]=0;if((ab[c[a+40>>2]&31](a,b,d)|0)<0)b=-1;else{c[a+8>>2]=0;c[a+4>>2]=0;c[a>>2]=c[a>>2]&-17;b=0}}return b|0}function aj(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+1040|0;k=o+8|0;m=o;j=c[b>>2]|0;c[m>>2]=j;n=(a|0)!=0;h=n?e:256;a=n?a:k;g=j;a:do if((h|0)!=0&(j|0)!=0){e=0;j=d;while(1){i=j>>>2;d=i>>>0>=h>>>0;if(!(j>>>0>131|d)){d=j;break a}g=d?h:i;d=j-g|0;g=bj(a,m,g,f)|0;if((g|0)==-1)break;j=(a|0)==(k|0);h=h-(j?0:g)|0;a=j?a:a+(g<<2)|0;e=g+e|0;g=c[m>>2]|0;if((h|0)!=0&(g|0)!=0)j=d;else break a}e=-1;h=0;g=c[m>>2]|0}else e=0;while(0);b:do if((g|0)!=0?(h|0)!=0&(d|0)!=0:0){i=a;while(1){a=yi(i,g,d,f)|0;if((a+2|0)>>>0<3)break;g=(c[m>>2]|0)+a|0;c[m>>2]=g;d=d-a|0;h=h+-1|0;e=e+1|0;if(!((h|0)!=0&(d|0)!=0))break b;else i=i+4|0}switch(a|0){case -1:{e=-1;break b}case 0:{c[m>>2]=0;break b}default:{c[f>>2]=0;break b}}}while(0);if(n)c[b>>2]=c[m>>2];l=o;return e|0}function bj(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0;h=c[e>>2]|0;if((g|0)!=0?(i=c[g>>2]|0,(i|0)!=0):0)if(!b){g=f;j=h;l=17}else{c[g>>2]=0;k=b;g=f;l=38}else if(!b){g=f;l=7}else{i=b;g=f;l=6}a:while(1)if((l|0)==6){if(!g){l=27;break}else b=i;while(1){i=a[h>>0]|0;do if(((i&255)+-1|0)>>>0<127?g>>>0>4&(h&3|0)==0:0){while(1){i=c[h>>2]|0;if((i+-16843009|i)&-2139062144|0){l=33;break}c[b>>2]=i&255;c[b+4>>2]=d[h+1>>0];c[b+8>>2]=d[h+2>>0];j=h+4|0;i=b+16|0;c[b+12>>2]=d[h+3>>0];g=g+-4|0;if(g>>>0>4){b=i;h=j}else{l=32;break}}if((l|0)==32){b=i;h=j;i=a[j>>0]|0;break}else if((l|0)==33){i=i&255;break}}while(0);i=i&255;if((i+-1|0)>>>0>=127)break;h=h+1|0;c[b>>2]=i;g=g+-1|0;if(!g){l=27;break a}else b=b+4|0}i=i+-194|0;if(i>>>0>50){l=49;break}k=b;i=c[12976+(i<<2)>>2]|0;h=h+1|0;l=38;continue}else if((l|0)==7){while(1){i=a[h>>0]|0;if(((i&255)+-1|0)>>>0<127?(h&3|0)==0:0){l=c[h>>2]|0;i=l&255;if(!((l+-16843009|l)&-2139062144)){do{h=h+4|0;g=g+-4|0;i=c[h>>2]|0}while(!((i+-16843009|i)&-2139062144|0));i=i&255}}i=i&255;if((i+-1|0)>>>0>=127)break;h=h+1|0;g=g+-1|0}i=i+-194|0;if(i>>>0>50){l=49;break}i=c[12976+(i<<2)>>2]|0;j=h+1|0;l=17;continue}else if((l|0)==17){l=(d[j>>0]|0)>>>3;if((l+-16|l+(i>>26))>>>0>7){l=18;break}h=j+1|0;if(i&33554432){if((a[h>>0]&-64)<<24>>24!=-128){l=21;break}h=j+2|0;if(i&524288){if((a[h>>0]&-64)<<24>>24!=-128){l=24;break}h=j+3|0}}g=g+-1|0;l=7;continue}else if((l|0)==38){b=d[h>>0]|0;l=b>>>3;if((l+-16|l+(i>>26))>>>0>7){l=39;break}j=h+1|0;b=b+-128|i<<6;if((b|0)<0){i=(d[j>>0]|0)+-128|0;if(i>>>0>63){l=42;break}j=h+2|0;b=i|b<<6;if((b|0)<0){i=(d[j>>0]|0)+-128|0;if(i>>>0>63){l=45;break}b=i|b<<6;h=h+3|0}else h=j}else h=j;c[k>>2]=b;i=k+4|0;g=g+-1|0;l=6;continue}if((l|0)==18){h=j+-1|0;l=48}else if((l|0)==21){h=j+-1|0;l=48}else if((l|0)==24){h=j+-1|0;l=48}else if((l|0)==27)c[e>>2]=h;else if((l|0)==39){h=h+-1|0;b=k;l=48}else if((l|0)==42){h=h+-1|0;f=k;l=53}else if((l|0)==45){h=h+-1|0;f=k;l=53}if((l|0)==48)if(!i)l=49;else{f=b;l=53}if((l|0)==49)if(!(a[h>>0]|0)){if(b|0){c[b>>2]=0;c[e>>2]=0}f=f-g|0}else{f=b;l=53}if((l|0)==53){c[(Oh()|0)>>2]=84;if(!f)f=-1;else{c[e>>2]=h;f=-1}}return f|0}function cj(a){a=a|0;var b=0,e=0,f=0;if((c[a+76>>2]|0)>=0?(_h(a)|0)!=0:0){b=a+4|0;e=c[b>>2]|0;if(e>>>0<(c[a+8>>2]|0)>>>0){c[b>>2]=e+1;b=d[e>>0]|0}else b=wi(a)|0}else f=3;do if((f|0)==3){b=a+4|0;e=c[b>>2]|0;if(e>>>0<(c[a+8>>2]|0)>>>0){c[b>>2]=e+1;b=d[e>>0]|0;break}else{b=wi(a)|0;break}}while(0);return b|0}function dj(a,b,c){a=a|0;b=b|0;c=c|0;return yi(0,a,b,c|0?c:1164072)|0}function ej(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0;m=l;l=l+272|0;i=m+8|0;j=m;h=c[b>>2]|0;c[j>>2]=h;k=(a|0)!=0;g=k?e:256;a=k?a:i;e=h;a:do if((g|0)!=0&(h|0)!=0){f=0;h=e;while(1){e=d>>>0>=g>>>0;if(!(e|d>>>0>32)){e=h;break a}e=e?g:d;d=d-e|0;e=Ri(a,j,e,0)|0;if((e|0)==-1)break;h=(a|0)==(i|0);g=g-(h?0:e)|0;a=h?a:a+e|0;f=e+f|0;e=c[j>>2]|0;if((g|0)!=0&(e|0)!=0)h=e;else break a}f=-1;g=0;e=c[j>>2]|0}else f=0;while(0);b:do if((e|0)!=0?(g|0)!=0&(d|0)!=0:0){h=a;while(1){a=ii(h,c[e>>2]|0,0)|0;if((a+1|0)>>>0<2)break;e=(c[j>>2]|0)+4|0;c[j>>2]=e;d=d+-1|0;g=g-a|0;f=f+1|0;if(!((g|0)!=0&(d|0)!=0))break b;else h=h+a|0}if(!a)c[j>>2]=0;else f=-1}while(0);if(k)c[b>>2]=c[j>>2];l=m;return f|0}function fj(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if(((a[d>>0]|0)!=0?(li(d,25590)|0)!=0:0)?(li(d,24851)|0)!=0:0)e=0;else f=4;do if((f|0)==4)if(!e)if(!(c[291019]|0)){c[291019]=1;e=1164080;break}else{e=Hj(1,4)|0;break}while(0);return e|0}function gj(a){a=a|0;var b=0;b=(hj(a)|0)==0;return (b?a:a|32)|0}function hj(a){a=a|0;return (a+-65|0)>>>0<26|0}function ij(a){a=a|0;return 0}function jj(a){a=a|0;var b=0;b=(kj(a)|0)==0;return (b?a:a&95)|0}function kj(a){a=a|0;return (a+-97|0)>>>0<26|0}function lj(a,b){a=a|0;b=b|0;return mj(a)|0}function mj(a){a=a|0;return ((a+-48|0)>>>0<10|((a|32)+-97|0)>>>0<6)&1|0}function nj(a){a=a|0;var b=0,d=0;b=(lv()|0)+184|0;d=c[b>>2]|0;if(a|0)c[b>>2]=a;return d|0}function oj(a,b){a=a|0;b=b|0;return -1|0}function pj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return d|0}function qj(a){a=a|0;Gj(a);return}function rj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=c[b>>2];if(!d)break;else{b=b+4|0;e=e+4|0}}}return a|0}function sj(a,b){a=a|0;b=b|0;return (a+-48|0)>>>0<10|0}function tj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0.0,f=0,g=0,h=0,i=0;i=l;l=l+112|0;h=i;f=h;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=h+4|0;c[f>>2]=a;g=h+8|0;c[g>>2]=-1;c[h+44>>2]=a;c[h+76>>2]=-1;si(h,0);e=+Bi(h,d,1);d=(c[f>>2]|0)-(c[g>>2]|0)+(c[h+108>>2]|0)|0;if(b|0)c[b>>2]=d|0?a+d|0:a;l=i;return +e}function uj(a,b,c){a=a|0;b=b|0;c=c|0;return +(+tj(a,b,2))}function vj(a,b,c){a=a|0;b=b|0;c=c|0;c=ri(a,b,c,-1,-1)|0;return c|0}function wj(a,b,c){a=a|0;b=b|0;c=c|0;c=ri(a,b,c,0,-2147483648)|0;return c|0}function xj(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;a:do if(!d)b=0;else{while(1){e=a[b>>0]|0;f=a[c>>0]|0;if(e<<24>>24!=f<<24>>24)break;d=d+-1|0;if(!d){b=0;break a}else{b=b+1|0;c=c+1|0}}b=(e&255)-(f&255)|0}while(0);return b|0}function yj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=vj(a,b,c)|0;return d|0}function zj(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=wj(a,b,c)|0;return d|0}function Aj(){return 13332}function Bj(){return 13336}function Cj(){return 14876}function Dj(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;if(d|0){e=a;while(1){d=d+-1|0;c[e>>2]=b;if(!d)break;else e=e+4|0}}return a|0}function Ej(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(!e)do{d=d+-1|0;c[a+(d<<2)>>2]=c[b+(d<<2)>>2]}while((d|0)!=0)}else if(!e){e=b;b=a;while(1){d=d+-1|0;c[b>>2]=c[e>>2];if(!d)break;else{e=e+4|0;b=b+4|0}}}return a|0}
function yd(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;b=l;l=l+144|0;a=b;c[a>>2]=0;c[a+4>>2]=0;c[a+8>>2]=0;Jt(a,21816,5);d=a+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=a+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=a+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=a+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=a+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=a+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=a+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=a+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=a+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=a+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=a+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[259376]=p;c[259375]=p;c[259377]=p+144;It(p,a);p=(c[259376]|0)+12|0;c[259376]=p;It(p,d);p=(c[259376]|0)+12|0;c[259376]=p;It(p,e);p=(c[259376]|0)+12|0;c[259376]=p;It(p,f);p=(c[259376]|0)+12|0;c[259376]=p;It(p,g);p=(c[259376]|0)+12|0;c[259376]=p;It(p,h);p=(c[259376]|0)+12|0;c[259376]=p;It(p,i);p=(c[259376]|0)+12|0;c[259376]=p;It(p,j);p=(c[259376]|0)+12|0;c[259376]=p;It(p,k);p=(c[259376]|0)+12|0;c[259376]=p;It(p,m);p=(c[259376]|0)+12|0;c[259376]=p;It(p,n);p=(c[259376]|0)+12|0;c[259376]=p;It(p,o);c[259376]=(c[259376]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(a);c[259378]=-4980811;c[259379]=-3539001;c[259380]=-1835017;c[259381]=-655362;c[259382]=327686;c[259383]=786446;c[259384]=1703958;c[259385]=1900573;c[259386]=1900580;a=1037548;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259410]=-3866672;c[259411]=-1507348;c[259412]=-196592;c[259413]=851994;c[259414]=1572902;c[259415]=2752563;c[259416]=3538999;c[259417]=3735615;c[259418]=4259903;c[259419]=4784196;c[259420]=5111889;c[259421]=5636177;c[259422]=5767259;c[259423]=6357090;a=1037696;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259442]=-5046332;c[259443]=-1310746;c[259444]=1769461;c[259445]=3735546;c[259446]=4521981;c[259447]=5373951;c[259448]=7143434;c[259449]=7929872;c[259450]=8585240;c[259451]=9371673;c[259452]=10158112;c[259453]=10682400;c[259454]=10944555;c[259455]=11206704;c[259456]=11337784;a=1037828;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259474]=-2359335;c[259475]=-983061;c[259476]=524291;c[259477]=1179651;c[259478]=2228238;c[259479]=3538966;c[259480]=3997724;c[259481]=4784169;c[259482]=5177387;c[259483]=6029360;c[259484]=6160440;c[259485]=6815804;c[259486]=7405628;c[259487]=7864386;c[259488]=8060995;c[259489]=8257606;c[259490]=8716359;c[259491]=8912969;c[259492]=9175119;c[259493]=9371736;c[259494]=9699416;c[259495]=10879075;c[259496]=11141222;c[259497]=11468902;c[259498]=12058730;c[259499]=12517485;c[259500]=13500529;c[259501]=13893748;c[259502]=0;c[259503]=0;c[259504]=0;c[259505]=0;c[259506]=-9961622;c[259507]=-7078e3;c[259508]=-3407890;c[259509]=-1310724;c[259510]=655372;c[259511]=1441822;c[259512]=3407916;c[259513]=3670076;c[259514]=3801160;a=1038060;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259538]=-7602272;c[259539]=-2490410;c[259540]=-262112;c[259541]=1572916;c[259542]=2883658;c[259543]=5505126;c[259544]=7077996;c[259545]=7602302;c[259546]=8257666;c[259547]=9175182;c[259548]=9699486;c[259549]=11272354;c[259550]=11796664;c[259551]=12320962;a=1038208;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259570]=-10223728;c[259571]=-2359346;c[259572]=3407850;c[259573]=7208950;c[259574]=9175032;c[259575]=10616830;c[259576]=14286864;c[259577]=15728668;c[259578]=16777258;c[259579]=18743342;c[259580]=20185150;c[259581]=20971584;c[259582]=21626966;c[259583]=22020194;c[259584]=22151286;a=1038340;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259602]=-4587600;c[259603]=-1572914;c[259604]=917508;c[259605]=2490376;c[259606]=4849692;c[259607]=7209008;c[259608]=8126514;c[259609]=9961552;c[259610]=10354774;c[259611]=11403358;c[259612]=12320876;c[259613]=13369456;c[259614]=14549112;c[259615]=15204492;c[259616]=15466640;c[259617]=15990930;c[259618]=16777366;c[259619]=17039514;c[259620]=17432746;c[259621]=17825980;c[259622]=18350278;c[259623]=20578520;c[259624]=20709600;c[259625]=21102818;c[259626]=22806764;c[259627]=23199982;c[259628]=25034998;c[259629]=26083584;c[259630]=0;c[259631]=0;c[259632]=0;c[259633]=0;c[259634]=-4980811;c[259635]=-3539e3;c[259636]=-1703945;c[259637]=-655362;c[259638]=327686;c[259639]=720911;c[259640]=1703958;c[259641]=1835038;c[259642]=1900580;a=1038572;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259666]=-3801136;c[259667]=-1245205;c[259668]=-131056;c[259669]=786458;c[259670]=1441829;c[259671]=2752563;c[259672]=3538998;c[259673]=3801151;c[259674]=4128833;c[259675]=4587591;c[259676]=4849743;c[259677]=5636177;c[259678]=5898332;c[259679]=6160481;a=1038720;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259698]=-5111864;c[259699]=-1179673;c[259700]=1703925;c[259701]=3604475;c[259702]=4587516;c[259703]=5308415;c[259704]=7143432;c[259705]=7864334;c[259706]=8388629;c[259707]=9371671;c[259708]=10092575;c[259709]=10485792;c[259710]=10813483;c[259711]=11010097;c[259712]=11075643;a=1038852;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259730]=-2293800;c[259731]=-786457;c[259732]=458754;c[259733]=1245188;c[259734]=2424846;c[259735]=3604504;c[259736]=4063257;c[259737]=4980776;c[259738]=5177387;c[259739]=5701679;c[259740]=6160438;c[259741]=6684728;c[259742]=7274556;c[259743]=7602246;c[259744]=7733320;c[259745]=7995465;c[259746]=8388683;c[259747]=8519757;c[259748]=8716373;c[259749]=8912990;c[259750]=9175139;c[259751]=10289260;c[259752]=10354800;c[259753]=10551409;c[259754]=11403382;c[259755]=11599991;c[259756]=12517499;c[259757]=13041792;c[259758]=0;c[259759]=0;c[259760]=0;c[259761]=0;c[259762]=-7340147;c[259763]=-3342430;c[259764]=-1572954;c[259765]=-327718;c[259766]=327686;c[259767]=720911;c[259768]=1703958;c[259769]=1835038;c[259770]=1900580;a=1039084;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259794]=-4128918;c[259795]=-2687067;c[259796]=-524272;c[259797]=786458;c[259798]=1441829;c[259799]=2752563;c[259800]=3538998;c[259801]=3801151;c[259802]=4128833;c[259803]=4587591;c[259804]=4849743;c[259805]=5636177;c[259806]=5898332;c[259807]=6160481;a=1039232;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259826]=-5111864;c[259827]=-1179673;c[259828]=1703925;c[259829]=3604475;c[259830]=4587516;c[259831]=5308415;c[259832]=7143432;c[259833]=7864334;c[259834]=8388629;c[259835]=9371671;c[259836]=10092575;c[259837]=10485792;c[259838]=10813483;c[259839]=11010097;c[259840]=11075643;a=1039364;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259858]=-2293800;c[259859]=-786457;c[259860]=458754;c[259861]=1245188;c[259862]=2424846;c[259863]=3604504;c[259864]=4063257;c[259865]=4980776;c[259866]=5177387;c[259867]=5701679;c[259868]=6160438;c[259869]=6684728;c[259870]=7274556;c[259871]=7602246;c[259872]=7733320;c[259873]=7995465;c[259874]=8388683;c[259875]=8519757;c[259876]=8716373;c[259877]=8912990;c[259878]=9175139;c[259879]=10289260;c[259880]=10354800;c[259881]=10551409;c[259882]=11403382;c[259883]=11599991;c[259884]=12517499;c[259885]=13041792;c[259886]=0;c[259887]=0;c[259888]=0;c[259889]=0;c[259890]=-4980811;c[259891]=-3539e3;c[259892]=-1703945;c[259893]=-655362;c[259894]=327686;c[259895]=720911;c[259896]=1703958;c[259897]=1835038;c[259898]=1900580;a=1039596;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259922]=-3801136;c[259923]=-1245205;c[259924]=-131056;c[259925]=786458;c[259926]=1441829;c[259927]=2752563;c[259928]=3538998;c[259929]=3801151;c[259930]=4128833;c[259931]=4587591;c[259932]=4849743;c[259933]=5636177;c[259934]=5898332;c[259935]=6160481;a=1039744;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259954]=-5111864;c[259955]=-1179673;c[259956]=1703925;c[259957]=3604475;c[259958]=4587516;c[259959]=5308415;c[259960]=7143432;c[259961]=7864334;c[259962]=8388629;c[259963]=9371671;c[259964]=10092575;c[259965]=10485792;c[259966]=10813483;c[259967]=11010097;c[259968]=11075643;a=1039876;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[259986]=-2293800;c[259987]=-786457;c[259988]=458754;c[259989]=1245188;c[259990]=2424846;c[259991]=3604504;c[259992]=4063257;c[259993]=4980776;c[259994]=5177387;c[259995]=5701679;c[259996]=6160438;c[259997]=6684728;c[259998]=7274556;c[259999]=7602246;c[26e4]=7733320;c[260001]=7995465;c[260002]=8388683;c[260003]=8519757;c[260004]=8716373;c[260005]=8912990;c[260006]=9175139;c[260007]=10289260;c[260008]=10354800;c[260009]=10551409;c[260010]=11403382;c[260011]=11599991;c[260012]=12517499;c[260013]=13041792;c[260014]=0;c[260015]=0;c[260016]=0;c[260017]=0;c[260018]=-4980811;c[260019]=-3539e3;c[260020]=-1703945;c[260021]=-655362;c[260022]=327686;c[260023]=720911;c[260024]=1703958;c[260025]=1835038;c[260026]=1900580;a=1040108;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260050]=-3801136;c[260051]=-1245205;c[260052]=-131056;c[260053]=786458;c[260054]=1441829;c[260055]=2752563;c[260056]=3538998;c[260057]=3801151;c[260058]=4128833;c[260059]=4587591;c[260060]=4849743;c[260061]=5636177;c[260062]=5898332;c[260063]=6160481;a=1040256;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260082]=-5111864;c[260083]=-1179673;c[260084]=1703925;c[260085]=3604475;c[260086]=4587516;c[260087]=5308415;c[260088]=7143432;c[260089]=7864334;c[260090]=8388629;c[260091]=9371671;c[260092]=10092575;c[260093]=10485792;c[260094]=10813483;c[260095]=11010097;c[260096]=11075643;a=1040388;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260114]=-2293800;c[260115]=-786457;c[260116]=458754;c[260117]=1245188;c[260118]=2424846;c[260119]=3604504;c[260120]=4063257;c[260121]=4980776;c[260122]=5177387;c[260123]=5701679;c[260124]=6160438;c[260125]=6684728;c[260126]=7274556;c[260127]=7602246;c[260128]=7733320;c[260129]=7995465;c[260130]=8388683;c[260131]=8519757;c[260132]=8716373;c[260133]=8912990;c[260134]=9175139;c[260135]=10289260;c[260136]=10354800;c[260137]=10551409;c[260138]=11403382;c[260139]=11599991;c[260140]=12517499;c[260141]=13041792;c[260142]=0;c[260143]=0;c[260144]=0;c[260145]=0;c[260146]=-4980811;c[260147]=-3539e3;c[260148]=-1703945;c[260149]=-655362;c[260150]=327686;c[260151]=720911;c[260152]=1703958;c[260153]=1835038;c[260154]=1900580;a=1040620;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260178]=-3801136;c[260179]=-1245205;c[260180]=-131056;c[260181]=786458;c[260182]=1441829;c[260183]=2752563;c[260184]=3538998;c[260185]=3801151;c[260186]=4128833;c[260187]=4587591;c[260188]=4849743;c[260189]=5636177;c[260190]=5898332;c[260191]=6160481;a=1040768;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260210]=-5111864;c[260211]=-1179673;c[260212]=1703925;c[260213]=3604475;c[260214]=4587516;c[260215]=5308415;c[260216]=7143432;c[260217]=7864334;c[260218]=8388629;c[260219]=9371671;c[260220]=10092575;c[260221]=10485792;c[260222]=10813483;c[260223]=11010097;c[260224]=11075643;a=1040900;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260242]=-2293800;c[260243]=-786457;c[260244]=458754;c[260245]=1245188;c[260246]=2424846;c[260247]=3604504;c[260248]=4063257;c[260249]=4980776;c[260250]=5177387;c[260251]=5701679;c[260252]=6160438;c[260253]=6684728;c[260254]=7274556;c[260255]=7602246;c[260256]=7733320;c[260257]=7995465;c[260258]=8388683;c[260259]=8519757;c[260260]=8716373;c[260261]=8912990;c[260262]=9175139;c[260263]=10289260;c[260264]=10354800;c[260265]=10551409;c[260266]=11403382;c[260267]=11599991;c[260268]=12517499;c[260269]=13041792;c[260270]=0;c[260271]=0;c[260272]=0;c[260273]=0;c[260274]=-9961622;c[260275]=-7078e3;c[260276]=-3407890;c[260277]=-1310724;c[260278]=655372;c[260279]=1441822;c[260280]=3407916;c[260281]=3670076;c[260282]=3801160;a=1041132;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260306]=-7602272;c[260307]=-2490410;c[260308]=-262112;c[260309]=1572916;c[260310]=2883658;c[260311]=5505126;c[260312]=7077996;c[260313]=7602302;c[260314]=8257666;c[260315]=9175182;c[260316]=9699486;c[260317]=11272354;c[260318]=11796664;c[260319]=12320962;a=1041280;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260338]=-10223728;c[260339]=-2359346;c[260340]=3407850;c[260341]=7208950;c[260342]=9175032;c[260343]=10616830;c[260344]=14286864;c[260345]=15728668;c[260346]=16777258;c[260347]=18743342;c[260348]=20185150;c[260349]=20971584;c[260350]=21626966;c[260351]=22020194;c[260352]=22151286;a=1041412;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260370]=-4587600;c[260371]=-1572914;c[260372]=917508;c[260373]=2490376;c[260374]=4849692;c[260375]=7209008;c[260376]=8126514;c[260377]=9961552;c[260378]=10354774;c[260379]=11403358;c[260380]=12320876;c[260381]=13369456;c[260382]=14549112;c[260383]=15204492;c[260384]=15466640;c[260385]=15990930;c[260386]=16777366;c[260387]=17039514;c[260388]=17432746;c[260389]=17825980;c[260390]=18350278;c[260391]=20578520;c[260392]=20709600;c[260393]=21102818;c[260394]=22806764;c[260395]=23199982;c[260396]=25034998;c[260397]=26083584;c[260398]=0;c[260399]=0;c[260400]=0;c[260401]=0;c[260402]=-4980811;c[260403]=-3539e3;c[260404]=-1703945;c[260405]=-655362;c[260406]=327686;c[260407]=720911;c[260408]=1703958;c[260409]=1835038;c[260410]=1900580;a=1041644;d=a+92|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260434]=-3801136;c[260435]=-1245205;c[260436]=-131056;c[260437]=786458;c[260438]=1441829;c[260439]=2752563;c[260440]=3538998;c[260441]=3801151;c[260442]=4128833;c[260443]=4587591;c[260444]=4849743;c[260445]=5636177;c[260446]=5898332;c[260447]=6160481;a=1041792;d=a+72|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260466]=-5111864;c[260467]=-1179673;c[260468]=1703925;c[260469]=3604475;c[260470]=4587516;c[260471]=5308415;c[260472]=7143432;c[260473]=7864334;c[260474]=8388629;c[260475]=9371671;c[260476]=10092575;c[260477]=10485792;c[260478]=10813483;c[260479]=11010097;c[260480]=11075643;a=1041924;d=a+68|0;do{c[a>>2]=0;a=a+4|0}while((a|0)<(d|0));c[260498]=-2293800;c[260499]=-786457;c[260500]=458754;c[260501]=1245188;c[260502]=2424846;c[260503]=3604504;c[260504]=4063257;c[260505]=4980776;c[260506]=5177387;c[260507]=5701679;c[260508]=6160438;c[260509]=6684728;c[260510]=7274556;c[260511]=7602246;c[260512]=7733320;c[260513]=7995465;c[260514]=8388683;c[260515]=8519757;c[260516]=8716373;c[260517]=8912990;c[260518]=9175139;c[260519]=10289260;c[260520]=10354800;c[260521]=10551409;c[260522]=11403382;c[260523]=11599991;c[260524]=12517499;c[260525]=13041792;c[260526]=0;c[260527]=0;c[260528]=0;c[260529]=0;c[260530]=393238;c[260531]=589857;c[260532]=131081;c[260533]=262158;c[260534]=458772;c[260535]=1310765;c[260536]=0;c[260537]=0;c[260538]=9109680;c[260539]=8323203;c[260540]=14287065;c[260541]=14090443;p=1042168;c[p>>2]=0;c[p+4>>2]=0;c[260544]=0;c[260545]=2162688;c[260546]=2818093;c[260547]=3080238;c[260548]=7012424;c[260549]=7733296;p=1042200;c[p>>2]=0;c[p+4>>2]=0;c[260552]=0;c[260553]=1638400;c[260554]=4063272;c[260555]=3866664;c[260556]=2228224;c[260557]=3145763;p=1042232;c[p>>2]=0;c[p+4>>2]=0;c[260560]=4063235;c[260561]=9043977;c[260562]=0;c[260563]=24183256;c[260564]=75958204;c[260565]=0;c[260566]=101779042;c[260567]=25166224;c[260568]=11403429;c[260569]=5701715;c[260570]=3276849;c[260571]=0;c[260572]=13828255;c[260573]=7798906;c[260574]=18284760;c[260575]=22348217;c[260576]=9175067;c[260577]=6225943;c[260578]=7340192;c[260579]=8454222;c[260580]=4915265;c[260581]=852038;c[260582]=8061074;c[260583]=0;c[260584]=5374010;c[260585]=7340112;c[260586]=5701756;c[260587]=7209063;c[260588]=7012537;c[260589]=3932232;c[260590]=4063358;c[260591]=0;c[260592]=8323183;c[260593]=6226022;c[260594]=11993209;c[260595]=2424972;c[260596]=6488184;c[260597]=720951;c[260598]=6094936;c[260599]=0;c[260600]=4522040;c[260601]=8126536;c[260602]=10092653;c[260603]=9764962;c[260604]=7405697;c[260605]=4718739;c[260606]=9961629;c[260607]=0;c[260608]=7798906;c[260609]=18284760;c[260610]=22348217;c[260611]=9175067;c[260612]=6225943;c[260613]=7340192;c[260614]=8454222;c[260615]=4915265;c[260616]=852038;c[260617]=8061074;c[260618]=0;c[260619]=5374010;c[260620]=7340112;c[260621]=5701756;c[260622]=7209063;c[260623]=7012537;c[260624]=3932232;c[260625]=4063358;c[260626]=0;c[260627]=8323183;c[260628]=6226022;c[260629]=11993209;c[260630]=2424972;c[260631]=6488184;c[260632]=720951;c[260633]=6094936;c[260634]=0;c[260635]=4522040;c[260636]=8126536;c[260637]=10092653;c[260638]=9764962;c[260639]=7405697;c[260640]=4718739;c[260641]=9961629;c[260642]=0;c[260643]=945567624;c[260644]=351541035;c[260645]=249041172;c[260646]=161679990;c[260647]=99288617;c[260648]=59900864;c[260649]=31457798;c[260650]=0;c[260651]=655369;c[260652]=655362;c[260653]=-524287;c[260654]=-786452;c[260655]=-786452;c[260656]=-524287;c[260657]=655362;c[260658]=655369;c[260659]=0;c[260660]=589831;c[260661]=65543;c[260662]=327681;c[260663]=-262154;c[260664]=-262145;c[260665]=-196615;c[260666]=-655376;c[260667]=0;c[260668]=524299;c[260669]=-65543;c[260670]=-131073;c[260671]=-458753;c[260672]=-196619;c[260673]=-65545;c[260674]=-65552;c[260675]=0;c[260676]=10;c[260677]=131070;c[260678]=262139;c[260679]=131066;c[260680]=-196622;c[260681]=-589826;c[260682]=-458764;c[260683]=0;c[260684]=-327677;c[260685]=-327678;c[260686]=-4;c[260687]=-393225;c[260688]=458748;c[260689]=-458765;c[260690]=-458762;c[260691]=16;c[260692]=786440;c[260693]=1572872;c[260694]=92;c[260695]=655410;c[260696]=655370;c[260697]=7;c[260698]=0;c[260699]=17;c[260700]=1310733;c[260701]=7;c[260702]=7;c[260703]=7;c[260704]=0;c[260705]=655375;c[260706]=5242900;c[260707]=3997767;c[260708]=196624;c[260709]=1769520;c[260710]=1441830;c[260711]=7;c[260712]=3276850;l=b;return}function zd(a){a=a|0;var b=0,d=0;switch(c[a+5364>>2]|0){case 1:{b=c[a+5348>>2]<<3;if(!(c[a+336+(b<<2)>>2]|0)){a=1;return a|0}a=(c[a+336+((b^8)<<2)>>2]|0)==0;return a|0}case 2:{b=c[a+5348>>2]<<3;if(!(c[a+336+((b^14)<<2)>>2]|0)){a=1;return a|0}a=(c[a+336+((b|6)<<2)>>2]|0)==0;return a|0}case 4:{a=(c[a+336+(((c[a+360>>2]|0)!=0&1)<<3<<2)>>2]|0)==0;return a|0}case 5:{b=c[a+5348>>2]|0;d=c[a+400+((b<<3|6)<<8)>>2]|0;if(((d>>3)+-3|0)>>>0<2?((d&7)+-3|0)>>>0<2:0){a=1;return a|0}b=c[a+400+((b<<3^14)<<8)>>2]|0;if(((b>>3)+-3|0)>>>0>=2){a=0;return a|0}a=((b&7)+-3|0)>>>0<2;return a|0}case 6:{b=c[a+5348>>2]<<3;if((c[a+336+(b<<2)>>2]|0)==1){a=1;return a|0}a=(c[a+336+((b^8)<<2)>>2]|0)==1;return a|0}case 7:{d=c[a+5348>>2]|0;b=d<<3;if((c[a+400+((b|6)<<8)>>2]&-8|0)==56){if((c[a+400+((b^14)<<8)>>2]&-8|0)==56){a=1;return a|0}if((c[a+400+((d<<3^14)<<8)>>2]>>3|0)<7){a=1;return a|0}}a=Hd(a)|0;return a|0}case 8:{d=c[a+5348>>2]|0;b=c[a+5356>>2]|0;if((c[b+36+(d<<2)>>2]|0)==3){a=1;return a|0}a=(c[b+36+((d^1)<<2)>>2]|0)==3;return a|0}default:{a=0;return a|0}}return 0}function Ad(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;i=c[a+5364>>2]|0;switch(i|0){case 1:{e=c[a+5348>>2]|0;f=e<<3;if(!(c[a+336+(f<<2)>>2]|0)){b=32e3-b|0;return b|0}if(!(c[a+336+((f^8)<<2)>>2]|0)){b=b+-32e3|0;return b|0}else h=10;break}case 2:{e=c[a+5348>>2]|0;h=10;break}case 4:{h=14;break}case 5:{f=c[a+5348>>2]|0;h=17;break}case 6:{f=c[a+5348>>2]|0;h=35;break}case 7:{f=c[a+5348>>2]|0;g=7;h=40;break}case 8:break;default:{b=0;return b|0}}if((h|0)==10){e=e<<3;if(!(c[a+336+((e^14)<<2)>>2]|0)){b=32e3-b|0;return b|0}if(!(c[a+336+((e|6)<<2)>>2]|0)){b=b+-32e3|0;return b|0}else h=14}a:do if((h|0)==14){if(!(c[a+336+(((c[a+360>>2]|0)!=0&1)<<3<<2)>>2]|0)){b=b+-32e3|0;return b|0}g=c[a+5348>>2]|0;switch(i|0){case 4:{e=g<<3|6;if(c[a+336+(e<<2)>>2]|0){f=g;h=24;break a}f=g;e=g^1;h=29;break a}case 2:{e=g<<3|6;if(c[a+336+(e<<2)>>2]|0){f=g;h=24;break a}f=g;e=g^1;h=30;break a}case 1:{e=g<<3|6;if(c[a+336+(e<<2)>>2]|0){f=g;h=24;break a}f=g;e=g^1;h=31;break a}default:{f=g;h=17;break a}}}while(0);if((h|0)==17){e=f<<3|6;h=24}b:do if((h|0)==24){h=c[a+400+(e<<8)>>2]|0;if(((h>>3)+-3|0)>>>0<2?((h&7)+-3|0)>>>0<2:0){b=32e3-b|0;return b|0}e=f^1;switch(i|0){case 4:{h=29;break b}case 2:{h=30;break b}case 1:{h=31;break b}default:{}}e=e<<3|6;h=32}while(0);if((h|0)==29){e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))h=35;else h=32}else if((h|0)==30){e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))h=35;else h=32}else if((h|0)==31){e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))h=35;else h=32}if((h|0)==32){h=c[a+400+(e<<8)>>2]|0;if(((h>>3)+-3|0)>>>0<2?((h&7)+-3|0)>>>0<2:0){b=b+-32e3|0;return b|0}else h=35}c:do if((h|0)==35){e=f<<3;if((c[a+336+(e<<2)>>2]|0)==1){b=32e3-b|0;return b|0}if((c[a+336+((e^8)<<2)>>2]|0)==1){b=b+-32e3|0;return b|0}switch(i|0){case 4:{e=e|6;if(!(c[a+336+(e<<2)>>2]|0)){h=53;break c}else{g=4;h=44;break c}}case 2:{e=e|6;if(!(c[a+336+(e<<2)>>2]|0)){h=54;break c}else{g=2;h=44;break c}}case 1:{e=e|6;if(!(c[a+336+(e<<2)>>2]|0)){h=55;break c}else{g=1;h=44;break c}}default:{g=i;h=40;break c}}}while(0);if((h|0)==40){e=f<<3|6;h=44}d:do if((h|0)==44){e:do if((c[a+400+(e<<8)>>2]&-8|0)==56){e=f^1;switch(g|0){case 4:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))break e;break}case 2:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))break e;break}case 1:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))break e;break}default:e=e<<3|6}if((c[a+400+(e<<8)>>2]&-8|0)==56){b=d;return b|0}}while(0);switch(i|0){case 4:{h=53;break d}case 2:{h=54;break d}case 1:{h=55;break d}default:{}}e=f<<3|6;h=56}while(0);if((h|0)==53){e=f<<3|6;if(!(c[a+336+(e<<2)>>2]|0))h=64;else h=56}else if((h|0)==54){e=f<<3|6;if(!(c[a+336+(e<<2)>>2]|0))h=64;else h=56}else if((h|0)==55){e=f<<3|6;if(!(c[a+336+(e<<2)>>2]|0))h=64;else h=56}f:do if((h|0)==56)if((c[a+400+(e<<8)>>2]&-8|0)==56){e=f^1;switch(i|0){case 4:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0)){h=64;break f}break}case 2:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0)){h=64;break f}break}case 1:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0)){h=64;break f}break}default:e=e<<3|6}if((c[a+400+(e<<8)>>2]>>3|0)<7){b=32e3-b|0;return b|0}else h=64}else h=64;while(0);if((h|0)==64?Hd(a)|0:0){b=b+-32e3|0;return b|0}f=c[a+5348>>2]|0;e=c[a+5356>>2]|0;if((c[e+36+(f<<2)>>2]|0)!=3)return ((c[e+36+((f^1)<<2)>>2]|0)==3?b+-32e3|0:0)|0;b=32e3-b|0;return b|0}function Bd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=a+320|0;h=i;g=a+264|0;m=c[g>>2]&c[h>>2];h=c[g+4>>2]&c[h+4>>2];g=a+256|0;g=av(c[g>>2]|0,c[g+4>>2]|0,8)|0;g=m&(g|16776960);h=h&D;m=c[a+5364>>2]|0;switch(m|0){case 4:{if(!(c[a+360>>2]|0)){i=31056;e=c[b+4>>2]|0;f=e+40|0;j=f;k=~(c[i+4>>2]|h|c[j+4>>2]);l=b+8|0;c[l>>2]=~(c[i>>2]|g|c[j>>2]);c[l+4>>2]=k;l=11}else l=8;break}case 2:{if(!(c[a+360>>2]|0)){i=31056;e=c[b+4>>2]|0;f=e+40|0;j=f;k=~(c[i+4>>2]|h|c[j+4>>2]);l=b+8|0;c[l>>2]=~(c[i>>2]|g|c[j>>2]);c[l+4>>2]=k;l=12}else l=8;break}case 1:{if(!(c[a+360>>2]|0)){n=31056;e=c[b+4>>2]|0;f=e+40|0;j=f;k=~(c[n+4>>2]|h|c[j+4>>2]);l=b+8|0;c[l>>2]=~(c[n>>2]|g|c[j>>2]);c[l+4>>2]=k;l=9}else l=8;break}default:l=8}if((l|0)==8){j=30544+(c[a+1936>>2]<<3)|0;e=c[b+4>>2]|0;f=e+40|0;k=f;l=~(c[j+4>>2]|h|c[k+4>>2]);n=b+8|0;c[n>>2]=~(c[j>>2]|g|c[k>>2]);c[n+4>>2]=l;switch(m|0){case 1:{l=9;break}case 4:{l=11;break}case 2:{l=12;break}default:l=13}}if((l|0)==9){k=b+72|0;h=k;c[h>>2]=0;c[h+4>>2]=0;h=i;n=a+304|0;g=c[n>>2]&c[h>>2];h=c[n+4>>2]&c[h+4>>2];if((g|0)==0&(h|0)==0){h=0;g=0}else{i=0;j=0;do{n=Qa(g|0,h|0,0)|0;o=Yu(g|0,h|0,-1,-1)|0;g=o&g;h=D&h;n=34448+(n<<3)|0;i=i|c[n>>2];j=j|c[n+4>>2];n=k;c[n>>2]=i;c[n+4>>2]=j}while(!((g|0)==0&(h|0)==0));h=i;g=j}}else if((l|0)==11)if(!(c[a+360>>2]|0)){g=64;l=14}else l=13;else if((l|0)==12)if(!(c[a+360>>2]|0)){g=64;l=14}else l=13;if((l|0)==13){g=c[a+1936>>2]|0;l=14}if((l|0)==14){g=34448+(g<<3)|0;h=c[g>>2]|0;g=c[g+4>>2]|0;o=b+72|0;c[o>>2]=h;c[o+4>>2]=g}n=e+32|0;l=c[n>>2]|0;n=c[n+4>>2]|0;o=b+32|0;c[o>>2]=l;c[o+4>>2]=n;o=b+152|0;c[o>>2]=l&h;c[o+4>>2]=n&g;o=b+24|0;c[o>>2]=l|h;c[o+4>>2]=n|g;if((m|0)!=1?((m|0)==3?1:(c[(c[a+5356>>2]|0)+20>>2]|0)>2512):0){m=gv(h|0,g|0,8)|0;n=b+168|0;c[n>>2]=m|h;c[n+4>>2]=D|g;n=f;m=c[n>>2]&h;n=c[n+4>>2]&g;a=av(m|0,n|0,16)|0;o=av(m|0,n|0,48)|0;c[b+188>>2]=(d[1167548+(a&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+(n&65535)>>0]|0)+(d[1167548+o>>0]|0);c[b+196>>2]=0;c[b+204>>2]=0;return}c[b+188>>2]=0;o=b+168|0;c[o>>2]=0;c[o+4>>2]=0;return}function Cd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;i=a+328|0;h=i;g=a+264|0;m=c[g>>2]&c[h>>2];h=c[g+4>>2]&c[h+4>>2];g=a+256|0;g=gv(c[g>>2]|0,c[g+4>>2]|0,8)|0;g=m&g;h=h&(D|16776960);m=c[a+5364>>2]|0;switch(m|0){case 4:{if(!(c[a+392>>2]|0)){i=31056;e=c[b+4>>2]|0;f=e+32|0;j=f;k=~(c[i+4>>2]|h|c[j+4>>2]);l=b+16|0;c[l>>2]=~(c[i>>2]|g|c[j>>2]);c[l+4>>2]=k;l=11}else l=8;break}case 2:{if(!(c[a+392>>2]|0)){i=31056;e=c[b+4>>2]|0;f=e+32|0;j=f;k=~(c[i+4>>2]|h|c[j+4>>2]);l=b+16|0;c[l>>2]=~(c[i>>2]|g|c[j>>2]);c[l+4>>2]=k;l=12}else l=8;break}case 1:{if(!(c[a+392>>2]|0)){n=31056;e=c[b+4>>2]|0;f=e+32|0;j=f;k=~(c[n+4>>2]|h|c[j+4>>2]);l=b+16|0;c[l>>2]=~(c[n>>2]|g|c[j>>2]);c[l+4>>2]=k;l=9}else l=8;break}default:l=8}if((l|0)==8){j=30544+(c[a+3984>>2]<<3)|0;e=c[b+4>>2]|0;f=e+32|0;k=f;l=~(c[j+4>>2]|h|c[k+4>>2]);n=b+16|0;c[n>>2]=~(c[j>>2]|g|c[k>>2]);c[n+4>>2]=l;switch(m|0){case 1:{l=9;break}case 4:{l=11;break}case 2:{l=12;break}default:l=13}}if((l|0)==9){k=b+136|0;h=k;c[h>>2]=0;c[h+4>>2]=0;h=i;n=a+304|0;g=c[n>>2]&c[h>>2];h=c[n+4>>2]&c[h+4>>2];if((g|0)==0&(h|0)==0){h=0;g=0}else{i=0;j=0;do{n=Qa(g|0,h|0,0)|0;o=Yu(g|0,h|0,-1,-1)|0;g=o&g;h=D&h;n=34448+(n<<3)|0;i=i|c[n>>2];j=j|c[n+4>>2];n=k;c[n>>2]=i;c[n+4>>2]=j}while(!((g|0)==0&(h|0)==0));h=i;g=j}}else if((l|0)==11)if(!(c[a+392>>2]|0)){g=64;l=14}else l=13;else if((l|0)==12)if(!(c[a+392>>2]|0)){g=64;l=14}else l=13;if((l|0)==13){g=c[a+3984>>2]|0;l=14}if((l|0)==14){g=34448+(g<<3)|0;h=c[g>>2]|0;g=c[g+4>>2]|0;o=b+136|0;c[o>>2]=h;c[o+4>>2]=g}n=e+40|0;l=c[n>>2]|0;n=c[n+4>>2]|0;o=b+96|0;c[o>>2]=l;c[o+4>>2]=n;o=b+160|0;c[o>>2]=l&h;c[o+4>>2]=n&g;o=b+88|0;c[o>>2]=l|h;c[o+4>>2]=n|g;if((m|0)!=1?((m|0)==3?1:(c[(c[a+5356>>2]|0)+16>>2]|0)>2512):0){m=av(h|0,g|0,8)|0;n=b+176|0;c[n>>2]=m|h;c[n+4>>2]=D|g;n=f;m=c[n>>2]&h;n=c[n+4>>2]&g;a=av(m|0,n|0,16)|0;o=av(m|0,n|0,48)|0;c[b+184>>2]=(d[1167548+(a&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+(n&65535)>>0]|0)+(d[1167548+o>>0]|0);c[b+192>>2]=0;c[b+200>>2]=0;return}c[b+184>>2]=0;o=b+176|0;c[o>>2]=0;c[o+4>>2]=0;return}function Dd(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;m=a+320|0;l=c[m>>2]|0;n=a+264|0;h=c[n>>2]|0;f=b+96|0;g=b+24|0;i=b+88|0;k=c[a+5364>>2]|0;j=(k|0)==4;e=(c[g>>2]|~c[i>>2])&~c[f>>2]&(j?-1:l&1010580480&h^1010580480);f=(c[g+4>>2]|~c[i+4>>2])&~c[f+4>>2]&(j?-1:0);l=h&l;m=c[n+4>>2]&c[m+4>>2];n=av(l|0,m|0,8)|0;l=n|l;m=D|m;n=av(l|0,m|0,16)|0;l=n|l;m=D|m;n=av(l|0,m|0,24)|0;l=((j?n:0)|l)&e;m=((j?D:0)|m)&f;n=m|e;h=av(l|0,m|0,16)|0;i=av(l|0,n|0,48)|0;g=d[1167548+(l&65535)>>0]|0;h=d[1167548+(h&65535)>>0]|0;i=h+g+(d[1167548+(n&65535)>>0]|0)+(d[1167548+i>>0]|0)|0;if(j){o=av(e|0,f|0,16)|0;n=av(e|0,f|0,48)|0;e=d[1167548+(e&65535)>>0]|0;o=d[1167548+(o&65535)>>0]|0;i=d[1167548+(f&65535)>>0]|0;n=d[1167548+n>>0]|0;f=av(l|0,m|0,48)|0;f=o+e+i+n+g+h+(d[1167548+(m&65535)>>0]|0)+(d[1167548+f>>0]|0)|0}else f=i>>>0<16?i:16;e=(c[a+336>>2]|0)-(c[(c[b+4>>2]|0)+116>>2]<<1)|0;if((k|0)==8){o=c[a+5356>>2]|0;e=e-(c[o+36>>2]|0)-(c[o+40>>2]|0)|0}if(j){e=S(S(e,f)|0,e)|0;if(!(c[a+360>>2]|0)){o=(e|0)/200|0;return o|0}}else{e=S(S(e,f)|0,e)|0;if((k|0)==5){o=c[260572]|0;m=m&24;n=av(l&402653184|0,m|0,16)|0;o=(S((d[1167548+m>>0]|0)+(d[1167548+(n&6144)>>0]|0)+((d[1167548]|0)<<1)|0,o)|0)+((e|0)/22|0)|0;return o|0}}o=(e|0)/18|0;return o|0}function Ed(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0;l=a+328|0;m=c[l+4>>2]|0;n=a+264|0;i=c[n+4>>2]|0;f=b+32|0;g=b+88|0;h=b+24|0;k=c[a+5364>>2]|0;j=(k|0)==4;e=(c[g>>2]|~c[h>>2])&~c[f>>2]&(j?-1:0);f=(c[g+4>>2]|~c[h+4>>2])&~c[f+4>>2]&(j?-1:m&3947580&i^3947580);l=c[n>>2]&c[l>>2];m=i&m;i=gv(l|0,m|0,8)|0;l=i|l;m=D|m;i=gv(l|0,m|0,16)|0;l=i|l;m=D|m;i=gv(l|0,m|0,24)|0;l=((j?i:0)|l)&e;m=((j?D:0)|m)&f;i=l|f;n=av(i|0,m|0,16)|0;h=av(l|0,m|0,48)|0;g=d[1167548+(m&65535)>>0]|0;h=d[1167548+h>>0]|0;i=(d[1167548+(n&65535)>>0]|0)+(d[1167548+(i&65535)>>0]|0)+g+h|0;if(j){o=av(e|0,f|0,16)|0;n=av(e|0,f|0,48)|0;e=d[1167548+(e&65535)>>0]|0;o=d[1167548+(o&65535)>>0]|0;i=d[1167548+(f&65535)>>0]|0;n=d[1167548+n>>0]|0;f=av(l|0,m|0,16)|0;f=o+e+i+n+(d[1167548+(l&65535)>>0]|0)+(d[1167548+(f&65535)>>0]|0)+g+h|0}else f=i>>>0<16?i:16;e=(c[a+368>>2]|0)-(c[(c[b+4>>2]|0)+116>>2]<<1)|0;if((k|0)==8){o=c[a+5356>>2]|0;e=e-(c[o+36>>2]|0)-(c[o+40>>2]|0)|0}if(j){e=S(S(e,f)|0,e)|0;if(!(c[a+392>>2]|0)){o=(e|0)/200|0;return o|0}}else{e=S(S(e,f)|0,e)|0;if((k|0)==5){o=c[260572]|0;m=m&24;n=av(l&402653184|0,m|0,16)|0;o=(S((d[1167548+m>>0]|0)+(d[1167548+(n&6144)>>0]|0)+((d[1167548]|0)<<1)|0,o)|0)+((e|0)/22|0)|0;return o|0}}o=(e|0)/18|0;return o|0}function Fd(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;switch(c[a+5364>>2]|0){case 4:{if(!(c[a+360>>2]|0))e=0;else e=c[a+1936>>2]&7;if(c[a+392>>2]|0){g=c[a+3984>>2]&7;e=e>>>0<g>>>0?g-e|0:e-g|0}if(!(c[a+360>>2]|0))f=8;else f=c[a+1936>>2]>>3;if(!(c[a+392>>2]|0))g=8;else h=17;break}case 2:{if(!(c[a+360>>2]|0))e=0;else e=c[a+1936>>2]&7;if(c[a+392>>2]|0){g=c[a+3984>>2]&7;e=e>>>0<g>>>0?g-e|0:e-g|0}if(!(c[a+360>>2]|0))f=8;else f=c[a+1936>>2]>>3;if(!(c[a+392>>2]|0))g=8;else h=17;break}case 1:{h=0;return h|0}default:{h=c[a+1936>>2]&7;e=c[a+3984>>2]&7;f=c[a+1936>>2]>>3;e=h>>>0<e>>>0?e-h|0:h-e|0;h=17}}if((h|0)==17)g=c[a+3984>>2]>>3;h=a+264|0;i=c[h>>2]|0;h=c[h+4>>2]|0;h=(((c[a+372>>2]|0)+(c[a+340>>2]|0)|0)*12|0)+-136+(e+b-((f|0)<(g|0)?g-f|0:f-g|0)<<3)+((((i&-252645136|0)!=0|(h&-252645136|0)!=0)&((i&252645135|0)!=0|(h&252645135|0)!=0)&1)<<4)|0;b=0-((d|0)>-1?d:0-d|0)|0;h=S(((d|0)>0&1)-(d>>>31)<<16,(h|0)<(b|0)?b:h)|0;return h|0}function Gd(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;k=(e|0)<1&1;f=c[b+12+(k<<2)>>2]|0;if(!((f|0)!=0?(g=nb[c[(c[f>>2]|0)+12>>2]&63](f,a)|0,(g|0)!=255):0))g=d[b+22+k>>0]|0;i=c[a+5364>>2]|0;if((i|0)==2){a=g;return a|0}a:do switch(g|0){case 48:case 64:{if(((c[a+348>>2]|0)==1?(c[a+380>>2]|0)==1:0)?(f=c[a+3216>>2]^c[a+1168>>2],(f>>>3^f)&1|0):0){b=c[a+5356>>2]|0;if((c[b+16>>2]|0)!=814){a=46;return a|0}if((c[b+20>>2]|0)!=814){a=46;return a|0}a=a+264|0;l=c[a>>2]|0;a=c[a+4>>2]|0;k=Yu(l|0,a|0,-1,-1)|0;a=(k&l|0)!=0|(D&a|0)!=0?31:9;return a|0}if((((e|0)>-1?e:0-e|0)|0)<891?(l=c[a+336+((k<<3|1)<<2)>>2]|0,(l|0)<3):0){f=k^1;switch(i|0){case 4:{b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))b=64;else b=c[a+400+(b<<8)>>2]|0;if(!(c[a+336+((f<<3|6)<<2)>>2]|0)){m=a+320+(k<<3)|0;n=a+264|0;e=109200+(f<<9)+(b<<3)|0;if((c[n>>2]&c[m>>2]&c[e>>2]|0)==0?(c[n+4>>2]&c[m+4>>2]&c[e+4>>2]|0)==0:0)break a}else{h=b;j=23}break}case 2:{b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0)){h=64;j=23}else j=19;break}case 1:{b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0)){h=64;j=23}else j=19;break}default:if((i|0)==7){n=g;return n|0}else{h=c[a+400+((f<<3|6)<<8)>>2]|0;j=23}}if((j|0)==19){h=c[a+400+(b<<8)>>2]|0;j=23}if((j|0)==23?(m=a+320+(k<<3)|0,j=a+264|0,n=110224+(f<<9)+(h<<3)|0,(c[j>>2]&c[m>>2]&c[n>>2]|0)==0?(c[j+4>>2]&c[m+4>>2]&c[n+4>>2]|0)==0:0):0){j=25;break a}n=(l*7|0)+37|0;return n|0}else j=25;break}default:j=25}while(0);if((j|0)==25?(i|0)!=4:0){n=g;return n|0}if((c[(c[a+5356>>2]|0)+16+(((c[a+360>>2]|0)!=0&1)<<2)>>2]|0)>2512)return ((c[a+336+((k<<3|6)<<2)>>2]|0)==0?g:10)|0;else{n=g;return n|0}return 0}function Hd(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0;g=a+5348|0;f=c[g>>2]|0;b=f^1;e=c[a+5364>>2]|0;switch(e|0){case 4:{b=b<<3|6;if(!(c[a+336+(b<<2)>>2]|0)){g=0;return g|0}break}case 2:{b=b<<3|6;if(!(c[a+336+(b<<2)>>2]|0)){g=0;return g|0}break}case 1:{b=b<<3|6;if(!(c[a+336+(b<<2)>>2]|0)){g=0;return g|0}break}default:b=b<<3|6}if((c[a+400+(b<<8)>>2]&-8|0)!=56){g=0;return g|0}switch(e|0){case 4:{b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))d=15;else d=12;break}case 2:{b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))d=16;else d=12;break}case 1:{b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))d=17;else d=12;break}default:{b=f<<3|6;d=12}}a:do if((d|0)==12){if((c[a+400+(b<<8)>>2]>>3|0)<(((f|0)==0?7:6)|0)){g=1;return g|0}switch(e|0){case 4:{d=15;break a}case 2:{d=16;break a}case 1:{d=17;break a}default:{}}b=f<<3|6;d=18}while(0);if((d|0)==15){b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))b=64;else d=18}else if((d|0)==16){b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))b=64;else d=18}else if((d|0)==17){b=f<<3|6;if(!(c[a+336+(b<<2)>>2]|0))b=64;else d=18}if((d|0)==18)b=c[a+400+(b<<8)>>2]|0;h=34448+(b<<3)|0;i=31176;e=a+320+(f<<3)|0;b=a+256|0;d=c[i>>2]&c[h>>2]&~c[e>>2];e=c[i+4>>2]&c[h+4>>2]&~c[e+4>>2];while(1){if((d|0)==0&(e|0)==0){b=1;d=22;break}i=Qa(d|0,e|0,0)|0;f=Yu(d|0,e|0,-1,-1)|0;e=D&e;h=b;h=Pf(a,i,c[h>>2]|0,c[h+4>>2]|0)|0;i=a+320+((c[g>>2]^1)<<3)|0;if((c[i>>2]&h|0)==0?(c[i+4>>2]&D|0)==0:0){b=0;d=22;break}else d=f&d}if((d|0)==22)return b|0;return 0}function Id(e){e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0;Ea=l;l=l+224|0;Q=Ea+208|0;Da=Ea;if(zd(e)|0){Da=Ad(e,0,0)|0;l=Ea;return Da|0}g=oe(e)|0;c[Da>>2]=g;f=c[g+8>>2]|0;if(f|0){Da=nb[c[(c[f>>2]|0)+12>>2]&63](f,e)|0;l=Ea;return Da|0}Aa=e+5356|0;Ca=((b[g+20>>1]|0)*65537|0)+(c[(c[Aa>>2]|0)+44>>2]|0)|0;T=wf(e)|0;Ba=Da+4|0;c[Ba>>2]=T;T=Ca+(c[T+8>>2]|0)|0;Ca=e+5364|0;if((c[Ca>>2]|0)==0?(za=(T+32768>>16)+(T<<16>>16)|0,h=(za|0)/2|0,i=0-h|0,(((za|0)>-2?h:i)|0)>1500):0){Da=(c[e+5348>>2]|0)==0?h:i;l=Ea;return Da|0}Bd(e,Da);Cd(e,Da);ga=Da+40|0;ua=ga;c[ua>>2]=0;c[ua+4>>2]=0;ua=e+320|0;wa=Da+24|0;ca=Da+152|0;Z=Da+176|0;P=Da+8|0;Y=Da+184|0;_=Da+192|0;oa=Da+136|0;$=Da+200|0;xa=e+1936|0;ya=e+360|0;ja=Da+32|0;za=e+264|0;f=c[e+912>>2]|0;a:do if((f|0)==64){g=0;r=0;M=c[260691]|0}else{F=(c[Ba>>2]|0)+56|0;M=c[260691]|0;H=(c[Aa>>2]|0)+344|0;B=ua;A=c[B>>2]|0;B=c[B+4>>2]|0;J=Z;I=c[J>>2]|0;J=c[J+4>>2]|0;w=c[Ca>>2]|0;L=oa;K=c[L>>2]|0;L=c[L+4>>2]|0;p=wa;m=ca;G=A&c[H>>2];H=B&c[H+4>>2];x=(w|0)==1;z=P;y=c[z>>2]|0;z=c[z+4>>2]|0;A=~A;B=~B;E=ja;C=c[E>>2]|0;E=c[E+4>>2]|0;s=0;r=0;q=c[p>>2]|0;p=c[p+4>>2]|0;n=c[m>>2]|0;m=c[m+4>>2]|0;k=0;j=0;i=e+916|0;while(1){if(x){o=f;break}o=32400+(f<<3)|0;h=c[o>>2]|0;o=c[o+4>>2]|0;v=30544+(f<<3)|0;u=c[v>>2]|0;v=c[v+4>>2]|0;if((G&u|0)==0&(H&v|0)==0)t=o;else{switch(w|0){case 4:{if(!(c[ya>>2]|0))g=64;else ka=23;break}case 2:{if(!(c[ya>>2]|0))g=64;else ka=23;break}default:ka=23}if((ka|0)==23){ka=0;g=c[xa>>2]|0}t=72336+(g<<9)+(f<<3)|0;h=c[t>>2]&h;t=c[t+4>>2]&o}n=n|q&h;m=m|p&t;k=h|k;j=t|j;q=q|k;p=p|j;if(!((I&h|0)==0&(J&t|0)==0)){c[Y>>2]=(c[Y>>2]|0)+1;c[_>>2]=(c[_>>2]|0)+78;sa=K&h;ta=L&t;ra=av(sa|0,ta|0,16)|0;va=av(sa|0,ta|0,48)|0;c[$>>2]=(d[1167548+(ra&65535)>>0]|0)+(d[1167548+(sa&65535)>>0]|0)+(d[1167548+(ta&65535)>>0]|0)+(d[1167548+va>>0]|0)+(c[$>>2]|0)}va=wa;c[va>>2]=q;c[va+4>>2]=p;va=ca;c[va>>2]=n;c[va+4>>2]=m;va=ga;c[va>>2]=k;c[va+4>>2]=j;va=y&h;ta=z&t;sa=av(va|0,ta|0,48)|0;sa=a[1167548+sa>>0]|0;ra=a[1167548+(ta&65535)>>0]|0;ta=av(va|0,ta|0,16)|0;r=(c[1037512+(w<<9)+((ra&255)+(sa&255)+(d[1167548+(ta&65535)>>0]|0)+(d[1167548+(va&65535)>>0]|0)<<2)>>2]|0)+r|0;switch(w|0){case 4:{if(!(c[ya>>2]|0))g=s;else ka=30;break}case 2:{if(!(c[ya>>2]|0)){g=64;ka=31}else ka=30;break}default:ka=30}if((ka|0)==30){g=c[xa>>2]|0;ka=31}if((ka|0)==31){ka=0;g=(c[1042636+(c[1019044+(f<<8)+(g<<2)>>2]<<2)>>2]|0)+s|0}s=F;o=c[s>>2]&-16777216^-16777216;s=c[s+4>>2]&65535^65535;if((o&u|0)==0&(s&v|0)==0){o=o&h&A;h=s&t&B;if(!((o|0)==0&(h|0)==0))g=(c[1042120+((((C&o|0)!=0|(E&h|0)!=0)&1)<<2)>>2]|0)+g|0}else g=(c[1042120+((((C&u|0)!=0|(E&v|0)!=0)&1)<<2)>>2]<<1)+g|0;if((f>>3|0)<4){va=za;ta=30544+(f+8<<3)|0;g=g+(((c[ta>>2]&c[va>>2]|0)==0?(c[ta+4>>2]&c[va+4>>2]|0)==0:0)?0:M)|0}f=c[i>>2]|0;if((f|0)==64)break a;else{s=g;i=i+4|0}}while(1){f=32400+(o<<3)|0;g=c[f>>2]|0;f=c[f+4>>2]|0;va=30544+(o<<3)|0;if(!((G&c[va>>2]|0)==0?(H&c[va+4>>2]|0)==0:0)){if(!(c[ya>>2]|0))h=64;else h=c[xa>>2]|0;va=72336+(h<<9)+(o<<3)|0;g=c[va>>2]&g;f=c[va+4>>2]&f}n=n|q&g;m=m|p&f;k=g|k;j=f|j;q=q|k;p=p|j;if(!((I&g|0)==0&(J&f|0)==0)){c[Y>>2]=(c[Y>>2]|0)+1;c[_>>2]=(c[_>>2]|0)+78;sa=K&g;ta=L&f;ra=av(sa|0,ta|0,16)|0;va=av(sa|0,ta|0,48)|0;c[$>>2]=(d[1167548+(ra&65535)>>0]|0)+(d[1167548+(sa&65535)>>0]|0)+(d[1167548+(ta&65535)>>0]|0)+(d[1167548+va>>0]|0)+(c[$>>2]|0)}va=av(g|0,f|0,16)|0;o=av(g|0,f|0,48)|0;r=(c[1038024+((d[1167548+(va&65535)>>0]|0)+(d[1167548+(g&65535)>>0]|0)+(d[1167548+(f&65535)>>0]|0)+(d[1167548+o>>0]|0)<<2)>>2]|0)+r|0;o=c[i>>2]|0;if((o|0)==64)break;else i=i+4|0}g=wa;c[g>>2]=q;c[g+4>>2]=p;g=ca;c[g>>2]=n;c[g+4>>2]=m;g=ga;c[g>>2]=k;c[g+4>>2]=j;g=s}while(0);na=Da+104|0;va=na;c[va>>2]=0;c[va+4>>2]=0;va=e+328|0;ra=Da+88|0;la=Da+160|0;R=Da+168|0;N=Da+16|0;O=Da+188|0;U=Da+196|0;ha=Da+72|0;V=Da+204|0;ta=e+3984|0;sa=e+392|0;ma=Da+96|0;h=c[e+2960>>2]|0;b:do if((h|0)==64){H=0;f=0}else{z=(c[Ba>>2]|0)+48|0;L=(c[Aa>>2]|0)+352|0;F=va;E=c[F>>2]|0;F=c[F+4>>2]|0;H=R;G=c[H>>2]|0;H=c[H+4>>2]|0;y=c[Ca>>2]|0;J=ha;I=c[J>>2]|0;J=c[J+4>>2]|0;s=ra;p=la;K=E&c[L>>2];L=F&c[L+4>>2];A=(y|0)==1;C=N;B=c[C>>2]|0;C=c[C+4>>2]|0;E=~E;F=~F;u=0;f=0;t=c[s>>2]|0;s=c[s+4>>2]|0;q=c[p>>2]|0;p=c[p+4>>2]|0;o=0;n=0;m=e+2964|0;while(1){if(A)break;k=32400+(h<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;x=30544+(h<<3)|0;w=c[x>>2]|0;x=c[x+4>>2]|0;if((K&w|0)==0&(L&x|0)==0)v=k;else{switch(y|0){case 4:{if(!(c[sa>>2]|0))i=64;else ka=54;break}case 2:{if(!(c[sa>>2]|0))i=64;else ka=54;break}default:ka=54}if((ka|0)==54){ka=0;i=c[ta>>2]|0}v=72336+(i<<9)+(h<<3)|0;j=c[v>>2]&j;v=c[v+4>>2]&k}q=q|t&j;p=p|s&v;o=j|o;n=v|n;t=t|o;s=s|n;if(!((G&j|0)==0&(H&v|0)==0)){c[O>>2]=(c[O>>2]|0)+1;c[U>>2]=(c[U>>2]|0)+78;ia=I&j;pa=J&v;da=av(ia|0,pa|0,16)|0;qa=av(ia|0,pa|0,48)|0;c[V>>2]=(d[1167548+(da&65535)>>0]|0)+(d[1167548+(ia&65535)>>0]|0)+(d[1167548+(pa&65535)>>0]|0)+(d[1167548+qa>>0]|0)+(c[V>>2]|0)}qa=ra;c[qa>>2]=t;c[qa+4>>2]=s;qa=la;c[qa>>2]=q;c[qa+4>>2]=p;qa=na;c[qa>>2]=o;c[qa+4>>2]=n;qa=B&j;pa=C&v;ia=av(qa|0,pa|0,48)|0;ia=a[1167548+ia>>0]|0;da=a[1167548+(pa&65535)>>0]|0;pa=av(qa|0,pa|0,16)|0;f=(c[1037512+(y<<9)+((da&255)+(ia&255)+(d[1167548+(pa&65535)>>0]|0)+(d[1167548+(qa&65535)>>0]|0)<<2)>>2]|0)+f|0;switch(y|0){case 4:{if(!(c[sa>>2]|0))i=u;else ka=61;break}case 2:{if(!(c[sa>>2]|0)){i=64;ka=62}else ka=61;break}default:ka=61}if((ka|0)==61){i=c[ta>>2]|0;ka=62}if((ka|0)==62){ka=0;i=(c[1042636+(c[1019044+(h<<8)+(i<<2)>>2]<<2)>>2]|0)+u|0}u=z;k=c[u>>2]&-65536^-65536;u=c[u+4>>2]&255^255;if((k&w|0)==0&(u&x|0)==0){k=k&j&E;j=u&v&F;if(!((k|0)==0&(j|0)==0)){qa=ma;i=(c[1042120+(((c[qa>>2]&k|0?1:(c[qa+4>>2]&j|0)!=0)&1)<<2)>>2]|0)+i|0}}else{qa=ma;i=(c[1042120+(((c[qa>>2]&w|0?1:(c[qa+4>>2]&x|0)!=0)&1)<<2)>>2]<<1)+i|0}if((h>>3^7|0)<4){qa=za;pa=30544+(h+-8<<3)|0;i=(((c[pa>>2]&c[qa>>2]|0)==0?(c[pa+4>>2]&c[qa+4>>2]|0)==0:0)?0:M)+i|0}h=c[m>>2]|0;if((h|0)==64){H=i;break b}else{u=i;m=m+4|0}}while(1){k=32400+(h<<3)|0;i=c[k>>2]|0;k=c[k+4>>2]|0;qa=30544+(h<<3)|0;if((K&c[qa>>2]|0)==0?(L&c[qa+4>>2]|0)==0:0)h=k;else{if(!(c[sa>>2]|0))j=64;else j=c[ta>>2]|0;h=72336+(j<<9)+(h<<3)|0;i=c[h>>2]&i;h=c[h+4>>2]&k}q=q|t&i;p=p|s&h;o=i|o;n=h|n;t=t|o;s=s|n;if(!((G&i|0)==0&(H&h|0)==0)){c[O>>2]=(c[O>>2]|0)+1;c[U>>2]=(c[U>>2]|0)+78;ia=I&i;pa=J&h;da=av(ia|0,pa|0,16)|0;qa=av(ia|0,pa|0,48)|0;c[V>>2]=(d[1167548+(da&65535)>>0]|0)+(d[1167548+(ia&65535)>>0]|0)+(d[1167548+(pa&65535)>>0]|0)+(d[1167548+qa>>0]|0)+(c[V>>2]|0)}pa=av(i|0,h|0,16)|0;qa=av(i|0,h|0,48)|0;f=(c[1038024+((d[1167548+(pa&65535)>>0]|0)+(d[1167548+(i&65535)>>0]|0)+(d[1167548+(h&65535)>>0]|0)+(d[1167548+qa>>0]|0)<<2)>>2]|0)+f|0;h=c[m>>2]|0;if((h|0)==64)break;else m=m+4|0}H=ra;c[H>>2]=t;c[H+4>>2]=s;H=la;c[H>>2]=q;c[H+4>>2]=p;H=na;c[H>>2]=o;c[H+4>>2]=n;H=u}while(0);aa=Da+48|0;pa=aa;c[pa>>2]=0;c[pa+4>>2]=0;pa=e+256|0;qa=e+296|0;F=e+5360|0;h=c[e+1168>>2]|0;c:do if((h|0)==64){G=0;E=c[260692]|0}else{u=c[Ba>>2]|0;v=u+56|0;E=c[260692]|0;w=c[260712]|0;y=pa;C=ua;B=c[C>>2]|0;C=c[C+4>>2]|0;z=qa;A=(c[Aa>>2]|0)+344|0;x=c[z>>2]&B^c[y>>2];y=c[z+4>>2]&C^c[y+4>>2];z=c[A>>2]&B;A=c[A+4>>2]&C;B=~B;C=~C;i=0;j=e+1172|0;k=0;m=0;while(1){t=j;while(1){n=29520+(h<<3)|0;o=30032+(h<<3)|0;o=(S(y&c[n+4>>2],c[o+4>>2]|0)|0)^(S(x&c[n>>2],c[o>>2]|0)|0);o=(c[1035940+(h<<2)>>2]|0)+(o>>>(c[1036196+(h<<2)>>2]|0)<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;s=30544+(h<<3)|0;q=c[s>>2]|0;s=c[s+4>>2]|0;if(!((z&q|0)==0&(A&s|0)==0)){switch(c[Ca>>2]|0){case 4:{if(!(c[ya>>2]|0))j=64;else ka=80;break}case 2:{if(!(c[ya>>2]|0))j=64;else ka=80;break}case 1:{if(!(c[ya>>2]|0))j=64;else ka=80;break}default:ka=80}if((ka|0)==80){ka=0;j=c[xa>>2]|0}ia=72336+(j<<9)+(h<<3)|0;n=c[ia>>2]&n;o=c[ia+4>>2]&o}da=wa;ba=c[da>>2]|0;da=c[da+4>>2]|0;W=ca;X=c[W+4>>2]|da&o;ia=ca;c[ia>>2]=c[W>>2]|ba&n;c[ia+4>>2]=X;k=n|k;m=o|m;ia=aa;c[ia>>2]=k;c[ia+4>>2]=m;ia=wa;c[ia>>2]=ba|k;c[ia+4>>2]=da|m;ia=Z;if(!((c[ia>>2]&n|0)==0?(c[ia+4>>2]&o|0)==0:0)){c[Y>>2]=(c[Y>>2]|0)+1;c[_>>2]=(c[_>>2]|0)+56;da=oa;ba=c[da>>2]&n;da=c[da+4>>2]&o;X=av(ba|0,da|0,16)|0;ia=av(ba|0,da|0,48)|0;c[$>>2]=(d[1167548+(X&65535)>>0]|0)+(d[1167548+(ba&65535)>>0]|0)+(d[1167548+(da&65535)>>0]|0)+(d[1167548+ia>>0]|0)+(c[$>>2]|0)}j=c[Ca>>2]|0;if((j|0)!=1)break;ia=av(n|0,o|0,16)|0;h=av(n|0,o|0,48)|0;r=(c[1038152+((d[1167548+(ia&65535)>>0]|0)+(d[1167548+(n&65535)>>0]|0)+(d[1167548+(o&65535)>>0]|0)+(d[1167548+h>>0]|0)<<2)>>2]|0)+r|0;h=c[t>>2]|0;if((h|0)==64){G=i;break c}else t=t+4|0}da=P;ia=c[da>>2]&n;da=c[da+4>>2]&o;ba=av(ia|0,da|0,48)|0;ba=a[1167548+ba>>0]|0;X=a[1167548+(da&65535)>>0]|0;da=av(ia|0,da|0,16)|0;r=(c[1037512+(j<<9)+128+((X&255)+(ba&255)+(d[1167548+(da&65535)>>0]|0)+(d[1167548+(ia&65535)>>0]|0)<<2)>>2]|0)+r|0;switch(j|0){case 4:{if(c[ya>>2]|0)ka=89;break}case 2:{if(!(c[ya>>2]|0)){j=64;ka=90}else ka=89;break}default:ka=89}if((ka|0)==89){j=c[xa>>2]|0;ka=90}if((ka|0)==90){ka=0;i=(c[1042668+(c[1019044+(h<<8)+(j<<2)>>2]<<2)>>2]|0)+i|0}p=v;j=c[p>>2]&-16777216^-16777216;p=c[p+4>>2]&65535^65535;if((j&q|0)==0&(p&s|0)==0){n=j&n&B;j=p&o&C;if(!((n|0)==0&(j|0)==0)){ia=ja;i=(c[1042128+(((c[ia>>2]&n|0?1:(c[ia+4>>2]&j|0)!=0)&1)<<2)>>2]|0)+i|0}}else{ia=ja;i=(c[1042128+(((c[ia>>2]&q|0?1:(c[ia+4>>2]&s|0)!=0)&1)<<2)>>2]<<1)+i|0}if((h>>3|0)<4){ia=za;da=30544+(h+8<<3)|0;i=i+(((c[da>>2]&c[ia>>2]|0)==0?(c[da+4>>2]&c[ia+4>>2]|0)==0:0)?0:M)|0}i=i-(S(c[u+96+((((q&-1437226411|0)!=0|(s&-1437226411|0)!=0)&1)<<2)>>2]|0,E)|0)|0;d:do if(a[F>>0]|0){switch(h|0){case 7:case 0:break;default:break d}j=(h&7|0)==0?9:7;h=j+h|0;if((c[e+(h<<2)>>2]|0)==1){if(!(c[e+(h+8<<2)>>2]|0))h=(c[e+(h+j<<2)>>2]|0)==1&1;else h=2;i=i-(w<<h)|0}}while(0);h=c[t>>2]|0;if((h|0)==64){G=i;break c}else j=t+4|0}}while(0);ia=Da+112|0;u=ia;c[u>>2]=0;c[u+4>>2]=0;u=c[260712]|0;h=c[e+3216>>2]|0;e:do if((h|0)==64)F=0;else{v=c[Ba>>2]|0;w=v+48|0;y=pa;C=va;B=c[C>>2]|0;C=c[C+4>>2]|0;z=qa;A=(c[Aa>>2]|0)+352|0;x=c[z>>2]&B^c[y>>2];y=c[z+4>>2]&C^c[y+4>>2];z=c[A>>2]&B;A=c[A+4>>2]&C;B=~B;C=~C;i=0;m=e+3220|0;j=0;k=0;while(1){t=j;while(1){n=29520+(h<<3)|0;o=30032+(h<<3)|0;o=(S(y&c[n+4>>2],c[o+4>>2]|0)|0)^(S(x&c[n>>2],c[o>>2]|0)|0);o=(c[1035940+(h<<2)>>2]|0)+(o>>>(c[1036196+(h<<2)>>2]|0)<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;s=30544+(h<<3)|0;q=c[s>>2]|0;s=c[s+4>>2]|0;if(!((z&q|0)==0&(A&s|0)==0)){switch(c[Ca>>2]|0){case 4:{if(!(c[sa>>2]|0))j=64;else ka=112;break}case 2:{if(!(c[sa>>2]|0))j=64;else ka=112;break}case 1:{if(!(c[sa>>2]|0))j=64;else ka=112;break}default:ka=112}if((ka|0)==112){ka=0;j=c[ta>>2]|0}da=72336+(j<<9)+(h<<3)|0;n=c[da>>2]&n;o=c[da+4>>2]&o}ba=ra;X=c[ba>>2]|0;ba=c[ba+4>>2]|0;L=la;W=c[L+4>>2]|ba&o;da=la;c[da>>2]=c[L>>2]|X&n;c[da+4>>2]=W;t=n|t;k=o|k;da=ia;c[da>>2]=t;c[da+4>>2]=k;da=ra;c[da>>2]=X|t;c[da+4>>2]=ba|k;da=R;if(!((c[da>>2]&n|0)==0?(c[da+4>>2]&o|0)==0:0)){c[O>>2]=(c[O>>2]|0)+1;c[U>>2]=(c[U>>2]|0)+56;ba=ha;X=c[ba>>2]&n;ba=c[ba+4>>2]&o;W=av(X|0,ba|0,16)|0;da=av(X|0,ba|0,48)|0;c[V>>2]=(d[1167548+(W&65535)>>0]|0)+(d[1167548+(X&65535)>>0]|0)+(d[1167548+(ba&65535)>>0]|0)+(d[1167548+da>>0]|0)+(c[V>>2]|0)}j=c[Ca>>2]|0;if((j|0)!=1)break;da=av(n|0,o|0,16)|0;h=av(n|0,o|0,48)|0;f=(c[1038152+((d[1167548+(da&65535)>>0]|0)+(d[1167548+(n&65535)>>0]|0)+(d[1167548+(o&65535)>>0]|0)+(d[1167548+h>>0]|0)<<2)>>2]|0)+f|0;h=c[m>>2]|0;if((h|0)==64){F=i;break e}else m=m+4|0}ba=N;da=c[ba>>2]&n;ba=c[ba+4>>2]&o;X=av(da|0,ba|0,48)|0;X=a[1167548+X>>0]|0;W=a[1167548+(ba&65535)>>0]|0;ba=av(da|0,ba|0,16)|0;f=(c[1037512+(j<<9)+128+((W&255)+(X&255)+(d[1167548+(ba&65535)>>0]|0)+(d[1167548+(da&65535)>>0]|0)<<2)>>2]|0)+f|0;switch(j|0){case 4:{if(c[sa>>2]|0)ka=121;break}case 2:{if(!(c[sa>>2]|0)){j=64;ka=122}else ka=121;break}default:ka=121}if((ka|0)==121){j=c[ta>>2]|0;ka=122}if((ka|0)==122){ka=0;i=(c[1042668+(c[1019044+(h<<8)+(j<<2)>>2]<<2)>>2]|0)+i|0}p=w;j=c[p>>2]&-65536^-65536;p=c[p+4>>2]&255^255;if((j&q|0)==0&(p&s|0)==0){n=j&n&B;j=p&o&C;if(!((n|0)==0&(j|0)==0)){da=ma;i=(c[1042128+(((c[da>>2]&n|0?1:(c[da+4>>2]&j|0)!=0)&1)<<2)>>2]|0)+i|0}}else{da=ma;i=(c[1042128+(((c[da>>2]&q|0?1:(c[da+4>>2]&s|0)!=0)&1)<<2)>>2]<<1)+i|0}if((h>>3^7|0)<4){da=za;ba=30544+(h+-8<<3)|0;i=(((c[ba>>2]&c[da>>2]|0)==0?(c[ba+4>>2]&c[da+4>>2]|0)==0:0)?0:M)+i|0}i=i-(S(c[v+104+((((q&-1437226411|0)!=0|(s&-1437226411|0)!=0)&1)<<2)>>2]|0,E)|0)|0;f:do if(a[F>>0]|0){switch(h|0){case 63:case 56:break;default:break f}j=(h&7|0)==0?-7:-9;h=j+h|0;if((c[e+(h<<2)>>2]|0)==9){if(!(c[e+(h+-8<<2)>>2]|0))h=(c[e+(h+j<<2)>>2]|0)==9&1;else h=2;i=i-(u<<h)|0}}while(0);h=c[m>>2]|0;if((h|0)==64){F=i;break e}else{m=m+4|0;j=t}}}while(0);X=Da+56|0;h=X;c[h>>2]=0;c[h+4>>2]=0;h=c[e+1424>>2]|0;if((h|0)==64)E=0;else{i=c[Aa>>2]|0;t=i+24|0;u=c[260693]|0;x=c[Ba>>2]|0;v=x+88|0;w=c[260694]|0;x=x+92|0;z=pa;B=ua;A=c[B>>2]|0;B=c[B+4>>2]|0;p=e+288|0;q=qa;i=i+344|0;y=(c[q>>2]|c[p>>2])&A^c[z>>2];z=(c[q+4>>2]|c[p+4>>2])&B^c[z+4>>2];A=c[i>>2]&A;B=c[i+4>>2]&B;i=0;p=0;q=0;s=e+1428|0;while(1){k=28496+(h<<3)|0;m=29008+(h<<3)|0;m=(S(z&c[k+4>>2],c[m+4>>2]|0)|0)^(S(y&c[k>>2],c[m>>2]|0)|0);m=(c[1035428+(h<<2)>>2]|0)+(m>>>(c[1035684+(h<<2)>>2]|0)<<3)|0;k=c[m>>2]|0;m=c[m+4>>2]|0;da=30544+(h<<3)|0;if(!((A&c[da>>2]|0)==0?(B&c[da+4>>2]|0)==0:0)){switch(c[Ca>>2]|0){case 4:{if(!(c[ya>>2]|0))j=64;else ka=143;break}case 2:{if(!(c[ya>>2]|0))j=64;else ka=143;break}case 1:{if(!(c[ya>>2]|0))j=64;else ka=143;break}default:ka=143}if((ka|0)==143){ka=0;j=c[xa>>2]|0}da=72336+(j<<9)+(h<<3)|0;k=c[da>>2]&k;m=c[da+4>>2]&m}ba=wa;W=c[ba>>2]|0;ba=c[ba+4>>2]|0;L=ca;M=c[L+4>>2]|ba&m;da=ca;c[da>>2]=c[L>>2]|W&k;c[da+4>>2]=M;p=k|p;q=m|q;da=X;c[da>>2]=p;c[da+4>>2]=q;da=wa;c[da>>2]=W|p;c[da+4>>2]=ba|q;da=Z;if(!((c[da>>2]&k|0)==0?(c[da+4>>2]&m|0)==0:0)){c[Y>>2]=(c[Y>>2]|0)+1;c[_>>2]=(c[_>>2]|0)+45;ba=oa;W=c[ba>>2]&k;ba=c[ba+4>>2]&m;M=av(W|0,ba|0,16)|0;da=av(W|0,ba|0,48)|0;c[$>>2]=(d[1167548+(M&65535)>>0]|0)+(d[1167548+(W&65535)>>0]|0)+(d[1167548+(ba&65535)>>0]|0)+(d[1167548+da>>0]|0)+(c[$>>2]|0)}o=P;da=c[o>>2]&k;o=c[o+4>>2]&m;ba=av(da|0,o|0,16)|0;n=av(da|0,o|0,48)|0;n=(d[1167548+(ba&65535)>>0]|0)+(d[1167548+(da&65535)>>0]|0)+(d[1167548+(o&65535)>>0]|0)+(d[1167548+n>>0]|0)|0;o=c[Ca>>2]|0;g:do if((o|0)!=1){r=(c[1037512+(o<<9)+256+(n<<2)>>2]|0)+r|0;switch(o|0){case 4:{if(c[ya>>2]|0)ka=152;break}case 2:{if(!(c[ya>>2]|0)){j=64;ka=153}else ka=152;break}default:ka=152}if((ka|0)==152){j=c[xa>>2]|0;ka=153}if((ka|0)==153){ka=0;i=(c[1042700+(c[1019044+(h<<8)+(j<<2)>>2]<<2)>>2]|0)+i|0}if((h>>3|0)>3){M=va;da=za;ba=114320+(h<<3)|0;W=c[da>>2]&c[M>>2]&c[ba>>2];ba=c[da+4>>2]&c[M+4>>2]&c[ba+4>>2];M=av(W|0,ba|0,16)|0;da=av(W|0,ba|0,48)|0;i=(S((d[1167548+(M&65535)>>0]|0)+(d[1167548+(W&65535)>>0]|0)+(d[1167548+(ba&65535)>>0]|0)+(d[1167548+da>>0]|0)|0,u)|0)+i|0}h=h&7;j=c[v>>2]|0;k=1<<h;if(j&k|0){i=(c[1042136+(((c[x>>2]&k|0)!=0&1)<<2)>>2]|0)+i|0;break}if(n>>>0<4){switch(o|0){case 4:{if(!(c[ya>>2]|0))break g;break}case 2:{if(!(c[ya>>2]|0))break g;break}default:{}}da=c[xa>>2]&7;ba=h>>>0<da>>>0;if(!(da>>>0<4^ba)?((ba?(1<<da)+-1|0:-1<<da+1)&j|0)==0:0){da=w+(S(n,-22)|0)|0;i=i-(S((c[t>>2]&3|0)==0?2:1,da)|0)|0}}}else{ba=av(k|0,m|0,16)|0;da=av(k|0,m|0,48)|0;r=(c[1038280+((d[1167548+(ba&65535)>>0]|0)+(d[1167548+(k&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+da>>0]|0)<<2)>>2]|0)+r|0}while(0);h=c[s>>2]|0;if((h|0)==64){E=i;break}else s=s+4|0}}da=Da+120|0;h=da;c[h>>2]=0;c[h+4>>2]=0;h=c[e+3472>>2]|0;if((h|0)==64){v=0;C=e+288|0}else{C=e+288|0;t=c[260693]|0;u=c[260694]|0;i=c[Aa>>2]|0;v=i+24|0;x=c[Ba>>2]|0;w=x+92|0;x=x+88|0;z=pa;B=va;A=c[B>>2]|0;B=c[B+4>>2]|0;p=C;q=qa;i=i+352|0;y=(c[q>>2]|c[p>>2])&A^c[z>>2];z=(c[q+4>>2]|c[p+4>>2])&B^c[z+4>>2];A=c[i>>2]&A;B=c[i+4>>2]&B;i=0;p=0;q=0;s=e+3476|0;while(1){k=28496+(h<<3)|0;m=29008+(h<<3)|0;m=(S(z&c[k+4>>2],c[m+4>>2]|0)|0)^(S(y&c[k>>2],c[m>>2]|0)|0);m=(c[1035428+(h<<2)>>2]|0)+(m>>>(c[1035684+(h<<2)>>2]|0)<<3)|0;k=c[m>>2]|0;m=c[m+4>>2]|0;ba=30544+(h<<3)|0;if(!((A&c[ba>>2]|0)==0?(B&c[ba+4>>2]|0)==0:0)){switch(c[Ca>>2]|0){case 4:{if(!(c[sa>>2]|0))j=64;else ka=174;break}case 2:{if(!(c[sa>>2]|0))j=64;else ka=174;break}case 1:{if(!(c[sa>>2]|0))j=64;else ka=174;break}default:ka=174}if((ka|0)==174){ka=0;j=c[ta>>2]|0}ba=72336+(j<<9)+(h<<3)|0;k=c[ba>>2]&k;m=c[ba+4>>2]&m}W=ra;M=c[W>>2]|0;W=c[W+4>>2]|0;K=la;L=c[K+4>>2]|W&m;ba=la;c[ba>>2]=c[K>>2]|M&k;c[ba+4>>2]=L;p=k|p;q=m|q;ba=da;c[ba>>2]=p;c[ba+4>>2]=q;ba=ra;c[ba>>2]=M|p;c[ba+4>>2]=W|q;ba=R;if(!((c[ba>>2]&k|0)==0?(c[ba+4>>2]&m|0)==0:0)){c[O>>2]=(c[O>>2]|0)+1;c[U>>2]=(c[U>>2]|0)+45;W=ha;M=c[W>>2]&k;W=c[W+4>>2]&m;L=av(M|0,W|0,16)|0;ba=av(M|0,W|0,48)|0;c[V>>2]=(d[1167548+(L&65535)>>0]|0)+(d[1167548+(M&65535)>>0]|0)+(d[1167548+(W&65535)>>0]|0)+(d[1167548+ba>>0]|0)+(c[V>>2]|0)}o=N;ba=c[o>>2]&k;o=c[o+4>>2]&m;W=av(ba|0,o|0,16)|0;n=av(ba|0,o|0,48)|0;n=(d[1167548+(W&65535)>>0]|0)+(d[1167548+(ba&65535)>>0]|0)+(d[1167548+(o&65535)>>0]|0)+(d[1167548+n>>0]|0)|0;o=c[Ca>>2]|0;h:do if((o|0)!=1){f=(c[1037512+(o<<9)+256+(n<<2)>>2]|0)+f|0;switch(o|0){case 4:{if(c[sa>>2]|0)ka=183;break}case 2:{if(!(c[sa>>2]|0)){j=64;ka=184}else ka=183;break}default:ka=183}if((ka|0)==183){j=c[ta>>2]|0;ka=184}if((ka|0)==184){ka=0;i=(c[1042700+(c[1019044+(h<<8)+(j<<2)>>2]<<2)>>2]|0)+i|0}if((h>>3^7|0)>3){L=ua;ba=za;W=114320+(h<<3)|0;M=c[ba>>2]&c[L>>2]&c[W>>2];W=c[ba+4>>2]&c[L+4>>2]&c[W+4>>2];L=av(M|0,W|0,16)|0;ba=av(M|0,W|0,48)|0;i=(S((d[1167548+(L&65535)>>0]|0)+(d[1167548+(M&65535)>>0]|0)+(d[1167548+(W&65535)>>0]|0)+(d[1167548+ba>>0]|0)|0,t)|0)+i|0}h=h&7;j=c[w>>2]|0;k=1<<h;if(j&k|0){i=(c[1042136+(((c[x>>2]&k|0)!=0&1)<<2)>>2]|0)+i|0;break}if(n>>>0<4){switch(o|0){case 4:{if(!(c[sa>>2]|0))break h;break}case 2:{if(!(c[sa>>2]|0))break h;break}default:{}}ba=c[ta>>2]&7;W=h>>>0<ba>>>0;if(!(ba>>>0<4^W)?((W?(1<<ba)+-1|0:-1<<ba+1)&j|0)==0:0){ba=(S(n,-22)|0)+u|0;i=i-(S((c[v>>2]&12|0)==0?2:1,ba)|0)|0}}}else{W=av(k|0,m|0,16)|0;ba=av(k|0,m|0,48)|0;f=(c[1038280+((d[1167548+(W&65535)>>0]|0)+(d[1167548+(k&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+ba>>0]|0)<<2)>>2]|0)+f|0}while(0);h=c[s>>2]|0;if((h|0)==64){v=i;break}else s=s+4|0}}W=Da+64|0;u=W;c[u>>2]=0;c[u+4>>2]=0;u=e+280|0;i=c[e+1680>>2]|0;i:do if((i|0)==64)t=0;else{h=0;j=e+1684|0;while(1){o=pa;n=c[o>>2]|0;o=c[o+4>>2]|0;q=(c[Aa>>2]|0)+344|0;s=ua;p=c[s>>2]&c[q>>2];q=c[s+4>>2]&c[q+4>>2];s=j;while(1){k=28496+(i<<3)|0;m=29008+(i<<3)|0;m=(S(c[k+4>>2]&o,c[m+4>>2]|0)|0)^(S(c[k>>2]&n,c[m>>2]|0)|0);m=(c[1035428+(i<<2)>>2]|0)+(m>>>(c[1035684+(i<<2)>>2]|0)<<3)|0;k=29520+(i<<3)|0;ba=30032+(i<<3)|0;ba=(S(c[k+4>>2]&o,c[ba+4>>2]|0)|0)^(S(c[k>>2]&n,c[ba>>2]|0)|0);ba=(c[1035940+(i<<2)>>2]|0)+(ba>>>(c[1036196+(i<<2)>>2]|0)<<3)|0;k=c[ba>>2]|c[m>>2];m=c[ba+4>>2]|c[m+4>>2];ba=30544+(i<<3)|0;if((p&c[ba>>2]|0)==0?(q&c[ba+4>>2]|0)==0:0)j=m;else{switch(c[Ca>>2]|0){case 4:{if(!(c[ya>>2]|0))j=64;else ka=205;break}case 2:{if(!(c[ya>>2]|0))j=64;else ka=205;break}case 1:{if(!(c[ya>>2]|0))j=64;else ka=205;break}default:ka=205}if((ka|0)==205){ka=0;j=c[xa>>2]|0}j=72336+(j<<9)+(i<<3)|0;k=c[j>>2]&k;j=c[j+4>>2]&m}M=wa;K=c[M>>2]|0;M=c[M+4>>2]|0;ba=ca;J=c[ba+4>>2]|M&j;L=ca;c[L>>2]=c[ba>>2]|K&k;c[L+4>>2]=J;L=W;J=c[L>>2]|k;L=c[L+4>>2]|j;ba=W;c[ba>>2]=J;c[ba+4>>2]=L;ba=wa;c[ba>>2]=J|K;c[ba+4>>2]=L|M;ba=Z;if(!((c[ba>>2]&k|0)==0?(c[ba+4>>2]&j|0)==0:0)){c[Y>>2]=(c[Y>>2]|0)+1;c[_>>2]=(c[_>>2]|0)+11;M=oa;L=c[M>>2]&k;M=c[M+4>>2]&j;K=av(L|0,M|0,16)|0;ba=av(L|0,M|0,48)|0;c[$>>2]=(d[1167548+(K&65535)>>0]|0)+(d[1167548+(L&65535)>>0]|0)+(d[1167548+(M&65535)>>0]|0)+(d[1167548+ba>>0]|0)+(c[$>>2]|0)}m=c[Ca>>2]|0;if((m|0)!=1)break;ba=av(k|0,j|0,16)|0;i=av(k|0,j|0,48)|0;r=(c[1038408+((d[1167548+(ba&65535)>>0]|0)+(d[1167548+(k&65535)>>0]|0)+(d[1167548+(j&65535)>>0]|0)+(d[1167548+i>>0]|0)<<2)>>2]|0)+r|0;i=c[s>>2]|0;if((i|0)==64){t=h;break i}else s=s+4|0}M=P;ba=c[M>>2]&k;M=c[M+4>>2]&j;L=av(ba|0,M|0,48)|0;L=a[1167548+L>>0]|0;K=a[1167548+(M&65535)>>0]|0;M=av(ba|0,M|0,16)|0;r=(c[1037512+(m<<9)+384+((K&255)+(L&255)+(d[1167548+(M&65535)>>0]|0)+(d[1167548+(ba&65535)>>0]|0)<<2)>>2]|0)+r|0;switch(m|0){case 4:{if(c[ya>>2]|0)ka=214;break}case 2:{if(!(c[ya>>2]|0)){j=64;ka=215}else ka=214;break}default:ka=214}if((ka|0)==214){j=c[xa>>2]|0;ka=215}if((ka|0)==215){ka=0;h=(c[1042732+(c[1019044+(i<<8)+(j<<2)>>2]<<2)>>2]|0)+h|0}ba=va;M=C;L=u;i=Mf(e,(c[L>>2]|c[M>>2])&c[ba>>2],(c[L+4>>2]|c[M+4>>2])&c[ba+4>>2],i,Q)|0;h=h-((i|0)==0&(D|0)==0?0:c[260695]|0)|0;i=c[s>>2]|0;if((i|0)==64){t=h;break i}else j=s+4|0}}while(0);ba=Da+128|0;i=ba;c[i>>2]=0;c[i+4>>2]=0;i=c[e+3728>>2]|0;j:do if((i|0)==64)h=0;else{h=0;j=e+3732|0;while(1){o=pa;n=c[o>>2]|0;o=c[o+4>>2]|0;q=(c[Aa>>2]|0)+352|0;s=va;p=c[s>>2]&c[q>>2];q=c[s+4>>2]&c[q+4>>2];s=j;while(1){k=28496+(i<<3)|0;m=29008+(i<<3)|0;m=(S(c[k+4>>2]&o,c[m+4>>2]|0)|0)^(S(c[k>>2]&n,c[m>>2]|0)|0);m=(c[1035428+(i<<2)>>2]|0)+(m>>>(c[1035684+(i<<2)>>2]|0)<<3)|0;k=29520+(i<<3)|0;P=30032+(i<<3)|0;P=(S(c[k+4>>2]&o,c[P+4>>2]|0)|0)^(S(c[k>>2]&n,c[P>>2]|0)|0);P=(c[1035940+(i<<2)>>2]|0)+(P>>>(c[1036196+(i<<2)>>2]|0)<<3)|0;k=c[P>>2]|c[m>>2];m=c[P+4>>2]|c[m+4>>2];P=30544+(i<<3)|0;if((p&c[P>>2]|0)==0?(q&c[P+4>>2]|0)==0:0)j=m;else{switch(c[Ca>>2]|0){case 4:{if(!(c[sa>>2]|0))j=64;else ka=225;break}case 2:{if(!(c[sa>>2]|0))j=64;else ka=225;break}case 1:{if(!(c[sa>>2]|0))j=64;else ka=225;break}default:ka=225}if((ka|0)==225){ka=0;j=c[ta>>2]|0}j=72336+(j<<9)+(i<<3)|0;k=c[j>>2]&k;j=c[j+4>>2]&m}M=ra;K=c[M>>2]|0;M=c[M+4>>2]|0;P=la;J=c[P+4>>2]|M&j;L=la;c[L>>2]=c[P>>2]|K&k;c[L+4>>2]=J;L=ba;J=c[L>>2]|k;L=c[L+4>>2]|j;P=ba;c[P>>2]=J;c[P+4>>2]=L;P=ra;c[P>>2]=J|K;c[P+4>>2]=L|M;P=R;if(!((c[P>>2]&k|0)==0?(c[P+4>>2]&j|0)==0:0)){c[O>>2]=(c[O>>2]|0)+1;c[U>>2]=(c[U>>2]|0)+11;M=ha;L=c[M>>2]&k;M=c[M+4>>2]&j;K=av(L|0,M|0,16)|0;P=av(L|0,M|0,48)|0;c[V>>2]=(d[1167548+(K&65535)>>0]|0)+(d[1167548+(L&65535)>>0]|0)+(d[1167548+(M&65535)>>0]|0)+(d[1167548+P>>0]|0)+(c[V>>2]|0)}m=c[Ca>>2]|0;if((m|0)!=1)break;P=av(k|0,j|0,16)|0;i=av(k|0,j|0,48)|0;f=(c[1038408+((d[1167548+(P&65535)>>0]|0)+(d[1167548+(k&65535)>>0]|0)+(d[1167548+(j&65535)>>0]|0)+(d[1167548+i>>0]|0)<<2)>>2]|0)+f|0;i=c[s>>2]|0;if((i|0)==64)break j;else s=s+4|0}M=N;P=c[M>>2]&k;M=c[M+4>>2]&j;L=av(P|0,M|0,48)|0;L=a[1167548+L>>0]|0;K=a[1167548+(M&65535)>>0]|0;M=av(P|0,M|0,16)|0;f=(c[1037512+(m<<9)+384+((K&255)+(L&255)+(d[1167548+(M&65535)>>0]|0)+(d[1167548+(P&65535)>>0]|0)<<2)>>2]|0)+f|0;switch(m|0){case 4:{if(c[sa>>2]|0)ka=234;break}case 2:{if(!(c[sa>>2]|0)){j=64;ka=235}else ka=234;break}default:ka=234}if((ka|0)==234){j=c[ta>>2]|0;ka=235}if((ka|0)==235){ka=0;h=(c[1042732+(c[1019044+(i<<8)+(j<<2)>>2]<<2)>>2]|0)+h|0}P=ua;M=C;L=u;i=Mf(e,(c[L>>2]|c[M>>2])&c[P>>2],(c[L+4>>2]|c[M+4>>2])&c[P+4>>2],i,Q)|0;h=h-((i|0)==0&(D|0)==0?0:c[260695]|0)|0;i=c[s>>2]|0;if((i|0)==64)break j;else j=s+4|0}}while(0);n=g+T-H+G-F+E-v+t-h+(r-f)|0;switch(c[Ca>>2]|0){case 1:{ka=330;break}case 7:{f=7;ka=348;break}case 4:{if(!(c[ya>>2]|0)){T=64;ka=241}else ka=240;break}case 2:{if(!(c[ya>>2]|0)){T=64;ka=241}else ka=240;break}default:ka=240}if((ka|0)==240){T=c[xa>>2]|0;ka=241}k:do if((ka|0)==241){f=c[Ba>>2]|0;if((c[f+64>>2]|0)==(T|0)?(c[f+80>>2]|0)==(c[(c[Aa>>2]|0)+24>>2]&3|0):0)k=c[f+72>>2]|0;else{k=tf(f,e,T)|0;c[f+72>>2]=k}f=c[O>>2]|0;do if(!f){o=ra;h=la;i=ja;f=za;V=k;p=c[o+4>>2]|0;o=c[o>>2]|0;m=c[i>>2]|0;k=c[i+4>>2]|0;i=c[h>>2]|0;h=c[h+4>>2]|0;j=c[Ca>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0}else{j=c[Ca>>2]|0;O=(j|0)==2;p=ra;o=c[p>>2]|0;p=c[p+4>>2]|0;Q=ha;P=c[Q>>2]|0;Q=c[Q+4>>2]|0;if(O){N=va;m=c[N>>2]|0;N=c[N+4>>2]|0;q=e+304|0;v=m;w=N;m=(m&~c[q>>2]|o)&P;q=(N&~c[q+4>>2]|p)&Q}else{q=ca;w=va;v=c[w>>2]|0;w=c[w+4>>2]|0;m=P&o&~c[q>>2];q=Q&p&~c[q+4>>2]}h=wa;g=~c[h>>2];h=~c[h+4>>2];z=~v;A=~w;L=o&z&g&c[R>>2];R=p&A&h&c[R+4>>2];J=S(c[U>>2]|0,f)|0;I=(c[V>>2]|0)*101|0;U=av(m|0,q|0,16)|0;K=av(m|0,q|0,48)|0;K=((d[1167548+(U&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+(q&65535)>>0]|0)+(d[1167548+K>>0]|0)|0)*235|0;U=av(L|0,R|0,16)|0;V=av(L|0,R|0,48)|0;M=c[Aa>>2]|0;f=M+344|0;u=ua;t=c[u>>2]|0;u=c[u+4>>2]|0;N=(j|0)==3;f=(((k<<16>>16)*7|0)/-5|0)+-5+I+((J|0)<807?J:807)+K+(((d[1167548+(U&65535)>>0]|0)+(d[1167548+(L&65535)>>0]|0)+(d[1167548+(R&65535)>>0]|0)+(d[1167548+V>>0]|0)+((t&c[f>>2]|0?1:(u&c[f+4>>2]|0)!=0)&1)|0)*134|0)-(0-((N|(c[e+388>>2]|0)!=0)&1^1)&717)|0;if(N){V=c[e+4548>>2]|0;f=((c[e+4540>>2]|0)*28|0)+f+((c[e+4544>>2]|0)*69|0)+(V*75|0)+((c[e+4536>>2]|0)+(c[e+4532>>2]|0)<<7)|0;if(!V){r=0;s=0}else{s=pa;r=m&~c[s>>2];s=q&~c[s+4>>2]}}else{r=0;s=0}R=la;i=c[R>>2]|0;R=c[R+4>>2]|0;m=(i&m|g)&z|(O?P:0);L=(R&q|h)&A|(O?Q:0);K=pa;J=c[K>>2]|0;K=c[K+4>>2]|0;x=28496+(T<<3)|0;y=29008+(T<<3)|0;y=(S(c[x+4>>2]&K,c[y+4>>2]|0)|0)^(S(c[x>>2]&J,c[y>>2]|0)|0);y=(c[1035428+(T<<2)>>2]|0)+(y>>>(c[1035684+(T<<2)>>2]|0)<<3)|0;x=c[y>>2]|0;y=c[y+4>>2]|0;C=29520+(T<<3)|0;E=30032+(T<<3)|0;E=(S(c[C+4>>2]&K,c[E+4>>2]|0)|0)^(S(c[C>>2]&J,c[E>>2]|0)|0);E=(c[1035940+(T<<2)>>2]|0)+(E>>>(c[1036196+(T<<2)>>2]|0)<<3)|0;C=c[E>>2]|0;E=c[E+4>>2]|0;h=ba;h=(((C|x)&m&(c[h>>2]|r)|0)==0?((E|y)&L&(c[h+4>>2]|s)|0)==0:0)?f:f+745|0;H=ca;r=W;q=i&~(c[H>>2]|v)&c[r>>2];r=R&~(c[H+4>>2]|w)&c[r+4>>2];H=(q&o|m)&~t;G=(r&p|L)&~u;q=q|m;r=r|L;L=ja;m=c[L>>2]|0;L=c[L+4>>2]|0;f=za;g=c[f>>2]|0;f=c[f+4>>2]|0;s=gv(g|0,f|0,8)|0;s=~(g&v&s|m);t=~(f&w&D|L);I=(j|0)==8;if(I){v=(c[M+40>>2]|0)==0;F=v?q:z;B=v?r:A;w=v?s:z;v=v?t:A}else{F=q;B=r;w=s;v=t}if(N){t=(c[e+4544>>2]|0)==0;s=t?0:~J;t=t?0:~K}else{s=0;t=0}r=da;q=c[r>>2]|0;r=c[r+4>>2]|0;do if(((q&F|s&H)&x|0)==0?((r&B|t&G)&y|0)==0:0){if((w&x&(q|s)|0)==0?(v&y&(r|t)|0)==0:0)break;k=k-(c[260696]|0)|0}else h=h+688|0;while(0);if(N){t=(c[e+4540>>2]|0)==0;s=t?0:~J;t=t?0:~K}else{s=0;t=0}r=ia;q=c[r>>2]|0;r=c[r+4>>2]|0;do if(((q&F|s&H)&C|0)==0?((r&B|t&G)&E|0)==0:0){if((w&C&(q|s)|0)==0?(v&E&(r|t)|0)==0:0)break;k=k-(c[260696]|0)|0}else h=h+588|0;while(0);if(N){s=(c[e+4536>>2]|0)==0;q=s?0:~J;s=s?0:~K}else{q=0;s=0}V=32400+(T<<3)|0;r=c[V>>2]|0;V=c[V+4>>2]|0;u=na;t=c[u>>2]&r;u=c[u+4>>2]&V;r=r&q;q=V&s;do if((t&F|r&H|0)==0?(u&B|q&G|0)==0:0){if(((t|r)&w|0)==0&((u|q)&v|0)==0)break;k=k-(c[260696]|0)|0}else h=h+924|0;while(0);if(O){P=J&P;U=K&Q;Q=av(P|0,U|0,16)|0;V=av(P|0,U|0,48)|0;k=(S((d[1167548+(Q&65535)>>0]|0)+(d[1167548+(P&65535)>>0]|0)+(d[1167548+(U&65535)>>0]|0)+(d[1167548+V>>0]|0)|0,-6553700)|0)+k|0}if((h|0)<=0){V=k;k=L;h=R;break}l:do if(I)switch(c[M+40>>2]|0){case 2:case 3:case 4:{h=h*3|0;break l}case 1:{h=h<<1;break l}case 0:{h=(h>>>1)+h|0;break l}default:break l}while(0);V=(S(h,h)|0)>>>12;h=c[2972+(j<<2)>>2]|0;V=(h|0)<(V|0)?h:V;V=k-(N|I?V*65537|0:V)|0;k=L;h=R}while(0);T=8+((T&7)<<3)|0;R=c[T>>2]|0;T=c[T+4>>2]|0;U=o&R;Q=p&255&T;P=gv(U|0,Q|0,4)|0;P=i&~m&U|P;Q=h&(k^255)&Q|D;U=c[1042788+(j<<2)>>2]|0;O=av(P|0,Q|0,16)|0;U=S((d[1167548+(O&65535)>>0]|0)+(d[1167548+(P&65535)>>0]|0)+(d[1167548+(Q&65535)>>0]|0)+(d[1167548]|0)|0,U)|0;T=(R&g|0)==0&(T&f|0)==0?0-(c[260706]|0)|0:0;switch(j|0){case 4:{if(!(c[sa>>2]|0))R=64;else ka=286;break}case 2:{if(!(c[sa>>2]|0))R=64;else ka=286;break}case 1:{if(!(c[sa>>2]|0))R=64;else ka=286;break}default:ka=286}if((ka|0)==286)R=c[ta>>2]|0;f=c[Ba>>2]|0;if((c[f+68>>2]|0)==(R|0)?(c[f+84>>2]|0)==(c[(c[Aa>>2]|0)+24>>2]&12|0):0)k=c[f+76>>2]|0;else{k=uf(f,e,R)|0;c[f+76>>2]=k}g=c[Y>>2]|0;do if(!g){p=wa;i=ca;m=ma;g=za;q=c[p>>2]|0;p=c[p+4>>2]|0;o=c[m>>2]|0;m=c[m+4>>2]|0;j=c[i>>2]|0;i=c[i+4>>2]|0;f=c[Ca>>2]|0;h=c[g>>2]|0;g=c[g+4>>2]|0}else{f=c[Ca>>2]|0;N=(f|0)==2;p=wa;q=c[p>>2]|0;p=c[p+4>>2]|0;P=oa;O=c[P>>2]|0;P=c[P+4>>2]|0;if(N){ka=ua;m=c[ka>>2]|0;ka=c[ka+4>>2]|0;o=e+304|0;v=m;w=ka;m=(m&~c[o>>2]|q)&O;o=(ka&~c[o+4>>2]|p)&P}else{o=la;w=ua;v=c[w>>2]|0;w=c[w+4>>2]|0;m=O&q&~c[o>>2];o=P&p&~c[o+4>>2]}i=ra;h=~c[i>>2];i=~c[i+4>>2];z=~v;A=~w;Y=q&z&h&c[Z>>2];Z=p&A&i&c[Z+4>>2];Q=S(c[_>>2]|0,g)|0;K=(c[$>>2]|0)*101|0;$=av(m|0,o|0,16)|0;_=av(m|0,o|0,48)|0;_=((d[1167548+($&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+(o&65535)>>0]|0)+(d[1167548+_>>0]|0)|0)*235|0;$=av(Y|0,Z|0,16)|0;ka=av(Y|0,Z|0,48)|0;L=c[Aa>>2]|0;g=L+352|0;u=va;t=c[u>>2]|0;u=c[u+4>>2]|0;M=(f|0)==3;g=(((k<<16>>16)*7|0)/-5|0)+-5+K+((Q|0)<807?Q:807)+_+(((d[1167548+($&65535)>>0]|0)+(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+ka>>0]|0)+((t&c[g>>2]|0?1:(u&c[g+4>>2]|0)!=0)&1)|0)*134|0)-(0-((M|(c[e+356>>2]|0)!=0)&1^1)&717)|0;do if(M){ka=c[e+4516>>2]|0;g=((c[e+4508>>2]|0)*28|0)+g+((c[e+4512>>2]|0)*69|0)+(ka*75|0)+((c[e+4504>>2]|0)+(c[e+4500>>2]|0)<<7)|0;if(!ka){r=0;s=0;break}s=pa;r=m&~c[s>>2];s=o&~c[s+4>>2]}else{r=0;s=0}while(0);Q=ca;j=c[Q>>2]|0;Q=c[Q+4>>2]|0;h=(j&m|h)&z|(N?O:0);m=(Q&o|i)&A|(N?P:0);K=pa;J=c[K>>2]|0;K=c[K+4>>2]|0;x=28496+(R<<3)|0;y=29008+(R<<3)|0;y=(S(c[x+4>>2]&K,c[y+4>>2]|0)|0)^(S(c[x>>2]&J,c[y>>2]|0)|0);y=(c[1035428+(R<<2)>>2]|0)+(y>>>(c[1035684+(R<<2)>>2]|0)<<3)|0;x=c[y>>2]|0;y=c[y+4>>2]|0;C=29520+(R<<3)|0;E=30032+(R<<3)|0;E=(S(c[C+4>>2]&K,c[E+4>>2]|0)|0)^(S(c[C>>2]&J,c[E>>2]|0)|0);E=(c[1035940+(R<<2)>>2]|0)+(E>>>(c[1036196+(R<<2)>>2]|0)<<3)|0;C=c[E>>2]|0;E=c[E+4>>2]|0;i=W;i=(((C|x)&h&(c[i>>2]|r)|0)==0?((E|y)&m&(c[i+4>>2]|s)|0)==0:0)?g:g+745|0;H=la;s=ba;r=j&~(c[H>>2]|v)&c[s>>2];s=Q&~(c[H+4>>2]|w)&c[s+4>>2];H=(r&q|h)&~t;G=(s&p|m)&~u;r=r|h;s=s|m;m=ma;o=c[m>>2]|0;m=c[m+4>>2]|0;g=za;h=c[g>>2]|0;g=c[g+4>>2]|0;t=av(h|0,g|0,8)|0;t=~(h&v&t|o);u=~(g&w&D|m);I=(f|0)==8;if(I){w=(c[L+36>>2]|0)==0;F=w?r:z;B=w?s:A;z=w?t:z;w=w?u:A}else{F=r;B=s;z=t;w=u}if(M){u=(c[e+4512>>2]|0)==0;t=u?0:~J;u=u?0:~K}else{t=0;u=0}s=X;r=c[s>>2]|0;s=c[s+4>>2]|0;do if(((r&F|t&H)&x|0)==0?((s&B|u&G)&y|0)==0:0){if((z&x&(r|t)|0)==0?(w&y&(s|u)|0)==0:0)break;k=k-(c[260696]|0)|0}else i=i+688|0;while(0);if(M){u=(c[e+4508>>2]|0)==0;t=u?0:~J;u=u?0:~K}else{t=0;u=0}s=aa;r=c[s>>2]|0;s=c[s+4>>2]|0;do if(((r&F|t&H)&C|0)==0?((s&B|u&G)&E|0)==0:0){if((z&C&(r|t)|0)==0?(w&E&(s|u)|0)==0:0)break;k=k-(c[260696]|0)|0}else i=i+588|0;while(0);if(M){t=(c[e+4504>>2]|0)==0;r=t?0:~J;t=t?0:~K}else{r=0;t=0}ka=32400+(R<<3)|0;s=c[ka>>2]|0;ka=c[ka+4>>2]|0;v=ga;u=c[v>>2]&s;v=c[v+4>>2]&ka;s=s&r;r=ka&t;do if((u&F|s&H|0)==0?(v&B|r&G|0)==0:0){if(((u|s)&z|0)==0&((v|r)&w|0)==0)break;k=k-(c[260696]|0)|0}else i=i+924|0;while(0);if(N){_=J&O;$=K&P;Z=av(_|0,$|0,16)|0;ka=av(_|0,$|0,48)|0;k=(S((d[1167548+(Z&65535)>>0]|0)+(d[1167548+(_&65535)>>0]|0)+(d[1167548+($&65535)>>0]|0)+(d[1167548+ka>>0]|0)|0,-6553700)|0)+k|0}if((i|0)<=0){i=Q;break}m:do if(I)switch(c[L+36>>2]|0){case 2:case 3:case 4:{i=i*3|0;break m}case 1:{i=i<<1;break m}case 0:{i=(i>>>1)+i|0;break m}default:break m}while(0);i=(S(i,i)|0)>>>12;ka=c[2972+(f<<2)>>2]|0;i=(ka|0)<(i|0)?ka:i;k=k-(M|I?i*65537|0:i)|0;i=Q}while(0);Y=8+((R&7)<<3)|0;R=c[Y>>2]|0;Y=c[Y+4>>2]|0;ka=q&-16777216&R;_=p&Y;$=av(ka|0,_|0,4)|0;$=j&(o^-16777216)&ka|$;_=i&~m&_|D;ka=c[1042788+(f<<2)>>2]|0;Z=av($|0,_|0,16)|0;$=av($|0,_|0,48)|0;n=V+n+T-U-k+((R&h|0)==0&(Y&g|0)==0?c[260706]|0:0)+(S((d[1167548+(Z&65535)>>0]|0)+(d[1167548]|0)+(d[1167548+(_&65535)>>0]|0)+(d[1167548+$>>0]|0)|0,ka)|0)|0;switch(f|0){case 1:{ka=330;break k}case 2:{j=(c[Ba>>2]|0)+16|0;f=0;i=c[j>>2]|0;j=c[j+4>>2]|0;ka=505;break k}case 6:break;default:{ka=348;break k}}H=wa;J=c[H>>2]|0;H=c[H+4>>2]|0;G=va;I=c[G>>2]|0;G=c[G+4>>2]|0;g=I&J;h=G&H;K=ra;F=c[K>>2]|0;K=c[K+4>>2]|0;C=ua;E=c[C>>2]|0;C=c[C+4>>2]|0;A=(E&F|0)!=0|(C&K|0)!=0;if((g|0)==0&(h|0)==0){h=ga;j=aa;m=X;p=W;q=ha;f=ca;t=0;s=c[q>>2]|0;r=c[p>>2]|0;q=c[q+4>>2]|0;p=c[p+4>>2]|0;o=c[m>>2]|0;m=c[m+4>>2]|0;k=c[j>>2]|0;j=c[j+4>>2]|0;i=c[h>>2]|0;h=c[h+4>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0}else{f=ca;B=c[f>>2]|0;f=c[f+4>>2]|0;x=~B;y=~f;z=A&1;t=((g&F|0)!=0|(h&K|0)!=0)&1;w=1042444+(z<<6)+(t<<5)|0;h=ja;g=c[h>>2]&I;h=c[h+4>>2]&G;do if((g&x|0)==0&(h&y|0)==0){if((g|0)==0&(h|0)==0){g=0;break}g=0-(c[w>>2]|0)|0}else g=0-(c[1042444+(z<<6)+(t<<5)+4>>2]|0)|0;while(0);h=ga;i=c[h>>2]|0;h=c[h+4>>2]|0;j=i&I;k=h&G;do if((j&x|0)==0&(k&y|0)==0){if((j|0)==0&(k|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042444+(z<<6)+(t<<5)+8>>2]|0)|0;while(0);j=aa;k=c[j>>2]|0;j=c[j+4>>2]|0;m=k&I;o=j&G;do if((m&x|0)==0&(o&y|0)==0){if((m|0)==0&(o|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042444+(z<<6)+(t<<5)+12>>2]|0)|0;while(0);m=X;v=c[m>>2]|0;m=c[m+4>>2]|0;o=v&I;p=m&G;do if((o&x|0)==0&(p&y|0)==0){if((o|0)==0&(p|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042444+(z<<6)+(t<<5)+16>>2]|0)|0;while(0);u=W;r=c[u>>2]|0;u=c[u+4>>2]|0;o=r&I;p=u&G;do if((o&x|0)==0&(p&y|0)==0){if((o|0)==0&(p|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042444+(z<<6)+(t<<5)+20>>2]|0)|0;while(0);q=ha;s=c[q>>2]|0;q=c[q+4>>2]|0;o=s&I;p=q&G;do if((o&x|0)==0&(p&y|0)==0){if((o|0)==0&(p|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042444+(z<<6)+(t<<5)+24>>2]|0)|0;while(0);if(!A){L=F;ka=424;break}t=g-(S(c[e+336>>2]|0,c[260608]|0)|0)|0;p=u;o=v;g=B}fa=za;ha=c[fa>>2]&E;fa=c[fa+4>>2]&C;ga=gv(ha|0,fa|0,8)|0;ka=pa;ja=~c[ka>>2];ka=~c[ka+4>>2];fa=gv(ja&16711680&ga|ha|0,fa|0,8)|0;fa=fa&ja;ha=D&ka;ja=(r|s|o|k|i)&ja;ka=(p|q|m|j|h)&ka;ga=c[260609]|0;ca=(fa|ja)&F;ea=(ha|ka)&K;aa=av(ca|0,ea|0,16)|0;L=av(ca|0,ea|0,48)|0;ga=(S((d[1167548+(aa&65535)>>0]|0)+(d[1167548+(ca&65535)>>0]|0)+(d[1167548+(ea&65535)>>0]|0)+(d[1167548+L>>0]|0)|0,ga)|0)+t|0;L=c[260610]|0;ja=(fa&~J|ja&~g)&F;ka=(ha&~H|ka&~f)&K;ha=av(ja|0,ka|0,16)|0;g=av(ja|0,ka|0,48)|0;g=ga+(S((d[1167548+(ha&65535)>>0]|0)+(d[1167548+(ja&65535)>>0]|0)+(d[1167548+(ka&65535)>>0]|0)+(d[1167548+g>>0]|0)|0,L)|0)|0;L=F;ka=424}while(0);n:do if((ka|0)==330){H=wa;J=c[H>>2]|0;H=c[H+4>>2]|0;G=va;I=c[G>>2]|0;G=c[G+4>>2]|0;g=I&J;h=G&H;K=ra;F=c[K>>2]|0;K=c[K+4>>2]|0;C=ua;E=c[C>>2]|0;C=c[C+4>>2]|0;A=(E&F|0)!=0|(C&K|0)!=0;if((g|0)==0&(h|0)==0){h=ga;j=aa;m=X;p=W;q=ha;f=ca;t=0;s=c[q>>2]|0;r=c[p>>2]|0;q=c[q+4>>2]|0;p=c[p+4>>2]|0;o=c[m>>2]|0;m=c[m+4>>2]|0;k=c[j>>2]|0;j=c[j+4>>2]|0;i=c[h>>2]|0;h=c[h+4>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0}else{f=ca;B=c[f>>2]|0;f=c[f+4>>2]|0;x=~B;y=~f;z=A&1;t=((g&F|0)!=0|(h&K|0)!=0)&1;w=1042304+(z<<6)+(t<<5)|0;h=ja;g=c[h>>2]&I;h=c[h+4>>2]&G;if((g&x|0)==0&(h&y|0)==0)if((g|0)==0&(h|0)==0)g=0;else g=0-(c[w>>2]|0)|0;else g=0-(c[1042304+(z<<6)+(t<<5)+4>>2]|0)|0;h=ga;i=c[h>>2]|0;h=c[h+4>>2]|0;j=i&I;k=h&G;if((j&x|0)==0&(k&y|0)==0){if(!((j|0)==0&(k|0)==0))g=g-(c[w>>2]|0)|0}else g=g-(c[1042304+(z<<6)+(t<<5)+8>>2]|0)|0;j=aa;k=c[j>>2]|0;j=c[j+4>>2]|0;m=k&I;o=j&G;if((m&x|0)==0&(o&y|0)==0){if(!((m|0)==0&(o|0)==0))g=g-(c[w>>2]|0)|0}else g=g-(c[1042304+(z<<6)+(t<<5)+12>>2]|0)|0;m=X;v=c[m>>2]|0;m=c[m+4>>2]|0;o=v&I;p=m&G;if((o&x|0)==0&(p&y|0)==0){if(!((o|0)==0&(p|0)==0))g=g-(c[w>>2]|0)|0}else g=g-(c[1042304+(z<<6)+(t<<5)+16>>2]|0)|0;u=W;r=c[u>>2]|0;u=c[u+4>>2]|0;o=r&I;p=u&G;do if((o&x|0)==0&(p&y|0)==0){if((o|0)==0&(p|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042304+(z<<6)+(t<<5)+20>>2]|0)|0;while(0);q=ha;s=c[q>>2]|0;q=c[q+4>>2]|0;o=s&I;p=q&G;do if((o&x|0)==0&(p&y|0)==0){if((o|0)==0&(p|0)==0)break;g=g-(c[w>>2]|0)|0}else g=g-(c[1042304+(z<<6)+(t<<5)+24>>2]|0)|0;while(0);if(!A){L=F;ka=415;break}t=g-(S(c[e+336>>2]|0,c[260573]|0)|0)|0;p=u;o=v;g=B}fa=za;ha=c[fa>>2]&E;fa=c[fa+4>>2]&C;ga=gv(ha|0,fa|0,8)|0;ka=pa;ja=~c[ka>>2];ka=~c[ka+4>>2];fa=gv(ja&16711680&ga|ha|0,fa|0,8)|0;fa=fa&ja;ha=D&ka;ja=(r|s|o|k|i)&ja;ka=(p|q|m|j|h)&ka;ga=c[260574]|0;ca=(fa|ja)&F;ea=(ha|ka)&K;aa=av(ca|0,ea|0,16)|0;L=av(ca|0,ea|0,48)|0;ga=(S((d[1167548+(aa&65535)>>0]|0)+(d[1167548+(ca&65535)>>0]|0)+(d[1167548+(ea&65535)>>0]|0)+(d[1167548+L>>0]|0)|0,ga)|0)+t|0;L=c[260575]|0;ja=(fa&~J|ja&~g)&F;ka=(ha&~H|ka&~f)&K;ha=av(ja|0,ka|0,16)|0;g=av(ja|0,ka|0,48)|0;g=ga+(S((d[1167548+(ha&65535)>>0]|0)+(d[1167548+(ja&65535)>>0]|0)+(d[1167548+(ka&65535)>>0]|0)+(d[1167548+g>>0]|0)|0,L)|0)|0;L=F;ka=415}else if((ka|0)==348){G=va;I=c[G>>2]|0;G=c[G+4>>2]|0;x=za;w=c[x>>2]|0;x=c[x+4>>2]|0;p=I&~w;q=G&~x;g=Da+24|0;v=ja;u=c[v>>2]|0;v=c[v+4>>2]|0;i=p&u;j=q&v;if(!((i|0)==0&(j|0)==0)){h=ua;k=ra;o=g;m=c[o>>2]|0;o=c[o+4>>2]|0;$=c[h>>2]&w&(m|~c[k>>2]);k=c[h+4>>2]&x&(o|~c[k+4>>2]);g=gv($|0,k|0,9)|0;h=D&-16843010;k=gv($|0,k|0,7)|0;k=(g&-16843264|k&2139062016)&i;h=(h|D&2139062143)&j;g=(i|0)==(k|0)&(j|0)==(h|0)?0:c[260707]|0;if((k|0)==0&(h|0)==0)J=m;else{i=k;do{$=Qa(i|0,h|0,0)|0;_=Yu(i|0,h|0,-1,-1)|0;i=_&i;h=D&h;g=(c[1042144+((c[e+($<<2)>>2]&7)<<2)>>2]|0)+g|0}while(!((i|0)==0&(h|0)==0));J=m}}else{o=g;g=0;J=c[o>>2]|0;o=c[o+4>>2]|0}k=Da+88|0;t=ma;s=c[t>>2]|0;t=c[t+4>>2]|0;i=la;z=ca;y=c[z>>2]|0;z=c[z+4>>2]|0;h=c[i>>2]&~y|s;i=c[i+4>>2]&~z|t;m=J&I&~h;r=o&G&~i;h=m|h&p;i=r|i&q;if(!((h|0)==0&(i|0)==0)){ca=aa;j=(c[ca>>2]|c[ga>>2])&h;h=(c[ca+4>>2]|c[ga+4>>2])&i;if(!((j|0)==0&(h|0)==0)){i=c[260708]|0;do{ga=Qa(j|0,h|0,0)|0;ca=Yu(j|0,h|0,-1,-1)|0;j=ca&j;h=D&h;ca=c[e+(ga<<2)>>2]&7;ga=S(ga>>>3^7,i)|0;g=(c[1042176+(ca<<2)>>2]|0)+g+((ca|0)==1?0:ga)|0}while(!((j|0)==0&(h|0)==0))}ga=qa;i=X;h=(c[ga>>2]&I|m)&c[i>>2];i=(c[ga+4>>2]&G|r)&c[i+4>>2];if(!((h|0)==0&(i|0)==0)){j=c[260708]|0;do{ga=Qa(h|0,i|0,0)|0;ca=Yu(h|0,i|0,-1,-1)|0;h=ca&h;i=D&i;ca=c[e+(ga<<2)>>2]&7;ga=S(ga>>>3^7,j)|0;g=(c[1042208+(ca<<2)>>2]|0)+g+((ca|0)==1?0:ga)|0}while(!((h|0)==0&(i|0)==0))}h=c[260709]|0;j=c[k>>2]|0;k=c[k+4>>2]|0;ca=m&~j;ga=r&~k;aa=av(ca|0,ga|0,16)|0;i=av(ca|0,ga|0,48)|0;g=(S((d[1167548+(aa&65535)>>0]|0)+(d[1167548+(ca&65535)>>0]|0)+(d[1167548+(ga&65535)>>0]|0)+(d[1167548+i>>0]|0)|0,h)|0)+g|0;h=ha;i=c[h>>2]&m;h=c[h+4>>2]&r;if((i|0)==0&(h|0)==0){L=j;K=k}else{L=Yu(i|0,h|0,-1,-1)|0;g=(c[1042240+((((L&i|0)!=0|(D&h|0)!=0)&1)<<2)>>2]|0)+g|0;L=j;K=k}}else{K=k;L=c[K>>2]|0;K=c[K+4>>2]|0}C=ua;E=c[C>>2]|0;C=c[C+4>>2]|0;ca=E&w;aa=C&x;$=gv(ca|0,aa|0,8)|0;ga=pa;ha=c[ga>>2]|0;ga=c[ga+4>>2]|0;aa=gv($&16711680&~ha|ca|0,aa&65535|0,8)|0;aa=((ha|s)^-256)&(L^-256|J)&aa;ga=((ga|t)^16777215)&(K^16777215|o)&D;ha=gv(aa|0,ga|0,7)|0;ca=D&2139062143;ga=gv(aa|0,ga|0,9)|0;ga=(u^-65536)&I&(ha&2139029504|ga&-16908288);ca=~v&G&(ca|D&-16843010);ha=c[260710]|0;aa=av(ga|0,ca|0,16)|0;ga=av(ga|0,ca|0,48)|0;g=(S((d[1167548+(aa&65535)>>0]|0)+(d[1167548]|0)+(d[1167548+(ca&65535)>>0]|0)+(d[1167548+ga>>0]|0)|0,ha)|0)+g|0;switch(f|0){case 1:{H=o;ka=415;break n}case 6:{H=o;ka=424;break n}case 8:{g=(c[1042248+(c[(c[Aa>>2]|0)+36>>2]<<2)>>2]|0)+g|0;f=8;break}case 4:{if((c[sa>>2]|0)==0?(ha=e+288|0,fa=qa,ea=c[fa>>2]|0,fa=c[fa+4>>2]|0,!(((ea|c[ha>>2])&E|0)==0?((fa|c[ha+4>>2])&C|0)==0:0)):0){ga=W;ca=X;ha=31120;if(((c[ca>>2]|c[ga>>2])&c[ha>>2]|0)==0?((c[ca+4>>2]|c[ga+4>>2])&c[ha+4>>2]|0)==0:0){m=w&I;k=x&G;h=0;f=8;o:while(1){ha=31056+(h<<3)|0;ga=c[ha>>2]&m;ha=c[ha+4>>2]&k;ca=av(ga|0,ha|0,16)|0;j=av(ga|0,ha|0,48)|0;j=(d[1167548+(ca&65535)>>0]|0)+(d[1167548+(ga&65535)>>0]|0)+(d[1167548+(ha&65535)>>0]|0)+(d[1167548+j>>0]|0)|0;do if((h|0)>0){ha=31056+(h+-1<<3)|0;ga=c[ha>>2]&m;ha=c[ha+4>>2]&k;ca=av(ga|0,ha|0,16)|0;i=av(ga|0,ha|0,48)|0;i=(d[1167548+(ca&65535)>>0]|0)+(d[1167548+(ga&65535)>>0]|0)+(d[1167548+(ha&65535)>>0]|0)+(d[1167548+i>>0]|0)|0;i=j>>>0<i>>>0?j:i;if((h|0)<7)break;h=h+1|0;f=(i|0)<(f|0)?i:f;if((h|0)==8)break o;else continue o}else i=0;while(0);ga=h+1|0;ca=31056+(ga<<3)|0;aa=c[ca>>2]&m;ca=c[ca+4>>2]&k;$=av(aa|0,ca|0,16)|0;ha=av(aa|0,ca|0,48)|0;ha=(d[1167548+($&65535)>>0]|0)+(d[1167548+(aa&65535)>>0]|0)+(d[1167548+(ca&65535)>>0]|0)+(d[1167548+ha>>0]|0)|0;ha=(j>>>0<ha>>>0?j:ha)+i|0;h=ga;f=(ha|0)<(f|0)?ha:f}f=f+1|0}else f=1;ha=S(c[e+372>>2]|0,c[260707]|0)|0;ha=(((ha+32768>>16|0)/(f|0)|0)<<16)+((ha<<16>>16|0)/(f|0)|0)|0;f=(ea&E|0)!=0|(fa&C|0)!=0?2:4;g=((ha<<16>>16|0)/(f|0)|0)+g+(((ha+32768>>16|0)/(f|0)|0)<<16)|0;f=4}else f=4;break}case 2:{j=(c[Ba>>2]|0)+16|0;f=0;i=c[j>>2]|0;j=c[j+4>>2]|0;n=g+n|0;ka=505;break n}default:{}}x=za;w=c[x>>2]|0;x=c[x+4>>2]|0;m=E&~w;p=C&~x;v=ma;u=c[v>>2]|0;v=c[v+4>>2]|0;h=m&u;i=p&v;if(!((h|0)==0&(i|0)==0)){ha=I&w&(L|~J);j=G&x&(K|~o);ma=av(ha|0,j|0,9)|0;k=D&8355711;j=av(ha|0,j|0,7)|0;j=(ma&2139062143|j&-16843010)&h;k=(k|D&16711422)&i;h=(h|0)==(j|0)&(i|0)==(k|0)?0:c[260707]|0;if(!((j|0)==0&(k|0)==0)){i=k;do{ma=Qa(j|0,i|0,0)|0;ha=Yu(j|0,i|0,-1,-1)|0;j=ha&j;i=D&i;h=(c[1042144+((c[e+(ma<<2)>>2]&7)<<2)>>2]|0)+h|0}while(!((j|0)==0&(i|0)==0))}}else h=0;t=ja;s=c[t>>2]|0;t=c[t+4>>2]|0;j=la;i=y&~c[j>>2]|s;j=z&~c[j+4>>2]|t;q=L&E&~i;r=K&C&~j;i=q|i&m;j=r|j&p;if(!((i|0)==0&(j|0)==0)){ma=ia;k=(c[ma>>2]|c[na>>2])&i;i=(c[ma+4>>2]|c[na+4>>2])&j;if(!((k|0)==0&(i|0)==0)){j=c[260708]|0;do{na=Qa(k|0,i|0,0)|0;ma=Yu(k|0,i|0,-1,-1)|0;k=ma&k;i=D&i;ma=c[e+(na<<2)>>2]&7;na=S(na>>>3,j)|0;h=(c[1042176+(ma<<2)>>2]|0)+h+((ma|0)==1?0:na)|0}while(!((k|0)==0&(i|0)==0))}na=qa;j=da;i=(c[na>>2]&E|q)&c[j>>2];j=(c[na+4>>2]&C|r)&c[j+4>>2];if(!((i|0)==0&(j|0)==0)){k=c[260708]|0;do{na=Qa(i|0,j|0,0)|0;ma=Yu(i|0,j|0,-1,-1)|0;i=ma&i;j=D&j;ma=c[e+(na<<2)>>2]&7;na=S(na>>>3,k)|0;h=(c[1042208+(ma<<2)>>2]|0)+h+((ma|0)==1?0:na)|0}while(!((i|0)==0&(j|0)==0))}i=c[260709]|0;ma=q&~J;na=r&~o;la=av(ma|0,na|0,16)|0;j=av(ma|0,na|0,48)|0;h=(S((d[1167548+(la&65535)>>0]|0)+(d[1167548+(ma&65535)>>0]|0)+(d[1167548+(na&65535)>>0]|0)+(d[1167548+j>>0]|0)|0,i)|0)+h|0;i=oa;j=c[i>>2]&q;i=c[i+4>>2]&r;if(!((j|0)==0&(i|0)==0)){oa=Yu(j|0,i|0,-1,-1)|0;h=(c[1042240+((((oa&j|0)!=0|(D&i|0)!=0)&1)<<2)>>2]|0)+h|0}}na=I&w;la=G&x;av(na|0,la|0,8)|0;ma=pa;oa=c[ma>>2]|0;ma=c[ma+4>>2]|0;la=av(na&-65536|0,D&65280&~ma|la|0,8)|0;la=((oa|s)^-256)&(J^-256|L)&la;ma=((ma|t)^16777215)&(o^16777215|K)&D;oa=av(la|0,ma|0,7)|0;na=D&65278;ma=av(la|0,ma|0,9)|0;ma=~u&E&(oa&-16843010|ma&2139062143);na=(v^65535)&C&(na|D&32639);oa=c[260710]|0;la=av(ma|0,na|0,16)|0;h=(S((d[1167548+(la&65535)>>0]|0)+(d[1167548+(ma&65535)>>0]|0)+(d[1167548+na>>0]|0)+(d[1167548]|0)|0,oa)|0)+h|0;switch(f|0){case 8:{h=(c[1042248+(c[(c[Aa>>2]|0)+40>>2]<<2)>>2]|0)+h|0;f=8;ka=497;break n}case 4:{ka=447;break}default:{}}if((ka|0)==447){if(c[ya>>2]|0){f=4;ka=497;break}oa=e+288|0;r=qa;q=c[r>>2]|0;r=c[r+4>>2]|0;if(((q|c[oa>>2])&I|0)==0?((r|c[oa+4>>2])&G|0)==0:0){f=4;ka=497;break}na=ba;ma=da;oa=31120;if(((c[ma>>2]|c[na>>2])&c[oa>>2]|0)==0?((c[ma+4>>2]|c[na+4>>2])&c[oa+4>>2]|0)==0:0){p=w&E;o=x&C;j=0;i=8;p:while(1){oa=31056+(j<<3)|0;na=c[oa>>2]&p;oa=c[oa+4>>2]&o;ma=av(na|0,oa|0,16)|0;m=av(na|0,oa|0,48)|0;m=(d[1167548+(ma&65535)>>0]|0)+(d[1167548+(na&65535)>>0]|0)+(d[1167548+(oa&65535)>>0]|0)+(d[1167548+m>>0]|0)|0;do if((j|0)>0){oa=31056+(j+-1<<3)|0;na=c[oa>>2]&p;oa=c[oa+4>>2]&o;ma=av(na|0,oa|0,16)|0;k=av(na|0,oa|0,48)|0;k=(d[1167548+(ma&65535)>>0]|0)+(d[1167548+(na&65535)>>0]|0)+(d[1167548+(oa&65535)>>0]|0)+(d[1167548+k>>0]|0)|0;k=m>>>0<k>>>0?m:k;if((j|0)<7)break;j=j+1|0;i=(k|0)<(i|0)?k:i;if((j|0)==8)break p;else continue p}else k=0;while(0);na=j+1|0;ma=31056+(na<<3)|0;la=c[ma>>2]&p;ma=c[ma+4>>2]&o;ka=av(la|0,ma|0,16)|0;oa=av(la|0,ma|0,48)|0;oa=(d[1167548+(ka&65535)>>0]|0)+(d[1167548+(la&65535)>>0]|0)+(d[1167548+(ma&65535)>>0]|0)+(d[1167548+oa>>0]|0)|0;oa=(m>>>0<oa>>>0?m:oa)+k|0;j=na;i=(oa|0)<(i|0)?oa:i}i=i+1|0}else i=1;na=S(c[e+340>>2]|0,c[260707]|0)|0;na=(((na+32768>>16|0)/(i|0)|0)<<16)+((na<<16>>16|0)/(i|0)|0)|0;oa=(q&I|0)!=0|(r&G|0)!=0?2:4;h=((na<<16>>16|0)/(oa|0)|0)+h+(((na+32768>>16|0)/(oa|0)|0)<<16)|0}n=g-h+n|0;if((f|0)==7){k=c[xa>>2]|0;m=k>>3;f=m^7;h=m+1|0;if((h|0)<8){j=~(E|L);i=~(C|K);g=m;while(1){za=31120+(h<<3)|0;g=105104+(k<<6)+(g-m<<3)|0;f=(((c[za>>2]&j&c[g>>2]|0)==0?(c[za+4>>2]&i&c[g+4>>2]|0)==0:0)&1)+f|0;g=h+1|0;if((g|0)==8)break;else{za=h;h=g;g=za}}}o=c[1042572+(((f|0)>7?7:f)<<2)>>2]|0;ka=540}else ka=503}while(0);do if((ka|0)==415){h=E&L;i=C&K;B=(I&J|0)!=0|(G&H|0)!=0;if((h|0)==0&(i|0)==0){i=na;k=ia;o=da;q=ba;r=oa;f=la;u=0;t=c[r>>2]|0;s=c[q>>2]|0;r=c[r+4>>2]|0;q=c[q+4>>2]|0;p=c[o>>2]|0;o=c[o+4>>2]|0;m=c[k>>2]|0;k=c[k+4>>2]|0;j=c[i>>2]|0;i=c[i+4>>2]|0;h=c[f>>2]|0;f=c[f+4>>2]|0}else{f=la;F=c[f>>2]|0;f=c[f+4>>2]|0;y=~F;z=~f;A=B&1;u=((h&J|0)!=0|(i&H|0)!=0)&1;x=1042304+(A<<6)+(u<<5)|0;i=ma;h=c[i>>2]&E;i=c[i+4>>2]&C;if((h&y|0)==0&(i&z|0)==0)if((h|0)==0&(i|0)==0)h=0;else h=0-(c[x>>2]|0)|0;else h=0-(c[1042304+(A<<6)+(u<<5)+4>>2]|0)|0;i=na;j=c[i>>2]|0;i=c[i+4>>2]|0;k=j&E;m=i&C;if((k&y|0)==0&(m&z|0)==0){if(!((k|0)==0&(m|0)==0))h=h-(c[x>>2]|0)|0}else h=h-(c[1042304+(A<<6)+(u<<5)+8>>2]|0)|0;k=ia;m=c[k>>2]|0;k=c[k+4>>2]|0;o=m&E;p=k&C;if((o&y|0)==0&(p&z|0)==0){if(!((o|0)==0&(p|0)==0))h=h-(c[x>>2]|0)|0}else h=h-(c[1042304+(A<<6)+(u<<5)+12>>2]|0)|0;o=da;p=c[o>>2]|0;o=c[o+4>>2]|0;q=p&E;r=o&C;if((q&y|0)==0&(r&z|0)==0){if(!((q|0)==0&(r|0)==0))h=h-(c[x>>2]|0)|0}else h=h-(c[1042304+(A<<6)+(u<<5)+16>>2]|0)|0;q=ba;w=c[q>>2]|0;q=c[q+4>>2]|0;r=w&E;s=q&C;do if((r&y|0)==0&(s&z|0)==0){if((r|0)==0&(s|0)==0)break;h=h-(c[x>>2]|0)|0}else h=h-(c[1042304+(A<<6)+(u<<5)+20>>2]|0)|0;while(0);v=oa;t=c[v>>2]|0;v=c[v+4>>2]|0;s=t&E;r=v&C;do if((s&y|0)==0&(r&z|0)==0){if((s|0)==0&(r|0)==0)break;h=h-(c[x>>2]|0)|0}else h=h-(c[1042304+(A<<6)+(u<<5)+24>>2]|0)|0;while(0);if(!B){f=1;ka=497;break}u=h-(S(c[e+368>>2]|0,c[260573]|0)|0)|0;s=w;r=v;h=F}ja=za;la=c[ja>>2]&I;ja=c[ja+4>>2]&G;av(la|0,ja|0,8)|0;na=pa;oa=~c[na>>2];na=~c[na+4>>2];ja=av(la|0,na&65280&D|ja|0,8)|0;ja=ja&oa;la=D&na;oa=(s|t|p|m|j)&oa;na=(q|r|o|k|i)&na;ma=c[260574]|0;ha=(ja|oa)&J;ia=(la|na)&H;ga=av(ha|0,ia|0,16)|0;ka=av(ha|0,ia|0,48)|0;ma=(S((d[1167548+(ga&65535)>>0]|0)+(d[1167548+(ha&65535)>>0]|0)+(d[1167548+(ia&65535)>>0]|0)+(d[1167548+ka>>0]|0)|0,ma)|0)+u|0;ka=c[260575]|0;oa=(ja&~L|oa&~h)&J;f=(la&~K|na&~f)&H;na=av(oa|0,f|0,16)|0;h=av(oa|0,f|0,48)|0;h=ma+(S((d[1167548+(na&65535)>>0]|0)+(d[1167548+(oa&65535)>>0]|0)+(d[1167548+(f&65535)>>0]|0)+(d[1167548+h>>0]|0)|0,ka)|0)|0;f=1;ka=497}else if((ka|0)==424){h=E&L;i=C&K;B=(I&J|0)!=0|(G&H|0)!=0;if((h|0)==0&(i|0)==0){i=na;k=ia;o=da;q=ba;r=oa;f=la;u=0;t=c[r>>2]|0;s=c[q>>2]|0;r=c[r+4>>2]|0;q=c[q+4>>2]|0;p=c[o>>2]|0;o=c[o+4>>2]|0;m=c[k>>2]|0;k=c[k+4>>2]|0;j=c[i>>2]|0;i=c[i+4>>2]|0;h=c[f>>2]|0;f=c[f+4>>2]|0}else{f=la;F=c[f>>2]|0;f=c[f+4>>2]|0;y=~F;z=~f;A=B&1;u=((h&J|0)!=0|(i&H|0)!=0)&1;x=1042444+(A<<6)+(u<<5)|0;i=ma;h=c[i>>2]&E;i=c[i+4>>2]&C;if((h&y|0)==0&(i&z|0)==0)if((h|0)==0&(i|0)==0)h=0;else h=0-(c[x>>2]|0)|0;else h=0-(c[1042444+(A<<6)+(u<<5)+4>>2]|0)|0;i=na;j=c[i>>2]|0;i=c[i+4>>2]|0;k=j&E;m=i&C;if((k&y|0)==0&(m&z|0)==0){if(!((k|0)==0&(m|0)==0))h=h-(c[x>>2]|0)|0}else h=h-(c[1042444+(A<<6)+(u<<5)+8>>2]|0)|0;k=ia;m=c[k>>2]|0;k=c[k+4>>2]|0;o=m&E;p=k&C;if((o&y|0)==0&(p&z|0)==0){if(!((o|0)==0&(p|0)==0))h=h-(c[x>>2]|0)|0}else h=h-(c[1042444+(A<<6)+(u<<5)+12>>2]|0)|0;o=da;p=c[o>>2]|0;o=c[o+4>>2]|0;q=p&E;r=o&C;if((q&y|0)==0&(r&z|0)==0){if(!((q|0)==0&(r|0)==0))h=h-(c[x>>2]|0)|0}else h=h-(c[1042444+(A<<6)+(u<<5)+16>>2]|0)|0;q=ba;w=c[q>>2]|0;q=c[q+4>>2]|0;r=w&E;s=q&C;do if((r&y|0)==0&(s&z|0)==0){if((r|0)==0&(s|0)==0)break;h=h-(c[x>>2]|0)|0}else h=h-(c[1042444+(A<<6)+(u<<5)+20>>2]|0)|0;while(0);v=oa;t=c[v>>2]|0;v=c[v+4>>2]|0;s=t&E;r=v&C;do if((s&y|0)==0&(r&z|0)==0){if((s|0)==0&(r|0)==0)break;h=h-(c[x>>2]|0)|0}else h=h-(c[1042444+(A<<6)+(u<<5)+24>>2]|0)|0;while(0);if(!B){f=6;ka=497;break}u=h-(S(c[e+368>>2]|0,c[260608]|0)|0)|0;s=w;r=v;h=F}ja=za;la=c[ja>>2]&I;ja=c[ja+4>>2]&G;av(la|0,ja|0,8)|0;na=pa;oa=~c[na>>2];na=~c[na+4>>2];ja=av(la|0,na&65280&D|ja|0,8)|0;ja=ja&oa;la=D&na;oa=(s|t|p|m|j)&oa;na=(q|r|o|k|i)&na;ma=c[260609]|0;ha=(ja|oa)&J;ia=(la|na)&H;ga=av(ha|0,ia|0,16)|0;ka=av(ha|0,ia|0,48)|0;ma=(S((d[1167548+(ga&65535)>>0]|0)+(d[1167548+(ha&65535)>>0]|0)+(d[1167548+(ia&65535)>>0]|0)+(d[1167548+ka>>0]|0)|0,ma)|0)+u|0;ka=c[260610]|0;oa=(ja&~L|oa&~h)&J;f=(la&~K|na&~f)&H;na=av(oa|0,f|0,16)|0;h=av(oa|0,f|0,48)|0;h=ma+(S((d[1167548+(na&65535)>>0]|0)+(d[1167548+(oa&65535)>>0]|0)+(d[1167548+(f&65535)>>0]|0)+(d[1167548+h>>0]|0)|0,ka)|0)|0;f=6;ka=497}while(0);if((ka|0)==497){n=g-h+n|0;ka=503}if((ka|0)==503){j=(c[Ba>>2]|0)+16|0;i=c[j>>2]|0;j=c[j+4>>2]|0;if((f|0)==5){h=c[xa>>2]|0;g=0;f=0;do{ma=c[3008+(g<<2)>>2]|0;ga=c[1019044+(h<<8)+(ma<<2)>>2]|0;ha=pa;ha=Pf(e,ma,c[ha>>2]|0,c[ha+4>>2]|0)|0;ja=va;ha=c[ja>>2]&ha;ja=c[ja+4>>2]&D;ia=av(ha|0,ja|0,16)|0;ka=av(ha|0,ja|0,48)|0;ha=d[1167548+(ha&65535)>>0]|0;ia=d[1167548+(ia&65535)>>0]|0;ja=d[1167548+(ja&65535)>>0]|0;ka=d[1167548+ka>>0]|0;na=ua;ma=30544+(ma<<3)|0;la=c[ma>>2]&c[na>>2];na=c[ma+4>>2]&c[na+4>>2];ma=av(la|0,na|0,16)|0;oa=av(la|0,na|0,48)|0;oa=ga+-1+ha+ia+ja+ka+(d[1167548+(la&65535)>>0]|0)+(d[1167548+(ma&65535)>>0]|0)+(d[1167548+(na&65535)>>0]|0)+(d[1167548+oa>>0]|0)|0;f=(c[1042264+(((oa|0)>5?5:oa)<<2)>>2]|0)+f|0;g=g+1|0}while((g|0)!=4);ka=505}else{f=0;ka=505}}if((ka|0)==505){q:do if((i|0)==0&(j|0)==0){o=f;f=c[Ca>>2]|0}else{z=ra;x=va;w=c[x>>2]|0;x=c[x+4>>2]|0;y=w|c[z>>2];z=x|c[z+4>>2];A=c[260711]|0;G=c[Ca>>2]|0;B=e+288|0;E=wa;C=c[E>>2]|0;E=c[E+4>>2]|0;F=(G|0)==4;while(1){u=Qa(i|0,j|0,0)|0;r=Yu(i|0,j|0,-1,-1)|0;i=r&i;j=D&j;r=109200+(u<<3)|0;q=c[r>>2]|0;r=c[r+4>>2]|0;o=q&y;m=r&z;s=av(o|0,m|0,16)|0;v=av(o|0,m|0,48)|0;v=S((d[1167548+(s&65535)>>0]|0)+(d[1167548+(o&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+v>>0]|0)|0,A)|0;m=u>>>3;o=m+-1|0;s=S(o,m+-2|0)|0;h=c[3024+(G<<6)+(o<<2)>>2]|0;g=c[3024+(G<<6)+32+(o<<2)>>2]|0;t=u+8|0;do if(s){r:do switch(G|0){case 4:{if(c[ya>>2]|0){g=(S(25-(c[1019044+(c[xa>>2]<<8)+(t<<2)>>2]<<1)|0,s)|0)+g|0;break r}if(!(c[sa>>2]|0))k=64;else k=c[ta>>2]|0;g=(S(((c[1019044+(k<<8)+(t<<2)>>2]|0)*5|0)+-10|0,s)|0)+g|0;break}case 1:break;case 2:{if(!(c[sa>>2]|0))k=S(s*5|0,c[1035428+(t<<2)>>2]|0)|0;else k=S(s*5|0,c[1019044+(c[ta>>2]<<8)+(t<<2)>>2]|0)|0;g=k+g|0;break}default:{oa=S(s*5|0,c[1019044+(c[ta>>2]<<8)+(t<<2)>>2]|0)|0;k=c[xa>>2]|0;g=oa-(S(s<<1,c[1019044+(k<<8)+(t<<2)>>2]|0)|0)+g|0;if((t&248|0)!=56){if(F?(c[ya>>2]|0)==0:0)k=64;g=g-(S(c[1019044+(k<<8)+(u+16<<2)>>2]|0,s)|0)|0}}}while(0);if(c[e+(t<<2)>>2]|0){na=ua;ma=30544+(t<<3)|0;oa=S(o,m)|0;oa=((c[ma>>2]&c[na>>2]|0)==0?(c[ma+4>>2]&c[na+4>>2]|0)==0:0)?0:oa;h=oa+h|0;g=oa+g|0;break}p=109712+(u<<3)|0;o=B;oa=qa;k=pa;na=28496+(u<<3)|0;m=29008+(u<<3)|0;m=(S(c[na+4>>2]&c[k+4>>2],c[m+4>>2]|0)|0)^(S(c[na>>2]&c[k>>2],c[m>>2]|0)|0);m=(c[1035428+(u<<2)>>2]|0)+(m>>>(c[1035684+(u<<2)>>2]|0)<<3)|0;k=(c[oa>>2]|c[o>>2])&c[p>>2]&c[m>>2];m=(c[oa+4>>2]|c[o+4>>2])&c[p+4>>2]&c[m+4>>2];p=ua;p=(c[p>>2]&k|0)==0?(c[p+4>>2]&m|0)==0:0;o=(p?C:-1)&q;p=(p?E:-1)&r;m=(k&w|0)==0&(m&x|0)==0;k=(m?y:-1)&q;m=(m?z:-1)&r;if((k|0)==0&(m|0)==0)k=18;else{oa=30544+(t<<3)|0;k=((c[oa>>2]&k|0)==0?(c[oa+4>>2]&m|0)==0:0)?8:0}if((o|0)==(q|0)&(p|0)==(r|0))k=k+6|0;else{oa=30544+(t<<3)|0;k=((c[oa>>2]&o|0)==0?(c[oa+4>>2]&p|0)==0:0)?k:k|4}oa=S(k,s)|0;h=oa+h|0;g=oa+g|0}while(0);switch(G|0){case 7:break;case 4:{if(!(c[ya>>2]|0)){na=za;oa=109200+(t<<3)|0;if(!((c[na>>2]&w&c[oa>>2]|0)==0?(c[na+4>>2]&x&c[oa+4>>2]|0)==0:0))ka=537}else ka=536;break}default:ka=536}if((ka|0)==536){ka=0;na=za;oa=110224+(t<<3)|0;if(!((c[na>>2]&w&c[oa>>2]|0)==0?(c[na+4>>2]&x&c[oa+4>>2]|0)==0:0))ka=537}if((ka|0)==537){ka=0;h=(h|0)/2|0;g=(g|0)/2|0}f=f-v+h+(g<<16)+(c[1042604+((u&7)<<2)>>2]|0)|0;if((i|0)==0&(j|0)==0){o=f;f=G;break q}}}while(0);if((f|0)!=7){j=(c[Ba>>2]|0)+24|0;i=c[j>>2]|0;j=c[j+4>>2]|0;if((f|0)==5){h=c[ta>>2]|0;g=0;f=0;do{ma=c[3008+(g<<2)>>2]|0;fa=c[1019044+(h<<8)+(ma<<2)>>2]|0;ga=pa;ga=Pf(e,ma,c[ga>>2]|0,c[ga+4>>2]|0)|0;ia=ua;ga=c[ia>>2]&ga;ia=c[ia+4>>2]&D;ha=av(ga|0,ia|0,16)|0;ja=av(ga|0,ia|0,48)|0;ga=d[1167548+(ga&65535)>>0]|0;ha=d[1167548+(ha&65535)>>0]|0;ia=d[1167548+(ia&65535)>>0]|0;ja=d[1167548+ja>>0]|0;na=va;ma=30544+(ma<<3)|0;la=c[ma>>2]&c[na>>2];na=c[ma+4>>2]&c[na+4>>2];ma=av(la|0,na|0,16)|0;oa=av(la|0,na|0,48)|0;oa=fa+-1+ga+ha+ia+ja+(d[1167548+(la&65535)>>0]|0)+(d[1167548+(ma&65535)>>0]|0)+(d[1167548+(na&65535)>>0]|0)+(d[1167548+oa>>0]|0)|0;f=(c[1042264+(((oa|0)>5?5:oa)<<2)>>2]|0)+f|0;g=g+1|0}while((g|0)!=4)}else f=0;s:do if((i|0)==0&(j|0)==0)g=c[Ca>>2]|0;else{F=wa;C=ua;B=c[C>>2]|0;C=c[C+4>>2]|0;E=B|c[F>>2];F=C|c[F+4>>2];G=c[260711]|0;g=c[Ca>>2]|0;H=e+288|0;z=ra;y=c[z>>2]|0;z=c[z+4>>2]|0;A=(g|0)==4;x=i;w=j;while(1){u=Qa(x|0,w|0,0)|0;r=Yu(x|0,w|0,-1,-1)|0;x=r&x;w=D&w;r=109712+(u<<3)|0;q=c[r>>2]|0;r=c[r+4>>2]|0;m=q&E;k=r&F;s=av(m|0,k|0,16)|0;v=av(m|0,k|0,48)|0;v=S((d[1167548+(s&65535)>>0]|0)+(d[1167548+(m&65535)>>0]|0)+(d[1167548+(k&65535)>>0]|0)+(d[1167548+v>>0]|0)|0,G)|0;k=u>>>3^7;m=k+-1|0;s=S(m,k+-2|0)|0;i=c[3024+(g<<6)+(m<<2)>>2]|0;h=c[3024+(g<<6)+32+(m<<2)>>2]|0;t=u+-8|0;do if(s){t:do switch(g|0){case 4:{if(c[sa>>2]|0){h=(S(25-(c[1019044+(c[ta>>2]<<8)+(t<<2)>>2]<<1)|0,s)|0)+h|0;break t}if(!(c[ya>>2]|0))j=64;else j=c[xa>>2]|0;h=(S(((c[1019044+(j<<8)+(t<<2)>>2]|0)*5|0)+-10|0,s)|0)+h|0;break}case 1:break;case 2:{if(!(c[ya>>2]|0))j=S(s*5|0,c[1035428+(t<<2)>>2]|0)|0;else j=S(s*5|0,c[1019044+(c[xa>>2]<<8)+(t<<2)>>2]|0)|0;h=j+h|0;break}default:{wa=S(s*5|0,c[1019044+(c[xa>>2]<<8)+(t<<2)>>2]|0)|0;j=c[ta>>2]|0;h=wa-(S(s<<1,c[1019044+(j<<8)+(t<<2)>>2]|0)|0)+h|0;if(t>>>0<8)break t;if(A?(c[sa>>2]|0)==0:0)j=64;h=h-(S(c[1019044+(j<<8)+(u+-16<<2)>>2]|0,s)|0)|0}}while(0);if(c[e+(t<<2)>>2]|0){ua=va;ra=30544+(t<<3)|0;wa=S(m,k)|0;wa=((c[ra>>2]&c[ua>>2]|0)==0?(c[ra+4>>2]&c[ua+4>>2]|0)==0:0)?0:wa;i=wa+i|0;h=wa+h|0;break}p=109200+(u<<3)|0;m=H;wa=qa;j=pa;ua=28496+(u<<3)|0;k=29008+(u<<3)|0;k=(S(c[ua+4>>2]&c[j+4>>2],c[k+4>>2]|0)|0)^(S(c[ua>>2]&c[j>>2],c[k>>2]|0)|0);k=(c[1035428+(u<<2)>>2]|0)+(k>>>(c[1035684+(u<<2)>>2]|0)<<3)|0;j=(c[wa>>2]|c[m>>2])&c[p>>2]&c[k>>2];k=(c[wa+4>>2]|c[m+4>>2])&c[p+4>>2]&c[k+4>>2];p=va;p=(c[p>>2]&j|0)==0?(c[p+4>>2]&k|0)==0:0;m=(p?y:-1)&q;p=(p?z:-1)&r;k=(j&B|0)==0&(k&C|0)==0;j=(k?E:-1)&q;k=(k?F:-1)&r;if((j|0)==0&(k|0)==0)j=18;else{wa=30544+(t<<3)|0;j=((c[wa>>2]&j|0)==0?(c[wa+4>>2]&k|0)==0:0)?8:0}if((m|0)==(q|0)&(p|0)==(r|0))j=j+6|0;else{wa=30544+(t<<3)|0;j=((c[wa>>2]&m|0)==0?(c[wa+4>>2]&p|0)==0:0)?j:j|4}wa=S(j,s)|0;i=wa+i|0;h=wa+h|0}while(0);u:do switch(g|0){case 7:break;case 4:{if(c[sa>>2]|0){ka=577;break u}ua=za;wa=109712+(t<<3)|0;if(!((c[ua>>2]&B&c[wa>>2]|0)==0?(c[ua+4>>2]&C&c[wa+4>>2]|0)==0:0))ka=578;break}default:ka=577}while(0);if((ka|0)==577){ka=0;ua=za;wa=110736+(t<<3)|0;if(!((c[ua>>2]&B&c[wa>>2]|0)==0?(c[ua+4>>2]&C&c[wa+4>>2]|0)==0:0))ka=578}if((ka|0)==578){ka=0;i=(i|0)/2|0;h=(h|0)/2|0}f=f-v+i+(h<<16)+(c[1042604+((u&7)<<2)>>2]|0)|0;if((x|0)==0&(w|0)==0)break s}}while(0);f=o-f+n|0;if((g|0)==4){Ba=Dd(e,Da)|0;f=Ba+f-(Ed(e,Da)|0)|0}else ka=582}else ka=540}if((ka|0)==540){k=c[ta>>2]|0;m=k>>3;f=m^7;h=m+1|0;if((h|0)<8){j=wa;g=va;i=~(c[g>>2]|c[j>>2]);j=~(c[g+4>>2]|c[j+4>>2]);g=m;while(1){za=31120+(h<<3)|0;g=105104+(k<<6)+(g-m<<3)|0;f=(((c[za>>2]&i&c[g>>2]|0)==0?(c[za+4>>2]&j&c[g+4>>2]|0)==0:0)&1)+f|0;g=h+1|0;if((g|0)==8)break;else{za=h;h=g;g=za}}}f=o-(c[1042572+(((f|0)>7?7:f)<<2)>>2]|0)+n|0;ka=582}if((ka|0)==582){Aa=c[Aa>>2]|0;if(((c[Aa+20>>2]|0)+(c[Aa+16>>2]|0)|0)>12221){Aa=Dd(e,Da)|0;f=Aa+f-(Ed(e,Da)|0)|0}f=(Fd(e,c[(c[Ba>>2]|0)+112>>2]|0,f+32768>>16)|0)+f|0}Ba=f+32768>>16;Aa=Gd(e,c[Da>>2]|0,Ba)|0;Da=c[(c[Da>>2]|0)+24>>2]|0;Da=(((S(S(Aa,Ba)|0,128-Da|0)|0)/64|0)+(S(Da,f<<16>>16)|0)|0)/128|0;Da=((c[e+5348>>2]|0)==0?Da:0-Da|0)+(c[12280+(c[Ca>>2]<<2)>>2]|0)|0;l=Ea;return Da|0}function Jd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;i=b+32|0;Nt(i,d)|0;h=b+44|0;c[h>>2]=0;j=b+48|0;g=c[j>>2]|0;if(g&8|0){d=a[i+11>>0]|0;if(d<<24>>24<0){d=c[i>>2]|0;e=d;f=d;d=d+(c[b+36>>2]|0)|0}else{e=i;f=i;d=i+(d&255)|0}c[h>>2]=d;c[b+8>>2]=e;c[b+12>>2]=f;c[b+16>>2]=d}if(!(g&16))return;e=i+11|0;d=a[e>>0]|0;if(d<<24>>24<0){g=c[b+36>>2]|0;c[h>>2]=(c[i>>2]|0)+g;d=(c[b+40>>2]&2147483647)+-1|0;h=g}else{g=d&255;c[h>>2]=i+g;d=10;h=g}St(i,d,0);d=a[e>>0]|0;if(d<<24>>24<0){e=c[i>>2]|0;g=e;f=c[b+36>>2]|0}else{g=i;f=d&255;e=i}d=b+24|0;c[d>>2]=e;c[b+20>>2]=e;c[b+28>>2]=g+f;if(!(c[j>>2]&3))return;c[d>>2]=e+h;return}function Kd(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;i=n+12|0;k=n;m=n+8|0;Yk(k,b);if(!(a[k>>0]|0)){Zk(k);l=n;return b|0}j=(c[b>>2]|0)+-12|0;c[m>>2]=c[b+(c[j>>2]|0)+24>>2];j=b+(c[j>>2]|0)|0;g=d+e|0;h=(c[j+4>>2]&176|0)==32?g:d;f=j+76|0;e=c[f>>2]|0;if((e|0)==-1){c[i>>2]=Sk(j)|0;e=lm(i,1165628)|0;e=nb[c[(c[e>>2]|0)+28>>2]&63](e,32)|0;pt(i);e=e<<24>>24;c[f>>2]=e}c[i>>2]=c[m>>2];if(Md(i,d,h,g,j,e&255)|0){Zk(k);l=n;return b|0}m=b+(c[(c[b>>2]|0)+-12>>2]|0)|0;Qk(m,c[m+16>>2]|5);Zk(k);l=n;return b|0}function Ld(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=c[d+48>>2]|0;if(e&16|0){e=d+44|0;f=c[e>>2]|0;g=c[d+24>>2]|0;if(f>>>0<g>>>0){c[e>>2]=g;f=g}e=c[d+20>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=f-e|0;if(d>>>0>4294967279)Gt(b);if(d>>>0<11)a[b+11>>0]=d;else{h=d+16&-16;g=At(h)|0;c[b>>2]=g;c[b+8>>2]=h|-2147483648;c[b+4>>2]=d;b=g}if((e|0)!=(f|0)){g=b;while(1){a[g>>0]=a[e>>0]|0;e=e+1|0;if((e|0)==(f|0))break;else g=g+1|0}b=b+d|0}a[b>>0]=0;return}if(!(e&8)){c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;return}e=c[d+8>>2]|0;g=c[d+16>>2]|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;d=g-e|0;if(d>>>0>4294967279)Gt(b);if(d>>>0<11)a[b+11>>0]=d;else{f=d+16&-16;h=At(f)|0;c[b>>2]=h;c[b+8>>2]=f|-2147483648;c[b+4>>2]=d;b=h}if((e|0)!=(g|0)){f=b;while(1){a[f>>0]=a[e>>0]|0;e=e+1|0;if((e|0)==(g|0))break;else f=f+1|0}b=b+d|0}a[b>>0]=0;return}function Md(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0,n=0,o=0;o=l;l=l+16|0;m=o;n=c[b>>2]|0;if(!n){n=0;l=o;return n|0}j=d;i=f-j|0;k=g+12|0;g=c[k>>2]|0;g=(g|0)>(i|0)?g-i|0:0;i=e;j=i-j|0;if((j|0)>0?(ab[c[(c[n>>2]|0)+48>>2]&31](n,d,j)|0)!=(j|0):0){c[b>>2]=0;n=0;l=o;return n|0}do if((g|0)>0){c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Kt(m,g,h);if((ab[c[(c[n>>2]|0)+48>>2]&31](n,(a[m+11>>0]|0)<0?c[m>>2]|0:m,g)|0)==(g|0)){Mt(m);break}c[b>>2]=0;Mt(m);n=0;l=o;return n|0}while(0);f=f-i|0;if((f|0)>0?(ab[c[(c[n>>2]|0)+48>>2]&31](n,e,f)|0)!=(f|0):0){c[b>>2]=0;n=0;l=o;return n|0}c[k>>2]=0;l=o;return n|0}function Nd(a){a=a|0;c[a>>2]=3708;Mt(a+32|0);Tj(a);return}function Od(a){a=a|0;c[a>>2]=3708;Mt(a+32|0);Tj(a);Dt(a);return}function Pd(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,l=0,m=0,n=0;i=d+44|0;j=c[i>>2]|0;m=d+24|0;n=c[m>>2]|0;k=n;if(j>>>0<n>>>0){c[i>>2]=n;l=k}else l=j;i=h&24;if(!i){n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;return}if((g|0)==1&(i|0)==24){n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;return}a:do switch(g|0){case 0:{i=0;j=0;break}case 1:if(!(h&8)){j=k-(c[d+20>>2]|0)|0;i=j;j=((j|0)<0)<<31>>31;break a}else{j=(c[d+12>>2]|0)-(c[d+8>>2]|0)|0;i=j;j=((j|0)<0)<<31>>31;break a}case 2:{i=d+32|0;if((a[i+11>>0]|0)<0)i=c[i>>2]|0;j=l-i|0;i=j;j=((j|0)<0)<<31>>31;break}default:{n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;return}}while(0);j=Yu(i|0,j|0,e|0,f|0)|0;k=D;if((k|0)>=0){i=d+32|0;if((a[i+11>>0]|0)<0)i=c[i>>2]|0;f=l-i|0;e=((f|0)<0)<<31>>31;if(!((e|0)<(k|0)|(e|0)==(k|0)&f>>>0<j>>>0)){i=h&8;if(!((j|0)==0&(k|0)==0)){if(i|0?(c[d+12>>2]|0)==0:0){n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;return}if((h&16|0)!=0&(n|0)==0){n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;return}}if(i|0){c[d+12>>2]=(c[d+8>>2]|0)+j;c[d+16>>2]=l}if(h&16|0)c[m>>2]=(c[d+20>>2]|0)+j;n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=j;c[n+4>>2]=k;return}}n=b;c[n>>2]=0;c[n+4>>2]=0;n=b+8|0;c[n>>2]=-1;c[n+4>>2]=-1;return}function Qd(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;d=d+8|0;mb[c[(c[b>>2]|0)+16>>2]&15](a,b,c[d>>2]|0,c[d+4>>2]|0,0,e);return}function Rd(a){a=a|0;var b=0,e=0,f=0;b=a+44|0;f=c[b>>2]|0;e=c[a+24>>2]|0;if(f>>>0<e>>>0){c[b>>2]=e;f=e}if(!(c[a+48>>2]&8)){a=-1;return a|0}b=a+16|0;e=c[b>>2]|0;if(e>>>0<f>>>0){c[b>>2]=f;e=f}b=c[a+12>>2]|0;if(b>>>0>=e>>>0){a=-1;return a|0}a=d[b>>0]|0;return a|0}function Sd(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;f=b+44|0;e=c[f>>2]|0;g=c[b+24>>2]|0;if(e>>>0<g>>>0){c[f>>2]=g;e=g}h=b+12|0;f=c[h>>2]|0;if((c[b+8>>2]|0)>>>0>=f>>>0){d=-1;return d|0}if((d|0)==-1){c[h>>2]=f+-1;c[b+16>>2]=e;d=0;return d|0}if(!(c[b+48>>2]&16)){g=d&255;f=f+-1|0;if(g<<24>>24!=(a[f>>0]|0)){d=-1;return d|0}}else{g=d&255;f=f+-1|0}c[h>>2]=f;c[b+16>>2]=e;a[f>>0]=g;return d|0}function Td(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;u=l;l=l+16|0;p=u;if((d|0)==-1){t=0;l=u;return t|0}q=b+12|0;r=b+8|0;s=(c[q>>2]|0)-(c[r>>2]|0)|0;t=b+24|0;k=c[t>>2]|0;n=b+28|0;e=c[n>>2]|0;if((k|0)==(e|0)){j=b+48|0;if(!(c[j>>2]&16)){t=-1;l=u;return t|0}h=b+20|0;i=c[h>>2]|0;o=b+44|0;m=(c[o>>2]|0)-i|0;g=b+32|0;Xt(g,0);e=g+11|0;if((a[e>>0]|0)<0)f=(c[b+40>>2]&2147483647)+-1|0;else f=10;St(g,f,0);e=a[e>>0]|0;if(e<<24>>24<0){f=c[g>>2]|0;e=c[b+36>>2]|0}else{f=g;e=e&255}e=f+e|0;c[h>>2]=f;c[n>>2]=e;k=f+(k-i)|0;c[t>>2]=k;f=f+m|0;c[o>>2]=f;m=o;g=o;i=e}else{f=b+44|0;m=f;j=b+48|0;g=f;f=c[f>>2]|0;i=e}h=k+1|0;c[p>>2]=h;f=c[(h>>>0<f>>>0?g:p)>>2]|0;c[m>>2]=f;if(c[j>>2]&8|0){e=b+32|0;if((a[e+11>>0]|0)<0)e=c[e>>2]|0;c[r>>2]=e;c[q>>2]=e+s;c[b+16>>2]=f}if((k|0)==(i|0)){t=nb[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;l=u;return t|0}else{c[t>>2]=h;a[k>>0]=d;t=d&255;l=u;return t|0}return 0}function Ud(a){a=a|0;var b=0,d=0;c[a>>2]=3612;b=a+64|0;c[b>>2]=3652;c[a+8>>2]=3632;d=a+12|0;c[d>>2]=3708;Mt(a+44|0);Tj(d);jl(a,3768);Pj(b);return}function Vd(a){a=a|0;var b=0,d=0;c[a>>2]=3612;b=a+64|0;c[b>>2]=3652;c[a+8>>2]=3632;d=a+12|0;c[d>>2]=3708;Mt(a+44|0);Tj(d);jl(a,3768);Pj(b);Dt(a);return}function Wd(a){a=a|0;var b=0,d=0;b=a+-8|0;c[b>>2]=3612;a=b+64|0;c[a>>2]=3652;c[b+8>>2]=3632;d=b+12|0;c[d>>2]=3708;Mt(b+44|0);Tj(d);jl(b,3768);Pj(a);return}function Xd(a){a=a|0;var b=0,d=0;a=a+-8|0;c[a>>2]=3612;b=a+64|0;c[b>>2]=3652;c[a+8>>2]=3632;d=a+12|0;c[d>>2]=3708;Mt(a+44|0);Tj(d);jl(a,3768);Pj(b);Dt(a);return}function Yd(a){a=a|0;var b=0,d=0;b=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[b>>2]=3612;a=b+64|0;c[a>>2]=3652;c[b+8>>2]=3632;d=b+12|0;c[d>>2]=3708;Mt(b+44|0);Tj(d);jl(b,3768);Pj(a);return}function Zd(a){a=a|0;var b=0,d=0;a=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[a>>2]=3612;b=a+64|0;c[b>>2]=3652;c[a+8>>2]=3632;d=a+12|0;c[d>>2]=3708;Mt(a+44|0);Tj(d);jl(a,3768);Pj(b);Dt(a);return}function _d(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[260714]=p;c[260713]=p;c[260715]=p+144;It(p,b);p=(c[260714]|0)+12|0;c[260714]=p;It(p,d);p=(c[260714]|0)+12|0;c[260714]=p;It(p,e);p=(c[260714]|0)+12|0;c[260714]=p;It(p,f);p=(c[260714]|0)+12|0;c[260714]=p;It(p,g);p=(c[260714]|0)+12|0;c[260714]=p;It(p,h);p=(c[260714]|0)+12|0;c[260714]=p;It(p,i);p=(c[260714]|0)+12|0;c[260714]=p;It(p,j);p=(c[260714]|0)+12|0;c[260714]=p;It(p,k);p=(c[260714]|0)+12|0;c[260714]=p;It(p,m);p=(c[260714]|0)+12|0;c[260714]=p;It(p,n);p=(c[260714]|0)+12|0;c[260714]=p;It(p,o);c[260714]=(c[260714]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function $d(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;d=l;l=l+48|0;g=d+36|0;f=d+24|0;e=d+16|0;b=d;qe(f,0);h=a[f+11>>0]|0;i=h<<24>>24<0;h=Kd(1164756,i?c[f>>2]|0:f,i?c[f+4>>2]|0:h&255)|0;c[g>>2]=Sk(h+(c[(c[h>>2]|0)+-12>>2]|0)|0)|0;i=lm(g,1165628)|0;i=nb[c[(c[i>>2]|0)+28>>2]&63](i,10)|0;pt(g);il(h,i)|0;Xk(h)|0;Mt(f);Ch(1163992);eg();Bb();Lf();yb();Kg();vf();Ug(1163764);c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21965,4);c[g>>2]=b;ae(e,1163992,b,1233084,g,f);dh(1163804,xh((c[e>>2]|0)+28|0)|0);Mt(b);l=d;return 0}function ae(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var i=0,j=0,k=0,m=0;m=l;l=l+16|0;k=m;h=d+4|0;f=c[h>>2]|0;do if(f){j=d+8|0;while(1){h=f+16|0;if(Bh(j,e,h)|0){h=c[f>>2]|0;if(!h){h=5;break}else f=h}else{if(!(Bh(j,h,e)|0)){h=10;break}i=f+4|0;h=c[i>>2]|0;if(!h){h=9;break}else f=h}}if((h|0)==5){c[k>>2]=f;j=f;i=f;break}else if((h|0)==9){c[k>>2]=f;j=f;break}else if((h|0)==10){c[k>>2]=f;j=f;i=k;break}}else{c[k>>2]=h;j=h;i=h}while(0);f=c[i>>2]|0;if(f|0){d=f;g=0;c[b>>2]=d;d=b+4|0;a[d>>0]=g;l=m;return}h=At(92)|0;k=h+16|0;f=c[g>>2]|0;c[k>>2]=c[f>>2];c[k+4>>2]=c[f+4>>2];c[k+8>>2]=c[f+8>>2];c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Ih(h+28|0,0);c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=j;c[i>>2]=h;f=c[c[d>>2]>>2]|0;if(!f)f=h;else{c[d>>2]=f;f=c[i>>2]|0}dc(c[d+4>>2]|0,f);d=d+8|0;c[d>>2]=(c[d>>2]|0)+1;d=h;g=1;c[b>>2]=d;d=b+4|0;a[d>>0]=g;l=m;return}function be(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[260717]=p;c[260716]=p;c[260718]=p+144;It(p,b);p=(c[260717]|0)+12|0;c[260717]=p;It(p,d);p=(c[260717]|0)+12|0;c[260717]=p;It(p,e);p=(c[260717]|0)+12|0;c[260717]=p;It(p,f);p=(c[260717]|0)+12|0;c[260717]=p;It(p,g);p=(c[260717]|0)+12|0;c[260717]=p;It(p,h);p=(c[260717]|0)+12|0;c[260717]=p;It(p,i);p=(c[260717]|0)+12|0;c[260717]=p;It(p,j);p=(c[260717]|0)+12|0;c[260717]=p;It(p,k);p=(c[260717]|0)+12|0;c[260717]=p;It(p,m);p=(c[260717]|0)+12|0;c[260717]=p;It(p,n);p=(c[260717]|0)+12|0;c[260717]=p;It(p,o);c[260717]=(c[260717]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);c[260719]=3872;c[260720]=0;c[260721]=1;c[260722]=3872;c[260723]=1;c[260724]=0;c[260725]=3896;c[260726]=0;c[260727]=1;c[260728]=3896;c[260729]=1;c[260730]=0;c[260731]=3920;c[260732]=0;c[260733]=1;c[260734]=3920;c[260735]=1;c[260736]=0;c[260737]=3944;c[260738]=0;c[260739]=1;c[260740]=3944;c[260741]=1;c[260742]=0;c[260743]=3968;c[260744]=0;c[260745]=1;c[260746]=3968;c[260747]=1;c[260748]=0;c[260749]=3992;c[260750]=0;c[260751]=1;c[260752]=3992;c[260753]=1;c[260754]=0;l=a;return}function ce(a){a=a|0;Dt(a);return}function de(a){a=a|0;return c[a+4>>2]|0}function ee(a){a=a|0;Dt(a);return}function fe(a){a=a|0;return c[a+4>>2]|0}function ge(a){a=a|0;Dt(a);return}function he(a){a=a|0;return c[a+4>>2]|0}function ie(a){a=a|0;Dt(a);return}function je(a){a=a|0;return c[a+4>>2]|0}function ke(a){a=a|0;Dt(a);return}function le(a){a=a|0;return c[a+4>>2]|0}function me(a){a=a|0;Dt(a);return}function ne(a){a=a|0;return c[a+4>>2]|0}
function ef(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0;pb=b+5364|0;if((c[pb>>2]|0)==1){b=d;return b|0}lb=b+5348|0;z=c[lb>>2]|0;y=z^1;ob=b+5356|0;p=(c[ob>>2]|0)+344+(y<<3)|0;kb=b+320+(z<<3)|0;qb=b+256|0;y=y<<3|6;x=b+336+(y<<2)|0;y=b+400+(y<<8)|0;o=c[kb>>2]&c[p>>2];p=c[kb+4>>2]&c[p+4>>2];a:while(1){do{do{if((o|0)==0&(p|0)==0)break a;v=Qa(o|0,p|0,0)|0;q=Yu(o|0,p|0,-1,-1)|0;o=q&o;p=D&p;q=c[b+(v<<2)>>2]&7}while((q|0)==1);t=qb;t=Cb(q,v,c[t>>2]|0,c[t+4>>2]|0)|0;u=qb;t=t&~c[u>>2];u=D&~c[u+4>>2];if((q|0)==6){switch(c[pb>>2]|0){case 4:{if(!(c[x>>2]|0))w=64;else mb=12;break}case 2:{if(!(c[x>>2]|0))w=64;else mb=12;break}case 1:{if(!(c[x>>2]|0))w=64;else mb=12;break}default:mb=12}if((mb|0)==12){mb=0;w=c[y>>2]|0}kb=114832+(w<<3)|0;t=t&~c[kb>>2];u=u&~c[kb+4>>2]}}while((t|0)==0&(u|0)==0);v=v<<6;while(1){q=d+8|0;kb=Qa(t|0,u|0,0)|0;jb=Yu(t|0,u|0,-1,-1)|0;t=jb&t;u=D&u;c[d>>2]=kb+v;if((t|0)==0&(u|0)==0){d=q;continue a}else d=q}}kb=qb;jb=~c[kb>>2];kb=~c[kb+4>>2];if(!z){y=b+320|0;l=y;z=b+264|0;q=z;j=c[q>>2]&c[l>>2];l=c[q+4>>2]&c[l+4>>2];q=l&16711680;l=l&-16711681;A=b+328|0;p=A;o=c[p>>2]|0;p=c[p+4>>2]|0;r=c[pb>>2]|0;e=gv(j|0,l|0,8)|0;e=e&jb;g=D&kb;h=gv(e|0,g|0,8)|0;ib=(r|0)==4;i=ib?-65536:-16777216;switch(r|0){case 4:{if(!(c[b+392>>2]|0))B=64;else mb=22;break}case 2:{if(!(c[b+392>>2]|0))B=64;else mb=22;break}case 1:{if(!(c[b+392>>2]|0))B=64;else mb=22;break}default:mb=22}if((mb|0)==22)B=c[b+3984>>2]|0;n=35984+(B<<3)|0;w=c[n>>2]|0;m=w&e;n=c[n+4>>2]&g;g=i&jb&h&w;w=c[lb>>2]|0;x=c[ob>>2]|0;v=x+344+((w^1)<<3)|0;t=c[v>>2]|0;v=c[v+4>>2]|0;w=b+320+(w<<3)|0;u=c[w>>2]|0;w=c[w+4>>2]|0;h=t&j&u;e=v&l&w;if((h|0)==0&(e|0)==0){i=m;h=n;e=0}else{i=gv(h|0,e|0,8)|0;h=31056+((B&7)<<3)|0;i=i&jb&~c[h>>2];h=D&kb&~c[h+4>>2];e=gv(i|0,h|0,8)|0;i=i|m;h=h|n;g=jb&-16777216&e|g;e=0}s=(r|0)==3;if((s?(c[b+4500>>2]|0)!=0:0)?(C=jb&-256,E=kb&16777215,!((C|0)==0&(E|0)==0)):0){m=C;l=E;while(1){j=d+8|0;ib=Qa(m|0,l|0,0)|0;gb=Yu(m|0,l|0,-1,-1)|0;m=gb&m;l=D&l;c[d>>2]=(ib|36864)+64;if((m|0)==0&(l|0)==0){d=j;break}else d=j}}if(!((i|0)==0&(h|0)==0)){j=d;while(1){ib=Qa(i|0,h|0,0)|0;d=Yu(i|0,h|0,-1,-1)|0;i=d&i;h=D&h;d=j+8|0;c[j>>2]=(ib|-512)+(ib<<6);if((i|0)==0&(h|0)==0)break;else j=d}}if(!((g|0)==0&(e|0)==0)){h=d;while(1){ib=Qa(g|0,e|0,0)|0;d=Yu(g|0,e|0,-1,-1)|0;g=d&g;e=D&e;d=h+8|0;c[h>>2]=(ib|-1024)+(ib<<6);if((g|0)==0&(e|0)==0)break;else h=d}}b:do if(!(0==0&(q|0)==0)){j=gv(0,q|0,9)|0;j=j&o;i=D&p;gv(0,q|0,7)|0;h=p&2130706432&D;g=gv(0,q|0,8)|0;g=g&jb;e=D&kb;switch(r|0){case 4:{if(!(c[b+392>>2]|0))F=64;else mb=38;break}case 2:{if(!(c[b+392>>2]|0))F=64;else mb=38;break}case 1:{if(!(c[b+392>>2]|0))F=64;else mb=38;break}default:mb=38}if((mb|0)==38)F=c[b+3984>>2]|0;c:do if(!((j|0)==0&(i|0)==0)){if((r|0)==1)while(1){ib=Yu(j|0,i|0,-1,-1)|0;j=ib&j;i=D&i;if((j|0)==0&(i|0)==0)break c}o=30544+(F<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;while(1){while(1){l=Qa(j|0,i|0,0)|0;ib=Yu(j|0,i|0,-1,-1)|0;j=ib&j;i=D&i;ib=32400+(l<<3)|0;if(!((c[ib>>2]&n|0)==0?(c[ib+4>>2]&o|0)==0:0))break;if((j|0)==0&(i|0)==0)break c}m=d+8|0;c[d>>2]=l+15808+(l<<6);if((j|0)==0&(i|0)==0){d=m;break}else d=m}}while(0);d:do if(!(0==0&(h|0)==0)){if((r|0)==1){i=0;while(1){ib=Yu(i|0,h|0,-1,-1)|0;i=ib&i;h=D&h;if((i|0)==0&(h|0)==0)break d}}n=30544+(F<<3)|0;m=c[n>>2]|0;n=c[n+4>>2]|0;i=0;while(1){while(1){j=Qa(i|0,h|0,0)|0;ib=Yu(i|0,h|0,-1,-1)|0;i=ib&i;h=D&h;ib=32400+(j<<3)|0;if(!((c[ib>>2]&m|0)==0?(c[ib+4>>2]&n|0)==0:0))break;if((i|0)==0&(h|0)==0)break d}l=d+8|0;c[d>>2]=j+15936+(j<<6);if((i|0)==0&(h|0)==0){d=l;break}else d=l}}while(0);if(!((g|0)==0&(e|0)==0)){if((r|0)==1)while(1){ib=Yu(g|0,e|0,-1,-1)|0;g=ib&g;e=D&e;if((g|0)==0&(e|0)==0)break b}l=30544+(F<<3)|0;j=c[l>>2]|0;l=c[l+4>>2]|0;while(1){while(1){h=Qa(g|0,e|0,0)|0;ib=Yu(g|0,e|0,-1,-1)|0;g=ib&g;e=D&e;ib=32400+(h<<3)|0;if(!((c[ib>>2]&j|0)==0?(c[ib+4>>2]&l|0)==0:0))break;if((g|0)==0&(e|0)==0)break b}i=d+8|0;c[d>>2]=(h|15872)+(h<<6);if((g|0)==0&(e|0)==0){d=i;break}else d=i}}}while(0);if(s?(c[b+4496>>2]|0)!=(c[b+4500>>2]|0):0){if((c[b+4504>>2]|0)!=0?(H=x+392|0,G=c[H>>2]&jb,H=c[H+4>>2]&kb,!((G|0)==0&(H|0)==0)):0){h=G;g=H;while(1){e=d+8|0;ib=Qa(h|0,g|0,0)|0;gb=Yu(h|0,g|0,-1,-1)|0;h=gb&h;g=D&g;c[d>>2]=ib|36992;if((h|0)==0&(g|0)==0){d=e;break}else d=e}}if((c[b+4508>>2]|0)!=0?(M=x+400|0,I=c[M>>2]&jb,M=c[M+4>>2]&kb,!((I|0)==0&(M|0)==0)):0){h=I;g=M;while(1){e=d+8|0;ib=Qa(h|0,g|0,0)|0;gb=Yu(h|0,g|0,-1,-1)|0;h=gb&h;g=D&g;c[d>>2]=(ib|36864)+192;if((h|0)==0&(g|0)==0){d=e;break}else d=e}}if((c[b+4512>>2]|0)!=0?(O=x+408|0,N=c[O>>2]&jb,O=c[O+4>>2]&kb,!((N|0)==0&(O|0)==0)):0){h=N;g=O;while(1){e=d+8|0;ib=Qa(h|0,g|0,0)|0;gb=Yu(h|0,g|0,-1,-1)|0;h=gb&h;g=D&g;c[d>>2]=ib|37120;if((h|0)==0&(g|0)==0){d=e;break}else d=e}}if((c[b+4516>>2]|0)!=0?(f=x+416|0,P=c[f>>2]&jb,f=c[f+4>>2]&kb,!((P|0)==0&(f|0)==0)):0){g=P;while(1){e=d+8|0;ib=Qa(g|0,f|0,0)|0;gb=Yu(g|0,f|0,-1,-1)|0;g=gb&g;f=D&f;c[d>>2]=(ib|36864)+320;if((g|0)==0&(f|0)==0){d=e;break}else d=e}}}f=b+912|0;e=c[f>>2]|0;if((e|0)!=64){m=u&t;l=w&v;j=x+392|0;i=f;do{ib=30544+(e<<3)|0;if(((m&c[ib>>2]|0)==0?(l&c[ib+4>>2]|0)==0:0)?(ib=32400+(e<<3)|0,U=j,T=c[ib>>2]&jb&c[U>>2],U=c[ib+4>>2]&kb&c[U+4>>2],!((T|0)==0&(U|0)==0)):0){h=e<<6;f=T;g=U;while(1){e=d+8|0;ib=Qa(f|0,g|0,0)|0;gb=Yu(f|0,g|0,-1,-1)|0;f=gb&f;g=D&g;c[d>>2]=ib+h;if((f|0)==0&(g|0)==0){d=e;break}else d=e}}i=i+4|0;e=c[i>>2]|0}while((e|0)!=64)}e=hf(b,gf(b,ff(b,d,0,jb,kb)|0,0,jb,kb)|0,0,jb,kb)|0;d=c[pb>>2]|0;do if((d|0)==1){f=y;mb=b+304|0;d=c[mb>>2]&c[f>>2];f=c[mb+4>>2]&c[f+4>>2];if((d|0)==0&(f|0)==0)g=e;else{do{g=Qa(d|0,f|0,0)|0;h=Yu(d|0,f|0,-1,-1)|0;d=h&d;f=D&f;h=34448+(g<<3)|0;i=c[h>>2]&jb;h=c[h+4>>2]&kb;if(!((i|0)==0&(h|0)==0)){j=g<<6;while(1){g=e+8|0;mb=Qa(i|0,h|0,0)|0;ib=Yu(i|0,h|0,-1,-1)|0;i=ib&i;h=D&h;c[e>>2]=mb+j;if((i|0)==0&(h|0)==0){e=g;break}else e=g}}}while(!((d|0)==0&(f|0)==0));g=e}if((c[b+5368>>2]|0)==9){b=g;return b|0}e=c[(c[ob>>2]|0)+48>>2]|0;if((e|0)!=64){kb=qb;kb=Pf(b,e,c[kb>>2]|0,c[kb+4>>2]|0)|0;d=b+320+(c[lb>>2]<<3)|0;e=c[d>>2]|0;d=c[d+4>>2]|0;mb=z;if(!((e&kb&c[mb>>2]|0)==0?(d&D&c[mb+4>>2]|0)==0:0)){b=g;return b|0}}else{d=b+320+(c[lb>>2]<<3)|0;e=c[d>>2]|0;d=c[d+4>>2]|0}while(1){if((e|0)==0&(d|0)==0){mb=96;break}mb=Qa(e|0,d|0,0)|0;f=Yu(e|0,d|0,-1,-1)|0;d=D&d;kb=qb;kb=Cb(c[b+(mb<<2)>>2]|0,mb,c[kb>>2]|0,c[kb+4>>2]|0)|0;mb=b+320+((c[lb>>2]^1)<<3)|0;if(!((c[mb>>2]&kb|0)==0?(c[mb+4>>2]&D|0)==0:0)){nb=g;mb=328;break}else e=f&e}if((mb|0)==96){k=g;W=c[pb>>2]|0;break}else if((mb|0)==328)return nb|0}else{k=e;W=d}while(0);if((W|0)==6?Te(b)|0:0){b=k;return b|0}e=c[(c[ob>>2]|0)+24>>2]|0;if(!(e&3)){b=k;return b|0}l=qb;f=c[l>>2]|0;l=c[l+4>>2]|0;lb=b+5216|0;e=(e&1|0)==0|(c[lb>>2]&f|0?1:(c[lb+4>>2]&l|0)!=0);if(!(a[b+5360>>0]|0)){e:do if(!e){switch(c[pb>>2]|0){case 4:{if(!(c[b+360>>2]|0))mb=143;else mb=144;break}case 2:{if(!(c[b+360>>2]|0))mb=143;else mb=144;break}case 1:{Y=c[b+5084>>2]|0;Z=c[b+5148>>2]|0;break}default:mb=144}if((mb|0)==143){za=64;Aa=c[b+5148>>2]|0;mb=145}else if((mb|0)==144){e=c[b+1936>>2]|0;d=c[b+5148>>2]|0;if((e|0)==6){Y=6;Z=d}else{za=e;Aa=d;mb=145}}f:do if((mb|0)==145){h=A;g=c[h>>2]|0;h=c[h+4>>2]|0;i=b+392|0;j=b+3984|0;e=6;d=l;while(1){nb=Pf(b,e,f,d)|0;if(!((nb&g|0)==0&(D&h|0)==0)){if((c[pb>>2]|0)!=2){l=k;break e}if(!(c[i>>2]|0))d=64;else d=c[j>>2]|0;nb=34448+(d<<3)|0;lb=30544+(e<<3)|0;if((c[lb>>2]&c[nb>>2]|0)==0?(c[lb+4>>2]&c[nb+4>>2]|0)==0:0){l=k;break e}}e=e+-1|0;if((e|0)==(za|0)){Y=za;Z=Aa;break f}d=qb;f=c[d>>2]|0;d=c[d+4>>2]|0}}while(0);e=Z+49152+(Y<<6)|0;if(Rf(b,e)|0){c[k>>2]=e;l=k+8|0}else l=k}else l=k;while(0);k=qb;f=c[k>>2]|0;k=c[k+4>>2]|0;nb=b+5224|0;if(!((c[nb>>2]&f|0)==0?(c[nb+4>>2]&k|0)==0:0)){b=l;return b|0}if(!(c[(c[ob>>2]|0)+24>>2]&2)){b=l;return b|0}switch(c[pb>>2]|0){case 4:{if(!(c[b+360>>2]|0))mb=161;else mb=162;break}case 2:{if(!(c[b+360>>2]|0))mb=161;else mb=162;break}case 1:{eb=c[b+5088>>2]|0;fb=c[b+5152>>2]|0;break}default:mb=162}if((mb|0)==161){cb=64;hb=c[b+5152>>2]|0;mb=163}else if((mb|0)==162){e=c[b+1936>>2]|0;d=c[b+5152>>2]|0;if((e|0)==2){eb=2;fb=d}else{cb=e;hb=d;mb=163}}g:do if((mb|0)==163){h=A;g=c[h>>2]|0;h=c[h+4>>2]|0;i=b+392|0;j=b+3984|0;e=2;d=k;while(1){ob=Pf(b,e,f,d)|0;if(!((ob&g|0)==0&(D&h|0)==0)){if((c[pb>>2]|0)!=2){nb=l;mb=328;break}if(!(c[i>>2]|0))d=64;else d=c[j>>2]|0;ob=34448+(d<<3)|0;nb=30544+(e<<3)|0;if((c[nb>>2]&c[ob>>2]|0)==0?(c[nb+4>>2]&c[ob+4>>2]|0)==0:0){nb=l;mb=328;break}}e=e+1|0;if((e|0)==(cb|0)){eb=cb;fb=hb;break g}d=qb;f=c[d>>2]|0;d=c[d+4>>2]|0}if((mb|0)==328)return nb|0}while(0);e=fb+49152+(eb<<6)|0;if(!(Rf(b,e)|0)){b=l;return b|0}c[l>>2]=e;b=l+8|0;return b|0}h:do if(!e){switch(c[pb>>2]|0){case 4:{if(!(c[b+360>>2]|0))mb=105;else mb=107;break}case 2:{if(!(c[b+360>>2]|0))mb=105;else mb=107;break}case 1:{na=c[b+5084>>2]|0;xa=c[b+5148>>2]|0;break}default:mb=107}if((mb|0)==105){va=A;la=64;sa=c[b+5148>>2]|0;ua=c[va>>2]|0;va=c[va+4>>2]|0;wa=1;mb=108}else if((mb|0)==107){e=c[b+1936>>2]|0;d=c[b+5148>>2]|0;h=A;g=c[h>>2]|0;h=c[h+4>>2]|0;if((e|0)==6){ha=6;ja=d;fa=f;ba=l;ca=g;da=h;mb=116}else{la=e;sa=d;ua=g;va=h;wa=(e|0)<6?-1:1;mb=108}}if((mb|0)==108){g=b+392|0;h=b+3984|0;d=6;e=l;do{lb=Pf(b,d,f,e)|0;if(!((lb&ua|0)==0&(D&va|0)==0)){if((c[pb>>2]|0)!=2)break h;if(!(c[g>>2]|0))e=64;else e=c[h>>2]|0;lb=34448+(e<<3)|0;kb=30544+(d<<3)|0;if((c[kb>>2]&c[lb>>2]|0)==0?(c[kb+4>>2]&c[lb+4>>2]|0)==0:0)break h}d=d+wa|0;e=qb;f=c[e>>2]|0;e=c[e+4>>2]|0}while((d|0)!=(la|0));da=A;ha=la;ja=sa;fa=f;ba=e;ca=c[da>>2]|0;da=c[da+4>>2]|0;mb=116}if((mb|0)==116){lb=30544+(ja<<3)|0;kb=28544;jb=29056;jb=(S(c[kb+4>>2]&(c[lb+4>>2]^ba),c[jb+4>>2]|0)|0)^(S(c[kb>>2]&(c[lb>>2]^fa),c[jb>>2]|0)|0);jb=(c[258863]|0)+(jb>>>(c[258927]|0)<<3)|0;lb=b+288|0;kb=b+296|0;if((c[jb>>2]&ca&(c[kb>>2]|c[lb>>2])|0)==0?(c[jb+4>>2]&da&(c[kb+4>>2]|c[lb+4>>2])|0)==0:0){na=ha;xa=ja}else break}e=xa+49152+(na<<6)|0;if(Rf(b,e)|0){c[k>>2]=e;k=k+8|0}}while(0);j=qb;i=c[j>>2]|0;j=c[j+4>>2]|0;lb=b+5224|0;if(!((c[lb>>2]&i|0)==0?(c[lb+4>>2]&j|0)==0:0)){b=k;return b|0}if(!(c[(c[ob>>2]|0)+24>>2]&2)){b=k;return b|0}switch(c[pb>>2]|0){case 4:{if(!(c[b+360>>2]|0))mb=124;else mb=126;break}case 2:{if(!(c[b+360>>2]|0))mb=124;else mb=126;break}case 1:{Fa=c[b+5088>>2]|0;Oa=c[b+5152>>2]|0;break}default:mb=126}if((mb|0)==124){ab=A;Da=64;Ia=1;Za=c[b+5152>>2]|0;$a=c[ab>>2]|0;ab=c[ab+4>>2]|0;mb=127}else if((mb|0)==126){e=c[b+1936>>2]|0;d=c[b+5152>>2]|0;g=A;f=c[g>>2]|0;g=c[g+4>>2]|0;if((e|0)==2){Ha=2;Ja=d;Ka=i;La=j;Ma=f;Na=g;mb=135}else{Da=e;Ia=(e|0)<2?-1:1;Za=d;$a=f;ab=g;mb=127}}do if((mb|0)==127){g=b+392|0;h=b+3984|0;f=2;d=j;while(1){ob=Pf(b,f,i,d)|0;if(!((ob&$a|0)==0&(D&ab|0)==0)){if((c[pb>>2]|0)!=2){nb=k;mb=328;break}if(!(c[g>>2]|0))e=64;else e=c[h>>2]|0;ob=34448+(e<<3)|0;mb=30544+(f<<3)|0;if((c[mb>>2]&c[ob>>2]|0)==0?(c[mb+4>>2]&c[ob+4>>2]|0)==0:0){nb=k;mb=328;break}}f=f+Ia|0;d=qb;i=c[d>>2]|0;d=c[d+4>>2]|0;if((f|0)==(Da|0)){mb=134;break}}if((mb|0)==134){Na=A;Ha=Da;Ja=Za;Ka=i;La=d;Ma=c[Na>>2]|0;Na=c[Na+4>>2]|0;mb=135;break}else if((mb|0)==328)return nb|0}while(0);if((mb|0)==135){qb=30544+(Ja<<3)|0;pb=28512;ob=29024;ob=(S(c[pb+4>>2]&(c[qb+4>>2]^La),c[ob+4>>2]|0)|0)^(S(c[pb>>2]&(c[qb>>2]^Ka),c[ob>>2]|0)|0);ob=(c[258859]|0)+(ob>>>(c[258923]|0)<<3)|0;qb=b+288|0;pb=b+296|0;if((c[ob>>2]&Ma&(c[pb>>2]|c[qb>>2])|0)==0?(c[ob+4>>2]&Na&(c[pb+4>>2]|c[qb+4>>2])|0)==0:0){Fa=Ha;Oa=Ja}else{b=k;return b|0}}e=Oa+49152+(Fa<<6)|0;if(!(Rf(b,e)|0)){b=k;return b|0}c[k>>2]=e;b=k+8|0;return b|0}else{H=b+328|0;u=H;I=b+264|0;x=I;t=c[x>>2]&c[u>>2];u=c[x+4>>2]&c[u+4>>2];x=t&65280;t=t&-65281;M=b+320|0;v=M;w=c[v>>2]|0;v=c[v+4>>2]|0;y=c[pb>>2]|0;f=av(t|0,u|0,8)|0;f=f&jb;k=D&kb;av(f|0,k|0,8)|0;o=D;p=(y|0)==4;p=p?65535:255;switch(y|0){case 4:{if(!(c[b+360>>2]|0))A=64;else mb=177;break}case 2:{if(!(c[b+360>>2]|0))A=64;else mb=177;break}case 1:{if(!(c[b+360>>2]|0))A=64;else mb=177;break}default:mb=177}if((mb|0)==177)A=c[b+1936>>2]|0;q=31888+(A<<3)|0;F=c[q+4>>2]|0;q=c[q>>2]&f;k=F&k;f=p&kb&o&F;F=c[lb>>2]|0;G=c[ob>>2]|0;E=G+344+((F^1)<<3)|0;B=c[E>>2]|0;E=c[E+4>>2]|0;F=b+320+(F<<3)|0;C=c[F>>2]|0;F=c[F+4>>2]|0;p=B&t&C;o=E&u&F;if((p|0)==0&(o|0)==0)o=0;else{hb=av(p|0,o|0,8)|0;o=31056+((A&7)<<3)|0;hb=hb&jb&~c[o>>2];o=D&kb&~c[o+4>>2];av(hb|0,o|0,8)|0;q=hb|q;k=o|k;o=0;f=kb&255&D|f}z=(y|0)==3;if((z?(c[b+4532>>2]|0)!=0:0)?(s=jb&-256,r=kb&16777215,!((s|0)==0&(r|0)==0)):0)while(1){p=d+8|0;hb=Qa(s|0,r|0,0)|0;fb=Yu(s|0,r|0,-1,-1)|0;s=fb&s;r=D&r;c[d>>2]=(hb|36864)+576;if((s|0)==0&(r|0)==0){d=p;break}else d=p}if(!((q|0)==0&(k|0)==0))while(1){hb=Qa(q|0,k|0,0)|0;p=Yu(q|0,k|0,-1,-1)|0;q=p&q;k=D&k;p=d+8|0;c[d>>2]=(hb|512)+(hb<<6);if((q|0)==0&(k|0)==0){d=p;break}else d=p}if(!((o|0)==0&(f|0)==0))while(1){hb=Qa(o|0,f|0,0)|0;k=Yu(o|0,f|0,-1,-1)|0;o=k&o;f=D&f;k=d+8|0;c[d>>2]=(hb|1024)+(hb<<6);if((o|0)==0&(f|0)==0){d=k;break}else d=k}i:do if(!((x|0)==0&0==0)){q=av(x|0,0,9)|0;q=q&w;p=D&v;o=av(x|0,0,7)|0;o=w&254&o;k=av(x|0,0,8)|0;k=k&jb;f=D&kb;switch(y|0){case 4:{if(!(c[b+360>>2]|0))J=64;else mb=193;break}case 2:{if(!(c[b+360>>2]|0))J=64;else mb=193;break}case 1:{if(!(c[b+360>>2]|0))J=64;else mb=193;break}default:mb=193}if((mb|0)==193)J=c[b+1936>>2]|0;j:do if(!((q|0)==0&(p|0)==0)){if((y|0)==1)while(1){hb=Yu(q|0,p|0,-1,-1)|0;q=hb&q;p=D&p;if((q|0)==0&(p|0)==0)break j}u=30544+(J<<3)|0;t=c[u>>2]|0;u=c[u+4>>2]|0;while(1){while(1){r=Qa(q|0,p|0,0)|0;hb=Yu(q|0,p|0,-1,-1)|0;q=hb&q;p=D&p;hb=32400+(r<<3)|0;if(!((c[hb>>2]&t|0)==0?(c[hb+4>>2]&u|0)==0:0))break;if((q|0)==0&(p|0)==0)break j}s=d+8|0;c[d>>2]=r+16960+(r<<6);if((q|0)==0&(p|0)==0){d=s;break}else d=s}}while(0);k:do if(!((o|0)==0&0==0)){if((y|0)==1){p=0;while(1){hb=Yu(o|0,p|0,-1,-1)|0;o=hb&o;p=D&p;if((o|0)==0&(p|0)==0)break k}}t=30544+(J<<3)|0;s=c[t>>2]|0;t=c[t+4>>2]|0;p=0;while(1){while(1){q=Qa(o|0,p|0,0)|0;hb=Yu(o|0,p|0,-1,-1)|0;o=hb&o;p=D&p;hb=32400+(q<<3)|0;if(!((c[hb>>2]&s|0)==0?(c[hb+4>>2]&t|0)==0:0))break;if((o|0)==0&(p|0)==0)break k}r=d+8|0;c[d>>2]=q+16832+(q<<6);if((o|0)==0&(p|0)==0){d=r;break}else d=r}}while(0);if(!((k|0)==0&(f|0)==0)){if((y|0)==1)while(1){hb=Yu(k|0,f|0,-1,-1)|0;k=hb&k;f=D&f;if((k|0)==0&(f|0)==0)break i}r=30544+(J<<3)|0;q=c[r>>2]|0;r=c[r+4>>2]|0;while(1){while(1){o=Qa(k|0,f|0,0)|0;hb=Yu(k|0,f|0,-1,-1)|0;k=hb&k;f=D&f;hb=32400+(o<<3)|0;if(!((c[hb>>2]&q|0)==0?(c[hb+4>>2]&r|0)==0:0))break;if((k|0)==0&(f|0)==0)break i}p=d+8|0;c[d>>2]=(o|16896)+(o<<6);if((k|0)==0&(f|0)==0){d=p;break}else d=p}}}while(0);if(z?(c[b+4528>>2]|0)!=(c[b+4532>>2]|0):0){if((c[b+4536>>2]|0)!=0?(K=G+392|0,n=c[K>>2]&jb,K=c[K+4>>2]&kb,!((n|0)==0&(K|0)==0)):0){k=K;while(1){f=d+8|0;hb=Qa(n|0,k|0,0)|0;fb=Yu(n|0,k|0,-1,-1)|0;n=fb&n;k=D&k;c[d>>2]=hb|37504;if((n|0)==0&(k|0)==0){d=f;break}else d=f}}if((c[b+4540>>2]|0)!=0?(L=G+400|0,m=c[L>>2]&jb,L=c[L+4>>2]&kb,!((m|0)==0&(L|0)==0)):0){k=L;while(1){f=d+8|0;hb=Qa(m|0,k|0,0)|0;fb=Yu(m|0,k|0,-1,-1)|0;m=fb&m;k=D&k;c[d>>2]=(hb|36864)+704;if((m|0)==0&(k|0)==0){d=f;break}else d=f}}if((c[b+4544>>2]|0)!=0?(i=G+408|0,j=c[i>>2]&jb,i=c[i+4>>2]&kb,!((j|0)==0&(i|0)==0)):0)while(1){f=d+8|0;hb=Qa(j|0,i|0,0)|0;fb=Yu(j|0,i|0,-1,-1)|0;j=fb&j;i=D&i;c[d>>2]=hb|37632;if((j|0)==0&(i|0)==0){d=f;break}else d=f}if((c[b+4548>>2]|0)!=0?(g=G+416|0,h=c[g>>2]&jb,g=c[g+4>>2]&kb,!((h|0)==0&(g|0)==0)):0)while(1){f=d+8|0;hb=Qa(h|0,g|0,0)|0;fb=Yu(h|0,g|0,-1,-1)|0;h=fb&h;g=D&g;c[d>>2]=(hb|36864)+832;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}g=b+2960|0;f=c[g>>2]|0;if((f|0)!=64){n=C&B;m=F&E;k=G+392|0;j=g;do{hb=30544+(f<<3)|0;if(((n&c[hb>>2]|0)==0?(m&c[hb+4>>2]|0)==0:0)?(hb=32400+(f<<3)|0,R=k,Q=c[hb>>2]&jb&c[R>>2],R=c[hb+4>>2]&kb&c[R+4>>2],!((Q|0)==0&(R|0)==0)):0){i=f<<6;g=Q;h=R;while(1){f=d+8|0;hb=Qa(g|0,h|0,0)|0;fb=Yu(g|0,h|0,-1,-1)|0;g=fb&g;h=D&h;c[d>>2]=hb+i;if((g|0)==0&(h|0)==0){d=f;break}else d=f}}j=j+4|0;f=c[j>>2]|0}while((f|0)!=64)}d=hf(b,gf(b,ff(b,d,1,jb,kb)|0,1,jb,kb)|0,1,jb,kb)|0;f=c[pb>>2]|0;do if((f|0)==1){g=H;mb=b+304|0;f=c[mb>>2]&c[g>>2];g=c[mb+4>>2]&c[g+4>>2];if((f|0)==0&(g|0)==0)h=d;else{do{h=Qa(f|0,g|0,0)|0;i=Yu(f|0,g|0,-1,-1)|0;f=i&f;g=D&g;i=34448+(h<<3)|0;j=c[i>>2]&jb;i=c[i+4>>2]&kb;if(!((j|0)==0&(i|0)==0)){k=h<<6;while(1){h=d+8|0;mb=Qa(j|0,i|0,0)|0;hb=Yu(j|0,i|0,-1,-1)|0;j=hb&j;i=D&i;c[d>>2]=mb+k;if((j|0)==0&(i|0)==0){d=h;break}else d=h}}}while(!((f|0)==0&(g|0)==0));h=d}if((c[b+5368>>2]|0)==9){b=h;return b|0}d=c[(c[ob>>2]|0)+48>>2]|0;if((d|0)!=64){kb=qb;kb=Pf(b,d,c[kb>>2]|0,c[kb+4>>2]|0)|0;f=b+320+(c[lb>>2]<<3)|0;d=c[f>>2]|0;f=c[f+4>>2]|0;mb=I;if(!((d&kb&c[mb>>2]|0)==0?(f&D&c[mb+4>>2]|0)==0:0)){b=h;return b|0}}else{f=b+320+(c[lb>>2]<<3)|0;d=c[f>>2]|0;f=c[f+4>>2]|0}while(1){if((d|0)==0&(f|0)==0){mb=251;break}mb=Qa(d|0,f|0,0)|0;g=Yu(d|0,f|0,-1,-1)|0;f=D&f;kb=qb;kb=Cb(c[b+(mb<<2)>>2]|0,mb,c[kb>>2]|0,c[kb+4>>2]|0)|0;mb=b+320+((c[lb>>2]^1)<<3)|0;if(!((c[mb>>2]&kb|0)==0?(c[mb+4>>2]&D|0)==0:0)){nb=h;mb=328;break}else d=g&d}if((mb|0)==251){l=h;V=c[pb>>2]|0;break}else if((mb|0)==328)return nb|0}else{l=d;V=f}while(0);if((V|0)==6?Te(b)|0:0){b=l;return b|0}d=c[(c[ob>>2]|0)+24>>2]|0;if(!(d&12)){b=l;return b|0}k=qb;f=c[k>>2]|0;k=c[k+4>>2]|0;lb=b+5240|0;d=(d&4|0)==0|(c[lb>>2]&f|0?1:(c[lb+4>>2]&k|0)!=0);if(!(a[b+5360>>0]|0)){l:do if(!d){switch(c[pb>>2]|0){case 4:{if(!(c[b+392>>2]|0))mb=298;else mb=299;break}case 2:{if(!(c[b+392>>2]|0))mb=298;else mb=299;break}case 1:{X=c[b+5096>>2]|0;_=c[b+5160>>2]|0;break}default:mb=299}if((mb|0)==298){ya=64;Ba=c[b+5160>>2]|0;mb=300}else if((mb|0)==299){e=c[b+3984>>2]|0;d=c[b+5160>>2]|0;if((e|0)==62){X=62;_=d}else{ya=e;Ba=d;mb=300}}m:do if((mb|0)==300){h=M;g=c[h>>2]|0;h=c[h+4>>2]|0;i=b+360|0;j=b+1936|0;e=62;d=k;while(1){nb=Pf(b,e,f,d)|0;if(!((nb&g|0)==0&(D&h|0)==0)){if((c[pb>>2]|0)!=2)break l;if(!(c[i>>2]|0))d=64;else d=c[j>>2]|0;nb=34448+(d<<3)|0;lb=30544+(e<<3)|0;if((c[lb>>2]&c[nb>>2]|0)==0?(c[lb+4>>2]&c[nb+4>>2]|0)==0:0)break l}e=e+-1|0;if((e|0)==(ya|0)){X=ya;_=Ba;break m}d=qb;f=c[d>>2]|0;d=c[d+4>>2]|0}}while(0);e=_+49152+(X<<6)|0;if(Rf(b,e)|0){c[l>>2]=e;l=l+8|0}}while(0);k=qb;f=c[k>>2]|0;k=c[k+4>>2]|0;nb=b+5272|0;if(!((c[nb>>2]&f|0)==0?(c[nb+4>>2]&k|0)==0:0)){b=l;return b|0}if(!(c[(c[ob>>2]|0)+24>>2]&8)){b=l;return b|0}switch(c[pb>>2]|0){case 4:{if(!(c[b+392>>2]|0))mb=316;else mb=317;break}case 2:{if(!(c[b+392>>2]|0))mb=316;else mb=317;break}case 1:{db=c[b+5112>>2]|0;gb=c[b+5176>>2]|0;break}default:mb=317}if((mb|0)==316){bb=64;ib=c[b+5176>>2]|0;mb=318}else if((mb|0)==317){e=c[b+3984>>2]|0;d=c[b+5176>>2]|0;if((e|0)==58){db=58;gb=d}else{bb=e;ib=d;mb=318}}n:do if((mb|0)==318){h=M;g=c[h>>2]|0;h=c[h+4>>2]|0;i=b+360|0;j=b+1936|0;e=58;d=k;while(1){ob=Pf(b,e,f,d)|0;if(!((ob&g|0)==0&(D&h|0)==0)){if((c[pb>>2]|0)!=2){nb=l;mb=328;break}if(!(c[i>>2]|0))d=64;else d=c[j>>2]|0;ob=34448+(d<<3)|0;nb=30544+(e<<3)|0;if((c[nb>>2]&c[ob>>2]|0)==0?(c[nb+4>>2]&c[ob+4>>2]|0)==0:0){nb=l;mb=328;break}}e=e+1|0;if((e|0)==(bb|0)){db=bb;gb=ib;break n}d=qb;f=c[d>>2]|0;d=c[d+4>>2]|0}if((mb|0)==328)return nb|0}while(0);e=gb+49152+(db<<6)|0;if(!(Rf(b,e)|0)){b=l;return b|0}c[l>>2]=e;b=l+8|0;return b|0}o:do if(!d){switch(c[pb>>2]|0){case 4:{if(!(c[b+392>>2]|0))mb=260;else mb=262;break}case 2:{if(!(c[b+392>>2]|0))mb=260;else mb=262;break}case 1:{ma=c[b+5096>>2]|0;ra=c[b+5160>>2]|0;break}default:mb=262}if((mb|0)==260){pa=M;ka=64;oa=c[pa>>2]|0;pa=c[pa+4>>2]|0;qa=1;ta=c[b+5160>>2]|0;mb=263}else if((mb|0)==262){d=c[b+3984>>2]|0;g=c[b+5160>>2]|0;i=M;h=c[i>>2]|0;i=c[i+4>>2]|0;if((d|0)==62){ga=62;ia=g;ea=f;e=k;$=h;aa=i;mb=271}else{ka=d;oa=h;pa=i;qa=(d|0)<62?-1:1;ta=g;mb=263}}if((mb|0)==263){g=b+360|0;h=b+1936|0;d=62;e=k;do{lb=Pf(b,d,f,e)|0;if(!((lb&oa|0)==0&(D&pa|0)==0)){if((c[pb>>2]|0)!=2)break o;if(!(c[g>>2]|0))e=64;else e=c[h>>2]|0;lb=34448+(e<<3)|0;kb=30544+(d<<3)|0;if((c[kb>>2]&c[lb>>2]|0)==0?(c[kb+4>>2]&c[lb+4>>2]|0)==0:0)break o}d=d+qa|0;e=qb;f=c[e>>2]|0;e=c[e+4>>2]|0}while((d|0)!=(ka|0));aa=M;ga=ka;ia=ta;ea=f;$=c[aa>>2]|0;aa=c[aa+4>>2]|0;mb=271}if((mb|0)==271){lb=30544+(ia<<3)|0;kb=28992;jb=29504;jb=(S(c[kb+4>>2]&(c[lb+4>>2]^e),c[jb+4>>2]|0)|0)^(S(c[kb>>2]&(c[lb>>2]^ea),c[jb>>2]|0)|0);jb=(c[258919]|0)+(jb>>>(c[258983]|0)<<3)|0;lb=b+288|0;kb=b+296|0;if((c[jb>>2]&$&(c[kb>>2]|c[lb>>2])|0)==0?(c[jb+4>>2]&aa&(c[kb+4>>2]|c[lb+4>>2])|0)==0:0){ma=ga;ra=ia}else break}e=ra+49152+(ma<<6)|0;if(Rf(b,e)|0){c[l>>2]=e;l=l+8|0}}while(0);j=qb;i=c[j>>2]|0;j=c[j+4>>2]|0;lb=b+5272|0;if(!((c[lb>>2]&i|0)==0?(c[lb+4>>2]&j|0)==0:0)){b=l;return b|0}if(!(c[(c[ob>>2]|0)+24>>2]&8)){b=l;return b|0}switch(c[pb>>2]|0){case 4:{if(!(c[b+392>>2]|0))mb=279;else mb=281;break}case 2:{if(!(c[b+392>>2]|0))mb=279;else mb=281;break}case 1:{Ea=c[b+5112>>2]|0;Ya=c[b+5176>>2]|0;break}default:mb=281}if((mb|0)==279){Ra=M;Ca=64;Pa=c[Ra>>2]|0;Ra=c[Ra+4>>2]|0;Sa=1;_a=c[b+5176>>2]|0;mb=282}else if((mb|0)==281){e=c[b+3984>>2]|0;d=c[b+5176>>2]|0;g=M;f=c[g>>2]|0;g=c[g+4>>2]|0;if((e|0)==58){Ga=58;Ta=d;Ua=i;Va=j;Wa=f;Xa=g;mb=290}else{Ca=e;Pa=f;Ra=g;Sa=(e|0)<58?-1:1;_a=d;mb=282}}do if((mb|0)==282){g=b+360|0;h=b+1936|0;f=58;d=j;while(1){ob=Pf(b,f,i,d)|0;if(!((ob&Pa|0)==0&(D&Ra|0)==0)){if((c[pb>>2]|0)!=2){nb=l;mb=328;break}if(!(c[g>>2]|0))e=64;else e=c[h>>2]|0;ob=34448+(e<<3)|0;mb=30544+(f<<3)|0;if((c[mb>>2]&c[ob>>2]|0)==0?(c[mb+4>>2]&c[ob+4>>2]|0)==0:0){nb=l;mb=328;break}}f=f+Sa|0;d=qb;i=c[d>>2]|0;d=c[d+4>>2]|0;if((f|0)==(Ca|0)){mb=289;break}}if((mb|0)==289){Xa=M;Ga=Ca;Ta=_a;Ua=i;Va=d;Wa=c[Xa>>2]|0;Xa=c[Xa+4>>2]|0;mb=290;break}else if((mb|0)==328)return nb|0}while(0);if((mb|0)==290){qb=30544+(Ta<<3)|0;pb=28960;ob=29472;ob=(S(c[pb+4>>2]&(c[qb+4>>2]^Va),c[ob+4>>2]|0)|0)^(S(c[pb>>2]&(c[qb>>2]^Ua),c[ob>>2]|0)|0);ob=(c[258915]|0)+(ob>>>(c[258979]|0)<<3)|0;qb=b+288|0;pb=b+296|0;if((c[ob>>2]&Wa&(c[pb>>2]|c[qb>>2])|0)==0?(c[ob+4>>2]&Xa&(c[pb+4>>2]|c[qb+4>>2])|0)==0:0){Ea=Ga;Ya=Ta}else{b=l;return b|0}}e=Ya+49152+(Ea<<6)|0;if(!(Rf(b,e)|0)){b=l;return b|0}c[l>>2]=e;b=l+8|0;return b|0}return 0}function ff(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=a+400+((d<<3|3)<<8)|0;g=c[d>>2]|0;if((g|0)==64){f=b;return f|0}k=c[a+5356>>2]|0;m=k+400|0;l=c[m>>2]|0;m=c[m+4>>2]|0;n=a+5348|0;o=a+256|0;p=l&e;q=m&f;do{j=113808+(g<<3)|0;if((!((c[j>>2]&e&l|0)==0?(c[j+4>>2]&f&m|0)==0:0)?(h=c[n>>2]|0,i=k+344+((h^1)<<3)|0,h=a+320+(h<<3)|0,j=30544+(g<<3)|0,(c[h>>2]&c[i>>2]&c[j>>2]|0)==0?(c[h+4>>2]&c[i+4>>2]&c[j+4>>2]|0)==0:0):0)?(r=o,j=29520+(g<<3)|0,s=30032+(g<<3)|0,s=(S(c[j+4>>2]&c[r+4>>2],c[s+4>>2]|0)|0)^(S(c[j>>2]&c[r>>2],c[s>>2]|0)|0),s=(c[1035940+(g<<2)>>2]|0)+(s>>>(c[1036196+(g<<2)>>2]|0)<<3)|0,r=p&c[s>>2],s=q&c[s+4>>2],!((r|0)==0&(s|0)==0)):0){j=g<<6;h=r;i=s;while(1){g=b+8|0;t=Qa(h|0,i|0,0)|0;u=Yu(h|0,i|0,-1,-1)|0;h=u&h;i=D&i;c[b>>2]=t+j;if((h|0)==0&(i|0)==0){b=g;break}else b=g}}d=d+4|0;g=c[d>>2]|0}while((g|0)!=64);return b|0}function gf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=a+400+((d<<3|4)<<8)|0;g=c[d>>2]|0;if((g|0)==64){f=b;return f|0}k=c[a+5356>>2]|0;m=k+408|0;l=c[m>>2]|0;m=c[m+4>>2]|0;n=a+5348|0;o=a+256|0;p=l&e;q=m&f;do{j=114320+(g<<3)|0;if((!((c[j>>2]&e&l|0)==0?(c[j+4>>2]&f&m|0)==0:0)?(h=c[n>>2]|0,i=k+344+((h^1)<<3)|0,h=a+320+(h<<3)|0,j=30544+(g<<3)|0,(c[h>>2]&c[i>>2]&c[j>>2]|0)==0?(c[h+4>>2]&c[i+4>>2]&c[j+4>>2]|0)==0:0):0)?(r=o,j=28496+(g<<3)|0,s=29008+(g<<3)|0,s=(S(c[j+4>>2]&c[r+4>>2],c[s+4>>2]|0)|0)^(S(c[j>>2]&c[r>>2],c[s>>2]|0)|0),s=(c[1035428+(g<<2)>>2]|0)+(s>>>(c[1035684+(g<<2)>>2]|0)<<3)|0,r=p&c[s>>2],s=q&c[s+4>>2],!((r|0)==0&(s|0)==0)):0){j=g<<6;h=r;i=s;while(1){g=b+8|0;t=Qa(h|0,i|0,0)|0;u=Yu(h|0,i|0,-1,-1)|0;h=u&h;i=D&i;c[b>>2]=t+j;if((h|0)==0&(i|0)==0){b=g;break}else b=g}}d=d+4|0;g=c[d>>2]|0}while((g|0)!=64);return b|0}function hf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=a+400+((d<<3|5)<<8)|0;g=c[d>>2]|0;if((g|0)==64){f=b;return f|0}k=c[a+5356>>2]|0;m=k+416|0;l=c[m>>2]|0;m=c[m+4>>2]|0;n=a+5348|0;o=a+256|0;p=l&e;q=m&f;do{j=114832+(g<<3)|0;if((!((c[j>>2]&e&l|0)==0?(c[j+4>>2]&f&m|0)==0:0)?(h=c[n>>2]|0,i=k+344+((h^1)<<3)|0,h=a+320+(h<<3)|0,j=30544+(g<<3)|0,(c[h>>2]&c[i>>2]&c[j>>2]|0)==0?(c[h+4>>2]&c[i+4>>2]&c[j+4>>2]|0)==0:0):0)?(h=o,r=c[h>>2]|0,h=c[h+4>>2]|0,i=28496+(g<<3)|0,s=29008+(g<<3)|0,s=(S(c[i+4>>2]&h,c[s+4>>2]|0)|0)^(S(c[i>>2]&r,c[s>>2]|0)|0),s=(c[1035428+(g<<2)>>2]|0)+(s>>>(c[1035684+(g<<2)>>2]|0)<<3)|0,i=29520+(g<<3)|0,j=30032+(g<<3)|0,j=(S(c[i+4>>2]&h,c[j+4>>2]|0)|0)^(S(c[i>>2]&r,c[j>>2]|0)|0),j=(c[1035940+(g<<2)>>2]|0)+(j>>>(c[1036196+(g<<2)>>2]|0)<<3)|0,r=p&(c[j>>2]|c[s>>2]),s=q&(c[j+4>>2]|c[s+4>>2]),!((r|0)==0&(s|0)==0)):0){j=g<<6;h=r;i=s;while(1){g=b+8|0;t=Qa(h|0,i|0,0)|0;u=Yu(h|0,i|0,-1,-1)|0;h=u&h;i=D&i;c[b>>2]=t+j;if((h|0)==0&(i|0)==0){b=g;break}else b=g}}d=d+4|0;g=c[d>>2]|0}while((g|0)!=64);return b|0}function jf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;L=a+5364|0;h=c[L>>2]|0;if((h|0)==1){M=b;return M|0}M=a+5348|0;q=c[M>>2]|0;switch(h|0){case 4:{d=q<<3|6;if(!(c[a+336+(d<<2)>>2]|0))p=64;else{e=d;g=6}break}case 2:{d=q<<3|6;if(!(c[a+336+(d<<2)>>2]|0))p=64;else{e=d;g=6}break}default:{e=q<<3|6;g=6}}if((g|0)==6)p=c[a+400+(e<<8)>>2]|0;C=a+5356|0;i=(c[C>>2]|0)+64|0;e=c[i>>2]|0;i=c[i+4>>2]|0;g=a+272|0;J=a+264|0;I=J;o=e&~(c[I>>2]|c[g>>2]);g=i&~(c[I+4>>2]|c[g+4>>2]);do if((h|0)==2){d=q<<3^14;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;l=34448+(d<<3)|0;k=c[l>>2]|0;l=c[l+4>>2]|0;n=a+320+((q^1)<<3)|0;m=c[n>>2]|0;n=c[n+4>>2]|0;if((e|0)==0&(i|0)==0){d=m;h=n}else{h=n;d=m;do{H=Qa(e|0,i|0,0)|0;I=Yu(e|0,i|0,-1,-1)|0;e=I&e;i=D&i;I=34448+(H<<3)|0;H=30544+(H<<3)|0;d=(c[H>>2]|c[I>>2])&d;h=(c[H+4>>2]|c[I+4>>2])&h}while(!((e|0)==0&(i|0)==0))}I=34448+(p<<3)|0;e=m&(d|k)&~c[I>>2];d=n&(h|l)&~c[I+4>>2];if(!q){b=Ue(a,b,e,d)|0;break}else{b=Ve(a,b,e,d)|0;break}}else{k=0;l=0}while(0);if((o|0)==0&(g|0)==0){d=0;i=0}else{h=o;d=0;e=0;do{H=Qa(h|0,g|0,0)|0;I=Yu(h|0,g|0,-1,-1)|0;h=I&h;g=D&g;I=72336+(H<<9)+(p<<3)|0;H=30544+(H<<3)|0;d=c[H>>2]^c[I>>2]|d;e=c[H+4>>2]^c[I+4>>2]|e}while(!((h|0)==0&(g|0)==0));i=e}g=c[L>>2]|0;h=34448+(p<<3)|0;e=c[h>>2]|0;h=c[h+4>>2]|0;if((g|0)!=2){I=a+320+(q<<3)|0;e=e&~d&~c[I>>2];d=h&~i&~c[I+4>>2];if((g|0)==6?Te(a)|0:0){I=a+320+((q^1)<<3)|0;e=c[I>>2]&e;d=c[I+4>>2]&d}}else{I=a+256|0;e=e&(k|~d)&~c[I>>2];d=h&(l|~i)&~c[I+4>>2]}if(!((e|0)==0&(d|0)==0)){h=p<<6;g=e;while(1){e=b+8|0;I=Qa(g|0,d|0,0)|0;H=Yu(g|0,d|0,-1,-1)|0;g=H&g;d=D&d;c[b>>2]=I+h;if((g|0)==0&(d|0)==0){b=e;break}else b=e}}e=(c[C>>2]|0)+64|0;d=c[e>>2]|0;e=c[e+4>>2]|0;I=Yu(d|0,e|0,-1,-1)|0;if(!((I&d|0)==0&(D&e|0)==0)){M=b;return M|0}e=Qa(d|0,e|0,0)|0;h=c[L>>2]|0;g=39568+(e<<9)+(p<<3)|0;d=c[g>>2]|0;g=c[g+4>>2]|0;if((h|0)!=2){e=30544+(e<<3)|0;d=c[e>>2]|d;e=c[e+4>>2]|g;if((h|0)==6?Te(a)|0:0){H=a+320+((q^1)<<3)|0;I=c[H>>2]&d;H=c[H+4>>2]&e}else{I=d;H=e}}else{I=d;H=g}if(!q){y=a+320|0;s=c[y>>2]|0;y=c[y+4>>2]|0;m=J;p=c[m>>2]&s;m=c[m+4>>2]&y;j=m&16711680;q=m&-16711681;o=a+328|0;n=c[o>>2]&I;o=c[o+4>>2]&H;B=a+256|0;A=B;z=c[A>>2]|0;A=c[A+4>>2]|0;i=~z;F=~A;v=c[L>>2]|0;x=(v|0)==1;k=I&i;l=H&F;d=gv(p|0,q|0,8)|0;e=D;F=gv((x?k:i)&d|0,(x?l:F)&e|0,8)|0;i=(v|0)==4;h=i?-65536:-16777216;h=F&h;if((v|0)!=6){i=k&d;f=l&e;e=h&k;if(((v|0)==3?(c[a+4500>>2]|0)!=0:0)?(r=k&-256,t=l&16777215,!((r|0)==0&(t|0)==0)):0){h=r;g=t;while(1){d=b+8|0;F=Qa(h|0,g|0,0)|0;t=Yu(h|0,g|0,-1,-1)|0;h=t&h;g=D&g;c[b>>2]=(F|36864)+64;if((h|0)==0&(g|0)==0){b=d;g=i;d=0;break}else b=d}}else{g=i;d=0}}else{g=d&k;f=e&l;e=h&k;d=0}if(!((g|0)==0&(f|0)==0)){h=b;while(1){F=Qa(g|0,f|0,0)|0;b=Yu(g|0,f|0,-1,-1)|0;g=b&g;f=D&f;b=h+8|0;c[h>>2]=(F|-512)+(F<<6);if((g|0)==0&(f|0)==0)break;else h=b}}if(!((e|0)==0&(d|0)==0)){f=b;while(1){F=Qa(e|0,d|0,0)|0;b=Yu(e|0,d|0,-1,-1)|0;e=b&e;d=D&d;b=f+8|0;c[f>>2]=(F|-1024)+(F<<6);if((e|0)==0&(d|0)==0)break;else f=b}}a:do if((H>>>0>16777215|(H|0)==16777215&I>>>0>4294967295)&(0!=0|(j|0)!=0)){e=gv(0,j|0,9)|0;d=v;e=e&n;f=D&o;b:while(1){while(1){if((e|0)==0&(f|0)==0)break b;g=Yu(e|0,f|0,-1,-1)|0;g=g&e;h=D&f;if((d|0)==1){d=1;e=g;f=h}else break}f=Qa(e|0,f|0,0)|0;e=f<<6;c[b>>2]=f+28096+e;c[b+8>>2]=f+24e3+e;c[b+16>>2]=f+19904+e;c[b+24>>2]=f+15808+e;b=b+32|0;e=g;f=h}gv(0,j|0,7)|0;d=v;e=0;f=o&2130706432&D;c:while(1){while(1){if((e|0)==0&(f|0)==0)break c;g=Yu(e|0,f|0,-1,-1)|0;g=g&e;h=D&f;if((d|0)==1){d=1;e=g;f=h}else break}f=Qa(e|0,f|0,0)|0;e=f<<6;c[b>>2]=f+28224+e;c[b+8>>2]=f+24128+e;c[b+16>>2]=f+20032+e;c[b+24>>2]=f+15936+e;b=b+32|0;e=g;f=h}e=gv(0,j|0,8)|0;g=v;e=e&k;d=D&l;while(1){while(1){if((e|0)==0&(d|0)==0)break a;f=Yu(e|0,d|0,-1,-1)|0;f=f&e;h=D&d;if((g|0)==1){g=1;e=f;d=h}else break}d=Qa(e|0,d|0,0)|0;e=d<<6;c[b>>2]=(d|28160)+e;c[b+8>>2]=(d|24064)+e;c[b+16>>2]=(d|19968)+e;c[b+24>>2]=(d|15872)+e;b=b+32|0;e=f;d=h}}while(0);g=gv(p|0,m|0,9)|0;g=g&-16843264&n;f=D&16711422&o;e=gv(p|0,m|0,7)|0;e=e&2139062016&n;d=D&8355711&o;if(!((g|0)==0&(f|0)==0)){h=b;while(1){F=Qa(g|0,f|0,0)|0;b=Yu(g|0,f|0,-1,-1)|0;g=b&g;f=D&f;b=h+8|0;c[h>>2]=F+-576+(F<<6);if((g|0)==0&(f|0)==0)break;else h=b}}if(!((e|0)==0&(d|0)==0)){f=b;while(1){F=Qa(e|0,d|0,0)|0;b=Yu(e|0,d|0,-1,-1)|0;e=b&e;d=D&d;b=f+8|0;c[f>>2]=F+-448+(F<<6);if((e|0)==0&(d|0)==0)break;else f=b}}h=c[C>>2]|0;k=c[h+48>>2]|0;l=(k|0)==64;if((!l?(F=30544+(k+-8<<3)|0,!((c[F>>2]&I|0)==0?(c[F+4>>2]&H|0)==0:0)):0)?(w=35984+(k<<3)|0,u=c[w>>2]&p,w=c[w+4>>2]&q,!((u|0)==0&(w|0)==0)):0){g=k+8192|0;f=u;e=w;while(1){d=b+8|0;F=Qa(f|0,e|0,0)|0;C=Yu(f|0,e|0,-1,-1)|0;f=C&f;e=D&e;c[b>>2]=g+(F<<6|24576);if((f|0)==0&(e|0)==0){b=d;break}else b=d}}do if((v|0)==3?(c[a+4496>>2]|0)!=(c[a+4500>>2]|0):0){e=h+64|0;f=c[e>>2]^I;e=c[e+4>>2]^H;i=(f|0)!=0|(e|0)!=0;if((c[a+4504>>2]|0)!=0&i){g=f;h=e;while(1){d=b+8|0;F=Qa(g|0,h|0,0)|0;C=Yu(g|0,h|0,-1,-1)|0;g=C&g;h=D&h;c[b>>2]=F|36992;if((g|0)==0&(h|0)==0){b=d;break}else b=d}}if(i&(c[a+4508>>2]|0)!=0){g=f;h=e;while(1){d=b+8|0;F=Qa(g|0,h|0,0)|0;C=Yu(g|0,h|0,-1,-1)|0;g=C&g;h=D&h;c[b>>2]=(F|36864)+192;if((g|0)==0&(h|0)==0){b=d;break}else b=d}}if(i&(c[a+4512>>2]|0)!=0){g=f;h=e;while(1){d=b+8|0;F=Qa(g|0,h|0,0)|0;C=Yu(g|0,h|0,-1,-1)|0;g=C&g;h=D&h;c[b>>2]=F|37120;if((g|0)==0&(h|0)==0){b=d;break}else b=d}}if(!(i&(c[a+4516>>2]|0)!=0))break;while(1){d=b+8|0;F=Qa(f|0,e|0,0)|0;C=Yu(f|0,e|0,-1,-1)|0;f=C&f;e=D&e;c[b>>2]=(F|36864)+320;if((f|0)==0&(e|0)==0){b=d;break}else b=d}}while(0);d=a+912|0;e=c[d>>2]|0;if((e|0)!=64)do{f=32400+(e<<3)|0;g=c[f>>2]&I;f=c[f+4>>2]&H;if(!((g|0)==0&(f|0)==0)){h=e<<6;while(1){e=b+8|0;F=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[b>>2]=F+h;if((g|0)==0&(f|0)==0){b=e;break}else b=e}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+1168|0;e=c[d>>2]|0;if((e|0)!=64)do{g=29520+(e<<3)|0;f=30032+(e<<3)|0;f=(S(c[g+4>>2]&A,c[f+4>>2]|0)|0)^(S(c[g>>2]&z,c[f>>2]|0)|0);f=(c[1035940+(e<<2)>>2]|0)+(f>>>(c[1036196+(e<<2)>>2]|0)<<3)|0;g=c[f>>2]&I;f=c[f+4>>2]&H;if(!((g|0)==0&(f|0)==0)){h=e<<6;while(1){e=b+8|0;F=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[b>>2]=F+h;if((g|0)==0&(f|0)==0){b=e;break}else b=e}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+1424|0;e=c[d>>2]|0;if((e|0)!=64)do{g=28496+(e<<3)|0;f=29008+(e<<3)|0;f=(S(c[g+4>>2]&A,c[f+4>>2]|0)|0)^(S(c[g>>2]&z,c[f>>2]|0)|0);f=(c[1035428+(e<<2)>>2]|0)+(f>>>(c[1035684+(e<<2)>>2]|0)<<3)|0;g=c[f>>2]&I;f=c[f+4>>2]&H;if(!((g|0)==0&(f|0)==0)){h=e<<6;while(1){e=b+8|0;F=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[b>>2]=F+h;if((g|0)==0&(f|0)==0){b=e;break}else b=e}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+1680|0;e=c[d>>2]|0;if((e|0)!=64)do{g=28496+(e<<3)|0;f=29008+(e<<3)|0;f=(S(c[g+4>>2]&A,c[f+4>>2]|0)|0)^(S(c[g>>2]&z,c[f>>2]|0)|0);f=(c[1035428+(e<<2)>>2]|0)+(f>>>(c[1035684+(e<<2)>>2]|0)<<3)|0;g=29520+(e<<3)|0;F=30032+(e<<3)|0;F=(S(c[g+4>>2]&A,c[F+4>>2]|0)|0)^(S(c[g>>2]&z,c[F>>2]|0)|0);F=(c[1035940+(e<<2)>>2]|0)+(F>>>(c[1036196+(e<<2)>>2]|0)<<3)|0;g=(c[F>>2]|c[f>>2])&I;f=(c[F+4>>2]|c[f+4>>2])&H;if(!((g|0)==0&(f|0)==0)){h=e<<6;while(1){e=b+8|0;F=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[b>>2]=F+h;if((g|0)==0&(f|0)==0){b=e;break}else b=e}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);do if(x){e=a+304|0;d=c[e>>2]&s;e=c[e+4>>2]&y;if((d|0)==0&(e|0)==0)f=b;else{do{f=Qa(d|0,e|0,0)|0;i=Yu(d|0,e|0,-1,-1)|0;d=i&d;e=D&e;i=34448+(f<<3)|0;g=c[i>>2]&I;i=c[i+4>>2]&H;if(!((g|0)==0&(i|0)==0)){j=f<<6;h=b;f=i;while(1){b=h+8|0;F=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[h>>2]=F+j;if((g|0)==0&(f|0)==0)break;else h=b}}}while(!((d|0)==0&(e|0)==0));f=b}if((c[a+5368>>2]|0)==9){M=f;return M|0}do if(l){d=a+320+(c[M>>2]<<3)|0;b=c[d>>2]|0;d=c[d+4>>2]|0}else{I=Pf(a,k,z,A)|0;d=a+320+(c[M>>2]<<3)|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if((b&I&c[J>>2]|0)==0?(d&D&c[J+4>>2]|0)==0:0)break;else K=f;return K|0}while(0);while(1){if((b|0)==0&(d|0)==0){g=108;break}J=Qa(b|0,d|0,0)|0;e=Yu(b|0,d|0,-1,-1)|0;d=D&d;I=B;I=Cb(c[a+(J<<2)>>2]|0,J,c[I>>2]|0,c[I+4>>2]|0)|0;J=a+320+((c[M>>2]^1)<<3)|0;if(!((c[J>>2]&I|0)==0?(c[J+4>>2]&D|0)==0:0)){K=f;g=191;break}else b=e&b}if((g|0)==108){E=f;G=c[L>>2]|0;break}else if((g|0)==191)return K|0}else{E=b;G=v}while(0);if((G|0)!=6){M=E;return M|0}Te(a)|0;M=E;return M|0}else{x=a+328|0;t=c[x>>2]|0;x=c[x+4>>2]|0;q=J;n=c[q>>2]&t;q=c[q+4>>2]&x;k=n&65280;r=n&-65281;p=a+320|0;o=c[p>>2]&I;p=c[p+4>>2]&H;A=a+256|0;z=A;y=c[z>>2]|0;z=c[z+4>>2]|0;h=~y;G=~z;u=c[L>>2]|0;w=(u|0)==1;l=I&h;m=H&G;d=av(r|0,q|0,8)|0;e=D;av((w?l:h)&d|0,(w?m:G)&e|0,8)|0;G=D;h=(u|0)==4;h=G&(h?65535:255);if((u|0)!=6){i=l&d;e=m&e;d=h&m;if(((u|0)==3?(c[a+4532>>2]|0)!=0:0)?(j=l&-256,s=m&16777215,!((j|0)==0&(s|0)==0)):0){h=s;while(1){g=b+8|0;G=Qa(j|0,h|0,0)|0;E=Yu(j|0,h|0,-1,-1)|0;j=E&j;h=D&h;c[b>>2]=(G|36864)+576;if((j|0)==0&(h|0)==0){b=g;g=0;break}else b=g}}else g=0}else{i=d&l;e=e&m;g=0;d=h&m}if(!((i|0)==0&(e|0)==0))while(1){G=Qa(i|0,e|0,0)|0;h=Yu(i|0,e|0,-1,-1)|0;i=h&i;e=D&e;h=b+8|0;c[b>>2]=(G|512)+(G<<6);if((i|0)==0&(e|0)==0){b=h;break}else b=h}if(!((g|0)==0&(d|0)==0))while(1){G=Qa(g|0,d|0,0)|0;e=Yu(g|0,d|0,-1,-1)|0;g=e&g;d=D&d;e=b+8|0;c[b>>2]=(G|1024)+(G<<6);if((g|0)==0&(d|0)==0){b=e;break}else b=e}d:do if(!((I&255|0)==0&0==0|(k|0)==0&0==0)){g=av(k|0,0,9)|0;d=u;g=g&o;e=D&p;e:while(1){while(1){if((g|0)==0&(e|0)==0)break e;h=Yu(g|0,e|0,-1,-1)|0;h=h&g;i=D&e;if((d|0)==1){d=1;g=h;e=i}else break}e=Qa(g|0,e|0,0)|0;g=e<<6;c[b>>2]=e+29248+g;c[b+8>>2]=e+25152+g;c[b+16>>2]=e+21056+g;c[b+24>>2]=e+16960+g;b=b+32|0;g=h;e=i}g=av(k|0,0,7)|0;d=u;g=o&254&g;e=0;f:while(1){while(1){if((g|0)==0&(e|0)==0)break f;h=Yu(g|0,e|0,-1,-1)|0;h=h&g;i=D&e;if((d|0)==1){d=1;g=h;e=i}else break}e=Qa(g|0,e|0,0)|0;g=e<<6;c[b>>2]=e+29120+g;c[b+8>>2]=e+25024+g;c[b+16>>2]=e+20928+g;c[b+24>>2]=e+16832+g;b=b+32|0;g=h;e=i}e=av(k|0,0,8)|0;h=u;e=e&l;d=D&m;while(1){while(1){if((e|0)==0&(d|0)==0)break d;g=Yu(e|0,d|0,-1,-1)|0;g=g&e;i=D&d;if((h|0)==1){h=1;e=g;d=i}else break}d=Qa(e|0,d|0,0)|0;e=d<<6;c[b>>2]=(d|29184)+e;c[b+8>>2]=(d|25088)+e;c[b+16>>2]=(d|20992)+e;c[b+24>>2]=(d|16896)+e;b=b+32|0;e=g;d=i}}while(0);i=av(n|0,q|0,9)|0;i=i&2139062016&o;e=D&8355711&p;g=av(n|0,q|0,7)|0;g=g&-16843264&o;d=D&16711422&p;if(!((i|0)==0&(e|0)==0))while(1){G=Qa(i|0,e|0,0)|0;h=Yu(i|0,e|0,-1,-1)|0;i=h&i;e=D&e;h=b+8|0;c[b>>2]=G+576+(G<<6);if((i|0)==0&(e|0)==0){b=h;break}else b=h}if(!((g|0)==0&(d|0)==0))while(1){G=Qa(g|0,d|0,0)|0;e=Yu(g|0,d|0,-1,-1)|0;g=e&g;d=D&d;e=b+8|0;c[b>>2]=G+448+(G<<6);if((g|0)==0&(d|0)==0){b=e;break}else b=e}h=c[C>>2]|0;j=c[h+48>>2]|0;k=(j|0)==64;if((!k?(G=30544+(j+8<<3)|0,!((c[G>>2]&I|0)==0?(c[G+4>>2]&H|0)==0:0)):0)?(v=31888+(j<<3)|0,f=c[v>>2]&r,v=c[v+4>>2]&q,!((f|0)==0&(v|0)==0)):0){g=j+8192|0;e=v;while(1){d=b+8|0;G=Qa(f|0,e|0,0)|0;E=Yu(f|0,e|0,-1,-1)|0;f=E&f;e=D&e;c[b>>2]=g+(G<<6|24576);if((f|0)==0&(e|0)==0){b=d;break}else b=d}}do if((u|0)==3?(c[a+4528>>2]|0)!=(c[a+4532>>2]|0):0){e=h+64|0;f=c[e>>2]^I;e=c[e+4>>2]^H;i=(f|0)!=0|(e|0)!=0;if((c[a+4536>>2]|0)!=0&i){d=b;g=f;h=e;while(1){b=d+8|0;G=Qa(g|0,h|0,0)|0;E=Yu(g|0,h|0,-1,-1)|0;g=E&g;h=D&h;c[d>>2]=G|37504;if((g|0)==0&(h|0)==0)break;else d=b}}if(i&(c[a+4540>>2]|0)!=0){g=f;h=e;while(1){d=b+8|0;G=Qa(g|0,h|0,0)|0;E=Yu(g|0,h|0,-1,-1)|0;g=E&g;h=D&h;c[b>>2]=(G|36864)+704;if((g|0)==0&(h|0)==0){b=d;break}else b=d}}if(i&(c[a+4544>>2]|0)!=0){g=f;h=e;while(1){d=b+8|0;G=Qa(g|0,h|0,0)|0;E=Yu(g|0,h|0,-1,-1)|0;g=E&g;h=D&h;c[b>>2]=G|37632;if((g|0)==0&(h|0)==0){b=d;break}else b=d}}if(!(i&(c[a+4548>>2]|0)!=0))break;while(1){d=b+8|0;G=Qa(f|0,e|0,0)|0;E=Yu(f|0,e|0,-1,-1)|0;f=E&f;e=D&e;c[b>>2]=(G|36864)+832;if((f|0)==0&(e|0)==0){b=d;break}else b=d}}while(0);d=a+2960|0;e=c[d>>2]|0;if((e|0)!=64)do{h=32400+(e<<3)|0;f=c[h>>2]&I;h=c[h+4>>2]&H;if(!((f|0)==0&(h|0)==0)){i=e<<6;g=b;e=h;while(1){b=g+8|0;G=Qa(f|0,e|0,0)|0;E=Yu(f|0,e|0,-1,-1)|0;f=E&f;e=D&e;c[g>>2]=G+i;if((f|0)==0&(e|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+3216|0;e=c[d>>2]|0;if((e|0)!=64)do{f=29520+(e<<3)|0;h=30032+(e<<3)|0;h=(S(c[f+4>>2]&z,c[h+4>>2]|0)|0)^(S(c[f>>2]&y,c[h>>2]|0)|0);h=(c[1035940+(e<<2)>>2]|0)+(h>>>(c[1036196+(e<<2)>>2]|0)<<3)|0;f=c[h>>2]&I;h=c[h+4>>2]&H;if(!((f|0)==0&(h|0)==0)){i=e<<6;g=b;e=h;while(1){b=g+8|0;G=Qa(f|0,e|0,0)|0;E=Yu(f|0,e|0,-1,-1)|0;f=E&f;e=D&e;c[g>>2]=G+i;if((f|0)==0&(e|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+3472|0;e=c[d>>2]|0;if((e|0)!=64)do{f=28496+(e<<3)|0;h=29008+(e<<3)|0;h=(S(c[f+4>>2]&z,c[h+4>>2]|0)|0)^(S(c[f>>2]&y,c[h>>2]|0)|0);h=(c[1035428+(e<<2)>>2]|0)+(h>>>(c[1035684+(e<<2)>>2]|0)<<3)|0;f=c[h>>2]&I;h=c[h+4>>2]&H;if(!((f|0)==0&(h|0)==0)){i=e<<6;g=b;e=h;while(1){b=g+8|0;G=Qa(f|0,e|0,0)|0;E=Yu(f|0,e|0,-1,-1)|0;f=E&f;e=D&e;c[g>>2]=G+i;if((f|0)==0&(e|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);d=a+3728|0;e=c[d>>2]|0;if((e|0)!=64)do{f=28496+(e<<3)|0;h=29008+(e<<3)|0;h=(S(c[f+4>>2]&z,c[h+4>>2]|0)|0)^(S(c[f>>2]&y,c[h>>2]|0)|0);h=(c[1035428+(e<<2)>>2]|0)+(h>>>(c[1035684+(e<<2)>>2]|0)<<3)|0;f=29520+(e<<3)|0;G=30032+(e<<3)|0;G=(S(c[f+4>>2]&z,c[G+4>>2]|0)|0)^(S(c[f>>2]&y,c[G>>2]|0)|0);G=(c[1035940+(e<<2)>>2]|0)+(G>>>(c[1036196+(e<<2)>>2]|0)<<3)|0;f=(c[G>>2]|c[h>>2])&I;h=(c[G+4>>2]|c[h+4>>2])&H;if(!((f|0)==0&(h|0)==0)){i=e<<6;g=b;e=h;while(1){b=g+8|0;G=Qa(f|0,e|0,0)|0;E=Yu(f|0,e|0,-1,-1)|0;f=E&f;e=D&e;c[g>>2]=G+i;if((f|0)==0&(e|0)==0)break;else g=b}}d=d+4|0;e=c[d>>2]|0}while((e|0)!=64);do if(w){e=a+304|0;d=c[e>>2]&t;e=c[e+4>>2]&x;if((d|0)==0&(e|0)==0)f=b;else{do{f=Qa(d|0,e|0,0)|0;g=Yu(d|0,e|0,-1,-1)|0;d=g&d;e=D&e;g=34448+(f<<3)|0;h=c[g>>2]&I;g=c[g+4>>2]&H;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=b+8|0;G=Qa(h|0,g|0,0)|0;E=Yu(h|0,g|0,-1,-1)|0;h=E&h;g=D&g;c[b>>2]=G+i;if((h|0)==0&(g|0)==0){b=f;break}else b=f}}}while(!((d|0)==0&(e|0)==0));f=b}if((c[a+5368>>2]|0)==9){M=f;return M|0}do if(k){d=a+320+(c[M>>2]<<3)|0;b=c[d>>2]|0;d=c[d+4>>2]|0}else{I=Pf(a,j,y,z)|0;d=a+320+(c[M>>2]<<3)|0;b=c[d>>2]|0;d=c[d+4>>2]|0;if((b&I&c[J>>2]|0)==0?(d&D&c[J+4>>2]|0)==0:0)break;else K=f;return K|0}while(0);while(1){if((b|0)==0&(d|0)==0){g=188;break}J=Qa(b|0,d|0,0)|0;e=Yu(b|0,d|0,-1,-1)|0;d=D&d;I=A;I=Cb(c[a+(J<<2)>>2]|0,J,c[I>>2]|0,c[I+4>>2]|0)|0;J=a+320+((c[M>>2]^1)<<3)|0;if(!((c[J>>2]&I|0)==0?(c[J+4>>2]&D|0)==0:0)){K=f;g=191;break}else b=e&b}if((g|0)==188){B=f;F=c[L>>2]|0;break}else if((g|0)==191)return K|0}else{B=b;F=u}while(0);if((F|0)!=6){M=B;return M|0}Te(a)|0;M=B;return M|0}return 0}function kf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(zd(a)|0){k=b;return k|0}d=c[a+5348>>2]|0;e=c[a+5356>>2]|0;j=e+344+(d<<3)|0;g=a+320+(d<<3)|0;k=a+5364|0;h=c[k>>2]|0;j=(h|0)==7|(c[g>>2]&c[j>>2]|0?1:(c[g+4>>2]&c[j+4>>2]|0)!=0);switch(h|0){case 4:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))h=64;else i=7;break}case 2:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))h=64;else i=7;break}case 1:{d=d<<3|6;if(!(c[a+336+(d<<2)>>2]|0))h=64;else i=7;break}default:{d=d<<3|6;i=7}}if((i|0)==7)h=c[a+400+(d<<8)>>2]|0;g=e+64|0;if((c[g>>2]|0)==0&(c[g+4>>2]|0)==0)d=df(a,b)|0;else d=jf(a,b)|0;if((d|0)==(b|0)){k=b;return k|0}a:while(1){b:do if(j){f=b;while(1){b=c[f>>2]|0;if((b&61440|0)!=36864?!(Qf(a,b)|0):0){b=f;e=f;i=29;break b}c:do if((c[k>>2]|0)==2){e=c[f>>2]|0;b=e&49152;d:do if((b|0)==49152?1:(c[a+((e&63)<<2)>>2]|0)==0){if((b|0)!=32768)break c;b=e&12288;if(b<<16>>16<8192)switch(b<<16>>16){case 4096:break c;default:break d}else switch(b<<16>>16){case 8192:break c;default:break d}}while(0);if(!(Qf(a,e)|0)){b=f;e=f;i=35;break b}}while(0);f=f+8|0;if((f|0)==(d|0)){i=38;break a}}}else{g=b;while(1){f=c[g>>2]|0;b=(f&49152|0)==32768;if(b)e=(f&12288|0)==4096?64:f>>>6&63;else e=f>>>6&63;e:do if((e|0)!=(h|0)){if(b){b=f&12288;if(b<<16>>16<8192)switch(b<<16>>16){case 4096:break e;default:{i=27;break e}}else switch(b<<16>>16){case 8192:break e;default:{i=27;break e}}}}else i=27;while(0);if(((i|0)==27?(i=0,(f&61440|0)!=36864):0)?!(Qf(a,f)|0):0){b=g;e=g;i=29;break b}f:do if((c[k>>2]|0)==2){e=c[g>>2]|0;b=e&49152;g:do if((b|0)==49152?1:(c[a+((e&63)<<2)>>2]|0)==0){if((b|0)!=32768)break f;b=e&12288;if(b<<16>>16<8192)switch(b<<16>>16){case 4096:break f;default:break g}else switch(b<<16>>16){case 8192:break f;default:break g}}while(0);if(!(Qf(a,e)|0)){b=g;e=g;i=35;break b}}while(0);g=g+8|0;if((g|0)==(d|0)){i=38;break a}}}while(0);if((i|0)==29){i=0;d=d+-8|0;c[e>>2]=c[d>>2]}else if((i|0)==35){i=0;d=d+-8|0;c[e>>2]=c[d>>2]}if((b|0)==(d|0)){d=b;i=38;break}}if((i|0)==38)return d|0;return 0}function lf(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[260838]=p;c[260837]=p;c[260839]=p+144;It(p,b);p=(c[260838]|0)+12|0;c[260838]=p;It(p,d);p=(c[260838]|0)+12|0;c[260838]=p;It(p,e);p=(c[260838]|0)+12|0;c[260838]=p;It(p,f);p=(c[260838]|0)+12|0;c[260838]=p;It(p,g);p=(c[260838]|0)+12|0;c[260838]=p;It(p,h);p=(c[260838]|0)+12|0;c[260838]=p;It(p,i);p=(c[260838]|0)+12|0;c[260838]=p;It(p,j);p=(c[260838]|0)+12|0;c[260838]=p;It(p,k);p=(c[260838]|0)+12|0;c[260838]=p;It(p,m);p=(c[260838]|0)+12|0;c[260838]=p;It(p,n);p=(c[260838]|0)+12|0;c[260838]=p;It(p,o);c[260838]=(c[260838]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function mf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[a>>2]=b;c[a+4>>2]=f;c[a+12>>2]=e;e=c[f+-28>>2]&63;c[a+8>>2]=c[(c[b+5352>>2]|0)+5560+(c[b+(e<<2)>>2]<<8)+(e<<2)>>2];e=(c[b+5356>>2]|0)+64|0;e=(c[e>>2]|0)!=0|(c[e+4>>2]|0)!=0?8:0;f=a+28|0;c[f>>2]=e;if(!d){d=0;b=e;a=a+16|0;c[a>>2]=d;d=(d|0)==0;d=d&1;d=b+d|0;c[f>>2]=d;return}b=Sf(b,d)|0;d=b?d:0;b=c[f>>2]|0;a=a+16|0;c[a>>2]=d;d=(d|0)==0;d=d&1;d=b+d|0;c[f>>2]=d;return}function nf(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;c[a>>2]=b;g=(c[b+5356>>2]|0)+64|0;do if((c[g>>2]|0)==0&(c[g+4>>2]|0)==0){if((e|0)>-1){c[a+28>>2]=14;g=14;break}g=a+28|0;if((e|0)>-5){c[g>>2]=18;g=18;break}c[g>>2]=21;c[a+20>>2]=f;return}else{c[a+28>>2]=8;g=8}while(0);if(!d){f=a+28|0;e=0}else{e=Sf(b,d)|0;g=a+28|0;f=g;e=e?d:0;g=c[g>>2]|0}c[a+16>>2]=e;c[f>>2]=g+((e|0)==0&1);return}function of(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;c[a>>2]=b;f=a+24|0;c[f>>2]=e;g=a+28|0;c[g>>2]=11;a:do if((d|0)!=0?Sf(b,d)|0:0){b=c[a>>2]|0;e=d&49152;b:do if((e|0)==49152?1:(c[b+((d&63)<<2)>>2]|0)==0){if((e|0)!=32768){e=0;break a}e=d&12288;if(e<<16>>16<8192)switch(e<<16>>16){case 4096:{e=0;break a}default:break b}else switch(e<<16>>16){case 8192:{e=0;break a}default:break b}}while(0);e=$f(b,d,c[f>>2]|0)|0;e=e?d:0}else e=0;while(0);c[a+16>>2]=e;c[g>>2]=(c[g>>2]|0)+((e|0)==0&1);return}function pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=c[a+32>>2]|0;h=c[a+36>>2]|0;if((b|0)==(h|0))return;do{e=c[a>>2]|0;g=c[e+5364>>2]|0;a:do switch(g|0){case 1:{g=c[b>>2]&63;c[b+4>>2]=(S((c[e+5348>>2]|0)*7^g>>>3,-50)|0)+(c[11236+(c[e+(g<<2)>>2]<<2)>>2]|0);break}case 2:{c[b+4>>2]=(_f(e,c[b>>2]|0)|0)+(S((c[b>>2]|0)>>>3&7^(c[(c[a>>2]|0)+5348>>2]|0)*7,-200)|0);break}case 3:{g=c[b>>2]&63;d=c[e+5348>>2]<<3;f=c[1019044+(g<<8)+(c[e+400+((d^14)<<8)>>2]<<2)>>2]|0;d=c[1019044+(g<<8)+(c[e+400+((d|6)<<8)>>2]<<2)>>2]|0;c[b+4>>2]=(S((d|0)<(f|0)?d:f,-200)|0)+(c[11492+(c[e+(g<<2)>>2]<<2)>>2]|0);break}default:{d=c[b>>2]&63;f=c[11108+(g<<7)+(c[e+(d<<2)>>2]<<2)>>2]|0;if((g|0)==7){c[b+4>>2]=(S(d>>>3^7,-200)|0)+f;break a}else{c[b+4>>2]=(S((c[e+5348>>2]|0)*7^d>>>3,-200)|0)+f;break a}}}while(0);b=b+8|0}while((b|0)!=(h|0));return}function qf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;m=c[a>>2]|0;q=c[m+5352>>2]|0;l=c[a+4>>2]|0;k=c[l+-36>>2]|0;r=c[l+-76>>2]|0;l=c[l+-156>>2]|0;m=c[m+5348>>2]|0;b=c[a+32>>2]|0;n=c[a+36>>2]|0;if((b|0)==(n|0))return;o=(r|0)==0;p=(l|0)==0;if(!k){do{if(o)g=0;else{e=c[b>>2]|0;d=e>>>6;if((e&61440|0)==36864)d=d&15;else d=c[(c[a>>2]|0)+((d&63)<<2)>>2]|0;g=c[r+(d<<8)+((e&63)<<2)>>2]|0}f=c[b>>2]|0;if(p)d=0;else{d=f>>>6;if((f&61440|0)==36864)d=d&15;else d=c[(c[a>>2]|0)+((d&63)<<2)>>2]|0;d=c[l+(d<<8)+((f&63)<<2)>>2]|0}if((f&49152|0)==32768)e=(f&12288|0)==4096?64:f>>>6&63;else e=f>>>6&63;c[b+4>>2]=g+d+(c[q+9656+(m*16640|0)+(e<<8)+((f&63)<<2)>>2]|0);b=b+8|0}while((b|0)!=(n|0));return}do{h=c[b>>2]|0;j=h&63;g=(h&61440|0)==36864;i=h>>>6;if(g)d=i&15;else d=c[(c[a>>2]|0)+((i&63)<<2)>>2]|0;e=c[k+(d<<8)+(j<<2)>>2]|0;if(o)d=0;else{if(g)d=i&15;else d=c[(c[a>>2]|0)+((i&63)<<2)>>2]|0;d=c[r+(d<<8)+(j<<2)>>2]|0}f=d+e|0;if(p)e=0;else{if(g)d=i&15;else d=c[(c[a>>2]|0)+((i&63)<<2)>>2]|0;e=c[l+(d<<8)+(j<<2)>>2]|0}if((h&49152|0)==32768)d=(h&12288|0)==4096?64:i&63;else d=i&63;c[b+4>>2]=f+e+(c[q+9656+(m*16640|0)+(d<<8)+(j<<2)>>2]|0);b=b+8|0}while((b|0)!=(n|0));return}function rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;L=a+28|0;b=c[L>>2]|0;do switch(b|0){case 11:case 18:case 14:case 8:case 0:{c[L>>2]=b+1;M=c[a+16>>2]|0;return M|0}case 1:{s=a+44|0;v=a+32|0;c[v>>2]=s;c[a+40>>2]=s;w=a+36|0;c[w>>2]=Se(c[a>>2]|0,s)|0;pf(a);s=(c[L>>2]|0)+1|0;c[L>>2]=s;B=12;break}case 2:{v=a+32|0;w=a+36|0;s=2;B=12;break}case 3:{e=a+4|0;B=27;break}case 4:{B=33;break}case 5:{B=41;break}case 6:{I=a+32|0;G=a+36|0;H=7;B=60;break}case 7:{K=a+32|0;J=K;K=c[K>>2]|0;break}case 9:{p=a+44|0;m=a+32|0;c[m>>2]=p;p=jf(c[a>>2]|0,p)|0;k=a+36|0;c[k>>2]=p;f=c[a>>2]|0;q=c[f+5352>>2]|0;r=c[f+5348>>2]|0;b=c[m>>2]|0;a:do if((b|0)!=(p|0))while(1){n=c[b>>2]|0;i=n&63;o=c[f+(i<<2)>>2]|0;g=n&49152;b:do if((g|0)==49152|(o|0)==0){if((g|0)==32768){g=n&12288;h=g&16383;if(h<<16>>16<8192)switch(h<<16>>16){case 4096:break;default:{B=75;break b}}else switch(h<<16>>16){case 8192:break;default:{B=75;break b}}g=(g|0)==4096?64:n>>>6&63}else g=n>>>6&63;c[b+4>>2]=c[q+9656+(r*16640|0)+(g<<8)+(i<<2)>>2]}else B=75;while(0);if((B|0)==75){B=0;g=n>>>6;if((n&61440|0)==36864)g=g&15;else g=c[f+((g&63)<<2)>>2]|0;c[b+4>>2]=(c[11108+(c[f+5364>>2]<<7)+(o<<2)>>2]|0)+268435456-(g&7)}b=b+8|0;if((b|0)==(p|0))break a;f=c[a>>2]|0}while(0);c[L>>2]=(c[L>>2]|0)+1;B=85;break}case 10:{m=a+32|0;k=a+36|0;B=85;break}case 12:{B=a+44|0;x=a+32|0;c[x>>2]=B;y=a+36|0;c[y>>2]=Se(c[a>>2]|0,B)|0;pf(a);c[L>>2]=(c[L>>2]|0)+1;B=91;break}case 13:{x=a+32|0;y=a+36|0;B=91;break}case 19:case 15:{B=a+44|0;c[a+32>>2]=B;c[a+36>>2]=Se(c[a>>2]|0,B)|0;pf(a);c[L>>2]=(c[L>>2]|0)+1;B=99;break}case 20:case 16:{B=99;break}case 17:{j=a+32|0;l=a+16|0;C=c[a+36>>2]|0;B=106;break}case 21:{B=a+44|0;t=a+32|0;c[t>>2]=B;u=a+36|0;c[u>>2]=Se(c[a>>2]|0,B)|0;pf(a);c[L>>2]=(c[L>>2]|0)+1;B=110;break}case 22:{t=a+32|0;u=a+36|0;B=110;break}default:{M=0;return M|0}}while(0);c:do if((B|0)==12){b=c[v>>2]|0;e=c[w>>2]|0;do if(b>>>0<e>>>0){i=a+16|0;k=a+40|0;h=b;while(1){f=h+8|0;c[v>>2]=f;if((h|0)==(e|0)|(f|0)==(e|0))b=h;else{b=h;g=h;while(1){b=(c[b+4>>2]|0)<(c[g+12>>2]|0)?f:b;g=f+8|0;if((g|0)==(e|0))break;else{B=f;f=g;g=B}}}B=h;y=c[B>>2]|0;B=c[B+4>>2]|0;t=b;u=c[t+4>>2]|0;x=h;c[x>>2]=c[t>>2];c[x+4>>2]=u;c[b>>2]=y;c[b+4>>2]=B;b=c[h>>2]|0;if((b|0)!=(c[i>>2]|0)){if($f(c[a>>2]|0,b,0)|0){d=b;B=116;break}B=c[k>>2]|0;c[k>>2]=B+8;c[B>>2]=b}h=c[v>>2]|0;e=c[w>>2]|0;if(h>>>0>=e>>>0){B=20;break}}if((B|0)==20){z=c[L>>2]|0;break}else if((B|0)==116)return d|0}else z=s;while(0);c[L>>2]=z+1;e=a+4|0;d=c[(c[e>>2]|0)+20>>2]|0;if((((d|0)!=0?(d|0)!=(c[a+16>>2]|0):0)?Sf(c[a>>2]|0,d)|0:0)?(A=d&49152,(A|0)==49152?1:(c[(c[a>>2]|0)+((d&63)<<2)>>2]|0)==0):0){if((A|0)!=32768){M=d;return M|0}b=d&12288;if(b<<16>>16<8192){switch(b<<16>>16){case 4096:break;default:{B=27;break c}}return d|0}else{switch(b<<16>>16){case 8192:break;default:{B=27;break c}}return d|0}}else B=27}else if((B|0)==85){i=a+16|0;while(1){h=c[m>>2]|0;g=c[k>>2]|0;if(h>>>0>=g>>>0){d=0;B=116;break}d=h+8|0;c[m>>2]=d;if((h|0)==(g|0)|(d|0)==(g|0))b=h;else{b=h;f=h;while(1){b=(c[b+4>>2]|0)<(c[f+12>>2]|0)?d:b;f=d+8|0;if((f|0)==(g|0))break;else{B=d;d=f;f=B}}}B=h;A=c[B>>2]|0;B=c[B+4>>2]|0;y=b;z=c[y+4>>2]|0;d=h;c[d>>2]=c[y>>2];c[d+4>>2]=z;d=b;c[d>>2]=A;c[d+4>>2]=B;d=c[h>>2]|0;if((d|0)!=(c[i>>2]|0)){B=116;break}}if((B|0)==116)return d|0}else if((B|0)==91){b=c[x>>2]|0;d=c[y>>2]|0;if(b>>>0>=d>>>0){M=0;return M|0}i=a+16|0;k=a+24|0;h=b;while(1){f=h+8|0;c[x>>2]=f;if((h|0)==(d|0)|(f|0)==(d|0))b=h;else{b=h;g=h;while(1){b=(c[b+4>>2]|0)<(c[g+12>>2]|0)?f:b;g=f+8|0;if((g|0)==(d|0))break;else{B=f;f=g;g=B}}}B=h;A=c[B>>2]|0;B=c[B+4>>2]|0;w=b;z=c[w+4>>2]|0;d=h;c[d>>2]=c[w>>2];c[d+4>>2]=z;d=b;c[d>>2]=A;c[d+4>>2]=B;d=c[h>>2]|0;if((d|0)!=(c[i>>2]|0)?$f(c[a>>2]|0,d,c[k>>2]|0)|0:0){B=116;break}h=c[x>>2]|0;d=c[y>>2]|0;if(h>>>0>=d>>>0){d=0;B=116;break}}if((B|0)==116)return d|0}else if((B|0)==99){j=a+32|0;k=a+36|0;l=a+16|0;while(1){i=c[j>>2]|0;h=c[k>>2]|0;if(i>>>0>=h>>>0)break;f=i+8|0;c[j>>2]=f;if((i|0)==(h|0)|(f|0)==(h|0))b=i;else{b=i;g=i;while(1){b=(c[b+4>>2]|0)<(c[g+12>>2]|0)?f:b;g=f+8|0;if((g|0)==(h|0))break;else{C=f;f=g;g=C}}}C=i;A=c[C>>2]|0;C=c[C+4>>2]|0;x=b;y=c[x+4>>2]|0;z=i;c[z>>2]=c[x>>2];c[z+4>>2]=y;c[b>>2]=A;c[b+4>>2]=C;b=c[i>>2]|0;if((b|0)!=(c[l>>2]|0)){d=b;B=116;break}}if((B|0)==116)return d|0;if((c[L>>2]|0)==20){M=0;return M|0}else{C=a+44|0;c[j>>2]=C;C=ef(c[a>>2]|0,C)|0;c[k>>2]=C;c[L>>2]=(c[L>>2]|0)+1;B=106;break}}else if((B|0)==110){i=a+20|0;while(1){h=c[t>>2]|0;g=c[u>>2]|0;if(h>>>0>=g>>>0){d=0;B=116;break}d=h+8|0;c[t>>2]=d;if((h|0)==(g|0)|(d|0)==(g|0))b=h;else{b=h;f=h;while(1){b=(c[b+4>>2]|0)<(c[f+12>>2]|0)?d:b;f=d+8|0;if((f|0)==(g|0))break;else{B=d;d=f;f=B}}}B=h;A=c[B>>2]|0;B=c[B+4>>2]|0;y=b;z=c[y+4>>2]|0;d=h;c[d>>2]=c[y>>2];c[d+4>>2]=z;d=b;c[d>>2]=A;c[d+4>>2]=B;d=c[h>>2]|0;if((d&63|0)==(c[i>>2]|0)){B=116;break}}if((B|0)==116)return d|0}while(0);if((B|0)==106){b=c[j>>2]|0;while(1){if(b>>>0>=C>>>0){d=0;B=116;break}d=b;b=b+8|0;c[j>>2]=b;d=c[d>>2]|0;if((d|0)!=(c[l>>2]|0)){B=116;break}}if((B|0)==116)return d|0}d:do if((B|0)==27){c[L>>2]=(c[L>>2]|0)+1;d=c[(c[e>>2]|0)+24>>2]|0;if((((d|0)!=0?(d|0)!=(c[a+16>>2]|0):0)?Sf(c[a>>2]|0,d)|0:0)?(D=d&49152,(D|0)==49152?1:(c[(c[a>>2]|0)+((d&63)<<2)>>2]|0)==0):0){if((D|0)!=32768){M=d;return M|0}b=d&12288;if(b<<16>>16<8192){switch(b<<16>>16){case 4096:break;default:{B=33;break d}}return d|0}else{switch(b<<16>>16){case 8192:break;default:{B=33;break d}}return d|0}}else B=33}while(0);e:do if((B|0)==33){c[L>>2]=(c[L>>2]|0)+1;d=c[a+8>>2]|0;if((((((d|0)!=0?(d|0)!=(c[a+16>>2]|0):0)?(E=c[a+4>>2]|0,(d|0)!=(c[E+20>>2]|0)):0)?(d|0)!=(c[E+24>>2]|0):0)?Sf(c[a>>2]|0,d)|0:0)?(F=d&49152,(F|0)==49152?1:(c[(c[a>>2]|0)+((d&63)<<2)>>2]|0)==0):0){if((F|0)!=32768){M=d;return M|0}b=d&12288;if(b<<16>>16<8192){switch(b<<16>>16){case 4096:break;default:{B=41;break e}}return d|0}else{switch(b<<16>>16){case 8192:break;default:{B=41;break e}}return d|0}}else B=41}while(0);if((B|0)==41){b=c[a+40>>2]|0;j=a+32|0;c[j>>2]=b;k=a+36|0;c[k>>2]=We(c[a>>2]|0,b)|0;qf(a);b=c[j>>2]|0;e=c[k>>2]|0;if((c[a+12>>2]|0)<3){f:do if((b|0)!=(e|0))while(1){while(1){if((c[b+4>>2]|0)<=0)break;b=b+8|0;if((b|0)==(e|0)){b=e;break f}}do{d=e;e=e+-8|0;if((b|0)==(e|0))break f}while((c[d+-4>>2]|0)<=0);H=b;G=c[H>>2]|0;H=c[H+4>>2]|0;E=e;F=c[E+4>>2]|0;I=b;c[I>>2]=c[E>>2];c[I+4>>2]=F;I=e;c[I>>2]=G;c[I+4>>2]=H;b=b+8|0;if((b|0)==(e|0)){b=e;break}}while(0);i=c[j>>2]|0;d=i+8|0;if(d>>>0<b>>>0)do{h=d;g=c[h>>2]|0;h=c[h+4>>2]|0;g:do if((d|0)==(i|0))e=i;else{f=d;while(1){e=f;f=f+-8|0;if((c[e+-4>>2]|0)>=(h|0))break g;G=f;H=c[G+4>>2]|0;I=e;c[I>>2]=c[G>>2];c[I+4>>2]=H;if((f|0)==(i|0)){e=i;break}}}while(0);I=e;c[I>>2]=g;c[I+4>>2]=h;d=d+8|0}while(d>>>0<b>>>0)}else{d=b+8|0;if(d>>>0<e>>>0)do{i=d;h=c[i>>2]|0;i=c[i+4>>2]|0;h:do if((d|0)==(b|0))f=b;else{g=d;while(1){f=g;g=g+-8|0;if((c[f+-4>>2]|0)>=(i|0))break h;G=g;H=c[G+4>>2]|0;I=f;c[I>>2]=c[G>>2];c[I+4>>2]=H;if((g|0)==(b|0)){f=b;break}}}while(0);I=f;c[I>>2]=h;c[I+4>>2]=i;d=d+8|0}while(d>>>0<e>>>0)}H=c[L>>2]|0;c[L>>2]=H+1;I=j;G=k;H=H+2|0;B=60}if((B|0)==60){b=c[I>>2]|0;e=c[G>>2]|0;do if(b>>>0<e>>>0){f=c[a+16>>2]|0;g=a+4|0;h=a+8|0;while(1){d=b;b=b+8|0;d=c[d>>2]|0;if((((d|0)!=(f|0)?(M=c[g>>2]|0,(d|0)!=(c[M+20>>2]|0)):0)?(d|0)!=(c[M+24>>2]|0):0)?(d|0)!=(c[h>>2]|0):0)break;if(b>>>0>=e>>>0){B=67;break}}if((B|0)==67){c[I>>2]=b;break}c[I>>2]=b;M=d;return M|0}while(0);c[L>>2]=H;K=a+44|0;c[I>>2]=K;J=I}if(K>>>0>=(c[a+40>>2]|0)>>>0){M=0;return M|0}c[J>>2]=K+8;M=c[K>>2]|0;return M|0}function sf(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[260841]=p;c[260840]=p;c[260842]=p+144;It(p,b);p=(c[260841]|0)+12|0;c[260841]=p;It(p,d);p=(c[260841]|0)+12|0;c[260841]=p;It(p,e);p=(c[260841]|0)+12|0;c[260841]=p;It(p,f);p=(c[260841]|0)+12|0;c[260841]=p;It(p,g);p=(c[260841]|0)+12|0;c[260841]=p;It(p,h);p=(c[260841]|0)+12|0;c[260841]=p;It(p,i);p=(c[260841]|0)+12|0;c[260841]=p;It(p,j);p=(c[260841]|0)+12|0;c[260841]=p;It(p,k);p=(c[260841]|0)+12|0;c[260841]=p;It(p,m);p=(c[260841]|0)+12|0;c[260841]=p;It(p,n);p=(c[260841]|0)+12|0;c[260841]=p;It(p,o);c[260841]=(c[260841]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);c[260843]=2621485;c[260844]=1769502;c[260845]=5242930;c[260846]=4522038;c[260847]=1769497;c[260848]=1179675;c[260849]=2621485;c[260850]=1769502;c[260851]=2883644;c[260852]=2490386;c[260853]=2621485;c[260854]=1769502;c[260855]=5242930;c[260856]=4522038;b=1043428;c[b>>2]=0;c[b+4>>2]=0;c[260859]=2621485;c[260860]=1769502;c[260861]=2162744;c[260862]=1245225;c[260863]=1638464;c[260864]=3276826;c[260865]=1638441;c[260866]=852009;c[260867]=2162744;c[260868]=1245225;c[260869]=1703984;c[260870]=983120;c[260871]=2162744;c[260872]=1245225;c[260873]=1638464;c[260874]=3276826;b=1043500;c[b>>2]=0;c[b+4>>2]=0;c[260877]=2162744;c[260878]=1245225;c[260879]=524305;c[260880]=-3145773;c[260881]=45;c[260882]=524305;c[260883]=3276847;c[260884]=524305;c[260885]=-3145773;c[260886]=0;c[260887]=524305;c[260888]=2490386;c[260889]=3342340;c[260890]=2752517;c[260891]=2490386;c[260892]=5111818;c[260893]=2490386;c[260894]=3342340;c[260895]=0;c[260896]=2490386;c[260897]=0;c[260898]=0;c[260899]=0;c[260900]=0;c[260901]=1048593;c[260902]=2097185;c[260903]=0;c[260904]=0;l=a;return}function tf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c[a+64>>2]=d;e=c[b+5356>>2]|0;n=e+24|0;c[a+80>>2]=c[n>>2]&3;y=c[b+5364>>2]|0;if((y|0)==8)x=S(c[e+40>>2]|0,-2)|0;else x=0;u=b+320|0;r=c[u>>2]|0;u=c[u+4>>2]|0;t=b+264|0;s=c[t>>2]|0;t=c[t+4>>2]|0;e=s&r;f=t&u;if((e|0)==0&(f|0)==0)v=0;else{a=0;do{v=a;a=a+1|0;v=105104+(d<<6)+(v<<3)|0}while((c[v>>2]&e|0)==0?(c[v+4>>2]&f|0)==0:0);v=S(a,-16)|0}i=d>>3;k=31248+(i<<3)|0;l=31120+(i<<3)|0;j=(c[l>>2]|c[k>>2])&s;k=(c[l+4>>2]|c[k+4>>2])&t;l=j&r;m=k&u;q=b+328|0;p=c[q>>2]|0;q=c[q+4>>2]|0;j=j&p;k=k&q;h=d&7;b=h>>>0<6?h:6;b=(b|0)>1?b:1;i=i+1|0;e=b+-1|0;o=258;while(1){f=31056+(e<<3)|0;g=c[f>>2]|0;f=c[f+4>>2]|0;z=l&g;d=m&f;a=Qa(z|0,d|0,0)|0;a=(z|0)==0&(d|0)==0?0:a>>>3;g=j&g;f=k&f;d=Qa(g|0,f|0,0)|0;d=(g|0)==0&(f|0)==0?0:d>>>3;f=7-e|0;f=(f|0)<(e|0)?f:e;g=c[8844+(y<<7)+(f<<5)+(a<<2)>>2]|0;if(!((e|0)==(h|0)&(d|0)==(i|0)))if(!a)a=1;else a=(d|0)==(a+1|0)?2:3;else a=0;o=o-g-(c[9996+(a<<7)+(f<<5)+(d<<2)>>2]|0)|0;if((e|0)>(b|0))break;else e=e+1|0}k=c[n>>2]|0;if(!(k&1))j=o;else{i=31248;d=31120;h=(c[d>>2]|c[i>>2])&s;i=(c[d+4>>2]|c[i+4>>2])&t;d=h&r;g=i&u;h=h&p;i=i&q;z=31096;n=c[z>>2]|0;z=c[z+4>>2]|0;m=d&n;e=g&z;a=Qa(m|0,e|0,0)|0;a=(m|0)==0&(e|0)==0?0:a>>>3;n=h&n;z=i&z;e=Qa(n|0,z|0,0)|0;e=(n|0)==0&(z|0)==0?0:e>>>3;if(!a)f=1;else f=(e|0)==(a+1|0)?2:3;b=258-(c[8844+(y<<7)+64+(a<<2)>>2]|0)-(c[9996+(f<<7)+64+(e<<2)>>2]|0)|0;e=31104;a=c[e>>2]|0;e=c[e+4>>2]|0;n=d&a;z=g&e;f=Qa(n|0,z|0,0)|0;f=(n|0)==0&(z|0)==0?0:f>>>3;a=h&a;e=i&e;if(!((a|0)==0&(e|0)==0)){a=Qa(a|0,e|0,0)|0;a=a>>>3;e=c[8844+(y<<7)+32+(f<<2)>>2]|0;if((a|0)==1){f=0;a=1}else w=29}else{a=0;e=c[8844+(y<<7)+32+(f<<2)>>2]|0;w=29}if((w|0)==29)if(!f)f=1;else f=(a|0)==(f+1|0)?2:3;b=b-e-(c[9996+(f<<7)+32+(a<<2)>>2]|0)|0;z=31112;n=c[z>>2]|0;z=c[z+4>>2]|0;m=d&n;a=g&z;f=Qa(m|0,a|0,0)|0;f=(m|0)==0&(a|0)==0?0:f>>>3;n=h&n;z=i&z;a=Qa(n|0,z|0,0)|0;a=(n|0)==0&(z|0)==0?0:a>>>3;if(!f)e=1;else e=(a|0)==(f+1|0)?2:3;j=b-(c[8844+(y<<7)+(f<<2)>>2]|0)-(c[9996+(e<<7)+(a<<2)>>2]|0)|0;j=(o|0)<(j|0)?j:o}if(!(k&2)){y=j;z=v+x|0;z=z<<16;z=y+z|0;return z|0}d=31248;i=31120;h=(c[i>>2]|c[d>>2])&s;d=(c[i+4>>2]|c[d+4>>2])&t;i=h&r;g=d&u;h=h&p;d=d&q;z=31064;u=c[z>>2]|0;z=c[z+4>>2]|0;t=i&u;e=g&z;a=Qa(t|0,e|0,0)|0;a=(t|0)==0&(e|0)==0?0:a>>>3;u=h&u;z=d&z;e=Qa(u|0,z|0,0)|0;e=(u|0)==0&(z|0)==0?0:e>>>3;if(!a)f=1;else f=(e|0)==(a+1|0)?2:3;b=258-(c[8844+(y<<7)+32+(a<<2)>>2]|0)-(c[9996+(f<<7)+32+(e<<2)>>2]|0)|0;e=31072;a=c[e>>2]|0;e=c[e+4>>2]|0;u=i&a;z=g&e;f=Qa(u|0,z|0,0)|0;f=(u|0)==0&(z|0)==0?0:f>>>3;a=h&a;e=d&e;if(!((a|0)==0&(e|0)==0)){a=Qa(a|0,e|0,0)|0;a=a>>>3;e=c[8844+(y<<7)+64+(f<<2)>>2]|0;if((a|0)==1){f=0;a=1}else w=22}else{a=0;e=c[8844+(y<<7)+64+(f<<2)>>2]|0;w=22}if((w|0)==22)if(!f)f=1;else f=(a|0)==(f+1|0)?2:3;b=b-e-(c[9996+(f<<7)+64+(a<<2)>>2]|0)|0;z=31080;w=c[z>>2]|0;z=c[z+4>>2]|0;u=i&w;a=g&z;f=Qa(u|0,a|0,0)|0;f=(u|0)==0&(a|0)==0?0:f>>>3;w=h&w;z=d&z;a=Qa(w|0,z|0,0)|0;a=(w|0)==0&(z|0)==0?0:a>>>3;if(!f)e=1;else e=(a|0)==(f+1|0)?2:3;y=b-(c[8844+(y<<7)+96+(f<<2)>>2]|0)-(c[9996+(e<<7)+96+(a<<2)>>2]|0)|0;y=(j|0)<(y|0)?y:j;z=v+x|0;z=z<<16;z=y+z|0;return z|0}function uf(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;c[a+68>>2]=d;e=c[b+5356>>2]|0;n=e+24|0;c[a+84>>2]=c[n>>2]&12;y=c[b+5364>>2]|0;if((y|0)==8)x=S(c[e+36>>2]|0,-2)|0;else x=0;u=b+328|0;r=c[u>>2]|0;u=c[u+4>>2]|0;t=b+264|0;s=c[t>>2]|0;t=c[t+4>>2]|0;e=s&r;f=t&u;if((e|0)==0&(f|0)==0)v=0;else{a=0;do{v=a;a=a+1|0;v=105104+(d<<6)+(v<<3)|0}while((c[v>>2]&e|0)==0?(c[v+4>>2]&f|0)==0:0);v=S(a,-16)|0}i=d>>3;k=31312+(i<<3)|0;l=31120+(i<<3)|0;j=(c[l>>2]|c[k>>2])&s;k=(c[l+4>>2]|c[k+4>>2])&t;l=j&r;m=k&u;q=b+320|0;p=c[q>>2]|0;q=c[q+4>>2]|0;j=j&p;k=k&q;h=d&7;b=h>>>0<6?h:6;b=(b|0)>1?b:1;i=(i^7)+1|0;e=b+-1|0;o=258;while(1){f=31056+(e<<3)|0;g=c[f>>2]|0;f=c[f+4>>2]|0;z=l&g;d=m&f;a=nv(z|0,d|0,0)|0;a=(z|0)==0&(d|0)==0?0:a>>>3;g=j&g;f=k&f;d=nv(g|0,f|0,0)|0;d=(g|0)==0&(f|0)==0?0:d>>>3;f=7-e|0;f=(f|0)<(e|0)?f:e;g=c[8844+(y<<7)+(f<<5)+(a<<2)>>2]|0;if(!((e|0)==(h|0)&(d|0)==(i|0)))if(!a)a=1;else a=(d|0)==(a+1|0)?2:3;else a=0;o=o-g-(c[9996+(a<<7)+(f<<5)+(d<<2)>>2]|0)|0;if((e|0)>(b|0))break;else e=e+1|0}k=c[n>>2]|0;if(!(k&4))j=o;else{i=31368;d=31176;h=(c[d>>2]|c[i>>2])&s;i=(c[d+4>>2]|c[i+4>>2])&t;d=h&r;g=i&u;h=h&p;i=i&q;z=31096;n=c[z>>2]|0;z=c[z+4>>2]|0;m=d&n;e=g&z;a=nv(m|0,e|0,0)|0;a=(m|0)==0&(e|0)==0?0:a>>>3;n=h&n;z=i&z;e=nv(n|0,z|0,0)|0;e=(n|0)==0&(z|0)==0?0:e>>>3;if(!a)f=1;else f=(e|0)==(a+1|0)?2:3;b=258-(c[8844+(y<<7)+64+(a<<2)>>2]|0)-(c[9996+(f<<7)+64+(e<<2)>>2]|0)|0;e=31104;a=c[e>>2]|0;e=c[e+4>>2]|0;n=d&a;z=g&e;f=nv(n|0,z|0,0)|0;f=(n|0)==0&(z|0)==0?0:f>>>3;a=h&a;e=i&e;if(!((a|0)==0&(e|0)==0)){a=nv(a|0,e|0,0)|0;a=a>>>3;e=c[8844+(y<<7)+32+(f<<2)>>2]|0;if((a|0)==1){f=0;a=1}else w=29}else{a=0;e=c[8844+(y<<7)+32+(f<<2)>>2]|0;w=29}if((w|0)==29)if(!f)f=1;else f=(a|0)==(f+1|0)?2:3;b=b-e-(c[9996+(f<<7)+32+(a<<2)>>2]|0)|0;z=31112;n=c[z>>2]|0;z=c[z+4>>2]|0;m=d&n;a=g&z;f=nv(m|0,a|0,0)|0;f=(m|0)==0&(a|0)==0?0:f>>>3;n=h&n;z=i&z;a=nv(n|0,z|0,0)|0;a=(n|0)==0&(z|0)==0?0:a>>>3;if(!f)e=1;else e=(a|0)==(f+1|0)?2:3;j=b-(c[8844+(y<<7)+(f<<2)>>2]|0)-(c[9996+(e<<7)+(a<<2)>>2]|0)|0;j=(o|0)<(j|0)?j:o}if(!(k&8)){y=j;z=v+x|0;z=z<<16;z=y+z|0;return z|0}d=31368;i=31176;h=(c[i>>2]|c[d>>2])&s;d=(c[i+4>>2]|c[d+4>>2])&t;i=h&r;g=d&u;h=h&p;d=d&q;z=31064;u=c[z>>2]|0;z=c[z+4>>2]|0;t=i&u;e=g&z;a=nv(t|0,e|0,0)|0;a=(t|0)==0&(e|0)==0?0:a>>>3;u=h&u;z=d&z;e=nv(u|0,z|0,0)|0;e=(u|0)==0&(z|0)==0?0:e>>>3;if(!a)f=1;else f=(e|0)==(a+1|0)?2:3;b=258-(c[8844+(y<<7)+32+(a<<2)>>2]|0)-(c[9996+(f<<7)+32+(e<<2)>>2]|0)|0;e=31072;a=c[e>>2]|0;e=c[e+4>>2]|0;u=i&a;z=g&e;f=nv(u|0,z|0,0)|0;f=(u|0)==0&(z|0)==0?0:f>>>3;a=h&a;e=d&e;if(!((a|0)==0&(e|0)==0)){a=nv(a|0,e|0,0)|0;a=a>>>3;e=c[8844+(y<<7)+64+(f<<2)>>2]|0;if((a|0)==1){f=0;a=1}else w=22}else{a=0;e=c[8844+(y<<7)+64+(f<<2)>>2]|0;w=22}if((w|0)==22)if(!f)f=1;else f=(a|0)==(f+1|0)?2:3;b=b-e-(c[9996+(f<<7)+64+(a<<2)>>2]|0)|0;z=31080;w=c[z>>2]|0;z=c[z+4>>2]|0;u=i&w;a=g&z;f=nv(u|0,a|0,0)|0;f=(u|0)==0&(a|0)==0?0:f>>>3;w=h&w;z=d&z;a=nv(w|0,z|0,0)|0;a=(w|0)==0&(z|0)==0?0:a>>>3;if(!f)e=1;else e=(a|0)==(f+1|0)?2:3;y=b-(c[8844+(y<<7)+96+(f<<2)>>2]|0)-(c[9996+(e<<7)+96+(a<<2)>>2]|0)|0;y=(j|0)<(y|0)?y:j;z=v+x|0;z=z<<16;z=y+z|0;return z|0}function vf(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=0;while(1){f=10508+(d<<5)+4|0;g=10508+(d<<5)+8|0;r=10508+(d<<5)+12|0;C=10508+(d<<5)+16|0;M=10508+(d<<5)+20|0;O=10508+(d<<5)+24|0;P=10508+(d<<5)+4|0;Q=10508+(d<<5)+8|0;R=10508+(d<<5)+12|0;S=10508+(d<<5)+16|0;h=10508+(d<<5)+20|0;i=10508+(d<<5)+24|0;j=10508+(d<<5)+4|0;k=10508+(d<<5)+8|0;l=10508+(d<<5)+12|0;m=10508+(d<<5)+16|0;n=10508+(d<<5)+20|0;o=10508+(d<<5)+24|0;p=10508+(d<<5)+28|0;q=10508+(d<<5)+4|0;s=10508+(d<<5)+8|0;t=10508+(d<<5)+12|0;u=10508+(d<<5)+16|0;v=10508+(d<<5)+20|0;w=10508+(d<<5)+24|0;x=10508+(d<<5)+28|0;b=0;while(1){y=1043620+(d<<8)+(b<<7)+4|0;z=1043620+(d<<8)+(b<<7)+8|0;A=1043620+(d<<8)+(b<<7)+12|0;B=1043620+(d<<8)+(b<<7)+16|0;D=1043620+(d<<8)+(b<<7)+20|0;E=1043620+(d<<8)+(b<<7)+24|0;a=0;while(1){F=(a|0)==0;G=1043620+(d<<8)+(b<<7)+(a<<6)+4|0;H=1043620+(d<<8)+(b<<7)+(a<<6)+8|0;I=1043620+(d<<8)+(b<<7)+(a<<6)+12|0;J=1043620+(d<<8)+(b<<7)+(a<<6)+16|0;K=1043620+(d<<8)+(b<<7)+(a<<6)+20|0;L=1043620+(d<<8)+(b<<7)+(a<<6)+24|0;e=0;a:while(1){N=(e|0)==0;do if(F)if(N){e=c[f>>2]>>b;c[y>>2]=(((e|0)/-4|0)<<16)+e;c[z>>2]=c[g>>2]>>b;e=c[r>>2]>>b;c[A>>2]=(((e|0)/4|0)<<16)+e;e=c[C>>2]>>b;c[B>>2]=(((e|0)/2|0)<<16)+e;e=c[M>>2]>>b;c[D>>2]=(((e*3|0)/4|0)<<16)+e;c[E>>2]=(c[O>>2]>>b)*65537;e=1;continue a}else{N=c[P>>2]>>b;N=((N|0)/2|0)+N|0;c[1043620+(d<<8)+(b<<7)+(e<<5)+4>>2]=(((N|0)/-4|0)<<16)+N;N=c[Q>>2]>>b;c[1043620+(d<<8)+(b<<7)+(e<<5)+8>>2]=((N|0)/2|0)+N;N=c[R>>2]>>b;N=((N|0)/2|0)+N|0;c[1043620+(d<<8)+(b<<7)+(e<<5)+12>>2]=(((N|0)/4|0)<<16)+N;N=c[S>>2]>>b;N=((N|0)/2|0)+N|0;c[1043620+(d<<8)+(b<<7)+(e<<5)+16>>2]=(((N|0)/2|0)<<16)+N;N=c[h>>2]>>b;N=((N|0)/2|0)+N|0;c[1043620+(d<<8)+(b<<7)+(e<<5)+20>>2]=(((N*3|0)/4|0)<<16)+N;N=c[i>>2]>>b;c[1043620+(d<<8)+(b<<7)+(e<<5)+24>>2]=(((N|0)/2|0)+N|0)*65537;break}else if(N){N=c[j>>2]|0;e=c[k>>2]|0;N=((e-N|0)/2|0)+N>>b;c[G>>2]=(((N|0)/-4|0)<<16)+N;N=c[l>>2]|0;c[H>>2]=((N-e|0)/2|0)+e>>b;e=c[m>>2]|0;N=((e-N|0)/2|0)+N>>b;c[I>>2]=(((N|0)/4|0)<<16)+N;N=c[n>>2]|0;e=((N-e|0)/2|0)+e>>b;c[J>>2]=(((e|0)/2|0)<<16)+e;e=c[o>>2]|0;N=((e-N|0)/2|0)+N>>b;c[K>>2]=(((N*3|0)/4|0)<<16)+N;c[L>>2]=((((c[p>>2]|0)-e|0)/2|0)+e>>b)*65537;e=1;continue a}else{T=c[q>>2]|0;N=c[s>>2]|0;T=((N-T|0)/2|0)+T>>b;T=((T|0)/2|0)+T|0;c[1043620+(d<<8)+(b<<7)+(a<<6)+(e<<5)+4>>2]=(((T|0)/-4|0)<<16)+T;T=c[t>>2]|0;N=((T-N|0)/2|0)+N>>b;c[1043620+(d<<8)+(b<<7)+(a<<6)+(e<<5)+8>>2]=((N|0)/2|0)+N;N=c[u>>2]|0;T=((N-T|0)/2|0)+T>>b;T=((T|0)/2|0)+T|0;c[1043620+(d<<8)+(b<<7)+(a<<6)+(e<<5)+12>>2]=(((T|0)/4|0)<<16)+T;T=c[v>>2]|0;N=((T-N|0)/2|0)+N>>b;N=((N|0)/2|0)+N|0;c[1043620+(d<<8)+(b<<7)+(a<<6)+(e<<5)+16>>2]=(((N|0)/2|0)<<16)+N;N=c[w>>2]|0;T=((N-T|0)/2|0)+T>>b;T=((T|0)/2|0)+T|0;c[1043620+(d<<8)+(b<<7)+(a<<6)+(e<<5)+20>>2]=(((T*3|0)/4|0)<<16)+T;N=(((c[x>>2]|0)-N|0)/2|0)+N>>b;c[1043620+(d<<8)+(b<<7)+(a<<6)+(e<<5)+24>>2]=(((N|0)/2|0)+N|0)*65537;break}while(0);e=e+1|0;if((e|0)==2)break}a=a+1|0;if((a|0)==2)break}b=b+1|0;if((b|0)==2)break}d=d+1|0;if((d|0)==9)break}return}function wf(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0;e=c[a+5356>>2]|0;b=c[e>>2]|0;e=c[e+4>>2]|0;$=b&16383;aa=c[(c[a+5352>>2]|0)+88>>2]|0;ba=aa+($*120|0)|0;Z=ba;if((c[Z>>2]|0)==(b|0)?(c[Z+4>>2]|0)==(e|0):0)return ba|0;X=ba;c[X>>2]=b;c[X+4>>2]=e;X=a+320|0;P=X;V=a+264|0;R=V;Q=c[R>>2]|0;R=c[R+4>>2]|0;O=Q&c[P>>2];P=R&c[P+4>>2];W=a+328|0;S=W;Q=c[S>>2]&Q;R=c[S+4>>2]&R;S=aa+($*120|0)+48|0;T=S;c[T>>2]=0;c[T+4>>2]=0;T=aa+($*120|0)+16|0;U=T;c[U>>2]=0;c[U+4>>2]=0;U=aa+($*120|0)+88|0;c[U>>2]=255;c[aa+($*120|0)+64>>2]=64;N=gv(O|0,P|0,9)|0;b=D&-16843010;Y=gv(O|0,P|0,7)|0;Z=aa+($*120|0)+32|0;c[Z>>2]=N&-16843264|Y&2139062016;c[Z+4>>2]=b|D&2139062143;Z=av(O|0,P|0,16)|0;b=av(O|0,P|0,48)|0;b=(d[1167548+(Z&43605)>>0]|0)+(d[1167548+(O&43605)>>0]|0)+(d[1167548+(P&43605)>>0]|0)+(d[1167548+(b&43605)>>0]|0)|0;c[aa+($*120|0)+100>>2]=b;c[aa+($*120|0)+96>>2]=(c[a+340>>2]|0)-b;b=c[a+656>>2]|0;if((b|0)==64){Z=0;Y=255}else{M=c[a+5364>>2]|0;N=1043552+(M<<2)|0;e=0;f=255;J=0;K=0;g=M;h=0;i=0;L=a+660|0;while(1){k=b&7;f=f&~(1<<k);c[U>>2]=f;o=111248+(b<<3)|0;J=c[o>>2]|J;K=c[o+4>>2]|K;o=S;c[o>>2]=J;c[o+4>>2]=K;o=109200+(b<<3)|0;n=c[o>>2]|0;o=c[o+4>>2]|0;w=(n&Q|0)!=0|(o&R|0)!=0;q=110224+(b<<3)|0;p=c[q>>2]&Q;q=c[q+4>>2]&R;s=31888+(b<<3)|0;r=c[s>>2]&Q;s=c[s+4>>2]&R;G=b+8|0;u=31888+(G<<3)|0;t=c[u>>2]&Q;u=c[u+4>>2]&R;G=30544+(G<<3)|0;F=c[G>>2]&O;G=c[G+4>>2]&P;k=31184+(k<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;l=j&O;m=k&P;H=b>>3;y=31120+(H<<3)|0;x=l&c[y>>2];y=m&c[y+4>>2];z=(g|0)==4;if(z&(H|0)==0){B=0;E=0}else{E=31120+(b+-8>>3<<3)|0;B=c[E>>2]&l;E=c[E+4>>2]&m}A=B|x;C=E|y;v=(l|0)==0&(m|0)==0;I=(r|0)!=0|(s|0)!=0;if((H|0)>3|(I|v))j=0;else{Z=Qa(l|p|0,m|q|0,0)|0;Z=31120+(Z>>>3<<3)|0;Y=c[Z>>2]|0;Z=c[Z+4>>2]|0;j=gv(Y&j|0,Z&k|0,8)|0;j=((j|Y)&p|0)!=0|((D|Z)&q|0)!=0}if(((n&O|0)==0&(o&P|0)==0&((r^p|0)==(t|0)&(s^q|0)==(u|0))?(Y=av(B|0,E|0,16)|0,q=av(B|0,E|0,48)|0,q=(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(B&65535)>>0]|0)+(d[1167548+(E&65535)>>0]|0)+(d[1167548+q>>0]|0)|0,Y=av(r|0,s|0,16)|0,Z=av(r|0,s|0,48)|0,q>>>0>=((d[1167548+(Y&65535)>>0]|0)+(d[1167548+(r&65535)>>0]|0)+(d[1167548+(s&65535)>>0]|0)+(d[1167548+Z>>0]|0)|0)>>>0):0)?(Y=av(x|0,y|0,16)|0,s=av(x|0,y|0,48)|0,s=(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(x&65535)>>0]|0)+(d[1167548+(y&65535)>>0]|0)+(d[1167548+s>>0]|0)|0,Y=av(t|0,u|0,16)|0,Z=av(t|0,u|0,48)|0,s>>>0>=((d[1167548+(Y&65535)>>0]|0)+(d[1167548+(t&65535)>>0]|0)+(d[1167548+(u&65535)>>0]|0)+(d[1167548+Z>>0]|0)|0)>>>0):0){Z=30544+(b<<3)|0;h=c[Z>>2]|h;i=c[Z+4>>2]|i;Z=T;c[Z>>2]=h;c[Z+4>>2]=i}do if(!v){if(j){e=e-(c[1043444+(g<<3)+((w&1)<<2)>>2]|0)|0;break}if((B|0)==0&(E|0)==0)e=e-(c[1043516+(g<<2)>>2]|0)|0}else e=e-(c[1043372+(g<<3)+((w&1)<<2)>>2]|0)|0;while(0);if(z)if((H|0)!=0&((A|0)!=0|(C|0)!=0))_=21;else b=4;else if((A|0)==0&(C|0)==0)b=g;else _=21;if((_|0)==21){_=0;b=Yu(B|0,E|0,-1,-1)|0;e=(c[1043620+(M<<8)+((w&1)<<7)+((((x|0)!=0|(y|0)!=0)&1)<<6)+((((b&B|0)!=0|(D&E|0)!=0)&1)<<5)+(H<<2)>>2]|0)+e|0;b=M}if((F|0)==0&(G|0)==0)g=b;else{e=e-(c[N>>2]|0)|0;g=M}if(I)e=(c[1043588+(H<<2)>>2]|0)+e|0;b=c[L>>2]|0;if((b|0)==64){Z=e;Y=f;break}else L=L+4|0}}Q=W;P=V;O=c[P>>2]|0;P=c[P+4>>2]|0;U=O&c[Q>>2];V=P&c[Q+4>>2];Q=X;O=c[Q>>2]&O;P=c[Q+4>>2]&P;Q=aa+($*120|0)+56|0;R=Q;c[R>>2]=0;c[R+4>>2]=0;R=aa+($*120|0)+24|0;S=R;c[S>>2]=0;c[S+4>>2]=0;S=aa+($*120|0)+92|0;c[S>>2]=255;c[aa+($*120|0)+68>>2]=64;T=av(U|0,V|0,9)|0;b=D&8355711;W=av(U|0,V|0,7)|0;X=aa+($*120|0)+40|0;c[X>>2]=T&2139062143|W&-16843010;c[X+4>>2]=b|D&16711422;X=av(U|0,V|0,16)|0;b=av(U|0,V|0,48)|0;b=(d[1167548+(X&43605)>>0]|0)+(d[1167548+(U&43605)>>0]|0)+(d[1167548+(V&43605)>>0]|0)+(d[1167548+(b&43605)>>0]|0)|0;c[aa+($*120|0)+108>>2]=b;c[aa+($*120|0)+104>>2]=(c[a+372>>2]|0)-b;b=c[a+2704>>2]|0;if((b|0)==64){e=0;b=255}else{N=c[a+5364>>2]|0;T=1043552+(N<<2)|0;e=0;H=b;b=255;L=0;M=0;f=N;g=0;h=0;K=a+2708|0;while(1){j=H&7;b=b&~(1<<j);c[S>>2]=b;n=111760+(H<<3)|0;L=c[n>>2]|L;M=c[n+4>>2]|M;n=Q;c[n>>2]=L;c[n+4>>2]=M;n=109712+(H<<3)|0;m=c[n>>2]|0;n=c[n+4>>2]|0;v=(m&O|0)!=0|(n&P|0)!=0;p=110736+(H<<3)|0;o=c[p>>2]&O;p=c[p+4>>2]&P;r=35984+(H<<3)|0;q=c[r>>2]&O;r=c[r+4>>2]&P;G=H+-8|0;t=35984+(G<<3)|0;s=c[t>>2]&O;t=c[t+4>>2]&P;G=30544+(G<<3)|0;F=c[G>>2]&U;G=c[G+4>>2]&V;j=31184+(j<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;k=i&U;l=j&V;w=H>>3;y=31120+(w<<3)|0;x=k&c[y>>2];y=l&c[y+4>>2];z=(f|0)==4;if(z&(w|0)==0){B=0;E=0}else{E=31120+(H+8>>3<<3)|0;B=c[E>>2]&k;E=c[E+4>>2]&l}A=B|x;C=E|y;u=(k|0)==0&(l|0)==0;I=(q|0)!=0|(r|0)!=0;J=w^7;if((J|0)>3|(I|u))i=0;else{a=nv(k|o|0,l|p|0,0)|0;a=31120+((a>>>3^7)<<3)|0;X=c[a>>2]|0;a=c[a+4>>2]|0;i=av(X&i|0,a&j|0,8)|0;i=((i|X)&o|0)!=0|((D|a)&p|0)!=0}if(((m&U|0)==0&(n&V|0)==0&((q^o|0)==(s|0)&(r^p|0)==(t|0))?(X=av(B|0,E|0,16)|0,W=av(B|0,E|0,48)|0,W=(d[1167548+(X&65535)>>0]|0)+(d[1167548+(B&65535)>>0]|0)+(d[1167548+(E&65535)>>0]|0)+(d[1167548+W>>0]|0)|0,X=av(q|0,r|0,16)|0,a=av(q|0,r|0,48)|0,W>>>0>=((d[1167548+(X&65535)>>0]|0)+(d[1167548+(q&65535)>>0]|0)+(d[1167548+(r&65535)>>0]|0)+(d[1167548+a>>0]|0)|0)>>>0):0)?(X=av(x|0,y|0,16)|0,W=av(x|0,y|0,48)|0,W=(d[1167548+(X&65535)>>0]|0)+(d[1167548+(x&65535)>>0]|0)+(d[1167548+(y&65535)>>0]|0)+(d[1167548+W>>0]|0)|0,X=av(s|0,t|0,16)|0,a=av(s|0,t|0,48)|0,W>>>0>=((d[1167548+(X&65535)>>0]|0)+(d[1167548+(s&65535)>>0]|0)+(d[1167548+(t&65535)>>0]|0)+(d[1167548+a>>0]|0)|0)>>>0):0){a=30544+(H<<3)|0;g=c[a>>2]|g;h=c[a+4>>2]|h;a=R;c[a>>2]=g;c[a+4>>2]=h}do if(!u){if(i){e=e-(c[1043444+(f<<3)+((v&1)<<2)>>2]|0)|0;break}if((B|0)==0&(E|0)==0)e=e-(c[1043516+(f<<2)>>2]|0)|0}else e=e-(c[1043372+(f<<3)+((v&1)<<2)>>2]|0)|0;while(0);if(z)if((w|0)!=7&((A|0)!=0|(C|0)!=0))_=46;else f=4;else if(!((A|0)==0&(C|0)==0))_=46;if((_|0)==46){_=0;f=Yu(B|0,E|0,-1,-1)|0;e=(c[1043620+(N<<8)+((v&1)<<7)+((((x|0)!=0|(y|0)!=0)&1)<<6)+((((f&B|0)!=0|(D&E|0)!=0)&1)<<5)+(J<<2)>>2]|0)+e|0;f=N}if(!((F|0)==0&(G|0)==0)){e=e-(c[T>>2]|0)|0;f=N}if(I)e=(c[1043588+(J<<2)>>2]|0)+e|0;H=c[K>>2]|0;if((H|0)==64)break;else K=K+4|0}}c[aa+($*120|0)+8>>2]=Z-e;_=b^Y;a=((_|0)<0)<<31>>31;X=av(_|0,a|0,16)|0;Z=av(_|0,a|0,48)|0;c[aa+($*120|0)+112>>2]=(d[1167548+(X&65535)>>0]|0)+(d[1167548+(_&65535)>>0]|0)+(d[1167548+(a&65535)>>0]|0)+(d[1167548+Z>>0]|0);Z=b&Y;a=((Z|0)<0)<<31>>31;Y=av(Z|0,a|0,16)|0;_=av(Z|0,a|0,48)|0;c[aa+($*120|0)+116>>2]=(d[1167548+(Y&65535)>>0]|0)+(d[1167548+(Z&65535)>>0]|0)+(d[1167548+(a&65535)>>0]|0)+(d[1167548+_>>0]|0);return ba|0}function xf(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[261482]=p;c[261481]=p;c[261483]=p+144;It(p,b);p=(c[261482]|0)+12|0;c[261482]=p;It(p,d);p=(c[261482]|0)+12|0;c[261482]=p;It(p,e);p=(c[261482]|0)+12|0;c[261482]=p;It(p,f);p=(c[261482]|0)+12|0;c[261482]=p;It(p,g);p=(c[261482]|0)+12|0;c[261482]=p;It(p,h);p=(c[261482]|0)+12|0;c[261482]=p;It(p,i);p=(c[261482]|0)+12|0;c[261482]=p;It(p,j);p=(c[261482]|0)+12|0;c[261482]=p;It(p,k);p=(c[261482]|0)+12|0;c[261482]=p;It(p,m);p=(c[261482]|0)+12|0;c[261482]=p;It(p,n);p=(c[261482]|0)+12|0;c[261482]=p;It(p,o);c[261482]=(c[261482]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);c[261484]=0;c[261485]=0;c[261486]=0;Jt(1045936,20896,15);l=a;return}function yf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;t=l;l=l+176|0;n=t+160|0;o=t+24|0;p=t+12|0;q=t;r=o+4|0;c[o>>2]=10952;s=o+56|0;c[s>>2]=10972;Rk(o+56|0,r);c[o+128>>2]=0;c[o+132>>2]=-1;c[o>>2]=10992;c[o+56>>2]=11012;Tk(r);c[r>>2]=3708;k=o+36|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[o+52>>2]=16;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jd(r,n);Mt(n);m=d+5364|0;i=d+4560|0;h=7;while(1){j=h<<3;e=0;do{f=0;while(1){if(c[d+(e+j<<2)>>2]|0){g=8;break}f=f+1|0;e=e+1|0;if((e|0)>=8){g=10;break}}if((g|0)==8){if(f|0)dl(o,f)|0;f=e+j|0;a[n>>0]=a[((a[1045947]|0)<0?c[261484]|0:1045936)+(c[d+(f<<2)>>2]|0)>>0]|0;Kd(o,n,1)|0;if((c[m>>2]|0)==3?(g=i,f=30544+(f<<3)|0,!((c[f>>2]&c[g>>2]|0)==0?(c[f+4>>2]&c[g+4>>2]|0)==0:0)):0)Kd(o,20912,1)|0}else if((g|0)==10)dl(o,f)|0;e=e+1|0}while((e|0)<8);if((h|0)<=0)break;a[n>>0]=47;Kd(o,n,1)|0;h=h+-1|0}if((c[m>>2]|0)==3){a[n>>0]=91;Kd(o,n,1)|0;f=n+11|0;g=n+4|0;e=0;do{j=e<<3;i=c[d+4496+(e<<5)+20>>2]|0;h=a[((a[1045947]|0)<0?c[261484]|0:1045936)+(j|5)>>0]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Kt(n,i,h);h=a[f>>0]|0;i=h<<24>>24<0;Kd(o,i?c[n>>2]|0:n,i?c[g>>2]|0:h&255)|0;Mt(n);h=c[d+4496+(e<<5)+16>>2]|0;i=a[((a[1045947]|0)<0?c[261484]|0:1045936)+(j|4)>>0]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Kt(n,h,i);i=a[f>>0]|0;h=i<<24>>24<0;Kd(o,h?c[n>>2]|0:n,h?c[g>>2]|0:i&255)|0;Mt(n);i=c[d+4496+(e<<5)+12>>2]|0;h=a[((a[1045947]|0)<0?c[261484]|0:1045936)+(j|3)>>0]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Kt(n,i,h);h=a[f>>0]|0;i=h<<24>>24<0;Kd(o,i?c[n>>2]|0:n,i?c[g>>2]|0:h&255)|0;Mt(n);h=c[d+4496+(e<<5)+8>>2]|0;i=a[((a[1045947]|0)<0?c[261484]|0:1045936)+(j|2)>>0]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Kt(n,h,i);i=a[f>>0]|0;h=i<<24>>24<0;Kd(o,h?c[n>>2]|0:n,h?c[g>>2]|0:i&255)|0;Mt(n);i=c[d+4496+(e<<5)+4>>2]|0;j=a[((a[1045947]|0)<0?c[261484]|0:1045936)+(j|1)>>0]|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Kt(n,i,j);j=a[f>>0]|0;i=j<<24>>24<0;Kd(o,i?c[n>>2]|0:n,i?c[g>>2]|0:j&255)|0;Mt(n);e=e+1|0}while((e|0)!=2);a[n>>0]=93;Kd(o,n,1)|0}g=d+5348|0;Kd(o,(c[g>>2]|0)==0?20914:20918,3)|0;h=d+5356|0;e=c[h>>2]|0;f=c[e+24>>2]|0;if(f&1){if(!(a[d+5360>>0]|0))e=75;else e=(c[d+5148>>2]&7)+65&255;a[n>>0]=e;Kd(o,n,1)|0;e=c[h>>2]|0;f=c[e+24>>2]|0}if(f&2){if(!(a[d+5360>>0]|0))e=81;else e=(c[d+5152>>2]&7)+65&255;a[n>>0]=e;Kd(o,n,1)|0;e=c[h>>2]|0;f=c[e+24>>2]|0}if(f&4){if(!(a[d+5360>>0]|0))e=107;else e=(c[d+5160>>2]&7)+97&255;a[n>>0]=e;Kd(o,n,1)|0;e=c[h>>2]|0;f=c[e+24>>2]|0}if(f&8){if(!(a[d+5360>>0]|0))e=113;else e=(c[d+5176>>2]&7)+97&255;a[n>>0]=e;Kd(o,n,1)|0;e=c[h>>2]|0;f=c[e+24>>2]|0}if(!(f&15)){a[n>>0]=45;Kd(o,n,1)|0;e=c[h>>2]|0}e=c[e+48>>2]|0;if((e|0)==64){c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,20922,3);q=a[n+11>>0]|0;p=q<<24>>24<0;Kd(o,p?c[n>>2]|0:n,p?c[n+4>>2]|0:q&255)|0;Mt(n)}else{th(q,e);j=Zt(q,0,21684)|0;c[p>>2]=c[j>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;j=Wt(p,21684)|0;c[n>>2]=c[j>>2];c[n+4>>2]=c[j+4>>2];c[n+8>>2]=c[j+8>>2];c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;j=a[n+11>>0]|0;i=j<<24>>24<0;Kd(o,i?c[n>>2]|0:n,i?c[n+4>>2]|0:j&255)|0;Mt(n);Mt(p);Mt(q)}if((c[m>>2]|0)!=8){p=c[h>>2]|0;p=p+28|0;p=c[p>>2]|0;p=dl(o,p)|0;p=Kd(p,21684,1)|0;n=d+5344|0;n=c[n>>2]|0;q=c[g>>2]|0;q=(q|0)==1;q=q&1;q=n-q|0;q=(q|0)/2|0;q=q+1|0;dl(p,q)|0;Ld(b,r);c[o>>2]=10992;c[s>>2]=11012;c[r>>2]=3708;Mt(k);Tj(r);cl(o,11024);Pj(s);l=t;return}p=Kd(dl(o,3-(c[(c[h>>2]|0)+36>>2]|0)|0)|0,20926,1)|0;Kd(dl(p,3-(c[(c[h>>2]|0)+40>>2]|0)|0)|0,21684,1)|0;p=c[h>>2]|0;p=p+28|0;p=c[p>>2]|0;p=dl(o,p)|0;p=Kd(p,21684,1)|0;n=d+5344|0;n=c[n>>2]|0;q=c[g>>2]|0;q=(q|0)==1;q=q&1;q=n-q|0;q=(q|0)/2|0;q=q+1|0;dl(p,q)|0;Ld(b,r);c[o>>2]=10992;c[s>>2]=11012;c[r>>2]=3708;Mt(k);Tj(r);cl(o,11024);Pj(s);l=t;return}function zf(b,e,f,g,h,i){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,T=0,U=0;H=l;l=l+144|0;A=H+140|0;F=H;G=F+8|0;c[F>>2]=10808;C=F+60|0;c[C>>2]=10828;c[F+4>>2]=0;Rk(F+60|0,G);c[F+132>>2]=0;c[F+136>>2]=-1;c[F>>2]=10848;c[F+60>>2]=10868;Tk(G);c[G>>2]=3708;E=F+40|0;c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;c[E+12>>2]=0;c[F+56>>2]=8;Jd(G,e);Wu(b|0,0,5376)|0;Wu(h|0,0,440)|0;e=1024;j=b+400|0;while(1){c[j>>2]=64;e=e+-1|0;if(!e)break;else j=j+4|0}B=b+5356|0;c[B>>2]=h;o=b+5368|0;c[o>>2]=g;a:do if((g|0)<9)e=g;else switch(g|0){case 9:{e=1;break a}case 10:{e=3;break a}case 11:{e=3;break a}default:{e=0;break a}}while(0);z=b+5364|0;c[z>>2]=e;n=F+(c[(c[F>>2]|0)+-12>>2]|0)+4|0;c[n>>2]=c[n>>2]&-4097;n=b+4560|0;p=b+256|0;e=0;m=56;b:while(1){k=30544+(m+-1<<3)|0;while(1){Wk(A,F,0);do if(a[A>>0]|0){j=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;h=j+12|0;g=c[h>>2]|0;if((g|0)==(c[j+16>>2]|0)){j=hb[c[(c[j>>2]|0)+40>>2]&127](j)|0;if((j|0)==-1){y=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(y,c[y+16>>2]|6);break}else e=j}else{c[h>>2]=g+1;e=d[g>>0]|0}e=e&255}while(0);if(c[F+(c[(c[F>>2]|0)+-12>>2]|0)+16>>2]&5|0){x=29;break b}j=e&255;if(vi(j)|0){x=29;break b}j=j+-48|0;if(j>>>0<10){x=19;break}if(e<<24>>24==47){x=21;break}j=_t(1045936,e,0)|0;if((j|0)!=-1){x=24;break}j=(c[z>>2]|0)==3;if(!j)continue;if(!(e<<24>>24==126&(c[o>>2]|0)!=11))if(e<<24>>24==91&j){e=91;x=30;break b}else continue;else{w=k;v=n;x=c[v+4>>2]|c[w+4>>2];y=n;c[y>>2]=c[v>>2]|c[w>>2];c[y+4>>2]=x;continue}}if((x|0)==19){m=j+m|0;continue}else if((x|0)==21){if((m|0)<16&(c[z>>2]|0)==3){e=47;x=30;break}e=47;m=m+-16|0;continue}else if((x|0)==24){c[b+(m<<2)>>2]=j;v=30544+(m<<3)|0;x=v;w=p;u=c[w+4>>2]|c[x+4>>2];y=p;c[y>>2]=c[w>>2]|c[x>>2];c[y+4>>2]=u;y=b+256+((j&7)<<3)|0;u=v;x=y;w=c[x+4>>2]|c[u+4>>2];c[y>>2]=c[x>>2]|c[u>>2];c[y+4>>2]=w;y=j>>3;w=b+320+(y<<3)|0;u=w;x=c[u+4>>2]|c[v+4>>2];c[w>>2]=c[u>>2]|c[v>>2];c[w+4>>2]=x;w=b+336+(j<<2)|0;x=c[w>>2]|0;c[w>>2]=x+1;c[b+4568+(m<<2)>>2]=x;c[b+400+(j<<8)+(x<<2)>>2]=m;y=b+336+(y<<3<<2)|0;c[y>>2]=(c[y>>2]|0)+1;m=m+1|0;continue}}if((x|0)==29)if((c[z>>2]|0)==3)x=30;else g=e;c:do if((x|0)==30){g=e;while(1){Wk(A,F,0);do if(!(a[A>>0]|0))e=g;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){e=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(e,c[e+16>>2]|6);e=g;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}e=e&255}while(0);if(c[F+(c[(c[F>>2]|0)+-12>>2]|0)+16>>2]&5|0){g=e;break c}if(vi(e&255)|0){g=e;break c}if(e<<24>>24==93){g=93;continue}j=_t(1045936,e,0)|0;if((j|0)==-1){g=e;continue}g=j>>3;y=b+4496+(g<<5)+((j&7)<<2)|0;c[y>>2]=(c[y>>2]|0)+1;g=b+4496+(g<<5)|0;c[g>>2]=(c[g>>2]|0)+1;g=e}}while(0);Wk(A,F,0);do if(a[A>>0]|0){e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){y=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(y,c[y+16>>2]|6);break}}else{c[j>>2]=h+1;e=d[h>>0]|0}g=e&255}while(0);y=b+5348|0;c[y>>2]=g<<24>>24!=119&1;Wk(A,F,0);do if(!(a[A>>0]|0))e=g;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){e=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(e,c[e+16>>2]|6);e=g;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}e=e&255}while(0);g=e;d:while(1){Wk(A,F,0);do if(a[A>>0]|0){e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){w=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(w,c[w+16>>2]|6);break}}else{c[j>>2]=h+1;e=d[h>>0]|0}g=e&255}while(0);if(c[F+(c[(c[F>>2]|0)+-12>>2]|0)+16>>2]&5|0)break;h=g&255;if(vi(h)|0)break;k=(kj(h)|0)!=0;o=k&1;m=k?7:0;e:do switch(c[z>>2]|0){case 4:{e=o<<3|6;if(!(c[b+336+(e<<2)>>2]|0))j=64;else x=68;break}case 2:{e=o<<3|6;if(!(c[b+336+(e<<2)>>2]|0))j=64;else x=68;break}case 1:{e=b+400+((o<<3|6)<<8)|0;while(1){j=c[e>>2]|0;if((j|0)==64){j=64;break e}if((j>>3|0)==(m|0))break;else e=e+4|0}break}default:{e=o<<3|6;x=68}}while(0);if((x|0)==68){x=0;j=c[b+400+(e<<8)>>2]|0}if((j>>3|0)!=(m|0))continue;n=o<<3|4;e=jj(h)|0;g=e&255;e=e&255;f:do switch(g<<24>>24){case 75:{e=k?63:7;if((e|0)==(j|0)){g=75;continue d}while(1){if((c[b+(e<<2)>>2]|0)==(n|0))break f;e=e+-1|0;if((e|0)==(j|0))continue d}}case 81:{e=k?56:0;if((e|0)==(j|0)){g=81;continue d}while(1){if((c[b+(e<<2)>>2]|0)==(n|0))break f;e=e+1|0;if((e|0)==(j|0))continue d}}default:{if((e+-65|0)>>>0>=8)continue d;e=(m<<3)+-65+e|0}}while(0);if((e|0)==(j|0))continue;Af(b,o,j,e)}Wk(A,F,0);do if(!(a[A>>0]|0))k=0;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){k=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(k,c[k+16>>2]|6);k=0;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}k=e&255}while(0);e=c[F>>2]|0;do if((k+-97&255)<8?(c[F+(c[e+-12>>2]|0)+16>>2]&5|0)==0:0){Wk(A,F,0);do if(!(a[A>>0]|0))j=0;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){j=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(j,c[j+16>>2]|6);j=0;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}j=e&255}while(0);e=c[F>>2]|0;if(!(c[F+(c[e+-12>>2]|0)+16>>2]&5)){v=c[y>>2]|0;w=(v|0)==0;if(w){if(j<<24>>24!=54){x=115;break}}else if(j<<24>>24!=51){x=115;break}h=(k&255)+-489+((j&255)<<3)|0;j=c[B>>2]|0;u=j+48|0;c[u>>2]=h;n=p;m=c[n>>2]|0;n=c[n+4>>2]|0;Q=35984+(h<<3)|0;p=b+320|0;o=c[p>>2]|0;p=c[p+4>>2]|0;r=b+264|0;q=c[r>>2]|0;r=c[r+4>>2]|0;R=31888+(h<<3)|0;t=b+328|0;s=c[t>>2]|0;t=c[t+4>>2]|0;O=32400+(h<<3)|0;P=b+272|0;N=28496+(h<<3)|0;M=29008+(h<<3)|0;M=(S(c[N+4>>2]&n,c[M+4>>2]|0)|0)^(S(c[N>>2]&m,c[M>>2]|0)|0);M=(c[1035428+(h<<2)>>2]|0)+(M>>>(c[1035684+(h<<2)>>2]|0)<<3)|0;N=b+288|0;K=b+296|0;U=c[K>>2]|0;K=c[K+4>>2]|0;L=29520+(h<<3)|0;J=30032+(h<<3)|0;J=(S(c[L+4>>2]&n,c[J+4>>2]|0)|0)^(S(c[L>>2]&m,c[J>>2]|0)|0);J=(c[1035940+(h<<2)>>2]|0)+(J>>>(c[1036196+(h<<2)>>2]|0)<<3)|0;L=b+280|0;k=34448+(h<<3)|0;I=b+304|0;T=b+320+(v<<3)|0;if(!((c[T>>2]&q&(c[R>>2]&q&s|o&c[Q>>2]&q|c[P>>2]&c[O>>2]|(U|c[N>>2])&c[M>>2]|(c[L>>2]|U)&c[J>>2]|c[I>>2]&c[k>>2])|0)==0?(c[T+4>>2]&r&(c[R+4>>2]&r&t|p&c[Q+4>>2]&r|c[P+4>>2]&c[O+4>>2]|(K|c[N+4>>2])&c[M+4>>2]|(c[L+4>>2]|K)&c[J+4>>2]|c[I+4>>2]&c[k+4>>2])|0)==0:0)?(U=v^1,T=b+320+(U<<3)|0,U=30544+(((U|0)==0?8:-8)+h<<3)|0,!((c[T>>2]&q&c[U>>2]|0)==0?(c[T+4>>2]&r&c[U+4>>2]|0)==0:0)):0){k=30544+(h<<3)|0;h=c[k>>2]|0;k=c[k+4>>2]|0;if(!((h&m|0)==0&(k&n|0)==0)){c[u>>2]=64;break}if(w){U=gv(h|0,k|0,8)|0;if(!((U&m|0)==0&(D&n|0)==0)){c[u>>2]=64;break}U=av(h|0,k|0,8)|0;if(!((U&s&q|0)==0&(D&t&r|0)==0))break;c[u>>2]=64;break}if((v|0)!=1)break;U=av(h|0,k|0,8)|0;if(!((U&m|0)==0&(D&n|0)==0)){c[u>>2]=64;break}U=gv(h|0,k|0,8)|0;if(!((U&o&q|0)==0&(D&p&r|0)==0))break;c[u>>2]=64;break}c[u>>2]=64}else x=115}else x=115;while(0);if((x|0)==115){j=c[B>>2]|0;c[j+48>>2]=64}c[j+36>>2]=0;c[j+40>>2]=0;U=F+(c[e+-12>>2]|0)+4|0;c[U>>2]=c[U>>2]|4096;Wk(A,F,0);do if(a[A>>0]|0){e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){U=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(U,c[U+16>>2]|6);break}}else{c[j>>2]=h+1;e=d[h>>0]|0}g=e&255}while(0);if((c[z>>2]|0)==8?(al(F)|0)==43:0){U=51-(g&255)|0;U=(U|0)>3?3:U;c[(c[B>>2]|0)+36>>2]=(U|0)<0?0:U;Wk(A,F,0);do if(a[A>>0]|0){e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){U=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(U,c[U+16>>2]|6);break}}else{c[j>>2]=h+1;e=d[h>>0]|0}g=e&255}while(0);Wk(A,F,0);do if(!(a[A>>0]|0))e=g;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){e=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(e,c[e+16>>2]|6);e=g;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}e=e&255}while(0);g=51-(e&255)|0;g=(g|0)>3?3:g;U=c[B>>2]|0;c[U+40>>2]=(g|0)<0?0:g;g=e;e=U}else{bl(F,g)|0;e=c[B>>2]|0}k=F+(c[(c[F>>2]|0)+-12>>2]|0)+4|0;c[k>>2]=c[k>>2]|4096;k=b+5344|0;_k(_k(F,e+28|0)|0,k)|0;if((c[z>>2]|0)!=8){T=c[k>>2]|0;T=T<<1;T=T+-2|0;U=(T|0)<0;T=U?0:T;U=c[y>>2]|0;U=(U|0)==1;U=U&1;U=T|U;c[k>>2]=U;U=b+5360|0;T=f&1;a[U>>0]=T;U=b+5352|0;c[U>>2]=i;U=c[B>>2]|0;Bf(b,U);c[F>>2]=10848;c[C>>2]=10868;c[G>>2]=3708;Mt(E);Tj(G);Vk(F,10880);Pj(C);l=H;return b|0}Wk(A,F,0);do if(!(a[A>>0]|0))e=g;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){e=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(e,c[e+16>>2]|6);e=g;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}e=e&255}while(0);if(!(e<<24>>24==43?(c[F+(c[(c[F>>2]|0)+-12>>2]|0)+16>>2]&5|0)==0:0)){T=c[k>>2]|0;T=T<<1;T=T+-2|0;U=(T|0)<0;T=U?0:T;U=c[y>>2]|0;U=(U|0)==1;U=U&1;U=T|U;c[k>>2]=U;U=b+5360|0;T=f&1;a[U>>0]=T;U=b+5352|0;c[U>>2]=i;U=c[B>>2]|0;Bf(b,U);c[F>>2]=10848;c[C>>2]=10868;c[G>>2]=3708;Mt(E);Tj(G);Vk(F,10880);Pj(C);l=H;return b|0}Wk(A,F,0);do if(!(a[A>>0]|0))g=43;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){g=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(g,c[g+16>>2]|6);g=43;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}g=e&255}while(0);U=(g&255)+-48|0;U=(U|0)>3?3:U;c[(c[B>>2]|0)+36>>2]=(U|0)<0?0:U;Wk(A,F,0);do if(a[A>>0]|0){e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){U=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(U,c[U+16>>2]|6);break}}else{c[j>>2]=h+1;e=d[h>>0]|0}g=e&255}while(0);Wk(A,F,0);do if(!(a[A>>0]|0))e=g;else{e=c[F+(c[(c[F>>2]|0)+-12>>2]|0)+24>>2]|0;j=e+12|0;h=c[j>>2]|0;if((h|0)==(c[e+16>>2]|0)){e=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;if((e|0)==-1){e=F+(c[(c[F>>2]|0)+-12>>2]|0)|0;Qk(e,c[e+16>>2]|6);e=g;break}}else{c[j>>2]=h+1;e=d[h>>0]|0}e=e&255}while(0);T=(e&255)+-48|0;T=(T|0)>3?3:T;c[(c[B>>2]|0)+40>>2]=(T|0)<0?0:T;T=c[k>>2]|0;T=T<<1;T=T+-2|0;U=(T|0)<0;T=U?0:T;U=c[y>>2]|0;U=(U|0)==1;U=U&1;U=T|U;c[k>>2]=U;U=b+5360|0;T=f&1;a[U>>0]=T;U=b+5352|0;c[U>>2]=i;U=c[B>>2]|0;Bf(b,U);c[F>>2]=10848;c[C>>2]=10868;c[G>>2]=3708;Mt(E);Tj(G);Vk(F,10880);Pj(C);l=H;return b|0}function Af(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0;i=(d|0)<(e|0);h=1<<((i&1|b<<1)^1);g=(c[a+5356>>2]|0)+24|0;c[g>>2]=c[g>>2]|h;g=a+4824+(d<<2)|0;c[g>>2]=c[g>>2]|h;g=a+4824+(e<<2)|0;c[g>>2]=c[g>>2]|h;c[a+5080+(h<<2)>>2]=d;c[a+5144+(h<<2)>>2]=e;g=b*56|0;b=(i?5:3)|g;f=(b|0)>(e|0)?b:e;h=a+5208+(h<<3)|0;b=(b|0)<(e|0)?b:e;while(1){if(!((b|0)==(d|0)|(b|0)==(e|0))){k=30544+(b<<3)|0;l=h;j=c[l+4>>2]|c[k+4>>2];a=h;c[a>>2]=c[l>>2]|c[k>>2];c[a+4>>2]=j}if((b|0)<(f|0))b=b+1|0;else break}b=(i?6:2)|g;a=(b|0)>(d|0)?b:d;b=(b|0)<(d|0)?b:d;while(1){if(!((b|0)==(d|0)|(b|0)==(e|0))){j=30544+(b<<3)|0;i=h;k=c[i+4>>2]|c[j+4>>2];l=h;c[l>>2]=c[i>>2]|c[j>>2];c[l+4>>2]=k}if((b|0)<(a|0))b=b+1|0;else break}return}function Bf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=a+5364|0;k=985968+(c[n>>2]<<3)|0;i=c[k>>2]|0;k=c[k+4>>2]|0;l=b+8|0;m=l;c[m>>2]=i;c[m+4>>2]=k;m=b+56|0;j=m;c[j>>2]=i;c[j+4>>2]=k;j=985960;k=c[j+4>>2]|0;i=b;c[i>>2]=c[j>>2];c[i+4>>2]=k;c[b+20>>2]=0;c[b+16>>2]=0;i=b+44|0;c[i>>2]=0;Cf(a,b);n=c[n>>2]|0;a:do switch(n|0){case 7:{d=c[a+5348>>2]<<3;if((c[a+400+((d|6)<<8)>>2]&-8|0)==56){e=0;d=0}else{e=0;d=c[30544+(c[a+400+((d^14)<<8)>>2]<<3)+4>>2]&-16777216}k=b+64|0;c[k>>2]=e;c[k+4>>2]=d;break}case 4:{if(!(c[a+336+((c[a+5348>>2]<<3|6)<<2)>>2]|0)){k=b+64|0;c[k>>2]=0;c[k+4>>2]=0}else g=7;break}case 1:{k=b+64|0;c[k>>2]=0;c[k+4>>2]=0;break}case 2:{f=c[a+5348>>2]|0;d=f<<3|6;if(c[a+336+(d<<2)>>2]|0?(e=c[a+400+(d<<8)>>2]|0,(e|0)!=64):0){e=34448+(e<<3)|0;d=f<<3^14;if(!(c[a+336+(d<<2)>>2]|0))d=64;else d=c[a+400+(d<<8)>>2]|0;k=30544+(d<<3)|0;if((c[k>>2]&c[e>>2]|0)==0?(c[k+4>>2]&c[e+4>>2]|0)==0:0){e=f;g=15;break a}}k=b+64|0;c[k>>2]=0;c[k+4>>2]=0;break}default:g=7}while(0);if((g|0)==7){e=c[a+5348>>2]|0;g=15}if((g|0)==15){switch(n|0){case 4:{d=e<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else g=20;break}case 2:{d=e<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else g=20;break}case 1:{d=e<<3|6;if(!(c[a+336+(d<<2)>>2]|0))d=64;else g=20;break}default:{d=e<<3|6;g=20}}if((g|0)==20)d=c[a+400+(d<<8)>>2]|0;f=a+256|0;q=c[f>>2]|0;f=c[f+4>>2]|0;w=35984+(d<<3)|0;x=a+320|0;k=a+264|0;v=c[k>>2]|0;k=c[k+4>>2]|0;z=31888+(d<<3)|0;y=a+328|0;t=32400+(d<<3)|0;u=a+272|0;s=28496+(d<<3)|0;r=29008+(d<<3)|0;r=(S(c[s+4>>2]&f,c[r+4>>2]|0)|0)^(S(c[s>>2]&q,c[r>>2]|0)|0);r=(c[1035428+(d<<2)>>2]|0)+(r>>>(c[1035684+(d<<2)>>2]|0)<<3)|0;s=a+288|0;j=a+296|0;p=c[j>>2]|0;j=c[j+4>>2]|0;g=29520+(d<<3)|0;o=30032+(d<<3)|0;o=(S(c[g+4>>2]&f,c[o+4>>2]|0)|0)^(S(c[g>>2]&q,c[o>>2]|0)|0);o=(c[1035940+(d<<2)>>2]|0)+(o>>>(c[1036196+(d<<2)>>2]|0)<<3)|0;q=a+280|0;g=34448+(d<<3)|0;f=a+304|0;h=a+320+((e^1)<<3)|0;j=(c[z+4>>2]&k&c[y+4>>2]|c[x+4>>2]&c[w+4>>2]&k|c[u+4>>2]&c[t+4>>2]|(j|c[s+4>>2])&c[r+4>>2]|(c[q+4>>2]|j)&c[o+4>>2]|c[f+4>>2]&c[g+4>>2])&c[h+4>>2];k=b+64|0;c[k>>2]=(c[z>>2]&v&c[y>>2]|c[x>>2]&c[w>>2]&v|c[u>>2]&c[t>>2]|(p|c[s>>2])&c[r>>2]|(c[q>>2]|p)&c[o>>2]|c[f>>2]&c[g>>2])&c[h>>2];c[k+4>>2]=j}e=a+256|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==0&(e|0)==0)){g=m;f=c[g>>2]|0;g=c[g+4>>2]|0;h=c[i>>2]|0;do{z=Qa(d|0,e|0,0)|0;y=Yu(d|0,e|0,-1,-1)|0;d=y&d;e=D&e;y=c[a+(z<<2)>>2]|0;x=977568+(y<<9)+(z<<3)|0;f=f^c[x>>2];g=g^c[x+4>>2];x=m;c[x>>2]=f;c[x+4>>2]=g;h=h+(c[1045948+(n*4160|0)+(y*260|0)+(z<<2)>>2]|0)|0;c[i>>2]=h}while(!((d|0)==0&(e|0)==0))}h=(n|0)==3;if(h){z=S(c[a+4500>>2]|0,c[264736]|0)|0;z=(c[i>>2]|0)+z|0;c[i>>2]=z;z=z+(S(c[a+4504>>2]|0,c[264801]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4508>>2]|0,c[264866]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4512>>2]|0,c[264931]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4516>>2]|0,c[264996]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4520>>2]|0,c[265061]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4532>>2]|0,c[265256]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4536>>2]|0,c[265321]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4540>>2]|0,c[265386]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4544>>2]|0,c[265451]|0)|0)|0;c[i>>2]=z;z=z+(S(c[a+4548>>2]|0,c[265516]|0)|0)|0;c[i>>2]=z;c[i>>2]=z+(S(c[a+4552>>2]|0,c[265581]|0)|0)}d=c[b+48>>2]|0;if((d|0)!=64){x=985760+((d&7)<<3)|0;w=m;y=c[w+4>>2]^c[x+4>>2];z=m;c[z>>2]=c[w>>2]^c[x>>2];c[z+4>>2]=y}if((c[a+5348>>2]|0)==1){e=985952;z=m;d=c[z>>2]^c[e>>2];e=c[z+4>>2]^c[e+4>>2];z=m;c[z>>2]=d;c[z+4>>2]=e}else{e=m;d=c[e>>2]|0;e=c[e+4>>2]|0}y=985824+(c[b+24>>2]<<3)|0;z=e^c[y+4>>2];e=m;c[e>>2]=d^c[y>>2];c[e+4>>2]=z;e=a+264|0;d=c[e>>2]|0;e=c[e+4>>2]|0;if(!((d|0)==0&(e|0)==0)){g=b;f=c[g>>2]|0;g=c[g+4>>2]|0;do{z=Qa(d|0,e|0,0)|0;y=Yu(d|0,e|0,-1,-1)|0;d=y&d;e=D&e;z=977568+(c[a+(z<<2)>>2]<<9)+(z<<3)|0;f=f^c[z>>2];g=g^c[z+4>>2];z=b;c[z>>2]=f;c[z+4>>2]=g}while(!((d|0)==0&(e|0)==0))}b:do if(h){e=10892;while(1){f=c[e>>2]|0;g=f&7;k=f&255;switch(k&7){case 1:case 6:break;default:{z=b+16+(f>>3<<2)|0;c[z>>2]=(S(c[11108+(f<<2)>>2]|0,c[a+336+(f<<2)>>2]|0)|0)+(c[z>>2]|0)}}j=c[a+336+(f<<2)>>2]|0;if((j|0)>0){i=l;d=0;h=c[i>>2]|0;i=c[i+4>>2]|0;do{z=977568+(f<<9)+(d<<3)|0;h=h^c[z>>2];i=i^c[z+4>>2];z=l;c[z>>2]=h;c[z+4>>2]=i;d=d+1|0}while((d|0)<(j|0))}switch(k&7){case 1:case 6:break;default:{y=f>>3;z=b+16+(y<<2)|0;c[z>>2]=(S(c[11108+(f<<2)>>2]|0,c[a+4496+(y<<5)+(g<<2)>>2]|0)|0)+(c[z>>2]|0)}}x=986040+(f*136|0)+(c[a+4496+(f>>3<<5)+(g<<2)>>2]<<3)|0;w=m;y=c[w+4>>2]^c[x+4>>2];z=m;c[z>>2]=c[w>>2]^c[x>>2];c[z+4>>2]=y;e=e+4|0;if((e|0)==10940)break b}}else{e=10892;while(1){f=c[e>>2]|0;switch(f&7){case 1:case 6:break;default:{z=b+16+(f>>3<<2)|0;c[z>>2]=(S(c[11108+(f<<2)>>2]|0,c[a+336+(f<<2)>>2]|0)|0)+(c[z>>2]|0)}}g=c[a+336+(f<<2)>>2]|0;if((g|0)>0){i=l;d=0;h=c[i>>2]|0;i=c[i+4>>2]|0;do{z=977568+(f<<9)+(d<<3)|0;h=h^c[z>>2];i=i^c[z+4>>2];z=l;c[z>>2]=h;c[z+4>>2]=i;d=d+1|0}while((d|0)<(g|0))}e=e+4|0;if((e|0)==10940)break b}}while(0);if((n|0)!=8)return;y=988216+(c[b+36>>2]<<3)|0;x=m;w=c[x>>2]^c[y>>2];y=c[x+4>>2]^c[y+4>>2];x=m;c[x>>2]=w;c[x+4>>2]=y;x=988248+(c[b+40>>2]<<3)|0;y=y^c[x+4>>2];z=m;c[z>>2]=w^c[x>>2];c[z+4>>2]=y;return}
function oe(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;z=l;l=l+64|0;v=z;s=d+5356|0;n=(c[s>>2]|0)+8|0;o=c[n>>2]|0;n=c[n+4>>2]|0;m=d+5352|0;w=o&8191;x=c[(c[m>>2]|0)+100>>2]|0;y=x+(w<<5)|0;u=y;if((c[u>>2]|0)==(o|0)?(c[u+4>>2]|0)==(n|0):0){l=z;return y|0}t=x+(w<<5)+8|0;c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;c[t+12>>2]=0;c[t+16>>2]=0;c[t+20>>2]=0;t=y;c[t>>2]=o;c[t+4>>2]=n;t=x+(w<<5)+23|0;a[t>>0]=64;u=x+(w<<5)+22|0;a[u>>0]=64;c[x+(w<<5)+24>>2]=Of(d)|0;k=c[m>>2]|0;j=k+112|0;i=c[k+116>>2]|0;a:do if(i){e=i;while(1){h=e+16|0;g=c[h>>2]|0;h=c[h+4>>2]|0;if(!(h>>>0>n>>>0|(h|0)==(n|0)&g>>>0>o>>>0)){if(!(h>>>0<n>>>0|(h|0)==(n|0)&g>>>0<o>>>0))break;e=e+4|0}e=c[e>>2]|0;if(!e){r=21;break a}}while(1){g=i+16|0;e=c[g>>2]|0;g=c[g+4>>2]|0;if(n>>>0<g>>>0|(n|0)==(g|0)&o>>>0<e>>>0){e=c[i>>2]|0;if(!e){r=11;break}}else{if(!(g>>>0<n>>>0|(g|0)==(n|0)&e>>>0<o>>>0)){r=16;break}g=i+4|0;e=c[g>>2]|0;if(!e){r=15;break}}i=e}if((r|0)==11){c[v>>2]=i;g=i}else if((r|0)==15)c[v>>2]=i;else if((r|0)==16){c[v>>2]=i;g=v}e=c[g>>2]|0;if(!e){e=At(32)|0;h=e+16|0;c[h>>2]=o;c[h+4>>2]=n;c[e+24>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=i;c[g>>2]=e;h=c[c[j>>2]>>2]|0;if(!h)g=e;else{c[j>>2]=h;g=c[g>>2]|0}dc(c[k+116>>2]|0,g);p=k+120|0;c[p>>2]=(c[p>>2]|0)+1}p=c[e+24>>2]|0;e=x+(w<<5)+8|0;c[e>>2]=p;if(!p)g=e;else{l=z;return y|0}}else r=21;while(0);if((r|0)==21){g=x+(w<<5)+8|0;c[g>>2]=0}p=d+5364|0;e=c[p>>2]|0;b:do switch(e|0){case 0:{k=d+328|0;j=c[k>>2]|0;k=c[k+4>>2]|0;if(((Yu(j|0,k|0,-1,-1)|0)&j|0)==0&(D&k|0)==0?(c[(c[s>>2]|0)+16>>2]|0)>1284:0)e=0;else{k=d+320|0;j=c[k>>2]|0;k=c[k+4>>2]|0;i=Yu(j|0,k|0,-1,-1)|0;if(!((i&j|0)==0&(D&k|0)==0))break b;if((c[(c[s>>2]|0)+20>>2]|0)>1284)e=1;else break b}c[g>>2]=1042876+(e*12|0);l=z;return y|0}case 2:{k=d+328|0;j=c[k>>2]|0;k=c[k+4>>2]|0;if(((Yu(j|0,k|0,-1,-1)|0)&j|0)==0&(D&k|0)==0?(c[(c[s>>2]|0)+16>>2]|0)>2037:0)e=0;else{k=d+320|0;j=c[k>>2]|0;k=c[k+4>>2]|0;i=Yu(j|0,k|0,-1,-1)|0;if(!((i&j|0)==0&(D&k|0)==0))break b;if((c[(c[s>>2]|0)+20>>2]|0)>2037)e=1;else break b}c[g>>2]=1042900+(e*12|0);l=z;return y|0}default:{}}while(0);m=c[m>>2]|0;k=m+124|0;j=c[m+128>>2]|0;c:do if(j){g=j;while(1){i=g+16|0;h=c[i>>2]|0;i=c[i+4>>2]|0;if(!(i>>>0>n>>>0|(i|0)==(n|0)&h>>>0>o>>>0)){if(!(i>>>0<n>>>0|(i|0)==(n|0)&h>>>0<o>>>0))break;g=g+4|0}g=c[g>>2]|0;if(!g)break c}while(1){g=j+16|0;e=c[g>>2]|0;g=c[g+4>>2]|0;if(n>>>0<g>>>0|(n|0)==(g|0)&o>>>0<e>>>0){e=c[j>>2]|0;if(!e){r=41;break}}else{if(!(g>>>0<n>>>0|(g|0)==(n|0)&e>>>0<o>>>0)){r=46;break}g=j+4|0;e=c[g>>2]|0;if(!e){r=45;break}}j=e}if((r|0)==41){c[v>>2]=j;h=j}else if((r|0)==45){c[v>>2]=j;h=g}else if((r|0)==46){c[v>>2]=j;h=v}e=c[h>>2]|0;if(!e){e=At(32)|0;g=e+16|0;c[g>>2]=o;c[g+4>>2]=n;c[e+24>>2]=0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=j;c[h>>2]=e;g=c[c[k>>2]>>2]|0;if(!g)g=e;else{c[k>>2]=g;g=c[h>>2]|0}dc(c[m+128>>2]|0,g);o=m+132|0;c[o>>2]=(c[o>>2]|0)+1}e=c[e+24>>2]|0;if(!e){e=c[p>>2]|0;break}c[x+(w<<5)+12+((hb[c[(c[e>>2]|0)+8>>2]&127](e)|0)<<2)>>2]=e;l=z;return y|0}while(0);switch(e|0){case 0:{g=c[(c[s>>2]|0)+16>>2]|0;if(((g|0)==814?(c[d+348>>2]|0)==1:0)?(q=c[d+340>>2]|0,(q|0)>0):0){c[x+(w<<5)+12>>2]=1042924;e=q}else{e=c[d+340>>2]|0;if(!e)if((((g|0)==2513?(c[d+356>>2]|0)==1:0)?(c[d+384>>2]|0)==1:0)?(c[d+372>>2]|0)>0:0){c[x+(w<<5)+12>>2]=1042948;e=0}else e=0}g=c[(c[s>>2]|0)+20>>2]|0;if(((g|0)==814?(c[d+380>>2]|0)==1:0)?(f=c[d+372>>2]|0,(f|0)>0):0)c[x+(w<<5)+16>>2]=1042936;else{f=c[d+372>>2]|0;if(!f)if(((g|0)==2513?(c[d+388>>2]|0)==1:0)?((e|0)>0?(c[d+352>>2]|0)==1:0):0){c[x+(w<<5)+16>>2]=1042960;f=0}else f=0}j=c[s>>2]|0;k=c[j+16>>2]|0;j=c[j+20>>2]|0;d:do if((j|0)==(0-k|0)?(s=d+264|0,!((c[s>>2]|0)==0&(c[s+4>>2]|0)==0)):0){if(!f){c[x+(w<<5)+12>>2]=1042972;r=74;break}switch(e|0){case 0:{c[x+(w<<5)+16>>2]=1042984;r=74;break d}case 1:{r=71;break}default:{}}if((r|0)==71?(f|0)==1:0){c[x+(w<<5)+12>>2]=1042996;c[x+(w<<5)+16>>2]=1043008}g=(k-j|0)<815;e=d+340|0;r=75}else r=74;while(0);if((r|0)==74){h=d+340|0;g=(k-j|0)<815;if(g&(e|0)==0){a[u>>0]=(k|0)<1285?0:(j|0)<815?4:14;f=d+372|0;i=f;f=c[f>>2]|0}else{e=h;r=75}}if((r|0)==75){i=d+372|0;h=e}e=(j-k|0)<815;if(e&(f|0)==0)a[t>>0]=(j|0)<1285?0:(k|0)<815?4:14;if(g&(c[h>>2]|0)==1)a[u>>0]=48;if(e&(c[i>>2]|0)==1)a[t>>0]=48;break}case 2:{t=c[s>>2]|0;s=d+264|0;if((c[s>>2]|0)==0&(c[s+4>>2]|0)==0&((c[t+20>>2]|0)+(c[t+16>>2]|0)|0)<1286)a[u>>0]=0;break}default:{}}m=c[d+348>>2]|0;g=(m|0)>1&1;c[v>>2]=g;c[v+4>>2]=c[d+340>>2];c[v+8>>2]=c[d+344>>2];c[v+12>>2]=m;c[v+16>>2]=c[d+352>>2];c[v+20>>2]=c[d+356>>2];c[v+24>>2]=c[d+360>>2];c[v+28>>2]=0;m=c[d+380>>2]|0;c[v+32>>2]=(m|0)>1&1;c[v+36>>2]=c[d+372>>2];c[v+40>>2]=c[d+376>>2];c[v+44>>2]=m;c[v+48>>2]=c[d+384>>2];c[v+52>>2]=c[d+388>>2];c[v+56>>2]=c[d+392>>2];c[v+60>>2]=0;m=c[p>>2]|0;n=(m|0)==1|(m|0)==4?6:5;i=0;h=0;j=1;while(1){if(g){e=0;f=0;do{u=S(c[v+(e<<2)>>2]|0,c[4008+(m<<8)+(i<<5)+(e<<2)>>2]|0)|0;f=u+f+(S(c[v+32+(e<<2)>>2]|0,c[6312+(m<<8)+(i<<5)+(e<<2)>>2]|0)|0)|0;e=e+1|0}while((e|0)!=(j|0));h=(S(f,g)|0)+h|0}e=i+1|0;if((i|0)>=(n|0)){j=0;e=0;k=1;break}i=e;g=c[v+(e<<2)>>2]|0;j=j+1|0}while(1){i=c[v+32+(j<<2)>>2]|0;if(i){f=0;g=0;do{u=S(c[v+32+(f<<2)>>2]|0,c[4008+(m<<8)+(j<<5)+(f<<2)>>2]|0)|0;g=u+g+(S(c[v+(f<<2)>>2]|0,c[6312+(m<<8)+(j<<5)+(f<<2)>>2]|0)|0)|0;f=f+1|0}while((f|0)!=(k|0));e=(S(g,i)|0)+e|0}if((j|0)<(n|0)){j=j+1|0;k=k+1|0}else break}b[x+(w<<5)+20>>1]=(h-e|0)/16|0;l=z;return y|0}function pe(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[260756]=p;c[260755]=p;c[260757]=p+144;It(p,b);p=(c[260756]|0)+12|0;c[260756]=p;It(p,d);p=(c[260756]|0)+12|0;c[260756]=p;It(p,e);p=(c[260756]|0)+12|0;c[260756]=p;It(p,f);p=(c[260756]|0)+12|0;c[260756]=p;It(p,g);p=(c[260756]|0)+12|0;c[260756]=p;It(p,h);p=(c[260756]|0)+12|0;c[260756]=p;It(p,i);p=(c[260756]|0)+12|0;c[260756]=p;It(p,j);p=(c[260756]|0)+12|0;c[260756]=p;It(p,k);p=(c[260756]|0)+12|0;c[260756]=p;It(p,m);p=(c[260756]|0)+12|0;c[260756]=p;It(p,n);p=(c[260756]|0)+12|0;c[260756]=p;It(p,o);c[260756]=(c[260756]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);c[260758]=0;c[260759]=0;c[260760]=0;Jt(1043032,1235164,0);l=a;return}function qe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;F=l;l=l+352|0;t=F+208|0;y=F+196|0;z=F+184|0;A=F+172|0;B=F+160|0;D=F+16|0;E=F;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;Jt(y,20750,47);c[z>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;c[A>>2]=0;c[A+4>>2]=0;c[A+8>>2]=0;c[B>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;s=D+8|0;c[s>>2]=3632;q=D+12|0;c[D>>2]=3672;r=D+64|0;c[r>>2]=3692;c[D+4>>2]=0;Rk(D+64|0,q);c[D+136>>2]=0;c[D+140>>2]=-1;c[D>>2]=3612;c[D+64>>2]=3652;c[s>>2]=3632;Tk(q);c[q>>2]=3708;s=D+44|0;c[s>>2]=0;c[s+4>>2]=0;c[s+8>>2]=0;c[s+12>>2]=0;c[D+60>>2]=24;c[t>>2]=0;c[t+4>>2]=0;c[t+8>>2]=0;Jd(q,t);Mt(t);c[E>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Jt(E,20798,11);w=t+8|0;c[w>>2]=3632;u=t+12|0;c[t>>2]=3672;v=t+64|0;c[v>>2]=3692;c[t+4>>2]=0;Rk(t+64|0,u);c[t+136>>2]=0;c[t+140>>2]=-1;c[t>>2]=3612;c[t+64>>2]=3652;c[w>>2]=3632;Tk(u);c[u>>2]=3708;w=t+44|0;c[w>>2]=0;c[w+4>>2]=0;c[w+8>>2]=0;c[w+12>>2]=0;c[t+60>>2]=24;Jd(u,E);Mt(E);x=D+8|0;o=Kd(x,20810,10)|0;C=a[1043043]|0;p=C<<24>>24<0;C=Kd(o,p?c[260758]|0:1043032,p?c[260759]|0:C&255)|0;c[C+(c[(c[C>>2]|0)+-12>>2]|0)+76>>2]=48;C=a[1043043]|0;if(!((C<<24>>24<0?c[260759]|0:C&255)|0)){re(re(re(t,z)|0,A)|0,B)|0;c[x+(c[(c[x>>2]|0)+-12>>2]|0)+12>>2]=2;C=a[A+11>>0]|0;e=C<<24>>24<0;C=Kd(x,e?c[A>>2]|0:A,e?c[A+4>>2]|0:C&255)|0;c[C+(c[(c[C>>2]|0)+-12>>2]|0)+12>>2]=2;e=a[y+11>>0]|0;f=e<<24>>24<0;g=f?c[y>>2]|0:y;e=f?c[y+4>>2]|0:e&255;f=a[z+11>>0]|0;p=f<<24>>24<0;j=p?c[z>>2]|0:z;f=p?c[z+4>>2]|0:f&255;if(e>>>0>=f>>>0)if(!f)e=1;else{o=g+e|0;k=j+f|0;p=g;m=o;a:do if((e|0)>=(f|0)?(n=o+(1-f)|0,(n|0)!=(g|0)):0){i=a[j>>0]|0;e=p;f=g;while(1){while(1){if((a[f>>0]|0)==i<<24>>24){g=j;h=f;break}f=f+1|0;if((f|0)==(n|0)){e=m;break a}else e=f}do{g=g+1|0;if((g|0)==(k|0))break a;h=h+1|0}while((a[h>>0]|0)==(a[g>>0]|0));f=f+1|0;if((f|0)==(n|0)){e=m;break}else e=f}}else e=m;while(0);e=(e|0)==(o|0)?1073741824:((e-p|0)>>>2)+1|0}else e=1073741824;o=el(C,e)|0;Lt(E,B,2,-1,B);C=a[E+11>>0]|0;p=C<<24>>24<0;Kd(o,p?c[E>>2]|0:E,p?c[E+4>>2]|0:C&255)|0;Mt(E)}E=Kd(Kd(x,1235164,0)|0,1235164,0)|0;Kd(Kd(E,d?20821:20833,d?11:4)|0,20838,47)|0;Ld(b,q);c[t>>2]=3612;c[v>>2]=3652;c[t+8>>2]=3632;c[u>>2]=3708;Mt(w);Tj(u);jl(t,3768);Pj(v);c[D>>2]=3612;c[r>>2]=3652;c[x>>2]=3632;c[q>>2]=3708;Mt(s);Tj(q);jl(D,3768);Pj(r);Mt(B);Mt(A);Mt(z);Mt(y);l=F;return}function re(e,f){e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;m=n+4|0;h=n;Wk(m,e,0);if(!(a[m>>0]|0)){f=e+(c[(c[e>>2]|0)+-12>>2]|0)|0;Qk(f,c[f+16>>2]|4);l=n;return e|0}g=f+11|0;if((a[g>>0]|0)<0){a[c[f>>2]>>0]=0;c[f+4>>2]=0}else{a[f>>0]=0;a[g>>0]=0}g=e+(c[(c[e>>2]|0)+-12>>2]|0)|0;m=c[g+12>>2]|0;m=(m|0)<1?2147483647:m;c[h>>2]=Sk(g)|0;g=lm(h,1165628)|0;pt(h);a:do if((m|0)>0){k=g+8|0;g=0;while(1){h=c[e+(c[(c[e>>2]|0)+-12>>2]|0)+24>>2]|0;i=c[h+12>>2]|0;if((i|0)==(c[h+16>>2]|0)){h=hb[c[(c[h>>2]|0)+36>>2]&127](h)|0;if((h|0)==-1){h=2;break a}}else h=d[i>>0]|0;i=h&255;if(i<<24>>24>-1?b[(c[k>>2]|0)+(h<<24>>24<<1)>>1]&8192:0){h=0;break a}Xt(f,i);g=g+1|0;h=c[e+(c[(c[e>>2]|0)+-12>>2]|0)+24>>2]|0;i=h+12|0;j=c[i>>2]|0;if((j|0)==(c[h+16>>2]|0))hb[c[(c[h>>2]|0)+40>>2]&127](h)|0;else c[i>>2]=j+1;if((g|0)>=(m|0)){h=0;break}}}else{g=0;h=0}while(0);c[e+(c[(c[e>>2]|0)+-12>>2]|0)+12>>2]=0;f=e+(c[(c[e>>2]|0)+-12>>2]|0)|0;Qk(f,c[f+16>>2]|((g|0)==0?h|4:h));l=n;return e|0}function se(){return}function te(b,c){b=b|0;c=c|0;(a[977552]|0)==0?Ru(977552)|0:0;switch(c|0){case 0:{xt(1043044);return b|0}case 1:{yt(1043044);return b|0}default:return b|0}return 0}function ue(a){a=a|0;ve(a);return}function ve(b){b=b|0;var d=0,e=0,f=0,g=0;if((a[977560]|0)==0?Ru(977560)|0:0){c[260768]=8628;c[260794]=8648;Rk(1043176,1043076);c[260812]=0;c[260813]=-1;c[260768]=8668;c[260794]=8688;we(1043076);f=c[1164580+(c[(c[291145]|0)+-12>>2]|0)+24>>2]|0;Tk(1043256);c[260814]=8704;c[260822]=f;c[260823]=1043076;f=c[1164756+(c[(c[291189]|0)+-12>>2]|0)+24>>2]|0;Tk(1043296);c[260824]=8704;c[260832]=f;c[260833]=1043076}e=a[b+11>>0]|0;d=e<<24>>24<0;e=((d?c[b+4>>2]|0:e&255)|0)==0;f=(c[260785]|0)!=0;if(!(e|f)){g=Ti(d?c[b>>2]|0:b,20886)|0;c[260785]=g;if(!g){g=1043072+(c[(c[260768]|0)+-12>>2]|0)|0;Qk(g,c[g+16>>2]|4)}else{c[260791]=16;Qk(1043072+(c[(c[260768]|0)+-12>>2]|0)|0,0)}g=1164580+(c[(c[291145]|0)+-12>>2]|0)|0;c[g+24>>2]=1043256;Qk(g,0);g=1164756+(c[(c[291189]|0)+-12>>2]|0)|0;c[g+24>>2]=1043296;Qk(g,0);return}if(!(e&f))return;b=1164756+(c[(c[291189]|0)+-12>>2]|0)|0;c[b+24>>2]=c[260832];Qk(b,0);b=1164580+(c[(c[291145]|0)+-12>>2]|0)|0;c[b+24>>2]=c[260822];Qk(b,0);b=c[260785]|0;if((b|0?(g=hb[c[(c[1043076>>2]|0)+24>>2]&127](1043076)|0,(Ki(b)|0)==0):0)?(c[260785]=0,(g|0)==0):0)return;g=1043072+(c[(c[260768]|0)+-12>>2]|0)|0;Qk(g,c[g+16>>2]|4);return}function we(d){d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;k=l;l=l+16|0;h=k+4|0;i=k;Tk(d);c[d>>2]=8784;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;e=d+52|0;j=d+68|0;f=e;g=f+44|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));b[e+44>>1]=0;a[e+46>>0]=0;e=d+4|0;ot(h,e);c[i>>2]=c[h>>2];g=qt(i,1167420)|0;pt(i);if(!g){j=c[d>>2]|0;j=j+12|0;j=c[j>>2]|0;ab[j&31](d,0,4096)|0;l=k;return}ot(h,e);c[i>>2]=c[h>>2];c[j>>2]=lm(i,1167420)|0;pt(i);j=c[j>>2]|0;a[d+98>>0]=(hb[c[(c[j>>2]|0)+28>>2]&127](j)|0)&1;j=c[d>>2]|0;j=j+12|0;j=c[j>>2]|0;ab[j&31](d,0,4096)|0;l=k;return}function xe(d){d=d|0;var e=0,f=0,g=0,h=0;c[d>>2]=8784;e=d+64|0;f=c[e>>2]|0;if(f|0?(ye(d)|0,(Ki(f)|0)==0):0)c[e>>2]=0;f=b[d+96>>1]|0;e=(f&65535)>>>8&255;if((f&255)<<24>>24!=0?(g=c[d+32>>2]|0,(g|0)!=0):0){Et(g);e=a[d+97>>0]|0}if(e<<24>>24?(h=c[d+56>>2]|0,h|0):0)Et(h);Tj(d);return}function ye(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0;n=l;l=l+16|0;k=n;m=b+64|0;if(!(c[m>>2]|0)){m=0;l=n;return m|0}j=b+92|0;d=c[j>>2]|0;do if(!(d&16)){if(d&8|0){g=b+80|0;h=c[g+4>>2]|0;i=k;c[i>>2]=c[g>>2];c[i+4>>2]=h;do if(!(a[b+98>>0]|0)){f=b+68|0;g=c[f>>2]|0;g=hb[c[(c[g>>2]|0)+24>>2]&127](g)|0;i=b+36|0;h=c[i>>2]|0;d=(c[b+40>>2]|0)-h|0;if((g|0)>0){e=0;d=(S((c[b+16>>2]|0)-(c[b+12>>2]|0)|0,g)|0)+d|0;break}e=c[b+12>>2]|0;if((e|0)==(c[b+16>>2]|0))e=0;else{f=c[f>>2]|0;g=b+32|0;h=ob[c[(c[f>>2]|0)+32>>2]&31](f,k,c[g>>2]|0,h,e-(c[b+8>>2]|0)|0)|0;e=1;d=d-h+(c[i>>2]|0)-(c[g>>2]|0)|0}}else{e=0;d=(c[b+16>>2]|0)-(c[b+12>>2]|0)|0}while(0);if(_i(c[m>>2]|0,0-d|0,1)|0){m=-1;l=n;return m|0}if(e){i=k;k=c[i+4>>2]|0;m=b+72|0;c[m>>2]=c[i>>2];c[m+4>>2]=k}m=c[b+32>>2]|0;c[b+40>>2]=m;c[b+36>>2]=m;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[j>>2]=0}}else{if((c[b+24>>2]|0)!=(c[b+20>>2]|0)?(nb[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1:0){m=-1;l=n;return m|0}f=b+68|0;g=b+72|0;h=b+32|0;d=b+52|0;a:while(1){j=c[f>>2]|0;e=c[h>>2]|0;e=ob[c[(c[j>>2]|0)+20>>2]&31](j,g,e,e+(c[d>>2]|0)|0,k)|0;j=c[h>>2]|0;b=(c[k>>2]|0)-j|0;if((Ni(j,1,b,c[m>>2]|0)|0)!=(b|0)){d=-1;e=22;break}switch(e|0){case 1:break;case 2:{d=-1;e=22;break a}default:{e=8;break a}}}if((e|0)==8){if(!(Li(c[m>>2]|0)|0))break;else d=-1;l=n;return d|0}else if((e|0)==22){l=n;return d|0}}while(0);m=0;l=n;return m|0}function ze(a){a=a|0;xe(a);Dt(a);return}function Ae(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0;hb[c[(c[d>>2]|0)+24>>2]&127](d)|0;f=lm(e,1167420)|0;c[d+68>>2]=f;g=d+98|0;j=a[g>>0]|0;f=hb[c[(c[f>>2]|0)+28>>2]&127](f)|0;a[g>>0]=f&1;if((j&255|0)==(f&1|0))return;e=d+8|0;j=d+96|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;c[e+16>>2]=0;c[e+20>>2]=0;e=b[j>>1]|0;g=(e&255)<<24>>24!=0;e=(e&65535)>>>8&255;if(f){f=d+32|0;if(g?(k=c[f>>2]|0,(k|0)!=0):0){Et(k);e=a[d+97>>0]|0}a[j>>0]=e;j=d+60|0;c[d+52>>2]=c[j>>2];k=d+56|0;c[f>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[d+97>>0]=0;return}if(!g?(h=d+32|0,i=c[h>>2]|0,(i|0)!=(d+44|0)):0){k=c[d+52>>2]|0;c[d+60>>2]=k;c[d+56>>2]=i;a[d+97>>0]=0;c[h>>2]=Ct(k)|0;a[j>>0]=1;return}k=c[d+52>>2]|0;c[d+60>>2]=k;c[d+56>>2]=Ct(k)|0;a[d+97>>0]=1;return}function Be(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;j=b+8|0;i=b+96|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;c[j+12>>2]=0;c[j+16>>2]=0;c[j+20>>2]=0;j=c[i>>2]|0;f=(j&65535)>>>8&255;if((j&255)<<24>>24!=0?(g=c[b+32>>2]|0,(g|0)!=0):0){Et(g);f=a[b+97>>0]|0}g=b+97|0;if(f<<24>>24?(h=c[b+56>>2]|0,h|0):0)Et(h);f=b+52|0;c[f>>2]=e;do if(e>>>0>8){f=a[b+98>>0]|0;if((d|0)!=0&f<<24>>24!=0){c[b+32>>2]=d;a[i>>0]=0;break}else{c[b+32>>2]=Ct(e)|0;a[i>>0]=1;break}}else{c[b+32>>2]=b+44;c[f>>2]=8;a[i>>0]=0;f=a[b+98>>0]|0}while(0);if(f<<24>>24){c[b+60>>2]=0;c[b+56>>2]=0;a[g>>0]=0;return b|0}f=(e|0)<8?8:e;c[b+60>>2]=f;if((d|0)!=0&f>>>0>7){c[b+56>>2]=d;a[g>>0]=0;return b|0}else{c[b+56>>2]=Ct(f)|0;a[g>>0]=1;return b|0}return 0}function Ce(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;g=c[b+68>>2]|0;g=hb[c[(c[g>>2]|0)+24>>2]&127](g)|0;h=b+64|0;if((c[h>>2]|0?!(((d|0)!=0|(e|0)!=0)&(g|0)<1):0)?(hb[c[(c[b>>2]|0)+24>>2]&127](b)|0)==0:0){if(f>>>0>=3){f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;return}i=c[h>>2]|0;e=fv(g|0,((g|0)<0)<<31>>31|0,d|0,e|0)|0;if(!(_i(i,(g|0)>0?e:0,f)|0)){f=Ji(c[h>>2]|0)|0;d=b+72|0;e=c[d+4>>2]|0;i=a;c[i>>2]=c[d>>2];c[i+4>>2]=e;i=a+8|0;c[i>>2]=f;c[i+4>>2]=((f|0)<0)<<31>>31;return}else{i=a;c[i>>2]=0;c[i+4>>2]=0;i=a+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}}i=a;c[i>>2]=0;c[i+4>>2]=0;i=a+8|0;c[i>>2]=-1;c[i+4>>2]=-1;return}function De(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;e=b+64|0;if(c[e>>2]|0?(hb[c[(c[b>>2]|0)+24>>2]&127](b)|0)==0:0)if(!(_i(c[e>>2]|0,c[d+8>>2]|0,0)|0)){f=d;e=c[f+4>>2]|0;b=b+72|0;c[b>>2]=c[f>>2];c[b+4>>2]=e;c[a>>2]=c[d>>2];c[a+4>>2]=c[d+4>>2];c[a+8>>2]=c[d+8>>2];c[a+12>>2]=c[d+12>>2];return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;return}f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;return}function Ee(b){b=b|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;t=l;l=l+16|0;s=t+4|0;p=t;o=b+64|0;if(!(c[o>>2]|0)){s=-1;l=t;return s|0}f=b+92|0;if(!(c[f>>2]&8)){c[b+24>>2]=0;c[b+20>>2]=0;c[b+28>>2]=0;if(!(a[b+98>>0]|0)){e=c[b+56>>2]|0;g=e+(c[b+60>>2]|0)|0}else{e=c[b+32>>2]|0;g=e+(c[b+52>>2]|0)|0}c[b+8>>2]=e;r=b+12|0;c[r>>2]=g;c[b+16>>2]=g;c[f>>2]=8;f=1;e=g}else{e=b+12|0;f=0;r=e;e=c[e>>2]|0}if(!e){e=s+1|0;c[b+8>>2]=s;c[r>>2]=e;c[b+16>>2]=e}q=b+16|0;if(f){f=c[q>>2]|0;n=0}else{f=c[q>>2]|0;n=(f-(c[b+8>>2]|0)|0)/2|0;n=n>>>0>4?4:n}do if((e|0)==(f|0)){f=b+8|0;hv(c[f>>2]|0,e+(0-n)|0,n|0)|0;if(a[b+98>>0]|0){e=c[f>>2]|0;e=Pi(e+n|0,1,(c[q>>2]|0)-n-e|0,c[o>>2]|0)|0;if(!e){e=-1;break}b=(c[f>>2]|0)+n|0;c[r>>2]=b;c[q>>2]=b+e;e=d[b>>0]|0;break}j=b+32|0;k=b+36|0;e=c[k>>2]|0;m=b+40|0;hv(c[j>>2]|0,e|0,(c[m>>2]|0)-e|0)|0;e=c[j>>2]|0;i=e+((c[m>>2]|0)-(c[k>>2]|0))|0;c[k>>2]=i;if((e|0)==(b+44|0))g=8;else g=c[b+52>>2]|0;u=e+g|0;c[m>>2]=u;g=b+60|0;e=(c[g>>2]|0)-n|0;u=u-i|0;h=b+72|0;x=h;w=c[x+4>>2]|0;v=b+80|0;c[v>>2]=c[x>>2];c[v+4>>2]=w;e=Pi(i,1,u>>>0<e>>>0?u:e,c[o>>2]|0)|0;if(!e)e=-1;else{w=(c[k>>2]|0)+e|0;c[m>>2]=w;v=c[b+68>>2]|0;x=c[f>>2]|0;if((kb[c[(c[v>>2]|0)+16>>2]&15](v,h,c[j>>2]|0,w,k,x+n|0,x+(c[g>>2]|0)|0,p)|0)!=3){g=c[p>>2]|0;e=(c[f>>2]|0)+n|0;if((g|0)==(e|0))e=-1;else{c[r>>2]=e;c[q>>2]=g;e=d[e>>0]|0}}else{e=c[j>>2]|0;x=c[m>>2]|0;c[f>>2]=e;c[r>>2]=e;c[q>>2]=x;e=d[e>>0]|0}}}else{e=d[e>>0]|0;f=b+8|0}while(0);if((c[f>>2]|0)==(s|0)){c[f>>2]=0;c[r>>2]=0;c[q>>2]=0}x=e;l=t;return x|0}function Fe(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if(!(c[b+64>>2]|0)){g=-1;return g|0}g=b+12|0;f=c[g>>2]|0;if((c[b+8>>2]|0)>>>0>=f>>>0){g=-1;return g|0}if((d|0)==-1){c[g>>2]=f+-1;g=0;return g|0}if(!(c[b+88>>2]&16)){e=d&255;b=f+-1|0;if(e<<24>>24!=(a[b>>0]|0)){g=-1;return g|0}}else{e=d&255;b=f+-1|0}c[g>>2]=b;a[b>>0]=e;g=d;return g|0}function Ge(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;x=l;l=l+16|0;k=x+8|0;u=x+4|0;v=x;w=b+64|0;if(!(c[w>>2]|0)){d=-1;l=x;return d|0}f=b+92|0;if(!(c[f>>2]&16)){c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;e=c[b+52>>2]|0;do if(e>>>0>8)if(!(a[b+98>>0]|0)){h=c[b+56>>2]|0;i=h+((c[b+60>>2]|0)+-1)|0;c[b+24>>2]=h;g=b+20|0;c[g>>2]=h;e=b+28|0;c[e>>2]=i;j=h;break}else{h=c[b+32>>2]|0;i=h+(e+-1)|0;c[b+24>>2]=h;g=b+20|0;c[g>>2]=h;e=b+28|0;c[e>>2]=i;j=h;break}else{c[b+24>>2]=0;g=b+20|0;c[g>>2]=0;e=b+28|0;c[e>>2]=0;j=0;i=0;h=0}while(0);c[f>>2]=16;t=g;r=e;s=e;q=g;g=j}else{q=b+20|0;g=c[q>>2]|0;i=b+28|0;t=q;r=i;s=i;h=g;i=c[i>>2]|0}p=(d|0)==-1;e=b+24|0;f=c[e>>2]|0;if(!p){if(!f){c[e>>2]=k;c[q>>2]=k;c[r>>2]=k+1;f=k}a[f>>0]=d;f=(c[e>>2]|0)+1|0;c[e>>2]=f;g=c[q>>2]|0}a:do if((f|0)==(g|0))m=31;else{do if(!(a[b+98>>0]|0)){m=b+32|0;j=c[m>>2]|0;c[u>>2]=j;n=b+68|0;o=b+72|0;k=b+52|0;while(1){b=c[n>>2]|0;f=kb[c[(c[b>>2]|0)+12>>2]&15](b,o,g,f,v,j,j+(c[k>>2]|0)|0,u)|0;g=c[q>>2]|0;if((c[v>>2]|0)==(g|0)){m=29;break}if((f|0)==3){m=21;break}if((f|1|0)!=1){m=29;break}j=c[m>>2]|0;b=(c[u>>2]|0)-j|0;if((Ni(j,1,b,c[w>>2]|0)|0)!=(b|0)){m=29;break}if((f|0)!=1){m=27;break}f=c[v>>2]|0;j=c[e>>2]|0;c[t>>2]=f;c[r>>2]=j;g=f;f=g+(j-f)|0;c[e>>2]=f;j=c[m>>2]|0}if((m|0)==21){v=(c[e>>2]|0)-g|0;if((Ni(g,1,v,c[w>>2]|0)|0)==(v|0))m=28;else m=29}else if((m|0)==27)m=28;if((m|0)==28)break;else if((m|0)==29){e=-1;break a}}else{v=f-g|0;if((Ni(g,1,v,c[w>>2]|0)|0)!=(v|0)){e=-1;break a}}while(0);c[e>>2]=h;c[t>>2]=h;c[s>>2]=i;m=31}while(0);if((m|0)==31)e=p?0:d;d=e;l=x;return d|0}function He(a){a=a|0;Tj(a);Dt(a);return}function Ie(a){a=a|0;var b=0;b=c[a+36>>2]|0;hb[c[(c[b>>2]|0)+24>>2]&127](b)|0;a=c[a+32>>2]|0;return hb[c[(c[a>>2]|0)+24>>2]&127](a)|0}function Je(a){a=a|0;var b=0;a=c[a+32>>2]|0;b=c[a+12>>2]|0;if((b|0)==(c[a+16>>2]|0)){b=hb[c[(c[a>>2]|0)+36>>2]&127](a)|0;return b|0}else{b=d[b>>0]|0;return b|0}return 0}function Ke(b){b=b|0;var e=0,f=0,g=0,h=0;e=c[b+32>>2]|0;f=e+12|0;g=c[f>>2]|0;if((g|0)==(c[e+16>>2]|0))h=hb[c[(c[e>>2]|0)+40>>2]&127](e)|0;else{c[f>>2]=g+1;h=d[g>>0]|0}e=b+36|0;if((c[2210]|0)==10){b=c[e>>2]|0;ab[c[(c[b>>2]|0)+48>>2]&31](b,20892,3)|0}e=c[e>>2]|0;f=e+24|0;g=c[f>>2]|0;if((g|0)==(c[e+28>>2]|0)){h=nb[c[(c[e>>2]|0)+52>>2]&63](e,h&255)|0;c[2210]=h;return h|0}else{c[f>>2]=g+1;a[g>>0]=h;h=h&255;c[2210]=h;return h|0}return 0}function Le(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=c[b+32>>2]|0;f=e+24|0;g=c[f>>2]|0;if((g|0)==(c[e+28>>2]|0))g=nb[c[(c[e>>2]|0)+52>>2]&63](e,d&255)|0;else{c[f>>2]=g+1;a[g>>0]=d;g=d&255}d=b+36|0;if((c[2210]|0)==10){b=c[d>>2]|0;ab[c[(c[b>>2]|0)+48>>2]&31](b,20888,3)|0}d=c[d>>2]|0;e=d+24|0;f=c[e>>2]|0;if((f|0)==(c[d+28>>2]|0)){b=nb[c[(c[d>>2]|0)+52>>2]&63](d,g&255)|0;c[2210]=b;return b|0}else{c[e>>2]=f+1;a[f>>0]=g;b=g&255;c[2210]=b;return b|0}return 0}function Me(a){a=a|0;var b=0;c[a>>2]=8668;b=a+104|0;c[b>>2]=8688;xe(a+4|0);cl(a,8764);Pj(b);return}function Ne(a){a=a|0;var b=0;c[a>>2]=8668;b=a+104|0;c[b>>2]=8688;xe(a+4|0);cl(a,8764);Pj(b);Dt(a);return}function Oe(a){a=a|0;var b=0;b=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[b>>2]=8668;a=b+104|0;c[a>>2]=8688;xe(b+4|0);cl(b,8764);Pj(a);return}function Pe(a){a=a|0;var b=0;a=a+(c[(c[a>>2]|0)+-12>>2]|0)|0;c[a>>2]=8668;b=a+104|0;c[b>>2]=8688;xe(a+4|0);cl(a,8764);Pj(b);Dt(a);return}function Qe(a){a=a|0;return}function Re(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0;a=l;l=l+144|0;b=a;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;Jt(b,21816,5);d=b+12|0;c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;Jt(d,21822,8);e=b+24|0;c[e>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;Jt(e,21831,6);f=b+36|0;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,21838,10);g=b+48|0;c[g>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Jt(g,21849,5);h=b+60|0;c[h>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Jt(h,21855,13);i=b+72|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;Jt(i,21869,6);j=b+84|0;c[j>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Jt(j,21876,11);k=b+96|0;c[k>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Jt(k,21888,10);m=b+108|0;c[m>>2]=0;c[m+4>>2]=0;c[m+8>>2]=0;Jt(m,21899,7);n=b+120|0;c[n>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Jt(n,21907,8);o=b+132|0;c[o>>2]=0;c[o+4>>2]=0;c[o+8>>2]=0;Jt(o,21916,4);p=At(144)|0;c[260835]=p;c[260834]=p;c[260836]=p+144;It(p,b);p=(c[260835]|0)+12|0;c[260835]=p;It(p,d);p=(c[260835]|0)+12|0;c[260835]=p;It(p,e);p=(c[260835]|0)+12|0;c[260835]=p;It(p,f);p=(c[260835]|0)+12|0;c[260835]=p;It(p,g);p=(c[260835]|0)+12|0;c[260835]=p;It(p,h);p=(c[260835]|0)+12|0;c[260835]=p;It(p,i);p=(c[260835]|0)+12|0;c[260835]=p;It(p,j);p=(c[260835]|0)+12|0;c[260835]=p;It(p,k);p=(c[260835]|0)+12|0;c[260835]=p;It(p,m);p=(c[260835]|0)+12|0;c[260835]=p;It(p,n);p=(c[260835]|0)+12|0;c[260835]=p;It(p,o);c[260835]=(c[260835]|0)+12;Mt(o);Mt(n);Mt(m);Mt(k);Mt(j);Mt(i);Mt(h);Mt(g);Mt(f);Mt(e);Mt(d);Mt(b);l=a;return}function Se(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;k=a+5348|0;n=c[k>>2]|0;m=a+320+((n^1)<<3)|0;d=m;e=c[d>>2]|0;d=c[d+4>>2]|0;l=a+5364|0;f=c[l>>2]|0;if((f|0)==1){f=c[(c[a+5356>>2]|0)+48>>2]|0;if((f|0)!=64){g=a+256|0;i=g;i=Pf(a,f,c[i>>2]|0,c[i+4>>2]|0)|0;h=a+320+(c[k>>2]<<3)|0;f=c[h>>2]|0;h=c[h+4>>2]|0;j=a+264|0;if((f&i&c[j>>2]|0)==0?(h&D&c[j+4>>2]|0)==0:0)j=5;else j=8}else{h=a+320+(n<<3)|0;g=a+256|0;f=c[h>>2]|0;h=c[h+4>>2]|0;j=5}a:do if((j|0)==5)while(1){if((f|0)==0&(h|0)==0)break a;o=Qa(f|0,h|0,0)|0;i=Yu(f|0,h|0,-1,-1)|0;h=D&h;p=g;p=Cb(c[a+(o<<2)>>2]|0,o,c[p>>2]|0,c[p+4>>2]|0)|0;o=a+320+((c[k>>2]^1)<<3)|0;if(!((c[o>>2]&p|0)==0?(c[o+4>>2]&D|0)==0:0)){j=8;break}else f=i&f}while(0);if((j|0)==8){p=m;e=c[p>>2]&e;d=c[p+4>>2]&d}g=c[l>>2]|0}else g=f;if((g|0)==2){f=n<<3|6;if(!(c[a+336+(f<<2)>>2]|0))f=64;else f=c[a+400+(f<<8)>>2]|0;p=34448+(f<<3)|0;e=e&~c[p>>2];d=d&~c[p+4>>2]}if((g|0)==6?Te(a)|0:0){p=m;e=c[p>>2]&e;d=c[p+4>>2]&d}if(!n){p=Ue(a,b,e,d)|0;return p|0}else{p=Ve(a,b,e,d)|0;return p|0}return 0}function Te(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;o=a+5356|0;d=c[o>>2]|0;b=c[d+48>>2]|0;if((b|0)!=64){l=a+256|0;l=Pf(a,b,c[l>>2]|0,c[l+4>>2]|0)|0;d=a+5348|0;e=c[d>>2]|0;g=a+320+(e<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0;m=a+264|0;b=c[o>>2]|0;n=b+344+(e<<3)|0;if(!((f&l&c[m>>2]&~(c[n>>2]&f)|0)==0?(g&D&c[m+4>>2]&~(c[n+4>>2]&g)|0)==0:0)?(m=b+64|0,n=30544+((c[b+48>>2]|0)+((e|0)==0?-8:8)<<3)|0,(c[m>>2]&~c[n>>2]|0)==0?(c[m+4>>2]&~c[n+4>>2]|0)==0:0):0){p=1;return p|0}else{n=d;e=g}}else{n=a+5348|0;e=a+320+(c[n>>2]<<3)|0;f=c[e>>2]|0;e=c[e+4>>2]|0;b=d}m=b+64|0;l=c[m>>2]|0;m=c[m+4>>2]|0;k=Yu(l|0,m|0,-1,-1)|0;if((k&l|0)==0&(D&m|0)==0){b=f;d=e}else{d=a+304|0;b=c[d>>2]&f;d=c[d+4>>2]&e}if((b|0)==0&(d|0)==0){p=0;return p|0}l=a+256|0;m=a+5364|0;a:while(1){i=Qa(b|0,d|0,0)|0;j=Yu(b|0,d|0,-1,-1)|0;b=j&b;d=D&d;j=a+(i<<2)|0;f=l;f=Cb(c[j>>2]|0,i,c[f>>2]|0,c[f+4>>2]|0)|0;e=c[n>>2]|0;g=a+320+((e^1)<<3)|0;f=c[g>>2]&f;g=c[g+4>>2]&D;k=c[o>>2]|0;q=k+344+(e<<3)|0;r=a+320+(e<<3)|0;h=30544+(i<<3)|0;if(!((c[r>>2]&c[q>>2]&c[h>>2]|0)==0?(c[r+4>>2]&c[q+4>>2]&c[h+4>>2]|0)==0:0)){switch(c[m>>2]|0){case 4:{h=e<<3|6;if(!(c[a+336+(h<<2)>>2]|0))h=64;else p=15;break}case 2:{h=e<<3|6;if(!(c[a+336+(h<<2)>>2]|0))h=64;else p=15;break}case 1:{h=e<<3|6;if(!(c[a+336+(h<<2)>>2]|0))h=64;else p=15;break}default:{h=e<<3|6;p=15}}if((p|0)==15){p=0;h=c[a+400+(h<<8)>>2]|0}r=72336+(i<<9)+(h<<3)|0;f=c[r>>2]&f;g=c[r+4>>2]&g}b:do if((c[j>>2]&7|0)!=6){r=k+64|0;k=c[r>>2]|0;r=c[r+4>>2]|0;q=(k|0)==0&(r|0)==0;if(!(((q?-1:k)&f|0)==0&((q?-1:r)&g|0)==0)){b=1;p=28;break a}}else while(1){if((f|0)==0&(g|0)==0)break b;h=Qa(f|0,g|0,0)|0;j=Yu(f|0,g|0,-1,-1)|0;f=j&f;g=D&g;j=l;i=c[j>>2]|0;j=c[j+4>>2]|0;switch(c[m>>2]|0){case 4:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))e=64;else p=24;break}case 2:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))e=64;else p=24;break}case 1:{e=e<<3|6;if(!(c[a+336+(e<<2)>>2]|0))e=64;else p=24;break}default:{e=e<<3|6;p=24}}if((p|0)==24){p=0;e=c[a+400+(e<<8)>>2]|0}q=30544+(e<<3)|0;q=Pf(a,h,c[q>>2]^i,c[q+4>>2]^j)|0;e=c[n>>2]|0;r=a+320+((e^1)<<3)|0;if((c[r>>2]&q|0)==0?(c[r+4>>2]&D|0)==0:0){b=1;p=28;break a}}while(0);if((b|0)==0&(d|0)==0){b=0;p=28;break}}if((p|0)==28)return b|0;return 0}function Ue(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=a+320|0;s=c[t>>2]|0;t=c[t+4>>2]|0;u=a+264|0;o=u;p=c[o>>2]&s;o=c[o+4>>2]&t;j=o&16711680;q=o&-16711681;if(!(0==0&(j|0)==0)){h=a+256|0;f=~c[h>>2];h=~c[h+4>>2];i=c[a+5364>>2]|0;if((i|0)==2){n=(c[a+5356>>2]|0)+64|0;n=(c[n>>2]|0)==0&(c[n+4>>2]|0)==0;f=(n?-1:d)&f;h=(n?-1:e)&h}n=(i|0)==1;v=(i|0)==6|n;k=gv(0,j|0,9)|0;k=k&d;l=D&e;gv(0,j|0,7)|0;m=e&2130706432&D;i=gv(0,j|0,8)|0;i=(v?d:0)&i&f;f=(v?e:-16777216)&D&h;if(!((k|0)==0&(l|0)==0))if(n){h=l;while(1){l=Qa(k|0,h|0,0)|0;v=Yu(k|0,h|0,-1,-1)|0;k=v&k;h=D&h;v=l<<6;c[b>>2]=l+28096+v;c[b+8>>2]=l+24e3+v;c[b+16>>2]=l+19904+v;c[b+24>>2]=l+15808+v;j=b+40|0;c[b+32>>2]=l+40384+v;if((k|0)==0&(h|0)==0){b=j;break}else b=j}}else{h=l;while(1){v=Qa(k|0,h|0,0)|0;j=Yu(k|0,h|0,-1,-1)|0;k=j&k;h=D&h;j=b+8|0;c[b>>2]=v+28096+(v<<6);if((k|0)==0&(h|0)==0){b=j;break}else b=j}}if(!(0==0&(m|0)==0))if(n){k=0;h=m;while(1){m=Qa(k|0,h|0,0)|0;v=Yu(k|0,h|0,-1,-1)|0;k=v&k;h=D&h;v=m<<6;c[b>>2]=m+28224+v;c[b+8>>2]=m+24128+v;c[b+16>>2]=m+20032+v;c[b+24>>2]=m+15936+v;j=b+40|0;c[b+32>>2]=m+40512+v;if((k|0)==0&(h|0)==0){b=j;break}else b=j}}else{k=0;h=m;while(1){v=Qa(k|0,h|0,0)|0;j=Yu(k|0,h|0,-1,-1)|0;k=j&k;h=D&h;j=b+8|0;c[b>>2]=v+28224+(v<<6);if((k|0)==0&(h|0)==0){b=j;break}else b=j}}if(!((i|0)==0&(f|0)==0))if(n)while(1){n=Qa(i|0,f|0,0)|0;v=Yu(i|0,f|0,-1,-1)|0;i=v&i;f=D&f;v=n<<6;c[b>>2]=(n|28160)+v;c[b+8>>2]=(n|24064)+v;c[b+16>>2]=(n|19968)+v;c[b+24>>2]=(n|15872)+v;h=b+40|0;c[b+32>>2]=(n|40448)+v;if((i|0)==0&(f|0)==0){b=h;break}else b=h}else while(1){v=Qa(i|0,f|0,0)|0;h=Yu(i|0,f|0,-1,-1)|0;i=h&i;f=D&f;h=b+8|0;c[b>>2]=(v|28160)+(v<<6);if((i|0)==0&(f|0)==0){b=h;break}else b=h}}j=gv(p|0,o|0,9)|0;j=d&-16843264&j;h=e&16711422&D;i=gv(p|0,o|0,7)|0;i=d&2139062016&i;f=e&8355711&D;if(!((j|0)==0&(h|0)==0)){k=j;while(1){v=Qa(k|0,h|0,0)|0;j=Yu(k|0,h|0,-1,-1)|0;k=j&k;h=D&h;j=b+8|0;c[b>>2]=v+-576+(v<<6);if((k|0)==0&(h|0)==0){b=j;break}else b=j}}if(!((i|0)==0&(f|0)==0))while(1){v=Qa(i|0,f|0,0)|0;h=Yu(i|0,f|0,-1,-1)|0;i=h&i;f=D&f;h=b+8|0;c[b>>2]=v+-448+(v<<6);if((i|0)==0&(f|0)==0){b=h;break}else b=h}o=c[(c[a+5356>>2]|0)+48>>2]|0;n=(o|0)==64;if(!n?(g=35984+(o<<3)|0,r=p&c[g>>2],g=q&c[g+4>>2],!((r|0)==0&(g|0)==0)):0){i=o+8192|0;h=r;while(1){f=b+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[b>>2]=i+(v<<6|24576);if((h|0)==0&(g|0)==0){b=f;break}else b=f}}p=a+5364|0;f=a+912|0;g=c[f>>2]|0;if((g|0)!=64)do{h=32400+(g<<3)|0;i=c[h>>2]&d;h=c[h+4>>2]&e;if(!((i|0)==0&(h|0)==0)){j=g<<6;while(1){g=b+8|0;v=Qa(i|0,h|0,0)|0;r=Yu(i|0,h|0,-1,-1)|0;i=r&i;h=D&h;c[b>>2]=v+j;if((i|0)==0&(h|0)==0){b=g;break}else b=g}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=a+1168|0;g=c[f>>2]|0;if((g|0)!=64){m=a+256|0;l=c[m>>2]|0;m=c[m+4>>2]|0;do{h=29520+(g<<3)|0;j=30032+(g<<3)|0;j=(S(c[h+4>>2]&m,c[j+4>>2]|0)|0)^(S(c[h>>2]&l,c[j>>2]|0)|0);j=(c[1035940+(g<<2)>>2]|0)+(j>>>(c[1036196+(g<<2)>>2]|0)<<3)|0;h=c[j>>2]&d;j=c[j+4>>2]&e;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=b;g=j;while(1){b=i+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[i>>2]=v+k;if((h|0)==0&(g|0)==0)break;else i=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+1424|0;g=c[f>>2]|0;if((g|0)!=64){m=a+256|0;l=c[m>>2]|0;m=c[m+4>>2]|0;do{h=28496+(g<<3)|0;j=29008+(g<<3)|0;j=(S(c[h+4>>2]&m,c[j+4>>2]|0)|0)^(S(c[h>>2]&l,c[j>>2]|0)|0);j=(c[1035428+(g<<2)>>2]|0)+(j>>>(c[1035684+(g<<2)>>2]|0)<<3)|0;h=c[j>>2]&d;j=c[j+4>>2]&e;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=b;g=j;while(1){b=i+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[i>>2]=v+k;if((h|0)==0&(g|0)==0)break;else i=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+1680|0;g=c[f>>2]|0;if((g|0)!=64){m=a+256|0;l=c[m>>2]|0;m=c[m+4>>2]|0;do{h=28496+(g<<3)|0;j=29008+(g<<3)|0;j=(S(c[h+4>>2]&m,c[j+4>>2]|0)|0)^(S(c[h>>2]&l,c[j>>2]|0)|0);j=(c[1035428+(g<<2)>>2]|0)+(j>>>(c[1035684+(g<<2)>>2]|0)<<3)|0;h=29520+(g<<3)|0;v=30032+(g<<3)|0;v=(S(c[h+4>>2]&m,c[v+4>>2]|0)|0)^(S(c[h>>2]&l,c[v>>2]|0)|0);v=(c[1035940+(g<<2)>>2]|0)+(v>>>(c[1036196+(g<<2)>>2]|0)<<3)|0;h=(c[v>>2]|c[j>>2])&d;j=(c[v+4>>2]|c[j+4>>2])&e;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=b;g=j;while(1){b=i+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[i>>2]=v+k;if((h|0)==0&(g|0)==0)break;else i=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=c[p>>2]|0;a:do switch(f|0){case 1:{g=a+304|0;f=c[g>>2]&s;g=c[g+4>>2]&t;if(!((f|0)==0&(g|0)==0))do{h=Qa(f|0,g|0,0)|0;k=Yu(f|0,g|0,-1,-1)|0;f=k&f;g=D&g;k=34448+(h<<3)|0;i=c[k>>2]&d;k=c[k+4>>2]&e;if(!((i|0)==0&(k|0)==0)){l=h<<6;j=b;h=k;while(1){b=j+8|0;v=Qa(i|0,h|0,0)|0;t=Yu(i|0,h|0,-1,-1)|0;i=t&i;h=D&h;c[j>>2]=v+l;if((i|0)==0&(h|0)==0)break;else j=b}}}while(!((f|0)==0&(g|0)==0));if((c[a+5368>>2]|0)==9){v=b;return v|0}if(!n){i=a+256|0;e=i;e=Pf(a,o,c[e>>2]|0,c[e+4>>2]|0)|0;f=a+5348|0;g=a+320+(c[f>>2]<<3)|0;h=c[g>>2]|0;g=c[g+4>>2]|0;v=u;if((h&e&c[v>>2]|0)==0?(g&D&c[v+4>>2]|0)==0:0)j=i;else{v=b;return v|0}}else{f=a+5348|0;g=a+320+(c[f>>2]<<3)|0;j=a+256|0;h=c[g>>2]|0;g=c[g+4>>2]|0}i=h;while(1){if((i|0)==0&(g|0)==0){j=69;break}v=Qa(i|0,g|0,0)|0;h=Yu(i|0,g|0,-1,-1)|0;g=D&g;e=j;e=Cb(c[a+(v<<2)>>2]|0,v,c[e>>2]|0,c[e+4>>2]|0)|0;v=a+320+((c[f>>2]^1)<<3)|0;if(!((c[v>>2]&e|0)==0?(c[v+4>>2]&D|0)==0:0)){j=72;break}else i=h&i}if((j|0)==69){f=c[p>>2]|0;break a}else if((j|0)==72)return b|0;break}case 4:{if(!(c[a+360>>2]|0))j=62;else j=63;break}case 2:{if(!(c[a+360>>2]|0))j=62;else j=63;break}default:{g=c[a+1936>>2]|0;k=34448+(g<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;i=j&d;h=k&e;if((f|0)==7){e=110224+(g<<3)|0;v=a+256|0;i=c[e>>2]&j&~c[v>>2]|i;h=c[e+4>>2]&k&~c[v+4>>2]|h;j=66}else j=66}}while(0);if((j|0)==62){h=34960;g=64;i=c[h>>2]&d;h=c[h+4>>2]&e;j=66}else if((j|0)==63){g=c[a+1936>>2]|0;h=34448+(g<<3)|0;i=c[h>>2]&d;h=c[h+4>>2]&e;j=66}if((j|0)==66)if(!((i|0)==0&(h|0)==0)){j=g<<6;while(1){g=b+8|0;v=Qa(i|0,h|0,0)|0;e=Yu(i|0,h|0,-1,-1)|0;i=e&i;h=D&h;c[b>>2]=v+j;if((i|0)==0&(h|0)==0){b=g;break}else b=g}}if((f|0)==6){Te(a)|0;return b|0}else{v=b;return v|0}return 0}function Ve(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;t=a+328|0;s=c[t>>2]|0;t=c[t+4>>2]|0;u=a+264|0;p=u;o=c[p>>2]&s;p=c[p+4>>2]&t;j=o&65280;q=o&-65281;if(!((j|0)==0&0==0)){h=a+256|0;f=~c[h>>2];h=~c[h+4>>2];i=c[a+5364>>2]|0;if((i|0)==2){n=(c[a+5356>>2]|0)+64|0;n=(c[n>>2]|0)==0&(c[n+4>>2]|0)==0;f=(n?-1:d)&f;h=(n?-1:e)&h}n=(i|0)==1;v=(i|0)==6|n;k=av(j|0,0,9)|0;k=k&d;l=D&e;m=av(j|0,0,7)|0;m=d&254&m;i=av(j|0,0,8)|0;i=(v?d:255)&i&f;f=(v?e:0)&D&h;if(!((k|0)==0&(l|0)==0))if(n){h=l;while(1){l=Qa(k|0,h|0,0)|0;v=Yu(k|0,h|0,-1,-1)|0;k=v&k;h=D&h;v=l<<6;c[b>>2]=l+29248+v;c[b+8>>2]=l+25152+v;c[b+16>>2]=l+21056+v;c[b+24>>2]=l+16960+v;j=b+40|0;c[b+32>>2]=l+41536+v;if((k|0)==0&(h|0)==0){b=j;break}else b=j}}else{h=l;while(1){v=Qa(k|0,h|0,0)|0;j=Yu(k|0,h|0,-1,-1)|0;k=j&k;h=D&h;j=b+8|0;c[b>>2]=v+29248+(v<<6);if((k|0)==0&(h|0)==0){b=j;break}else b=j}}if(!((m|0)==0&0==0))if(n){h=m;j=0;while(1){m=Qa(h|0,j|0,0)|0;v=Yu(h|0,j|0,-1,-1)|0;h=v&h;j=D&j;v=m<<6;c[b>>2]=m+29120+v;c[b+8>>2]=m+25024+v;c[b+16>>2]=m+20928+v;c[b+24>>2]=m+16832+v;k=b+40|0;c[b+32>>2]=m+41408+v;if((h|0)==0&(j|0)==0){b=k;break}else b=k}}else{h=m;j=0;while(1){v=Qa(h|0,j|0,0)|0;k=Yu(h|0,j|0,-1,-1)|0;h=k&h;j=D&j;k=b+8|0;c[b>>2]=v+29120+(v<<6);if((h|0)==0&(j|0)==0){b=k;break}else b=k}}if(!((i|0)==0&(f|0)==0))if(n)while(1){n=Qa(i|0,f|0,0)|0;v=Yu(i|0,f|0,-1,-1)|0;i=v&i;f=D&f;v=n<<6;c[b>>2]=(n|29184)+v;c[b+8>>2]=(n|25088)+v;c[b+16>>2]=(n|20992)+v;c[b+24>>2]=(n|16896)+v;h=b+40|0;c[b+32>>2]=(n|41472)+v;if((i|0)==0&(f|0)==0){b=h;break}else b=h}else while(1){v=Qa(i|0,f|0,0)|0;h=Yu(i|0,f|0,-1,-1)|0;i=h&i;f=D&f;h=b+8|0;c[b>>2]=(v|29184)+(v<<6);if((i|0)==0&(f|0)==0){b=h;break}else b=h}}j=av(o|0,p|0,9)|0;j=d&2139062016&j;h=e&8355711&D;i=av(o|0,p|0,7)|0;i=d&-16843264&i;f=e&16711422&D;if(!((j|0)==0&(h|0)==0)){k=j;while(1){v=Qa(k|0,h|0,0)|0;j=Yu(k|0,h|0,-1,-1)|0;k=j&k;h=D&h;j=b+8|0;c[b>>2]=v+576+(v<<6);if((k|0)==0&(h|0)==0){b=j;break}else b=j}}if(!((i|0)==0&(f|0)==0))while(1){v=Qa(i|0,f|0,0)|0;h=Yu(i|0,f|0,-1,-1)|0;i=h&i;f=D&f;h=b+8|0;c[b>>2]=v+448+(v<<6);if((i|0)==0&(f|0)==0){b=h;break}else b=h}o=c[(c[a+5356>>2]|0)+48>>2]|0;n=(o|0)==64;if(!n?(g=31888+(o<<3)|0,r=q&c[g>>2],g=p&c[g+4>>2],!((r|0)==0&(g|0)==0)):0){i=o+8192|0;h=r;while(1){f=b+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[b>>2]=i+(v<<6|24576);if((h|0)==0&(g|0)==0){b=f;break}else b=f}}p=a+5364|0;f=a+2960|0;g=c[f>>2]|0;if((g|0)!=64)do{h=32400+(g<<3)|0;i=c[h>>2]&d;h=c[h+4>>2]&e;if(!((i|0)==0&(h|0)==0)){j=g<<6;while(1){g=b+8|0;v=Qa(i|0,h|0,0)|0;r=Yu(i|0,h|0,-1,-1)|0;i=r&i;h=D&h;c[b>>2]=v+j;if((i|0)==0&(h|0)==0){b=g;break}else b=g}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=a+3216|0;g=c[f>>2]|0;if((g|0)!=64){m=a+256|0;l=c[m>>2]|0;m=c[m+4>>2]|0;do{h=29520+(g<<3)|0;j=30032+(g<<3)|0;j=(S(c[h+4>>2]&m,c[j+4>>2]|0)|0)^(S(c[h>>2]&l,c[j>>2]|0)|0);j=(c[1035940+(g<<2)>>2]|0)+(j>>>(c[1036196+(g<<2)>>2]|0)<<3)|0;h=c[j>>2]&d;j=c[j+4>>2]&e;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=b;g=j;while(1){b=i+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[i>>2]=v+k;if((h|0)==0&(g|0)==0)break;else i=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+3472|0;g=c[f>>2]|0;if((g|0)!=64){m=a+256|0;l=c[m>>2]|0;m=c[m+4>>2]|0;do{h=28496+(g<<3)|0;j=29008+(g<<3)|0;j=(S(c[h+4>>2]&m,c[j+4>>2]|0)|0)^(S(c[h>>2]&l,c[j>>2]|0)|0);j=(c[1035428+(g<<2)>>2]|0)+(j>>>(c[1035684+(g<<2)>>2]|0)<<3)|0;h=c[j>>2]&d;j=c[j+4>>2]&e;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=b;g=j;while(1){b=i+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[i>>2]=v+k;if((h|0)==0&(g|0)==0)break;else i=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=a+3728|0;g=c[f>>2]|0;if((g|0)!=64){m=a+256|0;l=c[m>>2]|0;m=c[m+4>>2]|0;do{h=28496+(g<<3)|0;j=29008+(g<<3)|0;j=(S(c[h+4>>2]&m,c[j+4>>2]|0)|0)^(S(c[h>>2]&l,c[j>>2]|0)|0);j=(c[1035428+(g<<2)>>2]|0)+(j>>>(c[1035684+(g<<2)>>2]|0)<<3)|0;h=29520+(g<<3)|0;v=30032+(g<<3)|0;v=(S(c[h+4>>2]&m,c[v+4>>2]|0)|0)^(S(c[h>>2]&l,c[v>>2]|0)|0);v=(c[1035940+(g<<2)>>2]|0)+(v>>>(c[1036196+(g<<2)>>2]|0)<<3)|0;h=(c[v>>2]|c[j>>2])&d;j=(c[v+4>>2]|c[j+4>>2])&e;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=b;g=j;while(1){b=i+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[i>>2]=v+k;if((h|0)==0&(g|0)==0)break;else i=b}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64)}f=c[p>>2]|0;a:do switch(f|0){case 1:{g=a+304|0;f=c[g>>2]&s;g=c[g+4>>2]&t;if(!((f|0)==0&(g|0)==0))do{h=Qa(f|0,g|0,0)|0;k=Yu(f|0,g|0,-1,-1)|0;f=k&f;g=D&g;k=34448+(h<<3)|0;i=c[k>>2]&d;k=c[k+4>>2]&e;if(!((i|0)==0&(k|0)==0)){l=h<<6;j=b;h=k;while(1){b=j+8|0;v=Qa(i|0,h|0,0)|0;t=Yu(i|0,h|0,-1,-1)|0;i=t&i;h=D&h;c[j>>2]=v+l;if((i|0)==0&(h|0)==0)break;else j=b}}}while(!((f|0)==0&(g|0)==0));if((c[a+5368>>2]|0)==9){v=b;return v|0}if(!n){i=a+256|0;e=i;e=Pf(a,o,c[e>>2]|0,c[e+4>>2]|0)|0;f=a+5348|0;g=a+320+(c[f>>2]<<3)|0;h=c[g>>2]|0;g=c[g+4>>2]|0;v=u;if((h&e&c[v>>2]|0)==0?(g&D&c[v+4>>2]|0)==0:0)j=i;else{v=b;return v|0}}else{f=a+5348|0;g=a+320+(c[f>>2]<<3)|0;j=a+256|0;h=c[g>>2]|0;g=c[g+4>>2]|0}i=h;while(1){if((i|0)==0&(g|0)==0){j=69;break}v=Qa(i|0,g|0,0)|0;h=Yu(i|0,g|0,-1,-1)|0;g=D&g;e=j;e=Cb(c[a+(v<<2)>>2]|0,v,c[e>>2]|0,c[e+4>>2]|0)|0;v=a+320+((c[f>>2]^1)<<3)|0;if(!((c[v>>2]&e|0)==0?(c[v+4>>2]&D|0)==0:0)){j=72;break}else i=h&i}if((j|0)==69){f=c[p>>2]|0;break a}else if((j|0)==72)return b|0;break}case 4:{if(!(c[a+392>>2]|0))j=62;else j=63;break}case 2:{if(!(c[a+392>>2]|0))j=62;else j=63;break}default:{g=c[a+3984>>2]|0;k=34448+(g<<3)|0;j=c[k>>2]|0;k=c[k+4>>2]|0;i=j&d;h=k&e;if((f|0)==7){e=110224+(g<<3)|0;v=a+256|0;i=c[e>>2]&j&~c[v>>2]|i;h=c[e+4>>2]&k&~c[v+4>>2]|h;j=66}else j=66}}while(0);if((j|0)==62){h=34960;g=64;i=c[h>>2]&d;h=c[h+4>>2]&e;j=66}else if((j|0)==63){g=c[a+3984>>2]|0;h=34448+(g<<3)|0;i=c[h>>2]&d;h=c[h+4>>2]&e;j=66}if((j|0)==66)if(!((i|0)==0&(h|0)==0)){j=g<<6;while(1){g=b+8|0;v=Qa(i|0,h|0,0)|0;e=Yu(i|0,h|0,-1,-1)|0;i=e&i;h=D&h;c[b>>2]=v+j;if((i|0)==0&(h|0)==0){b=g;break}else b=g}}if((f|0)==6){Te(a)|0;return b|0}else{v=b;return v|0}return 0}function We(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0;C=b+5348|0;r=c[C>>2]|0;E=b+256|0;l=E;m=c[l>>2]|0;l=c[l+4>>2]|0;k=~m;j=~l;A=b+5364|0;i=c[A>>2]|0;if((i|0)==1){i=c[(c[b+5356>>2]|0)+48>>2]|0;if((i|0)!=64){y=Pf(b,i,m,l)|0;l=b+320+(c[C>>2]<<3)|0;i=c[l>>2]|0;l=c[l+4>>2]|0;z=b+264|0;if((i&y&c[z>>2]|0)==0?(l&D&c[z+4>>2]|0)==0:0){o=i;p=l;i=5}else i=7}else{p=b+320+(r<<3)|0;o=c[p>>2]|0;p=c[p+4>>2]|0;i=5}a:do if((i|0)==5)while(1){i=0;if((o|0)==0&(p|0)==0){n=k;q=j;break a}z=Qa(o|0,p|0,0)|0;i=Yu(o|0,p|0,-1,-1)|0;p=D&p;y=E;y=Cb(c[b+(z<<2)>>2]|0,z,c[y>>2]|0,c[y+4>>2]|0)|0;z=b+320+((c[C>>2]^1)<<3)|0;if(!((c[z>>2]&y|0)==0?(c[z+4>>2]&D|0)==0:0)){i=7;break}else o=i&o}while(0);if((i|0)==7){q=b+320+((r^1)<<3)|0;n=c[q>>2]&k;q=c[q+4>>2]&j}k=n;j=q;i=c[A>>2]|0}if((i|0)==6?Te(b)|0:0){y=b+320+((r^1)<<3)|0;z=c[y>>2]&k;y=c[y+4>>2]&j}else{z=k;y=j}if(!r){p=b+320|0;h=p;q=b+264|0;j=q;g=c[j+4>>2]&c[h+4>>2];m=g&16711680;l=b+328|0;k=c[l>>2]|0;l=c[l+4>>2]|0;n=c[A>>2]|0;g=gv(c[j>>2]&c[h>>2]|0,g|0,8)|0;h=z&-256;j=y&16777215;g=g&h;f=D&j;e=gv(g|0,f|0,8)|0;r=(n|0)==4;v=r?-65536:-16777216;e=v&z&e;if((n|0)==3?!((h|0)==0&(j|0)==0|(c[b+4500>>2]|0)==0):0)while(1){i=d+8|0;v=Qa(h|0,j|0,0)|0;r=Yu(h|0,j|0,-1,-1)|0;h=r&h;j=D&j;c[d>>2]=(v|36864)+64;if((h|0)==0&(j|0)==0){d=i;break}else d=i}if(!((g|0)==0&(f|0)==0)){h=d;while(1){v=Qa(g|0,f|0,0)|0;d=Yu(g|0,f|0,-1,-1)|0;g=d&g;f=D&f;d=h+8|0;c[h>>2]=(v|-512)+(v<<6);if((g|0)==0&(f|0)==0)break;else h=d}}if(!((e|0)==0&0==0)){g=d;f=0;while(1){v=Qa(e|0,f|0,0)|0;d=Yu(e|0,f|0,-1,-1)|0;e=d&e;f=D&f;d=g+8|0;c[g>>2]=(v|-1024)+(v<<6);if((e|0)==0&(f|0)==0)break;else g=d}}if(!(0==0&(m|0)==0)){f=gv(0,m|0,9)|0;f=f&k;e=D&l;gv(0,m|0,7)|0;h=l&2130706432&D;k=gv(0,m|0,8)|0;k=k&z;i=D&y;b:do if(!((f|0)==0&(e|0)==0)){o=d;g=n;while(1){n=Qa(f|0,e|0,0)|0;m=Yu(f|0,e|0,-1,-1)|0;f=m&f;e=D&e;m=n<<6;if((g|0)==1){c[o+24>>2]=n+15808+m;c[o+32>>2]=n+40384+m;d=o+40|0;j=n+28096|0;l=n+24e3|0;g=n+19904|0}else{d=o+24|0;j=n+24e3|0;l=n+19904|0;g=n+15808|0}c[o>>2]=j+m;c[o+8>>2]=l+m;c[o+16>>2]=g+m;if((f|0)==0&(e|0)==0)break b;o=d;g=c[A>>2]|0}}while(0);if(!(0==0&(h|0)==0)){l=d;m=0;while(1){e=Qa(m|0,h|0,0)|0;j=Yu(m|0,h|0,-1,-1)|0;m=j&m;h=D&h;j=e<<6;if((c[A>>2]|0)==1){c[l+24>>2]=e+15936+j;c[l+32>>2]=e+40512+j;d=l+40|0;f=e+28224|0;g=e+24128|0;e=e+20032|0}else{d=l+24|0;f=e+24128|0;g=e+20032|0;e=e+15936|0}c[l>>2]=f+j;c[l+8>>2]=g+j;c[l+16>>2]=e+j;if((m|0)==0&(h|0)==0)break;else l=d}}if(!((k|0)==0&(i|0)==0))while(1){e=Qa(k|0,i|0,0)|0;j=Yu(k|0,i|0,-1,-1)|0;k=j&k;i=D&i;j=e<<6;if((c[A>>2]|0)==1){c[d+24>>2]=(e|15872)+j;c[d+32>>2]=(e|40448)+j;f=d+40|0;g=e|28160;h=e|24064;e=e|19968}else{f=d+24|0;g=e|24064;h=e|19968;e=e|15872}c[d>>2]=g+j;c[d+8>>2]=h+j;c[d+16>>2]=e+j;if((k|0)==0&(i|0)==0){d=f;break}else d=f}}l=c[A>>2]|0;if((l|0)==3?(c[b+4496>>2]|0)!=(c[b+4500>>2]|0):0){h=(z|0)!=0|(y|0)!=0;if(h&(c[b+4504>>2]|0)!=0){f=z;g=y;while(1){e=d+8|0;v=Qa(f|0,g|0,0)|0;r=Yu(f|0,g|0,-1,-1)|0;f=r&f;g=D&g;c[d>>2]=v|36992;if((f|0)==0&(g|0)==0){d=e;break}else d=e}}if(h&(c[b+4508>>2]|0)!=0){f=z;g=y;while(1){e=d+8|0;v=Qa(f|0,g|0,0)|0;r=Yu(f|0,g|0,-1,-1)|0;f=r&f;g=D&g;c[d>>2]=(v|36864)+192;if((f|0)==0&(g|0)==0){d=e;break}else d=e}}if(h&(c[b+4512>>2]|0)!=0){f=z;g=y;while(1){e=d+8|0;v=Qa(f|0,g|0,0)|0;r=Yu(f|0,g|0,-1,-1)|0;f=r&f;g=D&g;c[d>>2]=v|37120;if((f|0)==0&(g|0)==0){d=e;break}else d=e}}if(h&(c[b+4516>>2]|0)!=0){f=z;g=y;while(1){e=d+8|0;v=Qa(f|0,g|0,0)|0;r=Yu(f|0,g|0,-1,-1)|0;f=r&f;g=D&g;c[d>>2]=(v|36864)+320;if((f|0)==0&(g|0)==0){d=e;break}else d=e}}}e=b+912|0;f=c[e>>2]|0;if((f|0)!=64)do{g=32400+(f<<3)|0;h=c[g>>2]&z;g=c[g+4>>2]&y;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[d>>2]=v+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64);e=b+1168|0;f=c[e>>2]|0;if((f|0)!=64){k=E;j=c[k>>2]|0;k=c[k+4>>2]|0;do{h=29520+(f<<3)|0;g=30032+(f<<3)|0;g=(S(c[h+4>>2]&k,c[g+4>>2]|0)|0)^(S(c[h>>2]&j,c[g>>2]|0)|0);g=(c[1035940+(f<<2)>>2]|0)+(g>>>(c[1036196+(f<<2)>>2]|0)<<3)|0;h=c[g>>2]&z;g=c[g+4>>2]&y;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[d>>2]=v+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64)}e=b+1424|0;f=c[e>>2]|0;if((f|0)!=64){k=E;j=c[k>>2]|0;k=c[k+4>>2]|0;do{h=28496+(f<<3)|0;g=29008+(f<<3)|0;g=(S(c[h+4>>2]&k,c[g+4>>2]|0)|0)^(S(c[h>>2]&j,c[g>>2]|0)|0);g=(c[1035428+(f<<2)>>2]|0)+(g>>>(c[1035684+(f<<2)>>2]|0)<<3)|0;h=c[g>>2]&z;g=c[g+4>>2]&y;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[d>>2]=v+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64)}e=b+1680|0;f=c[e>>2]|0;if((f|0)!=64){k=E;j=c[k>>2]|0;k=c[k+4>>2]|0;do{h=28496+(f<<3)|0;g=29008+(f<<3)|0;g=(S(c[h+4>>2]&k,c[g+4>>2]|0)|0)^(S(c[h>>2]&j,c[g>>2]|0)|0);g=(c[1035428+(f<<2)>>2]|0)+(g>>>(c[1035684+(f<<2)>>2]|0)<<3)|0;h=29520+(f<<3)|0;v=30032+(f<<3)|0;v=(S(c[h+4>>2]&k,c[v+4>>2]|0)|0)^(S(c[h>>2]&j,c[v>>2]|0)|0);v=(c[1035940+(f<<2)>>2]|0)+(v>>>(c[1036196+(f<<2)>>2]|0)<<3)|0;h=(c[v>>2]|c[g>>2])&z;g=(c[v+4>>2]|c[g+4>>2])&y;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;v=Qa(h|0,g|0,0)|0;r=Yu(h|0,g|0,-1,-1)|0;h=r&h;g=D&g;c[d>>2]=v+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64)}c:do switch(l|0){case 1:{g=p;v=b+304|0;f=c[v>>2]&c[g>>2];g=c[v+4>>2]&c[g+4>>2];if((f|0)==0&(g|0)==0)h=d;else{e=d;do{h=Qa(f|0,g|0,0)|0;i=Yu(f|0,g|0,-1,-1)|0;f=i&f;g=D&g;i=34448+(h<<3)|0;j=c[i>>2]&z;i=c[i+4>>2]&y;if(!((j|0)==0&(i|0)==0)){k=h<<6;while(1){h=e+8|0;v=Qa(j|0,i|0,0)|0;r=Yu(j|0,i|0,-1,-1)|0;j=r&j;i=D&i;c[e>>2]=v+k;if((j|0)==0&(i|0)==0){e=h;break}else e=h}}}while(!((f|0)==0&(g|0)==0));h=e}if((c[b+5368>>2]|0)==9){b=h;return b|0}e=c[(c[b+5356>>2]|0)+48>>2]|0;if((e|0)!=64){r=E;r=Pf(b,e,c[r>>2]|0,c[r+4>>2]|0)|0;f=b+320+(c[C>>2]<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;v=q;if(!((e&r&c[v>>2]|0)==0?(f&D&c[v+4>>2]|0)==0:0)){b=h;return b|0}}else{f=b+320+(c[C>>2]<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0}while(1){if((e|0)==0&(f|0)==0){i=91;break}v=Qa(e|0,f|0,0)|0;g=Yu(e|0,f|0,-1,-1)|0;f=D&f;r=E;r=Cb(c[b+(v<<2)>>2]|0,v,c[r>>2]|0,c[r+4>>2]|0)|0;v=b+320+((c[C>>2]^1)<<3)|0;if(!((c[v>>2]&r|0)==0?(c[v+4>>2]&D|0)==0:0)){B=h;i=183;break}else e=g&e}if((i|0)==91){t=h;x=c[A>>2]|0;break c}else if((i|0)==183)return B|0;break}case 4:{if(!(c[b+360>>2]|0))i=84;else i=85;break}case 2:{if(!(c[b+360>>2]|0))i=84;else i=85;break}default:{e=c[b+1936>>2]|0;g=34448+(e<<3)|0;f=c[g>>2]&z;g=c[g+4>>2]&y;if((l|0)==7){w=110224+(e<<3)|0;s=e;u=f&~c[w>>2];w=g&~c[w+4>>2];i=88}else{s=e;u=f;w=g;i=88}}}while(0);if((i|0)==84){w=34960;s=64;u=c[w>>2]&z;w=c[w+4>>2]&y;i=88}else if((i|0)==85){s=c[b+1936>>2]|0;w=34448+(s<<3)|0;u=c[w>>2]&z;w=c[w+4>>2]&y;i=88}if((i|0)==88)if((u|0)==0&(w|0)==0){t=d;x=l}else{h=s<<6;g=u;f=w;while(1){e=d+8|0;E=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[d>>2]=E+h;if((g|0)==0&(f|0)==0){t=e;x=l;break}else d=e}}if((x|0)==6?Te(b)|0:0){b=t;return b|0}if(!(c[(c[b+5356>>2]|0)+24>>2]&3)){b=t;return b|0}if(!(a[b+5360>>0]|0)){b=_e(b,Ze(b,t)|0)|0;return b|0}else{b=Ye(b,Xe(b,t)|0)|0;return b|0}}else{t=b+328|0;l=t;u=b+264|0;k=u;n=c[k>>2]&c[l>>2];q=n&65280;o=b+320|0;p=c[o>>2]|0;o=c[o+4>>2]|0;s=c[A>>2]|0;l=av(n|0,c[k+4>>2]&c[l+4>>2]|0,8)|0;k=z&-256;n=y&16777215;l=l&k;j=D&n;av(l|0,j|0,8)|0;i=D;x=(s|0)==4;i=(x?65535:255)&y&i;if((s|0)==3?!((k|0)==0&(n|0)==0|(c[b+4532>>2]|0)==0):0)while(1){m=d+8|0;x=Qa(k|0,n|0,0)|0;w=Yu(k|0,n|0,-1,-1)|0;k=w&k;n=D&n;c[d>>2]=(x|36864)+576;if((k|0)==0&(n|0)==0){d=m;break}else d=m}if(!((l|0)==0&(j|0)==0))while(1){x=Qa(l|0,j|0,0)|0;k=Yu(l|0,j|0,-1,-1)|0;l=k&l;j=D&j;k=d+8|0;c[d>>2]=(x|512)+(x<<6);if((l|0)==0&(j|0)==0){d=k;break}else d=k}if(!(0==0&(i|0)==0)){k=0;while(1){x=Qa(k|0,i|0,0)|0;j=Yu(k|0,i|0,-1,-1)|0;k=j&k;i=D&i;j=d+8|0;c[d>>2]=(x|1024)+(x<<6);if((k|0)==0&(i|0)==0){d=j;break}else d=j}}if(!((q|0)==0&0==0)){i=av(q|0,0,9)|0;i=i&p;j=D&o;m=av(q|0,0,7)|0;m=p&254&m;n=av(q|0,0,8)|0;n=n&z;l=D&y;d:do if(!((i|0)==0&(j|0)==0)){r=d;k=s;d=j;while(1){j=Qa(i|0,d|0,0)|0;q=Yu(i|0,d|0,-1,-1)|0;i=q&i;q=D&d;p=j<<6;if((k|0)==1){c[r+24>>2]=j+16960+p;c[r+32>>2]=j+41536+p;d=r+40|0;k=j+29248|0;o=j+25152|0;j=j+21056|0}else{d=r+24|0;k=j+25152|0;o=j+21056|0;j=j+16960|0}c[r>>2]=k+p;c[r+8>>2]=o+p;c[r+16>>2]=j+p;if((i|0)==0&(q|0)==0)break d;r=d;k=c[A>>2]|0;d=q}}while(0);if(!((m|0)==0&0==0)){q=d;o=0;while(1){i=Qa(m|0,o|0,0)|0;p=Yu(m|0,o|0,-1,-1)|0;m=p&m;o=D&o;p=i<<6;if((c[A>>2]|0)==1){c[q+24>>2]=i+16832+p;c[q+32>>2]=i+41408+p;d=q+40|0;j=i+29120|0;k=i+25024|0;i=i+20928|0}else{d=q+24|0;j=i+25024|0;k=i+20928|0;i=i+16832|0}c[q>>2]=j+p;c[q+8>>2]=k+p;c[q+16>>2]=i+p;if((m|0)==0&(o|0)==0)break;else q=d}}if(!((n|0)==0&(l|0)==0)){o=d;while(1){i=Qa(n|0,l|0,0)|0;m=Yu(n|0,l|0,-1,-1)|0;n=m&n;l=D&l;m=i<<6;if((c[A>>2]|0)==1){c[o+24>>2]=(i|16896)+m;c[o+32>>2]=(i|41472)+m;d=o+40|0;j=i|29184;k=i|25088;i=i|20992}else{d=o+24|0;j=i|25088;k=i|20992;i=i|16896}c[o>>2]=j+m;c[o+8>>2]=k+m;c[o+16>>2]=i+m;if((n|0)==0&(l|0)==0)break;else o=d}}}q=c[A>>2]|0;if((q|0)==3?(c[b+4528>>2]|0)!=(c[b+4532>>2]|0):0){l=(z|0)!=0|(y|0)!=0;if(l&(c[b+4536>>2]|0)!=0){j=z;k=y;while(1){i=d+8|0;x=Qa(j|0,k|0,0)|0;w=Yu(j|0,k|0,-1,-1)|0;j=w&j;k=D&k;c[d>>2]=x|37504;if((j|0)==0&(k|0)==0){d=i;break}else d=i}}if(l&(c[b+4540>>2]|0)!=0){j=z;k=y;while(1){i=d+8|0;x=Qa(j|0,k|0,0)|0;w=Yu(j|0,k|0,-1,-1)|0;j=w&j;k=D&k;c[d>>2]=(x|36864)+704;if((j|0)==0&(k|0)==0){d=i;break}else d=i}}if(l&(c[b+4544>>2]|0)!=0){j=z;k=y;while(1){i=d+8|0;x=Qa(j|0,k|0,0)|0;w=Yu(j|0,k|0,-1,-1)|0;j=w&j;k=D&k;c[d>>2]=x|37632;if((j|0)==0&(k|0)==0){d=i;break}else d=i}}if(l&(c[b+4548>>2]|0)!=0){j=z;k=y;while(1){i=d+8|0;x=Qa(j|0,k|0,0)|0;w=Yu(j|0,k|0,-1,-1)|0;j=w&j;k=D&k;c[d>>2]=(x|36864)+832;if((j|0)==0&(k|0)==0){d=i;break}else d=i}}}i=b+2960|0;j=c[i>>2]|0;if((j|0)!=64)do{m=32400+(j<<3)|0;k=c[m>>2]&z;m=c[m+4>>2]&y;if(!((k|0)==0&(m|0)==0)){n=j<<6;l=d;j=m;while(1){d=l+8|0;x=Qa(k|0,j|0,0)|0;w=Yu(k|0,j|0,-1,-1)|0;k=w&k;j=D&j;c[l>>2]=x+n;if((k|0)==0&(j|0)==0)break;else l=d}}i=i+4|0;j=c[i>>2]|0}while((j|0)!=64);i=b+3216|0;j=c[i>>2]|0;if((j|0)!=64){p=E;o=c[p>>2]|0;p=c[p+4>>2]|0;do{k=29520+(j<<3)|0;m=30032+(j<<3)|0;m=(S(c[k+4>>2]&p,c[m+4>>2]|0)|0)^(S(c[k>>2]&o,c[m>>2]|0)|0);m=(c[1035940+(j<<2)>>2]|0)+(m>>>(c[1036196+(j<<2)>>2]|0)<<3)|0;k=c[m>>2]&z;m=c[m+4>>2]&y;if(!((k|0)==0&(m|0)==0)){n=j<<6;l=d;j=m;while(1){d=l+8|0;x=Qa(k|0,j|0,0)|0;w=Yu(k|0,j|0,-1,-1)|0;k=w&k;j=D&j;c[l>>2]=x+n;if((k|0)==0&(j|0)==0)break;else l=d}}i=i+4|0;j=c[i>>2]|0}while((j|0)!=64)}i=b+3472|0;j=c[i>>2]|0;if((j|0)!=64){p=E;o=c[p>>2]|0;p=c[p+4>>2]|0;do{k=28496+(j<<3)|0;m=29008+(j<<3)|0;m=(S(c[k+4>>2]&p,c[m+4>>2]|0)|0)^(S(c[k>>2]&o,c[m>>2]|0)|0);m=(c[1035428+(j<<2)>>2]|0)+(m>>>(c[1035684+(j<<2)>>2]|0)<<3)|0;k=c[m>>2]&z;m=c[m+4>>2]&y;if(!((k|0)==0&(m|0)==0)){n=j<<6;l=d;j=m;while(1){d=l+8|0;x=Qa(k|0,j|0,0)|0;w=Yu(k|0,j|0,-1,-1)|0;k=w&k;j=D&j;c[l>>2]=x+n;if((k|0)==0&(j|0)==0)break;else l=d}}i=i+4|0;j=c[i>>2]|0}while((j|0)!=64)}i=b+3728|0;j=c[i>>2]|0;if((j|0)!=64){p=E;o=c[p>>2]|0;p=c[p+4>>2]|0;do{k=28496+(j<<3)|0;m=29008+(j<<3)|0;m=(S(c[k+4>>2]&p,c[m+4>>2]|0)|0)^(S(c[k>>2]&o,c[m>>2]|0)|0);m=(c[1035428+(j<<2)>>2]|0)+(m>>>(c[1035684+(j<<2)>>2]|0)<<3)|0;k=29520+(j<<3)|0;x=30032+(j<<3)|0;x=(S(c[k+4>>2]&p,c[x+4>>2]|0)|0)^(S(c[k>>2]&o,c[x>>2]|0)|0);x=(c[1035940+(j<<2)>>2]|0)+(x>>>(c[1036196+(j<<2)>>2]|0)<<3)|0;k=(c[x>>2]|c[m>>2])&z;m=(c[x+4>>2]|c[m+4>>2])&y;if(!((k|0)==0&(m|0)==0)){n=j<<6;l=d;j=m;while(1){d=l+8|0;x=Qa(k|0,j|0,0)|0;w=Yu(k|0,j|0,-1,-1)|0;k=w&k;j=D&j;c[l>>2]=x+n;if((k|0)==0&(j|0)==0)break;else l=d}}i=i+4|0;j=c[i>>2]|0}while((j|0)!=64)}e:do switch(q|0){case 1:{k=t;x=b+304|0;j=c[x>>2]&c[k>>2];k=c[x+4>>2]&c[k+4>>2];if((j|0)==0&(k|0)==0)l=d;else{i=d;do{l=Qa(j|0,k|0,0)|0;m=Yu(j|0,k|0,-1,-1)|0;j=m&j;k=D&k;m=34448+(l<<3)|0;n=c[m>>2]&z;m=c[m+4>>2]&y;if(!((n|0)==0&(m|0)==0)){o=l<<6;while(1){l=i+8|0;x=Qa(n|0,m|0,0)|0;w=Yu(n|0,m|0,-1,-1)|0;n=w&n;m=D&m;c[i>>2]=x+o;if((n|0)==0&(m|0)==0){i=l;break}else i=l}}}while(!((j|0)==0&(k|0)==0));l=i}if((c[b+5368>>2]|0)==9){b=l;return b|0}i=c[(c[b+5356>>2]|0)+48>>2]|0;if((i|0)!=64){w=E;w=Pf(b,i,c[w>>2]|0,c[w+4>>2]|0)|0;j=b+320+(c[C>>2]<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0;x=u;if(!((i&w&c[x>>2]|0)==0?(j&D&c[x+4>>2]|0)==0:0)){b=l;return b|0}}else{j=b+320+(c[C>>2]<<3)|0;i=c[j>>2]|0;j=c[j+4>>2]|0}while(1){if((i|0)==0&(j|0)==0){i=176;break}x=Qa(i|0,j|0,0)|0;k=Yu(i|0,j|0,-1,-1)|0;j=D&j;w=E;w=Cb(c[b+(x<<2)>>2]|0,x,c[w>>2]|0,c[w+4>>2]|0)|0;x=b+320+((c[C>>2]^1)<<3)|0;if(!((c[x>>2]&w|0)==0?(c[x+4>>2]&D|0)==0:0)){B=l;i=183;break}else i=k&i}if((i|0)==176){e=l;v=c[A>>2]|0;break e}else if((i|0)==183)return B|0;break}case 4:{if(!(c[b+392>>2]|0))i=169;else i=170;break}case 2:{if(!(c[b+392>>2]|0))i=169;else i=170;break}default:{h=c[b+3984>>2]|0;f=34448+(h<<3)|0;g=c[f>>2]&z;f=c[f+4>>2]&y;if((q|0)==7){i=110224+(h<<3)|0;g=g&~c[i>>2];f=f&~c[i+4>>2];i=173}else i=173}}while(0);if((i|0)==169){f=34960;h=64;g=c[f>>2]&z;f=c[f+4>>2]&y;i=173}else if((i|0)==170){h=c[b+3984>>2]|0;f=34448+(h<<3)|0;g=c[f>>2]&z;f=c[f+4>>2]&y;i=173}if((i|0)==173)if((g|0)==0&(f|0)==0){e=d;v=q}else{h=h<<6;while(1){e=d+8|0;E=Qa(g|0,f|0,0)|0;C=Yu(g|0,f|0,-1,-1)|0;g=C&g;f=D&f;c[d>>2]=E+h;if((g|0)==0&(f|0)==0){v=q;break}else d=e}}if((v|0)==6?Te(b)|0:0){b=e;return b|0}if(!(c[(c[b+5356>>2]|0)+24>>2]&12)){b=e;return b|0}if(!(a[b+5360>>0]|0)){b=cf(b,bf(b,e)|0)|0;return b|0}else{b=af(b,$e(b,e)|0)|0;return b|0}}return 0}function Xe(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=a+256|0;h=p;o=c[h>>2]|0;h=c[h+4>>2]|0;q=a+5216|0;if(!((c[q>>2]&o|0)==0?(c[q+4>>2]&h|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&1)){a=b;return a|0}q=a+5364|0;switch(c[q>>2]|0){case 4:{if(!(c[a+360>>2]|0))k=6;else k=8;break}case 2:{if(!(c[a+360>>2]|0))k=6;else k=8;break}case 1:{e=c[a+5084>>2]|0;d=c[a+5148>>2]|0;break}default:k=8}if((k|0)==6){j=a+328|0;f=j;e=64;n=1;d=c[a+5148>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0;k=9}else if((k|0)==8){i=c[a+1936>>2]|0;d=c[a+5148>>2]|0;j=a+328|0;f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;if((i|0)==6){e=6;i=o;k=17}else{e=i;n=(i|0)<6?-1:1;k=9}}do if((k|0)==9){l=a+392|0;m=a+3984|0;k=6;i=o;while(1){o=Pf(a,k,i,h)|0;if(!((o&g|0)==0&(D&f|0)==0)){if((c[q>>2]|0)!=2){k=19;break}if(!(c[l>>2]|0))h=64;else h=c[m>>2]|0;o=34448+(h<<3)|0;i=30544+(k<<3)|0;if((c[i>>2]&c[o>>2]|0)==0?(c[i+4>>2]&c[o+4>>2]|0)==0:0){k=19;break}}k=k+n|0;h=p;i=c[h>>2]|0;h=c[h+4>>2]|0;if((k|0)==(e|0)){k=16;break}}if((k|0)==16){f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;k=17;break}else if((k|0)==19)return b|0}while(0);if((k|0)==17){q=30544+(d<<3)|0;o=28544;p=29056;p=(S(c[o+4>>2]&(c[q+4>>2]^h),c[p+4>>2]|0)|0)^(S(c[o>>2]&(c[q>>2]^i),c[p>>2]|0)|0);p=(c[258863]|0)+(p>>>(c[258927]|0)<<3)|0;q=a+288|0;a=a+296|0;if(!((g&c[p>>2]&(c[a>>2]|c[q>>2])|0)==0?(f&c[p+4>>2]&(c[a+4>>2]|c[q+4>>2])|0)==0:0)){a=b;return a|0}}c[b>>2]=(e<<6)+49152+d;a=b+8|0;return a|0}function Ye(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=a+256|0;h=p;o=c[h>>2]|0;h=c[h+4>>2]|0;q=a+5224|0;if(!((c[q>>2]&o|0)==0?(c[q+4>>2]&h|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&2)){a=b;return a|0}q=a+5364|0;switch(c[q>>2]|0){case 4:{if(!(c[a+360>>2]|0))k=6;else k=8;break}case 2:{if(!(c[a+360>>2]|0))k=6;else k=8;break}case 1:{e=c[a+5088>>2]|0;d=c[a+5152>>2]|0;break}default:k=8}if((k|0)==6){j=a+328|0;f=j;e=64;n=1;d=c[a+5152>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0;k=9}else if((k|0)==8){i=c[a+1936>>2]|0;d=c[a+5152>>2]|0;j=a+328|0;f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;if((i|0)==2){e=2;i=o;k=17}else{e=i;n=(i|0)<2?-1:1;k=9}}do if((k|0)==9){l=a+392|0;m=a+3984|0;k=2;i=o;while(1){o=Pf(a,k,i,h)|0;if(!((o&g|0)==0&(D&f|0)==0)){if((c[q>>2]|0)!=2){k=19;break}if(!(c[l>>2]|0))h=64;else h=c[m>>2]|0;o=34448+(h<<3)|0;i=30544+(k<<3)|0;if((c[i>>2]&c[o>>2]|0)==0?(c[i+4>>2]&c[o+4>>2]|0)==0:0){k=19;break}}k=k+n|0;h=p;i=c[h>>2]|0;h=c[h+4>>2]|0;if((k|0)==(e|0)){k=16;break}}if((k|0)==16){f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;k=17;break}else if((k|0)==19)return b|0}while(0);if((k|0)==17){q=30544+(d<<3)|0;o=28512;p=29024;p=(S(c[o+4>>2]&(c[q+4>>2]^h),c[p+4>>2]|0)|0)^(S(c[o>>2]&(c[q>>2]^i),c[p>>2]|0)|0);p=(c[258859]|0)+(p>>>(c[258923]|0)<<3)|0;q=a+288|0;a=a+296|0;if(!((g&c[p>>2]&(c[a>>2]|c[q>>2])|0)==0?(f&c[p+4>>2]&(c[a+4>>2]|c[q+4>>2])|0)==0:0)){a=b;return a|0}}c[b>>2]=(e<<6)+49152+d;a=b+8|0;return a|0}function Ze(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;m=a+256|0;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0;n=a+5216|0;if(!((c[n>>2]&h|0)==0?(c[n+4>>2]&g|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&1)){a=b;return a|0}n=a+5364|0;switch(c[n>>2]|0){case 4:{if(!(c[a+360>>2]|0))f=7;else f=8;break}case 2:{if(!(c[a+360>>2]|0))f=7;else f=8;break}case 1:{e=c[a+5084>>2]|0;d=c[a+5148>>2]|0;break}default:f=8}if((f|0)==7){e=64;d=c[a+5148>>2]|0;f=9}else if((f|0)==8){e=c[a+1936>>2]|0;d=c[a+5148>>2]|0;if((e|0)==6)e=6;else f=9}a:do if((f|0)==9){j=a+328|0;i=c[j>>2]|0;j=c[j+4>>2]|0;k=a+392|0;l=a+3984|0;f=6;while(1){h=Pf(a,f,h,g)|0;if(!((h&i|0)==0&(D&j|0)==0)){if((c[n>>2]|0)!=2){f=18;break}if(!(c[k>>2]|0))g=64;else g=c[l>>2]|0;h=34448+(g<<3)|0;g=30544+(f<<3)|0;if((c[g>>2]&c[h>>2]|0)==0?(c[g+4>>2]&c[h+4>>2]|0)==0:0){f=18;break}}f=f+-1|0;if((f|0)==(e|0))break a;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0}if((f|0)==18)return b|0}while(0);c[b>>2]=d+49152+(e<<6);a=b+8|0;return a|0}function _e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;m=a+256|0;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0;n=a+5224|0;if(!((c[n>>2]&h|0)==0?(c[n+4>>2]&g|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&2)){a=b;return a|0}n=a+5364|0;switch(c[n>>2]|0){case 4:{if(!(c[a+360>>2]|0))f=7;else f=8;break}case 2:{if(!(c[a+360>>2]|0))f=7;else f=8;break}case 1:{e=c[a+5088>>2]|0;d=c[a+5152>>2]|0;break}default:f=8}if((f|0)==7){e=64;d=c[a+5152>>2]|0;f=9}else if((f|0)==8){e=c[a+1936>>2]|0;d=c[a+5152>>2]|0;if((e|0)==2)e=2;else f=9}a:do if((f|0)==9){j=a+328|0;i=c[j>>2]|0;j=c[j+4>>2]|0;k=a+392|0;l=a+3984|0;f=2;while(1){h=Pf(a,f,h,g)|0;if(!((h&i|0)==0&(D&j|0)==0)){if((c[n>>2]|0)!=2){f=18;break}if(!(c[k>>2]|0))g=64;else g=c[l>>2]|0;h=34448+(g<<3)|0;g=30544+(f<<3)|0;if((c[g>>2]&c[h>>2]|0)==0?(c[g+4>>2]&c[h+4>>2]|0)==0:0){f=18;break}}f=f+1|0;if((f|0)==(e|0))break a;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0}if((f|0)==18)return b|0}while(0);c[b>>2]=d+49152+(e<<6);a=b+8|0;return a|0}function $e(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=a+256|0;h=p;o=c[h>>2]|0;h=c[h+4>>2]|0;q=a+5240|0;if(!((c[q>>2]&o|0)==0?(c[q+4>>2]&h|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&4)){a=b;return a|0}q=a+5364|0;switch(c[q>>2]|0){case 4:{if(!(c[a+392>>2]|0))k=6;else k=8;break}case 2:{if(!(c[a+392>>2]|0))k=6;else k=8;break}case 1:{e=c[a+5096>>2]|0;d=c[a+5160>>2]|0;break}default:k=8}if((k|0)==6){j=a+320|0;f=j;e=64;n=1;d=c[a+5160>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0;k=9}else if((k|0)==8){i=c[a+3984>>2]|0;d=c[a+5160>>2]|0;j=a+320|0;f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;if((i|0)==62){e=62;i=o;k=17}else{e=i;n=(i|0)<62?-1:1;k=9}}do if((k|0)==9){l=a+360|0;m=a+1936|0;k=62;i=o;while(1){o=Pf(a,k,i,h)|0;if(!((o&g|0)==0&(D&f|0)==0)){if((c[q>>2]|0)!=2){k=19;break}if(!(c[l>>2]|0))h=64;else h=c[m>>2]|0;o=34448+(h<<3)|0;i=30544+(k<<3)|0;if((c[i>>2]&c[o>>2]|0)==0?(c[i+4>>2]&c[o+4>>2]|0)==0:0){k=19;break}}k=k+n|0;h=p;i=c[h>>2]|0;h=c[h+4>>2]|0;if((k|0)==(e|0)){k=16;break}}if((k|0)==16){f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;k=17;break}else if((k|0)==19)return b|0}while(0);if((k|0)==17){q=30544+(d<<3)|0;o=28992;p=29504;p=(S(c[o+4>>2]&(c[q+4>>2]^h),c[p+4>>2]|0)|0)^(S(c[o>>2]&(c[q>>2]^i),c[p>>2]|0)|0);p=(c[258919]|0)+(p>>>(c[258983]|0)<<3)|0;q=a+288|0;a=a+296|0;if(!((g&c[p>>2]&(c[a>>2]|c[q>>2])|0)==0?(f&c[p+4>>2]&(c[a+4>>2]|c[q+4>>2])|0)==0:0)){a=b;return a|0}}c[b>>2]=(e<<6)+49152+d;a=b+8|0;return a|0}function af(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;p=a+256|0;h=p;o=c[h>>2]|0;h=c[h+4>>2]|0;q=a+5272|0;if(!((c[q>>2]&o|0)==0?(c[q+4>>2]&h|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&8)){a=b;return a|0}q=a+5364|0;switch(c[q>>2]|0){case 4:{if(!(c[a+392>>2]|0))k=6;else k=8;break}case 2:{if(!(c[a+392>>2]|0))k=6;else k=8;break}case 1:{e=c[a+5112>>2]|0;d=c[a+5176>>2]|0;break}default:k=8}if((k|0)==6){j=a+320|0;f=j;e=64;n=1;d=c[a+5176>>2]|0;g=c[f>>2]|0;f=c[f+4>>2]|0;k=9}else if((k|0)==8){i=c[a+3984>>2]|0;d=c[a+5176>>2]|0;j=a+320|0;f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;if((i|0)==58){e=58;i=o;k=17}else{e=i;n=(i|0)<58?-1:1;k=9}}do if((k|0)==9){l=a+360|0;m=a+1936|0;k=58;i=o;while(1){o=Pf(a,k,i,h)|0;if(!((o&g|0)==0&(D&f|0)==0)){if((c[q>>2]|0)!=2){k=19;break}if(!(c[l>>2]|0))h=64;else h=c[m>>2]|0;o=34448+(h<<3)|0;i=30544+(k<<3)|0;if((c[i>>2]&c[o>>2]|0)==0?(c[i+4>>2]&c[o+4>>2]|0)==0:0){k=19;break}}k=k+n|0;h=p;i=c[h>>2]|0;h=c[h+4>>2]|0;if((k|0)==(e|0)){k=16;break}}if((k|0)==16){f=j;g=c[f>>2]|0;f=c[f+4>>2]|0;k=17;break}else if((k|0)==19)return b|0}while(0);if((k|0)==17){q=30544+(d<<3)|0;o=28960;p=29472;p=(S(c[o+4>>2]&(c[q+4>>2]^h),c[p+4>>2]|0)|0)^(S(c[o>>2]&(c[q>>2]^i),c[p>>2]|0)|0);p=(c[258915]|0)+(p>>>(c[258979]|0)<<3)|0;q=a+288|0;a=a+296|0;if(!((g&c[p>>2]&(c[a>>2]|c[q>>2])|0)==0?(f&c[p+4>>2]&(c[a+4>>2]|c[q+4>>2])|0)==0:0)){a=b;return a|0}}c[b>>2]=(e<<6)+49152+d;a=b+8|0;return a|0}function bf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;m=a+256|0;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0;n=a+5240|0;if(!((c[n>>2]&h|0)==0?(c[n+4>>2]&g|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&4)){a=b;return a|0}n=a+5364|0;switch(c[n>>2]|0){case 4:{if(!(c[a+392>>2]|0))f=7;else f=8;break}case 2:{if(!(c[a+392>>2]|0))f=7;else f=8;break}case 1:{e=c[a+5096>>2]|0;d=c[a+5160>>2]|0;break}default:f=8}if((f|0)==7){e=64;d=c[a+5160>>2]|0;f=9}else if((f|0)==8){e=c[a+3984>>2]|0;d=c[a+5160>>2]|0;if((e|0)==62)e=62;else f=9}a:do if((f|0)==9){j=a+320|0;i=c[j>>2]|0;j=c[j+4>>2]|0;k=a+360|0;l=a+1936|0;f=62;while(1){h=Pf(a,f,h,g)|0;if(!((h&i|0)==0&(D&j|0)==0)){if((c[n>>2]|0)!=2){f=18;break}if(!(c[k>>2]|0))g=64;else g=c[l>>2]|0;h=34448+(g<<3)|0;g=30544+(f<<3)|0;if((c[g>>2]&c[h>>2]|0)==0?(c[g+4>>2]&c[h+4>>2]|0)==0:0){f=18;break}}f=f+-1|0;if((f|0)==(e|0))break a;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0}if((f|0)==18)return b|0}while(0);c[b>>2]=d+49152+(e<<6);a=b+8|0;return a|0}function cf(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0;m=a+256|0;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0;n=a+5272|0;if(!((c[n>>2]&h|0)==0?(c[n+4>>2]&g|0)==0:0)){a=b;return a|0}if(!(c[(c[a+5356>>2]|0)+24>>2]&8)){a=b;return a|0}n=a+5364|0;switch(c[n>>2]|0){case 4:{if(!(c[a+392>>2]|0))f=7;else f=8;break}case 2:{if(!(c[a+392>>2]|0))f=7;else f=8;break}case 1:{e=c[a+5112>>2]|0;d=c[a+5176>>2]|0;break}default:f=8}if((f|0)==7){e=64;d=c[a+5176>>2]|0;f=9}else if((f|0)==8){e=c[a+3984>>2]|0;d=c[a+5176>>2]|0;if((e|0)==58)e=58;else f=9}a:do if((f|0)==9){j=a+320|0;i=c[j>>2]|0;j=c[j+4>>2]|0;k=a+360|0;l=a+1936|0;f=58;while(1){h=Pf(a,f,h,g)|0;if(!((h&i|0)==0&(D&j|0)==0)){if((c[n>>2]|0)!=2){f=18;break}if(!(c[k>>2]|0))g=64;else g=c[l>>2]|0;h=34448+(g<<3)|0;g=30544+(f<<3)|0;if((c[g>>2]&c[h>>2]|0)==0?(c[g+4>>2]&c[h+4>>2]|0)==0:0){f=18;break}}f=f+1|0;if((f|0)==(e|0))break a;g=m;h=c[g>>2]|0;g=c[g+4>>2]|0}if((f|0)==18)return b|0}while(0);c[b>>2]=d+49152+(e<<6);a=b+8|0;return a|0}function df(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;R=b+5348|0;p=c[R>>2]|0;i=b+320+(p<<3)|0;j=c[i>>2]|0;i=c[i+4>>2]|0;h=~j;g=~i;P=b+5364|0;f=c[P>>2]|0;if((f|0)==1){f=c[(c[b+5356>>2]|0)+48>>2]|0;k=b+256|0;if((f|0)!=64){N=k;N=Pf(b,f,c[N>>2]|0,c[N+4>>2]|0)|0;i=b+320+(c[R>>2]<<3)|0;f=c[i>>2]|0;i=c[i+4>>2]|0;O=b+264|0;if((f&N&c[O>>2]|0)==0?(i&D&c[O+4>>2]|0)==0:0){m=f;n=i;f=4}else f=6}else{m=j;n=i;f=4}a:do if((f|0)==4)while(1){f=0;if((m|0)==0&(n|0)==0){l=h;o=g;break a}O=Qa(m|0,n|0,0)|0;f=Yu(m|0,n|0,-1,-1)|0;n=D&n;N=k;N=Cb(c[b+(O<<2)>>2]|0,O,c[N>>2]|0,c[N+4>>2]|0)|0;O=b+320+((c[R>>2]^1)<<3)|0;if(!((c[O>>2]&N|0)==0?(c[O+4>>2]&D|0)==0:0)){f=6;break}else m=f&m}while(0);if((f|0)==6){o=b+320+((p^1)<<3)|0;l=c[o>>2]&h;o=c[o+4>>2]&g}h=l;g=o;f=c[P>>2]|0}if((f|0)==6?Te(b)|0:0){O=b+320+((p^1)<<3)|0;N=c[O>>2]&h;O=c[O+4>>2]&g}else{N=h;O=g}if(!p){A=b+320|0;z=c[A>>2]|0;A=c[A+4>>2]|0;F=b+264|0;t=F;u=c[t>>2]&z;t=c[t+4>>2]&A;l=t&16711680;v=t&-16711681;x=b+328|0;w=c[x>>2]|0;x=c[x+4>>2]|0;G=b+256|0;E=G;C=c[E>>2]|0;E=c[E+4>>2]|0;n=~C;p=~E;H=c[P>>2]|0;r=(H|0)==1;m=N&n;o=O&p;n=r?m:n;p=r?o:p;e=gv(u|0,v|0,8)|0;f=D;j=n&e;g=p&f;k=gv(j|0,g|0,8)|0;L=(H|0)==4;i=L?-65536:-16777216;i=k&i;k=(H|0)==6;if(!k){f=i&n;if(((H|0)==3?(c[b+4500>>2]|0)!=0:0)?(q=n&-256,s=p&16777215,!((q|0)==0&(s|0)==0)):0){i=q;h=s;while(1){e=d+8|0;L=Qa(i|0,h|0,0)|0;J=Yu(i|0,h|0,-1,-1)|0;i=J&i;h=D&h;c[d>>2]=(L|36864)+64;if((i|0)==0&(h|0)==0){d=e;h=j;e=0;break}else d=e}}else{h=j;e=0}}else{h=e&m;g=f&o;f=i&m;e=0}if(!((h|0)==0&(g|0)==0)){i=d;while(1){L=Qa(h|0,g|0,0)|0;d=Yu(h|0,g|0,-1,-1)|0;h=d&h;g=D&g;d=i+8|0;c[i>>2]=(L|-512)+(L<<6);if((h|0)==0&(g|0)==0)break;else i=d}}if(!((f|0)==0&(e|0)==0)){g=d;while(1){L=Qa(f|0,e|0,0)|0;d=Yu(f|0,e|0,-1,-1)|0;f=d&f;e=D&e;d=g+8|0;c[g>>2]=(L|-1024)+(L<<6);if((f|0)==0&(e|0)==0)break;else g=d}}if(!(0==0&(l|0)==0)){e=k|r;i=gv(0,l|0,9)|0;i=i&w;h=D&x;gv(0,l|0,7)|0;f=x&2130706432&D;g=gv(0,l|0,8)|0;g=(e?m:n)&g;e=(e?o:p)&D;if(!((i|0)==0&(h|0)==0))if(r){j=d;while(1){J=Qa(i|0,h|0,0)|0;L=Yu(i|0,h|0,-1,-1)|0;i=L&i;h=D&h;L=J<<6;c[j>>2]=J+28096+L;c[j+8>>2]=J+24e3+L;c[j+16>>2]=J+19904+L;c[j+24>>2]=J+15808+L;d=j+40|0;c[j+32>>2]=J+40384+L;if((i|0)==0&(h|0)==0)break;else j=d}}else{j=d;while(1){J=Qa(i|0,h|0,0)|0;L=Yu(i|0,h|0,-1,-1)|0;i=L&i;h=D&h;L=J<<6;c[j>>2]=J+28096+L;c[j+8>>2]=J+24e3+L;c[j+16>>2]=J+19904+L;d=j+32|0;c[j+24>>2]=J+15808+L;if((i|0)==0&(h|0)==0)break;else j=d}}if(!(0==0&(f|0)==0))if(r){h=d;i=0;while(1){J=Qa(i|0,f|0,0)|0;L=Yu(i|0,f|0,-1,-1)|0;i=L&i;f=D&f;L=J<<6;c[h>>2]=J+28224+L;c[h+8>>2]=J+24128+L;c[h+16>>2]=J+20032+L;c[h+24>>2]=J+15936+L;d=h+40|0;c[h+32>>2]=J+40512+L;if((i|0)==0&(f|0)==0)break;else h=d}}else{h=d;i=0;while(1){J=Qa(i|0,f|0,0)|0;L=Yu(i|0,f|0,-1,-1)|0;i=L&i;f=D&f;L=J<<6;c[h>>2]=J+28224+L;c[h+8>>2]=J+24128+L;c[h+16>>2]=J+20032+L;d=h+32|0;c[h+24>>2]=J+15936+L;if((i|0)==0&(f|0)==0)break;else h=d}}if(!((g|0)==0&(e|0)==0))if(r)while(1){J=Qa(g|0,e|0,0)|0;L=Yu(g|0,e|0,-1,-1)|0;g=L&g;e=D&e;L=J<<6;c[d>>2]=(J|28160)+L;c[d+8>>2]=(J|24064)+L;c[d+16>>2]=(J|19968)+L;c[d+24>>2]=(J|15872)+L;f=d+40|0;c[d+32>>2]=(J|40448)+L;if((g|0)==0&(e|0)==0){d=f;break}else d=f}else while(1){J=Qa(g|0,e|0,0)|0;L=Yu(g|0,e|0,-1,-1)|0;g=L&g;e=D&e;L=J<<6;c[d>>2]=(J|28160)+L;c[d+8>>2]=(J|24064)+L;c[d+16>>2]=(J|19968)+L;f=d+32|0;c[d+24>>2]=(J|15872)+L;if((g|0)==0&(e|0)==0){d=f;break}else d=f}}h=gv(u|0,t|0,9)|0;h=w&-16843264&h;g=x&16711422&D;f=gv(u|0,t|0,7)|0;f=w&2139062016&f;e=x&8355711&D;if(!((h|0)==0&(g|0)==0)){i=d;while(1){L=Qa(h|0,g|0,0)|0;d=Yu(h|0,g|0,-1,-1)|0;h=d&h;g=D&g;d=i+8|0;c[i>>2]=L+-576+(L<<6);if((h|0)==0&(g|0)==0)break;else i=d}}if(!((f|0)==0&(e|0)==0)){g=d;while(1){L=Qa(f|0,e|0,0)|0;d=Yu(f|0,e|0,-1,-1)|0;f=d&f;e=D&e;d=g+8|0;c[g>>2]=L+-448+(L<<6);if((f|0)==0&(e|0)==0)break;else g=d}}n=b+5356|0;l=c[(c[n>>2]|0)+48>>2]|0;m=(l|0)==64;if(!m?(B=35984+(l<<3)|0,y=c[B>>2]&u,B=c[B+4>>2]&v,!((y|0)==0&(B|0)==0)):0){h=l+8192|0;g=y;f=B;while(1){e=d+8|0;L=Qa(g|0,f|0,0)|0;J=Yu(g|0,f|0,-1,-1)|0;g=J&g;f=D&f;c[d>>2]=h+(L<<6|24576);if((g|0)==0&(f|0)==0){d=e;break}else d=e}}if((H|0)==3?(c[b+4496>>2]|0)!=(c[b+4500>>2]|0):0){g=w^N;f=x^O;j=(g|0)!=0|(f|0)!=0;if(j&(c[b+4504>>2]|0)!=0){h=g;i=f;while(1){e=d+8|0;L=Qa(h|0,i|0,0)|0;J=Yu(h|0,i|0,-1,-1)|0;h=J&h;i=D&i;c[d>>2]=L|36992;if((h|0)==0&(i|0)==0){d=e;break}else d=e}}if(j&(c[b+4508>>2]|0)!=0){h=g;i=f;while(1){e=d+8|0;L=Qa(h|0,i|0,0)|0;J=Yu(h|0,i|0,-1,-1)|0;h=J&h;i=D&i;c[d>>2]=(L|36864)+192;if((h|0)==0&(i|0)==0){d=e;break}else d=e}}if(j&(c[b+4512>>2]|0)!=0){h=g;i=f;while(1){e=d+8|0;L=Qa(h|0,i|0,0)|0;J=Yu(h|0,i|0,-1,-1)|0;h=J&h;i=D&i;c[d>>2]=L|37120;if((h|0)==0&(i|0)==0){d=e;break}else d=e}}if(j&(c[b+4516>>2]|0)!=0)while(1){e=d+8|0;L=Qa(g|0,f|0,0)|0;J=Yu(g|0,f|0,-1,-1)|0;g=J&g;f=D&f;c[d>>2]=(L|36864)+320;if((g|0)==0&(f|0)==0){d=e;break}else d=e}}e=b+912|0;f=c[e>>2]|0;if((f|0)!=64)do{g=32400+(f<<3)|0;h=c[g>>2]&N;g=c[g+4>>2]&O;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;L=Qa(h|0,g|0,0)|0;J=Yu(h|0,g|0,-1,-1)|0;h=J&h;g=D&g;c[d>>2]=L+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64);e=b+1168|0;f=c[e>>2]|0;if((f|0)!=64)do{h=29520+(f<<3)|0;g=30032+(f<<3)|0;g=(S(c[h+4>>2]&E,c[g+4>>2]|0)|0)^(S(c[h>>2]&C,c[g>>2]|0)|0);g=(c[1035940+(f<<2)>>2]|0)+(g>>>(c[1036196+(f<<2)>>2]|0)<<3)|0;h=c[g>>2]&N;g=c[g+4>>2]&O;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;L=Qa(h|0,g|0,0)|0;J=Yu(h|0,g|0,-1,-1)|0;h=J&h;g=D&g;c[d>>2]=L+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64);e=b+1424|0;f=c[e>>2]|0;if((f|0)!=64)do{h=28496+(f<<3)|0;g=29008+(f<<3)|0;g=(S(c[h+4>>2]&E,c[g+4>>2]|0)|0)^(S(c[h>>2]&C,c[g>>2]|0)|0);g=(c[1035428+(f<<2)>>2]|0)+(g>>>(c[1035684+(f<<2)>>2]|0)<<3)|0;h=c[g>>2]&N;g=c[g+4>>2]&O;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;L=Qa(h|0,g|0,0)|0;J=Yu(h|0,g|0,-1,-1)|0;h=J&h;g=D&g;c[d>>2]=L+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64);e=b+1680|0;f=c[e>>2]|0;if((f|0)!=64)do{h=28496+(f<<3)|0;g=29008+(f<<3)|0;g=(S(c[h+4>>2]&E,c[g+4>>2]|0)|0)^(S(c[h>>2]&C,c[g>>2]|0)|0);g=(c[1035428+(f<<2)>>2]|0)+(g>>>(c[1035684+(f<<2)>>2]|0)<<3)|0;h=29520+(f<<3)|0;L=30032+(f<<3)|0;L=(S(c[h+4>>2]&E,c[L+4>>2]|0)|0)^(S(c[h>>2]&C,c[L>>2]|0)|0);L=(c[1035940+(f<<2)>>2]|0)+(L>>>(c[1036196+(f<<2)>>2]|0)<<3)|0;h=(c[L>>2]|c[g>>2])&N;g=(c[L+4>>2]|c[g+4>>2])&O;if(!((h|0)==0&(g|0)==0)){i=f<<6;while(1){f=d+8|0;L=Qa(h|0,g|0,0)|0;J=Yu(h|0,g|0,-1,-1)|0;h=J&h;g=D&g;c[d>>2]=L+i;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}e=e+4|0;f=c[e>>2]|0}while((f|0)!=64);b:do switch(H|0){case 1:{g=b+304|0;f=c[g>>2]&z;g=c[g+4>>2]&A;if((f|0)==0&(g|0)==0)h=d;else{e=d;do{h=Qa(f|0,g|0,0)|0;i=Yu(f|0,g|0,-1,-1)|0;f=i&f;g=D&g;i=34448+(h<<3)|0;j=c[i>>2]&N;i=c[i+4>>2]&O;if(!((j|0)==0&(i|0)==0)){k=h<<6;while(1){h=e+8|0;L=Qa(j|0,i|0,0)|0;J=Yu(j|0,i|0,-1,-1)|0;j=J&j;i=D&i;c[e>>2]=L+k;if((j|0)==0&(i|0)==0){e=h;break}else e=h}}}while(!((f|0)==0&(g|0)==0));h=e}if((c[b+5368>>2]|0)==9){b=h;return b|0}do if(m){f=b+320+(c[R>>2]<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0}else{J=Pf(b,l,C,E)|0;f=b+320+(c[R>>2]<<3)|0;e=c[f>>2]|0;f=c[f+4>>2]|0;L=F;if((e&J&c[L>>2]|0)==0?(f&D&c[L+4>>2]|0)==0:0)break;else Q=h;return Q|0}while(0);while(1){if((e|0)==0&(f|0)==0){f=91;break}L=Qa(e|0,f|0,0)|0;g=Yu(e|0,f|0,-1,-1)|0;f=D&f;J=G;J=Cb(c[b+(L<<2)>>2]|0,L,c[J>>2]|0,c[J+4>>2]|0)|0;L=b+320+((c[R>>2]^1)<<3)|0;if(!((c[L>>2]&J|0)==0?(c[L+4>>2]&D|0)==0:0)){Q=h;f=184;break}else e=g&e}if((f|0)==91){I=h;K=c[P>>2]|0;break b}else if((f|0)==184)return Q|0;break}case 4:{if(!(c[b+360>>2]|0)){M=64;f=88}else f=87;break}case 2:{if(!(c[b+360>>2]|0)){M=64;f=88}else f=87;break}default:f=87}while(0);if((f|0)==87){M=c[b+1936>>2]|0;f=88}if((f|0)==88){f=34448+(M<<3)|0;g=c[f>>2]&N;f=c[f+4>>2]&O;if((g|0)==0&(f|0)==0){I=d;K=H}else{h=M<<6;while(1){e=d+8|0;R=Qa(g|0,f|0,0)|0;Q=Yu(g|0,f|0,-1,-1)|0;g=Q&g;f=D&f;c[d>>2]=R+h;if((g|0)==0&(f|0)==0){I=e;K=H;break}else d=e}}}if((K|0)==6?Te(b)|0:0){b=I;return b|0}if(!(c[(c[n>>2]|0)+24>>2]&3)){b=I;return b|0}if(!(a[b+5360>>0]|0)){b=_e(b,Ze(b,I)|0)|0;return b|0}else{b=Ye(b,Xe(b,I)|0)|0;return b|0}}else{C=b+328|0;B=c[C>>2]|0;C=c[C+4>>2]|0;G=b+264|0;v=G;u=c[v>>2]&B;v=c[v+4>>2]&C;m=u&65280;w=u&-65281;y=b+320|0;x=c[y>>2]|0;y=c[y+4>>2]|0;H=b+256|0;F=H;E=c[F>>2]|0;F=c[F+4>>2]|0;o=~E;q=~F;I=c[P>>2]|0;s=(I|0)==1;n=N&o;p=O&q;o=s?n:o;q=s?p:q;k=av(w|0,v|0,8)|0;f=D;i=o&k;g=q&f;av(i|0,g|0,8)|0;l=D;j=(I|0)==4;j=l&(j?65535:255);l=(I|0)==6;if(!l){f=j&q;if(((I|0)==3?(c[b+4532>>2]|0)!=0:0)?(r=o&-256,t=q&16777215,!((r|0)==0&(t|0)==0)):0){k=r;j=t;while(1){h=d+8|0;M=Qa(k|0,j|0,0)|0;K=Yu(k|0,j|0,-1,-1)|0;k=K&k;j=D&j;c[d>>2]=(M|36864)+576;if((k|0)==0&(j|0)==0){d=h;h=0;break}else d=h}}else h=0}else{g=f&p;h=0;f=j&p;i=k&n}if(!((i|0)==0&(g|0)==0)){j=i;while(1){M=Qa(j|0,g|0,0)|0;i=Yu(j|0,g|0,-1,-1)|0;j=i&j;g=D&g;i=d+8|0;c[d>>2]=(M|512)+(M<<6);if((j|0)==0&(g|0)==0){d=i;break}else d=i}}if(!((h|0)==0&(f|0)==0))while(1){M=Qa(h|0,f|0,0)|0;g=Yu(h|0,f|0,-1,-1)|0;h=g&h;f=D&f;g=d+8|0;c[d>>2]=(M|1024)+(M<<6);if((h|0)==0&(f|0)==0){d=g;break}else d=g}if(!((m|0)==0&0==0)){f=l|s;j=av(m|0,0,9)|0;j=j&x;i=D&y;g=av(m|0,0,7)|0;g=x&254&g;h=av(m|0,0,8)|0;h=(f?n:o)&h;f=(f?p:q)&D;if(!((j|0)==0&(i|0)==0))if(s){k=d;while(1){K=Qa(j|0,i|0,0)|0;M=Yu(j|0,i|0,-1,-1)|0;j=M&j;i=D&i;M=K<<6;c[k>>2]=K+29248+M;c[k+8>>2]=K+25152+M;c[k+16>>2]=K+21056+M;c[k+24>>2]=K+16960+M;d=k+40|0;c[k+32>>2]=K+41536+M;if((j|0)==0&(i|0)==0)break;else k=d}}else{k=d;while(1){K=Qa(j|0,i|0,0)|0;M=Yu(j|0,i|0,-1,-1)|0;j=M&j;i=D&i;M=K<<6;c[k>>2]=K+29248+M;c[k+8>>2]=K+25152+M;c[k+16>>2]=K+21056+M;d=k+32|0;c[k+24>>2]=K+16960+M;if((j|0)==0&(i|0)==0)break;else k=d}}if(!((g|0)==0&0==0))if(s){j=d;i=0;while(1){K=Qa(g|0,i|0,0)|0;M=Yu(g|0,i|0,-1,-1)|0;g=M&g;i=D&i;M=K<<6;c[j>>2]=K+29120+M;c[j+8>>2]=K+25024+M;c[j+16>>2]=K+20928+M;c[j+24>>2]=K+16832+M;d=j+40|0;c[j+32>>2]=K+41408+M;if((g|0)==0&(i|0)==0)break;else j=d}}else{j=d;i=0;while(1){K=Qa(g|0,i|0,0)|0;M=Yu(g|0,i|0,-1,-1)|0;g=M&g;i=D&i;M=K<<6;c[j>>2]=K+29120+M;c[j+8>>2]=K+25024+M;c[j+16>>2]=K+20928+M;d=j+32|0;c[j+24>>2]=K+16832+M;if((g|0)==0&(i|0)==0)break;else j=d}}if(!((h|0)==0&(f|0)==0))if(s)while(1){K=Qa(h|0,f|0,0)|0;M=Yu(h|0,f|0,-1,-1)|0;h=M&h;f=D&f;M=K<<6;c[d>>2]=(K|29184)+M;c[d+8>>2]=(K|25088)+M;c[d+16>>2]=(K|20992)+M;c[d+24>>2]=(K|16896)+M;g=d+40|0;c[d+32>>2]=(K|41472)+M;if((h|0)==0&(f|0)==0){d=g;break}else d=g}else while(1){K=Qa(h|0,f|0,0)|0;M=Yu(h|0,f|0,-1,-1)|0;h=M&h;f=D&f;M=K<<6;c[d>>2]=(K|29184)+M;c[d+8>>2]=(K|25088)+M;c[d+16>>2]=(K|20992)+M;g=d+32|0;c[d+24>>2]=(K|16896)+M;if((h|0)==0&(f|0)==0){d=g;break}else d=g}}i=av(u|0,v|0,9)|0;i=x&2139062016&i;g=y&8355711&D;h=av(u|0,v|0,7)|0;h=x&-16843264&h;f=y&16711422&D;if(!((i|0)==0&(g|0)==0)){j=i;while(1){M=Qa(j|0,g|0,0)|0;i=Yu(j|0,g|0,-1,-1)|0;j=i&j;g=D&g;i=d+8|0;c[d>>2]=M+576+(M<<6);if((j|0)==0&(g|0)==0){d=i;break}else d=i}}if(!((h|0)==0&(f|0)==0))while(1){M=Qa(h|0,f|0,0)|0;g=Yu(h|0,f|0,-1,-1)|0;h=g&h;f=D&f;g=d+8|0;c[d>>2]=M+448+(M<<6);if((h|0)==0&(f|0)==0){d=g;break}else d=g}o=b+5356|0;m=c[(c[o>>2]|0)+48>>2]|0;n=(m|0)==64;if(!n?(A=31888+(m<<3)|0,z=c[A>>2]&w,A=c[A+4>>2]&v,!((z|0)==0&(A|0)==0)):0){i=m+8192|0;h=z;g=A;while(1){f=d+8|0;M=Qa(h|0,g|0,0)|0;K=Yu(h|0,g|0,-1,-1)|0;h=K&h;g=D&g;c[d>>2]=i+(M<<6|24576);if((h|0)==0&(g|0)==0){d=f;break}else d=f}}if((I|0)==3?(c[b+4528>>2]|0)!=(c[b+4532>>2]|0):0){h=x^N;g=y^O;k=(h|0)!=0|(g|0)!=0;if(k&(c[b+4536>>2]|0)!=0){i=h;j=g;while(1){f=d+8|0;M=Qa(i|0,j|0,0)|0;K=Yu(i|0,j|0,-1,-1)|0;i=K&i;j=D&j;c[d>>2]=M|37504;if((i|0)==0&(j|0)==0){d=f;break}else d=f}}if(k&(c[b+4540>>2]|0)!=0){i=h;j=g;while(1){f=d+8|0;M=Qa(i|0,j|0,0)|0;K=Yu(i|0,j|0,-1,-1)|0;i=K&i;j=D&j;c[d>>2]=(M|36864)+704;if((i|0)==0&(j|0)==0){d=f;break}else d=f}}if(k&(c[b+4544>>2]|0)!=0){i=h;j=g;while(1){f=d+8|0;M=Qa(i|0,j|0,0)|0;K=Yu(i|0,j|0,-1,-1)|0;i=K&i;j=D&j;c[d>>2]=M|37632;if((i|0)==0&(j|0)==0){d=f;break}else d=f}}if(k&(c[b+4548>>2]|0)!=0)while(1){f=d+8|0;M=Qa(h|0,g|0,0)|0;K=Yu(h|0,g|0,-1,-1)|0;h=K&h;g=D&g;c[d>>2]=(M|36864)+832;if((h|0)==0&(g|0)==0){d=f;break}else d=f}}f=b+2960|0;g=c[f>>2]|0;if((g|0)!=64)do{j=32400+(g<<3)|0;h=c[j>>2]&N;j=c[j+4>>2]&O;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=d;g=j;while(1){d=i+8|0;M=Qa(h|0,g|0,0)|0;K=Yu(h|0,g|0,-1,-1)|0;h=K&h;g=D&g;c[i>>2]=M+k;if((h|0)==0&(g|0)==0)break;else i=d}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=b+3216|0;g=c[f>>2]|0;if((g|0)!=64)do{h=29520+(g<<3)|0;j=30032+(g<<3)|0;j=(S(c[h+4>>2]&F,c[j+4>>2]|0)|0)^(S(c[h>>2]&E,c[j>>2]|0)|0);j=(c[1035940+(g<<2)>>2]|0)+(j>>>(c[1036196+(g<<2)>>2]|0)<<3)|0;h=c[j>>2]&N;j=c[j+4>>2]&O;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=d;g=j;while(1){d=i+8|0;M=Qa(h|0,g|0,0)|0;K=Yu(h|0,g|0,-1,-1)|0;h=K&h;g=D&g;c[i>>2]=M+k;if((h|0)==0&(g|0)==0)break;else i=d}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=b+3472|0;g=c[f>>2]|0;if((g|0)!=64)do{h=28496+(g<<3)|0;j=29008+(g<<3)|0;j=(S(c[h+4>>2]&F,c[j+4>>2]|0)|0)^(S(c[h>>2]&E,c[j>>2]|0)|0);j=(c[1035428+(g<<2)>>2]|0)+(j>>>(c[1035684+(g<<2)>>2]|0)<<3)|0;h=c[j>>2]&N;j=c[j+4>>2]&O;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=d;g=j;while(1){d=i+8|0;M=Qa(h|0,g|0,0)|0;K=Yu(h|0,g|0,-1,-1)|0;h=K&h;g=D&g;c[i>>2]=M+k;if((h|0)==0&(g|0)==0)break;else i=d}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);f=b+3728|0;g=c[f>>2]|0;if((g|0)!=64)do{h=28496+(g<<3)|0;j=29008+(g<<3)|0;j=(S(c[h+4>>2]&F,c[j+4>>2]|0)|0)^(S(c[h>>2]&E,c[j>>2]|0)|0);j=(c[1035428+(g<<2)>>2]|0)+(j>>>(c[1035684+(g<<2)>>2]|0)<<3)|0;h=29520+(g<<3)|0;M=30032+(g<<3)|0;M=(S(c[h+4>>2]&F,c[M+4>>2]|0)|0)^(S(c[h>>2]&E,c[M>>2]|0)|0);M=(c[1035940+(g<<2)>>2]|0)+(M>>>(c[1036196+(g<<2)>>2]|0)<<3)|0;h=(c[M>>2]|c[j>>2])&N;j=(c[M+4>>2]|c[j+4>>2])&O;if(!((h|0)==0&(j|0)==0)){k=g<<6;i=d;g=j;while(1){d=i+8|0;M=Qa(h|0,g|0,0)|0;K=Yu(h|0,g|0,-1,-1)|0;h=K&h;g=D&g;c[i>>2]=M+k;if((h|0)==0&(g|0)==0)break;else i=d}}f=f+4|0;g=c[f>>2]|0}while((g|0)!=64);c:do switch(I|0){case 1:{h=b+304|0;g=c[h>>2]&B;h=c[h+4>>2]&C;if((g|0)==0&(h|0)==0)i=d;else{f=d;do{i=Qa(g|0,h|0,0)|0;j=Yu(g|0,h|0,-1,-1)|0;g=j&g;h=D&h;j=34448+(i<<3)|0;k=c[j>>2]&N;j=c[j+4>>2]&O;if(!((k|0)==0&(j|0)==0)){l=i<<6;while(1){i=f+8|0;M=Qa(k|0,j|0,0)|0;K=Yu(k|0,j|0,-1,-1)|0;k=K&k;j=D&j;c[f>>2]=M+l;if((k|0)==0&(j|0)==0){f=i;break}else f=i}}}while(!((g|0)==0&(h|0)==0));i=f}if((c[b+5368>>2]|0)==9){b=i;return b|0}do if(n){g=b+320+(c[R>>2]<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0}else{K=Pf(b,m,E,F)|0;g=b+320+(c[R>>2]<<3)|0;f=c[g>>2]|0;g=c[g+4>>2]|0;M=G;if((f&K&c[M>>2]|0)==0?(g&D&c[M+4>>2]|0)==0:0)break;else Q=i;return Q|0}while(0);while(1){if((f|0)==0&(g|0)==0){f=177;break}M=Qa(f|0,g|0,0)|0;h=Yu(f|0,g|0,-1,-1)|0;g=D&g;K=H;K=Cb(c[b+(M<<2)>>2]|0,M,c[K>>2]|0,c[K+4>>2]|0)|0;M=b+320+((c[R>>2]^1)<<3)|0;if(!((c[M>>2]&K|0)==0?(c[M+4>>2]&D|0)==0:0)){Q=i;f=184;break}else f=h&f}if((f|0)==177){e=i;J=c[P>>2]|0;break c}else if((f|0)==184)return Q|0;break}case 4:{if(!(c[b+392>>2]|0)){L=64;f=174}else f=173;break}case 2:{if(!(c[b+392>>2]|0)){L=64;f=174}else f=173;break}default:f=173}while(0);if((f|0)==173){L=c[b+3984>>2]|0;f=174}if((f|0)==174){f=34448+(L<<3)|0;g=c[f>>2]&N;f=c[f+4>>2]&O;if((g|0)==0&(f|0)==0){e=d;J=I}else{h=L<<6;while(1){e=d+8|0;R=Qa(g|0,f|0,0)|0;Q=Yu(g|0,f|0,-1,-1)|0;g=Q&g;f=D&f;c[d>>2]=R+h;if((g|0)==0&(f|0)==0){J=I;break}else d=e}}}if((J|0)==6?Te(b)|0:0){b=e;return b|0}if(!(c[(c[o>>2]|0)+24>>2]&12)){b=e;return b|0}if(!(a[b+5360>>0]|0)){b=cf(b,bf(b,e)|0)|0;return b|0}else{b=af(b,$e(b,e)|0)|0;return b|0}}return 0}
function ct(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;g=a+4|0;d=c[g>>2]|0;f=c[a>>2]|0;e=d-f>>2;a:do if(e>>>0>=b>>>0){if(e>>>0>b>>>0){a=f+(b<<2)|0;while(1){if((d|0)==(a|0))break a;f=d+-4|0;c[g>>2]=f;d=f}}}else dt(a,b-e|0);while(0);return}function dt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,i=0;i=l;l=l+32|0;h=i;g=c[a+8>>2]|0;d=c[a+4>>2]|0;if(g-d>>2>>>0<b>>>0){f=c[a>>2]|0;d=d-f>>2;e=d+b|0;if(e>>>0>1073741823)vs(a);f=g-f|0;g=f>>1;ft(h,f>>2>>>0<536870911?(g>>>0<e>>>0?e:g):1073741823,d,a+16|0);e=h+8|0;d=c[e>>2]|0;do{c[d>>2]=0;d=(c[e>>2]|0)+4|0;c[e>>2]=d;b=b+-1|0}while((b|0)!=0);gt(a,h);ht(h)}else et(a,b);l=i;return}function et(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;a=b;b=c[d>>2]|0;do{c[b>>2]=0;b=(c[d>>2]|0)+4|0;c[d>>2]=b;a=a+-1|0}while((a|0)!=0);return}function ft(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;c[b+12>>2]=0;c[b+16>>2]=f;do if(d){g=f+112|0;if(d>>>0<29&(a[g>>0]|0)==0){a[g>>0]=1;break}else{f=At(d<<2)|0;break}}else f=0;while(0);c[b>>2]=f;e=f+(e<<2)|0;c[b+8>>2]=e;c[b+4>>2]=e;c[b+12>>2]=f+(d<<2);return}function gt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;e=c[a>>2]|0;h=a+4|0;g=b+4|0;f=(c[h>>2]|0)-e|0;d=(c[g>>2]|0)+(0-(f>>2)<<2)|0;c[g>>2]=d;if((f|0)>0){cv(d|0,e|0,f|0)|0;e=g;d=c[g>>2]|0}else e=g;g=c[a>>2]|0;c[a>>2]=d;c[e>>2]=g;g=b+8|0;f=c[h>>2]|0;c[h>>2]=c[g>>2];c[g>>2]=f;g=a+8|0;h=b+12|0;a=c[g>>2]|0;c[g>>2]=c[h>>2];c[h>>2]=a;c[b>>2]=c[e>>2];return}function ht(b){b=b|0;var d=0,e=0,f=0,g=0;d=c[b+4>>2]|0;e=b+8|0;f=c[e>>2]|0;while(1){if((f|0)==(d|0))break;g=f+-4|0;c[e>>2]=g;f=g}e=c[b>>2]|0;do if(e|0){d=c[b+16>>2]|0;if((d|0)==(e|0)){a[d+112>>0]=0;break}else{Dt(e);break}}while(0);return}function it(b,d){b=b|0;d=d|0;var e=0;if(d>>>0>1073741823)vs(b);e=b+128|0;if(d>>>0<29&(a[e>>0]|0)==0){a[e>>0]=1;e=b+16|0}else e=At(d<<2)|0;c[b+4>>2]=e;c[b>>2]=e;c[b+8>>2]=e+(d<<2);return}function jt(){if((a[994280]|0)==0?Ru(994280)|0:0){kt()|0;c[291864]=1167452}return c[291864]|0}function kt(){xs(994288,1);c[291863]=994288;return 1167452}function lt(){var a=0;a=c[(jt()|0)>>2]|0;c[291865]=a;ut(a);return 1167460}function mt(){if((a[994448]|0)==0?Ru(994448)|0:0){lt()|0;c[291866]=1167460}return c[291866]|0}function nt(a){a=a|0;var b=0;b=c[(mt()|0)>>2]|0;c[a>>2]=b;ut(b);return}function ot(a,b){a=a|0;b=b|0;b=c[b>>2]|0;c[a>>2]=b;ut(b);return}function pt(a){a=a|0;vt(c[a>>2]|0)|0;return}function qt(a,b){a=a|0;b=b|0;a=c[a>>2]|0;return rt(a,pm(b)|0)|0}function rt(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;if((c[a+12>>2]|0)-d>>2>>>0>b>>>0)a=(c[d+(b<<2)>>2]|0)!=0;else a=0;return a|0}function st(a,b,c){a=a|0;b=b|0;c=c|0;if(!c)a=0;else a=xj(a,b,c)|0;return a|0}function tt(a){a=a|0;return}function ut(a){a=a|0;a=a+4|0;c[a>>2]=(c[a>>2]|0)+1;return}function vt(a){a=a|0;var b=0,d=0;d=a+4|0;b=c[d>>2]|0;c[d>>2]=b+-1;if(!b){db[c[(c[a>>2]|0)+8>>2]&255](a);a=1}else a=0;return a|0}function wt(a){a=a|0;Ka(a|0)|0;return}function xt(a){a=a|0;Xu(a|0)|0;return}function yt(a){a=a|0;if(!(jv(a|0)|0))return;else Aa(27873,27881,48,27966)}function zt(a,b,d){a=a|0;b=b|0;d=d|0;Xu(1167468)|0;while(1){if((c[a>>2]|0)!=1)break;sa(1167496,1167468)|0}if(!(c[a>>2]|0)){c[a>>2]=1;jv(1167468)|0;db[d&255](b);Xu(1167468)|0;c[a>>2]=-1;jv(1167468)|0;bv(1167496)|0}else jv(1167468)|0;return}function At(a){a=a|0;var b=0;b=(a|0)==0?1:a;while(1){a=Fj(b)|0;if(a|0)break;a=Tu()|0;if(!a){a=0;break}jb[a&0]()}return a|0}function Bt(a,b){a=a|0;b=b|0;return At(a)|0}function Ct(a){a=a|0;return At(a)|0}function Dt(a){a=a|0;Gj(a);return}function Et(a){a=a|0;Dt(a);return}function Ft(){return}function Gt(a){a=a|0;Aa(27973,28002,1183,28088)}function Ht(a){a=a|0;Aa(28109,28002,1194,28138)}function It(b,d){b=b|0;d=d|0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;if((a[d+11>>0]|0)<0)Jt(b,c[d>>2]|0,c[d+4>>2]|0);else{c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2]}return}function Jt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(e>>>0>4294967279)Gt(b);if(e>>>0<11){a[b+11>>0]=e;if(e)f=6}else{g=e+16&-16;f=At(g)|0;c[b>>2]=f;c[b+8>>2]=g|-2147483648;c[b+4>>2]=e;b=f;f=6}if((f|0)==6)cv(b|0,d|0,e|0)|0;a[b+e>>0]=0;return}function Kt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(d>>>0>4294967279)Gt(b);if(d>>>0<11){a[b+11>>0]=d;if(d)f=6}else{g=d+16&-16;f=At(g)|0;c[b>>2]=f;c[b+8>>2]=g|-2147483648;c[b+4>>2]=d;b=f;f=6}if((f|0)==6)Wu(b|0,e|0,d|0)|0;a[b+d>>0]=0;return}function Lt(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;g=a[d+11>>0]|0;h=g<<24>>24<0;g=h?c[d+4>>2]|0:g&255;if(g>>>0<e>>>0)Ht(b);else{g=g-e|0;Jt(b,(h?c[d>>2]|0:d)+e|0,g>>>0<f>>>0?g:f);return}}function Mt(b){b=b|0;if((a[b+11>>0]|0)<0)Dt(c[b>>2]|0);return}function Nt(b,d){b=b|0;d=d|0;var e=0,f=0;if((b|0)!=(d|0)){e=a[d+11>>0]|0;f=e<<24>>24<0;Ot(b,f?c[d>>2]|0:d,f?c[d+4>>2]|0:e&255)|0}return b|0}function Ot(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=b+11|0;f=a[h>>0]|0;g=f<<24>>24<0;if(g)i=(c[b+8>>2]&2147483647)+-1|0;else i=10;do if(i>>>0>=e>>>0){if(g)f=c[b>>2]|0;else f=b;if(e|0)hv(f|0,d|0,e|0)|0;a[f+e>>0]=0;if((a[h>>0]|0)<0){c[b+4>>2]=e;break}else{a[h>>0]=e;break}}else{if(g)f=c[b+4>>2]|0;else f=f&255;Pt(b,i,e-i|0,f,0,f,e,d)}while(0);return b|0}function Pt(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0;if((-18-d|0)>>>0<e>>>0)Gt(b);if((a[b+11>>0]|0)<0)m=c[b>>2]|0;else m=b;if(d>>>0<2147483623){k=e+d|0;l=d<<1;k=k>>>0<l>>>0?l:k;k=k>>>0<11?11:k+16&-16}else k=-17;l=At(k)|0;if(g|0)cv(l|0,m|0,g|0)|0;if(i|0)cv(l+g|0,j|0,i|0)|0;e=f-h|0;f=e-g|0;if(f|0)cv(l+g+i|0,m+g+h|0,f|0)|0;if((d|0)!=10)Dt(m);c[b>>2]=l;c[b+8>>2]=k|-2147483648;i=e+i|0;c[b+4>>2]=i;a[l+i>>0]=0;return}function Qt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0,l=0,m=0;if(d>>>0>4294967279)Gt(b);m=b+11|0;j=a[m>>0]|0;g=j<<24>>24<0;if(g){l=c[b+4>>2]|0;e=(c[b+8>>2]&2147483647)+-1|0}else{l=j&255;e=10}k=l>>>0>d>>>0?l:d;d=k>>>0<11;k=d?10:(k+16&-16)+-1|0;do if((k|0)!=(e|0)){do if(d){e=c[b>>2]|0;if(g){d=0;f=b;i=12}else{d=0;g=1;f=b;i=13}}else{f=At(k+1|0)|0;if(g){d=1;e=c[b>>2]|0;i=12;break}else{d=1;g=0;e=b;i=13;break}}while(0);if((i|0)==12){h=d;g=1;d=c[b+4>>2]|0}else if((i|0)==13){h=d;d=j&255}d=d+1|0;if(d|0)cv(f|0,e|0,d|0)|0;if(g)Dt(e);if(h){c[b+8>>2]=k+1|-2147483648;c[b+4>>2]=l;c[b>>2]=f;break}else{a[m>>0]=l;break}}while(0);return}function Rt(a,b){a=a|0;b=b|0;return Ot(a,b,Vh(b)|0)|0}function St(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;g=b+11|0;f=a[g>>0]|0;h=f<<24>>24<0;if(h)f=c[b+4>>2]|0;else f=f&255;do if(f>>>0>=d>>>0)if(h){a[(c[b>>2]|0)+d>>0]=0;c[b+4>>2]=d;break}else{a[b+d>>0]=0;a[g>>0]=d;break}else Tt(b,d-f|0,e)|0;while(0);return}function Tt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;if(d|0){i=b+11|0;f=a[i>>0]|0;if(f<<24>>24<0){h=c[b+4>>2]|0;g=(c[b+8>>2]&2147483647)+-1|0}else{h=f&255;g=10}if((g-h|0)>>>0<d>>>0){Ut(b,g,d-g+h|0,h,h,0,0);f=a[i>>0]|0}if(f<<24>>24<0)g=c[b>>2]|0;else g=b;Wu(g+h|0,e|0,d|0)|0;f=h+d|0;if((a[i>>0]|0)<0)c[b+4>>2]=f;else a[i>>0]=f;a[g+f>>0]=0}return b|0}function Ut(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0;if((-17-d|0)>>>0<e>>>0)Gt(b);if((a[b+11>>0]|0)<0)l=c[b>>2]|0;else l=b;if(d>>>0<2147483623){j=e+d|0;k=d<<1;j=j>>>0<k>>>0?k:j;j=j>>>0<11?11:j+16&-16}else j=-17;k=At(j)|0;if(g|0)cv(k|0,l|0,g|0)|0;e=f-h-g|0;if(e|0)cv(k+g+i|0,l+g+h|0,e|0)|0;if((d|0)!=10)Dt(l);c[b>>2]=k;c[b+8>>2]=j|-2147483648;return}function Vt(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;i=b+11|0;f=a[i>>0]|0;g=f<<24>>24<0;if(g){h=c[b+4>>2]|0;f=(c[b+8>>2]&2147483647)+-1|0}else{h=f&255;f=10}if((f-h|0)>>>0>=e>>>0){if(e|0){if(g)g=c[b>>2]|0;else g=b;cv(g+h|0,d|0,e|0)|0;f=h+e|0;if((a[i>>0]|0)<0)c[b+4>>2]=f;else a[i>>0]=f;a[g+f>>0]=0}}else Pt(b,f,e-f+h|0,h,h,0,e,d);return b|0}function Wt(a,b){a=a|0;b=b|0;return Vt(a,b,Vh(b)|0)|0}function Xt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=b+11|0;e=a[h>>0]|0;f=e<<24>>24<0;if(f){g=c[b+4>>2]|0;e=(c[b+8>>2]&2147483647)+-1|0}else{g=e&255;e=10}if((g|0)==(e|0)){Ut(b,e,1,e,e,0,0);if((a[h>>0]|0)>-1)e=7;else e=8}else if(f)e=8;else e=7;if((e|0)==7)a[h>>0]=g+1;else if((e|0)==8){h=c[b>>2]|0;c[b+4>>2]=g+1;b=h}h=b+g|0;a[h>>0]=d;a[h+1>>0]=0;return}function Yt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;k=b+11|0;g=a[k>>0]|0;h=g<<24>>24<0;if(h)j=c[b+4>>2]|0;else j=g&255;if(j>>>0<d>>>0)Ht(b);if(h)g=(c[b+8>>2]&2147483647)+-1|0;else g=10;if((g-j|0)>>>0>=f>>>0){if(f|0){if(h)i=c[b>>2]|0;else i=b;h=j-d|0;g=i+d|0;if(h){hv(g+f|0,g|0,h|0)|0;e=g>>>0<=e>>>0&(i+j|0)>>>0>e>>>0?e+f|0:e}hv(g|0,e|0,f|0)|0;e=j+f|0;if((a[k>>0]|0)<0)c[b+4>>2]=e;else a[k>>0]=e;a[i+e>>0]=0}}else Pt(b,g,j+f-g|0,j,d,0,f,e);return b|0}function Zt(a,b,c){a=a|0;b=b|0;c=c|0;return Yt(a,b,c,Vh(c)|0)|0}function _t(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;h=l;l=l+16|0;g=h;f=a[b+11>>0]|0;if(f<<24>>24<0){f=c[b+4>>2]|0;b=c[b>>2]|0}else f=f&255;a[g>>0]=d;if(f>>>0>e>>>0){g=$t(b+e|0,f-e|0,g)|0;b=(g|0)==0?-1:g-b|0}else b=-1;l=h;return b|0}function $t(a,b,c){a=a|0;b=b|0;c=c|0;if(!b)a=0;else a=di(a,d[c>>0]|0,b)|0;return a|0}function au(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;h=a[b+11>>0]|0;i=h<<24>>24<0;if(i)h=c[b+4>>2]|0;else h=h&255;if((g|0)==-1|h>>>0<d>>>0)Ht(b);h=h-d|0;e=h>>>0<e>>>0?h:e;if(i)b=c[b>>2]|0;h=e>>>0>g>>>0;b=st(b+d|0,f,h?g:e)|0;if(!b)return (e>>>0<g>>>0?-1:h&1)|0;else return b|0;return 0}function bu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;if(f>>>0>4294967279)Gt(b);if(f>>>0<11)a[b+11>>0]=e;else{g=f+16&-16;f=At(g)|0;c[b>>2]=f;c[b+8>>2]=g|-2147483648;c[b+4>>2]=e;b=f}if(e|0)cv(b|0,d|0,e|0)|0;a[b+e>>0]=0;return}function cu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(e>>>0>1073741807)Gt(b);do if(e>>>0>=2){g=e+4&-4;if(g>>>0>1073741823)Aa(28159,28196,1734,28282);else{f=At(g<<2)|0;c[b>>2]=f;c[b+8>>2]=g|-2147483648;c[b+4>>2]=e;break}}else{a[b+8+3>>0]=e;f=b}while(0);tk(f,d,e)|0;c[f+(e<<2)>>2]=0;return}function du(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;if(d>>>0>1073741807)Gt(b);do if(d>>>0>=2){g=d+4&-4;if(g>>>0>1073741823)Aa(28159,28196,1734,28282);else{f=At(g<<2)|0;c[b>>2]=f;c[b+8>>2]=g|-2147483648;c[b+4>>2]=d;break}}else{a[b+8+3>>0]=d;f=b}while(0);eu(f,d,e)|0;c[f+(d<<2)>>2]=0;return}function eu(a,b,c){a=a|0;b=b|0;c=c|0;if(b)a=Dj(a,c,b)|0;return a|0}function fu(b){b=b|0;if((a[b+8+3>>0]|0)<0)Dt(c[b>>2]|0);return}function gu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0,j=0;f=b+8|0;j=f+3|0;g=a[j>>0]|0;h=g<<24>>24<0;if(h)i=(c[f>>2]&2147483647)+-1|0;else i=1;do if(i>>>0>=e>>>0){if(h)f=c[b>>2]|0;else f=b;hu(f,d,e)|0;c[f+(e<<2)>>2]=0;if((a[j>>0]|0)<0){c[b+4>>2]=e;break}else{a[j>>0]=e;break}}else{if(h)f=c[b+4>>2]|0;else f=g&255;iu(b,i,e-i|0,f,0,f,e,d)}while(0);return b|0}function hu(a,b,c){a=a|0;b=b|0;c=c|0;if(c)a=Ej(a,b,c)|0;return a|0}function iu(b,d,e,f,g,h,i,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;var k=0,l=0,m=0,n=0;if((1073741806-d|0)>>>0<e>>>0)Gt(b);l=b+8|0;if((a[l+3>>0]|0)<0)n=c[b>>2]|0;else n=b;if(d>>>0<536870887){e=e+d|0;k=d<<1;e=e>>>0<k>>>0?k:e;e=e>>>0<2?2:e+4&-4;if(e>>>0>1073741823)Aa(28159,28196,1734,28282);else m=e}else m=1073741807;k=At(m<<2)|0;if(g|0)tk(k,n,g)|0;if(i|0)tk(k+(g<<2)|0,j,i)|0;e=f-h|0;f=e-g|0;if(f|0)tk(k+(g<<2)+(i<<2)|0,n+(g<<2)+(h<<2)|0,f)|0;if((d|0)!=1)Dt(n);c[b>>2]=k;c[l>>2]=m|-2147483648;i=e+i|0;c[b+4>>2]=i;c[k+(i<<2)>>2]=0;return}function ju(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0,k=0;if(d>>>0>1073741807)Gt(b);k=b+8|0;i=k+3|0;f=a[i>>0]|0;g=f<<24>>24<0;if(g){j=c[b+4>>2]|0;e=(c[k>>2]&2147483647)+-1|0}else{j=f&255;e=1}h=j>>>0>d>>>0?j:d;d=h>>>0<2;h=d?1:(h+4&-4)+-1|0;do if((h|0)!=(e|0)){do if(d){d=c[b>>2]|0;if(g){g=0;e=d;d=b;f=15}else{tk(b,d,(f&255)+1|0)|0;Dt(d);f=17}}else{d=h+1|0;if(d>>>0>1073741823)Aa(28159,28196,1734,28282);d=At(d<<2)|0;if(g){g=1;e=c[b>>2]|0;f=15;break}else{tk(d,b,(f&255)+1|0)|0;f=16;break}}while(0);if((f|0)==15){tk(d,e,(c[b+4>>2]|0)+1|0)|0;Dt(e);if(g)f=16;else f=17}if((f|0)==16){c[k>>2]=h+1|-2147483648;c[b+4>>2]=j;c[b>>2]=d;break}else if((f|0)==17){a[i>>0]=j;break}}while(0);return}function ku(a,b){a=a|0;b=b|0;return gu(a,b,oi(b)|0)|0}function lu(b,d,e,f,g,h,i){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0;if((1073741807-d|0)>>>0<e>>>0)Gt(b);m=b+8|0;if((a[m+3>>0]|0)<0)l=c[b>>2]|0;else l=b;if(d>>>0<536870887){e=e+d|0;j=d<<1;e=e>>>0<j>>>0?j:e;e=e>>>0<2?2:e+4&-4;if(e>>>0>1073741823)Aa(28159,28196,1734,28282);else k=e}else k=1073741807;j=At(k<<2)|0;if(g|0)tk(j,l,g)|0;e=f-h-g|0;if(e|0)tk(j+(g<<2)+(i<<2)|0,l+(g<<2)+(h<<2)|0,e)|0;if((d|0)!=1)Dt(l);c[b>>2]=j;c[m>>2]=k|-2147483648;return}function mu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;f=b+8|0;i=f+3|0;e=a[i>>0]|0;g=e<<24>>24<0;if(g){h=c[b+4>>2]|0;e=(c[f>>2]&2147483647)+-1|0}else{h=e&255;e=1}if((h|0)==(e|0)){lu(b,e,1,e,e,0,0);if((a[i>>0]|0)>-1)e=7;else e=8}else if(g)e=8;else e=7;if((e|0)==7)a[i>>0]=h+1;else if((e|0)==8){i=c[b>>2]|0;c[b+4>>2]=h+1;b=i}i=b+(h<<2)|0;c[i>>2]=d;c[i+4>>2]=0;return}function nu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=l;l=l+16|0;f=e;c[f>>2]=0;c[f+4>>2]=0;c[f+8>>2]=0;Jt(f,28291,4);d=ou(f,a,b,d)|0;Mt(f);l=e;return d|0}function ou(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0;i=l;l=l+16|0;g=i;c[g>>2]=0;h=(a[d+11>>0]|0)<0?c[d>>2]|0:d;j=Oh()|0;k=c[j>>2]|0;c[j>>2]=0;f=qi(h,g,f)|0;d=c[j>>2]|0;c[j>>2]=k;if((d|0)==34)pu(b);d=c[g>>2]|0;if((d|0)==(h|0))qu(b);if(e|0)c[e>>2]=d-h;l=i;return f|0}function pu(b){b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;e=e+4|0;ru(e,b,28316);b=c[3156]|0;c[d>>2]=(a[e+11>>0]|0)<0?c[e>>2]|0:e;Qi(b,28312,d)|0;ya()}function qu(b){b=b|0;var d=0,e=0;e=l;l=l+16|0;d=e;e=e+4|0;ru(e,b,28296);b=c[3156]|0;c[d>>2]=(a[e+11>>0]|0)<0?c[e>>2]|0:e;Qi(b,28312,d)|0;ya()}function ru(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;f=0;while(1){if((f|0)==3)break;c[b+(f<<2)>>2]=0;f=f+1|0}g=a[d+11>>0]|0;h=g<<24>>24<0;g=h?c[d+4>>2]|0:g&255;f=Vh(e)|0;bu(b,h?c[d>>2]|0:d,g,g+f|0);Vt(b,e,f)|0;return}function su(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=l;l=l+16|0;h=j;i=j+4|0;c[i>>2]=0;c[i+4>>2]=0;c[i+8>>2]=0;e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}g=i+11|0;if((a[g>>0]|0)<0)e=(c[i+8>>2]&2147483647)+-1|0;else e=10;St(i,e,0);f=a[g>>0]|0;e=f<<24>>24<0?c[i+4>>2]|0:f&255;while(1){f=f<<24>>24<0?c[i>>2]|0:i;c[h>>2]=d;f=Wh(f,e+1|0,28331,h)|0;if((f|0)>-1)if(f>>>0>e>>>0)e=f;else break;else e=e<<1|1;St(i,e,0);f=a[g>>0]|0}St(i,f,0);c[b>>2]=c[i>>2];c[b+4>>2]=c[i+4>>2];c[b+8>>2]=c[i+8>>2];e=0;while(1){if((e|0)==3)break;c[i+(e<<2)>>2]=0;e=e+1|0}Mt(i);l=j;return}function tu(a,b){a=a|0;b=b|0;return}function uu(a){a=a|0;return}function vu(a){a=a|0;Dt(a);return}function wu(a){a=a|0;return}function xu(a){a=a|0;return}function yu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;h=l;l=l+64|0;f=h;if((a|0)!=(b|0))if((b|0)!=0?(g=Eu(b,1432,1416,0)|0,(g|0)!=0):0){b=f+4|0;e=b+52|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(e|0));c[f>>2]=g;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;pb[c[(c[g>>2]|0)+28>>2]&15](g,f,c[d>>2]|0,1);if((c[f+24>>2]|0)==1){c[d>>2]=c[f+16>>2];b=1}else b=0}else b=0;else b=1;l=h;return b|0}function zu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))Du(0,b,d,e,f);return}function Au(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(h=d+28|0,(c[h>>2]|0)!=1):0)c[h>>2]=f}else if((b|0)==(c[d>>2]|0)){if((c[d+16>>2]|0)!=(e|0)?(i=d+20|0,(c[i>>2]|0)!=(e|0)):0){c[d+32>>2]=f;c[i>>2]=e;g=d+40|0;c[g>>2]=(c[g>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0)a[d+54>>0]=1;c[d+44>>2]=4;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function Bu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))Cu(0,b,d,e);return}function Cu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0;b=d+16|0;g=c[b>>2]|0;do if(g){if((g|0)!=(e|0)){f=d+36|0;c[f>>2]=(c[f>>2]|0)+1;c[d+24>>2]=2;a[d+54>>0]=1;break}b=d+24|0;if((c[b>>2]|0)==2)c[b>>2]=f}else{c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1}while(0);return}function Du(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;a[d+53>>0]=1;do if((c[d+4>>2]|0)==(f|0)){a[d+52>>0]=1;b=d+16|0;f=c[b>>2]|0;if(!f){c[b>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((g|0)==1?(c[d+48>>2]|0)==1:0))break;a[d+54>>0]=1;break}if((f|0)!=(e|0)){g=d+36|0;c[g>>2]=(c[g>>2]|0)+1;a[d+54>>0]=1;break}f=d+24|0;b=c[f>>2]|0;if((b|0)==2){c[f>>2]=g;b=g}if((b|0)==1?(c[d+48>>2]|0)==1:0)a[d+54>>0]=1}while(0);return}function Eu(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,m=0,n=0,o=0,p=0,q=0,r=0;r=l;l=l+64|0;p=r;o=c[d>>2]|0;q=d+(c[o+-8>>2]|0)|0;o=c[o+-4>>2]|0;c[p>>2]=f;c[p+4>>2]=d;c[p+8>>2]=e;c[p+12>>2]=g;d=p+16|0;e=p+20|0;g=p+24|0;h=p+28|0;i=p+32|0;j=p+40|0;k=(o|0)==(f|0);m=d;n=m+36|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));b[d+36>>1]=0;a[d+38>>0]=0;a:do if(k){c[p+48>>2]=1;mb[c[(c[f>>2]|0)+20>>2]&15](f,p,q,q,1,0);d=(c[g>>2]|0)==1?q:0}else{bb[c[(c[o>>2]|0)+24>>2]&3](o,p,q,1,0);switch(c[p+36>>2]|0){case 0:{d=(c[j>>2]|0)==1&(c[h>>2]|0)==1&(c[i>>2]|0)==1?c[e>>2]|0:0;break a}case 1:break;default:{d=0;break a}}if((c[g>>2]|0)!=1?!((c[j>>2]|0)==0&(c[h>>2]|0)==1&(c[i>>2]|0)==1):0){d=0;break}d=c[d>>2]|0}while(0);l=r;return d|0}function Fu(a){a=a|0;Dt(a);return}function Gu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;if((a|0)==(c[b+8>>2]|0))Du(0,b,d,e,f);else{a=c[a+8>>2]|0;mb[c[(c[a>>2]|0)+20>>2]&15](a,b,d,e,f,g)}return}function Hu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0;do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(h=d+28|0,(c[h>>2]|0)!=1):0)c[h>>2]=f}else{if((b|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;bb[c[(c[j>>2]|0)+24>>2]&3](j,d,e,f,g);break}if((c[d+16>>2]|0)!=(e|0)?(j=d+20|0,(c[j>>2]|0)!=(e|0)):0){c[d+32>>2]=f;i=d+44|0;if((c[i>>2]|0)==4)break;h=d+52|0;a[h>>0]=0;f=d+53|0;a[f>>0]=0;b=c[b+8>>2]|0;mb[c[(c[b>>2]|0)+20>>2]&15](b,d,e,e,1,g);if(a[f>>0]|0)if(!(a[h>>0]|0)){h=1;f=13}else f=17;else{h=0;f=13}do if((f|0)==13){c[j>>2]=e;e=d+40|0;c[e>>2]=(c[e>>2]|0)+1;if((c[d+36>>2]|0)==1?(c[d+24>>2]|0)==2:0){a[d+54>>0]=1;if(h){f=17;break}else{h=4;break}}if(h)f=17;else h=4}while(0);if((f|0)==17)h=3;c[i>>2]=h;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function Iu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;if((a|0)==(c[b+8>>2]|0))Cu(0,b,d,e);else{a=c[a+8>>2]|0;pb[c[(c[a>>2]|0)+28>>2]&15](a,b,d,e)}return}function Ju(a){a=a|0;return}function Ku(a){a=a|0;Dt(a);return}function Lu(d,e,f,g,h,i){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;if((d|0)==(c[e+8>>2]|0))Du(0,e,f,g,h);else{r=e+52|0;m=b[r>>1]|0;k=m&255;l=e+53|0;m=(m&65535)>>>8&255;q=c[d+12>>2]|0;n=d+16+(q<<3)|0;a[r>>0]=0;a[l>>0]=0;Pu(d+16|0,e,f,g,h,i);a:do if((q|0)>1){o=e+24|0;p=d+8|0;q=e+54|0;d=d+24|0;do{if(a[q>>0]|0)break a;j=b[r>>1]|0;if(!((j&255)<<24>>24)){if((j&65535)>=256?(c[p>>2]&1|0)==0:0)break a}else{if((c[o>>2]|0)==1)break a;if(!(c[p>>2]&2))break a}a[r>>0]=0;a[l>>0]=0;Pu(d,e,f,g,h,i);d=d+8|0}while(d>>>0<n>>>0)}while(0);a[r>>0]=k;a[l>>0]=m}return}function Mu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;a:do if((b|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)==(e|0)?(h=d+28|0,(c[h>>2]|0)!=1):0)c[h>>2]=f}else{if((b|0)!=(c[d>>2]|0)){q=c[b+12>>2]|0;j=b+16+(q<<3)|0;Qu(b+16|0,d,e,f,g);h=b+24|0;if((q|0)<=1)break;b=c[b+8>>2]|0;if((b&2|0)==0?(k=d+36|0,(c[k>>2]|0)!=1):0){if(!(b&1)){b=d+54|0;while(1){if(a[b>>0]|0)break a;if((c[k>>2]|0)==1)break a;Qu(h,d,e,f,g);h=h+8|0;if(h>>>0>=j>>>0)break a}}b=d+24|0;i=d+54|0;while(1){if(a[i>>0]|0)break a;if((c[k>>2]|0)==1?(c[b>>2]|0)==1:0)break a;Qu(h,d,e,f,g);h=h+8|0;if(h>>>0>=j>>>0)break a}}b=d+54|0;while(1){if(a[b>>0]|0)break a;Qu(h,d,e,f,g);h=h+8|0;if(h>>>0>=j>>>0)break a}}if((c[d+16>>2]|0)!=(e|0)?(q=d+20|0,(c[q>>2]|0)!=(e|0)):0){c[d+32>>2]=f;p=d+44|0;if((c[p>>2]|0)==4)break;k=b+16+(c[b+12>>2]<<3)|0;f=d+52|0;l=d+53|0;n=d+54|0;m=b+8|0;o=d+24|0;h=0;i=b+16|0;j=0;b:while(1){if(i>>>0>=k>>>0){b=20;break}a[f>>0]=0;a[l>>0]=0;Pu(i,d,e,e,1,g);if(a[n>>0]|0){b=20;break}do if(a[l>>0]|0){if(!(a[f>>0]|0))if(!(c[m>>2]&1)){h=1;b=20;break b}else{h=1;b=j;break}if((c[o>>2]|0)==1){b=25;break b}if(!(c[m>>2]&2)){b=25;break b}else{h=1;b=1}}else b=j;while(0);i=i+8|0;j=b}do if((b|0)==20){if((!j?(c[q>>2]=e,e=d+40|0,c[e>>2]=(c[e>>2]|0)+1,(c[d+36>>2]|0)==1):0)?(c[o>>2]|0)==2:0){a[n>>0]=1;if(h){b=25;break}else{h=4;break}}if(h)b=25;else h=4}while(0);if((b|0)==25)h=3;c[p>>2]=h;break}if((f|0)==1)c[d+32>>2]=1}while(0);return}function Nu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;a:do if((b|0)!=(c[d+8>>2]|0)){h=c[b+12>>2]|0;g=b+16+(h<<3)|0;Ou(b+16|0,d,e,f);if((h|0)>1){h=d+54|0;b=b+24|0;do{Ou(b,d,e,f);if(a[h>>0]|0)break a;b=b+8|0}while(b>>>0<g>>>0)}}else Cu(0,d,e,f);while(0);return}function Ou(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=c[a+4>>2]|0;f=g>>8;if(g&1)f=c[(c[d>>2]|0)+f>>2]|0;a=c[a>>2]|0;pb[c[(c[a>>2]|0)+28>>2]&15](a,b,d+f|0,g&2|0?e:2);return}function Pu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,i=0;i=c[a+4>>2]|0;h=i>>8;if(i&1)h=c[(c[e>>2]|0)+h>>2]|0;a=c[a>>2]|0;mb[c[(c[a>>2]|0)+20>>2]&15](a,b,d,e+h|0,i&2|0?f:2,g);return}function Qu(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;h=c[a+4>>2]|0;g=h>>8;if(h&1)g=c[(c[d>>2]|0)+g>>2]|0;a=c[a>>2]|0;bb[c[(c[a>>2]|0)+24>>2]&3](a,b,d+g|0,h&2|0?e:2,f);return}function Ru(b){b=b|0;if((a[b>>0]|0)==1)b=0;else{a[b>>0]=1;b=1}return b|0}function Su(a){a=a|0;return}function Tu(){var a=0;a=c[291886]|0;c[291886]=a+0;return a|0}function Uu(){}function Vu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=b-d-(c>>>0>a>>>0|0)>>>0;return (D=d,a-c>>>0|0)|0}function Wu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;h=b+e|0;d=d&255;if((e|0)>=67){while(b&3){a[b>>0]=d;b=b+1|0}f=h&-4|0;g=f-64|0;i=d|d<<8|d<<16|d<<24;while((b|0)<=(g|0)){c[b>>2]=i;c[b+4>>2]=i;c[b+8>>2]=i;c[b+12>>2]=i;c[b+16>>2]=i;c[b+20>>2]=i;c[b+24>>2]=i;c[b+28>>2]=i;c[b+32>>2]=i;c[b+36>>2]=i;c[b+40>>2]=i;c[b+44>>2]=i;c[b+48>>2]=i;c[b+52>>2]=i;c[b+56>>2]=i;c[b+60>>2]=i;b=b+64|0}while((b|0)<(f|0)){c[b>>2]=i;b=b+4|0}}while((b|0)<(h|0)){a[b>>0]=d;b=b+1|0}return h-e|0}function Xu(a){a=a|0;return 0}function Yu(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;c=a+c>>>0;return (D=b+d+(c>>>0<a>>>0|0)>>>0,c|0)|0}function Zu(b){b=b|0;var c=0;c=a[n+(b&255)>>0]|0;if((c|0)<8)return c|0;c=a[n+(b>>8&255)>>0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>16&255)>>0]|0;if((c|0)<8)return c+16|0;return (a[n+(b>>>24)>>0]|0)+24|0}function _u(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;l=a;j=b;k=j;h=d;n=e;i=n;if(!k){g=(f|0)!=0;if(!i){if(g){c[f>>2]=(l>>>0)%(h>>>0);c[f+4>>2]=0}n=0;f=(l>>>0)/(h>>>0)>>>0;return (D=n,f)|0}else{if(!g){n=0;f=0;return (D=n,f)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;f=0;return (D=n,f)|0}}g=(i|0)==0;do if(h){if(!g){g=(V(i|0)|0)-(V(k|0)|0)|0;if(g>>>0<=31){m=g+1|0;i=31-g|0;b=g-31>>31;h=m;a=l>>>(m>>>0)&b|k<<i;b=k>>>(m>>>0)&b;g=0;i=l<<i;break}if(!f){n=0;f=0;return (D=n,f)|0}c[f>>2]=a|0;c[f+4>>2]=j|b&0;n=0;f=0;return (D=n,f)|0}g=h-1|0;if(g&h|0){i=(V(h|0)|0)+33-(V(k|0)|0)|0;p=64-i|0;m=32-i|0;j=m>>31;o=i-32|0;b=o>>31;h=i;a=m-1>>31&k>>>(o>>>0)|(k<<m|l>>>(i>>>0))&b;b=b&k>>>(i>>>0);g=l<<p&j;i=(k<<p|l>>>(o>>>0))&j|l<<m&i-33>>31;break}if(f|0){c[f>>2]=g&l;c[f+4>>2]=0}if((h|0)==1){o=j|b&0;p=a|0|0;return (D=o,p)|0}else{p=Zu(h|0)|0;o=k>>>(p>>>0)|0;p=k<<32-p|l>>>(p>>>0)|0;return (D=o,p)|0}}else{if(g){if(f|0){c[f>>2]=(k>>>0)%(h>>>0);c[f+4>>2]=0}o=0;p=(k>>>0)/(h>>>0)>>>0;return (D=o,p)|0}if(!l){if(f|0){c[f>>2]=0;c[f+4>>2]=(k>>>0)%(i>>>0)}o=0;p=(k>>>0)/(i>>>0)>>>0;return (D=o,p)|0}g=i-1|0;if(!(g&i)){if(f|0){c[f>>2]=a|0;c[f+4>>2]=g&k|b&0}o=0;p=k>>>((Zu(i|0)|0)>>>0);return (D=o,p)|0}g=(V(i|0)|0)-(V(k|0)|0)|0;if(g>>>0<=30){b=g+1|0;i=31-g|0;h=b;a=k<<i|l>>>(b>>>0);b=k>>>(b>>>0);g=0;i=l<<i;break}if(!f){o=0;p=0;return (D=o,p)|0}c[f>>2]=a|0;c[f+4>>2]=j|b&0;o=0;p=0;return (D=o,p)|0}while(0);if(!h){k=i;j=0;i=0}else{m=d|0|0;l=n|e&0;k=Yu(m|0,l|0,-1,-1)|0;d=D;j=i;i=0;do{e=j;j=g>>>31|j<<1;g=i|g<<1;e=a<<1|e>>>31|0;n=a>>>31|b<<1|0;Vu(k|0,d|0,e|0,n|0)|0;p=D;o=p>>31|((p|0)<0?-1:0)<<1;i=o&1;a=Vu(e|0,n|0,o&m|0,(((p|0)<0?-1:0)>>31|((p|0)<0?-1:0)<<1)&l|0)|0;b=D;h=h-1|0}while((h|0)!=0);k=j;j=0}h=0;if(f|0){c[f>>2]=a;c[f+4>>2]=b}o=(g|0)>>>31|(k|h)<<1|(h<<1|g>>>31)&0|j;p=(g<<1|0>>>31)&-2|i;return (D=o,p)|0}function $u(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0,j=0;j=b>>31|((b|0)<0?-1:0)<<1;i=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;f=d>>31|((d|0)<0?-1:0)<<1;e=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;h=Vu(j^a|0,i^b|0,j|0,i|0)|0;g=D;a=f^j;b=e^i;return Vu((_u(h,g,Vu(f^c|0,e^d|0,f|0,e|0)|0,D,0)|0)^a|0,D^b|0,a|0,b|0)|0}function av(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}D=0;return b>>>c-32|0}function bv(a){a=a|0;return 0}function cv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;if((e|0)>=8192)return Fa(b|0,d|0,e|0)|0;h=b|0;g=b+e|0;if((b&3)==(d&3)){while(b&3){if(!e)return h|0;a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0;e=e-1|0}e=g&-4|0;f=e-64|0;while((b|0)<=(f|0)){c[b>>2]=c[d>>2];c[b+4>>2]=c[d+4>>2];c[b+8>>2]=c[d+8>>2];c[b+12>>2]=c[d+12>>2];c[b+16>>2]=c[d+16>>2];c[b+20>>2]=c[d+20>>2];c[b+24>>2]=c[d+24>>2];c[b+28>>2]=c[d+28>>2];c[b+32>>2]=c[d+32>>2];c[b+36>>2]=c[d+36>>2];c[b+40>>2]=c[d+40>>2];c[b+44>>2]=c[d+44>>2];c[b+48>>2]=c[d+48>>2];c[b+52>>2]=c[d+52>>2];c[b+56>>2]=c[d+56>>2];c[b+60>>2]=c[d+60>>2];b=b+64|0;d=d+64|0}while((b|0)<(e|0)){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0}}else{e=g-4|0;while((b|0)<(e|0)){a[b>>0]=a[d>>0]|0;a[b+1>>0]=a[d+1>>0]|0;a[b+2>>0]=a[d+2>>0]|0;a[b+3>>0]=a[d+3>>0]|0;b=b+4|0;d=d+4|0}}while((b|0)<(g|0)){a[b>>0]=a[d>>0]|0;b=b+1|0;d=d+1|0}return h|0}function dv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return _u(a,b,c,d,0)|0}function ev(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;f=a&65535;e=b&65535;c=S(e,f)|0;d=a>>>16;a=(c>>>16)+(S(e,d)|0)|0;e=b>>>16;b=S(e,f)|0;return (D=(a>>>16)+(S(e,d)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|c&65535|0)|0}function fv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;f=c;c=ev(e,f)|0;a=D;return (D=(S(b,f)|0)+(S(d,e)|0)+a|a&0,c|0|0)|0}function gv(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){D=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}D=a<<c-32;return 0}function hv(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b>>0]=a[c>>0]|0}b=e}else cv(b,c,d)|0;return b|0}function iv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;g=l;l=l+16|0;f=g|0;_u(a,b,d,e,f)|0;l=g;return (D=c[f+4>>2]|0,c[f>>2]|0)|0}function jv(a){a=a|0;return 0}function kv(a){a=a|0;var b=0,d=0;d=a+15&-16|0;b=c[i>>2]|0;a=b+d|0;if((d|0)>0&(a|0)<(b|0)|(a|0)<0){_()|0;za(12);return -1}c[i>>2]=a;if((a|0)>(Z()|0)?(Y()|0)==0:0){za(12);c[i>>2]=b;return -1}return b|0}function lv(){return 0}function mv(a){a=+a;return a>=0.0?+E(a+.5):+R(a-.5)}function nv(a,b,c){a=a|0;b=b|0;c=c|0;b=V(b)|0;if((b|0)==32)b=b+(V(a)|0)|0;D=0;return b|0}function ov(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return $a[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function pv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ab[a&31](b|0,c|0,d|0)|0}function qv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;bb[a&3](b|0,c|0,d|0,e|0,f|0)}function rv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;return cb[a&3](b|0,c|0,d|0,e|0,f|0,+g)|0}function sv(a,b){a=a|0;b=b|0;db[a&255](b|0)}function tv(a,b,c){a=a|0;b=b|0;c=c|0;eb[a&63](b|0,c|0)}function uv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;return fb[a&63](b|0,c|0,d|0,e|0,f|0,g|0)|0}function vv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;return gb[a&7](b|0,c|0,d|0,e|0,+f)|0}function wv(a,b){a=a|0;b=b|0;return hb[a&127](b|0)|0}function xv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ib[a&0](b|0,c|0,d|0)}function yv(a){a=a|0;jb[a&0]()}function zv(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return kb[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function Av(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return lb[a&7](b|0,c|0,d|0,e|0)|0}function Bv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;mb[a&15](b|0,c|0,d|0,e|0,f|0,g|0)}function Cv(a,b,c){a=a|0;b=b|0;c=c|0;return nb[a&63](b|0,c|0)|0}function Dv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ob[a&31](b|0,c|0,d|0,e|0,f|0)|0}function Ev(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;pb[a&15](b|0,c|0,d|0,e|0)}function Fv(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;W(0);return 0}function Gv(a,b,c){a=a|0;b=b|0;c=c|0;W(1);return 0}function Hv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;W(2)}function Iv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;W(3);return 0}function Jv(a){a=a|0;W(4)}function Kv(a,b){a=a|0;b=b|0;W(5)}function Lv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;W(6);return 0}function Mv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;W(7);return 0}function Nv(a){a=a|0;W(8);return 0}function Ov(a,b,c){a=a|0;b=b|0;c=c|0;W(9)}function Pv(){W(10)}function Qv(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;W(11);return 0}function Rv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;W(12);return 0}function Sv(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;W(13)}function Tv(a,b){a=a|0;b=b|0;W(14);return 0}function Uv(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;W(15);return 0}function Vv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;W(16)}

// EMSCRIPTEN_END_FUNCS
var $a=[Fv,hp,mp,gq,hq,qq,rq,Fv];var ab=[Gv,Wj,$j,dk,Be,Lh,Mh,Rh,Sh,ki,ik,nk,rk,ul,zl,Sl,Yl,Kq,Pq,Jr,Lr,Or,es,js,ls,os,yu,Db,Fb,Yi,Gv,Gv];var bb=[Hv,Au,Hu,Mu];var cb=[Iv,yq,Eq,Iv];var db=[Jv,ec,fc,ic,lc,oc,rc,uc,xc,yc,Bc,Ec,Hc,Kc,Nc,Qc,Tc,Wc,Zc,ad,dd,gd,jd,md,pd,Ud,Vd,Wd,Xd,Yd,Zd,uk,vk,wk,xk,Nd,Od,Kk,Lk,Mk,Nk,Ok,Pk,me,ke,ie,ge,ee,ce,Ck,Dk,Ek,Fk,Me,Ne,Oe,Pe,Tj,He,xe,ze,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Mg,fg,gg,Ng,ig,Qj,Sj,Uj,fk,gk,yk,zk,Ak,Bk,Gk,Hk,Ik,Jk,rl,wl,Cl,Il,Nl,Ol,Pl,Ul,Vl,_l,$l,Qm,Rm,qn,rn,Hn,In,Un,Vn,Ao,Bo,fp,gp,kp,lp,op,pp,zp,Ap,Kp,Lp,Vp,Wp,eq,fq,oq,pq,wq,xq,Cq,Dq,Iq,Jq,Nq,Oq,Sq,cr,Tq,rr,sr,Dr,Er,Gr,Hr,Qr,Rr,Xr,Yr,cs,ds,qs,rs,ss,uu,vu,wu,xu,Fu,Ku,jg,og,yh,Ah,wh,vh,Ph,Th,qm,rm,iq,Gj,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv,Jv];var eb=[Kv,Vj,Ae,hk,sl,xl,Bl,Hl,sp,tp,up,vp,xp,yp,Dp,Ep,Fp,Gp,Ip,Jp,Op,Pp,Qp,Rp,Tp,Up,Zp,_p,$p,aq,cq,dq,Mq,Rq,Ur,Vr,Wr,$r,as,bs,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv,Kv];var fb=[Lv,am,bm,cm,dm,em,fm,gm,hm,im,jm,km,Sm,Tm,Um,Vm,Wm,Xm,Ym,Zm,_m,$m,an,un,wn,Ln,Nn,Xn,Yn,Zn,_n,$n,Do,Eo,Fo,Go,Ho,zq,Fq,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv,Lv];var gb=[Mv,xn,yn,On,Pn,Mv,Mv,Mv];var hb=[Nv,gc,jc,mc,pc,sc,vc,zc,Cc,Fc,Ic,Lc,Oc,Rc,Uc,Xc,_c,bd,ed,hd,kd,nd,qd,Zj,_j,Rd,bk,ne,le,je,he,fe,de,Ie,Je,Ke,ye,Ee,Kh,ak,lk,mk,ok,pk,tl,yl,Dl,El,Jl,Kl,Wn,bo,co,eo,fo,go,ho,io,Co,Jo,Ko,Lo,Mo,No,Oo,Po,qp,rp,wp,Bp,Cp,Hp,Mp,Np,Sp,Xp,Yp,bq,Xq,Yq,_q,nr,or,qr,Sr,Tr,Zr,_r,gr,hr,jr,wr,xr,zr,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv,Nv];var ib=[Ov];var jb=[Pv];var kb=[Qv,ao,Io,Uq,Vq,kr,lr,dr,er,tr,ur,Qv,Qv,Qv,Qv,Qv];var lb=[Rv,Nr,fs,gs,hs,ns,Rv,Rv];var mb=[Sv,Pd,Xj,Ce,jk,Lq,Qq,zu,Gu,Lu,Sv,Sv,Sv,Sv,Sv,Sv];var nb=[Tv,hc,kc,nc,qc,tc,wc,Ac,Dc,Gc,Jc,Mc,Pc,Sc,Vc,Yc,$c,cd,fd,id,ld,od,rd,Sd,Td,sd,xd,td,ud,vd,wd,ck,Le,Fe,Ge,ek,qk,sk,vl,Al,Fl,Ll,Ir,Kr,Mr,is,ks,ms,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv,Tv];var ob=[Uv,Ql,Wl,sn,tn,vn,zn,Jn,Kn,Mn,Qn,Wq,Zq,mr,pr,Pr,ps,fr,ir,vr,yr,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv,Uv];var pb=[Vv,Qd,Yj,De,kk,Rl,Xl,Bu,Iu,Nu,Vv,Vv,Vv,Vv,Vv,Vv];return{_main:$d,_uci_command:mh,___udivdi3:dv,_bitshift64Lshr:av,___udivmoddi4:_u,_bitshift64Shl:gv,_llvm_ctlz_i64:nv,_llvm_cttz_i32:Zu,_sbrk:kv,_memcpy:cv,___muldi3:fv,___uremdi3:iv,___divdi3:$u,_i64Subtract:Vu,_memset:Wu,_i64Add:Yu,_pthread_self:lv,_pthread_mutex_unlock:jv,_pthread_cond_broadcast:bv,___errno_location:Oh,___muldsi3:ev,_free:Gj,_round:mv,_memmove:hv,_malloc:Fj,_pthread_mutex_lock:Xu,__GLOBAL__I_000101:kl,__GLOBAL__sub_I_position_cpp:xf,__GLOBAL__sub_I_iostream_cpp:ll,__GLOBAL__sub_I_ucioption_cpp:uh,__GLOBAL__sub_I_uci_cpp:ih,__GLOBAL__sub_I_tt_cpp:ch,__GLOBAL__sub_I_timeman_cpp:ah,__GLOBAL__sub_I_thread_cpp:Qg,__GLOBAL__sub_I_search_cpp:Jg,__GLOBAL__sub_I_psqt_cpp:dg,__GLOBAL__sub_I_bitbase_cpp:zb,__GLOBAL__sub_I_pawns_cpp:sf,__GLOBAL__sub_I_movepick_cpp:lf,__GLOBAL__sub_I_movegen_cpp:Re,__GLOBAL__sub_I_misc_cpp:pe,__GLOBAL__sub_I_material_cpp:be,__GLOBAL__sub_I_main_cpp:_d,__GLOBAL__sub_I_evaluate_cpp:yd,__GLOBAL__sub_I_endgame_cpp:Hb,__GLOBAL__sub_I_bitboard_cpp:Ab,runPostSets:Uu,stackAlloc:qb,stackSave:rb,stackRestore:sb,establishStackSpace:tb,setTempRet0:vb,getTempRet0:wb,setThrew:ub,stackAlloc:qb,stackSave:rb,stackRestore:sb,establishStackSpace:tb,setThrew:ub,setTempRet0:vb,getTempRet0:wb,dynCall_iiiiiiii:ov,dynCall_iiii:pv,dynCall_viiiii:qv,dynCall_iiiiiid:rv,dynCall_vi:sv,dynCall_vii:tv,dynCall_iiiiiii:uv,dynCall_iiiiid:vv,dynCall_ii:wv,dynCall_viii:xv,dynCall_v:yv,dynCall_iiiiiiiii:zv,dynCall_iiiii:Av,dynCall_viiiiii:Bv,dynCall_iii:Cv,dynCall_iiiiii:Dv,dynCall_viiii:Ev}})

// EMSCRIPTEN_END_ASM
(Module.asmGlobalArg,Module.asmLibraryArg,buffer);var stackSave=Module["stackSave"]=asm["stackSave"];var _main=Module["_main"]=asm["_main"];var __GLOBAL__sub_I_misc_cpp=Module["__GLOBAL__sub_I_misc_cpp"]=asm["__GLOBAL__sub_I_misc_cpp"];var _uci_command=Module["_uci_command"]=asm["_uci_command"];var __GLOBAL__sub_I_thread_cpp=Module["__GLOBAL__sub_I_thread_cpp"]=asm["__GLOBAL__sub_I_thread_cpp"];var __GLOBAL__sub_I_main_cpp=Module["__GLOBAL__sub_I_main_cpp"]=asm["__GLOBAL__sub_I_main_cpp"];var _llvm_cttz_i32=Module["_llvm_cttz_i32"]=asm["_llvm_cttz_i32"];var establishStackSpace=Module["establishStackSpace"]=asm["establishStackSpace"];var getTempRet0=Module["getTempRet0"]=asm["getTempRet0"];var ___udivdi3=Module["___udivdi3"]=asm["___udivdi3"];var _bitshift64Lshr=Module["_bitshift64Lshr"]=asm["_bitshift64Lshr"];var _bitshift64Shl=Module["_bitshift64Shl"]=asm["_bitshift64Shl"];var __GLOBAL__sub_I_endgame_cpp=Module["__GLOBAL__sub_I_endgame_cpp"]=asm["__GLOBAL__sub_I_endgame_cpp"];var _llvm_ctlz_i64=Module["_llvm_ctlz_i64"]=asm["_llvm_ctlz_i64"];var __GLOBAL__sub_I_bitbase_cpp=Module["__GLOBAL__sub_I_bitbase_cpp"]=asm["__GLOBAL__sub_I_bitbase_cpp"];var _memset=Module["_memset"]=asm["_memset"];var _sbrk=Module["_sbrk"]=asm["_sbrk"];var _memcpy=Module["_memcpy"]=asm["_memcpy"];var __GLOBAL__sub_I_movegen_cpp=Module["__GLOBAL__sub_I_movegen_cpp"]=asm["__GLOBAL__sub_I_movegen_cpp"];var ___muldi3=Module["___muldi3"]=asm["___muldi3"];var __GLOBAL__sub_I_bitboard_cpp=Module["__GLOBAL__sub_I_bitboard_cpp"]=asm["__GLOBAL__sub_I_bitboard_cpp"];var __GLOBAL__sub_I_position_cpp=Module["__GLOBAL__sub_I_position_cpp"]=asm["__GLOBAL__sub_I_position_cpp"];var ___uremdi3=Module["___uremdi3"]=asm["___uremdi3"];var __GLOBAL__sub_I_pawns_cpp=Module["__GLOBAL__sub_I_pawns_cpp"]=asm["__GLOBAL__sub_I_pawns_cpp"];var ___divdi3=Module["___divdi3"]=asm["___divdi3"];var __GLOBAL__sub_I_ucioption_cpp=Module["__GLOBAL__sub_I_ucioption_cpp"]=asm["__GLOBAL__sub_I_ucioption_cpp"];var _i64Subtract=Module["_i64Subtract"]=asm["_i64Subtract"];var ___udivmoddi4=Module["___udivmoddi4"]=asm["___udivmoddi4"];var setTempRet0=Module["setTempRet0"]=asm["setTempRet0"];var _i64Add=Module["_i64Add"]=asm["_i64Add"];var _pthread_self=Module["_pthread_self"]=asm["_pthread_self"];var _pthread_mutex_unlock=Module["_pthread_mutex_unlock"]=asm["_pthread_mutex_unlock"];var __GLOBAL__I_000101=Module["__GLOBAL__I_000101"]=asm["__GLOBAL__I_000101"];var __GLOBAL__sub_I_psqt_cpp=Module["__GLOBAL__sub_I_psqt_cpp"]=asm["__GLOBAL__sub_I_psqt_cpp"];var __GLOBAL__sub_I_iostream_cpp=Module["__GLOBAL__sub_I_iostream_cpp"]=asm["__GLOBAL__sub_I_iostream_cpp"];var __GLOBAL__sub_I_timeman_cpp=Module["__GLOBAL__sub_I_timeman_cpp"]=asm["__GLOBAL__sub_I_timeman_cpp"];var stackAlloc=Module["stackAlloc"]=asm["stackAlloc"];var _pthread_cond_broadcast=Module["_pthread_cond_broadcast"]=asm["_pthread_cond_broadcast"];var __GLOBAL__sub_I_material_cpp=Module["__GLOBAL__sub_I_material_cpp"]=asm["__GLOBAL__sub_I_material_cpp"];var ___errno_location=Module["___errno_location"]=asm["___errno_location"];var ___muldsi3=Module["___muldsi3"]=asm["___muldsi3"];var _free=Module["_free"]=asm["_free"];var runPostSets=Module["runPostSets"]=asm["runPostSets"];var setThrew=Module["setThrew"]=asm["setThrew"];var _round=Module["_round"]=asm["_round"];var __GLOBAL__sub_I_tt_cpp=Module["__GLOBAL__sub_I_tt_cpp"]=asm["__GLOBAL__sub_I_tt_cpp"];var _memmove=Module["_memmove"]=asm["_memmove"];var __GLOBAL__sub_I_evaluate_cpp=Module["__GLOBAL__sub_I_evaluate_cpp"]=asm["__GLOBAL__sub_I_evaluate_cpp"];var stackRestore=Module["stackRestore"]=asm["stackRestore"];var _malloc=Module["_malloc"]=asm["_malloc"];var __GLOBAL__sub_I_search_cpp=Module["__GLOBAL__sub_I_search_cpp"]=asm["__GLOBAL__sub_I_search_cpp"];var _pthread_mutex_lock=Module["_pthread_mutex_lock"]=asm["_pthread_mutex_lock"];var __GLOBAL__sub_I_movepick_cpp=Module["__GLOBAL__sub_I_movepick_cpp"]=asm["__GLOBAL__sub_I_movepick_cpp"];var __GLOBAL__sub_I_uci_cpp=Module["__GLOBAL__sub_I_uci_cpp"]=asm["__GLOBAL__sub_I_uci_cpp"];var dynCall_iiiiiiii=Module["dynCall_iiiiiiii"]=asm["dynCall_iiiiiiii"];var dynCall_iiii=Module["dynCall_iiii"]=asm["dynCall_iiii"];var dynCall_viiiii=Module["dynCall_viiiii"]=asm["dynCall_viiiii"];var dynCall_iiiiiid=Module["dynCall_iiiiiid"]=asm["dynCall_iiiiiid"];var dynCall_vi=Module["dynCall_vi"]=asm["dynCall_vi"];var dynCall_vii=Module["dynCall_vii"]=asm["dynCall_vii"];var dynCall_iiiiiii=Module["dynCall_iiiiiii"]=asm["dynCall_iiiiiii"];var dynCall_iiiiid=Module["dynCall_iiiiid"]=asm["dynCall_iiiiid"];var dynCall_ii=Module["dynCall_ii"]=asm["dynCall_ii"];var dynCall_viii=Module["dynCall_viii"]=asm["dynCall_viii"];var dynCall_v=Module["dynCall_v"]=asm["dynCall_v"];var dynCall_iiiiiiiii=Module["dynCall_iiiiiiiii"]=asm["dynCall_iiiiiiiii"];var dynCall_iiiii=Module["dynCall_iiiii"]=asm["dynCall_iiiii"];var dynCall_viiiiii=Module["dynCall_viiiiii"]=asm["dynCall_viiiiii"];var dynCall_iii=Module["dynCall_iii"]=asm["dynCall_iii"];var dynCall_iiiiii=Module["dynCall_iiiiii"]=asm["dynCall_iiiiii"];var dynCall_viiii=Module["dynCall_viiii"]=asm["dynCall_viiii"];Runtime.stackAlloc=Module["stackAlloc"];Runtime.stackSave=Module["stackSave"];Runtime.stackRestore=Module["stackRestore"];Runtime.establishStackSpace=Module["establishStackSpace"];Runtime.setTempRet0=Module["setTempRet0"];Runtime.getTempRet0=Module["getTempRet0"];Module["asm"]=asm;function ExitStatus(status){this.name="ExitStatus";this.message="Program terminated with exit("+status+")";this.status=status}ExitStatus.prototype=new Error;ExitStatus.prototype.constructor=ExitStatus;var initialStackTop;var preloadStartTime=null;var calledMain=false;dependenciesFulfilled=function runCaller(){if(!Module["calledRun"])run();if(!Module["calledRun"])dependenciesFulfilled=runCaller};Module["callMain"]=Module.callMain=function callMain(args){args=args||[];ensureInitRuntime();var argc=args.length+1;function pad(){for(var i=0;i<4-1;i++){argv.push(0)}}var argv=[allocate(intArrayFromString(Module["thisProgram"]),"i8",ALLOC_NORMAL)];pad();for(var i=0;i<argc-1;i=i+1){argv.push(allocate(intArrayFromString(args[i]),"i8",ALLOC_NORMAL));pad()}argv.push(0);argv=allocate(argv,"i32",ALLOC_NORMAL);try{var ret=Module["_main"](argc,argv,0);exit(ret,true)}catch(e){if(e instanceof ExitStatus){return}else if(e=="SimulateInfiniteLoop"){Module["noExitRuntime"]=true;return}else{if(e&&typeof e==="object"&&e.stack)Module.printErr("exception thrown: "+[e,e.stack]);throw e}}finally{calledMain=true}};function run(args){args=args||Module["arguments"];if(preloadStartTime===null)preloadStartTime=Date.now();if(runDependencies>0){return}preRun();if(runDependencies>0)return;if(Module["calledRun"])return;function doRun(){if(Module["calledRun"])return;Module["calledRun"]=true;if(ABORT)return;ensureInitRuntime();preMain();if(Module["onRuntimeInitialized"])Module["onRuntimeInitialized"]();if(Module["_main"]&&shouldRunNow)Module["callMain"](args);postRun()}if(Module["setStatus"]){Module["setStatus"]("Running...");setTimeout((function(){setTimeout((function(){Module["setStatus"]("")}),1);doRun()}),1)}else{doRun()}}Module["run"]=Module.run=run;function exit(status,implicit){if(implicit&&Module["noExitRuntime"]){return}if(Module["noExitRuntime"]){}else{ABORT=true;EXITSTATUS=status;STACKTOP=initialStackTop;exitRuntime();if(Module["onExit"])Module["onExit"](status)}if(ENVIRONMENT_IS_NODE){process["exit"](status)}else if(ENVIRONMENT_IS_SHELL&&typeof quit==="function"){quit(status)}throw new ExitStatus(status)}Module["exit"]=Module.exit=exit;var abortDecorators=[];function abort(what){if(what!==undefined){Module.print(what);Module.printErr(what);what=JSON.stringify(what)}else{what=""}ABORT=true;EXITSTATUS=1;var extra="\nIf this abort() is unexpected, build with -s ASSERTIONS=1 which can give more information.";var output="abort("+what+") at "+stackTrace()+extra;if(abortDecorators){abortDecorators.forEach((function(decorator){output=decorator(output,what)}))}throw output}Module["abort"]=Module.abort=abort;if(Module["preInit"]){if(typeof Module["preInit"]=="function")Module["preInit"]=[Module["preInit"]];while(Module["preInit"].length>0){Module["preInit"].pop()()}}var shouldRunNow=true;if(Module["noInitialRun"]){shouldRunNow=false}Module["noExitRuntime"]=true;run();onmessage=(function(e){if(e.data=="quit")close();else Module.ccall("uci_command","number",["string"],[e.data])})


//*************** END OF PASTE

	Module.postMessage = function(pCommand) {
		Module.ccall('uci_command', 'number', ['string'], [pCommand]);
	};
	return Module;
});
